/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ue=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/nls","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/map","vs/base/common/uuid","fs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/process","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/errorMessage","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","net","vs/base/common/date","vs/base/common/marshalling","vs/amdX","child_process","vs/base/node/zip","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/nls.messages","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/jsonSchema","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/sandbox/node/electronTypes","vs/base/common/jsonErrorMessages","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],de=function(ce){for(var e=[],I=0,a=ce.length;I<a;I++)e[I]=ue[ce[I]];return e};define(ue[130],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=e.LoaderEventType=e.$W=e.$V=void 0,e.$V=!1,e.$W=!0;var I;(function(N){N[N.LoaderAvailable=1]="LoaderAvailable",N[N.BeginLoadingScript=10]="BeginLoadingScript",N[N.EndLoadingScriptOK=11]="EndLoadingScriptOK",N[N.EndLoadingScriptError=12]="EndLoadingScriptError",N[N.BeginInvokeFactory=21]="BeginInvokeFactory",N[N.EndInvokeFactory=22]="EndInvokeFactory",N[N.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",N[N.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",N[N.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",N[N.NodeEndNativeRequire=34]="NodeEndNativeRequire",N[N.CachedDataFound=60]="CachedDataFound",N[N.CachedDataMissed=61]="CachedDataMissed",N[N.CachedDataRejected=62]="CachedDataRejected",N[N.CachedDataCreated=63]="CachedDataCreated"})(I||(e.LoaderEventType=I={}));class a{static get(){const k=new Map,T=new Map,C=new Map,A=new Map;function b(l,g){l.has(g.detail)||l.set(g.detail,-g.timestamp)}function R(l,g){const E=l.get(g.detail);E&&(E>=0||l.set(g.detail,E+g.timestamp))}let p=[];typeof ce=="function"&&typeof ce.getStats=="function"&&(p=ce.getStats().slice(0).sort((l,g)=>l.timestamp-g.timestamp));for(const l of p)switch(l.type){case I.BeginLoadingScript:b(k,l);break;case I.EndLoadingScriptOK:case I.EndLoadingScriptError:R(k,l);break;case I.BeginInvokeFactory:b(T,l);break;case I.EndInvokeFactory:R(T,l);break;case I.NodeBeginNativeRequire:b(C,l);break;case I.NodeEndNativeRequire:R(C,l);break;case I.NodeBeginEvaluatingScript:b(A,l);break;case I.NodeEndEvaluatingScript:R(A,l);break}let m=0;C.forEach(l=>m+=l);function f(l){const g=[];return l.forEach((E,w)=>g.push([w,E])),g}return{amdLoad:f(k),amdInvoke:f(T),nodeRequire:f(C),nodeEval:f(A),nodeRequireTotal:m}}static toMarkdownTable(k,T){let C="";const A=[];return k.forEach((b,R)=>{A[R]=b.length}),T.forEach(b=>{b.forEach((R,p)=>{typeof R>"u"&&(R=b[p]="-");const m=R.toString().length;A[p]=Math.max(m,A[p])})}),k.forEach((b,R)=>{C+=`| ${b+" ".repeat(A[R]-b.toString().length)} `}),C+=`|
`,k.forEach((b,R)=>{C+=`| ${"-".repeat(A[R])} `}),C+=`|
`,T.forEach(b=>{b.forEach((R,p)=>{typeof R<"u"&&(C+=`| ${R+" ".repeat(A[p]-R.toString().length)} `)}),C+=`|
`}),C}}e.$X=a}),define(ue[131],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=void 0,e.$jb=I,e.$kb=a,e.$lb=N,e.$mb=k,e.$nb=T,e.$ob=C,e.$pb=A,e.$rb=R,e.$sb=p,e.$tb=m,e.$ub=f,e.$vb=l;function I(g,E){const w=a(g,E);if(w!==-1)return g[w]}function a(g,E,w=g.length-1){for(let d=w;d>=0;d--){const P=g[d];if(E(P))return d}return-1}function N(g,E){const w=k(g,E);return w===-1?void 0:g[w]}function k(g,E,w=0,d=g.length){let P=w,$=d;for(;P<$;){const c=Math.floor((P+$)/2);E(g[c])?P=c+1:$=c}return P-1}function T(g,E){const w=C(g,E);return w===g.length?void 0:g[w]}function C(g,E,w=0,d=g.length){let P=w,$=d;for(;P<$;){const c=Math.floor((P+$)/2);E(g[c])?$=c:P=c+1}return P}function A(g,E,w=0,d=g.length){const P=C(g,E,w,d);return P===g.length?-1:P}class b{static{this.assertInvariants=!1}constructor(E){this.e=E,this.c=0}findLastMonotonous(E){if(b.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!E(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=E}const w=k(this.e,E,this.c);return this.c=w+1,w===-1?void 0:this.e[w]}}e.$qb=b;function R(g,E){if(g.length===0)return;let w=g[0];for(let d=1;d<g.length;d++){const P=g[d];E(P,w)>0&&(w=P)}return w}function p(g,E){if(g.length===0)return;let w=g[0];for(let d=1;d<g.length;d++){const P=g[d];E(P,w)>=0&&(w=P)}return w}function m(g,E){return R(g,(w,d)=>-E(w,d))}function f(g,E){if(g.length===0)return-1;let w=0;for(let d=1;d<g.length;d++){const P=g[d];E(P,g[w])>0&&(w=d)}return w}function l(g,E){for(const w of g){const d=E(w);if(d!==void 0)return d}}}),define(ue[39],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var I;(function(a){a[a.Null=0]="Null",a[a.Backspace=8]="Backspace",a[a.Tab=9]="Tab",a[a.LineFeed=10]="LineFeed",a[a.CarriageReturn=13]="CarriageReturn",a[a.Space=32]="Space",a[a.ExclamationMark=33]="ExclamationMark",a[a.DoubleQuote=34]="DoubleQuote",a[a.Hash=35]="Hash",a[a.DollarSign=36]="DollarSign",a[a.PercentSign=37]="PercentSign",a[a.Ampersand=38]="Ampersand",a[a.SingleQuote=39]="SingleQuote",a[a.OpenParen=40]="OpenParen",a[a.CloseParen=41]="CloseParen",a[a.Asterisk=42]="Asterisk",a[a.Plus=43]="Plus",a[a.Comma=44]="Comma",a[a.Dash=45]="Dash",a[a.Period=46]="Period",a[a.Slash=47]="Slash",a[a.Digit0=48]="Digit0",a[a.Digit1=49]="Digit1",a[a.Digit2=50]="Digit2",a[a.Digit3=51]="Digit3",a[a.Digit4=52]="Digit4",a[a.Digit5=53]="Digit5",a[a.Digit6=54]="Digit6",a[a.Digit7=55]="Digit7",a[a.Digit8=56]="Digit8",a[a.Digit9=57]="Digit9",a[a.Colon=58]="Colon",a[a.Semicolon=59]="Semicolon",a[a.LessThan=60]="LessThan",a[a.Equals=61]="Equals",a[a.GreaterThan=62]="GreaterThan",a[a.QuestionMark=63]="QuestionMark",a[a.AtSign=64]="AtSign",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.OpenSquareBracket=91]="OpenSquareBracket",a[a.Backslash=92]="Backslash",a[a.CloseSquareBracket=93]="CloseSquareBracket",a[a.Caret=94]="Caret",a[a.Underline=95]="Underline",a[a.BackTick=96]="BackTick",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.OpenCurlyBrace=123]="OpenCurlyBrace",a[a.Pipe=124]="Pipe",a[a.CloseCurlyBrace=125]="CloseCurlyBrace",a[a.Tilde=126]="Tilde",a[a.NoBreakSpace=160]="NoBreakSpace",a[a.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",a[a.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",a[a.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",a[a.U_Combining_Tilde=771]="U_Combining_Tilde",a[a.U_Combining_Macron=772]="U_Combining_Macron",a[a.U_Combining_Overline=773]="U_Combining_Overline",a[a.U_Combining_Breve=774]="U_Combining_Breve",a[a.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",a[a.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",a[a.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",a[a.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",a[a.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",a[a.U_Combining_Caron=780]="U_Combining_Caron",a[a.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",a[a.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",a[a.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",a[a.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",a[a.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",a[a.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",a[a.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",a[a.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",a[a.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",a[a.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",a[a.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",a[a.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",a[a.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",a[a.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",a[a.U_Combining_Horn=795]="U_Combining_Horn",a[a.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",a[a.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",a[a.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",a[a.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",a[a.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",a[a.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",a[a.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",a[a.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",a[a.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",a[a.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",a[a.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",a[a.U_Combining_Cedilla=807]="U_Combining_Cedilla",a[a.U_Combining_Ogonek=808]="U_Combining_Ogonek",a[a.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",a[a.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",a[a.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",a[a.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",a[a.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",a[a.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",a[a.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",a[a.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",a[a.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",a[a.U_Combining_Low_Line=818]="U_Combining_Low_Line",a[a.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",a[a.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",a[a.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",a[a.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",a[a.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",a[a.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",a[a.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",a[a.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",a[a.U_Combining_Square_Below=827]="U_Combining_Square_Below",a[a.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",a[a.U_Combining_X_Above=829]="U_Combining_X_Above",a[a.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",a[a.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",a[a.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",a[a.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",a[a.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",a[a.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",a[a.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",a[a.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",a[a.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",a[a.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",a[a.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",a[a.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",a[a.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",a[a.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",a[a.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",a[a.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",a[a.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",a[a.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",a[a.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",a[a.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",a[a.U_Combining_Fermata=850]="U_Combining_Fermata",a[a.U_Combining_X_Below=851]="U_Combining_X_Below",a[a.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",a[a.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",a[a.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",a[a.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",a[a.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",a[a.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",a[a.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",a[a.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",a[a.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",a[a.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",a[a.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",a[a.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",a[a.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",a[a.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",a[a.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",a[a.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",a[a.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",a[a.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",a[a.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",a[a.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",a[a.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",a[a.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",a[a.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",a[a.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",a[a.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",a[a.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",a[a.LINE_SEPARATOR=8232]="LINE_SEPARATOR",a[a.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",a[a.NEXT_LINE=133]="NEXT_LINE",a[a.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",a[a.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",a[a.U_DIAERESIS=168]="U_DIAERESIS",a[a.U_MACRON=175]="U_MACRON",a[a.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",a[a.U_CEDILLA=184]="U_CEDILLA",a[a.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",a[a.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",a[a.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",a[a.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",a[a.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",a[a.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",a[a.U_BREVE=728]="U_BREVE",a[a.U_DOT_ABOVE=729]="U_DOT_ABOVE",a[a.U_RING_ABOVE=730]="U_RING_ABOVE",a[a.U_OGONEK=731]="U_OGONEK",a[a.U_SMALL_TILDE=732]="U_SMALL_TILDE",a[a.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",a[a.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",a[a.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",a[a.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",a[a.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",a[a.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",a[a.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",a[a.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",a[a.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",a[a.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",a[a.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",a[a.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",a[a.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",a[a.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",a[a.U_GREEK_TONOS=900]="U_GREEK_TONOS",a[a.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",a[a.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",a[a.U_GREEK_PSILI=8127]="U_GREEK_PSILI",a[a.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",a[a.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",a[a.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",a[a.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",a[a.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",a[a.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",a[a.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",a[a.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",a[a.U_GREEK_VARIA=8175]="U_GREEK_VARIA",a[a.U_GREEK_OXIA=8189]="U_GREEK_OXIA",a[a.U_GREEK_DASIA=8190]="U_GREEK_DASIA",a[a.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",a[a.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",a[a.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",a[a.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",a[a.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",a[a.U_OVERLINE=8254]="U_OVERLINE",a[a.UTF8_BOM=65279]="UTF8_BOM",a[a.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",a[a.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(I||(e.CharCode=I={}))}),define(ue[132],de([0,1]),function(ce,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$i=void 0,e.$e=a,e.$f=N,e.$g=k,e.$h=T;function a(A,b){const R=Object.create(null);for(const p of A){const m=b(p);let f=R[m];f||(f=R[m]=[]),f.push(p)}return R}function N(A,b){const R=[],p=[];for(const m of A)b.has(m)||R.push(m);for(const m of b)A.has(m)||p.push(m);return{removed:R,added:p}}function k(A,b){const R=[],p=[];for(const[m,f]of A)b.has(m)||R.push(f);for(const[m,f]of b)A.has(m)||p.push(f);return{removed:R,added:p}}function T(A,b){const R=new Set;for(const p of b)A.has(p)&&R.add(p);return R}class C{static{I=Symbol.toStringTag}constructor(b,R){this.b=R,this.a=new Map,this[I]="SetWithKey";for(const p of b)this.add(p)}get size(){return this.a.size}add(b){const R=this.b(b);return this.a.set(R,b),this}delete(b){return this.a.delete(this.b(b))}has(b){return this.a.has(this.b(b))}*entries(){for(const b of this.a.values())yield[b,b]}keys(){return this.values()}*values(){for(const b of this.a.values())yield b}clear(){this.a.clear()}forEach(b,R){this.a.forEach(p=>b.call(R,p,p,this))}[Symbol.iterator](){return this.values()}}e.$i=C}),define(ue[88],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=a,e.$di=N,e.$ei=k;function I(T){return(C,A,b)=>{let R=null,p=null;if(typeof b.value=="function"?(R="value",p=b.value):typeof b.get=="function"&&(R="get",p=b.get),!p)throw new Error("not supported");b[R]=T(p,A)}}function a(T,C,A){let b=null,R=null;if(typeof A.value=="function"?(b="value",R=A.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof A.get=="function"&&(b="get",R=A.get),!R)throw new Error("not supported");const p=`$memoize$${C}`;A[b]=function(...m){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,m)}),this[p]}}function N(T,C,A){return I((b,R)=>{const p=`$debounce$${R}`,m=`$debounce$result$${R}`;return function(...f){this[m]||(this[m]=A?A():void 0),clearTimeout(this[p]),C&&(this[m]=C(this[m],...f),f=[this[m]]),this[p]=setTimeout(()=>{b.apply(this,f),this[m]=A?A():void 0},T)}})}function k(T,C,A){return I((b,R)=>{const p=`$throttle$timer$${R}`,m=`$throttle$result$${R}`,f=`$throttle$lastRun$${R}`,l=`$throttle$pending$${R}`;return function(...g){if(this[m]||(this[m]=A?A():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),C&&(this[m]=C(this[m],...g)),this[l])return;const E=this[f]+T;E<=Date.now()?(this[f]=Date.now(),b.apply(this,[this[m]]),this[m]=A?A():void 0):(this[l]=!0,this[p]=setTimeout(()=>{this[l]=!1,this[f]=Date.now(),b.apply(this,[this[m]]),this[m]=A?A():void 0},E-Date.now()))}})}}),define(ue[8],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=e.$fb=e.$eb=e.$db=e.$cb=e.$ab=e.$9=e.$1=e.$Z=void 0,e.setUnexpectedErrorHandler=a,e.$3=N,e.$4=k,e.$5=T,e.$6=C,e.$7=A,e.$8=R,e.$0=m,e.$$=f,e.$_=l,e.$bb=E;class I{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?$.isErrorNoTelemetry(i)?new $(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(n=>{n(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$Z=I,e.$1=new I;function a(h){e.$1.setUnexpectedErrorHandler(h)}function N(h){if(!h||typeof h!="object")return!1;const i=h;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function k(h){R(h)||e.$1.onUnexpectedError(h)}function T(h){R(h)||e.$1.onUnexpectedExternalError(h)}function C(h){if(h instanceof Error){const{name:i,message:n}=h,t=h.stacktrace||h.stack;return{$isError:!0,name:i,message:n,stack:t,noTelemetry:$.isErrorNoTelemetry(h)}}return h}function A(h){let i;return h.noTelemetry?i=new $:(i=new Error,i.name=h.name),i.message=h.message,i.stack=h.stack,i}const b="Canceled";function R(h){return h instanceof p?!0:h instanceof Error&&h.name===b&&h.message===b}class p extends Error{constructor(){super(b),this.name=this.message}}e.$9=p;function m(){const h=new Error(b);return h.name=h.message,h}function f(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}function l(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}class g extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$ab=g;function E(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$cb=w;class d extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$db=d;class P extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$eb=P;class $ extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof $)return i;const n=new $;return n.message=i.message,n.stack=i.stack,n}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$fb=$;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$gb=c}),define(ue[17],de([0,1,8,131]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.$cc=e.$ac=e.$_b=e.CompareResult=void 0,e.$wb=N,e.$xb=k,e.$yb=T,e.$zb=C,e.$Ab=A,e.$Bb=b,e.$Cb=R,e.$Db=p,e.$Eb=m,e.$Fb=f,e.$Gb=l,e.$Hb=g,e.$Ib=E,e.top=w,e.$Kb=d,e.$Lb=$,e.$Mb=c,e.$Nb=h,e.$Ob=i,e.$Pb=n,e.$Qb=t,e.$Rb=s,e.$Sb=r,e.$Tb=o,e.$Ub=u,e.$Vb=y,e.$Wb=O,e.$Xb=S,e.$Yb=v,e.$Zb=L,e.$1b=j,e.$2b=U,e.$3b=F,e.$4b=G,e.$5b=V,e.$6b=x,e.$7b=H,e.$8b=te,e.$9b=z,e.$0b=ne,e.$$b=le,e.$bc=K,e.$fc=oe;function N(Q,Y=0){return Q[Q.length-(1+Y)]}function k(Q){if(Q.length===0)throw new Error("Invalid tail call");return[Q.slice(0,Q.length-1),Q[Q.length-1]]}function T(Q,Y,M=(B,ie)=>B===ie){if(Q===Y)return!0;if(!Q||!Y||Q.length!==Y.length)return!1;for(let B=0,ie=Q.length;B<ie;B++)if(!M(Q[B],Y[B]))return!1;return!0}function C(Q,Y){const M=Q.length-1;Y<M&&(Q[Y]=Q[M]),Q.pop()}function A(Q,Y,M){return b(Q.length,B=>M(Q[B],Y))}function b(Q,Y){let M=0,B=Q-1;for(;M<=B;){const ie=(M+B)/2|0,ae=Y(ie);if(ae<0)M=ie+1;else if(ae>0)B=ie-1;else return ie}return-(M+1)}function R(Q,Y,M){if(Q=Q|0,Q>=Y.length)throw new TypeError("invalid index");const B=Y[Math.floor(Y.length*Math.random())],ie=[],ae=[],he=[];for(const pe of Y){const be=M(pe,B);be<0?ie.push(pe):be>0?ae.push(pe):he.push(pe)}return Q<ie.length?R(Q,ie,M):Q<ie.length+he.length?he[0]:R(Q-(ie.length+he.length),ae,M)}function p(Q,Y){const M=[];let B;for(const ie of Q.slice(0).sort(Y))!B||Y(B[0],ie)!==0?(B=[ie],M.push(B)):B.push(ie);return M}function*m(Q,Y){let M,B;for(const ie of Q)B!==void 0&&Y(B,ie)?M.push(ie):(M&&(yield M),M=[ie]),B=ie;M&&(yield M)}function f(Q,Y){for(let M=0;M<=Q.length;M++)Y(M===0?void 0:Q[M-1],M===Q.length?void 0:Q[M])}function l(Q,Y){for(let M=0;M<Q.length;M++)Y(M===0?void 0:Q[M-1],Q[M],M+1===Q.length?void 0:Q[M+1])}function g(Q,Y,M){const B=[];function ie(pe,be,Ie){if(be===0&&Ie.length===0)return;const ke=B[B.length-1];ke&&ke.start+ke.deleteCount===pe?(ke.deleteCount+=be,ke.toInsert.push(...Ie)):B.push({start:pe,deleteCount:be,toInsert:Ie})}let ae=0,he=0;for(;;){if(ae===Q.length){ie(ae,0,Y.slice(he));break}if(he===Y.length){ie(ae,Q.length-ae,[]);break}const pe=Q[ae],be=Y[he],Ie=M(pe,be);Ie===0?(ae+=1,he+=1):Ie<0?(ie(ae,1,[]),ae+=1):Ie>0&&(ie(ae,0,[be]),he+=1)}return B}function E(Q,Y,M){const B=g(Q,Y,M),ie=[],ae=[];for(const he of B)ie.push(...Q.slice(he.start,he.start+he.deleteCount)),ae.push(...he.toInsert);return{removed:ie,added:ae}}function w(Q,Y,M){if(M===0)return[];const B=Q.slice(0,M).sort(Y);return P(Q,Y,B,M,Q.length),B}function d(Q,Y,M,B,ie){return M===0?Promise.resolve([]):new Promise((ae,he)=>{(async()=>{const pe=Q.length,be=Q.slice(0,M).sort(Y);for(let Ie=M,ke=Math.min(M+B,pe);Ie<pe;Ie=ke,ke=Math.min(ke+B,pe)){if(Ie>M&&await new Promise(ve=>setTimeout(ve)),ie&&ie.isCancellationRequested)throw new I.$9;P(Q,Y,be,Ie,ke)}return be})().then(ae,he)})}function P(Q,Y,M,B,ie){for(const ae=M.length;B<ie;B++){const he=Q[B];if(Y(he,M[ae-1])<0){M.pop();const pe=(0,a.$ob)(M,be=>Y(he,be)<0);M.splice(pe,0,he)}}}function $(Q){return Q.filter(Y=>!!Y)}function c(Q){let Y=0;for(let M=0;M<Q.length;M++)Q[M]&&(Q[Y]=Q[M],Y+=1);Q.length=Y}function h(Q,Y,M){Q.splice(M,0,Q.splice(Y,1)[0])}function i(Q){return!Array.isArray(Q)||Q.length===0}function n(Q){return Array.isArray(Q)&&Q.length>0}function t(Q,Y=M=>M){const M=new Set;return Q.filter(B=>{const ie=Y(B);return M.has(ie)?!1:(M.add(ie),!0)})}function s(Q){const Y=new Set;return M=>{const B=Q(M);return Y.has(B)?!1:(Y.add(B),!0)}}function r(Q,Y){return Q.length>0?Q[0]:Y}function o(Q,Y){return Q.length>0?Q[Q.length-1]:Y}function u(Q,Y,M=(B,ie)=>B===ie){let B=0;for(let ie=0,ae=Math.min(Q.length,Y.length);ie<ae&&M(Q[ie],Y[ie]);ie++)B++;return B}function y(Q,Y){let M=typeof Y=="number"?Q:0;typeof Y=="number"?M=Q:(M=0,Y=Q);const B=[];if(M<=Y)for(let ie=M;ie<Y;ie++)B.push(ie);else for(let ie=M;ie>Y;ie--)B.push(ie);return B}function O(Q,Y,M){return Q.reduce((B,ie)=>(B[Y(ie)]=M?M(ie):ie,B),Object.create(null))}function S(Q,Y){return Q.push(Y),()=>v(Q,Y)}function v(Q,Y){const M=Q.indexOf(Y);if(M>-1)return Q.splice(M,1),Y}function L(Q,Y,M){const B=Q.slice(0,Y),ie=Q.slice(Y);return B.concat(M,ie)}function j(Q,Y){let M;if(typeof Y=="number"){let B=Y;M=()=>{const ie=Math.sin(B++)*179426549;return ie-Math.floor(ie)}}else M=Math.random;for(let B=Q.length-1;B>0;B-=1){const ie=Math.floor(M()*(B+1)),ae=Q[B];Q[B]=Q[ie],Q[ie]=ae}}function U(Q,Y){const M=Q.indexOf(Y);M>-1&&(Q.splice(M,1),Q.unshift(Y))}function F(Q,Y){const M=Q.indexOf(Y);M>-1&&(Q.splice(M,1),Q.push(Y))}function G(Q,Y){for(const M of Y)Q.push(M)}function V(Q,Y){return Array.isArray(Q)?Q.map(Y):Y(Q)}function x(Q){return Array.isArray(Q)?Q:[Q]}function H(Q){return Q[Math.floor(Math.random()*Q.length)]}function te(Q,Y,M){const B=W(Q,Y),ie=Q.length,ae=M.length;Q.length=ie+ae;for(let he=ie-1;he>=B;he--)Q[he+ae]=Q[he];for(let he=0;he<ae;he++)Q[he+B]=M[he]}function z(Q,Y,M,B){const ie=W(Q,Y);let ae=Q.splice(ie,M);return ae===void 0&&(ae=[]),te(Q,ie,B),ae}function W(Q,Y){return Y<0?Math.max(Y+Q.length,0):Math.min(Y,Q.length)}var _;(function(Q){function Y(ae){return ae<0}Q.isLessThan=Y;function M(ae){return ae<=0}Q.isLessThanOrEqual=M;function B(ae){return ae>0}Q.isGreaterThan=B;function ie(ae){return ae===0}Q.isNeitherLessOrGreaterThan=ie,Q.greaterThan=1,Q.lessThan=-1,Q.neitherLessOrGreaterThan=0})(_||(e.CompareResult=_={}));function ne(Q,Y){return(M,B)=>Y(Q(M),Q(B))}function le(...Q){return(Y,M)=>{for(const B of Q){const ie=B(Y,M);if(!_.isNeitherLessOrGreaterThan(ie))return ie}return _.neitherLessOrGreaterThan}}const ee=(Q,Y)=>Q-Y;e.$_b=ee;const X=(Q,Y)=>(0,e.$_b)(Q?1:0,Y?1:0);e.$ac=X;function K(Q){return(Y,M)=>-Q(Y,M)}class q{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let M=this.c;for(;M<this.g.length&&Y(this.g[M]);)M++;const B=M===this.c?null:this.g.slice(this.c,M);return this.c=M,B}takeFromEndWhile(Y){let M=this.d;for(;M>=0&&Y(this.g[M]);)M--;const B=M===this.d?null:this.g.slice(M+1,this.d+1);return this.d=M,B}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const M=this.g.slice(this.c,this.c+Y);return this.c+=Y,M}}e.$cc=q;class D{static{this.empty=new D(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(M=>(Y(M),!0))}toArray(){const Y=[];return this.iterate(M=>(Y.push(M),!0)),Y}filter(Y){return new D(M=>this.iterate(B=>Y(B)?M(B):!0))}map(Y){return new D(M=>this.iterate(B=>M(Y(B))))}some(Y){let M=!1;return this.iterate(B=>(M=Y(B),!M)),M}findFirst(Y){let M;return this.iterate(B=>Y(B)?(M=B,!1):!0),M}findLast(Y){let M;return this.iterate(B=>(Y(B)&&(M=B),!0)),M}findLastMaxBy(Y){let M,B=!0;return this.iterate(ie=>((B||_.isGreaterThan(Y(ie,M)))&&(B=!1,M=ie),!0)),M}}e.$dc=D;class J{constructor(Y){this.c=Y}static createSortPermutation(Y,M){const B=Array.from(Y.keys()).sort((ie,ae)=>M(Y[ie],Y[ae]));return new J(B)}apply(Y){return Y.map((M,B)=>Y[this.c[B]])}inverse(){const Y=this.c.slice();for(let M=0;M<this.c.length;M++)Y[this.c[M]]=M;return new J(Y)}}e.$ec=J;async function oe(Q,Y){return(await Promise.all(Q.map(async(B,ie)=>({element:B,ok:await Y(B,ie)})))).find(B=>B.ok)?.element}}),define(ue[133],de([0,1,8]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=a,e.$jd=N,e.$kd=k,e.$ld=T,e.$md=C,e.$nd=A;function a(b,R){if(!b)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}function N(b,R="Unreachable"){throw new Error(R)}function k(b,R="unexpected state"){if(!b)throw new I.$gb(`Assertion Failed: ${R}`)}function T(b){b||(0,I.$4)(new I.$gb("Soft Assertion Failed"))}function C(b){if(!b()){debugger;b(),(0,I.$4)(new I.$gb("Assertion Failed"))}}function A(b,R){let p=0;for(;p<b.length-1;){const m=b[p],f=b[p+1];if(!R(m,f))return!1;p++}return!0}}),define(ue[89],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hb=I;function I(a,N){const k=this;let T=!1,C;return function(){if(T)return C;if(T=!0,N)try{C=a.apply(k,arguments)}finally{N()}else C=a.apply(k,arguments);return C}}}),define(ue[63],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(a){function N(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}a.is=N;const k=Object.freeze([]);function T(){return k}a.empty=T;function*C(i){yield i}a.single=C;function A(i){return N(i)?i:C(i)}a.wrap=A;function b(i){return i||k}a.from=b;function*R(i){for(let n=i.length-1;n>=0;n--)yield i[n]}a.reverse=R;function p(i){return!i||i[Symbol.iterator]().next().done===!0}a.isEmpty=p;function m(i){return i[Symbol.iterator]().next().value}a.first=m;function f(i,n){let t=0;for(const s of i)if(n(s,t++))return!0;return!1}a.some=f;function l(i,n){for(const t of i)if(n(t))return t}a.find=l;function*g(i,n){for(const t of i)n(t)&&(yield t)}a.filter=g;function*E(i,n){let t=0;for(const s of i)yield n(s,t++)}a.map=E;function*w(i,n){let t=0;for(const s of i)yield*n(s,t++)}a.flatMap=w;function*d(...i){for(const n of i)yield*n}a.concat=d;function P(i,n,t){let s=t;for(const r of i)s=n(s,r);return s}a.reduce=P;function*$(i,n,t=i.length){for(n<0&&(n+=i.length),t<0?t+=i.length:t>i.length&&(t=i.length);n<t;n++)yield i[n]}a.slice=$;function c(i,n=Number.POSITIVE_INFINITY){const t=[];if(n===0)return[t,i];const s=i[Symbol.iterator]();for(let r=0;r<n;r++){const o=s.next();if(o.done)return[t,a.empty()];t.push(o.value)}return[t,{[Symbol.iterator](){return s}}]}a.consume=c;async function h(i){const n=[];for await(const t of i)n.push(t);return Promise.resolve(n)}a.asyncToArray=h})(I||(e.Iterable=I={}))}),define(ue[36],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$3n=T,e.$4n=p,e.$5n=m,e.$6n=f,e.$7n=l,e.$8n=g,e.$9n=E,e.$0n=w,e.$$n=d,e.$_n=P,e.$ao=$;var I;(function(c){c[c.None=0]="None",c[c.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=2]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",c[c.InvalidUnicode=4]="InvalidUnicode",c[c.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",c[c.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var a;(function(c){c[c.OpenBraceToken=1]="OpenBraceToken",c[c.CloseBraceToken=2]="CloseBraceToken",c[c.OpenBracketToken=3]="OpenBracketToken",c[c.CloseBracketToken=4]="CloseBracketToken",c[c.CommaToken=5]="CommaToken",c[c.ColonToken=6]="ColonToken",c[c.NullKeyword=7]="NullKeyword",c[c.TrueKeyword=8]="TrueKeyword",c[c.FalseKeyword=9]="FalseKeyword",c[c.StringLiteral=10]="StringLiteral",c[c.NumericLiteral=11]="NumericLiteral",c[c.LineCommentTrivia=12]="LineCommentTrivia",c[c.BlockCommentTrivia=13]="BlockCommentTrivia",c[c.LineBreakTrivia=14]="LineBreakTrivia",c[c.Trivia=15]="Trivia",c[c.Unknown=16]="Unknown",c[c.EOF=17]="EOF"})(a||(e.SyntaxKind=a={}));var N;(function(c){c[c.InvalidSymbol=1]="InvalidSymbol",c[c.InvalidNumberFormat=2]="InvalidNumberFormat",c[c.PropertyNameExpected=3]="PropertyNameExpected",c[c.ValueExpected=4]="ValueExpected",c[c.ColonExpected=5]="ColonExpected",c[c.CommaExpected=6]="CommaExpected",c[c.CloseBraceExpected=7]="CloseBraceExpected",c[c.CloseBracketExpected=8]="CloseBracketExpected",c[c.EndOfFileExpected=9]="EndOfFileExpected",c[c.InvalidCommentToken=10]="InvalidCommentToken",c[c.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=12]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",c[c.InvalidUnicode=14]="InvalidUnicode",c[c.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",c[c.InvalidCharacter=16]="InvalidCharacter"})(N||(e.ParseErrorCode=N={}));var k;(function(c){c.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function T(c,h=!1){let i=0;const n=c.length;let t="",s=0,r=a.Unknown,o=I.None;function u(U){let F=0,G=0;for(;F<U;){const V=c.charCodeAt(i);if(V>=R._0&&V<=R._9)G=G*16+V-R._0;else if(V>=R.A&&V<=R.F)G=G*16+V-R.A+10;else if(V>=R.a&&V<=R.f)G=G*16+V-R.a+10;else break;i++,F++}return F<U&&(G=-1),G}function y(U){i=U,t="",s=0,r=a.Unknown,o=I.None}function O(){const U=i;if(c.charCodeAt(i)===R._0)i++;else for(i++;i<c.length&&b(c.charCodeAt(i));)i++;if(i<c.length&&c.charCodeAt(i)===R.dot)if(i++,i<c.length&&b(c.charCodeAt(i)))for(i++;i<c.length&&b(c.charCodeAt(i));)i++;else return o=I.UnexpectedEndOfNumber,c.substring(U,i);let F=i;if(i<c.length&&(c.charCodeAt(i)===R.E||c.charCodeAt(i)===R.e))if(i++,(i<c.length&&c.charCodeAt(i)===R.plus||c.charCodeAt(i)===R.minus)&&i++,i<c.length&&b(c.charCodeAt(i))){for(i++;i<c.length&&b(c.charCodeAt(i));)i++;F=i}else o=I.UnexpectedEndOfNumber;return c.substring(U,F)}function S(){let U="",F=i;for(;;){if(i>=n){U+=c.substring(F,i),o=I.UnexpectedEndOfString;break}const G=c.charCodeAt(i);if(G===R.doubleQuote){U+=c.substring(F,i),i++;break}if(G===R.backslash){if(U+=c.substring(F,i),i++,i>=n){o=I.UnexpectedEndOfString;break}switch(c.charCodeAt(i++)){case R.doubleQuote:U+='"';break;case R.backslash:U+="\\";break;case R.slash:U+="/";break;case R.b:U+="\b";break;case R.f:U+="\f";break;case R.n:U+=`
`;break;case R.r:U+="\r";break;case R.t:U+="	";break;case R.u:{const x=u(4);x>=0?U+=String.fromCharCode(x):o=I.InvalidUnicode;break}default:o=I.InvalidEscapeCharacter}F=i;continue}if(G>=0&&G<=31)if(A(G)){U+=c.substring(F,i),o=I.UnexpectedEndOfString;break}else o=I.InvalidCharacter;i++}return U}function v(){if(t="",o=I.None,s=i,i>=n)return s=n,r=a.EOF;let U=c.charCodeAt(i);if(C(U)){do i++,t+=String.fromCharCode(U),U=c.charCodeAt(i);while(C(U));return r=a.Trivia}if(A(U))return i++,t+=String.fromCharCode(U),U===R.carriageReturn&&c.charCodeAt(i)===R.lineFeed&&(i++,t+=`
`),r=a.LineBreakTrivia;switch(U){case R.openBrace:return i++,r=a.OpenBraceToken;case R.closeBrace:return i++,r=a.CloseBraceToken;case R.openBracket:return i++,r=a.OpenBracketToken;case R.closeBracket:return i++,r=a.CloseBracketToken;case R.colon:return i++,r=a.ColonToken;case R.comma:return i++,r=a.CommaToken;case R.doubleQuote:return i++,t=S(),r=a.StringLiteral;case R.slash:{const F=i-1;if(c.charCodeAt(i+1)===R.slash){for(i+=2;i<n&&!A(c.charCodeAt(i));)i++;return t=c.substring(F,i),r=a.LineCommentTrivia}if(c.charCodeAt(i+1)===R.asterisk){i+=2;const G=n-1;let V=!1;for(;i<G;){if(c.charCodeAt(i)===R.asterisk&&c.charCodeAt(i+1)===R.slash){i+=2,V=!0;break}i++}return V||(i++,o=I.UnexpectedEndOfComment),t=c.substring(F,i),r=a.BlockCommentTrivia}return t+=String.fromCharCode(U),i++,r=a.Unknown}case R.minus:if(t+=String.fromCharCode(U),i++,i===n||!b(c.charCodeAt(i)))return r=a.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return t+=O(),r=a.NumericLiteral;default:for(;i<n&&L(U);)i++,U=c.charCodeAt(i);if(s!==i){switch(t=c.substring(s,i),t){case"true":return r=a.TrueKeyword;case"false":return r=a.FalseKeyword;case"null":return r=a.NullKeyword}return r=a.Unknown}return t+=String.fromCharCode(U),i++,r=a.Unknown}}function L(U){if(C(U)||A(U))return!1;switch(U){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function j(){let U;do U=v();while(U>=a.LineCommentTrivia&&U<=a.Trivia);return U}return{setPosition:y,getPosition:()=>i,scan:h?j:v,getToken:()=>r,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>o}}function C(c){return c===R.space||c===R.tab||c===R.verticalTab||c===R.formFeed||c===R.nonBreakingSpace||c===R.ogham||c>=R.enQuad&&c<=R.zeroWidthSpace||c===R.narrowNoBreakSpace||c===R.mathematicalSpace||c===R.ideographicSpace||c===R.byteOrderMark}function A(c){return c===R.lineFeed||c===R.carriageReturn||c===R.lineSeparator||c===R.paragraphSeparator}function b(c){return c>=R._0&&c<=R._9}var R;(function(c){c[c.nullCharacter=0]="nullCharacter",c[c.maxAsciiCharacter=127]="maxAsciiCharacter",c[c.lineFeed=10]="lineFeed",c[c.carriageReturn=13]="carriageReturn",c[c.lineSeparator=8232]="lineSeparator",c[c.paragraphSeparator=8233]="paragraphSeparator",c[c.nextLine=133]="nextLine",c[c.space=32]="space",c[c.nonBreakingSpace=160]="nonBreakingSpace",c[c.enQuad=8192]="enQuad",c[c.emQuad=8193]="emQuad",c[c.enSpace=8194]="enSpace",c[c.emSpace=8195]="emSpace",c[c.threePerEmSpace=8196]="threePerEmSpace",c[c.fourPerEmSpace=8197]="fourPerEmSpace",c[c.sixPerEmSpace=8198]="sixPerEmSpace",c[c.figureSpace=8199]="figureSpace",c[c.punctuationSpace=8200]="punctuationSpace",c[c.thinSpace=8201]="thinSpace",c[c.hairSpace=8202]="hairSpace",c[c.zeroWidthSpace=8203]="zeroWidthSpace",c[c.narrowNoBreakSpace=8239]="narrowNoBreakSpace",c[c.ideographicSpace=12288]="ideographicSpace",c[c.mathematicalSpace=8287]="mathematicalSpace",c[c.ogham=5760]="ogham",c[c._=95]="_",c[c.$=36]="$",c[c._0=48]="_0",c[c._1=49]="_1",c[c._2=50]="_2",c[c._3=51]="_3",c[c._4=52]="_4",c[c._5=53]="_5",c[c._6=54]="_6",c[c._7=55]="_7",c[c._8=56]="_8",c[c._9=57]="_9",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.ampersand=38]="ampersand",c[c.asterisk=42]="asterisk",c[c.at=64]="at",c[c.backslash=92]="backslash",c[c.bar=124]="bar",c[c.caret=94]="caret",c[c.closeBrace=125]="closeBrace",c[c.closeBracket=93]="closeBracket",c[c.closeParen=41]="closeParen",c[c.colon=58]="colon",c[c.comma=44]="comma",c[c.dot=46]="dot",c[c.doubleQuote=34]="doubleQuote",c[c.equals=61]="equals",c[c.exclamation=33]="exclamation",c[c.greaterThan=62]="greaterThan",c[c.lessThan=60]="lessThan",c[c.minus=45]="minus",c[c.openBrace=123]="openBrace",c[c.openBracket=91]="openBracket",c[c.openParen=40]="openParen",c[c.percent=37]="percent",c[c.plus=43]="plus",c[c.question=63]="question",c[c.semicolon=59]="semicolon",c[c.singleQuote=39]="singleQuote",c[c.slash=47]="slash",c[c.tilde=126]="tilde",c[c.backspace=8]="backspace",c[c.formFeed=12]="formFeed",c[c.byteOrderMark=65279]="byteOrderMark",c[c.tab=9]="tab",c[c.verticalTab=11]="verticalTab"})(R||(R={}));function p(c,h){const i=[],n=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function o(u,y,O,S){s.value=u,s.offset=y,s.length=O,s.type=S,s.colonOffset=void 0,t=s}try{P(c,{onObjectBegin:(u,y)=>{if(h<=u)throw n;t=void 0,r=h>u,i.push("")},onObjectProperty:(u,y,O)=>{if(h<y||(o(u,y,O,"property"),i[i.length-1]=u,h<=y+O))throw n},onObjectEnd:(u,y)=>{if(h<=u)throw n;t=void 0,i.pop()},onArrayBegin:(u,y)=>{if(h<=u)throw n;t=void 0,i.push(0)},onArrayEnd:(u,y)=>{if(h<=u)throw n;t=void 0,i.pop()},onLiteralValue:(u,y,O)=>{if(h<y||(o(u,y,O,$(u)),h<=y+O))throw n},onSeparator:(u,y,O)=>{if(h<=y)throw n;if(u===":"&&t&&t.type==="property")t.colonOffset=y,r=!1,t=void 0;else if(u===","){const S=i[i.length-1];typeof S=="number"?i[i.length-1]=S+1:(r=!0,i[i.length-1]=""),t=void 0}}})}catch(u){if(u!==n)throw u}return{path:i,previousNode:t,isAtPropertyKey:r,matches:u=>{let y=0;for(let O=0;y<u.length&&O<i.length;O++)if(u[y]===i[O]||u[y]==="*")y++;else if(u[y]!=="**")return!1;return y===u.length}}}function m(c,h=[],i=k.DEFAULT){let n=null,t=[];const s=[];function r(u){Array.isArray(t)?t.push(u):n!==null&&(t[n]=u)}return P(c,{onObjectBegin:()=>{const u={};r(u),s.push(t),t=u,n=null},onObjectProperty:u=>{n=u},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const u=[];r(u),s.push(t),t=u,n=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:r,onError:(u,y,O)=>{h.push({error:u,offset:y,length:O})}},i),t[0]}function f(c,h=[],i=k.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(u){n.type==="property"&&(n.length=u-n.offset,n=n.parent)}function s(u){return n.children.push(u),u}P(c,{onObjectBegin:u=>{n=s({type:"object",offset:u,length:-1,parent:n,children:[]})},onObjectProperty:(u,y,O)=>{n=s({type:"property",offset:y,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:u,offset:y,length:O,parent:n})},onObjectEnd:(u,y)=>{n.length=u+y-n.offset,n=n.parent,t(u+y)},onArrayBegin:(u,y)=>{n=s({type:"array",offset:u,length:-1,parent:n,children:[]})},onArrayEnd:(u,y)=>{n.length=u+y-n.offset,n=n.parent,t(u+y)},onLiteralValue:(u,y,O)=>{s({type:$(u),offset:y,length:O,parent:n,value:u}),t(y+O)},onSeparator:(u,y,O)=>{n.type==="property"&&(u===":"?n.colonOffset=y:u===","&&t(y))},onError:(u,y,O)=>{h.push({error:u,offset:y,length:O})}},i);const o=n.children[0];return o&&delete o.parent,o}function l(c,h){if(!c)return;let i=c;for(const n of h)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===n){i=s.children[1],t=!0;break}if(!t)return}else{const t=n;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}function g(c){if(!c.parent||!c.parent.children)return[];const h=g(c.parent);if(c.parent.type==="property"){const i=c.parent.children[0].value;h.push(i)}else if(c.parent.type==="array"){const i=c.parent.children.indexOf(c);i!==-1&&h.push(i)}return h}function E(c){switch(c.type){case"array":return c.children.map(E);case"object":{const h=Object.create(null);for(const i of c.children){const n=i.children[1];n&&(h[i.children[0].value]=E(n))}return h}case"null":case"string":case"number":case"boolean":return c.value;default:return}}function w(c,h,i=!1){return h>=c.offset&&h<c.offset+c.length||i&&h===c.offset+c.length}function d(c,h,i=!1){if(w(c,h,i)){const n=c.children;if(Array.isArray(n))for(let t=0;t<n.length&&n[t].offset<=h;t++){const s=d(n[t],h,i);if(s)return s}return c}}function P(c,h,i=k.DEFAULT){const n=T(c,!1);function t(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(ne){return ne?le=>ne(le,n.getTokenOffset(),n.getTokenLength()):()=>!0}const r=t(h.onObjectBegin),o=s(h.onObjectProperty),u=t(h.onObjectEnd),y=t(h.onArrayBegin),O=t(h.onArrayEnd),S=s(h.onLiteralValue),v=s(h.onSeparator),L=t(h.onComment),j=s(h.onError),U=i&&i.disallowComments,F=i&&i.allowTrailingComma;function G(){for(;;){const ne=n.scan();switch(n.getTokenError()){case I.InvalidUnicode:V(N.InvalidUnicode);break;case I.InvalidEscapeCharacter:V(N.InvalidEscapeCharacter);break;case I.UnexpectedEndOfNumber:V(N.UnexpectedEndOfNumber);break;case I.UnexpectedEndOfComment:U||V(N.UnexpectedEndOfComment);break;case I.UnexpectedEndOfString:V(N.UnexpectedEndOfString);break;case I.InvalidCharacter:V(N.InvalidCharacter);break}switch(ne){case a.LineCommentTrivia:case a.BlockCommentTrivia:U?V(N.InvalidCommentToken):L();break;case a.Unknown:V(N.InvalidSymbol);break;case a.Trivia:case a.LineBreakTrivia:break;default:return ne}}}function V(ne,le=[],ee=[]){if(j(ne),le.length+ee.length>0){let X=n.getToken();for(;X!==a.EOF;){if(le.indexOf(X)!==-1){G();break}else if(ee.indexOf(X)!==-1)break;X=G()}}}function x(ne){const le=n.getTokenValue();return ne?S(le):o(le),G(),!0}function H(){switch(n.getToken()){case a.NumericLiteral:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(V(N.InvalidNumberFormat),ne=0)}catch{V(N.InvalidNumberFormat)}S(ne);break}case a.NullKeyword:S(null);break;case a.TrueKeyword:S(!0);break;case a.FalseKeyword:S(!1);break;default:return!1}return G(),!0}function te(){return n.getToken()!==a.StringLiteral?(V(N.PropertyNameExpected,[],[a.CloseBraceToken,a.CommaToken]),!1):(x(!1),n.getToken()===a.ColonToken?(v(":"),G(),_()||V(N.ValueExpected,[],[a.CloseBraceToken,a.CommaToken])):V(N.ColonExpected,[],[a.CloseBraceToken,a.CommaToken]),!0)}function z(){r(),G();let ne=!1;for(;n.getToken()!==a.CloseBraceToken&&n.getToken()!==a.EOF;){if(n.getToken()===a.CommaToken){if(ne||V(N.ValueExpected,[],[]),v(","),G(),n.getToken()===a.CloseBraceToken&&F)break}else ne&&V(N.CommaExpected,[],[]);te()||V(N.ValueExpected,[],[a.CloseBraceToken,a.CommaToken]),ne=!0}return u(),n.getToken()!==a.CloseBraceToken?V(N.CloseBraceExpected,[a.CloseBraceToken],[]):G(),!0}function W(){y(),G();let ne=!1;for(;n.getToken()!==a.CloseBracketToken&&n.getToken()!==a.EOF;){if(n.getToken()===a.CommaToken){if(ne||V(N.ValueExpected,[],[]),v(","),G(),n.getToken()===a.CloseBracketToken&&F)break}else ne&&V(N.CommaExpected,[],[]);_()||V(N.ValueExpected,[],[a.CloseBracketToken,a.CommaToken]),ne=!0}return O(),n.getToken()!==a.CloseBracketToken?V(N.CloseBracketExpected,[a.CloseBracketToken],[]):G(),!0}function _(){switch(n.getToken()){case a.OpenBracketToken:return W();case a.OpenBraceToken:return z();case a.StringLiteral:return x(!0);default:return H()}}return G(),n.getToken()===a.EOF?i.allowEmptyContent?!0:(V(N.ValueExpected,[],[]),!1):_()?(n.getToken()!==a.EOF&&V(N.EndOfFileExpected,[],[]),!0):(V(N.ValueExpected,[],[]),!1)}function $(c){switch(typeof c){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(c){if(Array.isArray(c))return"array"}else return"null";return"object"}default:return"null"}}}),define(ue[45],de([0,1,36]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=a,e.$co=N,e.$do=C,e.$eo=A;function a(b,R,p){let m,f,l,g,E;if(R){for(g=R.offset,E=g+R.length,l=g;l>0&&!A(b,l-1);)l--;let o=E;for(;o<b.length&&!A(b,o);)o++;f=b.substring(l,o),m=T(f,p)}else f=b,m=0,l=0,g=0,E=b.length;const w=C(p,b);let d=!1,P=0,$;p.insertSpaces?$=k(" ",p.tabSize||4):$="	";const c=(0,I.$3n)(f,!1);let h=!1;function i(){return w+k($,m+P)}function n(){let o=c.scan();for(d=!1;o===I.SyntaxKind.Trivia||o===I.SyntaxKind.LineBreakTrivia;)d=d||o===I.SyntaxKind.LineBreakTrivia,o=c.scan();return h=o===I.SyntaxKind.Unknown||c.getTokenError()!==I.ScanError.None,o}const t=[];function s(o,u,y){!h&&u<E&&y>g&&b.substring(u,y)!==o&&t.push({offset:u,length:y-u,content:o})}let r=n();if(r!==I.SyntaxKind.EOF){const o=c.getTokenOffset()+l,u=k($,m);s(u,l,o)}for(;r!==I.SyntaxKind.EOF;){let o=c.getTokenOffset()+c.getTokenLength()+l,u=n(),y="";for(;!d&&(u===I.SyntaxKind.LineCommentTrivia||u===I.SyntaxKind.BlockCommentTrivia);){const S=c.getTokenOffset()+l;s(" ",o,S),o=c.getTokenOffset()+c.getTokenLength()+l,y=u===I.SyntaxKind.LineCommentTrivia?i():"",u=n()}if(u===I.SyntaxKind.CloseBraceToken)r!==I.SyntaxKind.OpenBraceToken&&(P--,y=i());else if(u===I.SyntaxKind.CloseBracketToken)r!==I.SyntaxKind.OpenBracketToken&&(P--,y=i());else{switch(r){case I.SyntaxKind.OpenBracketToken:case I.SyntaxKind.OpenBraceToken:P++,y=i();break;case I.SyntaxKind.CommaToken:case I.SyntaxKind.LineCommentTrivia:y=i();break;case I.SyntaxKind.BlockCommentTrivia:d?y=i():y=" ";break;case I.SyntaxKind.ColonToken:y=" ";break;case I.SyntaxKind.StringLiteral:if(u===I.SyntaxKind.ColonToken){y="";break}case I.SyntaxKind.NullKeyword:case I.SyntaxKind.TrueKeyword:case I.SyntaxKind.FalseKeyword:case I.SyntaxKind.NumericLiteral:case I.SyntaxKind.CloseBraceToken:case I.SyntaxKind.CloseBracketToken:u===I.SyntaxKind.LineCommentTrivia||u===I.SyntaxKind.BlockCommentTrivia?y=" ":u!==I.SyntaxKind.CommaToken&&u!==I.SyntaxKind.EOF&&(h=!0);break;case I.SyntaxKind.Unknown:h=!0;break}d&&(u===I.SyntaxKind.LineCommentTrivia||u===I.SyntaxKind.BlockCommentTrivia)&&(y=i())}const O=c.getTokenOffset()+l;s(y,o,O),r=u}return t}function N(b,R){const p=JSON.stringify(b,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?p.replace(/\r\n|\r|\n/g,R.eol):p}function k(b,R){let p="";for(let m=0;m<R;m++)p+=b;return p}function T(b,R){let p=0,m=0;const f=R.tabSize||4;for(;p<b.length;){const l=b.charAt(p);if(l===" ")m++;else if(l==="	")m+=f;else break;p++}return Math.floor(m/f)}function C(b,R){for(let p=0;p<R.length;p++){const m=R.charAt(p);if(m==="\r")return p+1<R.length&&R.charAt(p+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return b&&b.eol||`
`}function A(b,R){return`\r
`.indexOf(b.charAt(R))!==-1}}),define(ue[64],de([0,1,36,45]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=N,e.$go=k,e.$ho=T,e.$io=C,e.$jo=A;function N(b,R,p){return k(b,R,void 0,p)}function k(b,R,p,m,f){const l=R.slice(),g=[],E=(0,I.$6n)(b,g);let w,d;for(;l.length>0&&(d=l.pop(),w=(0,I.$7n)(E,l),w===void 0&&p!==void 0);)typeof d=="string"?p={[d]:p}:p=[p];if(w)if(w.type==="object"&&typeof d=="string"&&Array.isArray(w.children)){const P=(0,I.$7n)(w,[d]);if(P!==void 0)if(p===void 0){if(!P.parent)throw new Error("Malformed AST");const $=w.children.indexOf(P.parent);let c,h=P.parent.offset+P.parent.length;if($>0){const i=w.children[$-1];c=i.offset+i.length}else c=w.offset+1,w.children.length>1&&(h=w.children[1].offset);return T(b,{offset:c,length:h-c,content:""},m)}else return T(b,{offset:P.offset,length:P.length,content:JSON.stringify(p)},m);else{if(p===void 0)return[];const $=`${JSON.stringify(d)}: ${JSON.stringify(p)}`,c=f?f(w.children.map(i=>i.children[0].value)):w.children.length;let h;if(c>0){const i=w.children[c-1];h={offset:i.offset+i.length,length:0,content:","+$}}else w.children.length===0?h={offset:w.offset+1,length:0,content:$}:h={offset:w.offset+1,length:0,content:$+","};return T(b,h,m)}}else if(w.type==="array"&&typeof d=="number"&&Array.isArray(w.children))if(p!==void 0){const P=`${JSON.stringify(p)}`;let $;if(w.children.length===0||d===0)$={offset:w.offset+1,length:0,content:w.children.length===0?P:P+","};else{const c=d===-1||d>w.children.length?w.children.length:d,h=w.children[c-1];$={offset:h.offset+h.length,length:0,content:","+P}}return T(b,$,m)}else{const P=d,$=w.children[P];let c;if(w.children.length===1)c={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===P){const h=w.children[P-1],i=h.offset+h.length,n=w.offset+w.length;c={offset:i,length:n-2-i,content:""}}else c={offset:$.offset,length:w.children[P+1].offset-$.offset,content:""};return T(b,c,m)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${w.type}`);else return p===void 0?[]:T(b,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(p)},m)}function T(b,R,p){let m=C(b,R),f=R.offset,l=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;f>0&&!(0,a.$eo)(m,f-1);)f--;for(;l<m.length&&!(0,a.$eo)(m,l);)l++}const g=(0,a.$bo)(m,{offset:f,length:l-f},p);for(let w=g.length-1;w>=0;w--){const d=g[w];m=C(m,d),f=Math.min(f,d.offset),l=Math.max(l,d.offset+d.length),l+=d.content.length-d.length}const E=b.length-(m.length-l)-f;return[{offset:f,length:E,content:m.substring(f,l)}]}function C(b,R){return b.substring(0,R.offset)+R.content+b.substring(R.offset+R.length)}function A(b,R){const p=R.slice(0).sort((f,l)=>{const g=f.offset-l.offset;return g===0?f.length-l.length:g});let m=b.length;for(let f=p.length-1;f>=0;f--){const l=p[f];if(l.offset+l.length<=m)b=C(b,l);else throw new Error("Overlapping edit");m=l.offset}return b}}),define(ue[134],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=I;function I(k){let T=!1;const C=new Map,A=new Map;if(N(k,g=>{if(k===g)return!0;const E=JSON.stringify(g);if(E.length<30)return!0;const w=C.get(E);if(!w){const d={schemas:[g]};return C.set(E,d),A.set(g,d),!0}return w.schemas.push(g),A.set(g,w),T=!0,!1}),C.clear(),!T)return JSON.stringify(k);let R="$defs";for(;k.hasOwnProperty(R);)R+="_";const p=[];function m(g){return JSON.stringify(g,(E,w)=>{if(w!==g){const d=A.get(w);if(d&&d.schemas.length>1)return d.id||(d.id=`_${p.length}`,p.push(d.schemas[0])),{$ref:`#/${R}/${d.id}`}}return w})}const f=m(k),l=[];for(let g=0;g<p.length;g++)l.push(`"_${g}":${m(p[g])}`);return l.length?`${f.substring(0,f.length-1)},"${R}":{${l.join(",")}}}`:f}function a(k){return typeof k=="object"&&k!==null}function N(k,T){if(!k||typeof k!="object")return;const C=(...f)=>{for(const l of f)a(l)&&p.push(l)},A=(...f)=>{for(const l of f)if(a(l))for(const g in l){const E=l[g];a(E)&&p.push(E)}},b=(...f)=>{for(const l of f)if(Array.isArray(l))for(const g of l)a(g)&&p.push(g)},R=f=>{if(Array.isArray(f))for(const l of f)a(l)&&p.push(l);else a(f)&&p.push(f)},p=[k];let m=p.pop();for(;m;)T(m)&&(C(m.additionalItems,m.additionalProperties,m.not,m.contains,m.propertyNames,m.if,m.then,m.else,m.unevaluatedItems,m.unevaluatedProperties),A(m.definitions,m.$defs,m.properties,m.patternProperties,m.dependencies,m.dependentSchemas),b(m.anyOf,m.allOf,m.oneOf,m.prefixItems),R(m.items)),m=p.pop()}}),define(ue[53],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y=void 0;class I{constructor(N){this.d=N,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(N){this.c=N}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$Y=I}),define(ue[90],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(k){this.element=k,this.next=I.Undefined,this.prev=I.Undefined}}class a{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let k=this.a;for(;k!==I.Undefined;){const T=k.next;k.prev=I.Undefined,k.next=I.Undefined,k=T}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(k){return this.d(k,!1)}push(k){return this.d(k,!0)}d(k,T){const C=new I(k);if(this.a===I.Undefined)this.a=C,this.b=C;else if(T){const b=this.b;this.b=C,C.prev=b,b.next=C}else{const b=this.a;this.a=C,C.next=b,b.prev=C}this.c+=1;let A=!1;return()=>{A||(A=!0,this.e(C))}}shift(){if(this.a!==I.Undefined){const k=this.a.element;return this.e(this.a),k}}pop(){if(this.b!==I.Undefined){const k=this.b.element;return this.e(this.b),k}}e(k){if(k.prev!==I.Undefined&&k.next!==I.Undefined){const T=k.prev;T.next=k.next,k.next.prev=T}else k.prev===I.Undefined&&k.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):k.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):k.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let k=this.a;for(;k!==I.Undefined;)yield k.element,k=k.next}}e.$0c=a}),define(ue[31],de([0,1]),function(ce,e){"use strict";var I,a,N;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.Touch=e.$Gc=e.$Fc=void 0,e.$Cc=k,e.$Dc=T,e.$Ec=C,e.$Nc=$;function k(c,h,i){let n=c.get(h);return n===void 0&&(n=i,c.set(h,n)),n}function T(c){const h=[];return c.forEach((i,n)=>{h.push(`${n} => ${i}`)}),`Map(${c.size}) {${h.join(", ")}}`}function C(c){const h=[];return c.forEach(i=>{h.push(i)}),`Set(${c.size}) {${h.join(", ")}}`}class A{constructor(h,i){this.uri=h,this.value=i}}function b(c){return Array.isArray(c)}class R{static{this.c=h=>h.toString()}constructor(h,i){if(this[I]="ResourceMap",h instanceof R)this.d=new Map(h.d),this.e=i??R.c;else if(b(h)){this.d=new Map,this.e=i??R.c;for(const[n,t]of h)this.set(n,t)}else this.d=new Map,this.e=h??R.c}set(h,i){return this.d.set(this.e(h),new A(h,i)),this}get(h){return this.d.get(this.e(h))?.value}has(h){return this.d.has(this.e(h))}get size(){return this.d.size}clear(){this.d.clear()}delete(h){return this.d.delete(this.e(h))}forEach(h,i){typeof i<"u"&&(h=h.bind(i));for(const[n,t]of this.d)h(t.value,t.uri,this)}*values(){for(const h of this.d.values())yield h.value}*keys(){for(const h of this.d.values())yield h.uri}*entries(){for(const h of this.d.values())yield[h.uri,h.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.d)yield[h.uri,h.value]}}e.$Fc=R;class p{constructor(h,i){this[a]="ResourceSet",!h||typeof h=="function"?this.c=new R(h):(this.c=new R(i),h.forEach(this.add,this))}get size(){return this.c.size}add(h){return this.c.set(h,h),this}clear(){this.c.clear()}delete(h){return this.c.delete(h)}forEach(h,i){this.c.forEach((n,t)=>h.call(i,t,t,this))}has(h){return this.c.has(h)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Gc=p;var m;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class f{constructor(){this[N]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(h){return this.c.has(h)}get(h,i=m.None){const n=this.c.get(h);if(n)return i!==m.None&&this.m(n,i),n.value}set(h,i,n=m.None){let t=this.c.get(h);if(t)t.value=i,n!==m.None&&this.m(t,n);else{switch(t={key:h,value:i,next:void 0,previous:void 0},n){case m.None:this.k(t);break;case m.AsOld:this.j(t);break;case m.AsNew:this.k(t);break;default:this.k(t);break}this.c.set(h,t),this.f++}return this}delete(h){return!!this.remove(h)}remove(h){const i=this.c.get(h);if(i)return this.c.delete(h),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const h=this.d;return this.c.delete(h.key),this.l(h),this.f--,h.value}forEach(h,i){const n=this.g;let t=this.d;for(;t;){if(i?h.bind(i)(t.value,t.key,this):h(t.value,t.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.key,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}values(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.value,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}entries(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:[n.key,n.value],done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(h){if(h>=this.size)return;if(h===0){this.clear();return}let i=this.d,n=this.size;for(;i&&n>h;)this.c.delete(i.key),i=i.next,n--;this.d=i,this.f=n,i&&(i.previous=void 0),this.g++}i(h){if(h>=this.size)return;if(h===0){this.clear();return}let i=this.e,n=this.size;for(;i&&n>h;)this.c.delete(i.key),i=i.previous,n--;this.e=i,this.f=n,i&&(i.next=void 0),this.g++}j(h){if(!this.d&&!this.e)this.e=h;else if(this.d)h.next=this.d,this.d.previous=h;else throw new Error("Invalid list");this.d=h,this.g++}k(h){if(!this.d&&!this.e)this.d=h;else if(this.e)h.previous=this.e,this.e.next=h;else throw new Error("Invalid list");this.e=h,this.g++}l(h){if(h===this.d&&h===this.e)this.d=void 0,this.e=void 0;else if(h===this.d){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.d=h.next}else if(h===this.e){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.e=h.previous}else{const i=h.next,n=h.previous;if(!i||!n)throw new Error("Invalid list");i.previous=n,n.next=i}h.next=void 0,h.previous=void 0,this.g++}m(h,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==m.AsOld&&i!==m.AsNew)){if(i===m.AsOld){if(h===this.d)return;const n=h.next,t=h.previous;h===this.e?(t.next=void 0,this.e=t):(n.previous=t,t.next=n),h.previous=void 0,h.next=this.d,this.d.previous=h,this.d=h,this.g++}else if(i===m.AsNew){if(h===this.e)return;const n=h.next,t=h.previous;h===this.d?(n.previous=void 0,this.d=n):(n.previous=t,t.next=n),h.next=void 0,h.previous=this.e,this.e.next=h,this.e=h,this.g++}}}toJSON(){const h=[];return this.forEach((i,n)=>{h.push([n,i])}),h}fromJSON(h){this.clear();for(const[i,n]of h)this.set(i,n)}}e.$Hc=f;class l extends f{constructor(h,i=1){super(),this.n=h,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(h){this.n=h,this.p()}get ratio(){return this.o}set ratio(h){this.o=Math.min(Math.max(0,h),1),this.p()}get(h,i=m.AsNew){return super.get(h,i)}peek(h){return super.get(h,m.None)}set(h,i){return super.set(h,i,m.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class g extends l{constructor(h,i=1){super(h,i)}q(h){this.h(h)}set(h,i){return super.set(h,i),this.p(),this}}e.$Ic=g;class E extends l{constructor(h,i=1){super(h,i)}q(h){this.i(h)}set(h,i){return this.n<=this.size&&!this.has(h)&&this.q(Math.round(this.n*this.o)-1),super.set(h,i),this}}e.$Jc=E;class w{constructor(){this.c=new Map}add(h){return this.c.set(h,(this.c.get(h)||0)+1),this}delete(h){let i=this.c.get(h)||0;return i===0?!1:(i--,i===0?this.c.delete(h):this.c.set(h,i),!0)}has(h){return this.c.has(h)}}e.$Kc=w;class d{constructor(h){if(this.c=new Map,this.d=new Map,h)for(const[i,n]of h)this.set(i,n)}clear(){this.c.clear(),this.d.clear()}set(h,i){this.c.set(h,i),this.d.set(i,h)}get(h){return this.c.get(h)}getKey(h){return this.d.get(h)}delete(h){const i=this.c.get(h);return i===void 0?!1:(this.c.delete(h),this.d.delete(i),!0)}forEach(h,i){this.c.forEach((n,t)=>{h.call(i,n,t,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Lc=d;class P{constructor(){this.c=new Map}add(h,i){let n=this.c.get(h);n||(n=new Set,this.c.set(h,n)),n.add(i)}delete(h,i){const n=this.c.get(h);n&&(n.delete(i),n.size===0&&this.c.delete(h))}forEach(h,i){const n=this.c.get(h);n&&n.forEach(i)}get(h){const i=this.c.get(h);return i||new Set}}e.$Mc=P;function $(c,h){if(c===h)return!0;if(c.size!==h.size)return!1;for(const[i,n]of c)if(!h.has(i)||h.get(i)!==n)return!1;for(const[i]of h)if(!c.has(i))return!1;return!0}}),define(ue[2],de([0,1,17,132,31,89,63]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Oc=void 0,e.$Pc=R,e.$Qc=p,e.$Rc=m,e.$Sc=g,e.$Tc=E,e.$Uc=w,e.$Vc=d,e.$Wc=P,e.$Xc=$,e.$8c=y;const C=!1;let A=null;class b{constructor(){this.b=new Map}static{this.a=0}c(v){let L=this.b.get(v);return L||(L={parent:null,source:null,isSingleton:!1,value:v,idx:b.a++},this.b.set(v,L)),L}trackDisposable(v){const L=this.c(v);L.source||(L.source=new Error().stack)}setParent(v,L){const j=this.c(v);j.parent=L}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,L){const j=L.get(v);if(j)return j;const U=v.parent?this.f(this.c(v.parent),L):v;return L.set(v,U),U}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,j])=>j.source!==null&&!this.f(j,v).isSingleton).flatMap(([j])=>j)}computeLeakingDisposables(v=10,L){let j;if(L)j=L;else{const x=new Map,H=[...this.b.values()].filter(z=>z.source!==null&&!this.f(z,x).isSingleton);if(H.length===0)return;const te=new Set(H.map(z=>z.value));if(j=H.filter(z=>!(z.parent&&te.has(z.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function U(x){function H(z,W){for(;z.length>0&&W.some(_=>typeof _=="string"?_===z[0]:z[0].match(_));)z.shift()}const te=x.source.split(`
`).map(z=>z.trim().replace("at ","")).filter(z=>z!=="");return H(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const F=new N.$Mc;for(const x of j){const H=U(x);for(let te=0;te<=H.length;te++)F.add(H.slice(0,te).join(`
`),x)}j.sort((0,I.$0b)(x=>x.idx,I.$_b));let G="",V=0;for(const x of j.slice(0,v)){V++;const H=U(x),te=[];for(let z=0;z<H.length;z++){let W=H[z];W=`(shared with ${F.get(H.slice(0,z+1).join(`
`)).size}/${j.length} leaks) at ${W}`;const ne=F.get(H.slice(0,z).join(`
`)),le=(0,a.$e)([...ne].map(ee=>U(ee)[z]),ee=>ee);delete le[H[z]];for(const[ee,X]of Object.entries(le))te.unshift(`    - stacktraces of ${X.length} other leaks continue with ${ee}`);te.unshift(W)}G+=`


==================== Leaking disposable ${V}/${j.length}: ${x.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return j.length>v&&(G+=`


... and ${j.length-v} more leaking disposables

`),{leaks:j,details:G}}}e.$Oc=b;function R(S){A=S}if(C){const S="__is_disposable_tracked__";R(new class{trackDisposable(v){const L=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[S]||console.log(L)},3e3)}setParent(v,L){if(v&&v!==h.None)try{v[S]=!0}catch{}}markAsDisposed(v){if(v&&v!==h.None)try{v[S]=!0}catch{}}markAsSingleton(v){}})}function p(S){return A?.trackDisposable(S),S}function m(S){A?.markAsDisposed(S)}function f(S,v){A?.setParent(S,v)}function l(S,v){if(A)for(const L of S)A.setParent(L,v)}function g(S){return A?.markAsSingleton(S),S}function E(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function w(S){if(T.Iterable.is(S)){const v=[];for(const L of S)if(L)try{L.dispose()}catch(j){v.push(j)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function d(S){for(const v of S)E(v)&&v.dispose();return[]}function P(...S){const v=$(()=>w(S));return l(S,v),v}function $(S){const v=p({dispose:(0,k.$hb)(()=>{m(v),S()})});return v}class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,p(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{w(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return f(v,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),f(v,null))}}e.$Yc=c;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,p(this),f(this.q,this)}dispose(){m(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Zc=h;class i{constructor(){this.b=!1,p(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&f(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&f(v,null),v}}e.$1c=i;class n{constructor(v){this.a=new i,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$2c=n;class t{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$3c=t;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(v){let L=v;return this.unset=()=>L=void 0,this.isset=()=>L!==void 0,this.dispose=()=>{L&&(L(),L=void 0,m(this))},this}}e.$4c=s;class r{constructor(){this.a=new Map}acquire(v,...L){let j=this.a.get(v);j||(j={counter:0,object:this.b(v,...L)},this.a.set(v,j));const{object:U}=j,F=(0,k.$hb)(()=>{--j.counter===0&&(this.c(v,j.object),this.a.delete(v))});return j.counter++,{object:U,dispose:F}}}e.$5c=r;class o{constructor(v){this.a=v}async acquire(v,...L){const j=this.a.acquire(v,...L);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(U){throw j.dispose(),U}}}e.$6c=o;class u{constructor(v){this.object=v}dispose(){}}e.$7c=u;function y(S){const v=new c;try{S(v)}finally{v.dispose()}}class O{constructor(){this.a=new Map,this.b=!1,p(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{w(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,L,j=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this.a.get(v)?.dispose(),this.a.set(v,L)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const L=this.a.get(v);return this.a.delete(v),L}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$9c=O}),define(ue[65],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var I;(function(a){a[a.Uri=1]="Uri",a[a.Regexp=2]="Regexp",a[a.ScmResource=3]="ScmResource",a[a.ScmResourceGroup=4]="ScmResourceGroup",a[a.ScmProvider=5]="ScmProvider",a[a.CommentController=6]="CommentController",a[a.CommentThread=7]="CommentThread",a[a.CommentThreadInstance=8]="CommentThreadInstance",a[a.CommentThreadReply=9]="CommentThreadReply",a[a.CommentNode=10]="CommentNode",a[a.CommentThreadNode=11]="CommentThreadNode",a[a.TimelineActionContext=12]="TimelineActionContext",a[a.NotebookCellActionContext=13]="NotebookCellActionContext",a[a.NotebookActionContext=14]="NotebookActionContext",a[a.TerminalContext=15]="TerminalContext",a[a.TestItemContext=16]="TestItemContext",a[a.Date=17]="Date",a[a.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(I||(e.MarshalledId=I={}))}),define(ue[91],de([0,1,31]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=void 0,e.$sm=N,e.$tm=T;const a=new I.$Ic(1e4);function N(b){return A(b,"NFC",a)}const k=new I.$Ic(1e4);function T(b){return A(b,"NFD",k)}const C=/[^\u0000-\u0080]/;function A(b,R,p){if(!b)return b;const m=p.get(b);if(m)return m;let f;return C.test(b)?f=b.normalize(R):f=b,p.set(b,f),f}e.$um=function(){const b=/[\u0300-\u036f]/g;return function(R){return T(R).replace(b,"")}}()}),function(){function ce(N){const k=[];typeof N=="number"&&k.push("code/timeOrigin",N);function T(A){k.push(A,Date.now())}function C(){const A=[];for(let b=0;b<k.length;b+=2)A.push({name:k[b],startTime:k[b+1]});return A}return{mark:T,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ce():{mark(N){performance.mark(N)},getMarks(){let N=performance.timeOrigin;typeof N!="number"&&(N=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(N)}];for(const T of performance.getEntriesByType("mark"))k.push({name:T.name,startTime:Math.round(N+T.startTime)});return k}};if(typeof process=="object"){const N=performance?.timeOrigin;return ce(N)}else return console.trace("perf-util loaded in UNKNOWN environment"),ce()}function I(N){return N.MonacoPerformanceMarks||(N.MonacoPerformanceMarks=e()),N.MonacoPerformanceMarks}var a;typeof global=="object"?a=global:typeof self=="object"?a=self:a={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(a)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(a):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),a.perf=I(a))}(),function(ce,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var a in I)(typeof exports=="object"?exports:ce)[a]=I[a]}}(typeof self<"u"?self:this,function(){return function(ce){var e={};function I(a){if(e[a])return e[a].exports;var N=e[a]={i:a,l:!1,exports:{}};return ce[a].call(N.exports,N,N.exports,I),N.l=!0,N.exports}return I.m=ce,I.c=e,I.d=function(a,N,k){I.o(a,N)||Object.defineProperty(a,N,{enumerable:!0,get:k})},I.r=function(a){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(a,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(a,"__esModule",{value:!0})},I.t=function(a,N){if(1&N&&(a=I(a)),8&N||4&N&&typeof a=="object"&&a&&a.__esModule)return a;var k=Object.create(null);if(I.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:a}),2&N&&typeof a!="string")for(var T in a)I.d(k,T,function(C){return a[C]}.bind(null,T));return k},I.n=function(a){var N=a&&a.__esModule?function(){return a.default}:function(){return a};return I.d(N,"a",N),N},I.o=function(a,N){return Object.prototype.hasOwnProperty.call(a,N)},I.p="",I(I.s=0)}([function(ce,e,I){(function(a){var N;e=ce.exports=X,N=typeof a=="object"&&a.env&&a.env.NODE_DEBUG&&/\bsemver\b/i.test(a.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],A=e.src=[],b=0,R=b++;A[R]="0|[1-9]\\d*";var p=b++;A[p]="[0-9]+";var m=b++;A[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=b++;A[f]="("+A[R]+")\\.("+A[R]+")\\.("+A[R]+")";var l=b++;A[l]="("+A[p]+")\\.("+A[p]+")\\.("+A[p]+")";var g=b++;A[g]="(?:"+A[R]+"|"+A[m]+")";var E=b++;A[E]="(?:"+A[p]+"|"+A[m]+")";var w=b++;A[w]="(?:-("+A[g]+"(?:\\."+A[g]+")*))";var d=b++;A[d]="(?:-?("+A[E]+"(?:\\."+A[E]+")*))";var P=b++;A[P]="[0-9A-Za-z-]+";var $=b++;A[$]="(?:\\+("+A[P]+"(?:\\."+A[P]+")*))";var c=b++,h="v?"+A[f]+A[w]+"?"+A[$]+"?";A[c]="^"+h+"$";var i="[v=\\s]*"+A[l]+A[d]+"?"+A[$]+"?",n=b++;A[n]="^"+i+"$";var t=b++;A[t]="((?:<|>)?=?)";var s=b++;A[s]=A[p]+"|x|X|\\*";var r=b++;A[r]=A[R]+"|x|X|\\*";var o=b++;A[o]="[v=\\s]*("+A[r]+")(?:\\.("+A[r]+")(?:\\.("+A[r]+")(?:"+A[w]+")?"+A[$]+"?)?)?";var u=b++;A[u]="[v=\\s]*("+A[s]+")(?:\\.("+A[s]+")(?:\\.("+A[s]+")(?:"+A[d]+")?"+A[$]+"?)?)?";var y=b++;A[y]="^"+A[t]+"\\s*"+A[o]+"$";var O=b++;A[O]="^"+A[t]+"\\s*"+A[u]+"$";var S=b++;A[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=b++;A[v]="(?:~>?)";var L=b++;A[L]="(\\s*)"+A[v]+"\\s+",C[L]=new RegExp(A[L],"g");var j=b++;A[j]="^"+A[v]+A[o]+"$";var U=b++;A[U]="^"+A[v]+A[u]+"$";var F=b++;A[F]="(?:\\^)";var G=b++;A[G]="(\\s*)"+A[F]+"\\s+",C[G]=new RegExp(A[G],"g");var V=b++;A[V]="^"+A[F]+A[o]+"$";var x=b++;A[x]="^"+A[F]+A[u]+"$";var H=b++;A[H]="^"+A[t]+"\\s*("+i+")$|^$";var te=b++;A[te]="^"+A[t]+"\\s*("+h+")$|^$";var z=b++;A[z]="(\\s*)"+A[t]+"\\s*("+i+"|"+A[o]+")",C[z]=new RegExp(A[z],"g");var W=b++;A[W]="^\\s*("+A[o]+")\\s+-\\s+("+A[o]+")\\s*$";var _=b++;A[_]="^\\s*("+A[u]+")\\s+-\\s+("+A[u]+")\\s*$";var ne=b++;A[ne]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)N(le,A[le]),C[le]||(C[le]=new RegExp(A[le]));function ee(re,fe){if(re instanceof X)return re;if(typeof re!="string"||re.length>k||!(fe?C[n]:C[c]).test(re))return null;try{return new X(re,fe)}catch{return null}}function X(re,fe){if(re instanceof X){if(re.loose===fe)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof X))return new X(re,fe);N("SemVer",re,fe),this.loose=fe;var me=re.trim().match(fe?C[n]:C[c]);if(!me)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Pe=+Se;if(Pe>=0&&Pe<T)return Pe}return Se}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=ee,e.valid=function(re,fe){var me=ee(re,fe);return me?me.version:null},e.clean=function(re,fe){var me=ee(re.trim().replace(/^[=v]+/,""),fe);return me?me.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(re){return N("SemVer.compare",this.version,this.loose,re),re instanceof X||(re=new X(re,this.loose)),this.compareMain(re)||this.comparePre(re)},X.prototype.compareMain=function(re){return re instanceof X||(re=new X(re,this.loose)),q(this.major,re.major)||q(this.minor,re.minor)||q(this.patch,re.patch)},X.prototype.comparePre=function(re){if(re instanceof X||(re=new X(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var fe=0;do{var me=this.prerelease[fe],Se=re.prerelease[fe];if(N("prerelease compare",fe,me,Se),me===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(me===void 0)return-1;if(me!==Se)return q(me,Se)}while(++fe)},X.prototype.inc=function(re,fe){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,fe,me,Se){typeof me=="string"&&(Se=me,me=void 0);try{return new X(re,me).inc(fe,Se).version}catch{return null}},e.diff=function(re,fe){if(Q(re,fe))return null;var me=ee(re),Se=ee(fe);if(me.prerelease.length||Se.prerelease.length){for(var Pe in me)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&me[Pe]!==Se[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in me)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&me[Pe]!==Se[Pe])return Pe},e.compareIdentifiers=q;var K=/^[0-9]+$/;function q(re,fe){var me=K.test(re),Se=K.test(fe);return me&&Se&&(re=+re,fe=+fe),me&&!Se?-1:Se&&!me?1:re<fe?-1:re>fe?1:0}function D(re,fe,me){return new X(re,me).compare(new X(fe,me))}function J(re,fe,me){return D(re,fe,me)>0}function oe(re,fe,me){return D(re,fe,me)<0}function Q(re,fe,me){return D(re,fe,me)===0}function Y(re,fe,me){return D(re,fe,me)!==0}function M(re,fe,me){return D(re,fe,me)>=0}function B(re,fe,me){return D(re,fe,me)<=0}function ie(re,fe,me,Se){var Pe;switch(fe){case"===":typeof re=="object"&&(re=re.version),typeof me=="object"&&(me=me.version),Pe=re===me;break;case"!==":typeof re=="object"&&(re=re.version),typeof me=="object"&&(me=me.version),Pe=re!==me;break;case"":case"=":case"==":Pe=Q(re,me,Se);break;case"!=":Pe=Y(re,me,Se);break;case">":Pe=J(re,me,Se);break;case">=":Pe=M(re,me,Se);break;case"<":Pe=oe(re,me,Se);break;case"<=":Pe=B(re,me,Se);break;default:throw new TypeError("Invalid operator: "+fe)}return Pe}function ae(re,fe){if(re instanceof ae){if(re.loose===fe)return re;re=re.value}if(!(this instanceof ae))return new ae(re,fe);N("comparator",re,fe),this.loose=fe,this.parse(re),this.semver===he?this.value="":this.value=this.operator+this.semver.version,N("comp",this)}e.rcompareIdentifiers=function(re,fe){return q(fe,re)},e.major=function(re,fe){return new X(re,fe).major},e.minor=function(re,fe){return new X(re,fe).minor},e.patch=function(re,fe){return new X(re,fe).patch},e.compare=D,e.compareLoose=function(re,fe){return D(re,fe,!0)},e.rcompare=function(re,fe,me){return D(fe,re,me)},e.sort=function(re,fe){return re.sort(function(me,Se){return e.compare(me,Se,fe)})},e.rsort=function(re,fe){return re.sort(function(me,Se){return e.rcompare(me,Se,fe)})},e.gt=J,e.lt=oe,e.eq=Q,e.neq=Y,e.gte=M,e.lte=B,e.cmp=ie,e.Comparator=ae;var he={};function pe(re,fe){if(re instanceof pe)return re.loose===fe?re:new pe(re.raw,fe);if(re instanceof ae)return new pe(re.value,fe);if(!(this instanceof pe))return new pe(re,fe);if(this.loose=fe,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function be(re){return!re||re.toLowerCase()==="x"||re==="*"}function Ie(re,fe,me,Se,Pe,De,Ne,Ce,je,Me,Ve,Fe,Be){return((fe=be(me)?"":be(Se)?">="+me+".0.0":be(Pe)?">="+me+"."+Se+".0":">="+fe)+" "+(Ce=be(je)?"":be(Me)?"<"+(+je+1)+".0.0":be(Ve)?"<"+je+"."+(+Me+1)+".0":Fe?"<="+je+"."+Me+"."+Ve+"-"+Fe:"<="+Ce)).trim()}function ke(re,fe){for(var me=0;me<re.length;me++)if(!re[me].test(fe))return!1;if(fe.prerelease.length){for(me=0;me<re.length;me++)if(N(re[me].semver),re[me].semver!==he&&re[me].semver.prerelease.length>0){var Se=re[me].semver;if(Se.major===fe.major&&Se.minor===fe.minor&&Se.patch===fe.patch)return!0}return!1}return!0}function ve(re,fe,me){try{fe=new pe(fe,me)}catch{return!1}return fe.test(re)}function we(re,fe,me,Se){var Pe,De,Ne,Ce,je;switch(re=new X(re,Se),fe=new pe(fe,Se),me){case">":Pe=J,De=B,Ne=oe,Ce=">",je=">=";break;case"<":Pe=oe,De=M,Ne=J,Ce="<",je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(re,fe,Se))return!1;for(var Me=0;Me<fe.set.length;++Me){var Ve=fe.set[Me],Fe=null,Be=null;if(Ve.forEach(function(ze){ze.semver===he&&(ze=new ae(">=0.0.0")),Fe=Fe||ze,Be=Be||ze,Pe(ze.semver,Fe.semver,Se)?Fe=ze:Ne(ze.semver,Be.semver,Se)&&(Be=ze)}),Fe.operator===Ce||Fe.operator===je||(!Be.operator||Be.operator===Ce)&&De(re,Be.semver)||Be.operator===je&&Ne(re,Be.semver))return!1}return!0}ae.prototype.parse=function(re){var fe=this.loose?C[H]:C[te],me=re.match(fe);if(!me)throw new TypeError("Invalid comparator: "+re);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new X(me[2],this.loose):this.semver=he},ae.prototype.toString=function(){return this.value},ae.prototype.test=function(re){return N("Comparator.test",re,this.loose),this.semver===he||(typeof re=="string"&&(re=new X(re,this.loose)),ie(re,this.operator,this.semver,this.loose))},ae.prototype.intersects=function(re,fe){if(!(re instanceof ae))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new pe(re.value,fe),ve(this.value,me,fe);if(re.operator==="")return me=new pe(this.value,fe),ve(re.semver,me,fe);var Se=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),De=this.semver.version===re.semver.version,Ne=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Ce=ie(this.semver,"<",re.semver,fe)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),je=ie(this.semver,">",re.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return Se||Pe||De&&Ne||Ce||je},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(re){var fe=this.loose;re=re.trim(),N("range",re,fe);var me=fe?C[_]:C[W];re=re.replace(me,Ie),N("hyphen replace",re),re=re.replace(C[z],"$1$2$3"),N("comparator trim",re,C[z]),re=(re=(re=re.replace(C[L],"$1~")).replace(C[G],"$1^")).split(/\s+/).join(" ");var Se=fe?C[H]:C[te],Pe=re.split(" ").map(function(De){return function(Ne,Ce){return N("comp",Ne),Ne=function(je,Me){return je.trim().split(/\s+/).map(function(Ve){return function(Fe,Be){N("caret",Fe,Be);var ze=Be?C[x]:C[V];return Fe.replace(ze,function(We,Le,se,ge,$e){var ye;return N("caret",Fe,We,Le,se,ge,$e),be(Le)?ye="":be(se)?ye=">="+Le+".0.0 <"+(+Le+1)+".0.0":be(ge)?ye=Le==="0"?">="+Le+"."+se+".0 <"+Le+"."+(+se+1)+".0":">="+Le+"."+se+".0 <"+(+Le+1)+".0.0":$e?(N("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=Le==="0"?se==="0"?">="+Le+"."+se+"."+ge+$e+" <"+Le+"."+se+"."+(+ge+1):">="+Le+"."+se+"."+ge+$e+" <"+Le+"."+(+se+1)+".0":">="+Le+"."+se+"."+ge+$e+" <"+(+Le+1)+".0.0"):(N("no pr"),ye=Le==="0"?se==="0"?">="+Le+"."+se+"."+ge+" <"+Le+"."+se+"."+(+ge+1):">="+Le+"."+se+"."+ge+" <"+Le+"."+(+se+1)+".0":">="+Le+"."+se+"."+ge+" <"+(+Le+1)+".0.0"),N("caret return",ye),ye})}(Ve,Me)}).join(" ")}(Ne,Ce),N("caret",Ne),Ne=function(je,Me){return je.trim().split(/\s+/).map(function(Ve){return function(Fe,Be){var ze=Be?C[U]:C[j];return Fe.replace(ze,function(We,Le,se,ge,$e){var ye;return N("tilde",Fe,We,Le,se,ge,$e),be(Le)?ye="":be(se)?ye=">="+Le+".0.0 <"+(+Le+1)+".0.0":be(ge)?ye=">="+Le+"."+se+".0 <"+Le+"."+(+se+1)+".0":$e?(N("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=">="+Le+"."+se+"."+ge+$e+" <"+Le+"."+(+se+1)+".0"):ye=">="+Le+"."+se+"."+ge+" <"+Le+"."+(+se+1)+".0",N("tilde return",ye),ye})}(Ve,Me)}).join(" ")}(Ne,Ce),N("tildes",Ne),Ne=function(je,Me){return N("replaceXRanges",je,Me),je.split(/\s+/).map(function(Ve){return function(Fe,Be){Fe=Fe.trim();var ze=Be?C[O]:C[y];return Fe.replace(ze,function(We,Le,se,ge,$e,ye){N("xRange",Fe,We,Le,se,ge,$e,ye);var Ae=be(se),Te=Ae||be(ge),qe=Te||be($e);return Le==="="&&qe&&(Le=""),Ae?We=Le===">"||Le==="<"?"<0.0.0":"*":Le&&qe?(Te&&(ge=0),qe&&($e=0),Le===">"?(Le=">=",Te?(se=+se+1,ge=0,$e=0):qe&&(ge=+ge+1,$e=0)):Le==="<="&&(Le="<",Te?se=+se+1:ge=+ge+1),We=Le+se+"."+ge+"."+$e):Te?We=">="+se+".0.0 <"+(+se+1)+".0.0":qe&&(We=">="+se+"."+ge+".0 <"+se+"."+(+ge+1)+".0"),N("xRange return",We),We})}(Ve,Me)}).join(" ")}(Ne,Ce),N("xrange",Ne),Ne=function(je,Me){return N("replaceStars",je,Me),je.trim().replace(C[ne],"")}(Ne,Ce),N("stars",Ne),Ne}(De,fe)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(De){return!!De.match(Se)})),Pe=Pe.map(function(De){return new ae(De,fe)})},pe.prototype.intersects=function(re,fe){if(!(re instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Se){return re.set.some(function(Pe){return Pe.every(function(De){return Se.intersects(De,fe)})})})})},e.toComparators=function(re,fe){return new pe(re,fe).set.map(function(me){return me.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new X(re,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],re))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(re,fe,me){var Se=null,Pe=null;try{var De=new pe(fe,me)}catch{return null}return re.forEach(function(Ne){De.test(Ne)&&(Se&&Pe.compare(Ne)!==-1||(Pe=new X(Se=Ne,me)))}),Se},e.minSatisfying=function(re,fe,me){var Se=null,Pe=null;try{var De=new pe(fe,me)}catch{return null}return re.forEach(function(Ne){De.test(Ne)&&(Se&&Pe.compare(Ne)!==1||(Pe=new X(Se=Ne,me)))}),Se},e.validRange=function(re,fe){try{return new pe(re,fe).range||"*"}catch{return null}},e.ltr=function(re,fe,me){return we(re,fe,"<",me)},e.gtr=function(re,fe,me){return we(re,fe,">",me)},e.outside=we,e.prerelease=function(re,fe){var me=ee(re,fe);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(re,fe,me){return re=new pe(re,me),fe=new pe(fe,me),re.intersects(fe)},e.coerce=function(re){if(re instanceof X)return re;if(typeof re!="string")return null;var fe=re.match(C[S]);return fe==null?null:ee((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,I(1))},function(ce,e){var I,a,N=ce.exports={};function k(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function C(E){if(I===setTimeout)return setTimeout(E,0);if((I===k||!I)&&setTimeout)return I=setTimeout,setTimeout(E,0);try{return I(E,0)}catch{try{return I.call(null,E,0)}catch{return I.call(this,E,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:k}catch{I=k}try{a=typeof clearTimeout=="function"?clearTimeout:T}catch{a=T}})();var A,b=[],R=!1,p=-1;function m(){R&&A&&(R=!1,A.length?b=A.concat(b):p=-1,b.length&&f())}function f(){if(!R){var E=C(m);R=!0;for(var w=b.length;w;){for(A=b,b=[];++p<w;)A&&A[p].run();p=-1,w=b.length}A=null,R=!1,function(d){if(a===clearTimeout)return clearTimeout(d);if((a===T||!a)&&clearTimeout)return a=clearTimeout,clearTimeout(d);try{a(d)}catch{try{return a.call(null,d)}catch{return a.call(this,d)}}}(E)}}function l(E,w){this.fun=E,this.array=w}function g(){}N.nextTick=function(E){var w=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)w[d-1]=arguments[d];b.push(new l(E,w)),b.length!==1||R||C(f)},l.prototype.run=function(){this.fun.apply(null,this.array)},N.title="browser",N.browser=!0,N.env={},N.argv=[],N.version="",N.versions={},N.on=g,N.addListener=g,N.once=g,N.off=g,N.removeListener=g,N.removeAllListeners=g,N.emit=g,N.prependListener=g,N.prependOnceListener=g,N.listeners=function(E){return[]},N.binding=function(E){throw new Error("process.binding is not supported")},N.cwd=function(){return"/"},N.chdir=function(E){throw new Error("process.chdir is not supported")},N.umask=function(){return 0}}])}),define(ue[135],de([0,1]),function(ce,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0;class a{constructor(C,A,b){this.level=C,this.key=A,this.value=b,this.forward=[]}}const N=void 0;class k{constructor(C,A=2**16){this.comparator=C,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(A)|0),this.e=new a(this.c,N,N)}get size(){return this.f}clear(){this.e=new a(this.c,N,N),this.f=0}has(C){return!!k.g(this,C,this.comparator)}get(C){return k.g(this,C,this.comparator)?.value}set(C,A){return k.h(this,C,A,this.comparator)&&(this.f+=1),this}delete(C){const A=k.k(this,C,this.comparator);return A&&(this.f-=1),A}forEach(C,A){let b=this.e.forward[0];for(;b;)C.call(A,b.value,b.key,this),b=b.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this.e.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this.e.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this.e.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",A=this.e.forward[0];for(;A;)C+=`node(${A.key}, ${A.value}, lvl:${A.level})`,A=A.forward[0];return C}static g(C,A,b){let R=C.e;for(let p=C.d-1;p>=0;p--)for(;R.forward[p]&&b(R.forward[p].key,A)<0;)R=R.forward[p];if(R=R.forward[0],R&&b(R.key,A)===0)return R}static h(C,A,b,R){const p=[];let m=C.e;for(let f=C.d-1;f>=0;f--){for(;m.forward[f]&&R(m.forward[f].key,A)<0;)m=m.forward[f];p[f]=m}if(m=m.forward[0],m&&R(m.key,A)===0)return m.value=b,!1;{const f=k.j(C);if(f>C.d){for(let l=C.d;l<f;l++)p[l]=C.e;C.d=f}m=new a(f,A,b);for(let l=0;l<f;l++)m.forward[l]=p[l].forward[l],p[l].forward[l]=m;return!0}}static j(C,A=.5){let b=1;for(;Math.random()<A&&b<C.c;)b+=1;return b}static k(C,A,b){const R=[];let p=C.e;for(let m=C.d-1;m>=0;m--){for(;p.forward[m]&&b(p.forward[m].key,A)<0;)p=p.forward[m];R[m]=p}if(p=p.forward[0],!p||b(p.key,A)!==0)return!1;for(let m=0;m<C.d&&R[m].forward[m]===p;m++)R[m].forward[m]=p.forward[m];for(;C.d>0&&C.e.forward[C.d-1]===N;)C.d-=1;return!0}}e.$2s=k}),define(ue[54],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class a{static create(k){return new a(k)}constructor(k){this.c=I&&k===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ke=a}),define(ue[3],de([0,1,8,89,2,90,54]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$me=e.Event=void 0,e.$ne=f;const C=!1,A=!1,b=!1;var R;(function(U){U.None=()=>N.$Zc.None;function F(ve){if(b){const{onDidAddListener:we}=ve,re=g.create();let fe=0;ve.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),we?.()}}}function G(ve,we){return X(ve,()=>{},0,void 0,!0,void 0,we)}U.defer=G;function V(ve){return(we,re=null,fe)=>{let me=!1,Se;return Se=ve(Pe=>{if(!me)return Se?Se.dispose():me=!0,we.call(re,Pe)},null,fe),me&&Se.dispose(),Se}}U.once=V;function x(ve,we){return U.once(U.filter(ve,we))}U.onceIf=x;function H(ve,we,re){return le((fe,me=null,Se)=>ve(Pe=>fe.call(me,we(Pe)),null,Se),re)}U.map=H;function te(ve,we,re){return le((fe,me=null,Se)=>ve(Pe=>{we(Pe),fe.call(me,Pe)},null,Se),re)}U.forEach=te;function z(ve,we,re){return le((fe,me=null,Se)=>ve(Pe=>we(Pe)&&fe.call(me,Pe),null,Se),re)}U.filter=z;function W(ve){return ve}U.signal=W;function _(...ve){return(we,re=null,fe)=>{const me=(0,N.$Wc)(...ve.map(Se=>Se(Pe=>we.call(re,Pe))));return ee(me,fe)}}U.any=_;function ne(ve,we,re,fe){let me=re;return H(ve,Se=>(me=we(me,Se),me),fe)}U.reduce=ne;function le(ve,we){let re;const fe={onWillAddFirstListener(){re=ve(me.fire,me)},onDidRemoveLastListener(){re?.dispose()}};we||F(fe);const me=new i(fe);return we?.add(me),me.event}function ee(ve,we){return we instanceof Array?we.push(ve):we&&we.add(ve),ve}function X(ve,we,re=100,fe=!1,me=!1,Se,Pe){let De,Ne,Ce,je=0,Me;const Ve={leakWarningThreshold:Se,onWillAddFirstListener(){De=ve(Be=>{je++,Ne=we(Ne,Be),fe&&!Ce&&(Fe.fire(Ne),Ne=void 0),Me=()=>{const ze=Ne;Ne=void 0,Ce=void 0,(!fe||je>1)&&Fe.fire(ze),je=0},typeof re=="number"?(clearTimeout(Ce),Ce=setTimeout(Me,re)):Ce===void 0&&(Ce=0,queueMicrotask(Me))})},onWillRemoveListener(){me&&je>0&&Me?.()},onDidRemoveLastListener(){Me=void 0,De.dispose()}};Pe||F(Ve);const Fe=new i(Ve);return Pe?.add(Fe),Fe.event}U.debounce=X;function K(ve,we=0,re){return U.debounce(ve,(fe,me)=>fe?(fe.push(me),fe):[me],we,void 0,!0,void 0,re)}U.accumulate=K;function q(ve,we=(fe,me)=>fe===me,re){let fe=!0,me;return z(ve,Se=>{const Pe=fe||!we(Se,me);return fe=!1,me=Se,Pe},re)}U.latch=q;function D(ve,we,re){return[U.filter(ve,we,re),U.filter(ve,fe=>!we(fe),re)]}U.split=D;function J(ve,we=!1,re=[],fe){let me=re.slice(),Se=ve(Ne=>{me?me.push(Ne):De.fire(Ne)});fe&&fe.add(Se);const Pe=()=>{me?.forEach(Ne=>De.fire(Ne)),me=null},De=new i({onWillAddFirstListener(){Se||(Se=ve(Ne=>De.fire(Ne)),fe&&fe.add(Se))},onDidAddFirstListener(){me&&(we?setTimeout(Pe):Pe())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return fe&&fe.add(De),De.event}U.buffer=J;function oe(ve,we){return(fe,me,Se)=>{const Pe=we(new Y);return ve(function(De){const Ne=Pe.evaluate(De);Ne!==Q&&fe.call(me,Ne)},void 0,Se)}}U.chain=oe;const Q=Symbol("HaltChainable");class Y{constructor(){this.f=[]}map(we){return this.f.push(we),this}forEach(we){return this.f.push(re=>(we(re),re)),this}filter(we){return this.f.push(re=>we(re)?re:Q),this}reduce(we,re){let fe=re;return this.f.push(me=>(fe=we(fe,me),fe)),this}latch(we=(re,fe)=>re===fe){let re=!0,fe;return this.f.push(me=>{const Se=re||!we(me,fe);return re=!1,fe=me,Se?me:Q}),this}evaluate(we){for(const re of this.f)if(we=re(we),we===Q)break;return we}}function M(ve,we,re=fe=>fe){const fe=(...De)=>Pe.fire(re(...De)),me=()=>ve.on(we,fe),Se=()=>ve.removeListener(we,fe),Pe=new i({onWillAddFirstListener:me,onDidRemoveLastListener:Se});return Pe.event}U.fromNodeEventEmitter=M;function B(ve,we,re=fe=>fe){const fe=(...De)=>Pe.fire(re(...De)),me=()=>ve.addEventListener(we,fe),Se=()=>ve.removeEventListener(we,fe),Pe=new i({onWillAddFirstListener:me,onDidRemoveLastListener:Se});return Pe.event}U.fromDOMEventEmitter=B;function ie(ve){return new Promise(we=>V(ve)(we))}U.toPromise=ie;function ae(ve){const we=new i;return ve.then(re=>{we.fire(re)},()=>{we.fire(void 0)}).finally(()=>{we.dispose()}),we.event}U.fromPromise=ae;function he(ve,we){return ve(re=>we.fire(re))}U.forward=he;function pe(ve,we,re){return we(re),ve(fe=>we(fe))}U.runAndSubscribe=pe;class be{constructor(we,re){this._observable=we,this.f=0,this.g=!1;const fe={onWillAddFirstListener:()=>{we.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{we.removeObserver(this)}};re||F(fe),this.emitter=new i(fe),re&&re.add(this.emitter)}beginUpdate(we){this.f++}handlePossibleChange(we){}handleChange(we,re){this.g=!0}endUpdate(we){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ie(ve,we){return new be(ve,we).emitter.event}U.fromObservable=Ie;function ke(ve){return(we,re,fe)=>{let me=0,Se=!1;const Pe={beginUpdate(){me++},endUpdate(){me--,me===0&&(ve.reportChanges(),Se&&(Se=!1,we.call(re)))},handlePossibleChange(){},handleChange(){Se=!0}};ve.addObserver(Pe),ve.reportChanges();const De={dispose(){ve.removeObserver(Pe)}};return fe instanceof N.$Yc?fe.add(De):Array.isArray(fe)&&fe.push(De),De}}U.fromObservableLight=ke})(R||(e.Event=R={}));class p{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${p.f++}`,p.all.add(this)}start(F){this.g=new T.$ke,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$me=p;let m=-1;function f(U){const F=m;return m=U,{dispose(){m=F}}}class l{static{this.f=1}constructor(F,G,V=(l.f++).toString(16).padStart(3,"0")){this.j=F,this.threshold=G,this.name=V,this.h=0}dispose(){this.g?.clear()}check(F,G){const V=this.threshold;if(V<=0||G<V)return;this.g||(this.g=new Map);const x=this.g.get(F.value)||0;if(this.g.set(F.value,x+1),this.h-=1,this.h<=0){this.h=V*.5;const[H,te]=this.getMostFrequentStack(),z=`[${this.name}] potential listener LEAK detected, having ${G} listeners already. MOST frequent listener (${te}):`;console.warn(z),console.warn(H);const W=new E(z,H);this.j(W)}return()=>{const H=this.g.get(F.value)||0;this.g.set(F.value,H-1)}}getMostFrequentStack(){if(!this.g)return;let F,G=0;for(const[V,x]of this.g)(!F||G<x)&&(F=[V,x],G=x);return F}}class g{static create(){const F=new Error;return new g(F.stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E extends Error{constructor(F,G){super(F),this.name="ListenerLeakError",this.stack=G}}e.$oe=E;class w extends Error{constructor(F,G){super(F),this.name="ListenerRefusalError",this.stack=G}}e.$pe=w;let d=0;class P{constructor(F){this.value=F,this.id=d++}}const $=2,c=(U,F)=>{if(U instanceof P)F(U);else for(let G=0;G<U.length;G++){const V=U[G];V&&F(V)}};let h;if(C){const U=[];setInterval(()=>{U.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(U.join(`
`)),U.length=0)},3e3),h=new FinalizationRegistry(F=>{typeof F=="string"&&U.push(F)})}class i{constructor(F){this.z=0,this.f=F,this.g=m>0||this.f?.leakWarningThreshold?new l(F?.onListenerError??I.$4,this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new p(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(A){const F=this.u;queueMicrotask(()=>{c(F,G=>G.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,G,V)=>{if(this.g&&this.z>this.g.threshold**2){const W=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(W);const _=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ne=new w(`${W}. HINT: Stack shows most frequent listener (${_[1]}-times)`,_[0]);return(this.f?.onListenerError||I.$4)(ne),N.$Zc.None}if(this.m)return N.$Zc.None;G&&(F=F.bind(G));const x=new P(F);let H,te;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(x.stack=g.create(),H=this.g.check(x.stack,this.z+1)),A&&(x.stack=te??g.create()),this.u?this.u instanceof P?(this.w??=new t,this.u=[this.u,x]):this.u.push(x):(this.f?.onWillAddFirstListener?.(this),this.u=x,this.f?.onDidAddFirstListener?.(this)),this.z++;const z=(0,N.$Xc)(()=>{h?.unregister(z),H?.(),this.A(x)});if(V instanceof N.$Yc?V.add(z):Array.isArray(V)&&V.push(z),h){const W=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),_=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(W);h.register(z,_?.[2]??W,z)}return z},this.q}A(F){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const G=this.u,V=G.indexOf(F);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,G[V]=void 0;const x=this.w.current===this;if(this.z*$<=G.length){let H=0;for(let te=0;te<G.length;te++)G[te]?G[H++]=G[te]:x&&(this.w.end--,H<this.w.i&&this.w.i--);G.length=H}}B(F,G){if(!F)return;const V=this.f?.onListenerError||I.$4;if(!V){F.value(G);return}try{F.value(G)}catch(x){V(x)}}C(F){const G=F.current.u;for(;F.i<F.end;)this.B(G[F.i++],F.value);F.reset()}fire(F){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof P)this.B(this.u,F);else{const G=this.w;G.enqueue(this,F,this.u.length),this.C(G)}this.j?.stop()}hasListeners(){return this.z>0}}e.$qe=i;const n=()=>new t;e.$re=n;class t{constructor(){this.i=-1,this.end=0}enqueue(F,G,V){this.i=0,this.end=V,this.current=F,this.value=G}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends i{async fireAsync(F,G,V){if(this.u)for(this.h||(this.h=new k.$0c),c(this.u,x=>this.h.push([x.value,F]));this.h.size>0&&!G.isCancellationRequested;){const[x,H]=this.h.shift(),te=[],z={...H,token:G,waitUntil:W=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");V&&(W=V(W,x)),te.push(W)}};try{x(z)}catch(W){(0,I.$4)(W);continue}Object.freeze(te),await Promise.allSettled(te).then(W=>{for(const _ of W)_.status==="rejected"&&(0,I.$4)(_.reason)})}}}e.$se=s;class r extends i{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new k.$0c,this.t=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.t(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.z&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$te=r;class o extends r{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$ue=o;class u extends i{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(G=>super.fire(G)),this.h=[]}))}}e.$ve=u;class y{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const G={event:F,listener:null};this.h.push(G),this.g&&this.m(G);const V=()=>{this.g&&this.o(G);const x=this.h.indexOf(G);this.h.splice(x,1)};return(0,N.$Xc)((0,a.$hb)(V))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(G=>this.f.fire(G))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$we=y;class O{constructor(F,G,V,x){this.f=new N.$Yc;const H=this.f.add(new y),te=this.f.add(new N.$9c);function z(W){te.set(W,H.add(x(W)))}for(const W of F)z(W);this.f.add(G(W=>{z(W)})),this.f.add(V(W=>{te.deleteAndDispose(W)})),this.event=H.event}dispose(){this.f.dispose()}}e.$xe=O;class S{constructor(){this.f=[]}wrapEvent(F,G,V){return(x,H,te)=>F(z=>{const W=this.f[this.f.length-1];if(!G){W?W.buffers.push(()=>x.call(H,z)):x.call(H,z);return}const _=W;if(!_){x.call(H,G(V,z));return}_.items??=[],_.items.push(z),_.buffers.length===0&&W.buffers.push(()=>{_.reducedResult??=V?_.items.reduce(G,V):_.items.reduce(G),x.call(H,_.reducedResult)})},void 0,te)}bufferEvents(F){const G={buffers:new Array};this.f.push(G);const V=F();return this.f.pop(),G.buffers.forEach(x=>x()),V}}e.$ye=S;class v{constructor(){this.f=!1,this.g=R.None,this.h=N.$Zc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ze=v;class L{static const(F){return new j(F)}constructor(F){this.g=F,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$Ae=L;class j{constructor(F){this.value=F,this.onDidChange=R.None}}}),define(ue[25],de([0,1,3]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.CancellationToken=void 0,e.$Ce=C;const a=Object.freeze(function(A,b){const R=setTimeout(A.bind(b),0);return{dispose(){clearTimeout(R)}}});var N;(function(A){function b(R){return R===A.None||R===A.Cancelled||R instanceof k?!0:!R||typeof R!="object"?!1:typeof R.isCancellationRequested=="boolean"&&typeof R.onCancellationRequested=="function"}A.isCancellationToken=b,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:a})})(N||(e.CancellationToken=N={}));class k{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?a:(this.b||(this.b=new I.$qe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new k),this.f}cancel(){this.f?this.f instanceof k&&this.f.cancel():this.f=N.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof k&&this.f.dispose():this.f=N.None}}e.$Be=T;function C(A){const b=new T;return A.add({dispose(){b.cancel()}}),b.token}}),define(ue[136],de([0,1,25]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ef=e.$df=e.$bf=void 0,e.$cf=N;class a{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new I.$Be,b=this.b(A.token);return this.a={promise:b,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.$bf=a;function N(C){return C}class k{constructor(A,b){this.a=void 0,this.b=void 0,typeof A=="function"?(this.c=A,this.d=N):(this.c=b,this.d=A.getCacheKey)}get(A){const b=this.d(A);return this.b!==b&&(this.b=b,this.a=this.c(A)),this.a}}e.$df=k;class T{get cachedValues(){return this.a}constructor(A,b){this.a=new Map,this.b=new Map,typeof A=="function"?(this.c=A,this.d=N):(this.c=b,this.d=A.getCacheKey)}get(A){const b=this.d(A);if(this.b.has(b))return this.b.get(b);const R=this.c(A);return this.a.set(A,R),this.b.set(b,R),R}}e.$ef=T}),define(ue[50],de([0,1,8,2]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=N,e.$Ee=k,e.$Fe=T,e.$Ge=C,e.$He=b,e.$Ie=R,e.$Je=p,e.$Ke=m,e.$Le=f,e.$Me=l,e.$Ne=g,e.$Oe=E,e.$Pe=w,e.$Qe=d,e.$Re=P;function N($){const c=$;return c?typeof c.read=="function":!1}function k($){const c=$;return c?[c.on,c.pause,c.resume,c.destroy].every(h=>typeof h=="function"):!1}function T($){const c=$;return c?k(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}function C($,c){return new A($,c)}class A{constructor(c,h){this.e=c,this.f=h,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(h=>this.d.push(h))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(h=>h(c))}h(c){this.c.error.length===0?(0,I.$4)(c):this.c.error.slice(0).forEach(h=>h(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,h){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(h),this.resume();break;case"end":this.c.end.push(h),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(h),this.a.flowing&&this.k();break}}removeListener(c,h){if(this.a.destroyed)return;let i;switch(c){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const n=i.indexOf(h);n>=0&&i.splice(n,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const h=[...this.d];this.d.length=0,h.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b($,c){const h=[];let i;for(;(i=$.read())!==null;)h.push(i);return c(h)}function R($,c,h){const i=[];let n;for(;(n=$.read())!==null&&i.length<h;)i.push(n);return n===null&&i.length>0?c(i):{read:()=>{if(i.length>0)return i.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return $.read()}}}function p($,c){return new Promise((h,i)=>{const n=[];m($,{onData:t=>{c&&n.push(t)},onError:t=>{c?i(t):h(void 0)},onEnd:()=>{h(c?c(n):void 0)}})})}function m($,c,h){$.on("error",i=>{h?.isCancellationRequested||c.onError(i)}),$.on("end",()=>{h?.isCancellationRequested||c.onEnd()}),$.on("data",i=>{h?.isCancellationRequested||c.onData(i)})}function f($,c){return new Promise((h,i)=>{const n=new a.$Yc,t=[],s=u=>{if(t.push(u),t.length>c)return n.dispose(),$.pause(),h({stream:$,buffer:t,ended:!1})},r=u=>(n.dispose(),i(u)),o=()=>(n.dispose(),h({stream:$,buffer:t,ended:!0}));n.add((0,a.$Xc)(()=>$.removeListener("error",r))),$.on("error",r),n.add((0,a.$Xc)(()=>$.removeListener("end",o))),$.on("end",o),n.add((0,a.$Xc)(()=>$.removeListener("data",s))),$.on("data",s)})}function l($,c){const h=C(c);return h.end($),h}function g(){const $=C(()=>{throw new Error("not supported")});return $.end(),$}function E($){let c=!1;return{read:()=>c?null:(c=!0,$)}}function w($,c,h){const i=C(h);return m($,{onData:n=>i.write(c.data(n)),onError:n=>i.error(c.error?c.error(n):n),onEnd:()=>i.end()}),i}function d($,c,h){let i=!1;return{read:()=>{const n=c.read();return i?n:(i=!0,n!==null?h([$,n]):$)}}}function P($,c,h){let i=!1;const n=C(h);return m(c,{onData:t=>i?n.write(t):(i=!0,n.write(h([$,t]))),onError:t=>n.error(t),onEnd:()=>{i||(i=!0,n.write($)),n.end()}}),n}});var kt=this&&this.__createBinding||(Object.create?function(ce,e,I,a){a===void 0&&(a=I);var N=Object.getOwnPropertyDescriptor(e,I);(!N||("get"in N?!e.__esModule:N.writable||N.configurable))&&(N={enumerable:!0,get:function(){return e[I]}}),Object.defineProperty(ce,a,N)}:function(ce,e,I,a){a===void 0&&(a=I),ce[a]=e[I]}),At=this&&this.__setModuleDefault||(Object.create?function(ce,e){Object.defineProperty(ce,"default",{enumerable:!0,value:e})}:function(ce,e){ce.default=e}),Oe=this&&this.__importStar||function(ce){if(ce&&ce.__esModule)return ce;var e={};if(ce!=null)for(var I in ce)I!=="default"&&Object.prototype.hasOwnProperty.call(ce,I)&&kt(e,ce,I);return At(e,ce),e};define(ue[14],de([0,1,53,50]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=void 0,e.$Te=b,e.$Ue=R,e.$Ve=p,e.$We=m,e.$Xe=f,e.$Ye=l,e.$Ze=g,e.$1e=E,e.$2e=w,e.$3e=d,e.$4e=P,e.$5e=$,e.$6e=c,e.$7e=h,e.$8e=i,e.$9e=n,e.$0e=t,e.$$e=s,e.$_e=r,e.$af=y,a=Oe(a);const N=typeof Buffer<"u",k=new I.$Y(()=>new Uint8Array(256));let T,C;class A{static alloc(S){return N?new A(Buffer.allocUnsafe(S)):new A(new Uint8Array(S))}static wrap(S){return N&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new A(S)}static fromString(S,v){return!(v?.dontUseNodeBuffer||!1)&&N?new A(Buffer.from(S)):(T||(T=new TextEncoder),new A(T.encode(S)))}static fromByteArray(S){const v=A.alloc(S.length);for(let L=0,j=S.length;L<j;L++)v.buffer[L]=S[L];return v}static concat(S,v){if(typeof v>"u"){v=0;for(let U=0,F=S.length;U<F;U++)v+=S[U].byteLength}const L=A.alloc(v);let j=0;for(let U=0,F=S.length;U<F;U++){const G=S[U];L.set(G,j),j+=G.byteLength}return L}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=A.alloc(this.byteLength);return S.set(this),S}toString(){return N?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(S,v){return new A(this.buffer.subarray(S,v))}set(S,v){if(S instanceof A)this.buffer.set(S.buffer,v);else if(S instanceof Uint8Array)this.buffer.set(S,v);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),v);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return m(this.buffer,S)}writeUInt32BE(S,v){f(this.buffer,S,v)}readUInt32LE(S){return l(this.buffer,S)}writeUInt32LE(S,v){g(this.buffer,S,v)}readUInt8(S){return E(this.buffer,S)}writeUInt8(S,v){w(this.buffer,S,v)}indexOf(S,v=0){return b(this.buffer,S instanceof A?S.buffer:S,v)}}e.$Se=A;function b(O,S,v=0){const L=S.byteLength,j=O.byteLength;if(L===0)return 0;if(L===1)return O.indexOf(S[0]);if(L>j-v)return-1;const U=k.value;U.fill(S.length);for(let x=0;x<S.length;x++)U[S[x]]=S.length-x-1;let F=v+S.length-1,G=F,V=-1;for(;F<j;)if(O[F]===S[G]){if(G===0){V=F;break}F--,G--}else F+=Math.max(S.length-G,U[O[F]]),G=S.length-1;return V}function R(O,S){return O[S+0]<<0>>>0|O[S+1]<<8>>>0}function p(O,S,v){O[v+0]=S&255,S=S>>>8,O[v+1]=S&255}function m(O,S){return O[S]*2**24+O[S+1]*2**16+O[S+2]*2**8+O[S+3]}function f(O,S,v){O[v+3]=S,S=S>>>8,O[v+2]=S,S=S>>>8,O[v+1]=S,S=S>>>8,O[v]=S}function l(O,S){return O[S+0]<<0>>>0|O[S+1]<<8>>>0|O[S+2]<<16>>>0|O[S+3]<<24>>>0}function g(O,S,v){O[v+0]=S&255,S=S>>>8,O[v+1]=S&255,S=S>>>8,O[v+2]=S&255,S=S>>>8,O[v+3]=S&255}function E(O,S){return O[S]}function w(O,S,v){O[v]=S}function d(O){return a.$He(O,S=>A.concat(S))}function P(O){return a.$Oe(O)}function $(O){return a.$Je(O,S=>A.concat(S))}async function c(O){return O.ended?A.concat(O.buffer):A.concat([...O.buffer,await $(O.stream)])}function h(O){return a.$Me(O,S=>A.concat(S))}function i(O){return a.$Pe(O,{data:S=>typeof S=="string"?A.fromString(S):A.wrap(S)},S=>A.concat(S))}function n(O){return a.$Ge(S=>A.concat(S),O)}function t(O,S){return a.$Qe(O,S,v=>A.concat(v))}function s(O,S){return a.$Re(O,S,v=>A.concat(v))}function r(O){let S=0,v=0,L=0;const j=new Uint8Array(Math.floor(O.length/4*3)),U=G=>{switch(v){case 3:j[L++]=S|G,v=0;break;case 2:j[L++]=S|G>>>2,S=G<<6,v=3;break;case 1:j[L++]=S|G>>>4,S=G<<4,v=2;break;default:S=G<<2,v=1}};for(let G=0;G<O.length;G++){const V=O.charCodeAt(G);if(V>=65&&V<=90)U(V-65);else if(V>=97&&V<=122)U(V-97+26);else if(V>=48&&V<=57)U(V-48+52);else if(V===43||V===45)U(62);else if(V===47||V===95)U(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${O[G]}`)}}const F=L;for(;v>0;)U(0);return A.wrap(j).slice(0,F)}const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:O},S=!0,v=!1){const L=v?u:o;let j="";const U=O.byteLength%3;let F=0;for(;F<O.byteLength-U;F+=3){const G=O[F+0],V=O[F+1],x=O[F+2];j+=L[G>>>2],j+=L[(G<<4|V>>>4)&63],j+=L[(V<<2|x>>>6)&63],j+=L[x&63]}if(U===1){const G=O[F+0];j+=L[G>>>2],j+=L[G<<4&63],S&&(j+="==")}else if(U===2){const G=O[F+0],V=O[F+1];j+=L[G>>>2],j+=L[(G<<4|V>>>4)&63],j+=L[V<<2&63],S&&(j+="=")}return j}}),define(ue[137],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=void 0,e.$le=Symbol("MicrotaskDelay")}),define(ue[12],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=I,e.$kg=a,e.$lg=N,e.$mg=k,e.$ng=T,e.$og=C,e.$pg=A,e.$qg=b,e.$rg=R,e.$sg=p,e.$tg=m,e.$ug=f,e.$vg=l,e.$wg=E,e.$xg=w,e.$yg=d,e.$zg=P,e.$Ag=$,e.$Bg=c;function I(h){return typeof h=="string"}function a(h){return Array.isArray(h)&&h.every(i=>I(i))}function N(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}function k(h){const i=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof i}function T(h){return typeof h=="number"&&!isNaN(h)}function C(h){return!!h&&typeof h[Symbol.iterator]=="function"}function A(h){return h===!0||h===!1}function b(h){return typeof h>"u"}function R(h){return!p(h)}function p(h){return b(h)||h===null}function m(h,i){if(!h)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function f(h){if(p(h))throw new Error("Assertion Failed: argument is undefined or null");return h}function l(...h){const i=[];for(let n=0;n<h.length;n++){const t=h[n];if(p(t))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(t)}return i}const g=Object.prototype.hasOwnProperty;function E(h){if(!N(h))return!1;for(const i in h)if(g.call(h,i))return!1;return!0}function w(h){return typeof h=="function"}function d(...h){return h.length>0&&h.every(w)}function P(h,i){const n=Math.min(h.length,i.length);for(let t=0;t<n;t++)$(h[t],i[t])}function $(h,i){if(I(i)){if(typeof h!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(w(i)){try{if(h instanceof i)return}catch{}if(!p(h)&&h.constructor===i||i.length===1&&i.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function c(h){return h}}),define(ue[29],de([0,1,12]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=a,e.$lo=N,e.$mo=T,e.$no=A,e.$oo=b,e.$po=R,e.$qo=p,e.$ro=m,e.$so=f,e.$to=l,e.$uo=g,e.$vo=E,e.$wo=w;function a(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const P=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([$,c])=>{P[$]=c&&typeof c=="object"?a(c):c}),P}function N(d){if(!d||typeof d!="object")return d;const P=[d];for(;P.length>0;){const $=P.shift();Object.freeze($);for(const c in $)if(k.call($,c)){const h=$[c];typeof h=="object"&&!Object.isFrozen(h)&&!(0,I.$mg)(h)&&P.push(h)}}return d}const k=Object.prototype.hasOwnProperty;function T(d,P){return C(d,P,new Set)}function C(d,P,$){if((0,I.$sg)(d))return d;const c=P(d);if(typeof c<"u")return c;if(Array.isArray(d)){const h=[];for(const i of d)h.push(C(i,P,$));return h}if((0,I.$lg)(d)){if($.has(d))throw new Error("Cannot clone recursive data-structure");$.add(d);const h={};for(const i in d)k.call(d,i)&&(h[i]=C(d[i],P,$));return $.delete(d),h}return d}function A(d,P,$=!0){return(0,I.$lg)(d)?((0,I.$lg)(P)&&Object.keys(P).forEach(c=>{c in d?$&&((0,I.$lg)(d[c])&&(0,I.$lg)(P[c])?A(d[c],P[c],$):d[c]=P[c]):d[c]=P[c]}),d):P}function b(d,P){if(d===P)return!0;if(d==null||P===null||P===void 0||typeof d!=typeof P||typeof d!="object"||Array.isArray(d)!==Array.isArray(P))return!1;let $,c;if(Array.isArray(d)){if(d.length!==P.length)return!1;for($=0;$<d.length;$++)if(!b(d[$],P[$]))return!1}else{const h=[];for(c in d)h.push(c);h.sort();const i=[];for(c in P)i.push(c);if(i.sort(),!b(h,i))return!1;for($=0;$<h.length;$++)if(!b(d[h[$]],P[h[$]]))return!1}return!0}function R(d){const P=new Set;return JSON.stringify(d,($,c)=>{if((0,I.$lg)(c)||Array.isArray(c)){if(P.has(c))return"[Circular]";P.add(c)}return typeof c=="bigint"?`[BigInt ${c.toString()}]`:c})}function p(d,P){const $=Object.create(null);return!d||!P||Object.keys(P).forEach(h=>{const i=d[h],n=P[h];b(i,n)||($[h]=n)}),$}function m(d,P){const $=P.toLowerCase(),c=Object.keys(d).find(h=>h.toLowerCase()===$);return c?d[c]:d[P]}function f(d,P){const $=Object.create(null);for(const[c,h]of Object.entries(d))P(c,h)&&($[c]=h);return $}function l(d){let P=[];for(;Object.prototype!==d;)P=P.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return P}function g(d){const P=[];for(const $ of l(d))typeof d[$]=="function"&&P.push($);return P}function E(d,P){const $=h=>function(){const i=Array.prototype.slice.call(arguments,0);return P(h,i)},c={};for(const h of d)c[h]=$(h);return c}function w(d,P){const $={};for(const[c,h]of Object.entries(d))$[c]=P(h,c);return $}}),define(ue[138],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$ff=a,e.$gf=N;var I;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(I||(e.Constants=I={}));function a(k){return k<0?0:k>I.MAX_UINT_8?I.MAX_UINT_8:k|0}function N(k){return k<0?0:k>I.MAX_UINT_32?I.MAX_UINT_32:k|0}}),define(ue[26],de([0,1,136,39,53,138]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=e.GraphemeBreakType=e.$9f=e.$1f=e.$Tf=e.$Sf=void 0,e.$hf=T,e.$if=A,e.$jf=R,e.$kf=p,e.$lf=m,e.$mf=f,e.$nf=l,e.$of=g,e.$pf=E,e.$qf=w,e.$rf=d,e.$sf=P,e.$tf=$,e.$uf=c,e.$vf=h,e.$wf=i,e.$xf=n,e.$yf=t,e.$zf=s,e.$Af=r,e.$Bf=o,e.$Cf=u,e.$Df=y,e.$Ef=O,e.$Ff=S,e.$Gf=v,e.$Hf=L,e.$If=j,e.$Jf=U,e.$Kf=F,e.$Lf=G,e.$Mf=V,e.$Nf=x,e.$Of=H,e.$Pf=te,e.$Qf=z,e.$Rf=W,e.$Uf=ee,e.$Vf=X,e.$Wf=K,e.$Xf=q,e.$Yf=oe,e.$Zf=Y,e.$2f=M,e.$3f=B,e.$4f=ie,e.$5f=ae,e.$6f=pe,e.$7f=be,e.$8f=ke,e.$0f=ve,e.$$f=we,e.$_f=re,e.$ag=fe,e.$bg=me,e.$cg=Se,e.$dg=Pe,e.$eg=De,e.$fg=Ve;function T(se){return!se||typeof se!="string"?!0:se.trim().length===0}const C=/{(\d+)}/g;function A(se,...ge){return ge.length===0?se:se.replace(C,function($e,ye){const Ae=parseInt(ye,10);return isNaN(Ae)||Ae<0||Ae>=ge.length?$e:ge[Ae]})}const b=/{([^}]+)}/g;function R(se,ge){return Object.keys(ge).length===0?se:se.replace(b,($e,ye)=>ge[ye]??$e)}function p(se){return se.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function m(se){return se.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function f(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(se,ge){let $e=0,ye=se.indexOf(ge);for(;ye!==-1;)$e++,ye=se.indexOf(ge,ye+ge.length);return $e}function g(se,ge,$e="\u2026"){return se.length<=ge?se:`${se.substr(0,ge)}${$e}`}function E(se,ge,$e="\u2026"){if(se.length<=ge)return se;const ye=Math.ceil(ge/2)-$e.length/2,Ae=Math.floor(ge/2)-$e.length/2;return`${se.substr(0,ye)}${$e}${se.substr(se.length-Ae)}`}function w(se,ge=" "){const $e=d(se,ge);return P($e,ge)}function d(se,ge){if(!se||!ge)return se;const $e=ge.length;if($e===0||se.length===0)return se;let ye=0;for(;se.indexOf(ge,ye)===ye;)ye=ye+$e;return se.substring(ye)}function P(se,ge){if(!se||!ge)return se;const $e=ge.length,ye=se.length;if($e===0||ye===0)return se;let Ae=ye,Te=-1;for(;Te=se.lastIndexOf(ge,Ae-1),!(Te===-1||Te+$e!==Ae);){if(Te===0)return"";Ae=Te}return se.substring(0,Ae)}function $(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function c(se){return se.replace(/\*/g,"")}function h(se,ge,$e={}){if(!se)throw new Error("Cannot create regex from empty string");ge||(se=f(se)),$e.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(se,ye)}function i(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function n(se){return se.split(/\r\n|\r|\n/)}function t(se){const ge=[],$e=se.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil($e.length/2);ye++)ge.push($e[2*ye]+($e[2*ye+1]??""));return ge}function s(se){for(let ge=0,$e=se.length;ge<$e;ge++){const ye=se.charCodeAt(ge);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return ge}return-1}function r(se,ge=0,$e=se.length){for(let ye=ge;ye<$e;ye++){const Ae=se.charCodeAt(ye);if(Ae!==a.CharCode.Space&&Ae!==a.CharCode.Tab)return se.substring(ge,ye)}return se.substring(ge,$e)}function o(se,ge=se.length-1){for(let $e=ge;$e>=0;$e--){const ye=se.charCodeAt($e);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return $e}return-1}function u(se,ge,$e){const ye=[];let Ae=0;for(const Te of se.matchAll(ge)){if(ye.push(se.slice(Ae,Te.index)),Te.index===void 0)throw new Error("match.index should be defined");Ae=Te.index+Te[0].length,ye.push($e(Te[0],...Te.slice(1),Te.index,se,Te.groups))}return ye.push(se.slice(Ae)),Promise.all(ye).then(Te=>Te.join(""))}function y(se,ge){return se<ge?-1:se>ge?1:0}function O(se,ge,$e=0,ye=se.length,Ae=0,Te=ge.length){for(;$e<ye&&Ae<Te;$e++,Ae++){const Je=se.charCodeAt($e),Ze=ge.charCodeAt(Ae);if(Je<Ze)return-1;if(Je>Ze)return 1}const qe=ye-$e,xe=Te-Ae;return qe<xe?-1:qe>xe?1:0}function S(se,ge){return v(se,ge,0,se.length,0,ge.length)}function v(se,ge,$e=0,ye=se.length,Ae=0,Te=ge.length){for(;$e<ye&&Ae<Te;$e++,Ae++){let Je=se.charCodeAt($e),Ze=ge.charCodeAt(Ae);if(Je===Ze)continue;if(Je>=128||Ze>=128)return O(se.toLowerCase(),ge.toLowerCase(),$e,ye,Ae,Te);j(Je)&&(Je-=32),j(Ze)&&(Ze-=32);const He=Je-Ze;if(He!==0)return He}const qe=ye-$e,xe=Te-Ae;return qe<xe?-1:qe>xe?1:0}function L(se){return se>=a.CharCode.Digit0&&se<=a.CharCode.Digit9}function j(se){return se>=a.CharCode.a&&se<=a.CharCode.z}function U(se){return se>=a.CharCode.A&&se<=a.CharCode.Z}function F(se,ge){return se.length===ge.length&&v(se,ge)===0}function G(se,ge){const $e=ge.length;return ge.length>se.length?!1:v(se,ge,0,$e)===0}function V(se,ge){const $e=Math.min(se.length,ge.length);let ye;for(ye=0;ye<$e;ye++)if(se.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return $e}function x(se,ge){const $e=Math.min(se.length,ge.length);let ye;const Ae=se.length-1,Te=ge.length-1;for(ye=0;ye<$e;ye++)if(se.charCodeAt(Ae-ye)!==ge.charCodeAt(Te-ye))return ye;return $e}function H(se){return 55296<=se&&se<=56319}function te(se){return 56320<=se&&se<=57343}function z(se,ge){return(se-55296<<10)+(ge-56320)+65536}function W(se,ge,$e){const ye=se.charCodeAt($e);if(H(ye)&&$e+1<ge){const Ae=se.charCodeAt($e+1);if(te(Ae))return z(ye,Ae)}return ye}function _(se,ge){const $e=se.charCodeAt(ge-1);if(te($e)&&ge>1){const ye=se.charCodeAt(ge-2);if(H(ye))return z(ye,$e)}return $e}class ne{get offset(){return this.e}constructor(ge,$e=0){this.c=ge,this.d=ge.length,this.e=$e}setOffset(ge){this.e=ge}prevCodePoint(){const ge=_(this.c,this.e);return this.e-=ge>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=W(this.c,this.d,this.e);return this.e+=ge>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Sf=ne;class le{get offset(){return this.c.offset}constructor(ge,$e=0){this.c=new ne(ge,$e)}nextGraphemeLength(){const ge=je.getInstance(),$e=this.c,ye=$e.offset;let Ae=ge.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Te=$e.offset,qe=ge.getGraphemeBreakType($e.nextCodePoint());if(Ne(Ae,qe)){$e.setOffset(Te);break}Ae=qe}return $e.offset-ye}prevGraphemeLength(){const ge=je.getInstance(),$e=this.c,ye=$e.offset;let Ae=ge.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Te=$e.offset,qe=ge.getGraphemeBreakType($e.prevCodePoint());if(Ne(qe,Ae)){$e.setOffset(Te);break}Ae=qe}return ye-$e.offset}eol(){return this.c.eol()}}e.$Tf=le;function ee(se,ge){return new le(se,ge).nextGraphemeLength()}function X(se,ge){return new le(se,ge).prevGraphemeLength()}function K(se,ge){ge>0&&te(se.charCodeAt(ge))&&ge--;const $e=ge+ee(se,ge);return[$e-X(se,$e),$e]}function q(se){const ge=new le(se);let $e=0;for(;!ge.eol();)$e++,ge.nextGraphemeLength();return $e}let D;function J(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(se){return D||(D=J()),D.test(se)}const Q=/^[\t\n\r\x20-\x7E]*$/;function Y(se){return Q.test(se)}e.$1f=/[\u2028\u2029]/;function M(se){return e.$1f.test(se)}function B(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function ie(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function ae(se,ge,$e=""){const ye=se.trimStart();if(ye.length<ge)return ye;const Ae=/\b/g;let Te=0;for(;Ae.test(ye)&&!(ye.length-Ae.lastIndex<ge);)Te=Ae.lastIndex,Ae.lastIndex+=1;return Te===0?ye:$e+ye.substring(Te).trimStart()}const he=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(se){let ge=0;for(const $e of se.matchAll(he))ge!==$e.index&&(yield{isCode:!1,str:se.substring(ge,$e.index)}),yield{isCode:!0,str:$e[0]},ge=$e.index+$e[0].length;ge!==se.length&&(yield{isCode:!1,str:se.substring(ge)})}function be(se){return se&&(se=se.replace(he,"")),se}const Ie=/\\\[.*?\\\]/g;function ke(se){return be(se).replace(Ie,"")}e.$9f=String.fromCharCode(a.CharCode.UTF8_BOM);function ve(se){return!!(se&&se.length>0&&se.charCodeAt(0)===a.CharCode.UTF8_BOM)}function we(se){return ve(se)?se.substr(1):se}function re(se,ge){if(!se||!ge||se.length<ge.length)return!1;const $e=ge.length,ye=se.toLowerCase();let Ae=0,Te=-1;for(;Ae<$e;){const qe=ye.indexOf(ge[Ae],Te+1);if(qe<0)return!1;Te=qe,Ae++}return!0}function fe(se,ge=!1){return se?(ge&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function me(se){return se.charAt(0).toUpperCase()+se.slice(1)}function Se(se,ge=1){if(ge===0)return"";let $e=-1;do $e=se.indexOf(`
`,$e+1),ge--;while(ge>0&&$e>=0);return $e===-1?se:(se[$e-1]==="\r"&&$e--,se.substr(0,$e))}function Pe(se){const ge=a.CharCode.Z-a.CharCode.A+1;return se=se%(2*ge),se<ge?String.fromCharCode(a.CharCode.a+se):String.fromCharCode(a.CharCode.A+se-ge)}function De(se){return je.getInstance().getGraphemeBreakType(se)}function Ne(se,ge){return se===Ce.Other?ge!==Ce.Extend&&ge!==Ce.SpacingMark:se===Ce.CR&&ge===Ce.LF?!1:se===Ce.Control||se===Ce.CR||se===Ce.LF||ge===Ce.Control||ge===Ce.CR||ge===Ce.LF?!0:!(se===Ce.L&&(ge===Ce.L||ge===Ce.V||ge===Ce.LV||ge===Ce.LVT)||(se===Ce.LV||se===Ce.V)&&(ge===Ce.V||ge===Ce.T)||(se===Ce.LVT||se===Ce.T)&&ge===Ce.T||ge===Ce.Extend||ge===Ce.ZWJ||ge===Ce.SpacingMark||se===Ce.Prepend||se===Ce.ZWJ&&ge===Ce.Extended_Pictographic||se===Ce.Regional_Indicator&&ge===Ce.Regional_Indicator)}var Ce;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(e.GraphemeBreakType=Ce={}));class je{static{this.c=null}static getInstance(){return je.c||(je.c=new je),je.c}constructor(){this.d=Me()}getGraphemeBreakType(ge){if(ge<32)return ge===a.CharCode.LineFeed?Ce.LF:ge===a.CharCode.CarriageReturn?Ce.CR:Ce.Control;if(ge<127)return Ce.Other;const $e=this.d,ye=$e.length/3;let Ae=1;for(;Ae<=ye;)if(ge<$e[3*Ae])Ae=2*Ae;else if(ge>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return Ce.Other}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(se,ge){if(se===0)return 0;const $e=Fe(se,ge);if($e!==void 0)return $e;const ye=new ne(ge,se);return ye.prevCodePoint(),ye.offset}function Fe(se,ge){const $e=new ne(ge,se);let ye=$e.prevCodePoint();for(;Be(ye)||ye===ze.emojiVariantSelector||ye===ze.enclosingKeyCap;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!ie(ye))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===ze.zwj&&(Ae=$e.offset),Ae}function Be(se){return 127995<=se&&se<=127999}var ze;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$gg="\xA0";class We{static{this.c=new N.$Y(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$df({getCacheKey:JSON.stringify},ge=>{function $e(He){const _e=new Map;for(let Ye=0;Ye<He.length;Ye+=2)_e.set(He[Ye],He[Ye+1]);return _e}function ye(He,_e){const Ye=new Map(He);for(const[nt,at]of _e)Ye.set(nt,at);return Ye}function Ae(He,_e){if(!He)return _e;const Ye=new Map;for(const[nt,at]of He)_e.has(nt)&&Ye.set(nt,at);return Ye}const Te=this.c.value;let qe=ge.filter(He=>!He.startsWith("_")&&He in Te);qe.length===0&&(qe=["_default"]);let xe;for(const He of qe){const _e=$e(Te[He]);xe=Ae(xe,_e)}const Je=$e(Te._common),Ze=ye(Je,xe);return new We(Ze)})}static getInstance(ge){return We.d.get(Array.from(ge))}static{this.e=new N.$Y(()=>Object.keys(We.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return We.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let $e=0;$e<ge.length;$e++){const ye=ge.codePointAt($e);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hg=We;class Le{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Le.c())),this.d}static isInvisibleCharacter(ge){return Le.e().has(ge)}static containsInvisibleCharacter(ge){for(let $e=0;$e<ge.length;$e++){const ye=ge.codePointAt($e);if(typeof ye=="number"&&Le.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Le.e()}}e.$ig=Le}),define(ue[55],de([0,1,26]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Cj=void 0,e.$yj=a,e.$zj=N,e.$Aj=k,e.$Bj=C,e.$Dj=g,I=Oe(I);function a(w){return N(w,0)}function N(w,d){switch(typeof w){case"object":return w===null?k(349,d):Array.isArray(w)?A(w,d):b(w,d);case"string":return C(w,d);case"boolean":return T(w,d);case"number":return k(w,d);case"undefined":return k(937,d);default:return k(617,d)}}function k(w,d){return(d<<5)-d+w|0}function T(w,d){return k(w?433:863,d)}function C(w,d){d=k(149417,d);for(let P=0,$=w.length;P<$;P++)d=k(w.charCodeAt(P),d);return d}function A(w,d){return d=k(104579,d),w.reduce((P,$)=>N($,P),d)}function b(w,d){return d=k(181387,d),Object.keys(w).sort().reduce((P,$)=>(P=C($,P),N(w[$],P)),d)}class R{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=N(d,this.g),this.g}}e.$Cj=R;var p;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function m(w,d,P=32){const $=P-d,c=~((1<<$)-1);return(w<<d|(c&w)>>>$)>>>0}function f(w,d=0,P=w.byteLength,$=0){for(let c=0;c<P;c++)w[d+c]=$}function l(w,d,P="0"){for(;w.length<d;)w=P+w;return w}function g(w,d=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(P=>P.toString(16).padStart(2,"0")).join(""):l((w>>>0).toString(16),d/4)}class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(p.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const P=d.length;if(P===0)return;const $=this.p;let c=this.r,h=this.u,i,n;for(h!==0?(i=h,n=-1,h=0):(i=d.charCodeAt(0),n=0);;){let t=i;if(I.$Of(i))if(n+1<P){const s=d.charCodeAt(n+1);I.$Pf(s)?(n++,t=I.$Qf(i,s)):t=p.UNICODE_REPLACEMENT}else{h=i;break}else I.$Pf(i)&&(t=p.UNICODE_REPLACEMENT);if(c=this.w($,c,t),n++,n<P)i=d.charCodeAt(n);else break}this.r=c,this.u=h}w(d,P,$){return $<128?d[P++]=$:$<2048?(d[P++]=192|($&1984)>>>6,d[P++]=128|($&63)>>>0):$<65536?(d[P++]=224|($&61440)>>>12,d[P++]=128|($&4032)>>>6,d[P++]=128|($&63)>>>0):(d[P++]=240|($&1835008)>>>18,d[P++]=128|($&258048)>>>12,d[P++]=128|($&4032)>>>6,d[P++]=128|($&63)>>>0),P>=p.BLOCK_SIZE&&(this.y(),P-=p.BLOCK_SIZE,this.t+=p.BLOCK_SIZE,d[0]=d[p.BLOCK_SIZE+0],d[1]=d[p.BLOCK_SIZE+1],d[2]=d[p.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,p.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=E.g,P=this.q;for(let o=0;o<64;o+=4)d.setUint32(o,P.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)d.setUint32(o,m(d.getUint32(o-12,!1)^d.getUint32(o-32,!1)^d.getUint32(o-56,!1)^d.getUint32(o-64,!1),1),!1);let $=this.h,c=this.l,h=this.m,i=this.n,n=this.o,t,s,r;for(let o=0;o<80;o++)o<20?(t=c&h|~c&i,s=1518500249):o<40?(t=c^h^i,s=1859775393):o<60?(t=c&h|c&i|h&i,s=2400959708):(t=c^h^i,s=3395469782),r=m($,5)+t+n+s+d.getUint32(o*4,!1)&4294967295,n=i,i=h,h=m(c,30),c=$,$=r;this.h=this.h+$&4294967295,this.l=this.l+c&4294967295,this.m=this.m+h&4294967295,this.n=this.n+i&4294967295,this.o=this.o+n&4294967295}}e.$Ej=E}),define(ue[92],de([0,1,26]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),I=Oe(I);var a;(function(N){N[N.Ignore=0]="Ignore",N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(a||(a={})),function(N){const k="error",T="warning",C="warn",A="info",b="ignore";function R(m){return m?I.$Kf(k,m)?N.Error:I.$Kf(T,m)||I.$Kf(C,m)?N.Warning:I.$Kf(A,m)?N.Info:N.Ignore:N.Ignore}N.fromValue=R;function p(m){switch(m){case N.Error:return k;case N.Warning:return T;case N.Info:return A;default:return b}}N.toString=p}(a||(a={})),e.default=a}),define(ue[51],de([0,1,17,39,26]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class k{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const g=l.charCodeAt(0),E=this.b.charCodeAt(this.c);return g-E}value(){return this.b[this.c]}}e.$Mi=k;class T{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===a.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,N.$Ef)(l,this.b,0,l.length,this.c,this.d):(0,N.$Gf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ni=T;class C{constructor(l=!0,g=!0){this.f=l,this.g=g}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let g=l.length-1;g>=0;g--,this.c--){const E=this.b.charCodeAt(g);if(!(E===a.CharCode.Slash||this.f&&E===a.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===a.CharCode.Slash||this.f&&g===a.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,N.$Ef)(l,this.b,0,l.length,this.d,this.e):(0,N.$Gf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Oi=C;var A;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(A||(A={}));class b{constructor(l,g){this.f=l,this.g=g,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(A.Scheme),this.c.authority&&this.d.push(A.Authority),this.c.path&&(this.b=new C(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(A.Path)),this.g(l)||(this.c.query&&this.d.push(A.Query),this.c.fragment&&this.d.push(A.Fragment)),this.e=0,this}next(){return this.d[this.e]===A.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===A.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===A.Scheme)return(0,N.$Ff)(l,this.c.scheme);if(this.d[this.e]===A.Authority)return(0,N.$Ff)(l,this.c.authority);if(this.d[this.e]===A.Path)return this.b.cmp(l);if(this.d[this.e]===A.Query)return(0,N.$Df)(l,this.c.query);if(this.d[this.e]===A.Fragment)return(0,N.$Df)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===A.Scheme)return this.c.scheme;if(this.d[this.e]===A.Authority)return this.c.authority;if(this.d[this.e]===A.Path)return this.b.value();if(this.d[this.e]===A.Query)return this.c.query;if(this.d[this.e]===A.Fragment)return this.c.fragment;throw new Error}}e.$Pi=b;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(p||(p={}));class m{static forUris(l=()=>!1,g=()=>!1){return new m(new b(l,g))}static forPaths(l=!1){return new m(new C(void 0,!l))}static forStrings(){return new m(new k)}static forConfigKeys(){return new m(new T)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,g){if(g){const E=g.slice(0);(0,I.$1b)(E);for(const w of E)this.set(w,l)}else{const E=l.slice(0);(0,I.$1b)(E);for(const w of E)this.set(w[0],w[1])}}set(l,g){const E=this.b.reset(l);let w;this.c||(this.c=new R,this.c.segment=E.value());const d=[];for(w=this.c;;){const $=E.cmp(w.segment);if($>0)w.left||(w.left=new R,w.left.segment=E.value()),d.push([p.Left,w]),w=w.left;else if($<0)w.right||(w.right=new R,w.right.segment=E.value()),d.push([p.Right,w]),w=w.right;else if(E.hasNext())E.next(),w.mid||(w.mid=new R,w.mid.segment=E.value()),d.push([p.Mid,w]),w=w.mid;else break}const P=w.value;w.value=g,w.key=l;for(let $=d.length-1;$>=0;$--){const c=d[$][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=d[$][0],n=d[$+1][0];if(i===p.Right&&n===p.Right)d[$][1]=c.rotateLeft();else if(i===p.Left&&n===p.Left)d[$][1]=c.rotateRight();else if(i===p.Right&&n===p.Left)c.right=d[$+1][1]=d[$+1][1].rotateRight(),d[$][1]=c.rotateLeft();else if(i===p.Left&&n===p.Right)c.left=d[$+1][1]=d[$+1][1].rotateLeft(),d[$][1]=c.rotateRight();else throw new Error;if($>0)switch(d[$-1][0]){case p.Left:d[$-1][1].left=d[$][1];break;case p.Right:d[$-1][1].right=d[$][1];break;case p.Mid:d[$-1][1].mid=d[$][1];break}else this.c=d[0][1]}}return P}get(l){return this.d(l)?.value}d(l){const g=this.b.reset(l);let E=this.c;for(;E;){const w=g.cmp(E.segment);if(w>0)E=E.left;else if(w<0)E=E.right;else if(g.hasNext())g.next(),E=E.mid;else break}return E}has(l){const g=this.d(l);return!(g?.value===void 0&&g?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,g){const E=this.b.reset(l),w=[];let d=this.c;for(;d;){const P=E.cmp(d.segment);if(P>0)w.push([p.Left,d]),d=d.left;else if(P<0)w.push([p.Right,d]),d=d.right;else if(E.hasNext())E.next(),w.push([p.Mid,d]),d=d.mid;else break}if(d){if(g?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const P=this.f(d.right);if(P.key){const{key:$,value:c,segment:h}=P;this.e(P.key,!1),d.key=$,d.value=c,d.segment=h}}else{const P=d.left??d.right;if(w.length>0){const[$,c]=w[w.length-1];switch($){case p.Left:c.left=P;break;case p.Mid:c.mid=P;break;case p.Right:c.right=P;break}}else this.c=P}for(let P=w.length-1;P>=0;P--){const $=w[P][1];$.updateHeight();const c=$.balanceFactor();if(c>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),w[P][1]=$.rotateLeft()):c<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),w[P][1]=$.rotateRight()),P>0)switch(w[P-1][0]){case p.Left:w[P-1][1].left=w[P][1];break;case p.Right:w[P-1][1].right=w[P][1];break;case p.Mid:w[P-1][1].mid=w[P][1];break}else this.c=w[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const g=this.b.reset(l);let E=this.c,w;for(;E;){const d=g.cmp(E.segment);if(d>0)E=E.left;else if(d<0)E=E.right;else if(g.hasNext())g.next(),w=E.value||w,E=E.mid;else break}return E&&E.value||w}findSuperstr(l){return this.g(l,!1)}g(l,g){const E=this.b.reset(l);let w=this.c;for(;w;){const d=E.cmp(w.segment);if(d>0)w=w.left;else if(d<0)w=w.right;else if(E.hasNext())E.next(),w=w.mid;else return w.mid?this.h(w.mid):g?w.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[g,E]of this)l(E,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const g=[];return this.j(l,g),g[Symbol.iterator]()}j(l,g){l&&(l.left&&this.j(l.left,g),l.value&&g.push([l.key,l.value]),l.mid&&this.j(l.mid,g),l.right&&this.j(l.right,g))}_isBalanced(){const l=g=>{if(!g)return!0;const E=g.balanceFactor();return E<-1||E>1?!1:l(g.left)&&l(g.right)};return l(this.c)}}e.$Qi=m}),define(ue[32],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=void 0,e.$6g=a;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function a(N){return I.test(N)}e.$7g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let N;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?N=crypto.getRandomValues.bind(crypto):N=function(C){for(let A=0;A<C.length;A++)C[A]=Math.floor(Math.random()*256);return C};const k=new Uint8Array(16),T=[];for(let C=0;C<256;C++)T.push(C.toString(16).padStart(2,"0"));return function(){N(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let A=0,b="";return b+=T[k[A++]],b+=T[k[A++]],b+=T[k[A++]],b+=T[k[A++]],b+="-",b+=T[k[A++]],b+=T[k[A++]],b+="-",b+=T[k[A++]],b+=T[k[A++]],b+="-",b+=T[k[A++]],b+=T[k[A++]],b+="-",b+=T[k[A++]],b+=T[k[A++]],b+=T[k[A++]],b+=T[k[A++]],b+=T[k[A++]],b+=T[k[A++]],b}}()}),define(ue[139],de([0,1,38]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=k;const a=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function N(T){const C=T.replace(/\-/g,":").toLowerCase();return!a.has(C)}function k(){const T=(0,I.networkInterfaces)();for(const C in T){const A=T[C];if(A){for(const{mac:b}of A)if(N(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ue[140],de([0,1,242,14]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hY=void 0;class N extends I.Transform{constructor(T){if(super(),typeof T=="number")this.b=T,this.c=1;else{const C=Buffer.isBuffer(T)?T:Buffer.from(T);this.b=C.length===1?C[0]:C,this.c=C.length}}_transform(T,C,A){this.a?this.a=Buffer.concat([this.a,T]):this.a=T;let b=0;for(;b<this.a.length;){const R=typeof this.b=="number"?this.a.indexOf(this.b,b):(0,a.$Te)(this.a,this.b,b);if(R===-1)break;this.push(this.a.slice(b,R+this.c)),b=R+this.c}this.a=b===this.a.length?void 0:this.a.slice(b),A()}_flush(T){this.a&&this.push(this.a),T()}}e.$hY=N}),define(ue[141],de([0,1,66]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=void 0,e.$9g=a,e.$$g=k,I=Oe(I);function a(C,A,b,R=1){let p=!1;return new Promise(m=>{const f=setTimeout(()=>{if(!p)return p=!0,m(0)},b);N(C,A,R,l=>{if(!p)return p=!0,clearTimeout(f),m(l)})})}function N(C,A,b,R){if(A===0)return R(0);const p=new I.Socket;p.once("connect",()=>(T(p),N(C+b,A-1,b,R))),p.once("data",()=>{}),p.once("error",m=>(T(p),m.code!=="ECONNREFUSED"?N(C+b,A-1,b,R):R(C))),p.connect(C,"127.0.0.1")}e.$0g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(C,A,b,R="127.0.0.1"){let p=!1,m,f=1;const l=I.createServer({pauseOnConnect:!0});function g(E,w){p||(p=!0,l.removeAllListeners(),l.close(),m&&clearTimeout(m),w(E))}return new Promise(E=>{m=setTimeout(()=>{g(0,E)},b),l.on("listening",()=>{g(C,E)}),l.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&f<A?(C++,f++,l.listen(C,R)):g(0,E)}),l.on("close",()=>{g(0,E)}),l.listen(C,R)})}function T(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(A){console.error(A)}}}),define(ue[142],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0,e.$cp=a;const I="Offline";function a(k){return k instanceof N?!0:k instanceof Error&&k.name===I&&k.message===I}class N extends Error{constructor(){super(I),this.name=this.message}}e.$dp=N}),define(ue[143],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zY=I;function I(a){return!!a.parentPort}}),define(ue[93],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a=I,e.$b=a;function I(){return globalThis._VSCODE_NLS_MESSAGES}function a(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(ue[9],de([0,1,93,93]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=e.getNLSLanguage=void 0,e.localize=T,e.localize2=A,Object.defineProperty(e,"getNLSLanguage",{enumerable:!0,get:function(){return a.$b}}),Object.defineProperty(e,"getNLSMessages",{enumerable:!0,get:function(){return a.$a}});const N=(0,I.$b)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function k(b,R){let p;return R.length===0?p=b:p=b.replace(/\{(\d+)\}/g,(m,f)=>{const l=f[0],g=R[l];let E=m;return typeof g=="string"?E=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(E=String(g)),E}),N&&(p="\uFF3B"+p.replace(/[aouei]/g,"$&$&")+"\uFF3D"),p}function T(b,R,...p){return k(typeof b=="number"?C(b,R):R,p)}function C(b,R){const p=(0,I.$a)()?.[b];if(typeof p!="string"){if(typeof R=="string")return R;throw new Error(`!!! NLS MISSING: ${b} !!!`)}return p}function A(b,R,...p){let m;typeof b=="number"?m=C(b,R):m=R;const f=k(m,p);return{value:f,original:R===m?f:k(R,p)}}}),define(ue[67],de([0,1,9]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=b,e.$8m=R,e.$9m=p,e.$0m=m;const a=60,N=a*60,k=N*24,T=k*7,C=k*30,A=k*365;function b(f,l,g,E){typeof f!="number"&&(f=f.getTime());const w=Math.round((new Date().getTime()-f)/1e3);if(w<-30)return(0,I.localize)(42,null,b(new Date().getTime()+w*1e3,!1));if(!E&&w<30)return(0,I.localize)(43,null);let d;return w<a?(d=w,l?d===1?g?(0,I.localize)(44,null,d):(0,I.localize)(45,null,d):g?(0,I.localize)(46,null,d):(0,I.localize)(47,null,d):d===1?g?(0,I.localize)(48,null,d):(0,I.localize)(49,null,d):g?(0,I.localize)(50,null,d):(0,I.localize)(51,null,d)):w<N?(d=Math.floor(w/a),l?d===1?g?(0,I.localize)(52,null,d):(0,I.localize)(53,null,d):g?(0,I.localize)(54,null,d):(0,I.localize)(55,null,d):d===1?g?(0,I.localize)(56,null,d):(0,I.localize)(57,null,d):g?(0,I.localize)(58,null,d):(0,I.localize)(59,null,d)):w<k?(d=Math.floor(w/N),l?d===1?g?(0,I.localize)(60,null,d):(0,I.localize)(61,null,d):g?(0,I.localize)(62,null,d):(0,I.localize)(63,null,d):d===1?g?(0,I.localize)(64,null,d):(0,I.localize)(65,null,d):g?(0,I.localize)(66,null,d):(0,I.localize)(67,null,d)):w<T?(d=Math.floor(w/k),l?d===1?(0,I.localize)(68,null,d):(0,I.localize)(69,null,d):d===1?(0,I.localize)(70,null,d):(0,I.localize)(71,null,d)):w<C?(d=Math.floor(w/T),l?d===1?g?(0,I.localize)(72,null,d):(0,I.localize)(73,null,d):g?(0,I.localize)(74,null,d):(0,I.localize)(75,null,d):d===1?g?(0,I.localize)(76,null,d):(0,I.localize)(77,null,d):g?(0,I.localize)(78,null,d):(0,I.localize)(79,null,d)):w<A?(d=Math.floor(w/C),l?d===1?g?(0,I.localize)(80,null,d):(0,I.localize)(81,null,d):g?(0,I.localize)(82,null,d):(0,I.localize)(83,null,d):d===1?g?(0,I.localize)(84,null,d):(0,I.localize)(85,null,d):g?(0,I.localize)(86,null,d):(0,I.localize)(87,null,d)):(d=Math.floor(w/A),l?d===1?g?(0,I.localize)(88,null,d):(0,I.localize)(89,null,d):g?(0,I.localize)(90,null,d):(0,I.localize)(91,null,d):d===1?g?(0,I.localize)(92,null,d):(0,I.localize)(93,null,d):g?(0,I.localize)(94,null,d):(0,I.localize)(95,null,d))}function R(f,l,g){typeof f!="number"&&(f=f.getTime());const E=new Date;E.setHours(0,0,0,0);const w=new Date(E.getTime());return w.setDate(w.getDate()-1),f>E.getTime()?(0,I.localize)(96,null):f>w.getTime()?(0,I.localize)(97,null):b(f,l,g)}function p(f,l){const g=Math.abs(f/1e3);return g<1?l?(0,I.localize)(98,null,f):(0,I.localize)(99,null,f):g<a?l?(0,I.localize)(100,null,Math.round(f)/1e3):(0,I.localize)(101,null,Math.round(f)/1e3):g<N?l?(0,I.localize)(102,null,Math.round(f/(1e3*a))):(0,I.localize)(103,null,Math.round(f/(1e3*a))):g<k?l?(0,I.localize)(104,null,Math.round(f/(1e3*N))):(0,I.localize)(105,null,Math.round(f/(1e3*N))):(0,I.localize)(106,null,Math.round(f/(1e3*k)))}function m(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ue[41],de([0,1,17,12,9]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=A,e.$wj=b,e.$xj=R,I=Oe(I),a=Oe(a),N=Oe(N);function k(p,m){return m&&(p.stack||p.stacktrace)?N.localize(107,null,C(p),T(p.stack)||T(p.stacktrace)):C(p)}function T(p){return Array.isArray(p)?p.join(`
`):p}function C(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?N.localize(108,null,p.message):p.message||N.localize(109,null)}function A(p=null,m=!1){if(!p)return N.localize(110,null);if(Array.isArray(p)){const f=I.$Lb(p),l=A(f[0],m);return f.length>1?N.localize(111,null,l,f.length):l}if(a.$jg(p))return p;if(p.detail){const f=p.detail;if(f.error)return k(f.error,m);if(f.exception)return k(f.exception,m)}return p.stack?k(p,m):p.message?p.message:N.localize(112,null)}function b(p){const m=p;return m instanceof Error&&Array.isArray(m.actions)}function R(p,m){let f;return typeof p=="string"?f=new Error(p):f=p,f.actions=m,f}}),define(ue[144],de([0,1,9,36]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=N;function N(k){switch(k){case a.ParseErrorCode.InvalidSymbol:return(0,I.localize)(113,null);case a.ParseErrorCode.InvalidNumberFormat:return(0,I.localize)(114,null);case a.ParseErrorCode.PropertyNameExpected:return(0,I.localize)(115,null);case a.ParseErrorCode.ValueExpected:return(0,I.localize)(116,null);case a.ParseErrorCode.ColonExpected:return(0,I.localize)(117,null);case a.ParseErrorCode.CommaExpected:return(0,I.localize)(118,null);case a.ParseErrorCode.CloseBraceExpected:return(0,I.localize)(119,null);case a.ParseErrorCode.CloseBracketExpected:return(0,I.localize)(120,null);case a.ParseErrorCode.EndOfFileExpected:return(0,I.localize)(121,null);default:return""}}}),define(ue[5],de([0,1,9]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=e.$H=e.OS=e.OperatingSystem=e.$E=e.$D=e.$C=e.$B=e.$A=e.Language=e.$z=e.$y=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.Platform=e.$j=void 0,e.$k=i,e.$G=u,e.$M=y,I=Oe(I),e.$j="en";let a=!1,N=!1,k=!1,T=!1,C=!1,A=!1,b=!1,R=!1,p=!1,m=!1,f,l=e.$j,g=e.$j,E,w;const d=globalThis;let P;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?P=d.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(P=process);const $=typeof P?.versions?.electron=="string",c=$&&P?.type==="renderer";if(typeof P=="object"){a=P.platform==="win32",N=P.platform==="darwin",k=P.platform==="linux",T=k&&!!P.env.SNAP&&!!P.env.SNAP_REVISION,b=$,p=!!P.env.CI||!!P.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$j,l=e.$j;const O=P.env.VSCODE_NLS_CONFIG;if(O)try{const S=JSON.parse(O);f=S.userLocale,g=S.osLocale,l=S.resolvedLanguage||e.$j,E=S.languagePack?.translationsConfigFile}catch{}C=!0}else typeof navigator=="object"&&!c?(w=navigator.userAgent,a=w.indexOf("Windows")>=0,N=w.indexOf("Macintosh")>=0,R=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=w.indexOf("Linux")>=0,m=w?.indexOf("Mobi")>=0,A=!0,l=I.getNLSLanguage()||e.$j,f=navigator.language.toLowerCase(),g=f):console.error("Unable to resolve platform.");var h;(function(O){O[O.Web=0]="Web",O[O.Mac=1]="Mac",O[O.Linux=2]="Linux",O[O.Windows=3]="Windows"})(h||(e.Platform=h={}));function i(O){switch(O){case h.Web:return"Web";case h.Mac:return"Mac";case h.Linux:return"Linux";case h.Windows:return"Windows"}}let n=h.Web;N?n=h.Mac:a?n=h.Windows:k&&(n=h.Linux),e.$l=a,e.$m=N,e.$n=k,e.$o=T,e.$p=C,e.$q=b,e.$r=A,e.$s=A&&typeof d.importScripts=="function",e.$t=e.$s?d.origin:void 0,e.$u=R,e.$v=m,e.$w=p,e.$x=n,e.$y=w,e.$z=l;var t;(function(O){function S(){return e.$z}O.value=S;function v(){return e.$z.length===2?e.$z==="en":e.$z.length>=3?e.$z[0]==="e"&&e.$z[1]==="n"&&e.$z[2]==="-":!1}O.isDefaultVariant=v;function L(){return e.$z==="en"}O.isDefault=L})(t||(e.Language=t={})),e.$A=f,e.$B=g,e.$C=E,e.$D=typeof d.postMessage=="function"&&!d.importScripts,e.$E=(()=>{if(e.$D){const O=[];d.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let L=0,j=O.length;L<j;L++){const U=O[L];if(U.id===v.data.vscodeScheduleAsyncWork){O.splice(L,1),U.callback();return}}});let S=0;return v=>{const L=++S;O.push({id:L,callback:v}),d.postMessage({vscodeScheduleAsyncWork:L},"*")}}return O=>setTimeout(O)})();var s;(function(O){O[O.Windows=1]="Windows",O[O.Macintosh=2]="Macintosh",O[O.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=N||R?s.Macintosh:a?s.Windows:s.Linux;let r=!0,o=!1;function u(){if(!o){o=!0;const O=new Uint8Array(2);O[0]=1,O[1]=2,r=new Uint16Array(O.buffer)[0]===513}return r}e.$H=!!(e.$y&&e.$y.indexOf("Chrome")>=0),e.$I=!!(e.$y&&e.$y.indexOf("Firefox")>=0),e.$J=!!(!e.$H&&e.$y&&e.$y.indexOf("Safari")>=0),e.$K=!!(e.$y&&e.$y.indexOf("Edg/")>=0),e.$L=!!(e.$y&&e.$y.indexOf("Android")>=0);function y(O){return parseFloat(O)>=20}}),define(ue[37],de([0,1,5]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jc=e.$ic=e.env=e.cwd=void 0;let a;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.process<"u"){const k=N.process;a={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?a={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:a={get platform(){return I.$l?"win32":I.$m?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=a.cwd,e.env=a.env,e.$ic=a.platform,e.$jc=a.arch}),define(ue[145],de([0,1,37]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XX=T;var a;(function(C){C.UNKNOWN="UNKNOWN",C.CINNAMON="CINNAMON",C.DEEPIN="DEEPIN",C.GNOME="GNOME",C.KDE3="KDE3",C.KDE4="KDE4",C.KDE5="KDE5",C.KDE6="KDE6",C.PANTHEON="PANTHEON",C.UNITY="UNITY",C.XFCE="XFCE",C.UKUI="UKUI",C.LXQT="LXQT"})(a||(a={}));const N="XDG_CURRENT_DESKTOP",k="KDE_SESSION_VERSION";function T(){const C=I.env[N];if(C){const b=C.split(":").map(R=>R.trim()).filter(R=>R.length>0);for(const R of b)switch(R){case"Unity":{const p=I.env.DESKTOP_SESSION;return p&&p.includes("gnome-fallback")?a.GNOME:a.UNITY}case"Deepin":return a.DEEPIN;case"GNOME":return a.GNOME;case"X-Cinnamon":return a.CINNAMON;case"KDE":{const p=I.env[k];return p==="5"?a.KDE5:p==="6"?a.KDE6:a.KDE4}case"Pantheon":return a.PANTHEON;case"XFCE":return a.XFCE;case"UKUI":return a.UKUI;case"LXQt":return a.LXQT}}const A=I.env.DESKTOP_SESSION;if(A)switch(A){case"deepin":return a.DEEPIN;case"gnome":case"mate":return a.GNOME;case"kde4":case"kde-plasma":return a.KDE4;case"kde":return k in I.env?a.KDE4:a.KDE3;case"xfce":case"xubuntu":return a.XFCE;case"ukui":return a.UKUI}return"GNOME_DESKTOP_SESSION_ID"in I.env?a.GNOME:"KDE_FULL_SESSION"in I.env?k in I.env?a.KDE4:a.KDE3:a.UNKNOWN}}),define(ue[13],de([0,1,37]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.sep=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=void 0,I=Oe(I);const a=65,N=97,k=90,T=122,C=46,A=47,b=92,R=58,p=63;class m extends Error{constructor(n,t,s){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const o=n.indexOf(".")!==-1?"property":"argument";let u=`The "${n}" ${o} ${r} of type ${t}`;u+=`. Received type ${typeof s}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,n){if(i===null||typeof i!="object")throw new m(n,"Object",i)}function l(i,n){if(typeof i!="string")throw new m(n,"string",i)}const g=I.$ic==="win32";function E(i){return i===A||i===b}function w(i){return i===A}function d(i){return i>=a&&i<=k||i>=N&&i<=T}function P(i,n,t,s){let r="",o=0,u=-1,y=0,O=0;for(let S=0;S<=i.length;++S){if(S<i.length)O=i.charCodeAt(S);else{if(s(O))break;O=A}if(s(O)){if(!(u===S-1||y===1))if(y===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==C||r.charCodeAt(r.length-2)!==C){if(r.length>2){const v=r.lastIndexOf(t);v===-1?(r="",o=0):(r=r.slice(0,v),o=r.length-1-r.lastIndexOf(t)),u=S,y=0;continue}else if(r.length!==0){r="",o=0,u=S,y=0;continue}}n&&(r+=r.length>0?`${t}..`:"..",o=2)}else r.length>0?r+=`${t}${i.slice(u+1,S)}`:r=i.slice(u+1,S),o=S-u-1;u=S,y=0}else O===C&&y!==-1?++y:y=-1}return r}function $(i){return i?`${i[0]==="."?"":"."}${i}`:""}function c(i,n){f(n,"pathObject");const t=n.dir||n.root,s=n.base||`${n.name||""}${$(n.ext)}`;return t?t===n.root?`${t}${s}`:`${t}${i}${s}`:s}e.$kc={resolve(...i){let n="",t="",s=!1;for(let r=i.length-1;r>=-1;r--){let o;if(r>=0){if(o=i[r],l(o,`paths[${r}]`),o.length===0)continue}else n.length===0?o=I.cwd():(o=I.env[`=${n}`]||I.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==n.toLowerCase()&&o.charCodeAt(2)===b)&&(o=`${n}\\`));const u=o.length;let y=0,O="",S=!1;const v=o.charCodeAt(0);if(u===1)E(v)&&(y=1,S=!0);else if(E(v))if(S=!0,E(o.charCodeAt(1))){let L=2,j=L;for(;L<u&&!E(o.charCodeAt(L));)L++;if(L<u&&L!==j){const U=o.slice(j,L);for(j=L;L<u&&E(o.charCodeAt(L));)L++;if(L<u&&L!==j){for(j=L;L<u&&!E(o.charCodeAt(L));)L++;(L===u||L!==j)&&(O=`\\\\${U}\\${o.slice(j,L)}`,y=L)}}}else y=1;else d(v)&&o.charCodeAt(1)===R&&(O=o.slice(0,2),y=2,u>2&&E(o.charCodeAt(2))&&(S=!0,y=3));if(O.length>0)if(n.length>0){if(O.toLowerCase()!==n.toLowerCase())continue}else n=O;if(s){if(n.length>0)break}else if(t=`${o.slice(y)}\\${t}`,s=S,S&&n.length>0)break}return t=P(t,!s,"\\",E),s?`${n}\\${t}`:`${n}${t}`||"."},normalize(i){l(i,"path");const n=i.length;if(n===0)return".";let t=0,s,r=!1;const o=i.charCodeAt(0);if(n===1)return w(o)?"\\":i;if(E(o))if(r=!0,E(i.charCodeAt(1))){let y=2,O=y;for(;y<n&&!E(i.charCodeAt(y));)y++;if(y<n&&y!==O){const S=i.slice(O,y);for(O=y;y<n&&E(i.charCodeAt(y));)y++;if(y<n&&y!==O){for(O=y;y<n&&!E(i.charCodeAt(y));)y++;if(y===n)return`\\\\${S}\\${i.slice(O)}\\`;y!==O&&(s=`\\\\${S}\\${i.slice(O,y)}`,t=y)}}}else t=1;else d(o)&&i.charCodeAt(1)===R&&(s=i.slice(0,2),t=2,n>2&&E(i.charCodeAt(2))&&(r=!0,t=3));let u=t<n?P(i.slice(t),!r,"\\",E):"";return u.length===0&&!r&&(u="."),u.length>0&&E(i.charCodeAt(n-1))&&(u+="\\"),s===void 0?r?`\\${u}`:u:r?`${s}\\${u}`:`${s}${u}`},isAbsolute(i){l(i,"path");const n=i.length;if(n===0)return!1;const t=i.charCodeAt(0);return E(t)||n>2&&d(t)&&i.charCodeAt(1)===R&&E(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let n,t;for(let o=0;o<i.length;++o){const u=i[o];l(u,"path"),u.length>0&&(n===void 0?n=t=u:n+=`\\${u}`)}if(n===void 0)return".";let s=!0,r=0;if(typeof t=="string"&&E(t.charCodeAt(0))){++r;const o=t.length;o>1&&E(t.charCodeAt(1))&&(++r,o>2&&(E(t.charCodeAt(2))?++r:s=!1))}if(s){for(;r<n.length&&E(n.charCodeAt(r));)r++;r>=2&&(n=`\\${n.slice(r)}`)}return e.$kc.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n)return"";const t=e.$kc.resolve(i),s=e.$kc.resolve(n);if(t===s||(i=t.toLowerCase(),n=s.toLowerCase(),i===n))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===b;)r++;let o=i.length;for(;o-1>r&&i.charCodeAt(o-1)===b;)o--;const u=o-r;let y=0;for(;y<n.length&&n.charCodeAt(y)===b;)y++;let O=n.length;for(;O-1>y&&n.charCodeAt(O-1)===b;)O--;const S=O-y,v=u<S?u:S;let L=-1,j=0;for(;j<v;j++){const F=i.charCodeAt(r+j);if(F!==n.charCodeAt(y+j))break;F===b&&(L=j)}if(j!==v){if(L===-1)return s}else{if(S>v){if(n.charCodeAt(y+j)===b)return s.slice(y+j+1);if(j===2)return s.slice(y+j)}u>v&&(i.charCodeAt(r+j)===b?L=j:j===2&&(L=3)),L===-1&&(L=0)}let U="";for(j=r+L+1;j<=o;++j)(j===o||i.charCodeAt(j)===b)&&(U+=U.length===0?"..":"\\..");return y+=L,U.length>0?`${U}${s.slice(y,O)}`:(s.charCodeAt(y)===b&&++y,s.slice(y,O))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const n=e.$kc.resolve(i);if(n.length<=2)return i;if(n.charCodeAt(0)===b){if(n.charCodeAt(1)===b){const t=n.charCodeAt(2);if(t!==p&&t!==C)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(d(n.charCodeAt(0))&&n.charCodeAt(1)===R&&n.charCodeAt(2)===b)return`\\\\?\\${n}`;return i},dirname(i){l(i,"path");const n=i.length;if(n===0)return".";let t=-1,s=0;const r=i.charCodeAt(0);if(n===1)return E(r)?i:".";if(E(r)){if(t=s=1,E(i.charCodeAt(1))){let y=2,O=y;for(;y<n&&!E(i.charCodeAt(y));)y++;if(y<n&&y!==O){for(O=y;y<n&&E(i.charCodeAt(y));)y++;if(y<n&&y!==O){for(O=y;y<n&&!E(i.charCodeAt(y));)y++;if(y===n)return i;y!==O&&(t=s=y+1)}}}}else d(r)&&i.charCodeAt(1)===R&&(t=n>2&&E(i.charCodeAt(2))?3:2,s=t);let o=-1,u=!0;for(let y=n-1;y>=s;--y)if(E(i.charCodeAt(y))){if(!u){o=y;break}}else u=!1;if(o===-1){if(t===-1)return".";o=t}return i.slice(0,o)},basename(i,n){n!==void 0&&l(n,"suffix"),l(i,"path");let t=0,s=-1,r=!0,o;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===R&&(t=2),n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let u=n.length-1,y=-1;for(o=i.length-1;o>=t;--o){const O=i.charCodeAt(o);if(E(O)){if(!r){t=o+1;break}}else y===-1&&(r=!1,y=o+1),u>=0&&(O===n.charCodeAt(u)?--u===-1&&(s=o):(u=-1,s=y))}return t===s?s=y:s===-1&&(s=i.length),i.slice(t,s)}for(o=i.length-1;o>=t;--o)if(E(i.charCodeAt(o))){if(!r){t=o+1;break}}else s===-1&&(r=!1,s=o+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=0,t=-1,s=0,r=-1,o=!0,u=0;i.length>=2&&i.charCodeAt(1)===R&&d(i.charCodeAt(0))&&(n=s=2);for(let y=i.length-1;y>=n;--y){const O=i.charCodeAt(y);if(E(O)){if(!o){s=y+1;break}continue}r===-1&&(o=!1,r=y+1),O===C?t===-1?t=y:u!==1&&(u=1):t!==-1&&(u=-1)}return t===-1||r===-1||u===0||u===1&&t===r-1&&t===s+1?"":i.slice(t,r)},format:c.bind(null,"\\"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.length;let s=0,r=i.charCodeAt(0);if(t===1)return E(r)?(n.root=n.dir=i,n):(n.base=n.name=i,n);if(E(r)){if(s=1,E(i.charCodeAt(1))){let L=2,j=L;for(;L<t&&!E(i.charCodeAt(L));)L++;if(L<t&&L!==j){for(j=L;L<t&&E(i.charCodeAt(L));)L++;if(L<t&&L!==j){for(j=L;L<t&&!E(i.charCodeAt(L));)L++;L===t?s=L:L!==j&&(s=L+1)}}}}else if(d(r)&&i.charCodeAt(1)===R){if(t<=2)return n.root=n.dir=i,n;if(s=2,E(i.charCodeAt(2))){if(t===3)return n.root=n.dir=i,n;s=3}}s>0&&(n.root=i.slice(0,s));let o=-1,u=s,y=-1,O=!0,S=i.length-1,v=0;for(;S>=s;--S){if(r=i.charCodeAt(S),E(r)){if(!O){u=S+1;break}continue}y===-1&&(O=!1,y=S+1),r===C?o===-1?o=S:v!==1&&(v=1):o!==-1&&(v=-1)}return y!==-1&&(o===-1||v===0||v===1&&o===y-1&&o===u+1?n.base=n.name=i.slice(u,y):(n.name=i.slice(u,o),n.base=i.slice(u,y),n.ext=i.slice(o,y))),u>0&&u!==s?n.dir=i.slice(0,u-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(g){const i=/\\/g;return()=>{const n=I.cwd().replace(i,"/");return n.slice(n.indexOf("/"))}}return()=>I.cwd()})();e.$lc={resolve(...i){let n="",t=!1;for(let s=i.length-1;s>=-1&&!t;s--){const r=s>=0?i[s]:h();l(r,`paths[${s}]`),r.length!==0&&(n=`${r}/${n}`,t=r.charCodeAt(0)===A)}return n=P(n,!t,"/",w),t?`/${n}`:n.length>0?n:"."},normalize(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===A,t=i.charCodeAt(i.length-1)===A;return i=P(i,!n,"/",w),i.length===0?n?"/":t?"./":".":(t&&(i+="/"),n?`/${i}`:i)},isAbsolute(i){return l(i,"path"),i.length>0&&i.charCodeAt(0)===A},join(...i){if(i.length===0)return".";let n;for(let t=0;t<i.length;++t){const s=i[t];l(s,"path"),s.length>0&&(n===void 0?n=s:n+=`/${s}`)}return n===void 0?".":e.$lc.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n||(i=e.$lc.resolve(i),n=e.$lc.resolve(n),i===n))return"";const t=1,s=i.length,r=s-t,o=1,u=n.length-o,y=r<u?r:u;let O=-1,S=0;for(;S<y;S++){const L=i.charCodeAt(t+S);if(L!==n.charCodeAt(o+S))break;L===A&&(O=S)}if(S===y)if(u>y){if(n.charCodeAt(o+S)===A)return n.slice(o+S+1);if(S===0)return n.slice(o+S)}else r>y&&(i.charCodeAt(t+S)===A?O=S:S===0&&(O=0));let v="";for(S=t+O+1;S<=s;++S)(S===s||i.charCodeAt(S)===A)&&(v+=v.length===0?"..":"/..");return`${v}${n.slice(o+O)}`},toNamespacedPath(i){return i},dirname(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===A;let t=-1,s=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===A){if(!s){t=r;break}}else s=!1;return t===-1?n?"/":".":n&&t===1?"//":i.slice(0,t)},basename(i,n){n!==void 0&&l(n,"ext"),l(i,"path");let t=0,s=-1,r=!0,o;if(n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let u=n.length-1,y=-1;for(o=i.length-1;o>=0;--o){const O=i.charCodeAt(o);if(O===A){if(!r){t=o+1;break}}else y===-1&&(r=!1,y=o+1),u>=0&&(O===n.charCodeAt(u)?--u===-1&&(s=o):(u=-1,s=y))}return t===s?s=y:s===-1&&(s=i.length),i.slice(t,s)}for(o=i.length-1;o>=0;--o)if(i.charCodeAt(o)===A){if(!r){t=o+1;break}}else s===-1&&(r=!1,s=o+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=-1,t=0,s=-1,r=!0,o=0;for(let u=i.length-1;u>=0;--u){const y=i.charCodeAt(u);if(y===A){if(!r){t=u+1;break}continue}s===-1&&(r=!1,s=u+1),y===C?n===-1?n=u:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||s===-1||o===0||o===1&&n===s-1&&n===t+1?"":i.slice(n,s)},format:c.bind(null,"/"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.charCodeAt(0)===A;let s;t?(n.root="/",s=1):s=0;let r=-1,o=0,u=-1,y=!0,O=i.length-1,S=0;for(;O>=s;--O){const v=i.charCodeAt(O);if(v===A){if(!y){o=O+1;break}continue}u===-1&&(y=!1,u=O+1),v===C?r===-1?r=O:S!==1&&(S=1):r!==-1&&(S=-1)}if(u!==-1){const v=o===0&&t?1:o;r===-1||S===0||S===1&&r===u-1&&r===o+1?n.base=n.name=i.slice(v,u):(n.name=i.slice(v,r),n.base=i.slice(v,u),n.ext=i.slice(r,u))}return o>0?n.dir=i.slice(0,o-1):t&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$lc.win32=e.$kc.win32=e.$kc,e.$lc.posix=e.$kc.posix=e.$lc,e.$mc=g?e.$kc.normalize:e.$lc.normalize,e.$nc=g?e.$kc.isAbsolute:e.$lc.isAbsolute,e.$oc=g?e.$kc.join:e.$lc.join,e.$pc=g?e.$kc.resolve:e.$lc.resolve,e.$qc=g?e.$kc.relative:e.$lc.relative,e.$rc=g?e.$kc.dirname:e.$lc.dirname,e.$sc=g?e.$kc.basename:e.$lc.basename,e.$tc=g?e.$kc.extname:e.$lc.extname,e.$uc=g?e.$kc.format:e.$lc.format,e.$vc=g?e.$kc.parse:e.$lc.parse,e.$wc=g?e.$kc.toNamespacedPath:e.$lc.toNamespacedPath,e.sep=g?e.$kc.sep:e.$lc.sep,e.$yc=g?e.$kc.delimiter:e.$lc.delimiter}),define(ue[42],de([0,1,39,13,5,26,12]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=C,e.$Dg=A,e.$Eg=b,e.$Fg=R,e.$Gg=p,e.$Hg=g,e.$Ig=E,e.$Jg=w,e.$Kg=d,e.$Lg=P,e.$Mg=$,e.$Ng=c,e.$Og=h,e.$Pg=i,e.$Qg=n,e.$Rg=t,e.$Sg=o;function C(u){return u===I.CharCode.Slash||u===I.CharCode.Backslash}function A(u){return u.replace(/[\\/]/g,a.$lc.sep)}function b(u){return u.indexOf("/")===-1&&(u=A(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function R(u,y=a.$lc.sep){if(!u)return"";const O=u.length,S=u.charCodeAt(0);if(C(S)){if(C(u.charCodeAt(1))&&!C(u.charCodeAt(2))){let L=3;const j=L;for(;L<O&&!C(u.charCodeAt(L));L++);if(j!==L&&!C(u.charCodeAt(L+1))){for(L+=1;L<O;L++)if(C(u.charCodeAt(L)))return u.slice(0,L+1).replace(/[\\/]/g,y)}}return y}else if(d(S)&&u.charCodeAt(1)===I.CharCode.Colon)return C(u.charCodeAt(2))?u.slice(0,2)+y:u.slice(0,2);let v=u.indexOf("://");if(v!==-1){for(v+=3;v<O;v++)if(C(u.charCodeAt(v)))return u.slice(0,v+1)}return""}function p(u){if(!N.$l||!u||u.length<5)return!1;let y=u.charCodeAt(0);if(y!==I.CharCode.Backslash||(y=u.charCodeAt(1),y!==I.CharCode.Backslash))return!1;let O=2;const S=O;for(;O<u.length&&(y=u.charCodeAt(O),y!==I.CharCode.Backslash);O++);return!(S===O||(y=u.charCodeAt(O+1),isNaN(y)||y===I.CharCode.Backslash))}const m=/[\\/:\*\?"<>\|]/g,f=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(u,y=N.$l){const O=y?m:f;return!(!u||u.length===0||/^\s+$/.test(u)||(O.lastIndex=0,O.test(u))||y&&l.test(u)||u==="."||u===".."||y&&u[u.length-1]==="."||y&&u.length!==u.trim().length||u.length>255)}function E(u,y,O){const S=u===y;return!O||S?S:!u||!y?!1:(0,k.$Kf)(u,y)}function w(u,y,O,S=a.sep){if(u===y)return!0;if(!u||!y||y.length>u.length)return!1;if(O){if(!(0,k.$Lf)(u,y))return!1;if(y.length===u.length)return!0;let L=y.length;return y.charAt(y.length-1)===S&&L--,u.charAt(L)===S}return y.charAt(y.length-1)!==S&&(y+=S),u.indexOf(y)===0}function d(u){return u>=I.CharCode.A&&u<=I.CharCode.Z||u>=I.CharCode.a&&u<=I.CharCode.z}function P(u,y){return N.$l&&u.endsWith(":")&&(u+=a.sep),(0,a.$nc)(u)||(u=(0,a.$oc)(y,u)),u=(0,a.$mc)(u),$(u)}function $(u){return N.$l?(u=(0,k.$sf)(u,a.sep),u.endsWith(":")&&(u+=a.sep)):(u=(0,k.$sf)(u,a.sep),u||(u=a.sep)),u}function c(u){const y=(0,a.$mc)(u);return N.$l?u.length>3?!1:h(y)&&(u.length===2||y.charCodeAt(2)===I.CharCode.Backslash):y===a.$lc.sep}function h(u,y=N.$l){return y?d(u.charCodeAt(0))&&u.charCodeAt(1)===I.CharCode.Colon:!1}function i(u,y=N.$l){return h(u,y)?u[0]:void 0}function n(u,y,O){return y.length>u.length?-1:u===y?0:(O&&(u=u.toLowerCase(),y=y.toLowerCase()),u.indexOf(y))}function t(u){const y=u.split(":");let O,S,v;for(const L of y){const j=Number(L);(0,T.$ng)(j)?S===void 0?S=j:v===void 0&&(v=j):O=O?[O,L].join(":"):L}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:S!==void 0?S:void 0,column:v!==void 0?v:S!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(u,y,O=8){let S="";for(let L=0;L<O;L++){let j;L===0&&N.$l&&!y&&(O===3||O===4)?j=r:j=s,S+=j.charAt(Math.floor(Math.random()*j.length))}let v;return y?v=`${y}-${S}`:v=S,u?(0,a.$oc)(u,v):v}}),define(ue[146],de([0,1,13]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=void 0,e.$ht=k,e.$it=T,e.$jt=C,e.$kt=b,e.$gt=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const a={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},N={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(R){const p=(0,I.$tc)(R),m=a[p.toLowerCase()];return m!==void 0?m:T(R)}function T(R){const p=(0,I.$tc)(R);return N[p.toLowerCase()]}function C(R){for(const p in N)if(N[p]===R)return p}const A=/^(.+)\/(.+?)(;.+)?$/;function b(R,p){const m=A.exec(R);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:p?void 0:R}}),define(ue[94],de([0,1,5]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=k,e.$rm=T;var a;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(a||(e.Source=a={}));var N;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(N||(e.TerminateResponseCode=N={}));function k(C,...A){const b=A.reduce((m,f)=>(m[f]=!0,m),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(m=>!b[m]).forEach(m=>{for(let f=0;f<R.length;f++)if(m.search(R[f])!==-1){delete C[m];break}})}function T(C){C&&(delete C.DEBUG,I.$n&&delete C.LD_PRELOAD)}}),define(ue[10],de([0,1,39,65,13,5]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$Ac=E,e.$Bc=h,N=Oe(N);const T=/^\w[\w\d+.-]*$/,C=/^\//,A=/^\/\//;function b(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!T.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!C.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function R(r,o){return!r&&!o?"file":r}function p(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==f&&(o=f+o):o=f;break}return o}const m="",f="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(o){return o instanceof g?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,u,y,O,S,v=!1){typeof o=="object"?(this.scheme=o.scheme||m,this.authority=o.authority||m,this.path=o.path||m,this.query=o.query||m,this.fragment=o.fragment||m):(this.scheme=R(o,v),this.authority=u||m,this.path=p(this.scheme,y||m),this.query=O||m,this.fragment=S||m,b(this,v))}get fsPath(){return h(this,!1)}with(o){if(!o)return this;let{scheme:u,authority:y,path:O,query:S,fragment:v}=o;return u===void 0?u=this.scheme:u===null&&(u=m),y===void 0?y=this.authority:y===null&&(y=m),O===void 0?O=this.path:O===null&&(O=m),S===void 0?S=this.query:S===null&&(S=m),v===void 0?v=this.fragment:v===null&&(v=m),u===this.scheme&&y===this.authority&&O===this.path&&S===this.query&&v===this.fragment?this:new d(u,y,O,S,v)}static parse(o,u=!1){const y=l.exec(o);return y?new d(y[2]||m,s(y[4]||m),s(y[5]||m),s(y[7]||m),s(y[9]||m),u):new d(m,m,m,m,m)}static file(o){let u=m;if(k.$l&&(o=o.replace(/\\/g,f)),o[0]===f&&o[1]===f){const y=o.indexOf(f,2);y===-1?(u=o.substring(2),o=f):(u=o.substring(2,y),o=o.substring(y)||f)}return new d("file",u,o,m,m)}static from(o,u){return new d(o.scheme,o.authority,o.path,o.query,o.fragment,u)}static joinPath(o,...u){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return k.$l&&o.scheme==="file"?y=g.file(N.$kc.join(h(o,!0),...u)).path:y=N.$lc.join(o.path,...u),o.with({path:y})}toString(o=!1){return i(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof g)return o;{const u=new d(o);return u._formatted=o.external??null,u._fsPath=o._sep===w?o.fsPath??null:null,u}}else return o}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=g;function E(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const w=k.$l?1:void 0;class d extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(o=!1){return o?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const o={$mid:a.MarshalledId.Uri};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=w),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const P={[I.CharCode.Colon]:"%3A",[I.CharCode.Slash]:"%2F",[I.CharCode.QuestionMark]:"%3F",[I.CharCode.Hash]:"%23",[I.CharCode.OpenSquareBracket]:"%5B",[I.CharCode.CloseSquareBracket]:"%5D",[I.CharCode.AtSign]:"%40",[I.CharCode.ExclamationMark]:"%21",[I.CharCode.DollarSign]:"%24",[I.CharCode.Ampersand]:"%26",[I.CharCode.SingleQuote]:"%27",[I.CharCode.OpenParen]:"%28",[I.CharCode.CloseParen]:"%29",[I.CharCode.Asterisk]:"%2A",[I.CharCode.Plus]:"%2B",[I.CharCode.Comma]:"%2C",[I.CharCode.Semicolon]:"%3B",[I.CharCode.Equals]:"%3D",[I.CharCode.Space]:"%20"};function $(r,o,u){let y,O=-1;for(let S=0;S<r.length;S++){const v=r.charCodeAt(S);if(v>=I.CharCode.a&&v<=I.CharCode.z||v>=I.CharCode.A&&v<=I.CharCode.Z||v>=I.CharCode.Digit0&&v<=I.CharCode.Digit9||v===I.CharCode.Dash||v===I.CharCode.Period||v===I.CharCode.Underline||v===I.CharCode.Tilde||o&&v===I.CharCode.Slash||u&&v===I.CharCode.OpenSquareBracket||u&&v===I.CharCode.CloseSquareBracket||u&&v===I.CharCode.Colon)O!==-1&&(y+=encodeURIComponent(r.substring(O,S)),O=-1),y!==void 0&&(y+=r.charAt(S));else{y===void 0&&(y=r.substr(0,S));const L=P[v];L!==void 0?(O!==-1&&(y+=encodeURIComponent(r.substring(O,S)),O=-1),y+=L):O===-1&&(O=S)}}return O!==-1&&(y+=encodeURIComponent(r.substring(O))),y!==void 0?y:r}function c(r){let o;for(let u=0;u<r.length;u++){const y=r.charCodeAt(u);y===I.CharCode.Hash||y===I.CharCode.QuestionMark?(o===void 0&&(o=r.substr(0,u)),o+=P[y]):o!==void 0&&(o+=r[u])}return o!==void 0?o:r}function h(r,o){let u;return r.authority&&r.path.length>1&&r.scheme==="file"?u=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===I.CharCode.Slash&&(r.path.charCodeAt(1)>=I.CharCode.A&&r.path.charCodeAt(1)<=I.CharCode.Z||r.path.charCodeAt(1)>=I.CharCode.a&&r.path.charCodeAt(1)<=I.CharCode.z)&&r.path.charCodeAt(2)===I.CharCode.Colon?o?u=r.path.substr(1):u=r.path[1].toLowerCase()+r.path.substr(2):u=r.path,k.$l&&(u=u.replace(/\//g,"\\")),u}function i(r,o){const u=o?c:$;let y="",{scheme:O,authority:S,path:v,query:L,fragment:j}=r;if(O&&(y+=O,y+=":"),(S||O==="file")&&(y+=f,y+=f),S){let U=S.indexOf("@");if(U!==-1){const F=S.substr(0,U);S=S.substr(U+1),U=F.lastIndexOf(":"),U===-1?y+=u(F,!1,!1):(y+=u(F.substr(0,U),!1,!1),y+=":",y+=u(F.substr(U+1),!1,!0)),y+="@"}S=S.toLowerCase(),U=S.lastIndexOf(":"),U===-1?y+=u(S,!1,!0):(y+=u(S.substr(0,U),!1,!0),y+=S.substr(U))}if(v){if(v.length>=3&&v.charCodeAt(0)===I.CharCode.Slash&&v.charCodeAt(2)===I.CharCode.Colon){const U=v.charCodeAt(1);U>=I.CharCode.A&&U<=I.CharCode.Z&&(v=`/${String.fromCharCode(U+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===I.CharCode.Colon){const U=v.charCodeAt(0);U>=I.CharCode.A&&U<=I.CharCode.Z&&(v=`${String.fromCharCode(U+32)}:${v.substr(2)}`)}y+=u(v,!0,!1)}return L&&(y+="?",y+=u(L,!1,!1)),j&&(y+="#",y+=o?j:$(j,!1,!1)),y}function n(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+n(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,o=>n(o)):r}}),define(ue[147],de([0,1,10]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=a,e.$mr=N,e.$nr=k,e.log=C;function a(b){const R=b;return R&&typeof R.type=="string"&&typeof R.severity=="string"}function N(b){const R=[];let p;try{const m=JSON.parse(b.arguments),f=m[m.length-1];f&&f.__$stack&&(m.pop(),p=f.__$stack),R.push(...m)}catch{R.push("Unable to log remote console arguments",b.arguments)}return{args:R,stack:p}}function k(b){if(typeof b!="string")return k(N(b).stack);const R=b;if(R){const p=T(R),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(m&&m.length===4)return{uri:I.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function T(b){if(!b)return b;const R=b.indexOf(`
`);return R===-1?b:b.substring(0,R)}function C(b,R){const{args:p,stack:m}=N(b),f=typeof p[0]=="string"&&p.length===1;let l=T(m);l&&(l=`(${l.trim()})`);let g=[];if(typeof p[0]=="string"?l&&f?g=[`%c[${R}] %c${p[0]} %c${l}`,A("blue"),A(""),A("grey")]:g=[`%c[${R}] %c${p[0]}`,A("blue"),A(""),...p.slice(1)]:g=[`%c[${R}]%`,A("blue"),...p],l&&!f&&g.push(l),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,g)}function A(b){return`color: ${b}`}}),define(ue[68],de([0,1,14,10,65]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=k,e.$gi=T,e.$hi=A;function k(b){return JSON.stringify(b,C)}function T(b){let R=JSON.parse(b);return R=A(R),R}function C(b,R){return R instanceof RegExp?{$mid:N.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function A(b,R=0){if(!b||R>200)return b;if(typeof b=="object"){switch(b.$mid){case N.MarshalledId.Uri:return a.URI.revive(b);case N.MarshalledId.Regexp:return new RegExp(b.source,b.flags);case N.MarshalledId.Date:return new Date(b.source)}if(b instanceof I.$Se||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let p=0;p<b.length;++p)b[p]=A(b[p],R+1);else for(const p in b)Object.hasOwnProperty.call(b,p)&&(b[p]=A(b[p],R+1))}return b}}),define(ue[22],de([0,1,8,5,26,10,13]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Xg=e.$Wg=e.$Vg=e.Schemas=void 0,e.$Tg=A,e.$Ug=b,e.$Yg=p,I=Oe(I),a=Oe(a),T=Oe(T);var C;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",l.vscodeNotebookMetadata="vscode-notebook-metadata",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting",l.outputChannel="output"})(C||(e.Schemas=C={}));function A(l,g){return k.URI.isUri(l)?(0,N.$Kf)(l.scheme,g):(0,N.$Lf)(l,g+":")}function b(l,...g){return g.some(E=>A(l,E))}e.$Vg="vscode-tkn",e.$Wg="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g,E){this.f=p(g,E)}getServerRootPath(){return this.f}get g(){return T.$lc.join(this.f,C.vscodeRemoteResource)}set(g,E,w){this.a[g]=E,this.b[g]=w}setConnectionToken(g,E){this.c[g]=E}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(c){return I.$4(c),g}const E=g.authority;let w=this.a[E];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const d=this.b[E],P=this.c[E];let $=`path=${encodeURIComponent(g.path)}`;return typeof P=="string"&&($+=`&${e.$Wg}=${encodeURIComponent(P)}`),k.URI.from({scheme:a.$r?this.d:C.vscodeRemoteResource,authority:`${w}:${d}`,path:this.g,query:$})}}e.$Xg=new R;function p(l,g){return T.$lc.join(g??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Zg="vs/../../extensions",e.$1g="vs/../../node_modules",e.$2g="vs/../../node_modules.asar",e.$3g="vs/../../node_modules.asar.unpacked",e.$4g="vscode-app";class m{static{this.a=e.$4g}asBrowserUri(g){const E=this.b(g,ce);return this.uriToBrowserUri(E)}uriToBrowserUri(g){return g.scheme===C.vscodeRemote?e.$Xg.rewrite(g):g.scheme===C.file&&(a.$p||a.$t===`${C.vscodeFileResource}://${m.a}`)?g.with({scheme:C.vscodeFileResource,authority:g.authority||m.a,query:null,fragment:null}):g}asFileUri(g){const E=this.b(g,ce);return this.uriToFileUri(E)}uriToFileUri(g){return g.scheme===C.vscodeFileResource?g.with({scheme:C.file,authority:g.authority!==m.a?g.authority:null,query:null,fragment:null}):g}b(g,E){if(k.URI.isUri(g))return g;if(globalThis._VSCODE_FILE_ROOT){const w=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(w))return k.URI.joinPath(k.URI.parse(w,!0),g);const d=T.$oc(w,g);return k.URI.file(d)}return k.URI.parse(E.toUrl(g))}}e.$5g=new m;var f;(function(l){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(g.get("3"));const E="vscode-coi";function w(P){let $;typeof P=="string"?$=new URL(P).searchParams:P instanceof URL?$=P.searchParams:k.URI.isUri(P)&&($=new URL(P.toString(!0)).searchParams);const c=$?.get(E);if(c)return g.get(c)}l.getHeadersFromQuery=w;function d(P,$,c){if(!globalThis.crossOriginIsolated)return;const h=$&&c?"3":c?"2":"1";P instanceof URLSearchParams?P.set(E,h):P[E]=h}l.addSearchParam=d})(f||(e.COI=f={}))}),define(ue[69],de([0,1,130,22,5,12,10]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=R,e.$Aq=p,N=Oe(N);class C{constructor(f,l,g){this.id=f,this.dependencies=l,this.callback=g}}class A{static{this.INSTANCE=new A}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(f,l,g)=>{typeof f!="string"&&(g=l,l=f,f=null),(typeof l!="object"||!Array.isArray(l))&&(g=l,l=null),this.c.push(new C(f,l,g))},globalThis.define.amd=!0,this.b?this.f=globalThis._VSCODE_WEB_PACKAGE_TTP??window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){if(f.startsWith(window.location.origin)||f.startsWith(`${a.Schemas.vscodeFileResource}://${a.$4g}`))return f;throw new Error(`[trusted_script_src] Invalid script url: ${f}`)}}):this.a&&(this.f=globalThis._VSCODE_WEB_PACKAGE_TTP??globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){return f}})))}async load(f){this.g();const l=await(this.a?this.i(f):this.b?this.h(f):this.j(f));if(!l){console.warn(`Did not receive a define call from script ${f}`);return}const g={},E=[],w=[];if(Array.isArray(l.dependencies))for(const d of l.dependencies)d==="exports"?E.push(g):w.push(d);if(w.length>0)throw new Error(`Cannot resolve dependencies for script ${f}. The dependencies are: ${w.join(", ")}`);return typeof l.callback=="function"?l.callback(...E)??g:l.callback}h(f){return new Promise((l,g)=>{const E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript");const w=()=>{E.removeEventListener("load",d),E.removeEventListener("error",P)},d=$=>{w(),l(this.c.pop())},P=$=>{w(),g($)};E.addEventListener("load",d),E.addEventListener("error",P),this.f&&(f=this.f.createScriptURL(f)),E.setAttribute("src",f),window.document.getElementsByTagName("head")[0].appendChild(E)})}async i(f){return this.f&&(f=this.f.createScriptURL(f)),I.$V?await new Promise((l,g)=>{ce([f],l,g)}).then(Oe):importScripts(f),this.c.pop()}async j(f){try{const l=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,E=globalThis._VSCODE_NODE_MODULES.module,w=T.URI.parse(f).fsPath,d=l.readFileSync(w).toString(),P=E.wrap(d.replace(/^#!.*/,""));return new g.Script(P).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const b=new Map;async function R(m,f,l){if(I.$V){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit);const g=f?`${m}/${f}`:m;if(b.has(g))return b.get(g);let E;if(/^\w[\w\d+.-]*:\/\//.test(g))E=g;else{const $=`${I.$W&&l&&!N.$r?a.$2g:a.$1g}/${g}`;E=a.$5g.asBrowserUri($).toString(!0)}const w=A.INSTANCE.load(E);return b.set(g,w),w}else return await new Promise((g,E)=>{ce([m],g,E)}).then(Oe)}function p(m,f){(0,k.$tg)(I.$V);const g=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,E=I.$W&&g&&!N.$r,w=`${m}/${f}`,P=`${E?a.$2g:a.$1g}/${w}`;return a.$5g.asBrowserUri(P).toString(!0)}}),define(ue[20],de([0,1,39,42,22,13,5,26,10]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0,e.$_g=b,e.$uh=p,e.$vh=f,a=Oe(a),k=Oe(k);function b(l){return(0,A.$Bc)(l,!0)}class R{constructor(g){this.a=g}compare(g,E,w=!1){return g===E?0:(0,C.$Df)(this.getComparisonKey(g,w),this.getComparisonKey(E,w))}isEqual(g,E,w=!1){return g===E?!0:!g||!E?!1:this.getComparisonKey(g,w)===this.getComparisonKey(E,w)}getComparisonKey(g,E=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,E,w=!1){if(g.scheme===E.scheme){if(g.scheme===N.Schemas.file)return a.$Jg(b(g),b(E),this.a(g))&&g.query===E.query&&(w||g.fragment===E.fragment);if((0,e.$qh)(g.authority,E.authority))return a.$Jg(g.path,E.path,this.a(g),"/")&&g.query===E.query&&(w||g.fragment===E.fragment)}return!1}joinPath(g,...E){return A.URI.joinPath(g,...E)}basenameOrAuthority(g){return(0,e.$ih)(g)||g.authority}basename(g){return k.$lc.basename(g.path)}extname(g){return k.$lc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let E;return g.scheme===N.Schemas.file?E=A.URI.file(k.$rc(b(g))).path:(E=k.$lc.dirname(g.path),g.authority&&E.length&&E.charCodeAt(0)!==I.CharCode.Slash&&(console.error(`dirname("${g.toString})) resulted in a relative path`),E="/")),g.with({path:E})}normalizePath(g){if(!g.path.length)return g;let E;return g.scheme===N.Schemas.file?E=A.URI.file(k.$mc(b(g))).path:E=k.$lc.normalize(g.path),g.with({path:E})}relativePath(g,E){if(g.scheme!==E.scheme||!(0,e.$qh)(g.authority,E.authority))return;if(g.scheme===N.Schemas.file){const P=k.$qc(b(g),b(E));return T.$l?a.$Dg(P):P}let w=g.path||"/";const d=E.path||"/";if(this.a(g)){let P=0;for(const $=Math.min(w.length,d.length);P<$&&!(w.charCodeAt(P)!==d.charCodeAt(P)&&w.charAt(P).toLowerCase()!==d.charAt(P).toLowerCase());P++);w=d.substr(0,P)+w.substr(P)}return k.$lc.relative(w,d)}resolvePath(g,E){if(g.scheme===N.Schemas.file){const w=A.URI.file(k.$pc(b(g),E));return g.with({authority:w.authority,path:w.path})}return E=a.$Eg(E),g.with({path:k.$lc.resolve(g.path,E)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,E){return g===E||g!==void 0&&E!==void 0&&(0,C.$Kf)(g,E)}hasTrailingPathSeparator(g,E=k.sep){if(g.scheme===N.Schemas.file){const w=b(g);return w.length>a.$Fg(w).length&&w[w.length-1]===E}else{const w=g.path;return w.length>1&&w.charCodeAt(w.length-1)===I.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,E=k.sep){return(0,e.$rh)(g,E)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,E=k.sep){let w=!1;if(g.scheme===N.Schemas.file){const d=b(g);w=d!==void 0&&d.length===a.$Fg(d).length&&d[d.length-1]===E}else{E="/";const d=g.path;w=d.length===1&&d.charCodeAt(d.length-1)===I.CharCode.Slash}return!w&&!(0,e.$rh)(g,E)?g.with({path:g.path+"/"}):g}}e.$ah=R,e.$bh=new R(()=>!1),e.$ch=new R(l=>l.scheme===N.Schemas.file?!T.$n:!0),e.$dh=new R(l=>!0),e.$eh=e.$bh.isEqual.bind(e.$bh),e.$fh=e.$bh.isEqualOrParent.bind(e.$bh),e.$gh=e.$bh.getComparisonKey.bind(e.$bh),e.$hh=e.$bh.basenameOrAuthority.bind(e.$bh),e.$ih=e.$bh.basename.bind(e.$bh),e.$jh=e.$bh.extname.bind(e.$bh),e.$kh=e.$bh.dirname.bind(e.$bh),e.$lh=e.$bh.joinPath.bind(e.$bh),e.$mh=e.$bh.normalizePath.bind(e.$bh),e.$nh=e.$bh.relativePath.bind(e.$bh),e.$oh=e.$bh.resolvePath.bind(e.$bh),e.$ph=e.$bh.isAbsolutePath.bind(e.$bh),e.$qh=e.$bh.isEqualAuthority.bind(e.$bh),e.$rh=e.$bh.hasTrailingPathSeparator.bind(e.$bh),e.$sh=e.$bh.removeTrailingPathSeparator.bind(e.$bh),e.$th=e.$bh.addTrailingPathSeparator.bind(e.$bh);function p(l,g){const E=[];for(let w=0;w<l.length;w++){const d=g(l[w]);l.some((P,$)=>$===w?!1:(0,e.$fh)(d,g(P)))||E.push(l[w])}return E}var m;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function g(E){const w=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach($=>{const[c,h]=$.split(":");c&&h&&w.set(c,h)});const P=E.path.substring(0,E.path.indexOf(";"));return P&&w.set(l.META_DATA_MIME,P),w}l.parseMetaData=g})(m||(e.DataUri=m={}));function f(l,g,E){if(g){let w=l.path;return w&&w[0]!==k.$lc.sep&&(w=k.$lc.sep+w),l.with({scheme:E,authority:g,path:w})}return l.with({scheme:E})}}),define(ue[6],de([0,1,25,8,3,2,20,5,137,53]),function(ce,e,I,a,N,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$_h=e.$$h=e.$0h=e.$9h=e.Promises=e.$8h=e.$7h=e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0,e.$wh=R,e.$xh=p,e.$yh=m,e.$zh=f,e.$Ah=l,e.$Bh=g,e.$Ch=E,e.$Dh=w,e.$Lh=r,e.$Mh=o,e.$Nh=u,e.$Oh=y,e.$Ph=O,e.$5h=W,e.$ai=Q;function R(M){return!!M&&typeof M.then=="function"}function p(M){const B=new I.$Be,ie=M(B.token),ae=new Promise((he,pe)=>{const be=B.token.onCancellationRequested(()=>{be.dispose(),pe(new a.$9)});Promise.resolve(ie).then(Ie=>{be.dispose(),B.dispose(),he(Ie)},Ie=>{be.dispose(),B.dispose(),pe(Ie)})});return new class{cancel(){B.cancel(),B.dispose()}then(he,pe){return ae.then(he,pe)}catch(he){return this.then(void 0,he)}finally(he){return ae.finally(he)}}}function m(M,B,ie){return new Promise((ae,he)=>{const pe=B.onCancellationRequested(()=>{pe.dispose(),ae(ie)});M.then(ae,he).finally(()=>pe.dispose())})}function f(M,B){return new Promise((ie,ae)=>{const he=B.onCancellationRequested(()=>{he.dispose(),ae(new a.$9)});M.then(ie,ae).finally(()=>he.dispose())})}async function l(M){let B=-1;const ie=M.map((ae,he)=>ae.then(pe=>(B=he,pe)));try{return await Promise.race(ie)}finally{M.forEach((ae,he)=>{he!==B&&ae.cancel()})}}function g(M,B,ie){let ae;const he=setTimeout(()=>{ae?.(void 0),ie?.()},B);return Promise.race([M.finally(()=>clearTimeout(he)),new Promise(pe=>ae=pe)])}function E(M){return new Promise((B,ie)=>{const ae=M();R(ae)?ae.then(B,ie):B(ae)})}function w(){let M,B;return{promise:new Promise((ae,he)=>{M=ae,B=he}),resolve:M,reject:B}}class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(B){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=B,!this.b){const ie=()=>{if(this.b=null,this.f)return;const ae=this.queue(this.d);return this.d=null,ae};this.b=new Promise(ae=>{this.a.then(ie,ie).then(ae)})}return new Promise((ie,ae)=>{this.b.then(ie,ae)})}return this.a=B(),new Promise((ie,ae)=>{this.a.then(he=>{this.a=null,ie(he)},he=>{this.a=null,ae(he)})})}dispose(){this.f=!0}}e.$Eh=d;class P{constructor(){this.a=Promise.resolve(null)}queue(B){return this.a=this.a.then(()=>B(),()=>B())}}e.$Fh=P;class ${constructor(){this.a=new Map}queue(B,ie){const he=(this.a.get(B)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(B)===he&&this.a.delete(B)});return this.a.set(B,he),he}}e.$Gh=$;const c=(M,B)=>{let ie=!0;const ae=setTimeout(()=>{ie=!1,B()},M);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(ae),ie=!1}}},h=M=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,M())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class i{constructor(B){this.defaultDelay=B,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(B,ie=this.defaultDelay){this.g=B,this.h(),this.b||(this.b=new Promise((he,pe)=>{this.d=he,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const he=this.g;return this.g=null,he()}}));const ae=()=>{this.a=null,this.d?.(null)};return this.a=ie===A.$le?h(ae):c(ie,ae),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new a.$9),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Hh=i;class n{constructor(B){this.a=new i(B),this.b=new d}trigger(B,ie){return this.a.trigger(()=>this.b.queue(B),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ih=n;class t{constructor(){this.a=!1,this.b=new Promise((B,ie)=>{this.d=B})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Jh=t;class s extends t{constructor(B){super(),this.f=setTimeout(()=>this.open(),B)}open(){clearTimeout(this.f),super.open()}}e.$Kh=s;function r(M,B){return B?new Promise((ie,ae)=>{const he=setTimeout(()=>{pe.dispose(),ie()},M),pe=B.onCancellationRequested(()=>{clearTimeout(he),pe.dispose(),ae(new a.$9)})}):p(ie=>r(M,ie))}function o(M,B=0,ie){const ae=setTimeout(()=>{M(),ie&&he.dispose()},B),he=(0,k.$Xc)(()=>{clearTimeout(ae),ie?.deleteAndLeak(he)});return ie?.add(he),he}function u(M){const B=[];let ie=0;const ae=M.length;function he(){return ie<ae?M[ie++]():null}function pe(be){be!=null&&B.push(be);const Ie=he();return Ie?Ie.then(pe):Promise.resolve(B)}return Promise.resolve(null).then(pe)}function y(M,B=ae=>!!ae,ie=null){let ae=0;const he=M.length,pe=()=>{if(ae>=he)return Promise.resolve(ie);const be=M[ae++];return Promise.resolve(be()).then(ke=>B(ke)?Promise.resolve(ke):pe())};return pe()}function O(M,B=ae=>!!ae,ie=null){if(M.length===0)return Promise.resolve(ie);let ae=M.length;const he=()=>{ae=-1;for(const pe of M)pe.cancel?.()};return new Promise((pe,be)=>{for(const Ie of M)Ie.then(ke=>{--ae>=0&&B(ke)?(he(),pe(ke)):ae===0&&pe(ie)}).catch(ke=>{--ae>=0&&(he(),be(ke))})})}class S{constructor(B){this.a=0,this.b=!1,this.f=B,this.g=[],this.d=0,this.h=new N.$qe}whenIdle(){return this.size>0?N.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(B){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,ae)=>{this.g.push({factory:B,c:ie,e:ae}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const B=this.g.shift();this.d++;const ie=B.factory();ie.then(B.c,B.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Qh=S;class v extends S{constructor(){super(1)}}e.$Rh=v;class L{constructor(){this.a=new _,this.b=0}queue(B){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,B())):this.a.run(this.b++,B())}}e.$Sh=L;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const B=new ee;return this.b.add(B),B.p}g(){for(const[,B]of this.a)if(B.size>0)return!1;return!0}queueSize(B,ie=T.$bh){const ae=ie.getComparisonKey(B);return this.a.get(ae)?.size??0}queueFor(B,ie,ae=T.$bh){const he=ae.getComparisonKey(B);let pe=this.a.get(he);if(!pe){pe=new v;const be=this.f++,Ie=N.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(he),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new k.$9c),this.d.set(be,Ie),this.a.set(he,pe)}return pe.queue(ie)}h(){this.g()&&this.j()}j(){for(const B of this.b)B.complete();this.b.clear()}dispose(){for(const[,B]of this.a)B.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Th=j;class U{constructor(B,ie){this.b=!1,this.a=-1,typeof B=="function"&&typeof ie=="number"&&this.setIfNotSet(B,ie)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(B,ie){if(this.b)throw new a.$gb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,B()},ie)}setIfNotSet(B,ie){if(this.b)throw new a.$gb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,B()},ie))}}e.$Uh=U;class F{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(B,ie,ae=globalThis){if(this.f)throw new a.$gb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const he=ae.setInterval(()=>{B()},ie);this.d=(0,k.$Xc)(()=>{ae.clearInterval(he),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Vh=F;class G{constructor(B,ie){this.b=-1,this.a=B,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(B=this.d){this.cancel(),this.b=setTimeout(this.f,B)}get delay(){return this.d}set delay(B){this.d=B}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Wh=G;class V{constructor(B,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=B,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(B=this.b){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(B/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Xh=V;class x extends G{constructor(B,ie){super(B,ie),this.j=[]}work(B){this.j.push(B),this.isScheduled()||this.schedule()}h(){const B=this.j;this.j=[],this.a?.(B)}dispose(){this.j=[],super.dispose()}}e.$Yh=x;class H extends k.$Zc{constructor(B,ie){super(),this.g=B,this.h=ie,this.a=[],this.b=this.B(new k.$1c),this.f=!1}get pending(){return this.a.length}work(B){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+B.length>this.g.maxBufferedWork)return!1}else if(this.pending+B.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of B)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Zh=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$2h=(M,B)=>{(0,C.$E)(()=>{if(ie)return;const ae=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$2h=(M,B,ie)=>{const ae=M.requestIdleCallback(B,typeof ie=="number"?{timeout:ie}:void 0);let he=!1;return{dispose(){he||(he=!0,M.cancelIdleCallback(ae))}}},e.$1h=M=>(0,e.$2h)(globalThis,M)}();class te{constructor(B,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(ae){this.l=ae}finally{this.g=!0}},this.f=(0,e.$2h)(B,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$3h=te;class z extends te{constructor(B){super(globalThis,B)}}e.$4h=z;async function W(M,B,ie){let ae;for(let he=0;he<ie;he++)try{return await M()}catch(pe){ae=pe,await r(B)}throw ae}class _{isRunning(B){return typeof B=="number"?this.a?.taskId===B:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(B,ie,ae){return this.a={taskId:B,cancel:()=>ae?.(),promise:ie},ie.then(()=>this.d(B),()=>this.d(B)),ie}d(B){this.a&&B===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const B=this.b;this.b=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}queue(B){if(this.b)this.b.run=B;else{const{promise:ie,resolve:ae,reject:he}=w();this.b={run:B,promise:ie,promiseResolve:ae,promiseReject:he}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$6h=_;class ne{constructor(B,ie=()=>Date.now()){this.d=B,this.f=ie,this.a=0,this.b=0}increment(){const B=this.f();return B-this.a>this.d&&(this.a=B,this.b=0),this.b++,this.b}}e.$7h=ne;var le;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(le||(le={}));class ee{get isRejected(){return this.d?.outcome===le.Rejected}get isResolved(){return this.d?.outcome===le.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===le.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((B,ie)=>{this.a=B,this.b=ie})}complete(B){return new Promise(ie=>{this.a(B),this.d={outcome:le.Resolved,value:B},ie()})}error(B){return new Promise(ie=>{this.b(B),this.d={outcome:le.Rejected,value:B},ie()})}cancel(){return this.error(new a.$9)}}e.$8h=ee;var X;(function(M){async function B(ae){let he;const pe=await Promise.all(ae.map(be=>be.then(Ie=>Ie,Ie=>{he||(he=Ie)})));if(typeof he<"u")throw he;return pe}M.settled=B;function ie(ae){return new Promise(async(he,pe)=>{try{await ae(he,pe)}catch(be){pe(be)}})}M.withAsyncBody=ie})(X||(e.Promises=X={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(B){this.a=void 0,this.b=void 0,this.d=!1,this.promise=B.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new a.$gb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$9h=K;class q{constructor(B){this.b=B,this.a=new b.$Y(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$0h=q;var D;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(D||(D={}));class J{static fromArray(B){return new J(ie=>{ie.emitMany(B)})}static fromPromise(B){return new J(async ie=>{ie.emitMany(await B)})}static fromPromises(B){return new J(async ie=>{await Promise.all(B.map(async ae=>ie.emitOne(await ae)))})}static merge(B){return new J(async ie=>{await Promise.all(B.map(async ae=>{for await(const he of ae)ie.emitOne(he)}))})}static{this.EMPTY=J.fromArray([])}constructor(B,ie){this.a=D.Initial,this.b=[],this.d=null,this.f=ie,this.g=new N.$qe,queueMicrotask(async()=>{const ae={emitOne:he=>this.h(he),emitMany:he=>this.j(he),reject:he=>this.l(he)};try{await Promise.resolve(B(ae)),this.k()}catch(he){this.l(he)}finally{ae.emitOne=void 0,ae.emitMany=void 0,ae.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this.a===D.DoneError)throw this.d;if(B<this.b.length)return{done:!1,value:this.b[B++]};if(this.a===D.DoneOK)return{done:!0,value:void 0};await N.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(B,ie){return new J(async ae=>{for await(const he of B)ae.emitOne(ie(he))})}map(B){return J.map(this,B)}static filter(B,ie){return new J(async ae=>{for await(const he of B)ie(he)&&ae.emitOne(he)})}filter(B){return J.filter(this,B)}static coalesce(B){return J.filter(B,ie=>!!ie)}coalesce(){return J.coalesce(this)}static async toPromise(B){const ie=[];for await(const ae of B)ie.push(ae);return ie}toPromise(){return J.toPromise(this)}h(B){this.a===D.Initial&&(this.b.push(B),this.g.fire())}j(B){this.a===D.Initial&&(this.b=this.b.concat(B),this.g.fire())}k(){this.a===D.Initial&&(this.a=D.DoneOK,this.g.fire())}l(B){this.a===D.Initial&&(this.a=D.DoneError,this.d=B,this.g.fire())}}e.$$h=J;class oe extends J{constructor(B,ie){super(ie),this.m=B}cancel(){this.m.cancel()}}e.$_h=oe;function Q(M){const B=new I.$Be,ie=M(B.token);return new oe(B,async ae=>{const he=B.token.onCancellationRequested(()=>{he.dispose(),B.dispose(),ae.reject(new a.$9)});try{for await(const pe of ie){if(B.token.isCancellationRequested)return;ae.emitOne(pe)}he.dispose(),B.dispose()}catch(pe){he.dispose(),B.dispose(),ae.reject(pe)}})}class Y{constructor(B){this.a=new ee,this.b=new J(he=>{if(ie){he.reject(ie);return}return ae&&he.emitMany(ae),this.d=pe=>he.reject(pe),this.f=pe=>he.emitOne(pe),this.a.p},B);let ie,ae;this.f=he=>{ae||(ae=[]),ae.push(he)},this.d=he=>{ie||(ie=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(B){this.d(B),this.a.complete()}emitOne(B){this.f(B)}}e.$bi=Y}),define(ue[95],de([0,1,17,6,39,42,31,13,5,26]),function(ce,e,I,a,N,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=void 0,e.$Ak=R,e.$Dk=g,e.$Ek=L,e.$Fk=j,e.$Gk=U,e.$Hk=F,e.$Ik=G,e.$Jk=te;function R(){return Object.create(null)}e.$Bk="**",e.$Ck="/";const p="[/\\\\]",m="[^/\\\\]",f=/\//g;function l(z,W){switch(z){case 0:return"";case 1:return`${m}*?`;default:return`(?:${p}|${m}+${p}${W?`|${p}${m}+`:""})*?`}}function g(z,W){if(!z)return[];const _=[];let ne=!1,le=!1,ee="";for(const X of z){switch(X){case W:if(!ne&&!le){_.push(ee),ee="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":le=!0;break;case"]":le=!1;break}ee+=X}return ee&&_.push(ee),_}function E(z){if(!z)return"";let W="";const _=g(z,e.$Ck);if(_.every(ne=>ne===e.$Bk))W=".*";else{let ne=!1;_.forEach((le,ee)=>{if(le===e.$Bk){if(ne)return;W+=l(2,ee===_.length-1)}else{let X=!1,K="",q=!1,D="";for(const J of le){if(J!=="}"&&X){K+=J;continue}if(q&&(J!=="]"||!D)){let oe;J==="-"?oe=J:(J==="^"||J==="!")&&!D?oe="^":J===e.$Ck?oe="":oe=(0,b.$mf)(J),D+=oe;continue}switch(J){case"{":X=!0;continue;case"[":q=!0;continue;case"}":{const Q=`(?:${g(K,",").map(Y=>E(Y)).join("|")})`;W+=Q,X=!1,K="";break}case"]":{W+="["+D+"]",q=!1,D="";break}case"?":W+=m;continue;case"*":W+=l(1);continue;default:W+=(0,b.$mf)(J)}}ee<_.length-1&&(_[ee+1]!==e.$Bk||ee+2<_.length)&&(W+=p)}ne=le===e.$Bk})}return W}const w=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,$=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.$Ic(1e4),n=function(){return!1},t=function(){return null};function s(z,W){if(!z)return t;let _;typeof z!="string"?_=z.pattern:_=z,_=_.trim();const ne=`${_}_${!!W.trimForExclusions}`;let le=i.get(ne);if(le)return r(le,z);let ee;return w.test(_)?le=u(_.substr(4),_):(ee=d.exec(o(_,W)))?le=y(ee[1],_):(W.trimForExclusions?$:P).test(_)?le=O(_,W):(ee=c.exec(o(_,W)))?le=S(ee[1].substr(1),_,!0):(ee=h.exec(o(_,W)))?le=S(ee[1],_,!1):le=v(_),i.set(ne,le),r(le,z)}function r(z,W){if(typeof W=="string")return z;const _=function(ne,le){return(0,k.$Jg)(ne,W.base,!A.$n)?z((0,b.$rf)(ne.substr(W.base.length),C.sep),le):null};return _.allBasenames=z.allBasenames,_.allPaths=z.allPaths,_.basenames=z.basenames,_.patterns=z.patterns,_}function o(z,W){return W.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function u(z,W){return function(_,ne){return typeof _=="string"&&_.endsWith(z)?W:null}}function y(z,W){const _=`/${z}`,ne=`\\${z}`,le=function(X,K){return typeof X!="string"?null:K?K===z?W:null:X===z||X.endsWith(_)||X.endsWith(ne)?W:null},ee=[z];return le.basenames=ee,le.patterns=[W],le.allBasenames=ee,le}function O(z,W){const _=H(z.slice(1,-1).split(",").map(K=>s(K,W)).filter(K=>K!==t),z),ne=_.length;if(!ne)return t;if(ne===1)return _[0];const le=function(K,q){for(let D=0,J=_.length;D<J;D++)if(_[D](K,q))return z;return null},ee=_.find(K=>!!K.allBasenames);ee&&(le.allBasenames=ee.allBasenames);const X=_.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return X.length&&(le.allPaths=X),le}function S(z,W,_){const ne=C.sep===C.$lc.sep,le=ne?z:z.replace(f,C.sep),ee=C.sep+le,X=C.$lc.sep+z;let K;return _?K=function(q,D){return typeof q=="string"&&(q===le||q.endsWith(ee)||!ne&&(q===z||q.endsWith(X)))?W:null}:K=function(q,D){return typeof q=="string"&&(q===le||!ne&&q===z)?W:null},K.allPaths=[(_?"*/":"./")+z],K}function v(z){try{const W=new RegExp(`^${E(z)}$`);return function(_){return W.lastIndex=0,typeof _=="string"&&W.test(_)?z:null}}catch{return t}}function L(z,W,_){return!z||typeof W!="string"?!1:j(z)(W,void 0,_)}function j(z,W={}){if(!z)return n;if(typeof z=="string"||U(z)){const _=s(z,W);if(_===t)return n;const ne=function(le,ee){return!!_(le,ee)};return _.allBasenames&&(ne.allBasenames=_.allBasenames),_.allPaths&&(ne.allPaths=_.allPaths),ne}return V(z,W)}function U(z){const W=z;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}function F(z){return z.allBasenames||[]}function G(z){return z.allPaths||[]}function V(z,W){const _=H(Object.getOwnPropertyNames(z).map(K=>x(K,z[K],W)).filter(K=>K!==t)),ne=_.length;if(!ne)return t;if(!_.some(K=>!!K.requiresSiblings)){if(ne===1)return _[0];const K=function(J,oe){let Q;for(let Y=0,M=_.length;Y<M;Y++){const B=_[Y](J,oe);if(typeof B=="string")return B;(0,a.$wh)(B)&&(Q||(Q=[]),Q.push(B))}return Q?(async()=>{for(const Y of Q){const M=await Y;if(typeof M=="string")return M}return null})():null},q=_.find(J=>!!J.allBasenames);q&&(K.allBasenames=q.allBasenames);const D=_.reduce((J,oe)=>oe.allPaths?J.concat(oe.allPaths):J,[]);return D.length&&(K.allPaths=D),K}const le=function(K,q,D){let J,oe;for(let Q=0,Y=_.length;Q<Y;Q++){const M=_[Q];M.requiresSiblings&&D&&(q||(q=(0,C.$sc)(K)),J||(J=q.substr(0,q.length-(0,C.$tc)(K).length)));const B=M(K,q,J,D);if(typeof B=="string")return B;(0,a.$wh)(B)&&(oe||(oe=[]),oe.push(B))}return oe?(async()=>{for(const Q of oe){const Y=await Q;if(typeof Y=="string")return Y}return null})():null},ee=_.find(K=>!!K.allBasenames);ee&&(le.allBasenames=ee.allBasenames);const X=_.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return X.length&&(le.allPaths=X),le}function x(z,W,_){if(W===!1)return t;const ne=s(z,_);if(ne===t)return t;if(typeof W=="boolean")return ne;if(W){const le=W.when;if(typeof le=="string"){const ee=(X,K,q,D)=>{if(!D||!ne(X,K))return null;const J=le.replace("$(basename)",()=>q),oe=D(J);return(0,a.$wh)(oe)?oe.then(Q=>Q?z:null):oe?z:null};return ee.requiresSiblings=!0,ee}}return ne}function H(z,W){const _=z.filter(K=>!!K.basenames);if(_.length<2)return z;const ne=_.reduce((K,q)=>{const D=q.basenames;return D?K.concat(D):K},[]);let le;if(W){le=[];for(let K=0,q=ne.length;K<q;K++)le.push(W)}else le=_.reduce((K,q)=>{const D=q.patterns;return D?K.concat(D):K},[]);const ee=function(K,q){if(typeof K!="string")return null;if(!q){let J;for(J=K.length;J>0;J--){const oe=K.charCodeAt(J-1);if(oe===N.CharCode.Slash||oe===N.CharCode.Backslash)break}q=K.substr(J)}const D=ne.indexOf(q);return D!==-1?le[D]:null};ee.basenames=ne,ee.patterns=le,ee.allBasenames=ne;const X=z.filter(K=>!K.basenames);return X.push(ee),X}function te(z,W){return(0,I.$yb)(z,W,(_,ne)=>typeof _=="string"&&typeof ne=="string"?_===ne:typeof _!="string"&&typeof ne!="string"?_.base===ne.base&&_.pattern===ne.pattern:!1)}}),define(ue[96],de([0,1,14,65,10]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=void 0,e.$Un=A,e.$Vn=R,e.$Wn=p;function k(m){return m.toJSON()}class T{constructor(f){this.a=f}transformIncoming(f){const l=this.a.transformIncoming(f);return l===f?f:k(N.URI.from(l))}transformOutgoing(f){const l=this.a.transformOutgoing(f);return l===f?f:k(N.URI.from(l))}transformOutgoingURI(f){const l=this.a.transformOutgoing(f);return l===f?f:N.URI.from(l)}transformOutgoingScheme(f){return this.a.transformOutgoingScheme(f)}}e.$Sn=T,e.$Tn=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function C(m,f,l){if(!m||l>200)return null;if(typeof m=="object"){if(m instanceof N.URI)return f.transformOutgoing(m);for(const g in m)if(Object.hasOwnProperty.call(m,g)){const E=C(m[g],f,l+1);E!==null&&(m[g]=E)}}return null}function A(m,f){const l=C(m,f,0);return l===null?m:l}function b(m,f,l,g){if(!m||g>200)return null;if(typeof m=="object"){if(m.$mid===a.MarshalledId.Uri)return l?N.URI.revive(f.transformIncoming(m)):f.transformIncoming(m);if(m instanceof I.$Se)return null;for(const E in m)if(Object.hasOwnProperty.call(m,E)){const w=b(m[E],f,l,g+1);w!==null&&(m[E]=w)}}return null}function R(m,f){const l=b(m,f,!1,0);return l===null?m:l}function p(m,f){const l=b(m,f,!0,0);return l===null?m:l}}),define(ue[148],de([0,1,38,51,32,139,5]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0,e.$Zn=A,e.$1n=p,e.$2n=m,N=Oe(N),e.$Yn=new class{c(f){return this.a||(this.a=a.$Qi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(f)}value(){if(this.b===void 0){let f=0,l=0;const g=(0,I.networkInterfaces)();for(const E in g){const w=g[E];if(w)for(const{mac:d,internal:P}of w)P||(l+=1,this.c(d.toUpperCase())&&(f+=1))}this.b=l>0?f/l:0}return this.b}};let C;async function A(f){return C||(C=(async()=>await b(f)||N.$7g())()),C}async function b(f){try{const l=await new Promise((E,w)=>{ce(["crypto"],E,w)}).then(Oe),g=(0,k.$Xn)();return l.createHash("sha256").update(g,"utf8").digest("hex")}catch(l){f(l);return}}const R="Software\\Microsoft\\SQMClient";async function p(f){if(T.$l){const l=await new Promise((g,E)=>{ce(["@vscode/windows-registry"],g,E)}).then(Oe);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",R,"MachineId")||""}catch(g){return f(g),""}}return""}async function m(f){try{return await(await new Promise((E,w)=>{ce(["@vscode/deviceid"],E,w)}).then(Oe)).getDeviceId()}catch(l){return f(l),""}}}),define(ue[149],de([0,1,33,13,37]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iY=b,e.$jY=R;const k="XDG_SESSION_TYPE",T="WAYLAND_DISPLAY",C="XDG_RUNTIME_DIR";var A;(function(p){p.Wayland="wayland",p.XWayland="xwayland",p.X11="x11",p.Unknown="unknown"})(A||(A={}));async function b(p){const m=N.env[k];if(m)return m===A.Wayland||m===A.X11?m:A.Unknown;if(N.env[T]){const l=N.env[C];if(l){const g=(0,a.$oc)(l,"wayland-0");try{return await I.promises.access(g,I.constants.R_OK),A.Wayland}catch(E){return p(E),A.Unknown}}else return A.Unknown}else return A.X11}function R(p,m){if(m)switch(m){case"auto":return p;case"x11":return p===A.Wayland?A.XWayland:A.X11;case"wayland":return A.Wayland;default:return A.Unknown}else return p===A.Wayland?A.XWayland:A.X11}}),define(ue[150],de([0,1,33,243,5]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=k,N=Oe(N);async function k(T){if(N.$m||N.$l)return;let C;for(const A of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{C=await I.promises.open(A,I.constants.R_OK);break}catch{}if(!C){T("Unable to retrieve release information from known identifier paths.");return}try{const A=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),b={id:"unknown"};for await(const R of(0,a.createInterface)({input:C.createReadStream(),crlfDelay:1/0})){if(!R.includes("="))continue;const p=R.split("=")[0].toUpperCase().trim();if(A.has(p)){const m=R.split("=")[1].replace(/"/g,"").toLowerCase().trim();p==="ID"||p==="DISTRIB_ID"?b.id=m:p==="ID_LIKE"?b.id_like=m:(p==="VERSION_ID"||p==="DISTRIB_RELEASE")&&(b.version_id=m)}}return b}catch(A){T(A)}}}),define(ue[30],de([0,1,33,38,244,6,42,91,13,5,20,10]),function(ce,e,I,a,N,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=E,e.readdirSync=P,e.whenDeleted=h,e.configureFlushOnWrite=r,e.writeFileSync=u,I=Oe(I);var m;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function f(V,x=m.UNLINK,H){if((0,T.$Ng)(V))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?g(V):l(V,H)}async function l(V,x=(0,T.$Sg)((0,a.tmpdir)())){try{try{await I.promises.rename(V,x)}catch(H){return H.code==="ENOENT"?void 0:g(V)}g(x).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function g(V){return I.promises.rm(V,{recursive:!0,force:!0,maxRetries:3})}function E(V){if((0,T.$Ng)(V))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function w(V,x){return $(await(x?d(V):I.promises.readdir(V)))}async function d(V){try{return await I.promises.readdir(V,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const x=[],H=await w(V);for(const te of H){let z=!1,W=!1,_=!1;try{const ne=await I.promises.lstat((0,A.$oc)(V,te));z=ne.isFile(),W=ne.isDirectory(),_=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:te,isFile:()=>z,isDirectory:()=>W,isSymbolicLink:()=>_})}return x}function P(V){return $(I.readdirSync(V))}function $(V){return V.map(x=>typeof x=="string"?b.$m?(0,C.$sm)(x):x:(x.name=b.$m?(0,C.$sm)(x.name):x.name,x))}async function c(V){const x=await w(V),H=[];for(const te of x)await i.existsDirectory((0,A.$oc)(V,te))&&H.push(te);return H}function h(V,x=1e3){return new Promise(H=>{let te=!1;const z=setInterval(()=>{te||(te=!0,I.access(V,W=>{te=!1,W&&(clearInterval(z),H(void 0))}))},x)})}var i;(function(V){async function x(z){let W;try{if(W=await I.promises.lstat(z),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await I.promises.stat(z),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(b.$l&&_.code==="EACCES")try{return{stat:await I.promises.stat(await I.promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw ne}throw _}}V.stat=x;async function H(z){try{const{stat:W,symbolicLink:_}=await V.stat(z);return W.isFile()&&_?.dangling!==!0}catch{}return!1}V.existsFile=H;async function te(z){try{const{stat:W,symbolicLink:_}=await V.stat(z);return W.isDirectory()&&_?.dangling!==!0}catch{}return!1}V.existsDirectory=te})(i||(e.SymlinkSupport=i={}));const n=new k.$Th;function t(V,x,H){return n.queueFor(p.URI.file(V),()=>{const te=y(H);return new Promise((z,W)=>o(V,x,te,_=>_?W(_):z()))},R.$ch)}let s=!0;function r(V){s=V}function o(V,x,H,te){if(!s)return I.writeFile(V,x,{mode:H.mode,flag:H.flag},te);I.open(V,H.flag,H.mode,(z,W)=>{if(z)return te(z);I.writeFile(W,x,_=>{if(_)return I.close(W,()=>te(_));I.fdatasync(W,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),I.close(W,le=>te(le))))})})}function u(V,x,H){const te=y(H);if(!s)return I.writeFileSync(V,x,{mode:te.mode,flag:te.flag});const z=I.openSync(V,te.flag,te.mode);try{I.writeFileSync(z,x);try{I.fdatasyncSync(z)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),r(!1)}}finally{I.closeSync(z)}}function y(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function O(V,x,H=6e4){if(V!==x)try{b.$l&&typeof H=="number"?await S(V,x,Date.now(),H):await I.promises.rename(V,x)}catch(te){if(V.toLowerCase()!==x.toLowerCase()&&te.code==="EXDEV"||V.endsWith("."))await v(V,x,{preserveSymlinks:!1}),await f(V,m.MOVE);else throw te}}async function S(V,x,H,te,z=0){try{return await I.promises.rename(V,x)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-H>=te)throw console.error(`[node.js fs] rename failed after ${z} retries with error: ${W}`),W;if(z===0){let _=!1;try{const{stat:ne}=await i.stat(x);ne.isFile()||(_=!0)}catch{}if(_)throw W}return await(0,k.$Lh)(Math.min(100,z*10)),S(V,x,H,te,z+1)}}async function v(V,x,H){return j(V,x,{root:{source:V,target:x},options:H,handledSourcePaths:new Set})}const L=511;async function j(V,x,H){if(H.handledSourcePaths.has(V))return;H.handledSourcePaths.add(V);const{stat:te,symbolicLink:z}=await i.stat(V);if(z){if(H.options.preserveSymlinks)try{return await G(V,x,H)}catch{}if(z.dangling)return}return te.isDirectory()?U(V,x,te.mode&L,H):F(V,x,te.mode&L)}async function U(V,x,H,te){await I.promises.mkdir(x,{recursive:!0,mode:H});const z=await w(V);for(const W of z)await j((0,A.$oc)(V,W),(0,A.$oc)(x,W),te)}async function F(V,x,H){await I.promises.copyFile(V,x),await I.promises.chmod(x,H)}async function G(V,x,H){let te=await I.promises.readlink(V);(0,T.$Jg)(te,H.root.source,!b.$n)&&(te=(0,A.$oc)(H.root.target,te.substr(H.root.source.length+1))),await I.promises.symlink(te,x)}e.Promises=new class{get read(){return(V,x,H,te,z)=>new Promise((W,_)=>{I.read(V,x,H,te,z,(ne,le,ee)=>ne?_(ne):W({bytesRead:le,buffer:ee}))})}get write(){return(V,x,H,te,z)=>new Promise((W,_)=>{I.write(V,x,H,te,z,(ne,le,ee)=>ne?_(ne):W({bytesWritten:le,buffer:ee}))})}get fdatasync(){return(0,N.promisify)(I.fdatasync)}get open(){return(0,N.promisify)(I.open)}get close(){return(0,N.promisify)(I.close)}get realpath(){return(0,N.promisify)(I.realpath)}async exists(V){try{return await I.promises.access(V),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return c}get writeFile(){return t}get rm(){return f}get rename(){return O}get copy(){return v}}}),define(ue[151],de([0,1,33,13,5,26,30]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=C,e.$ur=A,e.$vr=b,e.$wr=R,I=Oe(I);function C(m){if(N.$n)return m;const f=(0,a.$rc)(m);if(m===f)return m;const l=((0,a.$sc)(m)||m).toLowerCase();try{const E=(0,T.readdirSync)(f).filter(w=>w.toLowerCase()===l);if(E.length===1){const w=C(f);if(w)return(0,a.$oc)(w,E[0])}else if(E.length>1){const w=E.indexOf(l);if(w>=0){const d=C(f);if(d)return(0,a.$oc)(d,E[w])}}}catch{}return null}async function A(m,f){if(N.$n)return m;const l=(0,a.$rc)(m);if(m===l)return m;const g=((0,a.$sc)(m)||m).toLowerCase();try{if(f?.isCancellationRequested)return null;const w=(await T.Promises.readdir(l)).filter(d=>d.toLowerCase()===g);if(w.length===1){const d=await A(l,f);if(d)return(0,a.$oc)(d,w[0])}else if(w.length>1){const d=w.indexOf(g);if(d>=0){const P=await A(l,f);if(P)return(0,a.$oc)(P,w[d])}}}catch{}return null}async function b(m){try{return await T.Promises.realpath(m)}catch{const l=p(m);return await I.promises.access(l,I.constants.R_OK),l}}function R(m){try{return I.realpathSync(m)}catch{const l=p(m);return I.accessSync(l,I.constants.R_OK),l}}function p(m){return(0,k.$sf)((0,a.$mc)(m),a.sep)}}),define(ue[152],de([0,1,33,13,5,37,94,12,30]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Dm=b,e.$Em=R,a=Oe(a),N=Oe(N),k=Oe(k),C=Oe(C),A=Oe(A),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function b(m=k.env){return m.comspec||"cmd.exe"}function R(m){let f=[],l=!1;const g=function(E){if(l){f.push(E);return}(!m.send(E,d=>{if(d&&console.error(d),l=!1,f.length>0){const P=f.slice(0);f=[],P.forEach($=>g($))}})||N.$l)&&(l=!0)};return{send:g}}var p;(function(m){async function f(l,g,E){if(a.$nc(l))return l;if(g===void 0&&(g=k.cwd()),a.$rc(l)!=="."||(E===void 0&&C.$jg(k.env.PATH)&&(E=k.env.PATH.split(a.$yc)),E===void 0||E.length===0))return a.$oc(g,l);async function d(P){if(await A.Promises.exists(P)){let $;try{$=await I.promises.stat(P)}catch(c){c.message.startsWith("EACCES")&&($=await I.promises.lstat(P))}return $?!$.isDirectory():!1}return!1}for(const P of E){let $;if(a.$nc(P)?$=a.$oc(P,l):$=a.$oc(g,P,l),await d($))return $;let c=$+".com";if(await d(c)||(c=$+".exe",await d(c)))return c}return a.$oc(g,l)}m.findExecutable=f})(p||(e.win32=p={}))}),define(ue[153],de([0,1,70,22]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=N;function N(T){return new Promise((C,A)=>{let b;const R=new Map;function p(f,l,g,E,w){const d=R.get(l);if(f===T||d){const P={name:m(g),cmd:g,pid:f,ppid:l,load:E,mem:w};R.set(f,P),f===T&&(b=P),d&&(d.children||(d.children=[]),d.children.push(P),d.children.length>1&&(d.children=d.children.sort(($,c)=>$.pid-c.pid)))}}function m(f){const l=/--utility-sub-type=network/i,g=/--crashes-directory/i,E=/\\pipe\\winpty-control/i,w=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(g.exec(f))return"electron-crash-reporter";if(E.exec(f))return"winpty-agent";if(w.exec(f))return"conpty-agent";let P=d.exec(f);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?l.exec(f)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const $=/[a-zA-Z-]+\.js/g;let c="";do P=$.exec(f),P&&(c+=P+" ");while(P);return c&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${c})`:f}if(process.platform==="win32"){const f=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,g)=>{ce(["@vscode/windows-process-tree"],l,g)}).then(Oe).then(l=>{l.getProcessList(T,g=>{if(!g){A(new Error(`Root process ${T} not found`));return}l.getProcessCpuUsage(g,E=>{const w=new Map;E.forEach(d=>{const P=f(d.commandLine||"");w.set(d.pid,{name:m(P),cmd:P,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),b=w.get(T),b?(w.forEach(d=>{const P=w.get(d.ppid);P&&(P.children||(P.children=[]),P.children.push(d))}),w.forEach(d=>{d.children&&(d.children=d.children.sort((P,$)=>P.pid-$.pid))}),C(b)):A(new Error(`Root process ${T} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let f=function(){let l=[b];const g=[];for(;l.length;){const w=l.shift();w&&(g.push(w.pid),w.children&&(l=l.concat(w.children)))}let E=JSON.stringify(a.$5g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);E+=" "+g.join(" "),(0,I.exec)(E,{},(w,d,P)=>{if(w||P)A(w||new Error(P.toString()));else{const $=d.toString().split(`
`);for(let c=0;c<g.length;c++){const h=R.get(g[c]);h.load=parseFloat($[c])}if(!b){A(new Error(`Root process ${T} not found`));return}C(b)}})};(0,I.exec)("which ps",{},(l,g,E)=>{if(l||E)if(process.platform!=="linux")A(l||new Error(E.toString()));else{const w=JSON.stringify(a.$5g.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(w,{},(d,P,$)=>{d||$?A(d||new Error($.toString())):(k(P,p),f())})}else{const w=g.toString().trim();(0,I.exec)(`${w} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(P,$,c)=>{P||c&&!c.includes("screen size is bogus")?A(P||new Error(c.toString())):(k($,p),process.platform==="linux"?f():b?C(b):A(new Error(`Root process ${T} not found`)))})}})}})}function k(T,C){const A=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=T.toString().split(`
`);for(const R of b){const p=A.exec(R.trim());p&&p.length===6&&C(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(ue[71],de([0,1,33,6,13,12,30,9]),function(ce,e,I,a,N,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=void 0,e.zip=E,e.$Lq=w,e.$Mq=P,N=Oe(N),C=Oe(C),e.$Iq="end of central directory record signature not found";const A=new RegExp(e.$Iq);class b extends Error{constructor(c,h){let i=h.message;switch(c){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=c,this.cause=h}}e.$Jq=b;function R($){const c=$.externalFileAttributes>>16||33188;return[448,56,7].map(h=>c&h).reduce((h,i)=>h+i,c&61440)}function p($){if($ instanceof b)return $;let c;return A.test($.message)&&(c="CorruptZip"),new b(c,$)}function m($,c,h,i,n,t){const s=N.$rc(c),r=N.$oc(i,s);if(!r.startsWith(i))return Promise.reject(new Error(C.localize(142,null,c)));const o=N.$oc(i,c);let u;return t.onCancellationRequested(()=>{u?.destroy()}),Promise.resolve(I.promises.mkdir(r,{recursive:!0})).then(()=>new Promise((y,O)=>{if(!t.isCancellationRequested)try{u=(0,I.createWriteStream)(o,{mode:h}),u.once("close",()=>y()),u.once("error",O),$.once("error",O),$.pipe(u)}catch(S){O(S)}}))}function f($,c,h,i){let n=(0,a.$xh)(()=>Promise.resolve()),t=0;const s=i.onCancellationRequested(()=>{n.cancel(),$.close()});return new Promise((r,o)=>{const u=new a.$Fh,y=O=>{O.isCancellationRequested||(t++,$.readEntry())};$.once("error",o),$.once("close",()=>n.then(()=>{i.isCancellationRequested||$.entryCount===t?r():o(new b("Incomplete",new Error(C.localize(143,null,t,$.entryCount))))},o)),$.readEntry(),$.on("entry",O=>{if(i.isCancellationRequested)return;if(!h.sourcePathRegex.test(O.fileName)){y(i);return}const S=O.fileName.replace(h.sourcePathRegex,"");if(/\/$/.test(S)){const j=N.$oc(c,S);n=(0,a.$xh)(U=>I.promises.mkdir(j,{recursive:!0}).then(()=>y(U)).then(void 0,o));return}const v=g($,O),L=R(O);n=(0,a.$xh)(j=>u.queue(()=>v.then(U=>m(U,S,L,c,h,j).then(()=>y(j)))).then(null,o))})}).finally(()=>s.dispose())}async function l($,c=!1){const{open:h}=await new Promise((i,n)=>{ce(["yauzl"],i,n)}).then(Oe);return new Promise((i,n)=>{h($,c?{lazyEntries:!0}:void 0,(t,s)=>{t?n(p(t)):i((0,k.$ug)(s))})})}function g($,c){return new Promise((h,i)=>{$.openReadStream(c,(n,t)=>{n?i(p(n)):h((0,k.$ug)(t))})})}async function E($,c){const{ZipFile:h}=await new Promise((i,n)=>{ce(["yazl"],i,n)}).then(Oe);return new Promise((i,n)=>{const t=new h;c.forEach(r=>{r.contents?t.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&t.addFile(r.localPath,r.path)}),t.end();const s=(0,I.createWriteStream)($);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>i($))})}function w($,c,h={},i){const n=new RegExp(h.sourcePath?`^${h.sourcePath}`:"");let t=l($,!0);return h.overwrite&&(t=t.then(s=>T.Promises.rm(c).then(()=>s))),t.then(s=>f(s,c,{sourcePathRegex:n},i))}function d($,c){return l($).then(h=>new Promise((i,n)=>{h.on("entry",t=>{t.fileName===c&&g(h,t).then(s=>i(s),s=>n(s))}),h.once("close",()=>n(new Error(C.localize(144,null,c))))}))}function P($,c){return d($,c).then(h=>new Promise((i,n)=>{const t=[];h.once("error",n),h.on("data",s=>t.push(s)),h.on("end",()=>i(Buffer.concat(t)))}))}});var Ee=this&&this.__decorate||function(ce,e,I,a){var N=arguments.length,k=N<3?e:a===null?a=Object.getOwnPropertyDescriptor(e,I):a,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(ce,e,I,a);else for(var C=ce.length-1;C>=0;C--)(T=ce[C])&&(k=(N<3?T(k):N>3?T(e,I,k):T(e,I))||k);return N>3&&k&&Object.defineProperty(e,I,k),k};define(ue[43],de([0,1,17,6,14,25,88,8,3,2,68,26,12]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.ProxyChannel=e.$si=e.$pi=e.$oi=e.$ni=e.RequestInitiator=e.$mi=e.$ji=e.$ii=void 0,e.$ki=r,e.$li=o,e.$qi=L,e.$ri=j,p=Oe(p);var f;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(f||(f={}));function l(z){switch(z){case f.Promise:return"req";case f.PromiseCancel:return"cancel";case f.EventListen:return"subscribe";case f.EventDispose:return"unsubscribe"}}var g;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(g||(g={}));function E(z){switch(z){case g.Initialize:return"init";case g.PromiseSuccess:return"reply:";case g.PromiseError:case g.PromiseErrorObj:return"replyErr:";case g.EventFire:return"event:"}}var w;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(w||(w={}));function d(z){let W=0;for(let _=0;;_+=7){const ne=z.read(1);if(W|=(ne.buffer[0]&127)<<_,!(ne.buffer[0]&128))return W}}const P=n(0);function $(z,W){if(W===0){z.write(P);return}let _=0;for(let le=W;le!==0;le=le>>>7)_++;const ne=N.$Se.alloc(_);for(let le=0;W!==0;le++)ne.buffer[le]=W&127,W=W>>>7,W>0&&(ne.buffer[le]|=128);z.write(ne)}class c{constructor(W){this.b=W,this.a=0}read(W){const _=this.b.slice(this.a,this.a+W);return this.a+=_.byteLength,_}}e.$ii=c;class h{constructor(){this.a=[]}get buffer(){return N.$Se.concat(this.a)}write(W){this.a.push(W)}}e.$ji=h;var i;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(i||(i={}));function n(z){const W=N.$Se.alloc(1);return W.writeUInt8(z,0),W}const t={Undefined:n(i.Undefined),String:n(i.String),Buffer:n(i.Buffer),VSBuffer:n(i.VSBuffer),Array:n(i.Array),Object:n(i.Object),Uint:n(i.Int)},s=typeof Buffer<"u";function r(z,W){if(typeof W>"u")z.write(t.Undefined);else if(typeof W=="string"){const _=N.$Se.fromString(W);z.write(t.String),$(z,_.byteLength),z.write(_)}else if(s&&Buffer.isBuffer(W)){const _=N.$Se.wrap(W);z.write(t.Buffer),$(z,_.byteLength),z.write(_)}else if(W instanceof N.$Se)z.write(t.VSBuffer),$(z,W.byteLength),z.write(W);else if(Array.isArray(W)){z.write(t.Array),$(z,W.length);for(const _ of W)r(z,_)}else if(typeof W=="number"&&(W|0)===W)z.write(t.Uint),$(z,W);else{const _=N.$Se.fromString(JSON.stringify(W));z.write(t.Object),$(z,_.byteLength),z.write(_)}}function o(z){switch(z.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return z.read(d(z)).toString();case i.Buffer:return z.read(d(z)).buffer;case i.VSBuffer:return z.read(d(z));case i.Array:{const _=d(z),ne=[];for(let le=0;le<_;le++)ne.push(o(z));return ne}case i.Object:return JSON.parse(z.read(d(z)).toString());case i.Int:return d(z)}}class u{constructor(W,_,ne=null,le=1e3){this.h=W,this.j=_,this.k=ne,this.l=le,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ee=>this.q(ee)),this.m({type:g.Initialize})}registerChannel(W,_){this.b.set(W,_),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case g.Initialize:{const _=this.o([W.type]);this.k?.logOutgoing(_,0,y.OtherSide,E(W.type));return}case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:{const _=this.o([W.type,W.id],W.data);this.k?.logOutgoing(_,W.id,y.OtherSide,E(W.type),W.data);return}}}o(W,_=void 0){const ne=new h;return r(ne,W),r(ne,_),this.p(ne.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const _=new c(W),ne=o(_),le=o(_),ee=ne[0];switch(ee){case f.Promise:return this.k?.logIncoming(W.byteLength,ne[1],y.OtherSide,`${l(ee)}: ${ne[2]}.${ne[3]}`,le),this.s({type:ee,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case f.EventListen:return this.k?.logIncoming(W.byteLength,ne[1],y.OtherSide,`${l(ee)}: ${ne[2]}.${ne[3]}`,le),this.t({type:ee,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case f.PromiseCancel:return this.k?.logIncoming(W.byteLength,ne[1],y.OtherSide,`${l(ee)}`),this.u({type:ee,id:ne[1]});case f.EventDispose:return this.k?.logIncoming(W.byteLength,ne[1],y.OtherSide,`${l(ee)}`),this.u({type:ee,id:ne[1]})}}s(W){const _=this.b.get(W.channelName);if(!_){this.v(W);return}const ne=new k.$Be;let le;try{le=_.call(this.j,W.name,W.arg,ne.token)}catch(K){le=Promise.reject(K)}const ee=W.id;le.then(K=>{this.m({id:ee,data:K,type:g.PromiseSuccess})},K=>{K instanceof Error?this.m({id:ee,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split(`
`):void 0},type:g.PromiseError}):this.m({id:ee,data:K,type:g.PromiseErrorObj})}).finally(()=>{X.dispose(),this.d.delete(W.id)});const X=(0,b.$Xc)(()=>ne.cancel());this.d.set(W.id,X)}t(W){const _=this.b.get(W.channelName);if(!_){this.v(W);return}const ne=W.id,ee=_.listen(this.j,W.name,W.arg)(X=>this.m({id:ne,data:X,type:g.EventFire}));this.d.set(W.id,ee)}u(W){const _=this.d.get(W.id);_&&(_.dispose(),this.d.delete(W.id))}v(W){let _=this.g.get(W.channelName);_||(_=[],this.g.set(W.channelName,_));const ne=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===f.Promise&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:g.PromiseError})},this.l);_.push({request:W,timeoutTimer:ne})}w(W){const _=this.g.get(W);if(_){for(const ne of _)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case f.Promise:this.s(ne.request);break;case f.EventListen:this.t(ne.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Uc)(this.d.values()),this.d.clear()}}e.$mi=u;var y;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class O{constructor(W,_=null){this.l=W,this.a=!1,this.b=w.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new A.$qe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=_}getChannel(W){const _=this;return{call(ne,le,ee){return _.a?Promise.reject(new C.$9):_.m(W,ne,le,ee)},listen(ne,le){return _.a?A.Event.None:_.o(W,ne,le)}}}m(W,_,ne,le=k.CancellationToken.None){const ee=this.g++,X=f.Promise,K={id:ee,type:X,channelName:W,name:_,arg:ne};if(le.isCancellationRequested)return Promise.reject(new C.$9);let q;return new Promise((J,oe)=>{if(le.isCancellationRequested)return oe(new C.$9);const Q=()=>{const ie=ae=>{switch(ae.type){case g.PromiseSuccess:this.f.delete(ee),J(ae.data);break;case g.PromiseError:{this.f.delete(ee);const he=new Error(ae.data.message);he.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,he.name=ae.data.name,oe(he);break}case g.PromiseErrorObj:this.f.delete(ee),oe(ae.data);break}};this.f.set(ee,ie),this.p(K)};let Y=null;this.b===w.Idle?Q():(Y=(0,a.$xh)(ie=>this.u()),Y.then(()=>{Y=null,Q()}));const M=()=>{Y?(Y.cancel(),Y=null):this.p({id:ee,type:f.PromiseCancel}),oe(new C.$9)},B=le.onCancellationRequested(M);q=(0,b.$Wc)((0,b.$Xc)(M),B),this.d.add(q)}).finally(()=>{q.dispose(),this.d.delete(q)})}o(W,_,ne){const le=this.g++,ee=f.EventListen,X={id:le,type:ee,channelName:W,name:_,arg:ne};let K=null;const q=new A.$qe({onWillAddFirstListener:()=>{K=(0,a.$xh)(J=>this.u()),K.then(()=>{K=null,this.d.add(q),this.p(X)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(q),this.p({id:le,type:f.EventDispose}))}}),D=J=>q.fire(J.data);return this.f.set(le,D),q.event}p(W){switch(W.type){case f.Promise:case f.EventListen:{const _=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(_,W.id,y.LocalSide,`${l(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case f.PromiseCancel:case f.EventDispose:{const _=this.q([W.type,W.id]);this.j?.logOutgoing(_,W.id,y.LocalSide,l(W.type));return}}}q(W,_=void 0){const ne=new h;return r(ne,W),r(ne,_),this.r(ne.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const _=new c(W),ne=o(_),le=o(_),ee=ne[0];switch(ee){case g.Initialize:return this.j?.logIncoming(W.byteLength,0,y.LocalSide,E(ee)),this.t({type:ne[0]});case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:return this.j?.logIncoming(W.byteLength,ne[1],y.LocalSide,E(ee),le),this.t({type:ne[0],id:ne[1],data:le})}}t(W){if(W.type===g.Initialize){this.b=w.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return A.Event.toPromise(this.onDidInitialize)}u(){return this.b===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Uc)(this.d.values()),this.d.clear()}}e.$ni=O,Ee([T.$ci],O.prototype,"onDidInitializePromise",null);class S{get connections(){const W=[];return this.f.forEach(_=>W.push(_)),W}constructor(W,_,ne){this.a=new Map,this.f=new Set,this.g=new A.$qe,this.onDidAddConnection=this.g.event,this.h=new A.$qe,this.onDidRemoveConnection=this.h.event,this.j=new b.$Yc,this.j.add(W(({protocol:le,onDidClientDisconnect:ee})=>{const X=A.Event.once(le.onMessage);this.j.add(X(K=>{const q=new c(K),D=o(q),J=new u(le,D,_,ne),oe=new O(le,_);this.a.forEach((Y,M)=>J.registerChannel(M,Y));const Q={channelServer:J,channelClient:oe,ctx:D};this.f.add(Q),this.g.fire(Q),this.j.add(ee(()=>{J.dispose(),oe.dispose(),this.f.delete(Q),this.h.fire(Q)}))}))}))}getChannel(W,_){const ne=this;return{call(le,ee,X){let K;if((0,m.$xg)(_)){const D=(0,I.$7b)(ne.connections.filter(_));K=D?Promise.resolve(D):A.Event.toPromise(A.Event.filter(ne.onDidAddConnection,_))}else K=_.routeCall(ne,le,ee);const q=K.then(D=>D.channelClient.getChannel(W));return L(q).call(le,ee,X)},listen(le,ee){if((0,m.$xg)(_))return ne.k(W,_,le,ee);const X=_.routeEvent(ne,le,ee).then(K=>K.channelClient.getChannel(W));return L(X).listen(le,ee)}}}k(W,_,ne,le){const ee=this;let X;const K=new A.$qe({onWillAddFirstListener:()=>{X=new b.$Yc;const q=new A.$we,D=new Map,J=Q=>{const M=Q.channelClient.getChannel(W).listen(ne,le),B=q.add(M);D.set(Q,B)},oe=Q=>{const Y=D.get(Q);Y&&(Y.dispose(),D.delete(Q))};ee.connections.filter(_).forEach(J),A.Event.filter(ee.onDidAddConnection,_)(J,void 0,X),ee.onDidRemoveConnection(oe,void 0,X),q.event(K.fire,K,X),X.add(q)},onDidRemoveLastListener:()=>{X?.dispose(),X=void 0}});return K.event}registerChannel(W,_){this.a.set(W,_);for(const ne of this.f)ne.channelServer.registerChannel(W,_)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$oi=S;class v{constructor(W,_,ne=null){const le=new h;r(le,_),W.send(le.buffer),this.a=new O(W,ne),this.d=new u(W,_,ne)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,_){this.d.registerChannel(W,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.$pi=v;function L(z){return{call(W,_,ne){return z.then(le=>le.call(W,_,ne))},listen(W,_){const ne=new A.$ze;return z.then(le=>ne.input=le.listen(W,_)),ne.event}}}function j(z){let W=!1;return{call(_,ne,le){return W?z.call(_,ne,le):(0,a.$Lh)(0).then(()=>W=!0).then(()=>z.call(_,ne,le))},listen(_,ne){if(W)return z.listen(_,ne);const le=new A.$ze;return(0,a.$Lh)(0).then(()=>W=!0).then(()=>le.input=z.listen(_,ne)),le.event}}}class U{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const _ of W.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await A.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$si=U;var F;(function(z){function W(ee,X,K){const q=ee,D=K&&K.disableMarshalling,J=new Map;for(const oe in q)ne(oe)&&J.set(oe,A.Event.buffer(q[oe],!0,void 0,X));return new class{listen(oe,Q,Y){const M=J.get(Q);if(M)return M;const B=q[Q];if(typeof B=="function"){if(le(Q))return B.call(q,Y);if(ne(Q))return J.set(Q,A.Event.buffer(q[Q],!0,void 0,X)),J.get(Q)}throw new C.$fb(`Event not found: ${Q}`)}call(oe,Q,Y){const M=q[Q];if(typeof M=="function"){if(!D&&Array.isArray(Y))for(let ie=0;ie<Y.length;ie++)Y[ie]=(0,R.$hi)(Y[ie]);let B=M.apply(q,Y);return B instanceof Promise||(B=Promise.resolve(B)),B}throw new C.$fb(`Method not found: ${Q}`)}}}z.fromService=W;function _(ee,X){const K=X&&X.disableMarshalling;return new Proxy({},{get(q,D){if(typeof D=="string")return X?.properties?.has(D)?X.properties.get(D):le(D)?function(J){return ee.listen(D,J)}:ne(D)?ee.listen(D):async function(...J){let oe;X&&!(0,m.$sg)(X.context)?oe=[X.context,...J]:oe=J;const Q=await ee.call(D,oe);return K?Q:(0,R.$hi)(Q)};throw new C.$fb(`Property not found: ${String(D)}`)}})}z.toService=_;function ne(ee){return ee[0]==="o"&&ee[1]==="n"&&p.$Jf(ee.charCodeAt(2))}function le(ee){return/^onDynamic/.test(ee)&&p.$Jf(ee.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const W=z.toString();if(W!=="[object Object]")return W}return z}function x(z){return Array.isArray(z)?z.map(V):V(z)}function H(z,W,_,ne,le,ee,X){X=x(X);const K=G[le],q=K[ne%K.length];let D=[`%c[${z}]%c[${String(W).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(ee)?(D=D.concat(X),D.push(")")):D.push(X),console.log.apply(console,D)}class te{constructor(W,_){this.d=W,this.f=_,this.a=0,this.b=0}logOutgoing(W,_,ne,le,ee){this.b+=W,H(this.d,this.b,W,_,ne,le,ee)}logIncoming(W,_,ne,le,ee){this.a+=W,H(this.f,this.a,W,_,ne,le,ee)}}e.$ti=te}),define(ue[72],de([0,1,14,3,2,43]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.ProtocolConstants=e.$ui=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var C;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let r=0;function o(y,O){if(!s.has(y)){const S=String(++r);s.set(y,S)}return s.get(y)}function u(y,O,S,v){if(!t.enableDiagnostics)return;const L=o(y,O);if(v instanceof I.$Se||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const j=I.$Se.alloc(v.byteLength);j.set(v),t.records.push({timestamp:Date.now(),id:L,label:O,type:S,buff:j})}else t.records.push({timestamp:Date.now(),id:L,label:O,type:S,data:v})}t.traceSocketEvent=u})(C||(e.SocketDiagnostics=C={}));var A;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(A||(e.SocketCloseEventType=A={}));let b=null;function R(){return b||(b=I.$Se.alloc(0)),b}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,r){if(s===0)return R();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const O=this.a[0];return r&&(this.a.shift(),this.b-=s),O}if(this.a[0].byteLength>s){const O=this.a[0].slice(0,s);return r&&(this.a[0]=this.a[0].slice(s),this.b-=s),O}const o=I.$Se.alloc(s);let u=0,y=0;for(;s>0;){const O=this.a[y];if(O.byteLength>s){const S=O.slice(0,s);o.set(S,u),u+=s,r&&(this.a[y]=O.slice(s),this.b-=s),s-=s}else o.set(O,u),u+=O.byteLength,r?(this.a.shift(),this.b-=O.byteLength):y++,s-=O.byteLength}return o}}e.$ui=p;var m;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(m||(m={}));function f(t){switch(t){case m.None:return"None";case m.Regular:return"Regular";case m.Control:return"Control";case m.Ack:return"Ack";case m.Disconnect:return"Disconnect";case m.ReplayRequest:return"ReplayRequest";case m.Pause:return"PauseWriting";case m.Resume:return"ResumeWriting";case m.KeepAlive:return"KeepAlive"}}var l;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class g{constructor(s,r,o,u){this.type=s,this.id=r,this.ack=o,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends N.$Zc{constructor(s){super(),this.f=this.B(new a.$qe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:l.HeaderLength,messageType:m.None,id:0,ack:0},this.a=s,this.b=!1,this.c=new p,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,u=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=l.HeaderLength,this.g.messageType=m.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,r),this.f.fire(new g(o,u,y,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class w{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$Se.alloc(l.HeaderLength);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:f(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,s.data),this.j(r,s.data)}g(s,r){const o=this.f===0;return this.d.push(s,r),this.f+=s.byteLength+r.byteLength,o}h(){const s=I.$Se.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,r){this.g(s,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:s.byteLength}),this.c.write(s)}}class d extends N.$Zc{constructor(s){super(),this.f=new a.$qe,this.onMessage=this.f.event,this.g=new a.$qe,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new w(this.a)),this.c=this.B(new E(this.a)),this.B(this.c.onMessage(r=>{r.type===m.Regular&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new g(m.Regular,0,0,s))}}e.$vi=d;class P extends k.$pi{static fromSocket(s,r){return new P(new d(s),r)}get onDidDispose(){return this.b.onDidDispose}constructor(s,r,o=null){super(s,r,o),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$wi=P;class ${constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new a.$qe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$xi=$;class c{constructor(s){this.data=s,this.next=null}}class h{constructor(){this.a=null,this.b=null}length(){let s=0,r=this.a;for(;r;)r=r.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let r=0,o=this.a;for(;o;)s[r++]=o.data,o=o.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const r=new c(s);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const s=Date.now();for(let r=0;r<i.a;r++)this.c[r]=s-1e3*r;setInterval(()=>{for(let r=i.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),r=(1+i.a)*1e3;let o=0;for(let u=0;u<i.a;u++)s-this.c[u]<=r&&o++;return 1-o/i.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.d-this.f}constructor(s){this.v=new $,this.onControlMessage=this.v.event,this.w=new $,this.onMessage=this.w.event,this.x=new $,this.onDidDispose=this.x.event,this.y=new $,this.onSocketClose=this.y.event,this.z=new $,this.onSocketTimeout=this.z.event,this.t=s.loadEstimator??i.getInstance(),this.u=s.sendKeepAlive??!0,this.a=!1,this.c=new h,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new N.$Yc,this.p=s.socket,this.q=this.s.add(new w(this.p)),this.r=this.s.add(new E(this.p)),this.s.add(this.r.onMessage(r=>this.A(r))),this.s.add(this.p.onClose(r=>this.y.fire(r))),s.initialChunk&&this.r.acceptChunk(s.initialChunk),this.u?this.m=setInterval(()=>{this.E()},l.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const s=new g(m.Disconnect,0,0,R());this.q.write(s),this.q.flush()}}sendPause(){const s=new g(m.Pause,0,0,R());this.q.write(s)}sendResume(){const s=new g(m.Resume,0,0,R());this.q.write(s)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(s,r){this.a=!0,this.s.dispose(),this.s=new N.$Yc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=s,this.q=this.s.add(new w(this.p)),this.r=this.s.add(new E(this.p)),this.s.add(this.r.onMessage(o=>this.A(o))),this.s.add(this.p.onClose(o=>this.y.fire(o))),this.r.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.j=this.h;const s=new g(m.Ack,0,this.j,R());this.q.write(s);const r=this.c.toArray();for(let o=0,u=r.length;o<u;o++)this.q.write(r[o]);this.C()}acceptDisconnect(){this.x.fire()}A(s){if(s.ack>this.f){this.f=s.ack;do{const r=this.c.peek();if(r&&r.id<=s.ack)this.c.pop();else break}while(!0)}switch(s.type){case m.None:break;case m.Regular:{if(s.id>this.h)if(s.id!==this.h+1){const r=Date.now();r-this.n>1e4&&(this.n=r,this.q.write(new g(m.ReplayRequest,0,0,R())))}else this.h=s.id,this.k=Date.now(),this.B(),this.w.fire(s.data);break}case m.Control:{this.v.fire(s.data);break}case m.Ack:break;case m.Disconnect:{this.x.fire();break}case m.ReplayRequest:{const r=this.c.toArray();for(let o=0,u=r.length;o<u;o++)this.q.write(r[o]);this.C();break}case m.Pause:{this.q.pause();break}case m.Resume:{this.q.resume();break}case m.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(s){const r=++this.d;this.j=this.h;const o=new g(m.Regular,r,this.j,s);this.c.push(o),this.a||(this.q.write(o),this.C())}sendControl(s){const r=new g(m.Control,0,0,s);this.q.write(r)}B(){if(this.h<=this.j||this.l)return;const s=Date.now()-this.k;if(s>=l.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},l.AcknowledgeTime-s+5)}C(){if(this.d<=this.f||this.g||this.a)return;const s=this.c.peek(),r=Date.now()-s.writtenTime,o=Date.now()-this.r.lastReadTime,u=Date.now()-this.o;if(r>=l.TimeoutTime&&o>=l.TimeoutTime&&u>=l.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const y=Math.max(l.TimeoutTime-r,l.TimeoutTime-o,l.TimeoutTime-u,500);this.g=setTimeout(()=>{this.g=null,this.C()},y)}D(){if(this.h<=this.j)return;this.j=this.h;const s=new g(m.Ack,0,this.j,R());this.q.write(s)}E(){this.j=this.h;const s=new g(m.KeepAlive,0,this.j,R());this.q.write(s)}}e.$yi=n}),define(ue[97],de([0,1,70,6,14,25,147,8,3,2,29,152,94,43]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0,C=Oe(C);class l extends f.$mi{constructor(w){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:A.Event.fromNodeEventEmitter(process,"message",d=>N.$Se.wrap(Buffer.from(d,"base64")))},w),process.once("disconnect",()=>this.dispose())}}e.$pr=l;class g{constructor(w,d){this.i=w,this.j=d,this.c=new Set,this.g=new Map,this.h=new A.$qe,this.onDidProcessExit=this.h.event;const P=d&&d.timeout?d.timeout:6e4;this.b=new a.$Hh(P),this.d=null,this.f=null}getChannel(w){const d=this;return{call(P,$,c){return d.k(w,P,$,c)},listen(P,$){return d.l(w,P,$)}}}k(w,d,P,$=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(C.$0());this.b.cancel();const c=this.n(w),h=(0,a.$xh)(t=>c.call(d,P,t)),i=$.onCancellationRequested(()=>h.cancel()),n=(0,b.$Xc)(()=>h.cancel());return this.c.add(n),h.finally(()=>{i.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),h}l(w,d,P){if(!this.b)return A.Event.None;this.b.cancel();let $;const c=new A.$qe({onWillAddFirstListener:()=>{$=this.n(w).listen(d,P)(c.fire,c),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const w=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,R.$ko)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.$rm)(d.env),this.d=(0,I.fork)(this.i,w,d);const P=new A.$qe,c=A.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,T.$lr)(r)){(0,T.log)(r,`IPC Library: ${this.j.serverName}`);return}P.fire(N.$Se.wrap(Buffer.from(r,"base64")))}),h=this.j.useQueue?(0,p.$Em)(this.d):this.d,i=r=>this.d&&this.d.connected&&h.send(r.buffer.toString("base64")),n=P.event,t={send:i,onMessage:n};this.f=new f.$ni(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",s),c.dispose(),this.c.forEach(u=>(0,b.$Uc)(u)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(w){let d=this.g.get(w);return d||(d=this.m.getChannel(w),this.g.set(w,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$qr=g}),define(ue[154],de([0,1,143,14,43,3,12,17]),function(ce,e,I,a,N,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AY=void 0,e.$BY=R;class A{constructor(m){this.a=m,this.onMessage=k.Event.fromNodeEventEmitter(this.a,"message",f=>f.data?a.$Se.wrap(f.data):a.$Se.alloc(0)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class b extends N.$oi{static b(m){(0,T.$tg)((0,I.$zY)(process),"Electron Utility Process");const f=new k.$qe;return process.parentPort.on("message",l=>{if(m?.handledClientConnection(l))return;const g=(0,C.$Sb)(l.ports);g&&f.fire(g)}),k.Event.map(f.event,l=>({protocol:new A(l),onDidClientDisconnect:k.Event.fromNodeEventEmitter(l,"close")}))}constructor(m){super(b.b(m))}}e.$AY=b;function R(p,m,f){const l=g=>{g.data===m&&(p.removeListener("message",l),f())};p.on("message",l)}}),define(ue[73],de([0,1,6,3,2,68,12]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.StorageState=e.StorageHint=void 0,e.$jq=A;var C;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(e.StorageHint=C={}));function A(m){const f=m;return f?.changed instanceof Map||f?.deleted instanceof Set}var b;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(b||(e.StorageState=b={}));class R extends N.$Zc{static{this.a=100}constructor(f,l=Object.create(null)){super(),this.r=f,this.s=l,this.b=this.B(new a.$te),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=this.B(new I.$Ih(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((l,g)=>this.w(g,l)),f.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w(f,l){if(this.c===b.Closed)return;let g=!1;(0,T.$sg)(l)?g=this.f.delete(f):this.f.get(f)!==l&&(this.f.set(f,l),g=!0),g&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.s.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,l){const g=this.f.get(f);return(0,T.$sg)(g)?l:g}getBoolean(f,l){const g=this.get(f);return(0,T.$sg)(g)?l:g==="true"}getNumber(f,l){const g=this.get(f);return(0,T.$sg)(g)?l:parseInt(g,10)}getObject(f,l){const g=this.get(f);return(0,T.$sg)(g)?l:(0,k.$gi)(g)}async set(f,l,g=!1){if(this.c===b.Closed)return;if((0,T.$sg)(l))return this.delete(f,g);const E=(0,T.$lg)(l)||Array.isArray(l)?(0,k.$fi)(l):String(l);if(this.f.get(f)!==E)return this.f.set(f,E),this.j.set(f,E),this.h.delete(f),this.b.fire({key:f,external:g}),this.D()}async delete(f,l=!1){if(!(this.c===b.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:l}),this.D()}async optimize(){if(this.c!==b.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=b.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(!(this.c===b.Closed||this.m))return this.D(f)}async D(f){return this.s.hint===C.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===C.STORAGE_IN_MEMORY}}e.$kq=R;class p{constructor(){this.onDidChangeItemsExternal=a.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((l,g)=>this.a.set(g,l)),f.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$lq=p}),define(ue[155],de([0,1,39,8,9]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.TokenType=void 0;var k;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(k||(e.TokenType=k={}));function T(...R){switch(R.length){case 1:return(0,N.localize)(1693,null,R[0]);case 2:return(0,N.localize)(1694,null,R[0],R[1]);case 3:return(0,N.localize)(1695,null,R[0],R[1],R[2]);default:return}}const C=(0,N.localize)(1696,null),A=(0,N.localize)(1697,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return p.isTripleEq?"===":"==";case k.NotEq:return p.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return p.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return p.lexeme;case k.QuotedStr:return p.lexeme;case k.Error:return p.lexeme;case k.EOF:return"EOF";default:throw(0,a.$_)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case I.CharCode.OpenParen:this.k(k.LParen);break;case I.CharCode.CloseParen:this.k(k.RParen);break;case I.CharCode.ExclamationMark:if(this.h(I.CharCode.Equals)){const m=this.h(I.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:m})}else this.k(k.Neg);break;case I.CharCode.SingleQuote:this.o();break;case I.CharCode.Slash:this.q();break;case I.CharCode.Equals:if(this.h(I.CharCode.Equals)){const m=this.h(I.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:m})}else this.h(I.CharCode.Tilde)?this.k(k.RegexOp):this.l(T("==","=~"));break;case I.CharCode.LessThan:this.k(this.h(I.CharCode.Equals)?k.LtEq:k.Lt);break;case I.CharCode.GreaterThan:this.k(this.h(I.CharCode.Equals)?k.GtEq:k.Gt);break;case I.CharCode.Ampersand:this.h(I.CharCode.Ampersand)?this.k(k.And):this.l(T("&&"));break;case I.CharCode.Pipe:this.h(I.CharCode.Pipe)?this.k(k.Or):this.l(T("||"));break;case I.CharCode.Space:case I.CharCode.CarriageReturn:case I.CharCode.Tab:case I.CharCode.LineFeed:case I.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?I.CharCode.Null:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const m=this.d,f=this.c.substring(this.d,this.e),l={type:k.Error,offset:this.d,lexeme:f};this.g.push({offset:m,lexeme:f,additionalInfo:p}),this.f.push(l)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const m=this.c.substring(this.d,this.e),f=b.b.get(m);f?this.k(f):this.f.push({type:k.Str,lexeme:m,offset:this.d})}}o(){for(;this.j()!==I.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,m=!1,f=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(A);return}const g=this.c.charCodeAt(p);if(m)m=!1;else if(g===I.CharCode.Slash&&!f){p++;break}else g===I.CharCode.OpenSquareBracket?f=!0:g===I.CharCode.Backslash?m=!0:g===I.CharCode.CloseSquareBracket&&(f=!1);p++}for(;p<this.c.length&&b.a.has(this.c.charCodeAt(p));)p++;this.e=p;const l=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fj=b}),define(ue[156],de([0,1,67,88,22,13,37,20,10]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=void 0,e.$an=R,e.$bn=p,e.$$m=/^([^.]+\..+)[:=](.+)$/;class b{get appRoot(){return(0,k.$rc)(N.$5g.asFileUri("").fsPath)}get userHome(){return A.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return A.URI.file((0,k.$oc)(this.userDataPath,"User"))}get tmpDir(){return A.URI.file(this.b.tmpDir)}get cacheHome(){return A.URI.file(this.userDataPath)}get stateResource(){return(0,C.$lh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:N.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,C.$lh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,I.$0m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$oc)(this.userDataPath,"logs",f)}return A.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.$lh)(A.URI.file((0,k.$oc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.$lh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.$lh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.$lh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=T.env.VSCODE_PORTABLE;return f?A.URI.file((0,k.$oc)(f,"argv.json")):(0,C.$lh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return A.URI.file((0,k.$oc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,k.$pc)(f):(0,k.$mc)((0,k.$oc)(N.$5g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?A.URI.file((0,k.$pc)(f)):A.URI.file((0,k.$oc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,k.$pc)(f);const l=T.env.VSCODE_EXTENSIONS;if(l)return l;const g=T.env.VSCODE_PORTABLE;return g?(0,k.$oc)(g,"extensions"):(0,C.$lh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(l=>/^[^:/?#]+?:\/\//.test(l)?A.URI.parse(l):A.URI.file((0,k.$mc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?A.URI.parse(f):A.URI.file((0,k.$mc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$$m.test(f))}get extensionLogLevel(){const f=[];for(const l of this.args.log||[]){const g=e.$$m.exec(l);g&&g[1]&&g[2]&&f.push([g[1],g[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,C.$lh)(A.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=T.env.VSCODE_PORTABLE;return f?A.URI.file((0,k.$oc)(f,"policy.json")):(0,C.$lh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,l,g){this.a=f,this.b=l,this.c=g,this.editSessionId=this.args.editSessionId}}e.$_m=b,Ee([a.$ci],b.prototype,"appRoot",null),Ee([a.$ci],b.prototype,"userHome",null),Ee([a.$ci],b.prototype,"userDataPath",null),Ee([a.$ci],b.prototype,"appSettingsHome",null),Ee([a.$ci],b.prototype,"tmpDir",null),Ee([a.$ci],b.prototype,"cacheHome",null),Ee([a.$ci],b.prototype,"stateResource",null),Ee([a.$ci],b.prototype,"userRoamingDataHome",null),Ee([a.$ci],b.prototype,"userDataSyncHome",null),Ee([a.$ci],b.prototype,"sync",null),Ee([a.$ci],b.prototype,"machineSettingsResource",null),Ee([a.$ci],b.prototype,"workspaceStorageHome",null),Ee([a.$ci],b.prototype,"localHistoryHome",null),Ee([a.$ci],b.prototype,"keyboardLayoutResource",null),Ee([a.$ci],b.prototype,"argvResource",null),Ee([a.$ci],b.prototype,"isExtensionDevelopment",null),Ee([a.$ci],b.prototype,"untitledWorkspacesHome",null),Ee([a.$ci],b.prototype,"builtinExtensionsPath",null),Ee([a.$ci],b.prototype,"extensionsPath",null),Ee([a.$ci],b.prototype,"extensionDevelopmentLocationURI",null),Ee([a.$ci],b.prototype,"extensionDevelopmentKind",null),Ee([a.$ci],b.prototype,"extensionTestsLocationURI",null),Ee([a.$ci],b.prototype,"debugExtensionHost",null),Ee([a.$ci],b.prototype,"logLevel",null),Ee([a.$ci],b.prototype,"extensionLogLevel",null),Ee([a.$ci],b.prototype,"serviceMachineIdResource",null),Ee([a.$ci],b.prototype,"disableTelemetry",null),Ee([a.$ci],b.prototype,"disableWorkspaceTrust",null),Ee([a.$ci],b.prototype,"useInMemorySecretStorage",null),Ee([a.$ci],b.prototype,"policyFile",null);function R(m,f){return p(m["inspect-extensions"],m["inspect-brk-extensions"],5870,f,m.debugId,m.extensionEnvironment)}function p(m,f,l,g,E,w){const P=Number(f||m)||(g?null:l),$=P?!!f:!1;let c;if(w)try{c=JSON.parse(w)}catch{}return{port:P,break:$,debugId:E,env:c}}}),function(){function ce(e,I,a){function N(T,C){const A=k(T,C),b=[A];return e.isAbsolute(A)||b.unshift(a),e.resolve(...b)}function k(T,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const A=process.env.VSCODE_PORTABLE;if(A)return e.join(A,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,C);const R=T["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(p,"AppData","Roaming")}break;case"darwin":b=e.join(I.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,C)}return{getUserDataPath:N}}if(typeof define=="function")define(ue[157],de([245,38,37]),function(e,I,a){return ce(e,I,a.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=ce(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ue[158],de([0,1,38,156,157]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0,e.$dn=T,e.$en=C;class k extends a.$_m{constructor(b,R){super(b,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,N.getUserDataPath)(b,R.nameShort)},R)}}e.$cn=k;function T(A,b){return(0,a.$bn)(A["inspect-ptyhost"],A["inspect-brk-ptyhost"],5877,b,A.extensionEnvironment)}function C(A,b){return(0,a.$bn)(A["inspect-sharedprocess"],A["inspect-brk-sharedprocess"],5879,b,A.extensionEnvironment)}}),define(ue[159],de([0,1,12,9]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=N;function N(T,C,A,b){try{k(T,C,A,b)}catch(R){T.error(R?.message??R)}return C}function k(T,C,A,b){const R=(p,m,f)=>{const l=p[m];if((0,I.$jg)(l)){const g=l,E=g.length;if(E>1&&g[0]==="%"&&g[E-1]==="%"){const w=g.substr(1,E-2);let d=A[w];d===void 0&&b&&(d=b[w]);const P=typeof d=="string"?d:d?.message,$=b?.[w],c=typeof $=="string"?$:$?.message;if(!P){c||T.warn(`[${C.name}]: ${(0,a.localize)(1814,null,w)}`);return}if(f&&(m==="title"||m==="category")&&c&&c!==P){const h={value:P,original:c};p[m]=h}else p[m]=P}}else if((0,I.$lg)(l))for(const g in l)l.hasOwnProperty(g)&&(g==="commands"?R(l,g,!0):R(l,g,f));else if(Array.isArray(l))for(let g=0;g<l.length;g++)R(l,g,f)};for(const p in C)C.hasOwnProperty(p)&&R(C,p)}}),define(ue[160],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=e.$4jc=void 0;class I{constructor(k){this.a=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k){return this.a.call("promptImportantExtensionsInstallNotification",[k])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$4jc=I;class a{constructor(k){this.a=k}listen(k,T){throw new Error(`Event not found: ${T}`)}call(k,T,C){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(C[0])}throw new Error(`Call not found: ${T}`)}}e.$5jc=a}),define(ue[161],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const I={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:6},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(I)}),define(ue[74],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=void 0;class I{constructor(N,k=[],T=!1){this.ctor=N,this.staticArguments=k,this.supportsDelayedInstantiation=T}}e.$Hi=I}),define(ue[162],de([0,1,74]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Zs=k,e.$1s=T;const a=[];var N;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(N||(e.InstantiationType=N={}));function k(C,A,b){A instanceof I.$Hi||(A=new I.$Hi(A,[],!!b)),a.push([C,A])}function T(){return a}}),define(ue[163],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;class I{constructor(k,T){this.key=k,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$Cr=I;class a{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const T of this.a.values())T.outgoing.size===0&&k.push(T);return k}insertEdge(k,T){const C=this.lookupOrInsertNode(k),A=this.lookupOrInsertNode(T);C.outgoing.set(A.key,A),A.incoming.set(C.key,C)}removeNode(k){const T=this.b(k);this.a.delete(T);for(const C of this.a.values())C.outgoing.delete(T),C.incoming.delete(T)}lookupOrInsertNode(k){const T=this.b(k);let C=this.a.get(T);return C||(C=new I(T,k),this.a.set(T,C)),C}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[T,C]of this.a)k.push(`${T}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,T]of this.a){const C=new Set([k]),A=this.c(T,C);if(A)return A}}c(k,T){for(const[C,A]of k.outgoing){if(T.has(C))return[...T,C].join(" -> ");T.add(C);const b=this.c(A,T);if(b)return b;T.delete(C)}}}e.$Dr=a}),define(ue[4],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e._util=void 0,e.$Ki=N,e.$Li=k;var I;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function C(A){return A[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=C})(I||(e._util=I={})),e.$Ji=N("instantiationService");function a(T,C,A){C[I.DI_TARGET]===C?C[I.DI_DEPENDENCIES].push({id:T,index:A}):(C[I.DI_DEPENDENCIES]=[{id:T,index:A}],C[I.DI_TARGET]=C)}function N(T){if(I.serviceIds.has(T))return I.serviceIds.get(T);const C=function(A,b,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");a(C,A,R)};return C.toString=()=>T,I.serviceIds.set(T,C),C}function k(T){return T}}),define(ue[164],de([0,1,4]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=void 0,e.$Djc=(0,I.$Ki)("checksumService")}),define(ue[21],de([0,1,12,10,4]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$ej=void 0,e.$fj=k,e.$gj=T,e.$hj=A,e.$ij=b,e.$jj=R,e.$kj=p,e.$lj=m,e.$mj=l,e.$nj=g,e.$oj=E,I=Oe(I),e.$ej=(0,N.$Ki)("configurationService");function k(w){return w&&typeof w=="object"&&(!w.overrideIdentifier||typeof w.overrideIdentifier=="string")&&(!w.resource||w.resource instanceof a.URI)}function T(w){return w&&typeof w=="object"&&(!w.overrideIdentifiers||Array.isArray(w.overrideIdentifiers))&&!w.overrideIdentifier&&(!w.resource||w.resource instanceof a.URI)}var C;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.USER=2]="USER",w[w.USER_LOCAL=3]="USER_LOCAL",w[w.USER_REMOTE=4]="USER_REMOTE",w[w.WORKSPACE=5]="WORKSPACE",w[w.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",w[w.DEFAULT=7]="DEFAULT",w[w.MEMORY=8]="MEMORY"})(C||(e.ConfigurationTarget=C={}));function A(w){switch(w){case C.APPLICATION:return"APPLICATION";case C.USER:return"USER";case C.USER_LOCAL:return"USER_LOCAL";case C.USER_REMOTE:return"USER_REMOTE";case C.WORKSPACE:return"WORKSPACE";case C.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case C.DEFAULT:return"DEFAULT";case C.MEMORY:return"MEMORY"}}function b(w){return w.applicationValue!==void 0||w.userValue!==void 0||w.userLocalValue!==void 0||w.userRemoteValue!==void 0||w.workspaceValue!==void 0||w.workspaceFolderValue!==void 0}function R(w,d){const P=Object.create(null);for(const $ in w)p(P,$,w[$],d);return P}function p(w,d,P,$){const c=d.split("."),h=c.pop();let i=w;for(let n=0;n<c.length;n++){const t=c[n];let s=i[t];switch(typeof s){case"undefined":s=i[t]=Object.create(null);break;case"object":if(s===null){$(`Ignoring ${d} as ${c.slice(0,n+1).join(".")} is null`);return}break;default:$(`Ignoring ${d} as ${c.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}i=s}if(typeof i=="object"&&i!==null)try{i[h]=P}catch{$(`Ignoring ${d} as ${c.join(".")} is ${JSON.stringify(i)}`)}else $(`Ignoring ${d} as ${c.join(".")} is ${JSON.stringify(i)}`)}function m(w,d){const P=d.split(".");f(w,P)}function f(w,d){const P=d.shift();if(d.length===0){delete w[P];return}if(Object.keys(w).indexOf(P)!==-1){const $=w[P];typeof $=="object"&&!Array.isArray($)&&(f($,d),Object.keys($).length===0&&delete w[P])}}function l(w,d,P){function $(i,n){let t=i;for(const s of n){if(typeof t!="object"||t===null)return;t=t[s]}return t}const c=d.split("."),h=$(w,c);return typeof h>"u"?P:h}function g(w,d,P){Object.keys(d).forEach($=>{$!=="__proto__"&&($ in w?I.$lg(w[$])&&I.$lg(d[$])?g(w[$],d[$],P):P&&(w[$]=d[$]):w[$]=d[$])})}function E(w){return w.replace(/[\[\]]/g,"")}}),define(ue[98],de([0,1,39,5,26,155,4,9,8]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Ij=e.$Hj=e.ContextKeyExprType=void 0,e.$Gj=R,e.$Jj=n,e.$Kj=t,e.$4j=ee;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",a.$m),b.set("isLinux",a.$n),b.set("isWindows",a.$l),b.set("isWeb",a.$r),b.set("isMacNative",a.$m&&!a.$r),b.set("isEdge",a.$K),b.set("isFirefox",a.$I),b.set("isChrome",a.$H),b.set("isSafari",a.$J);function R(q,D){if(b.get(q)!==void 0)throw(0,A.$$)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(q,D)}const p=Object.prototype.hasOwnProperty;var m;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const f={regexParsingWithErrorRecovery:!0},l=(0,C.localize)(1673,null),g=(0,C.localize)(1674,null),E=(0,C.localize)(1675,null),w=(0,C.localize)(1676,null),d=(0,C.localize)(1677,null),P=(0,C.localize)(1678,null),$=(0,C.localize)(1679,null),c=(0,C.localize)(1680,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=f){this.k=D,this.d=new k.$Fj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const J=this.l();if(!this.E()){const oe=this.D(),Q=oe.type===k.TokenType.Str?P:void 0;throw this.h.push({message:d,offset:oe.offset,lexeme:k.$Fj.getLexeme(oe),additionalInfo:Q}),h.c}return J}catch(J){if(J!==h.c)throw J;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(k.TokenType.Or);){const J=this.o();D.push(J)}return D.length===1?D[0]:i.or(...D)}o(){const D=[this.s()];for(;this.y(k.TokenType.And);){const J=this.s();D.push(J)}return D.length===1?D[0]:i.and(...D)}s(){if(this.y(k.TokenType.Neg)){const D=this.D();switch(D.type){case k.TokenType.True:return this.z(),r.INSTANCE;case k.TokenType.False:return this.z(),o.INSTANCE;case k.TokenType.LParen:{this.z();const J=this.l();return this.A(k.TokenType.RParen,w),J?.negate()}case k.TokenType.Str:return this.z(),L.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case k.TokenType.True:return this.z(),i.true();case k.TokenType.False:return this.z(),i.false();case k.TokenType.LParen:{this.z();const J=this.l();return this.A(k.TokenType.RParen,w),J}case k.TokenType.Str:{const J=D.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const Q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Q.type!==k.TokenType.RegexStr)throw this.B("REGEX",Q);const Y=Q.lexeme,M=Y.lastIndexOf("/"),B=M===Y.length-1?void 0:this.w(Y.substring(M+1));let ie;try{ie=new RegExp(Y.substring(1,M),B)}catch{throw this.B("REGEX",Q)}return x.create(J,ie)}switch(Q.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const Y=[Q.lexeme];this.z();let M=this.D(),B=0;for(let be=0;be<Q.lexeme.length;be++)Q.lexeme.charCodeAt(be)===I.CharCode.OpenParen?B++:Q.lexeme.charCodeAt(be)===I.CharCode.CloseParen&&B--;for(;!this.E()&&M.type!==k.TokenType.And&&M.type!==k.TokenType.Or;){switch(M.type){case k.TokenType.LParen:B++;break;case k.TokenType.RParen:B--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let be=0;be<M.lexeme.length;be++)M.lexeme.charCodeAt(be)===I.CharCode.OpenParen?B++:Q.lexeme.charCodeAt(be)===I.CharCode.CloseParen&&B--}if(B<0)break;Y.push(k.$Fj.getLexeme(M)),this.z(),M=this.D()}const ie=Y.join(""),ae=ie.lastIndexOf("/"),he=ae===ie.length-1?void 0:this.w(ie.substring(ae+1));let pe;try{pe=new RegExp(ie.substring(1,ae),he)}catch{throw this.B("REGEX",Q)}return i.regex(J,pe)}case k.TokenType.QuotedStr:{const Y=Q.lexeme;this.z();let M=null;if(!(0,N.$hf)(Y)){const B=Y.indexOf("/"),ie=Y.lastIndexOf("/");if(B!==ie&&B>=0){const ae=Y.slice(B+1,ie),he=Y[ie+1]==="i"?"i":"";try{M=new RegExp(ae,he)}catch{throw this.B("REGEX",Q)}}}if(M===null)throw this.B("REGEX",Q);return x.create(J,M)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,E);const Q=this.u();return i.notIn(J,Q)}switch(this.D().type){case k.TokenType.Eq:{this.z();const Q=this.u();if(this.x().type===k.TokenType.QuotedStr)return i.equals(J,Q);switch(Q){case"true":return i.has(J);case"false":return i.not(J);default:return i.equals(J,Q)}}case k.TokenType.NotEq:{this.z();const Q=this.u();if(this.x().type===k.TokenType.QuotedStr)return i.notEquals(J,Q);switch(Q){case"true":return i.not(J);case"false":return i.has(J);default:return i.notEquals(J,Q)}}case k.TokenType.Lt:return this.z(),G.create(J,this.u());case k.TokenType.LtEq:return this.z(),V.create(J,this.u());case k.TokenType.Gt:return this.z(),U.create(J,this.u());case k.TokenType.GtEq:return this.z(),F.create(J,this.u());case k.TokenType.In:return this.z(),i.in(J,this.u());default:return i.has(J)}}case k.TokenType.EOF:throw this.h.push({message:$,offset:D.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),D.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,J){if(this.C(D))return this.z();throw this.B(J,this.D())}B(D,J,oe){const Q=(0,C.localize)(1681,null,D,k.$Fj.getLexeme(J)),Y=J.offset,M=k.$Fj.getLexeme(J);return this.h.push({message:Q,offset:Y,lexeme:M,additionalInfo:oe}),h.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}e.$Hj=h;class i{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(D){return u.create(D)}static equals(D,J){return y.create(D,J)}static notEquals(D,J){return v.create(D,J)}static regex(D,J){return x.create(D,J)}static in(D,J){return O.create(D,J)}static notIn(D,J){return S.create(D,J)}static not(D){return L.create(D)}static and(...D){return z.create(D,null,!0)}static or(...D){return W.create(D,null,!0)}static greater(D,J){return U.create(D,J)}static greaterEquals(D,J){return F.create(D,J)}static smaller(D,J){return G.create(D,J)}static smallerEquals(D,J){return V.create(D,J)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$Ij=i;function n(q){const D=new h({regexParsingWithErrorRecovery:!1});return q.map(J=>(D.parse(J),D.lexingErrors.length>0?D.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,C.localize)(1682,null,oe.additionalInfo):(0,C.localize)(1683,null),offset:oe.offset,length:oe.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function t(q,D){const J=q?q.substituteConstants():void 0,oe=D?D.substituteConstants():void 0;return!J&&!oe?!0:!J||!oe?!1:J.equals(oe)}function s(q,D){return q.cmp(D)}class r{static{this.INSTANCE=new r}constructor(){this.type=m.False}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return o.INSTANCE}}e.$Lj=r;class o{static{this.INSTANCE=new o}constructor(){this.type=m.True}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.$Mj=o;class u{static create(D,J=null){const oe=b.get(D);return typeof oe=="boolean"?oe?o.INSTANCE:r.INSTANCE:new u(D,J)}constructor(D,J){this.key=D,this.c=J,this.type=m.Defined}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=b.get(this.key);return typeof D=="boolean"?D?o.INSTANCE:r.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Nj=u;class y{static create(D,J,oe=null){if(typeof J=="boolean")return J?u.create(D,oe):L.create(D,oe);const Q=b.get(D);return typeof Q=="boolean"?J===(Q?"true":"false")?o.INSTANCE:r.INSTANCE:new y(D,J,oe)}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=m.Equals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=b.get(this.c);if(typeof D=="boolean"){const J=D?"true":"false";return this.d===J?o.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Oj=y;class O{static create(D,J){return new O(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=m.In,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:le(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const J=D.getValue(this.f),oe=D.getValue(this.d);return Array.isArray(J)?J.includes(oe):typeof oe=="string"&&typeof J=="object"&&J!==null?p.call(J,oe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$Pj=O;class S{static create(D,J){return new S(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=m.NotIn,this.c=O.create(D,J)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qj=S;class v{static create(D,J,oe=null){if(typeof J=="boolean")return J?L.create(D,oe):u.create(D,oe);const Q=b.get(D);return typeof Q=="boolean"?J===(Q?"true":"false")?r.INSTANCE:o.INSTANCE:new v(D,J,oe)}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=m.NotEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=b.get(this.c);if(typeof D=="boolean"){const J=D?"true":"false";return this.d===J?r.INSTANCE:o.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Rj=v;class L{static create(D,J=null){const oe=b.get(D);return typeof oe=="boolean"?oe?r.INSTANCE:o.INSTANCE:new L(D,J)}constructor(D,J){this.c=D,this.d=J,this.type=m.Not}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=b.get(this.c);return typeof D=="boolean"?D?r.INSTANCE:o.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$Sj=L;function j(q,D){if(typeof q=="string"){const J=parseFloat(q);isNaN(J)||(q=J)}return typeof q=="string"||typeof q=="number"?D(q):r.INSTANCE}class U{static create(D,J,oe=null){return j(J,Q=>new U(D,Q,oe))}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=m.Greater}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Tj=U;class F{static create(D,J,oe=null){return j(J,Q=>new F(D,Q,oe))}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=m.GreaterEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Uj=F;class G{static create(D,J,oe=null){return j(J,Q=>new G(D,Q,oe))}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=m.Smaller}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Vj=G;class V{static create(D,J,oe=null){return j(J,Q=>new V(D,Q,oe))}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=m.SmallerEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Wj=V;class x{static create(D,J){return new x(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=m.Regex,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const J=this.f?this.f.source:"",oe=D.f?D.f.source:"";return J<oe?-1:J>oe?1:0}equals(D){if(D.type===this.type){const J=this.f?this.f.source:"",oe=D.f?D.f.source:"";return this.d===D.d&&J===oe}return!1}substituteConstants(){return this}evaluate(D){const J=D.getValue(this.d);return this.f?this.f.test(J):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$Xj=x;class H{static create(D){return new H(D)}constructor(D){this.c=D,this.type=m.NotRegex}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new H(this.c.map(D))}negate(){return this.c}}e.$Yj=H;function te(q){let D=null;for(let J=0,oe=q.length;J<oe;J++){const Q=q[J].substituteConstants();if(q[J]!==Q&&D===null){D=[];for(let Y=0;Y<J;Y++)D[Y]=q[Y]}D!==null&&(D[J]=Q)}return D===null?q:D}class z{static create(D,J,oe){return z.d(D,J,oe)}constructor(D,J){this.expr=D,this.c=J,this.type=m.And}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let J=0,oe=this.expr.length;J<oe;J++){const Q=s(this.expr[J],D.expr[J]);if(Q!==0)return Q}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let J=0,oe=this.expr.length;J<oe;J++)if(!this.expr[J].equals(D.expr[J]))return!1;return!0}return!1}substituteConstants(){const D=te(this.expr);return D===this.expr?this:z.create(D,this.c,!1)}evaluate(D){for(let J=0,oe=this.expr.length;J<oe;J++)if(!this.expr[J].evaluate(D))return!1;return!0}static d(D,J,oe){const Q=[];let Y=!1;for(const M of D)if(M){if(M.type===m.True){Y=!0;continue}if(M.type===m.False)return r.INSTANCE;if(M.type===m.And){Q.push(...M.expr);continue}Q.push(M)}if(Q.length===0&&Y)return o.INSTANCE;if(Q.length!==0){if(Q.length===1)return Q[0];Q.sort(s);for(let M=1;M<Q.length;M++)Q[M-1].equals(Q[M])&&(Q.splice(M,1),M--);if(Q.length===1)return Q[0];for(;Q.length>1;){const M=Q[Q.length-1];if(M.type!==m.Or)break;Q.pop();const B=Q.pop(),ie=Q.length===0,ae=W.create(M.expr.map(he=>z.create([he,B],null,oe)),null,ie);ae&&(Q.push(ae),Q.sort(s))}if(Q.length===1)return Q[0];if(oe){for(let M=0;M<Q.length;M++)for(let B=M+1;B<Q.length;B++)if(Q[M].negate().equals(Q[B]))return r.INSTANCE;if(Q.length===1)return Q[0]}return new z(Q,J)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const J of this.expr)D.push(...J.keys());return D}map(D){return new z(this.expr.map(J=>J.map(D)),null)}negate(){if(!this.c){const D=[];for(const J of this.expr)D.push(J.negate());this.c=W.create(D,this,!0)}return this.c}}e.$Zj=z;class W{static create(D,J,oe){return W.d(D,J,oe)}constructor(D,J){this.expr=D,this.c=J,this.type=m.Or}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let J=0,oe=this.expr.length;J<oe;J++){const Q=s(this.expr[J],D.expr[J]);if(Q!==0)return Q}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let J=0,oe=this.expr.length;J<oe;J++)if(!this.expr[J].equals(D.expr[J]))return!1;return!0}return!1}substituteConstants(){const D=te(this.expr);return D===this.expr?this:W.create(D,this.c,!1)}evaluate(D){for(let J=0,oe=this.expr.length;J<oe;J++)if(this.expr[J].evaluate(D))return!0;return!1}static d(D,J,oe){let Q=[],Y=!1;if(D){for(let M=0,B=D.length;M<B;M++){const ie=D[M];if(ie){if(ie.type===m.False){Y=!0;continue}if(ie.type===m.True)return o.INSTANCE;if(ie.type===m.Or){Q=Q.concat(ie.expr);continue}Q.push(ie)}}if(Q.length===0&&Y)return r.INSTANCE;Q.sort(s)}if(Q.length!==0){if(Q.length===1)return Q[0];for(let M=1;M<Q.length;M++)Q[M-1].equals(Q[M])&&(Q.splice(M,1),M--);if(Q.length===1)return Q[0];if(oe){for(let M=0;M<Q.length;M++)for(let B=M+1;B<Q.length;B++)if(Q[M].negate().equals(Q[B]))return o.INSTANCE;if(Q.length===1)return Q[0]}return new W(Q,J)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const J of this.expr)D.push(...J.keys());return D}map(D){return new W(this.expr.map(J=>J.map(D)),null)}negate(){if(!this.c){const D=[];for(const J of this.expr)D.push(J.negate());for(;D.length>1;){const J=D.shift(),oe=D.shift(),Q=[];for(const Y of K(J))for(const M of K(oe))Q.push(z.create([Y,M],null,!1));D.unshift(W.create(Q,null,!1))}this.c=W.create(D,this,!0)}return this.c}}e.$1j=W;class _ extends u{static{this.d=[]}static all(){return _.d.values()}constructor(D,J,oe){super(D,null),this.f=J,typeof oe=="object"?_.d.push({...oe,key:D}):oe!==!0&&_.d.push({key:D,description:oe,type:J!=null?typeof J:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return y.create(this.key,D)}notEqualsTo(D){return v.create(this.key,D)}}e.$2j=_,e.$3j=(0,T.$Ki)("contextKeyService");function ne(q,D){return q<D?-1:q>D?1:0}function le(q,D,J,oe){return q<J?-1:q>J?1:D<oe?-1:D>oe?1:0}function ee(q,D){if(q.type===m.False||D.type===m.True)return!0;if(q.type===m.Or)return D.type===m.Or?X(q.expr,D.expr):!1;if(D.type===m.Or){for(const J of D.expr)if(ee(q,J))return!0;return!1}if(q.type===m.And){if(D.type===m.And)return X(D.expr,q.expr);for(const J of q.expr)if(ee(J,D))return!0;return!1}return q.equals(D)}function X(q,D){let J=0,oe=0;for(;J<q.length&&oe<D.length;){const Q=q[J].cmp(D[oe]);if(Q<0)return!1;Q===0&&J++,oe++}return J===q.length}function K(q){return q.type===m.Or?q.expr:[q]}}),define(ue[99],de([0,1,4]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Ym=e.ID=void 0,e.$Zm=a,e.ID="diagnosticsService",e.$Ym=(0,I.$Ki)(e.ID);function a(k){return!!k.hostName&&!!k.errorMessage}class N{async getPerformanceInfo(T,C){return{}}async getSystemInfo(T,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,C){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$1m=N}),define(ue[100],de([0,1,4]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=void 0,e.$8o=(0,I.$Ki)("downloadService")}),define(ue[15],de([0,1,4]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=void 0,e.$Ri=(0,I.$Ki)("environmentService"),e.$Si=(0,I.$Li)(e.$Ri)}),define(ue[75],de([0,1,4]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q8b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$P8b=N;var a;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(a||(e.RecommendationSource=a={}));function N(T){switch(T){case a.FILE:return"file";case a.WORKSPACE:return"workspace";case a.EXE:return"exe"}}var k;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(k||(e.RecommendationsNotificationResult=k={})),e.$Q8b=(0,I.$Ki)("IExtensionRecommendationNotificationService")}),define(ue[7],de([0,1,51,13,26,12,10,9,4,5,22,53]),function(ce,e,I,a,N,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Kl=e.FileKind=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.FileOperationResult=e.$Cl=e.$Bl=e.$Al=e.$yl=e.FileChangeType=e.$xl=e.FileOperation=e.$rl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$fl=void 0,e.$gl=m,e.$hl=E,e.$il=d,e.$jl=P,e.$kl=$,e.$ll=c,e.$ml=h,e.$nl=i,e.$ol=n,e.$pl=t,e.$ql=s,e.$sl=u,e.$tl=y,e.$ul=O,e.$vl=S,e.$wl=v,e.$zl=G,e.$Ll=W,e.$Ml=_,e.$Ol=le,e.$fl=(0,A.$Ki)("fileService");function m(ee){return ee.create===!0}var f;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var l;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var g;(function(ee){ee[ee.UPDATED=2]="UPDATED",ee[ee.ADDED=4]="ADDED",ee[ee.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function E(ee){const X=ee;return!!X&&typeof X.onDidChange=="function"}var w;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function d(ee){return!!(ee.capabilities&w.FileReadWrite)}function P(ee){return!!(ee.capabilities&w.FileFolderCopy)}function $(ee){return!!(ee.capabilities&w.FileClone)}function c(ee){return!!(ee.capabilities&w.FileOpenReadWriteClose)}function h(ee){return!!(ee.capabilities&w.FileReadStream)}function i(ee){return d(ee)?!!(ee.capabilities&w.FileAtomicRead):!1}function n(ee){return d(ee)?!!(ee.capabilities&w.FileAtomicWrite):!1}function t(ee){return!!(ee.capabilities&w.FileAtomicDelete)}function s(ee){return!!(ee.capabilities&w.Readonly)}var r;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class o extends Error{static create(X,K){const q=new o(X.toString(),K);return O(q,K),q}constructor(X,K){super(X),this.code=K}}e.$rl=o;function u(ee,X){return o.create(ee,X)}function y(ee){return ee||u((0,C.localize)(1865,null),r.Unknown)}function O(ee,X){return ee.name=X?`${X} (FileSystemError)`:"FileSystemError",ee}function S(ee){if(!ee)return r.Unknown;if(ee instanceof o)return ee.code;const X=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!X)return r.Unknown;switch(X[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function v(ee){if(ee instanceof V)return ee.fileOperationResult;switch(S(ee)){case r.FileNotFound:return te.FILE_NOT_FOUND;case r.FileIsADirectory:return te.FILE_IS_DIRECTORY;case r.FileNotADirectory:return te.FILE_NOT_DIRECTORY;case r.FileWriteLocked:return te.FILE_WRITE_LOCKED;case r.NoPermissions:return te.FILE_PERMISSION_DENIED;case r.FileExists:return te.FILE_MOVE_CONFLICT;case r.FileTooLarge:return te.FILE_TOO_LARGE;default:return te.FILE_OTHER_ERROR}}var L;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class j{constructor(X,K,q){this.resource=X,this.operation=K,this.target=q}isOperation(X){return this.operation===X}}e.$xl=j;var U;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class F{static{this.a=null}constructor(X,K){this.c=K,this.b=void 0,this.d=new p.$Y(()=>{const q=I.$Qi.forUris(()=>this.c);return q.fill(this.rawAdded.map(D=>[D,!0])),q}),this.f=new p.$Y(()=>{const q=I.$Qi.forUris(()=>this.c);return q.fill(this.rawUpdated.map(D=>[D,!0])),q}),this.g=new p.$Y(()=>{const q=I.$Qi.forUris(()=>this.c);return q.fill(this.rawDeleted.map(D=>[D,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of X){switch(q.type){case U.ADDED:this.rawAdded.push(q.resource);break;case U.UPDATED:this.rawUpdated.push(q.resource);break;case U.DELETED:this.rawDeleted.push(q.resource);break}this.b!==F.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(X,...K){return this.h(X,{includeChildren:!1},...K)}affects(X,...K){return this.h(X,{includeChildren:!0},...K)}h(X,K,...q){if(!X)return!1;const D=q.length>0;return!!((!D||q.includes(U.ADDED))&&(this.d.value.get(X)||K.includeChildren&&this.d.value.findSuperstr(X))||(!D||q.includes(U.UPDATED))&&(this.f.value.get(X)||K.includeChildren&&this.f.value.findSuperstr(X))||(!D||q.includes(U.DELETED))&&(this.g.value.findSubstr(X)||K.includeChildren&&this.g.value.findSuperstr(X)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(X){return this.b===X}hasCorrelation(){return typeof this.b=="number"}}e.$yl=F;function G(ee,X,K){return!ee||!X||ee===X||X.length>ee.length?!1:(X.charAt(X.length-1)!==a.sep&&(X+=a.sep),K?(0,N.$Lf)(ee,X):ee.indexOf(X)===0)}class V extends Error{constructor(X,K,q){super(X),this.fileOperationResult=K,this.options=q}}e.$Al=V;class x extends V{constructor(X,K,q,D){super(X,K,D),this.fileOperationResult=K,this.size=q}}e.$Bl=x;class H extends V{constructor(X,K,q){super(X,te.FILE_NOT_MODIFIED_SINCE,q),this.stat=K}}e.$Cl=H;var te;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.$Dl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$El={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Fl="files.associations",e.$Gl="files.exclude",e.$Hl="files.readonlyInclude",e.$Il="files.readonlyExclude",e.$Jl="files.readonlyFromPermissions";var z;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(z||(e.FileKind=z={})),e.$Kl="";function W(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}async function _(ee,X){if(!X.hasProvider(T.URI.from({scheme:ee.scheme})))return new Promise(K=>{const q=X.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===ee.scheme&&D.added&&(q.dispose(),K())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(X){return(0,k.$ng)(X)||(X=0),X<ne.KB?(0,C.localize)(1866,null,X.toFixed(0)):X<ne.MB?(0,C.localize)(1867,null,(X/ne.KB).toFixed(2)):X<ne.GB?(0,C.localize)(1868,null,(X/ne.MB).toFixed(2)):X<ne.TB?(0,C.localize)(1869,null,(X/ne.GB).toFixed(2)):(0,C.localize)(1870,null,(X/ne.TB).toFixed(2))}}e.$Nl=ne;function le(ee){const X=typeof ee=="string"||ee?.scheme===R.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===R.Schemas.file?1024*ne.MB:X?10*ne.MB:b.$r?50*ne.MB:1024*ne.MB}});var Z=this&&this.__param||function(ce,e){return function(I,a){e(I,a,ce)}};define(ue[165],de([0,1,76,50,7]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=void 0;let k=class{constructor(C){this.a=C}async checksum(C){const A=(await this.a.readFileStream(C)).value;return new Promise((b,R)=>{const p=(0,I.createHash)("sha256");(0,a.$Ke)(A,{onData:m=>p.update(m.buffer),onError:m=>R(m),onEnd:()=>b(p.digest("base64").replace(/=+$/,""))})})}};e.$Ejc=k,e.$Ejc=k=Ee([Z(0,N.$fl)],k)}),define(ue[101],de([0,1,14,8,9,7]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=T;async function T(R,p,m,f,l,g){let E;try{await C(R,p,m,f,l,g)}catch(w){E=w}finally{E&&l.errorTransformer&&(E=l.errorTransformer(E)),typeof E<"u"&&m.error(E),m.end()}}async function C(R,p,m,f,l,g){A(g);const E=await R.open(p,{create:!1});try{A(g);let w=0,d=0,P=l&&typeof l.length=="number"?l.length:void 0,$=I.$Se.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),c=l&&typeof l.position=="number"?l.position:0,h=0;do d=await R.read(E,c,$.buffer,h,$.byteLength-h),c+=d,h+=d,w+=d,typeof P=="number"&&(P-=d),h===$.byteLength&&(await m.write(f($)),$=I.$Se.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),h=0);while(d>0&&(typeof P!="number"||P>0)&&A(g)&&b(w,l));if(h>0){let i=h;typeof P=="number"&&(i=Math.min(h,P)),m.write(f($.slice(0,i)))}}catch(w){throw(0,k.$tl)(w)}finally{await R.close(E)}}function A(R){if(R.isCancellationRequested)throw(0,a.$0)();return!0}function b(R,p){if(typeof p?.limits?.size=="number"&&R>p.limits.size)throw(0,k.$sl)((0,N.localize)(1898,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ue[46],de([0,1,95,2,13,5,10,7]),function(ce,e,I,a,N,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=void 0,e.$_q=A,e.$ar=b,e.$er=f,e.$fr=l,e.$gr=g,e.$hr=E,e.$ir=d,e.$jr=P;function A($){return typeof $.correlationId=="number"}function b($){return $.recursive===!0}class R extends a.$Zc{static{this.a=5}constructor(c,h,i,n){super(),this.h=c,this.j=h,this.m=i,this.n=n,this.c=this.B(new a.$1c),this.f=void 0,this.g=0}s(){const c=new a.$Yc;this.c.value=c,this.b=this.r(c),this.b.setVerboseLogging(this.m),c.add(this.b.onDidChangeFile(h=>this.h(h))),c.add(this.b.onDidLogMessage(h=>this.j(h))),c.add(this.b.onDidError(h=>this.t(h.error,h.request)))}t(c,h){this.u(c,h)?this.g<R.a&&this.f?(this.y(`restarting watcher after unexpected error: ${c}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${c}`):this.y(c)}u(c,h){return!(!this.n.restartOnError||h||c.indexOf("No space left on device")!==-1||c.indexOf("EMFILE")!==-1)}w(c){this.g++,this.s(),this.watch(c)}async watch(c){this.f=c,await this.b?.watch(c)}async setVerboseLogging(c){this.m=c,await this.b?.setVerboseLogging(c)}y(c){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${c}`})}z(c){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${c}`})}dispose(){return this.b=void 0,super.dispose()}}e.$br=R;class p extends R{constructor(c,h,i){super(c,h,i,{type:"node.js",restartOnError:!1})}}e.$cr=p;class m extends R{constructor(c,h,i){super(c,h,i,{type:"universal",restartOnError:!0})}}e.$dr=m;function f($){return $.map(c=>({type:c.type,resource:T.URI.revive(c.resource),cId:c.cId}))}function l($){const c=new w;for(const h of $)c.processEvent(h);return c.coalesce()}function g($,c){return typeof c=="string"&&!c.startsWith(I.$Bk)&&!(0,N.$nc)(c)?{base:$,pattern:c}:c}function E($,c){const h=[];for(const i of c)h.push((0,I.$Fk)(g($,i)));return h}class w{constructor(){this.a=new Set,this.b=new Map}c(c){return k.$n?c.resource.fsPath:c.resource.fsPath.toLowerCase()}processEvent(c){const h=this.b.get(this.c(c));let i=!1;if(h){const n=h.type,t=c.type;h.resource.fsPath!==c.resource.fsPath&&(c.type===C.FileChangeType.DELETED||c.type===C.FileChangeType.ADDED)?i=!0:n===C.FileChangeType.ADDED&&t===C.FileChangeType.DELETED?(this.b.delete(this.c(c)),this.a.delete(h)):n===C.FileChangeType.DELETED&&t===C.FileChangeType.ADDED?h.type=C.FileChangeType.UPDATED:n===C.FileChangeType.ADDED&&t===C.FileChangeType.UPDATED||(h.type=t)}else i=!0;i&&(this.a.add(c),this.b.set(this.c(c),c))}coalesce(){const c=[],h=[];return Array.from(this.a).filter(i=>i.type!==C.FileChangeType.DELETED?(c.push(i),!1):!0).sort((i,n)=>i.resource.fsPath.length-n.resource.fsPath.length).filter(i=>h.some(n=>(0,C.$zl)(i.resource.fsPath,n,!k.$n))?!1:(h.push(i.resource.fsPath),!0)).concat(c)}}function d($,c){if(typeof c=="number")switch($.type){case C.FileChangeType.ADDED:return(c&C.FileChangeFilter.ADDED)===0;case C.FileChangeType.DELETED:return(c&C.FileChangeFilter.DELETED)===0;case C.FileChangeType.UPDATED:return(c&C.FileChangeFilter.UPDATED)===0}return!1}function P($){if(typeof $=="number"){const c=[];return $&C.FileChangeFilter.ADDED&&c.push("Added"),$&C.FileChangeFilter.DELETED&&c.push("Deleted"),$&C.FileChangeFilter.UPDATED&&c.push("Updated"),c.length===0?"<all>":`[${c.join(", ")}]`}return"<none>"}}),define(ue[166],de([0,1,14,41,8,3,2,50,32,7,46]),function(ce,e,I,a,N,k,T,C,A,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TR=e.$SR=void 0,e.$SR="localFilesystem";class p extends T.$Zc{constructor(f,l){super(),this.a=f,this.b=l,this.onDidChangeCapabilities=k.Event.None,this.f=this.B(new k.$qe),this.onDidChangeFile=this.f.event,this.g=this.B(new k.$qe),this.onDidWatchError=this.g.event,this.h=(0,A.$7g)(),this.j()}get capabilities(){return this.c||(this.c=b.FileSystemProviderCapabilities.FileReadWrite|b.FileSystemProviderCapabilities.FileOpenReadWriteClose|b.FileSystemProviderCapabilities.FileReadStream|b.FileSystemProviderCapabilities.FileFolderCopy|b.FileSystemProviderCapabilities.FileWriteUnlock|b.FileSystemProviderCapabilities.FileAtomicRead|b.FileSystemProviderCapabilities.FileAtomicWrite|b.FileSystemProviderCapabilities.FileAtomicDelete|b.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=b.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=b.FileSystemProviderCapabilities.Trash)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,l){const{buffer:g}=await this.a.call("readFile",[f,l]);return g}readFileStream(f,l,g){const E=(0,C.$Ge)(d=>I.$Se.concat(d.map(P=>I.$Se.wrap(P))).buffer),w=new T.$Yc;return w.add(this.a.listen("readFileStream",[f,l])(d=>{if(d instanceof I.$Se)E.write(d.buffer);else{if(d==="end")E.end();else{let P;if(d instanceof Error)P=d;else{const $=d;P=(0,b.$sl)($.message??(0,a.$vj)($),$.code??b.FileSystemProviderErrorCode.Unknown)}E.error(P),E.end()}w.dispose()}})),w.add(g.onCancellationRequested(()=>{E.error((0,N.$0)()),E.end(),w.dispose()})),E}writeFile(f,l,g){return this.a.call("writeFile",[f,I.$Se.wrap(l),g])}open(f,l){return this.a.call("open",[f,l])}close(f){return this.a.call("close",[f])}async read(f,l,g,E,w){const[d,P]=await this.a.call("read",[f,l,w]);return g.set(d.buffer.slice(0,P),E),P}write(f,l,g,E,w){return this.a.call("write",[f,l,I.$Se.wrap(g),E,w])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,l){return this.a.call("delete",[f,l])}rename(f,l,g){return this.a.call("rename",[f,l,g])}copy(f,l,g){return this.a.call("copy",[f,l,g])}cloneFile(f,l){return this.a.call("cloneFile",[f,l])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const l=f;this.f.fire((0,R.$er)(l))}else{const l=f;this.g.fire(l)}}))}watch(f,l){const g=(0,A.$7g)();return this.a.call("watch",[this.h,g,f,l]),(0,T.$Xc)(()=>this.a.call("unwatch",[this.h,g]))}}e.$TR=p}),define(ue[167],de([0,1,33,2,46,3,7,10,6]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class b extends a.$Zc{constructor(){super(),this.a=this.B(new k.$qe),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$qe),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$qe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new a.$9c),this.m=new Set,this.n=this.B(new A.$Ih(this.y())),this.r=5007,this.s=new A.$8h,this.R=!1,this.B(this.f(p=>this.t(p)))}t(p){this.u(p)&&this.z(p)}u(p){return(0,N.$_q)(p)}async watch(p){this.s.isSettled||this.s.complete(),this.s=new A.$8h;try{this.h.clear(),this.g.clear();for(const m of p)this.u(m)?this.h.set(m.correlationId,m):this.g.add(m);for(const[m]of this.j)this.h.has(m)||(this.j.deleteAndDispose(m),this.m.delete(m));return await this.w(!1)}finally{this.s.complete()}}w(p){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(m=>!this.j.has(m.correlationId))]),p?this.y():0)}y(){return 800}isSuspended(p){return typeof p.correlationId!="number"?!1:this.m.has(p.correlationId)?"polling":this.j.has(p.correlationId)}async z(p){if(this.j.has(p.correlationId))return;const m=new a.$Yc;this.j.set(p.correlationId,m),await this.s.p,!m.isDisposed&&(this.D(p,m),this.w(!0))}C(p){this.j.deleteAndDispose(p.correlationId),this.m.delete(p.correlationId),this.w(!1)}D(p,m){this.F(p,m)?(this.P(`reusing an existing recursive watcher to monitor ${p.path}`),this.m.delete(p.correlationId)):(this.G(p,m),this.m.add(p.correlationId))}F(p,m){const f=this.O?.subscribe(p.path,(l,g)=>{m.isDisposed||(l?this.D(p,m):g?.type===T.FileChangeType.ADDED&&this.H(p))});return f?(m.add(f),!0):!1}G(p,m){let f=!1;const l=(g,E)=>{if(m.isDisposed)return;const w=this.I(g),d=this.I(E),P=f;f=w,!w&&(d||P)&&this.H(p)};this.P(`starting fs.watchFile() on ${p.path} (correlationId: ${p.correlationId})`);try{(0,I.watchFile)(p.path,{persistent:!1,interval:this.r},l)}catch(g){this.Q(`fs.watchFile() failed with error ${g} on path ${p.path} (correlationId: ${p.correlationId})`)}m.add((0,a.$Xc)(()=>{this.P(`stopping fs.watchFile() on ${p.path} (correlationId: ${p.correlationId})`);try{(0,I.unwatchFile)(p.path,l)}catch(g){this.Q(`fs.unwatchFile() failed with error ${g} on path ${p.path} (correlationId: ${p.correlationId})`)}}))}H(p){this.P(`detected ${p.path} exists again, resuming watcher (correlationId: ${p.correlationId})`);const m={resource:C.URI.file(p.path),type:T.FileChangeType.ADDED,cId:p.correlationId};this.a.fire([m]),this.J(m,p),this.C(p)}I(p){return p.ctimeMs===0&&p.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(p,m){if(this.R){const f=` >> normalized ${p.type===T.FileChangeType.ADDED?"[ADDED]":p.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${p.resource.fsPath}`;this.L(f,m)}}L(p,m){this.R&&this.P(`${p}${typeof m.correlationId=="number"?` <${m.correlationId}> `:""}`)}M(p){return`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"}, filter: ${(0,N.$jr)(p.filter)}, correlationId: ${typeof p.correlationId=="number"?p.correlationId:"<none>"})`}async setVerboseLogging(p){this.R=p}}e.$sr=b}),define(ue[168],de([0,1,33,6,25,42,2,91,13,5,20,10,151,30,7,46]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0,e.$yr=w;class E extends T.$Zc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(P,$,c,h,i,n){super(),this.s=P,this.t=$,this.u=c,this.w=h,this.y=i,this.z=n,this.c=this.B(new a.$Zh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.u(t))),this.f=this.B(new a.$Yh(t=>this.M(t),E.b)),this.g=(0,g.$hr)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,g.$hr)(this.s.path,this.s.includes):void 0,this.j=(0,g.$_q)(this.s)?this.s.filter:void 0,this.m=new N.$Be,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const P=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const $=await I.promises.stat(P);if(this.m.token.isCancellationRequested)return;this.B(await this.G(P,$.isDirectory()))}catch(P){P.code!=="ENOENT"?this.O(P):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${P})`),this.D()}}D(){this.r=!0,this.w?.()}async F(P){let $=P.path;try{$=await f.Promises.realpath(P.path),P.path===$&&($=await(0,m.$ur)(P.path,this.m.token)??P.path),P.path!==$&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${P.path}, real: ${$})`)}catch{}return $}async G(P,$){const c=new T.$Yc;return this.H(P,$,c)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(P,$,c)),c}H(P,$,c){if($)return!1;const h=p.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(n,t)=>{if(!c.isDisposed)if(n){const s=await this.G(P,$);c.isDisposed?s.dispose():c.add(s)}else t&&(typeof t.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:h,type:t.type,cId:this.s.correlationId},!0)});return i?(c.add(i),!0):!1}async I(P,$,c){if(b.$m&&(0,k.$Jg)(P,"/Volumes/",!0)){this.O(`Refusing to watch ${P} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const h=new N.$Be(this.m.token);c.add((0,T.$Xc)(()=>h.dispose(!0)));const i=new T.$Yc;c.add(i);try{const n=p.URI.file(this.s.path),t=(0,A.$sc)(P),s=(0,I.watch)(P);i.add((0,T.$Xc)(()=>{s.removeAllListeners(),s.close()})),this.Q(`Started watching: '${P}'`);const r=new Set;if($)try{for(const u of await f.Promises.readdir(P))r.add(u)}catch(u){this.O(u)}if(h.token.isCancellationRequested)return;const o=new Map;i.add((0,T.$Xc)(()=>{for(const[,u]of o)u.dispose();o.clear()})),s.on("error",(u,y)=>{h.token.isCancellationRequested||(this.O(`Failed to watch ${P} for changes using fs.watch() (${u}, ${y})`),this.D())}),s.on("change",(u,y)=>{if(h.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${u}"] ${y}`);let O="";if(y&&(O=y.toString(),b.$m&&(O=(0,C.$sm)(O))),!(!O||u!=="change"&&u!=="rename"))if($)if(u==="rename"){o.get(O)?.dispose();const S=setTimeout(async()=>{if(o.delete(O),O===t&&!await f.Promises.exists(P)){this.J(n);return}if(h.token.isCancellationRequested)return;const v=await this.N((0,A.$oc)(P,O));if(h.token.isCancellationRequested)return;let L;v?r.has(O)?L=l.FileChangeType.UPDATED:(L=l.FileChangeType.ADDED,r.add(O)):(r.delete(O),L=l.FileChangeType.DELETED),this.L({resource:(0,R.$lh)(n,O),type:L,cId:this.s.correlationId})},E.a);o.set(O,(0,T.$Xc)(()=>clearTimeout(S)))}else{let S;r.has(O)?S=l.FileChangeType.UPDATED:(S=l.FileChangeType.ADDED,r.add(O)),this.L({resource:(0,R.$lh)(n,O),type:S,cId:this.s.correlationId})}else if(u==="rename"||O!==t){const S=setTimeout(async()=>{const v=await f.Promises.exists(P);h.token.isCancellationRequested||(v?(this.L({resource:n,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(P,!1))):this.J(n))},E.a);i.clear(),i.add((0,T.$Xc)(()=>clearTimeout(S)))}else this.L({resource:n,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(n){h.token.isCancellationRequested||this.O(`Failed to watch ${P} for changes using fs.watch() (${n.toString()})`),this.D()}}J(P){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:P,type:l.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(P,$=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${P.type===l.FileChangeType.ADDED?"[ADDED]":P.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${P.resource.fsPath}`),!$&&this.g.some(c=>c(P.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${P.resource.fsPath}`):!$&&this.h&&this.h.length>0&&!this.h.some(c=>c(P.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${P.resource.fsPath}`):this.f.work(P))}M(P){const $=(0,g.$fr)(P),c=[];for(const i of $){if((0,g.$ir)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}c.push(i)}if(c.length===0)return;if(this.z)for(const i of c)this.R(` >> normalized ${i.type===l.FileChangeType.ADDED?"[ADDED]":i.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(c)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(P){if(b.$n)return f.Promises.exists(P);try{const $=(0,A.$sc)(P);return(await f.Promises.readdir((0,A.$rc)(P))).some(h=>h===$)}catch($){return this.Q($),!1}}setVerboseLogging(P){this.z=P}O(P){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${P}`})}P(P){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${P}`})}Q(P){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${P}`})}R(P){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${P}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$xr=E;async function w(d,P,$,c,h=512){const i=await f.Promises.open(d,"r"),n=Buffer.allocUnsafe(h),t=new N.$Be(c);let s,r=!1;const o={path:d,excludes:[],recursive:!1},u=new E(o,void 0,y=>{(async()=>{for(const{type:O}of y)if(O===l.FileChangeType.UPDATED){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:S}=await f.Promises.read(i,n,0,h,null);if(!S||t.token.isCancellationRequested)break;P(n.slice(0,S))}}catch(S){s=new Error(S),t.dispose(!0)}finally{r=!1}}})()});return await u.ready,$(),new Promise((y,O)=>{t.token.onCancellationRequested(async()=>{u.dispose();try{await f.Promises.close(i)}catch(S){s=new Error(S)}s?O(s):y()})})}}),define(ue[169],de([0,1,3,95,167,5,168,42]),function(ce,e,I,a,N,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class A extends N.$sr{constructor(R){super(),this.O=R,this.onDidError=I.Event.None,this.watchers=new Set}async N(R){R=this.Z(R);const p=[],m=new Set(Array.from(this.watchers));for(const f of R){const l=this.W(f);l&&(0,a.$Jk)(l.request.excludes,f.excludes)&&(0,a.$Jk)(l.request.includes,f.includes)?m.delete(l):p.push(f)}p.length&&this.P(`Request to start watching: ${p.map(f=>this.M(f)).join(",")}`),m.size&&this.P(`Request to stop watching: ${Array.from(m).map(f=>this.M(f.request)).join(",")}`);for(const f of m)this.Y(f);for(const f of p)this.X(f)}W(R){for(const p of this.watchers)if(typeof R.correlationId=="number"||typeof p.request.correlationId=="number"){if(p.request.correlationId===R.correlationId)return p}else if((0,C.$Ig)(p.request.path,R.path,!k.$n))return p}X(R){const p=new T.$xr(R,this.O,f=>this.a.fire(f),()=>this.c.fire(R),f=>this.b.fire(f),this.R),m={request:R,instance:p};this.watchers.add(m)}async stop(){await super.stop();for(const R of this.watchers)this.Y(R)}Y(R){this.P("stopping file watcher",R),this.watchers.delete(R),R.instance.dispose()}Z(R){const p=new Map;for(const m of R){const f=k.$n?m.path:m.path.toLowerCase();let l=p.get(m.correlationId);l||(l=new Map,p.set(m.correlationId,l)),l.has(f)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(m)}`),l.set(f,m)}return Array.from(p.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(R){super.setVerboseLogging(R);for(const p of this.watchers)p.instance.setVerboseLogging(R)}P(R,p){this.R&&this.b.fire({type:"trace",message:this.bb(R,p)})}Q(R){this.b.fire({type:"warn",message:this.bb(R)})}bb(R,p){return p?`[File Watcher (node.js)] ${R} (${this.M(p.request)})`:`[File Watcher (node.js)] ${R}`}}e.$zr=A}),define(ue[170],de([0,1,46,169]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;class N extends I.$cr{constructor(T,C,A){super(T,C,A),this.s()}r(T){return T.add(new a.$zr(void 0))}}e.$Ar=N}),define(ue[171],de([0,1,22,43,97,46]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class T extends k.$dr{constructor(A,b,R){super(A,b,R),this.s()}r(A){const b=A.add(new N.$qr(I.$5g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return A.add(b.onDidProcessExit(({code:R,signal:p})=>this.t(`terminated by itself with code ${R}, signal: ${p} (ETERM)`))),a.ProxyChannel.toService((0,a.$ri)(b.getChannel("watcher")))}}e.$rr=T}),define(ue[77],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=void 0;class I{constructor(...N){this.a=new Map;for(const[k,T]of N)this.set(k,T)}set(N,k){const T=this.a.get(N);return this.a.set(N,k),T}has(N){return this.a.has(N)}get(N){return this.a.get(N)}}e.$Ii=I}),define(ue[172],de([0,1,6,8,2,74,163,4,77,90]),function(ce,e,I,a,N,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=void 0;const R=!1;class p extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class m{constructor(E=new A.$Ii,w=!1,d,P=R){this.i=E,this.j=w,this.k=d,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(C.$Ji,this),this._globalGraph=P?d?._globalGraph??new T.$Dr($=>$):void 0}dispose(){if(!this.f){this.f=!0,(0,N.$Uc)(this.h),this.h.clear();for(const E of this.g)(0,N.$Tc)(E)&&E.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(E,w){this.m();const d=this,P=new class extends m{dispose(){d.h.delete(P),super.dispose()}}(E,this.j,this,this.l);return this.h.add(P),w?.add(P),P}invokeFunction(E,...w){this.m();const d=l.traceInvocation(this.l,E);let P=!1;try{return E({get:c=>{if(P)throw(0,a.$_)("service accessor is only valid during the invocation of its target method");const h=this.s(c,d);if(!h)throw new Error(`[invokeFunction] unknown service '${c}'`);return h}},...w)}finally{P=!0,d.stop()}}createInstance(E,...w){this.m();let d,P;return E instanceof k.$Hi?(d=l.traceCreation(this.l,E.ctor),P=this.o(E.ctor,E.staticArguments.concat(w),d)):(d=l.traceCreation(this.l,E),P=this.o(E,w,d)),d.stop(),P}o(E,w=[],d){const P=C._util.getServiceDependencies(E).sort((h,i)=>h.index-i.index),$=[];for(const h of P){const i=this.s(h.id,d);i||this.y(`[createInstance] ${E.name} depends on UNKNOWN service ${h.id}.`,!1),$.push(i)}const c=P.length>0?P[0].index:w.length;if(w.length!==c){console.trace(`[createInstance] First service dependency of ${E.name} at position ${c+1} conflicts with ${w.length} static arguments`);const h=c-w.length;h>0?w=w.concat(new Array(h)):w=w.slice(0,c)}return Reflect.construct(E,w.concat($))}q(E,w){if(this.i.get(E)instanceof k.$Hi)this.i.set(E,w);else if(this.k)this.k.q(E,w);else throw new Error("illegalState - setting UNKNOWN service instance")}r(E){const w=this.i.get(E);return!w&&this.k?this.k.r(E):w}s(E,w){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const d=this.r(E);return d instanceof k.$Hi?this.u(E,d,w.branch(E,!0)):(w.branch(E,!1),d)}u(E,w,d){if(this.t.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.t.add(E);try{return this.v(E,w,d)}finally{this.t.delete(E)}}v(E,w,d){const P=new T.$Dr(i=>i.id.toString());let $=0;const c=[{id:E,desc:w,_trace:d}],h=new Set;for(;c.length;){const i=c.pop();if(!h.has(String(i.id))){if(h.add(String(i.id)),P.lookupOrInsertNode(i),$++>1e3)throw new p(P);for(const n of C._util.getServiceDependencies(i.desc.ctor)){const t=this.r(n.id);if(t||this.y(`[createInstance] ${E} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof k.$Hi){const s={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};P.insertEdge(i,s),c.push(s)}}}}for(;;){const i=P.roots();if(i.length===0){if(!P.isEmpty())throw new p(P);break}for(const{data:n}of i){if(this.r(n.id)instanceof k.$Hi){const s=this.w(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.q(n.id,s)}P.removeNode(n)}}return this.r(E)}w(E,w,d=[],P,$){if(this.i.get(E)instanceof k.$Hi)return this.x(E,w,d,P,$,this.g);if(this.k)return this.k.w(E,w,d,P,$);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}x(E,w,d=[],P,$,c){if(P){const h=new m(void 0,this.j,this,this.l);h.c=String(E);const i=new Map,n=new I.$4h(()=>{const t=h.o(w,d,$);for(const[s,r]of i){const o=t[s];if(typeof o=="function")for(const u of r)u.disposable=o.apply(t,u.listener)}return i.clear(),c.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!n.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let u=i.get(s);return u||(u=new b.$0c,i.set(s,u)),(O,S,v)=>{if(n.isInitialized)return n.value[s](O,S,v);{const L={listener:[O,S,v],disposable:void 0},j=u.push(L);return(0,N.$Xc)(()=>{j(),L.disposable?.dispose()})}}}if(s in t)return t[s];const r=n.value;let o=r[s];return typeof o!="function"||(o=o.bind(r),t[s]=o),o},set(t,s,r){return n.value[s]=r,!0},getPrototypeOf(t){return w.prototype}})}else{const h=this.o(w,d,$);return c.add(h),h}}y(E,w){if(w&&console.warn(E),this.j)throw new Error(E)}}e.$Er=m;var f;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(f||(f={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super(f.None,null)}stop(){}branch(){return this}}}static traceInvocation(E,w){return E?new l(f.Invocation,w.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(E,w){return E?new l(f.Creation,w.name):l.c}static{this.f=0}constructor(E,w){this.type=E,this.name=w,this.g=Date.now(),this.h=[]}branch(E,w){const d=new l(f.Branch,E.toString());return this.h.push([E,w,d]),d}stop(){const E=Date.now()-this.g;l.f+=E;let w=!1;function d($,c){const h=[],i=new Array($+1).join("	");for(const[n,t,s]of c.h)if(t&&s){w=!0,h.push(`${i}CREATES -> ${n}`);const r=d($+1,s);r&&h.push(r)}else h.push(`${i}uses -> ${n}`);return h.join(`
`)}const P=[`${this.type===f.Creation?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(E>2||w)&&l.all.add(P.join(`
`))}}e.$Fr=l}),define(ue[56],de([0,1,4]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=e.$hjc=void 0,e.$hjc=(0,I.$Ki)("mainProcessService");class a{constructor(k,T){this.a=k,this.b=T}getChannel(k){return this.a.getChannel(k,this.b)}registerChannel(k,T){this.a.registerChannel(k,T)}}e.$ijc=a}),define(ue[11],de([0,1,9,41,3,55,2,31,5,20,12,10,98,4]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$ik=e.LogLevel=e.$gk=e.$fk=void 0,e.$hk=g,e.log=w,e.$tk=o,e.$uk=u,e.$vk=y,e.$wk=O,I=Oe(I),e.$fk=(0,f.$Ki)("logService"),e.$gk=(0,f.$Ki)("loggerService");function l(){return new Date().toISOString()}function g(S){return(0,R.$ng)(S)}var E;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(E||(e.LogLevel=E={})),e.$ik=E.Info;function w(S,v,L){switch(v){case E.Trace:S.trace(L);break;case E.Debug:S.debug(L);break;case E.Info:S.info(L);break;case E.Warning:S.warn(L);break;case E.Error:S.error(L);break;case E.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function d(S,v=!1){let L="";for(let j=0;j<S.length;j++){let U=S[j];if(U instanceof Error&&(U=(0,a.$vj)(U,v)),typeof U=="object")try{U=JSON.stringify(U)}catch{}L+=(j>0?" ":"")+U}return L}class P extends T.$Zc{constructor(){super(...arguments),this.b=e.$ik,this.c=this.B(new N.$qe),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==E.Off&&this.b<=v}}e.$kk=P;class $ extends P{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...L){this.f(E.Trace)&&this.g(E.Trace,d([v,...L],!0))}debug(v,...L){this.f(E.Debug)&&this.g(E.Debug,d([v,...L]))}info(v,...L){this.f(E.Info)&&this.g(E.Info,d([v,...L]))}warn(v,...L){this.f(E.Warning)&&this.g(E.Warning,d([v,...L]))}error(v,...L){if(this.f(E.Error))if(v instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=v.stack,this.g(E.Error,d(j))}else this.g(E.Error,d([v,...L]))}flush(){}}e.$lk=$;class c extends P{constructor(v=e.$ik){super(),this.setLevel(v),this.g=!A.$l}trace(v,...L){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...L):console.log(`[main ${l()}]`,v,...L))}debug(v,...L){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...L):console.log(`[main ${l()}]`,v,...L))}info(v,...L){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...L):console.log(`[main ${l()}]`,v,...L))}warn(v,...L){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,v,...L):console.warn(`[main ${l()}]`,v,...L))}error(v,...L){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,v,...L):console.error(`[main ${l()}]`,v,...L))}flush(){}}e.$mk=c;class h extends P{constructor(v=e.$ik,L=!0){super(),this.g=L,this.setLevel(v)}trace(v,...L){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...L):console.log(v,...L))}debug(v,...L){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...L):console.log(v,...L))}info(v,...L){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...L):console.log(v,...L))}warn(v,...L){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...L):console.log(v,...L))}error(v,...L){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...L):console.error(v,...L))}flush(){}}e.$nk=h;class i extends P{constructor(v,L=e.$ik){super(),this.g=v,this.setLevel(L)}trace(v,...L){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(v),...L])}debug(v,...L){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(v),...L])}info(v,...L){this.f(E.Info)&&this.g.log(E.Info,[this.h(v),...L])}warn(v,...L){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(v),...L])}error(v,...L){this.f(E.Error)&&this.g.log(E.Error,[this.h(v),...L])}h(v){return typeof v=="string"?v:(0,a.$vj)(v,this.f(E.Trace))}flush(){}}e.$ok=i;class n extends P{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const L of this.g)L.setLevel(v);super.setLevel(v)}trace(v,...L){for(const j of this.g)j.trace(v,...L)}debug(v,...L){for(const j of this.g)j.debug(v,...L)}info(v,...L){for(const j of this.g)j.info(v,...L)}warn(v,...L){for(const j of this.g)j.warn(v,...L)}error(v,...L){for(const j of this.g)j.error(v,...L)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$pk=n;class t extends T.$Zc{constructor(v,L,j){if(super(),this.h=v,this.j=L,this.b=new C.$Fc,this.c=this.B(new N.$qe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$qe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$qe),this.onDidChangeVisibility=this.g.event,j)for(const U of j)this.b.set(U.resource,{logger:void 0,info:U})}m(v){return(0,R.$jg)(v)?[...this.b.values()].find(L=>L.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,L){const j=this.n(v),U=(0,R.$jg)(v)?v:L?.id??(0,k.$yj)(j.toString()).toString(16);let F=this.b.get(j)?.logger;const G=L?.logLevel==="always"?E.Trace:L?.logLevel;F||(F=this.s(j,G??this.getLogLevel(j)??this.h,{...L,id:U}));const V={logger:F,info:{resource:j,id:U,logLevel:G,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(V.info),this.b.set(j,V),F}n(v){return(0,R.$jg)(v)?(0,b.$lh)(this.j,`${v}.log`):v}setLogLevel(v,L){if(p.URI.isUri(v)){const j=v,U=L,F=this.b.get(j);F&&U!==F.info.logLevel&&(F.info.logLevel=U===this.h?void 0:U,F.logger?.setLevel(U),this.b.set(F.info.resource,F),this.f.fire([j,U]))}else{this.h=v;for(const[j,U]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,L){const j=this.m(v);j&&L!==!j.info.hidden&&(j.info.hidden=!L,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,L]))}getLogLevel(v){let L;return v&&(L=this.b.get(v)?.info.logLevel),L??this.h}registerLogger(v){const L=this.b.get(v.resource);L?L.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const L=this.b.get(v);L&&(L.logger&&L.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$qk=t;class s{constructor(){this.onDidChangeLogLevel=new N.$qe().event}setLevel(v){}getLevel(){return E.Info}trace(v,...L){}debug(v,...L){}info(v,...L){}warn(v,...L){}error(v,...L){}critical(v,...L){}dispose(){}flush(){}}e.$rk=s;class r extends s{}e.$sk=r;function o(S){if(S.verbose)return E.Trace;if(typeof S.logLevel=="string"){const v=O(S.logLevel.toLowerCase());if(v!==void 0)return v}return e.$ik}function u(S){switch(S){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}function y(S){switch(S){case E.Trace:return{original:"Trace",value:I.localize(1959,null)};case E.Debug:return{original:"Debug",value:I.localize(1960,null)};case E.Info:return{original:"Info",value:I.localize(1961,null)};case E.Warning:return{original:"Warning",value:I.localize(1962,null)};case E.Error:return{original:"Error",value:I.localize(1963,null)};case E.Off:return{original:"Off",value:I.localize(1964,null)}}}function O(S){switch(S){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.$xk=new m.$2j("logLevel",u(E.Info))}),define(ue[173],de([0,1,6,8,2,22,13,20,30,15,11]),function(ce,e,I,a,N,k,T,C,A,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=void 0;let p=class extends N.$Zc{constructor(f,l){super(),this.a=f,this.b=l,this.B(new I.$Wh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const f=(0,C.$ih)(this.a.logsHome),l=(0,C.$kh)(this.a.logsHome.with({scheme:k.Schemas.file})).fsPath,w=(await A.Promises.readdir(l)).filter(P=>/^\d{8}T\d{6}$/.test(P)).sort().filter(P=>P!==f),d=w.slice(0,Math.max(0,w.length-9));d.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(P=>A.Promises.rm((0,T.$oc)(l,P)))))}catch(f){(0,a.$4)(f)}}};e.$Bjc=p,e.$Bjc=p=Ee([Z(0,b.$Ri),Z(1,R.$fk)],p)}),define(ue[174],de([0,1,17,6,8,3,42,2,13,46,11]),function(ce,e,I,a,N,k,T,C,A,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class p extends C.$Zc{constructor(f,l){super(),this.a=f,this.b=l,this.c=this.B(new k.$qe),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$qe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new a.$Ih(0)),this.w=[],this.y=this.B(new a.$Ih(0))}watch(f,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(f,l):this.z(f,l)}n(f,l){const g={path:this.J(f),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},E=(0,I.$Xb)(this.j,g);return this.r(),(0,C.$Xc)(()=>{E(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(f=>(0,N.$4)(f))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,b.$er)(l)),l=>this.G(l),this.a.getLevel()===R.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===R.LogLevel.Trace)})));const f=this.b?.watcher?.recursive?.usePolling;if(f===!0)for(const l of this.j)(0,b.$ar)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const l of this.j)(0,b.$ar)(l)&&f.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(f,l){const g={path:this.J(f),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},E=(0,I.$Xb)(this.w,g);return this.C(),(0,C.$Xc)(()=>{E(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(f=>(0,N.$4)(f))}D(){return this.u||(this.u=this.B(this.F(f=>this.c.fire((0,b.$er)(f)),f=>this.G(f),this.a.getLevel()===R.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===R.LogLevel.Trace)}))),this.u.watch(this.w)}G(f){f.type==="error"&&this.g.fire(f.message),this.H(f)}H(f){this.a[f.type](f.message)}I(f){return(0,A.$mc)(f.fsPath)}J(f){const l=this.I(f);return(0,T.$Mg)(l)}}e.$kr=p}),define(ue[175],de([0,1,17,6,14,25,3,55,63,2,51,22,102,20,50,9,7,101,11,8]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;let c=class extends b.$Zc{static{$=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new T.$qe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$qe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$qe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$qe),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$qe),this.Y=this.B(new T.$qe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$qe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new a.$Th)}registerProvider(i,n){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${i}`);const t=new b.$Yc;return this.h.set(i,n),this.c.fire({added:!0,scheme:i,provider:n}),t.add(n.onDidChangeFile(s=>{const r=new E.$yl(s,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&t.add(n.onDidWatchError(s=>this.Z.fire(new Error(s)))),t.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:i}))),(0,b.$Xc)(()=>{this.c.fire({added:!1,scheme:i,provider:n}),this.h.delete(i),(0,b.$Uc)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const n=[];this.f.fire({scheme:i,join(t){n.push(t)}}),!this.h.has(i)&&await a.Promises.settled(n)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,n){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&n)}listCapabilities(){return A.Iterable.map(this.h,([i,n])=>({scheme:i,capabilities:n.capabilities}))}async j(i){if(!(0,f.$ph)(i))throw new E.$Al((0,g.localize)(1871,null,this.sb(i)),E.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const n=this.h.get(i.scheme);if(!n){const t=new P.$fb;throw t.message=(0,g.localize)(1872,null,i.toString()),t}return n}async m(i){const n=await this.j(i);if((0,E.$ll)(n)||(0,E.$il)(n)||(0,E.$ml)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const n=await this.j(i);if((0,E.$ll)(n)||(0,E.$il)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,n){try{return await this.s(i,n)}catch(t){throw(0,E.$vl)(t)===E.FileSystemProviderErrorCode.FileNotFound?new E.$Al((0,g.localize)(1873,null,this.sb(i)),E.FileOperationResult.FILE_NOT_FOUND):(0,E.$tl)(t)}}async s(i,n){const t=await this.j(i),s=this.S(t),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,u=n?.resolveMetadata,y=await t.stat(i);let O;return this.t(t,i,y,void 0,!!u,(S,v)=>(O||(O=R.$Qi.forUris(()=>!s),O.set(i,!0),r&&O.fill(!0,r)),O.get(S.resource)||O.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&o?v===1:!1))}async t(i,n,t,s,r,o){const{providerExtUri:u}=this.R(i),y={resource:n,name:u.basename(n),isFile:(t.type&E.FileType.File)!==0,isDirectory:(t.type&E.FileType.Directory)!==0,isSymbolicLink:(t.type&E.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&E.FilePermission.Readonly)||!!(i.capabilities&E.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&E.FilePermission.Locked),etag:(0,E.$Ll)({mtime:t.mtime,size:t.size}),children:void 0};if(y.isDirectory&&o(y,s)){try{const O=await i.readdir(n),S=await a.Promises.settled(O.map(async([v,L])=>{try{const j=u.joinPath(n,v),U=r?await i.stat(j):{type:L};return await this.t(i,j,U,O.length,r,o)}catch(j){return this.b.trace(j),null}}));y.children=(0,I.$Lb)(S)}catch(O){this.b.trace(O),y.children=[]}return y}return y}async resolveAll(i){return a.Promises.settled(i.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const n=await this.j(i),t=await n.stat(i);return this.t(n,i,t,void 0,!0,()=>!1)}async exists(i){const n=await this.j(i);try{return!!await n.stat(i)}catch{return!1}}async canCreateFile(i,n){try{await this.u(i,n)}catch(t){return t}return!0}async u(i,n){if(!n?.overwrite&&await this.exists(i))throw new E.$Al((0,g.localize)(1874,null,this.sb(i)),E.FileOperationResult.FILE_MODIFIED_SINCE,n)}async createFile(i,n=N.$Se.fromString(""),t){await this.u(i,t);const s=await this.writeFile(i,n);return this.r.fire(new E.$xl(i,E.FileOperation.CREATE,s)),s}async writeFile(i,n,t){const s=this.qb(await this.n(i),i),{providerExtUri:r}=this.R(s);let o=t;if((0,E.$ol)(s)&&!o?.atomic){const u=s.enforceAtomicWriteFile?.(i);u&&(o={...t,atomic:u})}try{await this.w(s,i,o)||await this.U(s,r.dirname(i));let y;if((0,E.$il)(s)&&!(n instanceof N.$Se))if((0,l.$Ee)(n)){const O=await(0,l.$Le)(n,3);O.ended?y=N.$Se.concat(O.buffer):y=O}else y=(0,l.$Ie)(n,O=>N.$Se.concat(O),3);else y=n;!(0,E.$ll)(s)||(0,E.$il)(s)&&y instanceof N.$Se||(0,E.$il)(s)&&(0,E.$ol)(s)&&o?.atomic?await this.hb(s,i,o,y):await this.db(s,i,o,y instanceof N.$Se?(0,N.$4e)(y):y),this.r.fire(new E.$xl(i,E.FileOperation.WRITE))}catch(u){throw new E.$Al((0,g.localize)(1875,null,this.sb(i),(0,E.$tl)(u).toString()),(0,E.$wl)(u),o)}return this.resolve(i,{resolveMetadata:!0})}async w(i,n,t){const s=!!t?.unlock;if(s&&!(i.capabilities&E.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,g.localize)(1876,null,this.sb(n)));if(!!t?.atomic){if(!(i.capabilities&E.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,g.localize)(1877,null,this.sb(n)));if(!(i.capabilities&E.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,g.localize)(1878,null,this.sb(n)));if(s)throw new Error((0,g.localize)(1879,null,this.sb(n)))}let o;try{o=await i.stat(n)}catch{return}if(o.type&E.FileType.Directory)throw new E.$Al((0,g.localize)(1880,null,this.sb(n)),E.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(n,o),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==E.$Kl&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,E.$Ll)({mtime:t.mtime,size:o.size}))throw new E.$Al((0,g.localize)(1881,null),E.FileOperationResult.FILE_MODIFIED_SINCE,t);return o}async readFile(i,n,t){const s=await this.m(i);return n?.atomic?this.z(s,i,n,t):this.C(s,i,n,t)}async z(i,n,t,s){return new Promise((r,o)=>{this.cb.queueFor(n,async()=>{try{const u=await this.C(i,n,t,s);r(u)}catch(u){o(u)}},this.R(i).providerExtUri)})}async C(i,n,t,s){const r=await this.D(i,n,{...t,preferUnbuffered:!0},s);return{...r,value:await(0,N.$5e)(r.value)}}async readFileStream(i,n,t){const s=await this.m(i);return this.D(s,i,n,t)}async D(i,n,t,s){const r=new k.$Be(s);let o=t;(0,E.$nl)(i)&&i.enforceAtomicReadFile?.(n)&&(o={...t,atomic:!0});const u=this.J(n,o).then(O=>O,O=>{throw r.dispose(!0),O});let y;try{return typeof o?.etag=="string"&&o.etag!==E.$Kl&&await u,o?.atomic&&(0,E.$nl)(i)||!((0,E.$ll)(i)||(0,E.$ml)(i))||(0,E.$il)(i)&&o?.preferUnbuffered?y=this.I(i,n,o):(0,E.$ml)(i)?y=this.G(i,n,r.token,o):y=this.H(i,n,r.token,o),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await u,value:y}}catch(O){throw y&&await(0,l.$Je)(y),this.F(O,n,o)}}F(i,n,t){const s=(0,g.localize)(1882,null,this.sb(n),(0,E.$tl)(i).toString());return i instanceof E.$Cl?new E.$Cl(s,i.stat,t):i instanceof E.$Bl?new E.$Bl(s,i.fileOperationResult,i.size,i.options):new E.$Al(s,(0,E.$wl)(i),t)}G(i,n,t,s=Object.create(null)){const r=i.readFileStream(n,s,t);return(0,l.$Pe)(r,{data:o=>o instanceof N.$Se?o:N.$Se.wrap(o),error:o=>this.F(o,n,s)},o=>N.$Se.concat(o))}H(i,n,t,s=Object.create(null)){const r=(0,N.$9e)();return(0,w.$0q)(i,n,r,o=>o,{...s,bufferSize:this.a,errorTransformer:o=>this.F(o,n,s)},t),r}I(i,n,t){const s=(0,l.$Ge)(r=>N.$Se.concat(r));return(async()=>{try{let r;t?.atomic&&(0,E.$nl)(i)?r=await i.readFile(n,{atomic:!0}):r=await i.readFile(n),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.L(n,r.byteLength,t),s.end(N.$Se.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async J(i,n){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new E.$Al((0,g.localize)(1883,null,this.sb(i)),E.FileOperationResult.FILE_IS_DIRECTORY,n);if(typeof n?.etag=="string"&&n.etag!==E.$Kl&&n.etag===t.etag)throw new E.$Cl((0,g.localize)(1884,null),t,n);return this.L(i,t.size,n),t}L(i,n,t){if(typeof t?.limits?.size=="number"&&n>t.limits.size)throw new E.$Bl((0,g.localize)(1885,null,this.sb(i)),E.FileOperationResult.FILE_TOO_LARGE,n,t)}async canMove(i,n,t){return this.M(i,n,"move",t)}async canCopy(i,n,t){return this.M(i,n,"copy",t)}async M(i,n,t,s){if(i.toString()!==n.toString())try{const r=t==="move"?this.qb(await this.n(i),i):await this.m(i),o=this.qb(await this.n(n),n);await this.Q(r,i,o,n,t,s)}catch(r){return r}return!0}async move(i,n,t){const s=this.qb(await this.n(i),i),r=this.qb(await this.n(n),n),o=await this.N(s,i,r,n,"move",!!t),u=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$xl(i,o==="move"?E.FileOperation.MOVE:E.FileOperation.COPY,u)),u}async copy(i,n,t){const s=await this.m(i),r=this.qb(await this.n(n),n),o=await this.N(s,i,r,n,"copy",!!t),u=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$xl(i,o==="copy"?E.FileOperation.COPY:E.FileOperation.MOVE,u)),u}async N(i,n,t,s,r,o){if(n.toString()===s.toString())return r;const{exists:u,isSameResourceWithDifferentPathCase:y}=await this.Q(i,n,t,s,r,o);if(u&&!y&&o&&await this.del(s,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(s)),r==="copy"){if(i===t&&(0,E.$jl)(i))await i.copy(n,s,{overwrite:o});else{const O=await this.resolve(n);O.isDirectory?await this.P(i,O,t,s):await this.O(i,n,t,s)}return r}else return i===t?(await i.rename(n,s,{overwrite:o}),r):(await this.N(i,n,t,s,"copy",o),await this.del(n,{recursive:!0}),"copy")}async O(i,n,t,s){if((0,E.$ll)(i)&&(0,E.$ll)(t))return this.jb(i,n,t,s);if((0,E.$ll)(i)&&(0,E.$il)(t))return this.pb(i,n,t,s);if((0,E.$il)(i)&&(0,E.$ll)(t))return this.nb(i,n,t,s);if((0,E.$il)(i)&&(0,E.$il)(t))return this.lb(i,n,t,s)}async P(i,n,t,s){await t.mkdir(s),Array.isArray(n.children)&&await a.Promises.settled(n.children.map(async r=>{const o=this.R(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.P(i,await this.resolve(r.resource),t,o):this.O(i,r.resource,t,o)}))}async Q(i,n,t,s,r,o){let u=!1;if(i===t){const{providerExtUri:O,isPathCaseSensitive:S}=this.R(i);if(S||(u=O.isEqual(n,s)),u&&r==="copy")throw new Error((0,g.localize)(1886,null,this.sb(n),this.sb(s)));if(!u&&O.isEqualOrParent(s,n))throw new Error((0,g.localize)(1887,null,this.sb(n),this.sb(s)))}const y=await this.exists(s);if(y&&!u){if(!o)throw new E.$Al((0,g.localize)(1888,null,this.sb(n),this.sb(s)),E.FileOperationResult.FILE_MOVE_CONFLICT);if(i===t){const{providerExtUri:O}=this.R(i);if(O.isEqualOrParent(n,s))throw new Error((0,g.localize)(1889,null,this.sb(n),this.sb(s)))}}return{exists:y,isSameResourceWithDifferentPathCase:u}}R(i){const n=this.S(i);return{providerExtUri:n?f.$bh:f.$dh,isPathCaseSensitive:n}}S(i){return!!(i.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const n=this.qb(await this.j(i),i);await this.U(n,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new E.$xl(i,E.FileOperation.CREATE,t)),t}async U(i,n){const t=[],{providerExtUri:s}=this.R(i);for(;!s.isEqual(n,s.dirname(n));)try{if(!((await i.stat(n)).type&E.FileType.Directory))throw new Error((0,g.localize)(1890,null,this.sb(n)));break}catch(r){if((0,E.$vl)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(n)),n=s.dirname(n)}for(let r=t.length-1;r>=0;r--){n=s.joinPath(n,t[r]);try{await i.mkdir(n)}catch(o){if((0,E.$vl)(o)!==E.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(i,n){try{await this.W(i,n)}catch(t){return t}return!0}async W(i,n){const t=this.qb(await this.j(i),i),s=!!n?.useTrash;if(s&&!(t.capabilities&E.FileSystemProviderCapabilities.Trash))throw new Error((0,g.localize)(1891,null,this.sb(i)));const r=n?.atomic;if(r&&!(t.capabilities&E.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,g.localize)(1892,null,this.sb(i)));if(s&&r)throw new Error((0,g.localize)(1893,null,this.sb(i)));let o;try{o=await t.stat(i)}catch{}if(o)this.rb(i,o);else throw new E.$Al((0,g.localize)(1894,null,this.sb(i)),E.FileOperationResult.FILE_NOT_FOUND);if(!!!n?.recursive){const y=await this.resolve(i);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,g.localize)(1895,null,this.sb(i)))}return t}async del(i,n){const t=await this.W(i,n);let s=n;if((0,E.$pl)(t)&&!s?.atomic){const y=t.enforceAtomicDelete?.(i);y&&(s={...n,atomic:y})}const r=!!s?.useTrash,o=!!s?.recursive,u=s?.atomic??!1;await t.delete(i,{recursive:o,useTrash:r,atomic:u}),this.r.fire(new E.$xl(i,E.FileOperation.DELETE))}async cloneFile(i,n){const t=await this.j(i),s=this.qb(await this.n(n),n);if(!(t===s&&this.R(t).providerExtUri.isEqual(i,n)))return t===s&&(0,E.$kl)(t)?t.cloneFile(i,n):(await this.U(s,this.R(s).providerExtUri.dirname(n)),t===s&&(0,E.$jl)(t)?this.cb.queueFor(i,()=>t.copy(i,n,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(i,()=>this.O(t,i,s,n),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(i,n){return this.watch(i,{...n,correlationId:$.ab++})}watch(i,n={recursive:!1,excludes:[]}){const t=new b.$Yc;let s=!1,r=()=>{s=!0};t.add((0,b.$Xc)(()=>r())),(async()=>{try{const u=await this.bb(i,n);s?(0,b.$Uc)(u):r=()=>(0,b.$Uc)(u)}catch(u){this.b.error(u)}})();const o=n.correlationId;if(typeof o=="number"){const u=t.add(new T.$qe);return t.add(this.X.event(O=>{O.correlates(o)&&u.fire(O)})),{onDidChange:u.event,dispose:()=>t.dispose()}}return t}async bb(i,n){const t=await this.j(i),s=(0,C.$yj)([this.R(t).providerExtUri.getComparisonKey(i),n]);let r=this.$.get(s);return r||(r={count:0,disposable:t.watch(i,n)},this.$.set(s,r)),r.count+=1,(0,b.$Xc)(()=>{r&&(r.count--,r.count===0&&((0,b.$Uc)(r.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,b.$Uc)(i.disposable);this.$.clear()}async db(i,n,t,s){return this.cb.queueFor(n,async()=>{const r=await i.open(n,{create:!0,unlock:t?.unlock??!1});try{(0,l.$Ee)(s)||(0,l.$Fe)(s)?await this.eb(i,r,s):await this.fb(i,r,s)}catch(o){throw(0,E.$tl)(o)}finally{await i.close(r)}},this.R(i).providerExtUri)}async eb(i,n,t){let s=0,r;if((0,l.$Fe)(t)){if(t.buffer.length>0){const o=N.$Se.concat(t.buffer);await this.gb(i,n,o,o.byteLength,s,0),s+=o.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((o,u)=>{(0,l.$Ke)(r,{onData:async y=>{r.pause();try{await this.gb(i,n,y,y.byteLength,s,0)}catch(O){return u(O)}s+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>u(y),onEnd:()=>o()})})}async fb(i,n,t){let s=0,r;for(;(r=t.read())!==null;)await this.gb(i,n,r,r.byteLength,s,0),s+=r.byteLength}async gb(i,n,t,s,r,o){let u=0;for(;u<s;){const y=await i.write(n,r+u,t.buffer,o+u,s-u);u+=y}}async hb(i,n,t,s){return this.cb.queueFor(n,()=>this.ib(i,n,t,s),this.R(i).providerExtUri)}async ib(i,n,t,s){let r;s instanceof N.$Se?r=s:(0,l.$Ee)(s)?r=await(0,N.$5e)(s):(0,l.$Fe)(s)?r=await(0,N.$6e)(s):r=(0,N.$3e)(s),await i.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(i,n,t,s){return this.cb.queueFor(s,()=>this.kb(i,n,t,s),this.R(t).providerExtUri)}async kb(i,n,t,s){let r,o;try{r=await i.open(n,{create:!1}),o=await t.open(s,{create:!0,unlock:!1});const u=N.$Se.alloc(this.a);let y=0,O=0,S=0;do S=await i.read(r,y,u.buffer,O,u.byteLength-O),await this.gb(t,o,u,S,y,O),y+=S,O+=S,O===u.byteLength&&(O=0);while(S>0)}catch(u){throw(0,E.$tl)(u)}finally{await a.Promises.settled([typeof r=="number"?i.close(r):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async lb(i,n,t,s){return this.cb.queueFor(s,()=>this.mb(i,n,t,s),this.R(t).providerExtUri)}async mb(i,n,t,s){return t.writeFile(s,await i.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,n,t,s){return this.cb.queueFor(s,()=>this.ob(i,n,t,s),this.R(t).providerExtUri)}async ob(i,n,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const o=await i.readFile(n);await this.gb(t,r,N.$Se.wrap(o),o.byteLength,0,0)}catch(o){throw(0,E.$tl)(o)}finally{await t.close(r)}}async pb(i,n,t,s){const r=await(0,N.$5e)(this.H(i,n,k.CancellationToken.None));await this.hb(t,s,void 0,r)}qb(i,n){if(i.capabilities&E.FileSystemProviderCapabilities.Readonly)throw new E.$Al((0,g.localize)(1896,null,this.sb(n)),E.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,n){if((n.permissions??0)&E.FilePermission.Readonly)throw new E.$Al((0,g.localize)(1897,null,this.sb(i)),E.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===p.Schemas.file?i.fsPath:i.toString(!0)}};e.$$q=c,e.$$q=c=$=Ee([Z(0,d.$fk)],c)}),define(ue[176],de([0,1,33,6,31,14,3,42,2,13,5,20,50,30,9,7,101,174,171,170]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;class $ extends w.$kr{static{this.L=!1}constructor(h,i){super(h,i),this.onDidChangeCapabilities=T.Event.None,this.P=new N.$Fc(n=>p.$ch.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=g.FileSystemProviderCapabilities.FileReadWrite|g.FileSystemProviderCapabilities.FileOpenReadWriteClose|g.FileSystemProviderCapabilities.FileReadStream|g.FileSystemProviderCapabilities.FileFolderCopy|g.FileSystemProviderCapabilities.FileWriteUnlock|g.FileSystemProviderCapabilities.FileAtomicRead|g.FileSystemProviderCapabilities.FileAtomicWrite|g.FileSystemProviderCapabilities.FileAtomicDelete|g.FileSystemProviderCapabilities.FileClone,R.$n&&(this.M|=g.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(h){try{const{stat:i,symbolicLink:n}=await f.SymlinkSupport.stat(this.I(h));return{type:this.O(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const i=await f.Promises.readdir(this.I(h),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,p.$lh)(h,t.name))).type:s=this.O(t),n.push([t.name,s])}catch(s){this.a.trace(s)}})),n}catch(i){throw this.hb(i)}}O(h,i){let n;return i?.dangling?n=g.FileType.Unknown:h.isFile()?n=g.FileType.File:h.isDirectory()?n=g.FileType.Directory:n=g.FileType.Unknown,i&&(n|=g.FileType.SymbolicLink),n}async Q(h){const i=this.I(h);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.P.get(h);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const t=new a.$Jh;return this.P.set(h,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,A.$Xc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(h)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(h)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),t.open()})}async readFile(h,i){let n;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(h)})`),n=await this.Q(h));const t=this.I(h);return await I.promises.readFile(t)}catch(t){throw this.hb(t)}finally{n?.dispose()}}R(h){$.L&&this.a.trace(h)}readFileStream(h,i,n){const t=(0,m.$Ge)(s=>k.$Se.concat(s.map(r=>k.$Se.wrap(r))).buffer);return(0,E.$0q)(this,h,t,s=>s.buffer,{...i,bufferSize:256*1024},n),t}async writeFile(h,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(h)?this.U(h,(0,p.$lh)((0,p.$kh)(h),`${(0,p.$ih)(h)}${n.atomic.postfix}`),i,n):this.W(h,i,n)}async S(h){try{const i=this.I(h),{symbolicLink:n}=await f.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async U(h,i,n,t){const s=new A.$Yc;try{s.add(await this.Q(h)),s.add(await this.Q(i)),await this.W(i,n,t,!0);try{await this.rename(i,h,{overwrite:!0})}catch(r){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}finally{s.dispose()}}async W(h,i,n,t){let s;try{const r=this.I(h);if(!n.create||!n.overwrite){if(await f.Promises.exists(r)){if(!n.overwrite)throw(0,g.$sl)((0,l.localize)(1901,null),g.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,g.$sl)((0,l.localize)(1902,null),g.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(h,{create:!0,unlock:n.unlock},t),await this.write(s,0,i,0,i.byteLength)}catch(r){throw await this.ib(h,r)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(h){$.$=h}async open(h,i,n){const t=this.I(h);let s;(0,g.$gl)(i)&&!n&&(s=await this.Q(h));let r;try{if((0,g.$gl)(i)&&i.unlock)try{const{stat:u}=await f.SymlinkSupport.stat(t);u.mode&128||await I.promises.chmod(t,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let o;if((0,g.$gl)(i)){if(R.$l)try{await I.promises.truncate(t,0),o="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}o||(o="w")}else o="r";r=await f.Promises.open(t,o)}catch(o){throw s?.dispose(),(0,g.$gl)(i)?await this.ib(h,o):this.hb(o)}if(this.X.set(r,0),(0,g.$gl)(i)&&this.Z.set(r,h),s){const o=this.Y.get(r);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${t})`),this.Y.set(r,s),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${t})`),o.dispose())}return r}async close(h){const i=this.Y.get(h);try{if(this.X.delete(h),this.Z.delete(h)&&$.$)try{await f.Promises.fdatasync(h)}catch(n){$.configureFlushOnWrite(!1),this.a.error(n)}return await f.Promises.close(h)}catch(n){throw this.hb(n)}finally{i&&(this.Y.get(h)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.Y.delete(h)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),i.dispose())}}async read(h,i,n,t,s){const r=this.ab(h,i);let o=null;try{o=(await f.Promises.read(h,n,t,s,r)).bytesRead}catch(u){throw this.hb(u)}finally{this.bb(h,r,o)}return o}ab(h,i){return i===this.X.get(h)?null:i}bb(h,i,n){const t=this.X.get(h);typeof t=="number"&&(typeof i=="number"||(typeof n=="number"?this.X.set(h,t+n):this.X.delete(h)))}async write(h,i,n,t,s){return(0,a.$5h)(()=>this.cb(h,i,n,t,s),100,3)}async cb(h,i,n,t,s){const r=this.ab(h,i);let o=null;try{o=(await f.Promises.write(h,n,t,s,r)).bytesWritten}catch(u){throw await this.ib(this.Z.get(h),u)}finally{this.bb(h,r,o)}return o}async mkdir(h){try{await I.promises.mkdir(this.I(h))}catch(i){throw this.hb(i)}}async delete(h,i){try{const n=this.I(h);if(i.recursive){let t;i?.atomic!==!1&&i.atomic.postfix&&(t=(0,b.$oc)((0,b.$rc)(n),`${(0,b.$sc)(n)}${i.atomic.postfix}`)),await f.Promises.rm(n,f.RimRafMode.MOVE,t)}else try{await I.promises.unlink(n)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:r,symbolicLink:o}=await f.SymlinkSupport.stat(n);s=r.isDirectory()&&!o}catch{}if(s)await I.promises.rmdir(n);else throw t}else throw t}}catch(n){throw this.hb(n)}}async rename(h,i,n){const t=this.I(h),s=this.I(i);if(t!==s)try{await this.db(h,i,"move",n.overwrite),await f.Promises.rename(t,s)}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(1903,null,(0,b.$sc)(t),(0,b.$sc)((0,b.$rc)(s)),r.toString()))),this.hb(r)}}async copy(h,i,n){const t=this.I(h),s=this.I(i);if(t!==s)try{await this.db(h,i,"copy",n.overwrite),await f.Promises.copy(t,s,{preserveSymlinks:!0})}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(1904,null,(0,b.$sc)(t),(0,b.$sc)((0,b.$rc)(s)),r.toString()))),this.hb(r)}}async db(h,i,n,t){const s=this.I(h),r=this.I(i);let o=!1;if(!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,C.$Ig)(s,r,!0)),o){if(n==="copy")throw(0,g.$sl)((0,l.localize)(1905,null),g.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const y=await this.N(h);if(!y)throw(0,g.$sl)((0,l.localize)(1906,null),g.FileSystemProviderErrorCode.FileNotFound);const O=await this.N(i);if(O){if(!t)throw(0,g.$sl)((0,l.localize)(1907,null),g.FileSystemProviderErrorCode.FileExists);y.type&g.FileType.File&&O.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,i){return this.eb(h,i,!1)}async eb(h,i,n){const t=this.I(h),s=this.I(i),r=!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive);if((0,C.$Ig)(t,s,!r))return;const o=new A.$Yc;try{o.add(await this.Q(h)),o.add(await this.Q(i)),n&&await I.promises.mkdir((0,b.$rc)(s),{recursive:!0}),await I.promises.copyFile(t,s)}catch(u){if(u.code==="ENOENT"&&!n)return this.eb(h,i,!0);throw this.hb(u)}finally{o.dispose()}}t(h,i,n){return new d.$rr(t=>h(t),t=>i(t),n)}F(h,i,n){return new P.$Ar(t=>h(t),t=>i(t),n)}hb(h){if(h instanceof g.$rl)return h;let i=h,n;switch(h.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=g.FileSystemProviderErrorCode.Unknown;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.$sl)(i,n)}async ib(h,i){let n=this.hb(i);if(h&&n.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await f.SymlinkSupport.stat(this.I(h));t.mode&128||(n=(0,g.$sl)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return n}}e.$Br=$}),define(ue[103],de([0,1,3,2,4,11]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2jc=e.$1jc=void 0,e.$1jc=(0,N.$Ki)("sharedProcessLifecycleService");let T=class extends a.$Zc{constructor(A){super(),this.b=A,this.a=this.B(new I.$qe),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$2jc=T,e.$2jc=T=Ee([Z(0,k.$fk)],T)}),define(ue[177],de([0,1,10,3,11,2]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=e.$Cs=e.$Bs=void 0;class T extends N.$qk{constructor(p,m,f,l,g){super(m,f,l),this.r=p,this.t=g,this.B(g.listen("onDidChangeLogLevel",p)(E=>{(0,N.$hk)(E)?super.setLogLevel(E):super.setLogLevel(I.URI.revive(E[0]),E[1])})),this.B(g.listen("onDidChangeVisibility",p)(([E,w])=>super.setVisibility(I.URI.revive(E),w))),this.B(g.listen("onDidChangeLoggers",p)(({added:E,removed:w})=>{for(const d of E)super.registerLogger({...d,resource:I.URI.revive(d.resource)});for(const d of w)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new N.$ok({log:(p,m)=>{this.t.call("consoleLog",[p,m])}})}registerLogger(p){super.registerLogger(p),this.t.call("registerLogger",[p,this.r])}deregisterLogger(p){super.deregisterLogger(p),this.t.call("deregisterLogger",[p,this.r])}setLogLevel(p,m){super.setLogLevel(p,m),this.t.call("setLogLevel",[p,m])}setVisibility(p,m){super.setVisibility(p,m),this.t.call("setVisibility",[this.n(p),m])}s(p,m,f){return new C(this.t,p,m,f,this.r)}static setLogLevel(p,m,f){return p.call("setLogLevel",[m,f])}}e.$Bs=T;class C extends N.$lk{constructor(p,m,f,l,g){super(l?.logLevel==="always"),this.r=p,this.s=m,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[m,l,g]).then(()=>{this.u(this.n),this.m=!0})}g(p,m){const f=[[p,m]];this.m?this.u(f):this.n.push(...f)}u(p){this.r.call("log",[this.s,p])}}class A{constructor(p,m){this.a=p,this.b=m}listen(p,m){const f=this.b(p);switch(m){case"onDidChangeLoggers":return a.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(g=>this.c(g,f)),removed:[...l.removed].map(g=>this.c(g,f))}));case"onDidChangeVisibility":return a.Event.map(this.a.onDidChangeVisibility,l=>[f.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return a.Event.map(this.a.onDidChangeLogLevel,l=>(0,N.$hk)(l)?l:[f.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${m}`)}async call(p,m,f){const l=this.b(p);switch(m){case"setLogLevel":return(0,N.$hk)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(I.URI.revive(l.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(g=>this.c(g,l)))}throw new Error(`Call not found: ${m}`)}c(p,m){return{...p,resource:m.transformOutgoingURI(p.resource)}}}e.$Cs=A;class b extends k.$Zc{constructor(p,m){super(),m.call("setLogLevel",[p.getLogLevel()]),this.B(p.onDidChangeLogLevel(f=>m.call("setLogLevel",[f]))),m.call("getRegisteredLoggers").then(f=>{for(const l of f)p.registerLogger({...l,resource:I.URI.revive(l.resource)})}),this.B(m.listen("onDidChangeVisibility")(([f,l])=>p.setVisibility(I.URI.revive(f),l))),this.B(m.listen("onDidChangeLoggers")(({added:f,removed:l})=>{for(const g of f)p.registerLogger({...g,resource:I.URI.revive(g.resource)});for(const g of l)p.deregisterLogger(g.resource)}))}}e.$Ds=b}),define(ue[178],de([0,1,2,11]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$R=void 0;class N extends I.$Zc{constructor(T,C=[]){super(),this.a=new a.$pk([T,...C]),this.B(T.onDidChangeLogLevel(A=>this.setLevel(A)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...C){this.a.trace(T,...C)}debug(T,...C){this.a.debug(T,...C)}info(T,...C){this.a.info(T,...C)}warn(T,...C){this.a.warn(T,...C)}error(T,...C){this.a.error(T,...C)}flush(){this.a.flush()}}e.$$R=N}),define(ue[57],de([0,1,4]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0,e.$2hc=(0,I.$Ki)("nativeHostService")}),define(ue[179],de([0,1,43,56]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0;let N=class{constructor(T,C){return this.windowId=T,I.ProxyChannel.toService(C.getChannel("nativeHost"),{context:T,properties:(()=>{const A=new Map;return A.set("windowId",T),A})()})}};e.$kjc=N,e.$kjc=N=Ee([Z(1,a.$hjc)],N)}),define(ue[58],de([0,1,3,63,2,4]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=void 0,e.$zo=(0,k.$Ki)("policy");class T extends N.$Zc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$qe),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const R=Object.keys(this.f).length;return this.f={...b,...this.f},R!==Object.keys(this.f).length&&await this.j(b),a.Iterable.reduce(this.g.entries(),(p,[m,f])=>({...p,[m]:f}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return a.Iterable.reduce(Object.entries(this.f),(b,[R,p])=>({...b,[R]:{definition:p,value:this.g.get(R)}}),{})}}e.$Ao=T;class C{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Bo=C}),define(ue[180],de([0,1,3,2,58]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=e.$Nic=void 0;class k{constructor(A){this.b=A,this.a=new a.$Yc}listen(A,b){switch(b){case"onDidChange":return I.Event.map(this.b.onDidChange,R=>R.reduce((p,m)=>({...p,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${b}`)}call(A,b,R){switch(b){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(R)}throw new Error(`Call not found: ${b}`)}dispose(){this.a.dispose()}}e.$Nic=k;class T extends N.$Ao{constructor(A,b){super(),this.a=b;for(const R in A){const{definition:p,value:m}=A[R];this.f[R]=p,m!==void 0&&this.g.set(R,m)}this.a.listen("onDidChange")(R=>{for(const p in R){const m=R[p];m===null?this.g.delete(p):this.g.set(p,m)}this.h.fire(Object.keys(R))})}async j(A){const b=await this.a.call("updatePolicyDefinitions",A);for(const R in b)this.g.set(R,b[R])}}e.$Oic=T}),define(ue[104],de([0,1,37]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.context<"u"){const k=N.context.configuration();if(k)a=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(a=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const k=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:k.version})}}else a={},Object.keys(a).length===0&&Object.assign(a,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(ue[23],de([0,1,4]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=void 0,e.$yk=(0,I.$Ki)("productService"),e.$zk="vscode://schemas/vscode-product"}),define(ue[181],de([0,1,33,6,8,2,13,30,11,23]),function(ce,e,I,a,N,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0,I=Oe(I);let R=class extends k.$Zc{constructor(m,f,l){super(),this.b=f,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,m&&this.B(new a.$Wh(()=>{this.f(m)},3e4)).schedule()}async f(m){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),l=(0,T.$rc)(m),g=(0,T.$sc)(m),E=await C.Promises.readdir(l);await Promise.all(E.map(async w=>{if(w===g)return;const d=(0,T.$oc)(l,w),P=await I.promises.stat(d);if(P.isDirectory()&&f-P.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),C.Promises.rm(d)}))}catch(f){(0,N.$4)(f)}}};e.$yjc=R,e.$yjc=R=Ee([Z(1,b.$yk),Z(2,A.$fk)],R)}),define(ue[182],de([0,1,33,6,8,2,13,30,15,11,23]),function(ce,e,I,a,N,k,T,C,A,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=void 0,I=Oe(I);let p=class extends k.$Zc{constructor(f,l,g){super(),this.b=f,this.c=l,this.f=g,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new a.$Wh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),l=JSON.parse(await I.promises.readFile((0,T.$oc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const P of Object.keys(l)){const $=l[P];f[`${$.hash}.${P}`]=!0}const g=(0,T.$oc)(this.b.userDataPath,"clp");if(!await C.Promises.exists(g))return;const w=await C.Promises.readdir(g);for(const P of w){if(f[P]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${P}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${P}`),await C.Promises.rm((0,T.$oc)(g,P))}const d=Date.now();for(const P of Object.keys(f)){const $=(0,T.$oc)(g,P),c=await C.Promises.readdir($);for(const h of c){if(h==="tcf.json")continue;const i=(0,T.$oc)($,h),n=await I.promises.stat(i);n.isDirectory()&&d-n.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.$oc)(P,h)}`),await C.Promises.rm(i))}}}catch(f){(0,N.$4)(f)}}};e.$zjc=p,e.$zjc=p=Ee([Z(0,A.$Si),Z(1,b.$fk),Z(2,R.$yk)],p)}),define(ue[183],de([0,1,13,4]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$gH=void 0,e.$gH=(0,a.$Ki)("IV8InspectProfilingService");var N;(function(k){function T(A){return!!(A.samples&&A.timeDeltas)}k.isValidProfile=T;function C(A,b="noAbsolutePaths"){for(const R of A.nodes)R.callFrame&&R.callFrame.url&&((0,I.$nc)(R.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(R.callFrame.url))&&(R.callFrame.url=(0,I.$oc)(b,(0,I.$sc)(R.callFrame.url)));return A}k.rewriteAbsolutePaths=C})(N||(e.Utils=N={}))}),define(ue[184],de([0,1,32]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=void 0;class a{constructor(){this.a=new Map}async startProfiling(k){const C=await(await new Promise((b,R)=>{ce(["v8-inspect-profiler"],b,R)}).then(Oe)).startProfiling({host:k.host,port:k.port,checkForPaused:!0}),A=(0,I.$7g)();return this.a.set(A,C),A}async stopProfiling(k){const T=this.a.get(k);if(!T)throw new Error(`UNKNOWN session '${k}'`);const C=await T.stop();return this.a.delete(k),C.profile}}e.$Qjc=a}),define(ue[44],de([0,1,133,12]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=void 0,I=Oe(I),a=Oe(a);class N{constructor(){this.a=new Map}add(T,C){I.ok(a.$jg(T)),I.ok(a.$lg(C)),I.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,C)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$xo=new N}),define(ue[105],de([0,1,3,134,44]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=void 0,N=Oe(N),e.$yo={JSONContribution:"base.contributions.json"};function k(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class T{constructor(){this.b=new I.$qe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,R){this.a[k(b)]=R,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(b){const R=this.a[b];return R?(0,a.$ak)(R):void 0}hasSchemaContent(b){return!!this.a[b]}}const C=new T;N.$xo.add(e.$yo.JSONContribution,C)}),define(ue[47],de([0,1,17,3,12,9,21,105,44]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ConfigurationScope=e.$Co=e.EditPresentationTypes=void 0,e.$No=g,e.$Oo=E,e.$Po=w,e.$Qo=P,e.$Ro=$,e.$So=c,e.$To=h,N=Oe(N),k=Oe(k);var b;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$Co={Configuration:"base.contributions.configuration"};var R;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho={properties:{},patternProperties:{}},e.$Io={properties:{},patternProperties:{}},e.$Jo="vscode://schemas/settings/resourceLanguage",e.$Ko="vscode://schemas/settings/configurationDefaults";const p=A.$xo.as(C.$yo.JSONContribution);class m{constructor(){this.a=[],this.i=new Set,this.j=new a.$qe,this.onDidSchemaChange=this.j.event,this.k=new a.$qe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:k.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},p.registerSchema(e.$Jo,this.h),this.z()}registerConfiguration(n,t=!0){this.registerConfigurations([n],t)}registerConfigurations(n,t=!0){const s=new Set;this.r(n,t,s),p.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:s})}deregisterConfigurations(n){const t=new Set;this.s(n,t),p.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:n,remove:t}){const s=new Set;this.s(t,s),this.r(n,!1,s),p.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:s})}registerDefaultConfigurations(n){const t=new Set;this.l(n,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(n,t){this.a.push(...n);const s=[];for(const{overrides:r,source:o}of n)for(const u in r){t.add(u);const y=this.b.get(u)??this.b.set(u,{configurationDefaultOverrides:[]}).get(u),O=r[u];if(y.configurationDefaultOverrides.push({value:O,source:o}),e.$Mo.test(u)){const S=this.o(u,O,o,y.configurationDefaultOverrideValue);if(!S)continue;y.configurationDefaultOverrideValue=S,this.n(u,S,o),s.push(...g(u))}else{const S=this.p(u,O,o,y.configurationDefaultOverrideValue);if(!S)continue;y.configurationDefaultOverrideValue=S;const v=this.e[u];v&&(this.A(u,v),this.w(u,v))}}this.q(s)}deregisterDefaultConfigurations(n){const t=new Set;this.m(n,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(n,t){for(const s of n){const r=this.a.indexOf(s);r!==-1&&this.a.splice(r,1)}for(const{overrides:s,source:r}of n)for(const o in s){const u=this.b.get(o);if(!u)continue;const y=u.configurationDefaultOverrides.findIndex(O=>r?O.source?.id===r.id:O.value===s[o]);if(y!==-1){if(u.configurationDefaultOverrides.splice(y,1),u.configurationDefaultOverrides.length===0&&this.b.delete(o),e.$Mo.test(o)){let O;for(const S of u.configurationDefaultOverrides)O=this.o(o,S.value,S.source,O);O&&!N.$wg(O.value)?(u.configurationDefaultOverrideValue=O,this.n(o,O,r)):(this.b.delete(o),delete this.e[o],delete this.c.properties[o])}else{let O;for(const v of u.configurationDefaultOverrides)O=this.p(o,v.value,v.source,O);u.configurationDefaultOverrideValue=O;const S=this.e[o];S&&(this.A(o,S),this.w(o,S))}t.add(o)}}this.y()}n(n,t,s){const r={type:"object",default:t.value,description:k.localize(1663,null,(0,T.$oj)(n)),$ref:e.$Jo,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.e[n]=r,this.c.properties[n]=r}o(n,t,s,r){const o=r?.value||{},u=r?.source??new Map;if(!(u instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const y of Object.keys(t)){const O=t[y];if(N.$lg(O)&&(N.$qg(o[y])||N.$lg(o[y]))){if(o[y]={...o[y]??{},...O},s)for(const v in O)u.set(`${y}.${v}`,s)}else o[y]=O,s?u.set(y,s):u.delete(y)}return{value:o,source:u}}p(n,t,s,r){const o=this.e[n],u=r?.value??o?.defaultDefaultValue;let y=s;if(N.$lg(t)&&(o!==void 0&&o.type==="object"||o===void 0&&(N.$qg(u)||N.$lg(u)))){if(y=r?.source??new Map,!(y instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const S in t)s&&y.set(`${n}.${S}`,s);t={...N.$lg(u)?u:{},...t}}return{value:t,source:y}}deltaConfiguration(n){let t=!1;const s=new Set;n.removedDefaults&&(this.m(n.removedDefaults,s),t=!0),n.addedDefaults&&(this.l(n.addedDefaults,s),t=!0),n.removedConfigurations&&this.s(n.removedConfigurations,s),n.addedConfigurations&&this.r(n.addedConfigurations,!1,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...n){this.j.fire()}registerOverrideIdentifiers(n){this.q(n),this.j.fire()}q(n){for(const t of n)this.i.add(t);this.y()}r(n,t,s){n.forEach(r=>{this.u(r,t,r.extensionInfo,r.restrictedProperties,void 0,s),this.d.push(r),this.v(r)})}s(n,t){const s=r=>{if(r.properties)for(const o in r.properties){t.add(o);const u=this.e[o];u?.policy?.name&&this.f.delete(u.policy.name),delete this.e[o],this.x(o,r.properties[o])}r.allOf?.forEach(o=>s(o))};for(const r of n){s(r);const o=this.d.indexOf(r);o!==-1&&this.d.splice(o,1)}}u(n,t=!0,s,r,o=R.WINDOW,u){o=N.$sg(n.scope)?o:n.scope;const y=n.properties;if(y)for(const S in y){const v=y[S];if(t&&P(S,v)){delete y[S];continue}if(v.source=s,v.defaultDefaultValue=y[S].default,this.A(S,v),e.$Mo.test(S)?v.scope=void 0:(v.scope=N.$sg(v.scope)?o:v.scope,v.restricted=N.$sg(v.restricted)?!!r?.includes(S):v.restricted),y[S].hasOwnProperty("included")&&!y[S].included){this.g[S]=y[S],delete y[S];continue}else this.e[S]=y[S],y[S].policy?.name&&this.f.set(y[S].policy.name,S);!y[S].deprecationMessage&&y[S].markdownDeprecationMessage&&(y[S].deprecationMessage=y[S].markdownDeprecationMessage),u.add(S)}const O=n.allOf;if(O)for(const S of O)this.u(S,t,s,r,o,u)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const n=new Map;for(const[t,s]of this.b)s.configurationDefaultOverrideValue&&n.set(t,s.configurationDefaultOverrideValue);return n}v(n){const t=s=>{const r=s.properties;if(r)for(const u in r)this.w(u,r[u]);s.allOf?.forEach(t)};t(n)}w(n,t){switch(e.$Do.properties[n]=t,t.scope){case R.APPLICATION:e.$Eo.properties[n]=t;break;case R.MACHINE:e.$Fo.properties[n]=t;break;case R.MACHINE_OVERRIDABLE:e.$Go.properties[n]=t;break;case R.WINDOW:e.$Ho.properties[n]=t;break;case R.RESOURCE:e.$Io.properties[n]=t;break;case R.LANGUAGE_OVERRIDABLE:e.$Io.properties[n]=t,this.h.properties[n]=t;break}}x(n,t){switch(delete e.$Do.properties[n],t.scope){case R.APPLICATION:delete e.$Eo.properties[n];break;case R.MACHINE:delete e.$Fo.properties[n];break;case R.MACHINE_OVERRIDABLE:delete e.$Go.properties[n];break;case R.WINDOW:delete e.$Ho.properties[n];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.$Io.properties[n],delete this.h.properties[n];break}}y(){for(const n of this.i.values()){const t=`[${n}]`,s={type:"object",description:k.localize(1664,null),errorMessage:k.localize(1665,null),$ref:e.$Jo};this.A(t,s),e.$Do.properties[t]=s,e.$Eo.properties[t]=s,e.$Fo.properties[t]=s,e.$Go.properties[t]=s,e.$Ho.properties[t]=s,e.$Io.properties[t]=s}}z(){const n={type:"object",description:k.localize(1666,null),errorMessage:k.localize(1667,null),$ref:e.$Jo};e.$Do.patternProperties[e.$Lo]=n,e.$Eo.patternProperties[e.$Lo]=n,e.$Fo.patternProperties[e.$Lo]=n,e.$Go.patternProperties[e.$Lo]=n,e.$Ho.patternProperties[e.$Lo]=n,e.$Io.patternProperties[e.$Lo]=n,this.j.fire()}A(n,t){const s=this.b.get(n)?.configurationDefaultOverrideValue;let r,o;s&&(!t.disallowConfigurationDefault||!s.source)&&(r=s.value,o=s.source),N.$qg(r)&&(r=t.defaultDefaultValue,o=void 0),N.$qg(r)&&(r=w(t.type)),t.default=r,t.defaultValueSource=o}}const f="\\[([^\\]]+)\\]",l=new RegExp(f,"g");e.$Lo=`^(${f})+$`,e.$Mo=new RegExp(e.$Lo);function g(i){const n=[];if(e.$Mo.test(i)){let t=l.exec(i);for(;t?.length;){const s=t[1].trim();s&&n.push(s),t=l.exec(i)}}return(0,I.$Qb)(n)}function E(i){return i.reduce((n,t)=>`${n}[${t}]`,"")}function w(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const d=new m;A.$xo.add(e.$Co.Configuration,d);function P(i,n){return i.trim()?e.$Mo.test(i)?k.localize(1669,null,i):d.getConfigurationProperties()[i]!==void 0?k.localize(1670,null,i):n.policy?.name&&d.getPolicyConfigurations().get(n.policy?.name)!==void 0?k.localize(1671,null,i,n.policy?.name,d.getPolicyConfigurations().get(n.policy?.name)):null:k.localize(1668,null)}function $(){const i=[],n=d.getConfigurationProperties();for(const t of Object.keys(n))i.push([t,n[t].scope]);return i.push(["launch",R.RESOURCE]),i.push(["task",R.RESOURCE]),i}function c(i){const n={};for(const t of i){const s=t.properties;if(N.$lg(s))for(const r in s)n[r]=s[r];t.allOf&&Object.assign(n,c(t.allOf))}return n}function h(i){switch(i){case"application":return R.APPLICATION;case"machine":return R.MACHINE;case"resource":return R.RESOURCE;case"machine-overridable":return R.MACHINE_OVERRIDABLE;case"language-overridable":return R.LANGUAGE_OVERRIDABLE;default:return R.WINDOW}}}),define(ue[78],de([0,1,17,3,36,2,31,29,12,10,21,47,7,44]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=void 0,e.$Yo=$,I=Oe(I),N=Oe(N),C=Oe(C),A=Oe(A);function l(n){return Object.isFrozen(n)?n:C.$lo(n)}class g{static createEmptyModel(t){return new g({},[],[],void 0,t)}constructor(t,s,r,o,u){this.b=t,this.c=s,this.d=r,this.raw=o,this.f=u,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof g)return s;const r=new E("",this.f);return r.parseRaw(s),r.configurationModel});this.g=t.reduce((s,r)=>r===s?r:s.merge(r),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,R.$mj)(this.contents,t):this.contents}inspect(t,s){const r=this;return{get value(){return l(r.rawConfiguration.getValue(t))},get override(){return s?l(r.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return l(s?r.rawConfiguration.override(s).getValue(t):r.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:u,identifiers:y,keys:O}of r.rawConfiguration.overrides){const S=new g(u,O,[],void 0,r.f).getValue(t);S!==void 0&&o.push({identifiers:y,value:S})}return o.length?l(o):void 0}}}getOverrideValue(t,s){const r=this.j(s);return r?t?(0,R.$mj)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const r of this.overrides)r.identifiers.includes(t)&&s.push(...r.keys);return I.$Qb(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return I.$Qb(t)}override(t){let s=this.a.get(t);return s||(s=this.h(t),this.a.set(t,s)),s}merge(...t){const s=C.$ko(this.contents),r=C.$ko(this.overrides),o=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const y of t)if(u.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(s,y.contents);for(const O of y.overrides){const[S]=r.filter(v=>I.$yb(v.identifiers,O.identifiers));S?(this.i(S.contents,O.contents),S.keys.push(...O.keys),S.keys=I.$Qb(S.keys)):r.push(C.$ko(O))}for(const O of y.keys)o.indexOf(O)===-1&&o.push(O)}return new g(s,o,r,u.every(y=>y instanceof g)?void 0:u,this.f)}h(t){const s=this.j(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const r={};for(const o of I.$Qb([...Object.keys(this.contents),...Object.keys(s)])){let u=this.contents[o];const y=s[o];y&&(typeof u=="object"&&typeof y=="object"?(u=C.$ko(u),this.i(u,y)):u=y),r[o]=u}return new g(r,this.keys,this.overrides,void 0,this.f)}i(t,s){for(const r of Object.keys(s)){if(r in t&&A.$lg(t[r])&&A.$lg(s[r])){this.i(t[r],s[r]);continue}t[r]=C.$ko(s[r])}}j(t){let s=null,r=null;const o=u=>{u&&(r?this.i(r,u):r=C.$ko(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===t?s=u.contents:u.identifiers.includes(t)&&o(u.contents);return o(s),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.k(t,s,!0)}setValue(t,s){this.k(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,R.$lj)(this.contents,t),p.$Mo.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>I.$yb(r.identifiers,(0,p.$No)(t))),1))}k(t,s,r){if((0,R.$kj)(this.contents,t,s,o=>this.f.error(o)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),p.$Mo.test(t)){const o=(0,p.$No)(t),u={identifiers:o,keys:Object.keys(this.contents[t]),contents:(0,R.$jj)(this.contents[t],O=>this.f.error(O))},y=this.overrides.findIndex(O=>I.$yb(O.identifiers,o));y!==-1?this.overrides[y]=u:this.overrides.push(u)}}}e.$Uo=g;class E{constructor(t,s){this.f=t,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,s){if(!A.$sg(t)){const r=this.h(t);this.parseRaw(r,s)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,s){this.a=t;const{contents:r,keys:o,overrides:u,restricted:y,hasExcludedProperties:O}=this.i(t,s);this.b=new g(r,o,u,O?[t]:void 0,this.g),this.c=y||[]}h(t){let s={},r=null,o=[];const u=[],y=[];function O(v){Array.isArray(o)?o.push(v):r!==null&&(o[r]=v)}const S={onObjectBegin:()=>{const v={};O(v),u.push(o),o=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const v=[];O(v),u.push(o),o=v,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:O,onError:(v,L,j)=>{y.push({error:v,offset:L,length:j})}};if(t)try{N.$_n(t,S),s=o[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return s}i(t,s){const r=f.$xo.as(p.$Co.Configuration).getConfigurationProperties(),o=this.j(t,r,!0,s);t=o.raw;const u=(0,R.$jj)(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`)),y=Object.keys(t),O=this.l(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:u,keys:y,overrides:O,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(t,s,r,o){let u=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:u};const y={},O=[];for(const S in t)if(p.$Mo.test(S)&&r){const v=this.j(t[S],s,!1,o);y[S]=v.raw,u=u||v.hasExcludedProperties,O.push(...v.restricted)}else{const v=s[S],L=v?typeof v.scope<"u"?v.scope:p.ConfigurationScope.WINDOW:void 0;v?.restricted&&O.push(S),!o.exclude?.includes(S)&&(o.include?.includes(S)||(L===void 0||o.scopes===void 0||o.scopes.includes(L))&&!(o.skipRestricted&&v?.restricted))?y[S]=t[S]:u=!0}return{raw:y,restricted:O,hasExcludedProperties:u}}l(t,s){const r=[];for(const o of Object.keys(t))if(p.$Mo.test(o)){const u={};for(const y in t[o])u[y]=t[o][y];r.push({identifiers:(0,p.$No)(o),keys:Object.keys(u),contents:(0,R.$jj)(u,s)})}return r}}e.$Vo=E;class w extends k.$Zc{constructor(t,s,r,o,u){super(),this.c=t,this.f=s,this.g=o,this.h=u,this.b=this.B(new a.$qe),this.onDidChange=this.b.event,this.a=new E(this.c.toString(),u),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(a.Event.any(a.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),a.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(m.FileOperation.CREATE)||y.isOperation(m.FileOperation.COPY)||y.isOperation(m.FileOperation.DELETE)||y.isOperation(m.FileOperation.WRITE))&&r.isEqual(y.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Wo=w;class d{constructor(t,s,r,o,u,y,O,S,v,L,j,U,F){this.a=t,this.b=s,this.c=r,this.overrideIdentifiers=o,this.d=u,this.f=y,this.g=O,this.h=S,this.i=v,this.j=L,this.k=j,this.l=U,this.m=F}get value(){return l(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(t,s,r,o,u,y,O,S,v,L){this.j=t,this.l=s,this.m=r,this.n=o,this.p=u,this.q=y,this.r=O,this.s=S,this.t=v,this.u=L,this.h=null,this.i=new T.$Fc,this.v=null}getValue(t,s,r){return this.w(t,s,r).getValue(t)}updateValue(t,s,r={}){let o;r.resource?(o=this.t.get(r.resource),o||(o=g.createEmptyModel(this.u),this.t.set(r.resource,o))):o=this.s,s===void 0?o.removeValue(t):o.setValue(t,s),r.resource||(this.h=null)}inspect(t,s,r){const o=this.w(t,s,r),u=this.A(s.resource,r),y=s.resource?this.t.get(s.resource)||this.s:this.s,O=new Set;for(const S of o.overrides)for(const v of S.identifiers)o.getOverrideValue(t,v)!==void 0&&O.add(v);return new d(t,s,o.getValue(t),O.size?[...O]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,u||void 0,y)}keys(t){const s=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,s){this.r.set(t,s),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=[];if(!s){const{added:o,updated:u,removed:y}=h(this.j,t);s=[...o,...u,...y]}for(const o of s)for(const u of(0,p.$No)(o)){const y=this.j.getKeysForOverrideIdentifier(u),O=t.getKeysForOverrideIdentifier(u),S=[...O.filter(v=>y.indexOf(v)===-1),...y.filter(v=>O.indexOf(v)===-1),...y.filter(v=>!C.$oo(this.j.override(u).getValue(v),t.override(u).getValue(v)))];r.push([u,S])}return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:r,removed:o}=h(this.l,t),u=[...s,...r,...o];return u.length&&this.updatePolicyConfiguration(t),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.applicationConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateApplicationConfiguration(t),{keys:y,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.localUserConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateLocalUserConfiguration(t),{keys:y,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.remoteUserConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateRemoteUserConfiguration(t),{keys:y,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.workspaceConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateWorkspaceConfiguration(t),{keys:y,overrides:u}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:o,updated:u,removed:y,overrides:O}=h(r,s),S=[...o,...u,...y];return(S.length||!r)&&this.updateFolderConfiguration(t,s),{keys:S,overrides:O}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:u,overrides:y}=h(s,void 0);return{keys:[...r,...o,...u],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,s,r){let o=this.x(s,r);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(o=o.merge(this.l)),o}x({resource:t},s){let r=this.y();if(s&&t){const o=s.getFolder(t);o&&(r=this.z(o.uri)||r);const u=this.t.get(t);u&&(r=r.merge(u))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let s=this.i.get(t);if(!s){const r=this.y(),o=this.r.get(t);o?(s=r.merge(o),this.i.set(t,s)):s=r}return s}A(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,s)=>{const{contents:r,overrides:o,keys:u}=this.r.get(s);return t.push([s,{contents:r,overrides:o,keys:u}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this.q.keys.forEach(s=>t.add(s)),this.r.forEach(s=>s.keys.forEach(r=>t.add(r))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}D(t){const s=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.q.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o))),[...s.values()]}static parse(t,s){const r=this.E(t.defaults,s),o=this.E(t.policy,s),u=this.E(t.application,s),y=this.E(t.user,s),O=this.E(t.workspace,s),S=t.folders.reduce((v,L)=>(v.set(b.URI.revive(L[0]),this.E(L[1],s)),v),new T.$Fc);return new P(r,o,u,y,g.createEmptyModel(s),O,S,g.createEmptyModel(s),new T.$Fc,s)}static E(t,s){return new g(t.contents,t.keys,t.overrides,void 0,s)}}e.$Xo=P;function $(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const t=new Set,s=new Map;for(const o of n)o.keys.forEach(u=>t.add(u)),o.overrides.forEach(([u,y])=>{const O=(0,T.$Cc)(s,u,new Set);y.forEach(S=>O.add(S))});const r=[];return s.forEach((o,u)=>r.push([u,[...o.values()]])),{keys:[...t.values()],overrides:r}}class c{constructor(t,s,r,o,u){this.change=t,this.f=s,this.g=r,this.h=o,this.i=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of t.keys)this.affectedKeys.add(y);for(const[,y]of t.overrides)for(const O of y)this.affectedKeys.add(O);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,s){const r=this.a+t,o=this.d.indexOf(r);if(o<0)return!1;const u=o+r.length;if(u>=this.d.length)return!1;const y=this.d.charCodeAt(u);if(y!==this.b&&y!==this.c)return!1;if(s){const O=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.f?.workspace):void 0,S=this.g.getValue(t,s,this.h);return!C.$oo(O,S)}return!0}}e.$Zo=c;function h(n,t){const{added:s,removed:r,updated:o}=i(t?.rawConfiguration,n?.rawConfiguration),u=[],y=n?.getAllOverrideIdentifiers()||[],O=t?.getAllOverrideIdentifiers()||[];if(t){const S=O.filter(v=>!y.includes(v));for(const v of S)u.push([v,t.getKeysForOverrideIdentifier(v)])}if(n){const S=y.filter(v=>!O.includes(v));for(const v of S)u.push([v,n.getKeysForOverrideIdentifier(v)])}if(t&&n){for(const S of y)if(O.includes(S)){const v=i({contents:n.getOverrideValue(void 0,S)||{},keys:n.getKeysForOverrideIdentifier(S)},{contents:t.getOverrideValue(void 0,S)||{},keys:t.getKeysForOverrideIdentifier(S)});u.push([S,[...v.added,...v.removed,...v.updated]])}}return{added:s,removed:r,updated:o,overrides:u}}function i(n,t){const s=n?t?n.keys.filter(u=>t.keys.indexOf(u)===-1):[...n.keys]:[],r=t?n?t.keys.filter(u=>n.keys.indexOf(u)===-1):[...t.keys]:[],o=[];if(n&&t){for(const u of t.keys)if(n.keys.indexOf(u)!==-1){const y=(0,R.$mj)(t.contents,u),O=(0,R.$mj)(n.contents,u);C.$oo(y,O)||o.push(u)}}return{added:s,removed:r,updated:o}}}),define(ue[185],de([0,1,17,3,2,29,12,78,47,11,58,44]),function(ce,e,I,a,N,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=void 0;class m extends N.$Zc{get configurationModel(){return this.b}constructor(E){super(),this.c=E,this.a=this.B(new a.$qe),this.onDidChangeConfiguration=this.a.event,this.b=C.$Uo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(p.$xo.as(A.$Co.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:w})=>this.f(Array.from(E),w))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(E,w){this.j(E,p.$xo.as(A.$Co.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:E})}g(){return{}}h(){this.b=C.$Uo.createEmptyModel(this.c);const E=p.$xo.as(A.$Co.Configuration).getConfigurationProperties();this.j(Object.keys(E),E)}j(E,w){const d=this.g();for(const P of E){const $=d[P],c=w[P];$!==void 0?this.b.setValue(P,$):c?this.b.setValue(P,c.default):this.b.removeValue(P)}}}e.$1o=m;class f{constructor(){this.onDidChangeConfiguration=a.Event.None,this.configurationModel=C.$Uo.createEmptyModel(new b.$sk)}async initialize(){return this.configurationModel}}e.$2o=f;let l=class extends N.$Zc{get configurationModel(){return this.b}constructor(E,w,d){super(),this.c=E,this.f=w,this.g=d,this.a=this.B(new a.$qe),this.onDidChangeConfiguration=this.a.event,this.b=C.$Uo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(E=>this.j(E))),this.B(this.c.onDidChangeConfiguration(async({properties:E})=>this.m(await this.h(E),!0))),this.b}async h(E){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",E);const w={},d=[],P=p.$xo.as(A.$Co.Configuration).getConfigurationProperties();for(const $ of E){const c=P[$];if(!c){d.push($);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.g.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}d.push($),w[c.policy.name]={type:c.type}}}return(0,T.$wg)(w)||await this.f.updatePolicyDefinitions(w),d}j(E){this.g.trace("PolicyConfiguration#onDidChangePolicies",E);const w=p.$xo.as(A.$Co.Configuration).getPolicyConfigurations(),d=(0,I.$Lb)(E.map(P=>w.get(P)));this.m(d,!0)}m(E,w){this.g.trace("PolicyConfiguration#update",E);const d=p.$xo.as(A.$Co.Configuration).getConfigurationProperties(),P=[],$=this.b.isEmpty();for(const c of E){const h=d[c]?.policy?.name;if(h){const i=this.f.getPolicyValue(h);($?i!==void 0:!(0,k.$oo)(this.b.getValue(c),i))&&P.push([c,i])}else this.b.getValue(c)!==void 0&&P.push([c,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const c=this.b;this.b=C.$Uo.createEmptyModel(this.g);for(const h of c.keys)this.b.setValue(h,c.getValue(h));for(const[h,i]of P)i===void 0?this.b.removeValue(h):this.b.setValue(h,i);w&&this.a.fire(this.b)}}};e.$3o=l,e.$3o=l=Ee([Z(1,R.$zo),Z(2,b.$fk)],l)}),define(ue[186],de([0,1,17,6,14,3,36,64,2,31,29,5,20,21,78,47,185,7,58]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=void 0;class P extends A.$Zc{constructor(h,i,n,t){super(),this.m=h,this.n=t,this.h=this.B(new k.$qe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new E.$1o(t)),this.c=n instanceof d.$Bo?new E.$2o:this.B(new E.$3o(this.b,n,t)),this.f=this.B(new l.$Wo(this.m,{},m.$ch,i,t)),this.a=new l.$Xo(this.b.configurationModel,this.c.configurationModel,l.$Uo.createEmptyModel(t),l.$Uo.createEmptyModel(t),l.$Uo.createEmptyModel(t),l.$Uo.createEmptyModel(t),new b.$Fc,l.$Uo.createEmptyModel(t),new b.$Fc,t),this.j=new $(h,i,this),this.g=this.B(new a.$Wh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:r})=>this.s(s,r))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,i,n]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$Xo(h,i,l.$Uo.createEmptyModel(this.n),n,l.$Uo.createEmptyModel(this.n),l.$Uo.createEmptyModel(this.n),new b.$Fc,l.$Uo.createEmptyModel(this.n),new b.$Fc,this.n)}getConfigurationData(){return this.a.toData()}getValue(h,i){const n=typeof h=="string"?h:void 0,t=(0,f.$fj)(h)?h:(0,f.$fj)(i)?i:{};return this.a.getValue(n,t,void 0)}async updateValue(h,i,n,t,s){const r=(0,f.$gj)(n)?n:(0,f.$fj)(n)?{resource:n.resource,overrideIdentifiers:n.overrideIdentifier?[n.overrideIdentifier]:void 0}:void 0,o=r?t:n;if(o!==void 0&&o!==f.ConfigurationTarget.USER_LOCAL&&o!==f.ConfigurationTarget.USER)throw new Error(`Unable to write ${h} to target ${o}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,I.$Qb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const u=this.inspect(h,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(u.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,R.$oo)(i,u.defaultValue)&&(i=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const O=r.overrideIdentifiers.sort(),S=this.a.localUserConfiguration.overrides.find(v=>(0,I.$yb)([...v.identifiers].sort(),O));S&&(r.overrideIdentifiers=S.identifiers)}const y=r?.overrideIdentifiers?.length?[(0,g.$Oo)(r.overrideIdentifiers),h]:[h];await this.j.write(y,i),await this.reloadConfiguration()}inspect(h,i={}){return this.a.inspect(h,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.r(h)}r(h){const i=this.a.toData(),n=this.a.compareAndUpdateLocalUserConfiguration(h);this.u(n,i,f.ConfigurationTarget.USER)}s(h,i){const n=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(h,i);this.u(t,n,f.ConfigurationTarget.DEFAULT)}t(h){const i=this.a.toData(),n=this.a.compareAndUpdatePolicyConfiguration(h);this.u(n,i,f.ConfigurationTarget.DEFAULT)}u(h,i,n){const t=new l.$Zo(h,{data:i},this.a,void 0,this.n);t.source=n,this.h.fire(t)}}e.$4o=P;class ${constructor(h,i,n){this.b=h,this.c=i,this.d=n,this.a=new a.$Rh}write(h,i){return this.a.queue(()=>this.e(h,i))}async e(h,i){let n;try{n=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===w.FileOperationResult.FILE_NOT_FOUND)n="{}";else throw r}const t=[];if((0,T.$5n)(n,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(n,h,i);n=(0,C.$jo)(n,s),await this.c.writeFile(this.b,N.$Se.fromString(n))}f(h,i,n){const{tabSize:t,insertSpaces:s,eol:r}=this.h;if(!i.length){const o=JSON.stringify(n,null,s?" ".repeat(t):"	");return[{content:o,length:o.length,offset:0}]}return(0,C.$go)(h,i,n,{tabSize:t,insertSpaces:s,eol:r})}get h(){if(!this.g){let h=p.OS===p.OperatingSystem.Linux||p.OS===p.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(h=i),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ue[187],de([0,1,14,3,2,72]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kzb=e.$Izb=e.$Hzb=void 0,e.$Jzb=C;const T=(b,R,p)=>{const m=new Uint8Array(16);for(let g=0;g<16;g++)m[g]=Math.round(Math.random()*256);const f=(0,I.$af)(I.$Se.wrap(m));return[`GET ws://localhost${b}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`].join(`\r
`)+`\r
\r
`};e.$Hzb=T,e.$Izb=I.$Se.fromString(`\r
\r
`);async function C(b,R,p,m,f){b.write(I.$Se.fromString((0,e.$Hzb)(R,p,m)));const l=new N.$Yc;try{return await new Promise((g,E)=>{let w;l.add(b.onData(d=>{w?w=I.$Se.concat([w,d],w.byteLength+d.byteLength):w=d;const P=w.indexOf(e.$Izb);if(P===-1)return;g(b),b.pauseData();const $=w.slice(P+e.$Izb.byteLength);$.byteLength&&f.onData.fire($)})),l.add(b.onClose(d=>E(d??new Error("socket closed")))),l.add(b.onEnd(()=>E(new Error("socket ended"))))})}catch(g){throw b.dispose(),g}finally{l.dispose()}}class A extends N.$Zc{constructor(R,p){super(),this.g=R,this.a=this.B(new a.$te),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new a.$qe),this.onDidDispose=this.b.event,this.f=!1,this.B(p.onData),this.B(p.onData.event(m=>this.a.fire(m))),this.onClose=this.B(p.onClose).event,this.onEnd=this.B(p.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,p){k.SocketDiagnostics.traceSocketEvent(this,this.g,R,p)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Kzb=A}),define(ue[106],de([0,1,8,4]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.RemoteAuthorityResolverErrorCode=e.$Yl=e.$Xl=e.RemoteConnectionType=e.$Wl=void 0,e.$1l=b,e.$Wl=(0,a.$Ki)("remoteAuthorityResolverService");var N;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(N||(e.RemoteConnectionType=N={}));class k{constructor(p){this.id=p,this.type=N.Managed}toString(){return`Managed(${this.id})`}}e.$Xl=k;class T{constructor(p,m){this.host=p,this.port=m,this.type=N.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Yl=T;var C;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(C||(e.RemoteAuthorityResolverErrorCode=C={}));class A extends I.$fb{static isNotAvailable(p){return p instanceof A&&p._code===C.NotAvailable}static isTemporarilyNotAvailable(p){return p instanceof A&&p._code===C.TemporarilyNotAvailable}static isNoResolverFound(p){return p instanceof A&&p._code===C.NoResolverFound}static isInvalidAuthority(p){return p instanceof A&&p._code===C.InvalidAuthority}static isHandled(p){return p instanceof A&&p.isHandled}constructor(p,m=C.Unknown,f){super(p),this._message=p,this._code=m,this._detail=f,this.isHandled=m===C.NotAvailable&&f===!0,Object.setPrototypeOf(this,A.prototype)}}e.$Zl=A;function b(R){const p=R.indexOf("+");return p===-1?R:R.substring(0,p)}}),define(ue[188],de([0,1,6,14,25,8,3,2,22,102,54,32,72,106]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$6l=u,e.$7l=y,e.$8l=S,b=Oe(b);const l=30*1e3;var g;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(g||(e.ConnectionType=g={}));function E(K){switch(K){case g.Management:return"Management";case g.ExtensionHost:return"ExtensionHost";case g.Tunnel:return"Tunnel"}}function w(K){const q=new N.$Be;return setTimeout(()=>q.cancel(),K),q.token}function d(K,q){if(K.isCancellationRequested||q.isCancellationRequested)return N.CancellationToken.Cancelled;const D=new N.$Be;return K.onCancellationRequested(()=>D.cancel()),q.onCancellationRequested(()=>D.cancel()),D.token}class P{get didTimeout(){return this.c==="timedout"}constructor(q){this.c="pending",this.d=new C.$Yc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,I.$Dh)(),q.isCancellationRequested?this.h():this.d.add(q.onCancellationRequested(()=>this.h()))}registerDisposable(q){this.c==="pending"?this.d.add(q):q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const q=new Error("Time limit reached");return q.code="ETIMEDOUT",q.syscall="connect",q}resolve(q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(q))}reject(q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(q))}}function $(K,q){const D=new P(q);return D.registerDisposable(K.onControlMessage(J=>{const oe=JSON.parse(J.toString()),Q=W(oe);Q?D.reject(Q):D.resolve(oe)})),D.promise}function c(K,q,D,J,oe,Q,Y,M){const B=new P(M),ie=R.$ke.create(!1);return K.info(`Creating a socket (${Y})...`),b.mark(`code/willCreateSocket/${Q}`),q.connect(D,J,oe,Y).then(ae=>{B.didTimeout?(b.mark(`code/didCreateSocketError/${Q}`),K.info(`Creating a socket (${Y}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),ae?.dispose()):(b.mark(`code/didCreateSocketOK/${Q}`),K.info(`Creating a socket (${Y}) was successful after ${ie.elapsed()} ms.`),B.resolve(ae))},ae=>{b.mark(`code/didCreateSocketError/${Q}`),K.info(`Creating a socket (${Y}) returned an error after ${ie.elapsed()} ms.`),K.error(ae),B.reject(ae)}),B.promise}function h(K,q){const D=new P(q);return K.then(J=>{D.didTimeout||D.resolve(J)},J=>{D.didTimeout||D.reject(J)}),D.promise}async function i(K,q,D,J){const oe=ee(K,q);K.logService.trace(`${oe} 1/6. invoking socketFactory.connect().`);let Q;try{Q=await c(K.logService,K.remoteSocketFactoryService,K.connectTo,A.$Xg.getServerRootPath(),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,E(q),`renderer-${E(q)}-${K.reconnectionToken}`,J)}catch(ae){throw K.logService.error(`${oe} socketFactory.connect() failed or timed out. Error:`),K.logService.error(ae),ae}K.logService.trace(`${oe} 2/6. socketFactory.connect() was successful.`);let Y,M;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(Q,null),Y=K.reconnectionProtocol,M=!1):(Y=new m.$yi({socket:Q}),M=!0),K.logService.trace(`${oe} 3/6. sending AuthRequest control message.`);const B=await h(K.signService.createNewMessage((0,p.$7g)()),J),ie={type:"auth",auth:K.connectionToken||"00000000000000000000",data:B.data};Y.sendControl(a.$Se.fromString(JSON.stringify(ie)));try{const ae=await $(Y,d(J,w(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(K.logService.trace(`${oe} 4/6. received SignRequest control message.`),!await h(K.signService.validate(B,ae.signedData),J)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const pe=await h(K.signService.sign(ae.data),J),be={type:"connectionType",commit:K.commit,signedData:pe,desiredConnectionType:q};return D&&(be.args=D),K.logService.trace(`${oe} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(a.$Se.fromString(JSON.stringify(be))),{protocol:Y,ownsProtocol:M}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(K.logService.error(`${oe} the handshake timed out. Error:`),K.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${oe} received error control message when negotiating connection. Error:`),K.logService.error(ae)),M&&z(Y),ae}}async function n(K,q,D,J){const oe=Date.now(),Q=ee(K,q),{protocol:Y,ownsProtocol:M}=await i(K,q,D,J),B=new P(J);return B.registerDisposable(Y.onControlMessage(ie=>{const ae=JSON.parse(ie.toString()),he=W(ae);he?(K.logService.error(`${Q} received error control message when negotiating connection. Error:`),K.logService.error(he),M&&z(Y),B.reject(he)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${X(oe)}!`),B.resolve({protocol:Y,firstMessage:ae}))})),B.promise}async function t(K,q){const{protocol:D}=await n(K,g.Management,void 0,q);return{protocol:D}}async function s(K,q,D){const{protocol:J,firstMessage:oe}=await n(K,g.ExtensionHost,q,D),Q=oe&&oe.debugPort;return{protocol:J,debugPort:Q}}async function r(K,q,D){const J=Date.now(),oe=ee(K,g.Tunnel),{protocol:Q}=await i(K,g.Tunnel,q,D);return K.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${X(J)}!`),Q}async function o(K,q,D){const{connectTo:J,connectionToken:oe}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:J,connectionToken:oe,reconnectionToken:q,reconnectionProtocol:D,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function u(K,q,D){return O(K,async J=>{const{protocol:oe}=await t(J,N.CancellationToken.None);return new H(K,q,D,J.reconnectionToken,oe)})}async function y(K,q){return O(K,async D=>{const{protocol:J,debugPort:oe}=await s(D,q,N.CancellationToken.None);return new te(K,q,D.reconnectionToken,J,oe)})}async function O(K,q){for(let J=1;;J++)try{const oe=(0,p.$7g)(),Q=await o(K,oe,null);return await q(Q)}catch(oe){if(J<5)K.logService.error(`[remote-connection][attempt ${J}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(oe);else throw K.logService.error(`[remote-connection][attempt ${J}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(oe),x.triggerPermanentFailure(0,0,f.$Zl.isHandled(oe)),oe}}async function S(K,q,D){const J=await o(K,(0,p.$7g)(),null);return await r(J,{host:q,port:D},N.CancellationToken.None)}function v(K){return(0,I.$xh)(q=>new Promise((D,J)=>{const oe=setTimeout(D,K*1e3);q.onCancellationRequested(()=>{clearTimeout(oe),D()})}))}var L;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(L||(e.PersistentConnectionEventType=L={}));class j{constructor(q,D){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.type=L.ConnectionLost}}e.$9l=j;class U{constructor(q,D,J,oe){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.durationSeconds=J,this.c=oe,this.type=L.ReconnectionWait}skipWait(){this.c.cancel()}}e.$0l=U;class F{constructor(q,D,J){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=J,this.type=L.ReconnectionRunning}}e.$$l=F;class G{constructor(q,D,J){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=J,this.type=L.ConnectionGain}}e.$_l=G;class V{constructor(q,D,J,oe){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=J,this.handled=oe,this.type=L.ReconnectionPermanentFailure}}e.$am=V;class x extends C.$Zc{static triggerPermanentFailure(q,D,J){this._permanentFailure=!0,this.f=q,this.g=D,this.h=J,this.j.forEach(oe=>oe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(q=>q.y())}static debugPauseSocketWriting(){this.j.forEach(q=>q.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(q,D,J,oe,Q){super(),this.t=q,this.u=D,this.reconnectionToken=J,this.protocol=oe,this.w=Q,this.m=this.B(new T.$qe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new G(this.reconnectionToken,0,0)),this.B(oe.onSocketClose(Y=>{const M=le(this.t,this.reconnectionToken,!0);Y?Y.type===m.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${M} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this.u.logService.error(Y.error)):(this.u.logService.info(`${M} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this.u.logService.error(Y.event)):this.u.logService.info(`${M} received socket close event.`),this.y()})),this.B(oe.onSocketTimeout(Y=>{const M=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${M} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,C.$Xc)(()=>{const Y=x.j.indexOf(this);Y>=0&&x.j.splice(Y,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const q=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${q} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let J=-1;do{J++;const oe=J<D.length?D[J]:D[D.length-1];try{if(oe>0){const Y=v(oe);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe,Y)),this.u.logService.info(`${q} waiting for ${oe} seconds before reconnecting...`);try{await Y}catch{}}if(this.n){this.u.logService.error(`${q} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1)),this.u.logService.info(`${q} resolving connection...`);const Q=await o(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${q} connecting to ${Q.connectTo}...`),await this.G(Q,w(l)),this.u.logService.info(`${q} reconnected!`),this.m.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1));break}catch(Q){if(Q.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(J>360){this.u.logService.error(`${q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(f.$Zl.isTemporarilyNotAvailable(Q)){this.u.logService.info(`${q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((Q.code==="ETIMEDOUT"||Q.code==="ENETUNREACH"||Q.code==="ECONNREFUSED"||Q.code==="ECONNRESET")&&Q.syscall==="connect"){this.u.logService.info(`${q} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((0,k.$8)(Q)){this.u.logService.info(`${q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if(Q instanceof f.$Zl){this.u.logService.error(`${q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,f.$Zl.isHandled(Q));break}this.u.logService.error(`${q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}}while(!this.n&&!this.s)}C(q,D,J){this.w?x.triggerPermanentFailure(q,D,J):this.D(q,D,J)}D(q,D,J){this.m.fire(new V(this.reconnectionToken,q,D,J)),z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$bm=x;class H extends x{constructor(q,D,J,oe,Q){super(g.Management,q,oe,Q,!0),this.client=this.B(new m.$wi(Q,{remoteAuthority:D,clientId:J},q.ipcLogger))}async G(q,D){await t(q,D)}}e.$cm=H;class te extends x{constructor(q,D,J,oe,Q){super(g.ExtensionHost,q,J,oe,!1),this.H=D,this.debugPort=Q}async G(q,D){await s(q,this.H,D)}}e.$dm=te;function z(K){try{K.acceptDisconnect();const q=K.getSocket();K.dispose(),q.dispose()}catch(q){(0,k.$4)(q)}}function W(K){if(K&&K.type==="error"){const q=new Error(`Connection error: ${K.reason}`);return q.code="VSCODE_CONNECTION_ERROR",q}return null}function _(K,q){for(;K.length<q;)K+=" ";return K}function ne(K,q){return`[remote-connection][${_(E(K),13)}][${q.substr(0,5)}\u2026]`}function le(K,q,D){return`${ne(K,q)}[${D?"reconnect":"initial"}]`}function ee(K,q){return`${le(q,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function X(K){return`${Date.now()-K} ms`}}),define(ue[107],de([0,1,22]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=a,e.$on=N,e.$pn=k,e.$qn=T;function a(A){return A.scheme===I.Schemas.vscodeRemote?A.authority:void 0}function N(A){if(!A)return;const b=A.indexOf("+");return b<0?A:A.substr(0,b)}function k(A){const{host:b,port:R}=C(A);if(typeof R>"u")throw new Error(`Invalid remote authority: ${A}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:b,port:R}}function T(A,b){let{host:R,port:p}=C(A);return typeof p>"u"&&(p=b),{host:R,port:p}}function C(A){const b=A.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const R=A.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const p=A.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:A,port:void 0}}}),define(ue[34],de([0,1,26,4,107]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$zn=e.$yn=e.$xn=e.TargetPlatform=e.ExtensionType=e.$wn=e.$un=e.$tn=e.$sn=e.$rn=void 0,e.$vn=k,e.$An=p,e.$Bn=m,e.$Cn=f,e.$Dn=l,e.$En=g,e.$Fn=E,I=Oe(I),e.$rn="extensions.user.cache",e.$sn="extensions.builtin.cache",e.$tn="undefined_publisher",e.$un=["ui","workspace","web"];function k(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$wn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(T||(e.ExtensionType=T={}));var C;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(C||(e.TargetPlatform=C={}));class A{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,P){if(typeof d>"u"||d===null)return typeof P>"u"||P===null;if(typeof P>"u"||P===null)return!1;if(typeof d=="string"||typeof P=="string"){const $=typeof d=="string"?d:d.value,c=typeof P=="string"?P:P.value;return I.$Kf($,c)}return d._lower===P._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$xn=A;class b{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const P of d)this.add(P)}add(d){this.c.add(A.toKey(d))}delete(d){return this.c.delete(A.toKey(d))}has(d){return this.c.has(A.toKey(d))}}e.$yn=b;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(A.toKey(d))}get(d){return this.c.get(A.toKey(d))}has(d){return this.c.has(A.toKey(d))}set(d,P){this.c.set(A.toKey(d),P)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$zn=R;function p(w){return m(w)}function m(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}function f(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}function l(w,d){if(d){const P=`onResolveRemoteAuthority:${(0,N.$on)(d)}`;return!!w.activationEvents?.includes(P)}return!1}function g(w){return w.map(d=>{const[P,$]=d.split("@");return{proposalName:P,version:$?parseInt($):void 0}})}function E(w){return w.map(d=>d.split("@")[0])}e.$Gn=(0,a.$Ki)("IBuiltinExtensionsScannerService")}),define(ue[27],de([0,1,5,9,34,4]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.ExtensionManagementErrorCode=e.$sp=e.ExtensionGalleryErrorCode=e.$rp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=void 0,e.$lp=C,e.$mp=A,e.$np=b,e.$op=R,e.$pp=p,e.$qp=m,e.$ep="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$fp=new RegExp(e.$ep),e.$gp="__web_extension",e.$hp="skipWalkthrough",e.$ip="extensionInstallSource",e.$jp="dependecyOrPackExtensionInstall",e.$kp="clientTargetPlatform";var T;(function(c){c.COMMAND="command",c.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function C(c){switch(c){case N.TargetPlatform.WIN32_X64:return"Windows 64 bit";case N.TargetPlatform.WIN32_ARM64:return"Windows ARM";case N.TargetPlatform.LINUX_X64:return"Linux 64 bit";case N.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case N.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case N.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case N.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case N.TargetPlatform.DARWIN_X64:return"Mac";case N.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case N.TargetPlatform.WEB:return"Web";case N.TargetPlatform.UNIVERSAL:return N.TargetPlatform.UNIVERSAL;case N.TargetPlatform.UNKNOWN:return N.TargetPlatform.UNKNOWN;case N.TargetPlatform.UNDEFINED:return N.TargetPlatform.UNDEFINED}}function A(c){switch(c){case N.TargetPlatform.WIN32_X64:return N.TargetPlatform.WIN32_X64;case N.TargetPlatform.WIN32_ARM64:return N.TargetPlatform.WIN32_ARM64;case N.TargetPlatform.LINUX_X64:return N.TargetPlatform.LINUX_X64;case N.TargetPlatform.LINUX_ARM64:return N.TargetPlatform.LINUX_ARM64;case N.TargetPlatform.LINUX_ARMHF:return N.TargetPlatform.LINUX_ARMHF;case N.TargetPlatform.ALPINE_X64:return N.TargetPlatform.ALPINE_X64;case N.TargetPlatform.ALPINE_ARM64:return N.TargetPlatform.ALPINE_ARM64;case N.TargetPlatform.DARWIN_X64:return N.TargetPlatform.DARWIN_X64;case N.TargetPlatform.DARWIN_ARM64:return N.TargetPlatform.DARWIN_ARM64;case N.TargetPlatform.WEB:return N.TargetPlatform.WEB;case N.TargetPlatform.UNIVERSAL:return N.TargetPlatform.UNIVERSAL;default:return N.TargetPlatform.UNKNOWN}}function b(c,h){switch(c){case I.Platform.Windows:return h==="x64"?N.TargetPlatform.WIN32_X64:h==="arm64"?N.TargetPlatform.WIN32_ARM64:N.TargetPlatform.UNKNOWN;case I.Platform.Linux:return h==="x64"?N.TargetPlatform.LINUX_X64:h==="arm64"?N.TargetPlatform.LINUX_ARM64:h==="arm"?N.TargetPlatform.LINUX_ARMHF:N.TargetPlatform.UNKNOWN;case"alpine":return h==="x64"?N.TargetPlatform.ALPINE_X64:h==="arm64"?N.TargetPlatform.ALPINE_ARM64:N.TargetPlatform.UNKNOWN;case I.Platform.Mac:return h==="x64"?N.TargetPlatform.DARWIN_X64:h==="arm64"?N.TargetPlatform.DARWIN_ARM64:N.TargetPlatform.UNKNOWN;case I.Platform.Web:return N.TargetPlatform.WEB}}function R(c,h){return h===N.TargetPlatform.WEB&&!c.includes(N.TargetPlatform.WEB)}function p(c,h,i){return R(h,i)?!1:c===N.TargetPlatform.UNDEFINED||c===N.TargetPlatform.UNIVERSAL?!0:c===N.TargetPlatform.UNKNOWN?!1:c===i}function m(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}var f;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(f||(e.SortBy=f={}));var l;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var g;(function(c){c.Install="install",c.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var E;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$rp=(0,k.$Ki)("extensionGalleryService");var w;(function(c){c.Timeout="Timeout",c.Cancelled="Cancelled",c.Failed="Failed",c.DownloadFailedWriting="DownloadFailedWriting",c.Offline="Offline"})(w||(e.ExtensionGalleryErrorCode=w={}));class d extends Error{constructor(h,i){super(h),this.code=i,this.name=i}}e.$sp=d;var P;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleApi="IncompatibleApi",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.DownloadSignature="DownloadSignature",c.DownloadFailedWriting="DownloadFailedWriting",c.UpdateMetadata="UpdateMetadata",c.Extract="Extract",c.Scanning="Scanning",c.ScanningExtension="ScanningExtension",c.ReadUninstalled="ReadUninstalled",c.UnsetUninstalled="UnsetUninstalled",c.Delete="Delete",c.Rename="Rename",c.IntializeDefaultProfile="IntializeDefaultProfile",c.AddToProfile="AddToProfile",c.InstalledExtensionNotFound="InstalledExtensionNotFound",c.PostInstall="PostInstall",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.NotAllowed="NotAllowed",c.Gallery="Gallery",c.Cancelled="Cancelled",c.Unknown="Unknown",c.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));class $ extends Error{constructor(h,i){super(h),this.code=i,this.name=i}}e.$tp=$,e.$up=(0,k.$Ki)("extensionManagementService"),e.$vp="extensionsIdentifiers/disabled",e.$wp="extensionsIdentifiers/enabled",e.$xp=(0,k.$Ki)("IGlobalExtensionEnablementService"),e.$yp=(0,k.$Ki)("IExtensionTipsService"),e.$zp=(0,a.localize2)(1780,"Extensions"),e.$Ap=(0,a.localize2)(1781,"Preferences")}),define(ue[189],de([0,1,3,2,29,10,96,27]),function(ce,e,I,a,N,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=void 0;function A(E,w){return E?k.URI.revive(w?w.transformIncoming(E):E):void 0}function b(E,w){return w?w.transformOutgoingURI(E):E}function R(E,w){w=w||T.$Tn;const d=E.manifest;return{...(0,T.$Wn)({...E,manifest:void 0},w),manifest:d}}function p(E,w){return E?.profileLocation?(0,T.$Wn)(E,w??T.$Tn):E}function m(E,w){return w?(0,N.$mo)(E,d=>d instanceof k.URI?w.transformOutgoingURI(d):void 0):E}class f{constructor(w,d){this.a=w,this.b=d,this.onInstallExtension=I.Event.buffer(w.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(w.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(w.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(w.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(w.onDidUpdateExtensionMetadata,!0)}listen(w,d){const P=this.b(w);switch(d){case"onInstallExtension":return I.Event.map(this.onInstallExtension,$=>({...$,profileLocation:$.profileLocation?b($.profileLocation,P):$.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,$=>$.map(c=>({...c,local:c.local?m(c.local,P):c.local,profileLocation:c.profileLocation?b(c.profileLocation,P):c.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,$=>({...$,profileLocation:$.profileLocation?b($.profileLocation,P):$.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,$=>({...$,profileLocation:$.profileLocation?b($.profileLocation,P):$.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,$=>({local:m($.local,P),profileLocation:b($.profileLocation,P)}))}throw new Error("Invalid listen")}async call(w,d,P){const $=this.b(w);switch(d){case"zip":{const c=R(P[0],$),h=await this.a.zip(c);return b(h,$)}case"install":return this.a.install(A(P[0],$),p(P[1],$));case"installFromLocation":return this.a.installFromLocation(A(P[0],$),A(P[1],$));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(P[0],A(P[1],$),A(P[2],$));case"getManifest":return this.a.getManifest(A(P[0],$));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(P[0]);case"installFromGallery":return this.a.installFromGallery(P[0],p(P[1],$));case"installGalleryExtensions":{const c=P[0];return this.a.installGalleryExtensions(c.map(({extension:h,options:i})=>({extension:h,options:p(i,$)??{}})))}case"uninstall":return this.a.uninstall(R(P[0],$),p(P[1],$));case"uninstallExtensions":{const c=P[0];return this.a.uninstallExtensions(c.map(({extension:h,options:i})=>({extension:R(h,$),options:p(i,$)})))}case"reinstallFromGallery":return this.a.reinstallFromGallery(R(P[0],$));case"getInstalled":return(await this.a.getInstalled(P[0],A(P[1],$),P[2])).map(h=>m(h,$));case"toggleAppliationScope":{const c=await this.a.toggleAppliationScope(R(P[0],$),A(P[1],$));return m(c,$)}case"copyExtensions":return this.a.copyExtensions(A(P[0],$),A(P[1],$));case"updateMetadata":{const c=await this.a.updateMetadata(R(P[0],$),P[1],A(P[2],$));return m(c,$)}case"resetPinnedStateForAllUserExtensions":return this.a.resetPinnedStateForAllUserExtensions(P[0]);case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(P[0],P[1],P[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Fq=f;class l extends a.$Zc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(w){super(),this.m=w,this.c=this.B(new I.$qe),this.f=this.B(new I.$qe),this.g=this.B(new I.$qe),this.h=this.B(new I.$qe),this.j=this.B(new I.$qe),this.B(this.m.listen("onInstallExtension")(d=>this.n(this.c,{...d,source:this.r(d.source)?k.URI.revive(d.source):d.source,profileLocation:k.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(d=>this.n(this.f,d.map(P=>({...P,local:P.local?R(P.local,null):P.local,source:this.r(P.source)?k.URI.revive(P.source):P.source,profileLocation:k.URI.revive(P.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(d=>this.n(this.g,{...d,profileLocation:k.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(d=>this.n(this.h,{...d,profileLocation:k.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(d=>this.n(this.j,{profileLocation:k.URI.revive(d.profileLocation),local:R(d.local,null)})))}n(w,d){w.fire(d)}r(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(w){const d=await this.getTargetPlatform();return w.allTargetPlatforms.some(P=>(0,C.$pp)(P,w.allTargetPlatforms,d))}zip(w){return Promise.resolve(this.m.call("zip",[w]).then(d=>k.URI.revive(d)))}install(w,d){return Promise.resolve(this.m.call("install",[w,d])).then(P=>R(P,null))}installFromLocation(w,d){return Promise.resolve(this.m.call("installFromLocation",[w,d])).then(P=>R(P,null))}async installExtensionsFromProfile(w,d,P){return(await this.m.call("installExtensionsFromProfile",[w,d,P])).map(c=>R(c,null))}getManifest(w){return Promise.resolve(this.m.call("getManifest",[w]))}installFromGallery(w,d){return Promise.resolve(this.m.call("installFromGallery",[w,d])).then(P=>R(P,null))}async installGalleryExtensions(w){return(await this.m.call("installGalleryExtensions",[w])).map(P=>({...P,local:P.local?R(P.local,null):P.local,source:this.r(P.source)?k.URI.revive(P.source):P.source,profileLocation:k.URI.revive(P.profileLocation)}))}uninstall(w,d){if(w.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[w,d]))}uninstallExtensions(w){if(w.some(d=>d.extension.isWorkspaceScoped))throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstallExtensions",[w]))}reinstallFromGallery(w){return Promise.resolve(this.m.call("reinstallFromGallery",[w])).then(d=>R(d,null))}getInstalled(w=null,d,P){return Promise.resolve(this.m.call("getInstalled",[w,d,P])).then($=>$.map(c=>R(c,null)))}updateMetadata(w,d,P){return Promise.resolve(this.m.call("updateMetadata",[w,d,P])).then($=>R($,null))}resetPinnedStateForAllUserExtensions(w){return this.m.call("resetPinnedStateForAllUserExtensions",[w])}toggleAppliationScope(w,d){return this.m.call("toggleAppliationScope",[w,d]).then(P=>R(P,null))}copyExtensions(w,d){return this.m.call("copyExtensions",[w,d])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(w,d,P){const $=await this.m.call("download",[w,d,P]);return k.URI.revive($)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Gq=l;class g{constructor(w){this.a=w}listen(w,d){throw new Error("Invalid listen")}call(w,d,P){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(k.URI.revive(P[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Hq=g}),define(ue[190],de([0,1,2,34,7]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;class k extends I.$Zc{constructor(C,A,b,R,p){super(),this.a=C,this.b=A,this.c=b,this.f=p,this.B(R.onDidInstallExtensions(m=>this.g(m))),this.B(R.onDidUninstallExtension(m=>this.h(m)))}g(C){for(const A of C)A.local&&this.invalidate(A.profileLocation)}h(C){C.error||this.invalidate(C.profileLocation)}async invalidate(C){if(C)for(const A of this.a.profiles)this.c.extUri.isEqual(A.extensionsResource,C)&&await this.j(A);else await this.j(this.a.defaultProfile)}async j(C){try{await this.b.del(this.c.extUri.joinPath(C.cacheHome,a.$rn))}catch(A){(0,N.$wl)(A)!==N.FileOperationResult.FILE_NOT_FOUND&&this.f.error(A)}}}e.$5q=k});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ue[59],de([0,1,20,92,9,60,34,161]),function(ce,e,I,a,N,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=R,e.$7p=p,e.$8p=m,e.$9p=f,e.$0p=l,e.$$p=g,e.$_p=E,e.$aq=w,a=it(a),N=Oe(N),k=Oe(k);const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function R($){return $=$.trim(),$==="*"||A.test($)}function p($){if(!R($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=$.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}function m($){if(!$)return null;const c=$.majorBase,h=$.majorMustEqual,i=$.minorBase;let n=$.minorMustEqual;const t=$.patchBase;let s=$.patchMustEqual;$.hasCaret&&(c===0||(n=!1),s=!1);let r=0;if($.preRelease){const o=b.exec($.preRelease);if(o){const[,u,y,O]=o;r=Date.UTC(Number(u),Number(y)-1,Number(O))}}return{majorBase:c,majorMustEqual:h,minorBase:i,minorMustEqual:n,patchBase:t,patchMustEqual:s,isMinimum:$.hasGreaterEquals,notBefore:r}}function f($,c,h){let i;typeof $=="string"?i=m(p($)):i=$;let n;c instanceof Date?n=c.getTime():typeof c=="string"&&(n=new Date(c).getTime());let t;if(typeof h=="string"?t=m(p(h)):t=h,!i||!t)return!1;const s=i.majorBase,r=i.minorBase,o=i.patchBase;let u=t.majorBase,y=t.minorBase,O=t.patchBase;const S=t.notBefore;let v=t.majorMustEqual,L=t.minorMustEqual,j=t.patchMustEqual;return t.isMinimum?s>u?!0:s<u?!1:r>y?!0:r<y||n&&n<S?!1:o>=O:(s===1&&u===0&&(!v||!L||!j)&&(u=1,y=0,O=0,v=!0,L=!1,j=!1),s<u?!1:s>u?!v:r<y?!1:r>y?!L:o<O?!1:o>O?!j:!(n&&n<S))}function l($,c,h,i,n,t){const s=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return s.push([a.default.Error,N.localize(1832,null)]),s;if(typeof i.name!="string")return s.push([a.default.Error,N.localize(1833,null,"name")]),s;if(typeof i.version!="string")return s.push([a.default.Error,N.localize(1834,null,"version")]),s;if(!i.engines)return s.push([a.default.Error,N.localize(1835,null,"engines")]),s;if(typeof i.engines.vscode!="string")return s.push([a.default.Error,N.localize(1836,null,"engines.vscode")]),s;if(typeof i.extensionDependencies<"u"&&!P(i.extensionDependencies))return s.push([a.default.Error,N.localize(1837,null,"extensionDependencies")]),s;if(typeof i.activationEvents<"u"){if(!P(i.activationEvents))return s.push([a.default.Error,N.localize(1838,null,"activationEvents")]),s;if(typeof i.main>"u"&&typeof i.browser>"u")return s.push([a.default.Error,N.localize(1839,null,"activationEvents","main","browser")]),s}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&s.push([a.default.Warning,N.localize(1840,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return s.push([a.default.Error,N.localize(1841,null,"main")]),s;{const u=(0,I.$lh)(h,i.main);(0,I.$fh)(u,h)||s.push([a.default.Warning,N.localize(1842,null,u.path,h.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return s.push([a.default.Error,N.localize(1843,null,"browser")]),s;{const u=(0,I.$lh)(h,i.browser);(0,I.$fh)(u,h)||s.push([a.default.Warning,N.localize(1844,null,u.path,h.path)])}}if(!k.valid(i.version))return s.push([a.default.Error,N.localize(1845,null)]),s;const r=[];if(!g($,c,i,n,r))for(const u of r)s.push([a.default.Error,u]);if(t&&i.enabledApiProposals?.length){const u=[];if(!w([...i.enabledApiProposals],u))for(const y of u)s.push([a.default.Error,y])}return s}function g($,c,h,i,n){return i||typeof h.main>"u"&&typeof h.browser>"u"?!0:d($,c,h.engines.vscode,n)}function E($,c,h){return $==="*"||d(c,h,$)}function w($,c){if($.length===0)return!0;const h=Array.isArray(c)?c:void 0,i=(h?void 0:c)??C.allApiProposals,n=[],t=(0,T.$En)($);for(const{proposalName:s,version:r}of t){const o=i[s];o&&r&&o.version!==r&&n.push(N.localize(1846,null,s))}return h?.push(...n),n.length===0}function d($,c,h,i=[]){const n=m(p(h));if(!n)return i.push(N.localize(1847,null,h)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return i.push(N.localize(1848,null,h)),!1}else if(!n.majorMustEqual)return i.push(N.localize(1849,null,h)),!1;return f($,c,n)?!0:(i.push(N.localize(1850,null,$,h)),!1)}function P($){if(!Array.isArray($))return!1;for(let c=0,h=$.length;c<h;c++)if(typeof $[c]!="string")return!1;return!0}}),define(ue[79],de([0,1,25,2,5,9,27,4]),function(ce,e,I,a,N,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=void 0,e.$gs=A;function A(R){return R.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.$hs=(0,C.$Ki)("languagePackService");let b=class extends a.$Zc{constructor(p){super(),this.c=p}async getAvailableLanguages(){const p=new I.$Be;setTimeout(()=>p.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const l=m.firstPage.filter(g=>g.properties.localizedLanguages?.length&&g.tags.some(E=>E.startsWith("lp-"))).map(g=>{const E=g.properties.localizedLanguages?.[0],w=A(g);return{...this.f(w,E,g),extensionId:g.identifier.id,galleryExtension:g}});return l.push(this.f("en","English")),l}f(p,m,f){const l=m??p;let g;if(l!==p&&(g=`(${p})`),p.toLowerCase()===N.$z.toLowerCase()&&(g??="",g+=(0,k.localize)(1928,null)),f?.installCount){g??="";const E=f.installCount;let w;E>1e6?w=`${Math.floor(E/1e5)/10}M`:E>1e3?w=`${Math.floor(E/1e3)}K`:w=String(E),g+=` $(cloud-download) ${w}`}return{id:p,label:l,description:g}}};e.$is=b,e.$is=b=Ee([Z(0,T.$rp)],b)}),define(ue[191],de([0,1,2,79]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ajc=void 0;let N=class extends I.$Zc{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};e.$Ajc=N,e.$Ajc=N=Ee([Z(0,a.$hs)],N)}),define(ue[108],de([0,1,2,4]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=void 0,e.$2l=(0,a.$Ki)("remoteSocketFactoryService");class N{constructor(){this.a={}}register(T,C){return this.a[T]??=[],this.a[T].push(C),(0,I.$Xc)(()=>{const A=this.a[T]?.indexOf(C);typeof A=="number"&&A>=0&&this.a[T]?.splice(A,1)})}b(T){return(this.a[T.type]||[]).find(A=>A.supports(T))}connect(T,C,A,b){const R=this.b(T);if(!R)throw new Error(`No socket factory found for ${T}`);return R.connect(T,C,A,b)}}e.$3l=N}),define(ue[192],de([0,1,4]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ojc=e.$Njc=void 0,e.$Njc=(0,I.$Ki)("sharedProcessTunnelService"),e.$Ojc="sharedProcessTunnel"}),define(ue[109],de([0,1,4,9]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=e.$Xjc=e.$Wjc=e.$Vjc=e.$Ujc=e.TunnelStates=e.$Tjc=e.$Sjc=void 0,e.$Sjc=(0,I.$Ki)("IRemoteTunnelService"),e.$Tjc={active:!1};var N;(function(k){k.disconnected=T=>({type:"disconnected",onTokenFailed:T}),k.connected=(T,C)=>({type:"connected",info:T,serviceInstallFailed:C}),k.connecting=T=>({type:"connecting",progress:T}),k.uninitialized={type:"uninitialized"}})(N||(e.TunnelStates=N={})),e.$Ujc="remote.tunnels.access",e.$Vjc=e.$Ujc+".hostNameOverride",e.$Wjc=e.$Ujc+".preventSleep",e.$Xjc="remoteTunnelService",e.$Yjc=(0,a.localize)(2044,null)}),define(ue[61],de([0,1,14,8,2,9,47,4,11,44]),function(ce,e,I,a,N,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0,e.$dq=m,e.$eq=f,e.$fq=l,e.$gq=g,e.$hq=E,e.$iq=w,e.$bq=(0,C.$Ki)("requestService");class R{constructor(c){this.b=c}toJSON(){if(!this.a){const c=Object.create(null);for(const h in this.b)h.toLowerCase()==="authorization"||h.toLowerCase()==="proxy-authorization"?c[h]="*****":c[h]=this.b[h];this.a=c}return this.a}}class p extends N.$Zc{constructor(c){super(),this.b=0,this.a=c.createLogger("network",{name:(0,k.localize)(2050,null),when:A.$xk.isEqualTo((0,A.$uk)(A.LogLevel.Trace)).serialize()})}async c(c,h,i){const n=`${c} #${++this.b}: ${h.url}`;this.a.trace(`${n} - begin`,h.type,new R(h.headers??{}));try{const t=await i();return this.a.trace(`${n} - end`,h.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${n} - error`,h.type,(0,a.$bb)(t)),t}}}e.$cq=p;function m($){return $.res.statusCode&&$.res.statusCode>=200&&$.res.statusCode<300||$.res.statusCode===1223}function f($){return $.res.statusCode===204}async function l($){return f($)?null:(await(0,I.$5e)($.stream)).toString()}async function g($){if(!m($))throw new Error("Server returned "+$.res.statusCode);return l($)}async function E($){if(!m($))throw new Error("Server returned "+$.res.statusCode);if(f($))return null;const h=(await(0,I.$5e)($.stream)).toString();try{return JSON.parse(h)}catch(i){throw i.message+=`:
`+h,i}}function w($){P($)}let d;function P($){const c=b.$xo.as(T.$Co.Configuration),h=d;d={id:"http",order:15,title:(0,k.localize)(2051,null),type:"object",scope:$,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,k.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(2057,null),(0,k.localize)(2058,null),(0,k.localize)(2059,null),(0,k.localize)(2060,null)],default:"override",description:(0,k.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(2063,null),restricted:!0}}},c.updateConfigurations({add:[d],remove:h?[h]:[]})}P(T.ConfigurationScope.APPLICATION)}),define(ue[193],de([0,1,25,22,7,61]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pS=void 0;let T=class{constructor(A,b){this.a=A,this.b=b}async download(A,b,R=I.CancellationToken.None){if(A.scheme===a.Schemas.file||A.scheme===a.Schemas.vscodeRemote){await this.b.copy(A,b);return}const p={type:"GET",url:A.toString(!0)},m=await this.a.request(p,R);if(m.res.statusCode===200)await this.b.writeFile(b,m.stream);else{const f=await(0,k.$gq)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${f}`)}}};e.$pS=T,e.$pS=T=Ee([Z(0,k.$bq),Z(1,N.$fl)],T)}),define(ue[194],de([0,1,14,25]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=void 0;class N{constructor(C){this.a=C}listen(C,A){throw new Error("Invalid listen")}call(C,A,b,R=a.CancellationToken.None){switch(A){case"request":return this.a.request(b[0],R).then(async({res:p,stream:m})=>{const f=await(0,I.$5e)(m);return[{statusCode:p.statusCode,headers:p.headers},f]});case"resolveProxy":return this.a.resolveProxy(b[0]);case"lookupAuthorization":return this.a.lookupAuthorization(b[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(b[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$ks=N;class k{constructor(C){this.a=C}async request(C,A){const[b,R]=await this.a.call("request",[C],A);return{res:b,stream:(0,I.$7e)(R)}}async resolveProxy(C){return this.a.call("resolveProxy",[C])}async lookupAuthorization(C){return this.a.call("lookupAuthorization",[C])}async lookupKerberosAuthorization(C){return this.a.call("lookupKerberosAuthorization",[C])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$ls=k}),define(ue[195],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=e.$mic=e.$lic=void 0,e.$lic={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$mic={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$nic={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ue[196],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(N){try{const k=await this.c();if(k){const T=String(I.a++);return this.b.set(T,k),{id:T,data:k.createNewMessage(N)}}}catch{}return{id:"",data:N}}async validate(N,k){if(!N.id)return!0;const T=this.b.get(N.id);if(!T)return!1;this.b.delete(N.id);try{return T.validate(k)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(N){try{return await this.d(N)}catch{}return N}}e.$7dc=I}),define(ue[110],de([0,1,4]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=void 0,e.$4l="signService",e.$5l=(0,I.$Ki)(e.$4l)}),define(ue[197],de([0,1,69,196]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=void 0;class N extends a.$7dc{c(){return this.h().then(T=>new T.validator)}d(T){return this.h().then(C=>new C.signer().sign(T))}async h(){return(0,I.$zq)("vsda","index.js")}}e.$djc=N}),define(ue[80],de([0,1,3,2]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XNb=e.$WNb=e.$VNb=e.$UNb=void 0;class N extends a.$Zc{constructor(p,m,f){super(),this.a=p,this.b=m,this.c=f}async getItems(){const p={profile:this.b,workspace:this.c},m=await this.a.call("getItems",p);return new Map(m)}updateItems(p){const m={profile:this.b,workspace:this.c};return p.insert&&(m.insert=Array.from(p.insert.entries())),p.delete&&(m.delete=Array.from(p.delete.values())),this.a.call("updateItems",m)}optimize(){const p={profile:this.b,workspace:this.c};return this.a.call("optimize",p)}}class k extends N{constructor(p,m){super(p,m,void 0),this.f=this.B(new I.$qe),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(p=>this.h(p)))}h(p){(Array.isArray(p.changed)||Array.isArray(p.deleted))&&this.f.fire({changed:p.changed?new Map(p.changed):void 0,deleted:p.deleted?new Set(p.deleted):void 0})}}class T extends k{constructor(p){super(p,void 0)}async close(){this.dispose()}}e.$UNb=T;class C extends k{constructor(p,m){super(p,m)}async close(){this.dispose()}}e.$VNb=C;class A extends N{constructor(p,m){super(p,void 0,m),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$WNb=A;class b{constructor(p){this.a=p}isUsed(p){const m={payload:p,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.$XNb=b}),define(ue[111],de([0,1,5,37,32]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=T,e.$Cp=C;function k(A){if(I.$x===I.Platform.Linux&&/^penguin(\.|$)/i.test(A))return"chromebook"}function T(A,b,R,p,m,f,l,g,E,w){const d=Object.create(null);d["common.machineId"]=f,d["common.sqmId"]=l,d["common.devDeviceId"]=g,d.sessionID=(0,N.$7g)()+Date.now(),d.commitHash=p,d.version=m,d["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,I.$k)(I.$x),d["common.nodePlatform"]=a.$ic,d["common.nodeArch"]=R,d["common.product"]=w||"desktop",E&&(d["common.msftInternal"]=E);let P=0;const $=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),I.$o&&(d["common.snap"]="true");const c=k(b);return c&&(d["common.platformDetail"]=c),d}function C(A){const b=a.env.USERDNSDOMAIN;if(!b)return!1;const R=b.toLowerCase();return A.some(p=>R===p)}}),define(ue[18],de([0,1,4]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em=(0,I.$Ki)("telemetryService"),e.$fm=(0,I.$Ki)("customEndpointTelemetryService"),e.$gm="telemetry.currentSessionDate",e.$hm="telemetry.firstSessionDate",e.$im="telemetry.lastSessionDate",e.$jm="telemetry.machineId",e.$km="telemetry.sqmId",e.$lm="telemetry.devDeviceId",e.$mm="telemetry",e.$nm="telemetry.telemetryLevel",e.$om="telemetry.enableCrashReporter",e.$pm="telemetry.enableTelemetry";var a;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(a||(e.TelemetryLevel=a={}));var N;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(N||(e.TelemetryConfiguration=N={}))}),define(ue[198],de([0,1,33,38,6,36,22,13,5,54,10,148,30,153,99,7,23,18]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0,e.$7s=P,e.$8s=c,e.$9s=h,I=Oe(I),a=Oe(a);const d=new Map;async function P(n,t){const s=`${n}::${t.join(":")}`,r=d.get(s);if(r)return r;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i},{tag:"cursorrules",filePattern:/^\.cursorrules$/i}],u=new Map,y=new Map,O=2e4;function S(L,j,U,F){const G=j.substring(L.length+1);return N.Promises.withAsyncBody(async V=>{let x;F.readdirCount++;try{x=await m.Promises.readdir(j,{withFileTypes:!0})}catch{V();return}if(F.count>=O){F.count+=x.length,F.maxReached=!0,V();return}let H=x.length;if(H===0){V();return}let te=x;F.count+x.length>O&&(F.maxReached=!0,H=O-F.count,te=x.slice(0,H)),F.count+=x.length;for(const z of te)if(z.isDirectory()){if(U.includes(z.name)||await S(L,(0,C.$oc)(j,z.name),U,F),--H===0){V();return}}else{const W=z.name.lastIndexOf(".");if(W>=0){const _=z.name.substring(W+1);_&&u.set(_,(u.get(_)??0)+1)}for(const _ of o)_.relativePathPattern?.test(G)!==!1&&_.filePattern.test(z.name)&&y.set(_.tag,(y.get(_.tag)??0)+1);if(--H===0){V();return}}})}const v=N.Promises.withAsyncBody(async L=>{const j={count:0,maxReached:!1,readdirCount:0},U=new b.$ke(!0);await S(n,n,t,j);const F=await h(n);L({configFiles:$(y),fileTypes:$(u),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:F,totalScanTime:U.elapsed(),totalReaddirCount:j.readdirCount})});return d.set(s,v),v}function $(n){return Array.from(n.entries(),([t,s])=>({name:t,count:s})).sort((t,s)=>s.count-t.count)}function c(){const n={os:`${a.type()} ${a.arch()} ${a.release()}`,memory:`${(a.totalmem()/g.$Nl.GB).toFixed(2)}GB (${(a.freemem()/g.$Nl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(p.$Yn.value()*100)}%`},t=a.cpus();return t&&t.length>0&&(n.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),n}async function h(n){try{const t=new Map,s=(0,C.$oc)(n,".vscode","launch.json"),r=await I.promises.readFile(s),o=[],u=(0,k.$5n)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,k.$ao)(u)==="object"&&u.configurations)for(const y of u.configurations){const O=y.type;O&&(t.has(O)?t.set(O,t.get(O)+1):t.set(O,1))}return $(t)}catch{return[]}}let i=class{constructor(t,s){this.c=t,this.d=s}f(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}g(t){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${a.type()} ${a.arch()} ${a.release()}`);const r=a.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(a.totalmem()/g.$Nl.GB).toFixed(2)}GB (${(a.freemem()/g.$Nl.GB).toFixed(2)}GB free)`),A.$l||s.push(`Load (avg):       ${a.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(p.$Yn.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,f.$6s)(t.mainPID),this.k(t)]).then(async r=>{let[o,u]=r,y=this.m(t,o);return s.forEach(O=>{if((0,l.$Zm)(O))y+=`
${O.errorMessage}`,u+=`
${O.errorMessage}`;else if(y+=`

Remote: ${O.hostName}`,O.processes&&(y+=`
${this.m(t,O.processes)}`),O.workspaceMetadata){u+=`
|  Remote: ${O.hostName}`;for(const S of Object.keys(O.workspaceMetadata)){const v=O.workspaceMetadata[S];let L=`${v.fileCount} files`;v.maxFilesReached&&(L=`more than ${L}`),u+=`|    Folder (${S}): ${L}`,u+=this.h(v)}}}),{processInfo:y,workspaceInfo:u}})}async getSystemInfo(t,s){const{memory:r,vmHint:o,os:u,cpus:y}=c(),O={os:u,memory:r,cpus:y,vmHint:o,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return A.$l||(O.load=`${a.loadavg().map(S=>Math.round(S)).join(", ")}`),A.$n&&(O.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(O)}async getDiagnostics(t,s){const r=[];return(0,f.$6s)(t.mainPID).then(async o=>(r.push(""),r.push(this.g(t)),r.push(""),r.push(this.m(t,o)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(t))),s.forEach(u=>{if((0,l.$Zm)(u))r.push(`
${u.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${u.hostName}`),r.push(this.f(u.machineInfo)),u.processes&&r.push(this.m(t,u.processes)),u.workspaceMetadata)for(const y of Object.keys(u.workspaceMetadata)){const O=u.workspaceMetadata[y];let S=`${O.fileCount} files`;O.maxFilesReached&&(S=`more than ${S}`),r.push(`Folder (${y}): ${S}`),r.push(this.h(O))}}),r.push(""),r.push(""),r.join(`
`)))}h(t){const s=[];let o=0;const u=(v,L)=>{const j=` ${v}(${L})`;o+j.length>60?(s.push(y),y="|                 ",o=y.length):o+=j.length,y+=j};let y="|      File types:";const O=10,S=t.fileTypes.length>O?O:t.fileTypes.length;for(let v=0;v<S;v++){const L=t.fileTypes[v];u(L.name,L.count)}if(s.push(y),t.configFiles.length>=0&&(y="|      Conf files:",o=0,t.configFiles.forEach(v=>{u(v.name,v.count)}),s.push(y)),t.launchConfigFiles.length>0){let v="|      Launch Configs:";t.launchConfigFiles.forEach(L=>{const j=L.count>1?` ${L.name}(${L.count})`:` ${L.name}`;v+=j}),s.push(v)}return s.join(`
`)}j(t){const s=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${t[r]}`).join(`
                  `)}k(t){const s=[],r=[];return t.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const y=R.URI.revive(u);if(y.scheme===T.Schemas.file){const O=y.fsPath;r.push(P(O,["node_modules",".git"]).then(S=>{let v=`${S.fileCount} files`;S.maxFilesReached&&(v=`more than ${v}`),s.push(`|    Folder (${(0,C.$sc)(O)}): ${v}`),s.push(this.h(S))}).catch(S=>{s.push(`|      Error: Unable to collect workspace stats for folder ${O} (${S.toString()})`)}))}else s.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(t,s){const r=new Map;t.windows.forEach(u=>r.set(u.pid,`window [${u.id}] (${u.title})`)),t.pidToNames.forEach(({pid:u,name:y})=>r.set(u,y));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.n(t.mainPID,r,o,s,0),o.join(`
`)}n(t,s,r,o,u){const y=u===0;let O;y?O=o.pid===t?`${this.d.applicationName} main`:"remote agent":s.has(o.pid)?O=s.get(o.pid):O=`${"  ".repeat(u)} ${o.name}`;const S=process.platform==="win32"?o.mem:a.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(S/g.$Nl.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${O}`),Array.isArray(o.children)&&o.children.forEach(v=>this.n(t,s,r,v,u+1))}async getWorkspaceFileExtensions(t){const s=new Set;for(const{uri:r}of t.folders){const o=R.URI.revive(r);if(o.scheme!==T.Schemas.file)continue;const u=o.fsPath;try{(await P(u,["node_modules",".git"])).fileTypes.forEach(O=>s.add(O.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const r=R.URI.revive(s);if(r.scheme!==T.Schemas.file)continue;const o=r.fsPath;try{const u=await P(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(y=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),u.launchConfigFiles.forEach(y=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),u.configFiles.forEach(y=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:u.totalScanTime,reachedLimit:u.maxFilesReached,fileCount:u.fileCount,readdirCount:u.totalReaddirCount})}catch{}}}};e.$0s=i,e.$0s=i=Ee([Z(0,w.$em),Z(1,E.$yk)],i)}),define(ue[112],de([0,1,69,8,4,11,18]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.ExtensionSignatureVerificationCode=e.$Bq=void 0,e.$Bq=(0,N.$Ki)("IExtensionSignatureVerificationService");var C;(function(R){R.Success="Success",R.RequiredArgumentMissing="RequiredArgumentMissing",R.InvalidArgument="InvalidArgument",R.PackageIsUnreadable="PackageIsUnreadable",R.UnhandledException="UnhandledException",R.SignatureManifestIsMissing="SignatureManifestIsMissing",R.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",R.SignatureIsMissing="SignatureIsMissing",R.SignatureIsUnreadable="SignatureIsUnreadable",R.CertificateIsUnreadable="CertificateIsUnreadable",R.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",R.FileAlreadyExists="FileAlreadyExists",R.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",R.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",R.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",R.SignatureIsInvalid="SignatureIsInvalid",R.SignatureManifestIsInvalid="SignatureManifestIsInvalid",R.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",R.EntryIsMissing="EntryIsMissing",R.EntryIsTampered="EntryIsTampered",R.Untrusted="Untrusted",R.CertificateRevoked="CertificateRevoked",R.SignatureIsNotValid="SignatureIsNotValid",R.UnknownError="UnknownError",R.PackageIsInvalidZip="PackageIsInvalidZip",R.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(C||(e.ExtensionSignatureVerificationCode=C={}));class A extends Error{constructor(p){super(p),this.code=p}}e.$Cq=A;let b=class{constructor(p,m){this.b=p,this.c=m}d(){return this.a||(this.a=this.f()),this.a}async f(){return(0,I.$zq)("@vscode/vsce-sign","src/main.js")}async verify(p,m,f,l){let g;const E=p.identifier.id;try{g=await this.d()}catch($){return this.b.error("Could not load vsce-sign module",(0,a.$bb)($)),this.b.info(`Extension signature verification is not done: ${E}`),!1}const w=new Date().getTime();let d;try{this.b.trace(`Verifying extension signature for ${E}...`),d=await g.verify(m,f,this.b.getLevel()===k.LogLevel.Trace)}catch($){d={code:C.UnknownError,didExecute:!1,output:(0,a.$bb)($)}}const P=new Date().getTime()-w;if(this.b.info(`Extension signature verification result for ${E}: ${d.code}. Executed: ${d.didExecute}. Duration: ${P}ms.`),this.b.trace(`Extension signature verification output for ${E}:
${d.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:E,extensionVersion:p.version,code:d.code,internalCode:d.internalCode,duration:P,didExecute:d.didExecute,clientTargetPlatform:l}),d.code===C.Success)return!0;throw new A(d.code)}};e.$Dq=b,e.$Dq=b=Ee([Z(0,k.$fk),Z(1,T.$em)],b)}),define(ue[113],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ric=e.$qic=void 0;class I{constructor(k){this.b=k}listen(k,T){throw new Error(`Event not found: ${T}`)}call(k,T,{eventName:C,data:A}){return this.b.forEach(b=>b.log(C,A)),Promise.resolve(null)}}e.$qic=I;class a{constructor(k){this.b=k}log(k,T){return this.b.call("log",{eventName:k,data:T}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$ric=a}),define(ue[48],de([0,1,29,12,107,111,18]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=void 0,e.$Kp=R,e.$Lp=p,e.$Mp=m,e.$Np=f,e.$Op=g,e.$Pp=w,e.$Qp=d,e.$Rp=c;class C{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$Dp=C;class A{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ep=A,e.$Fp=new A;class b{async publicLog(i,n,t){}async publicLogError(i,n,t){}}e.$Gp=b,e.$Hp="telemetry",e.$Ip="extensionTelemetryLog",e.$Jp={log:()=>null,flush:()=>Promise.resolve(null)};function R(h,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!h.enableTelemetry)}function p(h,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}function m(h){const i=h.getValue(T.$nm),n=h.getValue(T.$om);if(h.getValue(T.$pm)===!1||n===!1)return T.TelemetryLevel.NONE;switch(i??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function f(h){const i={},n={},t={};E(h,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const r=t[s];typeof r=="number"?n[s]=r:typeof r=="boolean"?n[s]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${r.length}`),i[s]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(i[s]=r)}return{properties:i,measurements:n}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(h){if(!h)return"none";const i=(0,N.$on)(h);return l.has(i)?i:"other"}function E(h,i,n=0,t){if(h)for(const s of Object.getOwnPropertyNames(h)){const r=h[s],o=t?t+s:s;Array.isArray(r)?i[o]=(0,I.$po)(r):r instanceof Date?i[o]=r.toISOString():(0,a.$lg)(r)?n<2?E(r,i,n+1,o+"."):i[o]=(0,I.$po)(r):i[o]=r}}function w(h,i){const n=h.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,k.$Cp)(n)||t}function d(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}function P(h,i){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let n=h;const t=[];for(const u of i)for(;;){const y=u.exec(h);if(!y)break;t.push([y.index,u.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(n="";;){const u=r.exec(h);if(!u)break;const y=t.some(([O,S])=>u.index<S&&O<r.lastIndex);!s.test(u[0])&&!y&&(n+=h.substring(o,u.index)+"<REDACTED: user-file-path>",o=r.lastIndex)}return o<h.length&&(n+=h.substr(o)),n}function $(h){if(!h)return h;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of i)if(n.regex.test(h))return`<REDACTED: ${n.label}>`;return h}function c(h,i){return(0,I.$mo)(h,n=>{if(n instanceof C||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let t=n.replaceAll("%20"," ");t=P(t,i);for(const s of i)t=t.replace(s,"");return t=$(t),t}})}}),define(ue[35],de([0,1,26,27,34,5,10,8,37,48]),function(ce,e,I,a,N,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$Tp=void 0,e.$Sp=R,e.$Up=l,e.$Vp=g,e.$Wp=E,e.$Xp=w,e.$Yp=d,e.$Zp=P,e.$1p=$,e.$3p=c,e.$4p=i;function R(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,I.$Ff)(n.id,t.id)===0}const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(t){const s=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new m(t.identifier,s,r)}static parse(t){const s=p.exec(t);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,r=N.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==N.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof m?R(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Tp=m;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(n){const t=f.exec(n);return t&&t[1]?[E(t[1]),t[2]]:[E(n),void 0]}function g(n,t){return`${n}.${t}`}function E(n){return n.toLowerCase()}function w(n,t){return E(g(n??N.$tn,t))}function d(n,t){const s=[],r=o=>{for(const u of s)if(u.some(y=>R(t(y),t(o))))return u;return null};for(const o of n){const u=r(o);u?u.push(o):s.push([o])}return s}function P(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function $(n){return{id:new b.$Dp(n.identifier.id),name:new b.$Dp(n.name),version:n.version,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$2p=new N.$xn("pprice.better-merge");function c(n,t){const s=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&s.every(u=>!R(u.identifier,{id:o}))){const u=n.filter(y=>R(y.identifier,{id:o}));u.length===1&&(s.push(u[0]),r.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function h(n,t){if(!k.$n)return!1;let s;try{s=(await n.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){t.debug("Error while getting the os-release file.",(0,C.$bb)(o))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(n,t){const s=await h(n,t),r=(0,a.$np)(s?"alpine":k.$x,A.$jc);return t.debug("ComputeTargetPlatform:",r),r}}),define(ue[199],de([0,1,25,27,35,34]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$98b=T;async function T(C,A,b,R,p){try{const m=await C.getExtensionsControlManifest();if(!m.deprecated)return;const f=await C.getInstalled(k.ExtensionType.User);for(const[l,g]of Object.entries(m.deprecated)){if(!g?.extension)continue;const{id:E,autoMigrate:w,preRelease:d}=g.extension;if(!w)continue;const P=f.find(c=>(0,N.$Sp)(c.identifier,{id:l}));if(!P)continue;const $=(await A.getExtensions([{id:E,preRelease:d}],{targetPlatform:await C.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!$){p.info(`Skipping migrating '${P.identifier.id}' extension because, the comaptible target '${E}' extension is not found`);continue}try{p.info(`Migrating '${P.identifier.id}' extension to '${E}' extension...`);const c=!R.getDisabledExtensions().some(i=>(0,N.$Sp)(i,P.identifier));await C.uninstall(P),p.info(`Uninstalled the unsupported extension '${P.identifier.id}'`);let h=f.find(i=>(0,N.$Sp)(i.identifier,{id:E}));(!h||!h.isPreReleaseVersion&&c)&&(h=await C.installFromGallery($,{installPreReleaseVersion:!0,isMachineScoped:P.isMachineScoped,operation:a.InstallOperation.Migrate}),p.info(`Installed the pre-release extension '${h.identifier.id}'`),c||(await R.disableExtension(h.identifier),p.info(`Disabled the pre-release extension '${h.identifier.id}' because the unsupported extension '${P.identifier.id}' is disabled`)),w.storage&&(b.addToMigrationList((0,N.$Vp)(P.manifest.publisher,P.manifest.name),(0,N.$Vp)(h.manifest.publisher,h.manifest.name)),p.info("Added pre-release extension to the storage migration list"))),p.info(`Migrated '${P.identifier.id}' extension to '${E}' extension.`)}catch(c){p.error(c)}}}catch(m){p.error(m)}}}),define(ue[200],de([0,1,8,3,2,31,35,34,7]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class b extends N.$Zc{constructor(p,m,f,l,g,E,w){super(),this.f=p,this.g=m,this.h=f,this.j=l,this.m=g,this.n=E,this.r=w,this.a=this.B(new a.$qe),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$9c),this.s().then(null,d=>w.error("Error while initializing Extensions Watcher",(0,I.$bb)(d)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(p=>this.u(p.added))),this.B(this.j.onAddExtensions(p=>this.w(p))),this.B(this.j.onDidAddExtensions(p=>this.y(p))),this.B(this.j.onRemoveExtensions(p=>this.z(p))),this.B(this.j.onDidRemoveExtensions(p=>this.C(p))),this.B(this.n.onDidFilesChange(p=>this.D(p)))}async u(p){try{p.length&&await Promise.all(p.map(m=>(this.c.set(m.id,(0,N.$Wc)(this.n.watch(this.m.extUri.dirname(m.extensionsResource)),this.n.watch(m.extensionsResource))),this.G(m.extensionsResource))))}catch(m){throw this.r.error(m),m}}async w(p){for(const m of p.extensions)this.I(this.L(m.identifier,m.version),p.profileLocation)}async y(p){for(const m of p.extensions){const f=this.L(m.identifier,m.version);p.error?this.J(f,p.profileLocation):this.I(f,p.profileLocation)}}async z(p){for(const m of p.extensions)this.J(this.L(m.identifier,m.version),p.profileLocation)}async C(p){const m=[],f=[];for(const l of p.extensions){const g=this.L(l.identifier,l.version);p.error?this.I(g,p.profileLocation):(this.J(g,p.profileLocation),this.b.has(g)||(this.r.debug("Extension is removed from all profiles",l.identifier.id,l.version),f.push(this.f.scanInstalledExtensionAtLocation(l.location).then(E=>{E?m.push(E):this.r.info("Extension not found at the location",l.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(f),m.length&&await this.H(m)}catch(l){this.r.error(l)}}D(p){for(const m of this.h.profiles)p.contains(m.extensionsResource,A.FileChangeType.UPDATED,A.FileChangeType.ADDED)&&this.F(m.extensionsResource)}async F(p){const m=[],f=[],l=await this.j.scanProfileExtensions(p),g=new Set,E=new Set;for(const[w,d]of this.b)d.has(p)&&E.add(w);for(const w of l){const d=this.L(w.identifier,w.version);g.add(d),E.has(d)||(m.push(w.identifier),this.I(d,p))}for(const w of E)if(!g.has(w)){const d=this.M(w);d&&(f.push(d.identifier),this.J(w,p))}(m.length||f.length)&&this.a.fire({added:m.length?{extensions:m,profileLocation:p}:void 0,removed:f.length?{extensions:f,profileLocation:p}:void 0})}async G(p){const m=await this.j.scanProfileExtensions(p);for(const f of m)this.I(this.L(f.identifier,f.version),p)}async H(p){p||(p=(await this.f.scanAllUserInstalledExtensions()).filter(f=>!this.b.has(this.L(f.identifier,f.manifest.version)))),p.length&&await this.f.markAsUninstalled(...p)}I(p,m){let f=this.b.get(p);f||this.b.set(p,f=new k.$Gc(l=>this.m.extUri.getComparisonKey(l))),f.add(m)}J(p,m){const f=this.b.get(p);f&&f.delete(m),f?.size||this.b.delete(p)}L(p,m){return`${C.$xn.toKey(p.id)}@${m}`}M(p){const[m,f]=(0,T.$Up)(p);return f?{identifier:{id:m},version:f}:void 0}}e.$6q=b}),define(ue[201],de([0,1,33,76,17,6,2,22,13,30,15,27,35,11,79,10]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0,I=Oe(I);let E=class extends l.$is{constructor($,c,h,i){super(h),this.h=$,this.j=i,this.g=this.B(new w(c,i)),this.h.registerParticipant({postInstall:async n=>this.m(n),postUninstall:async n=>this.n(n)})}async getBuiltInExtensionTranslationsUri($,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const n=i.translations[$];return n?g.URI.file(n):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),c=Object.keys($).map(h=>{const i=$[h];return{...this.f(h,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort((h,i)=>h.label.localeCompare(i.label)),c}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const c=await this.g.getLanguagePacks();Object.keys(c).some(h=>c[h]&&c[h].extensions.some(i=>(0,m.$Sp)(i.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),h=await this.g.update(c);return!(0,N.$yb)(Object.keys($),Object.keys(h))}};e.$js=E,e.$js=E=Ee([Z(0,p.$up),Z(1,R.$Si),Z(2,p.$rp),Z(3,f.$fk)],E);let w=class extends T.$Zc{constructor($,c){super(),this.j=c,this.c={},this.f=(0,A.$oc)($.userDataPath,"languagepacks.json"),this.g=new k.$Rh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(c=>{Object.keys(c).forEach(h=>delete c[h]),this.m(c,...$)}).then(()=>this.c)}m($,...c){for(const h of c)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.n($,h);Object.keys($).forEach(h=>this.r($[h]))}n($,c){const h=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const n of i)if(c.location.scheme===C.Schemas.file&&d(n)){let t=$[n.languageId];t||(t={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},$[n.languageId]=t);const s=t.extensions.filter(r=>(0,m.$Sp)(r.extensionIdentifier,h))[0];s?s.version=c.manifest.version:t.extensions.push({extensionIdentifier:h,version:c.manifest.version});for(const r of n.translations)t.translations[r.id]=(0,A.$oc)(c.location.fsPath,r.path)}}r($){if($){const c=(0,a.createHash)("md5");for(const h of $.extensions)c.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);$.hash=c.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let c=null;return I.promises.readFile(this.f,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch{return{}}}).then(h=>(c=$(h),h)).then(h=>{for(const n of Object.keys(h))h[n]||delete h[n];this.c=h,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),b.Promises.writeFile(this.f,i)}).then(()=>c,h=>this.j.error(h))})}};w=Ee([Z(0,R.$Si),Z(1,f.$fk)],w);function d(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const $ of P.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}}),define(ue[202],de([0,1,69,8,29,5,48]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XR=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0",A="https://mobile.events.data.microsoft.com/ping";async function b(p,m,f){k.$r;const l=await(0,I.$zq)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,I.$zq)("@microsoft/1ds-post-js","dist/ms.post.js"),E=new l.AppInsightsCore,w=new g.PostChannel,d={instrumentationKey:p,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(f){d.extensionConfig={};const P={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:f};d.extensionConfig[w.identifier]=P}return E.initialize(d,[]),E.addTelemetryInitializer(P=>{P.ext=P.ext??{},P.ext.web=P.ext.web??{},P.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',m&&(P.ext.utc=P.ext.utc??{},P.ext.utc.flags=8462029)}),E}class R{constructor(m,f,l,g,E){this.e=m,this.f=f,this.g=l,this.h=E,this.c=C,this.d=A,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(m){if(this.a){if(typeof this.a!="string"){m(this.a);return}this.b||(this.b=b(this.a,this.e,this.h)),this.b.then(f=>{m(f)},f=>{(0,a.$4)(f),console.error(f)})}}log(m,f){if(!this.a)return;f=(0,N.$no)(f,this.g),f=(0,T.$Np)(f);const l=this.f+"/"+m;try{this.i(g=>{g.pluginVersionString=f?.properties.version??"Unknown",g.track({name:l,baseData:{name:l,properties:f?.properties,measurements:f?.measurements}})})}catch{}}flush(){return this.a?new Promise(m=>{this.i(f=>{f.unload(!0,()=>{this.a=void 0,m(void 0)})})}):Promise.resolve(void 0)}}e.$XR=R}),define(ue[114],de([0,1,2,9,15,11,23,48]),function(ce,e,I,a,N,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;let A=class extends I.$Zc{constructor(R,p,m,f,l=""){super(),this.b=l;const g=p.getLogger(C.$Hp);if(g)this.a=this.B(g);else{const w=(0,C.$Lp)(f,m)?" (Not Sent)":"",d=()=>(0,C.$Kp)(f,m)&&R.getLevel()===k.LogLevel.Trace;this.a=this.B(p.createLogger(C.$Hp,{name:(0,a.localize)(2067,null,w),hidden:!d()})),this.B(R.onDidChangeLogLevel(()=>p.setVisibility(C.$Hp,d()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(R,p){this.a.trace(`${this.b}telemetry/${R}`,(0,C.$Np)(p))}};e.$Efc=A,e.$Efc=A=Ee([Z(0,k.$fk),Z(1,k.$gk),Z(2,N.$Ri),Z(3,T.$yk)],A)});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ue[115],de([0,1,2,29,5,26,9,21,47,104,23,44,18,48]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=void 0,b=it(b);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(w,d,P){this.k=d,this.l=P,this.d={},this.i=new I.$Yc,this.j=[],this.b=w.appenders,this.c=w.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=w.piiPaths||[],this.g=m.TelemetryLevel.USAGE,this.h=!!w.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const $ of this.f)this.j.push(new RegExp((0,k.$mf)($),"gi")),$.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$mf)($.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration($=>{($.affectsConfiguration(m.$nm)||$.affectsConfiguration(m.$pm)||$.affectsConfiguration(m.$om))&&this.m()}))}setExperimentProperty(w,d){this.d[w]=d}m(){let w=(0,f.$Mp)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const P=d.usage?m.TelemetryLevel.USAGE:d.error?m.TelemetryLevel.ERROR:m.TelemetryLevel.NONE;w=Math.min(w,P)}this.g=w}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(w,d,P){this.g<d||(P=(0,a.$no)(P,this.d),P=(0,f.$Rp)(P,this.j),P=(0,a.$no)(P,this.c),this.b.forEach($=>$.log(w,P)))}publicLog(w,d){this.n(w,m.TelemetryLevel.USAGE,d)}publicLog2(w,d){this.publicLog(w,d)}publicLogError(w,d){this.h&&this.n(w,m.TelemetryLevel.ERROR,d)}publicLogError2(w,d){this.publicLogError(w,d)}};e.$ps=l,e.$ps=l=Ee([Z(1,C.$ej),Z(2,R.$yk)],l);function g(){const E=(0,T.localize)(2068,null,b.default.nameLong),w=b.default.privacyStatementUrl?(0,T.localize)(2070,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,T.localize)(2069,null,"https://aka.ms/vscode-telemetry"),d=N.$r?"":(0,T.localize)(2071,null),P=(0,T.localize)(2072,null),$=(0,T.localize)(2073,null),c=(0,T.localize)(2074,null),h=(0,T.localize)(2075,null),i=`
|       | ${P} | ${$} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,T.localize)(2076,null);return`
${E} ${w} ${d}

&nbsp;

${h}
${i}

&nbsp;

${n}
`}p.$xo.as(A.$Co.Configuration).registerConfiguration({id:m.$mm,order:1,type:"object",title:(0,T.localize)(2077,null),properties:{[m.$nm]:{type:"string",enum:[m.TelemetryConfiguration.ON,m.TelemetryConfiguration.ERROR,m.TelemetryConfiguration.CRASH,m.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(2078,null),(0,T.localize)(2079,null),(0,T.localize)(2080,null),(0,T.localize)(2081,null)],markdownDescription:g(),default:m.TelemetryConfiguration.ON,restricted:!0,scope:A.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),p.$xo.as(A.$Co.Configuration).registerConfiguration({id:m.$mm,order:110,type:"object",title:(0,T.localize)(2082,null),properties:{[m.$pm]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,T.localize)(2084,null,b.default.nameLong,b.default.privacyStatementUrl):(0,T.localize)(2083,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(2085,null,`\`#${m.$nm}#\``),scope:A.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ue[203],de([0,1,14,25,246,202]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YR=void 0,N=Oe(N);async function T(R,p){const m=await p.request(R,a.CancellationToken.None),f=(await(0,I.$5e)(m.stream)).toString(),l=m.res.statusCode??200;return{headers:m.res.headers,statusCode:l,responseData:f}}async function C(R){const p={method:R.type,headers:R.headers};return new Promise((f,l)=>{const g=N.request(R.url??"",p,E=>{E.on("data",function(w){f({headers:E.headers,statusCode:E.statusCode??200,responseData:w.toString()})}),E.on("error",function(w){l(w)})});g.write(R.data,E=>{E&&l(E)}),g.end()})}async function A(R,p,m){const f=typeof p.data=="string"?p.data:new TextDecoder().decode(p.data),l={type:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data).toString()},url:p.urlString,data:f};try{const g=R?await T(l,R):await C(l);m(g.statusCode,g.headers,g.responseData)}catch{m(0,{})}}class b extends k.$XR{constructor(p,m,f,l,g){const E={sendPOST:(w,d)=>{A(p,w,d)}};super(m,f,l,g,E)}}e.$YR=b}),define(ue[204],de([0,1,22,97,21,15,11,23,18,113,114,115]),function(ce,e,I,a,N,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=void 0;let m=class{constructor(l,g,E,w,d,P){this.b=l,this.c=g,this.d=E,this.e=w,this.f=d,this.g=P,this.a=new Map}h(l){if(!this.a.has(l.id)){const g=Object.create(null);g["common.vscodemachineid"]=this.c.machineId,g["common.vscodesessionid"]=this.c.sessionId;const E=[l.id,JSON.stringify(g),l.aiKey],d=new a.$qr(I.$5g.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:E,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),P=[new b.$ric(d),new R.$Efc(this.d,this.e,this.f,this.g,`[${l.id}] `)];this.a.set(l.id,new p.$ps({appenders:P,sendErrorTelemetry:l.sendErrorTelemetry},this.b,this.g))}return this.a.get(l.id)}publicLog(l,g,E){this.h(l).publicLog(g,E)}publicLogError(l,g,E){this.h(l).publicLogError(g,E)}};e.$Fjc=m,e.$Fjc=m=Ee([Z(0,N.$ej),Z(1,A.$em),Z(2,T.$fk),Z(3,T.$gk),Z(4,k.$Ri),Z(5,C.$yk)],m)}),define(ue[81],de([0,1,3,2,5,10,21,4,11]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yw=e.$Xw=e.$Uw=e.$Sw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ow=e.$Nw=void 0,e.$Pw=p,e.$Qw=f,e.$Rw=l,e.$Tw=g,e.$Vw=E,e.$Ww=w,e.$Nw=(0,C.$Ki)("tunnelService"),e.$Ow=(0,C.$Ki)("sharedTunnelsService");var b;(function($){$.Http="http",$.Https="https"})(b||(e.TunnelProtocol=b={}));var R;(function($){$.ConstantPrivate="constantPrivate",$.Private="private",$.Public="public"})(R||(e.TunnelPrivacyId=R={}));function p($){return!!$.forwardPort}var m;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function f($){if($.scheme!=="http"&&$.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec($.authority);if(c)return{address:c[1],port:+c[2]}}function l($){if($.scheme!=="http"&&$.scheme!=="https"||!$.query)return;const c=$.query.split("&");for(const h of c){const i=h.split("=")[1];if(/^https?:/.exec(i)){const n=f(k.URI.parse(i));if(n)return n}}}e.$Sw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g($){return e.$Sw.indexOf($)>=0}e.$Uw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E($){return e.$Uw.indexOf($)>=0}function w($,c,h,i){if(h===N.OperatingSystem.Windows)return!1;if(h===N.OperatingSystem.Macintosh&&E(c)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(n?.length===4&&parseInt(n[1])>=18)return!1}return $<1024}class d{constructor(c,h,i){this.remoteAddress=c,this.localAddress=h,this.b=i,this.a=new I.$qe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Xw=d;let P=class extends a.$Zc{constructor(c,h){super(),this.r=c,this.s=h,this.a=new I.$qe,this.onTunnelOpened=this.a.event,this.b=new I.$qe,this.onTunnelClosed=this.b.event,this.c=new I.$qe,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const c=this.s.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.g=c,c?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.h=c.elevation,this.m=c.privacyOptions,this.j=c.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const c=[],h=Array.from(this.f.values());for(const i of h){const n=Array.from(i.values());for(const t of n){const s=await t.value;s&&typeof s!="string"&&c.push(s)}}return c}async dispose(){super.dispose();for(const c of this.f.values()){for(const{value:h}of c.values())await h.then(i=>typeof i!="string"?i?.dispose():void 0);c.clear()}this.f.clear()}setEnvironmentTunnel(c,h,i,n,t){this.z(c,h,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:h,localAddress:i,privacy:n,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,h){(E(c)||g(c))&&(c=e.$Sw[0]);const i=this.D(c,h);if(i)return++i.refcount,i.value}openTunnel(c,h,i,n,t,s=!1,r,o){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${i} on local port ${t}.`);const u=this.g??c;if(!u)return;if(h||(h="localhost"),n||(n=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.F(u,h,i,n,t,s,r,o);return y?y.then(O=>{if(O){if(typeof O=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(h,i),O}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(h,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.w(O);return(O.tunnelRemoteHost!==h||O.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&O.privacy!==r&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}w(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const h=this.f.get(c.tunnelRemoteHost);if(h){const i=h.get(c.tunnelRemotePort);i&&(i.refcount--,await this.y(c.tunnelRemoteHost,c.tunnelRemotePort,i))}}}}async y(c,h,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${h}.`);const n=i.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.f.has(c)&&this.f.get(c).delete(h),n}}async closeTunnel(c,h){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${h} `);const i=this.f.get(c);if(i&&i.has(h)){const n=i.get(h);n.refcount=0,await this.y(c,h,n)}}z(c,h,i){this.f.has(c)||this.f.set(c,new Map),this.f.get(c).set(h,{refcount:1,value:i})}async C(c,h){const i=this.f.get(c);if(i){const n=i.get(h),t=n?await n.value:void 0;(!t||typeof t=="string")&&i.delete(h),i.size===0&&this.f.delete(c)}}D(c,h){const i=[c];g(c)?(i.push(...e.$Sw),i.push(...e.$Uw)):E(c)&&i.push(...e.$Uw);const n=i.map(t=>this.f.get(t));for(const t of n){const s=t?.get(h);if(s)return s}}canTunnel(c){return!!f(c)}G(c,h,i,n,t,s,r){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${i} on local port ${n}.`);const o=i;this.n.add(o);const u=n===void 0?i:n,y={elevationRequired:t?this.isPortPrivileged(u):!1},O={remoteAddress:{host:h,port:i},localAddressPort:n,privacy:s,public:s?s!==R.Private:void 0,protocol:r},S=c.forwardPort(O,y);return S?(this.z(h,i,S),S.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(o)})):this.n.delete(o),S}};e.$Yw=P,e.$Yw=P=Ee([Z(0,A.$fk),Z(1,T.$ej)],P)}),define(ue[205],de([0,1,11,81,2,8,6]),function(ce,e,I,a,N,k,T){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjc=void 0;class A extends N.$Zc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.$8h),this.b.p)}setAddress(p){this.a=p,this.b&&(this.b.complete(p),this.b=null)}setTunnel(p){this.B(p)}}let b=class extends N.$Zc{static{C=this}static{this.a=0}constructor(p,m){super(),this.f=p,this.g=m,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(p=>p.dispose())}async createTunnel(){return{id:String(++C.a)}}async startTunnel(p,m,f,l,g,E,w){const d=new A,P=await Promise.resolve(this.f.openTunnel(p,d,f,l,g,E,w));if(!P||typeof P=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${l} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this.c.has(m))throw this.c.delete(m),d.dispose(),await P.dispose(),(0,k.$0)();return d.setTunnel(P),this.b.set(m,d),this.g.info(`[SharedProcessTunnelService] Created tunnel ${m}: ${P.localAddress} (local) to ${f}:${l} (remote).`),{tunnelLocalPort:P.tunnelLocalPort,localAddress:P.localAddress}}async setAddress(p,m){const f=this.b.get(p);f&&f.setAddress(m)}async destroyTunnel(p){const m=this.b.get(p);if(m){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${p}.`),this.b.delete(p),await m.dispose();return}this.c.add(p)}};e.$Pjc=b,e.$Pjc=b=C=Ee([Z(0,a.$Ow),Z(1,I.$fk)],b)}),define(ue[28],de([0,1,4]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0,e.$Pl=(0,I.$Ki)("IUriIdentityService")}),define(ue[206],de([0,1,28,162,7,20,135,3,2]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=void 0;class b{static{this._clock=0}constructor(m){this.uri=m,this.time=b._clock++}touch(){return this.time=b._clock++,this}}let R=class{constructor(m){this.g=m,this.c=new A.$Yc,this.f=2**16;const f=new Map,l=g=>{let E=f.get(g.scheme);return E===void 0&&(E=m.hasProvider(g)&&!this.g.hasCapability(g,N.FileSystemProviderCapabilities.PathCaseSensitive),f.set(g.scheme,E)),E};this.c.add(C.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(g=>{f.delete(g.scheme)})),this.extUri=new k.$ah(l),this.d=new T.$2s((g,E)=>this.extUri.compare(g,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,k.$mh)(m));const f=this.d.get(m);return f?f.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new b(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((l,g)=>l[1].time<g[1].time?1:l[1].time>g[1].time?-1:0);b._clock=0,this.d.clear();const f=this.f*.5;for(let l=0;l<f;l++)this.d.set(m[l][0],m[l][1].touch())}};e.$3s=R,e.$3s=R=Ee([Z(0,N.$fl)],R),(0,a.$Zs)(I.$Pl,R,a.InstantiationType.Delayed)}),define(ue[207],de([0,1,3,2,7,51,31]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gjc=void 0;class C extends a.$Zc{constructor(b,R,p,m,f,l){super(),this.f=b,this.g=R,this.h=p,this.j=m,this.m=f,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new I.$qe),this.onDidChangeFile=this.a.event,this.b=k.$Qi.forUris(()=>!(this.capabilities&N.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Gc(g=>this.m.extUri.getComparisonKey(this.t(g))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(g=>this.s(g)))}r(){this.c.clear();for(const b of this.j.profiles)this.c.add(b.settingsResource),this.c.add(b.keybindingsResource),this.c.add(b.tasksResource),this.c.add(b.extensionsResource)}open(b,R){return this.g.open(this.t(b),R)}close(b){return this.g.close(b)}read(b,R,p,m,f){return this.g.read(b,R,p,m,f)}write(b,R,p,m,f){return this.g.write(b,R,p,m,f)}watch(b,R){this.b.set(b,b);const p=this.g.watch(this.t(b),R);return(0,a.$Xc)(()=>{this.b.delete(b),p.dispose()})}stat(b){return this.g.stat(this.t(b))}mkdir(b){return this.g.mkdir(this.t(b))}rename(b,R,p){return this.g.rename(this.t(b),this.t(R),p)}readFile(b,R){return this.g.readFile(this.t(b),R)}readFileStream(b,R,p){return this.g.readFileStream(this.t(b),R,p)}readdir(b){return this.g.readdir(this.t(b))}enforceAtomicReadFile(b){return this.c.has(b)}writeFile(b,R,p){return this.g.writeFile(this.t(b),R,p)}enforceAtomicWriteFile(b){return this.c.has(b)?{postfix:".vsctmp"}:!1}delete(b,R){return this.g.delete(this.t(b),R)}copy(b,R,p){if((0,N.$jl)(this.g))return this.g.copy(this.t(b),this.t(R),p);throw new Error("copy not supported")}cloneFile(b,R){if((0,N.$kl)(this.g))return this.g.cloneFile(this.t(b),this.t(R));throw new Error("clone not supported")}s(b){const R=[];for(const p of b){if(p.resource.scheme!==this.f)continue;const m=this.u(p.resource);this.b.findSubstr(m)&&R.push({resource:m,type:p.type,cId:p.cId})}R.length&&(this.n.debug("User data changed"),this.a.fire(R))}t(b){return b.with({scheme:this.f})}u(b){return b.with({scheme:this.h})}}e.$gjc=C}),define(ue[82],de([0,1,64]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=a,e.$ANb=N,e.$BNb=k;function a(T,C,A,b){const R=(0,I.$go)(T,C,A,b)[0];return R&&(T=T.substring(0,R.offset)+R.content+T.substring(R.offset+R.length)),T}function N(T,C,A){let b=A;for(;b>=0;){if(T.charAt(b)===C.charAt(C.length-1)&&C.length===1)return b+1;if(b--,C.length===2&&b>=0&&T.charAt(b)===C.charAt(0))return b+2}return 0}function k(T,C,A){let b=A;for(;b>=0;)if(T.charAt(b)===C.charAt(C.length-1)&&C.length===1||(b++,C.length===2&&b>=0&&T.charAt(b)===C.charAt(1)))return b;return T.length-1}}),define(ue[208],de([0,1,29,60,12]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=k,a=Oe(a);function k(f,l,g,E,w,d){const P=[],$=[],c=[];if(!l){const F=f.filter(({identifier:G})=>w.every(V=>V.toLowerCase()!==G.id.toLowerCase()));return{local:{added:P,removed:$,updated:c},remote:F.length>0?{added:F,updated:[],removed:[],all:F}:null}}f=f.map(p),l=l.map(p),g=g?g.map(p):null;const h=new Map,i=F=>{F.uuid&&h.set(F.id.toLowerCase(),F.uuid)};f.forEach(({identifier:F})=>i(F)),l.forEach(({identifier:F})=>i(F)),g?.forEach(({identifier:F})=>i(F)),E?.forEach(({identifier:F})=>i(F)),d?.forEach(F=>i(F));const n=F=>{const G=F.identifier.uuid||h.get(F.identifier.id.toLowerCase());return G?`uuid:${G}`:`id:${F.identifier.id.toLowerCase()}`},t=(F,G)=>(F.set(n(G),G),F),s=f.reduce(t,new Map),r=l.reduce(t,new Map),o=l.reduce((F,G)=>t(F,(0,I.$ko)(G)),new Map),u=g?g.reduce(t,new Map):null,y=E.reduce(t,new Map),O=w.reduce((F,G)=>{const V=h.get(G.toLowerCase());return F.add(V?`uuid:${V}`:`id:${G.toLowerCase()}`)},new Set),S=d?d.reduce((F,{id:G,uuid:V})=>(V=V??h.get(G.toLowerCase()),F.add(V?`uuid:${V}`:`id:${G.toLowerCase()}`)),new Set):null,v=T(s,r,O,!1);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const F=T(u,s,O,!1),G=T(u,r,O,!0),V=(x,H,te,z)=>{let W,_,ne;return H.installed?(W=z.pinned,ne=z.preRelease,W&&(_=z.version)):(W=te.pinned,ne=te.preRelease,W&&(_=te.version)),W===void 0&&(W=H.pinned,W&&(_=H.version)),ne===void 0&&(ne=H.preRelease),{...z,installed:H.installed||te.installed,pinned:W,preRelease:ne,version:_??(te.version&&(!H.installed||a.gt(te.version,H.version))?te.version:H.version),state:A(H,te,u?.get(x))}};for(const x of G.removed.values()){const H=s.get(x);if(!H)continue;const te=(0,N.$ug)(u?.get(x)),z=S&&!S.has(x)&&te.installed;H.installed&&z?$.push(H.identifier):o.set(x,H)}for(const x of G.added.values()){const H=(0,N.$ug)(r.get(x)),te=s.get(x);if(te){if(v.updated.has(x)){const z=V(x,te,H,H);C(te,H,!1,!1)||c.push(m(z,x)),o.set(x,z)}}else H.installed&&P.push(m(H,x))}for(const x of G.updated.values()){const H=(0,N.$ug)(r.get(x)),te=(0,N.$ug)(u?.get(x)),z=s.get(x);if(z)if(S&&!S.has(x)&&te.installed&&z.installed&&!H.installed)$.push(z.identifier);else{const _=V(x,z,H,H);c.push(m(_,x)),o.set(x,_)}else H.installed&&P.push(m(H,x))}for(const x of F.added.values())G.added.has(x)||o.set(x,(0,N.$ug)(s.get(x)));for(const x of F.updated.values()){if(G.removed.has(x)||G.updated.has(x))continue;const H=(0,N.$ug)(s.get(x)),te=(0,N.$ug)(r.get(x));o.set(x,V(x,H,te,H))}for(const x of F.removed.values())G.updated.has(x)||G.removed.has(x)||y.has(x)||(0,N.$ug)(r.get(x)).installed&&S&&(S.has(x)||!(0,N.$ug)(u?.get(x)).installed||o.delete(x))}const L=[],j=T(r,o,new Set,!0),U=j.added.size>0||j.updated.size>0||j.removed.size>0;return U&&o.forEach((F,G)=>L.push(m(F,G))),{local:{added:P,removed:$,updated:c},remote:U?{added:[...j.added].map(F=>o.get(F)),updated:[...j.updated].map(F=>o.get(F)),removed:[...j.removed].map(F=>r.get(F)),all:L}:null}}function T(f,l,g,E){const w=f?[...f.keys()].filter(h=>!g.has(h)):[],d=[...l.keys()].filter(h=>!g.has(h)),P=d.filter(h=>!w.includes(h)).reduce((h,i)=>(h.add(i),h),new Set),$=w.filter(h=>!d.includes(h)).reduce((h,i)=>(h.add(i),h),new Set),c=new Set;for(const h of w){if($.has(h))continue;const i=f.get(h),n=l.get(h);(!n||!C(i,n,E,!0))&&c.add(h)}return{added:P,removed:$,updated:c}}function C(f,l,g,E){return!(f.disabled!==l.disabled||!!f.isApplicationScoped!=!!l.isApplicationScoped||E&&f.installed!==l.installed||f.installed&&l.installed&&(f.preRelease!==l.preRelease||f.pinned!==l.pinned||l.pinned&&f.version!==l.version)||!R(f.state,l.state)||g&&f.version!==l.version)}function A(f,l,g){const E=f.state,w=l.state,d=g?.state;if(!l.version||E&&a.gt(f.version,l.version))return E;if(w&&a.gt(l.version,f.version)||!E)return w;if(!w)return E;const P=(0,I.$ko)(E),$=d?b(d,w):{added:Object.keys(w).reduce((h,i)=>(h.add(i),h),new Set),removed:new Set,updated:new Set},c=d?b(d,E):{added:Object.keys(E).reduce((h,i)=>(h.add(i),h),new Set),removed:new Set,updated:new Set};for(const h of[...$.added.values(),...$.updated.values()])P[h]=w[h];for(const h of $.removed.values())c.updated.has(h)||delete P[h];return P}function b(f,l){const g=Object.keys(f),E=Object.keys(l),w=E.filter($=>!g.includes($)).reduce(($,c)=>($.add(c),$),new Set),d=g.filter($=>!E.includes($)).reduce(($,c)=>($.add(c),$),new Set),P=new Set;for(const $ of g){if(d.has($))continue;const c=f[$],h=l[$];(0,I.$oo)(c,h)||P.add($)}return{added:w,removed:d,updated:P}}function R(f={},l={}){const{added:g,removed:E,updated:w}=b(f,l);return g.size===0&&E.size===0&&w.size===0}function p(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function m(f,l){const g={...f,identifier:{id:f.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!f.preRelease,pinned:!!f.pinned};return f.disabled||delete g.disabled,f.installed||delete g.installed,f.state||delete g.state,f.isApplicationScoped||delete g.isApplicationScoped,g}}),define(ue[116],de([0,1,17,21,4]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UPb=e.$TPb=void 0,e.$TPb=(0,N.$Ki)("IIgnoredExtensionsManagementService");let k=class{constructor(C){this.a=C}hasToNeverSyncExtension(C){return this.b().includes(C.toLowerCase())}hasToAlwaysSyncExtension(C){return this.b().includes(`-${C.toLowerCase()}`)}updateIgnoredExtensions(C,A){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return b=b.filter(R=>R!==C&&R!==`-${C}`),A&&b.push(C.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,a.ConfigurationTarget.USER)}updateSynchronizedExtensions(C,A){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return b=b.filter(R=>R!==C&&R!==`-${C}`),A&&b.push(`-${C.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,a.ConfigurationTarget.USER)}getIgnoredExtensions(C){const A=C.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),b=this.b().map(m=>m.toLowerCase()),R=[],p=[];if(Array.isArray(b))for(const m of b)m.startsWith("-")?p.push(m.substring(1)):R.push(m);return(0,I.$Qb)([...A,...R].filter(m=>!p.includes(m)))}b(){let C=this.a.inspect("settingsSync.ignoredExtensions").userValue;return C!==void 0||(C=this.a.inspect("sync.ignoredExtensions").userValue,C!==void 0)?C:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(A=>A.toLowerCase())}};e.$UPb=k,e.$UPb=k=Ee([Z(0,a.$ej)],k)}),define(ue[209],de([0,1,17,36,29,98,82]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=A,N=Oe(N),T=Oe(T);function C($){return(0,a.$5n)($)||[]}async function A($,c,h,i,n){const t=C($),s=C(c),r=h?C(h):null,o=[...t,...s,...r||[]].map(V=>V.key),u=await n.resolveUserBindings(o),y=R(t,s,r,u);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:$,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:$,hasChanges:!0,hasConflicts:!1};const O=m(t),S=m(s),v=r?m(r):null,L=l(O,S,u),j=v?l(v,O,u):{added:[...O.keys()].reduce((V,x)=>(V.add(x),V),new Set),removed:new Set,updated:new Set},U=v?l(v,S,u):{added:[...S.keys()].reduce((V,x)=>(V.add(x),V),new Set),removed:new Set,updated:new Set},F=b(L,j,U);let G=$;for(const V of F.removed.values())F.conflicts.has(V)||(G=d(G,V,i));for(const V of F.added.values()){if(F.conflicts.has(V))continue;const x=S.get(V);if(x.some(H=>H.command!==`-${V}`&&y.conflicts.has(u[H.key]))){F.conflicts.add(V);continue}G=w(G,x,i)}for(const V of F.updated.values()){if(F.conflicts.has(V))continue;const x=S.get(V);if(x.some(H=>H.command!==`-${V}`&&y.conflicts.has(u[H.key]))){F.conflicts.add(V);continue}G=P(G,V,x,i)}return{mergeContent:G,hasChanges:!0,hasConflicts:F.conflicts.size>0}}function b($,c,h){const i=new Set,n=new Set,t=new Set,s=new Set;for(const r of c.removed.values())h.updated.has(r)&&s.add(r);for(const r of h.removed.values())s.has(r)||(c.updated.has(r)?s.add(r):n.add(r));for(const r of c.added.values())s.has(r)||h.added.has(r)&&$.updated.has(r)&&s.add(r);for(const r of h.added.values())s.has(r)||(c.added.has(r)?$.updated.has(r)&&s.add(r):i.add(r));for(const r of c.updated.values())s.has(r)||h.updated.has(r)&&$.updated.has(r)&&s.add(r);for(const r of h.updated.values())s.has(r)||(c.updated.has(r)?$.updated.has(r)&&s.add(r):t.add(r));return{added:i,removed:n,updated:t,conflicts:s}}function R($,c,h,i){const n=new Set,t=p($,i),s=p(c,i),r=h?p(h,i):null,o=f(t,s);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const u=r?f(r,t):{added:[...t.keys()].reduce((j,U)=>(j.add(U),j),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const y=r?f(r,s):{added:[...s.keys()].reduce((j,U)=>(j.add(U),j),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:O,removed:S,updated:v,conflicts:L}=b(o,u,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:O,removed:S,updated:v,conflicts:L}}function p($,c){const h=new Map;for(const i of $){const n=c[i.key];let t=h.get(n);t||(t=[],h.set(n,t)),t.push(i)}return h}function m($){const c=new Map;for(const h of $){const i=h.command[0]==="-"?h.command.substring(1):h.command;let n=c.get(i);n||(n=[],c.set(i,n)),n.push(h)}return c}function f($,c){const h=[...$.keys()],i=[...c.keys()],n=i.filter(r=>!h.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),t=h.filter(r=>!i.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),s=new Set;for(const r of h){if(t.has(r))continue;const o=$.get(r).map(y=>({...y,key:r})),u=c.get(r).map(y=>({...y,key:r}));(0,I.$yb)(o,u,(y,O)=>E(y,O))||s.add(r)}return{added:n,removed:t,updated:s}}function l($,c,h){const i=[...$.keys()],n=[...c.keys()],t=n.filter(o=>!i.includes(o)).reduce((o,u)=>(o.add(u),o),new Set),s=i.filter(o=>!n.includes(o)).reduce((o,u)=>(o.add(u),o),new Set),r=new Set;for(const o of i){if(s.has(o))continue;const u=$.get(o).map(O=>({...O,key:h[O.key]})),y=c.get(o).map(O=>({...O,key:h[O.key]}));g(u,y)||r.add(o)}return{added:t,removed:s,updated:r}}function g($,c){return!(!(0,I.$yb)($.filter(({command:h})=>h[0]!=="-"),c.filter(({command:h})=>h[0]!=="-"),(h,i)=>E(h,i))||!(0,I.$yb)($.filter(({command:h})=>h[0]==="-"),c.filter(({command:h})=>h[0]==="-"),(h,i)=>E(h,i)))}function E($,c){if($.command!==c.command||$.key!==c.key)return!1;const h=k.$Ij.deserialize($.when),i=k.$Ij.deserialize(c.when);return!(h&&!i||!h&&i||h&&i&&!h.equals(i)||!N.$oo($.args,c.args))}function w($,c,h){for(const i of c)$=T.edit($,[-1],i,h);return $}function d($,c,h){const i=C($);for(let n=i.length-1;n>=0;n--)(i[n].command===c||i[n].command===`-${c}`)&&($=T.edit($,[n],void 0,h));return $}function P($,c,h,i){const n=C($),t=n.findIndex(s=>s.command===c||s.command===`-${c}`);for(let s=n.length-1;s>=0;s--)(n[s].command===c||n[s].command===`-${c}`)&&($=T.edit($,[s],void 0,i));for(let s=h.length-1;s>=0;s--)$=T.edit($,[t],h[s],i);return $}}),define(ue[210],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=I,e.$vec=N;function I(k,T,C){const A={},b={},R=new Set;if(!T)return{local:{added:A,updated:b,removed:[...R.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const p=a(k,T);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{local:{added:A,updated:b,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=a(C,k),f=a(C,T),l={},g={},E=new Set,w=new Set;for(const d of m.removed.values())f.updated.has(d)?A[d]=T[d]:E.add(d);for(const d of f.removed.values())w.has(d)||(m.updated.has(d)?w.add(d):R.add(d));for(const d of m.updated.values())w.has(d)||(f.updated.has(d)?p.updated.has(d)&&w.add(d):g[d]=k[d]);for(const d of f.updated.values())w.has(d)||(m.updated.has(d)?p.updated.has(d)&&w.add(d):k[d]!==void 0&&(b[d]=T[d]));for(const d of m.added.values())w.has(d)||(f.added.has(d)?p.updated.has(d)&&w.add(d):l[d]=k[d]);for(const d of f.added.values())w.has(d)||(m.added.has(d)?p.updated.has(d)&&w.add(d):A[d]=T[d]);return{local:{added:A,removed:[...R.values()],updated:b},remote:{added:l,removed:[...E.values()],updated:g},conflicts:[...w.values()]}}function a(k,T){const C=k?Object.keys(k):[],A=T?Object.keys(T):[],b=A.filter(m=>!C.includes(m)).reduce((m,f)=>(m.add(f),m),new Set),R=C.filter(m=>!A.includes(m)).reduce((m,f)=>(m.add(f),m),new Set),p=new Set;for(const m of C){if(R.has(m))continue;const f=k[m],l=T[m];f!==l&&p.add(m)}return{added:b,removed:R,updated:p}}function N(k,T){const{added:C,removed:A,updated:b}=a(k,T);return C.size===0&&A.size===0&&b.size===0}}),define(ue[211],de([0,1,29]),function(ce,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=a;function a(k,T,C,A){const b={added:[],removed:[],updated:[]};let R={added:[],removed:[],updated:[]};if(!T){const m=k.filter(({id:f})=>!A.includes(f));return m.length?R.added=m:R=null,{local:b,remote:R}}const p=N(k,T,A);if(p.added.length>0||p.removed.length>0||p.updated.length>0){const m=N(C,k,A),f=N(C,T,A);for(const l of f.removed){const g=k.find(E=>E.id===l);g&&b.removed.push(g)}for(const l of f.added){const g=T.find(E=>E.id===l);m.added.includes(l)?p.updated.includes(l)&&b.updated.push(g):b.added.push(g)}for(const l of f.updated)b.updated.push(T.find(g=>g.id===l));for(const l of m.added)f.added.includes(l)||R.added.push(k.find(g=>g.id===l));for(const l of m.updated)f.removed.includes(l)||f.updated.includes(l)||R.updated.push(k.find(g=>g.id===l));for(const l of m.removed){const g=T.find(E=>E.id===l);g&&R.removed.push(g)}}return R.added.length===0&&R.removed.length===0&&R.updated.length===0&&(R=null),{local:b,remote:R}}function N(k,T,C){k=k?k.filter(({id:f})=>!C.includes(f)):[],T=T.filter(({id:f})=>!C.includes(f));const A=k.map(({id:f})=>f),b=T.map(({id:f})=>f),R=b.filter(f=>!A.includes(f)),p=A.filter(f=>!b.includes(f)),m=[];for(const{id:f,name:l,shortName:g,icon:E,useDefaultFlags:w}of k){if(p.includes(f))continue;const d=T.find(P=>P.id===f);(!d||d.name!==l||d.shortName!==g||d.icon!==E||!(0,I.$oo)(d.useDefaultFlags,w))&&m.push(f)}return{added:R,removed:p,updated:m}}}),define(ue[24],de([0,1,17,12,9,47,27,4,105,44]),function(ce,e,I,a,N,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pb=e.$7pb=e.$6pb=e.$5pb=e.$4pb=e.$3pb=e.$2pb=e.$1pb=e.$Zpb=e.$Xpb=e.MergeState=e.Change=e.SyncStatus=e.$Wpb=e.$Vpb=e.$Upb=e.UserDataSyncErrorCode=e.$Spb=e.$Rpb=e.$Qpb=e.$Ppb=e.$Opb=e.$Lpb=e.SyncResource=e.$Ipb=e.$Hpb=void 0,e.$Epb=R,e.$Fpb=p,e.$Gpb=m,e.$Jpb=l,e.$Kpb=g,e.$Mpb=w,e.$Npb=d,e.$Tpb=P,e.$Ypb=r;function R(){const o=b.$xo.as(k.$Co.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}function p(o=!1){const u=b.$xo.as(k.$Co.Configuration).getConfigurationProperties(),y=f(u,o),O=R();return(0,I.$Qb)([...y,...O])}function m(o){if(!o.contributes?.configuration)return[];const u=Array.isArray(o.contributes.configuration)?o.contributes.configuration:[o.contributes.configuration];if(!u.length)return[];const y=(0,k.$So)(u);return f(y,!1)}function f(o,u){const y=new Set;for(const O in o){if(u&&o[O].source)continue;const S=(0,a.$jg)(o[O].scope)?(0,k.$To)(o[O].scope):o[O].scope;(o[O].ignoreSync||S===k.ConfigurationScope.MACHINE||S===k.ConfigurationScope.MACHINE_OVERRIDABLE)&&y.add(O)}return[...y.values()]}e.$Hpb="settingsSync",e.$Ipb="settingsSync.keybindingsPerPlatform";function l(){const o="vscode://schemas/ignoredSettings",u=b.$xo.as(k.$Co.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,N.localize)(2455,null),type:"object",properties:{[e.$Ipb]:{type:"boolean",description:(0,N.localize)(2456,null),default:!0,scope:k.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,N.localize)(2457,null),items:[{type:"string",pattern:T.$ep,errorMessage:(0,N.localize)(2458,null)}],default:[],scope:k.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,N.localize)(2459,null),default:[],scope:k.ConfigurationScope.APPLICATION,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const y=b.$xo.as(A.$yo.JSONContribution),O=()=>{const S=R(),v=p(),L=Object.keys(k.$Do.properties).filter(F=>!v.includes(F)),j=v.filter(F=>!S.includes(F)),U={items:{type:"string",enum:[...L,...j.map(F=>`-${F}`)]}};y.registerSchema(o,U)};return u.onDidUpdateConfiguration(()=>O())}function g(o){return o&&(0,a.$lg)(o)&&(0,a.$jg)(o.id)&&Array.isArray(o.scopes)}var E;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState",o.Profiles="profiles",o.WorkspaceState="workspaceState"})(E||(e.SyncResource=E={})),e.$Lpb=[E.Settings,E.Keybindings,E.Snippets,E.Tasks,E.Extensions,E.GlobalState,E.Profiles];function w(o,...u){return o?[o,...u]:u}function d(o,u,y,O){return O.joinPath(y.userDataSyncHome,...w(o,u,`lastSync${u}.json`))}e.$Opb=(0,C.$Ki)("IUserDataSyncStoreManagementService"),e.$Ppb=(0,C.$Ki)("IUserDataSyncStoreService"),e.$Qpb=(0,C.$Ki)("IUserDataSyncLocalStoreService"),e.$Rpb="x-operation-id",e.$Spb="X-Execution-Id";function P(o){const u={};return u[e.$Spb]=o,u}var $;(function(o){o.Unauthorized="Unauthorized",o.Forbidden="Forbidden",o.NotFound="NotFound",o.MethodNotFound="MethodNotFound",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoCollection="NoCollection",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyProfiles="LocalTooManyProfiles",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.Unknown="Unknown"})($||(e.UserDataSyncErrorCode=$={}));class c extends Error{constructor(u,y,O,S){super(u),this.code=y,this.resource=O,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Upb=c;class h extends c{constructor(u,y,O,S,v){super(u,O,void 0,v),this.url=y,this.serverCode=S}}e.$Vpb=h;class i extends c{constructor(u,y){super(u,y)}}e.$Wpb=i,function(o){function u(y){if(y instanceof o)return y;const O=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(y.name);if(O&&O[1]){const S=O[2]==="unknown"?void 0:O[2],v=O[3]==="unknown"?void 0:O[3];return new o(y.message,O[1],S,v)}return new o(y.message,$.Unknown)}o.toUserDataSyncError=u}(c||(e.$Upb=c={}));var n;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var t;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(t||(e.Change=t={}));var s;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(s||(e.MergeState=s={})),e.$Xpb="sync.store.url.type";function r(o){return`sync.enable.${o}`}e.$Zpb=(0,C.$Ki)("IUserDataSyncEnablementService"),e.$1pb=(0,C.$Ki)("IUserDataSyncService"),e.$2pb=(0,C.$Ki)("IUserDataSyncResourceProviderService"),e.$3pb=(0,C.$Ki)("IUserDataAutoSyncService"),e.$4pb=(0,C.$Ki)("IUserDataSyncUtilService"),e.$5pb=(0,C.$Ki)("IUserDataSyncLogService"),e.$6pb="userDataSync",e.$7pb="vscode-userdata-sync",e.$8pb="preview"}),define(ue[212],de([0,1,29,24]),function(ce,e,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Ob=N,I=Oe(I);function N(T,C,A,b,R){if(!C)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const p=k(T,C);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=A?k(A,C):{added:Object.keys(C).reduce((d,P)=>(d.add(P),d),new Set),removed:new Set,updated:new Set},f=A?k(A,T):{added:Object.keys(T).reduce((d,P)=>(d.add(P),d),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},g=I.$ko(C),E=!A;for(const d of f.added.values())d!==a.$Xpb&&E&&m.added.has(d)||(g[d]=T[d]);for(const d of f.updated.values())g[d]=T[d];for(const d of f.removed.values())b.unregistered.includes(d)||delete g[d];for(const d of m.added.values()){const P=C[d];if(b.machine.includes(d)){R.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(A&&f.added.has(d))continue;const $=T[d];$&&$.value===P.value||d===a.$Xpb&&E&&f.added.has(d)||($?l.updated[d]=P:l.added[d]=P)}for(const d of m.updated.values()){const P=C[d];if(b.machine.includes(d)){R.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(d)||f.removed.has(d))continue;const $=T[d];$&&$.value===P.value||(l.updated[d]=P)}for(const d of m.removed.values()){if(b.machine.includes(d)){R.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}f.updated.has(d)||f.removed.has(d)||l.removed.push(d)}const w=k(C,g);return{local:l,remote:{added:[...w.added],updated:[...w.updated],removed:[...w.removed],all:w.added.size===0&&w.removed.size===0&&w.updated.size===0?null:g}}}function k(T,C){const A=Object.keys(T),b=Object.keys(C),R=b.filter(f=>!A.includes(f)).reduce((f,l)=>(f.add(l),f),new Set),p=A.filter(f=>!b.includes(f)).reduce((f,l)=>(f.add(l),f),new Set),m=new Set;for(const f of A){if(p.has(f))continue;const l=T[f],g=C[f];I.$oo(l,g)||m.add(f)}return{added:R,removed:p,updated:m}}}),define(ue[213],de([0,1,17,36,64,45,29,82,24]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CNb=b,e.$DNb=m,e.$ENb=f,e.$FNb=l,e.$GNb=E,e.$HNb=d,T=Oe(T),C=Oe(C);function b(o,u,y){let O=[];y?O=p(y):O=R(u);const S=[],v=[...(0,A.$Epb)()];if(Array.isArray(O))for(const L of O)L.startsWith("-")?v.push(L.substring(1)):S.push(L);return(0,I.$Qb)([...o,...S].filter(L=>!v.includes(L)))}function R(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function p(o){const u=(0,a.$5n)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function m(o,u){const y=(0,a.$5n)(o)||{};let O="{}";for(const S of Object.keys(y)){const v=(0,N.$go)(O,[S],y[S],u);O=(0,N.$jo)(O,v)}return O}function f(o,u,y,O){if(y.length){const S=r(u),v=(0,a.$5n)(u)||{},L=(0,a.$5n)(o);if(!L)return o;const j=[];for(const U of y){const F=v[U],G=L[U];F===void 0?o=C.edit(o,[U],void 0,O):G!==void 0?o=C.edit(o,[U],F,O):j.push(h(U,S))}j.sort((U,F)=>U.startOffset-F.startOffset),j.forEach(U=>o=d(U.setting.key,u,o,O))}return o}function l(o,u,y,O,S,v){const L=f(o,u,O,v),j=y!==L,U=y!==u;if(!j&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!U)return{conflictsSettings:[],localContent:null,remoteContent:L,hasConflicts:!1};if(U&&!j)return{conflictsSettings:[],localContent:f(u,o,O,v),remoteContent:null,hasConflicts:!1};if(y===null&&E(o)){const D=g(o,u,O)?null:f(u,o,O,v);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let F=o,G=u;const V=(0,a.$5n)(o),x=(0,a.$5n)(u),H=y?(0,a.$5n)(y):null,te=O.reduce((D,J)=>(D.add(J),D),new Set),z=w(V,x,te),W=w(H,V,te),_=w(H,x,te),ne=new Map,le=new Set,ee=D=>{le.add(D);const J=S.filter(({key:oe})=>oe===D)[0];J?(F=C.edit(F,[D],J.value,v),G=C.edit(G,[D],J.value,v)):ne.set(D,{key:D,localValue:V[D],remoteValue:x[D]})};for(const D of W.removed.values())_.updated.has(D)?ee(D):G=C.edit(G,[D],void 0,v);for(const D of _.removed.values())le.has(D)||(W.updated.has(D)?ee(D):F=C.edit(F,[D],void 0,v));for(const D of W.updated.values())le.has(D)||(_.updated.has(D)?z.updated.has(D)&&ee(D):G=C.edit(G,[D],V[D],v));for(const D of _.updated.values())le.has(D)||(W.updated.has(D)?z.updated.has(D)&&ee(D):F=C.edit(F,[D],x[D],v));for(const D of W.added.values())le.has(D)||(_.added.has(D)?z.updated.has(D)&&ee(D):G=d(D,F,G,v));for(const D of _.added.values())le.has(D)||(W.added.has(D)?z.updated.has(D)&&ee(D):F=d(D,G,F,v));const X=ne.size>0||!g(F,G,O),K=X||!g(F,o,[]),q=X||!g(G,u,[]);return{localContent:K?F:null,remoteContent:q?G:null,conflictsSettings:[...ne.values()],hasConflicts:X}}function g(o,u,y){if(o===u)return!0;const O=(0,a.$5n)(o),S=(0,a.$5n)(u),v=y.reduce((U,F)=>(U.add(F),U),new Set),L=r(o).filter(U=>!(U.setting&&v.has(U.setting.key))),j=r(u).filter(U=>!(U.setting&&v.has(U.setting.key)));if(L.length!==j.length)return!1;for(let U=0;U<L.length;U++){const F=L[U],G=j[U];if(F.setting&&G.setting){if(F.setting.key!==G.setting.key||!T.$oo(O[F.setting.key],S[F.setting.key]))return!1}else if(!F.setting&&!G.setting){if(F.value!==G.value)return!1}else return!1}return!0}function E(o){return o?r(o).length===0:!0}function w(o,u,y){const O=o?Object.keys(o).filter(U=>!y.has(U)):[],S=Object.keys(u).filter(U=>!y.has(U)),v=S.filter(U=>!O.includes(U)).reduce((U,F)=>(U.add(F),U),new Set),L=O.filter(U=>!S.includes(U)).reduce((U,F)=>(U.add(F),U),new Set),j=new Set;if(o)for(const U of O){if(L.has(U))continue;const F=o[U],G=u[U];T.$oo(F,G)||j.add(U)}return{added:v,removed:L,updated:j}}function d(o,u,y,O){const S=(0,a.$5n)(u),v=r(u),L=r(y),j=P(o,v,L);return $(y,o,S[o],j,L,O)}function P(o,u,y){const O=u.findIndex(v=>v.setting?.key===o),S=u[O-1];if(S){if(S.setting){const L=h(S.setting.key,y);if(L)return{index:y.indexOf(L),insertAfter:!0}}else{const L=i(O,u);if(L){const j=h(L.setting.key,y);if(j){const U=n(y.indexOf(j),y),F=t(u,L,u[O]);if(U){const G=t(y,j,U),V=s(F,G);return V?{index:y.indexOf(V),insertAfter:!0}:{index:y.indexOf(U),insertAfter:!1}}else{const G=t(y,j,y[y.length-1]),V=s(F,G);return V?{index:y.indexOf(V),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const v=u[O+1];if(v)if(v.setting){const L=h(v.setting.key,y);if(L)return{index:y.indexOf(L),insertAfter:!1}}else{const L=n(O,u);if(L){const j=h(L.setting.key,y);if(j){const U=i(y.indexOf(j),y),F=t(u,u[O],L);if(U){const G=t(y,U,j),V=s(F.reverse(),G.reverse());return V?{index:y.indexOf(V),insertAfter:!1}:{index:y.indexOf(U),insertAfter:!0}}else{const G=t(y,y[0],j),V=s(F.reverse(),G.reverse());return V?{index:y.indexOf(V),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function $(o,u,y,O,S,v){let L;return O.index===-1?L=(0,N.$go)(o,[u],y,v):L=c(o,u,y,O,S,v).map(j=>(0,N.$ho)(o,j,v)[0]),(0,N.$jo)(o,L)}function c(o,u,y,O,S,v){const L=`${JSON.stringify(u)}: ${JSON.stringify(y)}`,j=(0,k.$do)(v,o),U=S[O.index];if(O.insertAfter){const F=[];if(U.setting)F.push({offset:U.endOffset,length:0,content:","+L});else{const G=n(O.index,S),V=i(O.index,S),x=V?.setting?.commaOffset;V&&x===void 0&&F.push({offset:V.endOffset,length:0,content:","});const H=x!==void 0&&x>U.endOffset;F.push({offset:H?x+1:U.endOffset,length:0,content:G?j+L+",":j+L})}return F}else{if(U.setting)return[{offset:U.startOffset,length:0,content:L+","}];const F=(S[O.index-1]&&!S[O.index-1].setting?j:"")+L+(n(O.index,S)?",":"")+j;return[{offset:U.startOffset,length:0,content:F}]}}function h(o,u){return u.filter(y=>y.setting?.key===o)[0]}function i(o,u){for(let y=o-1;y>=0;y--)if(u[y].setting)return u[y]}function n(o,u){for(let y=o+1;y<u.length;y++)if(u[y].setting)return u[y]}function t(o,u,y){const O=o.indexOf(u),S=o.indexOf(y);return o.filter((v,L)=>O<L&&L<S)}function s(o,u){if(o.length&&u.length){let y=0;for(;y<u.length&&y<o.length;y++)if(o[y].value!==u[y].value)return u[y-1];return u[y-1]}}function r(o){const u=[];let y=-1,O,S;const v={onObjectBegin:L=>{y++},onObjectProperty:(L,j,U)=>{y===0&&(O=j,S=L)},onObjectEnd:(L,j)=>{y--,y===0&&u.push({startOffset:O,endOffset:L+j,value:o.substring(O,L+j),setting:{key:S,commaOffset:void 0}})},onArrayBegin:(L,j)=>{y++},onArrayEnd:(L,j)=>{y--,y===0&&u.push({startOffset:O,endOffset:L+j,value:o.substring(O,L+j),setting:{key:S,commaOffset:void 0}})},onLiteralValue:(L,j,U)=>{y===0&&u.push({startOffset:O,endOffset:j+U,value:o.substring(O,j+U),setting:{key:S,commaOffset:void 0}})},onSeparator:(L,j,U)=>{if(y===0&&L===","){let F=u.length-1;for(;F>=0&&!u[F].setting;F--);const G=u[F];G&&u.splice(F,1,{startOffset:G.startOffset,endOffset:G.endOffset,value:G.value,setting:{key:G.setting.key,commaOffset:j}})}},onComment:(L,j)=>{y===0&&u.push({startOffset:L,endOffset:L+j,value:o.substring(L,L+j)})}};return(0,a.$_n)(o,v),u}}),define(ue[83],de([0,1,3,2,4,24]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nNb=e.$mNb=void 0,e.$mNb=(0,N.$Ki)("IUserDataSyncAccountService");let T=class extends a.$Zc{get account(){return this.a}constructor(A,b){super(),this.g=A,this.h=b,this.b=this.B(new I.$qe),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$qe),this.onTokenFailed=this.c.event,this.f=!1,this.B(A.onTokenFailed(R=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,R),this.updateAccount(void 0),R===k.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(A.onTokenSucceed(()=>this.f=!1))}async updateAccount(A){(A&&this.a?A.token!==this.a.token||A.authenticationProviderId!==this.a.authenticationProviderId:A!==this.a)&&(this.a=A,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(A))}};e.$nNb=T,e.$nNb=T=Ee([Z(0,k.$Ppb),Z(1,k.$5pb)],T)}),define(ue[214],de([0,1,20,9,15,11,24]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VPb=void 0;let C=class extends k.$kk{constructor(b,R){super(),this.g=this.B(b.createLogger((0,I.$lh)(R.logsHome,`${T.$6pb}.log`),{id:T.$6pb,name:(0,a.localize)(2460,null)}))}trace(b,...R){this.g.trace(b,...R)}debug(b,...R){this.g.debug(b,...R)}info(b,...R){this.g.info(b,...R)}warn(b,...R){this.g.warn(b,...R)}error(b,...R){this.g.error(b,...R)}flush(){this.g.flush()}};e.$VPb=C,e.$VPb=C=Ee([Z(0,k.$gk),Z(1,N.$Ri)],C)}),define(ue[215],de([0,1,6,3,2]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=void 0;class k extends N.$Zc{constructor({onDidOpenMainWindow:C,onDidFocusMainWindow:A,getActiveWindowId:b}){super(),this.a=this.B(new N.$Yc),a.Event.latch(a.Event.any(C,A))(this.f,this,this.a),this.b=(0,I.$xh)(()=>b()),(async()=>{try{const p=await this.b;this.c=typeof this.c=="number"?this.c:p}catch{}finally{this.b=void 0}})()}f(C){this.b&&(this.b.cancel(),this.b=void 0),this.c=C}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Lic=k}),define(ue[117],de([0,1,9,13,51,20,10,4,22]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$0i=e.$9i=e.$8i=e.$7i=e.$5i=e.$4i=e.WorkbenchState=e.$Xi=e.$Wi=e.$Ti=void 0,e.$Ui=b,e.$Vi=R,e.$Yi=p,e.$Zi=m,e.$1i=f,e.$2i=g,e.$3i=E,e.$6i=P,e.$$i=$,e.$_i=c,e.$bj=h,e.$cj=i,e.$dj=n,e.$Ti=(0,C.$Ki)("contextService");function b(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.uri)}function R(t){return typeof t?.id=="string"&&!b(t)&&!m(t)}e.$Wi={id:"ext-dev"},e.$Xi={id:"empty-window"};function p(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,a.$sc)(t)}:s?e.$Wi:e.$Xi;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function m(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.configPath)}function f(t){const s=t;if(s?.uri)return{id:s.id,uri:T.URI.revive(s.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:T.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}var l;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function g(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function E(t){const s=t;return!!(s&&typeof s=="object"&&T.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class w{constructor(s,r,o,u,y){this.h=s,this.j=o,this.k=u,this.l=y,this.c=N.$Qi.forUris(this.l,()=>!0),this.folders=r}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=N.$Qi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$4i=w;class d{constructor(s,r){this.raw=r,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,k.$lh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$5i=d;function P(t){return new d({uri:t,index:0,name:(0,k.$hh)(t)},{uri:t.toString()})}e.$7i="code-workspace",e.$8i=`.${e.$7i}`,e.$9i=[{name:(0,I.localize)(2489,null),extensions:[e.$7i]}],e.$0i="workspace.json";function $(t,s){return k.$ch.isEqualOrParent(t,s.untitledWorkspacesHome)}function c(t){let s;return T.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===A.Schemas.tmp}e.$aj="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function h(t){return t.id===e.$aj}function i(t,s){return!$(t,s)&&!c(t)}function n(t){return(typeof t=="string"?(0,a.$tc)(t):(0,k.$jh)(t))===e.$8i}}),define(ue[19],de([0,1,55,3,2,20,10,9,15,7,4,11,117,31,28,6,32,26,12]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Rl=e.ProfileResourceType=void 0,e.$Ql=$,e.$Sl=c,e.$Tl=h;var P;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function $(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&T.URI.isUri(s.location)&&T.URI.isUri(s.globalStorageHome)&&T.URI.isUri(s.settingsResource)&&T.URI.isUri(s.keybindingsResource)&&T.URI.isUri(s.tasksResource)&&T.URI.isUri(s.snippetsHome)&&T.URI.isUri(s.extensionsResource))}e.$Rl=(0,R.$Ki)("IUserDataProfilesService");function c(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:T.URI.revive(t.location).with({scheme:s}),globalStorageHome:T.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:T.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:T.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:T.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:T.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:T.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:T.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function h(t,s,r,o,u,y){return{id:t,name:s,location:r,isDefault:!1,shortName:u?.shortName,icon:u?.icon,globalStorageHome:y&&u?.useDefaultFlags?.globalState?y.globalStorageHome:(0,k.$lh)(r,"globalStorage"),settingsResource:y&&u?.useDefaultFlags?.settings?y.settingsResource:(0,k.$lh)(r,"settings.json"),keybindingsResource:y&&u?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,k.$lh)(r,"keybindings.json"),tasksResource:y&&u?.useDefaultFlags?.tasks?y.tasksResource:(0,k.$lh)(r,"tasks.json"),snippetsHome:y&&u?.useDefaultFlags?.snippets?y.snippetsHome:(0,k.$lh)(r,"snippets"),extensionsResource:y&&u?.useDefaultFlags?.extensions?y.extensionsResource:(0,k.$lh)(r,"extensions.json"),cacheHome:(0,k.$lh)(o,t),useDefaultFlags:u?.useDefaultFlags,isTransient:u?.transient}}let i=class extends N.$Zc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,r,o,u){super(),this.t=s,this.u=r,this.w=o,this.y=u,this.f=!0,this.h=this.B(new a.$qe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new a.$qe),this.onWillCreateProfile=this.j.event,this.m=this.B(new a.$qe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new a.$qe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new f.$Fc,workspaces:new f.$Fc,emptyWindows:new Map},this.profilesHome=(0,k.$lh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$lh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),r=[s];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,d.$jg)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(h((0,k.$ih)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},s))}}catch(y){this.y.error(y)}const o=new f.$Fc,u=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[O,S]of Object.entries(y.workspaces)){const v=T.URI.parse(O),L=r.find(j=>j.id===S);L&&o.set(v,L)}if(y.emptyWindows)for(const[O,S]of Object.entries(y.emptyWindows)){const v=r.find(L=>L.id===S);v&&u.set(O,v)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:o,emptyWindows:u}}return this.z}D(){const s=h("__default__profile__",(0,C.localize)(2442,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const r="Temp",o=new RegExp(`${(0,w.$mf)(r)}\\s(\\d+)`);let u=0;for(const O of this.profiles){const S=o.exec(O.name),v=S?parseInt(S[1]):0;u=v>u?v:u}const y=`${r} ${u+1}`;return this.createProfile((0,I.$yj)((0,E.$7g)()).toString(16),y,{transient:!0},s)}async createNamedProfile(s,r,o){return this.createProfile((0,I.$yj)((0,E.$7g)()).toString(16),s,r,o)}async createProfile(s,r,o,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(s,r,o);return u&&await this.setProfileForWorkspace(u,y),y}async F(s,r,o){if(!(0,d.$jg)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let u=this.r.get(r);return u||(u=(async()=>{try{if(this.profiles.find(v=>v.name===r||v.id===s))throw new Error(`Profile with ${r} name already exists`);const O=h(s,r,(0,k.$lh)(this.profilesHome,s),this.g,o,this.defaultProfile);await this.u.createFolder(O.location);const S=[];return this.j.fire({profile:O,join(v){S.push(v)}}),await g.Promises.settled(S),this.I([O],[],[]),O}finally{this.r.delete(r)}})(),this.r.set(r,u)),u}async updateProfile(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(u=>u.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);return o=h(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.I([],[],[o]),o}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(u=>u.id===s.id);if(!r)throw new Error(`Profile '${s.name}' does not exist`);const o=[];this.m.fire({profile:r,join(u){o.push(u)}});try{await Promise.allSettled(o)}catch(u){this.y.error(u)}for(const u of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(u)?.id&&this.C.emptyWindows.delete(u);for(const u of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(u)?.id&&this.C.workspaces.delete(u);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(u){(0,b.$wl)(u)!==b.FileOperationResult.FILE_NOT_FOUND&&this.y.error(u)}}async setProfileForWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(u=>u.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.L(s,o)}unsetWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,r)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.w.extUri.isEqual(o.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(s.map(r=>this.removeProfile(r)))}getProfileForWorkspace(s){const r=this.G(s),o=T.URI.isUri(r)?this.C.workspaces.get(r):this.C.emptyWindows.get(r);return o||((0,m.$Ui)(s)?this.s.folders.get(s.uri):(0,m.$Zi)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,m.$Ui)(s)?s.uri:(0,m.$Zi)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.folders.values()].some(r=>this.w.extUri.isEqual(r.location,s.location)))}I(s,r,o){const u=[...this.profiles,...s],y=[],O=this.s.profiles;this.s.profiles=[];for(let S of u){if(S.isDefault||r.some(L=>S.id===L.id))continue;S=o.find(L=>S.id===L.id)??S;const v=O.find(L=>S.id===L.id);if(S.isTransient)this.s.profiles.push(S);else{if(v){for(const[L,j]of this.s.emptyWindows.entries())if(S.id===j.id){this.L({id:L},S);break}for(const[L,j]of this.s.workspaces.entries())if(S.id===j.id){this.L({id:"",configPath:L},S);break}for(const[L,j]of this.s.folders.entries())if(S.id===j.id){this.L({id:"",uri:L},S);break}}y.push({location:S.location,name:S.name,shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags})}}this.P(y),this.z=void 0,this.J(s,r,o)}J(s,r,o){this.h.fire({added:s,removed:r,updated:o,all:this.profiles})}L(s,r,o){if(o=r?.isTransient?!0:o,o)(0,m.$Ui)(s)?(this.s.folders.delete(s.uri),r&&this.s.folders.set(s.uri,r)):(0,m.$Zi)(s)?(this.s.workspaces.delete(s.configPath),r&&this.s.workspaces.set(s.configPath,r)):(this.s.emptyWindows.delete(s.id),r&&this.s.emptyWindows.set(s.id,r));else{this.L(s,void 0,!0);const u=this.G(s);T.URI.isUri(u)?(this.C.workspaces.delete(u),r&&this.C.workspaces.set(u,r)):(this.C.emptyWindows.delete(u),r&&this.C.emptyWindows.set(u,r)),this.M()}}M(){const s={};for(const[o,u]of this.C.workspaces.entries())s[o.toString()]=u.id;const r={};for(const[o,u]of this.C.emptyWindows.entries())r[o.toString()]=u.id;this.R({workspaces:s,emptyWindows:r}),this.z=void 0}N(s){const r={},o=this.D();if(s.workspaces)for(const[y,O]of Object.entries(s.workspaces)){const S=T.URI.parse(O);r[y]=this.w.extUri.isEqual(S,o.location)?o.id:this.w.extUri.basename(S)}const u={};if(s.emptyWindows)for(const[y,O]of Object.entries(s.emptyWindows)){const S=T.URI.parse(O);u[y]=this.w.extUri.isEqual(S,o.location)?o.id:this.w.extUri.basename(S)}return{workspaces:r,emptyWindows:u}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Ul=i,e.$Ul=i=Ee([Z(0,A.$Ri),Z(1,b.$fl),Z(2,l.$Pl),Z(3,p.$fk)],i);class n extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Vl=n}),define(ue[216],de([0,1,6,2,19]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=void 0;let k=class extends a.$Zc{constructor(C){super(),this.B(new I.$Wh(()=>{C.cleanUp()},10*1e3)).schedule()}};e.$Rjc=k,e.$Rjc=k=Ee([Z(0,N.$Rl)],k)}),define(ue[84],de([0,1,17,6,25,8,3,2,31,5,12,10,9,27,35,34,59,11,23,18,28,19]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Nq=void 0,e.$Oq=i,m=Oe(m);let h=class extends C.$Zc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(r,o,u,y,O,S){super(),this.z=r,this.C=o,this.D=u,this.F=y,this.G=O,this.H=S,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new T.$qe),this.s=this.B(new T.$qe),this.t=this.B(new T.$qe),this.u=this.B(new T.$qe),this.w=this.B(new T.$qe),this.y=[],this.B((0,C.$Xc)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(u=>(0,f.$pp)(u,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{const y=(await this.installGalleryExtensions([{extension:r,options:o}])).find(({identifier:O})=>(0,l.$Sp)(O,r.identifier));if(y?.local)return y?.local;throw y?.error?y.error:new f.$tp(`Unknown error while installing extension ${r.identifier.id}`,f.ExtensionManagementErrorCode.Unknown)}catch(u){throw i(u)}}async installGalleryExtensions(r){if(!this.z.isEnabled())throw new f.$tp(m.localize(1767,null),f.ExtensionManagementErrorCode.NotAllowed);const o=[],u=[];return await Promise.allSettled(r.map(async({extension:y,options:O})=>{try{const S=await this.N(y,!!O?.installGivenVersion,!!O?.installPreReleaseVersion,O.productVersion??{version:this.G.version,date:this.G.date});u.push({...S,options:O})}catch(S){o.push({identifier:y.identifier,operation:f.InstallOperation.Install,source:y,error:S,profileLocation:O.profileLocation??this.W()})}})),u.length&&o.push(...await this.I(u)),o}async uninstall(r,o){return this.F.trace("ExtensionManagementService#uninstall",r.identifier.id),this.uninstallExtensions([{extension:r,options:o}])}async toggleAppliationScope(r,o){if((0,g.$An)(r.manifest)||r.isBuiltin)return r;if(r.isApplicationScoped){let u=await this.updateMetadata(r,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(u=await this.Z(r,this.H.defaultProfile.extensionsResource,o));for(const y of this.H.profiles){const O=(await this.getInstalled(g.ExtensionType.User,y.extensionsResource)).find(S=>(0,l.$Sp)(S.identifier,r.identifier));O?this.w.fire({local:O,profileLocation:y.extensionsResource}):this.u.fire({identifier:r.identifier,profileLocation:y.extensionsResource})}return u}else{const u=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(r,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(r,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:u.identifier,operation:f.InstallOperation.Install,local:u,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.g||r-this.h>1e3*60*5)&&(this.g=this.U(),this.h=r),this.g}registerParticipant(r){this.y.push(r)}async resetPinnedStateForAllUserExtensions(r){try{await this.L(this.H.profiles.map(async o=>{const u=await this.getInstalled(g.ExtensionType.User,o.extensionsResource);await this.L(u.map(async y=>{y.pinned!==r&&await this.updateMetadata(y,{pinned:r},o.extensionsResource)}))}))}catch(o){throw this.F.error("Error while resetting pinned state for all user extensions",(0,k.$bb)(o)),o}}async I(r){const o=new Map,u=new Map,y=[],O=(v,L)=>`${l.$Tp.create(v).toString()}-${L.toString()}`,S=(v,L,j,U)=>{const F=this.X(v,L,j),G=`${(0,l.$Xp)(v.publisher,v.name)}-${j.profileLocation.toString()}`;u.set(G,{task:F,root:U}),this.n.fire({identifier:F.identifier,source:L,profileLocation:j.profileLocation}),this.F.info("Installing extension:",F.identifier.id,j),p.URI.isUri(L)||this.j.set(O(L,j.profileLocation),{task:F,waitingTasks:[]})};try{for(const{manifest:v,extension:L,options:j}of r){const U=j.isApplicationScoped||j.isBuiltin||(0,g.$An)(v),F={...j,installOnlyNewlyAddedFromExtensionPack:j.installOnlyNewlyAddedFromExtensionPack??!p.URI.isUri(L),isApplicationScoped:U,profileLocation:U?this.H.defaultProfile.extensionsResource:j.profileLocation??this.W(),productVersion:j.productVersion??{version:this.G.version,date:this.G.date}},G=p.URI.isUri(L)?void 0:this.j.get(O(L,F.profileLocation));G?(this.F.info("Extension is already requested to install",G.task.identifier.id,F.profileLocation.toString()),y.push(G.task.waitUntilTaskIsFinished())):S(v,L,F,void 0)}return await Promise.all([...u.values()].map(async({task:v})=>{if(v.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const L=await this.M(v.identifier,v.manifest,!!v.options.installOnlyNewlyAddedFromExtensionPack,!!v.options.installPreReleaseVersion,v.options.profileLocation,v.options.productVersion),j=await this.getInstalled(void 0,v.options.profileLocation,v.options.productVersion),U={...v.options,context:{...v.options.context,[f.$jp]:!0}};for(const{gallery:F,manifest:G}of(0,I.$Qb)(L,({gallery:V})=>V.identifier.id)){if(u.has(`${F.identifier.id.toLowerCase()}-${U.profileLocation.toString()}`))continue;const V=this.j.get(O(F,U.profileLocation));if(V){if(this.J(v,V.task)){const x=V.task.identifier;this.F.info("Waiting for already requested installing extension",x.id,v.identifier.id,U.profileLocation.toString()),V.waitingTasks.push(v),y.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,H=>H.some(te=>(0,l.$Sp)(te.identifier,x)))).then(H=>{if(this.F.info("Finished waiting for already requested installing extension",x.id,v.identifier.id,U.profileLocation.toString()),!H.find(z=>(0,l.$Sp)(z.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else j.some(({identifier:x})=>(0,l.$Sp)(x,F.identifier))||S(G,F,U,v)}}catch(L){if(p.URI.isUri(v.source))(0,I.$Pb)(v.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",v.identifier.id,L.message),(0,I.$Pb)(v.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",v.identifier.id,L.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),L}})),await this.L([...u.entries()].map(async([v,{task:L}])=>{const j=new Date().getTime();let U;try{U=await L.run(),await this.L(this.y.map(F=>F.postInstall(U,L.source,L.options,N.CancellationToken.None)),f.ExtensionManagementErrorCode.PostInstall)}catch(F){const G=i(F);throw p.URI.isUri(L.source)||n(this.C,L.operation===f.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$1p)(L.source),error:G,source:L.options.context?.[f.$ip]}),o.set(v,{error:G,identifier:L.identifier,operation:L.operation,source:L.source,context:L.options.context,profileLocation:L.options.profileLocation,applicationScoped:L.options.isApplicationScoped}),this.F.error("Error while installing the extension",L.identifier.id,(0,k.$bb)(G),L.options.profileLocation.toString()),G}if(!p.URI.isUri(L.source)){const F=L.operation===f.InstallOperation.Update,G=F?void 0:(new Date().getTime()-L.source.lastUpdated)/1e3;if(n(this.C,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$1p)(L.source),verificationStatus:L.verificationStatus,duration:new Date().getTime()-j,durationSinceUpdate:G,source:L.options.context?.[f.$ip]}),b.$r&&L.operation!==f.InstallOperation.Update)try{await this.z.reportStatistic(U.manifest.publisher,U.manifest.name,U.manifest.version,f.StatisticType.Install)}catch{}}o.set(v,{local:U,identifier:L.identifier,operation:L.operation,source:L.source,context:L.options.context,profileLocation:L.options.profileLocation,applicationScoped:U.isApplicationScoped})})),y.length&&await this.L(y),[...o.values()]}catch(v){const L=(F,G,V)=>{const x=[];F.manifest.extensionDependencies?.length&&x.push(...F.manifest.extensionDependencies),F.manifest.extensionPack?.length&&x.push(...F.manifest.extensionPack);for(const H of x){if(V.includes(H.toLowerCase()))continue;V.push(H.toLowerCase());const te=o.get(`${H.toLowerCase()}-${G.toString()}`);te?.local&&(V=L(te.local,G,V))}return V},j=F=>({identifier:F.identifier,operation:f.InstallOperation.Install,source:F.source,context:F.options.context,profileLocation:F.options.profileLocation,error:v}),U=[];for(const[F,{task:G,root:V}]of u){const x=o.get(F);x?x.local&&V&&!o.get(`${V.identifier.id.toLowerCase()}-${G.options.profileLocation.toString()}`)?.local&&(U.push(this.Y(x.local,{versionOnly:!0,profileLocation:G.options.profileLocation})),o.set(F,j(G))):(G.cancel(),o.set(F,j(G)))}for(const[F,{task:G}]of u){const V=o.get(F);if(!V?.local||G.options.donotIncludePackAndDependencies)continue;L(V.local,G.options.profileLocation,[V.local.identifier.id.toLowerCase()]).slice(1).some(H=>u.has(`${H.toLowerCase()}-${G.options.profileLocation.toString()}`)&&!o.get(`${H.toLowerCase()}-${G.options.profileLocation.toString()}`)?.local)&&(U.push(this.Y(V.local,{versionOnly:!0,profileLocation:G.options.profileLocation})),o.set(F,j(G)))}throw U.length&&await Promise.allSettled(U.map(async F=>{try{await F.run(),this.F.info("Rollback: Uninstalled extension",F.extension.identifier.id)}catch(G){this.F.warn("Rollback: Error while uninstalling extension",F.extension.identifier.id,(0,k.$bb)(G))}})),v}finally{for(const{task:v}of u.values())v.source&&!p.URI.isUri(v.source)&&this.j.delete(O(v.source,v.options.profileLocation));if(o.size){const v=[...o.values()];for(const L of v)L.local&&this.F.info("Extension installed successfully:",L.identifier.id,L.profileLocation.toString());this.s.fire(v)}}}J(r,o){for(const[,{task:u,waitingTasks:y}]of this.j.entries())if(u===r&&(y.includes(o)||y.some(O=>this.J(O,o)))||u===o&&y[0]&&!this.J(r,y[0]))return!1;return!0}async L(r,o){const u=[],y=[],O=await Promise.allSettled(r);for(const v of O)v.status==="fulfilled"?u.push(v.value):y.push(i(v.reason,o));if(!y.length)return u;if(y.length===1)throw y[0];let S=new f.$tp("",f.ExtensionManagementErrorCode.Unknown);for(const v of y)S=new f.$tp(S.message?`${S.message}, ${v.message}`:v.message,v.code!==f.ExtensionManagementErrorCode.Unknown&&v.code!==f.ExtensionManagementErrorCode.Internal?v.code:S.code);throw S}async M(r,o,u,y,O,S){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,O,S),L=[],j=[],U=async(F,G)=>{L.push(F);const V=G.extensionDependencies||[],x=[...V];if(G.extensionPack){const H=u?v.find(te=>(0,l.$Sp)(te.identifier,F)):void 0;for(const te of G.extensionPack)H&&H.manifest.extensionPack&&H.manifest.extensionPack.some(z=>(0,l.$Sp)({id:z},{id:te}))||x.every(z=>!(0,l.$Sp)({id:z},{id:te}))&&x.push(te)}if(x.length){const H=x.filter(te=>L.every(z=>!(0,l.$Sp)(z,{id:te})));if(H.length){const te=await this.z.getExtensions(H.map(z=>({id:z,preRelease:y})),N.CancellationToken.None);for(const z of te){if(L.find(ne=>(0,l.$Sp)(ne,z.identifier)))continue;const W=V.some(ne=>(0,l.$Sp)({id:ne},z.identifier));let _;try{_=await this.N(z,!1,y,S)}catch(ne){if(W)throw ne;this.F.info("Skipping the packed extension as it cannot be installed",z.identifier.id,(0,k.$bb)(ne));continue}j.push({gallery:_.extension,manifest:_.manifest}),await U(_.extension.identifier,_.manifest)}}}};return await U(r,o),j}async N(r,o,u,y){let O;const S=await this.getExtensionsControlManifest();if(S.malicious.some(j=>(0,l.$Sp)(r.identifier,j)))throw new f.$tp(m.localize(1768,null,r.identifier.id),f.ExtensionManagementErrorCode.Malicious);const v=S.deprecated[r.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${r.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),O=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:y},N.CancellationToken.None))[0],!O)throw new f.$tp(m.localize(1769,null,r.identifier.id,v.extension.id),f.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(r)){const j=await this.getTargetPlatform();throw new f.$tp(m.localize(1770,null,r.identifier.id,this.G.nameLong,(0,f.$lp)(j)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(O=await this.O(r,o,u,y),!O){const j=[];throw(0,E.$aq)(r.properties.enabledApiProposals??[],j)?!u&&r.properties.isPreReleaseVersion&&(await this.z.getExtensions([r.identifier],N.CancellationToken.None))[0]?new f.$tp(m.localize(1772,null,r.displayName??r.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.$tp(m.localize(1773,null,r.identifier.id,this.G.nameLong,this.G.version),f.ExtensionManagementErrorCode.Incompatible):new f.$tp(m.localize(1771,null,r.displayName??r.identifier.id,j[0]),f.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",O.identifier.id);const L=await this.z.getManifest(O,N.CancellationToken.None);if(L===null)throw new f.$tp(`Missing manifest for extension ${O.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(L.version!==O.version)throw new f.$tp(`Cannot install '${O.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:O,manifest:L}}async O(r,o,u,y){const O=await this.getTargetPlatform();let S=null;return!o&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==u&&(S=(await this.z.getExtensions([{...r.identifier,preRelease:u}],{targetPlatform:O,compatible:!0,productVersion:y},N.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(r,u,O,y)&&(S=r),S||(o?S=(await this.z.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:O,compatible:!0,productVersion:y},N.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(r,u,O,y)),S}async uninstallExtensions(r){const o=(j,U)=>`${j.identifier.id.toLowerCase()}${U.versionOnly?`-${j.manifest.version}`:""}@${U.profileLocation.toString()}`,u=(j,U)=>{const F=this.Y(j,U);return this.m.set(o(F.extension,U),F),this.F.info("Uninstalling extension from the profile:",`${j.identifier.id}@${j.manifest.version}`,U.profileLocation.toString()),this.t.fire({identifier:j.identifier,profileLocation:U.profileLocation,applicationScoped:j.isApplicationScoped}),F},y=(j,U,F)=>{F?this.F.error("Failed to uninstall extension from the profile:",`${j.identifier.id}@${j.manifest.version}`,U.profileLocation.toString(),F.message):this.F.info("Successfully uninstalled extension from the profile",`${j.identifier.id}@${j.manifest.version}`,U.profileLocation.toString()),n(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Zp)(j),error:F}),this.u.fire({identifier:j.identifier,error:F?.code,profileLocation:U.profileLocation,applicationScoped:j.isApplicationScoped})},O=[],S=[],v=[],L=new A.$Fc;for(const{extension:j,options:U}of r){const F={...U,profileLocation:j.isApplicationScoped?this.H.defaultProfile.extensionsResource:U?.profileLocation??this.W()},G=this.m.get(o(j,F));G?(this.F.info("Extensions is already requested to uninstall",j.identifier.id),v.push(G.waitUntilTaskIsFinished())):O.push(u(j,F))}try{for(const j of O.slice(0)){let U=L.get(j.options.profileLocation);if(U||L.set(j.options.profileLocation,U=await this.getInstalled(g.ExtensionType.User,j.options.profileLocation)),j.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${j.extension.identifier.id}@${j.extension.manifest.version}`);else{const F=this.R(j.extension,U);for(const G of F)this.m.has(o(G,j.options))?this.F.info("Extensions is already requested to uninstall",G.identifier.id):O.push(u(G,j.options))}j.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${j.extension.identifier.id}@${j.extension.manifest.version}`):this.P(O.map(F=>F.extension),U,j.extension)}await this.L(O.map(async j=>{try{if(await j.run(),await this.L(this.y.map(U=>U.postUninstall(j.extension,j.options,N.CancellationToken.None))),j.extension.identifier.uuid)try{await this.z.reportStatistic(j.extension.manifest.publisher,j.extension.manifest.name,j.extension.manifest.version,f.StatisticType.Uninstall)}catch{}}catch(U){const F=i(U);throw y(j.extension,j.options,F),F}finally{S.push(j)}})),v.length&&await this.L(v);for(const j of O)y(j.extension,j.options)}catch(j){const U=i(j);for(const F of O){try{F.cancel()}catch{}S.includes(F)||y(F.extension,F.options,U)}throw U}finally{for(const j of O)this.m.delete(o(j.extension,j.options))||this.F.warn("Uninstallation task is not found in the cache",j.extension.identifier.id)}}P(r,o,u){for(const y of r){const O=this.S(y,o);if(O.length){const S=O.filter(v=>!r.some(L=>(0,l.$Sp)(L.identifier,v.identifier)));if(S.length)throw new Error(this.Q(y,S,u))}}}Q(r,o,u){return u===r?o.length===1?m.localize(1774,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?m.localize(1775,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):m.localize(1776,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?m.localize(1777,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?m.localize(1778,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):m.localize(1779,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}R(r,o,u=[]){if(u.indexOf(r)!==-1)return[];u.push(r);const y=r.manifest.extensionPack?r.manifest.extensionPack:[];if(y.length){const O=o.filter(v=>!v.isBuiltin&&y.some(L=>(0,l.$Sp)({id:L},v.identifier))),S=[];for(const v of O)S.push(...this.R(v,o,u));return[...O,...S]}return[]}S(r,o){return o.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(y=>(0,l.$Sp)({id:y},r.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(r){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$bb)(r)),{malicious:[],deprecated:{},search:[]}}}};e.$Nq=h,e.$Nq=h=Ee([Z(0,f.$rp),Z(1,P.$em),Z(2,$.$Pl),Z(3,w.$fk),Z(4,d.$yk),Z(5,c.$Rl)],h);function i(s,r){if(s instanceof f.$tp)return s;let o;return s instanceof f.$sp?o=new f.$tp(s.message,s.code===f.ExtensionGalleryErrorCode.DownloadFailedWriting?f.ExtensionManagementErrorCode.DownloadFailedWriting:f.ExtensionManagementErrorCode.Gallery):o=new f.$tp(s.message,(0,k.$8)(s)?f.ExtensionManagementErrorCode.Cancelled:r??f.ExtensionManagementErrorCode.Internal),o.stack=s.stack,o}function n(s,r,{extensionData:o,verificationStatus:u,duration:y,error:O,source:S,durationSinceUpdate:v}){let L,j;(0,R.$rg)(u)&&(u===!0?u="Verified":(u===!1||(L=f.ExtensionManagementErrorCode.Signature,j=u),u="Unverified")),O&&(L=O.code,O.code===f.ExtensionManagementErrorCode.Signature&&(j=O.message)),s.publicLog(r,{...o,verificationStatus:u,success:!O,duration:y,errorcode:L,errorcodeDetail:j,durationSinceUpdate:v,source:S})}class t{constructor(){this.d=new a.$Jh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,a.$xh)(r=>this.h(r))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,a.$xh)(r=>new Promise((o,u)=>{const y=r.onCancellationRequested(()=>{y.dispose(),u(new k.$9)})})),this.d.open()),this.g.cancel()}}e.$Pq=t}),define(ue[52],de([0,1,6,14,2,3,31,10,27,35,7,4,11,19,28,12,8,18]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=e.$Qq=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class P extends Error{constructor(n,t){super(n),this.code=t}}e.$Qq=P,e.$Rq=(0,p.$Ki)("IExtensionsProfileScannerService");let $=class extends N.$Zc{constructor(n,t,s,r,o,u){super(),this.j=n,this.m=t,this.n=s,this.r=r,this.s=o,this.t=u,this.b=this.B(new k.$qe),this.onAddExtensions=this.b.event,this.c=this.B(new k.$qe),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$qe),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$qe),this.onDidRemoveExtensions=this.g.event,this.h=new T.$Fc}scanProfileExtensions(n,t){return this.u(n,void 0,t)}async addExtensionsToProfile(n,t,s){const r=[],o=[];try{return await this.u(t,u=>{const y=[];if(s)y.push(...u);else for(const O of u)n.some(([S])=>(0,b.$Sp)(S.identifier,O.identifier)&&S.manifest.version!==O.version)?r.push(O):y.push(O);for(const[O,S]of n){const v=y.findIndex(j=>(0,b.$Sp)(j.identifier,O.identifier)&&j.version===O.manifest.version),L={identifier:O.identifier,version:O.manifest.version,location:O.location,metadata:S};v===-1?(o.push(L),y.push(L)):y.splice(v,1,L)}return o.length&&this.b.fire({extensions:o,profileLocation:t}),r.length&&this.f.fire({extensions:r,profileLocation:t}),y}),o.length&&this.c.fire({extensions:o,profileLocation:t}),r.length&&this.g.fire({extensions:r,profileLocation:t}),o}catch(u){throw o.length&&this.c.fire({extensions:o,error:u,profileLocation:t}),r.length&&this.g.fire({extensions:r,error:u,profileLocation:t}),u}}async updateMetadata(n,t){const s=[];return await this.u(t,r=>{const o=[];for(const u of r){const y=n.find(([O])=>(0,b.$Sp)(O.identifier,u.identifier)&&O.manifest.version===u.version);y&&(u.metadata={...u.metadata,...y[1]},s.push(u)),o.push(u)}return o}),s}async removeExtensionFromProfile(n,t){const s=[];try{await this.u(t,r=>{const o=[];for(const u of r)(0,b.$Sp)(u.identifier,n.identifier)?s.push(u):o.push(u);return s.length&&this.f.fire({extensions:s,profileLocation:t}),o}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(r){throw s.length&&this.g.fire({extensions:s,error:r,profileLocation:t}),r}}async u(n,t,s){return this.F(n).queue(async()=>{let r=[],o;try{const u=await this.m.readFile(n);o=JSON.parse(u.value.toString().trim()||"[]")}catch(u){if((0,R.$wl)(u)!==R.FileOperationResult.FILE_NOT_FOUND)throw u;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(o=await this.D()),!o&&s?.bailOutWhenFileNotFound)throw new P((0,E.$bb)(u),d.ERROR_PROFILE_NOT_FOUND)}if(o){Array.isArray(o)||this.w(n);let u=!1;for(const y of o){c(y)||this.w(n);let O;if((0,g.$jg)(y.relativeLocation)&&y.relativeLocation)O=this.z(y.relativeLocation);else if((0,g.$jg)(y.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${y.location}`);continue}else{O=C.URI.revive(y.location);const S=this.y(O);S&&(u=!0,y.relativeLocation=S)}(0,g.$qg)(y.metadata?.hasPreReleaseVersion)&&y.metadata?.preRelease&&(u=!0,y.metadata.hasPreReleaseVersion=!0),r.push({identifier:y.identifier,location:O,version:y.version,metadata:y.metadata})}u&&await this.m.writeFile(n,a.$Se.fromString(JSON.stringify(o)))}if(t){r=t(r);const u=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(n,a.$Se.fromString(JSON.stringify(u)))}return r})}w(n){const t=new P(`Invalid extensions content in ${n.toString()}`,d.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(n)).value.toString()}catch(o){if((0,R.$wl)(o)===R.FileOperationResult.FILE_NOT_FOUND)return;throw o}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(s);Array.isArray(o)&&o.every(u=>c(u))?r=o:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.t.error(o)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,a.$Se.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(o){if((0,R.$wl)(o)===R.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw o}try{await this.m.del(n)}catch(o){(0,R.$wl)(o)!==R.FileOperationResult.FILE_NOT_FOUND&&this.t.error(o)}try{await this.m.del(t)}catch(o){(0,R.$wl)(o)!==R.FileOperationResult.FILE_NOT_FOUND&&this.t.error(o)}return r})()),this.C}F(n){let t=this.h.get(n);return t||(t=new I.$Rh,this.h.set(n,t)),t}};e.$Sq=$,e.$Sq=$=Ee([Z(1,R.$fl),Z(2,f.$Rl),Z(3,l.$Pl),Z(4,w.$em),Z(5,m.$fk)],$);function c(i){return(0,g.$lg)(i)&&(0,A.$qp)(i.identifier)&&(h(i.location)||(0,g.$jg)(i.location)&&i.location)&&((0,g.$qg)(i.relativeLocation)||(0,g.$jg)(i.relativeLocation))&&i.version&&(0,g.$jg)(i.version)}function h(i){return i?(0,g.$jg)(i.path)&&(0,g.$jg)(i.scheme):!1}});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ue[85],de([0,1,17,6,29,14,8,36,144,2,22,13,5,20,60,92,12,10,9,15,35,34,59,7,4,11,23,3,68,52,19,28,159]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P,$,c,h,i,n,t,s,r,o,u,y,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Xq=e.$Wq=e.$Vq=e.Translations=void 0,e.$Yq=G,N=Oe(N),p=Oe(p),m=Oe(m),l=Oe(l),g=it(g);var v;(function(x){function H(te,z){if(te===z)return!0;const W=Object.keys(te),_=new Set;for(const ne of Object.keys(z))_.add(ne);if(W.length!==_.size)return!1;for(const ne of W){if(te[ne]!==z[ne])return!1;_.delete(ne)}return _.size===0}x.equals=H})(v||(e.Translations=v={})),e.$Vq=(0,n.$Ki)("IExtensionsScannerService");let L=class extends b.$Zc{constructor(H,te,z,W,_,ne,le,ee,X,K,q,D){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=te,this.r=z,this.s=W,this.t=_,this.u=ne,this.w=le,this.y=ee,this.z=X,this.C=K,this.D=q,this.F=D,this.g=this.B(new r.$qe),this.onDidChangeCache=this.g.event,this.h=(0,f.$lh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(F,this.s,this.h)),this.m=this.B(this.F.createInstance(F,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(c.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(c.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,$.$4p)(this.w,this.y)),this.G}async scanAllExtensions(H,te,z){const[W,_]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(te)]),ne=z?await this.scanExtensionsUnderDevelopment(H,[...W,..._]):[];return this.L(W,_,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const te=[];te.push(this.M(!!H.useCache,H.language)),te.push(this.N(H.language,!!H.checkControlFile));const[z,W]=await Promise.all(te);return this.J([...z,...W],c.ExtensionType.System,H,!1)}async scanUserExtensions(H){const te=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",te);const z=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(te,!!H.profileLocation,c.ExtensionType.User,!H.includeUninstalled,H.language,!0,z,H.productVersion??this.R()),_=H.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let ne;try{ne=await _.scanExtensions(W)}catch(le){if(le instanceof u.$Qq&&le.code===u.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),ne=await _.scanExtensions(W);else throw le}return ne=await this.J(ne,c.ExtensionType.User,H,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,te){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const z=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===R.Schemas.file).map(async W=>{const _=await this.P(W,!1,c.ExtensionType.User,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(_)).map(le=>(le.type=te.find(ee=>(0,$.$Sp)(ee.identifier,le.identifier))?.type??le.type,this.n.validate(le,_)))}))).flat();return this.J(z,"development",H,!0)}return[]}async scanExistingExtension(H,te,z){const W=await this.P(H,!1,te,!0,z.language,!0,void 0,z.productVersion??this.R()),_=await this.n.scanExtension(W);return!_||!z.includeInvalid&&!_.isValid?null:_}async scanOneOrMultipleExtensions(H,te,z){const W=await this.P(H,!1,te,!0,z.language,!0,void 0,z.productVersion??this.R()),_=await this.n.scanOneOrMultipleExtensions(W);return this.J(_,te,z,!0)}async scanMultipleExtensions(H,te,z){const W=[];return await Promise.all(H.map(async _=>{const ne=await this.scanOneOrMultipleExtensions(_,te,z);W.push(...ne)})),this.J(W,te,z,!0)}async scanMetadata(H){const te=(0,f.$lh)(H,"package.json"),z=(await this.w.readFile(te)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(H,te){const z=(0,f.$lh)(H,"package.json"),W=(await this.w.readFile(z)).value.toString(),_=JSON.parse(W);te.isMachineScoped===!1&&delete te.isMachineScoped,te.isBuiltin===!1&&delete te.isBuiltin,_.__metadata={..._.__metadata,...te},await this.w.writeFile((0,f.$lh)(H,"package.json"),k.$Se.fromString(JSON.stringify(_,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof u.$Qq&&H.code===u.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(te=>[te,te.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Se.fromString(JSON.stringify([])))}catch(te){(0,i.$wl)(te)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$bb)(te))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,te,z,W){return z.includeAllVersions||(H=this.L(te===c.ExtensionType.System?H:void 0,te===c.ExtensionType.User?H:void 0,te==="development"?H:void 0,await this.getTargetPlatform(),W)),z.includeInvalid||(H=H.filter(_=>_.isValid)),H.sort((_,ne)=>{const le=p.$sc(_.location.fsPath),ee=p.$sc(ne.location.fsPath);return le<ee?-1:le>ee?1:0})}L(H,te,z,W,_){const ne=(ee,X,K)=>{if(ee.isValid&&!X.isValid)return!1;if(ee.isValid===X.isValid){if(_&&l.gt(ee.manifest.version,X.manifest.version))return this.y.debug(`Skipping extension ${X.location.path} with lower version ${X.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(l.eq(ee.manifest.version,X.manifest.version)){if(ee.type===c.ExtensionType.System)return this.y.debug(`Skipping extension ${X.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===W)return this.y.debug(`Skipping extension ${X.location.path} from different target platform ${X.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${ee.location.path} with ${X.location.path}.`):this.y.debug(`Overwriting user extension ${ee.location.path} with ${X.location.path}.`),!0},le=new c.$zn;return H?.forEach(ee=>{const X=le.get(ee.identifier.id);(!X||ne(X,ee,!1))&&le.set(ee.identifier.id,ee)}),te?.forEach(ee=>{const X=le.get(ee.identifier.id);if(!X&&H&&ee.type===c.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!X||ne(X,ee,!1))&&le.set(ee.identifier.id,ee)}),z?.forEach(ee=>{const X=le.get(ee.identifier.id);(!X||ne(X,ee,!0))&&le.set(ee.identifier.id,ee),le.set(ee.identifier.id,ee)}),[...le.values()]}async M(H,te){this.y.trace("Started scanning system extensions");const z=await this.P(this.systemExtensionsLocation,!1,c.ExtensionType.System,!0,te,!0,void 0,this.R()),_=await(H&&!z.devMode?this.j:this.n).scanExtensions(z);return this.y.trace("Scanned system extensions:",_.length),_}async N(H,te){const z=this.z.isBuilt?[]:this.C.builtInExtensions;if(!z?.length)return[];this.y.trace("Started scanning dev system extensions");const W=te?await this.O():{},_=[],ne=w.URI.file(p.$mc(p.$oc(R.$5g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of z){const X=W[ee.name]||"marketplace";switch(X){case"disabled":break;case"marketplace":_.push((0,f.$lh)(ne,ee.name));break;default:_.push(w.URI.file(X));break}}const le=await Promise.all(_.map(async ee=>this.n.scanExtension(await this.P(ee,!1,c.ExtensionType.System,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",le.length),(0,I.$Lb)(le)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,te,z,W,_,ne,le,ee){const X=await this.f(_??m.$z),K=await this.Q(H),q=te&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=q?await this.Q(q):void 0;return new j(H,K,q,D,te,le,z,W,ne,ee.version,ee.date,this.C.commit,!this.z.isBuilt,_,X)}async Q(H){try{const te=await this.w.stat(H);if(typeof te.mtime=="number")return te.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Wq=L,e.$Wq=L=Ee([Z(4,y.$Rl),Z(5,u.$Rq),Z(6,i.$fl),Z(7,t.$fk),Z(8,P.$Ri),Z(9,s.$yk),Z(10,O.$Pl),Z(11,n.$Ji)],L);class j{constructor(H,te,z,W,_,ne,le,ee,X,K,q,D,J,oe,Q){this.location=H,this.mtime=te,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=W,this.profile=_,this.profileScanOptions=ne,this.type=le,this.excludeObsolete=ee,this.validate=X,this.productVersion=K,this.productDate=q,this.productCommit=D,this.devMode=J,this.language=oe,this.translations=Q}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,te){return(0,f.$eh)(H.location,te.location)&&H.mtime===te.mtime&&(0,f.$eh)(H.applicationExtensionslocation,te.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&H.profile===te.profile&&N.$oo(H.profileScanOptions,te.profileScanOptions)&&H.type===te.type&&H.excludeObsolete===te.excludeObsolete&&H.validate===te.validate&&H.productVersion===te.productVersion&&H.productDate===te.productDate&&H.productCommit===te.productCommit&&H.devMode===te.devMode&&H.language===te.language&&v.equals(H.translations,te.translations)}}e.$Xq=j;let U=class extends b.$Zc{constructor(H,te,z,W,_,ne,le){super(),this.g=H,this.h=te,this.j=z,this.m=W,this.n=ne,this.r=le,this.f=_.extensionsEnabledWithApiProposalVersion?.map(ee=>ee.toLowerCase())??[]}async scanExtensions(H){const te=H.profile?await this.t(H):await this.s(H);let z={};if(H.excludeObsolete&&H.type===c.ExtensionType.User)try{const W=(await this.m.readFile(this.g)).value.toString();z=JSON.parse(W)}catch{}return(0,E.$wg)(z)?te:te.filter(W=>!z[$.$Tp.create(W).toString()])}async s(H){const te=await this.m.resolve(H.location);if(!te.children?.length)return[];const z=await Promise.all(te.children.map(async W=>{if(!W.isDirectory||H.type===c.ExtensionType.User&&(0,f.$ih)(W.resource).indexOf(".")===0)return null;const _=new j(W.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(_)}));return(0,I.$Lb)(z).sort((W,_)=>W.location.path<_.location.path?-1:1)}async t(H){let te=await this.u(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.j.extUri.isEqual(H.location,H.applicationExtensionslocation)){te=te.filter(W=>!W.metadata?.isApplicationScoped);const z=await this.u(H.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,H);te.push(...z)}return te}async u(H,te,z){const W=await this.h.scanProfileExtensions(H,z.profileScanOptions);if(!W.length)return[];const _=await Promise.all(W.map(async ne=>{if(te(ne)){const le=new j(ne.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(le,ne.metadata)}return null}));return(0,I.$Lb)(_)}async scanOneOrMultipleExtensions(H){try{if(await this.m.exists((0,f.$lh)(H.location,"package.json"))){const te=await this.scanExtension(H);return te?[te]:[]}else return await this.scanExtensions(H)}catch(te){return this.r.error(`Error scanning extensions at ${H.location.path}:`,(0,T.$bb)(te)),[]}}async scanExtension(H,te){try{let z=await this.w(H.location);if(z){z.publisher||(z.publisher=c.$tn),te=te??z.__metadata,delete z.__metadata;const W=(0,$.$Xp)(z.publisher,z.name),_=te?.id?{id:W,uuid:te.id}:{id:W},ne=te?.isSystem?c.ExtensionType.System:H.type,le=ne===c.ExtensionType.System||!!te?.isBuiltin;z=await this.y(H.location,z,j.createNlsConfiguration(H));let ee={type:ne,identifier:_,manifest:z,location:H.location,isBuiltin:le,targetPlatform:te?.targetPlatform??c.TargetPlatform.UNDEFINED,publisherDisplayName:te?.publisherDisplayName,metadata:te,isValid:!0,validations:[]};return H.validate&&(ee=this.validate(ee,H)),z.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(W.toLowerCase()))&&(z.originalEnabledApiProposals=z.enabledApiProposals,z.enabledApiProposals=(0,c.$Fn)([...z.enabledApiProposals])),ee}}catch(z){H.type!==c.ExtensionType.System&&this.r.error(z)}return null}validate(H,te){let z=!0;const W=this.n.isBuilt&&this.f.includes(H.identifier.id.toLowerCase()),_=(0,h.$0p)(te.productVersion,te.productDate,te.location,H.manifest,H.isBuiltin,W);for(const[ne,le]of _)ne===g.default.Error&&(z=!1,this.r.error(this.F(te.location,le)));return H.isValid=z,H.validations=_,H}async w(H){const te=(0,f.$lh)(H,"package.json");let z;try{z=(await this.m.readFile(te)).value.toString()}catch(_){return(0,i.$wl)(_)!==i.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(H,(0,d.localize)(1815,null,te.path,_.message))),null}let W;try{W=JSON.parse(z)}catch{const ne=[];(0,C.$5n)(z,ne);for(const le of ne)this.r.error(this.F(H,(0,d.localize)(1816,null,te.path,le.offset,le.length,(0,A.$Tq)(le.error))));return null}return(0,C.$ao)(W)!=="object"?(this.r.error(this.F(H,(0,d.localize)(1817,null,te.path))),null):W}async y(H,te,z){const W=await this.z(H,te,z);if(W)try{const _=[],ne=await this.C(W.default,_);if(_.length>0)return _.forEach(ee=>{this.r.error(this.F(H,(0,d.localize)(1818,null,W.default?.path,(0,A.$Tq)(ee.error))))}),te;if((0,C.$ao)(W)!=="object")return this.r.error(this.F(H,(0,d.localize)(1819,null,W.default?.path))),te;const le=W.values||Object.create(null);return(0,S.$Uq)(this.r,te,le,ne)}catch{}return te}async z(H,te,z){const W=(0,f.$lh)(H,"package.nls.json"),_=(X,K)=>{K.forEach(q=>{this.r.error(this.F(H,(0,d.localize)(1820,null,X?.path,(0,A.$Tq)(q.error))))})},ne=X=>{this.r.error(this.F(H,(0,d.localize)(1821,null,X?.path)))},le=`${te.publisher}.${te.name}`,ee=z.translations[le];if(ee)try{const X=w.URI.file(ee),K=(await this.m.readFile(X)).value.toString(),q=[],D=(0,C.$5n)(K,q);return q.length>0?(_(X,q),{values:void 0,default:W}):(0,C.$ao)(D)!=="object"?(ne(X),{values:void 0,default:W}):{values:D.contents?D.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.m.exists(W))return;let K;try{K=await this.D(H,z)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const q=(await this.m.readFile(K.localized)).value.toString(),D=[],J=(0,C.$5n)(q,D);return D.length>0?(_(K.localized,D),{values:void 0,default:K.original}):(0,C.$ao)(J)!=="object"?(ne(K.localized),{values:void 0,default:K.original}):{values:J,default:K.original}}catch{return{values:void 0,default:K.original}}}}async C(H,te){if(H)try{const z=(await this.m.readFile(H)).value.toString();return(0,C.$5n)(z,te)}catch{}}D(H,te){return new Promise((z,W)=>{const _=ne=>{const le=(0,f.$lh)(H,`package.nls.${ne}.json`);this.m.exists(le).then(ee=>{ee&&z({localized:le,original:(0,f.$lh)(H,"package.nls.json")});const X=ne.lastIndexOf("-");X===-1?z({localized:(0,f.$lh)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,X),_(ne))})};if(te.devMode||te.pseudo||!te.language)return z({localized:(0,f.$lh)(H,"package.nls.json"),original:null});_(te.language)})}F(H,te){return`[${H.path}]: ${te}`}};U=Ee([Z(1,u.$Rq),Z(2,O.$Pl),Z(3,i.$fl),Z(4,s.$yk),Z(5,P.$Ri),Z(6,t.$fk)],U);let F=class extends U{constructor(H,te,z,W,_,ne,le,ee,X){super(te,W,_,ne,le,ee,X),this.J=H,this.L=z,this.H=this.B(new a.$Ih(3e3)),this.I=this.B(new r.$qe),this.onDidChangeCache=this.I.event}async scanExtensions(H){const te=this.P(H),z=await this.M(te);if(this.G=H,z&&z.input&&j.equals(z.input,this.G))return this.r.debug("Using cached extensions scan result",H.type===c.ExtensionType.System?"system":"user",H.location.toString()),this.H.trigger(()=>this.O()),z.result.map(_=>(_.location=w.URI.revive(_.location),_));const W=await super.scanExtensions(H);return await this.N(te,{input:H,result:W}),W}async M(H){try{const te=await this.m.readFile(H),z=JSON.parse(te.value.toString());return{result:z.result,input:(0,o.$hi)(z.input)}}catch(te){this.r.debug("Error while reading the extension cache file:",H.path,(0,T.$bb)(te))}return null}async N(H,te){try{await this.m.writeFile(H,k.$Se.fromString(JSON.stringify(te)))}catch(z){this.r.debug("Error while writing the extension cache file:",H.path,(0,T.$bb)(z))}}async O(){if(!this.G)return;const H=this.P(this.G),te=await this.M(H);if(!te)return;const z=te.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!N.$oo(W,z))try{this.r.info("Invalidating Cache",z,W),await this.m.del(H),this.I.fire()}catch(_){this.r.error(_)}}P(H){const te=this.Q(H);return this.j.extUri.joinPath(te.cacheHome,H.type===c.ExtensionType.System?c.$sn:c.$rn)}Q(H){return H.type===c.ExtensionType.System?this.L.defaultProfile:H.profile?this.j.extUri.isEqual(H.location,this.J.extensionsResource)?this.J:this.L.profiles.find(te=>this.j.extUri.isEqual(H.location,te.extensionsResource))??this.J:this.L.defaultProfile}};F=Ee([Z(2,y.$Rl),Z(3,u.$Rq),Z(4,O.$Pl),Z(5,i.$fl),Z(6,s.$yk),Z(7,P.$Ri),Z(8,t.$fk)],F);function G(x,H){const te=(0,$.$Vp)(x.manifest.publisher,x.manifest.name);return{id:te,identifier:new c.$xn(te),isBuiltin:x.type===c.ExtensionType.System,isUserBuiltin:x.type===c.ExtensionType.User&&x.isBuiltin,isUnderDevelopment:H,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,publisherDisplayName:x.publisherDisplayName,...x.manifest}}class V extends L{constructor(H,te,z,W,_,ne,le,ee,X,K,q,D){super(H,te,(0,f.$lh)(z,".vscode-oss-dev","extensions","control.json"),W,_,ne,le,ee,X,K,q,D),this.S=(async()=>{if(m.$C)try{const J=await this.w.readFile(w.URI.file(m.$C));return JSON.parse(J.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}e.$Zq=V}),define(ue[217],de([0,1,70,6,41,3,2,22,13,30,11,19]),function(ce,e,I,a,N,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;let m=class extends T.$Zc{constructor(l,g){super(),this.b=l,this.f=g,this.a=new a.$Qh(5)}async postUninstall(l){const g=this.g(l,"uninstall");g&&(this.f.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(g.script,"uninstall",g.args,!0,l),this.f.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(E){this.f.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.f.error(E)}}));try{await b.Promises.rm(this.m(l))}catch(E){this.f.error("Error while removing extension storage path",l.identifier.id),this.f.error(E)}}g(l,g){const E=`vscode:${g}`;if(l.location.scheme===C.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[E]=="string"){const w=l.manifest.scripts[E].split(" ");return w.length<2||w[0]!=="node"||!w[1]?(this.f.warn(l.identifier.id,l.manifest.version,`${E} should be a node script`),null):{script:(0,A.$oc)(l.location.fsPath,w[1]),args:w.slice(2)||[]}}return null}h(l,g,E,w,d){return new Promise((P,$)=>{const c=this.j(l,g,E,d);let h;const i=n=>{h&&(clearTimeout(h),h=null),n?$(n):P(void 0)};c.on("error",n=>{i((0,N.$vj)(n)||"Unknown")}),c.on("exit",(n,t)=>{i(n?`post-${g} process exited with code ${n}`:void 0)}),w&&(h=setTimeout(()=>{h=null,c.kill(),$("timed out")},5e3))})}j(l,g,E,w){const d={silent:!0,execArgv:void 0},P=(0,I.fork)(l,[`--type=extension-post-${g}`,...E],d);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const $=k.Event.fromNodeEventEmitter(P.stdout,"data"),c=k.Event.fromNodeEventEmitter(P.stderr,"data");this.B($(n=>this.f.info(w.identifier.id,w.manifest.version,`post-${g}`,n))),this.B(c(n=>this.f.error(w.identifier.id,w.manifest.version,`post-${g}`,n)));const h=k.Event.any(k.Event.map($,n=>({data:`%c${n}`,format:[""]}),this.q),k.Event.map(c,n=>({data:`%c${n}`,format:["color: red"]}),this.q));return k.Event.debounce(h,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(n=>{console.group(w.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),P}m(l){return(0,A.$oc)(this.b.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.$4q=m,e.$4q=m=Ee([Z(0,p.$Rl),Z(1,R.$fk)],m)}),define(ue[118],de([0,1,71,9,84,27]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=T,e.$2q=C;function T(A){let b=k.ExtensionManagementErrorCode.Extract;return A instanceof I.$Jq&&(A.type==="CorruptZip"?b=k.ExtensionManagementErrorCode.CorruptZip:A.type==="Incomplete"&&(b=k.ExtensionManagementErrorCode.IncompleteZip)),(0,N.$Oq)(A,b)}async function C(A){let b;try{b=await(0,I.$Mq)(A,"extension/package.json")}catch(R){throw T(R)}try{return JSON.parse(b.toString("utf8"))}catch{throw new k.$tp((0,a.localize)(1831,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(ue[218],de([0,1,6,8,2,22,20,60,12,32,30,71,21,15,84,27,35,118,112,7,11,18]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P,$,c){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0,C=Oe(C);let i=class extends N.$Zc{static{h=this}static{this.c=".sigzip"}constructor(t,s,r,o,u,y,O){super(),this.h=s,this.j=r,this.m=o,this.n=u,this.r=y,this.t=O,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,s,r,o){await this.g;const u=await this.w(t,s);let y=!1;if(r&&this.u(t)){let O;try{O=await this.y(t)}catch(S){try{await this.delete(u)}catch(v){this.t.error(v)}throw S}try{y=await this.n.verify(t,u.fsPath,O.fsPath,o)}catch(S){if(y=S.code,y===d.ExtensionSignatureVerificationCode.PackageIsInvalidZip||y===d.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(u)}catch(v){this.t.error(v)}throw new g.$tp(p.$Iq,g.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(O)}catch(S){this.t.error(S)}}}return{location:u,verificationStatus:y}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,A.$pg)(s)?s:!0}async w(t,s){try{const r=(0,T.$lh)(this.extensionsDownloadDir,this.G(t)),o=await this.C(t,"vsix",async()=>{await this.z(t,r,u=>this.j.download(t,u,s));try{await this.D(r.fsPath,"extension/package.json")}catch(u){try{await this.h.del(r)}catch(y){this.t.warn(`Error while deleting: ${r.path}`,(0,a.$bb)(y))}throw u}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:o}),r}catch(r){throw(0,l.$Oq)(r,g.ExtensionManagementErrorCode.Download)}}async y(t){try{const s=(0,T.$lh)(this.extensionsDownloadDir,`.${(0,b.$7g)()}`),r=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,s);try{await this.D(s.fsPath,".signature.p7s")}catch(o){try{await this.h.del(s)}catch(u){this.t.warn(`Error while deleting: ${s.path}`,(0,a.$bb)(u))}throw o}},2);return r>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:r}),s}catch(s){throw(0,l.$Oq)(s,g.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,s,r){if(await this.h.exists(s))return;if(s.scheme!==k.Schemas.file){await r(s);return}const o=(0,T.$lh)(this.extensionsDownloadDir,`.${(0,b.$7g)()}`);try{await r(o)}catch(u){try{await this.h.del(o)}catch{}throw u}try{await R.Promises.rename(o.fsPath,s.fsPath,2*60*1e3)}catch(u){try{await this.h.del(o)}catch{}let y=!1;try{y=await this.h.exists(s)}catch{}if(y)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,a.$bb)(u)}. Deleted the file from downloaded location`,o.path),u}}async C(t,s,r,o){let u=1;for(;;)try{return await r(),u}catch(y){if(u++>o)throw y;this.t.warn(`Failed downloading ${s}. ${(0,a.$bb)(y)}. Retry again...`,t.identifier.id)}}async D(t,s){try{await(0,p.$Mq)(t,s)}catch(r){throw(0,w.$1q)(r)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],r=[],o=[];for(const O of t.children)if(O.name.endsWith(h.c))o.push(O.resource);else{const S=E.$Tp.parse(O.name);S&&r.push([S,O])}const u=(0,E.$Yp)(r,([O])=>O),y=[];for(const O of u)O.sort((S,v)=>C.rcompare(S[0].version,v[0].version)),s.push(...O.slice(1).map(S=>S[1].resource)),y.push(O[0][1]);y.sort((O,S)=>O.mtime-S.mtime),s.push(...y.slice(0,Math.max(0,y.length-this.f)).map(O=>O.resource)),s.push(...o),await I.Promises.settled(s.map(O=>(this.t.trace("Deleting from cache",O.path),this.h.del(O))))}}catch(t){this.t.error(t)}}G(t){return this.f?E.$Tp.create(t).toString().toLowerCase():(0,b.$7g)()}};e.$3q=i,e.$3q=i=h=Ee([Z(0,f.$Si),Z(1,P.$fl),Z(2,g.$rp),Z(3,m.$ej),Z(4,d.$Bq),Z(5,c.$em),Z(6,$.$fk)],i)}),define(ue[119],de([0,1,33,6,14,25,41,8,3,55,2,31,22,13,20,60,12,10,32,30,71,9,100,15,84,27,35,52,85,218,217,118,190,200,34,59,7,4,11,23,18,28,19]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P,$,c,h,i,n,t,s,r,o,u,y,O,S,v,L,j,U,F,G,V,x,H,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=void 0,I=Oe(I),f=Oe(f),g=Oe(g),P=Oe(P),c=Oe(c),e.$7q=(0,F.$Li)(t.$up);const z=".vsctmp";let W=class extends n.$Nq{constructor(X,K,q,D,J,oe,Q,Y,M,B,ie,ae){super(X,K,ie,q,B,ae),this.db=J,this.eb=oe,this.fb=Q,this.gb=Y,this.hb=M,this.cb=new Map,this.sb=new p.$Gc;const he=this.B(Y.createInstance(y.$4q));this.$=this.B(Y.createInstance(_,be=>he.postUninstall(be))),this.ab=this.B(new S.$5q(ae,M,ie,this,this.F)),this.bb=this.B(Y.createInstance(u.$3q));const pe=this.B(new v.$6q(this,this.db,ae,oe,ie,M,q));this.B(pe.onDidChangeExtensionsByAnotherSource(be=>this.rb(be))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$4p)(this.hb,this.F)),this.ib}async zip(X){this.F.trace("ExtensionManagementService#zip",X.identifier.id);const K=await this.qb(X),q=await(0,$.zip)((0,l.$lh)(this.bb.extensionsDownloadDir,(0,d.$7g)()).fsPath,K);return w.URI.file(q)}async getManifest(X){const{location:K,cleanup:q}=await this.kb(X),D=f.$pc(K.fsPath);try{return await(0,O.$2q)(D)}finally{await q()}}getInstalled(X,K=this.H.defaultProfile.extensionsResource,q={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(X??null,K,q)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(X){return this.$.scanUserExtensionAtLocation(X)}async install(X,K={}){this.F.trace("ExtensionManagementService#install",X.toString());const{location:q,cleanup:D}=await this.kb(X);try{const J=await(0,O.$2q)(f.$pc(q.fsPath)),oe=(0,s.$Xp)(J.publisher,J.name);if(J.engines&&J.engines.vscode&&!(0,j.$_p)(J.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(1822,null,oe,this.G.version));const Y=(await this.I([{manifest:J,extension:q,options:K}])).find(({identifier:M})=>(0,s.$Sp)(M,{id:oe}));if(Y?.local)return Y.local;throw Y?.error?Y.error:(0,n.$Oq)(new Error(`Unknown error while installing extension ${oe}`))}finally{await D()}}async installFromLocation(X,K){this.F.trace("ExtensionManagementService#installFromLocation",X.toString());const q=await this.$.scanUserExtensionAtLocation(X);if(!q||!q.manifest.name||!q.manifest.version)throw new Error(`Cannot find a valid extension from the location ${X.toString()}`);return await this.vb([[q,{source:"resource"}]],K),this.F.info("Successfully installed extension",q.identifier.id,K.toString()),q}async installExtensionsFromProfile(X,K,q){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",X,K.toString(),q.toString());const D=(await this.getInstalled(L.ExtensionType.User,K)).filter(J=>X.some(oe=>(0,s.$Sp)(oe,J.identifier)));if(D.length){const J=await Promise.all(D.map(oe=>this.$.scanMetadata(oe,K)));await this.vb(D.map((oe,Q)=>[oe,J[Q]]),q),this.F.info("Successfully installed extensions",D.map(oe=>oe.identifier.id),q.toString())}return D}async updateMetadata(X,K,q){return this.F.trace("ExtensionManagementService#updateMetadata",X.identifier.id),K.isPreReleaseVersion&&(K.preRelease=!0,K.hasPreReleaseVersion=!0),K.isMachineScoped===!1&&(K.isMachineScoped=void 0),K.isBuiltin===!1&&(K.isBuiltin=void 0),K.pinned===!1&&(K.pinned=void 0),X=await this.$.updateMetadata(X,K,q),this.ab.invalidate(q),this.w.fire({local:X,profileLocation:q}),X}async reinstallFromGallery(X){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",X.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1823,null));const K=await this.getTargetPlatform(),[q]=await this.z.getExtensions([{...X.identifier,preRelease:X.preRelease}],{targetPlatform:K,compatible:!0},k.CancellationToken.None);if(!q)throw new Error(c.localize(1824,null));await this.$.setUninstalled(X);try{await this.$.removeUninstalledExtension(X)}catch(D){throw new Error(c.localize(1825,null,(0,T.$vj)(D)))}return this.installFromGallery(q)}Z(X,K,q,D){return this.$.copyExtension(X,K,q,D)}copyExtensions(X,K){return this.$.copyExtensions(X,K,{version:this.G.version,date:this.G.date})}markAsUninstalled(...X){return this.$.setUninstalled(...X)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(X){this.F.error(X)}}async download(X,K,q){const{location:D}=await this.bb.download(X,K,!q);return D}async kb(X){if(X.scheme===m.Schemas.file)return{location:X,async cleanup(){}};this.F.trace("Downloading extension from",X.toString());const K=(0,l.$lh)(this.bb.extensionsDownloadDir,(0,d.$7g)());return await this.fb.download(X,K),this.F.info("Downloaded extension to",K.toString()),{location:K,cleanup:async()=>{try{await this.hb.del(K)}catch(D){this.F.error(D)}}}}W(){return this.H.defaultProfile.extensionsResource}X(X,K,q){const D=K instanceof w.URI?new s.$Tp({id:(0,s.$Xp)(X.publisher,X.name)},X.version):s.$Tp.create(K);return this.gb.createInstance(ne,D,X,K,q,(J,oe)=>{if(K instanceof w.URI)return this.pb(D,K,q,oe);let Q=this.cb.get(D.toString());return Q||(this.cb.set(D.toString(),Q=this.ob(D,K,J,q,oe)),Q.finally(()=>this.cb.delete(D.toString()))),Q},this.$)}Y(X,K){return new le(X,K,this.eb)}async ob(X,K,q,D,J){const{verificationStatus:oe,location:Q}=await this.bb.download(K,q,!D.donotVerifySignature,D.context?.[t.$kp]);try{if(J.isCancellationRequested)throw new C.$9;const Y=await(0,O.$2q)(Q.fsPath);if(!new s.$Tp(K.identifier,K.version).equals(new s.$Tp({id:(0,s.$Xp)(Y.publisher,Y.name)},Y.version)))throw new t.$tp(c.localize(1826,null,K.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(X,Q.fsPath,{id:K.identifier.uuid,publisherId:K.publisherId,publisherDisplayName:K.publisherDisplayName,targetPlatform:K.properties.targetPlatform,isApplicationScoped:D.isApplicationScoped,isMachineScoped:D.isMachineScoped,isBuiltin:D.isBuiltin,isPreReleaseVersion:K.properties.isPreReleaseVersion,hasPreReleaseVersion:K.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:D.installGivenVersion?!0:!!D.pinned,preRelease:(0,E.$pg)(D.preRelease)?D.preRelease:D.installPreReleaseVersion||K.properties.isPreReleaseVersion,source:"gallery"},!1,J),verificationStatus:oe}}catch(Y){try{await this.bb.delete(Q)}catch(M){this.F.warn("Error while deleting the downloaded file",Q.toString(),(0,C.$bb)(M))}throw(0,n.$Oq)(Y)}}async pb(X,K,q,D){return{local:await this.$.extractUserExtension(X,f.$pc(K.fsPath),{isApplicationScoped:q.isApplicationScoped,isMachineScoped:q.isMachineScoped,isBuiltin:q.isBuiltin,installedTimestamp:Date.now(),pinned:q.installGivenVersion?!0:!!q.pinned,source:"vsix"},q.keepExisting??!0,D)}}async qb(X){const K=async D=>{let J=await P.Promises.readdir(D);J=J.map(Y=>f.$oc(D,Y));const oe=await Promise.all(J.map(Y=>I.promises.stat(Y)));let Q=Promise.resolve([]);return oe.forEach((Y,M)=>{const B=J[M];Y.isFile()&&(Q=Q.then(ie=>[...ie,B])),Y.isDirectory()&&(Q=Q.then(ie=>K(B).then(ae=>[...ie,...ae])))}),Q};return(await K(X.location.fsPath)).map(D=>({path:`extension/${f.$qc(X.location.fsPath,D)}`,localPath:D}))}async rb({added:X,removed:K}){if(K){const q=X&&this.D.extUri.isEqual(K.profileLocation,X.profileLocation)?K.extensions.filter(D=>X.extensions.every(J=>!(0,s.$Sp)(J,D))):K.extensions;for(const D of q)this.F.info("Extensions removed from another source",D.id,K.profileLocation.toString()),this.u.fire({identifier:D,profileLocation:K.profileLocation})}if(X){const D=(await this.getInstalled(L.ExtensionType.User,X.profileLocation)).filter(J=>X.extensions.some(oe=>(0,s.$Sp)(oe,J.identifier)));this.s.fire(D.map(J=>(this.F.info("Extensions added from another source",J.identifier.id,X.profileLocation.toString()),{identifier:J.identifier,local:J,profileLocation:X.profileLocation,operation:t.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(K=>this.sb.add(K)));const X=await this.hb.resolve(this.db.userExtensionsLocation);for(const K of X.children??[])K.isDirectory&&this.sb.add(K.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(K=>this.ub(K)))}async ub(X){if(!X.affects(this.db.userExtensionsLocation,U.FileChangeType.ADDED))return;const K=[];for(const q of X.rawAdded){if(this.sb.has(q)||!this.D.extUri.isEqual(this.D.extUri.dirname(q),this.db.userExtensionsLocation)||this.D.extUri.isEqual(q,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(q).startsWith(".")||!(await this.hb.stat(q)).isDirectory)continue;const D=await this.$.scanUserExtensionAtLocation(q);D&&D.installedTimestamp===void 0&&(this.sb.add(q),K.push(D))}K.length&&(await this.vb(K.map(q=>[q,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",K.map(q=>q.identifier.id)))}async vb(X,K){const q=X.map(D=>D[0]);await this.wb(q),await this.eb.addExtensionsToProfile(X,K),this.s.fire(q.map(D=>({local:D,identifier:D.identifier,operation:t.InstallOperation.None,profileLocation:K})))}async wb(X){const K=await this.$.getUninstalledExtensions();for(const q of X){const D=s.$Tp.create(q);K[D.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",D.id),await this.$.setInstalled(D),this.F.info("Removed the extension from uninstalled list:",D.id))}}};e.$8q=W,e.$8q=W=Ee([Z(0,t.$rp),Z(1,x.$em),Z(2,G.$fk),Z(3,i.$Si),Z(4,o.$Vq),Z(5,r.$Rq),Z(6,h.$8o),Z(7,F.$Ji),Z(8,U.$fl),Z(9,V.$yk),Z(10,H.$Pl),Z(11,te.$Rl)],W);let _=class extends R.$Zc{constructor(X,K,q,D,J,oe,Q){super(),this.n=X,this.s=K,this.t=q,this.u=D,this.w=J,this.y=oe,this.z=Q,this.h=this.B(new A.$qe),this.onExtract=this.h.event,this.j=new p.$Fc,this.m=new p.$Fc,this.c=(0,l.$lh)(this.t.userExtensionsLocation,".obsolete"),this.g=new a.$Rh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(X,K,q){try{const D={includeInvalid:!0,profileLocation:K,productVersion:q};let J=[];if(X===null||X===L.ExtensionType.System){let oe=this.j.get(K);oe||(oe=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},D,!1).finally(()=>this.j.delete(K)),this.j.set(K,oe)),J.push(...await oe)}else if(X===L.ExtensionType.User){let oe=this.m.get(K);oe||(oe=this.t.scanUserExtensions(D).finally(()=>this.m.delete(K)),this.m.set(K,oe)),J.push(...await oe)}return J=X!==null?J.filter(oe=>oe.type===X):J,await Promise.all(J.map(oe=>this.H(oe)))}catch(D){throw(0,n.$Oq)(D,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(X){try{const K=await this.t.scanUserExtensions({includeAllVersions:!X,includeInvalid:!0});return await Promise.all(K.map(q=>this.H(q)))}catch(K){throw(0,n.$Oq)(K,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(X){try{const K=await this.t.scanExistingExtension(X,L.ExtensionType.User,{includeInvalid:!0});if(K)return await this.H(K)}catch(K){this.z.error(K)}return null}async extractUserExtension(X,K,q,D,J){const oe=X.toString(),Q=w.URI.file(f.$oc(this.t.userExtensionsLocation.fsPath,`.${(0,d.$7g)()}`)),Y=w.URI.file(f.$oc(this.t.userExtensionsLocation.fsPath,oe));if(await this.s.exists(Y)){if(!D)try{return await this.scanLocalExtension(Y,L.ExtensionType.User)}catch(M){this.z.warn(`Error while scanning the existing extension at ${Y.path}. Deleting the existing extension and extracting it.`,(0,C.$bb)(M))}try{await this.D(X.id,Y,"removeExisting")}catch{throw new t.$tp(c.localize(1827,null,Y.fsPath,X.id),t.ExtensionManagementErrorCode.Delete)}}try{if(J.isCancellationRequested)throw new C.$9;try{this.z.trace(`Started extracting the extension from ${K} to ${Y.fsPath}`),await(0,$.$Lq)(K,Q.fsPath,{sourcePath:"extension",overwrite:!0},J),this.z.info(`Extracted extension to ${Y}:`,X.id)}catch(M){throw(0,O.$1q)(M)}try{await this.t.updateMetadata(Q,q)}catch(M){throw this.y.publicLog2("extension:extract",{extensionId:X.id,code:`${(0,U.$wl)(M)}`}),(0,n.$Oq)(M,t.ExtensionManagementErrorCode.UpdateMetadata)}if(J.isCancellationRequested)throw new C.$9;try{this.z.trace(`Started renaming the extension from ${Q.fsPath} to ${Y.fsPath}`),await this.G(Q.fsPath,Y.fsPath),this.z.info("Renamed to",Y.fsPath)}catch(M){if(M.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",X.id);try{await this.s.del(Q,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,C.$bb)(M)}. Deleted from extracted location`,Q),M}this.h.fire(Y)}catch(M){try{await this.s.del(Q,{recursive:!0})}catch{}throw M}return this.scanLocalExtension(Y,L.ExtensionType.User)}async scanMetadata(X,K){return K?(await this.C(X,K))?.metadata:this.t.scanMetadata(X.location)}async C(X,K){return(await this.u.scanProfileExtensions(K)).find(D=>(0,s.$Sp)(D.identifier,X.identifier))}async updateMetadata(X,K,q){try{q?await this.u.updateMetadata([[X,K]],q):await this.t.updateMetadata(X.location,K)}catch(D){throw this.y.publicLog2("extension:extract",{extensionId:X.identifier.id,code:`${(0,U.$wl)(D)}`,isProfile:!!q}),(0,n.$Oq)(D,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(X.location,X.type,q)}async getUninstalledExtensions(){try{return await this.F()}catch(X){throw(0,n.$Oq)(X,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...X){const K=X.map(q=>s.$Tp.create(q));await this.F(q=>K.forEach(D=>{q[D.toString()]=!0,this.z.info("Marked extension as uninstalled",D.toString())}))}async setInstalled(X){try{await this.F(K=>delete K[X.toString()])}catch(K){throw(0,n.$Oq)(K,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(X,K){if(this.w.extUri.isEqualOrParent(X.location,this.t.userExtensionsLocation))return this.D(X.identifier.id,X.location,K)}async removeUninstalledExtension(X){await this.removeExtension(X,"uninstalled"),await this.F(K=>delete K[s.$Tp.create(X).toString()])}async copyExtension(X,K,q,D){const J=await this.C(X,K),oe=await this.C(X,q);if(D={...J?.metadata,...D},oe)if(this.w.extUri.isEqual(oe.location,X.location))await this.u.updateMetadata([[X,{...oe.metadata,...D}]],q);else{const Q=await this.scanLocalExtension(oe.location,X.type,q);await this.u.removeExtensionFromProfile(Q,q),await this.u.addExtensionsToProfile([[X,{...oe.metadata,...D}]],q)}else await this.u.addExtensionsToProfile([[X,D]],q);return this.scanLocalExtension(X.location,X.type,q)}async copyExtensions(X,K,q){const D=await this.scanExtensions(L.ExtensionType.User,X,q),J=await Promise.all(D.filter(oe=>!oe.isApplicationScoped).map(async oe=>[oe,await this.scanMetadata(oe,X)]));await this.u.addExtensionsToProfile(J,K)}async D(X,K,q){this.z.trace(`Deleting ${q} extension from disk`,X,K.fsPath);const D=this.w.extUri.joinPath(this.w.extUri.dirname(K),`${this.w.extUri.basename(K)}.${(0,b.$yj)((0,d.$7g)()).toString(16)}${z}`);await this.G(K.fsPath,D.fsPath),await this.s.del(D,{recursive:!0}),this.z.info(`Deleted ${q} extension from disk`,X,K.fsPath)}F(X){return this.g.queue(async()=>{let K;try{K=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(D){if((0,U.$wl)(D)!==U.FileOperationResult.FILE_NOT_FOUND)throw D}let q={};if(K)try{q=JSON.parse(K)}catch{}return X&&(X(q),Object.keys(q).length?await this.s.writeFile(this.c,N.$Se.fromString(JSON.stringify(q))):await this.s.del(this.c)),q})}async G(X,K){try{await P.Promises.rename(X,K,2*60*1e3)}catch(q){throw(0,n.$Oq)(q,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(X,K,q){try{if(q){const J=(await this.t.scanUserExtensions({profileLocation:q})).find(oe=>this.w.extUri.isEqual(oe.location,X));if(J)return await this.H(J)}else{const D=await this.t.scanExistingExtension(X,K,{includeInvalid:!0});if(D)return await this.H(D)}throw new t.$tp(c.localize(1828,null,X.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(D){throw(0,n.$Oq)(D,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(X){const K=await this.s.resolve(X.location);let q,D;return K.children&&(q=K.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,D=K.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource),{identifier:X.identifier,type:X.type,isBuiltin:X.isBuiltin||!!X.metadata?.isBuiltin,location:X.location,manifest:X.manifest,targetPlatform:X.targetPlatform,validations:X.validations,isValid:X.isValid,readmeUrl:q,changelogUrl:D,publisherDisplayName:X.metadata?.publisherDisplayName,publisherId:X.metadata?.publisherId||null,isApplicationScoped:!!X.metadata?.isApplicationScoped,isMachineScoped:!!X.metadata?.isMachineScoped,isPreReleaseVersion:!!X.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!X.metadata?.hasPreReleaseVersion,preRelease:!!X.metadata?.preRelease,installedTimestamp:X.metadata?.installedTimestamp,updated:!!X.metadata?.updated,pinned:!!X.metadata?.pinned,isWorkspaceScoped:!1,source:X.metadata?.source??(X.identifier.uuid?"gallery":"vsix")}}async I(){const X=await this.getUninstalledExtensions();if(Object.keys(X).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(X));const K=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=new Set;for(const J of K)X[s.$Tp.create(J).toString()]||q.add(J.identifier.id.toLowerCase());try{const J=(0,s.$Yp)(K,oe=>oe.identifier);await a.Promises.settled(J.map(async oe=>{const Q=oe.sort((Y,M)=>g.rcompare(Y.manifest.version,M.manifest.version))[0];q.has(Q.identifier.id.toLowerCase())||await this.n(await this.H(Q))}))}catch(J){this.z.error(J)}const D=K.filter(J=>J.metadata&&X[s.$Tp.create(J).toString()]);await Promise.allSettled(D.map(J=>this.removeUninstalledExtension(J)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let X;try{X=await this.s.resolve(this.t.userExtensionsLocation)}catch(K){(0,U.$wl)(K)!==U.FileOperationResult.FILE_NOT_FOUND&&this.z.error(K);return}if(X?.children)try{await Promise.allSettled(X.children.map(async K=>{if(!(!K.isDirectory||!K.name.endsWith(z))){this.z.trace("Deleting the temporarily deleted folder",K.resource.toString());try{await this.s.del(K.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",K.resource.toString())}catch(q){(0,U.$wl)(q)!==U.FileOperationResult.FILE_NOT_FOUND&&this.z.error(q)}}}))}catch{}}};e.$9q=_,e.$9q=_=Ee([Z(1,U.$fl),Z(2,o.$Vq),Z(3,r.$Rq),Z(4,H.$Pl),Z(5,x.$em),Z(6,G.$fk)],_);let ne=class extends n.$Pq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(X,K,q,D,J,oe,Q,Y,M,B,ie,ae){super(),this.l=X,this.manifest=K,this.source=q,this.options=D,this.m=J,this.n=oe,this.o=Q,this.p=Y,this.q=M,this.s=B,this.t=ie,this.u=ae,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(X){const q=(await this.n.scanExtensions(L.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(Q=>(0,s.$Sp)(Q.identifier,this.identifier));q&&(this.j=t.InstallOperation.Update);const D={isApplicationScoped:this.options.isApplicationScoped||q?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||q?.isMachineScoped,isBuiltin:this.options.isBuiltin||q?.isBuiltin,isSystem:q?.type===L.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??q?.pinned,source:this.source instanceof w.URI?"vsix":"gallery"};let J;if(this.source instanceof w.URI){if(q&&this.l.equals(new s.$Tp(q.identifier,q.manifest.version)))try{await this.n.removeExtension(q,"existing")}catch{throw new Error(c.localize(1829,null,this.manifest.displayName||this.manifest.name))}const Q=await this.w(this.l);if(Q)try{await this.n.removeExtension(Q,"existing")}catch{throw new Error(c.localize(1830,null,this.manifest.displayName||this.manifest.name))}}else{if(D.id=this.source.identifier.uuid,D.publisherId=this.source.publisherId,D.publisherDisplayName=this.source.publisherDisplayName,D.targetPlatform=this.source.properties.targetPlatform,D.updated=!!q,D.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,D.hasPreReleaseVersion=q?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,D.preRelease=(0,E.$pg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||q?.preRelease,q&&q.type!==L.ExtensionType.System&&q.manifest.version===this.source.version)return this.n.updateMetadata(q,D,this.options.profileLocation);J=await this.w(this.l)}if(X.isCancellationRequested)throw(0,n.$Oq)(new C.$9);if(!J){const Q=await this.m(this.operation,X);J=Q.local,this.k=Q.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(Q){throw(0,n.$Oq)(Q,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(X.isCancellationRequested)throw(0,n.$Oq)(new C.$9);try{await this.t.addExtensionsToProfile([[J,D]],this.options.profileLocation,!J.isValid)}catch(Q){throw(0,n.$Oq)(Q,t.ExtensionManagementErrorCode.AddToProfile)}const oe=await this.n.scanLocalExtension(J.location,L.ExtensionType.User,this.options.profileLocation);if(!oe)throw new t.$tp("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof w.URI&&this.x(J,X),oe}async w(X){return(await this.n.getUninstalledExtensions())[X.toString()]?(this.u.trace("Removing the extension from uninstalled list:",X.id),await this.n.setInstalled(X),this.u.info("Removed the extension from uninstalled list:",X.id),(await this.n.scanAllUserExtensions(!0)).find(D=>s.$Tp.create(D).equals(X))):void 0}async x(X,K){try{let[q]=await this.p.getExtensions([{id:X.identifier.id,version:X.manifest.version}],K);if(q||([q]=await this.p.getExtensions([{id:X.identifier.id}],K)),q){const D={id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,hasPreReleaseVersion:X.hasPreReleaseVersion||q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(X,D,this.options.profileLocation)}}catch{}}};ne=Ee([Z(6,H.$Pl),Z(7,t.$rp),Z(8,te.$Rl),Z(9,o.$Vq),Z(10,r.$Rq),Z(11,G.$fk)],ne);class le extends n.$Pq{constructor(X,K,q){super(),this.extension=X,this.options=K,this.j=q}async h(X){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(ue[219],de([0,1,11,19,28,18,52,7,15,10]),function(ce,e,I,a,N,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0R=void 0;let R=class extends T.$Sq{constructor(m,f,l,g,E,w){super(b.URI.file(m.extensionsPath),f,l,g,E,w)}};e.$0R=R,e.$0R=R=Ee([Z(0,A.$Si),Z(1,C.$fl),Z(2,a.$Rl),Z(3,N.$Pl),Z(4,k.$em),Z(5,I.$fk)],R)}),define(ue[220],de([0,1,10,15,52,85,7,4,11,23,28,19]),function(ce,e,I,a,N,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=void 0;let m=class extends k.$Zq{constructor(l,g,E,w,d,P,$,c){super(I.URI.file(d.builtinExtensionsPath),I.URI.file(d.extensionsPath),d.userHome,l.defaultProfile,l,g,E,w,d,P,$,c)}};e.$Pic=m,e.$Pic=m=Ee([Z(0,p.$Rl),Z(1,N.$Rq),Z(2,T.$fl),Z(3,A.$fk),Z(4,a.$Si),Z(5,b.$yk),Z(6,R.$Pl),Z(7,C.$Ji)],m)}),define(ue[16],de([0,1,6,3,2,102,12,73,4,19]),function(ce,e,I,a,N,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$qq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$oq=e.$nq=e.$mq=void 0,e.$pq=f,e.$rq=g,e.$tq=w,e.$mq="__$__isNewStorageMarker",e.$nq="__$__targetStorageMarker",e.$oq=(0,A.$Ki)("storageService");var R;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var p;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(p||(e.StorageScope=p={}));var m;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function f(d){const P=d.get(e.$nq);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class l extends N.$Zc{static{this.a=60*1e3}constructor(P={flushInterval:l.a}){super(),this.m=P,this.b=this.B(new a.$te),this.c=this.B(new a.$te),this.onDidChangeTarget=this.c.event,this.f=this.B(new a.$qe),this.onWillSaveState=this.f.event,this.h=this.B(new I.$Wh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new N.$1c),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,$,c){return a.Event.filter(this.b.event,h=>h.scope===P&&($===void 0||h.key===$),c)}n(){this.j.value=(0,I.$1h)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,N.$Uc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,$){const{key:c,external:h}=$;if(c===e.$nq){switch(P){case p.APPLICATION:this.H=void 0;break;case p.PROFILE:this.F=void 0;break;case p.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:c,target:this.J(P)[c],external:h})}w(P){this.f.fire({reason:P})}get(P,$,c){return this.P($)?.get(P,c)}getBoolean(P,$,c){return this.P($)?.getBoolean(P,c)}getNumber(P,$,c){return this.P($)?.getNumber(P,c)}getObject(P,$,c){return this.P($)?.getObject(P,c)}storeAll(P,$){this.y(()=>{for(const c of P)this.store(c.key,c.value,c.scope,c.target,$)})}store(P,$,c,h,i=!1){if((0,T.$sg)($)){this.remove(P,c,i);return}this.y(()=>{this.z(P,c,h),this.P(c)?.set(P,$,i)})}remove(P,$,c=!1){this.y(()=>{this.z(P,$,void 0),this.P($)?.delete(P,c)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,$){const c=[],h=this.J(P);for(const i of Object.keys(h))h[i]===$&&c.push(i);return c}z(P,$,c,h=!1){const i=this.J($);typeof c=="number"?i[P]!==c&&(i[P]=c,this.P($)?.set(e.$nq,JSON.stringify(i),h)):typeof i[P]=="number"&&(delete i[P],this.P($)?.set(e.$nq,JSON.stringify(i),h))}get D(){return this.C||(this.C=this.L(p.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(p.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(p.APPLICATION)),this.H}J(P){switch(P){case p.APPLICATION:return this.I;case p.PROFILE:return this.G;default:return this.D}}L(P){const $=this.P(P);return $?f($):Object.create(null)}isNew(P){return this.getBoolean(e.$mq,P)===!0}async flush(P=R.NONE){this.f.fire({reason:P});const $=this.P(p.APPLICATION),c=this.P(p.PROFILE),h=this.P(p.WORKSPACE);switch(P){case R.NONE:await I.Promises.settled([$?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await I.Promises.settled([$?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P(p.APPLICATION)?.items??new Map,$=this.P(p.PROFILE)?.items??new Map,c=this.P(p.WORKSPACE)?.items??new Map;return w(P,$,c,this.Q(p.APPLICATION)??"",this.Q(p.PROFILE)??"",this.Q(p.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,$){return this.w(R.NONE),(0,b.$Ql)(P)?this.R(P,$):this.S(P,$)}M(P,$){return!(P.id===$.id||g($)&&g(P))}N(P,$,c){this.y(()=>{const h=new Set;for(const[i,n]of P)h.add(i),$.get(i)!==n&&this.u(c,{key:i,external:!0});for(const[i]of $.items)h.has(i)||this.u(c,{key:i,external:!0})})}}e.$qq=l;function g(d){return d.isDefault||!!d.useDefaultFlags?.globalState}class E extends l{constructor(){super(),this.U=this.B(new C.$kq(new C.$lq,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new C.$kq(new C.$lq,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new C.$kq(new C.$lq,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u(p.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u(p.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u(p.APPLICATION,P)))}P(P){switch(P){case p.APPLICATION:return this.U;case p.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case p.APPLICATION:return"inMemory (application)";case p.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}e.$sq=E;async function w(d,P,$,c,h,i){const n=v=>{try{return JSON.parse(v)}catch{return v}},t=new Map,s=new Map;d.forEach((v,L)=>{t.set(L,v),s.set(L,n(v))});const r=new Map,o=new Map;P.forEach((v,L)=>{r.set(L,v),o.set(L,n(v))});const u=new Map,y=new Map;$.forEach((v,L)=>{u.set(L,v),y.set(L,n(v))}),console.group(c!==h?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const O=[];if(t.forEach((v,L)=>{O.push({key:L,value:v})}),console.table(O),console.groupEnd(),console.log(s),c!==h){console.group(`Storage: Profile (path: ${h}, profile specific)`);const v=[];r.forEach((L,j)=>{v.push({key:j,value:L})}),console.table(v),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${i})`);const S=[];u.forEach((v,L)=>{S.push({key:L,value:v})}),console.table(S),console.groupEnd(),console.log(y)}}),define(ue[120],de([0,1,3,2,12,27,35,16]),function(ce,e,I,a,N,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lNb=e.$kNb=void 0;let A=class extends a.$Zc{constructor(p,m){super(),this.a=new I.$qe,this.onDidChangeEnablement=this.a.event,this.b=this.B(new b(p)),this.B(this.b.onDidChange(f=>this.a.fire({extensions:f,source:"storage"}))),this.B(m.onDidInstallExtensions(f=>f.forEach(({local:l,operation:g})=>{l&&g===k.InstallOperation.Migrate&&this.f(l.identifier)})))}async enableExtension(p,m){return this.f(p)?(this.a.fire({extensions:[p],source:m}),!0):!1}async disableExtension(p,m){return this.c(p)?(this.a.fire({extensions:[p],source:m}),!0):!1}getDisabledExtensions(){return this.h(k.$vp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(p){const m=this.getDisabledExtensions();return m.every(f=>!(0,T.$Sp)(f,p))?(m.push(p),this.g(m),!0):!1}f(p){const m=this.getDisabledExtensions();for(let f=0;f<m.length;f++){const l=m[f];if((0,T.$Sp)(l,p))return m.splice(f,1),this.g(m),!0}return!1}g(p){this.j(k.$vp,p)}h(p){return this.b.get(p,C.StorageScope.PROFILE)}j(p,m){this.b.set(p,m,C.StorageScope.PROFILE)}};e.$kNb=A,e.$kNb=A=Ee([Z(0,C.$oq),Z(1,k.$up)],A);class b extends a.$Zc{constructor(p){super(),this.c=p,this.a=Object.create(null),this.b=this.B(new I.$qe),this.onDidChange=this.b.event,this.B(p.onDidChangeValue(C.StorageScope.PROFILE,void 0,this.B(new a.$Yc))(m=>this.f(m)))}get(p,m){let f;return m===C.StorageScope.PROFILE?((0,N.$sg)(this.a[p])&&(this.a[p]=this.g(p,m)),f=this.a[p]):f=this.g(p,m),JSON.parse(f)}set(p,m,f){const l=JSON.stringify(m.map(({id:E,uuid:w})=>({id:E,uuid:w})));this.g(p,f)!==l&&(f===C.StorageScope.PROFILE&&(m.length?this.a[p]=l:delete this.a[p]),this.h(p,m.length?l:void 0,f))}f(p){if(!(0,N.$sg)(this.a[p.key])&&this.g(p.key,p.scope)!==this.a[p.key]){const f=this.get(p.key,p.scope);delete this.a[p.key];const l=this.get(p.key,p.scope),g=f.filter(w=>!l.some(d=>(0,T.$Sp)(w,d))),E=l.filter(w=>!f.some(d=>(0,T.$Sp)(d,w)));(g.length||E.length)&&this.b.fire([...g,...E])}}g(p,m){return this.c.get(p,m,"[]")}h(p,m,f){m?this.c.store(p,m,f,C.StorageTarget.MACHINE):this.c.remove(p,f)}}e.$lNb=b}),define(ue[86],de([0,1,4,3,2,16,35,23,17,11,12]),function(ce,e,I,a,N,k,T,C,A,b,R){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Aw=e.$zw=void 0,e.$zw=(0,I.$Ki)("IExtensionStorageService");const m=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class extends N.$Zc{static{p=this}static{this.a=512*1024}static b(g){return`extensionKeys/${(0,T.$Wp)(g.id)}@${g.version}`}static c(g){const E=m.exec(g);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(g,E){const w=await g.getInstalled(),d=[];for(const[P,$]of p.f(E)){const c=w.find(h=>(0,T.$Sp)(h.identifier,{id:P}))?.manifest.version;for(const h of $)c!==h&&d.push(p.b({id:P,version:h}))}for(const P of d)E.remove(P,k.StorageScope.PROFILE)}static f(g){const E=new Map,w=g.keys(k.StorageScope.PROFILE,k.StorageTarget.MACHINE);for(const d of w){const P=p.c(d);if(P){let $=E.get(P.id.toLowerCase());$||E.set(P.id.toLowerCase(),$=[]),$.push(P.version)}}return E}constructor(g,E,w){super(),this.j=g,this.m=E,this.n=w,this.g=this.B(new a.$qe),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=p.f(g),this.B(this.j.onDidChangeValue(k.StorageScope.PROFILE,void 0,this.B(new N.$Yc))(d=>this.r(d)))}r(g){if(this.h.has(g.key.toLowerCase())){this.g.fire();return}const E=p.c(g.key);if(E){if(this.j.get(g.key,k.StorageScope.PROFILE)===void 0)this.h.delete(E.id.toLowerCase());else{let w=this.h.get(E.id.toLowerCase());w||this.h.set(E.id.toLowerCase(),w=[]),w.push(E.version),this.g.fire()}return}}s(g){if((0,R.$jg)(g))return g;const E=g.manifest?g.manifest.publisher:g.publisher,w=g.manifest?g.manifest.name:g.name;return(0,T.$Vp)(E,w)}getExtensionState(g,E){const w=this.s(g),d=this.getExtensionStateRaw(g,E);if(d)try{return JSON.parse(d)}catch(P){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${E}): ${P}`)}}getExtensionStateRaw(g,E){const w=this.s(g),d=this.j.get(w,E?k.StorageScope.PROFILE:k.StorageScope.WORKSPACE);return d&&d?.length>p.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${w}, global: ${E}): ${d.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),d}setExtensionState(g,E,w){const d=this.s(g);E===void 0?this.j.remove(d,w?k.StorageScope.PROFILE:k.StorageScope.WORKSPACE):this.j.store(d,JSON.stringify(E),w?k.StorageScope.PROFILE:k.StorageScope.WORKSPACE,k.StorageTarget.MACHINE)}setKeysForSync(g,E){this.j.store(p.b(g),JSON.stringify(E),k.StorageScope.PROFILE,k.StorageTarget.MACHINE)}getKeysForSync(g){const E=this.m.extensionSyncedKeys?.[g.id.toLowerCase()],w=this.j.get(p.b(g),k.StorageScope.PROFILE),d=w?JSON.parse(w):void 0;return d&&E?(0,A.$Qb)([...d,...E]):d||E}addToMigrationList(g,E){if(g!==E){const w=this.t.filter(d=>!d.includes(g)&&!d.includes(E));w.push([g,E]),this.t=w}}getSourceExtensionToMigrate(g){const E=this.t.find(([,w])=>g===w);return E?E[0]:void 0}get t(){const g=this.j.get("extensionStorage.migrationList",k.StorageScope.APPLICATION,"[]");try{const E=JSON.parse(g);if(Array.isArray(E))return E}catch{}return[]}set t(g){g.length?this.j.store("extensionStorage.migrationList",JSON.stringify(g),k.StorageScope.APPLICATION,k.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",k.StorageScope.APPLICATION)}};e.$Aw=f,e.$Aw=f=p=Ee([Z(0,k.$oq),Z(1,C.$yk),Z(2,b.$fk)],f)}),define(ue[221],de([0,1,2,27,86,199,119,11,16]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;let b=class extends I.$Zc{constructor(p,m,f,l,g,E){super(),p.cleanUp(),(0,k.$98b)(p,m,f,l,E),N.$Aw.removeOutdatedExtensionVersions(p,g)}};e.$Zjc=b,e.$Zjc=b=Ee([Z(0,T.$7q),Z(1,a.$rp),Z(2,N.$zw),Z(3,a.$xp),Z(4,A.$oq),Z(5,C.$fk)],b)}),define(ue[222],de([0,1,17,2,20,10,7,23,6,3,13,5,37,35,75,34,16]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=e.$egc=void 0;let w=class extends a.$Zc{constructor(h,i){super(),this.b=h,this.c=i,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,n])=>this.a.set(n.configPath,n))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const i=[];for(const[n,t]of this.a)if(!(t.configScheme&&t.configScheme!==h.scheme))try{const s=(await this.b.readFile((0,N.$lh)(h,n))).value.toString();for(const[r,o]of Object.entries(t.recommendations))(!o.contentPattern||new RegExp(o.contentPattern,"mig").test(s))&&i.push({extensionId:r,extensionName:o.name,configName:t.configName,important:!!o.important,isExtensionPack:!!o.isExtensionPack,whenNotInstalled:o.whenNotInstalled})}catch{}return i}};e.$egc=w,e.$egc=w=Ee([Z(0,T.$fl),Z(1,C.$yk)],w);const d="extensionTips/promptedExecutableTips",P="extensionTips/lastPromptedMediumImpExeTime";class $ extends w{constructor(h,i,n,t,s,r,o,u){super(o,u),this.r=h,this.s=i,this.t=n,this.u=t,this.w=s,this.z=r,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,u.exeBasedExtensionTips&&Object.entries(u.exeBasedExtensionTips).forEach(([y,O])=>{const S=[],v=[],L=[];Object.entries(O.recommendations).forEach(([j,U])=>{U.important?O.important?S.push({extensionId:j,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):v.push({extensionId:j,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):L.push({extensionId:j,extensionName:U.name,isExtensionPack:!!U.isExtensionPack})}),S.length&&this.g.set(y,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:S}),v.length&&this.h.set(y,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:v}),L.length&&this.j.set(y,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:L})}),(0,A.$Mh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),i=await this.O(this.h);return[...h,...i]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),i=await this.O(this.h),n=await this.u.getInstalled();this.m=this.D(h,n),this.n=this.D(i,n)}D(h,i){const n=new Map;h.forEach(u=>n.set(u.extensionId.toLowerCase(),u));const{installed:t,uninstalled:s}=this.N([...n.keys()],i);for(const u of t){const y=n.get(u);y&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:u,exeName:y.exeName})}for(const u of s){const y=n.get(u);y&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:u,exeName:y.exeName})}const r=this.L(),o=new Map;for(const u of s){const y=n.get(u);if(y&&(!r[y.exeName]||!r[y.exeName].includes(y.extensionId))){let O=o.get(y.exeName);O||(O=[],o.set(y.exeName,O)),O.push(y)}}return o}F(){if(this.m.size===0)return;const[h,i]=[...this.m.entries()][0];this.H(i).then(n=>{switch(n){case l.RecommendationsNotificationResult.Accepted:this.M(i[0].exeName,i);break;case l.RecommendationsNotificationResult.Ignored:this.m.delete(h);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const t=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case l.RecommendationsNotificationResult.TooMany:{const t=this.B(new a.$1c);t.value=(0,A.$Mh)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),i=Date.now()-h,n=7*24*60*60*1e3;if(i<n){const r=this.B(new a.$1c);r.value=(0,A.$Mh)(()=>{r.dispose(),this.G()},n-i);return}const[t,s]=[...this.n.entries()][0];this.H(s).then(r=>{switch(r){case l.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(t),this.M(s[0].exeName,s);const o=this.B(new a.$1c);o.value=(0,A.$Mh)(()=>{o.dispose(),this.G()},n);break}case l.RecommendationsNotificationResult.Ignored:this.n.delete(t),this.G();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const o=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(o(()=>this.G()));break}case l.RecommendationsNotificationResult.TooMany:{const o=this.B(new a.$1c);o.value=(0,A.$Mh)(()=>{o.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const i=await this.u.getInstalled(g.ExtensionType.User),n=h.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(s=>i.every(r=>!(0,f.$Sp)(r.identifier,{id:s})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:n,source:l.RecommendationSource.EXE,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber(P,E.StorageScope.APPLICATION);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store(P,h,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(d,E.StorageScope.APPLICATION,"{}"))}M(h,i){const n=this.L();n[h]=i.map(({extensionId:t})=>t.toLowerCase()),this.w.store(d,JSON.stringify(n),E.StorageScope.APPLICATION,E.StorageTarget.USER)}N(h,i){const n=[],t=[],s=i.reduce((r,o)=>(r.add(o.identifier.id.toLowerCase()),r),new Set);return h.forEach(r=>{s.has(r.toLowerCase())?n.push(r):t.push(r)}),{installed:n,uninstalled:t}}async O(h){const i=[],n=new Map;for(const t of h.keys()){const s=h.get(t);if(!s||!(0,I.$Pb)(s.recommendations))continue;const r=[];p.$l?s.windowsPath&&r.push(s.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(r.push((0,R.$oc)("/usr/local/bin",t)),r.push((0,R.$oc)("/usr/bin",t)),r.push((0,R.$oc)(this.r.fsPath,t)));for(const o of r){let u=n.get(o);if(u===void 0&&(u=await this.b.exists(k.URI.file(o)),n.set(o,u)),u)for(const{extensionId:y,extensionName:O,isExtensionPack:S,whenNotInstalled:v}of s.recommendations)i.push({extensionId:y,extensionName:O,isExtensionPack:S,exeName:t,exeFriendlyName:s.exeFriendlyName,windowsPath:s.windowsPath,whenNotInstalled:v})}}return i}}e.$fgc=$}),define(ue[223],de([0,1,27,7,23,15,75,57,16,18,222]),function(ce,e,I,a,N,k,T,C,A,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7jc=void 0;let p=class extends R.$fgc{constructor(f,l,g,E,w,d,P,$){super(f.userHome,w,l,g,E,d,P,$)}};e.$7jc=p,e.$7jc=p=Ee([Z(0,k.$Si),Z(1,b.$em),Z(2,I.$up),Z(3,A.$oq),Z(4,C.$2hc),Z(5,T.$Q8b),Z(6,a.$fl),Z(7,N.$yk)],p)}),define(ue[49],de([0,1,14,32,16]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=k;async function k(T,C,A){let b=A&&A.get("storage.serviceMachineId",N.StorageScope.APPLICATION)||null;if(b)return b;try{const p=(await C.readFile(T.serviceMachineIdResource)).value.toString();b=(0,a.$6g)(p)?p:null}catch{b=null}if(!b){b=(0,a.$7g)();try{await C.writeFile(T.serviceMachineIdResource,I.$Se.fromString(b))}catch{}}return A?.store("storage.serviceMachineId",b,N.StorageScope.APPLICATION,N.StorageTarget.MACHINE),b}}),define(ue[224],de([0,1,49,18,48]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=k;async function k(T,C,A,b,R,p,m){const f={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${C.nameShort})`};if((0,N.$Kp)(C,A)&&(0,N.$Mp)(b)===a.TelemetryLevel.USAGE){const l=await(0,I.$uq)(A,R,p);f["X-Market-User-Id"]=l,f["VSCode-SessionId"]=m.machineId||l}return f}}),define(ue[225],de([0,1,17,25,8,5,37,12,10,142,21,15,27,35,34,59,7,11,23,61,224,16,18,54]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P,$,c,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0,e.$wq=K;const n=k.$r?l.TargetPlatform.WEB:(0,m.$np)(k.$x,T.$jc),t="X-Market-Search-Activity-Id";var s;(function(Y){Y[Y.None=0]="None",Y[Y.IncludeVersions=1]="IncludeVersions",Y[Y.IncludeFiles=2]="IncludeFiles",Y[Y.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",Y[Y.IncludeSharedAccounts=8]="IncludeSharedAccounts",Y[Y.IncludeVersionProperties=16]="IncludeVersionProperties",Y[Y.ExcludeNonValidated=32]="ExcludeNonValidated",Y[Y.IncludeInstallationTargets=64]="IncludeInstallationTargets",Y[Y.IncludeAssetUri=128]="IncludeAssetUri",Y[Y.IncludeStatistics=256]="IncludeStatistics",Y[Y.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",Y[Y.Unpublished=4096]="Unpublished",Y[Y.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function r(...Y){return String(Y.reduce((M,B)=>M|B,0))}var o;(function(Y){Y[Y.Tag=1]="Tag",Y[Y.ExtensionId=4]="ExtensionId",Y[Y.Category=5]="Category",Y[Y.ExtensionName=7]="ExtensionName",Y[Y.Target=8]="Target",Y[Y.Featured=9]="Featured",Y[Y.SearchText=10]="SearchText",Y[Y.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},y={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},S={pageNumber:1,pageSize:10,sortBy:m.SortBy.NoneOrRelevance,sortOrder:m.SortOrder.Default,flags:s.None,criteria:[],assetTypes:[]};class v{constructor(M=S){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,B=this.d.pageSize){return new v({...this.d,pageNumber:M,pageSize:B})}withFilter(M,...B){const ie=[...this.d.criteria,...B.length?B.map(ae=>({filterType:M,value:ae})):[{filterType:M}]];return new v({...this.d,criteria:ie})}withSortBy(M){return new v({...this.d,sortBy:M})}withSortOrder(M){return new v({...this.d,sortOrder:M})}withFlags(...M){return new v({...this.d,flags:M.reduce((B,ie)=>B|ie,0)})}withAssetTypes(...M){return new v({...this.d,assetTypes:M})}withSource(M){return new v({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:B,pageSize:ie,sortBy:ae,sortOrder:he,flags:pe,assetTypes:be}=this.d;return{filters:[{criteria:M,pageNumber:B,pageSize:ie,sortBy:ae,sortOrder:he}],assetTypes:be,flags:pe}}get searchText(){const M=this.d.criteria.filter(B=>B.filterType===o.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function L(Y,M){const B=(Y||[]).filter(ie=>ie.statisticName===M)[0];return B?B.value:0}function j(Y){const M="Microsoft.VisualStudio.Code.Translation.";return Y.files.filter(ie=>ie.assetType.indexOf(M)===0).reduce((ie,ae)=>{const he=G(Y,ae.assetType);return he&&ie.push([ae.assetType.substring(M.length),he]),ie},[])}function U(Y){if(Y.properties){const M=Y.properties.filter(ae=>ae.key===u.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=M.filter(ae=>B.test(ae.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return G(Y,u.Repository)}function F(Y){return{uri:`${Y.fallbackAssetUri}/${u.VSIX}?redirect=true${Y.targetPlatform?`&targetPlatform=${Y.targetPlatform}`:""}`,fallbackUri:`${Y.fallbackAssetUri}/${u.VSIX}${Y.targetPlatform?`?targetPlatform=${Y.targetPlatform}`:""}`}}function G(Y,M){return Y.files.filter(ie=>ie.assetType===M)[0]?{uri:`${Y.assetUri}/${M}${Y.targetPlatform?`?targetPlatform=${Y.targetPlatform}`:""}`,fallbackUri:`${Y.fallbackAssetUri}/${M}${Y.targetPlatform?`?targetPlatform=${Y.targetPlatform}`:""}`}:null}function V(Y,M){const B=Y.properties?Y.properties.filter(ae=>ae.key===M):[],ie=B.length>0&&B[0].value;return ie?ie.split(",").map(ae=>(0,f.$Wp)(ae)):[]}function x(Y){const M=Y.properties?Y.properties.filter(B=>B.key===y.Engine):[];return M.length>0&&M[0].value||""}function H(Y){const M=Y.properties?Y.properties.filter(B=>B.key===y.PreRelease):[];return M.length>0&&M[0].value==="true"}function te(Y){const M=Y.properties?Y.properties.filter(B=>B.key===y.ExecutesCode):[];return M.length>0?M[0].value==="true":void 0}function z(Y){const M=Y.properties?Y.properties.filter(ie=>ie.key===y.EnabledApiProposals):[],B=M.length>0&&M[0].value||"";return B?B.split(","):[]}function W(Y){const M=Y.properties?Y.properties.filter(ie=>ie.key===y.LocalizedLanguages):[],B=M.length>0&&M[0].value||"";return B?B.split(","):[]}function _(Y){return Y.properties?.find(M=>M.key===y.SponsorLink)?.value}function ne(Y){return Y.properties?.find(M=>M.key===y.SupportLink)?.value}function le(Y){return Y.indexOf("preview")!==-1}function ee(Y){return Y.targetPlatform?(0,m.$mp)(Y.targetPlatform):l.TargetPlatform.UNDEFINED}function X(Y){const M=(0,I.$Qb)(Y.versions.map(ee)),B=!!Y.tags?.includes(m.$gp),ie=M.indexOf(l.TargetPlatform.WEB);return B?ie===-1&&M.push(l.TargetPlatform.WEB):ie!==-1&&M.splice(ie,1),M}function K(Y,M){for(let B=0;B<Y.length;B++){const ie=Y[B];if(ie.version===Y[B-1]?.version){let ae=B;if(ee(ie)===M)for(;ae>0&&Y[ae-1].version===ie.version;)ae--;ae!==B&&(Y.splice(B,1),Y.splice(ae,0,ie))}}return Y}function q(Y,M,B){Y.telemetryData={index:M,querySource:B,queryActivityId:Y.queryContext?.[t]}}function D(Y,M,B,ie){const ae=Y.versions[0],he={manifest:G(M,u.Manifest),readme:G(M,u.Details),changelog:G(M,u.Changelog),license:G(M,u.License),repository:U(M),download:F(M),icon:G(M,u.Icon),signature:G(M,u.Signature),coreTranslations:j(M)};return{type:"gallery",identifier:{id:(0,f.$Xp)(Y.publisher.publisherName,Y.extensionName),uuid:Y.extensionId},name:Y.extensionName,version:M.version,displayName:Y.displayName,publisherId:Y.publisher.publisherId,publisher:Y.publisher.publisherName,publisherDisplayName:Y.publisher.displayName,publisherDomain:Y.publisher.domain?{link:Y.publisher.domain,verified:!!Y.publisher.isDomainVerified}:void 0,publisherSponsorLink:_(ae),description:Y.shortDescription??"",installCount:L(Y.statistics,"install"),rating:L(Y.statistics,"averagerating"),ratingCount:L(Y.statistics,"ratingcount"),categories:Y.categories||[],tags:Y.tags||[],releaseDate:Date.parse(Y.releaseDate),lastUpdated:Date.parse(Y.lastUpdated),allTargetPlatforms:B,assets:he,properties:{dependencies:V(M,y.Dependency),extensionPack:V(M,y.ExtensionPack),engine:x(M),enabledApiProposals:z(M),localizedLanguages:W(M),targetPlatform:ee(M),isPreReleaseVersion:H(M),executesCode:te(M)},hasPreReleaseVersion:H(ae),hasReleaseVersion:!0,preview:le(Y.flags),isSigned:!!he.signature,queryContext:ie,supportLink:ne(ae)}}let J=class{constructor(M,B,ie,ae,he,pe,be,Ie){this.l=B,this.n=ie,this.o=ae,this.q=he,this.u=pe,this.w=be,this.x=Ie;const ke=be.extensionsGallery,ve=ke?.servicePPEUrl&&Ie.getValue("_extensionsGallery.enablePPE");this.d=ve?ke.servicePPEUrl:ke?.serviceUrl,this.g=ve?void 0:ke?.searchUrl,this.h=ke?.controlUrl,this.k=be.extensionsEnabledWithApiProposalVersion?.map(we=>we.toLowerCase())??[],this.j=(0,$.$vq)(be.version,be,this.o,this.x,this.u,M,this.q)}y(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,B,ie){const ae=a.CancellationToken.isCancellationToken(B)?{}:B,he=a.CancellationToken.isCancellationToken(B)?B:ie,pe=await this.z(M,ae,he),be=pe.map(ke=>ke.identifier.uuid),Ie=[];for(const ke of M)ke.uuid&&!be.includes(ke.uuid)&&Ie.push({...ke,uuid:void 0});if(Ie.length){this.q.publicLog2("galleryService:additionalQueryByName",{count:Ie.length});const ke=await this.z(Ie,ae,he);pe.push(...ke)}return pe}async z(M,B,ie){const ae=[],he=[],pe=[],be=[];let Ie=!0;for(const we of M){we.uuid?he.push(we.uuid):ae.push(we.id);const re=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:re}),we.version&&be.push({id:we.id,uuid:we.uuid,version:we.version}),Ie=Ie&&!!we.hasPreRelease&&!re}if(!he.length&&!ae.length)return[];let ke=new v().withPage(1,M.length);he.length&&(ke=ke.withFilter(o.ExtensionId,...he)),ae.length&&(ke=ke.withFilter(o.ExtensionName,...ae)),(B.queryAllVersions||Ie)&&(ke=ke.withFlags(ke.flags,s.IncludeVersions)),B.source&&(ke=ke.withSource(B.source));const{extensions:ve}=await this.C(ke,{targetPlatform:B.targetPlatform??n,includePreRelease:pe,versions:be,compatible:!!B.compatible,productVersion:B.productVersion??{version:this.w.version,date:this.w.date}},ie);return B.source&&ve.forEach((we,re)=>q(we,re,B.source)),ve}async getCompatibleExtension(M,B,ie,ae={version:this.w.version,date:this.w.date}){if((0,m.$op)(M.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(M,B,ie))return M;const he=new v().withFlags(s.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,M.identifier.uuid),{extensions:pe}=await this.C(he,{targetPlatform:ie,compatible:!0,includePreRelease:B,productVersion:ae},a.CancellationToken.None);return pe[0]||null}async isExtensionCompatible(M,B,ie,ae={version:this.w.version,date:this.w.date}){if(!(0,m.$pp)(M.properties.targetPlatform,M.allTargetPlatforms,ie)||!B&&M.properties.isPreReleaseVersion)return!1;let he=M.properties.engine;if(!he){const pe=await this.getManifest(M,a.CancellationToken.None);if(!pe)throw new Error("Manifest was not found");he=pe.engines.vscode}return!(!(0,g.$_p)(he,ae.version,ae.date)||!this.A(M.identifier,M.properties.enabledApiProposals))}A(M,B){return!B||!this.k.includes(M.id.toLowerCase())?!0:(0,g.$aq)(B)}async B(M,B,ie,ae,he,pe,be={version:this.w.version,date:this.w.date}){if(!(0,m.$pp)(ee(B),he,pe)||ie!=="any"&&H(B)!==(ie==="prerelease"))return!1;if(ae)try{const Ie=await this.H(M,B);if(!(0,g.$_p)(Ie,be.version,be.date))return!1}catch(Ie){return this.n.error(`Error while getting the engine for the version ${B.version}.`,(0,N.$bb)(Ie)),!1}return!0}async query(M,B){let ie=M.text||"";const ae=M.pageSize??50;let he=new v().withPage(1,ae);ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,we,re)=>(he=he.withFilter(o.Category,re||we),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,we,re)=>(he=he.withFilter(o.Tag,re||we),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(o.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),he=he.withFilter(o.SearchText,ie)),he=he.withSortBy(m.SortBy.NoneOrRelevance)):M.ids?he=he.withFilter(o.ExtensionId,...M.ids):M.names?he=he.withFilter(o.ExtensionName,...M.names):he=he.withSortBy(m.SortBy.InstallCount),typeof M.sortBy=="number"&&(he=he.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(he=he.withSortOrder(M.sortOrder)),M.source&&(he=he.withSource(M.source));const pe=async(ve,we)=>{const{extensions:re,total:fe}=await this.C(ve,{targetPlatform:n,compatible:!1,includePreRelease:!!M.includePreRelease,productVersion:M.productVersion??{version:this.w.version,date:this.w.date}},we);return re.forEach((me,Se)=>q(me,(ve.pageNumber-1)*ve.pageSize+Se,M.source)),{extensions:re,total:fe}},{extensions:be,total:Ie}=await pe(he,B),ke=async(ve,we)=>{if(we.isCancellationRequested)throw new N.$9;const{extensions:re}=await pe(he.withPage(ve+1),we);return re};return{firstPage:be,total:Ie,pageSize:he.pageSize,getPage:ke}}async C(M,B,ie){const ae=M.flags;M.flags&s.IncludeLatestVersionOnly&&M.flags&s.IncludeVersions&&(M=M.withFlags(M.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(M.flags&s.IncludeLatestVersionOnly)&&!(M.flags&s.IncludeVersions)&&(M=M.withFlags(M.flags,s.IncludeLatestVersionOnly)),B.versions?.length&&(M=M.withFlags(M.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),M=M.withFlags(M.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:he,total:pe,context:be}=await this.E(M,ie);if(!(M.flags&s.IncludeLatestVersionOnly)){const we=[];for(const re of he){const fe=await this.D(re,B,be);fe&&we.push(fe)}return{extensions:we,total:pe}}const ke=[],ve=new Map;for(let we=0;we<he.length;we++){const re=he[we],fe={id:(0,f.$Xp)(re.publisher.publisherName,re.extensionName),uuid:re.extensionId},me=(0,C.$pg)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(Pe=>(0,f.$Sp)(Pe,fe))?.includePreRelease;if(B.compatible&&(0,m.$op)(X(re),B.targetPlatform))continue;const Se=await this.D(re,B,be);!Se||Se.properties.isPreReleaseVersion&&(!me||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==B.targetPlatform&&Se.hasPreReleaseVersion?ve.set(re.extensionId,we):ke.push([we,Se])}if(ve.size){const we=new i.$ke,re=new v().withFlags(ae&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,ve.size).withFilter(o.ExtensionId,...ve.keys()),{extensions:fe}=await this.C(re,B,ie);this.q.publicLog2("galleryService:additionalQuery",{duration:we.elapsed(),count:ve.size});for(const me of fe){const Se=ve.get(me.identifier.uuid);ke.push([Se,me])}}return{extensions:ke.sort((we,re)=>we[0]-re[0]).map(([,we])=>we),total:pe}}async D(M,B,ie){const ae={id:(0,f.$Xp)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},he=B.versions?.find(ke=>(0,f.$Sp)(ke,ae))?.version,pe=(0,C.$pg)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(ke=>(0,f.$Sp)(ke,ae))?.includePreRelease,be=X(M),Ie=K(M.versions,B.targetPlatform);if(B.compatible&&(0,m.$op)(be,B.targetPlatform))return null;for(let ke=0;ke<Ie.length;ke++){const ve=Ie[ke];if(!(he&&ve.version!==he)){if(await this.B(ae.id,ve,pe?"any":"release",B.compatible,be,B.targetPlatform,B.productVersion)){if(B.compatible&&!this.A(ae,z(ve)))continue;return D(M,ve,be,ie)}if(he&&ve.version===he)return null}}return he||B.compatible?null:D(M,M.versions[0],be)}async E(M,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,s.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,r(s.Unpublished));const ie=await this.j,ae=JSON.stringify(M.raw),he={...ie,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ae.length)},pe=new i.$ke;let be,Ie,ke=0;try{if(be=await this.l.request({type:"POST",url:this.g&&M.criteria.some(we=>we.filterType===o.SearchText)?this.g:this.y("/extensionquery"),data:ae,headers:he},B),be.res.statusCode&&be.res.statusCode>=400&&be.res.statusCode<500)return{galleryExtensions:[],total:ke};const ve=await(0,P.$hq)(be);if(ve){const we=ve.results[0],re=we.extensions,fe=we.resultMetadata&&we.resultMetadata.filter(me=>me.metadataType==="ResultCount")[0];return ke=fe&&fe.metadataItems.filter(me=>me.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:ke,context:be.res.headers.activityid?{[t]:be.res.headers.activityid}:{}}}return{galleryExtensions:[],total:ke}}catch(ve){if((0,N.$8)(ve))throw Ie=m.ExtensionGalleryErrorCode.Cancelled,ve;{const we=(0,N.$bb)(ve);throw Ie=(0,b.$cp)(ve)?m.ExtensionGalleryErrorCode.Offline:we.startsWith("XHR timeout")?m.ExtensionGalleryErrorCode.Timeout:m.ExtensionGalleryErrorCode.Failed,new m.$sp(we,Ie)}}finally{this.q.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(ae.length),duration:pe.elapsed(),success:!!be&&(0,P.$dq)(be),responseBodySize:be?.res.headers["Content-Length"],statusCode:be?String(be.res.statusCode):void 0,errorCode:Ie,count:String(ke)})}}async reportStatistic(M,B,ie,ae){if(!this.isEnabled())return;const he=k.$r?this.y(`/itemName/${M}.${B}/version/${ie}/statType/${ae===m.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${M}/extensions/${B}/${ie}/stats?statType=${ae}`),pe=k.$r?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.j,Accept:pe};try{await this.l.request({type:"POST",url:he,headers:Ie},a.CancellationToken.None)}catch{}}async download(M,B,ie){this.n.trace("ExtensionGalleryService#download",M.identifier.id);const ae=(0,f.$1p)(M),he=new Date().getTime(),pe=ie===m.InstallOperation.Install?"install":ie===m.InstallOperation.Update?"update":"",be=pe?{uri:`${M.assets.download.uri}${A.URI.parse(M.assets.download.uri).query?"&":"?"}${pe}=true`,fallbackUri:`${M.assets.download.fallbackUri}${A.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${pe}=true`}:M.assets.download,Ie=M.queryContext?.[t]?{[t]:M.queryContext[t]}:void 0,ke=await this.G(M.identifier.id,be,u.VSIX,Ie?{headers:Ie}:void 0);try{await this.u.writeFile(B,ke.stream)}catch(ve){try{await this.u.del(B)}catch(we){this.n.warn(`Error while deleting the file ${B.toString()}`,(0,N.$bb)(we))}throw new m.$sp((0,N.$bb)(ve),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...ae,duration:new Date().getTime()-he})}async downloadSignatureArchive(M,B){if(!M.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const ie=await this.G(M.identifier.id,M.assets.signature,u.Signature);try{await this.u.writeFile(B,ie.stream)}catch(ae){try{await this.u.del(B)}catch(he){this.n.warn(`Error while deleting the file ${B.toString()}`,(0,N.$bb)(he))}throw new m.$sp((0,N.$bb)(ae),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(M,B){if(M.assets.readme){const ie=await this.G(M.identifier.id,M.assets.readme,u.Details,{},B);return await(0,P.$gq)(ie)||""}return""}async getManifest(M,B){if(M.assets.manifest){const ie=await this.G(M.identifier.id,M.assets.manifest,u.Manifest,{},B),ae=await(0,P.$gq)(ie);return ae?JSON.parse(ae):null}return null}async F(M,B,ie){const ae=G(B,u.Manifest);if(!ae)throw new Error("Manifest was not found");const he={"Accept-Encoding":"gzip"},pe=await this.G(M,ae,u.Manifest,{headers:he});return await(0,P.$hq)(pe)}async getCoreTranslation(M,B){const ie=M.assets.coreTranslations.filter(ae=>ae[0]===B.toUpperCase())[0];if(ie){const ae=await this.G(M.identifier.id,ie[1],ie[0]),he=await(0,P.$gq)(ae);return he?JSON.parse(he):null}return null}async getChangelog(M,B){if(M.assets.changelog){const ie=await this.G(M.identifier.id,M.assets.changelog,u.Changelog,{},B);return await(0,P.$gq)(ie)||""}return""}async getAllCompatibleVersions(M,B,ie){let ae=new v().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);M.uuid?ae=ae.withFilter(o.ExtensionId,M.uuid):ae=ae.withFilter(o.ExtensionName,M.id);const{galleryExtensions:he}=await this.E(ae,a.CancellationToken.None);if(!he.length)return[];const pe=X(he[0]);if((0,m.$op)(pe,ie))return[];const be=[];await Promise.all(he[0].versions.map(async ve=>{try{await this.B(M.id,ve,B?"any":"release",!0,pe,ie)&&this.A(M,z(ve))&&be.push(ve)}catch{}}));const Ie=[],ke=new Set;for(const ve of K(be,ie))ke.has(ve.version)||(ke.add(ve.version),Ie.push({version:ve.version,date:ve.lastUpdated,isPreReleaseVersion:H(ve)}));return Ie}async G(M,B,ie,ae={},he=a.CancellationToken.None){const pe=await this.j,be={type:"GET"},Ie={...pe,...ae.headers||{}};ae={...ae,...be,headers:Ie};const ke=B.uri,ve=B.fallbackUri,we={...ae,url:ke};try{const re=await this.l.request(we,he);if(re.res.statusCode===200)return re;const fe=await(0,P.$gq)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${fe}`)}catch(re){if((0,N.$8)(re))throw re;const fe=(0,N.$bb)(re);this.q.publicLog2("galleryService:cdnFallback",{extension:M,assetType:ie,message:fe});const me={...ae,url:ve};return this.l.request(me,he)}}async H(M,B){let ie=x(B);if(!ie){this.q.publicLog2("galleryService:engineFallback",{extension:M,version:B.version});const ae=await this.F(M,B,a.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");ie=ae.engines.vscode}return ie}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const M=await this.l.request({type:"GET",url:this.h},a.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,P.$hq)(M),ie=[],ae={},he=[],pe=[];if(B){for(const be of B.malicious)ie.push({id:be});if(B.migrateToPreRelease)for(const[be,Ie]of Object.entries(B.migrateToPreRelease))(!Ie.engine||(0,g.$_p)(Ie.engine,this.w.version,this.w.date))&&(ae[be.toLowerCase()]={disallowInstall:!0,extension:{id:Ie.id,displayName:Ie.displayName,autoMigrate:{storage:!!Ie.migrateStorage},preRelease:!0}});if(B.deprecated)for(const[be,Ie]of Object.entries(B.deprecated))Ie&&(ae[be.toLowerCase()]=(0,C.$pg)(Ie)?{}:Ie);if(B.search)for(const be of B.search)he.push(be);if(Array.isArray(B.extensionsEnabledWithPreRelease))for(const be of B.extensionsEnabledWithPreRelease)pe.push(be.toLowerCase())}return{malicious:ie,deprecated:ae,search:he,extensionsEnabledWithPreRelease:pe}}};J=Ee([Z(1,P.$bq),Z(2,w.$fk),Z(3,p.$Ri),Z(4,h.$em),Z(5,E.$fl),Z(6,d.$yk),Z(7,R.$ej)],J);let oe=class extends J{constructor(M,B,ie,ae,he,pe,be,Ie){super(M,B,ie,ae,he,pe,be,Ie)}};e.$xq=oe,e.$xq=oe=Ee([Z(0,c.$oq),Z(1,P.$bq),Z(2,w.$fk),Z(3,p.$Ri),Z(4,h.$em),Z(5,E.$fl),Z(6,d.$yk),Z(7,R.$ej)],oe);let Q=class extends J{constructor(M,B,ie,ae,he,pe,be){super(void 0,M,B,ie,ae,he,pe,be)}};e.$yq=Q,e.$yq=Q=Ee([Z(0,P.$bq),Z(1,w.$fk),Z(2,p.$Ri),Z(3,h.$em),Z(4,E.$fl),Z(5,d.$yk),Z(6,R.$ej)],Q)}),define(ue[226],de([0,1,109,3,18,15,2,11,13,70,23,5,6,103,21,9,38,16,12,140,20]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=void 0;const c=[I.$Vjc,I.$Wjc],h="remoteTunnelSession",i="remoteTunnelIsService";let n=class extends T.$Zc{constructor(o,u,y,O,S,v,L){super(),this.y=o,this.z=u,this.C=y,this.D=v,this.F=L,this.f=new a.$qe,this.onDidTokenFailed=this.f.event,this.g=new a.$qe,this.onDidChangeTunnelStatus=this.g.event,this.h=new a.$qe,this.onDidChangeMode=this.h.event,this.n=I.$Tjc,this.w=!1,this.I=(j,U)=>{U?this.j.error(j):this.j.info(j)},this.j=this.B(O.createLogger((0,$.$lh)(y.logsHome,`${I.$Xjc}.log`),{id:I.$Xjc,name:I.$Yjc})),this.t=new m.$Hh(100),this.B(this.j.onDidChangeLogLevel(j=>this.j.info("Log level changed to "+(0,C.$uk)(j)))),this.B(S.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(v.onDidChangeConfiguration(j=>{c.some(U=>j.affectsConfiguration(U))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(o){this.s=o,this.g.fire(o)}H(o){s(this.n,o)||(this.n=o,this.S(o),this.h.fire(this.n),o.active?(this.j.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this.j.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(o){if(this.w)return this.s;this.w=!0,this.H(o);try{await this.t.trigger(()=>this.L())}catch(u){this.j.error(u)}return this.s}J(){if(!this.u){let o;p.$m?o=this.C.appRoot:o=(0,A.$rc)((0,A.$rc)(this.C.appRoot)),this.u=(0,A.$oc)(o,"bin",`${this.z.tunnelApplicationName}${p.$l?".exe":""}`)}return this.u}async startTunnel(o){if(s(this.n,o)&&this.s.type!=="disconnected")return this.s;this.H(o);try{await this.t.trigger(()=>this.L())}catch(u){this.j.error(u)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const o=this.n.asService;this.H(I.$Tjc);try{o&&this.O("uninstallService",["service","uninstall"])}catch(u){this.j.error(u)}}try{await this.O("stop",["kill"])}catch(o){this.j.error(o)}this.G(I.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let o="",u=!1;const y=(U,F)=>{F?this.j.error(U):o+=U,!this.C.isBuilt&&U.startsWith("   Compiling")&&this.G(I.TunnelStates.connecting((0,g.localize)(2045,null)))},O=this.O("status",["status"],y);this.r=O;try{if(await O,this.r!==O)return;let U;try{U=JSON.parse(o.trim().split(`
`).find(F=>F.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(o.trim())}`),this.G(I.TunnelStates.disconnected());return}if(u=U.service_installed,this.j.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this.n.active){this.G(I.TunnelStates.disconnected());return}}catch(U){this.j.error(U),this.G(I.TunnelStates.disconnected());return}finally{this.r===O&&(this.r=void 0)}const S=this.n.active?this.n.session:void 0;if(S&&S.token){const U=S.token;this.G(I.TunnelStates.connecting((0,g.localize)(2046,null,S.accountLabel,S.providerId)));const F=(V,x)=>{V=V.replaceAll(U,"*".repeat(4)),y(V,x)},G=this.O("login",["user","login","--provider",S.providerId,"--log",(0,C.$uk)(this.j.getLevel())],F,{VSCODE_CLI_ACCESS_TOKEN:U});this.r=G;try{if(await G,this.r!==G)return}catch(V){this.j.error(V),this.r=void 0,this.f.fire(S),this.G(I.TunnelStates.disconnected(S));return}}const v=this.Q();v?this.G(I.TunnelStates.connecting((0,g.localize)(2047,null,v))):this.G(I.TunnelStates.connecting((0,g.localize)(2048,null)));const L=["--accept-server-license-terms","--log",(0,C.$uk)(this.j.getLevel())];v?L.push("--name",v):L.push("--random-name");let j=!1;return this.n.active&&this.n.asService&&!u&&(j=await this.M(L)===!1),this.N(S,L,j)}async M(o){let u;try{u=await this.O("serviceInstall",["service","install",...o])}catch(y){this.j.error(y),u=1}if(u!==0){const y=(0,g.localize)(2049,null);return this.j.warn(y),this.G(I.TunnelStates.connecting(y)),!1}return!0}async N(o,u,y){u.push("--parent-process-id",String(process.pid)),this.P()&&u.push("--no-sleep");let O=!1;const S=this.O("tunnel",u,(v,L)=>{L?this.j.error(v):this.j.info(v),v.includes("Connected to an existing tunnel process")&&(O=!0);const j=v.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(j){const U={link:j[1],domain:j[2],tunnelName:j[4],isAttached:O};this.G(I.TunnelStates.connected(U,y))}else v.match(/error refreshing token/)&&(S.cancel(),this.f.fire(o),this.G(I.TunnelStates.disconnected(o)))});this.r=S,S.finally(()=>{S===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=I.$Tjc,this.G(I.TunnelStates.disconnected()))})}O(o,u,y=this.I,O){return(0,m.$xh)(S=>new Promise((v,L)=>{S.isCancellationRequested&&v(-1);let j;const U=["ignore","pipe","pipe"];if(S.onCancellationRequested(()=>{j&&(this.j.info(`${o} terminating(${j.pid})`),j.kill())}),!this.C.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${o} Spawning: cargo run -- tunnel ${u.join(" ")}
`,!1),j=(0,b.spawn)("cargo",["run","--","tunnel",...u],{cwd:(0,A.$oc)(this.C.appRoot,"cli"),stdio:U,env:{...process.env,RUST_BACKTRACE:"1",...O}});else{y(`Running tunnel CLI
`,!1);const F=this.J();y(`${o} Spawning: ${F} tunnel ${u.join(" ")}
`,!1),j=(0,b.spawn)(F,["tunnel",...u],{cwd:(0,E.homedir)(),stdio:U,env:{...process.env,...O}})}j.stdout.pipe(new P.$hY(`
`)).on("data",F=>{if(j){const G=F.toString();y(G,!1)}}),j.stderr.pipe(new P.$hY(`
`)).on("data",F=>{if(j){const G=F.toString();y(G,!0)}}),j.on("exit",F=>{j&&(y(`${o} exit(${j.pid}): + ${F} `,!1),j=void 0,v(F||0))}),j.on("error",F=>{j&&(y(`${o} error(${j.pid}): + ${F} `,!0),j=void 0,L())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(I.$Wjc)}Q(){let o=this.D.getValue(I.$Vjc)||(0,E.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}R(){try{const o=this.F.get(h,w.StorageScope.APPLICATION),u=this.F.getBoolean(i,w.StorageScope.APPLICATION,!1);if(o){const y=JSON.parse(o);if(y&&(0,d.$jg)(y.accountLabel)&&(0,d.$jg)(y.sessionId)&&(0,d.$jg)(y.providerId))return{active:!0,session:y,asService:u};this.j.error("Problems restoring session from storage, invalid format",y)}}catch(o){this.j.error("Problems restoring session from storage",o)}return I.$Tjc}S(o){if(o.active){const u={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.F.store(h,JSON.stringify(u),w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),this.F.store(i,o.asService,w.StorageScope.APPLICATION,w.StorageTarget.MACHINE)}else this.F.remove(h,w.StorageScope.APPLICATION),this.F.remove(i,w.StorageScope.APPLICATION)}};e.$3jc=n,e.$3jc=n=Ee([Z(0,N.$em),Z(1,R.$yk),Z(2,k.$Si),Z(3,C.$gk),Z(4,f.$1jc),Z(5,l.$ej),Z(6,w.$oq)],n);function t(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const s=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&t(r.session,o.session):!0}),define(ue[227],de([0,1,6,2,22,20,73,16,80,19]),function(ce,e,I,a,N,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=void 0;class R extends C.$qq{constructor(m,f,l,g){super(),this.bb=m,this.cb=f,this.db=l,this.eb=g,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new a.$Yc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new a.$Yc),this.ab=this.hb(this.bb)}fb(){const m=this.B(new A.$UNb(this.db.getChannel("storage"))),f=this.B(new T.$kq(m));return this.B(f.onDidChangeStorage(l=>this.u(C.StorageScope.APPLICATION,l))),f}gb(m){this.X.clear(),this.W=m;let f;if((0,C.$rq)(m))f=this.U;else{const l=this.X.add(new A.$VNb(this.db.getChannel("storage"),m));f=this.X.add(new T.$kq(l))}return this.X.add(f.onDidChangeStorage(l=>this.u(C.StorageScope.PROFILE,l))),f}hb(m){this.$.clear(),this.Z=m?.id;let f;if(m){const l=this.$.add(new A.$WNb(this.db.getChannel("storage"),m));f=this.$.add(new T.$kq(l)),this.$.add(f.onDidChangeStorage(g=>this.u(C.StorageScope.WORKSPACE,g)))}return f}async O(){await I.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(m){switch(m){case C.StorageScope.APPLICATION:return this.U;case C.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(m){switch(m){case C.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;case C.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;default:return this.Z?`${(0,k.$lh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:N.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(C.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(m){if(!this.M(this.W,m))return;const f=this.Y,l=f.items;f!==this.U&&await f.close(),this.Y=this.gb(m),await this.Y.init(),this.N(l,this.Y,C.StorageScope.PROFILE)}async S(m,f){const l=this.ab,g=l?.items??new Map;await l?.close(),this.ab=this.hb(m),await this.ab.init(),this.N(g,this.ab,C.StorageScope.WORKSPACE)}hasScope(m){return(0,b.$Ql)(m)?this.W.id===m.id:this.Z===m.id}}e.$8jc=R}),define(ue[228],de([0,1,3,2,19,96]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fS=e.$eS=void 0;class T{constructor(b,R){this.a=b,this.b=R}listen(b,R){const p=this.b(b);switch(R){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(f=>(0,k.$Un)({...f},p)),added:m.added.map(f=>(0,k.$Un)({...f},p)),removed:m.removed.map(f=>(0,k.$Un)({...f},p)),updated:m.updated.map(f=>(0,k.$Un)({...f},p))}))}throw new Error(`Invalid listen ${R}`)}async call(b,R,p){const m=this.b(b);switch(R){case"createProfile":{const f=await this.a.createProfile(p[0],p[1],p[2]);return(0,k.$Un)({...f},m)}case"updateProfile":{let f=(0,N.$Sl)((0,k.$Vn)(p[0],m),this.a.profilesHome.scheme);return f=await this.a.updateProfile(f,p[1]),(0,k.$Un)({...f},m)}case"removeProfile":{const f=(0,N.$Sl)((0,k.$Vn)(p[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(f)}}throw new Error(`Invalid call ${R}`)}}e.$eS=T;class C extends a.$Zc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(b,R,p){super(),this.profilesHome=R,this.f=p,this.a=[],this.b=this.B(new I.$qe),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=b.map(m=>(0,N.$Sl)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const f=m.added.map(E=>(0,N.$Sl)(E,this.profilesHome.scheme)),l=m.removed.map(E=>(0,N.$Sl)(E,this.profilesHome.scheme)),g=m.updated.map(E=>(0,N.$Sl)(E,this.profilesHome.scheme));this.a=m.all.map(E=>(0,N.$Sl)(E,this.profilesHome.scheme)),this.b.fire({added:f,removed:l,updated:g,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(b){this.c=b}isEnabled(){return this.c}async createNamedProfile(b,R,p){const m=await this.f.call("createNamedProfile",[b,R,p]);return(0,N.$Sl)(m,this.profilesHome.scheme)}async createProfile(b,R,p,m){const f=await this.f.call("createProfile",[b,R,p,m]);return(0,N.$Sl)(f,this.profilesHome.scheme)}async createTransientProfile(b){const R=await this.f.call("createTransientProfile",[b]);return(0,N.$Sl)(R,this.profilesHome.scheme)}async setProfileForWorkspace(b,R){await this.f.call("setProfileForWorkspace",[b,R])}removeProfile(b){return this.f.call("removeProfile",[b])}async updateProfile(b,R){const p=await this.f.call("updateProfile",[b,R]);return(0,N.$Sl)(p,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$fS=C}),define(ue[62],de([0,1,2,73,4,16,3,80,19]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Nb=e.$ZNb=e.$YNb=void 0,e.$YNb=(0,N.$Ki)("IUserDataProfileStorageService");let b=class extends I.$Zc{constructor(f,l){super(),this.b=l,f&&(this.a=this.B(new I.$9c))}async readStorageData(f){return this.withProfileScopedStorageService(f,async l=>this.c(l))}async updateStorageData(f,l,g){return this.withProfileScopedStorageService(f,async E=>this.f(E,l,g))}async withProfileScopedStorageService(f,l){if(this.b.hasScope(f))return l(this.b);let g=this.a?.get(f.id);if(!g){g=new p(this.g(f)),this.a?.set(f.id,g);try{await g.initialize()}catch(E){throw this.a?.has(f.id)?this.a.deleteAndDispose(f.id):g.dispose(),E}}try{const E=await l(g);return await g.flush(),E}finally{this.a?.has(f.id)||g.dispose()}}c(f){const l=new Map,g=E=>{for(const w of f.keys(k.StorageScope.PROFILE,E))l.set(w,{value:f.get(w,k.StorageScope.PROFILE),target:E})};return g(k.StorageTarget.USER),g(k.StorageTarget.MACHINE),l}f(f,l,g){f.storeAll(Array.from(l.entries()).map(([E,w])=>({key:E,value:w,scope:k.StorageScope.PROFILE,target:g})),!0)}};e.$ZNb=b,e.$ZNb=b=Ee([Z(1,k.$oq)],b);class R extends b{constructor(f,l,g,E,w){super(f,E),this.j=l;const d=l.getChannel("profileStorageListener"),P=this.B(new I.$1c);this.h=this.B(new T.$qe({onWillAddFirstListener:()=>{P.value=d.listen("onDidChange")($=>{w.trace("profile storage changes",$),this.h.fire({targetChanges:$.targetChanges.map(c=>(0,A.$Sl)(c,g.profilesHome.scheme)),valueChanges:$.valueChanges.map(c=>({...c,profile:(0,A.$Sl)(c.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>P.value=void 0})),this.onDidChange=this.h.event}async g(f){const l=this.j.getChannel("storage");return(0,k.$rq)(f)?new C.$UNb(l):new C.$VNb(l,f)}}e.$1Nb=R;class p extends k.$qq{constructor(f){super({flushInterval:100}),this.U=f}async O(){const f=await this.U,l=new a.$kq(f);return this.B(l.onDidChangeStorage(g=>{this.u(k.StorageScope.PROFILE,g)})),this.B((0,I.$Xc)(()=>{l.close(),l.dispose(),(0,I.$Tc)(f)&&f.dispose()})),this.s=l,this.s.init()}P(f){return f===k.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ue[229],de([0,1,16,11,19,56,62]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=void 0;let C=class extends T.$1Nb{constructor(b,R,p,m){super(!0,b,R,p,m)}};e.$Mjc=C,e.$Mjc=C=Ee([Z(0,k.$hjc),Z(1,N.$Rl),Z(2,I.$oq),Z(3,a.$fk)],C)}),define(ue[40],de([0,1,17,6,14,25,3,36,2,26,12,9,21,15,7,11,49,16,18,28,24,19]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Ob=e.$3Ob=e.$2Ob=e.$1Ob=void 0,e.$XOb=h,e.$YOb=i,e.$ZOb=n;function h(u){return!!(u&&u.ref!==void 0&&typeof u.ref=="string"&&u.ref!==""&&u.syncData!==void 0&&(u.syncData===null||i(u.syncData)))}function i(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}function n(u,y){return`${(0,b.$bg)(u)}${y.isDefault?"":` (${y.name})`}`}let t=class extends A.$Zc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(y,O,S,v,L,j,U,F,G,V,x,H){super(),this.syncResource=y,this.collection=O,this.G=S,this.H=v,this.I=L,this.J=j,this.L=U,this.M=F,this.N=G,this.O=V,this.P=x,this.c=null,this.m=$.SyncStatus.Idle,this.n=this.B(new T.$qe),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new T.$qe),this.onDidChangeConflicts=this.t.event,this.u=this.B(new a.$Ih(50)),this.w=this.B(new T.$qe),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(y.syncResource,y.profile),this.h=H.extUri,this.f=this.h.joinPath(v.userDataSyncHome,...(0,$.$Mpb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,$.$8pb),this.y=(0,$.$Npb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,v,this.h),this.j=(0,E.$uq)(v,S,L)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===$.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const O=await this.Y(y.remoteUserData,y.lastSyncUserData,!0,this.ob());this.S(O)}else{this.O.trace(`${this.D}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.ub(y):!0)&&this.w.fire()}}S(y){this.m!==y&&(this.m=y,this.n.fire(y))}async sync(y,O={}){await this.U(y,!0,this.ob(),O)}async preview(y,O,S={}){return this.U(y,!1,O,S)}async apply(y,O={}){try{this.F={...O};const S=await this.ab(y);return this.S(S),this.c}finally{this.F={}}}async U(y,O,S,v){try{if(this.F={...v},this.status===$.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===$.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S($.SyncStatus.Syncing);let L=$.SyncStatus.Idle;try{const j=await this.getLastSyncUserData(),U=await this.X(y,j);return L=await this.Y(U,j,O,S),L===$.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):L===$.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(L)}}finally{this.F={}}}async replace(y){const O=this.kb(y);if(!O)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S($.SyncStatus.Syncing);const S=await this.getLastSyncUserData(),v=await this.X(null,S),L=await this.W(v),j=await this.qb({ref:v.ref,syncData:O},S,L,this.ob(),k.CancellationToken.None),U=[];for(const F of j){const G=await this.sb(F,F.remoteResource,void 0,k.CancellationToken.None),{remoteChange:V}=await this.sb(F,F.previewResource,F.remoteContent,k.CancellationToken.None);U.push([F,{...G,remoteChange:V!==$.Change.None?V:$.Change.Modified}])}await this.tb(v,S,U,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S($.SyncStatus.Idle)}return!0}async W(y){const O=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===O}async X(y,O){if(O){const S=y?y[this.resource]:void 0;if(O.ref===S||S===void 0&&O.syncData===null)return O}return this.getRemoteUserData(O)}async Y(y,O,S,v){if(y.syncData&&y.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new $.$Upb((0,p.localize)(2443,null,this.resource,this.pb,y.syncData.version),$.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(y,O,S,v)}catch(L){if(L instanceof $.$Upb)switch(L.code){case $.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(y,O,S,v);case $.UserDataSyncErrorCode.Conflict:case $.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),O=await this.getLastSyncUserData(),this.Y(y,O,S,v)}throw L}}async Z(y,O,S,v){try{const L=await this.W(y),j=!L&&O===null&&this.gb()!==void 0,U=S&&!j;this.c||(this.c=(0,a.$xh)(G=>this.eb(y,O,L,U,v,G)));let F=await this.c;if(S&&j){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const G of F.resourcePreviews)F=await this.accept(G.remoteResource)||F}return this.cb(F.resourcePreviews),F.resourcePreviews.some(({mergeState:G})=>G===$.MergeState.Conflict)?$.SyncStatus.HasConflicts:S?await this.ab(!1):$.SyncStatus.Syncing}catch(L){throw this.c=null,L}}async merge(y){return await this.$(y,async O=>{const S=await this.rb(O,k.CancellationToken.None);await this.G.writeFile(O.previewResource,N.$Se.fromString(S?.content||""));const v=S&&!S.hasConflicts?await this.sb(O,O.previewResource,void 0,k.CancellationToken.None):void 0;return O.acceptResult=v,O.mergeState=S.hasConflicts?$.MergeState.Conflict:v?$.MergeState.Accepted:$.MergeState.Preview,O.localChange=v?v.localChange:S.localChange,O.remoteChange=v?v.remoteChange:S.remoteChange,O}),this.c}async accept(y,O){return await this.$(y,async S=>{const v=await this.sb(S,y,O,k.CancellationToken.None);return S.acceptResult=v,S.mergeState=$.MergeState.Accepted,S.localChange=v.localChange,S.remoteChange=v.remoteChange,S}),this.c}async discard(y){return await this.$(y,async O=>{const S=await this.rb(O,k.CancellationToken.None);return await this.G.writeFile(O.previewResource,N.$Se.fromString(S.content||"")),O.acceptResult=void 0,O.mergeState=$.MergeState.Preview,O.localChange=S.localChange,O.remoteChange=S.remoteChange,O}),this.c}async $(y,O){if(!this.c)return;let S=await this.c;const v=S.resourcePreviews.findIndex(({localResource:L,remoteResource:j,previewResource:U})=>this.h.isEqual(L,y)||this.h.isEqual(j,y)||this.h.isEqual(U,y));v!==-1&&(this.c=(0,a.$xh)(async L=>{const j=[...S.resourcePreviews];return j[v]=await O(j[v]),{...S,resourcePreviews:j}}),S=await this.c,this.cb(S.resourcePreviews),S.resourcePreviews.some(({mergeState:L})=>L===$.MergeState.Conflict)?this.S($.SyncStatus.HasConflicts):this.S($.SyncStatus.Syncing))}async ab(y){if(!this.c)return $.SyncStatus.Idle;const O=await this.c;return O.resourcePreviews.some(({mergeState:S})=>S===$.MergeState.Conflict)?$.SyncStatus.HasConflicts:O.resourcePreviews.some(({mergeState:S})=>S!==$.MergeState.Accepted)?$.SyncStatus.Syncing:(await this.tb(O.remoteUserData,O.lastSyncUserData,O.resourcePreviews.map(S=>[S,S.acceptResult]),y),this.c=null,await this.bb(),$.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(y){const O=y.filter(({mergeState:S})=>S===$.MergeState.Conflict);(0,I.$yb)(this.s,O,(S,v)=>this.h.isEqual(S.previewResource,v.previewResource))||(this.s=O,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async db(y){const O=this.c?await this.c:null;if(O)for(const S of O.resourcePreviews){if(this.h.isEqual(S.acceptedResource,y))return S.acceptResult?S.acceptResult.content:null;if(this.h.isEqual(S.remoteResource,y))return S.remoteContent;if(this.h.isEqual(S.localResource,y))return S.localContent;if(this.h.isEqual(S.baseResource,y))return S.baseContent}return null}async resetLocal(){this.I.remove(this.z,w.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(y){(0,l.$wl)(y)!==l.FileOperationResult.FILE_NOT_FOUND&&this.O.error(y)}}async eb(y,O,S,v,L,j){const U=await this.qb(y,O,S,L,j),F=[];for(const G of U){const V=G.previewResource.with({scheme:$.$7pb,authority:"accepted"});if(G.localChange===$.Change.None&&G.remoteChange===$.Change.None)F.push({...G,acceptedResource:V,acceptResult:{content:null,localChange:$.Change.None,remoteChange:$.Change.None},mergeState:$.MergeState.Accepted});else{const x=v?await this.rb(G,j):void 0;if(j.isCancellationRequested)break;await this.G.writeFile(G.previewResource,N.$Se.fromString(x?.content||""));const H=x&&!x.hasConflicts?await this.sb(G,G.previewResource,void 0,j):void 0;F.push({...G,acceptResult:H,mergeState:x?.hasConflicts?$.MergeState.Conflict:H?$.MergeState.Accepted:$.MergeState.Preview,localChange:H?H.localChange:x?x.localChange:G.localChange,remoteChange:H?H.remoteChange:x?x.remoteChange:G.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:O,resourcePreviews:F,isLastSyncFromCurrentMachine:S}}async getLastSyncUserData(){let y=this.gb();if(y||(y=await this.jb()),!y)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const O=JSON.parse(y),S=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!O.version&&!!S&&O.version!==S,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${O.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;let v,L=1;for(;v===void 0&&L++<6;)try{const j=await this.hb();j&&(j.ref===O.ref?v=j.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(j){if(j instanceof l.$Al&&j.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(j instanceof $.$Upb)throw j;this.O.error(j,L)}}if(v===void 0)try{const j=await this.J.resolveResourceContent(this.resource,O.ref,this.collection,this.F);v=j===null?null:this.kb(j),await this.ib({ref:O.ref,syncData:v})}catch(j){if(j instanceof $.$Upb&&j.code===$.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw j}return v===void 0?null:{...O,syncData:v}}async fb(y,O={}){if(O.ref||O.version)throw new Error("Cannot have core properties as additional");const S=this.M.getResourceSyncStateVersion(this.resource),v={ref:y.ref,version:S,...O};this.I.store(this.z,JSON.stringify(v),w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),await this.ib(y)}gb(){return this.I.get(this.z,w.StorageScope.APPLICATION)}async hb(){const y=(await this.G.readFile(this.y)).value.toString();try{const O=y?JSON.parse(y):void 0;if(h(O))return O}catch(O){this.O.error(O)}}async ib(y){await this.G.writeFile(this.y,N.$Se.fromString(JSON.stringify(y)))}async jb(){try{const y=await this.G.readFile(this.y),O=JSON.parse(y.value.toString());await this.G.del(this.y),O.ref&&O.content!==void 0?(this.I.store(this.z,JSON.stringify({...O,content:void 0}),w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),await this.ib({ref:O.ref,syncData:O.content===null?null:JSON.parse(O.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,O)}catch(y){y instanceof l.$Al&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(y)}return this.I.get(this.z,w.StorageScope.APPLICATION)}async getRemoteUserData(y){const{ref:O,content:S}=await this.lb(y);let v=null;return S!==null&&(v=this.kb(S)),{ref:O,syncData:v}}kb(y){try{const O=JSON.parse(y);if(i(O))return O}catch(O){this.O.error(O)}throw new $.$Upb((0,p.localize)(2444,null),$.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(y){const O=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.J.readResource(this.resource,O,this.collection,this.F)}async mb(y,O){const S=await this.j,v={version:this.pb,machineId:S,content:y};try{return O=await this.J.writeResource(this.resource,JSON.stringify(v),O,this.collection,this.F),{ref:O,syncData:v}}catch(L){throw L instanceof $.$Upb&&L.code===$.UserDataSyncErrorCode.TooLarge&&(L=new $.$Upb(L.message,L.code,this.resource)),L}}async nb(y){const O={version:this.pb,content:y};return this.L.writeResource(this.resource,JSON.stringify(O),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==$.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S($.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue($.$Hpb)}};e.$1Ob=t,e.$1Ob=t=Ee([Z(2,l.$fl),Z(3,f.$Ri),Z(4,w.$oq),Z(5,$.$Ppb),Z(6,$.$Qpb),Z(7,$.$Zpb),Z(8,d.$em),Z(9,$.$5pb),Z(10,m.$ej),Z(11,P.$Pl)],t);let s=class extends t{constructor(y,O,S,v,L,j,U,F,G,V,x,H,te){super(O,S,v,L,j,U,F,G,V,x,H,te),this.r=y,this.B(this.G.watch(this.h.dirname(y))),this.B(this.G.onDidFilesChange(z=>this.yb(z)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(y,O,S){try{O?await this.G.writeFile(this.r,N.$Se.fromString(y),S?void 0:O):await this.G.createFile(this.r,N.$Se.fromString(y),{overwrite:S})}catch(v){throw v instanceof l.$Al&&v.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||v instanceof l.$Al&&v.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new $.$Upb(v.message,$.UserDataSyncErrorCode.LocalPreconditionFailed):v}}async xb(){try{await this.G.del(this.r)}catch(y){if(!(y instanceof l.$Al&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw y}}yb(y){y.contains(this.r)&&this.Q()}};e.$2Ob=s,e.$2Ob=s=Ee([Z(3,l.$fl),Z(4,f.$Ri),Z(5,w.$oq),Z(6,$.$Ppb),Z(7,$.$Qpb),Z(8,$.$Zpb),Z(9,d.$em),Z(10,$.$5pb),Z(11,m.$ej),Z(12,P.$Pl)],s);let r=class extends s{constructor(y,O,S,v,L,j,U,F,G,V,x,H,te,z){super(y,O,S,v,L,j,U,F,G,V,x,te,z),this.zb=H,this.Bb=void 0}Ab(y,O){const S=[],v=(0,C.$5n)(y,S,{allowEmptyContent:!0,allowTrailingComma:!0});return S.length>0||!(0,R.$qg)(v)&&O!==Array.isArray(v)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$3Ob=r,e.$3Ob=r=Ee([Z(3,l.$fl),Z(4,f.$Ri),Z(5,w.$oq),Z(6,$.$Ppb),Z(7,$.$Qpb),Z(8,$.$Zpb),Z(9,d.$em),Z(10,$.$5pb),Z(11,$.$4pb),Z(12,m.$ej),Z(13,P.$Pl)],r);let o=class{constructor(y,O,S,v,L,j,U){this.resource=y,this.g=O,this.h=S,this.j=v,this.k=L,this.l=j,this.d=U.extUri,this.f=(0,$.$Npb)(void 0,this.resource,S,this.d)}async initialize({ref:y,content:O}){if(!O){this.j.info("Remote content does not exist.",this.resource);return}const S=this.m(O);if(S)try{await this.o({ref:y,syncData:S})}catch(v){this.j.error(v)}}m(y){try{const O=JSON.parse(y);if(i(O))return O}catch(O){this.j.error(O)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,O={}){if(O.ref||O.version)throw new Error("Cannot have core properties as additional");const S={ref:y.ref,version:void 0,...O};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(S),w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),await this.k.writeFile(this.f,N.$Se.fromString(JSON.stringify(y)))}};e.$4Ob=o,e.$4Ob=o=Ee([Z(1,c.$Rl),Z(2,f.$Ri),Z(3,g.$fk),Z(4,l.$fl),Z(5,w.$oq),Z(6,P.$Pl)],o)}),define(ue[121],de([0,1,6,25,8,3,45,2,26,21,15,120,27,35,86,34,7,4,77,11,16,18,28,19,40,208,116,24,62]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P,$,c,h,i,n,t,s,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=e.$lec=e.$kec=void 0,e.$iec=y,e.$jec=O;async function u(j,U){const F=JSON.parse(j.content);if(j.version===1||j.version===2){const G=(await U.getInstalled(g.ExtensionType.System)).filter(V=>V.isBuiltin);for(const V of F)j.version===1&&(V.enabled===!1&&(V.disabled=!0),delete V.enabled),j.version===2&&G.every(x=>!(0,f.$Sp)(x.identifier,V.identifier))&&(V.installed=!0)}return F}function y(j){return JSON.parse(j.content)}function O(j,U){return j.sort((F,G)=>!F.identifier.uuid&&G.identifier.uuid?-1:F.identifier.uuid&&!G.identifier.uuid?1:(0,A.$Df)(F.identifier.id,G.identifier.id)),U?(0,T.$co)(j,{}):JSON.stringify(j)}let S=class extends n.$1Ob{constructor(U,F,G,V,x,H,te,z,W,_,ne,le,ee,X,K,q,D){super({syncResource:r.SyncResource.Extensions,profile:U},F,V,G,x,H,te,le,ee,_,ne,K),this.Cb=z,this.Db=W,this.Eb=D,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$7pb,authority:"base"}),this.yb=this.wb.with({scheme:r.$7pb,authority:"local"}),this.zb=this.wb.with({scheme:r.$7pb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$7pb,authority:"accepted"}),this.Bb=this.Eb.createInstance(v),this.B(k.Event.any(k.Event.filter(this.Cb.onDidInstallExtensions,J=>J.some(({local:oe})=>!!oe)),k.Event.filter(this.Cb.onDidUninstallExtension,J=>!J.error),k.Event.filter(q.onDidChange,J=>J.valueChanges.some(({profile:oe,changes:Q})=>this.syncResource.profile.id===oe.id&&Q.some(Y=>Y.key===m.$vp))),X.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(U,F){const G=U.syncData?await u(U.syncData,this.Cb):null,V=F?.skippedExtensions??[],x=F?.builtinExtensions??null,H=F?.syncData?await u(F.syncData,this.Cb):null,{localExtensions:te,ignoredExtensions:z}=await this.Bb.getLocalExtensions(this.syncResource.profile);G?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:_}=(0,t.$hec)(te,G,H,V,z,x),ne={local:W,remote:_,content:this.Hb(te,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:_!==null?r.Change.Modified:r.Change.None},le=this.Ob(te,!1);return[{skippedExtensions:V,builtinExtensions:x,baseResource:this.xb,baseContent:H?this.Ob(H,!1):le,localResource:this.yb,localContent:le,localExtensions:te,remoteResource:this.zb,remoteExtensions:G,remoteContent:G?this.Ob(G,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(U){const F=U.syncData?await u(U.syncData,this.Cb):null,{localExtensions:G,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,t.$hec)(G,F,F,U.skippedExtensions||[],V,U.builtinExtensions||[]);return x!==null}Hb(U,F,G,V){const x=[...F,...G],H=new Set,te=z=>{H.add(z.id.toLowerCase()),z.uuid&&H.add(z.uuid)};x.forEach(({identifier:z})=>te(z)),V.forEach(te);for(const z of U)H.has(z.identifier.id.toLowerCase())||z.identifier.uuid&&H.has(z.identifier.uuid)||x.push(z);return this.Ob(x,!1)}async rb(U,F){return{...U.previewResult,hasConflicts:!1}}async sb(U,F,G,V){if(this.h.isEqual(F,this.yb))return this.Kb(U);if(this.h.isEqual(F,this.zb))return this.Lb(U);if(this.h.isEqual(F,this.wb))return U.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Kb(U){const F=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),G=this.Db.getIgnoredExtensions(F),V=(0,t.$hec)(U.localExtensions,null,null,U.skippedExtensions,G,U.builtinExtensions),{local:x,remote:H}=V;return{content:U.localContent,local:x,remote:H,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:H!==null?r.Change.Modified:r.Change.None}}async Lb(U){const F=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),G=this.Db.getIgnoredExtensions(F),V=U.remoteContent?JSON.parse(U.remoteContent):null;if(V!==null){const x=(0,t.$hec)(U.localExtensions,V,U.localExtensions,[],G,U.builtinExtensions),{local:H,remote:te}=x;return{content:U.remoteContent,local:H,remote:te,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:te!==null?r.Change.Modified:r.Change.None}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:r.Change.None,remoteChange:r.Change.None}}async tb(U,F,G,V){let{skippedExtensions:x,builtinExtensions:H,localExtensions:te}=G[0][0];const{local:z,remote:W,localChange:_,remoteChange:ne}=G[0][1];if(_===r.Change.None&&ne===r.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),_!==r.Change.None&&(await this.nb(JSON.stringify(te)),x=await this.Bb.updateLocalExtensions(z.added,z.removed,z.updated,x,this.syncResource.profile)),W){this.O.trace(`${this.D}: Updating remote extensions...`);const le=JSON.stringify(W.all);U=await this.mb(le,V?null:U.ref),this.O.info(`${this.D}: Updated remote extensions.${W.added.length?` Added: ${JSON.stringify(W.added.map(ee=>ee.identifier.id))}.`:""}${W.updated.length?` Updated: ${JSON.stringify(W.updated.map(ee=>ee.identifier.id))}.`:""}${W.removed.length?` Removed: ${JSON.stringify(W.removed.map(ee=>ee.identifier.id))}.`:""}`)}F?.ref!==U.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(te,H),await this.fb(U,{skippedExtensions:x,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(le=>le.identifier.id))}.`:""}`))}Nb(U,F){const G=new Set,V=[];for(const x of U)G.add(x.identifier.id.toLowerCase()),x.installed||V.push(x.identifier);if(F)for(const x of F)G.has(x.id.toLowerCase())||V.push(x);return V}async resolveContent(U){if(this.h.isEqual(this.zb,U)||this.h.isEqual(this.xb,U)||this.h.isEqual(this.yb,U)||this.h.isEqual(this.Ab,U)){const F=await this.db(U);return F&&this.Ob(JSON.parse(F),!0)}return null}Ob(U,F){return O(U,F)}async hasLocalData(){try{const{localExtensions:U}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(U.some(F=>F.installed||F.disabled))return!0}catch{}return!1}};e.$kec=S,e.$kec=S=Ee([Z(2,R.$Ri),Z(3,E.$fl),Z(4,$.$oq),Z(5,r.$Ppb),Z(6,r.$Qpb),Z(7,m.$up),Z(8,s.$TPb),Z(9,r.$5pb),Z(10,b.$ej),Z(11,r.$Zpb),Z(12,c.$em),Z(13,l.$zw),Z(14,h.$Pl),Z(15,o.$YNb),Z(16,w.$Ji)],S);let v=class{constructor(U,F,G,V,x,H){this.a=U,this.b=F,this.c=G,this.d=V,this.f=x,this.g=H}async getLocalExtensions(U){const F=await this.a.getInstalled(void 0,U.extensionsResource),G=this.d.getIgnoredExtensions(F);return{localExtensions:await this.j(U,async(x,H)=>{const te=x.getDisabledExtensions();return F.map(z=>{const{identifier:W,isBuiltin:_,manifest:ne,preRelease:le,pinned:ee,isApplicationScoped:X}=z,K={identifier:W,preRelease:le,version:ne.version,pinned:!!ee};X&&!(0,g.$An)(ne)&&(K.isApplicationScoped=X),te.some(q=>(0,f.$Sp)(q,W))&&(K.disabled=!0),_||(K.installed=!0);try{const q=H.getKeysForSync({id:W.id,version:ne.version});if(q){const D=H.getExtensionState(z,!0)||{};K.state=Object.keys(D).reduce((J,oe)=>(q.includes(oe)&&(J[oe]=D[oe]),J),{})}}catch(q){this.g.info(`${(0,n.$ZOb)(r.SyncResource.Extensions,U)}: Error while parsing extension state`,(0,N.$bb)(q))}return K})}),ignoredExtensions:G}}async updateLocalExtensions(U,F,G,V,x){const H=(0,n.$ZOb)(r.SyncResource.Extensions,x),te=[],z=new Map,W=[],_=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((U.length||G.length)&&await this.j(x,async(X,K)=>{await I.Promises.settled([...U,...G].map(async q=>{const D=ne.find(Q=>(0,f.$Sp)(Q.identifier,q.identifier));if(D&&D.isBuiltin){q.state&&D.manifest.version===q.version&&this.h(q.state,D,D.manifest.version,K),X.getDisabledExtensions().some(Y=>(0,f.$Sp)(Y,q.identifier))!==!!q.disabled&&(q.disabled?(this.g.trace(`${H}: Disabling extension...`,q.identifier.id),await X.disableExtension(q.identifier),this.g.info(`${H}: Disabled extension`,q.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,q.identifier.id),await X.enableExtension(q.identifier),this.g.info(`${H}: Enabled extension`,q.identifier.id))),W.push(q.identifier);return}const J=q.pinned?q.version:void 0,oe=(await this.c.getExtensions([{...q.identifier,version:J,preRelease:J?void 0:q.preRelease}],a.CancellationToken.None))[0];if(q.state&&(D?D.manifest.version===q.version:oe)&&this.h(q.state,D||oe,D?.manifest.version,K),oe)try{X.getDisabledExtensions().some(Y=>(0,f.$Sp)(Y,q.identifier))!==!!q.disabled&&(q.disabled?(this.g.trace(`${H}: Disabling extension...`,q.identifier.id,oe.version),await X.disableExtension(oe.identifier),this.g.info(`${H}: Disabled extension`,q.identifier.id,oe.version)):(this.g.trace(`${H}: Enabling extension...`,q.identifier.id,oe.version),await X.enableExtension(oe.identifier),this.g.info(`${H}: Enabled extension`,q.identifier.id,oe.version))),(!D||D.preRelease!==q.preRelease||D.pinned!==q.pinned||J&&D.manifest.version!==J)&&(await this.a.canInstall(oe)?(te.push({extension:oe,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:q.pinned&&!!q.version,pinned:q.pinned,installPreReleaseVersion:q.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:q.isApplicationScoped,context:{[m.$hp]:!0,[m.$ip]:m.ExtensionInstallSource.SETTINGS_SYNC}}}),z.set(oe.identifier.id.toLowerCase(),q)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,oe.displayName||oe.identifier.id),_.push(q)))}catch(Q){_.push(q),this.g.error(Q),this.g.info(`${H}: Skipped synchronizing extension`,oe.displayName||oe.identifier.id)}else _.push(q),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,q.identifier.id)}))}),F.length){const X=ne.filter(({identifier:K,isBuiltin:q})=>!q&&F.some(D=>(0,f.$Sp)(K,D)));await I.Promises.settled(X.map(async K=>{this.g.trace(`${H}: Uninstalling local extension...`,K.identifier.id),await this.a.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,K.identifier.id),W.push(K.identifier)}))}const le=await this.a.installGalleryExtensions(te);for(const{identifier:X,local:K,error:q,source:D}of le){const J=D;if(K)this.g.info(`${H}: Installed extension.`,X.id,J.version),W.push(X);else{const oe=z.get(X.id.toLowerCase());oe&&(_.push(oe),this.g.info(`${H}: Skipped synchronizing extension`,J.displayName||J.identifier.id)),q instanceof m.$tp&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatibleApi,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(q.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,J.displayName||J.identifier.id):q&&this.g.error(q)}}const ee=[];for(const X of V)W.some(K=>(0,f.$Sp)(K,X.identifier))||ee.push(X);for(const X of _)ee.some(K=>(0,f.$Sp)(K.identifier,X.identifier))||ee.push(X);return ee}h(U,F,G,V){const x=V.getExtensionState(F,!0)||{},H=G?V.getKeysForSync({id:F.identifier.id,version:G}):void 0;H?H.forEach(te=>{x[te]=U[te]}):Object.keys(U).forEach(te=>x[te]=U[te]),V.setExtensionState(F,x,!0)}async j(U,F){return this.b.withProfileScopedStorageService(U,async G=>{const V=new C.$Yc,x=V.add(this.f.createChild(new d.$Ii([$.$oq,G]))),H=V.add(x.createInstance(p.$kNb)),te=V.add(x.createInstance(l.$Aw));try{return await F(H,te)}finally{V.dispose()}})}};e.$lec=v,e.$lec=v=Ee([Z(0,m.$up),Z(1,o.$YNb),Z(2,m.$rp),Z(3,s.$TPb),Z(4,w.$Ji),Z(5,r.$5pb)],v);let L=class extends n.$4Ob{constructor(U,F,G,V,x,H,te,z){super(r.SyncResource.Extensions,V,x,H,G,te,z),this.p=U,this.q=F}async t(U){return U.syncData?await u(U.syncData,this.p):null}u(U,F){const G=[],V=[],x=[];for(const H of U){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const te=F.find(z=>(0,f.$Sp)(z.identifier,H.identifier));te?(G.push(te),H.disabled&&x.push(H.identifier)):H.installed&&(V.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&x.push(H.identifier))}return{installedExtensions:G,newExtensions:V,disabledExtensions:x,remoteExtensions:U}}};e.$mec=L,e.$mec=L=Ee([Z(0,m.$up),Z(1,s.$TPb),Z(2,E.$fl),Z(3,i.$Rl),Z(4,R.$Ri),Z(5,P.$fk),Z(6,$.$oq),Z(7,h.$Pl)],L)}),define(ue[122],de([0,1,14,8,3,36,45,5,32,21,15,7,11,49,16,18,28,40,82,212,24,19,62,4]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P,$,c,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Ob=e.$9Ob=e.$8Ob=e.$7Ob=void 0,e.$6Ob=s;const n="globalState.argv.",t=["locale"];function s(S,v){const L=S.storage?Object.keys(S.storage).sort():[],j={};return L.forEach(U=>j[U]=S.storage[U]),S.storage=j,v?(0,T.$co)(S,{}):JSON.stringify(S)}const r=1;let o=class extends w.$1Ob{constructor(v,L,j,U,F,G,V,x,H,te,z,W,_,ne){super({syncResource:$.SyncResource.GlobalState,profile:v},L,U,x,W,F,G,H,te,V,z,_),this.Bb=j,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:$.$7pb,authority:"base"}),this.xb=this.vb.with({scheme:$.$7pb,authority:"local"}),this.yb=this.vb.with({scheme:$.$7pb,authority:"remote"}),this.zb=this.vb.with({scheme:$.$7pb,authority:"accepted"}),this.Ab=ne.createInstance(u),this.B(U.watch(this.h.dirname(this.H.argvResource))),this.B(N.Event.any(N.Event.filter(U.onDidFilesChange,le=>le.contains(this.H.argvResource)),N.Event.filter(j.onDidChange,le=>!!(le.targetChanges.some(ee=>this.syncResource.profile.id===ee.id)||le.valueChanges.some(({profile:ee,changes:X})=>this.syncResource.profile.id===ee.id&&X.some(K=>K.target===l.StorageTarget.USER)))))(()=>this.Q()))}async qb(v,L,j){const U=v.syncData?JSON.parse(v.syncData.content):null;L=L===null&&j?v:L;const F=L&&L.syncData?JSON.parse(L.syncData.content):null,G=await this.Ab.getLocalGlobalState(this.syncResource.profile);U?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const V=await this.Jb(F),{local:x,remote:H}=(0,P.$5Ob)(G.storage,U?U.storage:null,F?F.storage:null,V,this.O),te={content:null,local:x,remote:H,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?$.Change.Modified:$.Change.None,remoteChange:H.all!==null?$.Change.Modified:$.Change.None},z=s(G,!1);return[{baseResource:this.wb,baseContent:F?s(F,!1):z,localResource:this.xb,localContent:z,localUserData:G,remoteResource:this.yb,remoteContent:U?s(U,!1):null,previewResource:this.vb,previewResult:te,localChange:te.localChange,remoteChange:te.remoteChange,acceptedResource:this.zb,storageKeys:V}]}async ub(v){const L=v.syncData?JSON.parse(v.syncData.content):null;if(L===null)return!0;const j=await this.Ab.getLocalGlobalState(this.syncResource.profile),U=await this.Jb(L),{remote:F}=(0,P.$5Ob)(j.storage,L.storage,L.storage,U,this.O);return F.all!==null}async rb(v,L){return{...v.previewResult,hasConflicts:!1}}async sb(v,L,j,U){if(this.h.isEqual(L,this.xb))return this.Gb(v);if(this.h.isEqual(L,this.yb))return this.Hb(v);if(this.h.isEqual(L,this.vb))return v.previewResult;throw new Error(`Invalid Resource: ${L.toString()}`)}async Gb(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(v.localUserData.storage),removed:[],updated:[],all:v.localUserData.storage},localChange:$.Change.None,remoteChange:$.Change.Modified}}async Hb(v){if(v.remoteContent!==null){const L=JSON.parse(v.remoteContent),{local:j,remote:U}=(0,P.$5Ob)(v.localUserData.storage,L.storage,null,v.storageKeys,this.O);return{content:v.remoteContent,local:j,remote:U,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?$.Change.Modified:$.Change.None,remoteChange:U!==null?$.Change.Modified:$.Change.None}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:$.Change.None,remoteChange:$.Change.None}}async tb(v,L,j,U){const{localUserData:F}=j[0][0],{local:G,remote:V,localChange:x,remoteChange:H}=j[0][1];if(x===$.Change.None&&H===$.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==$.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(F)),await this.Ab.writeLocalGlobalState(G,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==$.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const te=JSON.stringify({storage:V.all});v=await this.mb(te,U?null:v.ref),this.O.info(`${this.D}: Updated remote ui state.${V.added.length?` Added: ${V.added}.`:""}${V.updated.length?` Updated: ${V.updated}.`:""}${V.removed.length?` Removed: ${V.removed}.`:""}`)}L?.ref!==v.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(v),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(v){if(this.h.isEqual(this.yb,v)||this.h.isEqual(this.wb,v)||this.h.isEqual(this.xb,v)||this.h.isEqual(this.zb,v)){const L=await this.db(v);return L&&s(JSON.parse(L),!0)}return null}async hasLocalData(){try{const{storage:v}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(v).length>1||v[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(v){const L=await this.Bb.readStorageData(this.syncResource.profile),j=[],U=[];for(const[V,x]of L)x.target===l.StorageTarget.USER?j.push(V):x.target===l.StorageTarget.MACHINE&&U.push(V);const F=[...j,...U],G=v?.storage?Object.keys(v.storage).filter(V=>!V.startsWith(n)&&!F.includes(V)&&L.get(V)!==void 0):[];if(!C.$r){const V=[...$.$Lpb.map(x=>(0,$.$Ypb)(x)),$.$Xpb];G.push(...V),U.push(...V)}return{user:j,machine:U,unregistered:G}}};e.$7Ob=o,e.$7Ob=o=Ee([Z(2,h.$YNb),Z(3,p.$fl),Z(4,$.$Ppb),Z(5,$.$Qpb),Z(6,$.$5pb),Z(7,R.$Ri),Z(8,$.$Zpb),Z(9,g.$em),Z(10,b.$ej),Z(11,l.$oq),Z(12,E.$Pl),Z(13,i.$Ji)],o);let u=class{constructor(v,L,j,U){this.a=v,this.b=L,this.c=j,this.d=U}async getLocalGlobalState(v){const L={};if(v.isDefault){const U=await this.f(),F=(0,k.$5n)(U);for(const G of t)F[G]!==void 0&&(L[`${n}${G}`]={version:1,value:F[G]})}const j=await this.c.readStorageData(v);for(const[U,F]of j)F.value&&F.target===l.StorageTarget.USER&&(L[U]={version:1,value:F.value});return{storage:L}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const v=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),v.value.toString()}catch(v){this.d.debug((0,a.$bb)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:L,updated:j},U){const F=(0,w.$ZOb)($.SyncResource.GlobalState,U),G={},V=new Map,x=await this.c.readStorageData(U),H=(te,z)=>{for(const W of te){if(W.startsWith(n)){G[W.substring(n.length)]=z?z[W].value:void 0;continue}if(z){const _=z[W];_.value!==x.get(W)?.value&&V.set(W,_.value)}else x.get(W)!==void 0&&V.set(W,void 0)}};if(H(Object.keys(v),v),H(Object.keys(j),j),H(L),Object.keys(G).length){this.d.trace(`${F}: Updating locale...`);const te=await this.f();let z=te;for(const W of Object.keys(G))z=(0,d.edit)(z,[W],G[W],{});te!==z&&(this.d.trace(`${F}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$Se.fromString(z)),this.d.info(`${F}: Updated locale.`)),this.d.info(`${F}: Updated locale`)}V.size&&(this.d.trace(`${F}: Updating global state...`),await this.c.updateStorageData(U,V,l.StorageTarget.USER),this.d.info(`${F}: Updated global state`,[...V.keys()]))}};e.$8Ob=u,e.$8Ob=u=Ee([Z(0,p.$fl),Z(1,R.$Ri),Z(2,h.$YNb),Z(3,$.$5pb)],u);let y=class extends w.$4Ob{constructor(v,L,j,U,F,G){super($.SyncResource.GlobalState,j,U,F,L,v,G)}async o(v){const L=v.syncData?JSON.parse(v.syncData.content):null;if(!L){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const j={},U={};for(const F of Object.keys(L.storage))F.startsWith(n)?j[F.substring(n.length)]=L.storage[F].value:this.l.get(F,l.StorageScope.PROFILE)===void 0&&(U[F]=L.storage[F].value);if(Object.keys(j).length){let F="{}";try{F=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const G of Object.keys(j))F=(0,d.edit)(F,[G],j[G],{});await this.k.writeFile(this.h.argvResource,I.$Se.fromString(F))}if(Object.keys(U).length){const F=[];for(const G of Object.keys(U))F.push({key:G,value:U[G],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.l.storeAll(F,!0)}}};e.$9Ob=y,e.$9Ob=y=Ee([Z(0,l.$oq),Z(1,p.$fl),Z(2,c.$Rl),Z(3,R.$Ri),Z(4,$.$5pb),Z(5,E.$Pl)],y);let O=class{constructor(v,L,j,U,F){this.a=v,this.b=L,this.c=j,this.d=U,this.f=F}getSyncStoreType(v){return this.h(v)?.storage[$.$Xpb]?.value}async sync(v){const L=(0,$.$Tpb)((0,A.$7g)());try{return await this.g(v,L)}catch(j){if(j instanceof $.$Upb)switch(j.code){case $.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(v,L)}throw j}}async g(v,L){const j=await this.a.readResource($.SyncResource.GlobalState,null,void 0,L),U=this.h(j)||{storage:{}};U.storage[$.$Xpb]={value:v,version:r};const F=await(0,f.$uq)(this.c,this.d,this.b),G={version:r,machineId:F,content:s(U,!1)};await this.a.writeResource($.SyncResource.GlobalState,JSON.stringify(G),j.ref,void 0,L)}h({content:v}){if(!v)return null;const L=JSON.parse(v);if((0,w.$YOb)(L))return L?JSON.parse(L.content):null;throw new Error("Invalid remote data")}};e.$0Ob=O,e.$0Ob=O=Ee([Z(1,l.$oq),Z(2,R.$Ri),Z(3,p.$fl),Z(4,m.$fk)],O)}),define(ue[123],de([0,1,17,14,3,36,5,12,9,21,15,7,16,18,28,19,40,209,24]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=e.$pec=void 0,e.$oec=P;function P(h,i,n){try{const t=JSON.parse(h);if(!i)return(0,C.$qg)(t.all)?null:t.all;switch(T.OS){case T.OperatingSystem.Macintosh:return(0,C.$qg)(t.mac)?null:t.mac;case T.OperatingSystem.Linux:return(0,C.$qg)(t.linux)?null:t.linux;case T.OperatingSystem.Windows:return(0,C.$qg)(t.windows)?null:t.windows}}catch(t){return n.error(t),null}}let $=class extends E.$3Ob{constructor(i,n,t,s,r,o,u,y,O,S,v,L,j){super(i.keybindingsResource,{syncResource:d.SyncResource.Keybindings,profile:i},n,y,O,S,t,s,u,L,r,v,o,j),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:d.$7pb,authority:"base"}),this.Gb=this.Eb.with({scheme:d.$7pb,authority:"local"}),this.Hb=this.Eb.with({scheme:d.$7pb,authority:"remote"}),this.Ib=this.Eb.with({scheme:d.$7pb,authority:"accepted"}),this.B(N.Event.filter(o.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(i,n,t,s){const r=i.syncData?P(i.syncData.content,s.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&t?i:n;const o=n?this.Ob(n):null,u=await this.vb(),y=await this.Cb();let O=null,S=!1,v=!1,L=!1;if(r){let F=u?u.value.toString():"[]";if(F=F||"[]",this.Ab(F,!0))throw new d.$Upb((0,A.localize)(2445,null),d.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!o||o!==F||o!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const G=await(0,w.$nec)(F,r,o,y,this.zb);G.hasChanges&&(O=G.mergeContent,L=G.hasConflicts,S=L||G.mergeContent!==F,v=L||G.mergeContent!==r)}}else u&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),O=u.value.toString(),v=!0);const j={content:L?o:O,localChange:S?u?d.Change.Modified:d.Change.Added:d.Change.None,remoteChange:v?d.Change.Modified:d.Change.None,hasConflicts:L},U=u?u.value.toString():null;return[{fileContent:u,baseResource:this.Fb,baseContent:o,localResource:this.Gb,localContent:U,localChange:j.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:j.remoteChange,previewResource:this.Eb,previewResult:j,acceptedResource:this.Ib}]}async ub(i){const n=this.Ob(i);if(n===null)return!0;const t=await this.vb(),s=t?t.value.toString():"",r=await this.Cb(),o=await(0,w.$nec)(s||"[]",n,n,r,this.zb);return o.hasConflicts||o.mergeContent!==n}async rb(i,n){return i.previewResult}async sb(i,n,t,s){if(this.h.isEqual(n,this.Gb))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:d.Change.None,remoteChange:d.Change.Modified};if(this.h.isEqual(n,this.Hb))return{content:i.remoteContent,localChange:d.Change.Modified,remoteChange:d.Change.None};if(this.h.isEqual(n,this.Eb))return t===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:t,localChange:d.Change.Modified,remoteChange:d.Change.Modified};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(i,n,t,s){const{fileContent:r}=t[0][0];let{content:o,localChange:u,remoteChange:y}=t[0][1];if(u===d.Change.None&&y===d.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.Ab(o,!0)))throw new d.$Upb((0,A.localize)(2446,null),d.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(u!==d.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(o||"[]",r,s),this.O.info(`${this.D}: Updated local keybindings`)),y!==d.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const O=this.Pb(o||"[]",i.syncData?.content);i=await this.mb(O,s?null:i.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(i,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.vb();if(i){const n=(0,k.$5n)(i.value.toString());if((0,I.$Pb)(n))return!0}}catch(i){if(i.fileOperationResult!==p.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.Hb,i)||this.h.isEqual(this.Fb,i)||this.h.isEqual(this.Gb,i)||this.h.isEqual(this.Ib,i)?this.db(i):null}Ob(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.Qb()?null:P(i.syncData.content,this.Qb(),this.O)}Pb(i,n){let t={};try{t=JSON.parse(n||"{}")}catch(s){this.O.error(s)}switch(this.Qb()?delete t.all:t.all=i,T.OS){case T.OperatingSystem.Macintosh:t.mac=i;break;case T.OperatingSystem.Linux:t.linux=i;break;case T.OperatingSystem.Windows:t.windows=i;break}return JSON.stringify(t)}Qb(){return!!this.P.getValue(d.$Ipb)}};e.$pec=$,e.$pec=$=Ee([Z(2,d.$Ppb),Z(3,d.$Qpb),Z(4,d.$5pb),Z(5,b.$ej),Z(6,d.$Zpb),Z(7,p.$fl),Z(8,R.$Ri),Z(9,m.$oq),Z(10,d.$4pb),Z(11,f.$em),Z(12,l.$Pl)],$);let c=class extends E.$4Ob{constructor(i,n,t,s,r,o){super(d.SyncResource.Keybindings,n,t,s,i,r,o)}async o(i){const n=i.syncData?this.p(i.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,a.$Se.fromString(n)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,k.$5n)(i.value.toString());return!(0,I.$Pb)(n)}catch(i){return i.fileOperationResult===p.FileOperationResult.FILE_NOT_FOUND}}p(i){try{return P(i,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$qec=c,e.$qec=c=Ee([Z(0,p.$fl),Z(1,g.$Rl),Z(2,R.$Ri),Z(3,d.$5pb),Z(4,m.$oq),Z(5,l.$Pl)],c)}),define(ue[124],de([0,1,17,14,3,9,21,78,15,27,34,7,16,18,28,19,40,213,24]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=e.$sec=void 0,e.$rec=$;function P(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function $(i){const n=JSON.parse(i);return P(n)?n:{settings:i}}let c=class extends E.$3Ob{constructor(n,t,s,r,o,u,y,O,S,v,L,j,U,F){super(n.settingsResource,{syncResource:d.SyncResource.Settings,profile:n},t,s,r,o,u,y,L,j,O,S,v,F),this.Eb=n,this.Fb=U,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:d.$7pb,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.$7pb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.$7pb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.$7pb,authority:"accepted"}),this.Pb=void 0,this.Qb=void 0,this.Rb=void 0}async getRemoteUserDataSyncConfiguration(n){const t=await this.getLastSyncUserData(),s=await this.X(n,t),r=this.Mb(s),o=new C.$Vo(d.$Hpb,this.O);return r?.settings&&o.parse(r.settings),o.configurationModel.getValue(d.$Hpb)||{}}async qb(n,t,s){const r=await this.vb(),o=await this.Cb(),u=this.Mb(n);t=t===null&&s?n:t;const y=t?this.Mb(t):null,O=await this.Sb();let S=null,v=!1,L=!1,j=!1;if(u){let V=r?r.value.toString().trim():"{}";V=V||"{}",this.Vb(V),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const x=(0,w.$FNb)(V,u.settings,y?y.settings:null,O,[],o);S=x.localContent||x.remoteContent,v=x.localContent!==null,L=x.remoteContent!==null,j=x.hasConflicts}else r&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),S=r.value.toString().trim()||"{}",this.Vb(S),L=!0);const U=r?r.value.toString():null,F=y?.settings??null,G={content:j?F:S,localChange:v?d.Change.Modified:d.Change.None,remoteChange:L?d.Change.Modified:d.Change.None,hasConflicts:j};return[{fileContent:r,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:U,localChange:G.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:G.remoteChange,previewResource:this.previewResource,previewResult:G,acceptedResource:this.acceptedResource}]}async ub(n){const t=this.Mb(n);if(t===null)return!0;const s=await this.vb(),r=s?s.value.toString().trim():"",o=await this.Sb(),u=await this.Cb();return(0,w.$FNb)(r||"{}",t.settings,t.settings,o,[],u).remoteContent!==null}async rb(n,t){const s=await this.Cb(),r=await this.Sb();return{...n.previewResult,content:n.previewResult.content?(0,w.$ENb)(n.previewResult.content,"{}",r,s):null}}async sb(n,t,s,r){const o=await this.Cb(),u=await this.Sb();if(this.h.isEqual(t,this.localResource))return{content:n.fileContent?(0,w.$ENb)(n.fileContent.value.toString(),"{}",u,o):null,localChange:d.Change.None,remoteChange:d.Change.Modified};if(this.h.isEqual(t,this.remoteResource))return{content:n.remoteContent!==null?(0,w.$ENb)(n.remoteContent,n.fileContent?n.fileContent.value.toString():"{}",u,o):null,localChange:d.Change.Modified,remoteChange:d.Change.None};if(this.h.isEqual(t,this.previewResource))return s===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:s!==null?(0,w.$ENb)(s,n.fileContent?n.fileContent.value.toString():"{}",u,o):null,localChange:d.Change.Modified,remoteChange:d.Change.Modified};throw new Error(`Invalid Resource: ${t.toString()}`)}async tb(n,t,s,r){const{fileContent:o}=s[0][0];let{content:u,localChange:y,remoteChange:O}=s[0][1];if(y===d.Change.None&&O===d.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.Vb(u),y!==d.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),o&&await this.nb(JSON.stringify(this.Ob(o.value.toString()))),await this.wb(u,o,r),await this.P.reloadConfiguration(T.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),O!==d.Change.None){const S=await this.Cb(),v=this.Mb(n),L=await this.Sb(u);u=(0,w.$ENb)(u,v?v.settings:"{}",L,S),this.O.trace(`${this.D}: Updating remote settings...`),n=await this.mb(JSON.stringify(this.Ob(u)),r?null:n.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}t?.ref!==n.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(n),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const n=await this.vb();if(n)return!(0,w.$GNb)(n.value.toString())}catch(n){if(n.fileOperationResult!==p.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(n){return this.h.isEqual(this.remoteResource,n)||this.h.isEqual(this.localResource,n)||this.h.isEqual(this.acceptedResource,n)||this.h.isEqual(this.baseResource,n)?this.db(n):null}async db(n){let t=await super.db(n);if(t){const s=await this.Cb(),r=await this.Sb();t=(0,w.$ENb)(t,"{}",r,s)}return t}Mb(n){return n.syncData?this.Nb(n.syncData.content):null}Nb(n){try{return $(n)}catch(t){this.O.error(t)}return null}Ob(n){return{settings:n}}async Sb(n){if(this.Pb||(this.Pb=this.zb.resolveDefaultCoreIgnoredSettings()),this.Qb||(this.Qb=this.Tb()),!this.Rb){this.Rb=this.Ub();const s=this.B(N.Event.any(N.Event.filter(this.Fb.onDidInstallExtensions,r=>r.some(({local:o})=>!!o)),N.Event.filter(this.Fb.onDidUninstallExtension,r=>!r.error))(()=>{s.dispose(),this.Rb=void 0}))}const t=(await Promise.all([this.Pb,this.Qb,this.Rb])).flat();return(0,w.$CNb)(t,this.P,n)}async Tb(){const n=await this.Fb.getInstalled(R.ExtensionType.System);return(0,I.$Qb)(n.map(t=>(0,d.$Gpb)(t.manifest)).flat())}async Ub(){const n=await this.Fb.getInstalled(R.ExtensionType.User,this.Eb.extensionsResource);return(0,I.$Qb)(n.map(t=>(0,d.$Gpb)(t.manifest)).flat())}Vb(n){if(this.Ab(n,!1))throw new d.$Upb((0,k.localize)(2447,null),d.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$sec=c,e.$sec=c=Ee([Z(2,p.$fl),Z(3,A.$Ri),Z(4,m.$oq),Z(5,d.$Ppb),Z(6,d.$Qpb),Z(7,d.$5pb),Z(8,d.$4pb),Z(9,T.$ej),Z(10,d.$Zpb),Z(11,f.$em),Z(12,b.$up),Z(13,l.$Pl)],c);let h=class extends E.$4Ob{constructor(n,t,s,r,o,u){super(d.SyncResource.Settings,t,s,r,n,o,u)}async o(n){const t=n.syncData?this.p(n.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,a.$Se.fromString(t.settings)),await this.n(n)}async i(){try{const n=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,w.$GNb)(n.value.toString().trim())}catch(n){return n.fileOperationResult===p.FileOperationResult.FILE_NOT_FOUND}}p(n){try{return $(n)}catch(t){this.j.error(t)}return null}};e.$tec=h,e.$tec=h=Ee([Z(0,p.$fl),Z(1,g.$Rl),Z(2,A.$Ri),Z(3,d.$5pb),Z(4,m.$oq),Z(5,l.$Pl)],h)}),define(ue[125],de([0,1,14,3,29,21,15,7,16,18,28,19,40,210,24]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=e.$xec=void 0,e.$wec=g;function g(d){return JSON.parse(d.content)}let E=class extends m.$1Ob{constructor(P,$,c,h,i,n,t,s,r,o,u,y){super({syncResource:l.SyncResource.Snippets,profile:P},$,h,c,i,n,t,o,u,s,r,y),this.pb=1,this.vb=P.snippetsHome,this.B(this.G.watch(c.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(a.Event.filter(this.G.onDidFilesChange,O=>O.affects(this.vb))(()=>this.Q()))}async qb(P,$,c){const h=await this.Hb(),i=this.Gb(h),n=P.syncData?this.Fb(P.syncData):null;$=$===null&&c?P:$;const t=$&&$.syncData?this.Fb($.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,f.$uec)(i,n,t);return this.Bb(s,h,n||{},t||{})}async ub(P){const $=P.syncData?this.Fb(P.syncData):null;if($===null)return!0;const c=await this.Hb(),h=this.Gb(c),i=(0,f.$uec)(h,$,$);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async rb(P,$){return P.previewResult}async sb(P,$,c,h){if(this.h.isEqualOrParent($,this.g.with({scheme:l.$7pb,authority:"local"})))return{content:P.fileContent?P.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:P.fileContent?P.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.h.isEqualOrParent($,this.g.with({scheme:l.$7pb,authority:"remote"})))return{content:P.remoteContent,localChange:P.remoteContent!==null?P.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.h.isEqualOrParent($,this.g))return c===void 0?{content:P.previewResult.content,localChange:P.previewResult.localChange,remoteChange:P.previewResult.remoteChange}:{content:c,localChange:c===null?P.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:c===null?P.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${$.toString()}`)}async tb(P,$,c,h){const i=c.map(([n,t])=>({...n,acceptResult:t}));i.every(({localChange:n,remoteChange:t})=>n===l.Change.None&&t===l.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),i.some(({localChange:n})=>n!==l.Change.None)&&(await this.Cb(i),await this.Db(i,h)),i.some(({remoteChange:n})=>n!==l.Change.None)&&(P=await this.Eb(i,P,h)),$?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of i)try{await this.G.del(n)}catch{}}Bb(P,$,c,h){const i=new Map;for(const n of Object.keys(P.local.added)){const t={content:P.local.added[n],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"accepted"})})}for(const n of Object.keys(P.local.updated)){const t={content:P.local.updated[n],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"local"}),fileContent:$[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"accepted"})})}for(const n of P.local.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"local"}),fileContent:$[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"accepted"})})}for(const n of Object.keys(P.remote.added)){const t={content:P.remote.added[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"local"}),fileContent:$[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"accepted"})})}for(const n of Object.keys(P.remote.updated)){const t={content:P.remote.updated[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"local"}),fileContent:$[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"accepted"})})}for(const n of P.remote.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"accepted"})})}for(const n of P.conflicts){const t={content:h[n]??null,hasConflicts:!0,localChange:$[n]?l.Change.Modified:l.Change.Added,remoteChange:c[n]?l.Change.Modified:l.Change.Added},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"local"}),fileContent:$[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"remote"}),remoteContent:c[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"accepted"})})}for(const n of Object.keys($))if(!i.has(n)){const t={content:$[n]?$[n].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"local"}),fileContent:$[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"remote"}),remoteContent:c[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$7pb,authority:"accepted"})})}return[...i.values()]}async resolveContent(P){return this.h.isEqualOrParent(P,this.g.with({scheme:l.$7pb,authority:"remote"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$7pb,authority:"local"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$7pb,authority:"base"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$7pb,authority:"accepted"}))?this.db(P):null}async hasLocalData(){try{const P=await this.Hb();if(Object.keys(P).length)return!0}catch{}return!1}async Cb(P){const $={};for(const c of P)c.fileContent&&($[this.h.basename(c.localResource)]=c.fileContent);await this.nb(JSON.stringify(this.Gb($)))}async Db(P,$){for(const{fileContent:c,acceptResult:h,localResource:i,remoteResource:n,localChange:t}of P)if(t!==l.Change.None){const s=n?this.h.basename(n):this.h.basename(i),r=this.h.joinPath(this.vb,s);t===l.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):t===l.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,I.$Se.fromString(h.content),{overwrite:$}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,I.$Se.fromString(h.content),$?void 0:c),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(P,$,c){const h=$.syncData?this.Fb($.syncData):{},i=(0,N.$ko)(h);for(const{acceptResult:n,localResource:t,remoteResource:s,remoteChange:r}of P)if(r!==l.Change.None){const o=t?this.h.basename(t):this.h.basename(s);r===l.Change.Deleted?delete i[o]:i[o]=n.content}return(0,f.$vec)(h,i)||(this.O.trace(`${this.D}: Updating remote snippets...`),$=await this.mb(JSON.stringify(i),c?null:$.ref),this.O.info(`${this.D}: Updated remote snippets`)),$}Fb(P){return g(P)}Gb(P){const $={};for(const c of Object.keys(P))$[c]=P[c].value.toString();return $}async Hb(){const P={};let $;try{$=await this.G.resolve(this.vb)}catch(c){if(c instanceof C.$Al&&c.fileOperationResult===C.FileOperationResult.FILE_NOT_FOUND)return P;throw c}for(const c of $.children||[]){const h=c.resource,i=this.h.extname(h);if(i===".json"||i===".code-snippets"){const n=this.h.relativePath(this.vb,h),t=await this.G.readFile(h);P[n]=t}}return P}};e.$xec=E,e.$xec=E=Ee([Z(2,T.$Ri),Z(3,C.$fl),Z(4,A.$oq),Z(5,l.$Ppb),Z(6,l.$Qpb),Z(7,l.$5pb),Z(8,k.$ej),Z(9,l.$Zpb),Z(10,b.$em),Z(11,R.$Pl)],E);let w=class extends m.$4Ob{constructor(P,$,c,h,i,n){super(l.SyncResource.Snippets,$,c,h,P,i,n)}async o(P){const $=P.syncData?JSON.parse(P.syncData.content):null;if(!$){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const h of Object.keys($)){const i=$[h];if(i){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,h);await this.k.createFile(n,I.$Se.fromString(i)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(P)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(P){return P.fileOperationResult===C.FileOperationResult.FILE_NOT_FOUND}}};e.$yec=w,e.$yec=w=Ee([Z(0,C.$fl),Z(1,p.$Rl),Z(2,T.$Ri),Z(3,l.$5pb),Z(4,A.$oq),Z(5,R.$Pl)],w)}),define(ue[126],de([0,1,14,21,15,7,16,18,28,19,40,24]),function(ce,e,I,a,N,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=e.$Aec=void 0,e.$zec=m;function m(E,w){try{return JSON.parse(E).tasks??null}catch(d){return w.error(d),null}}let f=class extends R.$2Ob{constructor(w,d,P,$,c,h,i,n,t,s,r,o){super(w.tasksResource,{syncResource:p.SyncResource.Tasks,profile:w},d,n,t,s,P,$,i,r,c,h,o),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:p.$7pb,authority:"base"}),this.Cb=this.Ab.with({scheme:p.$7pb,authority:"local"}),this.Db=this.Ab.with({scheme:p.$7pb,authority:"remote"}),this.Eb=this.Ab.with({scheme:p.$7pb,authority:"accepted"})}async qb(w,d,P,$){const c=w.syncData?m(w.syncData.content,this.O):null;d=d===null&&P?w:d;const h=d?.syncData?m(d.syncData.content,this.O):null,i=await this.vb();let n=null,t=!1,s=!1,r=!1;if(w.syncData){const y=i?i.value.toString():null;if(!h||h!==y||h!==c){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const O=g(y,c,h);n=O.content,r=O.hasConflicts,t=O.hasLocalChanged,s=O.hasRemoteChanged}}else i&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=i.value.toString(),s=!0);const o={content:r?h:n,localChange:t?i?p.Change.Modified:p.Change.Added:p.Change.None,remoteChange:s?p.Change.Modified:p.Change.None,hasConflicts:r},u=i?i.value.toString():null;return[{fileContent:i,baseResource:this.Bb,baseContent:h,localResource:this.Cb,localContent:u,localChange:o.localChange,remoteResource:this.Db,remoteContent:c,remoteChange:o.remoteChange,previewResource:this.Ab,previewResult:o,acceptedResource:this.Eb}]}async ub(w){const d=w?.syncData?m(w.syncData.content,this.O):null;if(d===null)return!0;const P=await this.vb(),$=P?P.value.toString():null,c=g($,d,d);return c.hasLocalChanged||c.hasRemoteChanged}async rb(w,d){return w.previewResult}async sb(w,d,P,$){if(this.h.isEqual(d,this.Cb))return{content:w.fileContent?w.fileContent.value.toString():null,localChange:p.Change.None,remoteChange:p.Change.Modified};if(this.h.isEqual(d,this.Db))return{content:w.remoteContent,localChange:p.Change.Modified,remoteChange:p.Change.None};if(this.h.isEqual(d,this.Ab))return P===void 0?{content:w.previewResult.content,localChange:w.previewResult.localChange,remoteChange:w.previewResult.remoteChange}:{content:P,localChange:p.Change.Modified,remoteChange:p.Change.Modified};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(w,d,P,$){const{fileContent:c}=P[0][0],{content:h,localChange:i,remoteChange:n}=P[0][1];if(i===p.Change.None&&n===p.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),i!==p.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),c&&await this.nb(JSON.stringify(this.Kb(c.value.toString()))),h?await this.wb(h,c,$):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==p.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const t=JSON.stringify(this.Kb(h));w=await this.mb(t,$?null:w.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}d?.ref!==w.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(w),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(w){return this.h.isEqual(this.Db,w)||this.h.isEqual(this.Bb,w)||this.h.isEqual(this.Cb,w)||this.h.isEqual(this.Eb,w)?this.db(w):null}Kb(w){return w?{tasks:w}:{}}};e.$Aec=f,e.$Aec=f=Ee([Z(2,p.$Ppb),Z(3,p.$Qpb),Z(4,p.$5pb),Z(5,a.$ej),Z(6,p.$Zpb),Z(7,k.$fl),Z(8,N.$Ri),Z(9,T.$oq),Z(10,C.$em),Z(11,A.$Pl)],f);let l=class extends R.$4Ob{constructor(w,d,P,$,c,h){super(p.SyncResource.Tasks,d,P,$,w,c,h),this.c=this.g.defaultProfile.tasksResource}async o(w){const d=w.syncData?m(w.syncData.content,this.j):null;if(!d){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$Se.fromString(d)),await this.n(w)}async p(){return this.k.exists(this.c)}};e.$Bec=l,e.$Bec=l=Ee([Z(0,k.$fl),Z(1,b.$Rl),Z(2,N.$Ri),Z(3,p.$5pb),Z(4,T.$oq),Z(5,A.$Pl)],l);function g(E,w,d){if(E===null&&w===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(E===w)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const P=d!==E,$=d!==w;return!P&&!$?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:P&&!$?{content:E,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:$&&!P?{content:w,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:E,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ue[127],de([0,1,45,21,15,7,16,18,28,19,40,211,24]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0,e.$kgc=l,e.$lgc=g;let f=class extends R.$1Ob{constructor(w,d,P,$,c,h,i,n,t,s,r,o,u){super({syncResource:m.SyncResource.Profiles,profile:w},d,$,c,h,i,n,r,o,t,s,u),this.vb=P,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.$7pb,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.$7pb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.$7pb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.$7pb,authority:"accepted"}),this.B(P.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const w=await this.getLastSyncUserData();return w?.syncData?g(w.syncData):null}async getRemoteSyncedProfiles(w){const d=await this.getLastSyncUserData(),P=await this.X(w,d);return P?.syncData?g(P.syncData):null}async qb(w,d,P){if(!this.vb.isEnabled())throw new m.$Upb("Cannot sync profiles because they are disabled",m.UserDataSyncErrorCode.LocalError);const $=w.syncData?g(w.syncData):null,c=d?.syncData?g(d.syncData):null,h=this.Db(),{local:i,remote:n}=(0,p.$igc)(h,$,c,[]),t={local:i,remote:n,content:c?this.Eb(c):null,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?m.Change.Modified:m.Change.None,remoteChange:n!==null?m.Change.Modified:m.Change.None},s=l(h,!1);return[{baseResource:this.baseResource,baseContent:c?this.Eb(c):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:$?this.Eb($):null,remoteProfiles:$,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async ub(w){const d=w?.syncData?g(w.syncData):null,P=this.Db(),{remote:$}=(0,p.$igc)(P,d,d,[]);return!!$?.added.length||!!$?.removed.length||!!$?.updated.length}async rb(w,d){return{...w.previewResult,hasConflicts:!1}}async sb(w,d,P,$){if(this.h.isEqual(d,this.localResource))return this.Ab(w);if(this.h.isEqual(d,this.remoteResource))return this.Bb(w);if(this.h.isEqual(d,this.previewResource))return w.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async Ab(w){const d=this.Db(),P=(0,p.$igc)(d,null,null,[]),{local:$,remote:c}=P;return{content:w.localContent,local:$,remote:c,localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?m.Change.Modified:m.Change.None,remoteChange:c!==null?m.Change.Modified:m.Change.None}}async Bb(w){const d=w.remoteContent?JSON.parse(w.remoteContent):null,P=[],$=[];for(const c of this.Db()){const h=d?.find(i=>i.id===c.id);h&&(P.push({id:c.id,name:c.name,collection:h.collection}),$.push(c))}if(d!==null){const c=(0,p.$igc)($,d,P,[]),{local:h,remote:i}=c;return{content:w.remoteContent,local:h,remote:i,localChange:h.added.length>0||h.removed.length>0||h.updated.length>0?m.Change.Modified:m.Change.None,remoteChange:i!==null?m.Change.Modified:m.Change.None}}else return{content:w.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:m.Change.None,remoteChange:m.Change.None}}async tb(w,d,P,$){const{local:c,remote:h,localChange:i,remoteChange:n}=P[0][1];i===m.Change.None&&n===m.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const t=P[0][0].remoteProfiles||[];if(t.length+(h?.added.length??0)-(h?.removed.length??0)>20)throw new m.$Upb("Too many profiles to sync. Please remove some profiles and try again.",m.UserDataSyncErrorCode.LocalTooManyProfiles);if(i!==m.Change.None&&(await this.nb(l(this.Db(),!1)),await Promise.all(c.removed.map(async s=>{this.O.trace(`${this.D}: Removing '${s.name}' profile...`),await this.vb.removeProfile(s),this.O.info(`${this.D}: Removed profile '${s.name}'.`)})),await Promise.all(c.added.map(async s=>{this.O.trace(`${this.D}: Creating '${s.name}' profile...`),await this.vb.createProfile(s.id,s.name,{shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${s.name}'.`)})),await Promise.all(c.updated.map(async s=>{const r=this.vb.profiles.find(o=>o.id===s.id);r?(this.O.trace(`${this.D}: Updating '${s.name}' profile...`),await this.vb.updateProfile(r,{name:s.name,shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${s.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${s.id}' to update.`)}))),n!==m.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const s=[],r=t.length+(h?.added.length??0)<=20;if(r)for(const o of h?.added||[]){const u=await this.J.createCollection(this.F);s.push(u),t.push({id:o.id,name:o.name,collection:u,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const o of h?.removed||[])t.splice(t.findIndex(({id:u})=>o.id===u),1);for(const o of h?.updated||[]){const u=t.find(({id:y})=>o.id===y);u&&t.splice(t.indexOf(u),1,{...u,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{w=await this.updateRemoteProfiles(t,$?null:w.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&h?.added.length?` Added: ${JSON.stringify(h.added.map(o=>o.name))}.`:""}${h?.updated.length?` Updated: ${JSON.stringify(h.updated.map(o=>o.name))}.`:""}${h?.removed.length?` Removed: ${JSON.stringify(h.removed.map(o=>o.name))}.`:""}`)}catch(o){if(s.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const u of s)await this.J.deleteCollection(u,this.F)}throw o}for(const o of h?.removed||[])await this.J.deleteCollection(o.collection,this.F)}d?.ref!==w.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(w),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(w,d){return this.mb(this.Eb(w),d)}async hasLocalData(){return this.Db().length>0}async resolveContent(w){if(this.h.isEqual(this.remoteResource,w)||this.h.isEqual(this.baseResource,w)||this.h.isEqual(this.localResource,w)||this.h.isEqual(this.acceptedResource,w)){const d=await this.db(w);return d&&(0,I.$co)(JSON.parse(d),{})}return null}Db(){return this.vb.profiles.filter(w=>!w.isDefault&&!w.isTransient)}Eb(w){return JSON.stringify([...w].sort((d,P)=>d.name.localeCompare(P.name)))}};e.$jgc=f,e.$jgc=f=Ee([Z(2,b.$Rl),Z(3,k.$fl),Z(4,N.$Ri),Z(5,T.$oq),Z(6,m.$Ppb),Z(7,m.$Qpb),Z(8,m.$5pb),Z(9,a.$ej),Z(10,m.$Zpb),Z(11,C.$em),Z(12,A.$Pl)],f);function l(E,w){const d=[...E].sort((P,$)=>P.name.localeCompare($.name)).map(P=>({id:P.id,name:P.name}));return w?(0,I.$co)(d,{}):JSON.stringify(d)}function g(E){return JSON.parse(E.content)}}),define(ue[230],de([0,1,3,2,5,15,16,18,24]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;const b="sync.enable";let R=class extends a.$Zc{constructor(m,f,l,g){super(),this.c=m,this.f=f,this.g=l,this.h=g,this.a=new I.$qe,this.onDidChangeEnablement=this.a.event,this.b=new I.$qe,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(T.StorageScope.APPLICATION,void 0,this.B(new a.$Yc))(E=>this.m(E)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(b,T.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(b,{enabled:m}),this.c.store(b,m,T.StorageScope.APPLICATION,T.StorageTarget.MACHINE))}isResourceEnabled(m){return this.c.getBoolean((0,A.$Ypb)(m),T.StorageScope.APPLICATION,!0)}setResourceEnablement(m,f){if(this.isResourceEnabled(m)!==f){const l=(0,A.$Ypb)(m);this.j(l,f)}}getResourceSyncStateVersion(m){}j(m,f){this.c.store(m,f,T.StorageScope.APPLICATION,N.$r?T.StorageTarget.USER:T.StorageTarget.MACHINE)}m(m){if(b===m.key){this.a.fire(this.isEnabled());return}const f=A.$Lpb.filter(l=>(0,A.$Ypb)(l)===m.key)[0];if(f){this.b.fire([f,this.isResourceEnabled(f)]);return}}};e.$9fc=R,e.$9fc=R=Ee([Z(0,T.$oq),Z(1,C.$em),Z(2,k.$Ri),Z(3,A.$Opb)],R)}),define(ue[231],de([0,1,6,14,67,2,20,21,15,7,19,24]),function(ce,e,I,a,N,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;let m=class extends k.$Zc{constructor(l,g,E,w,d){super(),this.a=l,this.b=g,this.c=E,this.f=w,this.g=d,this.h()}async h(){for(const g of this.g.profiles)for(const E of p.$Lpb)try{await this.m(this.j(E,g.isDefault?void 0:g.id))}catch(w){this.f.error(w)}let l;try{l=await this.b.resolve(this.a.userDataSyncHome)}catch(g){(0,b.$wl)(g)!==b.FileOperationResult.FILE_NOT_FOUND&&this.f.error(g);return}if(l.children){for(const g of l.children)if(g.isDirectory&&!p.$Lpb.includes(g.name)&&!this.g.profiles.some(E=>E.id===g.name))try{this.f.info("Deleting non existing profile from backup",g.resource.path),await this.b.del(g.resource,{recursive:!0})}catch(E){this.f.error(E)}}}async getAllResourceRefs(l,g,E){const w=this.j(l,g,E);try{const d=await this.b.resolve(w);if(d.children)return d.children.filter($=>$.isFile&&!$.name.startsWith("lastSync")).sort().reverse().map($=>({ref:$.name,created:this.n($)}))}catch(d){if((0,b.$wl)(d)!==b.FileOperationResult.FILE_NOT_FOUND)throw d}return[]}async resolveResourceContent(l,g,E,w){const d=this.j(l,E,w),P=(0,T.$lh)(d,g);try{return(await this.b.readFile(P)).value.toString()}catch($){return this.f.error($),null}}async writeResource(l,g,E,w,d){const P=this.j(l,w,d),$=(0,T.$lh)(P,`${(0,N.$0m)(E).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile($,a.$Se.fromString(g))}catch(c){this.f.error(c)}}j(l,g,E=this.a.userDataSyncHome){return(0,T.$lh)(E,...g?[g,l]:[l])}async m(l){try{try{if(!await this.b.exists(l))return}catch{return}const g=await this.b.resolve(l);if(g.children){const E=g.children.filter($=>$.isFile&&/^\d{8}T\d{6}(\.json)?$/.test($.name)).sort(),w=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=E.filter($=>Date.now()-this.n($)>w);const P=E.length-d.length;P<10&&(d=d.slice(10-P)),await I.Promises.settled(d.map(async $=>{this.f.info("Deleting from backup",$.resource.path),await this.b.del($.resource)}))}}catch(g){this.f.error(g)}}n(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.$hgc=m,e.$hgc=m=Ee([Z(0,A.$Ri),Z(1,b.$fl),Z(2,C.$ej),Z(3,p.$5pb),Z(4,R.$Rl)],m)}),define(ue[87],de([0,1,3,2,5,26,9,15,7,4,23,49,16,24]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpb=e.$Bpb=void 0,e.$Cpb=c,e.$Bpb=(0,b.$Ki)("IUserDataSyncMachinesService");const g="sync.currentMachineName",E="Safari",w="Chrome",d="Edge",P="Firefox",$="Android";function c(n){switch(n){case E:case w:case d:case P:case $:case(0,N.$k)(N.Platform.Web):return!0}return!1}function h(){return N.$J?E:N.$H?w:N.$K?d:N.$I?P:N.$L?$:(0,N.$k)(N.$r?N.Platform.Web:N.$x)}let i=class extends a.$Zc{static{l=this}static{this.a=1}static{this.b="machines"}constructor(t,s,r,o,u,y){super(),this.h=r,this.j=o,this.m=u,this.n=y,this.c=this.B(new I.$qe),this.onDidChange=this.c.event,this.g=null,this.f=(0,p.$uq)(t,s,r)}async getMachines(t){const s=await this.f;return(await this.s(t)).machines.map(o=>({...o,isCurrent:o.id===s}))}async addCurrentMachine(t){const s=await this.f,r=await this.s(t);r.machines.some(({id:o})=>o===s)||(r.machines.push({id:s,name:this.r(r.machines),platform:h()}),await this.t(r))}async removeCurrentMachine(t){const s=await this.f,r=await this.s(t),o=r.machines.filter(({id:u})=>u!==s);o.length!==r.machines.length&&(r.machines=o,await this.t(r))}async renameMachine(t,s,r){const o=await this.s(r),u=o.machines.find(({id:y})=>y===t);if(u){u.name=s,await this.t(o);const y=await this.f;t===y&&this.h.store(g,s,m.StorageScope.APPLICATION,m.StorageTarget.MACHINE)}}async setEnablements(t){const s=await this.s();for(const[r,o]of t){const u=s.machines.find(y=>y.id===r);u&&(u.disabled=o?void 0:!0)}await this.t(s)}r(t){const s=this.h.get(g,m.StorageScope.APPLICATION);if(s)return s;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${h()} (${this.n.nameShort})`,o=new RegExp(`${(0,k.$mf)(r)}\\s#(\\d+)`);let u=0;for(const y of t){const O=o.exec(y.name),S=O?parseInt(O[1]):0;u=S>u?S:u}return`${r} #${u+1}`}async s(t){this.g=await this.u(t);const s=this.w(this.g);if(s.version!==l.a)throw new Error((0,T.localize)(2461,null,this.n.nameLong));return s}async t(t){const s=JSON.stringify(t),r=await this.j.writeResource(l.b,s,this.g?.ref||null);this.g={ref:r,content:s},this.c.fire()}async u(t){if(this.g){const s=t&&t.latest?t.latest[l.b]:void 0;if(this.g.ref===s)return this.g;if(s===void 0&&this.g.content===null)return this.g}return this.j.readResource(l.b,this.g)}w(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.m.error(s)}return{version:l.a,machines:[]}}};e.$Dpb=i,e.$Dpb=i=l=Ee([Z(0,C.$Ri),Z(1,A.$fl),Z(2,m.$oq),Z(3,f.$Ppb),Z(4,f.$5pb),Z(5,R.$yk)],i)}),define(ue[232],de([0,1,6,67,41,8,3,2,5,20,10,9,23,16,18,24,83,87]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;const d="sync.disableMachineEventually",P="sync.sessionId",$="sync.storeUrl",c="sync.productQuality";let h=class extends C.$Zc{get n(){const t=this.H.get($,f.StorageScope.APPLICATION);return t?R.URI.parse(t):void 0}set n(t){t?this.H.store($,t.toString(),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE):this.H.remove($,f.StorageScope.APPLICATION)}get s(){return this.H.get(c,f.StorageScope.APPLICATION)}set s(t){t?this.H.store(c,t,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE):this.H.remove(c,f.StorageScope.APPLICATION)}constructor(t,s,r,o,u,y,O,S,v,L){super(),this.u=s,this.w=r,this.y=o,this.z=u,this.C=y,this.D=O,this.F=S,this.G=v,this.H=L,this.a=this.B(new C.$1c),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.$qe),this.onError=this.h.event,this.S=[],this.f=this.B(new I.$Ih(this.U())),this.j=this.n,this.n=s.userDataSyncStore?.url,this.r=this.s,this.s=t.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,b.$eh)(this.n,s.userDataSyncStore?.url)||(this.j=this.n,this.n=s.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(O.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(u.onDidChangeLocal(j=>this.triggerSync([j],!1,!1))),this.B(T.Event.filter(this.y.onDidChangeResourceEnablement,([,j])=>j)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:t,message:s}=this.L();t?this.a.value===void 0&&(this.a.value=new i(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.C.info(s),this.a.clear()):s&&this.y.isEnabled()&&this.C.info(s))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,a.$0m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(t,s,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(P,f.StorageScope.APPLICATION),t?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(o){if(this.C.error(o),s)this.M(!1);else throw o}}M(t){this.y.isEnabled()!==t&&(this.y.setEnablement(t),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(t){if(!t){this.b=0;return}const s=g.$Upb.toUserDataSyncError(t);s instanceof g.$Wpb&&this.F.publicLog2("autosync/error",{code:s.code,service:this.u.userDataSyncStore.url.toString()}),s.code===g.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):s.code===g.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code===g.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):s.code===g.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code===g.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code===g.UserDataSyncErrorCode.UpgradeRequired||s.code===g.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code===g.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code===g.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code===g.UserDataSyncErrorCode.ServiceChanged||s.code===g.UserDataSyncErrorCode.DefaultServiceChanged?A.$r&&s.code===g.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(s),this.b++),this.h.fire(s)}async P(){this.H.store(d,!0,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await(0,I.$Lh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(d,f.StorageScope.APPLICATION,!1)}R(){this.H.remove(d,f.StorageScope.APPLICATION)}async triggerSync(t,s,r){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...t),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const o=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:o}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$ngc=h,e.$ngc=h=Ee([Z(0,m.$yk),Z(1,g.$Opb),Z(2,g.$Ppb),Z(3,g.$Zpb),Z(4,g.$1pb),Z(5,g.$5pb),Z(6,E.$mNb),Z(7,l.$em),Z(8,w.$Bpb),Z(9,f.$oq)],h);class i extends C.$Zc{static{this.a="Interval"}constructor(t,s,r,o,u,y,O,S,v){super(),this.m=t,this.n=s,this.r=r,this.s=o,this.u=u,this.w=y,this.y=O,this.z=S,this.C=v,this.b=this.B(new C.$1c),this.c=this.B(new T.$qe),this.onDidStartSync=this.c.event,this.f=this.B(new T.$qe),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,C.$Xc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(i.a,!1)}D(){this.b.value=(0,I.$Mh)(()=>{this.sync(i.a,!1),this.b.value=void 0},this.n)}sync(t,s){const r=(0,I.$xh)(async o=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(u){if((0,k.$8)(u))return}return this.H(t,s,o)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,b.$eh)(this.m,this.r.userDataSyncStore?.url)}async G(){const t=await this.r.getPreviousUserDataSyncStore(),s=this.r.userDataSyncStore;return!!s&&!!t&&(!(0,b.$eh)(s.defaultUrl,t.defaultUrl)||!(0,b.$eh)(s.insidersUrl,t.insidersUrl)||!(0,b.$eh)(s.stableUrl,t.stableUrl))}async H(t,s,r){this.y.info(`Auto Sync: Triggered by ${t}`),this.c.fire();let o;try{await this.I(s,r)}catch(u){if(this.y.error(u),o=u,g.$Upb.toUserDataSyncError(u).code===g.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(s,r),o=void 0}catch(y){this.y.error(y),o=y}}this.f.fire(o)}async I(t,s){if(this.h=await this.u.createSyncTask(this.g,t),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new g.$Wpb((0,p.localize)(2448,null),g.UserDataSyncErrorCode.DefaultServiceChanged):new g.$Wpb((0,p.localize)(2449,null),g.UserDataSyncErrorCode.ServiceChanged):new g.$Wpb((0,p.localize)(2450,null),g.UserDataSyncErrorCode.TurnedOff);const r=this.C.get(P,f.StorageScope.APPLICATION);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new g.$Wpb((0,p.localize)(2451,null),g.UserDataSyncErrorCode.DefaultServiceChanged):new g.$Wpb((0,p.localize)(2452,null),g.UserDataSyncErrorCode.ServiceChanged):new g.$Wpb((0,p.localize)(2453,null),g.UserDataSyncErrorCode.SessionExpired);const o=await this.w.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const u=o.find(O=>O.isCurrent);if(u?.disabled)throw new g.$Wpb((0,p.localize)(2454,null),g.UserDataSyncErrorCode.TurnedOff);const y=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.s.manifest(null)}catch(O){throw new g.$Wpb((0,N.$vj)(O),O instanceof g.$Upb?O.code:g.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==r&&this.C.store(P,this.g.session,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),!s.isCancellationRequested&&(u||await this.w.addCurrentMachine(this.g||void 0))}register(t){return super.B(t)}}}),define(ue[233],de([0,1,10,9,15,7,49,16,28,24,19,40,125,124,123,21,126,121,122,4,127,45,26]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P,$,c,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;let n=class{static{i=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(s,r,o,u,y,O,S,v,L,j){this.e=s,this.f=r,this.g=o,this.h=y,this.i=O,this.j=S,this.k=v,this.l=L,this.n=j,this.d=u.extUri}async getRemoteSyncedProfiles(){const s=await this.e.readResource(b.SyncResource.Profiles,null,void 0);if(s.content){const r=this.L(s.content,b.SyncResource.Profiles);return(0,$.$lgc)(r)}return[]}async getLocalSyncedProfiles(s){const r=await this.f.getAllResourceRefs(b.SyncResource.Profiles,void 0,s);if(r.length){const o=await this.f.resolveResourceContent(b.SyncResource.Profiles,r[0].ref,void 0,s);if(o){const u=this.L(o,b.SyncResource.Profiles);return(0,$.$lgc)(u)}}return[]}async getLocalSyncedMachines(s){const r=await this.f.getAllResourceRefs("machines",void 0,s);if(r.length){const o=await this.f.resolveResourceContent("machines",r[0].ref,void 0,s);if(o)return JSON.parse(o).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(s,r){return(await this.e.getAllResourceRefs(s,r?.collection)).map(({created:u,ref:y})=>({created:u,uri:this.J({remote:!0,syncResource:s,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(s,r,o){return(await this.f.getAllResourceRefs(s,r?.collection,o)).map(({created:y,ref:O})=>({created:y,uri:this.J({remote:!1,syncResource:s,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:O,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:s}){const r=this.K(s),o=r?this.k.profiles.find(u=>u.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:s}){const r=this.K(s);if(!r)return[];const o=this.k.profiles.find(u=>u.id===r.profile);switch(r.syncResource){case b.SyncResource.Settings:return this.s(s,o);case b.SyncResource.Keybindings:return this.u(s,o);case b.SyncResource.Tasks:return this.w(s,o);case b.SyncResource.Snippets:return this.y(s,o);case b.SyncResource.GlobalState:return this.D(s,o);case b.SyncResource.Extensions:return this.A(s,o);case b.SyncResource.Profiles:return this.G(s,o);case b.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:s}){const r=this.K(s);if(r){if(r.remote){if(r.ref){const{content:o}=await this.M(r.syncResource,r.ref,r.collection);if(o)return this.L(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.L(o,r.syncResource)?.machineId}return}return(0,T.$uq)(this.h,this.j,this.i)}}async resolveContent(s){const r=this.K(s);if(!r||r.node===i.a)return null;if(r.ref){const o=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.q(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(s,r,o,u,y){if(s){const{content:O}=await this.M(r,u,o);return O}return this.f.resolveResourceContent(r,u,o,y)}q(s,r,o){const u=this.L(r,s);switch(s){case b.SyncResource.Settings:return this.t(u,o);case b.SyncResource.Keybindings:return this.v(u,o);case b.SyncResource.Tasks:return this.x(u,o);case b.SyncResource.Snippets:return this.z(u,o);case b.SyncResource.GlobalState:return this.E(u,o);case b.SyncResource.Extensions:return this.B(u,o);case b.SyncResource.Profiles:return this.H(u,o);case b.SyncResource.WorkspaceState:return null}}async r(s,r){const o=this.k.profiles.find(u=>u.id===r);if(!o)return null;switch(s){case b.SyncResource.GlobalState:return this.F(o);case b.SyncResource.Extensions:return this.C(o);case b.SyncResource.Profiles:return this.I(o);case b.SyncResource.Settings:return null;case b.SyncResource.Keybindings:return null;case b.SyncResource.Tasks:return null;case b.SyncResource.Snippets:return null;case b.SyncResource.WorkspaceState:return null}}s(s,r){const o=this.d.joinPath(s,"settings.json"),u=r?r.settingsResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}t(s,r){switch(r){case"settings.json":return(0,f.$rec)(s.content).settings}return null}u(s,r){const o=this.d.joinPath(s,"keybindings.json"),u=r?r.keybindingsResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}v(s,r){switch(r){case"keybindings.json":return(0,l.$oec)(s.content,!!this.l.getValue(b.$Ipb),this.g)}return null}w(s,r){const o=this.d.joinPath(s,"tasks.json"),u=r?r.tasksResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}x(s,r){switch(r){case"tasks.json":return(0,E.$zec)(s.content,this.g)}return null}async y(s,r){const o=await this.resolveContent(s);if(o){const u=this.L(o,b.SyncResource.Snippets);if(u){const y=(0,m.$wec)(u),O=[];for(const S of Object.keys(y)){const v=this.d.joinPath(s,S),L=r?this.d.joinPath(r.snippetsHome,S):this.d.joinPath(s,i.a);O.push({resource:v,comparableResource:L})}return O}}return[]}z(s,r){return(0,m.$wec)(s)[r]||null}A(s,r){const o=this.d.joinPath(s,"extensions.json"),u=r?this.J({remote:!1,syncResource:b.SyncResource.Extensions,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}B(s,r){switch(r){case"extensions.json":return(0,w.$jec)((0,w.$iec)(s),!0)}return null}async C(s){const{localExtensions:r}=await this.n.createInstance(w.$lec).getLocalExtensions(s);return(0,w.$jec)(r,!0)}D(s,r){const o=this.d.joinPath(s,"globalState.json"),u=r?this.J({remote:!1,syncResource:b.SyncResource.GlobalState,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}E(s,r){switch(r){case"globalState.json":return(0,d.$6Ob)(JSON.parse(s.content),!0)}return null}async F(s){const r=await this.n.createInstance(d.$8Ob).getLocalGlobalState(s);return(0,d.$6Ob)(r,!0)}G(s,r){const o=this.d.joinPath(s,"profiles.json"),u=this.J({remote:!1,syncResource:b.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:u}]}H(s,r){switch(r){case"profiles.json":return(0,c.$co)(JSON.parse(s.content),{})}return null}async I(s){return(0,$.$kgc)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(s){const r=s.remote?i.b:i.c,o=[];return s.location&&(o.push(`scheme:${s.location.scheme}`),o.push(`authority:${s.location.authority}`),o.push((0,h.$qf)(s.location.path,"/"))),o.push(`syncResource:${s.syncResource}`),o.push(`profile:${s.profile}`),s.collection&&o.push(`collection:${s.collection}`),s.ref&&o.push(`ref:${s.ref}`),s.node&&o.push(s.node),this.d.joinPath(I.URI.from({scheme:b.$7pb,authority:r,path:"/",query:s.location?.query,fragment:s.location?.fragment}),...o)}K(s){if(s.scheme!==b.$7pb)return;const r=[];for(;s.path!=="/";)r.unshift(this.d.basename(s)),s=this.d.dirname(s);if(r.length<2)return;const o=s.authority===i.b;let u,y;const O=[];let S,v,L,j,U;for(;r.length;){const F=r.shift();F.startsWith("scheme:")?u=F.substring(7):F.startsWith("authority:")?y=F.substring(10):F.startsWith("syncResource:")?S=F.substring(13):F.startsWith("profile:")?v=F.substring(8):F.startsWith("collection:")?L=F.substring(11):F.startsWith("ref:")?j=F.substring(4):S?U=F:O.push(F)}return{remote:o,syncResource:S,profile:v,collection:L,ref:j,node:U,location:u&&y!==void 0?this.d.joinPath(I.URI.from({scheme:u,authority:y,query:s.query,fragment:s.fragment,path:"/"}),...O):void 0}}L(s,r){try{const o=JSON.parse(s);if((0,p.$YOb)(o))return o}catch(o){this.g.error(o)}throw new b.$Upb((0,a.localize)(2462,null),b.UserDataSyncErrorCode.IncompatibleRemoteContent,r)}async M(s,r,o){const u=await this.e.resolveResourceContent(s,r,o);return{ref:r,content:u}}};e.$4gc=n,e.$4gc=n=i=Ee([Z(0,b.$Ppb),Z(1,b.$Qpb),Z(2,b.$5pb),Z(3,A.$Pl),Z(4,N.$Ri),Z(5,C.$oq),Z(6,k.$fl),Z(7,R.$Rl),Z(8,g.$ej),Z(9,P.$Ji)],n)}),define(ue[234],de([0,1,17,6,25,41,3,2,20,12,32,21,27,7,4,16,18,19,121,122,123,124,125,126,127,24]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P,$,c,h,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;const s="sync.lastSyncTime";let r=class extends C.$Zc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(S,v,L,j,U,F,G,V,x,H,te){super(),this.C=S,this.D=v,this.F=L,this.G=j,this.H=U,this.I=F,this.J=G,this.L=V,this.M=x,this.N=H,this.O=te,this.f=t.SyncStatus.Uninitialized,this.g=this.B(new T.$qe),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.$qe),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new T.$qe),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new T.$qe),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new T.$qe),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new T.$qe),this.onDidResetLocal=this.w.event,this.y=this.B(new T.$qe),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=L.userDataSyncStore?t.SyncStatus.Idle:t.SyncStatus.Uninitialized,this.t=this.J.getNumber(s,g.StorageScope.APPLICATION,void 0),this.B((0,C.$Xc)(()=>this.cb())),this.B(new a.$Wh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(S,v){this.db(),this.H.info("Sync started.");const L=new Date().getTime(),j=(0,R.$7g)();try{const V=(0,t.$Tpb)(j);v&&(V["Cache-Control"]="no-cache"),S=await this.D.manifest(S,V)}catch(V){const x=t.$Upb.toUserDataSyncError(V);throw y(x,j,this.F,this.I),x}const U=!1,F=this;let G;return{manifest:S,async run(){if(U)throw new Error("Can run a task only once");G=(0,a.$xh)(V=>F.P(S,!1,j,V)),await G.finally(()=>G=void 0),F.H.info(`Sync done. Took ${new Date().getTime()-L}ms`),F.ab()},stop(){return G?.cancel(),F.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new t.$Upb("Cannot start manual sync when sync is enabled",t.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const S=new Date().getTime(),v=(0,R.$7g)(),L=(0,t.$Tpb)(v);let j;try{j=await this.D.manifest(null,L)}catch(G){const V=t.$Upb.toUserDataSyncError(G);throw y(V,v,this.F,this.I),V}await this.resetLocal();const U=this,F=new N.$Be;return{id:v,async merge(){return U.P(j,!0,v,F.token)},async apply(){try{try{await U.R(j,v,F.token)}catch(G){if(t.$Upb.toUserDataSyncError(G).code===t.UserDataSyncErrorCode.MethodNotFound)U.H.info("Client is making invalid requests. Cleaning up data..."),await U.cleanUpRemoteData(),U.H.info("Applying manual sync again..."),await U.R(j,v,F.token);else throw G}}catch(G){throw U.H.error(G),G}U.H.info(`Sync done. Took ${new Date().getTime()-S}ms`),U.ab()},async stop(){F.cancel(),await U.U(),await U.resetLocal()}}}async P(S,v,L,j){this.n=[];try{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Syncing);const U=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(U,S,v,L,j));const F=U.enabled.find(G=>G.resource===t.SyncResource.Profiles);if(F){const G=await F.getLastSyncedProfiles()||[];if(j.isCancellationRequested)return;await this.Q(G,S,v,L,j)}}finally{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Idle),this.r.fire(this.n)}}async Q(S,v,L,j,U){for(const F of S){if(U.isCancellationRequested)return;const G=this.M.profiles.find(x=>x.id===F.id);if(!G){this.H.error(`Profile with id:${F.id} and name: ${F.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",F.name);const V=this.getOrCreateActiveProfileSynchronizer(G,F);this.n.push(...await this.S(V,v,L,j,U))}for(const[F,G]of this.z.entries())this.M.profiles.some(V=>V.id===G[0].profile.id)||(await G[0].resetLocal(),G[1].dispose(),this.z.delete(F))}async R(S,v,L){const j=this.bb();for(const x of j){if(L.isCancellationRequested)return;await x.apply(v,L)}const U=j.find(x=>x.profile.isDefault);if(!U)return;const F=U.enabled.find(x=>x.resource===t.SyncResource.Profiles);if(!F)return;const V=(await F.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(x=>j.every(H=>H.profile.id!==x.id));V.length&&await this.Q(V,S,!1,v,L)}async S(S,v,L,j,U){return(await S.sync(v,L,j,U)).map(([G,V])=>({profile:S.profile,syncResource:G,error:V}))}async U(){this.status!==t.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(S=>S.stop()))}async resolveContent(S){const v=await this.N.resolveContent(S);if(v)return v;for(const L of this.bb())for(const j of L.enabled){const U=await j.resolveContent(S);if(U)return U}return null}async replace(S){this.db();const v=this.N.resolveUserDataSyncResource(S);if(!v)return;const L=await this.resolveContent(S.uri);L&&await this.X(v.profile,async j=>{if(v.syncResource===j.resource)return await j.replace(L),!0})}async accept(S,v,L,j){this.db(),await this.X(S.profile,async U=>{if(S.syncResource===U.resource)return await U.accept(v,L),j&&await U.apply((0,b.$pg)(j)?!1:j.force,(0,t.$Tpb)((0,R.$7g)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async v=>{if(v.resource!==t.SyncResource.GlobalState&&await v.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async v=>{if(await v.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(S){this.H.error(S)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(s,g.StorageScope.APPLICATION);for(const[S]of this.z.values())try{await S.resetLocal()}catch(v){this.H.error(v)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const S=this.J.keys(g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),v=[];for(const j of S){if(!j.endsWith(".lastSyncUserData"))continue;const U=j.split(".");U.length===3&&v.push([j,U[0]])}if(!v.length)return;const L=new C.$Yc;try{let j=this.z.get(this.M.defaultProfile.id)?.[0];j||(j=L.add(this.G.createInstance(o,this.M.defaultProfile,void 0)));const U=j.enabled.find(V=>V.resource===t.SyncResource.Profiles);if(!U)return;const G=(await U.getLastSyncedProfiles())?.map(V=>V.collection)??[];for(const[V,x]of v)G.includes(x)||(this.H.info(`Removing last sync state for stale profile: ${x}`),this.J.remove(V,g.StorageScope.APPLICATION))}finally{L.dispose()}}async cleanUpRemoteData(){const S=await this.N.getRemoteSyncedProfiles(),v=S.map(F=>F.collection),L=await this.D.getAllCollections(),j=L.filter(F=>!v.includes(F));j.length&&(this.H.info(`Deleting ${j.length} redundant collections on server`),await Promise.allSettled(j.map(F=>this.D.deleteCollection(F))),this.H.info("Deleted redundant collections on server"));const U=S.filter(F=>L.includes(F.collection));if(U.length!==S.length){const F=this.G.createInstance(n.$jgc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await F.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await F.updateRemoteProfiles(U,null),this.H.info("Updated remote profiles on server")}finally{F.dispose()}}}async saveRemoteActivityData(S){this.db();const v=await this.D.getActivityData();await this.C.writeFile(S,v)}async extractActivityData(S,v){const L=(await this.C.readFile(S)).value.toString(),j=JSON.parse(L);if(j.resources)for(const U in j.resources)for(const F of j.resources[U])await this.O.writeResource(U,F.content,new Date(F.created*1e3),void 0,v);if(j.collections)for(const U in j.collections)for(const F in j.collections[U].resources)for(const G of j.collections[U].resources?.[F]??[])await this.O.writeResource(F,G.content,new Date(G.created*1e3),U,v)}async X(S,v){const L=new C.$Yc;try{const j=this.z.get(S.id);if(j){const x=await this.Y(j[0],v,L);return(0,b.$qg)(x)?null:x}if(S.isDefault){const x=L.add(this.G.createInstance(o,S,void 0)),H=await this.Y(x,v,L);return(0,b.$qg)(H)?null:H}if(this.M.isEnabled())return null;const U=L.add(this.G.createInstance(n.$jgc,S,void 0)),F=await this.D.manifest(null),V=(await U.getRemoteSyncedProfiles(F?.latest??null)||[]).find(x=>x.id===S.id);if(V){const x=L.add(this.G.createInstance(o,S,V.collection)),H=await this.Y(x,v,L);return(0,b.$qg)(H)?null:H}return null}finally{L.dispose()}}async Y(S,v,L){const j=[...S.enabled,...S.disabled.reduce((U,F)=>(F!==t.SyncResource.WorkspaceState&&U.push(L.add(S.createSynchronizer(F))),U),[])];for(const U of j){const F=await v(U);if(!(0,b.$qg)(F))return F}}Z(S){const v=this.f;this.f!==S&&(this.f=S,this.g.fire(S),v===t.SyncStatus.HasConflicts&&this.ab())}$(){const S=this.bb().map(v=>v.conflicts).flat();(0,I.$yb)(this.j,S,(v,L)=>v.profile.id===L.profile.id&&v.syncResource===L.syncResource&&(0,I.$yb)(v.conflicts,L.conflicts,(j,U)=>(0,A.$eh)(j.previewResource,U.previewResource)))||(this.j=S,this.m.fire(S))}ab(){this.status===t.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(s,this.t,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(S,v){let L=this.z.get(S.id);if(L&&L[0].collection!==v?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),L[1].dispose(),L=void 0,this.z.delete(S.id)),!L){const j=new C.$Yc,U=j.add(this.G.createInstance(o,S,v?.collection));j.add(U.onDidChangeStatus(F=>this.Z(F))),j.add(U.onDidChangeConflicts(F=>this.$())),j.add(U.onDidChangeLocal(F=>this.h.fire(F))),this.z.set(S.id,L=[U,j])}return L[0]}bb(){const S=[];for(const[v]of this.z.values())S.push(v);return S}cb(){this.z.forEach(([,S])=>S.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$mgc=r,e.$mgc=r=Ee([Z(0,f.$fl),Z(1,t.$Ppb),Z(2,t.$Opb),Z(3,l.$Ji),Z(4,t.$5pb),Z(5,E.$em),Z(6,g.$oq),Z(7,t.$Zpb),Z(8,w.$Rl),Z(9,t.$2pb),Z(10,t.$Qpb)],r);let o=class extends C.$Zc{get enabled(){return this.f.sort((S,v)=>S[1]-v[1]).map(([S])=>S)}get disabled(){return t.$Lpb.filter(S=>!this.r.isResourceEnabled(S))}get status(){return this.g}get conflicts(){return this.m}constructor(S,v,L,j,U,F,G,V,x,H){super(),this.profile=S,this.collection=v,this.r=L,this.t=j,this.u=U,this.w=F,this.y=G,this.z=V,this.C=x,this.D=H,this.f=[],this.g=t.SyncStatus.Idle,this.h=this.B(new T.$qe),this.onDidChangeStatus=this.h.event,this.j=this.B(new T.$qe),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new T.$qe),this.onDidChangeConflicts=this.n.event,this.B(L.onDidChangeResourceEnablement(([te,z])=>this.F(te,z))),this.B((0,C.$Xc)(()=>this.f.splice(0,this.f.length).forEach(([,,te])=>te.dispose())));for(const te of t.$Lpb)L.isResourceEnabled(te)&&this.G(te)}F(S,v){v?this.G(S):this.H(S)}G(S){if(this.f.some(([U])=>U.resource===S))return;if(S===t.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(S===t.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||S===t.SyncResource.WorkspaceState)return;if(S!==t.SyncResource.Profiles&&this.profile.useDefaultFlags?.[S]){this.z.debug(`Skipping syncing ${S} in ${this.profile.name} because it is already synced by default profile`);return}const v=new C.$Yc,L=v.add(this.createSynchronizer(S));v.add(L.onDidChangeStatus(()=>this.L())),v.add(L.onDidChangeConflicts(()=>this.M())),v.add(L.onDidChangeLocal(()=>this.j.fire(S)));const j=this.N(S);this.f.push([L,j,v])}H(S){const v=this.f.findIndex(([L])=>L.resource===S);if(v!==-1){const[[L,,j]]=this.f.splice(v,1);j.dispose(),this.L(),L.stop().then(null,U=>this.z.error(U))}}createSynchronizer(S){switch(S){case t.SyncResource.Settings:return this.t.createInstance(c.$sec,this.profile,this.collection);case t.SyncResource.Keybindings:return this.t.createInstance($.$pec,this.profile,this.collection);case t.SyncResource.Snippets:return this.t.createInstance(h.$xec,this.profile,this.collection);case t.SyncResource.Tasks:return this.t.createInstance(i.$Aec,this.profile,this.collection);case t.SyncResource.GlobalState:return this.t.createInstance(P.$7Ob,this.profile,this.collection);case t.SyncResource.Extensions:return this.t.createInstance(d.$kec,this.profile,this.collection);case t.SyncResource.Profiles:return this.t.createInstance(n.$jgc,this.profile,this.collection)}}async sync(S,v,L,j){if(j.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const F=[],G=(0,t.$Tpb)(L),V=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,x=v?await this.I(V):{};for(const H of U){if(j.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(v){const te=await H.preview(V,x,G);if(te)for(const z of te.resourcePreviews)(z.localChange!==t.Change.None||z.remoteChange!==t.Change.None)&&z.mergeState===t.MergeState.Preview&&await H.merge(z.previewResource)}else await H.sync(V,G)}catch(te){const z=t.$Upb.toUserDataSyncError(te);if(y(z,L,this.w,this.y),u(te))throw z;this.z.error(te),this.z.error(`${H.resource}: ${(0,k.$vj)(te)}`),F.push([H.resource,z])}}return F}finally{this.L()}}async apply(S,v){const L=(0,t.$Tpb)(S);for(const j of this.enabled){if(v.isCancellationRequested)return;try{await j.apply(!1,L)}catch(U){const F=t.$Upb.toUserDataSyncError(U);if(y(F,S,this.w,this.y),u(U))throw F;this.z.error(U),this.z.error(`${j.resource}: ${(0,k.$vj)(U)}`)}}}async stop(){for(const S of this.enabled)try{S.status!==t.SyncStatus.Idle&&await S.stop()}catch(v){this.z.error(v)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(v){this.z.error(`${S.resource}: ${(0,k.$vj)(v)}`),this.z.error(v)}}async I(S){if(!this.profile.isDefault)return{};const v=this.D.getValue(t.$Hpb),L=this.enabled.find(j=>j instanceof c.$sec);if(L){const j=await L.getRemoteUserDataSyncConfiguration(S);return{...v,...j}}return v}J(S){this.g!==S&&(this.g=S,this.h.fire(S))}L(){return this.M(),this.enabled.some(S=>S.status===t.SyncStatus.HasConflicts)?this.J(t.SyncStatus.HasConflicts):this.enabled.some(S=>S.status===t.SyncStatus.Syncing)?this.J(t.SyncStatus.Syncing):this.J(t.SyncStatus.Idle)}M(){const S=this.enabled.filter(v=>v.status===t.SyncStatus.HasConflicts).filter(v=>v.conflicts.conflicts.length>0).map(v=>v.conflicts);(0,I.$yb)(this.m,S,(v,L)=>v.syncResource===L.syncResource&&(0,I.$yb)(v.conflicts,L.conflicts,(j,U)=>(0,A.$eh)(j.previewResource,U.previewResource)))||(this.m=S,this.n.fire(S))}N(S){switch(S){case t.SyncResource.Settings:return 0;case t.SyncResource.Keybindings:return 1;case t.SyncResource.Snippets:return 2;case t.SyncResource.Tasks:return 3;case t.SyncResource.GlobalState:return 4;case t.SyncResource.Extensions:return 5;case t.SyncResource.Profiles:return 6;case t.SyncResource.WorkspaceState:return 7}}};o=Ee([Z(2,t.$Zpb),Z(3,l.$Ji),Z(4,m.$rp),Z(5,t.$Opb),Z(6,E.$em),Z(7,t.$5pb),Z(8,w.$Rl),Z(9,p.$ej)],o);function u(O){if(O instanceof t.$Upb)switch(O.code){case t.UserDataSyncErrorCode.MethodNotFound:case t.UserDataSyncErrorCode.TooLarge:case t.UserDataSyncErrorCode.TooManyRequests:case t.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case t.UserDataSyncErrorCode.LocalTooManyRequests:case t.UserDataSyncErrorCode.LocalTooManyProfiles:case t.UserDataSyncErrorCode.Gone:case t.UserDataSyncErrorCode.UpgradeRequired:case t.UserDataSyncErrorCode.IncompatibleRemoteContent:case t.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function y(O,S,v,L){L.publicLog2("sync/error",{code:O.code,serverCode:O instanceof t.$Vpb?String(O.serverCode):void 0,url:O instanceof t.$Vpb?O.url:void 0,resource:O.resource,executionId:S,service:v.userDataSyncStore.url.toString()})}}),define(ue[235],de([0,1,3,2,10,19,24]),function(ce,e,I,a,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=e.$Kjc=void 0;function C(m,f){return{...m,profile:(0,k.$Sl)(m.profile,f.profilesHome.scheme)}}function A(m){return{created:m.created,uri:N.URI.revive(m.uri)}}class b{constructor(f,l,g){this.c=f,this.d=l,this.f=g,this.a=new Map,this.b=new I.$qe}listen(f,l){switch(l){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call(f,l,g){try{return await this.g(f,l,g)}catch(E){throw this.f.error(E),E}}async g(f,l,g){switch(l){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(N.URI.revive(g[0]));case"accept":return this.c.accept(C(g[0],this.d),N.URI.revive(g[1]),g[2],g[3]);case"replace":return this.c.replace(A(g[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(N.URI.revive(g[0]));case"extractActivityData":return this.c.extractActivityData(N.URI.revive(g[0]),N.URI.revive(g[1]));case"createManualSyncTask":return this.i()}if(l.startsWith("manualSync/")){const E=l.substring(11),w=g[0],d=this.h(w);switch(g=g.slice(1),E){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(f){const l=this.a.get(this.j(f));if(!l)throw new Error(`Manual sync taks not found: ${f}`);return l}async i(){const f=await this.c.createManualSyncTask();return this.a.set(this.j(f.id),f),f.id}j(f){return`manualSyncTask-${f}`}}e.$Kjc=b;let R=class extends a.$Zc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(f,l){super(),this.n=l,this.b=T.SyncStatus.Uninitialized,this.c=this.B(new I.$qe),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$qe),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new I.$qe),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new I.$qe),this.onSyncErrors=this.m.event,this.a={call(g,E,w){return f.call(g,E,w).then(null,d=>{throw T.$Upb.toUserDataSyncError(d)})},listen(g,E){return f.listen(g,E)}},this.a.call("_getInitialData").then(([g,E,w])=>{this.s(g),this.t(E),w&&this.u(w),this.B(this.a.listen("onDidChangeStatus")(d=>this.s(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.u(d)))}),this.B(this.a.listen("onDidChangeConflicts")(g=>this.t(g))),this.B(this.a.listen("onSyncErrors")(g=>this.m.fire(g.map(E=>({...E,error:T.$Upb.toUserDataSyncError(E.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const f=await this.a.call("createManualSyncTask"),l=this;return new p(f,{async call(E,w,d){return l.a.call(`manualSync/${E}`,[f,...Array.isArray(w)?w:[w]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(f,l,g,E){return this.a.call("accept",[f,l,g,E])}resolveContent(f){return this.a.call("resolveContent",[f])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(f){return this.a.call("replace",[f])}saveRemoteActivityData(f){return this.a.call("getRemoteActivityData",[f])}extractActivityData(f,l){return this.a.call("extractActivityData",[f,l])}async s(f){this.b=f,this.c.fire(f)}async t(f){this.f=f.map(l=>({syncResource:l.syncResource,profile:(0,k.$Sl)(l.profile,this.n.profilesHome.scheme),conflicts:l.conflicts.map(g=>({...g,baseResource:N.URI.revive(g.baseResource),localResource:N.URI.revive(g.localResource),remoteResource:N.URI.revive(g.remoteResource),previewResource:N.URI.revive(g.previewResource)}))})),this.g.fire(this.f)}u(f){this.h!==f&&(this.h=f,this.j.fire(f))}};e.$Ljc=R,e.$Ljc=R=Ee([Z(1,k.$Rl)],R);class p extends a.$Zc{constructor(f,l){super(),this.id=f,this.a=l}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(ue[128],de([0,1,6,25,8,3,2,146,5,20,12,10,32,21,15,7,23,61,49,16,24]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WOb=e.$VOb=e.$UOb=e.$TOb=e.$SOb=void 0;const c="configurationSync.store",h="sync.previous.store",i="sync.donot-make-requests-until",n="sync.user-session-id",t="sync.machine-session-id",s=100,r=1e3*60*5;let o=class extends T.$Zc{get userDataSyncStore(){return this.b}get c(){return this.h.get($.$Xpb,P.StorageScope.APPLICATION)}set c(L){this.h.store($.$Xpb,L,P.StorageScope.APPLICATION,A.$r?P.StorageTarget.USER:P.StorageTarget.MACHINE)}constructor(L,j,U){super(),this.f=L,this.g=j,this.h=U,this.a=this.B(new k.$qe),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const F=this.B(new T.$Yc);this.B(k.Event.filter(U.onDidChangeValue(P.StorageScope.APPLICATION,$.$Xpb,F),()=>this.c!==this.userDataSyncStore?.type,F)(()=>this.j()))}j(){this.b=this.m(this.f[c]),this.a.fire()}m(L){if(L&&(L=A.$r&&L.web?{...L,...L.web}:L,(0,R.$jg)(L.url)&&(0,R.$lg)(L.authenticationProviders)&&Object.keys(L.authenticationProviders).every(j=>Array.isArray(L.authenticationProviders[j].scopes)))){const j=L,U=!!j.canSwitch,F=j.url===j.insidersUrl?"insiders":"stable",G=(U?this.c:void 0)||F,V=G==="insiders"?j.insidersUrl:G==="stable"?j.stableUrl:j.url;return{url:p.URI.parse(V),type:G,defaultType:F,defaultUrl:p.URI.parse(j.url),stableUrl:p.URI.parse(j.stableUrl),insidersUrl:p.URI.parse(j.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(j.authenticationProviders).reduce((x,H)=>(x.push({id:H,scopes:j.authenticationProviders[H].scopes}),x),[])}}}};e.$SOb=o,e.$SOb=o=Ee([Z(0,E.$yk),Z(1,f.$ej),Z(2,P.$oq)],o);let u=class extends o{constructor(L,j,U){super(L,j,U);const F=this.h.get(h,P.StorageScope.APPLICATION);F&&(this.n=JSON.parse(F));const G=this.f[c];G?this.h.store(h,JSON.stringify(G),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE):this.h.remove(h,P.StorageScope.APPLICATION)}async switch(L){L!==this.c&&(this.c=L,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$TOb=u,e.$TOb=u=Ee([Z(0,E.$yk),Z(1,f.$ej),Z(2,P.$oq)],u);let y=class extends T.$Zc{get donotMakeRequestsUntil(){return this.j}constructor(L,j,U,F,G,V,x){super(),this.n=U,this.r=F,this.s=x,this.g=this.B(new k.$qe),this.onTokenFailed=this.g.event,this.h=this.B(new k.$qe),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new k.$qe),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(L),this.c=(0,d.$uq)(G,V,x).then(H=>{const te={"X-Client-Name":`${j.applicationName}${A.$r?"-web":""}`,"X-Client-Version":j.version};return j.commit&&(te["X-Client-Commit"]=j.commit),te}),this.f=new S(s,r,this.n,this.r),this.u(),this.B((0,T.$Xc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(L,j){this.b={token:L,type:j}}t(L){this.a=L?(0,b.$lh)(L,"v1"):void 0}u(){const L=this.s.getNumber(i,P.StorageScope.APPLICATION);L&&Date.now()<L&&this.y(new Date(L))}y(L){this.j?.getTime()!==L?.getTime()&&(this.j=L,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(i,this.j.getTime(),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),this.w=(0,I.$xh)(j=>(0,I.$Lh)(this.j.getTime()-Date.now(),j).then(()=>this.y(void 0))),this.w.then(null,j=>null)):this.s.remove(i,P.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(L={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,b.$lh)(this.a,"collection").toString();L={...L},L["Content-Type"]="application/json";const U=await this.D(j,{type:"GET",headers:L},[],a.CancellationToken.None);return(await(0,w.$hq)(U))?.map(({id:F})=>F)||[]}async createCollection(L={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,b.$lh)(this.a,"collection").toString();L={...L},L["Content-Type"]=C.$gt.text;const U=await this.D(j,{type:"POST",headers:L},[],a.CancellationToken.None),F=await(0,w.$gq)(U);if(!F)throw new $.$Vpb("Server did not return the collection id",j,$.UserDataSyncErrorCode.NoCollection,U.res.statusCode,U.res.headers[$.$Rpb]);return F}async deleteCollection(L,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=L?(0,b.$lh)(this.a,"collection",L).toString():(0,b.$lh)(this.a,"collection").toString();j={...j},await this.D(U,{type:"DELETE",headers:j},[],a.CancellationToken.None)}async getAllResourceRefs(L,j){if(!this.a)throw new Error("No settings sync store url configured.");const U=this.z(this.a,j,L),F={},G=await this.D(U.toString(),{type:"GET",headers:F},[],a.CancellationToken.None);return(await(0,w.$hq)(G)||[]).map(({url:x,created:H})=>({ref:(0,b.$nh)(U,U.with({path:x})),created:H*1e3}))}async resolveResourceContent(L,j,U,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=(0,b.$lh)(this.z(this.a,U,L),j).toString();F={...F},F["Cache-Control"]="no-cache";const V=await this.D(G,{type:"GET",headers:F},[],a.CancellationToken.None);return await(0,w.$gq)(V)}async deleteResource(L,j,U){if(!this.a)throw new Error("No settings sync store url configured.");const F=j!==null?(0,b.$lh)(this.z(this.a,U,L),j).toString():this.z(this.a,U,L).toString(),G={};await this.D(F,{type:"DELETE",headers:G},[],a.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const L=(0,b.$lh)(this.a,"resource").toString(),j={"Content-Type":C.$gt.text};await this.D(L,{type:"DELETE",headers:j},[],a.CancellationToken.None)}async readResource(L,j,U,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=(0,b.$lh)(this.z(this.a,U,L),"latest").toString();F={...F},F["Cache-Control"]="no-cache",j&&(F["If-None-Match"]=j.ref);const V=await this.D(G,{type:"GET",headers:F},[304],a.CancellationToken.None);let x=null;if(V.res.statusCode===304&&(x=j),x===null){const H=V.res.headers.etag;if(!H)throw new $.$Vpb("Server did not return the ref",G,$.UserDataSyncErrorCode.NoRef,V.res.statusCode,V.res.headers[$.$Rpb]);const te=await(0,w.$gq)(V);if(!te&&V.res.statusCode===304)throw new $.$Vpb("Empty response",G,$.UserDataSyncErrorCode.EmptyResponse,V.res.statusCode,V.res.headers[$.$Rpb]);x={ref:H,content:te}}return x}async writeResource(L,j,U,F,G={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=this.z(this.a,F,L).toString();G={...G},G["Content-Type"]=C.$gt.text,U&&(G["If-Match"]=U);const x=await this.D(V,{type:"POST",data:j,headers:G},[],a.CancellationToken.None),H=x.res.headers.etag;if(!H)throw new $.$Vpb("Server did not return the ref",V,$.UserDataSyncErrorCode.NoRef,x.res.statusCode,x.res.headers[$.$Rpb]);return H}async manifest(L,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,b.$lh)(this.a,"manifest").toString();j={...j},j["Content-Type"]="application/json",L&&(j["If-None-Match"]=L.ref);const F=await this.D(U,{type:"GET",headers:j},[304],a.CancellationToken.None);let G=null;if(F.res.statusCode===304&&(G=L),!G){const x=F.res.headers.etag;if(!x)throw new $.$Vpb("Server did not return the ref",U,$.UserDataSyncErrorCode.NoRef,F.res.statusCode,F.res.headers[$.$Rpb]);const H=await(0,w.$gq)(F);if(!H&&F.res.statusCode===304)throw new $.$Vpb("Empty response",U,$.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[$.$Rpb]);H&&(G={...JSON.parse(H),ref:x})}const V=this.s.get(n,P.StorageScope.APPLICATION);return V&&G&&V!==G.session&&this.C(),G===null&&V&&this.C(),G&&this.s.store(n,G.session,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),G}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const L=(0,b.$lh)(this.a,"download").toString(),j={},U=await this.D(L,{type:"GET",headers:j},[],a.CancellationToken.None);if(!(0,w.$dq)(U))throw new $.$Vpb("Server returned "+U.res.statusCode,L,$.UserDataSyncErrorCode.EmptyResponse,U.res.statusCode,U.res.headers[$.$Rpb]);if((0,w.$eq)(U))throw new $.$Vpb("Empty response",L,$.UserDataSyncErrorCode.EmptyResponse,U.res.statusCode,U.res.headers[$.$Rpb]);return U.stream}z(L,j,U){return j?(0,b.$lh)(L,"collection",j,"resource",U):(0,b.$lh)(L,"resource",U)}C(){this.s.remove(n,P.StorageScope.APPLICATION),this.s.remove(t,P.StorageScope.APPLICATION)}async D(L,j,U,F){if(!this.b)throw new $.$Vpb("No Auth Token Available",L,$.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new $.$Vpb(`${j.type} request '${L}' failed because of too many requests (429).`,L,$.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const G=await this.c;j.headers={...j.headers||{},...G,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(j.headers),this.r.trace("Sending request to server",{url:L,type:j.type,headers:{...j.headers,authorization:void 0}});let V;try{V=await this.f.request(L,j,F)}catch(W){if(!(W instanceof $.$Vpb)){let _=$.UserDataSyncErrorCode.RequestFailed;const ne=(0,N.$bb)(W).toLowerCase();ne.includes("xhr timeout")?_=$.UserDataSyncErrorCode.RequestTimeout:ne.includes("protocol")&&ne.includes("not supported")?_=$.UserDataSyncErrorCode.RequestProtocolNotSupported:ne.includes("request path contains unescaped characters")?_=$.UserDataSyncErrorCode.RequestPathNotEscaped:ne.includes("headers must be an object")?_=$.UserDataSyncErrorCode.RequestHeadersNotObject:(0,N.$8)(W)&&(_=$.UserDataSyncErrorCode.RequestCanceled),W=new $.$Vpb(`Connection refused for the request '${L}'.`,L,_,void 0,void 0)}throw this.r.info("Request failed",L),W}const x=V.res.headers[$.$Rpb],H={url:L,status:V.res.statusCode,"execution-id":j.headers[$.$Spb],"operation-id":x},te=(0,w.$dq)(V)||V.res.statusCode&&U.includes(V.res.statusCode);let z="";if(te?this.r.trace("Request succeeded",H):(z=await(0,w.$fq)(V)||"",this.r.info("Request failed",H,z)),V.res.statusCode===401||V.res.statusCode===403){if(this.b=void 0,V.res.statusCode===401)throw this.g.fire($.UserDataSyncErrorCode.Unauthorized),new $.$Vpb(`${j.type} request '${L}' failed because of Unauthorized (401).`,L,$.UserDataSyncErrorCode.Unauthorized,V.res.statusCode,x);if(V.res.statusCode===403)throw this.g.fire($.UserDataSyncErrorCode.Forbidden),new $.$Vpb(`${j.type} request '${L}' failed because the access is forbidden (403).`,L,$.UserDataSyncErrorCode.Forbidden,V.res.statusCode,x)}if(this.h.fire(),V.res.statusCode===404)throw new $.$Vpb(`${j.type} request '${L}' failed because the requested resource is not found (404).`,L,$.UserDataSyncErrorCode.NotFound,V.res.statusCode,x);if(V.res.statusCode===405)throw new $.$Vpb(`${j.type} request '${L}' failed because the requested endpoint is not found (405). ${z}`,L,$.UserDataSyncErrorCode.MethodNotFound,V.res.statusCode,x);if(V.res.statusCode===409)throw new $.$Vpb(`${j.type} request '${L}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,L,$.UserDataSyncErrorCode.Conflict,V.res.statusCode,x);if(V.res.statusCode===410)throw new $.$Vpb(`${j.type} request '${L}' failed because the requested resource is not longer available (410).`,L,$.UserDataSyncErrorCode.Gone,V.res.statusCode,x);if(V.res.statusCode===412)throw new $.$Vpb(`${j.type} request '${L}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,L,$.UserDataSyncErrorCode.PreconditionFailed,V.res.statusCode,x);if(V.res.statusCode===413)throw new $.$Vpb(`${j.type} request '${L}' failed because of too large payload (413).`,L,$.UserDataSyncErrorCode.TooLarge,V.res.statusCode,x);if(V.res.statusCode===426)throw new $.$Vpb(`${j.type} request '${L}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,L,$.UserDataSyncErrorCode.UpgradeRequired,V.res.statusCode,x);if(V.res.statusCode===429){const W=V.res.headers["retry-after"];throw W?(this.y(new Date(Date.now()+parseInt(W)*1e3)),new $.$Vpb(`${j.type} request '${L}' failed because of too many requests (429).`,L,$.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,V.res.statusCode,x)):new $.$Vpb(`${j.type} request '${L}' failed because of too many requests (429).`,L,$.UserDataSyncErrorCode.TooManyRequests,V.res.statusCode,x)}if(!te)throw new $.$Vpb("Server returned "+V.res.statusCode,L,$.UserDataSyncErrorCode.Unknown,V.res.statusCode,x);return V}F(L){let j=this.s.get(t,P.StorageScope.APPLICATION);j===void 0&&(j=(0,m.$7g)(),this.s.store(t,j,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE)),L["X-Machine-Session-Id"]=j;const U=this.s.get(n,P.StorageScope.APPLICATION);U!==void 0&&(L["X-User-Session-Id"]=U)}};e.$UOb=y,e.$UOb=y=Ee([Z(1,E.$yk),Z(2,w.$bq),Z(3,$.$5pb),Z(4,l.$Ri),Z(5,g.$fl),Z(6,P.$oq)],y);let O=class extends y{constructor(L,j,U,F,G,V,x){super(L.userDataSyncStore?.url,j,U,F,G,V,x),this.B(L.onDidChangeUserDataSyncStore(()=>this.t(L.userDataSyncStore?.url)))}};e.$VOb=O,e.$VOb=O=Ee([Z(0,$.$Opb),Z(1,E.$yk),Z(2,w.$bq),Z(3,$.$5pb),Z(4,l.$Ri),Z(5,g.$fl),Z(6,P.$oq)],O);class S{constructor(L,j,U,F){this.c=L,this.d=j,this.f=U,this.g=F,this.a=[],this.b=void 0}request(L,j,U){if(this.h()&&this.i(),j.url=L,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new $.$Vpb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,L,$.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(L),this.f.request(j,U)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$WOb=S}),define(ue[236],de([0,1,3,2,10,21,23,16,128]),function(ce,e,I,a,N,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=e.$Ijc=e.$Hjc=e.$Gjc=void 0;class b{constructor(l){this.a=l}listen(l,g){switch(g){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${g}`)}call(l,g,E){switch(g){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(E)}throw new Error("Invalid call")}}e.$Gjc=b;class R extends a.$Zc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(l){super(),this.c=l,this.b=this.B(new I.$qe),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(g=>{this.a=g,this.B(this.c.listen("onDidChangeAccount")(E=>{this.a=E,this.b.fire(E)}))})}updateAccount(l){return this.c.call("updateAccount",l)}}e.$Hjc=R;class p{constructor(l){this.a=l}listen(l,g){switch(g){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${g}`)}call(l,g,E){switch(g){case"switch":return this.a.switch(E[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Ijc=p;let m=class extends A.$SOb{constructor(l,g,E,w){super(g,E,w),this.n=l,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(l){return this.n.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.n.call("getPreviousUserDataSyncStore");return this.r(l)}r(l){return{url:N.URI.revive(l.url),type:l.type,defaultUrl:N.URI.revive(l.defaultUrl),insidersUrl:N.URI.revive(l.insidersUrl),stableUrl:N.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.$Jjc=m,e.$Jjc=m=Ee([Z(1,T.$yk),Z(2,k.$ej),Z(3,C.$oq)],m)}),define(ue[237],de([0,1,3,57,23,16,18,232,24,83,87]),function(ce,e,I,a,N,k,T,C,A,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6jc=void 0;let p=class extends C.$ngc{constructor(f,l,g,E,w,d,P,$,c,h,i){super(f,l,g,E,w,P,$,c,h,i),this.B(I.Event.debounce(I.Event.any(I.Event.map(d.onDidFocusMainWindow,()=>"windowFocus"),I.Event.map(d.onDidOpenMainWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$6jc=p,e.$6jc=p=Ee([Z(0,N.$yk),Z(1,A.$Opb),Z(2,A.$Ppb),Z(3,A.$Zpb),Z(4,A.$1pb),Z(5,a.$2hc),Z(6,A.$5pb),Z(7,b.$mNb),Z(8,T.$em),Z(9,R.$Bpb),Z(10,k.$oq)],p)}),define(ue[238],de([0,1,76,22,5,20]),function(ce,e,I,a,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0,e.$phc=T,e.$qhc=C,e.$rhc=A,e.$ohc=128/4;function T(b){function R(){let p=b.scheme===a.Schemas.file?(0,k.$_g)(b):b.toString();return N.$n||(p=p.toLowerCase()),(0,I.createHash)("md5").update(p).digest("hex")}return{id:R(),configPath:b}}function C(b,R){function p(){if(b.scheme!==a.Schemas.file)return(0,I.createHash)("md5").update(b.toString()).digest("hex");if(!R)return;let f;return N.$n?f=R.ino:N.$m?f=R.birthtime.getTime():N.$l&&(typeof R.birthtimeMs=="number"?f=Math.floor(R.birthtimeMs):f=R.birthtime.getTime()),(0,I.createHash)("md5").update(b.fsPath).update(f?String(f):"").digest("hex")}const m=p();if(typeof m=="string")return{id:m,uri:b}}function A(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ue[239],de([0,1,6,8,2,13,30,15,11,80,117,238,57,56,22]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=void 0;let g=class extends N.$Zc{constructor(w,d,P,$){super(),this.a=w,this.b=d,this.c=P,this.f=$,this.B(new I.$Wh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const w=this.a.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,d=await T.Promises.readdir(w),P=new b.$XNb(this.f.getChannel("storage"));await Promise.all(d.map(async $=>{const c=(0,k.$oc)(w,$);$.length===p.$ohc||$===R.$Wi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===$)||await P.isUsed(c)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${$} as it seems to be an unused empty workspace.`),await T.Promises.rm(c))}))}catch(w){(0,a.$4)(w)}}};e.$Cjc=g,e.$Cjc=g=Ee([Z(0,C.$Si),Z(1,A.$fk),Z(2,m.$2hc),Z(3,f.$hjc)],g)}),define(ue[129],de([0,1,76,66,38,247,14,8,3,2,13,5,32,43,72]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Bi=e.$Ai=e.$zi=void 0,e.$Ci=t,e.$Di=s,e.$Fi=u,e.$Gi=y;const g=3e4;class E{traceSocketEvent(S,v){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,v)}constructor(S,v=""){this.f=!0,this.debugLabel=v,this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,C.$4)(j)}},this.socket.on("error",this.a);let L;this.b=j=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:j}),this.f=!1,L&&clearTimeout(L)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,L=setTimeout(()=>S.destroy(),g)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const v=L=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,L),S(T.$Se.wrap(L))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(S){const v=L=>{S({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:L,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(S){const v=()=>{S()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,S),this.socket.write(S.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,C.$4)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,C.$4)(v)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((S,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$zi=E;var w;(function(O){O[O.MinHeaderByteSize=2]="MinHeaderByteSize",O[O.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var d;(function(O){O[O.PeekHeader=1]="PeekHeader",O[O.ReadHeader=2]="ReadHeader",O[O.ReadBody=3]="ReadBody",O[O.Fin=4]="Fin"})(d||(d={}));class P extends b.$Zc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,v){this.socket.traceSocketEvent(S,v)}constructor(S,v,L,j){super(),this.f=this.B(new A.$qe),this.g=this.B(new A.$qe),this.h=!1,this.j={state:d.PeekHeader,readLen:w.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:L?.byteLength||0,recordInflateBytes:j}),this.a=this.B(new $(this,v,L,j,this.f,(U,F)=>this.m(U,F))),this.B(this.a.onError(U=>{console.error(U),(0,C.$4)(U),this.g.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:U})})),this.b=new l.$ui,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await A.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let v=0;for(;v<S.byteLength;)this.a.writeMessage(S.slice(v,Math.min(v+w.MaxWebSocketMessageLength,S.byteLength)),{compressed:!0,opcode:2}),v+=w.MaxWebSocketMessageLength}m(S,{compressed:v,opcode:L}){if(this.h)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,S);let j=w.MinHeaderByteSize;S.byteLength<126?j+=0:S.byteLength<2**16?j+=2:j+=8;const U=T.$Se.alloc(j),F=v?64:0,G=L&15;if(U.writeUInt8(128|F|G,0),S.byteLength<126)U.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){U.writeUInt8(126,1);let V=1;U.writeUInt8(S.byteLength>>>8&255,++V),U.writeUInt8(S.byteLength>>>0&255,++V)}else{U.writeUInt8(127,1);let V=1;U.writeUInt8(0,++V),U.writeUInt8(0,++V),U.writeUInt8(0,++V),U.writeUInt8(0,++V),U.writeUInt8(S.byteLength>>>24&255,++V),U.writeUInt8(S.byteLength>>>16&255,++V),U.writeUInt8(S.byteLength>>>8&255,++V),U.writeUInt8(S.byteLength>>>0&255,++V)}this.socket.write(T.$Se.concat([U,S]))}end(){this.h=!0,this.socket.end()}n(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===d.PeekHeader){const v=this.b.peek(this.j.readLen),L=v.readUInt8(0),j=(L&128)>>>7,U=(L&64)>>>6,F=L&15,G=v.readUInt8(1),V=(G&128)>>>7,x=G&127;this.j.state=d.ReadHeader,this.j.readLen=w.MinHeaderByteSize+(V?4:0)+(x===126?2:0)+(x===127?8:0),this.j.fin=j,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!j,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===d.ReadHeader){const v=this.b.read(this.j.readLen),L=v.readUInt8(1),j=(L&128)>>>7;let U=L&127,F=1;U===126?U=v.readUInt8(++F)*2**8+v.readUInt8(++F):U===127&&(U=v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*2**24+v.readUInt8(++F)*2**16+v.readUInt8(++F)*2**8+v.readUInt8(++F));let G=0;j&&(G=v.readUInt8(++F)*2**24+v.readUInt8(++F)*2**16+v.readUInt8(++F)*2**8+v.readUInt8(++F)),this.j.state=d.ReadBody,this.j.readLen=U,this.j.mask=G,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===d.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),i(v,this.j.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=d.PeekHeader,this.j.readLen=w.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await A.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$Ai=P;class $ extends b.$Zc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Se.alloc(0)}constructor(S,v,L,j,U,F){super(),this.n=S,this.r=U,this.s=F,this.a=this.B(new A.$qe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new A.$qe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new A.$qe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new c(this.n,j,L,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(G=>this.a.fire(G))),this.B(this.f.onError(G=>this.a.fire(G)))):(this.b=null,this.f=null)}writeMessage(S,v){this.g.push({data:S,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:S,options:v}=this.g.shift();if(this.f&&v.compressed){const L=await this.w(this.f,S);this.s(L,v)}else this.s(S,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(S,v){return new Promise((L,j)=>{S.write(v),S.flush(U=>L(U))})}acceptFrame(S,v,L){this.h.push({data:S,isCompressed:v,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const v=await this.C(this.b,S.data,S.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(S.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(S,v,L){return new Promise((j,U)=>{S.write(v),L&&S.write(T.$Se.fromByteArray([0,0,255,255])),S.flush(F=>j(F))})}}class c extends b.$Zc{get recordedInflateBytes(){return this.j?T.$Se.concat(this.f):T.$Se.alloc(0)}constructor(S,v,L,j){super(),this.h=S,this.j=v,this.a=this.B(new A.$qe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,k.createInflateRaw)(j),this.b.on("error",U=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,U),this.g.push(T.$Se.wrap(U))}),L&&(this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=T.$Se.concat(this.g);this.g.length=0,S(v)})}}class h extends b.$Zc{constructor(S,v){super(),this.g=S,this.a=this.B(new A.$qe),this.onError=this.a.event,this.f=[],this.b=(0,k.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,L),this.f.push(T.$Se.wrap(L))})}write(S){this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=T.$Se.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),S(v)})}}function i(O,S){if(S===0)return;const v=O.byteLength>>>2;for(let V=0;V<v;V++){const x=O.readUInt32BE(V*4);O.writeUInt32BE(x^S,V*4)}const L=v*4,j=O.byteLength-L,U=S>>>24&255,F=S>>>16&255,G=S>>>8&255;j>=1&&O.writeUInt8(O.readUInt8(L)^U,L),j>=2&&O.writeUInt8(O.readUInt8(L+1)^F,L+1),j>=3&&O.writeUInt8(O.readUInt8(L+2)^G,L+2)}e.$Bi=process.env.XDG_RUNTIME_DIR;const n={[p.Platform.Linux]:107,[p.Platform.Mac]:103};function t(){const O=(0,m.$7g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${O}-sock`;const S=process.platform!=="darwin"&&e.$Bi?e.$Bi:(0,N.tmpdir)(),v=(0,R.$oc)(S,`vscode-ipc-${O}.sock`);return r(v),v}function s(O,S,v){const j=(0,I.createHash)("sha256").update(O).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${v}-${S}-sock`;const U=v.substr(0,4),F=S.substr(0,6);let G;return process.platform!=="darwin"&&e.$Bi&&!process.env.VSCODE_PORTABLE?G=(0,R.$oc)(e.$Bi,`vscode-${j}-${U}-${F}.sock`):G=(0,R.$oc)(O,`${U}-${F}.sock`),r(G),G}function r(O){const S=n[p.$x];typeof S=="number"&&O.length>=S&&console.warn(`WARNING: IPC handle "${O}" is longer than ${S} chars, try a shorter --user-data-dir`)}class o extends f.$oi{static b(S){const v=A.Event.fromNodeEventEmitter(S,"connection");return A.Event.map(v,L=>({protocol:new l.$vi(new E(L,"ipc-server-connection")),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(L,"close"))}))}constructor(S){super(o.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ei=o;function u(O){return new Promise((S,v)=>{const L=(0,a.createServer)();L.on("error",v),L.listen(O,()=>{L.removeListener("error",v),S(new o(L))})})}function y(O,S){return new Promise((v,L)=>{const j=(0,a.createConnection)(O,()=>{j.removeListener("error",L),v(l.$wi.fromSocket(new E(j,`ipc-client${S}`),S))});j.once("error",L)})}}),define(ue[240],de([0,1,66,129,187]),function(ce,e,I,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=void 0,I=Oe(I),e.$9jc=new class{supports(k){return!0}connect({host:k,port:T},C,A,b){return new Promise((R,p)=>{const m=I.createConnection({host:k,port:T},()=>{m.removeListener("error",p),m.write((0,N.$Hzb)(C,A,b));const f=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",f),R(new a.$zi(m,b)))};m.on("data",f)});m.setNoDelay(!0),m.once("error",p)})}}}),define(ue[241],de([0,1,66,38,141,129,6,2,5,21,11,23,188,108,110,81,14]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjc=e.$ajc=e.$_ic=e.$$ic=void 0,I=Oe(I),a=Oe(a);async function w(h,i,n,t,s){let r;for(let o=3;o&&(r?.dispose(),r=await new d(h,i,n,t,s).waitForReady(),!(s&&N.$0g[s]||!N.$0g[r.tunnelLocalPort]));o--);return r}class d extends C.$Zc{constructor(i,n,t,s,r){super(),this.m=n,this.n=r,this.privacy=g.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=I.createServer(),this.c=new T.$Jh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.r(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,n=(0,g.$Vw)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,N.$$g)(i,2,1e3,n),s=null;return this.b.listen(t,this.m),await this.c.wait(),s=this.b.address(),s||(t=0,this.b.listen(t,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(i){i.pause();const n=(0,g.$Tw)(this.tunnelRemoteHost)||(0,g.$Vw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,m.$8l)(this.a,n,this.tunnelRemotePort),s=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&i.write(r.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),s.end()}),i.on("close",()=>s.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),s instanceof k.$zi?s.socket.destroy():s.end()}),s instanceof k.$zi?this.t(i,s):this.s(i,s),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),s.end()})}s(i,n){n.onClose(()=>i.destroy()),n.onEnd(()=>i.end()),n.onData(t=>i.write(t.buffer)),i.on("data",t=>n.write(E.$Se.wrap(t))),i.resume()}t(i,n){const t=n.socket;t.on("end",()=>i.end()),t.on("close",()=>i.end()),t.on("error",()=>{i.destroy()}),t.pipe(i),i.pipe(t)}}e.$$ic=d;let P=class extends g.$Yw{constructor(i,n,t,s,r){super(n,r),this.H=i,this.I=t,this.J=s}isPortPrivileged(i){return(0,g.$Ww)(i,this.t,A.OS,a.release())}F(i,n,t,s,r,o,u,y){const O=this.D(n,t);if(O)return++O.refcount,O.value;if((0,g.$Pw)(i))return this.G(i,n,t,r,o,u,y);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${t} on local port ${r}.`);const S={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=w(S,s,n,t,r);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(n,t,v),v}}};e.$_ic=P,e.$_ic=P=Ee([Z(0,f.$2l),Z(1,R.$fk),Z(2,l.$5l),Z(3,p.$yk),Z(4,b.$ej)],P);let $=class extends P{constructor(i,n,t,s,r){super(i,n,t,s,r)}};e.$ajc=$,e.$ajc=$=Ee([Z(0,f.$2l),Z(1,R.$fk),Z(2,l.$5l),Z(3,p.$yk),Z(4,b.$ej)],$);let c=class extends C.$Zc{constructor(i,n,t,s,r){super(),this.b=i,this.c=n,this.f=t,this.g=s,this.h=r,this.a=new Map}async openTunnel(i,n,t,s,r,o,u,y,O){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${s} on local port ${o}.`),!this.a.has(i)){const S=new $(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(i,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(n,t,s,r,o,u,y,O)}};e.$bjc=c,e.$bjc=c=Ee([Z(0,f.$2l),Z(1,R.$fk),Z(2,p.$yk),Z(3,l.$5l),Z(4,b.$ej)],c)});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ue[248],de([0,1,38,41,8,2,22,10,17,3,43,154,181,182,191,173,239,164,165,21,186,99,198,100,193,15,120,225,27,112,189,119,75,7,175,176,74,4,172,77,79,201,11,177,104,23,61,16,111,18,113,114,115,48,204,86,116,24,83,231,236,214,87,230,234,235,128,62,229,215,110,197,81,241,192,205,28,206,5,207,166,184,183,85,220,19,52,180,58,228,203,216,109,233,221,9,178,103,226,219,194,160,57,179,237,223,56,227,108,106,240,158,195,150,145,149]),function(ce,e,I,a,N,k,T,C,A,b,R,p,m,f,l,g,E,w,d,P,$,c,h,i,n,t,s,r,o,u,y,O,S,v,L,j,U,F,G,V,x,H,te,z,W,_,ne,le,ee,X,K,q,D,J,oe,Q,Y,M,B,ie,ae,he,pe,be,Ie,ke,ve,we,re,fe,me,Se,Pe,De,Ne,Ce,je,Me,Ve,Fe,Be,ze,We,Le,se,ge,$e,ye,Ae,Te,qe,xe,Je,Ze,He,_e,Ye,nt,at,Ct,Nt,Lt,Tt,Dt,Ut,jt,yt,Ft,vt,Mt,qt,Bt,ht,zt,Wt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,W=it(W);class Vt extends k.$Zc{constructor(Re){super(),this.f=Re,this.a=this.B(new p.$AY(this)),this.b=void 0,this.c=this.B(new b.$qe),this.g()}g(){let Re=!1;const Ue=()=>{Re||(Re=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ue),(0,p.$BY)(process.parentPort,ht.$lic.exit,Ue)}async init(){const Re=await this.h();(0,M.$Jpb)(),Re.invokeFunction(Ue=>{const Ke=Ue.get(te.$fk),Ge=Ue.get(X.$em),et=Ue.get(ge.$Rl);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ue),this.m(Ke),this.n(Ge,et),this.B(et.onDidChangeProfiles(()=>this.n(Ge,et))),this.r(Ge,Ke)}),this.B((0,k.$Wc)(Re.createInstance(m.$yjc,this.f.codeCachePath),Re.createInstance(f.$zjc),Re.createInstance(E.$Cjc),Re.createInstance(g.$Bjc),Re.createInstance(l.$Ajc),Re.createInstance(He.$Zjc),Re.createInstance(xe.$Rjc)))}async h(){const Re=new V.$Ii,Ue={_serviceBrand:void 0,...W.default};Re.set(_.$yk,Ue);const Ke=new R.$si(Qe=>Qe==="main"),Ge=new yt.$ijc(this.a,Ke);Re.set(yt.$hjc,Ge);const et=this.f.policiesData?new ye.$Oic(this.f.policiesData,Ge.getChannel("policy")):new Ae.$Bo;Re.set(Ae.$zo,et);const Xe=new Bt.$cn(this.f.args,Ue);Re.set(t.$Si,Xe);const ot=new z.$Bs(void 0,this.f.logLevel,Xe.logsHome,this.f.loggers.map(Qe=>({...Qe,resource:C.URI.revive(Qe.resource)})),Ge.getChannel("logger"));Re.set(te.$gk,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(172,null)})),$t=this.B(new te.$nk(ft.getLevel())),tt=this.B(new Ye.$$R(ft,[$t]));Re.set(te.$fk,tt),this.b=this.B(new nt.$2jc(tt)),Re.set(nt.$1jc,this.b);const st=this.B(new L.$$q(tt));Re.set(v.$fl,st);const pt=this.B(new j.$Br(tt));st.registerProvider(T.Schemas.file,pt);const dt=new Me.$3s(st);Re.set(je.$Pl,dt);const rt=this.B(new Te.$fS(this.f.profiles.all,C.URI.revive(this.f.profiles.home).with({scheme:Xe.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));Re.set(ge.$Rl,rt);const wt=this.B(new Fe.$gjc(T.Schemas.file,this.B(new Be.$TR(Ge.getChannel(Be.$SR),{pathCaseSensitive:Ve.$n})),T.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(T.Schemas.vscodeUserData,wt);const ct=this.B(new $.$4o(rt.defaultProfile.settingsResource,st,et,tt));Re.set(P.$ej,ct);const bt=new Ft.$8jc(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ge,Xe);Re.set(le.$oq,bt),this.B((0,k.$Xc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const Rt=new Nt.$ls(Ge.getChannel("request"));Re.set(ne.$bq,Rt),Re.set(w.$Djc,new U.$Hi(d.$Ejc,void 0,!1)),Re.set(We.$gH,new U.$Hi(ze.$Qjc,void 0,!1));const It=new Dt.$kjc(-1,Ge);Re.set(Tt.$2hc,It),Re.set(i.$8o,new U.$Hi(n.$pS,void 0,!0));const Gt=this.B(new fe.$Lic(It)),Kt=new R.$si(Qe=>Gt.getActiveClientId().then(mt=>Qe===mt));Re.set(S.$Q8b,new Lt.$4jc(this.a.getChannel("extensionRecommendationNotification",Kt)));let gt;const lt=[],Pt=(0,J.$Pp)(Ue,ct);if((0,J.$Kp)(Ue,Xe)){const Qe=new q.$Efc(tt,ot,Xe,Ue);if(lt.push(Qe),!(0,J.$Lp)(Ue,Xe)&&Ue.aiConfig?.ariaKey){const mt=new qe.$YR(Rt,Pt,"monacoworkbench",null,Ue.aiConfig.ariaKey);this.B((0,k.$Xc)(()=>mt.flush())),lt.push(mt)}gt=new D.$ps({appenders:lt,commonProperties:(0,ee.$Bp)((0,I.release)(),(0,I.hostname)(),process.arch,Ue.commit,Ue.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Pt),sendErrorTelemetry:!0,piiPaths:(0,J.$Qp)(Xe)},ct,Ue)}else{gt=J.$Fp;const Qe=J.$Jp;lt.push(Qe)}this.a.registerChannel("telemetryAppender",new K.$qic(lt)),Re.set(X.$em,gt);const Jt=new oe.$Fjc(ct,gt,tt,ot,Xe,Ue);Re.set(X.$fm,Jt),Re.set($e.$Rq,new U.$Hi(Ct.$0R,void 0,!0)),Re.set(Le.$Vq,new U.$Hi(se.$Pic,void 0,!0)),Re.set(u.$Bq,new U.$Hi(u.$Dq,void 0,!0)),Re.set(O.$7q,new U.$Hi(O.$8q,void 0,!0)),Re.set(o.$rp,new U.$Hi(r.$xq,void 0,!0)),Re.set(o.$yp,new U.$Hi(jt.$7jc,void 0,!1)),Re.set(x.$hs,new U.$Hi(H.$js,void 0,!1)),Re.set(c.$Ym,new U.$Hi(h.$0s,void 0,!1)),Re.set(B.$mNb,new U.$Hi(B.$nNb,void 0,!0)),Re.set(M.$5pb,new U.$Hi(he.$VPb,void 0,!0)),Re.set(M.$4pb,R.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),Re.set(o.$xp,new U.$Hi(s.$kNb,void 0,!1)),Re.set(Y.$TPb,new U.$Hi(Y.$UPb,void 0,!0)),Re.set(Q.$zw,new U.$Hi(Q.$Aw)),Re.set(M.$Opb,new U.$Hi(ve.$TOb,void 0,!0)),Re.set(M.$Ppb,new U.$Hi(ve.$VOb,void 0,!0)),Re.set(pe.$Bpb,new U.$Hi(pe.$Dpb,void 0,!0)),Re.set(M.$Qpb,new U.$Hi(ie.$hgc,void 0,!1)),Re.set(M.$Zpb,new U.$Hi(be.$9fc,void 0,!0)),Re.set(M.$1pb,new U.$Hi(Ie.$mgc,void 0,!1)),Re.set(we.$YNb,new U.$Hi(re.$Mjc,void 0,!0)),Re.set(M.$2pb,new U.$Hi(Ze.$4gc,void 0,!0)),Re.set(me.$5l,new U.$Hi(Se.$djc,void 0,!1));const Ot=new vt.$3l;return Re.set(vt.$2l,Ot),Ot.register(Mt.RemoteConnectionType.WebSocket,qt.$9jc),Re.set(Pe.$Ow,new U.$Hi(De.$bjc)),Re.set(Ne.$Njc,new U.$Hi(Ce.$Pjc)),Re.set(Je.$Sjc,new U.$Hi(at.$3jc)),new G.$Er(Re)}j(Re){const Ue=new y.$Fq(Re.get(o.$up),()=>null);this.a.registerChannel("extensions",Ue);const Ke=R.ProxyChannel.fromService(Re.get(x.$hs),this.q);this.a.registerChannel("languagePacks",Ke);const Ge=R.ProxyChannel.fromService(Re.get(c.$Ym),this.q);this.a.registerChannel("diagnostics",Ge);const et=new y.$Hq(Re.get(o.$yp));this.a.registerChannel("extensionTipsService",et);const Xe=R.ProxyChannel.fromService(Re.get(w.$Djc),this.q);this.a.registerChannel("checksum",Xe);const ot=R.ProxyChannel.fromService(Re.get(We.$gH),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=R.ProxyChannel.fromService(Re.get(pe.$Bpb),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=R.ProxyChannel.fromService(Re.get(X.$fm),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new ae.$Gjc(Re.get(B.$mNb));this.a.registerChannel("userDataSyncAccount",tt);const st=new ae.$Ijc(Re.get(M.$Opb));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new ke.$Kjc(Re.get(M.$1pb),Re.get(ge.$Rl),Re.get(te.$fk));this.a.registerChannel("userDataSync",pt);const dt=this.B(Re.get(F.$Ji).createInstance(Ut.$6jc));this.a.registerChannel("userDataAutoSync",R.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",R.ProxyChannel.fromService(Re.get(M.$2pb),this.q));const rt=R.ProxyChannel.fromService(Re.get(Ne.$Njc),this.q);this.a.registerChannel(Ne.$Ojc,rt);const wt=R.ProxyChannel.fromService(Re.get(Je.$Sjc),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Re){process.on("uncaughtException",Ue=>(0,N.$4)(Ue)),process.on("unhandledRejection",Ue=>(0,N.$4)(Ue)),(0,N.setUnexpectedErrorHandler)(Ue=>{const Ke=(0,a.$vj)(Ue,!0);Ke&&Re.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Re,Ue){Re.publicLog2("profilesInfo",{count:Ue.profiles.length})}async r(Re,Ue){if(Ve.$n){const[Ke,Ge]=await Promise.all([(0,zt.$8g)(Ue.error.bind(Ue)),(0,Et.$iY)(Ue.error.bind(Ue))]),et=(0,Wt.$XX)(),Xe=(0,Et.$jY)(Ge,this.f.args["ozone-platform"]);Ke&&Re.publicLog2("clientPlatformInfo",{platformId:Ke.id,platformVersionId:Ke.version_id,platformIdLike:Ke.id_like,desktopEnvironment:et,displayProtocol:Ge,codeDisplayProtocol:Xe})}}handledClientConnection(Re){if(Re.data!==ht.$nic.response)return!1;const Ue=(0,A.$Sb)(Re.ports);return Ue?(this.c.fire(Ue),!0):!1}}async function St(ut){try{const Re=new Vt(ut);process.parentPort.postMessage(ht.$lic.ipcReady),await Re.init(),process.parentPort.postMessage(ht.$lic.initDone)}catch(Re){process.parentPort.postMessage({error:Re.toString()})}}const Ht=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Ht),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/d1388fd24fc0acf17ae1f759e85c1acf559ed759/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
