/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/base/common/charCode","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/marshalling","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/iterator","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/ternarySearchTree","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/lazy","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/services/search/common/searchExtTypes","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/base/common/extpath","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/searchExtConversionTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Te=function(we){for(var e=[],v=0,D=we.length;v<D;v++)e[v]=Re[we[v]];return e};define(Re[71],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=D,e.$di=P,e.$ei=L;function v(R){return(O,m,s)=>{let I=null,w=null;if(typeof s.value=="function"?(I="value",w=s.value):typeof s.get=="function"&&(I="get",w=s.get),!w)throw new Error("not supported");s[I]=R(w,m)}}function D(R,O,m){let s=null,I=null;if(typeof m.value=="function"?(s="value",I=m.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(s="get",I=m.get),!I)throw new Error("not supported");const w=`$memoize$${O}`;m[s]=function(...u){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[w]}}function P(R,O,m){return v((s,I)=>{const w=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...E){this[u]||(this[u]=m?m():void 0),clearTimeout(this[w]),O&&(this[u]=O(this[u],...E),E=[this[u]]),this[w]=setTimeout(()=>{s.apply(this,E),this[u]=m?m():void 0},R)}})}function L(R,O,m){return v((s,I)=>{const w=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,E=`$throttle$lastRun$${I}`,p=`$throttle$pending$${I}`;return function(...r){if(this[u]||(this[u]=m?m():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),O&&(this[u]=O(this[u],...r)),this[p])return;const l=this[E]+R;l<=Date.now()?(this[E]=Date.now(),s.apply(this,[this[u]]),this[u]=m?m():void 0):(this[p]=!0,this[w]=setTimeout(()=>{this[p]=!1,this[E]=Date.now(),s.apply(this,[this[u]]),this[u]=m?m():void 0},l-Date.now()))}})}});var Kn=this&&this.__createBinding||(Object.create?function(we,e,v,D){D===void 0&&(D=v);var P=Object.getOwnPropertyDescriptor(e,v);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(we,D,P)}:function(we,e,v,D){D===void 0&&(D=v),we[D]=e[v]}),Hn=this&&this.__setModuleDefault||(Object.create?function(we,e){Object.defineProperty(we,"default",{enumerable:!0,value:e})}:function(we,e){we.default=e}),Ve=this&&this.__importStar||function(we){if(we&&we.__esModule)return we;var e={};if(we!=null)for(var v in we)v!=="default"&&Object.prototype.hasOwnProperty.call(we,v)&&Kn(e,we,v);return Hn(e,we),e};define(Re[136],Te([1,0,17]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$c=void 0,e.$_c=P,e.$ad=L,e.$bd=R,e.$cd=O,e.$dd=m,e.$ed=s,v=Ve(v);const D=(E,p)=>E===p;e.$$c=D;function P(E=e.$$c){return(p,r)=>v.$yb(p,r,E)}function L(){return(E,p)=>JSON.stringify(E)===JSON.stringify(p)}function R(){return(E,p)=>E.equals(p)}function O(E,p,r){if(r!==void 0){const l=E;return l==null||p===void 0||p===null?p===l:r(l,p)}else{const l=E;return(d,a)=>d==null||a===void 0||a===null?a===d:l(d,a)}}function m(E,p){if(E===p)return!0;if(Array.isArray(E)&&Array.isArray(p)){if(E.length!==p.length)return!1;for(let r=0;r<E.length;r++)if(!m(E[r],p[r]))return!1;return!0}if(E&&typeof E=="object"&&p&&typeof p=="object"&&Object.getPrototypeOf(E)===Object.prototype&&Object.getPrototypeOf(p)===Object.prototype){const r=E,l=p,d=Object.keys(r),a=Object.keys(l),i=new Set(a);if(d.length!==a.length)return!1;for(const n of d)if(!i.has(n)||!m(r[n],l[n]))return!1;return!0}return!1}function s(E){return JSON.stringify(u(E))}let I=0;const w=new WeakMap;function u(E){if(Array.isArray(E))return E.map(u);if(E&&typeof E=="object")if(Object.getPrototypeOf(E)===Object.prototype){const p=E,r=Object.create(null);for(const l of Object.keys(p).sort())r[l]=u(p[l]);return r}else{let p=w.get(E);return p===void 0&&(p=I++,w.set(E,p)),p+"----2b76a038c20c4bcc"}return E}}),define(Re[97],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QQ=e.$PQ=void 0;class v{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$PQ=v,e.$QQ=new v("id#")}),define(Re[137],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$3n=R,e.$4n=w,e.$5n=u,e.$6n=E,e.$7n=p,e.$8n=r,e.$9n=l,e.$0n=d,e.$$n=a,e.$_n=i,e.$ao=n;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,o=!1){let c=0;const g=t.length;let f="",h=0,S=D.Unknown,k=v.None;function y(F){let G=0,x=0;for(;G<F;){const j=t.charCodeAt(c);if(j>=I._0&&j<=I._9)x=x*16+j-I._0;else if(j>=I.A&&j<=I.F)x=x*16+j-I.A+10;else if(j>=I.a&&j<=I.f)x=x*16+j-I.a+10;else break;c++,G++}return G<F&&(x=-1),x}function C(F){c=F,f="",h=0,S=D.Unknown,k=v.None}function T(){const F=c;if(t.charCodeAt(c)===I._0)c++;else for(c++;c<t.length&&s(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===I.dot)if(c++,c<t.length&&s(t.charCodeAt(c)))for(c++;c<t.length&&s(t.charCodeAt(c));)c++;else return k=v.UnexpectedEndOfNumber,t.substring(F,c);let G=c;if(c<t.length&&(t.charCodeAt(c)===I.E||t.charCodeAt(c)===I.e))if(c++,(c<t.length&&t.charCodeAt(c)===I.plus||t.charCodeAt(c)===I.minus)&&c++,c<t.length&&s(t.charCodeAt(c))){for(c++;c<t.length&&s(t.charCodeAt(c));)c++;G=c}else k=v.UnexpectedEndOfNumber;return t.substring(F,G)}function $(){let F="",G=c;for(;;){if(c>=g){F+=t.substring(G,c),k=v.UnexpectedEndOfString;break}const x=t.charCodeAt(c);if(x===I.doubleQuote){F+=t.substring(G,c),c++;break}if(x===I.backslash){if(F+=t.substring(G,c),c++,c>=g){k=v.UnexpectedEndOfString;break}switch(t.charCodeAt(c++)){case I.doubleQuote:F+='"';break;case I.backslash:F+="\\";break;case I.slash:F+="/";break;case I.b:F+="\b";break;case I.f:F+="\f";break;case I.n:F+=`
`;break;case I.r:F+="\r";break;case I.t:F+="	";break;case I.u:{const U=y(4);U>=0?F+=String.fromCharCode(U):k=v.InvalidUnicode;break}default:k=v.InvalidEscapeCharacter}G=c;continue}if(x>=0&&x<=31)if(m(x)){F+=t.substring(G,c),k=v.UnexpectedEndOfString;break}else k=v.InvalidCharacter;c++}return F}function b(){if(f="",k=v.None,h=c,c>=g)return h=g,S=D.EOF;let F=t.charCodeAt(c);if(O(F)){do c++,f+=String.fromCharCode(F),F=t.charCodeAt(c);while(O(F));return S=D.Trivia}if(m(F))return c++,f+=String.fromCharCode(F),F===I.carriageReturn&&t.charCodeAt(c)===I.lineFeed&&(c++,f+=`
`),S=D.LineBreakTrivia;switch(F){case I.openBrace:return c++,S=D.OpenBraceToken;case I.closeBrace:return c++,S=D.CloseBraceToken;case I.openBracket:return c++,S=D.OpenBracketToken;case I.closeBracket:return c++,S=D.CloseBracketToken;case I.colon:return c++,S=D.ColonToken;case I.comma:return c++,S=D.CommaToken;case I.doubleQuote:return c++,f=$(),S=D.StringLiteral;case I.slash:{const G=c-1;if(t.charCodeAt(c+1)===I.slash){for(c+=2;c<g&&!m(t.charCodeAt(c));)c++;return f=t.substring(G,c),S=D.LineCommentTrivia}if(t.charCodeAt(c+1)===I.asterisk){c+=2;const x=g-1;let j=!1;for(;c<x;){if(t.charCodeAt(c)===I.asterisk&&t.charCodeAt(c+1)===I.slash){c+=2,j=!0;break}c++}return j||(c++,k=v.UnexpectedEndOfComment),f=t.substring(G,c),S=D.BlockCommentTrivia}return f+=String.fromCharCode(F),c++,S=D.Unknown}case I.minus:if(f+=String.fromCharCode(F),c++,c===g||!s(t.charCodeAt(c)))return S=D.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return f+=T(),S=D.NumericLiteral;default:for(;c<g&&N(F);)c++,F=t.charCodeAt(c);if(h!==c){switch(f=t.substring(h,c),f){case"true":return S=D.TrueKeyword;case"false":return S=D.FalseKeyword;case"null":return S=D.NullKeyword}return S=D.Unknown}return f+=String.fromCharCode(F),c++,S=D.Unknown}}function N(F){if(O(F)||m(F))return!1;switch(F){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function A(){let F;do F=b();while(F>=D.LineCommentTrivia&&F<=D.Trivia);return F}return{setPosition:C,getPosition:()=>c,scan:o?A:b,getToken:()=>S,getTokenValue:()=>f,getTokenOffset:()=>h,getTokenLength:()=>c-h,getTokenError:()=>k}}function O(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function m(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function s(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function w(t,o){const c=[],g=new Object;let f;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function k(y,C,T,$){h.value=y,h.offset=C,h.length=T,h.type=$,h.colonOffset=void 0,f=h}try{i(t,{onObjectBegin:(y,C)=>{if(o<=y)throw g;f=void 0,S=o>y,c.push("")},onObjectProperty:(y,C,T)=>{if(o<C||(k(y,C,T,"property"),c[c.length-1]=y,o<=C+T))throw g},onObjectEnd:(y,C)=>{if(o<=y)throw g;f=void 0,c.pop()},onArrayBegin:(y,C)=>{if(o<=y)throw g;f=void 0,c.push(0)},onArrayEnd:(y,C)=>{if(o<=y)throw g;f=void 0,c.pop()},onLiteralValue:(y,C,T)=>{if(o<C||(k(y,C,T,n(y)),o<=C+T))throw g},onSeparator:(y,C,T)=>{if(o<=C)throw g;if(y===":"&&f&&f.type==="property")f.colonOffset=C,S=!1,f=void 0;else if(y===","){const $=c[c.length-1];typeof $=="number"?c[c.length-1]=$+1:(S=!0,c[c.length-1]=""),f=void 0}}})}catch(y){if(y!==g)throw y}return{path:c,previousNode:f,isAtPropertyKey:S,matches:y=>{let C=0;for(let T=0;C<y.length&&T<c.length;T++)if(y[C]===c[T]||y[C]==="*")C++;else if(y[C]!=="**")return!1;return C===y.length}}}function u(t,o=[],c=L.DEFAULT){let g=null,f=[];const h=[];function S(y){Array.isArray(f)?f.push(y):g!==null&&(f[g]=y)}return i(t,{onObjectBegin:()=>{const y={};S(y),h.push(f),f=y,g=null},onObjectProperty:y=>{g=y},onObjectEnd:()=>{f=h.pop()},onArrayBegin:()=>{const y=[];S(y),h.push(f),f=y,g=null},onArrayEnd:()=>{f=h.pop()},onLiteralValue:S,onError:(y,C,T)=>{o.push({error:y,offset:C,length:T})}},c),f[0]}function E(t,o=[],c=L.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(y){g.type==="property"&&(g.length=y-g.offset,g=g.parent)}function h(y){return g.children.push(y),y}i(t,{onObjectBegin:y=>{g=h({type:"object",offset:y,length:-1,parent:g,children:[]})},onObjectProperty:(y,C,T)=>{g=h({type:"property",offset:C,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:y,offset:C,length:T,parent:g})},onObjectEnd:(y,C)=>{g.length=y+C-g.offset,g=g.parent,f(y+C)},onArrayBegin:(y,C)=>{g=h({type:"array",offset:y,length:-1,parent:g,children:[]})},onArrayEnd:(y,C)=>{g.length=y+C-g.offset,g=g.parent,f(y+C)},onLiteralValue:(y,C,T)=>{h({type:n(y),offset:C,length:T,parent:g,value:y}),f(C+T)},onSeparator:(y,C,T)=>{g.type==="property"&&(y===":"?g.colonOffset=C:y===","&&f(C))},onError:(y,C,T)=>{o.push({error:y,offset:C,length:T})}},c);const k=g.children[0];return k&&delete k.parent,k}function p(t,o){if(!t)return;let c=t;for(const g of o)if(typeof g=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let f=!1;for(const h of c.children)if(Array.isArray(h.children)&&h.children[0].value===g){c=h.children[1],f=!0;break}if(!f)return}else{const f=g;if(c.type!=="array"||f<0||!Array.isArray(c.children)||f>=c.children.length)return;c=c.children[f]}return c}function r(t){if(!t.parent||!t.parent.children)return[];const o=r(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;o.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&o.push(c)}return o}function l(t){switch(t.type){case"array":return t.children.map(l);case"object":{const o=Object.create(null);for(const c of t.children){const g=c.children[1];g&&(o[c.children[0].value]=l(g))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function d(t,o,c=!1){return o>=t.offset&&o<t.offset+t.length||c&&o===t.offset+t.length}function a(t,o,c=!1){if(d(t,o,c)){const g=t.children;if(Array.isArray(g))for(let f=0;f<g.length&&g[f].offset<=o;f++){const h=a(g[f],o,c);if(h)return h}return t}}function i(t,o,c=L.DEFAULT){const g=R(t,!1);function f(ie){return ie?()=>ie(g.getTokenOffset(),g.getTokenLength()):()=>!0}function h(ie){return ie?ue=>ie(ue,g.getTokenOffset(),g.getTokenLength()):()=>!0}const S=f(o.onObjectBegin),k=h(o.onObjectProperty),y=f(o.onObjectEnd),C=f(o.onArrayBegin),T=f(o.onArrayEnd),$=h(o.onLiteralValue),b=h(o.onSeparator),N=f(o.onComment),A=h(o.onError),F=c&&c.disallowComments,G=c&&c.allowTrailingComma;function x(){for(;;){const ie=g.scan();switch(g.getTokenError()){case v.InvalidUnicode:j(P.InvalidUnicode);break;case v.InvalidEscapeCharacter:j(P.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:j(P.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:F||j(P.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:j(P.UnexpectedEndOfString);break;case v.InvalidCharacter:j(P.InvalidCharacter);break}switch(ie){case D.LineCommentTrivia:case D.BlockCommentTrivia:F?j(P.InvalidCommentToken):N();break;case D.Unknown:j(P.InvalidSymbol);break;case D.Trivia:case D.LineBreakTrivia:break;default:return ie}}}function j(ie,ue=[],_=[]){if(A(ie),ue.length+_.length>0){let $e=g.getToken();for(;$e!==D.EOF;){if(ue.indexOf($e)!==-1){x();break}else if(_.indexOf($e)!==-1)break;$e=x()}}}function U(ie){const ue=g.getTokenValue();return ie?$(ue):k(ue),x(),!0}function J(){switch(g.getToken()){case D.NumericLiteral:{let ie=0;try{ie=JSON.parse(g.getTokenValue()),typeof ie!="number"&&(j(P.InvalidNumberFormat),ie=0)}catch{j(P.InvalidNumberFormat)}$(ie);break}case D.NullKeyword:$(null);break;case D.TrueKeyword:$(!0);break;case D.FalseKeyword:$(!1);break;default:return!1}return x(),!0}function Z(){return g.getToken()!==D.StringLiteral?(j(P.PropertyNameExpected,[],[D.CloseBraceToken,D.CommaToken]),!1):(U(!1),g.getToken()===D.ColonToken?(b(":"),x(),oe()||j(P.ValueExpected,[],[D.CloseBraceToken,D.CommaToken])):j(P.ColonExpected,[],[D.CloseBraceToken,D.CommaToken]),!0)}function ae(){S(),x();let ie=!1;for(;g.getToken()!==D.CloseBraceToken&&g.getToken()!==D.EOF;){if(g.getToken()===D.CommaToken){if(ie||j(P.ValueExpected,[],[]),b(","),x(),g.getToken()===D.CloseBraceToken&&G)break}else ie&&j(P.CommaExpected,[],[]);Z()||j(P.ValueExpected,[],[D.CloseBraceToken,D.CommaToken]),ie=!0}return y(),g.getToken()!==D.CloseBraceToken?j(P.CloseBraceExpected,[D.CloseBraceToken],[]):x(),!0}function ee(){C(),x();let ie=!1;for(;g.getToken()!==D.CloseBracketToken&&g.getToken()!==D.EOF;){if(g.getToken()===D.CommaToken){if(ie||j(P.ValueExpected,[],[]),b(","),x(),g.getToken()===D.CloseBracketToken&&G)break}else ie&&j(P.CommaExpected,[],[]);oe()||j(P.ValueExpected,[],[D.CloseBracketToken,D.CommaToken]),ie=!0}return T(),g.getToken()!==D.CloseBracketToken?j(P.CloseBracketExpected,[D.CloseBracketToken],[]):x(),!0}function oe(){switch(g.getToken()){case D.OpenBracketToken:return ee();case D.OpenBraceToken:return ae();case D.StringLiteral:return U(!0);default:return J()}}return x(),g.getToken()===D.EOF?c.allowEmptyContent?!0:(j(P.ValueExpected,[],[]),!1):oe()?(g.getToken()!==D.EOF&&j(P.EndOfFileExpected,[],[]),!0):(j(P.ValueExpected,[],[]),!1)}function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Re[138],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=v;function v(L){let R=!1;const O=new Map,m=new Map;if(P(L,r=>{if(L===r)return!0;const l=JSON.stringify(r);if(l.length<30)return!0;const d=O.get(l);if(!d){const a={schemas:[r]};return O.set(l,a),m.set(r,a),!0}return d.schemas.push(r),m.set(r,d),R=!0,!1}),O.clear(),!R)return JSON.stringify(L);let I="$defs";for(;L.hasOwnProperty(I);)I+="_";const w=[];function u(r){return JSON.stringify(r,(l,d)=>{if(d!==r){const a=m.get(d);if(a&&a.schemas.length>1)return a.id||(a.id=`_${w.length}`,w.push(a.schemas[0])),{$ref:`#/${I}/${a.id}`}}return d})}const E=u(L),p=[];for(let r=0;r<w.length;r++)p.push(`"_${r}":${u(w[r])}`);return p.length?`${E.substring(0,E.length-1)},"${I}":{${p.join(",")}}}`:E}function D(L){return typeof L=="object"&&L!==null}function P(L,R){if(!L||typeof L!="object")return;const O=(...E)=>{for(const p of E)D(p)&&w.push(p)},m=(...E)=>{for(const p of E)if(D(p))for(const r in p){const l=p[r];D(l)&&w.push(l)}},s=(...E)=>{for(const p of E)if(Array.isArray(p))for(const r of p)D(r)&&w.push(r)},I=E=>{if(Array.isArray(E))for(const p of E)D(p)&&w.push(p);else D(E)&&w.push(E)},w=[L];let u=w.pop();for(;u;)R(u)&&(O(u.additionalItems,u.additionalProperties,u.not,u.contains,u.propertyNames,u.if,u.then,u.else,u.unevaluatedItems,u.unevaluatedProperties),m(u.definitions,u.$defs,u.properties,u.patternProperties,u.dependencies,u.dependentSchemas),s(u.anyOf,u.allOf,u.oneOf,u.prefixItems),I(u.items)),u=w.pop()}}),function(we,e){typeof define=="function"&&define.amd?define(Re[139],Te([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(we=typeof globalThis<"u"?globalThis:we||self,e(we.marked={}))}(this,function(we){"use strict";function e(){return{async:!1,breaks:!1,extensions:null,gfm:!0,hooks:null,pedantic:!1,renderer:null,silent:!1,tokenizer:null,walkTokens:null}}we.defaults=e();function v(Ye){we.defaults=Ye}const D=/[&<>"']/,P=new RegExp(D.source,"g"),L=/[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/,R=new RegExp(L.source,"g"),O={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=Ye=>O[Ye];function s(Ye,he){if(he){if(D.test(Ye))return Ye.replace(P,m)}else if(L.test(Ye))return Ye.replace(R,m);return Ye}const I=/(^|[^\[])\^/g;function w(Ye,he){let pe=typeof Ye=="string"?Ye:Ye.source;he=he||"";const ye={replace:(Ce,fe)=>{let ve=typeof fe=="string"?fe:fe.source;return ve=ve.replace(I,"$1"),pe=pe.replace(Ce,ve),ye},getRegex:()=>new RegExp(pe,he)};return ye}function u(Ye){try{Ye=encodeURI(Ye).replace(/%25/g,"%")}catch{return null}return Ye}const E={exec:()=>null};function p(Ye,he){const pe=Ye.replace(/\|/g,(fe,ve,Y)=>{let q=!1,de=ve;for(;--de>=0&&Y[de]==="\\";)q=!q;return q?"|":" |"}),ye=pe.split(/ \|/);let Ce=0;if(ye[0].trim()||ye.shift(),ye.length>0&&!ye[ye.length-1].trim()&&ye.pop(),he)if(ye.length>he)ye.splice(he);else for(;ye.length<he;)ye.push("");for(;Ce<ye.length;Ce++)ye[Ce]=ye[Ce].trim().replace(/\\\|/g,"|");return ye}function r(Ye,he,pe){const ye=Ye.length;if(ye===0)return"";let Ce=0;for(;Ce<ye;){const fe=Ye.charAt(ye-Ce-1);if(fe===he&&!pe)Ce++;else if(fe!==he&&pe)Ce++;else break}return Ye.slice(0,ye-Ce)}function l(Ye,he){if(Ye.indexOf(he[1])===-1)return-1;let pe=0;for(let ye=0;ye<Ye.length;ye++)if(Ye[ye]==="\\")ye++;else if(Ye[ye]===he[0])pe++;else if(Ye[ye]===he[1]&&(pe--,pe<0))return ye;return-1}function d(Ye,he,pe,ye){const Ce=he.href,fe=he.title?s(he.title):null,ve=Ye[1].replace(/\\([\[\]])/g,"$1");if(Ye[0].charAt(0)!=="!"){ye.state.inLink=!0;const Y={type:"link",raw:pe,href:Ce,title:fe,text:ve,tokens:ye.inlineTokens(ve)};return ye.state.inLink=!1,Y}return{type:"image",raw:pe,href:Ce,title:fe,text:s(ve)}}function a(Ye,he){const pe=Ye.match(/^(\s+)(?:```)/);if(pe===null)return he;const ye=pe[1];return he.split(`
`).map(Ce=>{const fe=Ce.match(/^\s+/);if(fe===null)return Ce;const[ve]=fe;return ve.length>=ye.length?Ce.slice(ye.length):Ce}).join(`
`)}class i{options;rules;lexer;constructor(he){this.options=he||we.defaults}space(he){const pe=this.rules.block.newline.exec(he);if(pe&&pe[0].length>0)return{type:"space",raw:pe[0]}}code(he){const pe=this.rules.block.code.exec(he);if(pe){const ye=pe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:pe[0],codeBlockStyle:"indented",text:this.options.pedantic?ye:r(ye,`
`)}}}fences(he){const pe=this.rules.block.fences.exec(he);if(pe){const ye=pe[0],Ce=a(ye,pe[3]||"");return{type:"code",raw:ye,lang:pe[2]?pe[2].trim().replace(this.rules.inline.anyPunctuation,"$1"):pe[2],text:Ce}}}heading(he){const pe=this.rules.block.heading.exec(he);if(pe){let ye=pe[2].trim();if(/#$/.test(ye)){const Ce=r(ye,"#");(this.options.pedantic||!Ce||/ $/.test(Ce))&&(ye=Ce.trim())}return{type:"heading",raw:pe[0],depth:pe[1].length,text:ye,tokens:this.lexer.inline(ye)}}}hr(he){const pe=this.rules.block.hr.exec(he);if(pe)return{type:"hr",raw:r(pe[0],`
`)}}blockquote(he){const pe=this.rules.block.blockquote.exec(he);if(pe){let ye=r(pe[0],`
`).split(`
`),Ce="",fe="";const ve=[];for(;ye.length>0;){let Y=!1;const q=[];let de;for(de=0;de<ye.length;de++)if(/^ {0,3}>/.test(ye[de]))q.push(ye[de]),Y=!0;else if(!Y)q.push(ye[de]);else break;ye=ye.slice(de);const je=q.join(`
`),Qe=je.replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g,`
    $1`).replace(/^ {0,3}>[ \t]?/gm,"");Ce=Ce?`${Ce}
${je}`:je,fe=fe?`${fe}
${Qe}`:Qe;const st=this.lexer.state.top;if(this.lexer.state.top=!0,this.lexer.blockTokens(Qe,ve,!0),this.lexer.state.top=st,ye.length===0)break;const dt=ve[ve.length-1];if(dt?.type==="code")break;if(dt?.type==="blockquote"){const mt=dt,Tt=mt.raw+`
`+ye.join(`
`),Ot=this.blockquote(Tt);ve[ve.length-1]=Ot,Ce=Ce.substring(0,Ce.length-mt.raw.length)+Ot.raw,fe=fe.substring(0,fe.length-mt.text.length)+Ot.text;break}else if(dt?.type==="list"){const mt=dt,Tt=mt.raw+`
`+ye.join(`
`),Ot=this.list(Tt);ve[ve.length-1]=Ot,Ce=Ce.substring(0,Ce.length-dt.raw.length)+Ot.raw,fe=fe.substring(0,fe.length-mt.raw.length)+Ot.raw,ye=Tt.substring(ve[ve.length-1].raw.length).split(`
`);continue}}return{type:"blockquote",raw:Ce,tokens:ve,text:fe}}}list(he){let pe=this.rules.block.list.exec(he);if(pe){let ye=pe[1].trim();const Ce=ye.length>1,fe={type:"list",raw:"",ordered:Ce,start:Ce?+ye.slice(0,-1):"",loose:!1,items:[]};ye=Ce?`\\d{1,9}\\${ye.slice(-1)}`:`\\${ye}`,this.options.pedantic&&(ye=Ce?ye:"[*+-]");const ve=new RegExp(`^( {0,3}${ye})((?:[	 ][^\\n]*)?(?:\\n|$))`);let Y=!1;for(;he;){let q=!1,de="",je="";if(!(pe=ve.exec(he))||this.rules.block.hr.test(he))break;de=pe[0],he=he.substring(de.length);let Qe=pe[2].split(`
`,1)[0].replace(/^\t+/,Qt=>" ".repeat(3*Qt.length)),st=he.split(`
`,1)[0],dt=!Qe.trim(),mt=0;if(this.options.pedantic?(mt=2,je=Qe.trimStart()):dt?mt=pe[1].length+1:(mt=pe[2].search(/[^ ]/),mt=mt>4?1:mt,je=Qe.slice(mt),mt+=pe[1].length),dt&&/^ *$/.test(st)&&(de+=st+`
`,he=he.substring(st.length+1),q=!0),!q){const Qt=new RegExp(`^ {0,${Math.min(3,mt-1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ 	][^\\n]*)?(?:\\n|$))`),_t=new RegExp(`^ {0,${Math.min(3,mt-1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`),Xe=new RegExp(`^ {0,${Math.min(3,mt-1)}}(?:\`\`\`|~~~)`),At=new RegExp(`^ {0,${Math.min(3,mt-1)}}#`);for(;he;){const Ut=he.split(`
`,1)[0];if(st=Ut,this.options.pedantic&&(st=st.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Xe.test(st)||At.test(st)||Qt.test(st)||_t.test(he))break;if(st.search(/[^ ]/)>=mt||!st.trim())je+=`
`+st.slice(mt);else{if(dt||Qe.search(/[^ ]/)>=4||Xe.test(Qe)||At.test(Qe)||_t.test(Qe))break;je+=`
`+st}!dt&&!st.trim()&&(dt=!0),de+=Ut+`
`,he=he.substring(Ut.length+1),Qe=st.slice(mt)}}fe.loose||(Y?fe.loose=!0:/\n *\n *$/.test(de)&&(Y=!0));let Tt=null,Ot;this.options.gfm&&(Tt=/^\[[ xX]\] /.exec(je),Tt&&(Ot=Tt[0]!=="[ ] ",je=je.replace(/^\[[ xX]\] +/,""))),fe.items.push({type:"list_item",raw:de,task:!!Tt,checked:Ot,loose:!1,text:je,tokens:[]}),fe.raw+=de}fe.items[fe.items.length-1].raw=fe.items[fe.items.length-1].raw.trimEnd(),fe.items[fe.items.length-1].text=fe.items[fe.items.length-1].text.trimEnd(),fe.raw=fe.raw.trimEnd();for(let q=0;q<fe.items.length;q++)if(this.lexer.state.top=!1,fe.items[q].tokens=this.lexer.blockTokens(fe.items[q].text,[]),!fe.loose){const de=fe.items[q].tokens.filter(Qe=>Qe.type==="space"),je=de.length>0&&de.some(Qe=>/\n.*\n/.test(Qe.raw));fe.loose=je}if(fe.loose)for(let q=0;q<fe.items.length;q++)fe.items[q].loose=!0;return fe}}html(he){const pe=this.rules.block.html.exec(he);if(pe)return{type:"html",block:!0,raw:pe[0],pre:pe[1]==="pre"||pe[1]==="script"||pe[1]==="style",text:pe[0]}}def(he){const pe=this.rules.block.def.exec(he);if(pe){const ye=pe[1].toLowerCase().replace(/\s+/g," "),Ce=pe[2]?pe[2].replace(/^<(.*)>$/,"$1").replace(this.rules.inline.anyPunctuation,"$1"):"",fe=pe[3]?pe[3].substring(1,pe[3].length-1).replace(this.rules.inline.anyPunctuation,"$1"):pe[3];return{type:"def",tag:ye,raw:pe[0],href:Ce,title:fe}}}table(he){const pe=this.rules.block.table.exec(he);if(!pe||!/[:|]/.test(pe[2]))return;const ye=p(pe[1]),Ce=pe[2].replace(/^\||\| *$/g,"").split("|"),fe=pe[3]&&pe[3].trim()?pe[3].replace(/\n[ \t]*$/,"").split(`
`):[],ve={type:"table",raw:pe[0],header:[],align:[],rows:[]};if(ye.length===Ce.length){for(const Y of Ce)/^ *-+: *$/.test(Y)?ve.align.push("right"):/^ *:-+: *$/.test(Y)?ve.align.push("center"):/^ *:-+ *$/.test(Y)?ve.align.push("left"):ve.align.push(null);for(let Y=0;Y<ye.length;Y++)ve.header.push({text:ye[Y],tokens:this.lexer.inline(ye[Y]),header:!0,align:ve.align[Y]});for(const Y of fe)ve.rows.push(p(Y,ve.header.length).map((q,de)=>({text:q,tokens:this.lexer.inline(q),header:!1,align:ve.align[de]})));return ve}}lheading(he){const pe=this.rules.block.lheading.exec(he);if(pe)return{type:"heading",raw:pe[0],depth:pe[2].charAt(0)==="="?1:2,text:pe[1],tokens:this.lexer.inline(pe[1])}}paragraph(he){const pe=this.rules.block.paragraph.exec(he);if(pe){const ye=pe[1].charAt(pe[1].length-1)===`
`?pe[1].slice(0,-1):pe[1];return{type:"paragraph",raw:pe[0],text:ye,tokens:this.lexer.inline(ye)}}}text(he){const pe=this.rules.block.text.exec(he);if(pe)return{type:"text",raw:pe[0],text:pe[0],tokens:this.lexer.inline(pe[0])}}escape(he){const pe=this.rules.inline.escape.exec(he);if(pe)return{type:"escape",raw:pe[0],text:s(pe[1])}}tag(he){const pe=this.rules.inline.tag.exec(he);if(pe)return!this.lexer.state.inLink&&/^<a /i.test(pe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(pe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(this.lexer.state.inRawBlock=!1),{type:"html",raw:pe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,block:!1,text:pe[0]}}link(he){const pe=this.rules.inline.link.exec(he);if(pe){const ye=pe[2].trim();if(!this.options.pedantic&&/^</.test(ye)){if(!/>$/.test(ye))return;const ve=r(ye.slice(0,-1),"\\");if((ye.length-ve.length)%2===0)return}else{const ve=l(pe[2],"()");if(ve>-1){const q=(pe[0].indexOf("!")===0?5:4)+pe[1].length+ve;pe[2]=pe[2].substring(0,ve),pe[0]=pe[0].substring(0,q).trim(),pe[3]=""}}let Ce=pe[2],fe="";if(this.options.pedantic){const ve=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ce);ve&&(Ce=ve[1],fe=ve[3])}else fe=pe[3]?pe[3].slice(1,-1):"";return Ce=Ce.trim(),/^</.test(Ce)&&(this.options.pedantic&&!/>$/.test(ye)?Ce=Ce.slice(1):Ce=Ce.slice(1,-1)),d(pe,{href:Ce&&Ce.replace(this.rules.inline.anyPunctuation,"$1"),title:fe&&fe.replace(this.rules.inline.anyPunctuation,"$1")},pe[0],this.lexer)}}reflink(he,pe){let ye;if((ye=this.rules.inline.reflink.exec(he))||(ye=this.rules.inline.nolink.exec(he))){const Ce=(ye[2]||ye[1]).replace(/\s+/g," "),fe=pe[Ce.toLowerCase()];if(!fe){const ve=ye[0].charAt(0);return{type:"text",raw:ve,text:ve}}return d(ye,fe,ye[0],this.lexer)}}emStrong(he,pe,ye=""){let Ce=this.rules.inline.emStrongLDelim.exec(he);if(!Ce||Ce[3]&&ye.match(/[\p{L}\p{N}]/u))return;if(!(Ce[1]||Ce[2]||"")||!ye||this.rules.inline.punctuation.exec(ye)){const ve=[...Ce[0]].length-1;let Y,q,de=ve,je=0;const Qe=Ce[0][0]==="*"?this.rules.inline.emStrongRDelimAst:this.rules.inline.emStrongRDelimUnd;for(Qe.lastIndex=0,pe=pe.slice(-1*he.length+ve);(Ce=Qe.exec(pe))!=null;){if(Y=Ce[1]||Ce[2]||Ce[3]||Ce[4]||Ce[5]||Ce[6],!Y)continue;if(q=[...Y].length,Ce[3]||Ce[4]){de+=q;continue}else if((Ce[5]||Ce[6])&&ve%3&&!((ve+q)%3)){je+=q;continue}if(de-=q,de>0)continue;q=Math.min(q,q+de+je);const st=[...Ce[0]][0].length,dt=he.slice(0,ve+Ce.index+st+q);if(Math.min(ve,q)%2){const Tt=dt.slice(1,-1);return{type:"em",raw:dt,text:Tt,tokens:this.lexer.inlineTokens(Tt)}}const mt=dt.slice(2,-2);return{type:"strong",raw:dt,text:mt,tokens:this.lexer.inlineTokens(mt)}}}}codespan(he){const pe=this.rules.inline.code.exec(he);if(pe){let ye=pe[2].replace(/\n/g," ");const Ce=/[^ ]/.test(ye),fe=/^ /.test(ye)&&/ $/.test(ye);return Ce&&fe&&(ye=ye.substring(1,ye.length-1)),ye=s(ye,!0),{type:"codespan",raw:pe[0],text:ye}}}br(he){const pe=this.rules.inline.br.exec(he);if(pe)return{type:"br",raw:pe[0]}}del(he){const pe=this.rules.inline.del.exec(he);if(pe)return{type:"del",raw:pe[0],text:pe[2],tokens:this.lexer.inlineTokens(pe[2])}}autolink(he){const pe=this.rules.inline.autolink.exec(he);if(pe){let ye,Ce;return pe[2]==="@"?(ye=s(pe[1]),Ce="mailto:"+ye):(ye=s(pe[1]),Ce=ye),{type:"link",raw:pe[0],text:ye,href:Ce,tokens:[{type:"text",raw:ye,text:ye}]}}}url(he){let pe;if(pe=this.rules.inline.url.exec(he)){let ye,Ce;if(pe[2]==="@")ye=s(pe[0]),Ce="mailto:"+ye;else{let fe;do fe=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])?.[0]??"";while(fe!==pe[0]);ye=s(pe[0]),pe[1]==="www."?Ce="http://"+pe[0]:Ce=pe[0]}return{type:"link",raw:pe[0],text:ye,href:Ce,tokens:[{type:"text",raw:ye,text:ye}]}}}inlineText(he){const pe=this.rules.inline.text.exec(he);if(pe){let ye;return this.lexer.state.inRawBlock?ye=pe[0]:ye=s(pe[0]),{type:"text",raw:pe[0],text:ye}}}}const n=/^(?: *(?:\n|$))+/,t=/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,o=/^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/,c=/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,g=/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,f=/(?:[*+-]|\d{1,9}[.)])/,h=w(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g,f).replace(/blockCode/g,/ {4}/).replace(/fences/g,/ {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g,/ {0,3}>/).replace(/heading/g,/ {0,3}#{1,6}/).replace(/html/g,/ {0,3}<[^\n>]+>\n/).getRegex(),S=/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,k=/^[^\n]+/,y=/(?!\s*\])(?:\\.|[^\[\]\\])+/,C=w(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace("label",y).replace("title",/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex(),T=w(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g,f).getRegex(),$="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",b=/<!--(?:-?>|[\s\S]*?(?:-->|$))/,N=w("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))","i").replace("comment",b).replace("tag",$).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),A=w(S).replace("hr",c).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$).getRegex(),G={blockquote:w(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace("paragraph",A).getRegex(),code:t,def:C,fences:o,heading:g,hr:c,html:N,lheading:h,list:T,newline:n,paragraph:A,table:E,text:k},x=w("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace("hr",c).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$).getRegex(),j={...G,table:x,paragraph:w(S).replace("hr",c).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("table",x).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$).getRegex()},U={...G,html:w(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",b).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,lheading:/^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,paragraph:w(S).replace("hr",c).replace("heading",` *#{1,6} *[^
]`).replace("lheading",h).replace("|table","").replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").replace("|tag","").getRegex()},J=/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,Z=/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,ae=/^( {2,}|\\)\n(?!\s*$)/,ee=/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,oe="\\p{P}\\p{S}",ie=w(/^((?![*_])[\spunctuation])/,"u").replace(/punctuation/g,oe).getRegex(),ue=/\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g,_=w(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/,"u").replace(/punct/g,oe).getRegex(),$e=w("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])","gu").replace(/punct/g,oe).getRegex(),Ie=w("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])","gu").replace(/punct/g,oe).getRegex(),X=w(/\\([punct])/,"gu").replace(/punct/g,oe).getRegex(),V=w(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace("scheme",/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace("email",/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex(),re=w(b).replace("(?:-->|$)","-->").getRegex(),be=w("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace("comment",re).replace("attribute",/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex(),Pe=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Fe=w(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace("label",Pe).replace("href",/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace("title",/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex(),Be=w(/^!?\[(label)\]\[(ref)\]/).replace("label",Pe).replace("ref",y).getRegex(),xe=w(/^!?\[(ref)\](?:\[\])?/).replace("ref",y).getRegex(),nt=w("reflink|nolink(?!\\()","g").replace("reflink",Be).replace("nolink",xe).getRegex(),ht={_backpedal:E,anyPunctuation:X,autolink:V,blockSkip:ue,br:ae,code:Z,del:E,emStrongLDelim:_,emStrongRDelimAst:$e,emStrongRDelimUnd:Ie,escape:J,link:Fe,nolink:xe,punctuation:ie,reflink:Be,reflinkSearch:nt,tag:be,text:ee,url:E},$t={...ht,link:w(/^!?\[(label)\]\((.*?)\)/).replace("label",Pe).getRegex(),reflink:w(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Pe).getRegex()},ut={...ht,escape:w(J).replace("])","~|])").getRegex(),url:w(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,"i").replace("email",/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),_backpedal:/(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/},et={...ut,br:w(ae).replace("{2,}","*").getRegex(),text:w(ut.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()},Le={normal:G,gfm:j,pedantic:U},Me={normal:ht,gfm:ut,breaks:et,pedantic:$t};class Ne{tokens;options;state;tokenizer;inlineQueue;constructor(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||we.defaults,this.options.tokenizer=this.options.tokenizer||new i,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};const pe={block:Le.normal,inline:Me.normal};this.options.pedantic?(pe.block=Le.pedantic,pe.inline=Me.pedantic):this.options.gfm&&(pe.block=Le.gfm,this.options.breaks?pe.inline=Me.breaks:pe.inline=Me.gfm),this.tokenizer.rules=pe}static get rules(){return{block:Le,inline:Me}}static lex(he,pe){return new Ne(pe).lex(he)}static lexInline(he,pe){return new Ne(pe).inlineTokens(he)}lex(he){he=he.replace(/\r\n|\r/g,`
`),this.blockTokens(he,this.tokens);for(let pe=0;pe<this.inlineQueue.length;pe++){const ye=this.inlineQueue[pe];this.inlineTokens(ye.src,ye.tokens)}return this.inlineQueue=[],this.tokens}blockTokens(he,pe=[],ye=!1){this.options.pedantic?he=he.replace(/\t/g,"    ").replace(/^ +$/gm,""):he=he.replace(/^( *)(\t+)/gm,(Y,q,de)=>q+"    ".repeat(de.length));let Ce,fe,ve;for(;he;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(Y=>(Ce=Y.call({lexer:this},he,pe))?(he=he.substring(Ce.raw.length),pe.push(Ce),!0):!1))){if(Ce=this.tokenizer.space(he)){he=he.substring(Ce.raw.length),Ce.raw.length===1&&pe.length>0?pe[pe.length-1].raw+=`
`:pe.push(Ce);continue}if(Ce=this.tokenizer.code(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce);continue}if(Ce=this.tokenizer.fences(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.heading(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.hr(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.blockquote(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.list(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.html(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.def(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[Ce.tag]||(this.tokens.links[Ce.tag]={href:Ce.href,title:Ce.title});continue}if(Ce=this.tokenizer.table(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.lheading(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(ve=he,this.options.extensions&&this.options.extensions.startBlock){let Y=1/0;const q=he.slice(1);let de;this.options.extensions.startBlock.forEach(je=>{de=je.call({lexer:this},q),typeof de=="number"&&de>=0&&(Y=Math.min(Y,de))}),Y<1/0&&Y>=0&&(ve=he.substring(0,Y+1))}if(this.state.top&&(Ce=this.tokenizer.paragraph(ve))){fe=pe[pe.length-1],ye&&fe?.type==="paragraph"?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce),ye=ve.length!==he.length,he=he.substring(Ce.raw.length);continue}if(Ce=this.tokenizer.text(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce);continue}if(he){const Y="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return this.state.top=!0,pe}inline(he,pe=[]){return this.inlineQueue.push({src:he,tokens:pe}),pe}inlineTokens(he,pe=[]){let ye,Ce,fe,ve=he,Y,q,de;if(this.tokens.links){const je=Object.keys(this.tokens.links);if(je.length>0)for(;(Y=this.tokenizer.rules.inline.reflinkSearch.exec(ve))!=null;)je.includes(Y[0].slice(Y[0].lastIndexOf("[")+1,-1))&&(ve=ve.slice(0,Y.index)+"["+"a".repeat(Y[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Y=this.tokenizer.rules.inline.blockSkip.exec(ve))!=null;)ve=ve.slice(0,Y.index)+"["+"a".repeat(Y[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Y=this.tokenizer.rules.inline.anyPunctuation.exec(ve))!=null;)ve=ve.slice(0,Y.index)+"++"+ve.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);for(;he;)if(q||(de=""),q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(je=>(ye=je.call({lexer:this},he,pe))?(he=he.substring(ye.raw.length),pe.push(ye),!0):!1))){if(ye=this.tokenizer.escape(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.tag(he)){he=he.substring(ye.raw.length),Ce=pe[pe.length-1],Ce&&ye.type==="text"&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(ye=this.tokenizer.link(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.reflink(he,this.tokens.links)){he=he.substring(ye.raw.length),Ce=pe[pe.length-1],Ce&&ye.type==="text"&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(ye=this.tokenizer.emStrong(he,ve,de)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.codespan(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.br(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.del(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.autolink(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(!this.state.inLink&&(ye=this.tokenizer.url(he))){he=he.substring(ye.raw.length),pe.push(ye);continue}if(fe=he,this.options.extensions&&this.options.extensions.startInline){let je=1/0;const Qe=he.slice(1);let st;this.options.extensions.startInline.forEach(dt=>{st=dt.call({lexer:this},Qe),typeof st=="number"&&st>=0&&(je=Math.min(je,st))}),je<1/0&&je>=0&&(fe=he.substring(0,je+1))}if(ye=this.tokenizer.inlineText(fe)){he=he.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(de=ye.raw.slice(-1)),q=!0,Ce=pe[pe.length-1],Ce&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(he){const je="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return pe}}class W{options;parser;constructor(he){this.options=he||we.defaults}space(he){return""}code({text:he,lang:pe,escaped:ye}){const Ce=(pe||"").match(/^\S*/)?.[0],fe=he.replace(/\n$/,"")+`
`;return Ce?'<pre><code class="language-'+s(Ce)+'">'+(ye?fe:s(fe,!0))+`</code></pre>
`:"<pre><code>"+(ye?fe:s(fe,!0))+`</code></pre>
`}blockquote({tokens:he}){return`<blockquote>
${this.parser.parse(he)}</blockquote>
`}html({text:he}){return he}heading({tokens:he,depth:pe}){return`<h${pe}>${this.parser.parseInline(he)}</h${pe}>
`}hr(he){return`<hr>
`}list(he){const pe=he.ordered,ye=he.start;let Ce="";for(let Y=0;Y<he.items.length;Y++){const q=he.items[Y];Ce+=this.listitem(q)}const fe=pe?"ol":"ul",ve=pe&&ye!==1?' start="'+ye+'"':"";return"<"+fe+ve+`>
`+Ce+"</"+fe+`>
`}listitem(he){let pe="";if(he.task){const ye=this.checkbox({checked:!!he.checked});he.loose?he.tokens.length>0&&he.tokens[0].type==="paragraph"?(he.tokens[0].text=ye+" "+he.tokens[0].text,he.tokens[0].tokens&&he.tokens[0].tokens.length>0&&he.tokens[0].tokens[0].type==="text"&&(he.tokens[0].tokens[0].text=ye+" "+he.tokens[0].tokens[0].text)):he.tokens.unshift({type:"text",raw:ye+" ",text:ye+" "}):pe+=ye+" "}return pe+=this.parser.parse(he.tokens,!!he.loose),`<li>${pe}</li>
`}checkbox({checked:he}){return"<input "+(he?'checked="" ':"")+'disabled="" type="checkbox">'}paragraph({tokens:he}){return`<p>${this.parser.parseInline(he)}</p>
`}table(he){let pe="",ye="";for(let fe=0;fe<he.header.length;fe++)ye+=this.tablecell(he.header[fe]);pe+=this.tablerow({text:ye});let Ce="";for(let fe=0;fe<he.rows.length;fe++){const ve=he.rows[fe];ye="";for(let Y=0;Y<ve.length;Y++)ye+=this.tablecell(ve[Y]);Ce+=this.tablerow({text:ye})}return Ce&&(Ce=`<tbody>${Ce}</tbody>`),`<table>
<thead>
`+pe+`</thead>
`+Ce+`</table>
`}tablerow({text:he}){return`<tr>
${he}</tr>
`}tablecell(he){const pe=this.parser.parseInline(he.tokens),ye=he.header?"th":"td";return(he.align?`<${ye} align="${he.align}">`:`<${ye}>`)+pe+`</${ye}>
`}strong({tokens:he}){return`<strong>${this.parser.parseInline(he)}</strong>`}em({tokens:he}){return`<em>${this.parser.parseInline(he)}</em>`}codespan({text:he}){return`<code>${he}</code>`}br(he){return"<br>"}del({tokens:he}){return`<del>${this.parser.parseInline(he)}</del>`}link({href:he,title:pe,tokens:ye}){const Ce=this.parser.parseInline(ye),fe=u(he);if(fe===null)return Ce;he=fe;let ve='<a href="'+he+'"';return pe&&(ve+=' title="'+pe+'"'),ve+=">"+Ce+"</a>",ve}image({href:he,title:pe,text:ye}){const Ce=u(he);if(Ce===null)return ye;he=Ce;let fe=`<img src="${he}" alt="${ye}"`;return pe&&(fe+=` title="${pe}"`),fe+=">",fe}text(he){return"tokens"in he&&he.tokens?this.parser.parseInline(he.tokens):he.text}}class B{strong({text:he}){return he}em({text:he}){return he}codespan({text:he}){return he}del({text:he}){return he}html({text:he}){return he}text({text:he}){return he}link({text:he}){return""+he}image({text:he}){return""+he}br(){return""}}class Q{options;renderer;textRenderer;constructor(he){this.options=he||we.defaults,this.options.renderer=this.options.renderer||new W,this.renderer=this.options.renderer,this.renderer.options=this.options,this.renderer.parser=this,this.textRenderer=new B}static parse(he,pe){return new Q(pe).parse(he)}static parseInline(he,pe){return new Q(pe).parseInline(he)}parse(he,pe=!0){let ye="";for(let Ce=0;Ce<he.length;Ce++){const fe=he[Ce];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]){const Y=fe,q=this.options.extensions.renderers[Y.type].call({parser:this},Y);if(q!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Y.type)){ye+=q||"";continue}}const ve=fe;switch(ve.type){case"space":{ye+=this.renderer.space(ve);continue}case"hr":{ye+=this.renderer.hr(ve);continue}case"heading":{ye+=this.renderer.heading(ve);continue}case"code":{ye+=this.renderer.code(ve);continue}case"table":{ye+=this.renderer.table(ve);continue}case"blockquote":{ye+=this.renderer.blockquote(ve);continue}case"list":{ye+=this.renderer.list(ve);continue}case"html":{ye+=this.renderer.html(ve);continue}case"paragraph":{ye+=this.renderer.paragraph(ve);continue}case"text":{let Y=ve,q=this.renderer.text(Y);for(;Ce+1<he.length&&he[Ce+1].type==="text";)Y=he[++Ce],q+=`
`+this.renderer.text(Y);pe?ye+=this.renderer.paragraph({type:"paragraph",raw:q,text:q,tokens:[{type:"text",raw:q,text:q}]}):ye+=q;continue}default:{const Y='Token with "'+ve.type+'" type was not found.';if(this.options.silent)return console.error(Y),"";throw new Error(Y)}}}return ye}parseInline(he,pe){pe=pe||this.renderer;let ye="";for(let Ce=0;Ce<he.length;Ce++){const fe=he[Ce];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]){const Y=this.options.extensions.renderers[fe.type].call({parser:this},fe);if(Y!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type)){ye+=Y||"";continue}}const ve=fe;switch(ve.type){case"escape":{ye+=pe.text(ve);break}case"html":{ye+=pe.html(ve);break}case"link":{ye+=pe.link(ve);break}case"image":{ye+=pe.image(ve);break}case"strong":{ye+=pe.strong(ve);break}case"em":{ye+=pe.em(ve);break}case"codespan":{ye+=pe.codespan(ve);break}case"br":{ye+=pe.br(ve);break}case"del":{ye+=pe.del(ve);break}case"text":{ye+=pe.text(ve);break}default:{const Y='Token with "'+ve.type+'" type was not found.';if(this.options.silent)return console.error(Y),"";throw new Error(Y)}}}return ye}}class H{options;constructor(he){this.options=he||we.defaults}static passThroughHooks=new Set(["preprocess","postprocess","processAllTokens"]);preprocess(he){return he}postprocess(he){return he}processAllTokens(he){return he}}class se{defaults=e();options=this.setOptions;parse=this.parseMarkdown(Ne.lex,Q.parse);parseInline=this.parseMarkdown(Ne.lexInline,Q.parseInline);Parser=Q;Renderer=W;TextRenderer=B;Lexer=Ne;Tokenizer=i;Hooks=H;constructor(...he){this.use(...he)}walkTokens(he,pe){let ye=[];for(const Ce of he)switch(ye=ye.concat(pe.call(this,Ce)),Ce.type){case"table":{const fe=Ce;for(const ve of fe.header)ye=ye.concat(this.walkTokens(ve.tokens,pe));for(const ve of fe.rows)for(const Y of ve)ye=ye.concat(this.walkTokens(Y.tokens,pe));break}case"list":{const fe=Ce;ye=ye.concat(this.walkTokens(fe.items,pe));break}default:{const fe=Ce;this.defaults.extensions?.childTokens?.[fe.type]?this.defaults.extensions.childTokens[fe.type].forEach(ve=>{const Y=fe[ve].flat(1/0);ye=ye.concat(this.walkTokens(Y,pe))}):fe.tokens&&(ye=ye.concat(this.walkTokens(fe.tokens,pe)))}}return ye}use(...he){const pe=this.defaults.extensions||{renderers:{},childTokens:{}};return he.forEach(ye=>{const Ce={...ye};if(Ce.async=this.defaults.async||Ce.async||!1,ye.extensions&&(ye.extensions.forEach(fe=>{if(!fe.name)throw new Error("extension name required");if("renderer"in fe){const ve=pe.renderers[fe.name];ve?pe.renderers[fe.name]=function(...Y){let q=fe.renderer.apply(this,Y);return q===!1&&(q=ve.apply(this,Y)),q}:pe.renderers[fe.name]=fe.renderer}if("tokenizer"in fe){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");const ve=pe[fe.level];ve?ve.unshift(fe.tokenizer):pe[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?pe.startBlock?pe.startBlock.push(fe.start):pe.startBlock=[fe.start]:fe.level==="inline"&&(pe.startInline?pe.startInline.push(fe.start):pe.startInline=[fe.start]))}"childTokens"in fe&&fe.childTokens&&(pe.childTokens[fe.name]=fe.childTokens)}),Ce.extensions=pe),ye.renderer){const fe=this.defaults.renderer||new W(this.defaults);for(const ve in ye.renderer){if(!(ve in fe))throw new Error(`renderer '${ve}' does not exist`);if(["options","parser"].includes(ve))continue;const Y=ve,q=ye.renderer[Y],de=fe[Y];fe[Y]=(...je)=>{let Qe=q.apply(fe,je);return Qe===!1&&(Qe=de.apply(fe,je)),Qe||""}}Ce.renderer=fe}if(ye.tokenizer){const fe=this.defaults.tokenizer||new i(this.defaults);for(const ve in ye.tokenizer){if(!(ve in fe))throw new Error(`tokenizer '${ve}' does not exist`);if(["options","rules","lexer"].includes(ve))continue;const Y=ve,q=ye.tokenizer[Y],de=fe[Y];fe[Y]=(...je)=>{let Qe=q.apply(fe,je);return Qe===!1&&(Qe=de.apply(fe,je)),Qe}}Ce.tokenizer=fe}if(ye.hooks){const fe=this.defaults.hooks||new H;for(const ve in ye.hooks){if(!(ve in fe))throw new Error(`hook '${ve}' does not exist`);if(ve==="options")continue;const Y=ve,q=ye.hooks[Y],de=fe[Y];H.passThroughHooks.has(ve)?fe[Y]=je=>{if(this.defaults.async)return Promise.resolve(q.call(fe,je)).then(st=>de.call(fe,st));const Qe=q.call(fe,je);return de.call(fe,Qe)}:fe[Y]=(...je)=>{let Qe=q.apply(fe,je);return Qe===!1&&(Qe=de.apply(fe,je)),Qe}}Ce.hooks=fe}if(ye.walkTokens){const fe=this.defaults.walkTokens,ve=ye.walkTokens;Ce.walkTokens=function(Y){let q=[];return q.push(ve.call(this,Y)),fe&&(q=q.concat(fe.call(this,Y))),q}}this.defaults={...this.defaults,...Ce}}),this}setOptions(he){return this.defaults={...this.defaults,...he},this}lexer(he,pe){return Ne.lex(he,pe??this.defaults)}parser(he,pe){return Q.parse(he,pe??this.defaults)}parseMarkdown(he,pe){return(Ce,fe)=>{const ve={...fe},Y={...this.defaults,...ve},q=this.onError(!!Y.silent,!!Y.async);if(this.defaults.async===!0&&ve.async===!1)return q(new Error("marked(): The async option was set to true by an extension. Remove async: false from the parse options object to return a Promise."));if(typeof Ce>"u"||Ce===null)return q(new Error("marked(): input parameter is undefined or null"));if(typeof Ce!="string")return q(new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected"));if(Y.hooks&&(Y.hooks.options=Y),Y.async)return Promise.resolve(Y.hooks?Y.hooks.preprocess(Ce):Ce).then(de=>he(de,Y)).then(de=>Y.hooks?Y.hooks.processAllTokens(de):de).then(de=>Y.walkTokens?Promise.all(this.walkTokens(de,Y.walkTokens)).then(()=>de):de).then(de=>pe(de,Y)).then(de=>Y.hooks?Y.hooks.postprocess(de):de).catch(q);try{Y.hooks&&(Ce=Y.hooks.preprocess(Ce));let de=he(Ce,Y);Y.hooks&&(de=Y.hooks.processAllTokens(de)),Y.walkTokens&&this.walkTokens(de,Y.walkTokens);let je=pe(de,Y);return Y.hooks&&(je=Y.hooks.postprocess(je)),je}catch(de){return q(de)}}}onError(he,pe){return ye=>{if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,he){const Ce="<p>An error occurred:</p><pre>"+s(ye.message+"",!0)+"</pre>";return pe?Promise.resolve(Ce):Ce}if(pe)return Promise.reject(ye);throw ye}}}const ge=new se;function Ee(Ye,he){return ge.parse(Ye,he)}Ee.options=Ee.setOptions=function(Ye){return ge.setOptions(Ye),Ee.defaults=ge.defaults,v(Ee.defaults),Ee},Ee.getDefaults=e,Ee.defaults=we.defaults,Ee.use=function(...Ye){return ge.use(...Ye),Ee.defaults=ge.defaults,v(Ee.defaults),Ee},Ee.walkTokens=function(Ye,he){return ge.walkTokens(Ye,he)},Ee.parseInline=ge.parseInline,Ee.Parser=Q,Ee.parser=Q.parse,Ee.Renderer=W,Ee.TextRenderer=B,Ee.Lexer=Ne,Ee.lexer=Ne.lex,Ee.Tokenizer=i,Ee.Hooks=H,Ee.parse=Ee;const ze=Ee.options,Je=Ee.setOptions,_e=Ee.use,tt=Ee.walkTokens,ct=Ee.parseInline,it=Ee,at=Q.parse,yt=Ne.lex;we.Hooks=H,we.Lexer=Ne,we.Marked=se,we.Parser=Q,we.Renderer=W,we.TextRenderer=B,we.Tokenizer=i,we.getDefaults=e,we.lexer=yt,we.marked=Ee,we.options=ze,we.parse=it,we.parseInline=ct,we.parser=at,we.setOptions=Je,we.use=_e,we.walkTokens=tt}),define(Re[140],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=v;function v(r){const l=L(r);if(l&&l.length>0)return new Uint32Array(l)}let D=0;const P=new Uint32Array(10);function L(r){if(D=0,R(r,w,m.InitialConsonant),D>0||(R(r,u,m.Vowel),D>0)||(R(r,E,m.FinalConsonant),D>0)||(R(r,p,m.CompatibilityJamo),D))return P.subarray(0,D);if(r>=44032&&r<=55203){const l=r-44032,d=l%588,a=Math.floor(l/588),i=Math.floor(d/28),n=d%28-1;if(a<w.length?R(a,w,0):m.InitialConsonant+a-m.CompatibilityJamo<p.length&&R(m.InitialConsonant+a,p,m.CompatibilityJamo),i<u.length?R(i,u,0):m.Vowel+i-m.CompatibilityJamo<p.length&&R(m.Vowel+i-m.CompatibilityJamo,p,m.CompatibilityJamo),n>=0&&(n<E.length?R(n,E,0):m.FinalConsonant+n-m.CompatibilityJamo<p.length&&R(m.FinalConsonant+n-m.CompatibilityJamo,p,m.CompatibilityJamo)),D>0)return P.subarray(0,D)}}function R(r,l,d){r>=d&&r<d+l.length&&O(l[r-d])}function O(r){r!==s.NUL&&(P[D++]=r&255,r>>8&&(P[D++]=r>>8&255),r>>16&&(P[D++]=r>>16&255))}var m;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var s;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(s||(s={}));var I;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(I||(I={}));const w=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),u=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l]),E=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,I.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),p=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.E,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,s.Q,I.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l])}),define(Re[141],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Qm=v,e.rot=D,e.$Vm=O;function v(m,s,I){return Math.min(Math.max(m,s),I)}function D(m,s){return(s+m%s)%s}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Sm=P;class L{constructor(){this.a=1,this.b=0}update(s){return this.b=this.b+(s-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Tm=L;class R{constructor(s){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(s),this.c.fill(0,0,s)}update(s){const I=this.c[this.d];return this.c[this.d]=s,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=s,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Um=R;function O(m,s,I,w,u,E,p,r){const l=p-I,d=r-w,a=u-I,i=E-w,n=m-I,t=s-w,o=l*l+d*d,c=l*a+d*i,g=l*n+d*t,f=a*a+i*i,h=a*n+i*t,S=1/(o*f-c*c),k=(f*g-c*h)*S,y=(o*h-c*g)*S;return k>=0&&y>=0&&k+y<1}}),define(Re[142],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fd=void 0,e.$gd=L,e.$hd=u;class v{constructor(p,r,l){this.owner=p,this.debugNameSource=r,this.referenceFn=l}getDebugName(p){return L(p,this)}}e.$fd=v;const D=new Map,P=new WeakMap;function L(E,p){const r=P.get(E);if(r)return r;const l=R(E,p);if(l){let d=D.get(l)??0;d++,D.set(l,d);const a=d===1?l:`${l}#${d}`;return P.set(E,a),a}}function R(E,p){const r=P.get(E);if(r)return r;const l=p.owner?I(p.owner)+".":"";let d;const a=p.debugNameSource;if(a!==void 0)if(typeof a=="function"){if(d=a(),d!==void 0)return l+d}else return l+a;const i=p.referenceFn;if(i!==void 0&&(d=u(i),d!==void 0))return l+d;if(p.owner!==void 0){const n=O(p.owner,E);if(n!==void 0)return l+n}}function O(E,p){for(const r in E)if(E[r]===p)return r}const m=new Map,s=new WeakMap;function I(E){const p=s.get(E);if(p)return p;const r=w(E);let l=m.get(r)??0;l++,m.set(r,l);const d=l===1?r:`${r}#${l}`;return s.set(E,d),d}function w(E){const p=E.constructor;return p?p.name:"Object"}function u(E){const p=E.toString(),l=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(p);return(l?l[1]:void 0)?.trim()}}),define(Re[143],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0,e.$Pd=D,e.$Qd=P;let v;function D(r){v=r}function P(){return v}class L{constructor(){this.a=0,this.d=new WeakMap}b(l){return R([O(E("|  ",this.a)),l])}c(l){return l.hadValue?l.didChange?[O(" "),s(I(l.oldValue,70),{color:"red",strikeThrough:!0}),O(" "),s(I(l.newValue,60),{color:"green"})]:[O(" (unchanged)")]:[O(" "),s(I(l.newValue,60),{color:"green"}),O(" (initial)")]}handleObservableChanged(l,d){console.log(...this.b([m("observable value changed"),s(l.debugName,{color:"BlueViolet"}),...this.c(d)]))}formatChanges(l){if(l.size!==0)return s(" (changed deps: "+[...l].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(l){const d=l.handleChange;this.d.set(l,new Set),l.handleChange=(a,i)=>(this.d.get(l).add(a),d.apply(l,[a,i]))}handleDerivedRecomputed(l,d){const a=this.d.get(l);console.log(...this.b([m("derived recomputed"),s(l.debugName,{color:"BlueViolet"}),...this.c(d),this.formatChanges(a),{data:[{fn:l._debugNameData.referenceFn??l._computeFn}]}])),a.clear()}handleFromEventObservableTriggered(l,d){console.log(...this.b([m("observable from event triggered"),s(l.debugName,{color:"BlueViolet"}),...this.c(d),{data:[{fn:l._getValue}]}]))}handleAutorunCreated(l){const d=l.handleChange;this.d.set(l,new Set),l.handleChange=(a,i)=>(this.d.get(l).add(a),d.apply(l,[a,i]))}handleAutorunTriggered(l){const d=this.d.get(l);console.log(...this.b([m("autorun"),s(l.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:l._debugNameData.referenceFn??l._runFn}]}])),d.clear(),this.a++}handleAutorunFinished(l){this.a--}handleBeginTransaction(l){let d=l.getDebugName();d===void 0&&(d=""),console.log(...this.b([m("transaction"),s(d,{color:"BlueViolet"}),{data:[{fn:l._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Rd=L;function R(r){const l=new Array,d=[];let a="";function i(t){if("length"in t)for(const o of t)o&&i(o);else"text"in t?(a+=`%c${t.text}`,l.push(t.style),t.data&&d.push(...t.data)):"data"in t&&d.push(...t.data)}i(r);const n=[a,...l];return n.push(...d),n}function O(r){return s(r,{color:"black"})}function m(r){return s(p(`${r}: `,10),{color:"black",bold:!0})}function s(r,l={color:"black"}){function d(i){return Object.entries(i).reduce((n,[t,o])=>`${n}${t}:${o};`,"")}const a={color:l.color};return l.strikeThrough&&(a["text-decoration"]="line-through"),l.bold&&(a["font-weight"]="bold"),{text:r,style:d(a)}}function I(r,l){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=l?`"${r}"`:`"${r.substr(0,l-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?w(r,l):u(r,l);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function w(r,l){let d="[ ",a=!0;for(const i of r){if(a||(d+=", "),d.length-5>l){d+="...";break}a=!1,d+=`${I(i,l-d.length)}`}return d+=" ]",d}function u(r,l){let d="{ ",a=!0;for(const[i,n]of Object.entries(r)){if(a||(d+=", "),d.length-5>l){d+="...";break}a=!1,d+=`${i}: ${I(n,l-d.length)}`}return d+=" }",d}function E(r,l){let d="";for(let a=1;a<=l;a++)d+=r;return d}function p(r,l){for(;r.length<l;)r+=" ";return r}}),define(Re[144],Te([1,0,136,142,143]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$_d=e.$0d=e.$5d=e.$4d=void 0,e.$1d=R,e.$2d=m,e.$3d=I,e.$6d=E,e.$7d=r,e.$8d=l,e.$9d=d,e.$$d=i,e.$ae=t;let L;function R(c){L=c}let O;function m(c){O=c}let s;function I(c){s=c}class w{get TChange(){return null}reportChanges(){this.get()}read(g){return g?g.readObservable(this):this.get()}map(g,f){const h=f===void 0?void 0:g,S=f===void 0?g:f;return s({owner:h,debugName:()=>{const k=(0,D.$hd)(S);if(k!==void 0)return k;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(C)return`${this.debugName}.${C[2]}`;if(!h)return`${this.debugName} (mapped)`},debugReferenceFn:S},k=>S(this.read(k),k))}flatten(){return s({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},g=>this.read(g).read(g))}recomputeInitiallyAndOnChange(g,f){return g.add(L(this,f)),this}keepObserved(g){return g.add(O(this)),this}get a(){return this.get()}}e.$4d=w;class u extends w{constructor(){super(...arguments),this.b=new Set}addObserver(g){const f=this.b.size;this.b.add(g),f===0&&this.c()}removeObserver(g){this.b.delete(g)&&this.b.size===0&&this.f()}c(){}f(){}}e.$5d=u;function E(c,g){const f=new a(c,g);try{c(f)}finally{f.finish()}}let p;function r(c){if(p)c(p);else{const g=new a(c,void 0);p=g;try{c(g)}finally{g.finish(),p=void 0}}}async function l(c,g){const f=new a(c,g);try{await c(f)}finally{f.finish()}}function d(c,g,f){c?g(c):E(g,f)}class a{constructor(g,f){this._fn=g,this.b=f,this.a=[],(0,P.$Qd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,D.$hd)(this._fn)}updateObserver(g,f){this.a.push({observer:g,observable:f}),g.beginUpdate(f)}finish(){const g=this.a;for(let f=0;f<g.length;f++){const{observer:h,observable:S}=g[f];h.endUpdate(S)}this.a=null,(0,P.$Qd)()?.handleEndTransaction()}}e.$0d=a;function i(c,g){let f;return typeof c=="string"?f=new D.$fd(void 0,c,void 0):f=new D.$fd(c,void 0,void 0),new n(f,g,v.$$c)}class n extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(g,f,h){super(),this.e=g,this.g=h,this.d=f}get(){return this.d}set(g,f,h){if(h===void 0&&this.g(this.d,g))return;let S;f||(f=S=new a(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.d;this.h(g),(0,P.$Qd)()?.handleObservableChanged(this,{oldValue:k,newValue:g,change:h,didChange:!0,hadValue:!0});for(const y of this.b)f.updateObserver(y,this),y.handleChange(this,h)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(g){this.d=g}}e.$_d=n;function t(c,g){let f;return typeof c=="string"?f=new D.$fd(void 0,c,void 0):f=new D.$fd(c,void 0,void 0),new o(f,g,v.$$c)}class o extends n{h(g){this.d!==g&&(this.d&&this.d.dispose(),this.d=g)}dispose(){this.d?.dispose()}}e.$be=o}),function(){function we(P){const L=[];typeof P=="number"&&L.push("code/timeOrigin",P);function R(m){L.push(m,Date.now())}function O(){const m=[];for(let s=0;s<L.length;s+=2)m.push({name:L[s],startTime:L[s+1]});return m}return{mark:R,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?we():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(P+R.startTime)});return L}};if(typeof process=="object"){const P=performance?.timeOrigin;return we(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),we()}function v(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=v(D))}(),define(Re[145],Te([1,0,41]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oJ=void 0;const D=Symbol("unset");class P{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}get entries(){return this.a.children?.entries()||v.Iterable.empty()}insert(m,s,I){this.d(m,w=>w._value=s,I)}mutate(m,s){this.d(m,I=>I._value=s(I._value===D?void 0:I._value))}mutatePath(m,s){this.d(m,()=>{},I=>s(I))}delete(m){const s=this.c(m);if(!s)return;let I=s.length-1;const w=s[I].node._value;if(w!==D){for(this.b--,s[I].node._value=D;I>0;I--){const{node:u,part:E}=s[I];if(u.children?.size||u._value!==D)break;s[I-1].node.children.delete(E)}return w}}*deleteRecursive(m){const s=this.c(m);if(!s)return;const I=s[s.length-1].node;for(let w=s.length-1;w>0;w--){const u=s[w-1];if(u.node.children.delete(s[w].part),u.node.children.size>0||u.node._value!==D)break}for(const w of L(I))w._value!==D&&(this.b--,yield w._value)}find(m){let s=this.a;for(const I of m){const w=s.children?.get(I);if(!w)return;s=w}return s._value===D?void 0:s._value}hasKeyOrParent(m){let s=this.a;for(const I of m){const w=s.children?.get(I);if(!w)return!1;if(w._value!==D)return!0;s=w}return!1}hasKeyOrChildren(m){let s=this.a;for(const I of m){const w=s.children?.get(I);if(!w)return!1;s=w}return!0}hasKey(m){let s=this.a;for(const I of m){const w=s.children?.get(I);if(!w)return!1;s=w}return s._value!==D}c(m){const s=[{part:"",node:this.a}];let I=0;for(const w of m){const u=s[I].node.children?.get(w);if(!u)return;s.push({part:w,node:u}),I++}return s}d(m,s,I){let w=this.a;for(const p of m){if(w.children)if(w.children.has(p))w=w.children.get(p);else{const r=new R;w.children.set(p,r),w=r}else{const r=new R;w.children=new Map([[p,r]]),w=r}I?.(w)}const u=w._value===D?0:1;s(w);const E=w._value===D?0:1;this.b+=E-u}*values(){for(const{_value:m}of L(this.a))m!==D&&(yield m)}}e.$oJ=P;function*L(O){const m=[O];for(;m.length>0;){const s=m.pop();if(yield s,s.children)for(const I of s.children.values())m.push(I)}}class R{constructor(){this._value=D}get value(){return this._value===D?void 0:this._value}set value(m){this._value=m===void 0?D:m}}}),function(we,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var D in v)(typeof exports=="object"?exports:we)[D]=v[D]}}(typeof self<"u"?self:this,function(){return function(we){var e={};function v(D){if(e[D])return e[D].exports;var P=e[D]={i:D,l:!1,exports:{}};return we[D].call(P.exports,P,P.exports,v),P.l=!0,P.exports}return v.m=we,v.c=e,v.d=function(D,P,L){v.o(D,P)||Object.defineProperty(D,P,{enumerable:!0,get:L})},v.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},v.t=function(D,P){if(1&P&&(D=v(D)),8&P||4&P&&typeof D=="object"&&D&&D.__esModule)return D;var L=Object.create(null);if(v.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:D}),2&P&&typeof D!="string")for(var R in D)v.d(L,R,function(O){return D[O]}.bind(null,R));return L},v.n=function(D){var P=D&&D.__esModule?function(){return D.default}:function(){return D};return v.d(P,"a",P),P},v.o=function(D,P){return Object.prototype.hasOwnProperty.call(D,P)},v.p="",v(v.s=0)}([function(we,e,v){(function(D){var P;e=we.exports=$e,P=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],m=e.src=[],s=0,I=s++;m[I]="0|[1-9]\\d*";var w=s++;m[w]="[0-9]+";var u=s++;m[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=s++;m[E]="("+m[I]+")\\.("+m[I]+")\\.("+m[I]+")";var p=s++;m[p]="("+m[w]+")\\.("+m[w]+")\\.("+m[w]+")";var r=s++;m[r]="(?:"+m[I]+"|"+m[u]+")";var l=s++;m[l]="(?:"+m[w]+"|"+m[u]+")";var d=s++;m[d]="(?:-("+m[r]+"(?:\\."+m[r]+")*))";var a=s++;m[a]="(?:-?("+m[l]+"(?:\\."+m[l]+")*))";var i=s++;m[i]="[0-9A-Za-z-]+";var n=s++;m[n]="(?:\\+("+m[i]+"(?:\\."+m[i]+")*))";var t=s++,o="v?"+m[E]+m[d]+"?"+m[n]+"?";m[t]="^"+o+"$";var c="[v=\\s]*"+m[p]+m[a]+"?"+m[n]+"?",g=s++;m[g]="^"+c+"$";var f=s++;m[f]="((?:<|>)?=?)";var h=s++;m[h]=m[w]+"|x|X|\\*";var S=s++;m[S]=m[I]+"|x|X|\\*";var k=s++;m[k]="[v=\\s]*("+m[S]+")(?:\\.("+m[S]+")(?:\\.("+m[S]+")(?:"+m[d]+")?"+m[n]+"?)?)?";var y=s++;m[y]="[v=\\s]*("+m[h]+")(?:\\.("+m[h]+")(?:\\.("+m[h]+")(?:"+m[a]+")?"+m[n]+"?)?)?";var C=s++;m[C]="^"+m[f]+"\\s*"+m[k]+"$";var T=s++;m[T]="^"+m[f]+"\\s*"+m[y]+"$";var $=s++;m[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=s++;m[b]="(?:~>?)";var N=s++;m[N]="(\\s*)"+m[b]+"\\s+",O[N]=new RegExp(m[N],"g");var A=s++;m[A]="^"+m[b]+m[k]+"$";var F=s++;m[F]="^"+m[b]+m[y]+"$";var G=s++;m[G]="(?:\\^)";var x=s++;m[x]="(\\s*)"+m[G]+"\\s+",O[x]=new RegExp(m[x],"g");var j=s++;m[j]="^"+m[G]+m[k]+"$";var U=s++;m[U]="^"+m[G]+m[y]+"$";var J=s++;m[J]="^"+m[f]+"\\s*("+c+")$|^$";var Z=s++;m[Z]="^"+m[f]+"\\s*("+o+")$|^$";var ae=s++;m[ae]="(\\s*)"+m[f]+"\\s*("+c+"|"+m[k]+")",O[ae]=new RegExp(m[ae],"g");var ee=s++;m[ee]="^\\s*("+m[k]+")\\s+-\\s+("+m[k]+")\\s*$";var oe=s++;m[oe]="^\\s*("+m[y]+")\\s+-\\s+("+m[y]+")\\s*$";var ie=s++;m[ie]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)P(ue,m[ue]),O[ue]||(O[ue]=new RegExp(m[ue]));function _(B,Q){if(B instanceof $e)return B;if(typeof B!="string"||B.length>L||!(Q?O[g]:O[t]).test(B))return null;try{return new $e(B,Q)}catch{return null}}function $e(B,Q){if(B instanceof $e){if(B.loose===Q)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof $e))return new $e(B,Q);P("SemVer",B,Q),this.loose=Q;var H=B.trim().match(Q?O[g]:O[t]);if(!H)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var ge=+se;if(ge>=0&&ge<R)return ge}return se}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=_,e.valid=function(B,Q){var H=_(B,Q);return H?H.version:null},e.clean=function(B,Q){var H=_(B.trim().replace(/^[=v]+/,""),Q);return H?H.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(B){return P("SemVer.compare",this.version,this.loose,B),B instanceof $e||(B=new $e(B,this.loose)),this.compareMain(B)||this.comparePre(B)},$e.prototype.compareMain=function(B){return B instanceof $e||(B=new $e(B,this.loose)),X(this.major,B.major)||X(this.minor,B.minor)||X(this.patch,B.patch)},$e.prototype.comparePre=function(B){if(B instanceof $e||(B=new $e(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var Q=0;do{var H=this.prerelease[Q],se=B.prerelease[Q];if(P("prerelease compare",Q,H,se),H===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(H===void 0)return-1;if(H!==se)return X(H,se)}while(++Q)},$e.prototype.inc=function(B,Q){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,Q,H,se){typeof H=="string"&&(se=H,H=void 0);try{return new $e(B,H).inc(Q,se).version}catch{return null}},e.diff=function(B,Q){if(Pe(B,Q))return null;var H=_(B),se=_(Q);if(H.prerelease.length||se.prerelease.length){for(var ge in H)if((ge==="major"||ge==="minor"||ge==="patch")&&H[ge]!==se[ge])return"pre"+ge;return"prerelease"}for(var ge in H)if((ge==="major"||ge==="minor"||ge==="patch")&&H[ge]!==se[ge])return ge},e.compareIdentifiers=X;var Ie=/^[0-9]+$/;function X(B,Q){var H=Ie.test(B),se=Ie.test(Q);return H&&se&&(B=+B,Q=+Q),H&&!se?-1:se&&!H?1:B<Q?-1:B>Q?1:0}function V(B,Q,H){return new $e(B,H).compare(new $e(Q,H))}function re(B,Q,H){return V(B,Q,H)>0}function be(B,Q,H){return V(B,Q,H)<0}function Pe(B,Q,H){return V(B,Q,H)===0}function Fe(B,Q,H){return V(B,Q,H)!==0}function Be(B,Q,H){return V(B,Q,H)>=0}function xe(B,Q,H){return V(B,Q,H)<=0}function nt(B,Q,H,se){var ge;switch(Q){case"===":typeof B=="object"&&(B=B.version),typeof H=="object"&&(H=H.version),ge=B===H;break;case"!==":typeof B=="object"&&(B=B.version),typeof H=="object"&&(H=H.version),ge=B!==H;break;case"":case"=":case"==":ge=Pe(B,H,se);break;case"!=":ge=Fe(B,H,se);break;case">":ge=re(B,H,se);break;case">=":ge=Be(B,H,se);break;case"<":ge=be(B,H,se);break;case"<=":ge=xe(B,H,se);break;default:throw new TypeError("Invalid operator: "+Q)}return ge}function ht(B,Q){if(B instanceof ht){if(B.loose===Q)return B;B=B.value}if(!(this instanceof ht))return new ht(B,Q);P("comparator",B,Q),this.loose=Q,this.parse(B),this.semver===$t?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(B,Q){return X(Q,B)},e.major=function(B,Q){return new $e(B,Q).major},e.minor=function(B,Q){return new $e(B,Q).minor},e.patch=function(B,Q){return new $e(B,Q).patch},e.compare=V,e.compareLoose=function(B,Q){return V(B,Q,!0)},e.rcompare=function(B,Q,H){return V(Q,B,H)},e.sort=function(B,Q){return B.sort(function(H,se){return e.compare(H,se,Q)})},e.rsort=function(B,Q){return B.sort(function(H,se){return e.rcompare(H,se,Q)})},e.gt=re,e.lt=be,e.eq=Pe,e.neq=Fe,e.gte=Be,e.lte=xe,e.cmp=nt,e.Comparator=ht;var $t={};function ut(B,Q){if(B instanceof ut)return B.loose===Q?B:new ut(B.raw,Q);if(B instanceof ht)return new ut(B.value,Q);if(!(this instanceof ut))return new ut(B,Q);if(this.loose=Q,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function et(B){return!B||B.toLowerCase()==="x"||B==="*"}function Le(B,Q,H,se,ge,Ee,ze,Je,_e,tt,ct,it,at){return((Q=et(H)?"":et(se)?">="+H+".0.0":et(ge)?">="+H+"."+se+".0":">="+Q)+" "+(Je=et(_e)?"":et(tt)?"<"+(+_e+1)+".0.0":et(ct)?"<"+_e+"."+(+tt+1)+".0":it?"<="+_e+"."+tt+"."+ct+"-"+it:"<="+Je)).trim()}function Me(B,Q){for(var H=0;H<B.length;H++)if(!B[H].test(Q))return!1;if(Q.prerelease.length){for(H=0;H<B.length;H++)if(P(B[H].semver),B[H].semver!==$t&&B[H].semver.prerelease.length>0){var se=B[H].semver;if(se.major===Q.major&&se.minor===Q.minor&&se.patch===Q.patch)return!0}return!1}return!0}function Ne(B,Q,H){try{Q=new ut(Q,H)}catch{return!1}return Q.test(B)}function W(B,Q,H,se){var ge,Ee,ze,Je,_e;switch(B=new $e(B,se),Q=new ut(Q,se),H){case">":ge=re,Ee=xe,ze=be,Je=">",_e=">=";break;case"<":ge=be,Ee=Be,ze=re,Je="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(B,Q,se))return!1;for(var tt=0;tt<Q.set.length;++tt){var ct=Q.set[tt],it=null,at=null;if(ct.forEach(function(yt){yt.semver===$t&&(yt=new ht(">=0.0.0")),it=it||yt,at=at||yt,ge(yt.semver,it.semver,se)?it=yt:ze(yt.semver,at.semver,se)&&(at=yt)}),it.operator===Je||it.operator===_e||(!at.operator||at.operator===Je)&&Ee(B,at.semver)||at.operator===_e&&ze(B,at.semver))return!1}return!0}ht.prototype.parse=function(B){var Q=this.loose?O[J]:O[Z],H=B.match(Q);if(!H)throw new TypeError("Invalid comparator: "+B);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new $e(H[2],this.loose):this.semver=$t},ht.prototype.toString=function(){return this.value},ht.prototype.test=function(B){return P("Comparator.test",B,this.loose),this.semver===$t||(typeof B=="string"&&(B=new $e(B,this.loose)),nt(B,this.operator,this.semver,this.loose))},ht.prototype.intersects=function(B,Q){if(!(B instanceof ht))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new ut(B.value,Q),Ne(this.value,H,Q);if(B.operator==="")return H=new ut(this.value,Q),Ne(B.semver,H,Q);var se=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),ge=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Ee=this.semver.version===B.semver.version,ze=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Je=nt(this.semver,"<",B.semver,Q)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),_e=nt(this.semver,">",B.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return se||ge||Ee&&ze||Je||_e},e.Range=ut,ut.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},ut.prototype.toString=function(){return this.range},ut.prototype.parseRange=function(B){var Q=this.loose;B=B.trim(),P("range",B,Q);var H=Q?O[oe]:O[ee];B=B.replace(H,Le),P("hyphen replace",B),B=B.replace(O[ae],"$1$2$3"),P("comparator trim",B,O[ae]),B=(B=(B=B.replace(O[N],"$1~")).replace(O[x],"$1^")).split(/\s+/).join(" ");var se=Q?O[J]:O[Z],ge=B.split(" ").map(function(Ee){return function(ze,Je){return P("comp",ze),ze=function(_e,tt){return _e.trim().split(/\s+/).map(function(ct){return function(it,at){P("caret",it,at);var yt=at?O[U]:O[j];return it.replace(yt,function(Ye,he,pe,ye,Ce){var fe;return P("caret",it,Ye,he,pe,ye,Ce),et(he)?fe="":et(pe)?fe=">="+he+".0.0 <"+(+he+1)+".0.0":et(ye)?fe=he==="0"?">="+he+"."+pe+".0 <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+".0 <"+(+he+1)+".0.0":Ce?(P("replaceCaret pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),fe=he==="0"?pe==="0"?">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+pe+"."+(+ye+1):">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+"."+ye+Ce+" <"+(+he+1)+".0.0"):(P("no pr"),fe=he==="0"?pe==="0"?">="+he+"."+pe+"."+ye+" <"+he+"."+pe+"."+(+ye+1):">="+he+"."+pe+"."+ye+" <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+"."+ye+" <"+(+he+1)+".0.0"),P("caret return",fe),fe})}(ct,tt)}).join(" ")}(ze,Je),P("caret",ze),ze=function(_e,tt){return _e.trim().split(/\s+/).map(function(ct){return function(it,at){var yt=at?O[F]:O[A];return it.replace(yt,function(Ye,he,pe,ye,Ce){var fe;return P("tilde",it,Ye,he,pe,ye,Ce),et(he)?fe="":et(pe)?fe=">="+he+".0.0 <"+(+he+1)+".0.0":et(ye)?fe=">="+he+"."+pe+".0 <"+he+"."+(+pe+1)+".0":Ce?(P("replaceTilde pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),fe=">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+(+pe+1)+".0"):fe=">="+he+"."+pe+"."+ye+" <"+he+"."+(+pe+1)+".0",P("tilde return",fe),fe})}(ct,tt)}).join(" ")}(ze,Je),P("tildes",ze),ze=function(_e,tt){return P("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(ct){return function(it,at){it=it.trim();var yt=at?O[T]:O[C];return it.replace(yt,function(Ye,he,pe,ye,Ce,fe){P("xRange",it,Ye,he,pe,ye,Ce,fe);var ve=et(pe),Y=ve||et(ye),q=Y||et(Ce);return he==="="&&q&&(he=""),ve?Ye=he===">"||he==="<"?"<0.0.0":"*":he&&q?(Y&&(ye=0),q&&(Ce=0),he===">"?(he=">=",Y?(pe=+pe+1,ye=0,Ce=0):q&&(ye=+ye+1,Ce=0)):he==="<="&&(he="<",Y?pe=+pe+1:ye=+ye+1),Ye=he+pe+"."+ye+"."+Ce):Y?Ye=">="+pe+".0.0 <"+(+pe+1)+".0.0":q&&(Ye=">="+pe+"."+ye+".0 <"+pe+"."+(+ye+1)+".0"),P("xRange return",Ye),Ye})}(ct,tt)}).join(" ")}(ze,Je),P("xrange",ze),ze=function(_e,tt){return P("replaceStars",_e,tt),_e.trim().replace(O[ie],"")}(ze,Je),P("stars",ze),ze}(Ee,Q)}).join(" ").split(/\s+/);return this.loose&&(ge=ge.filter(function(Ee){return!!Ee.match(se)})),ge=ge.map(function(Ee){return new ht(Ee,Q)})},ut.prototype.intersects=function(B,Q){if(!(B instanceof ut))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(se){return B.set.some(function(ge){return ge.every(function(Ee){return se.intersects(Ee,Q)})})})})},e.toComparators=function(B,Q){return new ut(B,Q).set.map(function(H){return H.map(function(se){return se.value}).join(" ").trim().split(" ")})},ut.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new $e(B,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Me(this.set[Q],B))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(B,Q,H){var se=null,ge=null;try{var Ee=new ut(Q,H)}catch{return null}return B.forEach(function(ze){Ee.test(ze)&&(se&&ge.compare(ze)!==-1||(ge=new $e(se=ze,H)))}),se},e.minSatisfying=function(B,Q,H){var se=null,ge=null;try{var Ee=new ut(Q,H)}catch{return null}return B.forEach(function(ze){Ee.test(ze)&&(se&&ge.compare(ze)!==1||(ge=new $e(se=ze,H)))}),se},e.validRange=function(B,Q){try{return new ut(B,Q).range||"*"}catch{return null}},e.ltr=function(B,Q,H){return W(B,Q,"<",H)},e.gtr=function(B,Q,H){return W(B,Q,">",H)},e.outside=W,e.prerelease=function(B,Q){var H=_(B,Q);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(B,Q,H){return B=new ut(B,H),Q=new ut(Q,H),B.intersects(Q)},e.coerce=function(B){if(B instanceof $e)return B;if(typeof B!="string")return null;var Q=B.match(O[$]);return Q==null?null:_((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,v(1))},function(we,e){var v,D,P=we.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function O(l){if(v===setTimeout)return setTimeout(l,0);if((v===L||!v)&&setTimeout)return v=setTimeout,setTimeout(l,0);try{return v(l,0)}catch{try{return v.call(null,l,0)}catch{return v.call(this,l,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:L}catch{v=L}try{D=typeof clearTimeout=="function"?clearTimeout:R}catch{D=R}})();var m,s=[],I=!1,w=-1;function u(){I&&m&&(I=!1,m.length?s=m.concat(s):w=-1,s.length&&E())}function E(){if(!I){var l=O(u);I=!0;for(var d=s.length;d;){for(m=s,s=[];++w<d;)m&&m[w].run();w=-1,d=s.length}m=null,I=!1,function(a){if(D===clearTimeout)return clearTimeout(a);if((D===R||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(a);try{D(a)}catch{try{return D.call(null,a)}catch{return D.call(this,a)}}}(l)}}function p(l,d){this.fun=l,this.array=d}function r(){}P.nextTick=function(l){var d=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)d[a-1]=arguments[a];s.push(new p(l,d)),s.length!==1||I||O(E)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(l){return[]},P.binding=function(l){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(l){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Re[146],Te([1,0,6,4]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=e.$nt=e.$mt=e.$lt=e.ScrollbarVisibility=void 0;var P;(function(E){E[E.Auto=1]="Auto",E[E.Hidden=2]="Hidden",E[E.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class L{constructor(p,r,l,d,a,i,n){this.c=p,this._scrollStateBrand=void 0,this.c&&(r=r|0,l=l|0,d=d|0,a=a|0,i=i|0,n=n|0),this.rawScrollLeft=d,this.rawScrollTop=n,r<0&&(r=0),d+r>l&&(d=l-r),d<0&&(d=0),a<0&&(a=0),n+a>i&&(n=i-a),n<0&&(n=0),this.width=r,this.scrollWidth=l,this.scrollLeft=d,this.height=a,this.scrollHeight=i,this.scrollTop=n}equals(p){return this.rawScrollLeft===p.rawScrollLeft&&this.rawScrollTop===p.rawScrollTop&&this.width===p.width&&this.scrollWidth===p.scrollWidth&&this.scrollLeft===p.scrollLeft&&this.height===p.height&&this.scrollHeight===p.scrollHeight&&this.scrollTop===p.scrollTop}withScrollDimensions(p,r){return new L(this.c,typeof p.width<"u"?p.width:this.width,typeof p.scrollWidth<"u"?p.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof p.height<"u"?p.height:this.height,typeof p.scrollHeight<"u"?p.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(p){return new L(this.c,this.width,this.scrollWidth,typeof p.scrollLeft<"u"?p.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof p.scrollTop<"u"?p.scrollTop:this.rawScrollTop)}createScrollEvent(p,r){const l=this.width!==p.width,d=this.scrollWidth!==p.scrollWidth,a=this.scrollLeft!==p.scrollLeft,i=this.height!==p.height,n=this.scrollHeight!==p.scrollHeight,t=this.scrollTop!==p.scrollTop;return{inSmoothScrolling:r,oldWidth:p.width,oldScrollWidth:p.scrollWidth,oldScrollLeft:p.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:p.height,oldScrollHeight:p.scrollHeight,oldScrollTop:p.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:l,scrollWidthChanged:d,scrollLeftChanged:a,heightChanged:i,scrollHeightChanged:n,scrollTopChanged:t}}}e.$lt=L;class R extends D.$Zc{constructor(p){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$qe),this.onScroll=this.j.event,this.c=p.smoothScrollDuration,this.f=p.scheduleAtNextAnimationFrame,this.g=new L(p.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(p){this.c=p}validateScrollPosition(p){return this.g.withScrollPosition(p)}getScrollDimensions(){return this.g}setScrollDimensions(p,r){const l=this.g.withScrollDimensions(p,r);this.n(l,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(p){const r=this.g.withScrollPosition(p);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(p,r){if(this.c===0)return this.setScrollPositionNow(p);if(this.h){p={scrollLeft:typeof p.scrollLeft>"u"?this.h.to.scrollLeft:p.scrollLeft,scrollTop:typeof p.scrollTop>"u"?this.h.to.scrollTop:p.scrollTop};const l=this.g.withScrollPosition(p);if(this.h.to.scrollLeft===l.scrollLeft&&this.h.to.scrollTop===l.scrollTop)return;let d;r?d=new I(this.h.from,l,this.h.startTime,this.h.duration):d=this.h.combine(this.g,l,this.c),this.h.dispose(),this.h=d}else{const l=this.g.withScrollPosition(p);this.h=I.start(this.g,l,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const p=this.h.tick(),r=this.g.withScrollPosition(p);if(this.n(r,!0),!!this.h){if(p.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(p,r){const l=this.g;l.equals(p)||(this.g=p,this.j.fire(this.g.createScrollEvent(l,r)))}}e.$mt=R;class O{constructor(p,r,l){this.scrollLeft=p,this.scrollTop=r,this.isDone=l}}e.$nt=O;function m(E,p){const r=p-E;return function(l){return E+r*u(l)}}function s(E,p,r){return function(l){return l<r?E(l/r):p((l-r)/(1-r))}}class I{constructor(p,r,l,d){this.from=p,this.to=r,this.duration=d,this.startTime=l,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(p,r,l){if(Math.abs(p-r)>2.5*l){let a,i;return p<r?(a=p+.75*l,i=r-.75*l):(a=p-.75*l,i=r+.75*l),s(m(p,a),m(i,r),.33)}return m(p,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(p){this.to=p.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(p){const r=(p-this.startTime)/this.duration;if(r<1){const l=this.c(r),d=this.d(r);return new O(l,d,!1)}return new O(this.to.scrollLeft,this.to.scrollTop,!0)}combine(p,r,l){return I.start(p,r,l)}static start(p,r,l){l=l+10;const d=Date.now()-10;return new I(p,r,d,l)}}e.$ot=I;function w(E){return Math.pow(E,3)}function u(E){return 1-w(1-E)}}),define(Re[147],Te([1,0,12,4]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=P,e.$Ee=L,e.$Fe=R,e.$Ge=O,e.$He=s,e.$Ie=I,e.$Je=w,e.$Ke=u,e.$Le=E,e.$Me=p,e.$Ne=r,e.$Oe=l,e.$Pe=d,e.$Qe=a,e.$Re=i;function P(n){const t=n;return t?typeof t.read=="function":!1}function L(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}function R(n){const t=n;return t?L(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function O(n,t){return new m(n,t)}class m{constructor(t,o){this.e=t,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(o=>o(t))}h(t){this.c.error.length===0?(0,v.$4)(t):this.c.error.slice(0).forEach(o=>o(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,o){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(t,o){if(this.a.destroyed)return;let c;switch(t){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const g=c.indexOf(o);g>=0&&c.splice(g,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(n,t){const o=[];let c;for(;(c=n.read())!==null;)o.push(c);return t(o)}function I(n,t,o){const c=[];let g;for(;(g=n.read())!==null&&c.length<o;)c.push(g);return g===null&&c.length>0?t(c):{read:()=>{if(c.length>0)return c.shift();if(typeof g<"u"){const f=g;return g=void 0,f}return n.read()}}}function w(n,t){return new Promise((o,c)=>{const g=[];u(n,{onData:f=>{t&&g.push(f)},onError:f=>{t?c(f):o(void 0)},onEnd:()=>{o(t?t(g):void 0)}})})}function u(n,t,o){n.on("error",c=>{o?.isCancellationRequested||t.onError(c)}),n.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),n.on("data",c=>{o?.isCancellationRequested||t.onData(c)})}function E(n,t){return new Promise((o,c)=>{const g=new D.$Yc,f=[],h=y=>{if(f.push(y),f.length>t)return g.dispose(),n.pause(),o({stream:n,buffer:f,ended:!1})},S=y=>(g.dispose(),c(y)),k=()=>(g.dispose(),o({stream:n,buffer:f,ended:!0}));g.add((0,D.$Xc)(()=>n.removeListener("error",S))),n.on("error",S),g.add((0,D.$Xc)(()=>n.removeListener("end",k))),n.on("end",k),g.add((0,D.$Xc)(()=>n.removeListener("data",h))),n.on("data",h)})}function p(n,t){const o=O(t);return o.end(n),o}function r(){const n=O(()=>{throw new Error("not supported")});return n.end(),n}function l(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}function d(n,t,o){const c=O(o);return u(n,{onData:g=>c.write(t.data(g)),onError:g=>c.error(t.error?t.error(g):g),onEnd:()=>c.end()}),c}function a(n,t,o){let c=!1;return{read:()=>{const g=t.read();return c?g:(c=!0,g!==null?o([n,g]):n)}}}function i(n,t,o){let c=!1;const g=O(o);return u(t,{onData:f=>c?g.write(f):(c=!0,g.write(o([n,f]))),onError:f=>g.error(f),onEnd:()=>{c||(c=!0,g.write(n)),g.end()}}),g}}),define(Re[20],Te([1,0,51,147]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=void 0,e.$Te=s,e.$Ue=I,e.$Ve=w,e.$We=u,e.$Xe=E,e.$Ye=p,e.$Ze=r,e.$1e=l,e.$2e=d,e.$3e=a,e.$4e=i,e.$5e=n,e.$6e=t,e.$7e=o,e.$8e=c,e.$9e=g,e.$0e=f,e.$$e=h,e.$_e=S,e.$af=C,D=Ve(D);const P=typeof Buffer<"u",L=new v.$Y(()=>new Uint8Array(256));let R,O;class m{static alloc($){return P?new m(Buffer.allocUnsafe($)):new m(new Uint8Array($))}static wrap($){return P&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new m($)}static fromString($,b){return!(b?.dontUseNodeBuffer||!1)&&P?new m(Buffer.from($)):(R||(R=new TextEncoder),new m(R.encode($)))}static fromByteArray($){const b=m.alloc($.length);for(let N=0,A=$.length;N<A;N++)b.buffer[N]=$[N];return b}static concat($,b){if(typeof b>"u"){b=0;for(let F=0,G=$.length;F<G;F++)b+=$[F].byteLength}const N=m.alloc(b);let A=0;for(let F=0,G=$.length;F<G;F++){const x=$[F];N.set(x,A),A+=x.byteLength}return N}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=m.alloc(this.byteLength);return $.set(this),$}toString(){return P?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice($,b){return new m(this.buffer.subarray($,b))}set($,b){if($ instanceof m)this.buffer.set($.buffer,b);else if($ instanceof Uint8Array)this.buffer.set($,b);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),b);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return u(this.buffer,$)}writeUInt32BE($,b){E(this.buffer,$,b)}readUInt32LE($){return p(this.buffer,$)}writeUInt32LE($,b){r(this.buffer,$,b)}readUInt8($){return l(this.buffer,$)}writeUInt8($,b){d(this.buffer,$,b)}indexOf($,b=0){return s(this.buffer,$ instanceof m?$.buffer:$,b)}}e.$Se=m;function s(T,$,b=0){const N=$.byteLength,A=T.byteLength;if(N===0)return 0;if(N===1)return T.indexOf($[0]);if(N>A-b)return-1;const F=L.value;F.fill($.length);for(let U=0;U<$.length;U++)F[$[U]]=$.length-U-1;let G=b+$.length-1,x=G,j=-1;for(;G<A;)if(T[G]===$[x]){if(x===0){j=G;break}G--,x--}else G+=Math.max($.length-x,F[T[G]]),x=$.length-1;return j}function I(T,$){return T[$+0]<<0>>>0|T[$+1]<<8>>>0}function w(T,$,b){T[b+0]=$&255,$=$>>>8,T[b+1]=$&255}function u(T,$){return T[$]*2**24+T[$+1]*2**16+T[$+2]*2**8+T[$+3]}function E(T,$,b){T[b+3]=$,$=$>>>8,T[b+2]=$,$=$>>>8,T[b+1]=$,$=$>>>8,T[b]=$}function p(T,$){return T[$+0]<<0>>>0|T[$+1]<<8>>>0|T[$+2]<<16>>>0|T[$+3]<<24>>>0}function r(T,$,b){T[b+0]=$&255,$=$>>>8,T[b+1]=$&255,$=$>>>8,T[b+2]=$&255,$=$>>>8,T[b+3]=$&255}function l(T,$){return T[$]}function d(T,$,b){T[b]=$}function a(T){return D.$He(T,$=>m.concat($))}function i(T){return D.$Oe(T)}function n(T){return D.$Je(T,$=>m.concat($))}async function t(T){return T.ended?m.concat(T.buffer):m.concat([...T.buffer,await n(T.stream)])}function o(T){return D.$Me(T,$=>m.concat($))}function c(T){return D.$Pe(T,{data:$=>typeof $=="string"?m.fromString($):m.wrap($)},$=>m.concat($))}function g(T){return D.$Ge($=>m.concat($),T)}function f(T,$){return D.$Qe(T,$,b=>m.concat(b))}function h(T,$){return D.$Re(T,$,b=>m.concat(b))}function S(T){let $=0,b=0,N=0;const A=new Uint8Array(Math.floor(T.length/4*3)),F=x=>{switch(b){case 3:A[N++]=$|x,b=0;break;case 2:A[N++]=$|x>>>2,$=x<<6,b=3;break;case 1:A[N++]=$|x>>>4,$=x<<4,b=2;break;default:$=x<<2,b=1}};for(let x=0;x<T.length;x++){const j=T.charCodeAt(x);if(j>=65&&j<=90)F(j-65);else if(j>=97&&j<=122)F(j-97+26);else if(j>=48&&j<=57)F(j-48+52);else if(j===43||j===45)F(62);else if(j===47||j===95)F(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${T[x]}`)}}const G=N;for(;b>0;)F(0);return m.wrap(A).slice(0,G)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:T},$=!0,b=!1){const N=b?y:k;let A="";const F=T.byteLength%3;let G=0;for(;G<T.byteLength-F;G+=3){const x=T[G+0],j=T[G+1],U=T[G+2];A+=N[x>>>2],A+=N[(x<<4|j>>>4)&63],A+=N[(j<<2|U>>>6)&63],A+=N[U&63]}if(F===1){const x=T[G+0];A+=N[x>>>2],A+=N[x<<4&63],$&&(A+="==")}else if(F===2){const x=T[G+0],j=T[G+1];A+=N[x>>>2],A+=N[(x<<4|j>>>4)&63],A+=N[j<<2&63],$&&(A+="=")}return A}}),define(Re[36],Te([1,0,98]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$$j=P;var D;(function(R){function O(m){return m&&typeof m=="object"&&typeof m.id=="string"}R.isThemeColor=O})(D||(e.ThemeColor=D={}));function P(R){return{id:R}}var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const O=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function m(a){const i=O.exec(a.id);if(!i)return m(v.$0j.error);const[,n,t]=i,o=["codicon","codicon-"+n];return t&&o.push("codicon-modifier-"+t.substring(1)),o}R.asClassNameArray=m;function s(a){return m(a).join(" ")}R.asClassName=s;function I(a){return"."+m(a).join(".")}R.asCSSSelector=I;function w(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||D.isThemeColor(a.color))}R.isThemeIcon=w;const u=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function E(a){const i=u.exec(a);if(!i)return;const[,n]=i;return{id:n}}R.fromString=E;function p(a){return{id:a}}R.fromId=p;function r(a,i){let n=a.id;const t=n.lastIndexOf("~");return t!==-1&&(n=n.substring(0,t)),i&&(n=`${n}~${i}`),{id:n}}R.modify=r;function l(a){const i=a.id.lastIndexOf("~");if(i!==-1)return a.id.substring(i+1)}R.getModifier=l;function d(a,i){return a.id===i.id&&a.color?.id===i.color?.id}R.isEqual=d})(L||(e.ThemeIcon=L={}))}),define(Re[148],Te([1,0,30,27,140,13]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.FuzzyScore=e.$Nk=e.$Mk=void 0,e.or=R,e.$Ok=m,e.$Pk=s,e.$Qk=u,e.$Rk=k,e.$Sk=y,e.$Tk=A,e.$Uk=F,e.$Vk=G,e.$Wk=x,e.$Xk=re,e.$Zk=Be,e.$1k=ht,e.$2k=$t,L=Ve(L);function R(...Le){return function(Me,Ne){for(let W=0,B=Le.length;W<B;W++){const Q=Le[W](Me,Ne);if(Q)return Q}return null}}e.$Mk=O.bind(void 0,!1),e.$Nk=O.bind(void 0,!0);function O(Le,Me,Ne){if(!Ne||Ne.length<Me.length)return null;let W;return Le?W=L.$Lf(Ne,Me):W=Ne.indexOf(Me)===0,W?Me.length>0?[{start:0,end:Me.length}]:[]:null}function m(Le,Me){const Ne=Me.toLowerCase().indexOf(Le.toLowerCase());return Ne===-1?null:[{start:Ne,end:Ne+Le.length}]}function s(Le,Me){return I(Le.toLowerCase(),Me.toLowerCase(),0,0)}function I(Le,Me,Ne,W){if(Ne===Le.length)return[];if(W===Me.length)return null;if(Le[Ne]===Me[W]){let B=null;return(B=I(Le,Me,Ne+1,W+1))?t({start:W,end:W+1},B):null}return I(Le,Me,Ne,W+1)}function w(Le){return v.CharCode.a<=Le&&Le<=v.CharCode.z}function u(Le){return v.CharCode.A<=Le&&Le<=v.CharCode.Z}function E(Le){return v.CharCode.Digit0<=Le&&Le<=v.CharCode.Digit9}function p(Le){return Le===v.CharCode.Space||Le===v.CharCode.Tab||Le===v.CharCode.LineFeed||Le===v.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Le=>r.add(Le.charCodeAt(0)));function l(Le){return p(Le)||r.has(Le)}function d(Le,Me){return Le===Me||l(Le)&&l(Me)}const a=new Map;function i(Le){if(a.has(Le))return a.get(Le);let Me;const Ne=(0,P.$Kk)(Le);return Ne&&(Me=Ne),a.set(Le,Me),Me}function n(Le){return w(Le)||u(Le)||E(Le)}function t(Le,Me){return Me.length===0?Me=[Le]:Le.end===Me[0].start?Me[0].start=Le.start:Me.unshift(Le),Me}function o(Le,Me){for(let Ne=Me;Ne<Le.length;Ne++){const W=Le.charCodeAt(Ne);if(u(W)||E(W)||Ne>0&&!n(Le.charCodeAt(Ne-1)))return Ne}return Le.length}function c(Le,Me,Ne,W){if(Ne===Le.length)return[];if(W===Me.length)return null;if(Le[Ne]!==Me[W].toLowerCase())return null;{let B=null,Q=W+1;for(B=c(Le,Me,Ne+1,W+1);!B&&(Q=o(Me,Q))<Me.length;)B=c(Le,Me,Ne+1,Q),Q++;return B===null?null:t({start:W,end:W+1},B)}}function g(Le){let Me=0,Ne=0,W=0,B=0,Q=0;for(let ze=0;ze<Le.length;ze++)Q=Le.charCodeAt(ze),u(Q)&&Me++,w(Q)&&Ne++,n(Q)&&W++,E(Q)&&B++;const H=Me/Le.length,se=Ne/Le.length,ge=W/Le.length,Ee=B/Le.length;return{upperPercent:H,lowerPercent:se,alphaPercent:ge,numericPercent:Ee}}function f(Le){const{upperPercent:Me,lowerPercent:Ne}=Le;return Ne===0&&Me>.6}function h(Le){const{upperPercent:Me,lowerPercent:Ne,alphaPercent:W,numericPercent:B}=Le;return Ne>.2&&Me<.8&&W>.6&&B<.2}function S(Le){let Me=0,Ne=0,W=0,B=0;for(let Q=0;Q<Le.length;Q++)W=Le.charCodeAt(Q),u(W)&&Me++,w(W)&&Ne++,p(W)&&B++;return(Me===0||Ne===0)&&B===0?Le.length<=30:Me<=5}function k(Le,Me){if(!Me||(Me=Me.trim(),Me.length===0)||!S(Le))return null;Me.length>60&&(Me=Me.substring(0,60));const Ne=g(Me);if(!h(Ne)){if(!f(Ne))return null;Me=Me.toLowerCase()}let W=null,B=0;for(Le=Le.toLowerCase();B<Me.length&&(W=c(Le,Me,0,B))===null;)B=o(Me,B+1);return W}function y(Le,Me,Ne=!1){if(!Me||Me.length===0)return null;let W=null,B=0;for(Le=Le.toLowerCase(),Me=Me.toLowerCase();B<Me.length&&(W=C(Le,Me,0,B,Ne),W===null);)B=T(Me,B+1);return W}function C(Le,Me,Ne,W,B){let Q=0;if(Ne===Le.length)return[];if(W===Me.length)return null;if(!d(Le.charCodeAt(Ne),Me.charCodeAt(W))){const ge=i(Le.charCodeAt(Ne));if(!ge)return null;for(let Ee=0;Ee<ge.length;Ee++)if(!d(ge[Ee],Me.charCodeAt(W+Ee)))return null;Q+=ge.length-1}let H=null,se=W+Q+1;if(H=C(Le,Me,Ne+1,se,B),!B)for(;!H&&(se=T(Me,se))<Me.length;)H=C(Le,Me,Ne+1,se,B),se++;if(!H)return null;if(Le.charCodeAt(Ne)!==Me.charCodeAt(W)){const ge=i(Le.charCodeAt(Ne));if(!ge)return H;for(let Ee=0;Ee<ge.length;Ee++)if(ge[Ee]!==Me.charCodeAt(W+Ee))return H}return t({start:W,end:W+Q+1},H)}function T(Le,Me){for(let Ne=Me;Ne<Le.length;Ne++)if(l(Le.charCodeAt(Ne))||Ne>0&&l(Le.charCodeAt(Ne-1)))return Ne;return Le.length}const $=R(e.$Nk,k,m),b=R(e.$Nk,k,s),N=new D.$Ic(1e4);function A(Le,Me,Ne=!1){if(typeof Le!="string"||typeof Me!="string")return null;let W=N.get(Le);W||(W=new RegExp(L.$tf(Le),"i"),N.set(Le,W));const B=W.exec(Me);return B?[{start:B.index,end:B.index+B[0].length}]:Ne?b(Le,Me):$(Le,Me)}function F(Le,Me){const Ne=Be(Le,Le.toLowerCase(),0,Me,Me.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ne?x(Ne):null}function G(Le,Me,Ne,W,B,Q){const H=Math.min(13,Le.length);for(;Ne<H;Ne++){const se=Be(Le,Me,Ne,W,B,Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,Q]}function x(Le){if(typeof Le>"u")return[];const Me=[],Ne=Le[1];for(let W=Le.length-1;W>1;W--){const B=Le[W]+Ne,Q=Me[Me.length-1];Q&&Q.end===B?Q.end=B+1:Me.push({start:B,end:B+1})}return Me}const j=128;function U(){const Le=[],Me=[];for(let Ne=0;Ne<=j;Ne++)Me[Ne]=0;for(let Ne=0;Ne<=j;Ne++)Le.push(Me.slice(0));return Le}function J(Le){const Me=[];for(let Ne=0;Ne<=Le;Ne++)Me[Ne]=0;return Me}const Z=J(2*j),ae=J(2*j),ee=U(),oe=U(),ie=U(),ue=!1;function _(Le,Me,Ne,W,B){function Q(se,ge,Ee=" "){for(;se.length<ge;)se=Ee+se;return se}let H=` |   |${W.split("").map(se=>Q(se,3)).join("|")}
`;for(let se=0;se<=Ne;se++)se===0?H+=" |":H+=`${Me[se-1]}|`,H+=Le[se].slice(0,B+1).map(ge=>Q(ge.toString(),3)).join("|")+`
`;return H}function $e(Le,Me,Ne,W){Le=Le.substr(Me),Ne=Ne.substr(W),console.log(_(oe,Le,Le.length,Ne,Ne.length)),console.log(_(ie,Le,Le.length,Ne,Ne.length)),console.log(_(ee,Le,Le.length,Ne,Ne.length))}function Ie(Le,Me){if(Me<0||Me>=Le.length)return!1;const Ne=Le.codePointAt(Me);switch(Ne){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!L.$4f(Ne)}}function X(Le,Me){if(Me<0||Me>=Le.length)return!1;switch(Le.charCodeAt(Me)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function V(Le,Me,Ne){return Me[Le]!==Ne[Le]}function re(Le,Me,Ne,W,B,Q,H=!1){for(;Me<Ne&&B<Q;)Le[Me]===W[B]&&(H&&(Z[Me]=B),Me+=1),B+=1;return Me===Ne}var be;(function(Le){Le[Le.Diag=1]="Diag",Le[Le.Left=2]="Left",Le[Le.LeftLeft=3]="LeftLeft"})(be||(be={}));var Pe;(function(Le){Le.Default=[-100,0];function Me(Ne){return!Ne||Ne.length===2&&Ne[0]===-100&&Ne[1]===0}Le.isDefault=Me})(Pe||(e.FuzzyScore=Pe={}));class Fe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Me,Ne){this.firstMatchCanBeWeak=Me,this.boostFullMatch=Ne}}e.$Yk=Fe;function Be(Le,Me,Ne,W,B,Q,H=Fe.default){const se=Le.length>j?j:Le.length,ge=W.length>j?j:W.length;if(Ne>=se||Q>=ge||se-Ne>ge-Q||!re(Me,Ne,se,B,Q,ge,!0))return;xe(se,ge,Ne,Q,Me,B);let Ee=1,ze=1,Je=Ne,_e=Q;const tt=[!1];for(Ee=1,Je=Ne;Je<se;Ee++,Je++){const Ye=Z[Je],he=ae[Je],pe=Je+1<se?ae[Je+1]:ge;for(ze=Ye-Q+1,_e=Ye;_e<pe;ze++,_e++){let ye=Number.MIN_SAFE_INTEGER,Ce=!1;_e<=he&&(ye=nt(Le,Me,Je,Ne,W,B,_e,ge,Q,ee[Ee-1][ze-1]===0,tt));let fe=0;ye!==Number.MAX_SAFE_INTEGER&&(Ce=!0,fe=ye+oe[Ee-1][ze-1]);const ve=_e>Ye,Y=ve?oe[Ee][ze-1]+(ee[Ee][ze-1]>0?-5:0):0,q=_e>Ye+1&&ee[Ee][ze-1]>0,de=q?oe[Ee][ze-2]+(ee[Ee][ze-2]>0?-5:0):0;if(q&&(!ve||de>=Y)&&(!Ce||de>=fe))oe[Ee][ze]=de,ie[Ee][ze]=be.LeftLeft,ee[Ee][ze]=0;else if(ve&&(!Ce||Y>=fe))oe[Ee][ze]=Y,ie[Ee][ze]=be.Left,ee[Ee][ze]=0;else if(Ce)oe[Ee][ze]=fe,ie[Ee][ze]=be.Diag,ee[Ee][ze]=ee[Ee-1][ze-1]+1;else throw new Error("not possible")}}if(ue&&$e(Le,Ne,W,Q),!tt[0]&&!H.firstMatchCanBeWeak)return;Ee--,ze--;const ct=[oe[Ee][ze],Q];let it=0,at=0;for(;Ee>=1;){let Ye=ze;do{const he=ie[Ee][Ye];if(he===be.LeftLeft)Ye=Ye-2;else if(he===be.Left)Ye=Ye-1;else break}while(Ye>=1);it>1&&Me[Ne+Ee-1]===B[Q+ze-1]&&!V(Ye+Q-1,W,B)&&it+1>ee[Ee][Ye]&&(Ye=ze),Ye===ze?it++:it=1,at||(at=Ye),Ee--,ze=Ye-1,ct.push(ze)}ge-Q===se&&H.boostFullMatch&&(ct[0]+=2);const yt=at-se;return ct[0]-=yt,ct}function xe(Le,Me,Ne,W,B,Q){let H=Le-1,se=Me-1;for(;H>=Ne&&se>=W;)B[H]===Q[se]&&(ae[H]=se,H--),se--}function nt(Le,Me,Ne,W,B,Q,H,se,ge,Ee,ze){if(Me[Ne]!==Q[H])return Number.MIN_SAFE_INTEGER;let Je=1,_e=!1;return H===Ne-W?Je=Le[Ne]===B[H]?7:5:V(H,B,Q)&&(H===0||!V(H-1,B,Q))?(Je=Le[Ne]===B[H]?7:5,_e=!0):Ie(Q,H)&&(H===0||!Ie(Q,H-1))?Je=5:(Ie(Q,H-1)||X(Q,H-1))&&(Je=5,_e=!0),Je>1&&Ne===W&&(ze[0]=!0),_e||(_e=V(H,B,Q)||Ie(Q,H-1)||X(Q,H-1)),Ne===W?H>ge&&(Je-=_e?3:5):Ee?Je+=_e?2:0:Je+=_e?0:1,H+1===se&&(Je-=_e?3:5),Je}function ht(Le,Me,Ne,W,B,Q,H){return ut(Le,Me,Ne,W,B,Q,!0,H)}function $t(Le,Me,Ne,W,B,Q,H){return ut(Le,Me,Ne,W,B,Q,!1,H)}function ut(Le,Me,Ne,W,B,Q,H,se){let ge=Be(Le,Me,Ne,W,B,Q,se);if(ge&&!H)return ge;if(Le.length>=3){const Ee=Math.min(7,Le.length-1);for(let ze=Ne+1;ze<Ee;ze++){const Je=et(Le,ze);if(Je){const _e=Be(Je,Je.toLowerCase(),Ne,W,B,Q,se);_e&&(_e[0]-=3,(!ge||_e[0]>ge[0])&&(ge=_e))}}}return ge}function et(Le,Me){if(Me+1>=Le.length)return;const Ne=Le[Me],W=Le[Me+1];if(Ne!==W)return Le.slice(0,Me)+W+Ne+Le.slice(Me+2)}}),define(Re[99],Te([1,0,148,13,36]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=m,e.$4k=I,e.$5k=u,e.$6k=E,e.$7k=r,e.$8k=l;const L="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),O=new RegExp(`(\\\\)?${R.source}`,"g");function m(d){return d.replace(O,(a,i)=>i?a:`\\${a}`)}const s=new RegExp(`\\\\${R.source}`,"g");function I(d){return d.replace(s,a=>`\\${a}`)}const w=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function u(d){return d.indexOf(L)===-1?d:d.replace(w,(a,i,n,t)=>n?a:i||t||"")}function E(d){return d?d.replace(/\$\((.*?)\)/g,(a,i)=>` ${i} `).trim():""}const p=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(d){p.lastIndex=0;let a="";const i=[];let n=0;for(;;){const t=p.lastIndex,o=p.exec(d),c=d.substring(t,o?.index);if(c.length>0){a+=c;for(let g=0;g<c.length;g++)i.push(n)}if(!o)break;n+=o[0].length}return{text:a,iconOffsets:i}}function l(d,a,i=!1){const{text:n,iconOffsets:t}=a;if(!t||t.length===0)return(0,v.$Tk)(d,n,i);const o=(0,D.$rf)(n," "),c=n.length-o.length,g=(0,v.$Tk)(d,o,i);if(g)for(const f of g){const h=t[f.start+c]+c;f.start+=h,f.end+=h}return g}}),define(Re[37],Te([1,0,13]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=Ve(v);var D;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(D||(D={})),function(P){const L="error",R="warning",O="warn",m="info",s="ignore";function I(u){return u?v.$Kf(L,u)?P.Error:v.$Kf(R,u)||v.$Kf(O,u)?P.Warning:v.$Kf(m,u)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function w(u){switch(u){case P.Error:return L;case P.Warning:return R;case P.Info:return m;default:return s}}P.toString=w}(D||(D={})),e.default=D}),define(Re[48],Te([1,0,17,30,13]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class L{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const r=p.charCodeAt(0),l=this.b.charCodeAt(this.c);return r-l}value(){return this.b[this.c]}}e.$Mi=L;class R{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===D.CharCode.Period)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,P.$Ef)(p,this.b,0,p.length,this.c,this.d):(0,P.$Gf)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ni=R;class O{constructor(p=!0,r=!0){this.f=p,this.g=r}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let r=p.length-1;r>=0;r--,this.c--){const l=this.b.charCodeAt(r);if(!(l===D.CharCode.Slash||this.f&&l===D.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===D.CharCode.Slash||this.f&&r===D.CharCode.Backslash)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,P.$Ef)(p,this.b,0,p.length,this.d,this.e):(0,P.$Gf)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Oi=O;var m;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(m||(m={}));class s{constructor(p,r){this.f=p,this.g=r,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(m.Scheme),this.c.authority&&this.d.push(m.Authority),this.c.path&&(this.b=new O(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(m.Path)),this.g(p)||(this.c.query&&this.d.push(m.Query),this.c.fragment&&this.d.push(m.Fragment)),this.e=0,this}next(){return this.d[this.e]===m.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===m.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===m.Scheme)return(0,P.$Ff)(p,this.c.scheme);if(this.d[this.e]===m.Authority)return(0,P.$Ff)(p,this.c.authority);if(this.d[this.e]===m.Path)return this.b.cmp(p);if(this.d[this.e]===m.Query)return(0,P.$Df)(p,this.c.query);if(this.d[this.e]===m.Fragment)return(0,P.$Df)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===m.Scheme)return this.c.scheme;if(this.d[this.e]===m.Authority)return this.c.authority;if(this.d[this.e]===m.Path)return this.b.value();if(this.d[this.e]===m.Query)return this.c.query;if(this.d[this.e]===m.Fragment)return this.c.fragment;throw new Error}}e.$Pi=s;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(w||(w={}));class u{static forUris(p=()=>!1,r=()=>!1){return new u(new s(p,r))}static forPaths(p=!1){return new u(new O(void 0,!p))}static forStrings(){return new u(new L)}static forConfigKeys(){return new u(new R)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,r){if(r){const l=r.slice(0);(0,v.$1b)(l);for(const d of l)this.set(d,p)}else{const l=p.slice(0);(0,v.$1b)(l);for(const d of l)this.set(d[0],d[1])}}set(p,r){const l=this.b.reset(p);let d;this.c||(this.c=new I,this.c.segment=l.value());const a=[];for(d=this.c;;){const n=l.cmp(d.segment);if(n>0)d.left||(d.left=new I,d.left.segment=l.value()),a.push([w.Left,d]),d=d.left;else if(n<0)d.right||(d.right=new I,d.right.segment=l.value()),a.push([w.Right,d]),d=d.right;else if(l.hasNext())l.next(),d.mid||(d.mid=new I,d.mid.segment=l.value()),a.push([w.Mid,d]),d=d.mid;else break}const i=d.value;d.value=r,d.key=p;for(let n=a.length-1;n>=0;n--){const t=a[n][1];t.updateHeight();const o=t.balanceFactor();if(o<-1||o>1){const c=a[n][0],g=a[n+1][0];if(c===w.Right&&g===w.Right)a[n][1]=t.rotateLeft();else if(c===w.Left&&g===w.Left)a[n][1]=t.rotateRight();else if(c===w.Right&&g===w.Left)t.right=a[n+1][1]=a[n+1][1].rotateRight(),a[n][1]=t.rotateLeft();else if(c===w.Left&&g===w.Right)t.left=a[n+1][1]=a[n+1][1].rotateLeft(),a[n][1]=t.rotateRight();else throw new Error;if(n>0)switch(a[n-1][0]){case w.Left:a[n-1][1].left=a[n][1];break;case w.Right:a[n-1][1].right=a[n][1];break;case w.Mid:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}return i}get(p){return this.d(p)?.value}d(p){const r=this.b.reset(p);let l=this.c;for(;l;){const d=r.cmp(l.segment);if(d>0)l=l.left;else if(d<0)l=l.right;else if(r.hasNext())r.next(),l=l.mid;else break}return l}has(p){const r=this.d(p);return!(r?.value===void 0&&r?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,r){const l=this.b.reset(p),d=[];let a=this.c;for(;a;){const i=l.cmp(a.segment);if(i>0)d.push([w.Left,a]),a=a.left;else if(i<0)d.push([w.Right,a]),a=a.right;else if(l.hasNext())l.next(),d.push([w.Mid,a]),a=a.mid;else break}if(a){if(r?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const i=this.f(a.right);if(i.key){const{key:n,value:t,segment:o}=i;this.e(i.key,!1),a.key=n,a.value=t,a.segment=o}}else{const i=a.left??a.right;if(d.length>0){const[n,t]=d[d.length-1];switch(n){case w.Left:t.left=i;break;case w.Mid:t.mid=i;break;case w.Right:t.right=i;break}}else this.c=i}for(let i=d.length-1;i>=0;i--){const n=d[i][1];n.updateHeight();const t=n.balanceFactor();if(t>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),d[i][1]=n.rotateLeft()):t<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),d[i][1]=n.rotateRight()),i>0)switch(d[i-1][0]){case w.Left:d[i-1][1].left=d[i][1];break;case w.Right:d[i-1][1].right=d[i][1];break;case w.Mid:d[i-1][1].mid=d[i][1];break}else this.c=d[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const r=this.b.reset(p);let l=this.c,d;for(;l;){const a=r.cmp(l.segment);if(a>0)l=l.left;else if(a<0)l=l.right;else if(r.hasNext())r.next(),d=l.value||d,l=l.mid;else break}return l&&l.value||d}findSuperstr(p){return this.g(p,!1)}g(p,r){const l=this.b.reset(p);let d=this.c;for(;d;){const a=l.cmp(d.segment);if(a>0)d=d.left;else if(a<0)d=d.right;else if(l.hasNext())l.next(),d=d.mid;else return d.mid?this.h(d.mid):r?d.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[r,l]of this)p(l,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const r=[];return this.j(p,r),r[Symbol.iterator]()}j(p,r){p&&(p.left&&this.j(p.left,r),p.value&&r.push([p.key,p.value]),p.mid&&this.j(p.mid,r),p.right&&this.j(p.right,r))}_isBalanced(){const p=r=>{if(!r)return!0;const l=r.balanceFactor();return l<-1||l>1?!1:p(r.left)&&p(r.right)};return p(this.c)}}e.$Qi=u}),define(Re[33],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=void 0,e.$6g=D;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(P){return v.test(P)}e.$7g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(O){for(let m=0;m<O.length;m++)O[m]=Math.floor(Math.random()*256);return O};const L=new Uint8Array(16),R=[];for(let O=0;O<256;O++)R.push(O.toString(16).padStart(2,"0"));return function(){P(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let m=0,s="";return s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+="-",s+=R[L[m++]],s+=R[L[m++]],s+="-",s+=R[L[m++]],s+=R[L[m++]],s+="-",s+=R[L[m++]],s+=R[L[m++]],s+="-",s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s}}()}),define(Re[149],Te([1,0,17,41,33]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bu=e.$zu=void 0,e.$xu=L,e.$yu=R,e.$Au=s;function L(w){return{asString:async()=>w,asFile:()=>{},value:typeof w=="string"?w:void 0}}function R(w,u,E){const p={id:(0,P.$7g)(),name:w,uri:u,data:E};return{asString:async()=>"",asFile:()=>p,value:void 0}}class O{constructor(){this.a=new Map}get size(){let u=0;for(const E of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const E=[...this.a.keys()];return D.Iterable.some(this,([p,r])=>r.asFile())&&E.push("files"),I(m(u),E)}get(u){return this.a.get(this.b(u))?.[0]}append(u,E){const p=this.a.get(u);p?p.push(E):this.a.set(this.b(u),[E])}replace(u,E){this.a.set(this.b(u),[E])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,E]of this.a)for(const p of E)yield[u,p]}b(u){return m(u)}}e.$zu=O;function m(w){return w.toLowerCase()}function s(w,u){return I(m(w),u.map(m))}function I(w,u){if(w==="*/*")return u.length>0;if(u.includes(w))return!0;const E=w.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[p,r,l]=E;return l==="*"?u.some(d=>d.startsWith(r+"/")):!1}e.$Bu=Object.freeze({create:w=>(0,v.$Qb)(w.map(u=>u.toString())).join(`\r
`),split:w=>w.split(`\r
`),parse:w=>e.$Bu.split(w).filter(u=>!u.startsWith("#"))})}),define(Re[150],Te([1,0,30]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Hu=P;var D;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function P(L){let R=0,O=0,m=0,s=D.Unknown;for(let I=0,w=L.length;I<w;I++){const u=L.charCodeAt(I);u===v.CharCode.CarriageReturn?(R===0&&(O=I),R++,I+1<w&&L.charCodeAt(I+1)===v.CharCode.LineFeed?(s|=D.CRLF,I++):s|=D.Invalid,m=I+1):u===v.CharCode.LineFeed&&(s|=D.LF,R===0&&(O=I),R++,m=I+1)}return R===0&&(O=L.length),[R,O,L.length-m,s]}}),define(Re[151],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0,e.$tt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[152],Te([1,0,30,153]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7u=e.$6u=e.IndentAction=void 0;var P;(function(m){m[m.None=0]="None",m[m.Indent=1]="Indent",m[m.IndentOutdent=2]="IndentOutdent",m[m.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class L{constructor(s){if(this.e=null,this.f=!1,this.open=s.open,this.close=s.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(s.notIn))for(let I=0,w=s.notIn.length;I<w;I++)switch(s.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(s){switch(s){case D.StandardTokenType.Other:return!0;case D.StandardTokenType.Comment:return this.c;case D.StandardTokenType.String:return this.b;case D.StandardTokenType.RegEx:return this.d}}shouldAutoClose(s,I){if(s.getTokenCount()===0)return!0;const w=s.findTokenIndexAtOffset(I-2),u=s.getStandardTokenType(w);return this.isOK(u)}g(s,I){for(let w=s;w<=I;w++){const u=String.fromCharCode(w);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$6u=L;class R{constructor(s){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of s)O(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),O(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),O(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),O(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&O(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$7u=R;function O(m,s,I){m.has(s)?m.get(s).push(I):m.set(s,[I])}}),define(Re[154],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oD=e.NodeColor=e.$nD=void 0,e.$pD=P,e.$qD=L,e.$rD=s,e.$sD=I,e.$tD=w,e.$uD=u,e.$vD=E,e.$wD=p;class v{constructor(l,d){this.piece=l,this.color=d,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$oD)return P(this.right);let l=this;for(;l.parent!==e.$oD&&l.parent.left!==l;)l=l.parent;return l.parent===e.$oD?e.$oD:l.parent}prev(){if(this.left!==e.$oD)return L(this.left);let l=this;for(;l.parent!==e.$oD&&l.parent.right!==l;)l=l.parent;return l.parent===e.$oD?e.$oD:l.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$nD=v;var D;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(D||(e.NodeColor=D={})),e.$oD=new v(null,D.Black),e.$oD.parent=e.$oD,e.$oD.left=e.$oD,e.$oD.right=e.$oD,e.$oD.color=D.Black;function P(r){for(;r.left!==e.$oD;)r=r.left;return r}function L(r){for(;r.right!==e.$oD;)r=r.right;return r}function R(r){return r===e.$oD?0:r.size_left+r.piece.length+R(r.right)}function O(r){return r===e.$oD?0:r.lf_left+r.piece.lineFeedCnt+O(r.right)}function m(){e.$oD.parent=e.$oD}function s(r,l){const d=l.right;d.size_left+=l.size_left+(l.piece?l.piece.length:0),d.lf_left+=l.lf_left+(l.piece?l.piece.lineFeedCnt:0),l.right=d.left,d.left!==e.$oD&&(d.left.parent=l),d.parent=l.parent,l.parent===e.$oD?r.root=d:l.parent.left===l?l.parent.left=d:l.parent.right=d,d.left=l,l.parent=d}function I(r,l){const d=l.left;l.left=d.right,d.right!==e.$oD&&(d.right.parent=l),d.parent=l.parent,l.size_left-=d.size_left+(d.piece?d.piece.length:0),l.lf_left-=d.lf_left+(d.piece?d.piece.lineFeedCnt:0),l.parent===e.$oD?r.root=d:l===l.parent.right?l.parent.right=d:l.parent.left=d,d.right=l,l.parent=d}function w(r,l){let d,a;if(l.left===e.$oD?(a=l,d=a.right):l.right===e.$oD?(a=l,d=a.left):(a=P(l.right),d=a.right),a===r.root){r.root=d,d.color=D.Black,l.detach(),m(),r.root.parent=e.$oD;return}const i=a.color===D.Red;if(a===a.parent.left?a.parent.left=d:a.parent.right=d,a===l?(d.parent=a.parent,p(r,d)):(a.parent===l?d.parent=a:d.parent=a.parent,p(r,d),a.left=l.left,a.right=l.right,a.parent=l.parent,a.color=l.color,l===r.root?r.root=a:l===l.parent.left?l.parent.left=a:l.parent.right=a,a.left!==e.$oD&&(a.left.parent=a),a.right!==e.$oD&&(a.right.parent=a),a.size_left=l.size_left,a.lf_left=l.lf_left,p(r,a)),l.detach(),d.parent.left===d){const t=R(d),o=O(d);if(t!==d.parent.size_left||o!==d.parent.lf_left){const c=t-d.parent.size_left,g=o-d.parent.lf_left;d.parent.size_left=t,d.parent.lf_left=o,E(r,d.parent,c,g)}}if(p(r,d.parent),i){m();return}let n;for(;d!==r.root&&d.color===D.Black;)d===d.parent.left?(n=d.parent.right,n.color===D.Red&&(n.color=D.Black,d.parent.color=D.Red,s(r,d.parent),n=d.parent.right),n.left.color===D.Black&&n.right.color===D.Black?(n.color=D.Red,d=d.parent):(n.right.color===D.Black&&(n.left.color=D.Black,n.color=D.Red,I(r,n),n=d.parent.right),n.color=d.parent.color,d.parent.color=D.Black,n.right.color=D.Black,s(r,d.parent),d=r.root)):(n=d.parent.left,n.color===D.Red&&(n.color=D.Black,d.parent.color=D.Red,I(r,d.parent),n=d.parent.left),n.left.color===D.Black&&n.right.color===D.Black?(n.color=D.Red,d=d.parent):(n.left.color===D.Black&&(n.right.color=D.Black,n.color=D.Red,s(r,n),n=d.parent.left),n.color=d.parent.color,d.parent.color=D.Black,n.left.color=D.Black,I(r,d.parent),d=r.root));d.color=D.Black,m()}function u(r,l){for(p(r,l);l!==r.root&&l.parent.color===D.Red;)if(l.parent===l.parent.parent.left){const d=l.parent.parent.right;d.color===D.Red?(l.parent.color=D.Black,d.color=D.Black,l.parent.parent.color=D.Red,l=l.parent.parent):(l===l.parent.right&&(l=l.parent,s(r,l)),l.parent.color=D.Black,l.parent.parent.color=D.Red,I(r,l.parent.parent))}else{const d=l.parent.parent.left;d.color===D.Red?(l.parent.color=D.Black,d.color=D.Black,l.parent.parent.color=D.Red,l=l.parent.parent):(l===l.parent.left&&(l=l.parent,I(r,l)),l.parent.color=D.Black,l.parent.parent.color=D.Red,s(r,l.parent.parent))}r.root.color=D.Black}function E(r,l,d,a){for(;l!==r.root&&l!==e.$oD;)l.parent.left===l&&(l.parent.size_left+=d,l.parent.lf_left+=a),l=l.parent}function p(r,l){let d=0,a=0;if(l!==r.root){for(;l!==r.root&&l===l.parent.right;)l=l.parent;if(l!==r.root)for(l=l.parent,d=R(l.left)-l.size_left,a=O(l.left)-l.lf_left,l.size_left+=d,l.lf_left+=a;l!==r.root&&(d!==0||a!==0);)l.parent.left===l&&(l.parent.size_left+=d,l.parent.lf_left+=a),l=l.parent}}}),define(Re[100],Te([1,0,30,101,32,52,154,102]),function(we,e,v,D,P,L,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HD=e.$GD=e.$FD=void 0,e.$DD=w,e.$ED=u;const m=65535;function s(a){let i;return a[a.length-1]<65536?i=new Uint16Array(a.length):i=new Uint32Array(a.length),i.set(a,0),i}class I{constructor(i,n,t,o,c){this.lineStarts=i,this.cr=n,this.lf=t,this.crlf=o,this.isBasicASCII=c}}function w(a,i=!0){const n=[0];let t=1;for(let o=0,c=a.length;o<c;o++){const g=a.charCodeAt(o);g===v.CharCode.CarriageReturn?o+1<c&&a.charCodeAt(o+1)===v.CharCode.LineFeed?(n[t++]=o+2,o++):n[t++]=o+1:g===v.CharCode.LineFeed&&(n[t++]=o+1)}return i?s(n):n}function u(a,i){a.length=0,a[0]=0;let n=1,t=0,o=0,c=0,g=!0;for(let h=0,S=i.length;h<S;h++){const k=i.charCodeAt(h);k===v.CharCode.CarriageReturn?h+1<S&&i.charCodeAt(h+1)===v.CharCode.LineFeed?(c++,a[n++]=h+2,h++):(t++,a[n++]=h+1):k===v.CharCode.LineFeed?(o++,a[n++]=h+1):g&&k!==v.CharCode.Tab&&(k<32||k>126)&&(g=!1)}const f=new I(s(a),t,o,c,g);return a.length=0,f}class E{constructor(i,n,t,o,c){this.bufferIndex=i,this.start=n,this.end=t,this.lineFeedCnt=o,this.length=c}}e.$FD=E;class p{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$GD=p;class r{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==R.$oD&&i.iterate(i.root,t=>(t!==R.$oD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class l{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const t=this.b;for(let o=0;o<t.length;o++){const c=t[o];if(c.node.parent===null||c.nodeStartOffset>=i){t[o]=null,n=!0;continue}}if(n){const o=[];for(const c of t)c!==null&&o.push(c);this.b=o}}}class d{constructor(i,n,t){this.create(i,n,t)}create(i,n,t){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=R.$oD,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=t;let o=null;for(let c=0,g=i.length;c<g;c++)if(i[c].buffer.length>0){i[c].lineStarts||(i[c].lineStarts=w(i[c].buffer));const f=new E(c+1,{line:0,column:0},{line:i[c].lineStarts.length-1,column:i[c].buffer.length-i[c].lineStarts[i[c].lineStarts.length-1]},i[c].lineStarts.length-1,i[c].buffer.length);this.a.push(i[c]),o=this.S(o,f)}this.h=new l(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=m,t=n-Math.floor(n/3),o=t*2;let c="",g=0;const f=[];if(this.iterate(this.root,h=>{const S=this.R(h),k=S.length;if(g<=t||g+k<o)return c+=S,g+=k,!0;const y=c.replace(/\r\n|\r|\n/g,i);return f.push(new p(y,w(y))),c=S,g=k,!0}),g>0){const h=c.replace(/\r\n|\r|\n/g,i);f.push(new p(h,w(h)))}this.create(f,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new r(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,o=>{if(o===R.$oD)return!0;const c=this.R(o),g=c.length,f=i.G(n),h=i.G(n+g),S=i.getValueInRange2(f,h);return n+=g,c===S})}getOffsetAt(i,n){let t=0,o=this.root;for(;o!==R.$oD;)if(o.left!==R.$oD&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){t+=o.size_left;const c=this.B(o,i-o.lf_left-2);return t+=c+n-1}else i-=o.lf_left+o.piece.lineFeedCnt,t+=o.size_left+o.piece.length,o=o.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,t=0;const o=i;for(;n!==R.$oD;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const c=this.A(n,i-n.size_left);if(t+=n.lf_left+c.index,c.index===0){const g=this.getOffsetAt(t+1,1),f=o-g;return new D.$Vt(t+1,f+1)}return new D.$Vt(t+1,c.remainder+1)}else if(i-=n.size_left+n.piece.length,t+=n.lf_left+n.piece.lineFeedCnt,n.right===R.$oD){const c=this.getOffsetAt(t+1,1),g=o-i-c;return new D.$Vt(t+1,g+1)}else n=n.right;return new D.$Vt(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),c=this.getValueInRange2(t,o);return n?n!==this.d||!this.f?c.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?c:c.replace(/\r\n|\r|\n/g,n):c}getValueInRange2(i,n){if(i.node===n.node){const f=i.node,h=this.a[f.piece.bufferIndex].buffer,S=this.u(f.piece.bufferIndex,f.piece.start);return h.substring(S+i.remainder,S+n.remainder)}let t=i.node;const o=this.a[t.piece.bufferIndex].buffer,c=this.u(t.piece.bufferIndex,t.piece.start);let g=o.substring(c+i.remainder,c+t.piece.length);for(t=t.next();t!==R.$oD;){const f=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(t===n.node){g+=f.substring(h,h+n.remainder);break}else g+=f.substr(h,t.piece.length);t=t.next()}return g}getLinesContent(){const i=[];let n=0,t="",o=!1;return this.iterate(this.root,c=>{if(c===R.$oD)return!0;const g=c.piece;let f=g.length;if(f===0)return!0;const h=this.a[g.bufferIndex].buffer,S=this.a[g.bufferIndex].lineStarts,k=g.start.line,y=g.end.line;let C=S[k]+g.start.column;if(o&&(h.charCodeAt(C)===v.CharCode.LineFeed&&(C++,f--),i[n++]=t,t="",o=!1,f===0))return!0;if(k===y)return!this.f&&h.charCodeAt(C+f-1)===v.CharCode.CarriageReturn?(o=!0,t+=h.substr(C,f-1)):t+=h.substr(C,f),!0;t+=this.f?h.substring(C,Math.max(C,S[k+1]-this.e)):h.substring(C,S[k+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;for(let T=k+1;T<y;T++)t=this.f?h.substring(S[T],S[T+1]-this.e):h.substring(S[T],S[T+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;return!this.f&&h.charCodeAt(S[y]+g.end.column-1)===v.CharCode.CarriageReturn?(o=!0,g.end.column===0?n--:t=h.substr(S[y],g.end.column-1)):t=h.substr(S[y],g.end.column),!0}),o&&(i[n++]=t,t=""),i[n++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const t=this.a[n.piece.bufferIndex],o=this.u(n.piece.bufferIndex,n.piece.start);return t.buffer.charCodeAt(o)}else{const n=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(o)}}getLineCharCode(i,n){const t=this.H(i,n+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}getNearestChunk(i){const n=this.G(i);if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t||t===R.$oD)return"";const o=this.a[t.piece.bufferIndex],c=this.u(t.piece.bufferIndex,t.piece.start);return o.buffer.substring(c,c+t.piece.length)}else{const t=this.a[n.node.piece.bufferIndex],o=this.u(n.node.piece.bufferIndex,n.node.piece.start),c=o+n.remainder,g=o+n.node.piece.length;return t.buffer.substring(c,g)}}findMatchesInNode(i,n,t,o,c,g,f,h,S,k,y){const C=this.a[i.piece.bufferIndex],T=this.u(i.piece.bufferIndex,i.piece.start),$=this.u(i.piece.bufferIndex,c),b=this.u(i.piece.bufferIndex,g);let N;const A={line:0,column:0};let F,G;n._wordSeparators?(F=C.buffer.substring($,b),G=x=>x+$,n.reset(0)):(F=C.buffer,G=x=>x,n.reset($));do if(N=n.next(F),N){if(G(N.index)>=b)return k;this.s(i,G(N.index)-T,A);const x=this.t(i.piece.bufferIndex,c,A),j=A.line===c.line?A.column-c.column+o:A.column+1,U=j+N[0].length;if(y[k++]=(0,O.$zD)(new P.$Wt(t+x,j,t+x,U),N,h),G(N.index)+N[0].length>=b||k>=S)return k}while(N);return k}findMatchesLineByLine(i,n,t,o){const c=[];let g=0;const f=new O.$CD(n.wordSeparators,n.regex);let h=this.H(i.startLineNumber,i.startColumn);if(h===null)return[];const S=this.H(i.endLineNumber,i.endColumn);if(S===null)return[];let k=this.s(h.node,h.remainder);const y=this.s(S.node,S.remainder);if(h.node===S.node)return this.findMatchesInNode(h.node,f,i.startLineNumber,i.startColumn,k,y,n,t,o,g,c),c;let C=i.startLineNumber,T=h.node;for(;T!==S.node;){const b=this.t(T.piece.bufferIndex,k,T.piece.end);if(b>=1){const A=this.a[T.piece.bufferIndex].lineStarts,F=this.u(T.piece.bufferIndex,T.piece.start),G=A[k.line+b],x=C===i.startLineNumber?i.startColumn:1;if(g=this.findMatchesInNode(T,f,C,x,k,this.s(T,G-F),n,t,o,g,c),g>=o)return c;C+=b}const N=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const A=this.getLineContent(C).substring(N,i.endColumn-1);return g=this.n(n,f,A,i.endLineNumber,N,g,c,t,o),c}if(g=this.n(n,f,this.getLineContent(C).substr(N),C,N,g,c,t,o),g>=o)return c;C++,h=this.H(C,1),T=h.node,k=this.s(h.node,h.remainder)}if(C===i.endLineNumber){const b=C===i.startLineNumber?i.startColumn-1:0,N=this.getLineContent(C).substring(b,i.endColumn-1);return g=this.n(n,f,N,i.endLineNumber,b,g,c,t,o),c}const $=C===i.startLineNumber?i.startColumn:1;return g=this.findMatchesInNode(S.node,f,C,$,k,y,n,t,o,g,c),c}n(i,n,t,o,c,g,f,h,S){const k=i.wordSeparators;if(!h&&i.simpleSearch){const C=i.simpleSearch,T=C.length,$=t.length;let b=-T;for(;(b=t.indexOf(C,b+T))!==-1;)if((!k||(0,O.$BD)(k,t,$,b,T))&&(f[g++]=new L.$nw(new P.$Wt(o,b+1+c,o,b+1+T+c),null),g>=S))return g;return g}let y;n.reset(0);do if(y=n.next(t),y&&(f[g++]=(0,O.$zD)(new P.$Wt(o,y.index+1+c,o,y.index+1+y[0].length+c),y,h),g>=S))return g;while(y);return g}insert(i,n,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==R.$oD){const{node:o,remainder:c,nodeStartOffset:g}=this.G(i),f=o.piece,h=f.bufferIndex,S=this.s(o,c);if(o.piece.bufferIndex===0&&f.end.line===this.g.line&&f.end.column===this.g.column&&g+f.length===i&&n.length<m){this.F(o,n),this.y();return}if(g===i)this.o(n,o),this.h.validate(i);else if(g+o.piece.length>i){const k=[];let y=new E(f.bufferIndex,S,f.end,this.t(f.bufferIndex,S,f.end),this.u(h,f.end)-this.u(h,S));if(this.K()&&this.M(n)&&this.I(o,c)===10){const b={line:y.start.line+1,column:0};y=new E(y.bufferIndex,b,y.end,this.t(y.bufferIndex,b,y.end),y.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(o,c-1)===13){const b=this.s(o,c-1);this.C(o,b),n="\r"+n,o.piece.length===0&&k.push(o)}else this.C(o,S);else this.C(o,S);const C=this.w(n);y.length>0&&this.S(o,y);let T=o;for(let $=0;$<C.length;$++)T=this.S(T,C[$]);this.v(k)}else this.q(n,o)}else{const o=this.w(n);let c=this.T(null,o[0]);for(let g=1;g<o.length;g++)c=this.S(c,o[g])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===R.$oD)return;const t=this.G(i),o=this.G(i+n),c=t.node,g=o.node;if(c===g){const C=this.s(c,t.remainder),T=this.s(c,o.remainder);if(t.nodeStartOffset===i){if(n===c.piece.length){const $=c.next();(0,R.$tD)(this,c),this.N($),this.y();return}this.D(c,T),this.h.validate(i),this.N(c),this.y();return}if(t.nodeStartOffset+c.piece.length===i+n){this.C(c,C),this.O(c),this.y();return}this.E(c,C,T),this.y();return}const f=[],h=this.s(c,t.remainder);this.C(c,h),this.h.validate(i),c.piece.length===0&&f.push(c);const S=this.s(g,o.remainder);this.D(g,S),g.piece.length===0&&f.push(g);const k=c.next();for(let C=k;C!==R.$oD&&C!==g;C=C.next())f.push(C);const y=c.piece.length===0?c.prev():c;this.v(f),this.O(y),this.y()}o(i,n){const t=[];if(this.K()&&this.M(i)&&this.L(n)){const g=n.piece,f={line:g.start.line+1,column:0},h=new E(g.bufferIndex,f,g.end,this.t(g.bufferIndex,f,g.end),g.length-1);n.piece=h,i+=`
`,(0,R.$vD)(this,n,-1,-1),n.piece.length===0&&t.push(n)}const o=this.w(i);let c=this.T(n,o[o.length-1]);for(let g=o.length-2;g>=0;g--)c=this.T(c,o[g]);this.N(c),this.v(t)}q(i,n){this.Q(i,n)&&(i+=`
`);const t=this.w(i),o=this.S(n,t[0]);let c=o;for(let g=1;g<t.length;g++)c=this.S(c,t[g]);this.N(o)}s(i,n,t){const o=i.piece,c=i.piece.bufferIndex,g=this.a[c].lineStarts,h=g[o.start.line]+o.start.column+n;let S=o.start.line,k=o.end.line,y=0,C=0,T=0;for(;S<=k&&(y=S+(k-S)/2|0,T=g[y],y!==k);)if(C=g[y+1],h<T)k=y-1;else if(h>=C)S=y+1;else break;return t?(t.line=y,t.column=h-T,null):{line:y,column:h-T}}t(i,n,t){if(t.column===0)return t.line-n.line;const o=this.a[i].lineStarts;if(t.line===o.length-1)return t.line-n.line;const c=o[t.line+1],g=o[t.line]+t.column;if(c>g+1)return t.line-n.line;const f=g-1;return this.a[i].buffer.charCodeAt(f)===13?t.line-n.line+1:t.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,R.$tD)(this,i[n])}w(i){if(i.length>m){const k=[];for(;i.length>m;){const C=i.charCodeAt(m-1);let T;C===v.CharCode.CarriageReturn||C>=55296&&C<=56319?(T=i.substring(0,m-1),i=i.substring(m-1)):(T=i.substring(0,m),i=i.substring(m));const $=w(T);k.push(new E(this.a.length,{line:0,column:0},{line:$.length-1,column:T.length-$[$.length-1]},$.length-1,T.length)),this.a.push(new p(T,$))}const y=w(i);return k.push(new E(this.a.length,{line:0,column:0},{line:y.length-1,column:i.length-y[y.length-1]},y.length-1,i.length)),this.a.push(new p(i,y)),k}let n=this.a[0].buffer.length;const t=w(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let k=0;k<t.length;k++)t[k]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let k=0;k<t.length;k++)t[k]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const c=this.a[0].buffer.length,g=this.a[0].lineStarts.length-1,f=c-this.a[0].lineStarts[g],h={line:g,column:f},S=new E(0,o,h,this.t(0,o,h),c-n);return this.g=h,[S]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let t=this.root,o="";const c=this.h.get2(i);if(c){t=c.node;const g=this.B(t,i-c.nodeStartLineNumber-1),f=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(c.nodeStartLineNumber+t.piece.lineFeedCnt===i)o=f.substring(h+g,h+t.piece.length);else{const S=this.B(t,i-c.nodeStartLineNumber);return f.substring(h+g,h+S-n)}}else{let g=0;const f=i;for(;t!==R.$oD;)if(t.left!==R.$oD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const h=this.B(t,i-t.lf_left-2),S=this.B(t,i-t.lf_left-1),k=this.a[t.piece.bufferIndex].buffer,y=this.u(t.piece.bufferIndex,t.piece.start);return g+=t.size_left,this.h.set({node:t,nodeStartOffset:g,nodeStartLineNumber:f-(i-1-t.lf_left)}),k.substring(y+h,y+S-n)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const h=this.B(t,i-t.lf_left-2),S=this.a[t.piece.bufferIndex].buffer,k=this.u(t.piece.bufferIndex,t.piece.start);o=S.substring(k+h,k+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==R.$oD;){const g=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const f=this.B(t,0),h=this.u(t.piece.bufferIndex,t.piece.start);return o+=g.substring(h,h+f-n),o}else{const f=this.u(t.piece.bufferIndex,t.piece.start);o+=g.substr(f,t.piece.length)}t=t.next()}return o}y(){let i=this.root,n=1,t=0;for(;i!==R.$oD;)n+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=t,this.h.validate(this.c)}A(i,n){const t=i.piece,o=this.s(i,n),c=o.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===n){const g=this.t(i.piece.bufferIndex,t.start,o);if(g!==c)return{index:g,remainder:0}}return{index:c,remainder:o.column}}B(i,n){if(n<0)return 0;const t=i.piece,o=this.a[t.bufferIndex].lineStarts,c=t.start.line+n+1;return c>t.end.line?o[t.end.line]+t.end.column-o[t.start.line]-t.start.column:o[c]-o[t.start.line]-t.start.column}C(i,n){const t=i.piece,o=t.lineFeedCnt,c=this.u(t.bufferIndex,t.end),g=n,f=this.u(t.bufferIndex,g),h=this.t(t.bufferIndex,t.start,g),S=h-o,k=f-c,y=t.length+k;i.piece=new E(t.bufferIndex,t.start,g,h,y),(0,R.$vD)(this,i,k,S)}D(i,n){const t=i.piece,o=t.lineFeedCnt,c=this.u(t.bufferIndex,t.start),g=n,f=this.t(t.bufferIndex,g,t.end),h=this.u(t.bufferIndex,g),S=f-o,k=c-h,y=t.length+k;i.piece=new E(t.bufferIndex,g,t.end,f,y),(0,R.$vD)(this,i,k,S)}E(i,n,t){const o=i.piece,c=o.start,g=o.end,f=o.length,h=o.lineFeedCnt,S=n,k=this.t(o.bufferIndex,o.start,S),y=this.u(o.bufferIndex,n)-this.u(o.bufferIndex,c);i.piece=new E(o.bufferIndex,o.start,S,k,y),(0,R.$vD)(this,i,y-f,k-h);const C=new E(o.bufferIndex,t,g,this.t(o.bufferIndex,t,g),this.u(o.bufferIndex,g)-this.u(o.bufferIndex,t)),T=this.S(i,C);this.N(T)}F(i,n){this.Q(n,i)&&(n+=`
`);const t=this.K()&&this.L(n)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=n;const c=w(n,!1);for(let T=0;T<c.length;T++)c[T]+=o;if(t){const T=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-T}}this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1));const g=this.a[0].lineStarts.length-1,f=this.a[0].buffer.length-this.a[0].lineStarts[g],h={line:g,column:f},S=i.piece.length+n.length,k=i.piece.lineFeedCnt,y=this.t(0,i.piece.start,h),C=y-k;i.piece=new E(i.piece.bufferIndex,i.piece.start,h,y,S),this.g=h,(0,R.$vD)(this,i,n.length,C)}G(i){let n=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let o=0;for(;n!==R.$oD;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){o+=n.size_left;const c={node:n,remainder:i-n.size_left,nodeStartOffset:o};return this.h.set(c),c}else i-=n.size_left+n.piece.length,o+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let t=this.root,o=0;for(;t!==R.$oD;)if(t.left!==R.$oD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const c=this.B(t,i-t.lf_left-2),g=this.B(t,i-t.lf_left-1);return o+=t.size_left,{node:t,remainder:Math.min(c+n-1,g),nodeStartOffset:o}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const c=this.B(t,i-t.lf_left-2);if(c+n-1<=t.piece.length)return{node:t,remainder:c+n-1,nodeStartOffset:o};n-=t.piece.length-c;break}else i-=t.lf_left+t.piece.lineFeedCnt,o+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==R.$oD;){if(t.piece.lineFeedCnt>0){const c=this.B(t,0),g=this.J(t);return{node:t,remainder:Math.min(n-1,c),nodeStartOffset:g}}else if(t.piece.length>=n-1){const c=this.J(t);return{node:t,remainder:n-1,nodeStartOffset:c}}else n-=t.piece.length;t=t.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+n;return t.buffer.charCodeAt(o)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===R.$oD||i.piece.lineFeedCnt===0)return!1;const n=i.piece,t=this.a[n.bufferIndex].lineStarts,o=n.start.line,c=t[o]+n.start.column;return o===t.length-1||t[o+1]>c+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(c)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===R.$oD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const t=[],o=this.a[i.piece.bufferIndex].lineStarts;let c;i.piece.end.column===0?c={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:c={line:i.piece.end.line,column:i.piece.end.column-1};const g=i.piece.length-1,f=i.piece.lineFeedCnt-1;i.piece=new E(i.piece.bufferIndex,i.piece.start,c,f,g),(0,R.$vD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const h={line:n.piece.start.line+1,column:0},S=n.piece.length-1,k=this.t(n.piece.bufferIndex,h,n.piece.end);n.piece=new E(n.piece.bufferIndex,h,n.piece.end,k,S),(0,R.$vD)(this,n,-1,-1),n.piece.length===0&&t.push(n);const y=this.w(`\r
`);this.S(i,y[0]);for(let C=0;C<t.length;C++)(0,R.$tD)(this,t[C])}Q(i,n){if(this.K()&&this.M(i)){const t=n.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,R.$tD)(this,t);else{const o=t.piece,c={line:o.start.line+1,column:0},g=o.length-1,f=this.t(o.bufferIndex,c,o.end);t.piece=new E(o.bufferIndex,c,o.end,f,g),(0,R.$vD)(this,t,-1,-1)}return!0}}return!1}iterate(i,n){if(i===R.$oD)return n(R.$oD);const t=this.iterate(i.left,n);return t&&n(i)&&this.iterate(i.right,n)}R(i){if(i===R.$oD)return"";const n=this.a[i.piece.bufferIndex],t=i.piece,o=this.u(t.bufferIndex,t.start),c=this.u(t.bufferIndex,t.end);return n.buffer.substring(o,c)}getPieceContent(i){const n=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return n.buffer.substring(t,o)}S(i,n){const t=new R.$nD(n,R.NodeColor.Red);if(t.left=R.$oD,t.right=R.$oD,t.parent=R.$oD,t.size_left=0,t.lf_left=0,this.root===R.$oD)this.root=t,t.color=R.NodeColor.Black;else if(i.right===R.$oD)i.right=t,t.parent=i;else{const c=(0,R.$pD)(i.right);c.left=t,t.parent=c}return(0,R.$uD)(this,t),t}T(i,n){const t=new R.$nD(n,R.NodeColor.Red);if(t.left=R.$oD,t.right=R.$oD,t.parent=R.$oD,t.size_left=0,t.lf_left=0,this.root===R.$oD)this.root=t,t.color=R.NodeColor.Black;else if(i.left===R.$oD)i.left=t,t.parent=i;else{const o=(0,R.$qD)(i.left);o.right=t,t.parent=o}return(0,R.$uD)(this,t),t}U(i){let n="";return this.iterate(i,t=>(n+=this.R(t),!0)),n}}e.$HD=d}),define(Re[155],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kab=e.$jab=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$jab=v;class D{constructor(L){this.identifier=L}}e.$kab=D}),define(Re[156],Te([1,0,6,4,9]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0,e.$uj=I,P=Ve(P);class L extends D.$Zc{constructor(u,E="",p="",r=!0,l){super(),this.j=this.B(new v.$qe),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=E,this.w=p,this.z=r,this.D=l}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,E){this.D&&await this.D(u)}}e.$pj=L;class R extends D.$Zc{constructor(){super(...arguments),this.f=this.B(new v.$qe),this.onWillRun=this.f.event,this.m=this.B(new v.$qe),this.onDidRun=this.m.event}async run(u,E){if(!u.enabled)return;this.f.fire({action:u});let p;try{await this.u(u,E)}catch(r){p=r}this.m.fire({action:u,error:p})}async u(u,E){await u.run(E)}}e.$qj=R;class O{constructor(){this.id=O.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let E=[];for(const p of u)p.length&&(E.length?E=[...E,new O,...p]:E=p);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$rj=O;class m{get actions(){return this.a}constructor(u,E,p,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=E,this.class=r,this.a=p}async run(){}}e.$sj=m;class s extends L{static{this.ID="vs.actions.empty"}constructor(){super(s.ID,P.localize(41,null),void 0,!1)}}e.$tj=s;function I(w){return{id:w.id,label:w.label,tooltip:w.tooltip??w.label,class:w.class,enabled:w.enabled??!0,checked:w.checked,run:async(...u)=>w.run(...u)}}}),define(Re[157],Te([1,0,9]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=s,e.$8m=I,e.$9m=w,e.$0m=u;const D=60,P=D*60,L=P*24,R=L*7,O=L*30,m=L*365;function s(E,p,r,l){typeof E!="number"&&(E=E.getTime());const d=Math.round((new Date().getTime()-E)/1e3);if(d<-30)return(0,v.localize)(42,null,s(new Date().getTime()+d*1e3,!1));if(!l&&d<30)return(0,v.localize)(43,null);let a;return d<D?(a=d,p?a===1?r?(0,v.localize)(44,null,a):(0,v.localize)(45,null,a):r?(0,v.localize)(46,null,a):(0,v.localize)(47,null,a):a===1?r?(0,v.localize)(48,null,a):(0,v.localize)(49,null,a):r?(0,v.localize)(50,null,a):(0,v.localize)(51,null,a)):d<P?(a=Math.floor(d/D),p?a===1?r?(0,v.localize)(52,null,a):(0,v.localize)(53,null,a):r?(0,v.localize)(54,null,a):(0,v.localize)(55,null,a):a===1?r?(0,v.localize)(56,null,a):(0,v.localize)(57,null,a):r?(0,v.localize)(58,null,a):(0,v.localize)(59,null,a)):d<L?(a=Math.floor(d/P),p?a===1?r?(0,v.localize)(60,null,a):(0,v.localize)(61,null,a):r?(0,v.localize)(62,null,a):(0,v.localize)(63,null,a):a===1?r?(0,v.localize)(64,null,a):(0,v.localize)(65,null,a):r?(0,v.localize)(66,null,a):(0,v.localize)(67,null,a)):d<R?(a=Math.floor(d/L),p?a===1?(0,v.localize)(68,null,a):(0,v.localize)(69,null,a):a===1?(0,v.localize)(70,null,a):(0,v.localize)(71,null,a)):d<O?(a=Math.floor(d/R),p?a===1?r?(0,v.localize)(72,null,a):(0,v.localize)(73,null,a):r?(0,v.localize)(74,null,a):(0,v.localize)(75,null,a):a===1?r?(0,v.localize)(76,null,a):(0,v.localize)(77,null,a):r?(0,v.localize)(78,null,a):(0,v.localize)(79,null,a)):d<m?(a=Math.floor(d/O),p?a===1?r?(0,v.localize)(80,null,a):(0,v.localize)(81,null,a):r?(0,v.localize)(82,null,a):(0,v.localize)(83,null,a):a===1?r?(0,v.localize)(84,null,a):(0,v.localize)(85,null,a):r?(0,v.localize)(86,null,a):(0,v.localize)(87,null,a)):(a=Math.floor(d/m),p?a===1?r?(0,v.localize)(88,null,a):(0,v.localize)(89,null,a):r?(0,v.localize)(90,null,a):(0,v.localize)(91,null,a):a===1?r?(0,v.localize)(92,null,a):(0,v.localize)(93,null,a):r?(0,v.localize)(94,null,a):(0,v.localize)(95,null,a))}function I(E,p,r){typeof E!="number"&&(E=E.getTime());const l=new Date;l.setHours(0,0,0,0);const d=new Date(l.getTime());return d.setDate(d.getDate()-1),E>l.getTime()?(0,v.localize)(96,null):E>d.getTime()?(0,v.localize)(97,null):s(E,p,r)}function w(E,p){const r=Math.abs(E/1e3);return r<1?p?(0,v.localize)(98,null,E):(0,v.localize)(99,null,E):r<D?p?(0,v.localize)(100,null,Math.round(E)/1e3):(0,v.localize)(101,null,Math.round(E)/1e3):r<P?p?(0,v.localize)(102,null,Math.round(E/(1e3*D))):(0,v.localize)(103,null,Math.round(E/(1e3*D))):r<L?p?(0,v.localize)(104,null,Math.round(E/(1e3*P))):(0,v.localize)(105,null,Math.round(E/(1e3*P))):(0,v.localize)(106,null,Math.round(E/(1e3*L)))}function u(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Re[42],Te([1,0,17,14,9]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=m,e.$wj=s,e.$xj=I,v=Ve(v),D=Ve(D),P=Ve(P);function L(w,u){return u&&(w.stack||w.stacktrace)?P.localize(107,null,O(w),R(w.stack)||R(w.stacktrace)):O(w)}function R(w){return Array.isArray(w)?w.join(`
`):w}function O(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?P.localize(108,null,w.message):w.message||P.localize(109,null)}function m(w=null,u=!1){if(!w)return P.localize(110,null);if(Array.isArray(w)){const E=v.$Lb(w),p=m(E[0],u);return E.length>1?P.localize(111,null,p,E.length):p}if(D.$jg(w))return w;if(w.detail){const E=w.detail;if(E.error)return L(E.error,u);if(E.exception)return L(E.exception,u)}return w.stack?L(w,u):w.message?w.message:P.localize(112,null)}function s(w){const u=w;return u instanceof Error&&Array.isArray(u.actions)}function I(w,u){let E;return typeof w=="string"?E=new Error(w):E=w,E.actions=u,E}}),define(Re[158],Te([1,0,51,22]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=O,e.$Jr=m,e.$Kr=s,e.$Lr=I,e.$Mr=w,e.$Nr=u,e.$Or=E,e.$Pr=p,e.$Qr=r,e.$Rr=l,e.$Sr=h,e.$Tr=S,e.$Ur=k;const P=new v.$Y(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),L=new v.$Y(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new v.$Y(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(y,C,T=!1){const $=y||"",b=C||"",N=P.value.collator.compare($,b);return P.value.collatorIsNumeric&&N===0&&$!==b?$<b?-1:1:N}function m(y,C){const T=L.value.collator;return y=y||"",C=C||"",n(T,y,C)}function s(y,C){const T=L.value.collator;return y=y||"",C=C||"",g(y,C)||n(T,y,C)}function I(y,C){const T=L.value.collator;return y=y||"",C=C||"",c(y,C)||n(T,y,C)}function w(y,C){return y=y||"",C=C||"",y===C?0:y<C?-1:1}function u(y,C){const[T,$]=a(y),[b,N]=a(C);let A=P.value.collator.compare($,N);if(A===0){if(P.value.collatorIsNumeric&&$!==N)return $<N?-1:1;if(A=P.value.collator.compare(T,b),P.value.collatorIsNumeric&&A===0&&T!==b)return T<b?-1:1}return A}function E(y,C){y=y||"",C=C||"";const T=i(y),$=i(C),b=L.value.collator,N=R.value.collator;return n(N,T,$)||n(b,y,C)}function p(y,C){y=y||"",C=C||"";const T=i(y),$=i(C),b=L.value.collator,N=R.value.collator;return n(N,T,$)||g(y,C)||n(b,y,C)}function r(y,C){y=y||"",C=C||"";const T=i(y),$=i(C),b=L.value.collator,N=R.value.collator;return n(N,T,$)||c(y,C)||n(b,y,C)}function l(y,C){y=y||"",C=C||"";const T=i(y).toLowerCase(),$=i(C).toLowerCase();return T!==$?T<$?-1:1:y!==C?y<C?-1:1:0}const d=/^(.*?)(\.([^.]*))?$/;function a(y,C=!1){const T=y?d.exec(y):[];let $=[T&&T[1]||"",T&&T[3]||""];return C&&(!$[0]&&$[1]||$[0]&&$[0].charAt(0)===".")&&($=[$[0]+"."+$[1],""]),$}function i(y){const C=y?d.exec(y):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function n(y,C,T){const $=y.compare(C,T);return $!==0?$:C.length!==T.length?C.length<T.length?-1:1:0}function t(y){const C=y.charAt(0);return C.toLocaleUpperCase()!==C}function o(y){const C=y.charAt(0);return C.toLocaleLowerCase()!==C}function c(y,C){return t(y)&&o(C)?-1:o(y)&&t(C)?1:0}function g(y,C){return o(y)&&t(C)?-1:t(y)&&o(C)?1:0}function f(y,C,T=!1){return T||(y=y&&y.toLowerCase(),C=C&&C.toLowerCase()),y===C?0:y<C?-1:1}function h(y,C,T=!1){const $=y.split(D.sep),b=C.split(D.sep),N=$.length-1,A=b.length-1;let F,G;for(let x=0;;x++){if(F=N===x,G=A===x,F&&G)return O($[x],b[x],T);if(F)return-1;if(G)return 1;const j=f($[x],b[x],T);if(j!==0)return j}}function S(y,C,T){const $=y.toLowerCase(),b=C.toLowerCase(),N=k(y,C,T);if(N)return N;const A=$.endsWith(T),F=b.endsWith(T);if(A!==F)return A?-1:1;const G=O($,b);return G!==0?G:$.localeCompare(b)}function k(y,C,T){const $=y.toLowerCase(),b=C.toLowerCase(),N=$.startsWith(T),A=b.startsWith(T);if(N!==A)return N?-1:1;if(N&&A){if($.length<b.length)return-1;if($.length>b.length)return 1}return 0}}),define(Re[72],Te([1,0,22]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=void 0,e.$ht=L,e.$it=R,e.$jt=O,e.$kt=s,e.$gt=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const D={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(I){const w=(0,v.$tc)(I),u=D[w.toLowerCase()];return u!==void 0?u:R(I)}function R(I){const w=(0,v.$tc)(I);return P[w.toLowerCase()]}function O(I){for(const w in P)if(P[w]===I)return w}const m=/^(.+)\/(.+?)(;.+)?$/;function s(I,w){const u=m.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:w?void 0:I}}),define(Re[34],Te([1,0,20,2,38]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=L,e.$gi=R,e.$hi=m;function L(s){return JSON.stringify(s,O)}function R(s){let I=JSON.parse(s);return I=m(I),I}function O(s,I){return I instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function m(s,I=0){if(!s||I>200)return s;if(typeof s=="object"){switch(s.$mid){case P.MarshalledId.Uri:return D.URI.revive(s);case P.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case P.MarshalledId.Date:return new Date(s.source)}if(s instanceof v.$Se||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let w=0;w<s.length;++w)s[w]=m(s[w],I+1);else for(const w in s)Object.hasOwnProperty.call(s,w)&&(s[w]=m(s[w],I+1))}return s}}),define(Re[43],Te([1,0,17,10,30,73,27,22,23,13]),function(we,e,v,D,P,L,R,O,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=void 0,e.$Ak=I,e.$Dk=r,e.$Ek=N,e.$Fk=A,e.$Gk=F,e.$Hk=G,e.$Ik=x,e.$Jk=Z;function I(){return Object.create(null)}e.$Bk="**",e.$Ck="/";const w="[/\\\\]",u="[^/\\\\]",E=/\//g;function p(ae,ee){switch(ae){case 0:return"";case 1:return`${u}*?`;default:return`(?:${w}|${u}+${w}${ee?`|${w}${u}+`:""})*?`}}function r(ae,ee){if(!ae)return[];const oe=[];let ie=!1,ue=!1,_="";for(const $e of ae){switch($e){case ee:if(!ie&&!ue){oe.push(_),_="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}_+=$e}return _&&oe.push(_),oe}function l(ae){if(!ae)return"";let ee="";const oe=r(ae,e.$Ck);if(oe.every(ie=>ie===e.$Bk))ee=".*";else{let ie=!1;oe.forEach((ue,_)=>{if(ue===e.$Bk){if(ie)return;ee+=p(2,_===oe.length-1)}else{let $e=!1,Ie="",X=!1,V="";for(const re of ue){if(re!=="}"&&$e){Ie+=re;continue}if(X&&(re!=="]"||!V)){let be;re==="-"?be=re:(re==="^"||re==="!")&&!V?be="^":re===e.$Ck?be="":be=(0,s.$mf)(re),V+=be;continue}switch(re){case"{":$e=!0;continue;case"[":X=!0;continue;case"}":{const Pe=`(?:${r(Ie,",").map(Fe=>l(Fe)).join("|")})`;ee+=Pe,$e=!1,Ie="";break}case"]":{ee+="["+V+"]",X=!1,V="";break}case"?":ee+=u;continue;case"*":ee+=p(1);continue;default:ee+=(0,s.$mf)(re)}}_<oe.length-1&&(oe[_+1]!==e.$Bk||_+2<oe.length)&&(ee+=w)}ie=ue===e.$Bk})}return ee}const d=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new R.$Ic(1e4),g=function(){return!1},f=function(){return null};function h(ae,ee){if(!ae)return f;let oe;typeof ae!="string"?oe=ae.pattern:oe=ae,oe=oe.trim();const ie=`${oe}_${!!ee.trimForExclusions}`;let ue=c.get(ie);if(ue)return S(ue,ae);let _;return d.test(oe)?ue=y(oe.substr(4),oe):(_=a.exec(k(oe,ee)))?ue=C(_[1],oe):(ee.trimForExclusions?n:i).test(oe)?ue=T(oe,ee):(_=t.exec(k(oe,ee)))?ue=$(_[1].substr(1),oe,!0):(_=o.exec(k(oe,ee)))?ue=$(_[1],oe,!1):ue=b(oe),c.set(ie,ue),S(ue,ae)}function S(ae,ee){if(typeof ee=="string")return ae;const oe=function(ie,ue){return(0,L.$Jg)(ie,ee.base,!m.$n)?ae((0,s.$rf)(ie.substr(ee.base.length),O.sep),ue):null};return oe.allBasenames=ae.allBasenames,oe.allPaths=ae.allPaths,oe.basenames=ae.basenames,oe.patterns=ae.patterns,oe}function k(ae,ee){return ee.trimForExclusions&&ae.endsWith("/**")?ae.substr(0,ae.length-2):ae}function y(ae,ee){return function(oe,ie){return typeof oe=="string"&&oe.endsWith(ae)?ee:null}}function C(ae,ee){const oe=`/${ae}`,ie=`\\${ae}`,ue=function($e,Ie){return typeof $e!="string"?null:Ie?Ie===ae?ee:null:$e===ae||$e.endsWith(oe)||$e.endsWith(ie)?ee:null},_=[ae];return ue.basenames=_,ue.patterns=[ee],ue.allBasenames=_,ue}function T(ae,ee){const oe=J(ae.slice(1,-1).split(",").map(Ie=>h(Ie,ee)).filter(Ie=>Ie!==f),ae),ie=oe.length;if(!ie)return f;if(ie===1)return oe[0];const ue=function(Ie,X){for(let V=0,re=oe.length;V<re;V++)if(oe[V](Ie,X))return ae;return null},_=oe.find(Ie=>!!Ie.allBasenames);_&&(ue.allBasenames=_.allBasenames);const $e=oe.reduce((Ie,X)=>X.allPaths?Ie.concat(X.allPaths):Ie,[]);return $e.length&&(ue.allPaths=$e),ue}function $(ae,ee,oe){const ie=O.sep===O.$lc.sep,ue=ie?ae:ae.replace(E,O.sep),_=O.sep+ue,$e=O.$lc.sep+ae;let Ie;return oe?Ie=function(X,V){return typeof X=="string"&&(X===ue||X.endsWith(_)||!ie&&(X===ae||X.endsWith($e)))?ee:null}:Ie=function(X,V){return typeof X=="string"&&(X===ue||!ie&&X===ae)?ee:null},Ie.allPaths=[(oe?"*/":"./")+ae],Ie}function b(ae){try{const ee=new RegExp(`^${l(ae)}$`);return function(oe){return ee.lastIndex=0,typeof oe=="string"&&ee.test(oe)?ae:null}}catch{return f}}function N(ae,ee,oe){return!ae||typeof ee!="string"?!1:A(ae)(ee,void 0,oe)}function A(ae,ee={}){if(!ae)return g;if(typeof ae=="string"||F(ae)){const oe=h(ae,ee);if(oe===f)return g;const ie=function(ue,_){return!!oe(ue,_)};return oe.allBasenames&&(ie.allBasenames=oe.allBasenames),oe.allPaths&&(ie.allPaths=oe.allPaths),ie}return j(ae,ee)}function F(ae){const ee=ae;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}function G(ae){return ae.allBasenames||[]}function x(ae){return ae.allPaths||[]}function j(ae,ee){const oe=J(Object.getOwnPropertyNames(ae).map(Ie=>U(Ie,ae[Ie],ee)).filter(Ie=>Ie!==f)),ie=oe.length;if(!ie)return f;if(!oe.some(Ie=>!!Ie.requiresSiblings)){if(ie===1)return oe[0];const Ie=function(re,be){let Pe;for(let Fe=0,Be=oe.length;Fe<Be;Fe++){const xe=oe[Fe](re,be);if(typeof xe=="string")return xe;(0,D.$wh)(xe)&&(Pe||(Pe=[]),Pe.push(xe))}return Pe?(async()=>{for(const Fe of Pe){const Be=await Fe;if(typeof Be=="string")return Be}return null})():null},X=oe.find(re=>!!re.allBasenames);X&&(Ie.allBasenames=X.allBasenames);const V=oe.reduce((re,be)=>be.allPaths?re.concat(be.allPaths):re,[]);return V.length&&(Ie.allPaths=V),Ie}const ue=function(Ie,X,V){let re,be;for(let Pe=0,Fe=oe.length;Pe<Fe;Pe++){const Be=oe[Pe];Be.requiresSiblings&&V&&(X||(X=(0,O.$sc)(Ie)),re||(re=X.substr(0,X.length-(0,O.$tc)(Ie).length)));const xe=Be(Ie,X,re,V);if(typeof xe=="string")return xe;(0,D.$wh)(xe)&&(be||(be=[]),be.push(xe))}return be?(async()=>{for(const Pe of be){const Fe=await Pe;if(typeof Fe=="string")return Fe}return null})():null},_=oe.find(Ie=>!!Ie.allBasenames);_&&(ue.allBasenames=_.allBasenames);const $e=oe.reduce((Ie,X)=>X.allPaths?Ie.concat(X.allPaths):Ie,[]);return $e.length&&(ue.allPaths=$e),ue}function U(ae,ee,oe){if(ee===!1)return f;const ie=h(ae,oe);if(ie===f)return f;if(typeof ee=="boolean")return ie;if(ee){const ue=ee.when;if(typeof ue=="string"){const _=($e,Ie,X,V)=>{if(!V||!ie($e,Ie))return null;const re=ue.replace("$(basename)",()=>X),be=V(re);return(0,D.$wh)(be)?be.then(Pe=>Pe?ae:null):be?ae:null};return _.requiresSiblings=!0,_}}return ie}function J(ae,ee){const oe=ae.filter(Ie=>!!Ie.basenames);if(oe.length<2)return ae;const ie=oe.reduce((Ie,X)=>{const V=X.basenames;return V?Ie.concat(V):Ie},[]);let ue;if(ee){ue=[];for(let Ie=0,X=ie.length;Ie<X;Ie++)ue.push(ee)}else ue=oe.reduce((Ie,X)=>{const V=X.patterns;return V?Ie.concat(V):Ie},[]);const _=function(Ie,X){if(typeof Ie!="string")return null;if(!X){let re;for(re=Ie.length;re>0;re--){const be=Ie.charCodeAt(re-1);if(be===P.CharCode.Slash||be===P.CharCode.Backslash)break}X=Ie.substr(re)}const V=ie.indexOf(X);return V!==-1?ue[V]:null};_.basenames=ie,_.patterns=ue,_.allBasenames=ie;const $e=ae.filter(Ie=>!Ie.basenames);return $e.push(_),$e}function Z(ae,ee){return(0,v.$yb)(ae,ee,(oe,ie)=>typeof oe=="string"&&typeof ie=="string"?oe===ie:typeof oe!="string"&&typeof ie!="string"?oe.base===ie.base&&oe.pattern===ie.pattern:!1)}}),define(Re[59],Te([1,0,12,99,24,13,2]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.MarkdownStringTextNewlineStyle=void 0,e.$0k=s,e.$$k=I,e.$_k=w,e.$al=u,e.$bl=E,e.$cl=p,e.$dl=r,e.$el=l;var O;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(O||(e.MarkdownStringTextNewlineStyle=O={}));class m{constructor(a="",i=!1){if(this.value=a,typeof this.value!="string")throw(0,v.$$)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(a,i=O.Paragraph){return this.value+=u(this.supportThemeIcons?(0,D.$3k)(a):a).replace(/([ \t]+)/g,(n,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===O.Break?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,i){return this.value+=`
${E(i,a)}
`,this}appendLink(a,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(a),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(a,i){const n=new RegExp((0,L.$mf)(i),"g");return a.replace(n,(t,o)=>a.charAt(o-1)!=="\\"?`\\${t}`:t)}}e.$9k=m;function s(d){return I(d)?!d.value:Array.isArray(d)?d.every(s):!0}function I(d){return d instanceof m?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}function w(d,a){return d===a?!0:!d||!a?!1:d.value===a.value&&d.isTrusted===a.isTrusted&&d.supportThemeIcons===a.supportThemeIcons&&d.supportHtml===a.supportHtml&&(d.baseUri===a.baseUri||!!d.baseUri&&!!a.baseUri&&(0,P.$eh)(R.URI.from(d.baseUri),R.URI.from(a.baseUri)))}function u(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(d,a){const i=d.match(/^`+/gm)?.reduce((t,o)=>t.length>o.length?t:o).length??0,n=i>=3?i+1:3;return[`${"`".repeat(n)}${a}`,d,`${"`".repeat(n)}`].join(`
`)}function p(d){return d.replace(/"/g,"&quot;")}function r(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function l(d){const a=[],i=d.split("|").map(t=>t.trim());d=i[0];const n=i[1];if(n){const t=/height=(\d+)/.exec(n),o=/width=(\d+)/.exec(n),c=t?t[1]:"",g=o?o[1]:"",f=isFinite(parseInt(g)),h=isFinite(parseInt(c));f&&a.push(`width="${g}"`),h&&a.push(`height="${c}"`)}return{href:d,dimensions:a}}}),define(Re[103],Te([1,0,17,73,22,23,24,13]),function(we,e,v,D,P,L,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9w=m,e.$0w=I,e.$$w=u,e.$_w=E,e.$ax=d,e.$bx=i,e.$cx=n,e.$dx=t,e.$ex=o,e.$fx=c;function m(f,h){const{os:S,tildify:k,relative:y}=h;if(y){const $=s(f,y,S);if(typeof $=="string")return $}let C=f.fsPath;if(S===L.OperatingSystem.Windows&&!L.$l?C=C.replace(/\//g,"\\"):S!==L.OperatingSystem.Windows&&L.$l&&(C=C.replace(/\\/g,"/")),S!==L.OperatingSystem.Windows&&k?.userHome){const $=k.userHome.fsPath;let b;f.scheme!==k.userHome.scheme&&f.path[0]===P.$lc.sep&&f.path[1]!==P.$lc.sep?b=k.userHome.with({path:f.path}).fsPath:b=C,C=u(b,$,S)}return(S===L.OperatingSystem.Windows?P.$kc:P.$lc).normalize(I(C,S===L.OperatingSystem.Windows))}function s(f,h,S){const k=S===L.OperatingSystem.Windows?P.$kc:P.$lc,y=S===L.OperatingSystem.Linux?R.$bh:R.$dh,C=h.getWorkspace(),T=(0,v.$Sb)(C.folders);if(!T)return;f.scheme!==T.uri.scheme&&f.path[0]===P.$lc.sep&&f.path[1]!==P.$lc.sep&&(f=T.uri.with({path:f.path}));const $=h.getWorkspaceFolder(f);if(!$)return;let b;if(y.isEqual($.uri,f)?b="":b=y.relativePath($.uri,f)??"",b&&(b=k.normalize(b)),C.folders.length>1&&!h.noPrefix){const N=$.name?$.name:y.basenameOrAuthority($.uri);b=b?`${N} \u2022 ${b}`:N}return b}function I(f,h=L.$l){return(0,D.$Og)(f,h)?f.charAt(0).toUpperCase()+f.slice(1):f}let w=Object.create(null);function u(f,h,S=L.OS){if(S===L.OperatingSystem.Windows||!f||!h)return f;let k=w.original===h?w.normalized:void 0;k||(k=h,L.$l&&(k=(0,D.$Dg)(k)),k=`${(0,O.$sf)(k,P.$lc.sep)}${P.$lc.sep}`,w={original:h,normalized:k});let y=f;return L.$l&&(y=(0,D.$Dg)(y)),(S===L.OperatingSystem.Linux?y.startsWith(k):(0,O.$Lf)(y,k))?`~/${y.substr(k.length)}`:f}function E(f,h){return f.replace(/^~($|\/|\\)/,`${h}$1`)}const p="\u2026",r="\\\\",l="~";function d(f,h=P.sep){const S=new Array(f.length);let k=!1;for(let y=0;y<f.length;y++){const C=f[y];if(C===""){S[y]=`.${h}`;continue}if(!C){S[y]=C;continue}k=!0;let T="",$=C;$.indexOf(r)===0?(T=$.substr(0,$.indexOf(r)+r.length),$=$.substr($.indexOf(r)+r.length)):$.indexOf(h)===0?(T=$.substr(0,$.indexOf(h)+h.length),$=$.substr($.indexOf(h)+h.length)):$.indexOf(l)===0&&(T=$.substr(0,$.indexOf(l)+l.length),$=$.substr($.indexOf(l)+l.length));const b=$.split(h);for(let N=1;k&&N<=b.length;N++)for(let A=b.length-N;k&&A>=0;A--){k=!1;let F=b.slice(A,A+N).join(h);for(let G=0;!k&&G<f.length;G++)if(G!==y&&f[G]&&f[G].indexOf(F)>-1){const x=A+N===b.length,j=A>0&&f[G].indexOf(h)>-1?h+F:F,U=f[G].endsWith(j);k=!x||U}if(!k){let G="";(b[0].endsWith(":")||T!=="")&&(A===1&&(A=0,N++,F=b[0]+h+F),A>0&&(G=b[0]+h),G=T+G),A>0&&(G=G+p+h),G=G+F,A+N<b.length&&(G=G+h+p),S[y]=G}}k&&(S[y]=C)}return S}var a;(function(f){f[f.TEXT=0]="TEXT",f[f.VARIABLE=1]="VARIABLE",f[f.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function i(f,h=Object.create(null)){const S=[];let k=!1,y="";for(const C of f)if(C==="$"||k&&C==="{")y&&S.push({value:y,type:a.TEXT}),y="",k=!0;else if(C==="}"&&k){const T=h[y];if(typeof T=="string")T.length&&S.push({value:T,type:a.VARIABLE});else if(T){const $=S[S.length-1];(!$||$.type!==a.SEPARATOR)&&S.push({value:T.label,type:a.SEPARATOR})}y="",k=!1}else y+=C;return y&&!k&&S.push({value:y,type:a.TEXT}),S.filter((C,T)=>{if(C.type===a.SEPARATOR){const $=S[T-1],b=S[T+1];return[$,b].every(N=>N&&(N.type===a.VARIABLE||N.type===a.TEXT)&&N.value.length>0)}return!0}).map(C=>C.value).join("")}function n(f,h){return L.$m||h?f.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$m?"&":"&&"):f.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function t(f,h){return L.$m||h?f.replace(/\(&&\w\)|&&/g,""):L.$l?f.replace(/&&|&/g,S=>S==="&"?"&&":"&"):f.replace(/&&/g,"_")}function o(f){return f.replace(/&/g,"&&")}function c(f){if(f.endsWith("]")){const h=f.lastIndexOf(" [",f.length-2);if(h!==-1){const S=g(f.substring(0,h)),k=f.substring(h);return{name:S.name+k,parentPath:S.parentPath}}}return g(f)}function g(f){const h=f.indexOf("/")!==-1?P.$lc:P.$kc,S=h.basename(f),k=h.dirname(f);return S.length?{name:S,parentPath:k}:{name:k,parentPath:""}}}),define(Re[159],Te([1,0,20,38,2]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=void 0,e.$Un=m,e.$Vn=I,e.$Wn=w;function L(u){return u.toJSON()}class R{constructor(E){this.a=E}transformIncoming(E){const p=this.a.transformIncoming(E);return p===E?E:L(P.URI.from(p))}transformOutgoing(E){const p=this.a.transformOutgoing(E);return p===E?E:L(P.URI.from(p))}transformOutgoingURI(E){const p=this.a.transformOutgoing(E);return p===E?E:P.URI.from(p)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.$Sn=R,e.$Tn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function O(u,E,p){if(!u||p>200)return null;if(typeof u=="object"){if(u instanceof P.URI)return E.transformOutgoing(u);for(const r in u)if(Object.hasOwnProperty.call(u,r)){const l=O(u[r],E,p+1);l!==null&&(u[r]=l)}}return null}function m(u,E){const p=O(u,E,0);return p===null?u:p}function s(u,E,p,r){if(!u||r>200)return null;if(typeof u=="object"){if(u.$mid===D.MarshalledId.Uri)return p?P.URI.revive(E.transformIncoming(u)):E.transformIncoming(u);if(u instanceof v.$Se)return null;for(const l in u)if(Object.hasOwnProperty.call(u,l)){const d=s(u[l],E,p,r+1);d!==null&&(u[l]=d)}}return null}function I(u,E){const p=s(u,E,!1,0);return p===null?u:p}function w(u,E){const p=s(u,E,!0,0);return p===null?u:p}}),define(Re[160],Te([1,0,10,6,4,34,14]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.StorageState=e.StorageHint=void 0,e.$jq=m;var O;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function m(u){const E=u;return E?.changed instanceof Map||E?.deleted instanceof Set}var s;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(s||(e.StorageState=s={}));class I extends P.$Zc{static{this.a=100}constructor(E,p=Object.create(null)){super(),this.r=E,this.s=p,this.b=this.B(new D.$te),this.onDidChangeStorage=this.b.event,this.c=s.None,this.f=new Map,this.g=this.B(new v.$Ih(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((p,r)=>this.w(r,p)),E.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(E,p){if(this.c===s.Closed)return;let r=!1;(0,R.$sg)(p)?r=this.f.delete(E):this.f.get(E)!==p&&(this.f.set(E,p),r=!0),r&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===s.None&&(this.c=s.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,p){const r=this.f.get(E);return(0,R.$sg)(r)?p:r}getBoolean(E,p){const r=this.get(E);return(0,R.$sg)(r)?p:r==="true"}getNumber(E,p){const r=this.get(E);return(0,R.$sg)(r)?p:parseInt(r,10)}getObject(E,p){const r=this.get(E);return(0,R.$sg)(r)?p:(0,L.$gi)(r)}async set(E,p,r=!1){if(this.c===s.Closed)return;if((0,R.$sg)(p))return this.delete(E,r);const l=(0,R.$lg)(p)||Array.isArray(p)?(0,L.$fi)(p):String(p);if(this.f.get(E)!==l)return this.f.set(E,l),this.j.set(E,l),this.h.delete(E),this.b.fire({key:E,external:r}),this.D()}async delete(E,p=!1){if(!(this.c===s.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:p}),this.D()}async optimize(){if(this.c!==s.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=s.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(!(this.c===s.Closed||this.m))return this.D(E)}async D(E){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$kq=I;class w{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((p,r)=>this.a.set(r,p)),E.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$lq=w}),define(Re[161],Te([1,0,13,23,20]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mu=void 0,e.$ku=I,e.$lu=w,v=Ve(v),D=Ve(D),P=Ve(P);let L;function R(){return L||(L=new TextDecoder("UTF-16LE")),L}let O;function m(){return O||(O=new TextDecoder("UTF-16BE")),O}let s;function I(){return s||(s=D.$G()?R():m()),s}function w(p,r,l){const d=new Uint16Array(p.buffer,r,l);return l>0&&(d[0]===65279||d[0]===65534)?u(p,r,l):R().decode(d)}function u(p,r,l){const d=[];let a=0;for(let i=0;i<l;i++){const n=P.$Ue(p,r);r+=2,d[a++]=String.fromCharCode(n)}return d.join("")}class E{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return I().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const l=this.a-this.d;l<=1&&(l===0||v.$Of(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const l=r.length;if(this.d+l>=this.a){this.f(),this.c[this.c.length]=r;return}for(let d=0;d<l;d++)this.b[this.d++]=r.charCodeAt(d)}}e.$mu=E}),define(Re[162],Te([1,0,20,161]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nu=void 0,e.$ou=R,v=Ve(v);function P(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(s,I,w,u){this.oldPosition=s,this.oldText=I,this.newPosition=w,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(s){return 4+2*s.length}static c(s,I,w){const u=I.length;v.$Xe(s,u,w),w+=4;for(let E=0;E<u;E++)v.$Ve(s,I.charCodeAt(E),w),w+=2;return w}static d(s,I){const w=v.$We(s,I);return I+=4,(0,D.$lu)(s,I,w)}writeSize(){return 8+L.a(this.oldText)+L.a(this.newText)}write(s,I){return v.$Xe(s,this.oldPosition,I),I+=4,v.$Xe(s,this.newPosition,I),I+=4,I=L.c(s,this.oldText,I),I=L.c(s,this.newText,I),I}static read(s,I,w){const u=v.$We(s,I);I+=4;const E=v.$We(s,I);I+=4;const p=L.d(s,I);I+=L.a(p);const r=L.d(s,I);return I+=L.a(r),w.push(new L(u,p,E,r)),I}}e.$nu=L;function R(m,s){return m===null||m.length===0?s:new O(m,s).compress()}class O{constructor(s,I){this.a=s,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let s=0,I=0,w=this.n(s),u=this.l(I);for(;s<this.f||I<this.h;){if(w===null){this.k(u),u=this.l(++I);continue}if(u===null){this.m(w),w=this.n(++s);continue}if(u.oldEnd<=w.newPosition){this.k(u),u=this.l(++I);continue}if(w.newEnd<=u.oldPosition){this.m(w),w=this.n(++s);continue}if(u.oldPosition<w.newPosition){const[d,a]=O.r(u,w.newPosition-u.oldPosition);this.k(d),u=a;continue}if(w.newPosition<u.oldPosition){const[d,a]=O.q(w,u.oldPosition-w.newPosition);this.m(d),w=a;continue}let r,l;if(u.oldEnd===w.newEnd)r=w,l=u,w=this.n(++s),u=this.l(++I);else if(u.oldEnd<w.newEnd){const[d,a]=O.q(w,u.oldLength);r=d,l=u,w=a,u=this.l(++I)}else{const[d,a]=O.r(u,w.newLength);r=w,l=d,w=this.n(++s),u=a}this.d[this.e++]=new L(r.oldPosition,r.oldText,l.newPosition,l.newText),this.g+=r.newLength-r.oldLength,this.j+=l.newLength-l.oldLength}const E=O.s(this.d);return O.t(E)}k(s){this.d[this.e++]=O.o(this.g,s),this.j+=s.newLength-s.oldLength}l(s){return s<this.h?this.c[s]:null}m(s){this.d[this.e++]=O.p(this.j,s),this.g+=s.newLength-s.oldLength}n(s){return s<this.f?this.a[s]:null}static o(s,I){return new L(I.oldPosition-s,I.oldText,I.newPosition,I.newText)}static p(s,I){return new L(I.oldPosition,I.oldText,I.newPosition+s,I.newText)}static q(s,I){const w=s.newText.substr(0,I),u=s.newText.substr(I);return[new L(s.oldPosition,s.oldText,s.newPosition,w),new L(s.oldEnd,"",s.newPosition+I,u)]}static r(s,I){const w=s.oldText.substr(0,I),u=s.oldText.substr(I);return[new L(s.oldPosition,w,s.newPosition,s.newText),new L(s.oldPosition+I,u,s.newEnd,"")]}static s(s){if(s.length===0)return s;const I=[];let w=0,u=s[0];for(let E=1;E<s.length;E++){const p=s[E];u.oldEnd===p.oldPosition?u=new L(u.oldPosition,u.oldText+p.oldText,u.newPosition,u.newText+p.newText):(I[w++]=u,u=p)}return I[w++]=u,I}static t(s){if(s.length===0)return s;const I=[];let w=0;for(let u=0;u<s.length;u++){const E=s[u];E.oldText!==E.newText&&(I[w++]=E)}return I}}}),define(Re[163],Te([1,0,43,22]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eu=P,e.$Fu=L;function P(R,O,m,s,I,w){if(Array.isArray(R)){let u=0;for(const E of R){const p=P(E,O,m,s,I,w);if(p===10)return p;p>u&&(u=p)}return u}else{if(typeof R=="string")return s?R==="*"?5:R===m?10:0:0;if(R){const{language:u,pattern:E,scheme:p,hasAccessToAllModels:r,notebookType:l}=R;if(!s&&!r)return 0;l&&I&&(O=I);let d=0;if(p)if(p===O.scheme)d=10;else if(p==="*")d=5;else return 0;if(u)if(u===m)d=10;else if(u==="*")d=Math.max(d,5);else return 0;if(l)if(l===w)d=10;else if(l==="*"&&w!==void 0)d=Math.max(d,5);else return 0;if(E){let a;if(typeof E=="string"?a=E:a={...E,base:(0,D.$mc)(E.base)},a===O.fsPath||(0,v.$Ek)(a,O.fsPath))d=10;else return 0}return d}else return 0}}function L(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(L):!!R.notebookType}}),define(Re[164],Te([1,0,6,13,32,52,100,150,162,4]),function(we,e,v,D,P,L,R,O,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ID=void 0,D=Ve(D);class I extends s.$Zc{constructor(u,E,p,r,l,d,a){super(),this.m=this.B(new v.$qe),this.onDidChangeContent=this.m.event,this.f=E,this.j=!d,this.g=r,this.h=l,this.c=new R.$HD(u,p,a)}equals(u){return!(u instanceof I)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,E){return this.c.getOffsetAt(u,E)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,E){const p=u+E,r=this.getPositionAt(u),l=this.getPositionAt(p);return new P.$Wt(r.lineNumber,r.column,l.lineNumber,l.column)}getValueInRange(u,E=L.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const p=this.n(E);return this.c.getValueInRange(u,p)}getValueLengthInRange(u,E=L.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const p=this.getOffsetAt(u.startLineNumber,u.startColumn),r=this.getOffsetAt(u.endLineNumber,u.endColumn);let l=0;const d=this.n(E),a=this.getEOL();if(d.length!==a.length){const i=d.length-a.length,n=u.endLineNumber-u.startLineNumber;l=i*n}return r-p+l}getCharacterCountInRange(u,E=L.EndOfLinePreference.TextDefined){if(this.j){let p=0;const r=u.startLineNumber,l=u.endLineNumber;for(let d=r;d<=l;d++){const a=this.getLineContent(d),i=d===r?u.startColumn-1:0,n=d===l?u.endColumn-1:a.length;for(let t=i;t<n;t++)D.$Of(a.charCodeAt(t))?(p=p+1,t=t+1):p=p+1}return p+=this.n(E).length*(l-r),p}return this.getValueLengthInRange(u,E)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,E){return this.c.getLineCharCode(u,E)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const E=D.$zf(this.getLineContent(u));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(u){const E=D.$Bf(this.getLineContent(u));return E===-1?0:E+2}n(u){switch(u){case L.EndOfLinePreference.LF:return`
`;case L.EndOfLinePreference.CRLF:return`\r
`;case L.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,E,p){let r=this.g,l=this.h,d=this.j,a=!0,i=[];for(let h=0;h<u.length;h++){const S=u[h];a&&S._isTracked&&(a=!1);const k=S.range;if(S.text){let b=!0;d||(b=!D.$Zf(S.text),d=b),!r&&b&&(r=D.$Yf(S.text)),!l&&b&&(l=D.$2f(S.text))}let y="",C=0,T=0,$=0;if(S.text){let b;[C,T,$,b]=(0,O.$Hu)(S.text);const N=this.getEOL(),A=N===`\r
`?O.StringEOL.CRLF:O.StringEOL.LF;b===O.StringEOL.Unknown||b===A?y=S.text:y=S.text.replace(/\r\n|\r|\n/g,N)}i[h]={sortIndex:h,identifier:S.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:y,eolCount:C,firstLineLength:T,lastLineLength:$,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}i.sort(I.u);let n=!1;for(let h=0,S=i.length-1;h<S;h++){const k=i[h].range.getEndPosition(),y=i[h+1].range.getStartPosition();if(y.isBeforeOrEqual(k)){if(y.isBefore(k))throw new Error("Overlapping ranges are not allowed!");n=!0}}a&&(i=this.s(i));const t=p||E?I._getInverseEditRanges(i):[],o=[];if(E)for(let h=0;h<i.length;h++){const S=i[h],k=t[h];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let y=k.startLineNumber;y<=k.endLineNumber;y++){let C="";y===k.startLineNumber&&(C=this.getLineContent(S.range.startLineNumber),D.$zf(C)!==-1)||o.push({lineNumber:y,oldContent:C})}}let c=null;if(p){let h=0;c=[];for(let S=0;S<i.length;S++){const k=i[S],y=t[S],C=this.getValueInRange(k.range),T=k.rangeOffset+h;h+=k.text.length-C.length,c[S]={sortIndex:k.sortIndex,identifier:k.identifier,range:y,text:C,textChange:new m.$nu(k.rangeOffset,C,T,k.text)}}n||c.sort((S,k)=>S.sortIndex-k.sortIndex)}this.g=r,this.h=l,this.j=d;const g=this.t(i);let f=null;if(E&&o.length>0){o.sort((h,S)=>S.lineNumber-h.lineNumber),f=[];for(let h=0,S=o.length;h<S;h++){const k=o[h].lineNumber;if(h>0&&o[h-1].lineNumber===k)continue;const y=o[h].oldContent,C=this.getLineContent(k);C.length===0||C===y||D.$zf(C)!==-1||f.push(k)}}return this.m.fire(),new L.$rw(c,g,f)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let E=!1;const p=u[0].range,r=u[u.length-1].range,l=new P.$Wt(p.startLineNumber,p.startColumn,r.endLineNumber,r.endColumn);let d=p.startLineNumber,a=p.startColumn;const i=[];for(let g=0,f=u.length;g<f;g++){const h=u[g],S=h.range;E=E||h.forceMoveMarkers,i.push(this.getValueInRange(new P.$Wt(d,a,S.startLineNumber,S.startColumn))),h.text.length>0&&i.push(h.text),d=S.endLineNumber,a=S.endColumn}const n=i.join(""),[t,o,c]=(0,O.$Hu)(n);return{sortIndex:0,identifier:u[0].identifier,range:l,rangeOffset:this.getOffsetAt(l.startLineNumber,l.startColumn),rangeLength:this.getValueLengthInRange(l,L.EndOfLinePreference.TextDefined),text:n,eolCount:t,firstLineLength:o,lastLineLength:c,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(u){u.sort(I.w);const E=[];for(let p=0;p<u.length;p++){const r=u[p],l=r.range.startLineNumber,d=r.range.startColumn,a=r.range.endLineNumber,i=r.range.endColumn;if(l===a&&d===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const n=new P.$Wt(l,d,a,i);E.push({range:n,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return E}findMatchesLineByLine(u,E,p,r){return this.c.findMatchesLineByLine(u,E,p,r)}getPieceTree(){return this.c}static _getInverseEditRange(u,E){const p=u.startLineNumber,r=u.startColumn,[l,d,a]=(0,O.$Hu)(E);let i;if(E.length>0){const n=l+1;n===1?i=new P.$Wt(p,r,p,r+d):i=new P.$Wt(p,r,p+n-1,a+1)}else i=new P.$Wt(p,r,p,r);return i}static _getInverseEditRanges(u){const E=[];let p=0,r=0,l=null;for(let d=0,a=u.length;d<a;d++){const i=u[d];let n,t;l?l.range.endLineNumber===i.range.startLineNumber?(n=p,t=r+(i.range.startColumn-l.range.endColumn)):(n=p+(i.range.startLineNumber-l.range.endLineNumber),t=i.range.startColumn):(n=i.range.startLineNumber,t=i.range.startColumn);let o;if(i.text.length>0){const c=i.eolCount+1;c===1?o=new P.$Wt(n,t,n,t+i.firstLineLength):o=new P.$Wt(n,t,n+c-1,i.lastLineLength+1)}else o=new P.$Wt(n,t,n,t);p=o.endLineNumber,r=o.endColumn,E.push(o),l=i}return E}static u(u,E){const p=P.$Wt.compareRangesUsingEnds(u.range,E.range);return p===0?u.sortIndex-E.sortIndex:p}static w(u,E){const p=P.$Wt.compareRangesUsingEnds(u.range,E.range);return p===0?E.sortIndex-u.sortIndex:-p}}e.$ID=I}),define(Re[165],Te([1,0,30,13,52,100,164]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JD=void 0,D=Ve(D);class O{constructor(I,w,u,E,p,r,l,d,a){this.a=I,this.b=w,this.c=u,this.d=E,this.e=p,this.f=r,this.g=l,this.h=d,this.j=a}k(I){const w=this.c+this.d+this.e,u=this.c+this.e;return w===0?I===P.DefaultEndOfLine.LF?`
`:`\r
`:u>w/2?`\r
`:`
`}create(I){const w=this.k(I),u=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let p=0,r=u.length;p<r;p++){const l=u[p].buffer.replace(/\r\n|\r|\n/g,w),d=(0,L.$DD)(l);u[p]=new L.$GD(l,d)}const E=new R.$ID(u,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class m{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&D.$0f(I)&&(this.b=D.$9f,I=I.substr(1));const w=I.charCodeAt(I.length-1);w===v.CharCode.CarriageReturn||w>=55296&&w<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=w):(this.m(I,!1),this.c=!1,this.d=w)}m(I,w){!w&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const w=(0,L.$ED)(this.e,I);this.a.push(new L.$GD(I,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=D.$Yf(I)),this.k||(this.k=D.$2f(I)))}finish(I=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const w=(0,L.$DD)(I.buffer);I.lineStarts=w,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$JD=m}),define(Re[104],Te([1,0,20,23]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$web=m,e.$xeb=I,D=Ve(D);var P;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(P||(P={}));function L(w){for(let u=0,E=w.length;u<E;u+=4){const p=w[u+0],r=w[u+1],l=w[u+2],d=w[u+3];w[u+0]=d,w[u+1]=l,w[u+2]=r,w[u+3]=p}}function R(w){const u=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return D.$G()||L(u),v.$Se.wrap(u)}function O(w){const u=w.buffer;if(D.$G()||L(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const E=new Uint8Array(u.byteLength);return E.set(u),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function m(w){const u=new Uint32Array(s(w));let E=0;if(u[E++]=w.id,w.type==="full")u[E++]=P.Full,u[E++]=w.data.length,u.set(w.data,E),E+=w.data.length;else{u[E++]=P.Delta,u[E++]=w.deltas.length;for(const p of w.deltas)u[E++]=p.start,u[E++]=p.deleteCount,p.data?(u[E++]=p.data.length,u.set(p.data,E),E+=p.data.length):u[E++]=0}return R(u)}function s(w){let u=0;if(u+=2,w.type==="full")u+=1+w.data.length;else{u+=1,u+=3*w.deltas.length;for(const E of w.deltas)E.data&&(u+=E.data.length)}return u}function I(w){const u=O(w);let E=0;const p=u[E++];if(u[E++]===P.Full){const a=u[E++],i=u.subarray(E,E+a);return E+=a,{id:p,type:"full",data:i}}const l=u[E++],d=[];for(let a=0;a<l;a++){const i=u[E++],n=u[E++],t=u[E++];let o;t>0&&(o=u.subarray(E,E+t),E+=t),d[a]={start:i,deleteCount:n,data:o}}return{id:p,type:"delta",deltas:d}}}),define(Re[166],Te([1,0,30,12,9]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.TokenType=void 0;var L;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(L||(e.TokenType=L={}));function R(...I){switch(I.length){case 1:return(0,P.localize)(1693,null,I[0]);case 2:return(0,P.localize)(1694,null,I[0],I[1]);case 3:return(0,P.localize)(1695,null,I[0],I[1],I[2]);default:return}}const O=(0,P.localize)(1696,null),m=(0,P.localize)(1697,null);class s{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case L.LParen:return"(";case L.RParen:return")";case L.Neg:return"!";case L.Eq:return w.isTripleEq?"===":"==";case L.NotEq:return w.isTripleEq?"!==":"!=";case L.Lt:return"<";case L.LtEq:return"<=";case L.Gt:return">=";case L.GtEq:return">=";case L.RegexOp:return"=~";case L.RegexStr:return w.lexeme;case L.True:return"true";case L.False:return"false";case L.In:return"in";case L.Not:return"not";case L.And:return"&&";case L.Or:return"||";case L.Str:return w.lexeme;case L.QuotedStr:return w.lexeme;case L.Error:return w.lexeme;case L.EOF:return"EOF";default:throw(0,D.$_)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0)))}static{this.b=new Map([["not",L.Not],["in",L.In],["false",L.False],["true",L.True]])}get errors(){return this.g}reset(w){return this.c=w,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(L.LParen);break;case v.CharCode.CloseParen:this.k(L.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const u=this.h(v.CharCode.Equals);this.f.push({type:L.NotEq,offset:this.d,isTripleEq:u})}else this.k(L.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const u=this.h(v.CharCode.Equals);this.f.push({type:L.Eq,offset:this.d,isTripleEq:u})}else this.h(v.CharCode.Tilde)?this.k(L.RegexOp):this.l(R("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?L.LtEq:L.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?L.GtEq:L.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(L.And):this.l(R("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(L.Or):this.l(R("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(L.EOF),Array.from(this.f)}h(w){return this.r()||this.c.charCodeAt(this.e)!==w?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(w){this.f.push({type:w,offset:this.d})}l(w){const u=this.d,E=this.c.substring(this.d,this.e),p={type:L.Error,offset:this.d,lexeme:E};this.g.push({offset:u,lexeme:E,additionalInfo:w}),this.f.push(p)}n(){this.m.lastIndex=this.d;const w=this.m.exec(this.c);if(w){this.e=this.d+w[0].length;const u=this.c.substring(this.d,this.e),E=s.b.get(u);E?this.k(E):this.f.push({type:L.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:L.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let w=this.e,u=!1,E=!1;for(;;){if(w>=this.c.length){this.e=w,this.l(m);return}const r=this.c.charCodeAt(w);if(u)u=!1;else if(r===v.CharCode.Slash&&!E){w++;break}else r===v.CharCode.OpenSquareBracket?E=!0:r===v.CharCode.Backslash?u=!0:r===v.CharCode.CloseSquareBracket&&(E=!1);w++}for(;w<this.c.length&&s.a.has(this.c.charCodeAt(w));)w++;this.e=w;const p=this.c.substring(this.d,this.e);this.f.push({type:L.RegexStr,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fj=s}),define(Re[105],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const v={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:6},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(v)}),define(Re[74],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=void 0;class v{constructor(P,L=[],R=!1){this.ctor=P,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$Hi=v}),define(Re[60],Te([1,0,74]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Zs=L,e.$1s=R;const D=[];var P;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function L(O,m,s){m instanceof v.$Hi||(m=new v.$Hi(m,[],!!s)),D.push([O,m])}function R(){return D}}),define(Re[167],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;class v{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Cr=v;class D{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const O=this.lookupOrInsertNode(L),m=this.lookupOrInsertNode(R);O.outgoing.set(m.key,m),m.incoming.set(O.key,O)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const O of this.a.values())O.outgoing.delete(R),O.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let O=this.a.get(R);return O||(O=new v(R,L),this.a.set(R,O)),O}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,O]of this.a)L.push(`${R}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const O=new Set([L]),m=this.c(R,O);if(m)return m}}c(L,R){for(const[O,m]of L.outgoing){if(R.has(O))return[...R,O].join(" -> ");R.add(O);const s=this.c(m,R);if(s)return s;R.delete(O)}}}e.$Dr=D}),define(Re[3],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e._util=void 0,e.$Ki=P,e.$Li=L;var v;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function O(m){return m[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=O})(v||(e._util=v={})),e.$Ji=P("instantiationService");function D(R,O,m){O[v.DI_TARGET]===O?O[v.DI_DEPENDENCIES].push({id:R,index:m}):(O[v.DI_DEPENDENCIES]=[{id:R,index:m}],O[v.DI_TARGET]=O)}function P(R){if(v.serviceIds.has(R))return v.serviceIds.get(R);const O=function(m,s,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(O,m,I)};return O.toString=()=>R,v.serviceIds.set(R,O),O}function L(R){return R}}),define(Re[44],Te([1,0,14,2,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$ej=void 0,e.$fj=L,e.$gj=R,e.$hj=m,e.$ij=s,e.$jj=I,e.$kj=w,e.$lj=u,e.$mj=p,e.$nj=r,e.$oj=l,v=Ve(v),e.$ej=(0,P.$Ki)("configurationService");function L(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof D.URI)}function R(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof D.URI)}var O;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function m(d){switch(d){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function s(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function I(d,a){const i=Object.create(null);for(const n in d)w(i,n,d[n],a);return i}function w(d,a,i,n){const t=a.split("."),o=t.pop();let c=d;for(let g=0;g<t.length;g++){const f=t[g];let h=c[f];switch(typeof h){case"undefined":h=c[f]=Object.create(null);break;case"object":if(h===null){n(`Ignoring ${a} as ${t.slice(0,g+1).join(".")} is null`);return}break;default:n(`Ignoring ${a} as ${t.slice(0,g+1).join(".")} is ${JSON.stringify(h)}`);return}c=h}if(typeof c=="object"&&c!==null)try{c[o]=i}catch{n(`Ignoring ${a} as ${t.join(".")} is ${JSON.stringify(c)}`)}else n(`Ignoring ${a} as ${t.join(".")} is ${JSON.stringify(c)}`)}function u(d,a){const i=a.split(".");E(d,i)}function E(d,a){const i=a.shift();if(a.length===0){delete d[i];return}if(Object.keys(d).indexOf(i)!==-1){const n=d[i];typeof n=="object"&&!Array.isArray(n)&&(E(n,a),Object.keys(n).length===0&&delete d[i])}}function p(d,a,i){function n(c,g){let f=c;for(const h of g){if(typeof f!="object"||f===null)return;f=f[h]}return f}const t=a.split("."),o=n(d,t);return typeof o>"u"?i:o}function r(d,a,i){Object.keys(a).forEach(n=>{n!=="__proto__"&&(n in d?v.$lg(d[n])&&v.$lg(a[n])?r(d[n],a[n],i):i&&(d[n]=a[n]):d[n]=a[n])})}function l(d){return d.replace(/[\[\]]/g,"")}}),define(Re[31],Te([1,0,30,23,13,166,3,9,12]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Ij=e.$Hj=e.ContextKeyExprType=void 0,e.$Gj=I,e.$Jj=g,e.$Kj=f,e.$4j=_;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",D.$m),s.set("isLinux",D.$n),s.set("isWindows",D.$l),s.set("isWeb",D.$r),s.set("isMacNative",D.$m&&!D.$r),s.set("isEdge",D.$K),s.set("isFirefox",D.$I),s.set("isChrome",D.$H),s.set("isSafari",D.$J);function I(X,V){if(s.get(X)!==void 0)throw(0,m.$$)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(X,V)}const w=Object.prototype.hasOwnProperty;var u;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const E={regexParsingWithErrorRecovery:!0},p=(0,O.localize)(1673,null),r=(0,O.localize)(1674,null),l=(0,O.localize)(1675,null),d=(0,O.localize)(1676,null),a=(0,O.localize)(1677,null),i=(0,O.localize)(1678,null),n=(0,O.localize)(1679,null),t=(0,O.localize)(1680,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=E){this.k=V,this.d=new L.$Fj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const re=this.l();if(!this.E()){const be=this.D(),Pe=be.type===L.TokenType.Str?i:void 0;throw this.h.push({message:a,offset:be.offset,lexeme:L.$Fj.getLexeme(be),additionalInfo:Pe}),o.c}return re}catch(re){if(re!==o.c)throw re;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(L.TokenType.Or);){const re=this.o();V.push(re)}return V.length===1?V[0]:c.or(...V)}o(){const V=[this.s()];for(;this.y(L.TokenType.And);){const re=this.s();V.push(re)}return V.length===1?V[0]:c.and(...V)}s(){if(this.y(L.TokenType.Neg)){const V=this.D();switch(V.type){case L.TokenType.True:return this.z(),S.INSTANCE;case L.TokenType.False:return this.z(),k.INSTANCE;case L.TokenType.LParen:{this.z();const re=this.l();return this.A(L.TokenType.RParen,d),re?.negate()}case L.TokenType.Str:return this.z(),N.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case L.TokenType.True:return this.z(),c.true();case L.TokenType.False:return this.z(),c.false();case L.TokenType.LParen:{this.z();const re=this.l();return this.A(L.TokenType.RParen,d),re}case L.TokenType.Str:{const re=V.lexeme;if(this.z(),this.y(L.TokenType.RegexOp)){const Pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Pe.type!==L.TokenType.RegexStr)throw this.B("REGEX",Pe);const Fe=Pe.lexeme,Be=Fe.lastIndexOf("/"),xe=Be===Fe.length-1?void 0:this.w(Fe.substring(Be+1));let nt;try{nt=new RegExp(Fe.substring(1,Be),xe)}catch{throw this.B("REGEX",Pe)}return U.create(re,nt)}switch(Pe.type){case L.TokenType.RegexStr:case L.TokenType.Error:{const Fe=[Pe.lexeme];this.z();let Be=this.D(),xe=0;for(let et=0;et<Pe.lexeme.length;et++)Pe.lexeme.charCodeAt(et)===v.CharCode.OpenParen?xe++:Pe.lexeme.charCodeAt(et)===v.CharCode.CloseParen&&xe--;for(;!this.E()&&Be.type!==L.TokenType.And&&Be.type!==L.TokenType.Or;){switch(Be.type){case L.TokenType.LParen:xe++;break;case L.TokenType.RParen:xe--;break;case L.TokenType.RegexStr:case L.TokenType.QuotedStr:for(let et=0;et<Be.lexeme.length;et++)Be.lexeme.charCodeAt(et)===v.CharCode.OpenParen?xe++:Pe.lexeme.charCodeAt(et)===v.CharCode.CloseParen&&xe--}if(xe<0)break;Fe.push(L.$Fj.getLexeme(Be)),this.z(),Be=this.D()}const nt=Fe.join(""),ht=nt.lastIndexOf("/"),$t=ht===nt.length-1?void 0:this.w(nt.substring(ht+1));let ut;try{ut=new RegExp(nt.substring(1,ht),$t)}catch{throw this.B("REGEX",Pe)}return c.regex(re,ut)}case L.TokenType.QuotedStr:{const Fe=Pe.lexeme;this.z();let Be=null;if(!(0,P.$hf)(Fe)){const xe=Fe.indexOf("/"),nt=Fe.lastIndexOf("/");if(xe!==nt&&xe>=0){const ht=Fe.slice(xe+1,nt),$t=Fe[nt+1]==="i"?"i":"";try{Be=new RegExp(ht,$t)}catch{throw this.B("REGEX",Pe)}}}if(Be===null)throw this.B("REGEX",Pe);return U.create(re,Be)}default:throw this.B("REGEX",this.D())}}if(this.y(L.TokenType.Not)){this.A(L.TokenType.In,l);const Pe=this.u();return c.notIn(re,Pe)}switch(this.D().type){case L.TokenType.Eq:{this.z();const Pe=this.u();if(this.x().type===L.TokenType.QuotedStr)return c.equals(re,Pe);switch(Pe){case"true":return c.has(re);case"false":return c.not(re);default:return c.equals(re,Pe)}}case L.TokenType.NotEq:{this.z();const Pe=this.u();if(this.x().type===L.TokenType.QuotedStr)return c.notEquals(re,Pe);switch(Pe){case"true":return c.not(re);case"false":return c.has(re);default:return c.notEquals(re,Pe)}}case L.TokenType.Lt:return this.z(),x.create(re,this.u());case L.TokenType.LtEq:return this.z(),j.create(re,this.u());case L.TokenType.Gt:return this.z(),F.create(re,this.u());case L.TokenType.GtEq:return this.z(),G.create(re,this.u());case L.TokenType.In:return this.z(),c.in(re,this.u());default:return c.has(re)}}case L.TokenType.EOF:throw this.h.push({message:n,offset:V.offset,lexeme:"",additionalInfo:t}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case L.TokenType.Str:case L.TokenType.QuotedStr:return this.z(),V.lexeme;case L.TokenType.True:return this.z(),"true";case L.TokenType.False:return this.z(),"false";case L.TokenType.In:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,re){if(this.C(V))return this.z();throw this.B(re,this.D())}B(V,re,be){const Pe=(0,O.localize)(1681,null,V,L.$Fj.getLexeme(re)),Fe=re.offset,Be=L.$Fj.getLexeme(re);return this.h.push({message:Pe,offset:Fe,lexeme:Be,additionalInfo:be}),o.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===L.TokenType.EOF}}e.$Hj=o;class c{static false(){return S.INSTANCE}static true(){return k.INSTANCE}static has(V){return y.create(V)}static equals(V,re){return C.create(V,re)}static notEquals(V,re){return b.create(V,re)}static regex(V,re){return U.create(V,re)}static in(V,re){return T.create(V,re)}static notIn(V,re){return $.create(V,re)}static not(V){return N.create(V)}static and(...V){return ae.create(V,null,!0)}static or(...V){return ee.create(V,null,!0)}static greater(V,re){return F.create(V,re)}static greaterEquals(V,re){return G.create(V,re)}static smaller(V,re){return x.create(V,re)}static smallerEquals(V,re){return j.create(V,re)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$Ij=c;function g(X){const V=new o({regexParsingWithErrorRecovery:!1});return X.map(re=>(V.parse(re),V.lexingErrors.length>0?V.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,O.localize)(1682,null,be.additionalInfo):(0,O.localize)(1683,null),offset:be.offset,length:be.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function f(X,V){const re=X?X.substituteConstants():void 0,be=V?V.substituteConstants():void 0;return!re&&!be?!0:!re||!be?!1:re.equals(be)}function h(X,V){return X.cmp(V)}class S{static{this.INSTANCE=new S}constructor(){this.type=u.False}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return k.INSTANCE}}e.$Lj=S;class k{static{this.INSTANCE=new k}constructor(){this.type=u.True}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return S.INSTANCE}}e.$Mj=k;class y{static create(V,re=null){const be=s.get(V);return typeof be=="boolean"?be?k.INSTANCE:S.INSTANCE:new y(V,re)}constructor(V,re){this.key=V,this.c=re,this.type=u.Defined}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=s.get(this.key);return typeof V=="boolean"?V?k.INSTANCE:S.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$Nj=y;class C{static create(V,re,be=null){if(typeof re=="boolean")return re?y.create(V,be):N.create(V,be);const Pe=s.get(V);return typeof Pe=="boolean"?re===(Pe?"true":"false")?k.INSTANCE:S.INSTANCE:new C(V,re,be)}constructor(V,re,be){this.c=V,this.d=re,this.f=be,this.type=u.Equals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=s.get(this.c);if(typeof V=="boolean"){const re=V?"true":"false";return this.d===re?k.INSTANCE:S.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Oj=C;class T{static create(V,re){return new T(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=u.In,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const re=V.getValue(this.f),be=V.getValue(this.d);return Array.isArray(re)?re.includes(be):typeof be=="string"&&typeof re=="object"&&re!==null?w.call(re,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=$.create(this.d,this.f)),this.c}}e.$Pj=T;class ${static create(V,re){return new $(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=u.NotIn,this.c=T.create(V,re)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qj=$;class b{static create(V,re,be=null){if(typeof re=="boolean")return re?N.create(V,be):y.create(V,be);const Pe=s.get(V);return typeof Pe=="boolean"?re===(Pe?"true":"false")?S.INSTANCE:k.INSTANCE:new b(V,re,be)}constructor(V,re,be){this.c=V,this.d=re,this.f=be,this.type=u.NotEquals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=s.get(this.c);if(typeof V=="boolean"){const re=V?"true":"false";return this.d===re?S.INSTANCE:k.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Rj=b;class N{static create(V,re=null){const be=s.get(V);return typeof be=="boolean"?be?S.INSTANCE:k.INSTANCE:new N(V,re)}constructor(V,re){this.c=V,this.d=re,this.type=u.Not}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=s.get(this.c);return typeof V=="boolean"?V?S.INSTANCE:k.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Sj=N;function A(X,V){if(typeof X=="string"){const re=parseFloat(X);isNaN(re)||(X=re)}return typeof X=="string"||typeof X=="number"?V(X):S.INSTANCE}class F{static create(V,re,be=null){return A(re,Pe=>new F(V,Pe,be))}constructor(V,re,be){this.c=V,this.d=re,this.f=be,this.type=u.Greater}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Tj=F;class G{static create(V,re,be=null){return A(re,Pe=>new G(V,Pe,be))}constructor(V,re,be){this.c=V,this.d=re,this.f=be,this.type=u.GreaterEquals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Uj=G;class x{static create(V,re,be=null){return A(re,Pe=>new x(V,Pe,be))}constructor(V,re,be){this.c=V,this.d=re,this.f=be,this.type=u.Smaller}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Vj=x;class j{static create(V,re,be=null){return A(re,Pe=>new j(V,Pe,be))}constructor(V,re,be){this.c=V,this.d=re,this.f=be,this.type=u.SmallerEquals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Wj=j;class U{static create(V,re){return new U(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=u.Regex,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const re=this.f?this.f.source:"",be=V.f?V.f.source:"";return re<be?-1:re>be?1:0}equals(V){if(V.type===this.type){const re=this.f?this.f.source:"",be=V.f?V.f.source:"";return this.d===V.d&&re===be}return!1}substituteConstants(){return this}evaluate(V){const re=V.getValue(this.d);return this.f?this.f.test(re):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=J.create(this)),this.c}}e.$Xj=U;class J{static create(V){return new J(V)}constructor(V){this.c=V,this.type=u.NotRegex}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new J(this.c.map(V))}negate(){return this.c}}e.$Yj=J;function Z(X){let V=null;for(let re=0,be=X.length;re<be;re++){const Pe=X[re].substituteConstants();if(X[re]!==Pe&&V===null){V=[];for(let Fe=0;Fe<re;Fe++)V[Fe]=X[Fe]}V!==null&&(V[re]=Pe)}return V===null?X:V}class ae{static create(V,re,be){return ae.d(V,re,be)}constructor(V,re){this.expr=V,this.c=re,this.type=u.And}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let re=0,be=this.expr.length;re<be;re++){const Pe=h(this.expr[re],V.expr[re]);if(Pe!==0)return Pe}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let re=0,be=this.expr.length;re<be;re++)if(!this.expr[re].equals(V.expr[re]))return!1;return!0}return!1}substituteConstants(){const V=Z(this.expr);return V===this.expr?this:ae.create(V,this.c,!1)}evaluate(V){for(let re=0,be=this.expr.length;re<be;re++)if(!this.expr[re].evaluate(V))return!1;return!0}static d(V,re,be){const Pe=[];let Fe=!1;for(const Be of V)if(Be){if(Be.type===u.True){Fe=!0;continue}if(Be.type===u.False)return S.INSTANCE;if(Be.type===u.And){Pe.push(...Be.expr);continue}Pe.push(Be)}if(Pe.length===0&&Fe)return k.INSTANCE;if(Pe.length!==0){if(Pe.length===1)return Pe[0];Pe.sort(h);for(let Be=1;Be<Pe.length;Be++)Pe[Be-1].equals(Pe[Be])&&(Pe.splice(Be,1),Be--);if(Pe.length===1)return Pe[0];for(;Pe.length>1;){const Be=Pe[Pe.length-1];if(Be.type!==u.Or)break;Pe.pop();const xe=Pe.pop(),nt=Pe.length===0,ht=ee.create(Be.expr.map($t=>ae.create([$t,xe],null,be)),null,nt);ht&&(Pe.push(ht),Pe.sort(h))}if(Pe.length===1)return Pe[0];if(be){for(let Be=0;Be<Pe.length;Be++)for(let xe=Be+1;xe<Pe.length;xe++)if(Pe[Be].negate().equals(Pe[xe]))return S.INSTANCE;if(Pe.length===1)return Pe[0]}return new ae(Pe,re)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const re of this.expr)V.push(...re.keys());return V}map(V){return new ae(this.expr.map(re=>re.map(V)),null)}negate(){if(!this.c){const V=[];for(const re of this.expr)V.push(re.negate());this.c=ee.create(V,this,!0)}return this.c}}e.$Zj=ae;class ee{static create(V,re,be){return ee.d(V,re,be)}constructor(V,re){this.expr=V,this.c=re,this.type=u.Or}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let re=0,be=this.expr.length;re<be;re++){const Pe=h(this.expr[re],V.expr[re]);if(Pe!==0)return Pe}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let re=0,be=this.expr.length;re<be;re++)if(!this.expr[re].equals(V.expr[re]))return!1;return!0}return!1}substituteConstants(){const V=Z(this.expr);return V===this.expr?this:ee.create(V,this.c,!1)}evaluate(V){for(let re=0,be=this.expr.length;re<be;re++)if(this.expr[re].evaluate(V))return!0;return!1}static d(V,re,be){let Pe=[],Fe=!1;if(V){for(let Be=0,xe=V.length;Be<xe;Be++){const nt=V[Be];if(nt){if(nt.type===u.False){Fe=!0;continue}if(nt.type===u.True)return k.INSTANCE;if(nt.type===u.Or){Pe=Pe.concat(nt.expr);continue}Pe.push(nt)}}if(Pe.length===0&&Fe)return S.INSTANCE;Pe.sort(h)}if(Pe.length!==0){if(Pe.length===1)return Pe[0];for(let Be=1;Be<Pe.length;Be++)Pe[Be-1].equals(Pe[Be])&&(Pe.splice(Be,1),Be--);if(Pe.length===1)return Pe[0];if(be){for(let Be=0;Be<Pe.length;Be++)for(let xe=Be+1;xe<Pe.length;xe++)if(Pe[Be].negate().equals(Pe[xe]))return k.INSTANCE;if(Pe.length===1)return Pe[0]}return new ee(Pe,re)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const re of this.expr)V.push(...re.keys());return V}map(V){return new ee(this.expr.map(re=>re.map(V)),null)}negate(){if(!this.c){const V=[];for(const re of this.expr)V.push(re.negate());for(;V.length>1;){const re=V.shift(),be=V.shift(),Pe=[];for(const Fe of Ie(re))for(const Be of Ie(be))Pe.push(ae.create([Fe,Be],null,!1));V.unshift(ee.create(Pe,null,!1))}this.c=ee.create(V,this,!0)}return this.c}}e.$1j=ee;class oe extends y{static{this.d=[]}static all(){return oe.d.values()}constructor(V,re,be){super(V,null),this.f=re,typeof be=="object"?oe.d.push({...be,key:V}):be!==!0&&oe.d.push({key:V,description:be,type:re!=null?typeof re:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return C.create(this.key,V)}notEqualsTo(V){return b.create(this.key,V)}}e.$2j=oe,e.$3j=(0,R.$Ki)("contextKeyService");function ie(X,V){return X<V?-1:X>V?1:0}function ue(X,V,re,be){return X<re?-1:X>re?1:V<be?-1:V>be?1:0}function _(X,V){if(X.type===u.False||V.type===u.True)return!0;if(X.type===u.Or)return V.type===u.Or?$e(X.expr,V.expr):!1;if(V.type===u.Or){for(const re of V.expr)if(_(X,re))return!0;return!1}if(X.type===u.And){if(V.type===u.And)return $e(V.expr,X.expr);for(const re of X.expr)if(_(re,V))return!0;return!1}return X.equals(V)}function $e(X,V){let re=0,be=0;for(;re<X.length&&be<V.length;){const Pe=X[re].cmp(V[be]);if(Pe<0)return!1;Pe===0&&re++,be++}return re===X.length}function Ie(X){return X.type===u.Or?X.expr:[X]}}),define(Re[168],Te([1,0,31,3]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.$At=e.AccessibilitySupport=e.$zt=void 0,e.$Bt=L,e.$zt=(0,D.$Ki)("accessibilityService");var P;(function(R){R[R.Unknown=0]="Unknown",R[R.Disabled=1]="Disabled",R[R.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$At=new v.$2j("accessibilityModeEnabled",!1);function L(R){return R&&typeof R=="object"&&typeof R.label=="string"&&(typeof R.role>"u"||typeof R.role=="string")}e.$Ct="ACCESSIBLE_VIEW_SHOWN_"}),define(Re[106],Te([1,0,17,25,23,146,280,151,169,9,168]),function(we,e,v,D,P,L,R,O,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=c,e.stringSet=h,e.cursorStyleToString=A,e.filterValidationDecorations=Me,v=Ve(v),D=Ve(D),P=Ve(P),s=Ve(s);var w;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(w||(e.EditorAutoIndentStrategy=w={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(q){this.c=q}hasChanged(q){return this.c[q]}}e.ConfigurationChangedEvent=u;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class p{constructor(q,de,je,Qe){this.id=q,this.name=de,this.defaultValue=je,this.schema=Qe}applyUpdate(q,de){return l(q,de)}compute(q,de,je){return je}}class r{constructor(q,de){this.newValue=q,this.didChange=de}}e.ApplyUpdateResult=r;function l(Y,q){if(typeof Y!="object"||typeof q!="object"||!Y||!q)return new r(q,Y!==q);if(Array.isArray(Y)||Array.isArray(q)){const je=Array.isArray(Y)&&Array.isArray(q)&&v.$yb(Y,q);return new r(q,!je)}let de=!1;for(const je in q)if(q.hasOwnProperty(je)){const Qe=l(Y[je],q[je]);Qe.didChange&&(Y[je]=Qe.newValue,de=!0)}return new r(Y,de)}class d{constructor(q){this.schema=void 0,this.id=q,this.name="_never_",this.defaultValue=void 0}applyUpdate(q,de){return l(q,de)}validate(q){return this.defaultValue}}class a{constructor(q,de,je,Qe){this.id=q,this.name=de,this.defaultValue=je,this.schema=Qe}applyUpdate(q,de){return l(q,de)}validate(q){return typeof q>"u"?this.defaultValue:q}compute(q,de,je){return je}}function i(Y,q){return typeof Y>"u"?q:Y==="false"?!1:!!Y}class n extends a{constructor(q,de,je,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=je),super(q,de,je,Qe)}validate(q){return i(q,this.defaultValue)}}function t(Y,q,de,je){if(typeof Y>"u")return q;let Qe=parseInt(Y,10);return isNaN(Qe)?q:(Qe=Math.max(de,Qe),Qe=Math.min(je,Qe),Qe|0)}class o extends a{static clampedInt(q,de,je,Qe){return t(q,de,je,Qe)}constructor(q,de,je,Qe,st,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=je,dt.minimum=Qe,dt.maximum=st),super(q,de,je,dt),this.minimum=Qe,this.maximum=st}validate(q){return o.clampedInt(q,this.defaultValue,this.minimum,this.maximum)}}function c(Y,q,de,je){if(typeof Y>"u")return q;const Qe=g.float(Y,q);return g.clamp(Qe,de,je)}class g extends a{static clamp(q,de,je){return q<de?de:q>je?je:q}static float(q,de){if(typeof q=="number")return q;if(typeof q>"u")return de;const je=parseFloat(q);return isNaN(je)?de:je}constructor(q,de,je,Qe,st){typeof st<"u"&&(st.type="number",st.default=je),super(q,de,je,st),this.validationFn=Qe}validate(q){return this.validationFn(g.float(q,this.defaultValue))}}class f extends a{static string(q,de){return typeof q!="string"?de:q}constructor(q,de,je,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=je),super(q,de,je,Qe)}validate(q){return f.string(q,this.defaultValue)}}function h(Y,q,de,je){return typeof Y!="string"?q:je&&Y in je?je[Y]:de.indexOf(Y)===-1?q:Y}class S extends a{constructor(q,de,je,Qe,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Qe,st.default=je),super(q,de,je,st),this.c=Qe}validate(q){return h(q,this.defaultValue,this.c)}}class k extends p{constructor(q,de,je,Qe,st,dt,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=st,mt.default=Qe),super(q,de,je,mt),this.c=st,this.d=dt}validate(q){return typeof q!="string"?this.defaultValue:this.c.indexOf(q)===-1?this.defaultValue:this.d(q)}}function y(Y){switch(Y){case"none":return w.None;case"keep":return w.Keep;case"brackets":return w.Brackets;case"advanced":return w.Advanced;case"full":return w.Full}}class C extends p{constructor(){super(ve.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(302,null),s.localize(303,null),s.localize(304,null)],default:"auto",tags:["accessibility"],description:s.localize(305,null)})}validate(q){switch(q){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(q,de,je){return je===I.AccessibilitySupport.Unknown?q.accessibilitySupport:je}}class T extends p{constructor(){const q={insertSpace:!0,ignoreEmptyLines:!0};super(ve.comments,"comments",q,{"editor.comments.insertSpace":{type:"boolean",default:q.insertSpace,description:s.localize(306,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:q.ignoreEmptyLines,description:s.localize(307,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{insertSpace:i(de.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(de.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var $;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})($||(e.TextEditorCursorBlinkingStyle=$={}));function b(Y){switch(Y){case"blink":return $.Blink;case"smooth":return $.Smooth;case"phase":return $.Phase;case"expand":return $.Expand;case"solid":return $.Solid}}var N;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(N||(e.TextEditorCursorStyle=N={}));function A(Y){switch(Y){case N.Line:return"line";case N.Block:return"block";case N.Underline:return"underline";case N.LineThin:return"line-thin";case N.BlockOutline:return"block-outline";case N.UnderlineThin:return"underline-thin"}}function F(Y){switch(Y){case"line":return N.Line;case"block":return N.Block;case"underline":return N.Underline;case"line-thin":return N.LineThin;case"block-outline":return N.BlockOutline;case"underline-thin":return N.UnderlineThin}}class G extends d{constructor(){super(ve.editorClassName)}compute(q,de,je){const Qe=["monaco-editor"];return de.get(ve.extraEditorClassName)&&Qe.push(de.get(ve.extraEditorClassName)),q.extraEditorClassName&&Qe.push(q.extraEditorClassName),de.get(ve.mouseStyle)==="default"?Qe.push("mouse-default"):de.get(ve.mouseStyle)==="copy"&&Qe.push("mouse-copy"),de.get(ve.showUnused)&&Qe.push("showUnused"),de.get(ve.showDeprecated)&&Qe.push("showDeprecated"),Qe.join(" ")}}class x extends n{constructor(){super(ve.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(308,null)})}compute(q,de,je){return je&&q.emptySelectionClipboard}}class j extends p{constructor(){const q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(ve.find,"find",q,{"editor.find.cursorMoveOnType":{type:"boolean",default:q.cursorMoveOnType,description:s.localize(309,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:q.seedSearchStringFromSelection,enumDescriptions:[s.localize(310,null),s.localize(311,null),s.localize(312,null)],description:s.localize(313,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:q.autoFindInSelection,enumDescriptions:[s.localize(314,null),s.localize(315,null),s.localize(316,null)],description:s.localize(317,null)},"editor.find.globalFindClipboard":{type:"boolean",default:q.globalFindClipboard,description:s.localize(318,null),included:P.$m},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:q.addExtraSpaceOnTop,description:s.localize(319,null)},"editor.find.loop":{type:"boolean",default:q.loop,description:s.localize(320,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{cursorMoveOnType:i(de.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof q.seedSearchStringFromSelection=="boolean"?q.seedSearchStringFromSelection?"always":"never":h(de.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof q.autoFindInSelection=="boolean"?q.autoFindInSelection?"always":"never":h(de.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(de.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(de.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(de.loop,this.defaultValue.loop)}}}class U extends p{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(ve.fontLigatures,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:s.localize(321,null)},{type:"string",description:s.localize(322,null)}],description:s.localize(323,null),default:!1})}validate(q){return typeof q>"u"?this.defaultValue:typeof q=="string"?q==="false"||q.length===0?U.OFF:q==="true"?U.ON:q:q?U.ON:U.OFF}}e.EditorFontLigatures=U;class J extends p{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(ve.fontVariations,"fontVariations",J.OFF,{anyOf:[{type:"boolean",description:s.localize(324,null)},{type:"string",description:s.localize(325,null)}],description:s.localize(326,null),default:!1})}validate(q){return typeof q>"u"?this.defaultValue:typeof q=="string"?q==="false"?J.OFF:q==="true"?J.TRANSLATE:q:q?J.TRANSLATE:J.OFF}compute(q,de,je){return q.fontInfo.fontVariationSettings}}e.EditorFontVariations=J;class Z extends d{constructor(){super(ve.fontInfo)}compute(q,de,je){return q.fontInfo}}class ae extends a{constructor(){super(ve.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(327,null)})}validate(q){const de=g.float(q,this.defaultValue);return de===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(de,6,100)}compute(q,de,je){return q.fontInfo.fontSize}}class ee extends p{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(ve.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ee.d,maximum:ee.e,errorMessage:s.localize(328,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ee.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(329,null)})}validate(q){return q==="normal"||q==="bold"?q:String(o.clampedInt(q,e.EDITOR_FONT_DEFAULTS.fontWeight,ee.d,ee.e))}}class oe extends p{constructor(){const q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},de={type:"string",enum:["peek","gotoAndPeek","goto"],default:q.multiple,enumDescriptions:[s.localize(330,null),s.localize(331,null),s.localize(332,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(ve.gotoLocation,"gotoLocation",q,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(333,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(334,null),...de},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(335,null),...de},"editor.gotoLocation.multipleDeclarations":{description:s.localize(336,null),...de},"editor.gotoLocation.multipleImplementations":{description:s.localize(337,null),...de},"editor.gotoLocation.multipleReferences":{description:s.localize(338,null),...de},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:q.alternativeDefinitionCommand,enum:je,description:s.localize(339,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:q.alternativeTypeDefinitionCommand,enum:je,description:s.localize(340,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:q.alternativeDeclarationCommand,enum:je,description:s.localize(341,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:q.alternativeImplementationCommand,enum:je,description:s.localize(342,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:q.alternativeReferenceCommand,enum:je,description:s.localize(343,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{multiple:h(de.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:de.multipleDefinitions??h(de.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:de.multipleTypeDefinitions??h(de.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:de.multipleDeclarations??h(de.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:de.multipleImplementations??h(de.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:de.multipleReferences??h(de.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:de.multipleTests??h(de.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:f.string(de.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:f.string(de.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:f.string(de.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:f.string(de.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:f.string(de.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:f.string(de.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class ie extends p{constructor(){const q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(ve.hover,"hover",q,{"editor.hover.enabled":{type:"boolean",default:q.enabled,description:s.localize(344,null)},"editor.hover.delay":{type:"number",default:q.delay,minimum:0,maximum:1e4,description:s.localize(345,null)},"editor.hover.sticky":{type:"boolean",default:q.sticky,description:s.localize(346,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:q.hidingDelay,description:s.localize(347,null)},"editor.hover.above":{type:"boolean",default:q.above,description:s.localize(348,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),delay:o.clampedInt(de.delay,this.defaultValue.delay,0,1e4),sticky:i(de.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(de.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(de.above,this.defaultValue.above)}}}var ue;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(ue||(e.RenderMinimap=ue={}));class _ extends d{constructor(){super(ve.layoutInfo)}compute(q,de,je){return _.computeLayout(de,{memory:q.memory,outerWidth:q.outerWidth,outerHeight:q.outerHeight,isDominatedByLongLines:q.isDominatedByLongLines,lineHeight:q.fontInfo.lineHeight,viewLineCount:q.viewLineCount,lineNumbersDigitCount:q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:q.fontInfo.maxDigitWidth,pixelRatio:q.pixelRatio,glyphMarginDecorationLaneCount:q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(q){const de=q.height/q.lineHeight,je=Math.floor(q.paddingTop/q.lineHeight);let Qe=Math.floor(q.paddingBottom/q.lineHeight);q.scrollBeyondLastLine&&(Qe=Math.max(Qe,de-1));const st=(je+q.viewLineCount+Qe)/(q.pixelRatio*q.height),dt=Math.floor(q.viewLineCount/st);return{typicalViewportLineCount:de,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Qe,desiredRatio:st,minimapLineCount:dt}}static c(q,de){const je=q.outerWidth,Qe=q.outerHeight,st=q.pixelRatio;if(!q.minimap.enabled)return{renderMinimap:ue.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const dt=de.stableMinimapLayoutInput,mt=dt&&q.outerHeight===dt.outerHeight&&q.lineHeight===dt.lineHeight&&q.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&q.pixelRatio===dt.pixelRatio&&q.scrollBeyondLastLine===dt.scrollBeyondLastLine&&q.paddingTop===dt.paddingTop&&q.paddingBottom===dt.paddingBottom&&q.minimap.enabled===dt.minimap.enabled&&q.minimap.side===dt.minimap.side&&q.minimap.size===dt.minimap.size&&q.minimap.showSlider===dt.minimap.showSlider&&q.minimap.renderCharacters===dt.minimap.renderCharacters&&q.minimap.maxColumn===dt.minimap.maxColumn&&q.minimap.scale===dt.minimap.scale&&q.verticalScrollbarWidth===dt.verticalScrollbarWidth&&q.isViewportWrapping===dt.isViewportWrapping,Tt=q.lineHeight,Ot=q.typicalHalfwidthCharacterWidth,Qt=q.scrollBeyondLastLine,_t=q.minimap.renderCharacters;let Xe=st>=2?Math.round(q.minimap.scale*2):q.minimap.scale;const At=q.minimap.maxColumn,Ut=q.minimap.size,wt=q.minimap.side,Dt=q.verticalScrollbarWidth,ei=q.viewLineCount,ti=q.remainingWidth,Ht=q.isViewportWrapping,bt=_t?2:3;let Lt=Math.floor(st*Qe);const ci=Lt/st;let Yt=!1,Ge=!1,ii=bt*Xe,li=Xe/st,hi=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:ri,extraLinesBeforeFirstLine:Gt,extraLinesBeyondLastLine:Jt,desiredRatio:ui,minimapLineCount:Mt}=_.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:Qt,paddingTop:q.paddingTop,paddingBottom:q.paddingBottom,height:Qe,lineHeight:Tt,pixelRatio:st});if(ei/Mt>1)Yt=!0,Ge=!0,Xe=1,ii=1,li=Xe/st;else{let vt=!1,Xt=Xe+1;if(Ut==="fit"){const Et=Math.ceil((Gt+ei+Jt)*ii);Ht&&mt&&ti<=de.stableFitRemainingWidth?(vt=!0,Xt=de.stableFitMaxMinimapScale):vt=Et>Lt}if(Ut==="fill"||vt){Yt=!0;const Et=Xe;ii=Math.min(Tt*st,Math.max(1,Math.floor(1/ui))),Ht&&mt&&ti<=de.stableFitRemainingWidth&&(Xt=de.stableFitMaxMinimapScale),Xe=Math.min(Xt,Math.max(1,Math.floor(ii/bt))),Xe>Et&&(hi=Math.min(2,Xe/Et)),li=Xe/st/hi,Lt=Math.ceil(Math.max(ri,Gt+ei+Jt)*ii),Ht?(de.stableMinimapLayoutInput=q,de.stableFitRemainingWidth=ti,de.stableFitMaxMinimapScale=Xe):(de.stableMinimapLayoutInput=null,de.stableFitRemainingWidth=0)}}}const kt=Math.floor(At*li),jt=Math.min(kt,Math.max(0,Math.floor((ti-Dt-2)*li/(Ot+li)))+e.MINIMAP_GUTTER_WIDTH);let Nt=Math.floor(st*jt);const Bt=Nt/st;Nt=Math.floor(Nt*hi);const ai=_t?ue.Text:ue.Blocks,ni=wt==="left"?0:je-jt-Dt;return{renderMinimap:ai,minimapLeft:ni,minimapWidth:jt,minimapHeightIsEditorHeight:Yt,minimapIsSampling:Ge,minimapScale:Xe,minimapLineHeight:ii,minimapCanvasInnerWidth:Nt,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:ci}}static computeLayout(q,de){const je=de.outerWidth|0,Qe=de.outerHeight|0,st=de.lineHeight|0,dt=de.lineNumbersDigitCount|0,mt=de.typicalHalfwidthCharacterWidth,Tt=de.maxDigitWidth,Ot=de.pixelRatio,Qt=de.viewLineCount,_t=q.get(ve.wordWrapOverride2),Xe=_t==="inherit"?q.get(ve.wordWrapOverride1):_t,At=Xe==="inherit"?q.get(ve.wordWrap):Xe,Ut=q.get(ve.wordWrapColumn),wt=de.isDominatedByLongLines,Dt=q.get(ve.glyphMargin),ei=q.get(ve.lineNumbers).renderType!==et.Off,ti=q.get(ve.lineNumbersMinChars),Ht=q.get(ve.scrollBeyondLastLine),bt=q.get(ve.padding),Lt=q.get(ve.minimap),ci=q.get(ve.scrollbar),Yt=ci.verticalScrollbarSize,Ge=ci.verticalHasArrows,ii=ci.arrowSize,li=ci.horizontalScrollbarSize,hi=q.get(ve.folding),kt=q.get(ve.showFoldingControls)!=="never";let jt=q.get(ve.lineDecorationsWidth);hi&&kt&&(jt+=16);let Nt=0;if(ei){const Zt=Math.max(dt,ti);Nt=Math.round(Zt*Tt)}let Bt=0;Dt&&(Bt=st*de.glyphMarginDecorationLaneCount);let ai=0,ni=ai+Bt,ri=ni+Nt,Gt=ri+jt;const Jt=je-Bt-Nt-jt;let ui=!1,Mt=!1,Ct=-1;Xe==="inherit"&&wt?(ui=!0,Mt=!0):At==="on"||At==="bounded"?Mt=!0:At==="wordWrapColumn"&&(Ct=Ut);const vt=_.c({outerWidth:je,outerHeight:Qe,lineHeight:st,typicalHalfwidthCharacterWidth:mt,pixelRatio:Ot,scrollBeyondLastLine:Ht,paddingTop:bt.top,paddingBottom:bt.bottom,minimap:Lt,verticalScrollbarWidth:Yt,viewLineCount:Qt,remainingWidth:Jt,isViewportWrapping:Mt},de.memory||new E);vt.renderMinimap!==ue.None&&vt.minimapLeft===0&&(ai+=vt.minimapWidth,ni+=vt.minimapWidth,ri+=vt.minimapWidth,Gt+=vt.minimapWidth);const Xt=Jt-vt.minimapWidth,Et=Math.max(1,Math.floor((Xt-Yt-2)/mt)),si=Ge?ii:0;return Mt&&(Ct=Math.max(1,Et),At==="bounded"&&(Ct=Math.min(Ct,Ut))),{width:je,height:Qe,glyphMarginLeft:ai,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:de.glyphMarginDecorationLaneCount,lineNumbersLeft:ni,lineNumbersWidth:Nt,decorationsLeft:ri,decorationsWidth:jt,contentLeft:Gt,contentWidth:Xt,minimap:vt,viewportColumn:Et,isWordWrapMinified:ui,isViewportWrapping:Mt,wrappingColumn:Ct,verticalScrollbarWidth:Yt,horizontalScrollbarHeight:li,overviewRuler:{top:si,width:Yt,height:Qe-2*si,right:0}}}}e.EditorLayoutInfoComputer=_;class $e extends p{constructor(){super(ve.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(349,null),s.localize(350,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(351,null)}})}validate(q){return h(q,"simple",["simple","advanced"])}compute(q,de,je){return de.get(ve.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":je}}var Ie;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(Ie||(e.ShowLightbulbIconMode=Ie={}));class X extends p{constructor(){const q={enabled:Ie.OnCode};super(ve.lightbulb,"lightbulb",q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ie.Off,Ie.OnCode,Ie.On],default:q.enabled,enumDescriptions:[s.localize(352,null),s.localize(353,null),s.localize(354,null)],description:s.localize(355,null)}})}validate(q){return!q||typeof q!="object"?this.defaultValue:{enabled:h(q.enabled,this.defaultValue.enabled,[Ie.Off,Ie.OnCode,Ie.On])}}}class V extends p{constructor(){const q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(ve.stickyScroll,"stickyScroll",q,{"editor.stickyScroll.enabled":{type:"boolean",default:q.enabled,description:s.localize(356,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:q.maxLineCount,minimum:1,maximum:20,description:s.localize(357,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:q.defaultModel,description:s.localize(358,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:q.scrollWithEditor,description:s.localize(359,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(de.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:h(de.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(de.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends p{constructor(){const q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(ve.inlayHints,"inlayHints",q,{"editor.inlayHints.enabled":{type:"string",default:q.enabled,description:s.localize(360,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(361,null),s.localize(362,null,P.$m?"Ctrl+Option":"Ctrl+Alt"),s.localize(363,null,P.$m?"Ctrl+Option":"Ctrl+Alt"),s.localize(364,null)]},"editor.inlayHints.fontSize":{type:"number",default:q.fontSize,markdownDescription:s.localize(365,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:q.fontFamily,markdownDescription:s.localize(366,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:q.padding,description:s.localize(367,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return typeof de.enabled=="boolean"&&(de.enabled=de.enabled?"on":"off"),{enabled:h(de.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(de.fontSize,this.defaultValue.fontSize,0,100),fontFamily:f.string(de.fontFamily,this.defaultValue.fontFamily),padding:i(de.padding,this.defaultValue.padding)}}}class be extends p{constructor(){super(ve.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(q){return typeof q=="string"&&/^\d+(\.\d+)?ch$/.test(q)?-parseFloat(q.substring(0,q.length-2)):o.clampedInt(q,this.defaultValue,0,1e3)}compute(q,de,je){return je<0?o.clampedInt(-je*q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class Pe extends g{constructor(){super(ve.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,q=>g.clamp(q,0,150),{markdownDescription:s.localize(368,null)})}compute(q,de,je){return q.fontInfo.lineHeight}}class Fe extends p{constructor(){const q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(ve.minimap,"minimap",q,{"editor.minimap.enabled":{type:"boolean",default:q.enabled,description:s.localize(369,null)},"editor.minimap.autohide":{type:"boolean",default:q.autohide,description:s.localize(370,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(371,null),s.localize(372,null),s.localize(373,null)],default:q.size,description:s.localize(374,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:q.side,description:s.localize(375,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:q.showSlider,description:s.localize(376,null)},"editor.minimap.scale":{type:"number",default:q.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(377,null)},"editor.minimap.renderCharacters":{type:"boolean",default:q.renderCharacters,description:s.localize(378,null)},"editor.minimap.maxColumn":{type:"number",default:q.maxColumn,description:s.localize(379,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:q.showRegionSectionHeaders,description:s.localize(380,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:q.showMarkSectionHeaders,description:s.localize(381,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:q.sectionHeaderFontSize,description:s.localize(382,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:q.sectionHeaderLetterSpacing,description:s.localize(383,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),autohide:i(de.autohide,this.defaultValue.autohide),size:h(de.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(de.side,this.defaultValue.side,["right","left"]),showSlider:h(de.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(de.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(de.scale,1,1,3),maxColumn:o.clampedInt(de.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(de.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(de.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:g.clamp(de.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:g.clamp(de.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function Be(Y){return Y==="ctrlCmd"?P.$m?"metaKey":"ctrlKey":"altKey"}class xe extends p{constructor(){super(ve.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(384,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(385,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{top:o.clampedInt(de.top,0,0,1e3),bottom:o.clampedInt(de.bottom,0,0,1e3)}}}class nt extends p{constructor(){const q={enabled:!0,cycle:!0};super(ve.parameterHints,"parameterHints",q,{"editor.parameterHints.enabled":{type:"boolean",default:q.enabled,description:s.localize(386,null)},"editor.parameterHints.cycle":{type:"boolean",default:q.cycle,description:s.localize(387,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),cycle:i(de.cycle,this.defaultValue.cycle)}}}class ht extends d{constructor(){super(ve.pixelRatio)}compute(q,de,je){return q.pixelRatio}}class $t extends p{constructor(){super(ve.placeholder,"placeholder",void 0)}validate(q){return typeof q>"u"?this.defaultValue:typeof q=="string"?q:this.defaultValue}}class ut extends p{constructor(){const q={other:"on",comments:"off",strings:"off"},de=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(388,null),s.localize(389,null),s.localize(390,null)]}];super(ve.quickSuggestions,"quickSuggestions",q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:de,default:q.strings,description:s.localize(391,null)},comments:{anyOf:de,default:q.comments,description:s.localize(392,null)},other:{anyOf:de,default:q.other,description:s.localize(393,null)}},default:q,markdownDescription:s.localize(394,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=q}validate(q){if(typeof q=="boolean"){const Ot=q?"on":"off";return{comments:Ot,strings:Ot,other:Ot}}if(!q||typeof q!="object")return this.defaultValue;const{other:de,comments:je,strings:Qe}=q,st=["on","inline","off"];let dt,mt,Tt;return typeof de=="boolean"?dt=de?"on":"off":dt=h(de,this.defaultValue.other,st),typeof je=="boolean"?mt=je?"on":"off":mt=h(je,this.defaultValue.comments,st),typeof Qe=="boolean"?Tt=Qe?"on":"off":Tt=h(Qe,this.defaultValue.strings,st),{other:dt,comments:mt,strings:Tt}}}var et;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(et||(e.RenderLineNumbersType=et={}));class Le extends p{constructor(){super(ve.lineNumbers,"lineNumbers",{renderType:et.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(395,null),s.localize(396,null),s.localize(397,null),s.localize(398,null)],default:"on",description:s.localize(399,null)})}validate(q){let de=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof q<"u"&&(typeof q=="function"?(de=et.Custom,je=q):q==="interval"?de=et.Interval:q==="relative"?de=et.Relative:q==="on"?de=et.On:de=et.Off),{renderType:de,renderFn:je}}}function Me(Y){const q=Y.get(ve.renderValidationDecorations);return q==="editable"?Y.get(ve.readOnly):q!=="on"}class Ne extends p{constructor(){const q=[],de={type:"number",description:s.localize(400,null)};super(ve.rulers,"rulers",q,{type:"array",items:{anyOf:[de,{type:["object"],properties:{column:de,color:{type:"string",description:s.localize(401,null),format:"color-hex"}}}]},default:q,description:s.localize(402,null)})}validate(q){if(Array.isArray(q)){const de=[];for(const je of q)if(typeof je=="number")de.push({column:o.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Qe=je;de.push({column:o.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return de.sort((je,Qe)=>je.column-Qe.column),de}return this.defaultValue}}class W extends p{constructor(){super(ve.readOnlyMessage,"readOnlyMessage",void 0)}validate(q){return!q||typeof q!="object"?this.defaultValue:q}}function B(Y,q){if(typeof Y!="string")return q;switch(Y){case"hidden":return L.ScrollbarVisibility.Hidden;case"visible":return L.ScrollbarVisibility.Visible;default:return L.ScrollbarVisibility.Auto}}class Q extends p{constructor(){const q={vertical:L.ScrollbarVisibility.Auto,horizontal:L.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(ve.scrollbar,"scrollbar",q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(403,null),s.localize(404,null),s.localize(405,null)],default:"auto",description:s.localize(406,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(407,null),s.localize(408,null),s.localize(409,null)],default:"auto",description:s.localize(410,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:q.verticalScrollbarSize,description:s.localize(411,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:q.horizontalScrollbarSize,description:s.localize(412,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:q.scrollByPage,description:s.localize(413,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:q.ignoreHorizontalScrollbarInContentHeight,description:s.localize(414,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q,je=o.clampedInt(de.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=o.clampedInt(de.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(de.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:B(de.vertical,this.defaultValue.vertical),horizontal:B(de.horizontal,this.defaultValue.horizontal),useShadows:i(de.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(de.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(de.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(de.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(de.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:o.clampedInt(de.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:o.clampedInt(de.verticalSliderSize,Qe,0,1e3),scrollByPage:i(de.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(de.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends p{constructor(){const q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(ve.unicodeHighlighting,"unicodeHighlight",q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.nonBasicASCII,description:s.localize(415,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:q.invisibleCharacters,description:s.localize(416,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:q.ambiguousCharacters,description:s.localize(417,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.includeComments,description:s.localize(418,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.includeStrings,description:s.localize(419,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:q.allowedCharacters,description:s.localize(420,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:q.allowedLocales,description:s.localize(421,null)}})}applyUpdate(q,de){let je=!1;de.allowedCharacters&&q&&(D.$oo(q.allowedCharacters,de.allowedCharacters)||(q={...q,allowedCharacters:de.allowedCharacters},je=!0)),de.allowedLocales&&q&&(D.$oo(q.allowedLocales,de.allowedLocales)||(q={...q,allowedLocales:de.allowedLocales},je=!0));const Qe=super.applyUpdate(q,de);return je?new r(Qe.newValue,!0):Qe}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{nonBasicASCII:Je(de.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(de.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(de.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Je(de.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Je(de.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(q.allowedLocales,this.defaultValue.allowedLocales)}}c(q,de){if(typeof q!="object"||!q)return de;const je={};for(const[Qe,st]of Object.entries(q))st===!0&&(je[Qe]=!0);return je}}class se extends p{constructor(){const q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(ve.inlineSuggest,"inlineSuggest",q,{"editor.inlineSuggest.enabled":{type:"boolean",default:q.enabled,description:s.localize(422,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(423,null),s.localize(424,null),s.localize(425,null)],description:s.localize(426,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:q.suppressSuggestions,description:s.localize(427,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:q.fontFamily,description:s.localize(428,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),mode:h(de.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(de.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(de.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(de.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:f.string(de.fontFamily,this.defaultValue.fontFamily)}}}class ge extends p{constructor(){const q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(ve.inlineEdit,"experimentalInlineEdit",q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:q.enabled,description:s.localize(429,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(430,null),s.localize(431,null),s.localize(432,null)],description:s.localize(433,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:q.fontFamily,description:s.localize(434,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),showToolbar:h(de.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:f.string(de.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(de.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ee extends p{constructor(){const q={enabled:O.$tt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$tt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(ve.bracketPairColorization,"bracketPairColorization",q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:q.enabled,markdownDescription:s.localize(435,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:q.independentColorPoolPerBracketType,description:s.localize(436,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(de.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ze extends p{constructor(){const q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(ve.guides,"guides",q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(437,null),s.localize(438,null),s.localize(439,null)],default:q.bracketPairs,description:s.localize(440,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(441,null),s.localize(442,null),s.localize(443,null)],default:q.bracketPairsHorizontal,description:s.localize(444,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:q.highlightActiveBracketPair,description:s.localize(445,null)},"editor.guides.indentation":{type:"boolean",default:q.indentation,description:s.localize(446,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(447,null),s.localize(448,null),s.localize(449,null)],default:q.highlightActiveIndentation,description:s.localize(450,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{bracketPairs:Je(de.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Je(de.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(de.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(de.indentation,this.defaultValue.indentation),highlightActiveIndentation:Je(de.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Je(Y,q,de){const je=de.indexOf(Y);return je===-1?q:de[je]}class _e extends p{constructor(){const q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(ve.suggest,"suggest",q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(451,null),s.localize(452,null)],default:q.insertMode,description:s.localize(453,null)},"editor.suggest.filterGraceful":{type:"boolean",default:q.filterGraceful,description:s.localize(454,null)},"editor.suggest.localityBonus":{type:"boolean",default:q.localityBonus,description:s.localize(455,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:q.shareSuggestSelections,markdownDescription:s.localize(456,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(457,null),s.localize(458,null),s.localize(459,null),s.localize(460,null)],default:q.selectionMode,markdownDescription:s.localize(461,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:q.snippetsPreventQuickSuggestions,description:s.localize(462,null)},"editor.suggest.showIcons":{type:"boolean",default:q.showIcons,description:s.localize(463,null)},"editor.suggest.showStatusBar":{type:"boolean",default:q.showStatusBar,description:s.localize(464,null)},"editor.suggest.preview":{type:"boolean",default:q.preview,description:s.localize(465,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:q.showInlineDetails,description:s.localize(466,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(467,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(468,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(469,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(470,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(471,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(472,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(473,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(474,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(475,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(476,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(477,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(478,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(479,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(480,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(481,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(482,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(483,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(484,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(485,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(486,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(487,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(488,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(489,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(490,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(491,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(492,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(493,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(494,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(495,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(496,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(497,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(498,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{insertMode:h(de.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(de.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(de.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(de.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(de.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(de.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(de.showIcons,this.defaultValue.showIcons),showStatusBar:i(de.showStatusBar,this.defaultValue.showStatusBar),preview:i(de.preview,this.defaultValue.preview),previewMode:h(de.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(de.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(de.showMethods,this.defaultValue.showMethods),showFunctions:i(de.showFunctions,this.defaultValue.showFunctions),showConstructors:i(de.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(de.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(de.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(de.showFields,this.defaultValue.showFields),showVariables:i(de.showVariables,this.defaultValue.showVariables),showClasses:i(de.showClasses,this.defaultValue.showClasses),showStructs:i(de.showStructs,this.defaultValue.showStructs),showInterfaces:i(de.showInterfaces,this.defaultValue.showInterfaces),showModules:i(de.showModules,this.defaultValue.showModules),showProperties:i(de.showProperties,this.defaultValue.showProperties),showEvents:i(de.showEvents,this.defaultValue.showEvents),showOperators:i(de.showOperators,this.defaultValue.showOperators),showUnits:i(de.showUnits,this.defaultValue.showUnits),showValues:i(de.showValues,this.defaultValue.showValues),showConstants:i(de.showConstants,this.defaultValue.showConstants),showEnums:i(de.showEnums,this.defaultValue.showEnums),showEnumMembers:i(de.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(de.showKeywords,this.defaultValue.showKeywords),showWords:i(de.showWords,this.defaultValue.showWords),showColors:i(de.showColors,this.defaultValue.showColors),showFiles:i(de.showFiles,this.defaultValue.showFiles),showReferences:i(de.showReferences,this.defaultValue.showReferences),showFolders:i(de.showFolders,this.defaultValue.showFolders),showTypeParameters:i(de.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(de.showSnippets,this.defaultValue.showSnippets),showUsers:i(de.showUsers,this.defaultValue.showUsers),showIssues:i(de.showIssues,this.defaultValue.showIssues)}}}class tt extends p{constructor(){super(ve.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(499,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(500,null),default:!0,type:"boolean"}})}validate(q){return!q||typeof q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(q.selectSubwords,this.defaultValue.selectSubwords)}}}class ct extends p{constructor(){const q=[];super(ve.wordSegmenterLocales,"wordSegmenterLocales",q,{anyOf:[{description:s.localize(501,null),type:"string"},{description:s.localize(502,null),type:"array",items:{type:"string"}}]})}validate(q){if(typeof q=="string"&&(q=[q]),Array.isArray(q)){const de=[];for(const je of q)if(typeof je=="string")try{Intl.Segmenter.supportedLocalesOf(je).length>0&&de.push(je)}catch{}return de}return this.defaultValue}}var it;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(it||(e.WrappingIndent=it={}));class at extends p{constructor(){super(ve.wrappingIndent,"wrappingIndent",it.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(503,null),s.localize(504,null),s.localize(505,null),s.localize(506,null)],description:s.localize(507,null),default:"same"}})}validate(q){switch(q){case"none":return it.None;case"same":return it.Same;case"indent":return it.Indent;case"deepIndent":return it.DeepIndent}return it.Same}compute(q,de,je){return de.get(ve.accessibilitySupport)===I.AccessibilitySupport.Enabled?it.None:je}}class yt extends d{constructor(){super(ve.wrappingInfo)}compute(q,de,je){const Qe=de.get(ve.layoutInfo);return{isDominatedByLongLines:q.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class Ye extends p{constructor(){const q={enabled:!0,showDropSelector:"afterDrop"};super(ve.dropIntoEditor,"dropIntoEditor",q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:q.enabled,markdownDescription:s.localize(508,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(509,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(510,null),s.localize(511,null)],default:"afterDrop"}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),showDropSelector:h(de.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class he extends p{constructor(){const q={enabled:!0,showPasteSelector:"afterPaste"};super(ve.pasteAs,"pasteAs",q,{"editor.pasteAs.enabled":{type:"boolean",default:q.enabled,markdownDescription:s.localize(512,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(513,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(514,null),s.localize(515,null)],default:"afterPaste"}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),showPasteSelector:h(de.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const pe="Consolas, 'Courier New', monospace",ye="Menlo, Monaco, 'Courier New', monospace",Ce="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$m?ye:P.$n?Ce:pe,fontWeight:"normal",fontSize:P.$m?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function fe(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var ve;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.inlineEdit=63]="inlineEdit",Y[Y.letterSpacing=64]="letterSpacing",Y[Y.lightbulb=65]="lightbulb",Y[Y.lineDecorationsWidth=66]="lineDecorationsWidth",Y[Y.lineHeight=67]="lineHeight",Y[Y.lineNumbers=68]="lineNumbers",Y[Y.lineNumbersMinChars=69]="lineNumbersMinChars",Y[Y.linkedEditing=70]="linkedEditing",Y[Y.links=71]="links",Y[Y.matchBrackets=72]="matchBrackets",Y[Y.minimap=73]="minimap",Y[Y.mouseStyle=74]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=76]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=78]="multiCursorModifier",Y[Y.multiCursorPaste=79]="multiCursorPaste",Y[Y.multiCursorLimit=80]="multiCursorLimit",Y[Y.occurrencesHighlight=81]="occurrencesHighlight",Y[Y.overviewRulerBorder=82]="overviewRulerBorder",Y[Y.overviewRulerLanes=83]="overviewRulerLanes",Y[Y.padding=84]="padding",Y[Y.pasteAs=85]="pasteAs",Y[Y.parameterHints=86]="parameterHints",Y[Y.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Y[Y.placeholder=88]="placeholder",Y[Y.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=90]="quickSuggestions",Y[Y.quickSuggestionsDelay=91]="quickSuggestionsDelay",Y[Y.readOnly=92]="readOnly",Y[Y.readOnlyMessage=93]="readOnlyMessage",Y[Y.renameOnType=94]="renameOnType",Y[Y.renderControlCharacters=95]="renderControlCharacters",Y[Y.renderFinalNewline=96]="renderFinalNewline",Y[Y.renderLineHighlight=97]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=99]="renderValidationDecorations",Y[Y.renderWhitespace=100]="renderWhitespace",Y[Y.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",Y[Y.roundedSelection=102]="roundedSelection",Y[Y.rulers=103]="rulers",Y[Y.scrollbar=104]="scrollbar",Y[Y.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=106]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=107]="scrollPredominantAxis",Y[Y.selectionClipboard=108]="selectionClipboard",Y[Y.selectionHighlight=109]="selectionHighlight",Y[Y.selectOnLineNumbers=110]="selectOnLineNumbers",Y[Y.showFoldingControls=111]="showFoldingControls",Y[Y.showUnused=112]="showUnused",Y[Y.snippetSuggestions=113]="snippetSuggestions",Y[Y.smartSelect=114]="smartSelect",Y[Y.smoothScrolling=115]="smoothScrolling",Y[Y.stickyScroll=116]="stickyScroll",Y[Y.stickyTabStops=117]="stickyTabStops",Y[Y.stopRenderingLineAfter=118]="stopRenderingLineAfter",Y[Y.suggest=119]="suggest",Y[Y.suggestFontSize=120]="suggestFontSize",Y[Y.suggestLineHeight=121]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",Y[Y.suggestSelection=123]="suggestSelection",Y[Y.tabCompletion=124]="tabCompletion",Y[Y.tabIndex=125]="tabIndex",Y[Y.unicodeHighlighting=126]="unicodeHighlighting",Y[Y.unusualLineTerminators=127]="unusualLineTerminators",Y[Y.useShadowDOM=128]="useShadowDOM",Y[Y.useTabStops=129]="useTabStops",Y[Y.wordBreak=130]="wordBreak",Y[Y.wordSegmenterLocales=131]="wordSegmenterLocales",Y[Y.wordSeparators=132]="wordSeparators",Y[Y.wordWrap=133]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=136]="wordWrapColumn",Y[Y.wordWrapOverride1=137]="wordWrapOverride1",Y[Y.wordWrapOverride2=138]="wordWrapOverride2",Y[Y.wrappingIndent=139]="wrappingIndent",Y[Y.wrappingStrategy=140]="wrappingStrategy",Y[Y.showDeprecated=141]="showDeprecated",Y[Y.inlayHints=142]="inlayHints",Y[Y.editorClassName=143]="editorClassName",Y[Y.pixelRatio=144]="pixelRatio",Y[Y.tabFocusMode=145]="tabFocusMode",Y[Y.layoutInfo=146]="layoutInfo",Y[Y.wrappingInfo=147]="wrappingInfo",Y[Y.defaultColorDecorators=148]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(ve||(e.EditorOption=ve={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:fe(new n(ve.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(516,null)})),acceptSuggestionOnEnter:fe(new S(ve.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(517,null),""],markdownDescription:s.localize(518,null)})),accessibilitySupport:fe(new C),accessibilityPageSize:fe(new o(ve.accessibilityPageSize,"accessibilityPageSize",10,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(519,null),tags:["accessibility"]})),ariaLabel:fe(new f(ve.ariaLabel,"ariaLabel",s.localize(520,null))),ariaRequired:fe(new n(ve.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:fe(new n(ve.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(521,null),tags:["accessibility"]})),autoClosingBrackets:fe(new S(ve.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(522,null),s.localize(523,null),""],description:s.localize(524,null)})),autoClosingComments:fe(new S(ve.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(525,null),s.localize(526,null),""],description:s.localize(527,null)})),autoClosingDelete:fe(new S(ve.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(528,null),""],description:s.localize(529,null)})),autoClosingOvertype:fe(new S(ve.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(530,null),""],description:s.localize(531,null)})),autoClosingQuotes:fe(new S(ve.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(532,null),s.localize(533,null),""],description:s.localize(534,null)})),autoIndent:fe(new k(ve.autoIndent,"autoIndent",w.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[s.localize(535,null),s.localize(536,null),s.localize(537,null),s.localize(538,null),s.localize(539,null)],description:s.localize(540,null)})),automaticLayout:fe(new n(ve.automaticLayout,"automaticLayout",!1)),autoSurround:fe(new S(ve.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(541,null),s.localize(542,null),s.localize(543,null),""],description:s.localize(544,null)})),bracketPairColorization:fe(new Ee),bracketPairGuides:fe(new ze),stickyTabStops:fe(new n(ve.stickyTabStops,"stickyTabStops",!1,{description:s.localize(545,null)})),codeLens:fe(new n(ve.codeLens,"codeLens",!0,{description:s.localize(546,null)})),codeLensFontFamily:fe(new f(ve.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(547,null)})),codeLensFontSize:fe(new o(ve.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(548,null)})),colorDecorators:fe(new n(ve.colorDecorators,"colorDecorators",!0,{description:s.localize(549,null)})),colorDecoratorActivatedOn:fe(new S(ve.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(550,null),s.localize(551,null),s.localize(552,null)],description:s.localize(553,null)})),colorDecoratorsLimit:fe(new o(ve.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(554,null)})),columnSelection:fe(new n(ve.columnSelection,"columnSelection",!1,{description:s.localize(555,null)})),comments:fe(new T),contextmenu:fe(new n(ve.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:fe(new n(ve.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(556,null)})),cursorBlinking:fe(new k(ve.cursorBlinking,"cursorBlinking",$.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:s.localize(557,null)})),cursorSmoothCaretAnimation:fe(new S(ve.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(558,null),s.localize(559,null),s.localize(560,null)],description:s.localize(561,null)})),cursorStyle:fe(new k(ve.cursorStyle,"cursorStyle",N.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:s.localize(562,null)})),cursorSurroundingLines:fe(new o(ve.cursorSurroundingLines,"cursorSurroundingLines",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(563,null)})),cursorSurroundingLinesStyle:fe(new S(ve.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(564,null),s.localize(565,null)],markdownDescription:s.localize(566,null)})),cursorWidth:fe(new o(ve.cursorWidth,"cursorWidth",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(567,null)})),disableLayerHinting:fe(new n(ve.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:fe(new n(ve.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:fe(new n(ve.domReadOnly,"domReadOnly",!1)),dragAndDrop:fe(new n(ve.dragAndDrop,"dragAndDrop",!0,{description:s.localize(568,null)})),emptySelectionClipboard:fe(new x),dropIntoEditor:fe(new Ye),stickyScroll:fe(new V),experimentalWhitespaceRendering:fe(new S(ve.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(569,null),s.localize(570,null),s.localize(571,null)],description:s.localize(572,null)})),extraEditorClassName:fe(new f(ve.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:fe(new g(ve.fastScrollSensitivity,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:s.localize(573,null)})),find:fe(new j),fixedOverflowWidgets:fe(new n(ve.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:fe(new n(ve.folding,"folding",!0,{description:s.localize(574,null)})),foldingStrategy:fe(new S(ve.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(575,null),s.localize(576,null)],description:s.localize(577,null)})),foldingHighlight:fe(new n(ve.foldingHighlight,"foldingHighlight",!0,{description:s.localize(578,null)})),foldingImportsByDefault:fe(new n(ve.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(579,null)})),foldingMaximumRegions:fe(new o(ve.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(580,null)})),unfoldOnClickAfterEndOfLine:fe(new n(ve.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(581,null)})),fontFamily:fe(new f(ve.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(582,null)})),fontInfo:fe(new Z),fontLigatures2:fe(new U),fontSize:fe(new ae),fontWeight:fe(new ee),fontVariations:fe(new J),formatOnPaste:fe(new n(ve.formatOnPaste,"formatOnPaste",!1,{description:s.localize(583,null)})),formatOnType:fe(new n(ve.formatOnType,"formatOnType",!1,{description:s.localize(584,null)})),glyphMargin:fe(new n(ve.glyphMargin,"glyphMargin",!0,{description:s.localize(585,null)})),gotoLocation:fe(new oe),hideCursorInOverviewRuler:fe(new n(ve.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(586,null)})),hover:fe(new ie),inDiffEditor:fe(new n(ve.inDiffEditor,"inDiffEditor",!1)),letterSpacing:fe(new g(ve.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>g.clamp(Y,-5,20),{description:s.localize(587,null)})),lightbulb:fe(new X),lineDecorationsWidth:fe(new be),lineHeight:fe(new Pe),lineNumbers:fe(new Le),lineNumbersMinChars:fe(new o(ve.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:fe(new n(ve.linkedEditing,"linkedEditing",!1,{description:s.localize(588,null)})),links:fe(new n(ve.links,"links",!0,{description:s.localize(589,null)})),matchBrackets:fe(new S(ve.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(590,null)})),minimap:fe(new Fe),mouseStyle:fe(new S(ve.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:fe(new g(ve.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:s.localize(591,null)})),mouseWheelZoom:fe(new n(ve.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$m?s.localize(592,null):s.localize(593,null)})),multiCursorMergeOverlapping:fe(new n(ve.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(594,null)})),multiCursorModifier:fe(new k(ve.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Be,{markdownEnumDescriptions:[s.localize(595,null),s.localize(596,null)],markdownDescription:s.localize(597,null)})),multiCursorPaste:fe(new S(ve.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(598,null),s.localize(599,null)],markdownDescription:s.localize(600,null)})),multiCursorLimit:fe(new o(ve.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(601,null)})),occurrencesHighlight:fe(new S(ve.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(602,null),s.localize(603,null),s.localize(604,null)],markdownDescription:s.localize(605,null)})),overviewRulerBorder:fe(new n(ve.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(606,null)})),overviewRulerLanes:fe(new o(ve.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:fe(new xe),pasteAs:fe(new he),parameterHints:fe(new nt),peekWidgetDefaultFocus:fe(new S(ve.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(607,null),s.localize(608,null)],description:s.localize(609,null)})),placeholder:fe(new $t),definitionLinkOpensInPeek:fe(new n(ve.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(610,null)})),quickSuggestions:fe(new ut),quickSuggestionsDelay:fe(new o(ve.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(611,null)})),readOnly:fe(new n(ve.readOnly,"readOnly",!1)),readOnlyMessage:fe(new W),renameOnType:fe(new n(ve.renameOnType,"renameOnType",!1,{description:s.localize(612,null),markdownDeprecationMessage:s.localize(613,null)})),renderControlCharacters:fe(new n(ve.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(614,null),restricted:!0})),renderFinalNewline:fe(new S(ve.renderFinalNewline,"renderFinalNewline",P.$n?"dimmed":"on",["off","on","dimmed"],{description:s.localize(615,null)})),renderLineHighlight:fe(new S(ve.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(616,null)],description:s.localize(617,null)})),renderLineHighlightOnlyWhenFocus:fe(new n(ve.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(618,null)})),renderValidationDecorations:fe(new S(ve.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:fe(new S(ve.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(619,null),s.localize(620,null),s.localize(621,null),""],description:s.localize(622,null)})),revealHorizontalRightPadding:fe(new o(ve.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:fe(new n(ve.roundedSelection,"roundedSelection",!0,{description:s.localize(623,null)})),rulers:fe(new Ne),scrollbar:fe(new Q),scrollBeyondLastColumn:fe(new o(ve.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(624,null)})),scrollBeyondLastLine:fe(new n(ve.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(625,null)})),scrollPredominantAxis:fe(new n(ve.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(626,null)})),selectionClipboard:fe(new n(ve.selectionClipboard,"selectionClipboard",!0,{description:s.localize(627,null),included:P.$n})),selectionHighlight:fe(new n(ve.selectionHighlight,"selectionHighlight",!0,{description:s.localize(628,null)})),selectOnLineNumbers:fe(new n(ve.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:fe(new S(ve.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(629,null),s.localize(630,null),s.localize(631,null)],description:s.localize(632,null)})),showUnused:fe(new n(ve.showUnused,"showUnused",!0,{description:s.localize(633,null)})),showDeprecated:fe(new n(ve.showDeprecated,"showDeprecated",!0,{description:s.localize(634,null)})),inlayHints:fe(new re),snippetSuggestions:fe(new S(ve.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(635,null),s.localize(636,null),s.localize(637,null),s.localize(638,null)],description:s.localize(639,null)})),smartSelect:fe(new tt),smoothScrolling:fe(new n(ve.smoothScrolling,"smoothScrolling",!1,{description:s.localize(640,null)})),stopRenderingLineAfter:fe(new o(ve.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:fe(new _e),inlineSuggest:fe(new se),inlineEdit:fe(new ge),inlineCompletionsAccessibilityVerbose:fe(new n(ve.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(641,null)})),suggestFontSize:fe(new o(ve.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(642,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:fe(new o(ve.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(643,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:fe(new n(ve.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(644,null)})),suggestSelection:fe(new S(ve.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(645,null),s.localize(646,null),s.localize(647,null)],description:s.localize(648,null)})),tabCompletion:fe(new S(ve.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(649,null),s.localize(650,null),s.localize(651,null)],description:s.localize(652,null)})),tabIndex:fe(new o(ve.tabIndex,"tabIndex",0,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:fe(new H),unusualLineTerminators:fe(new S(ve.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(653,null),s.localize(654,null),s.localize(655,null)],description:s.localize(656,null)})),useShadowDOM:fe(new n(ve.useShadowDOM,"useShadowDOM",!0)),useTabStops:fe(new n(ve.useTabStops,"useTabStops",!0,{description:s.localize(657,null)})),wordBreak:fe(new S(ve.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(658,null),s.localize(659,null)],description:s.localize(660,null)})),wordSegmenterLocales:fe(new ct),wordSeparators:fe(new f(ve.wordSeparators,"wordSeparators",m.$ut,{description:s.localize(661,null)})),wordWrap:fe(new S(ve.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(662,null),s.localize(663,null),s.localize(664,null),s.localize(665,null)],description:s.localize(666,null)})),wordWrapBreakAfterCharacters:fe(new f(ve.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:fe(new f(ve.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:fe(new o(ve.wordWrapColumn,"wordWrapColumn",80,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(667,null)})),wordWrapOverride1:fe(new S(ve.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:fe(new S(ve.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:fe(new G),defaultColorDecorators:fe(new n(ve.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(668,null)})),pixelRatio:fe(new ht),tabFocusMode:fe(new n(ve.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(669,null)})),layoutInfo:fe(new _),wrappingInfo:fe(new yt),wrappingIndent:fe(new at),wrappingStrategy:fe(new $e)}}),define(Re[107],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=void 0,e.$Ri=(0,v.$Ki)("environmentService"),e.$Si=(0,v.$Li)(e.$Ri)}),define(Re[28],Te([1,0,48,22,13,14,2,9,3,23,15,51]),function(we,e,v,D,P,L,R,O,m,s,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Kl=e.FileKind=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.FileOperationResult=e.$Cl=e.$Bl=e.$Al=e.$yl=e.FileChangeType=e.$xl=e.FileOperation=e.$rl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$fl=void 0,e.$gl=u,e.$hl=l,e.$il=a,e.$jl=i,e.$kl=n,e.$ll=t,e.$ml=o,e.$nl=c,e.$ol=g,e.$pl=f,e.$ql=h,e.$sl=y,e.$tl=C,e.$ul=T,e.$vl=$,e.$wl=b,e.$zl=x,e.$Ll=ee,e.$Ml=oe,e.$Ol=ue,e.$fl=(0,m.$Ki)("fileService");function u(_){return _.create===!0}var E;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var p;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var r;(function(_){_[_.UPDATED=2]="UPDATED",_[_.ADDED=4]="ADDED",_[_.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function l(_){const $e=_;return!!$e&&typeof $e.onDidChange=="function"}var d;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function a(_){return!!(_.capabilities&d.FileReadWrite)}function i(_){return!!(_.capabilities&d.FileFolderCopy)}function n(_){return!!(_.capabilities&d.FileClone)}function t(_){return!!(_.capabilities&d.FileOpenReadWriteClose)}function o(_){return!!(_.capabilities&d.FileReadStream)}function c(_){return a(_)?!!(_.capabilities&d.FileAtomicRead):!1}function g(_){return a(_)?!!(_.capabilities&d.FileAtomicWrite):!1}function f(_){return!!(_.capabilities&d.FileAtomicDelete)}function h(_){return!!(_.capabilities&d.Readonly)}var S;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class k extends Error{static create($e,Ie){const X=new k($e.toString(),Ie);return T(X,Ie),X}constructor($e,Ie){super($e),this.code=Ie}}e.$rl=k;function y(_,$e){return k.create(_,$e)}function C(_){return _||y((0,O.localize)(1865,null),S.Unknown)}function T(_,$e){return _.name=$e?`${$e} (FileSystemError)`:"FileSystemError",_}function $(_){if(!_)return S.Unknown;if(_ instanceof k)return _.code;const $e=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!$e)return S.Unknown;switch($e[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function b(_){if(_ instanceof j)return _.fileOperationResult;switch($(_)){case S.FileNotFound:return Z.FILE_NOT_FOUND;case S.FileIsADirectory:return Z.FILE_IS_DIRECTORY;case S.FileNotADirectory:return Z.FILE_NOT_DIRECTORY;case S.FileWriteLocked:return Z.FILE_WRITE_LOCKED;case S.NoPermissions:return Z.FILE_PERMISSION_DENIED;case S.FileExists:return Z.FILE_MOVE_CONFLICT;case S.FileTooLarge:return Z.FILE_TOO_LARGE;default:return Z.FILE_OTHER_ERROR}}var N;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class A{constructor($e,Ie,X){this.resource=$e,this.operation=Ie,this.target=X}isOperation($e){return this.operation===$e}}e.$xl=A;var F;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class G{static{this.a=null}constructor($e,Ie){this.c=Ie,this.b=void 0,this.d=new w.$Y(()=>{const X=v.$Qi.forUris(()=>this.c);return X.fill(this.rawAdded.map(V=>[V,!0])),X}),this.f=new w.$Y(()=>{const X=v.$Qi.forUris(()=>this.c);return X.fill(this.rawUpdated.map(V=>[V,!0])),X}),this.g=new w.$Y(()=>{const X=v.$Qi.forUris(()=>this.c);return X.fill(this.rawDeleted.map(V=>[V,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of $e){switch(X.type){case F.ADDED:this.rawAdded.push(X.resource);break;case F.UPDATED:this.rawUpdated.push(X.resource);break;case F.DELETED:this.rawDeleted.push(X.resource);break}this.b!==G.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains($e,...Ie){return this.h($e,{includeChildren:!1},...Ie)}affects($e,...Ie){return this.h($e,{includeChildren:!0},...Ie)}h($e,Ie,...X){if(!$e)return!1;const V=X.length>0;return!!((!V||X.includes(F.ADDED))&&(this.d.value.get($e)||Ie.includeChildren&&this.d.value.findSuperstr($e))||(!V||X.includes(F.UPDATED))&&(this.f.value.get($e)||Ie.includeChildren&&this.f.value.findSuperstr($e))||(!V||X.includes(F.DELETED))&&(this.g.value.findSubstr($e)||Ie.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$yl=G;function x(_,$e,Ie){return!_||!$e||_===$e||$e.length>_.length?!1:($e.charAt($e.length-1)!==D.sep&&($e+=D.sep),Ie?(0,P.$Lf)(_,$e):_.indexOf($e)===0)}class j extends Error{constructor($e,Ie,X){super($e),this.fileOperationResult=Ie,this.options=X}}e.$Al=j;class U extends j{constructor($e,Ie,X,V){super($e,Ie,V),this.fileOperationResult=Ie,this.size=X}}e.$Bl=U;class J extends j{constructor($e,Ie,X){super($e,Z.FILE_NOT_MODIFIED_SINCE,X),this.stat=Ie}}e.$Cl=J;var Z;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$Dl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$El={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Fl="files.associations",e.$Gl="files.exclude",e.$Hl="files.readonlyInclude",e.$Il="files.readonlyExclude",e.$Jl="files.readonlyFromPermissions";var ae;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae||(e.FileKind=ae={})),e.$Kl="";function ee(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}async function oe(_,$e){if(!$e.hasProvider(R.URI.from({scheme:_.scheme})))return new Promise(Ie=>{const X=$e.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===_.scheme&&V.added&&(X.dispose(),Ie())})})}class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize($e){return(0,L.$ng)($e)||($e=0),$e<ie.KB?(0,O.localize)(1866,null,$e.toFixed(0)):$e<ie.MB?(0,O.localize)(1867,null,($e/ie.KB).toFixed(2)):$e<ie.GB?(0,O.localize)(1868,null,($e/ie.MB).toFixed(2)):$e<ie.TB?(0,O.localize)(1869,null,($e/ie.GB).toFixed(2)):(0,O.localize)(1870,null,($e/ie.TB).toFixed(2))}}e.$Nl=ie;function ue(_){const $e=typeof _=="string"||_?.scheme===I.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===I.Schemas.file?1024*ie.MB:$e?10*ie.MB:s.$r?50*ie.MB:1024*ie.MB}}),define(Re[75],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=void 0;class v{constructor(...P){this.a=new Map;for(const[L,R]of P)this.set(L,R)}set(P,L){const R=this.a.get(P);return this.a.set(P,L),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Ii=v}),define(Re[170],Te([1,0,10,12,4,74,167,3,75,171]),function(we,e,v,D,P,L,R,O,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=void 0;const I=!1;class w extends Error{constructor(l){super("cyclic dependency between services"),this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class u{constructor(l=new m.$Ii,d=!1,a,i=I){this.i=l,this.j=d,this.k=a,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Ji,this),this._globalGraph=i?a?._globalGraph??new R.$Dr(n=>n):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Uc)(this.h),this.h.clear();for(const l of this.g)(0,P.$Tc)(l)&&l.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(l,d){this.m();const a=this,i=new class extends u{dispose(){a.h.delete(i),super.dispose()}}(l,this.j,this,this.l);return this.h.add(i),d?.add(i),i}invokeFunction(l,...d){this.m();const a=p.traceInvocation(this.l,l);let i=!1;try{return l({get:t=>{if(i)throw(0,D.$_)("service accessor is only valid during the invocation of its target method");const o=this.s(t,a);if(!o)throw new Error(`[invokeFunction] unknown service '${t}'`);return o}},...d)}finally{i=!0,a.stop()}}createInstance(l,...d){this.m();let a,i;return l instanceof L.$Hi?(a=p.traceCreation(this.l,l.ctor),i=this.o(l.ctor,l.staticArguments.concat(d),a)):(a=p.traceCreation(this.l,l),i=this.o(l,d,a)),a.stop(),i}o(l,d=[],a){const i=O._util.getServiceDependencies(l).sort((o,c)=>o.index-c.index),n=[];for(const o of i){const c=this.s(o.id,a);c||this.y(`[createInstance] ${l.name} depends on UNKNOWN service ${o.id}.`,!1),n.push(c)}const t=i.length>0?i[0].index:d.length;if(d.length!==t){console.trace(`[createInstance] First service dependency of ${l.name} at position ${t+1} conflicts with ${d.length} static arguments`);const o=t-d.length;o>0?d=d.concat(new Array(o)):d=d.slice(0,t)}return Reflect.construct(l,d.concat(n))}q(l,d){if(this.i.get(l)instanceof L.$Hi)this.i.set(l,d);else if(this.k)this.k.q(l,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(l){const d=this.i.get(l);return!d&&this.k?this.k.r(l):d}s(l,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(l));const a=this.r(l);return a instanceof L.$Hi?this.u(l,a,d.branch(l,!0)):(d.branch(l,!1),a)}u(l,d,a){if(this.t.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this.t.add(l);try{return this.v(l,d,a)}finally{this.t.delete(l)}}v(l,d,a){const i=new R.$Dr(c=>c.id.toString());let n=0;const t=[{id:l,desc:d,_trace:a}],o=new Set;for(;t.length;){const c=t.pop();if(!o.has(String(c.id))){if(o.add(String(c.id)),i.lookupOrInsertNode(c),n++>1e3)throw new w(i);for(const g of O._util.getServiceDependencies(c.desc.ctor)){const f=this.r(g.id);if(f||this.y(`[createInstance] ${l} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(c.id),String(g.id)),f instanceof L.$Hi){const h={id:g.id,desc:f,_trace:c._trace.branch(g.id,!0)};i.insertEdge(c,h),t.push(h)}}}}for(;;){const c=i.roots();if(c.length===0){if(!i.isEmpty())throw new w(i);break}for(const{data:g}of c){if(this.r(g.id)instanceof L.$Hi){const h=this.w(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this.q(g.id,h)}i.removeNode(g)}}return this.r(l)}w(l,d,a=[],i,n){if(this.i.get(l)instanceof L.$Hi)return this.x(l,d,a,i,n,this.g);if(this.k)return this.k.w(l,d,a,i,n);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(l,d,a=[],i,n,t){if(i){const o=new u(void 0,this.j,this,this.l);o.c=String(l);const c=new Map,g=new v.$4h(()=>{const f=o.o(d,a,n);for(const[h,S]of c){const k=f[h];if(typeof k=="function")for(const y of S)y.disposable=k.apply(f,y.listener)}return c.clear(),t.add(f),f});return new Proxy(Object.create(null),{get(f,h){if(!g.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let y=c.get(h);return y||(y=new s.$0c,c.set(h,y)),(T,$,b)=>{if(g.isInitialized)return g.value[h](T,$,b);{const N={listener:[T,$,b],disposable:void 0},A=y.push(N);return(0,P.$Xc)(()=>{A(),N.disposable?.dispose()})}}}if(h in f)return f[h];const S=g.value;let k=S[h];return typeof k!="function"||(k=k.bind(S),f[h]=k),k},set(f,h,S){return g.value[h]=S,!0},getPrototypeOf(f){return d.prototype}})}else{const o=this.o(d,a,n);return t.add(o),o}}y(l,d){if(d&&console.warn(l),this.j)throw new Error(l)}}e.$Er=u;var E;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(E||(E={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(E.None,null)}stop(){}branch(){return this}}}static traceInvocation(l,d){return l?new p(E.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(l,d){return l?new p(E.Creation,d.name):p.c}static{this.f=0}constructor(l,d){this.type=l,this.name=d,this.g=Date.now(),this.h=[]}branch(l,d){const a=new p(E.Branch,l.toString());return this.h.push([l,d,a]),a}stop(){const l=Date.now()-this.g;p.f+=l;let d=!1;function a(n,t){const o=[],c=new Array(n+1).join("	");for(const[g,f,h]of t.h)if(f&&h){d=!0,o.push(`${c}CREATES -> ${g}`);const S=a(n+1,h);S&&o.push(S)}else o.push(`${c}uses -> ${g}`);return o.join(`
`)}const i=[`${this.type===E.Creation?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(l>2||d)&&p.all.add(i.join(`
`))}}e.$Fr=p}),define(Re[11],Te([1,0,9,42,6,76,4,27,23,24,14,2,31,3]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$ik=e.LogLevel=e.$gk=e.$fk=void 0,e.$hk=r,e.log=d,e.$tk=k,e.$uk=y,e.$vk=C,e.$wk=T,v=Ve(v),e.$fk=(0,E.$Ki)("logService"),e.$gk=(0,E.$Ki)("loggerService");function p(){return new Date().toISOString()}function r($){return(0,I.$ng)($)}var l;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(l||(e.LogLevel=l={})),e.$ik=l.Info;function d($,b,N){switch(b){case l.Trace:$.trace(N);break;case l.Debug:$.debug(N);break;case l.Info:$.info(N);break;case l.Warning:$.warn(N);break;case l.Error:$.error(N);break;case l.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function a($,b=!1){let N="";for(let A=0;A<$.length;A++){let F=$[A];if(F instanceof Error&&(F=(0,D.$vj)(F,b)),typeof F=="object")try{F=JSON.stringify(F)}catch{}N+=(A>0?" ":"")+F}return N}class i extends R.$Zc{constructor(){super(...arguments),this.b=e.$ik,this.c=this.B(new P.$qe),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==l.Off&&this.b<=b}}e.$kk=i;class n extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...N){this.f(l.Trace)&&this.g(l.Trace,a([b,...N],!0))}debug(b,...N){this.f(l.Debug)&&this.g(l.Debug,a([b,...N]))}info(b,...N){this.f(l.Info)&&this.g(l.Info,a([b,...N]))}warn(b,...N){this.f(l.Warning)&&this.g(l.Warning,a([b,...N]))}error(b,...N){if(this.f(l.Error))if(b instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=b.stack,this.g(l.Error,a(A))}else this.g(l.Error,a([b,...N]))}flush(){}}e.$lk=n;class t extends i{constructor(b=e.$ik){super(),this.setLevel(b),this.g=!m.$l}trace(b,...N){this.f(l.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,b,...N):console.log(`[main ${p()}]`,b,...N))}debug(b,...N){this.f(l.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,b,...N):console.log(`[main ${p()}]`,b,...N))}info(b,...N){this.f(l.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,b,...N):console.log(`[main ${p()}]`,b,...N))}warn(b,...N){this.f(l.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,b,...N):console.warn(`[main ${p()}]`,b,...N))}error(b,...N){this.f(l.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,b,...N):console.error(`[main ${p()}]`,b,...N))}flush(){}}e.$mk=t;class o extends i{constructor(b=e.$ik,N=!0){super(),this.g=N,this.setLevel(b)}trace(b,...N){this.f(l.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...N):console.log(b,...N))}debug(b,...N){this.f(l.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...N):console.log(b,...N))}info(b,...N){this.f(l.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...N):console.log(b,...N))}warn(b,...N){this.f(l.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...N):console.log(b,...N))}error(b,...N){this.f(l.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...N):console.error(b,...N))}flush(){}}e.$nk=o;class c extends i{constructor(b,N=e.$ik){super(),this.g=b,this.setLevel(N)}trace(b,...N){this.f(l.Trace)&&this.g.log(l.Trace,[this.h(b),...N])}debug(b,...N){this.f(l.Debug)&&this.g.log(l.Debug,[this.h(b),...N])}info(b,...N){this.f(l.Info)&&this.g.log(l.Info,[this.h(b),...N])}warn(b,...N){this.f(l.Warning)&&this.g.log(l.Warning,[this.h(b),...N])}error(b,...N){this.f(l.Error)&&this.g.log(l.Error,[this.h(b),...N])}h(b){return typeof b=="string"?b:(0,D.$vj)(b,this.f(l.Trace))}flush(){}}e.$ok=c;class g extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const N of this.g)N.setLevel(b);super.setLevel(b)}trace(b,...N){for(const A of this.g)A.trace(b,...N)}debug(b,...N){for(const A of this.g)A.debug(b,...N)}info(b,...N){for(const A of this.g)A.info(b,...N)}warn(b,...N){for(const A of this.g)A.warn(b,...N)}error(b,...N){for(const A of this.g)A.error(b,...N)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$pk=g;class f extends R.$Zc{constructor(b,N,A){if(super(),this.h=b,this.j=N,this.b=new O.$Fc,this.c=this.B(new P.$qe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$qe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$qe),this.onDidChangeVisibility=this.g.event,A)for(const F of A)this.b.set(F.resource,{logger:void 0,info:F})}m(b){return(0,I.$jg)(b)?[...this.b.values()].find(N=>N.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,N){const A=this.n(b),F=(0,I.$jg)(b)?b:N?.id??(0,L.$yj)(A.toString()).toString(16);let G=this.b.get(A)?.logger;const x=N?.logLevel==="always"?l.Trace:N?.logLevel;G||(G=this.s(A,x??this.getLogLevel(A)??this.h,{...N,id:F}));const j={logger:G,info:{resource:A,id:F,logLevel:x,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(j.info),this.b.set(A,j),G}n(b){return(0,I.$jg)(b)?(0,s.$lh)(this.j,`${b}.log`):b}setLogLevel(b,N){if(w.URI.isUri(b)){const A=b,F=N,G=this.b.get(A);G&&F!==G.info.logLevel&&(G.info.logLevel=F===this.h?void 0:F,G.logger?.setLevel(F),this.b.set(G.info.resource,G),this.f.fire([A,F]))}else{this.h=b;for(const[A,F]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,N){const A=this.m(b);A&&N!==!A.info.hidden&&(A.info.hidden=!N,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,N]))}getLogLevel(b){let N;return b&&(N=this.b.get(b)?.info.logLevel),N??this.h}registerLogger(b){const N=this.b.get(b.resource);N?N.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const N=this.b.get(b);N&&(N.logger&&N.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$qk=f;class h{constructor(){this.onDidChangeLogLevel=new P.$qe().event}setLevel(b){}getLevel(){return l.Info}trace(b,...N){}debug(b,...N){}info(b,...N){}warn(b,...N){}error(b,...N){}critical(b,...N){}dispose(){}flush(){}}e.$rk=h;class S extends h{}e.$sk=S;function k($){if($.verbose)return l.Trace;if(typeof $.logLevel=="string"){const b=T($.logLevel.toLowerCase());if(b!==void 0)return b}return e.$ik}function y($){switch($){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}function C($){switch($){case l.Trace:return{original:"Trace",value:v.localize(1959,null)};case l.Debug:return{original:"Debug",value:v.localize(1960,null)};case l.Info:return{original:"Info",value:v.localize(1961,null)};case l.Warning:return{original:"Warning",value:v.localize(1962,null)};case l.Error:return{original:"Error",value:v.localize(1963,null)};case l.Off:return{original:"Off",value:v.localize(1964,null)}}}function T($){switch($){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.$xk=new u.$2j("logLevel",y(l.Info))}),define(Re[172],Te([1,0,4,11]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$R=void 0;class P extends v.$Zc{constructor(R,O=[]){super(),this.a=new D.$pk([R,...O]),this.B(R.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...O){this.a.trace(R,...O)}debug(R,...O){this.a.debug(R,...O)}info(R,...O){this.a.info(R,...O)}warn(R,...O){this.a.warn(R,...O)}error(R,...O){this.a.error(R,...O)}flush(){this.a.flush()}}e.$$R=P});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[108],Te([1,0,37,9,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ou=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=oi(v);var L;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(m){function s(p,r){return r-p}m.compare=s;const I=Object.create(null);I[m.Error]=(0,D.localize)(1965,null),I[m.Warning]=(0,D.localize)(1966,null),I[m.Info]=(0,D.localize)(1967,null);function w(p){return I[p]||""}m.toString=w;function u(p){switch(p){case v.default.Error:return m.Error;case v.default.Warning:return m.Warning;case v.default.Info:return m.Info;case v.default.Ignore:return m.Hint}}m.fromSeverity=u;function E(p){switch(p){case m.Error:return v.default.Error;case m.Warning:return v.default.Warning;case m.Info:return v.default.Info;case m.Hint:return v.default.Ignore}}m.toSeverity=E}(R||(e.MarkerSeverity=R={}));var O;(function(m){const s="";function I(u){return w(u,!0)}m.makeKey=I;function w(u,E){const p=[s];return u.source?p.push(u.source.replace("\xA6","\\\xA6")):p.push(s),u.code?typeof u.code=="string"?p.push(u.code.replace("\xA6","\\\xA6")):p.push(u.code.value.replace("\xA6","\\\xA6")):p.push(s),u.severity!==void 0&&u.severity!==null?p.push(R.toString(u.severity)):p.push(s),u.message&&E?p.push(u.message.replace("\xA6","\\\xA6")):p.push(s),u.startLineNumber!==void 0&&u.startLineNumber!==null?p.push(u.startLineNumber.toString()):p.push(s),u.startColumn!==void 0&&u.startColumn!==null?p.push(u.startColumn.toString()):p.push(s),u.endLineNumber!==void 0&&u.endLineNumber!==null?p.push(u.endLineNumber.toString()):p.push(s),u.endColumn!==void 0&&u.endColumn!==null?p.push(u.endColumn.toString()):p.push(s),p.push(s),p.join("\xA6")}m.makeKeyOptionalMessage=w})(O||(e.IMarkerData=O={})),e.$Ou=(0,P.$Ki)("markerService")});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[173],Te([1,0,6,37,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fw=e.$Ew=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Cw=e.Severity=void 0,e.$Dw=O,D=oi(D),e.Severity=D.default,e.$Cw=(0,P.$Ki)("notificationService");var L;(function(w){w[w.DEFAULT=0]="DEFAULT",w[w.SILENT=1]="SILENT",w[w.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(w){w[w.WORKSPACE=0]="WORKSPACE",w[w.PROFILE=1]="PROFILE",w[w.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function O(w){if(w){const u=w;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var m;(function(w){w[w.OFF=0]="OFF",w[w.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class s{constructor(){this.progress=new I,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Ew=s;class I{infinite(){}done(){}total(u){}worked(u){}}e.$Fw=I}),define(Re[109],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=void 0,e.$yk=(0,v.$Ki)("productService"),e.$zk="vscode://schemas/vscode-product"});var He=this&&this.__decorate||function(we,e,v,D){var P=arguments.length,L=P<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,v):D,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(we,e,v,D);else for(var O=we.length-1;O>=0;O--)(R=we[O])&&(L=(P<3?R(L):P>3?R(e,v,L):R(e,v))||L);return P>3&&L&&Object.defineProperty(e,v,L),L},qe=this&&this.__param||function(we,e){return function(v,D){e(v,D,we)}};define(Re[77],Te([1,0,10,19,4,3]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=e.$Lw=e.$Kw=e.$Jw=e.$Iw=e.$Hw=e.ProgressLocation=e.$Gw=void 0,e.$Gw=(0,L.$Ki)("progressService");var R;(function(w){w[w.Explorer=1]="Explorer",w[w.Scm=3]="Scm",w[w.Extensions=5]="Extensions",w[w.Window=10]="Window",w[w.Notification=15]="Notification",w[w.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Hw=Object.freeze({total(){},worked(){},done(){}});class O{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Iw=O;class m{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const E=this.d;this.d=()=>{E?.(),u()}}):Promise.resolve()}}e.$Jw=m;let s=class extends P.$Zc{constructor(u,E){super(),this.a=new v.$8h,E.withProgress(u,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,P.$Xc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$Kw=s,e.$Kw=s=He([qe(1,e.$Gw)],s);class I extends P.$Zc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new P.$Yc)}start(u){this.stop();const E=++this.a,p=new D.$Be;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,P.$Xc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Xc)(()=>p.cancel())),this.b.add((0,P.$Xc)(()=>this.c?this.c.done():void 0)),{id:E,token:p.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Lw=I,e.$Mw=(0,L.$Ki)("editorProgressService")}),define(Re[29],Te([1,0,61,14]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=void 0,v=Ve(v),D=Ve(D);class P{constructor(){this.a=new Map}add(R,O){v.ok(D.$jg(R)),v.ok(D.$lg(O)),v.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,O)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$xo=new P}),define(Re[78],Te([1,0,6,138,29]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=void 0,P=Ve(P),e.$yo={JSONContribution:"base.contributions.json"};function L(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class R{constructor(){this.b=new v.$qe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(s,I){this.a[L(s)]=I,this.b.fire(s)}notifySchemaChanged(s){this.b.fire(s)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(s){const I=this.a[s];return I?(0,D.$ak)(I):void 0}hasSchemaContent(s){return!!this.a[s]}}const O=new R;P.$xo.add(e.$yo.JSONContribution,O)}),define(Re[53],Te([1,0,17,6,14,9,44,78,29]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ConfigurationScope=e.$Co=e.EditPresentationTypes=void 0,e.$No=r,e.$Oo=l,e.$Po=d,e.$Qo=i,e.$Ro=n,e.$So=t,e.$To=o,P=Ve(P),L=Ve(L);var s;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.$Co={Configuration:"base.contributions.configuration"};var I;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho={properties:{},patternProperties:{}},e.$Io={properties:{},patternProperties:{}},e.$Jo="vscode://schemas/settings/resourceLanguage",e.$Ko="vscode://schemas/settings/configurationDefaults";const w=m.$xo.as(O.$yo.JSONContribution);class u{constructor(){this.a=[],this.i=new Set,this.j=new D.$qe,this.onDidSchemaChange=this.j.event,this.k=new D.$qe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:L.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},w.registerSchema(e.$Jo,this.h),this.z()}registerConfiguration(g,f=!0){this.registerConfigurations([g],f)}registerConfigurations(g,f=!0){const h=new Set;this.r(g,f,h),w.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:h})}deregisterConfigurations(g){const f=new Set;this.s(g,f),w.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:f})}updateConfigurations({add:g,remove:f}){const h=new Set;this.s(f,h),this.r(g,!1,h),w.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:h})}registerDefaultConfigurations(g){const f=new Set;this.l(g,f),this.j.fire(),this.k.fire({properties:f,defaultsOverrides:!0})}l(g,f){this.a.push(...g);const h=[];for(const{overrides:S,source:k}of g)for(const y in S){f.add(y);const C=this.b.get(y)??this.b.set(y,{configurationDefaultOverrides:[]}).get(y),T=S[y];if(C.configurationDefaultOverrides.push({value:T,source:k}),e.$Mo.test(y)){const $=this.o(y,T,k,C.configurationDefaultOverrideValue);if(!$)continue;C.configurationDefaultOverrideValue=$,this.n(y,$,k),h.push(...r(y))}else{const $=this.p(y,T,k,C.configurationDefaultOverrideValue);if(!$)continue;C.configurationDefaultOverrideValue=$;const b=this.e[y];b&&(this.A(y,b),this.w(y,b))}}this.q(h)}deregisterDefaultConfigurations(g){const f=new Set;this.m(g,f),this.j.fire(),this.k.fire({properties:f,defaultsOverrides:!0})}m(g,f){for(const h of g){const S=this.a.indexOf(h);S!==-1&&this.a.splice(S,1)}for(const{overrides:h,source:S}of g)for(const k in h){const y=this.b.get(k);if(!y)continue;const C=y.configurationDefaultOverrides.findIndex(T=>S?T.source?.id===S.id:T.value===h[k]);if(C!==-1){if(y.configurationDefaultOverrides.splice(C,1),y.configurationDefaultOverrides.length===0&&this.b.delete(k),e.$Mo.test(k)){let T;for(const $ of y.configurationDefaultOverrides)T=this.o(k,$.value,$.source,T);T&&!P.$wg(T.value)?(y.configurationDefaultOverrideValue=T,this.n(k,T,S)):(this.b.delete(k),delete this.e[k],delete this.c.properties[k])}else{let T;for(const b of y.configurationDefaultOverrides)T=this.p(k,b.value,b.source,T);y.configurationDefaultOverrideValue=T;const $=this.e[k];$&&(this.A(k,$),this.w(k,$))}f.add(k)}}this.y()}n(g,f,h){const S={type:"object",default:f.value,description:L.localize(1663,null,(0,R.$oj)(g)),$ref:e.$Jo,defaultDefaultValue:f.value,source:h,defaultValueSource:h};this.e[g]=S,this.c.properties[g]=S}o(g,f,h,S){const k=S?.value||{},y=S?.source??new Map;if(!(y instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const C of Object.keys(f)){const T=f[C];if(P.$lg(T)&&(P.$qg(k[C])||P.$lg(k[C]))){if(k[C]={...k[C]??{},...T},h)for(const b in T)y.set(`${C}.${b}`,h)}else k[C]=T,h?y.set(C,h):y.delete(C)}return{value:k,source:y}}p(g,f,h,S){const k=this.e[g],y=S?.value??k?.defaultDefaultValue;let C=h;if(P.$lg(f)&&(k!==void 0&&k.type==="object"||k===void 0&&(P.$qg(y)||P.$lg(y)))){if(C=S?.source??new Map,!(C instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const $ in f)h&&C.set(`${g}.${$}`,h);f={...P.$lg(y)?y:{},...f}}return{value:f,source:C}}deltaConfiguration(g){let f=!1;const h=new Set;g.removedDefaults&&(this.m(g.removedDefaults,h),f=!0),g.addedDefaults&&(this.l(g.addedDefaults,h),f=!0),g.removedConfigurations&&this.s(g.removedConfigurations,h),g.addedConfigurations&&this.r(g.addedConfigurations,!1,h),this.j.fire(),this.k.fire({properties:h,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...g){this.j.fire()}registerOverrideIdentifiers(g){this.q(g),this.j.fire()}q(g){for(const f of g)this.i.add(f);this.y()}r(g,f,h){g.forEach(S=>{this.u(S,f,S.extensionInfo,S.restrictedProperties,void 0,h),this.d.push(S),this.v(S)})}s(g,f){const h=S=>{if(S.properties)for(const k in S.properties){f.add(k);const y=this.e[k];y?.policy?.name&&this.f.delete(y.policy.name),delete this.e[k],this.x(k,S.properties[k])}S.allOf?.forEach(k=>h(k))};for(const S of g){h(S);const k=this.d.indexOf(S);k!==-1&&this.d.splice(k,1)}}u(g,f=!0,h,S,k=I.WINDOW,y){k=P.$sg(g.scope)?k:g.scope;const C=g.properties;if(C)for(const $ in C){const b=C[$];if(f&&i($,b)){delete C[$];continue}if(b.source=h,b.defaultDefaultValue=C[$].default,this.A($,b),e.$Mo.test($)?b.scope=void 0:(b.scope=P.$sg(b.scope)?k:b.scope,b.restricted=P.$sg(b.restricted)?!!S?.includes($):b.restricted),C[$].hasOwnProperty("included")&&!C[$].included){this.g[$]=C[$],delete C[$];continue}else this.e[$]=C[$],C[$].policy?.name&&this.f.set(C[$].policy.name,$);!C[$].deprecationMessage&&C[$].markdownDeprecationMessage&&(C[$].deprecationMessage=C[$].markdownDeprecationMessage),y.add($)}const T=g.allOf;if(T)for(const $ of T)this.u($,f,h,S,k,y)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const g=new Map;for(const[f,h]of this.b)h.configurationDefaultOverrideValue&&g.set(f,h.configurationDefaultOverrideValue);return g}v(g){const f=h=>{const S=h.properties;if(S)for(const y in S)this.w(y,S[y]);h.allOf?.forEach(f)};f(g)}w(g,f){switch(e.$Do.properties[g]=f,f.scope){case I.APPLICATION:e.$Eo.properties[g]=f;break;case I.MACHINE:e.$Fo.properties[g]=f;break;case I.MACHINE_OVERRIDABLE:e.$Go.properties[g]=f;break;case I.WINDOW:e.$Ho.properties[g]=f;break;case I.RESOURCE:e.$Io.properties[g]=f;break;case I.LANGUAGE_OVERRIDABLE:e.$Io.properties[g]=f,this.h.properties[g]=f;break}}x(g,f){switch(delete e.$Do.properties[g],f.scope){case I.APPLICATION:delete e.$Eo.properties[g];break;case I.MACHINE:delete e.$Fo.properties[g];break;case I.MACHINE_OVERRIDABLE:delete e.$Go.properties[g];break;case I.WINDOW:delete e.$Ho.properties[g];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Io.properties[g],delete this.h.properties[g];break}}y(){for(const g of this.i.values()){const f=`[${g}]`,h={type:"object",description:L.localize(1664,null),errorMessage:L.localize(1665,null),$ref:e.$Jo};this.A(f,h),e.$Do.properties[f]=h,e.$Eo.properties[f]=h,e.$Fo.properties[f]=h,e.$Go.properties[f]=h,e.$Ho.properties[f]=h,e.$Io.properties[f]=h}}z(){const g={type:"object",description:L.localize(1666,null),errorMessage:L.localize(1667,null),$ref:e.$Jo};e.$Do.patternProperties[e.$Lo]=g,e.$Eo.patternProperties[e.$Lo]=g,e.$Fo.patternProperties[e.$Lo]=g,e.$Go.patternProperties[e.$Lo]=g,e.$Ho.patternProperties[e.$Lo]=g,e.$Io.patternProperties[e.$Lo]=g,this.j.fire()}A(g,f){const h=this.b.get(g)?.configurationDefaultOverrideValue;let S,k;h&&(!f.disallowConfigurationDefault||!h.source)&&(S=h.value,k=h.source),P.$qg(S)&&(S=f.defaultDefaultValue,k=void 0),P.$qg(S)&&(S=d(f.type)),f.default=S,f.defaultValueSource=k}}const E="\\[([^\\]]+)\\]",p=new RegExp(E,"g");e.$Lo=`^(${E})+$`,e.$Mo=new RegExp(e.$Lo);function r(c){const g=[];if(e.$Mo.test(c)){let f=p.exec(c);for(;f?.length;){const h=f[1].trim();h&&g.push(h),f=p.exec(c)}}return(0,v.$Qb)(g)}function l(c){return c.reduce((g,f)=>`${g}[${f}]`,"")}function d(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const a=new u;m.$xo.add(e.$Co.Configuration,a);function i(c,g){return c.trim()?e.$Mo.test(c)?L.localize(1669,null,c):a.getConfigurationProperties()[c]!==void 0?L.localize(1670,null,c):g.policy?.name&&a.getPolicyConfigurations().get(g.policy?.name)!==void 0?L.localize(1671,null,c,g.policy?.name,a.getPolicyConfigurations().get(g.policy?.name)):null:L.localize(1668,null)}function n(){const c=[],g=a.getConfigurationProperties();for(const f of Object.keys(g))c.push([f,g[f].scope]);return c.push(["launch",I.RESOURCE]),c.push(["task",I.RESOURCE]),c}function t(c){const g={};for(const f of c){const h=f.properties;if(P.$lg(h))for(const S in h)g[S]=h[S];f.allOf&&Object.assign(g,t(f.allOf))}return g}function o(c){switch(c){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(Re[174],Te([1,0,17,6,137,4,27,25,14,2,44,53,28,29]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=void 0,e.$Yo=n,v=Ve(v),P=Ve(P),O=Ve(O),m=Ve(m);function p(g){return Object.isFrozen(g)?g:O.$lo(g)}class r{static createEmptyModel(f){return new r({},[],[],void 0,f)}constructor(f,h,S,k,y){this.b=f,this.c=h,this.d=S,this.raw=k,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const f=this.raw.map(h=>{if(h instanceof r)return h;const S=new l("",this.f);return S.parseRaw(h),S.configurationModel});this.g=f.reduce((h,S)=>S===h?S:h.merge(S),f[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(f){return f?(0,I.$mj)(this.contents,f):this.contents}inspect(f,h){const S=this;return{get value(){return p(S.rawConfiguration.getValue(f))},get override(){return h?p(S.rawConfiguration.getOverrideValue(f,h)):void 0},get merged(){return p(h?S.rawConfiguration.override(h).getValue(f):S.rawConfiguration.getValue(f))},get overrides(){const k=[];for(const{contents:y,identifiers:C,keys:T}of S.rawConfiguration.overrides){const $=new r(y,T,[],void 0,S.f).getValue(f);$!==void 0&&k.push({identifiers:C,value:$})}return k.length?p(k):void 0}}}getOverrideValue(f,h){const S=this.j(h);return S?f?(0,I.$mj)(S,f):S:void 0}getKeysForOverrideIdentifier(f){const h=[];for(const S of this.overrides)S.identifiers.includes(f)&&h.push(...S.keys);return v.$Qb(h)}getAllOverrideIdentifiers(){const f=[];for(const h of this.overrides)f.push(...h.identifiers);return v.$Qb(f)}override(f){let h=this.a.get(f);return h||(h=this.h(f),this.a.set(f,h)),h}merge(...f){const h=O.$ko(this.contents),S=O.$ko(this.overrides),k=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const C of f)if(y.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i(h,C.contents);for(const T of C.overrides){const[$]=S.filter(b=>v.$yb(b.identifiers,T.identifiers));$?(this.i($.contents,T.contents),$.keys.push(...T.keys),$.keys=v.$Qb($.keys)):S.push(O.$ko(T))}for(const T of C.keys)k.indexOf(T)===-1&&k.push(T)}return new r(h,k,S,y.every(C=>C instanceof r)?void 0:y,this.f)}h(f){const h=this.j(f);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const S={};for(const k of v.$Qb([...Object.keys(this.contents),...Object.keys(h)])){let y=this.contents[k];const C=h[k];C&&(typeof y=="object"&&typeof C=="object"?(y=O.$ko(y),this.i(y,C)):y=C),S[k]=y}return new r(S,this.keys,this.overrides,void 0,this.f)}i(f,h){for(const S of Object.keys(h)){if(S in f&&m.$lg(f[S])&&m.$lg(h[S])){this.i(f[S],h[S]);continue}f[S]=O.$ko(h[S])}}j(f){let h=null,S=null;const k=y=>{y&&(S?this.i(S,y):S=O.$ko(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===f?h=y.contents:y.identifiers.includes(f)&&k(y.contents);return k(h),S}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(f,h){this.k(f,h,!0)}setValue(f,h){this.k(f,h,!1)}removeValue(f){const h=this.keys.indexOf(f);h!==-1&&(this.keys.splice(h,1),(0,I.$lj)(this.contents,f),w.$Mo.test(f)&&this.overrides.splice(this.overrides.findIndex(S=>v.$yb(S.identifiers,(0,w.$No)(f))),1))}k(f,h,S){if((0,I.$kj)(this.contents,f,h,k=>this.f.error(k)),S=S||this.keys.indexOf(f)===-1,S&&this.keys.push(f),w.$Mo.test(f)){const k=(0,w.$No)(f),y={identifiers:k,keys:Object.keys(this.contents[f]),contents:(0,I.$jj)(this.contents[f],T=>this.f.error(T))},C=this.overrides.findIndex(T=>v.$yb(T.identifiers,k));C!==-1?this.overrides[C]=y:this.overrides.push(y)}}}e.$Uo=r;class l{constructor(f,h){this.f=f,this.g=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(f,h){if(!m.$sg(f)){const S=this.h(f);this.parseRaw(S,h)}}reparse(f){this.a&&this.parseRaw(this.a,f)}parseRaw(f,h){this.a=f;const{contents:S,keys:k,overrides:y,restricted:C,hasExcludedProperties:T}=this.i(f,h);this.b=new r(S,k,y,T?[f]:void 0,this.g),this.c=C||[]}h(f){let h={},S=null,k=[];const y=[],C=[];function T(b){Array.isArray(k)?k.push(b):S!==null&&(k[S]=b)}const $={onObjectBegin:()=>{const b={};T(b),y.push(k),k=b,S=null},onObjectProperty:b=>{S=b},onObjectEnd:()=>{k=y.pop()},onArrayBegin:()=>{const b=[];T(b),y.push(k),k=b,S=null},onArrayEnd:()=>{k=y.pop()},onLiteralValue:T,onError:(b,N,A)=>{C.push({error:b,offset:N,length:A})}};if(f)try{P.$_n(f,$),h=k[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return h}i(f,h){const S=E.$xo.as(w.$Co.Configuration).getConfigurationProperties(),k=this.j(f,S,!0,h);f=k.raw;const y=(0,I.$jj)(f,$=>this.g.error(`Conflict in settings file ${this.f}: ${$}`)),C=Object.keys(f),T=this.l(f,$=>this.g.error(`Conflict in settings file ${this.f}: ${$}`));return{contents:y,keys:C,overrides:T,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}j(f,h,S,k){let y=!1;if(!k?.scopes&&!k?.skipRestricted&&!k?.exclude?.length)return{raw:f,restricted:[],hasExcludedProperties:y};const C={},T=[];for(const $ in f)if(w.$Mo.test($)&&S){const b=this.j(f[$],h,!1,k);C[$]=b.raw,y=y||b.hasExcludedProperties,T.push(...b.restricted)}else{const b=h[$],N=b?typeof b.scope<"u"?b.scope:w.ConfigurationScope.WINDOW:void 0;b?.restricted&&T.push($),!k.exclude?.includes($)&&(k.include?.includes($)||(N===void 0||k.scopes===void 0||k.scopes.includes(N))&&!(k.skipRestricted&&b?.restricted))?C[$]=f[$]:y=!0}return{raw:C,restricted:T,hasExcludedProperties:y}}l(f,h){const S=[];for(const k of Object.keys(f))if(w.$Mo.test(k)){const y={};for(const C in f[k])y[C]=f[k][C];S.push({identifiers:(0,w.$No)(k),keys:Object.keys(y),contents:(0,I.$jj)(y,h)})}return S}}e.$Vo=l;class d extends L.$Zc{constructor(f,h,S,k,y){super(),this.c=f,this.f=h,this.g=k,this.h=y,this.b=this.B(new D.$qe),this.onDidChange=this.b.event,this.a=new l(this.c.toString(),y),this.B(this.g.watch(S.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(u.FileOperation.CREATE)||C.isOperation(u.FileOperation.COPY)||C.isOperation(u.FileOperation.DELETE)||C.isOperation(u.FileOperation.WRITE))&&S.isEqual(C.resource,f)))(()=>this.b.fire()))}async loadConfiguration(){try{const f=await this.g.readFile(this.c);return this.a.parse(f.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(f){return f&&(this.f=f),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Wo=d;class a{constructor(f,h,S,k,y,C,T,$,b,N,A,F,G){this.a=f,this.b=h,this.c=S,this.overrideIdentifiers=k,this.d=y,this.f=C,this.g=T,this.h=$,this.i=b,this.j=N,this.k=A,this.l=F,this.m=G}get value(){return p(this.c)}n(f){return f?.value!==void 0||f?.override!==void 0||f?.overrides!==void 0?f:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(f,h,S,k,y,C,T,$,b,N){this.j=f,this.l=h,this.m=S,this.n=k,this.p=y,this.q=C,this.r=T,this.s=$,this.t=b,this.u=N,this.h=null,this.i=new R.$Fc,this.v=null}getValue(f,h,S){return this.w(f,h,S).getValue(f)}updateValue(f,h,S={}){let k;S.resource?(k=this.t.get(S.resource),k||(k=r.createEmptyModel(this.u),this.t.set(S.resource,k))):k=this.s,h===void 0?k.removeValue(f):k.setValue(f,h),S.resource||(this.h=null)}inspect(f,h,S){const k=this.w(f,h,S),y=this.A(h.resource,S),C=h.resource?this.t.get(h.resource)||this.s:this.s,T=new Set;for(const $ of k.overrides)for(const b of $.identifiers)k.getOverrideValue(f,b)!==void 0&&T.add(b);return new a(f,h,k.getValue(f),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,S?this.q:void 0,y||void 0,C)}keys(f){const h=this.A(void 0,f);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(f){this.j=f,this.h=null,this.i.clear()}updatePolicyConfiguration(f){this.l=f}updateApplicationConfiguration(f){this.m=f,this.h=null,this.i.clear()}updateLocalUserConfiguration(f){this.n=f,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(f){this.p=f,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(f){this.q=f,this.h=null,this.i.clear()}updateFolderConfiguration(f,h){this.r.set(f,h),this.i.delete(f)}deleteFolderConfiguration(f){this.folderConfigurations.delete(f),this.i.delete(f)}compareAndUpdateDefaultConfiguration(f,h){const S=[];if(!h){const{added:k,updated:y,removed:C}=o(this.j,f);h=[...k,...y,...C]}for(const k of h)for(const y of(0,w.$No)(k)){const C=this.j.getKeysForOverrideIdentifier(y),T=f.getKeysForOverrideIdentifier(y),$=[...T.filter(b=>C.indexOf(b)===-1),...C.filter(b=>T.indexOf(b)===-1),...C.filter(b=>!O.$oo(this.j.override(y).getValue(b),f.override(y).getValue(b)))];S.push([y,$])}return this.updateDefaultConfiguration(f),{keys:h,overrides:S}}compareAndUpdatePolicyConfiguration(f){const{added:h,updated:S,removed:k}=o(this.l,f),y=[...h,...S,...k];return y.length&&this.updatePolicyConfiguration(f),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(f){const{added:h,updated:S,removed:k,overrides:y}=o(this.applicationConfiguration,f),C=[...h,...S,...k];return C.length&&this.updateApplicationConfiguration(f),{keys:C,overrides:y}}compareAndUpdateLocalUserConfiguration(f){const{added:h,updated:S,removed:k,overrides:y}=o(this.localUserConfiguration,f),C=[...h,...S,...k];return C.length&&this.updateLocalUserConfiguration(f),{keys:C,overrides:y}}compareAndUpdateRemoteUserConfiguration(f){const{added:h,updated:S,removed:k,overrides:y}=o(this.remoteUserConfiguration,f),C=[...h,...S,...k];return C.length&&this.updateRemoteUserConfiguration(f),{keys:C,overrides:y}}compareAndUpdateWorkspaceConfiguration(f){const{added:h,updated:S,removed:k,overrides:y}=o(this.workspaceConfiguration,f),C=[...h,...S,...k];return C.length&&this.updateWorkspaceConfiguration(f),{keys:C,overrides:y}}compareAndUpdateFolderConfiguration(f,h){const S=this.folderConfigurations.get(f),{added:k,updated:y,removed:C,overrides:T}=o(S,h),$=[...k,...y,...C];return($.length||!S)&&this.updateFolderConfiguration(f,h),{keys:$,overrides:T}}compareAndDeleteFolderConfiguration(f){const h=this.folderConfigurations.get(f);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(f);const{added:S,updated:k,removed:y,overrides:C}=o(h,void 0);return{keys:[...S,...k,...y],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(f,h,S){let k=this.x(h,S);return h.overrideIdentifier&&(k=k.override(h.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(f)!==void 0&&(k=k.merge(this.l)),k}x({resource:f},h){let S=this.y();if(h&&f){const k=h.getFolder(f);k&&(S=this.z(k.uri)||S);const y=this.t.get(f);y&&(S=S.merge(y))}return S}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(f){let h=this.i.get(f);if(!h){const S=this.y(),k=this.r.get(f);k?(h=S.merge(k),this.i.set(f,h)):h=S}return h}A(f,h){if(h&&f){const S=h.getFolder(f);if(S)return this.r.get(S.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((f,h)=>{const{contents:S,overrides:k,keys:y}=this.r.get(h);return f.push([h,{contents:S,overrides:k,keys:y}]),f},[])}}allKeys(){const f=new Set;return this.j.keys.forEach(h=>f.add(h)),this.userConfiguration.keys.forEach(h=>f.add(h)),this.q.keys.forEach(h=>f.add(h)),this.r.forEach(h=>h.keys.forEach(S=>f.add(S))),[...f.values()]}B(){const f=new Set;return this.j.getAllOverrideIdentifiers().forEach(h=>f.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>f.add(h)),this.q.getAllOverrideIdentifiers().forEach(h=>f.add(h)),this.r.forEach(h=>h.getAllOverrideIdentifiers().forEach(S=>f.add(S))),[...f.values()]}D(f){const h=new Set;return this.j.getKeysForOverrideIdentifier(f).forEach(S=>h.add(S)),this.userConfiguration.getKeysForOverrideIdentifier(f).forEach(S=>h.add(S)),this.q.getKeysForOverrideIdentifier(f).forEach(S=>h.add(S)),this.r.forEach(S=>S.getKeysForOverrideIdentifier(f).forEach(k=>h.add(k))),[...h.values()]}static parse(f,h){const S=this.E(f.defaults,h),k=this.E(f.policy,h),y=this.E(f.application,h),C=this.E(f.user,h),T=this.E(f.workspace,h),$=f.folders.reduce((b,N)=>(b.set(s.URI.revive(N[0]),this.E(N[1],h)),b),new R.$Fc);return new i(S,k,y,C,r.createEmptyModel(h),T,$,r.createEmptyModel(h),new R.$Fc,h)}static E(f,h){return new r(f.contents,f.keys,f.overrides,void 0,h)}}e.$Xo=i;function n(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const f=new Set,h=new Map;for(const k of g)k.keys.forEach(y=>f.add(y)),k.overrides.forEach(([y,C])=>{const T=(0,R.$Cc)(h,y,new Set);C.forEach($=>T.add($))});const S=[];return h.forEach((k,y)=>S.push([y,[...k.values()]])),{keys:[...f.values()],overrides:S}}class t{constructor(f,h,S,k,y){this.change=f,this.f=h,this.g=S,this.h=k,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of f.keys)this.affectedKeys.add(C);for(const[,C]of f.overrides)for(const T of C)this.affectedKeys.add(T);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(f,h){const S=this.a+f,k=this.d.indexOf(S);if(k<0)return!1;const y=k+S.length;if(y>=this.d.length)return!1;const C=this.d.charCodeAt(y);if(C!==this.b&&C!==this.c)return!1;if(h){const T=this.previousConfiguration?this.previousConfiguration.getValue(f,h,this.f?.workspace):void 0,$=this.g.getValue(f,h,this.h);return!O.$oo(T,$)}return!0}}e.$Zo=t;function o(g,f){const{added:h,removed:S,updated:k}=c(f?.rawConfiguration,g?.rawConfiguration),y=[],C=g?.getAllOverrideIdentifiers()||[],T=f?.getAllOverrideIdentifiers()||[];if(f){const $=T.filter(b=>!C.includes(b));for(const b of $)y.push([b,f.getKeysForOverrideIdentifier(b)])}if(g){const $=C.filter(b=>!T.includes(b));for(const b of $)y.push([b,g.getKeysForOverrideIdentifier(b)])}if(f&&g){for(const $ of C)if(T.includes($)){const b=c({contents:g.getOverrideValue(void 0,$)||{},keys:g.getKeysForOverrideIdentifier($)},{contents:f.getOverrideValue(void 0,$)||{},keys:f.getKeysForOverrideIdentifier($)});y.push([$,[...b.added,...b.removed,...b.updated]])}}return{added:h,removed:S,updated:k,overrides:y}}function c(g,f){const h=g?f?g.keys.filter(y=>f.keys.indexOf(y)===-1):[...g.keys]:[],S=f?g?f.keys.filter(y=>g.keys.indexOf(y)===-1):[...f.keys]:[],k=[];if(g&&f){for(const y of f.keys)if(g.keys.indexOf(y)!==-1){const C=(0,I.$mj)(f.contents,y),T=(0,I.$mj)(g.contents,y);O.$oo(C,T)||k.push(y)}}return{added:h,removed:S,updated:k}}}),define(Re[110],Te([1,0,12,3]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.RemoteAuthorityResolverErrorCode=e.$Yl=e.$Xl=e.RemoteConnectionType=e.$Wl=void 0,e.$1l=s,e.$Wl=(0,D.$Ki)("remoteAuthorityResolverService");var P;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class L{constructor(w){this.id=w,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Xl=L;class R{constructor(w,u){this.host=w,this.port=u,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Yl=R;var O;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(O||(e.RemoteAuthorityResolverErrorCode=O={}));class m extends v.$fb{static isNotAvailable(w){return w instanceof m&&w._code===O.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof m&&w._code===O.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof m&&w._code===O.NoResolverFound}static isInvalidAuthority(w){return w instanceof m&&w._code===O.InvalidAuthority}static isHandled(w){return w instanceof m&&w.isHandled}constructor(w,u=O.Unknown,E){super(w),this._message=w,this._code=u,this._detail=E,this.isHandled=u===O.NotAvailable&&E===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Zl=m;function s(I){const w=I.indexOf("+");return w===-1?I:I.substring(0,w)}}),define(Re[62],Te([1,0,15]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=D,e.$on=P,e.$pn=L,e.$qn=R;function D(m){return m.scheme===v.Schemas.vscodeRemote?m.authority:void 0}function P(m){if(!m)return;const s=m.indexOf("+");return s<0?m:m.substr(0,s)}function L(m){const{host:s,port:I}=O(m);if(typeof I>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:I}}function R(m,s){let{host:I,port:w}=O(m);return typeof w>"u"&&(w=s),{host:I,port:w}}function O(m){const s=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const I=m.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const w=m.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:m,port:void 0}}}),define(Re[18],Te([1,0,13,3,62]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$zn=e.$yn=e.$xn=e.TargetPlatform=e.ExtensionType=e.$wn=e.$un=e.$tn=e.$sn=e.$rn=void 0,e.$vn=L,e.$An=w,e.$Bn=u,e.$Cn=E,e.$Dn=p,e.$En=r,e.$Fn=l,v=Ve(v),e.$rn="extensions.user.cache",e.$sn="extensions.builtin.cache",e.$tn="undefined_publisher",e.$un=["ui","workspace","web"];function L(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$wn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(R||(e.ExtensionType=R={}));var O;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class m{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,i){if(typeof a>"u"||a===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof a=="string"||typeof i=="string"){const n=typeof a=="string"?a:a.value,t=typeof i=="string"?i:i.value;return v.$Kf(n,t)}return a._lower===i._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.$xn=m;class s{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const i of a)this.add(i)}add(a){this.c.add(m.toKey(a))}delete(a){return this.c.delete(m.toKey(a))}has(a){return this.c.has(m.toKey(a))}}e.$yn=s;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(m.toKey(a))}get(a){return this.c.get(m.toKey(a))}has(a){return this.c.has(m.toKey(a))}set(a,i){this.c.set(m.toKey(a),i)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$zn=I;function w(d){return u(d)}function u(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function E(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function p(d,a){if(a){const i=`onResolveRemoteAuthority:${(0,P.$on)(a)}`;return!!d.activationEvents?.includes(i)}return!1}function r(d){return d.map(a=>{const[i,n]=a.split("@");return{proposalName:i,version:n?parseInt(n):void 0}})}function l(d){return d.map(a=>a.split("@")[0])}e.$Gn=(0,D.$Ki)("IBuiltinExtensionsScannerService")}),define(Re[111],Te([1,0,23,9,18,3]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.ExtensionManagementErrorCode=e.$sp=e.ExtensionGalleryErrorCode=e.$rp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=void 0,e.$lp=O,e.$mp=m,e.$np=s,e.$op=I,e.$pp=w,e.$qp=u,e.$ep="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$fp=new RegExp(e.$ep),e.$gp="__web_extension",e.$hp="skipWalkthrough",e.$ip="extensionInstallSource",e.$jp="dependecyOrPackExtensionInstall",e.$kp="clientTargetPlatform";var R;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(R||(e.ExtensionInstallSource=R={}));function O(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function m(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function s(t,o){switch(t){case v.Platform.Windows:return o==="x64"?P.TargetPlatform.WIN32_X64:o==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Linux:return o==="x64"?P.TargetPlatform.LINUX_X64:o==="arm64"?P.TargetPlatform.LINUX_ARM64:o==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return o==="x64"?P.TargetPlatform.ALPINE_X64:o==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Mac:return o==="x64"?P.TargetPlatform.DARWIN_X64:o==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Web:return P.TargetPlatform.WEB}}function I(t,o){return o===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function w(t,o,c){return I(o,c)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===c}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var E;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var p;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var r;(function(t){t.Install="install",t.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var l;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.$rp=(0,L.$Ki)("extensionGalleryService");var d;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting",t.Offline="Offline"})(d||(e.ExtensionGalleryErrorCode=d={}));class a extends Error{constructor(o,c){super(o),this.code=c,this.name=c}}e.$sp=a;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class n extends Error{constructor(o,c){super(o),this.code=c,this.name=c}}e.$tp=n,e.$up=(0,L.$Ki)("extensionManagementService"),e.$vp="extensionsIdentifiers/disabled",e.$wp="extensionsIdentifiers/enabled",e.$xp=(0,L.$Ki)("IGlobalExtensionEnablementService"),e.$yp=(0,L.$Ki)("IExtensionTipsService"),e.$zp=(0,D.localize2)(1780,"Extensions"),e.$Ap=(0,D.localize2)(1781,"Preferences")}),define(Re[112],Te([1,0,12,18]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fH=e.$eH=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,O){this.a.set(R,O)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const O=Object.create(null);for(const m of R){const s=this.readActivationEvents(m);s.length>0&&(O[D.$xn.toKey(m.identifier)]=s)}return O}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const O=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let m=0;m<O.length;m++)O[m]==="onUri"&&(O[m]=`onUri:${D.$xn.toKey(R.identifier)}`);if(!R.contributes)return O;for(const m in R.contributes){const s=this.a.get(m);if(!s)continue;const I=R.contributes[m],w=Array.isArray(I)?I:[I];try{s(w,O)}catch(u){(0,v.$4)(u)}}return O}}e.$eH=P,e.$fH=new P});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[175],Te([1,0,24,37,9,281,18,105]),function(we,e,v,D,P,L,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=I,e.$7p=w,e.$8p=u,e.$9p=E,e.$0p=p,e.$$p=r,e.$_p=l,e.$aq=d,D=oi(D),P=Ve(P),L=Ve(L);const m=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,s=/^-(\d{4})(\d{2})(\d{2})$/;function I(n){return n=n.trim(),n==="*"||m.test(n)}function w(n){if(!I(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=n.match(m);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(n){if(!n)return null;const t=n.majorBase,o=n.majorMustEqual,c=n.minorBase;let g=n.minorMustEqual;const f=n.patchBase;let h=n.patchMustEqual;n.hasCaret&&(t===0||(g=!1),h=!1);let S=0;if(n.preRelease){const k=s.exec(n.preRelease);if(k){const[,y,C,T]=k;S=Date.UTC(Number(y),Number(C)-1,Number(T))}}return{majorBase:t,majorMustEqual:o,minorBase:c,minorMustEqual:g,patchBase:f,patchMustEqual:h,isMinimum:n.hasGreaterEquals,notBefore:S}}function E(n,t,o){let c;typeof n=="string"?c=u(w(n)):c=n;let g;t instanceof Date?g=t.getTime():typeof t=="string"&&(g=new Date(t).getTime());let f;if(typeof o=="string"?f=u(w(o)):f=o,!c||!f)return!1;const h=c.majorBase,S=c.minorBase,k=c.patchBase;let y=f.majorBase,C=f.minorBase,T=f.patchBase;const $=f.notBefore;let b=f.majorMustEqual,N=f.minorMustEqual,A=f.patchMustEqual;return f.isMinimum?h>y?!0:h<y?!1:S>C?!0:S<C||g&&g<$?!1:k>=T:(h===1&&y===0&&(!b||!N||!A)&&(y=1,C=0,T=0,b=!0,N=!1,A=!1),h<y?!1:h>y?!b:S<C?!1:S>C?!N:k<T?!1:k>T?!A:!(g&&g<$))}function p(n,t,o,c,g,f){const h=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return h.push([D.default.Error,P.localize(1832,null)]),h;if(typeof c.name!="string")return h.push([D.default.Error,P.localize(1833,null,"name")]),h;if(typeof c.version!="string")return h.push([D.default.Error,P.localize(1834,null,"version")]),h;if(!c.engines)return h.push([D.default.Error,P.localize(1835,null,"engines")]),h;if(typeof c.engines.vscode!="string")return h.push([D.default.Error,P.localize(1836,null,"engines.vscode")]),h;if(typeof c.extensionDependencies<"u"&&!i(c.extensionDependencies))return h.push([D.default.Error,P.localize(1837,null,"extensionDependencies")]),h;if(typeof c.activationEvents<"u"){if(!i(c.activationEvents))return h.push([D.default.Error,P.localize(1838,null,"activationEvents")]),h;if(typeof c.main>"u"&&typeof c.browser>"u")return h.push([D.default.Error,P.localize(1839,null,"activationEvents","main","browser")]),h}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&h.push([D.default.Warning,P.localize(1840,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return h.push([D.default.Error,P.localize(1841,null,"main")]),h;{const y=(0,v.$lh)(o,c.main);(0,v.$fh)(y,o)||h.push([D.default.Warning,P.localize(1842,null,y.path,o.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return h.push([D.default.Error,P.localize(1843,null,"browser")]),h;{const y=(0,v.$lh)(o,c.browser);(0,v.$fh)(y,o)||h.push([D.default.Warning,P.localize(1844,null,y.path,o.path)])}}if(!L.valid(c.version))return h.push([D.default.Error,P.localize(1845,null)]),h;const S=[];if(!r(n,t,c,g,S))for(const y of S)h.push([D.default.Error,y]);if(f&&c.enabledApiProposals?.length){const y=[];if(!d([...c.enabledApiProposals],y))for(const C of y)h.push([D.default.Error,C])}return h}function r(n,t,o,c,g){return c||typeof o.main>"u"&&typeof o.browser>"u"?!0:a(n,t,o.engines.vscode,g)}function l(n,t,o){return n==="*"||a(t,o,n)}function d(n,t){if(n.length===0)return!0;const o=Array.isArray(t)?t:void 0,c=(o?void 0:t)??O.allApiProposals,g=[],f=(0,R.$En)(n);for(const{proposalName:h,version:S}of f){const k=c[h];k&&S&&k.version!==S&&g.push(P.localize(1846,null,h))}return o?.push(...g),g.length===0}function a(n,t,o,c=[]){const g=u(w(o));if(!g)return c.push(P.localize(1847,null,o)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return c.push(P.localize(1848,null,o)),!1}else if(!g.majorMustEqual)return c.push(P.localize(1849,null,o)),!1;return E(n,t,g)?!0:(c.push(P.localize(1850,null,n,o)),!1)}function i(n){if(!Array.isArray(n))return!1;for(let t=0,o=n.length;t<o;t++)if(typeof n[t]!="string")return!1;return!0}}),define(Re[176],Te([1,0,20,12,4,9,53,3,11,29]),function(we,e,v,D,P,L,R,O,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0,e.$dq=u,e.$eq=E,e.$fq=p,e.$gq=r,e.$hq=l,e.$iq=d,e.$bq=(0,O.$Ki)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const o in this.b)o.toLowerCase()==="authorization"||o.toLowerCase()==="proxy-authorization"?t[o]="*****":t[o]=this.b[o];this.a=t}return this.a}}class w extends P.$Zc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,L.localize)(2050,null),when:m.$xk.isEqualTo((0,m.$uk)(m.LogLevel.Trace)).serialize()})}async c(t,o,c){const g=`${t} #${++this.b}: ${o.url}`;this.a.trace(`${g} - begin`,o.type,new I(o.headers??{}));try{const f=await c();return this.a.trace(`${g} - end`,o.type,f.res.statusCode,f.res.headers),f}catch(f){throw this.a.error(`${g} - error`,o.type,(0,D.$bb)(f)),f}}}e.$cq=w;function u(n){return n.res.statusCode&&n.res.statusCode>=200&&n.res.statusCode<300||n.res.statusCode===1223}function E(n){return n.res.statusCode===204}async function p(n){return E(n)?null:(await(0,v.$5e)(n.stream)).toString()}async function r(n){if(!u(n))throw new Error("Server returned "+n.res.statusCode);return p(n)}async function l(n){if(!u(n))throw new Error("Server returned "+n.res.statusCode);if(E(n))return null;const o=(await(0,v.$5e)(n.stream)).toString();try{return JSON.parse(o)}catch(c){throw c.message+=`:
`+o,c}}function d(n){i(n)}let a;function i(n){const t=s.$xo.as(R.$Co.Configuration),o=a;a={id:"http",order:15,title:(0,L.localize)(2051,null),type:"object",scope:n,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,L.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(2057,null),(0,L.localize)(2058,null),(0,L.localize)(2059,null),(0,L.localize)(2060,null)],default:"override",description:(0,L.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(2063,null),restricted:!0}}},t.updateConfigurations({add:[a],remove:o?[o]:[]})}i(R.ConfigurationScope.APPLICATION)}),define(Re[177],Te([1,0,23,79,33]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=R,e.$Cp=O;function L(m){if(v.$x===v.Platform.Linux&&/^penguin(\.|$)/i.test(m))return"chromebook"}function R(m,s,I,w,u,E,p,r,l,d){const a=Object.create(null);a["common.machineId"]=E,a["common.sqmId"]=p,a["common.devDeviceId"]=r,a.sessionID=(0,P.$7g)()+Date.now(),a.commitHash=w,a.version=u,a["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,v.$k)(v.$x),a["common.nodePlatform"]=D.$ic,a["common.nodeArch"]=I,a["common.product"]=d||"desktop",l&&(a["common.msftInternal"]=l);let i=0;const n=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$o&&(a["common.snap"]="true");const t=L(s);return t&&(a["common.platformDetail"]=t),a}function O(m){const s=D.env.USERDNSDOMAIN;if(!s)return!1;const I=s.toLowerCase();return m.some(w=>I===w)}}),define(Re[113],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em=(0,v.$Ki)("telemetryService"),e.$fm=(0,v.$Ki)("customEndpointTelemetryService"),e.$gm="telemetry.currentSessionDate",e.$hm="telemetry.firstSessionDate",e.$im="telemetry.lastSessionDate",e.$jm="telemetry.machineId",e.$km="telemetry.sqmId",e.$lm="telemetry.devDeviceId",e.$mm="telemetry",e.$nm="telemetry.telemetryLevel",e.$om="telemetry.enableCrashReporter",e.$pm="telemetry.enableTelemetry";var D;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var P;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Re[63],Te([1,0,25,14,62,177,113]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=void 0,e.$Kp=I,e.$Lp=w,e.$Mp=u,e.$Np=E,e.$Op=r,e.$Pp=d,e.$Qp=a,e.$Rp=t;class O{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$Dp=O;class m{constructor(){this.telemetryLevel=R.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ep=m,e.$Fp=new m;class s{async publicLog(c,g,f){}async publicLogError(c,g,f){}}e.$Gp=s,e.$Hp="telemetry",e.$Ip="extensionTelemetryLog",e.$Jp={log:()=>null,flush:()=>Promise.resolve(null)};function I(o,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!o.enableTelemetry)}function w(o,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}function u(o){const c=o.getValue(R.$nm),g=o.getValue(R.$om);if(o.getValue(R.$pm)===!1||g===!1)return R.TelemetryLevel.NONE;switch(c??R.TelemetryConfiguration.ON){case R.TelemetryConfiguration.ON:return R.TelemetryLevel.USAGE;case R.TelemetryConfiguration.ERROR:return R.TelemetryLevel.ERROR;case R.TelemetryConfiguration.CRASH:return R.TelemetryLevel.CRASH;case R.TelemetryConfiguration.OFF:return R.TelemetryLevel.NONE}}function E(o){const c={},g={},f={};l(o,f);for(let h in f){h=h.length>150?h.substr(h.length-149):h;const S=f[h];typeof S=="number"?g[h]=S:typeof S=="boolean"?g[h]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${S.length}`),c[h]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(c[h]=S)}return{properties:c,measurements:g}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(o){if(!o)return"none";const c=(0,P.$on)(o);return p.has(c)?c:"other"}function l(o,c,g=0,f){if(o)for(const h of Object.getOwnPropertyNames(o)){const S=o[h],k=f?f+h:h;Array.isArray(S)?c[k]=(0,v.$po)(S):S instanceof Date?c[k]=S.toISOString():(0,D.$lg)(S)?g<2?l(S,c,g+1,k+"."):c[k]=(0,v.$po)(S):c[k]=S}}function d(o,c){const g=o.msftInternalDomains||[],f=c.getValue("telemetry.internalTesting");return(0,L.$Cp)(g)||f}function a(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}function i(o,c){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let g=o;const f=[];for(const y of c)for(;;){const C=y.exec(o);if(!C)break;f.push([C.index,y.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(g="";;){const y=S.exec(o);if(!y)break;const C=f.some(([T,$])=>y.index<$&&T<S.lastIndex);!h.test(y[0])&&!C&&(g+=o.substring(k,y.index)+"<REDACTED: user-file-path>",k=S.lastIndex)}return k<o.length&&(g+=o.substr(k)),g}function n(o){if(!o)return o;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of c)if(g.regex.test(o))return`<REDACTED: ${g.label}>`;return o}function t(o,c){return(0,v.$mo)(o,g=>{if(g instanceof O||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let f=g.replaceAll("%20"," ");f=i(f,c);for(const h of c)f=f.replace(h,"");return f=n(f),f}})}}),define(Re[178],Te([1,0,13,111,18,23,2,12,79,63]),function(we,e,v,D,P,L,R,O,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$Tp=void 0,e.$Sp=I,e.$Up=p,e.$Vp=r,e.$Wp=l,e.$Xp=d,e.$Yp=a,e.$Zp=i,e.$1p=n,e.$3p=t,e.$4p=c;function I(g,f){return g.uuid&&f.uuid?g.uuid===f.uuid:g.id===f.id?!0:(0,v.$Ff)(g.id,f.id)===0}const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(f){const h=f.manifest?f.manifest.version:f.version,S=f.manifest?f.targetPlatform:f.properties.targetPlatform;return new u(f.identifier,h,S)}static parse(f){const h=w.exec(f);return h&&h[1]&&h[2]?new u({id:h[1]},h[2],h[4]||void 0):null}constructor(f,h,S=P.TargetPlatform.UNDEFINED){this.identifier=f,this.version=h,this.targetPlatform=S,this.id=f.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(f){return f instanceof u?I(this,f)&&this.version===f.version&&this.targetPlatform===f.targetPlatform:!1}}e.$Tp=u;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(g){const f=E.exec(g);return f&&f[1]?[l(f[1]),f[2]]:[l(g),void 0]}function r(g,f){return`${g}.${f}`}function l(g){return g.toLowerCase()}function d(g,f){return l(r(g??P.$tn,f))}function a(g,f){const h=[],S=k=>{for(const y of h)if(y.some(C=>I(f(C),f(k))))return y;return null};for(const k of g){const y=S(k);y?y.push(k):h.push([k])}return h}function i(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}function n(g){return{id:new s.$Dp(g.identifier.id),name:new s.$Dp(g.name),version:g.version,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),isSigned:g.isSigned,...g.telemetryData}}e.$2p=new P.$xn("pprice.better-merge");function t(g,f){const h=[],S=f.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const k=S.shift();if(k&&h.every(y=>!I(y.identifier,{id:k}))){const y=g.filter(C=>I(C.identifier,{id:k}));y.length===1&&(h.push(y[0]),S.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}async function o(g,f){if(!L.$n)return!1;let h;try{h=(await g.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await g.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){f.debug("Error while getting the os-release file.",(0,O.$bb)(k))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(g,f){const h=await o(g,f),S=(0,D.$np)(h?"alpine":L.$x,m.$jc);return f.debug("ComputeTargetPlatform:",S),S}}),define(Re[179],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=v,e.$Os=D,e.$Ps=P,e.$Qs=L,e.$Rs=R,e.$Ss=O;function v(m){return[...m.entries()]}function D(m){return m?[...m.entries()]:[]}function P(m){return new Map(m)}function L(m){return new Map(m??[])}function R(m){return Array.from(m.entries()).map(s=>[s[0],v(s[1].map),D(s[1].descriptionMap)])}function O(m){return new Map(m.map(s=>[s[0],{map:P(s[1]),descriptionMap:L(s[2])}]))}}),define(Re[180],Te([1,0,3,31,29]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=e.$zs=e.$ys=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$xs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ws=void 0,e.$ws=new D.$2j("terminalTabFocusMode",!1,!0);var L;(function(o){o.AutomationProfile="terminal.integrated.automationProfile.",o.DefaultProfile="terminal.integrated.defaultProfile.",o.Profiles="terminal.integrated.profiles."})(L||(e.TerminalSettingPrefix=L={}));var R;(function(o){o.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",o.AutomationProfileLinux="terminal.integrated.automationProfile.linux",o.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",o.AutomationProfileWindows="terminal.integrated.automationProfile.windows",o.ProfilesWindows="terminal.integrated.profiles.windows",o.ProfilesMacOs="terminal.integrated.profiles.osx",o.ProfilesLinux="terminal.integrated.profiles.linux",o.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",o.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",o.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",o.UseWslProfiles="terminal.integrated.useWslProfiles",o.TabsDefaultColor="terminal.integrated.tabs.defaultColor",o.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",o.TabsEnabled="terminal.integrated.tabs.enabled",o.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",o.TabsHideCondition="terminal.integrated.tabs.hideCondition",o.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",o.TabsShowActions="terminal.integrated.tabs.showActions",o.TabsLocation="terminal.integrated.tabs.location",o.TabsFocusMode="terminal.integrated.tabs.focusMode",o.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",o.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",o.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",o.CopyOnSelection="terminal.integrated.copyOnSelection",o.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",o.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",o.FontFamily="terminal.integrated.fontFamily",o.FontSize="terminal.integrated.fontSize",o.LetterSpacing="terminal.integrated.letterSpacing",o.LineHeight="terminal.integrated.lineHeight",o.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",o.TabStopWidth="terminal.integrated.tabStopWidth",o.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",o.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",o.BellDuration="terminal.integrated.bellDuration",o.FontWeight="terminal.integrated.fontWeight",o.FontWeightBold="terminal.integrated.fontWeightBold",o.CursorBlinking="terminal.integrated.cursorBlinking",o.CursorStyle="terminal.integrated.cursorStyle",o.CursorStyleInactive="terminal.integrated.cursorStyleInactive",o.CursorWidth="terminal.integrated.cursorWidth",o.Scrollback="terminal.integrated.scrollback",o.DetectLocale="terminal.integrated.detectLocale",o.DefaultLocation="terminal.integrated.defaultLocation",o.GpuAcceleration="terminal.integrated.gpuAcceleration",o.TerminalTitleSeparator="terminal.integrated.tabs.separator",o.TerminalTitle="terminal.integrated.tabs.title",o.TerminalDescription="terminal.integrated.tabs.description",o.RightClickBehavior="terminal.integrated.rightClickBehavior",o.MiddleClickBehavior="terminal.integrated.middleClickBehavior",o.Cwd="terminal.integrated.cwd",o.ConfirmOnExit="terminal.integrated.confirmOnExit",o.ConfirmOnKill="terminal.integrated.confirmOnKill",o.EnableBell="terminal.integrated.enableBell",o.EnableVisualBell="terminal.integrated.enableVisualBell",o.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",o.AllowChords="terminal.integrated.allowChords",o.AllowMnemonics="terminal.integrated.allowMnemonics",o.TabFocusMode="terminal.integrated.tabFocusMode",o.EnvMacOs="terminal.integrated.env.osx",o.EnvLinux="terminal.integrated.env.linux",o.EnvWindows="terminal.integrated.env.windows",o.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",o.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",o.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",o.ShowExitAlert="terminal.integrated.showExitAlert",o.SplitCwd="terminal.integrated.splitCwd",o.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",o.WordSeparators="terminal.integrated.wordSeparators",o.EnableFileLinks="terminal.integrated.enableFileLinks",o.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",o.UnicodeVersion="terminal.integrated.unicodeVersion",o.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",o.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",o.HideOnStartup="terminal.integrated.hideOnStartup",o.CustomGlyphs="terminal.integrated.customGlyphs",o.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",o.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",o.InheritEnv="terminal.integrated.inheritEnv",o.ShowLinkHover="terminal.integrated.showLinkHover",o.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",o.AutoReplies="terminal.integrated.autoReplies",o.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",o.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",o.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",o.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",o.EnableImages="terminal.integrated.enableImages",o.SmoothScrolling="terminal.integrated.smoothScrolling",o.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",o.FocusAfterRun="terminal.integrated.focusAfterRun",o.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",o.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",o.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var O;(function(o){o.Bash="bash",o.Fish="fish",o.Sh="sh",o.Csh="csh",o.Ksh="ksh",o.Zsh="zsh"})(O||(e.PosixShellType=O={}));var m;(function(o){o.CommandPrompt="cmd",o.Wsl="wsl",o.GitBash="gitbash"})(m||(e.WindowsShellType=m={}));var s;(function(o){o.PowerShell="pwsh",o.Python="python",o.Julia="julia",o.NuShell="nu"})(s||(e.GeneralShellType=s={}));var I;(function(o){o[o.Api=0]="Api",o[o.Process=1]="Process",o[o.Sequence=2]="Sequence",o[o.Config=3]="Config"})(I||(e.TitleEventSource=I={}));var w;(function(o){o.LocalPty="localPty",o.PtyHost="ptyHost",o.PtyHostWindow="ptyHostWindow",o.Logger="logger",o.Heartbeat="heartbeat"})(w||(e.TerminalIpcChannels=w={}));var u;(function(o){o.Cwd="cwd",o.InitialCwd="initialCwd",o.FixedDimensions="fixedDimensions",o.Title="title",o.ShellType="shellType",o.HasChildProcesses="hasChildProcesses",o.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",o.OverrideDimensions="overrideDimensions",o.FailedShellIntegrationActivation="failedShellIntegrationActivation",o.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(u||(e.ProcessPropertyType=u={})),e.$xs=(0,v.$Ki)("ptyService");var E;(function(o){o[o.BeatInterval=5e3]="BeatInterval",o[o.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",o[o.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",o[o.SecondWaitMultiplier=1]="SecondWaitMultiplier",o[o.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E||(e.HeartbeatConstants=E={}));var p;(function(o){o[o.Panel=1]="Panel",o[o.Editor=2]="Editor"})(p||(e.TerminalLocation=p={}));var r;(function(o){o.TerminalView="view",o.Editor="editor"})(r||(e.TerminalLocationString=r={}));var l;(function(o){o[o.GraceTime=6e4]="GraceTime",o[o.ShortGraceTime=6e3]="ShortGraceTime"})(l||(e.LocalReconnectConstants=l={}));var d;(function(o){o[o.HighWatermarkChars=1e5]="HighWatermarkChars",o[o.LowWatermarkChars=5e3]="LowWatermarkChars",o[o.CharCountAckSize=5e3]="CharCountAckSize"})(d||(e.FlowControlConstants=d={}));var a;(function(o){o.GitBash="Git Bash",o.Pwsh="PowerShell"})(a||(e.ProfileSource=a={}));var i;(function(o){o[o.Off=0]="Off",o[o.FinalTerm=1]="FinalTerm",o[o.VSCode=2]="VSCode"})(i||(e.ShellIntegrationStatus=i={}));var n;(function(o){o[o.Unknown=0]="Unknown",o[o.Shutdown=1]="Shutdown",o[o.Process=2]="Process",o[o.User=3]="User",o[o.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$ys={Backend:"workbench.contributions.terminal.processBackend"};class t{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(c){const g=this.b(c.remoteAuthority);if(this.a.has(g))throw new Error(`A terminal backend with remote authority '${g}' was already registered.`);this.a.set(g,c)}getTerminalBackend(c){return this.a.get(this.b(c))}b(c){return c?.toLowerCase()??""}}P.$xo.add(e.$ys.Backend,new t),e.$zs=(0,v.$Ki)("localPtyService"),e.$As=(0,v.$Ki)("terminalLogService")}),define(Re[181],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3zb=void 0;class v{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,L,R=5){const O=L(m=>{const s=typeof m=="string"?m:m.data;let I=this.a.get(P);if(I){I.data.push(s);return}const w=setTimeout(()=>this.flushBuffer(P),R);I={data:[s],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(P),O.dispose()}},this.a.set(P,I)});return O}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const L=this.a.get(P);L&&(this.a.delete(P),this.b(P,L.data.join("")))}}e.$3zb=v}),define(Re[182],Te([1,0,10,98,282,36,6,14,2,9,78,29]),function(we,e,v,D,P,L,R,O,m,s,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rx=e.$Qx=e.$Px=e.$Ox=e.$Nx=e.$Mx=e.IconFontDefinition=e.IconContribution=e.$Jx=void 0,e.$Kx=l,e.$Lx=d,w=Ve(w),e.$Jx={IconContribution:"base.contributions.icons"};var u;(function(t){function o(c,g){let f=c.defaults;for(;L.ThemeIcon.isThemeIcon(f);){const h=r.getIcon(f.id);if(!h)return;f=h.defaults}return f}t.getDefinition=o})(u||(e.IconContribution=u={}));var E;(function(t){function o(g){return{weight:g.weight,style:g.style,src:g.src.map(f=>({format:f.format,location:f.location.toString()}))}}t.toJSONObject=o;function c(g){const f=h=>(0,O.$jg)(h)?h:void 0;if(g&&Array.isArray(g.src)&&g.src.every(h=>(0,O.$jg)(h.format)&&(0,O.$jg)(h.location)))return{weight:f(g.weight),style:f(g.style),src:g.src.map(h=>({format:h.format,location:m.URI.parse(h.location)}))}}t.fromJSONObject=c})(E||(e.IconFontDefinition=E={}));class p{constructor(){this.a=new R.$qe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,s.localize)(2364,null)},fontCharacter:{type:"string",description:(0,s.localize)(2365,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${L.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,c,g,f){const h=this.b[o];if(h){if(g&&!h.description){h.description=g,this.d.properties[o].markdownDescription=`${g} $(${o})`;const y=this.e.enum.indexOf(o);y!==-1&&(this.e.enumDescriptions[y]=g),this.a.fire()}return h}const S={id:o,description:g,defaults:c,deprecationMessage:f};this.b[o]=S;const k={$ref:"#/definitions/icons"};return f&&(k.deprecationMessage=f),g&&(k.markdownDescription=`${g}: $(${o})`),this.d.properties[o]=k,this.e.enum.push(o),this.e.enumDescriptions.push(g||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const c=this.e.enum.indexOf(o);c!==-1&&(this.e.enum.splice(c,1),this.e.enumDescriptions.splice(c,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,c){const g=this.f[o];return g||(this.f[o]=c,this.a.fire(),c)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(h,S)=>h.id.localeCompare(S.id),c=h=>{for(;L.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},g=[];g.push("| preview     | identifier                        | default codicon ID                | description"),g.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.b).map(h=>this.b[h]);for(const h of f.filter(S=>!!S.description).sort(o))g.push(`|<i class="${c(h)}"></i>|${h.id}|${L.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);g.push("| preview     | identifier                        "),g.push("| ----------- | --------------------------------- |");for(const h of f.filter(S=>!L.ThemeIcon.isThemeIcon(S.defaults)).sort(o))g.push(`|<i class="${c(h)}"></i>|${h.id}|`);return g.join(`
`)}}const r=new p;w.$xo.add(e.$Jx.IconContribution,r);function l(t,o,c,g){return r.registerIcon(t,o,c,g)}function d(){return r}function a(){const t=(0,P.$6j)();for(const o in t){const c="\\"+t[o].toString(16);r.registerIcon(o,{fontCharacter:c})}}a(),e.$Mx="vscode://schemas/icons";const i=w.$xo.as(I.$yo.JSONContribution);i.registerSchema(e.$Mx,r.getIconSchema());const n=new v.$Wh(()=>i.notifySchemaChanged(e.$Mx),200);r.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Nx=l("widget-close",D.$0j.close,(0,s.localize)(2366,null)),e.$Ox=l("goto-previous-location",D.$0j.arrowUp,(0,s.localize)(2367,null)),e.$Px=l("goto-next-location",D.$0j.arrowDown,(0,s.localize)(2368,null)),e.$Qx=L.ThemeIcon.modify(D.$0j.sync,"spin"),e.$Rx=L.ThemeIcon.modify(D.$0j.loading,"spin")}),define(Re[183],Te([1,0,6,4,23,2,44,3,11]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yw=e.$Xw=e.$Uw=e.$Sw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ow=e.$Nw=void 0,e.$Pw=w,e.$Qw=E,e.$Rw=p,e.$Tw=r,e.$Vw=l,e.$Ww=d,e.$Nw=(0,O.$Ki)("tunnelService"),e.$Ow=(0,O.$Ki)("sharedTunnelsService");var s;(function(n){n.Http="http",n.Https="https"})(s||(e.TunnelProtocol=s={}));var I;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(I||(e.TunnelPrivacyId=I={}));function w(n){return!!n.forwardPort}var u;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function E(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function p(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const o of t){const c=o.split("=")[1];if(/^https?:/.exec(c)){const g=E(L.URI.parse(c));if(g)return g}}}e.$Sw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(n){return e.$Sw.indexOf(n)>=0}e.$Uw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(n){return e.$Uw.indexOf(n)>=0}function d(n,t,o,c){if(o===P.OperatingSystem.Windows)return!1;if(o===P.OperatingSystem.Macintosh&&l(t)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(g?.length===4&&parseInt(g[1])>=18)return!1}return n<1024}class a{constructor(t,o,c){this.remoteAddress=t,this.localAddress=o,this.b=c,this.a=new v.$qe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Xw=a;let i=class extends D.$Zc{constructor(t,o){super(),this.r=t,this.s=o,this.a=new v.$qe,this.onTunnelOpened=this.a.event,this.b=new v.$qe,this.onTunnelClosed=this.b.event,this.c=new v.$qe,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],o=Array.from(this.f.values());for(const c of o){const g=Array.from(c.values());for(const f of g){const h=await f.value;h&&typeof h!="string"&&t.push(h)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:o}of t.values())await o.then(c=>typeof c!="string"?c?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,o,c,g,f){this.z(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:c,privacy:g,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(l(t)||r(t))&&(t=e.$Sw[0]);const c=this.D(t,o);if(c)return++c.refcount,c.value}openTunnel(t,o,c,g,f,h=!1,S,k){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${c} on local port ${f}.`);const y=this.g??t;if(!y)return;if(o||(o="localhost"),g||(g=this.t),this.g&&this.n.has(c)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.F(y,o,c,g,f,h,S,k);return C?C.then(T=>{if(T){if(typeof T=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(o,c),T}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(o,c);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.w(T);return(T.tunnelRemoteHost!==o||T.tunnelRemotePort!==c)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),S&&T.privacy!==S&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this.f.get(t.tunnelRemoteHost);if(o){const c=o.get(t.tunnelRemotePort);c&&(c.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,c))}}}}async y(t,o,c){if(c.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const g=c.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(o),g}}async closeTunnel(t,o){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const c=this.f.get(t);if(c&&c.has(o)){const g=c.get(o);g.refcount=0,await this.y(t,o,g)}}z(t,o,c){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(o,{refcount:1,value:c})}async C(t,o){const c=this.f.get(t);if(c){const g=c.get(o),f=g?await g.value:void 0;(!f||typeof f=="string")&&c.delete(o),c.size===0&&this.f.delete(t)}}D(t,o){const c=[t];r(t)?(c.push(...e.$Sw),c.push(...e.$Uw)):l(t)&&c.push(...e.$Uw);const g=c.map(f=>this.f.get(f));for(const f of g){const h=f?.get(o);if(h)return h}}canTunnel(t){return!!E(t)}G(t,o,c,g,f,h,S){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${c} on local port ${g}.`);const k=c;this.n.add(k);const y=g===void 0?c:g,C={elevationRequired:f?this.isPortPrivileged(y):!1},T={remoteAddress:{host:o,port:c},localAddressPort:g,privacy:h,public:h?h!==I.Private:void 0,protocol:S},$=t.forwardPort(T,C);return $?(this.z(o,c,$),$.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(k)})):this.n.delete(k),$}};e.$Yw=i,e.$Yw=i=He([qe(0,m.$fk),qe(1,R.$ej)],i)}),define(Re[114],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0,e.$Pl=(0,v.$Ki)("IUriIdentityService")}),define(Re[184],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Zw=void 0,e.$Zw=(0,v.$Ki)("editSessionIdentityService");var D;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(D||(e.EditSessionIdentityMatch=D={}))}),define(Re[185],Te([1,0,15]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GN=D,e.$HN=P,e.$IN=L,e.$JN=R,e.$KN=O;function D(m){return m.scheme!==v.Schemas.file&&m.scheme!==v.Schemas.vscodeRemote}function P(m){if(m.folders.length)return m.folders.every(s=>D(s.uri))?m.folders[0].uri:void 0;if(m.configuration&&D(m.configuration))return m.configuration}function L(m){return P(m)?.scheme}function R(m){return P(m)?.authority}function O(m){return P(m)!==void 0}}),define(Re[49],Te([1,0,9,22,48,24,2,3,15]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$0i=e.$9i=e.$8i=e.$7i=e.$5i=e.$4i=e.WorkbenchState=e.$Xi=e.$Wi=e.$Ti=void 0,e.$Ui=s,e.$Vi=I,e.$Yi=w,e.$Zi=u,e.$1i=E,e.$2i=r,e.$3i=l,e.$6i=i,e.$$i=n,e.$_i=t,e.$bj=o,e.$cj=c,e.$dj=g,e.$Ti=(0,O.$Ki)("contextService");function s(f){const h=f;return typeof h?.id=="string"&&R.URI.isUri(h.uri)}function I(f){return typeof f?.id=="string"&&!s(f)&&!u(f)}e.$Wi={id:"ext-dev"},e.$Xi={id:"empty-window"};function w(f,h){if(typeof f=="string"||typeof f>"u")return typeof f=="string"?{id:(0,D.$sc)(f)}:h?e.$Wi:e.$Xi;const S=f;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function u(f){const h=f;return typeof h?.id=="string"&&R.URI.isUri(h.configPath)}function E(f){const h=f;if(h?.uri)return{id:h.id,uri:R.URI.revive(h.uri)};const S=f;if(S?.configPath)return{id:S.id,configPath:R.URI.revive(S.configPath)};if(f?.id)return{id:f.id}}var p;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function r(f){const h=f;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}function l(f){const h=f;return!!(h&&typeof h=="object"&&R.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}class d{constructor(h,S,k,y,C){this.h=h,this.j=k,this.k=y,this.l=C,this.c=P.$Qi.forUris(this.l,()=>!0),this.folders=S}update(h){this.h=h.id,this.k=h.configuration,this.j=h.transient,this.l=h.l,this.folders=h.folders}get folders(){return this.g}set folders(h){this.g=h,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(h){this.k=h}getFolder(h){return h&&this.c.findSubstr(h)||null}n(){this.c=P.$Qi.forUris(this.l,()=>!0);for(const h of this.folders)this.c.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$4i=d;class a{constructor(h,S){this.raw=S,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,L.$lh)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$5i=a;function i(f){return new a({uri:f,index:0,name:(0,L.$hh)(f)},{uri:f.toString()})}e.$7i="code-workspace",e.$8i=`.${e.$7i}`,e.$9i=[{name:(0,v.localize)(2489,null),extensions:[e.$7i]}],e.$0i="workspace.json";function n(f,h){return L.$ch.isEqualOrParent(f,h.untitledWorkspacesHome)}function t(f){let h;return R.URI.isUri(f)?h=f:h=f.configuration,h?.scheme===m.Schemas.tmp}e.$aj="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function o(f){return f.id===e.$aj}function c(f,h){return!n(f,h)&&!t(f)}function g(f){return(typeof f=="string"?(0,D.$tc)(f):(0,L.$jh)(f))===e.$8i}}),define(Re[115],Te([1,0,76,6,4,24,2,9,107,28,3,11,49,27,114,10,33,13,14]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Rl=e.ProfileResourceType=void 0,e.$Ql=n,e.$Sl=t,e.$Tl=o;var i;(function(f){f.Settings="settings",f.Keybindings="keybindings",f.Snippets="snippets",f.Tasks="tasks",f.Extensions="extensions",f.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function n(f){const h=f;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&typeof h.isDefault=="boolean"&&typeof h.name=="string"&&R.URI.isUri(h.location)&&R.URI.isUri(h.globalStorageHome)&&R.URI.isUri(h.settingsResource)&&R.URI.isUri(h.keybindingsResource)&&R.URI.isUri(h.tasksResource)&&R.URI.isUri(h.snippetsHome)&&R.URI.isUri(h.extensionsResource))}e.$Rl=(0,I.$Ki)("IUserDataProfilesService");function t(f,h){return{id:f.id,isDefault:f.isDefault,name:f.name,shortName:f.shortName,icon:f.icon,location:R.URI.revive(f.location).with({scheme:h}),globalStorageHome:R.URI.revive(f.globalStorageHome).with({scheme:h}),settingsResource:R.URI.revive(f.settingsResource).with({scheme:h}),keybindingsResource:R.URI.revive(f.keybindingsResource).with({scheme:h}),tasksResource:R.URI.revive(f.tasksResource).with({scheme:h}),snippetsHome:R.URI.revive(f.snippetsHome).with({scheme:h}),extensionsResource:R.URI.revive(f.extensionsResource).with({scheme:h}),cacheHome:R.URI.revive(f.cacheHome).with({scheme:h}),useDefaultFlags:f.useDefaultFlags,isTransient:f.isTransient}}function o(f,h,S,k,y,C){return{id:f,name:h,location:S,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:C&&y?.useDefaultFlags?.globalState?C.globalStorageHome:(0,L.$lh)(S,"globalStorage"),settingsResource:C&&y?.useDefaultFlags?.settings?C.settingsResource:(0,L.$lh)(S,"settings.json"),keybindingsResource:C&&y?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,L.$lh)(S,"keybindings.json"),tasksResource:C&&y?.useDefaultFlags?.tasks?C.tasksResource:(0,L.$lh)(S,"tasks.json"),snippetsHome:C&&y?.useDefaultFlags?.snippets?C.snippetsHome:(0,L.$lh)(S,"snippets"),extensionsResource:C&&y?.useDefaultFlags?.extensions?C.extensionsResource:(0,L.$lh)(S,"extensions.json"),cacheHome:(0,L.$lh)(k,f),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let c=class extends P.$Zc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(h,S,k,y){super(),this.t=h,this.u=S,this.w=k,this.y=y,this.f=!0,this.h=this.B(new D.$qe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$qe),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$qe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$qe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new E.$Fc,workspaces:new E.$Fc,emptyWindows:new Map},this.profilesHome=(0,L.$lh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$lh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(h){this.f!==h&&(this.z=void 0,this.f=h)}isEnabled(){return this.f}get C(){if(!this.z){const h=this.D(),S=[h];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,a.$jg)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}S.push(o((0,L.$ih)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},h))}}catch(C){this.y.error(C)}const k=new E.$Fc,y=new Map;if(S.length)try{const C=this.Q();if(C.workspaces)for(const[T,$]of Object.entries(C.workspaces)){const b=R.URI.parse(T),N=S.find(A=>A.id===$);N&&k.set(b,N)}if(C.emptyWindows)for(const[T,$]of Object.entries(C.emptyWindows)){const b=S.find(N=>N.id===$);b&&y.set(T,b)}}catch(C){this.y.error(C)}this.z={profiles:S,workspaces:k,emptyWindows:y}}return this.z}D(){const h=o("__default__profile__",(0,O.localize)(2442,null),this.t.userRoamingDataHome,this.g);return{...h,extensionsResource:this.S()??h.extensionsResource,isDefault:!0}}async createTransientProfile(h){const S="Temp",k=new RegExp(`${(0,d.$mf)(S)}\\s(\\d+)`);let y=0;for(const T of this.profiles){const $=k.exec(T.name),b=$?parseInt($[1]):0;y=b>y?b:y}const C=`${S} ${y+1}`;return this.createProfile((0,v.$yj)((0,l.$7g)()).toString(16),C,{transient:!0},h)}async createNamedProfile(h,S,k){return this.createProfile((0,v.$yj)((0,l.$7g)()).toString(16),h,S,k)}async createProfile(h,S,k,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(h,S,k);return y&&await this.setProfileForWorkspace(y,C),C}async F(h,S,k){if(!(0,a.$jg)(S)||!S)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(S);return y||(y=(async()=>{try{if(this.profiles.find(b=>b.name===S||b.id===h))throw new Error(`Profile with ${S} name already exists`);const T=o(h,S,(0,L.$lh)(this.profilesHome,h),this.g,k,this.defaultProfile);await this.u.createFolder(T.location);const $=[];return this.j.fire({profile:T,join(b){$.push(b)}}),await r.Promises.settled($),this.I([T],[],[]),T}finally{this.r.delete(S)}})(),this.r.set(S,y)),y}async updateProfile(h,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(y=>y.id===h.id);if(!k)throw new Error(`Profile '${h.name}' does not exist`);return k=o(k.id,S.name??k.name,k.location,this.g,{shortName:S.shortName??k.shortName,icon:S.icon===null?void 0:S.icon??k.icon,transient:S.transient??k.isTransient,useDefaultFlags:S.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(h.isDefault)throw new Error("Cannot remove default profile");const S=this.profiles.find(y=>y.id===h.id);if(!S)throw new Error(`Profile '${h.name}' does not exist`);const k=[];this.m.fire({profile:S,join(y){k.push(y)}});try{await Promise.allSettled(k)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])S.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])S.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[S],[]);try{await this.u.del(S.cacheHome,{recursive:!0})}catch(y){(0,s.$wl)(y)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(h,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(y=>y.id===S.id);if(!k)throw new Error(`Profile '${S.name}' does not exist`);this.L(h,k)}unsetWorkspace(h,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(h,void 0,S)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const h=await this.u.resolve(this.profilesHome);await Promise.all((h.children||[]).filter(S=>S.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,S.resource))).map(S=>this.u.del(S.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const h=this.s.profiles.filter(S=>!this.H(S));await Promise.allSettled(h.map(S=>this.removeProfile(S)))}getProfileForWorkspace(h){const S=this.G(h),k=R.URI.isUri(S)?this.C.workspaces.get(S):this.C.emptyWindows.get(S);return k||((0,u.$Ui)(h)?this.s.folders.get(h.uri):(0,u.$Zi)(h)?this.s.workspaces.get(h.configPath):this.s.emptyWindows.get(h.id))}G(h){return(0,u.$Ui)(h)?h.uri:(0,u.$Zi)(h)?h.configPath:h.id}H(h){return!!([...this.C.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,h.location))||[...this.C.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,h.location))||[...this.s.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,h.location))||[...this.s.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,h.location))||[...this.s.folders.values()].some(S=>this.w.extUri.isEqual(S.location,h.location)))}I(h,S,k){const y=[...this.profiles,...h],C=[],T=this.s.profiles;this.s.profiles=[];for(let $ of y){if($.isDefault||S.some(N=>$.id===N.id))continue;$=k.find(N=>$.id===N.id)??$;const b=T.find(N=>$.id===N.id);if($.isTransient)this.s.profiles.push($);else{if(b){for(const[N,A]of this.s.emptyWindows.entries())if($.id===A.id){this.L({id:N},$);break}for(const[N,A]of this.s.workspaces.entries())if($.id===A.id){this.L({id:"",configPath:N},$);break}for(const[N,A]of this.s.folders.entries())if($.id===A.id){this.L({id:"",uri:N},$);break}}C.push({location:$.location,name:$.name,shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags})}}this.P(C),this.z=void 0,this.J(h,S,k)}J(h,S,k){this.h.fire({added:h,removed:S,updated:k,all:this.profiles})}L(h,S,k){if(k=S?.isTransient?!0:k,k)(0,u.$Ui)(h)?(this.s.folders.delete(h.uri),S&&this.s.folders.set(h.uri,S)):(0,u.$Zi)(h)?(this.s.workspaces.delete(h.configPath),S&&this.s.workspaces.set(h.configPath,S)):(this.s.emptyWindows.delete(h.id),S&&this.s.emptyWindows.set(h.id,S));else{this.L(h,void 0,!0);const y=this.G(h);R.URI.isUri(y)?(this.C.workspaces.delete(y),S&&this.C.workspaces.set(y,S)):(this.C.emptyWindows.delete(y),S&&this.C.emptyWindows.set(y,S)),this.M()}}M(){const h={};for(const[k,y]of this.C.workspaces.entries())h[k.toString()]=y.id;const S={};for(const[k,y]of this.C.emptyWindows.entries())S[k.toString()]=y.id;this.R({workspaces:h,emptyWindows:S}),this.z=void 0}N(h){const S={},k=this.D();if(h.workspaces)for(const[C,T]of Object.entries(h.workspaces)){const $=R.URI.parse(T);S[C]=this.w.extUri.isEqual($,k.location)?k.id:this.w.extUri.basename($)}const y={};if(h.emptyWindows)for(const[C,T]of Object.entries(h.emptyWindows)){const $=R.URI.parse(T);y[C]=this.w.extUri.isEqual($,k.location)?k.id:this.w.extUri.basename($)}return{workspaces:S,emptyWindows:y}}O(){return[]}P(h){throw new Error("not implemented")}Q(){return{}}R(h){throw new Error("not implemented")}S(){}};e.$Ul=c,e.$Ul=c=He([qe(0,m.$Ri),qe(1,s.$fl),qe(2,p.$Pl),qe(3,w.$fk)],c);class g extends c{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(h){this.a=h}Q(){return this.X}R(h){this.X=h}}e.$Vl=g}),define(Re[186],Te([1,0,10,6,4,64,14,160,3,115]),function(we,e,v,D,P,L,R,O,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$qq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$oq=e.$nq=e.$mq=void 0,e.$pq=E,e.$rq=r,e.$tq=d,e.$mq="__$__isNewStorageMarker",e.$nq="__$__targetStorageMarker",e.$oq=(0,m.$Ki)("storageService");var I;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var w;(function(a){a[a.APPLICATION=-1]="APPLICATION",a[a.PROFILE=0]="PROFILE",a[a.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var u;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function E(a){const i=a.get(e.$nq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class p extends P.$Zc{static{this.a=60*1e3}constructor(i={flushInterval:p.a}){super(),this.m=i,this.b=this.B(new D.$te),this.c=this.B(new D.$te),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$qe),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Wh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$1c),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,n,t){return D.Event.filter(this.b.event,o=>o.scope===i&&(n===void 0||o.key===n),t)}n(){this.j.value=(0,v.$1h)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Uc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,n){const{key:t,external:o}=n;if(t===e.$nq){switch(i){case w.APPLICATION:this.H=void 0;break;case w.PROFILE:this.F=void 0;break;case w.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:o})}w(i){this.f.fire({reason:i})}get(i,n,t){return this.P(n)?.get(i,t)}getBoolean(i,n,t){return this.P(n)?.getBoolean(i,t)}getNumber(i,n,t){return this.P(n)?.getNumber(i,t)}getObject(i,n,t){return this.P(n)?.getObject(i,t)}storeAll(i,n){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,n)})}store(i,n,t,o,c=!1){if((0,R.$sg)(n)){this.remove(i,t,c);return}this.y(()=>{this.z(i,t,o),this.P(t)?.set(i,n,c)})}remove(i,n,t=!1){this.y(()=>{this.z(i,n,void 0),this.P(n)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,n){const t=[],o=this.J(i);for(const c of Object.keys(o))o[c]===n&&t.push(c);return t}z(i,n,t,o=!1){const c=this.J(n);typeof t=="number"?c[i]!==t&&(c[i]=t,this.P(n)?.set(e.$nq,JSON.stringify(c),o)):typeof c[i]=="number"&&(delete c[i],this.P(n)?.set(e.$nq,JSON.stringify(c),o))}get D(){return this.C||(this.C=this.L(w.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(w.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(w.APPLICATION)),this.H}J(i){switch(i){case w.APPLICATION:return this.I;case w.PROFILE:return this.G;default:return this.D}}L(i){const n=this.P(i);return n?E(n):Object.create(null)}isNew(i){return this.getBoolean(e.$mq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const n=this.P(w.APPLICATION),t=this.P(w.PROFILE),o=this.P(w.WORKSPACE);switch(i){case I.NONE:await v.Promises.settled([n?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await v.Promises.settled([n?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(w.APPLICATION)?.items??new Map,n=this.P(w.PROFILE)?.items??new Map,t=this.P(w.WORKSPACE)?.items??new Map;return d(i,n,t,this.Q(w.APPLICATION)??"",this.Q(w.PROFILE)??"",this.Q(w.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,n){return this.w(I.NONE),(0,s.$Ql)(i)?this.R(i,n):this.S(i,n)}M(i,n){return!(i.id===n.id||r(n)&&r(i))}N(i,n,t){this.y(()=>{const o=new Set;for(const[c,g]of i)o.add(c),n.get(c)!==g&&this.u(t,{key:c,external:!0});for(const[c]of n.items)o.has(c)||this.u(t,{key:c,external:!0})})}}e.$qq=p;function r(a){return a.isDefault||!!a.useDefaultFlags?.globalState}class l extends p{constructor(){super(),this.U=this.B(new O.$kq(new O.$lq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$kq(new O.$lq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$kq(new O.$lq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(w.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(w.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(w.APPLICATION,i)))}P(i){switch(i){case w.APPLICATION:return this.U;case w.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case w.APPLICATION:return"inMemory (application)";case w.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$sq=l;async function d(a,i,n,t,o,c){const g=b=>{try{return JSON.parse(b)}catch{return b}},f=new Map,h=new Map;a.forEach((b,N)=>{f.set(N,b),h.set(N,g(b))});const S=new Map,k=new Map;i.forEach((b,N)=>{S.set(N,b),k.set(N,g(b))});const y=new Map,C=new Map;n.forEach((b,N)=>{y.set(N,b),C.set(N,g(b))}),console.group(t!==o?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const T=[];if(f.forEach((b,N)=>{T.push({key:N,value:b})}),console.table(T),console.groupEnd(),console.log(h),t!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const b=[];S.forEach((N,A)=>{b.push({key:A,value:N})}),console.table(b),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${c})`);const $=[];y.forEach((b,N)=>{$.push({key:N,value:b})}),console.table($),console.groupEnd(),console.log(C)}}),define(Re[80],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qqc=void 0;class v{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const L=this.c++;return this.b.set(L,P),this.e(),L}get(P,L){return this.b.has(P)?this.b.get(P)[L]:void 0}delete(P){this.b.delete(P),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Qqc=v}),define(Re[50],Te([1,0,15,24,28,3]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wqc=e.$Vqc=void 0;class R{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new D.$ah(m=>{const s=this.b.get(m.scheme);return!(s===void 0||s&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(m,s){s===null?this.b.delete(m.scheme):this.b.set(m.scheme,s)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$Vqc=R,e.$Wqc=(0,L.$Ki)("IExtHostFileSystemInfo")}),define(Re[26],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Q=void 0,e.$1Q=(0,v.$Ki)("IExtHostInitDataService")}),define(Re[187],Te([1,0,9,11,172,26]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0sc=void 0;let R=class extends P.$$R{constructor(m,s,I){const w=I.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",u=I.remote.isRemote?(0,v.localize)(2706,null):m?(0,v.localize)(2707,null):(0,v.localize)(2708,null);super(s.createLogger(w,{name:u}))}};e.$0sc=R,e.$0sc=R=He([qe(1,D.$gk),qe(2,L.$1Q)],R)}),define(Re[188],Te([1,0,10]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Crc=e.$Brc=void 0;class D{constructor(R,O,m){this.h=new Map,this.a=R,this.b=O,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(s=>(this.f=s,this)),this.g=this.c.onDidChangeStorage(s=>{s.shared===this.b&&s.key===this.a&&(this.f=s.value)}),this.i=new v.$Wh(()=>{const s=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of s.values())I.complete()}catch(I){for(const w of s.values())w.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,O){let m=this.f[R];return typeof m>"u"&&(m=O),m}update(R,O){this.f[R]=O;const m=this.h.get(R);if(m!==void 0)return m.p;const s=new v.$8h;return this.h.set(R,s),this.i.isScheduled()||this.i.schedule(),s.p}dispose(){this.g.dispose()}}e.$Brc=D;class P extends D{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,O){super(R.identifier.value,!0,O),this.j=R}}e.$Crc=P}),define(Re[189],Te([1,0,6,2]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bsc=void 0;class P{constructor(R){this.c=R,this.a=new v.$qe,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$qe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,O,m,s){const w=this.c.getNotebookDocument(D.URI.revive(R)).acceptModelChanged(O.value,m,s);this.b.fire(w)}$acceptDirtyStateChanged(R,O){this.c.getNotebookDocument(D.URI.revive(R)).acceptDirty(O)}$acceptModelSaved(R){const O=this.c.getNotebookDocument(D.URI.revive(R));this.a.fire(O.apiNotebook)}}e.$Bsc=P}),define(Re[16],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LQ=e.$KQ=void 0,e.$KQ=(0,v.$Ki)("IExtHostRpcService");class D{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$LQ=D}),define(Re[190],Te([1,0,18,6,4]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lrc=void 0;class L{#e;constructor(O,m){this.disposables=new P.$Yc,this.a=v.$xn.toKey(O.identifier),this.#e=m,this.onDidChange=D.Event.map(D.Event.filter(this.#e.onDidChangePassword,s=>s.extensionId===this.a),s=>({key:s.key}),this.disposables)}dispose(){this.disposables.dispose()}get(O){return this.#e.get(this.a,O)}store(O,m){return this.#e.store(this.a,O,m)}delete(O){return this.#e.delete(this.a,O)}}e.$Lrc=L}),define(Re[65],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=e.$_qc=void 0,e.$_qc=(0,v.$Ki)("IURITransformerService");class D{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$arc=D});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[116],Te([1,0,9,14,2,4,3,29,28,15,42,156,37]),function(we,e,v,D,P,L,R,O,m,s,I,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$HG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$xG=e.EditorInputCapabilities=e.$wG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=void 0,e.$nG=r,e.$oG=l,e.$pG=d,e.$qG=a,e.$rG=i,e.$sG=n,e.$tG=t,e.$uG=o,e.$vG=c,e.$yG=y,e.$zG=T,e.$AG=$,e.$BG=b,e.$CG=N,e.$DG=A,e.$EG=F,e.$FG=G,e.$GG=ae,e.$IG=ie,e.$JG=_,e.$KG=$e,e.$LG=Ie,u=oi(u),e.$iG={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$jG={id:"default",displayName:(0,v.localize)(4055,null),providerDisplayName:(0,v.localize)(4056,null)},e.$kG="workbench.editor.sidebysideEditor",e.$lG="workbench.editors.textDiffEditor",e.$mG="workbench.editors.binaryResourceDiffEditor";var E;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var p;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function r(X){const V=X;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}function l(X){const V=X;return!!V&&typeof V.getScrollPosition=="function"&&typeof V.setScrollPosition=="function"&&!!V.onDidChangeScroll}function d(X,V,re){for(const be of re.visibleEditorPanes)if(be.group.id===V&&X.matches(be.input))return be.getViewState()}function a(X){if(y(X))return!1;const V=X;return P.URI.isUri(V?.resource)}function i(X){if(y(X))return!1;const V=X;return V?.original!==void 0&&V.modified!==void 0}function n(X){if(y(X))return!1;const V=X;return!V||V.resources&&!Array.isArray(V.resources)?!1:!!V.resources||!!V.multiDiffSource}function t(X){if(y(X)||i(X))return!1;const V=X;return V?.primary!==void 0&&V.secondary!==void 0}function o(X){if(y(X))return!1;const V=X;return V?V.resource===void 0||V.resource.scheme===s.Schemas.untitled||V.forceUntitled===!0:!1}function c(X){if(y(X))return!1;const V=X;return P.URI.isUri(V?.base?.resource)&&P.URI.isUri(V?.input1?.resource)&&P.URI.isUri(V?.input2?.resource)&&P.URI.isUri(V?.result?.resource)}var g;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(g||(e.Verbosity=g={}));var f;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f||(e.SaveReason=f={}));class h{constructor(){this.a=new Map}registerSource(V,re){let be=this.a.get(V);return be||(be={source:V,label:re},this.a.set(V,be)),be.source}getSourceLabel(V){return this.a.get(V)?.label??V}}e.$wG=new h;var S;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class k extends L.$Zc{}e.$xG=k;function y(X){return X instanceof k}function C(X){const V=X;return P.URI.isUri(V?.preferredResource)}function T(X){const V=X;return y(V?.primary)&&y(V?.secondary)}function $(X){const V=X;return y(V?.modified)&&y(V?.original)}function b(X,V,re,be,Pe){return Ie(be,[(0,w.$uj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(4057,null),run:()=>{const Fe={...re,limits:{size:Number.MAX_VALUE}};X.openEditor(V,Fe)}}),(0,w.$uj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(4058,null),run:()=>Pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function N(X){return y(X?.editor)}function A(X){const V=X;return N(X)&&V?.group!==void 0}function F(X){const V=X;return typeof V?.groupId=="number"&&y(V.editor)}function G(X){return typeof X?.groupId=="number"}var x;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(x||(e.EditorCloseContext=x={}));var j;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LABEL=2]="GROUP_LABEL",X[X.GROUP_LOCKED=3]="GROUP_LOCKED",X[X.EDITORS_SELECTION=4]="EDITORS_SELECTION",X[X.EDITOR_OPEN=5]="EDITOR_OPEN",X[X.EDITOR_CLOSE=6]="EDITOR_CLOSE",X[X.EDITOR_MOVE=7]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=9]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=11]="EDITOR_PIN",X[X.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",X[X.EDITOR_STICKY=13]="EDITOR_STICKY",X[X.EDITOR_DIRTY=14]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var U;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class J{getOriginalUri(V,re){if(!V)return;if(c(V))return e.$HG.getOriginalUri(V.result,re);if(re?.supportSideBySide){const{primary:Pe,secondary:Fe}=this.a(V);if(Pe&&Fe){if(re?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Pe,{filterByScheme:re.filterByScheme}),secondary:this.getOriginalUri(Fe,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===U.ANY)return this.getOriginalUri(Pe,{filterByScheme:re.filterByScheme})??this.getOriginalUri(Fe,{filterByScheme:re.filterByScheme});V=re.supportSideBySide===U.PRIMARY?Pe:Fe}}if(i(V)||n(V)||t(V)||c(V))return;const be=C(V)?V.preferredResource:V.resource;return!be||!re||!re.filterByScheme?be:this.b(be,re.filterByScheme)}a(V){return T(V)||t(V)?{primary:V.primary,secondary:V.secondary}:$(V)||i(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,re){if(!V)return;if(c(V))return e.$HG.getCanonicalUri(V.result,re);if(re?.supportSideBySide){const{primary:Pe,secondary:Fe}=this.a(V);if(Pe&&Fe){if(re?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Pe,{filterByScheme:re.filterByScheme}),secondary:this.getCanonicalUri(Fe,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===U.ANY)return this.getCanonicalUri(Pe,{filterByScheme:re.filterByScheme})??this.getCanonicalUri(Fe,{filterByScheme:re.filterByScheme});V=re.supportSideBySide===U.PRIMARY?Pe:Fe}}if(i(V)||n(V)||t(V)||c(V))return;const be=V.resource;return!be||!re||!re.filterByScheme?be:this.b(be,re.filterByScheme)}b(V,re){if(Array.isArray(re)){if(re.some(be=>V.scheme===be))return V}else if(re===V.scheme)return V}}var Z;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.KEYBOARD=1]="KEYBOARD",X[X.MOUSE=2]="MOUSE"})(Z||(e.EditorCloseMethod=Z={}));function ae(X,V,re,be){if(!X.isSticky(V))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return re===Z.MOUSE||re===Z.KEYBOARD;case"mouse":return re===Z.MOUSE;case"keyboard":return re===Z.KEYBOARD}return!1}e.$HG=new J;var ee;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(ee||(e.CloseDirection=ee={}));class oe{constructor(){this.c=new Map,this.d=new Map}start(V){const re=this.a=V.get(R.$Ji);for(const[be,Pe]of this.c)this.e(be,Pe,re);this.c.clear()}e(V,re,be){const Pe=be.createInstance(re);this.d.set(V,Pe)}registerFileEditorFactory(V){if(this.b)throw new Error("Can only register one file editor factory.");this.b=V}getFileEditorFactory(){return(0,D.$ug)(this.b)}registerEditorSerializer(V,re){if(this.c.has(V)||this.d.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.a?this.e(V,re,this.a):this.c.set(V,re),(0,L.$Xc)(()=>{this.c.delete(V),this.d.delete(V)})}getEditorSerializer(V){return this.d.get(typeof V=="string"?V:V.typeId)}}O.$xo.add(e.$iG.EditorFactory,new oe);async function ie(X,V,re){return!X||!X.length?[]:await Promise.all(X.map(async be=>{const Pe=P.URI.revive(be.fileUri);if(!Pe){re.info("Cannot resolve the path because it is not valid.",be);return}if(!await V.canHandleResource(Pe)){re.info("Cannot resolve the path because it cannot be handled",be);return}let Be=be.exists,xe=be.type;if(typeof Be!="boolean"||typeof xe!="number")try{xe=(await V.stat(Pe)).isDirectory?m.FileType.Directory:m.FileType.Unknown,Be=!0}catch(ht){re.error(ht),Be=!1}if(!Be&&be.openOnlyIfExists){re.info("Cannot resolve the path because it does not exist",be);return}if(xe===m.FileType.Directory){re.info("Cannot resolve the path because it is a directory",be);return}const nt={...be.options,pinned:!0};return Be?{resource:Pe,options:nt}:{resource:Pe,options:nt,forceUntitled:!0}}))}var ue;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function _(X){const V=X;if(!V)return!1;const re=V;if(re.modified)return _(re.modified);const be=V;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function $e(X){return(0,I.$wj)(X)}function Ie(X,V,re){const be=(0,I.$xj)(X,V);return be.forceMessage=re?.forceMessage,be.forceSeverity=re?.forceSeverity,be.allowDialog=re?.allowDialog,be}}),define(Re[191],Te([1,0,6,9,3,4,27,29,25,98,182]),function(we,e,v,D,P,L,R,O,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TG=e.$SG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$RG=e.ViewContentGroups=e.$PG=e.ViewContainerLocation=e.Extensions=e.$OG=e.$NG=e.$MG=void 0,e.$QG=E,e.$MG="views",e.$NG=(0,D.localize)(4218,null),e.$OG=(0,I.$Kx)("default-view-icon",s.$0j.window,(0,D.localize)(4219,null));var w;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(w||(e.Extensions=w={}));var u;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$PG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function E(o){switch(o){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class p extends L.$Zc{constructor(){super(...arguments),this.c=this.B(new v.$qe),this.onDidRegister=this.c.event,this.f=this.B(new v.$qe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(c,g,f){const h=this.get(c.id);if(h)return h;const S=c;return S.openCommandActionDescriptor=f?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$Cc)(this.g,g,[]).push(S),f?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:g}),S}deregisterViewContainer(c){for(const g of this.g.keys()){const f=this.g.get(g),h=f?.indexOf(c);if(h!==-1){f?.splice(h,1),f.length===0&&this.g.delete(g),this.f.fire({viewContainer:c,viewContainerLocation:g});return}}}get(c){return this.all.filter(g=>g.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(g=>this.getViewContainers(g).filter(f=>f?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(g=>this.getViewContainerLocation(g)===c)}}O.$xo.add(w.ViewContainersRegistry,new p);var r;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(r||(e.ViewContentGroups=r={}));function l(o,c){const g=o.group??r.More,f=c.group??r.More;return g!==f?g.localeCompare(f):(o.order??5)-(c.order??5)}class d extends L.$Zc{constructor(){super(...arguments),this.c=this.B(new v.$qe),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$qe),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$qe),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$qe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Mc}registerViews(c,g){this.registerViews2([{views:c,viewContainer:g}])}registerViews2(c){c.forEach(({views:g,viewContainer:f})=>this.r(g,f)),this.c.fire(c)}deregisterViews(c,g){const f=this.s(c,g);f.length&&this.f.fire({views:f,viewContainer:g})}moveViews(c,g){for(const f of this.m.keys())if(f!==g){const h=this.s(c,f);h.length&&(this.r(h,g),this.g.fire({views:h,from:f,to:g}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const g of this.j){const f=(this.m.get(g)||[]).filter(h=>h.id===c)[0];if(f)return f}return null}getViewContainer(c){for(const g of this.j)if((this.m.get(g)||[]).filter(h=>h.id===c)[0])return g;return null}registerViewWelcomeContent(c,g){return this.n.add(c,g),this.h.fire(c),(0,L.$Xc)(()=>{this.n.delete(c,g),this.h.fire(c)})}registerViewWelcomeContent2(c,g){const f=new Map;for(const[h,S]of g)this.n.add(c,S),f.set(h,(0,L.$Xc)(()=>{this.n.delete(c,S),this.h.fire(c)}));return this.h.fire(c),f}getViewWelcomeContent(c){const g=[];return this.n.forEach(c,f=>g.push(f)),g.sort(l)}r(c,g){let f=this.m.get(g);f||(f=[],this.m.set(g,f),this.j.push(g));for(const h of c){if(this.getView(h.id)!==null)throw new Error((0,D.localize)(4220,null,h.id));f.push(h)}}s(c,g){const f=this.m.get(g);if(!f)return[];const h=[],S=[];for(const k of f)c.includes(k)?h.push(k):S.push(k);return h.length&&(S.length?this.m.set(g,S):(this.m.delete(g),this.j.splice(this.j.indexOf(g),1))),h}}O.$xo.add(w.ViewsRegistry,new d),e.$RG=(0,P.$Ki)("viewDescriptorService");var a;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(a||(e.ViewVisibilityState=a={}));var i;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class n{constructor(c,g){this.c=!1,this.d=!1,(0,m.$no)(this,c),this.d=!!g,this.resolve=async f=>{if(g&&!this.c){const h=await g(f);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}f.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$SG=n;class t extends Error{constructor(c){super((0,D.localize)(4221,null,c)),this.name="NoTreeViewError"}static is(c){return!!c&&c.name==="NoTreeViewError"}}e.$TG=t}),define(Re[192],Te([1,0,9,31]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=void 0,e.$XG=new D.$2j("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(4716,null)}),e.$YG=new D.$2j("chatVoteUpEnabled",!1,{type:"boolean",description:(0,v.localize)(4717,null)}),e.$ZG=new D.$2j("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(4718,null)}),e.$1G=new D.$2j("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(4719,null)}),e.$2G=new D.$2j("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(4720,null)}),e.$3G=new D.$2j("chatSessionResponseError",!1,{type:"boolean",description:(0,v.localize)(4721,null)}),e.$4G=new D.$2j("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(4722,null)}),e.$5G=new D.$2j("chatResponse",!1,{type:"boolean",description:(0,v.localize)(4723,null)}),e.$6G=new D.$2j("chatRequest",!1,{type:"boolean",description:(0,v.localize)(4724,null)}),e.$7G=new D.$2j("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(4725,null)}),e.$8G=new D.$2j("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(4726,null)}),e.$9G=new D.$2j("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(4727,null)}),e.$0G=new D.$2j("inChatInput",!1,{type:"boolean",description:(0,v.localize)(4728,null)}),e.$$G=new D.$2j("inChat",!1,{type:"boolean",description:(0,v.localize)(4729,null)}),e.$_G=new D.$2j("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(4730,null)}),e.$aH=new D.$2j("chatCursorAtTop",!1),e.$bH=new D.$2j("chatInputHasAgent",!1),e.$cH=new D.$2j("chatLocation",void 0),e.$dH=new D.$2j("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(4731,null)})}),define(Re[117],Te([1,0,283,10,19,6,41,4,34,144,13,31,18,3,11,109,176,186,192]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.ChatAgentLocation=void 0,e.$mI=g,e.$nI=f;var n;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(n||(e.ChatAgentLocation=n={})),function(h){function S(k){switch(k){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=S}(n||(e.ChatAgentLocation=n={})),e.$hI=(0,E.$Ki)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(S){this.f=S,this.b=new Map,this.d=new L.$qe,this.onDidChangeAgents=this.d.event,this.g=new Map,this.i=new Map,this.e=a.$_G.bindTo(this.f)}registerAgent(S,k){if(this.getAgent(S))throw new Error(`Agent already registered: ${JSON.stringify(S)}`);const C=this,T=k.slashCommands;k={...k,get slashCommands(){return T.filter(b=>!b.when||C.f.contextMatchesRules(w.$Ij.deserialize(b.when)))}};const $={data:k};return this.b.set(S,$),(0,O.$Xc)(()=>{this.b.delete(S),this.d.fire(void 0)})}registerAgentImplementation(S,k){const y=this.b.get(S);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(S)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(S)}`);return y.data.isDefault&&this.e.set(!0),y.impl=k,this.d.fire(new o(y.data,k)),(0,O.$Xc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(S,k){S.isDynamic=!0;const y={data:S,impl:k};return this.b.set(S.id,y),this.d.fire(new o(S,k)),(0,O.$Xc)(()=>{this.b.delete(S.id),this.d.fire(void 0)})}registerAgentCompletionProvider(S,k){return this.g.set(S,k),{dispose:()=>{this.g.delete(S)}}}async getAgentCompletionItems(S,k,y){return await this.g.get(S)?.(k,y)??[]}updateAgent(S,k){const y=this.b.get(S);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(S)} registered`);y.data.metadata={...y.data.metadata,...k},this.d.fire(new o(y.data,y.impl))}getDefaultAgent(S){return(0,v.$jb)(this.getActivatedAgents(),k=>!!k.isDefault&&k.locations.includes(S))}getContributedDefaultAgent(S){return this.getAgents().find(k=>!!k.isDefault&&k.locations.includes(S))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),S=>!!S.data.metadata.isSecondary)?.data}getAgent(S){if(this.h(S))return this.b.get(S)?.data}h(S){const k=this.b.get(S);return!k?.data.when||this.f.contextMatchesRules(w.$Ij.deserialize(k.data.when))}getAgentByFullyQualifiedId(S){const k=R.Iterable.find(this.b.values(),y=>g(y.data)===S)?.data;if(!(k&&!this.h(k.id)))return k}getAgents(){return Array.from(this.b.values()).map(S=>S.data).filter(S=>this.h(S.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(S=>!!S.impl).filter(S=>this.h(S.data.id)).map(S=>new o(S.data,S.impl))}getAgentsByName(S){return this.getAgents().filter(k=>k.name===S)}agentHasDupeName(S){const k=this.getAgent(S);return k?this.getAgentsByName(k.name).filter(y=>y.extensionId.value!==k.extensionId.value).length>0:!1}async invokeAgent(S,k,y,C,T){const $=this.b.get(S);if(!$?.impl)throw new Error(`No activated agent with id "${S}"`);return await $.impl.invoke(k,y,C,T)}async getFollowups(S,k,y,C,T){const $=this.b.get(S);if(!$?.impl)throw new Error(`No activated agent with id "${S}"`);return $.impl?.provideFollowups?$.impl.provideFollowups(k,y,C,T):[]}async getChatTitle(S,k,y){const C=this.b.get(S);if(!C?.impl)throw new Error(`No activated agent with id "${S}"`);if(C.impl?.provideChatTitle)return C.impl.provideChatTitle(k,y)}registerChatParticipantDetectionProvider(S,k){return this.i.set(S,k),(0,O.$Xc)(()=>{this.i.delete(S)})}hasChatParticipantDetectionProviders(){return this.i.size>0}async detectAgentOrCommand(S,k,y,C){const T=R.Iterable.first(this.i.values());if(!T)return;const $=this.getAgents().reduce((F,G)=>{F.push({participant:G.id,disambiguation:G.disambiguation??[]});for(const x of G.slashCommands)F.push({participant:G.id,command:x.name,disambiguation:[]});return F},[]),b=await T.provideParticipantDetection(S,k,{...y,participants:$},C);if(!b)return;const N=this.getAgent(b.participant);if(!N)return;if(!b.command)return{agent:N};const A=N?.slashCommands.find(F=>F.name===b.command);if(A)return{agent:N,command:A}}};e.$iI=t,e.$iI=t=He([qe(0,w.$3j)],t);class o{constructor(S,k){this.b=S,this.d=k}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}get disambiguation(){return this.b.disambiguation}async invoke(S,k,y,C){return this.d.invoke(S,k,y,C)}async provideFollowups(S,k,y,C){return this.d.provideFollowups?this.d.provideFollowups(S,k,y,C):[]}provideWelcomeMessage(S,k){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(S,k)}provideSampleQuestions(S,k){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(S,k)}toJSON(){return this.b}}e.$jI=o,e.$kI=(0,E.$Ki)("chatAgentNameService");let c=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(S,k,y,C){if(this.g=k,this.h=y,this.i=C,this.e=(0,s.$$d)(this,Object.create(null)),this.f=!1,!S.chatParticipantRegistry)return;this.d=S.chatParticipantRegistry;const T=C.get(i.b,d.StorageScope.APPLICATION);try{this.e.set(JSON.parse(T??"{}"),void 0)}catch{C.remove(i.b,d.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(S=>this.h.warn("Failed to fetch chat participant registry",S)).then(()=>(0,D.$Lh)(5*60*1e3)).then(()=>this.j())}async k(){const S=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(S.res.statusCode!==200)throw new Error("Could not get extensions report.");const k=await(0,l.$hq)(S);if(!k||k.version!==1)throw new Error("Unexpected chat participant registry response.");const y=k.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(i.b,JSON.stringify(y),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}getAgentNameRestriction(S){const k=this.l(S.name,S).get(),y=!S.fullName||this.l(S.fullName.replace(/\s/g,""),S).get();return k&&y}l(S,k){return this.e.map(C=>C[S.toLowerCase()]).map(C=>C?C.some(T=>(0,I.$Kf)(T,T.includes(".")?k.extensionId.value:k.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$lI=c,e.$lI=c=i=He([qe(0,r.$yk),qe(1,l.$bq),qe(2,p.$fk),qe(3,d.$oq)],c);function g(h){return`${h.extensionId.value}.${h.id}`}function f(h){const S="name"in h?h:{...h,name:h.id};return"extensionPublisherId"in S||(S.extensionPublisherId=S.extensionPublisher??""),"extensionDisplayName"in S||(S.extensionDisplayName=""),"extensionId"in S||(S.extensionId=new u.$xn("")),(0,m.$hi)(S)}}),define(Re[193],Te([1,0,2,32,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PH=e.$OH=e.ChatCopyKind=e.ChatAgentVoteDownReason=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$MH=L,e.$NH=R;function L(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof v.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(D.$Wt.isIRange)}function R(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(L)}var O;(function(w){w[w.Complete=1]="Complete",w[w.Partial=2]="Partial",w[w.Omitted=3]="Omitted"})(O||(e.ChatResponseReferencePartStatusKind=O={}));var m;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(m||(e.ChatAgentVoteDirection=m={}));var s;(function(w){w.IncorrectCode="incorrectCode",w.DidNotFollowInstructions="didNotFollowInstructions",w.IncompleteCode="incompleteCode",w.MissingContext="missingContext",w.PoorlyWrittenOrFormatted="poorlyWrittenOrFormatted",w.RefusedAValidRequest="refusedAValidRequest",w.OffensiveOrUnsafe="offensiveOrUnsafe",w.Other="other",w.WillReportIssue="willReportIssue"})(s||(e.ChatAgentVoteDownReason=s={}));var I;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(I||(e.ChatCopyKind=I={})),e.$OH=(0,P.$Ki)("IChatService"),e.$PH="accessibility.voice.keywordActivation"}),define(Re[194],Te([1,0,6,10,9]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cwb=void 0;class L{constructor(){this.f=new Map,this.m=[],this.n=new v.$qe,this.o=new v.$qe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(O){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=O}onEvent(O){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=O}onRequest(O){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=O}sendResponse(O){O.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.u("response",O)}sendRequest(O,m,s,I){const w={command:O};if(m&&Object.keys(m).length>0&&(w.arguments=m),this.u("request",w),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const E=this.f.get(w.seq);if(E){this.f.delete(w.seq);const p={type:"response",seq:0,request_seq:w.seq,success:!1,command:O,message:(0,P.localize)(5731,null,I,O)};E(p)}},I)}return s&&this.f.set(w.seq,s),w.seq}acceptMessage(O){this.k?this.k(O):(this.m.push(O),this.m.length===1&&this.s())}q(O,m){return O.type!=="event"||m.type!=="event"}async s(){let O;for(;this.m.length;){if((!O||this.q(this.m[0],O))&&await(0,D.$Lh)(0),O=this.m.shift(),!O)return;switch(O.type){case"event":this.j?.(O);break;case"request":this.g?.(O);break;case"response":{const m=O,s=this.f.get(m.request_seq);s&&(this.f.delete(m.request_seq),s(m));break}}}}u(O,m){m.type=O,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const O=new Map;this.f.forEach((m,s)=>O.set(s,m)),await(0,D.$Lh)(500),O.forEach((m,s)=>{m({type:"response",seq:0,request_seq:s,success:!1,command:"canceled",message:"canceled"}),this.f.delete(s)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$cwb=L}),define(Re[81],Te([1,0,2,9,31,3]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$$K=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$9K=e.MemoryRangeType=e.State=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=void 0,e.$8K=m,e.$0K=I,D=Ve(D),e.$VJ="workbench.view.debug",e.$WJ="workbench.debug.variablesView",e.$XJ="workbench.debug.watchExpressionsView",e.$YJ="workbench.debug.callStackView",e.$ZJ="workbench.debug.loadedScriptsView",e.$1J="workbench.debug.breakPointsView",e.$2J="workbench.debug.disassemblyView",e.$3J="workbench.panel.repl",e.$4J="workbench.panel.repl.view",e.$5J=new P.$2j("debugType",void 0,{type:"string",description:D.localize(5732,null)}),e.$6J=new P.$2j("debugConfigurationType",void 0,{type:"string",description:D.localize(5733,null)}),e.$7J=new P.$2j("debugState","inactive",{type:"string",description:D.localize(5734,null)}),e.$8J="debugUx",e.$9J=new P.$2j(e.$8J,"default",{type:"string",description:D.localize(5735,null)}),e.$0J=new P.$2j("hasDebugged",!1,{type:"boolean",description:D.localize(5736,null)}),e.$$J=new P.$2j("inDebugMode",!1,{type:"boolean",description:D.localize(5737,null)}),e.$_J=new P.$2j("inDebugRepl",!1,{type:"boolean",description:D.localize(5738,null)}),e.$aK=new P.$2j("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(5739,null)}),e.$bK=new P.$2j("inBreakpointWidget",!1,{type:"boolean",description:D.localize(5740,null)}),e.$cK=new P.$2j("breakpointsFocused",!0,{type:"boolean",description:D.localize(5741,null)}),e.$dK=new P.$2j("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(5742,null)}),e.$eK=new P.$2j("watchExpressionsExist",!1,{type:"boolean",description:D.localize(5743,null)}),e.$fK=new P.$2j("variablesFocused",!0,{type:"boolean",description:D.localize(5744,null)}),e.$gK=new P.$2j("expressionSelected",!1,{type:"boolean",description:D.localize(5745,null)}),e.$hK=new P.$2j("breakpointInputFocused",!1,{type:"boolean",description:D.localize(5746,null)}),e.$iK=new P.$2j("callStackItemType",void 0,{type:"string",description:D.localize(5747,null)}),e.$jK=new P.$2j("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(5748,null)}),e.$kK=new P.$2j("callStackItemStopped",!1,{type:"boolean",description:D.localize(5749,null)}),e.$lK=new P.$2j("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(5750,null)}),e.$mK=new P.$2j("watchItemType",void 0,{type:"string",description:D.localize(5751,null)}),e.$nK=new P.$2j("canViewMemory",void 0,{type:"boolean",description:D.localize(5752,null)}),e.$oK=new P.$2j("breakpointItemType",void 0,{type:"string",description:D.localize(5753,null)}),e.$pK=new P.$2j("breakpointItemBytes",void 0,{type:"boolean",description:D.localize(5754,null)}),e.$qK=new P.$2j("breakpointHasModes",!1,{type:"boolean",description:D.localize(5755,null)}),e.$rK=new P.$2j("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(5756,null)}),e.$sK=new P.$2j("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(5757,null)}),e.$tK=new P.$2j("loadedScriptsItemType",void 0,{type:"string",description:D.localize(5758,null)}),e.$uK=new P.$2j("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(5759,null)}),e.$vK=new P.$2j("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(5760,null)}),e.$wK=new P.$2j("stepBackSupported",!1,{type:"boolean",description:D.localize(5761,null)}),e.$xK=new P.$2j("restartFrameSupported",!1,{type:"boolean",description:D.localize(5762,null)}),e.$yK=new P.$2j("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(5763,null)}),e.$zK=new P.$2j("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(5764,null)}),e.$AK=new P.$2j("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(5765,null)}),e.$BK=new P.$2j("breakpointsExist",!1,{type:"boolean",description:D.localize(5766,null)}),e.$CK=new P.$2j("debuggersAvailable",!1,{type:"boolean",description:D.localize(5767,null)}),e.$DK=new P.$2j("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(5768,null)}),e.$EK=new P.$2j("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(5769,null)}),e.$FK=new P.$2j("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(5770,null)}),e.$GK=new P.$2j("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:D.localize(5771,null)}),e.$HK=new P.$2j("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(5772,null)}),e.$IK=new P.$2j("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(5773,null)}),e.$JK=new P.$2j("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(5774,null)}),e.$KK=new P.$2j("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(5775,null)}),e.$LK=new P.$2j("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(5776,null)}),e.$MK=new P.$2j("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(5777,null)}),e.$NK=new P.$2j("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(5778,null)}),e.$OK=new P.$2j("variableIsReadonly",!1,{type:"boolean",description:D.localize(5779,null)}),e.$PK=new P.$2j("variableValue",!1,{type:"string",description:D.localize(5780,null)}),e.$QK=new P.$2j("variableType",!1,{type:"string",description:D.localize(5781,null)}),e.$RK=new P.$2j("variableInterfaces",!1,{type:"array",description:D.localize(5782,null)}),e.$SK=new P.$2j("variableName",!1,{type:"string",description:D.localize(5783,null)}),e.$TK=new P.$2j("variableLanguage",!1,{type:"string",description:D.localize(5784,null)}),e.$UK=new P.$2j("variableExtensionId",!1,{type:"string",description:D.localize(5785,null)}),e.$VK=new P.$2j("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(5786,null)}),e.$WK=new P.$2j("multiSessionRepl",!1,{type:"boolean",description:D.localize(5787,null)}),e.$XK=new P.$2j("multiSessionDebug",!1,{type:"boolean",description:D.localize(5788,null)}),e.$YK=new P.$2j("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(5789,null)}),e.$ZK=new P.$2j("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(5790,null)}),e.$1K=new P.$2j("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(5791,null)}),e.$2K=new P.$2j("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(5792,null)});const R=i=>D.localize(5793,null,i);e.$3K=R,e.$4K="editor.contrib.debug",e.$5K="editor.contrib.breakpoint",e.$6K="debug",e.$7K={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(5794,null)};var O;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(O||(e.State=O={}));function m(i){switch(i){case O.Initializing:return"initializing";case O.Stopped:return"stopped";case O.Running:return"running";default:return"inactive"}}var s;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.$9K="vscode-debug-memory";function I(i){const n=i.presentationHint??i.source.presentationHint;return n==="deemphasize"||n==="subtle"}var w;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(w||(e.DataBreakpointSetType=w={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var E;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$$K=(0,L.$Ki)("debugService");var p;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(p||(e.BreakpointWidgetContext=p={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var l;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(l||(e.DebugTreeItemCollapsibleState=l={}));var d;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(d||(e.IDebugVisualizationTreeItem=d={}));var a;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:v.URI.revive(n.iconPath.light),dark:v.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(a||(e.IDebugVisualization=a={}))}),define(Re[195],Te([1,0,13,2,22,25,15,32,19,17]),function(we,e,v,D,P,L,R,O,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CI=void 0,e.$qI=w,e.$rI=u,e.$sI=E,e.$tI=p,e.$uI=r,e.$vI=l,e.$wI=d,e.$xI=i,e.$yI=o,e.$zI=c,e.$AI=f,e.$BI=S;const I=/{([^}]+)}/g;function w(y,C,T){return y.replace(I,function($,b){return C&&b.length>0&&b[0]!=="_"?$:T&&T.hasOwnProperty(b)?T[b]:$})}function u(y){const C={};for(const T of Object.keys(y))T.startsWith("!")||(C[T]=y[T]);return C}function E(y){return y.configuration.request==="attach"&&!p(y)&&(!y.parentSession||E(y.parentSession))}function p(y){let C=y.configuration.type;if(C)return C==="vslsShare"&&(C=y.configuration.adapterProxy.configuration.type),(0,v.$Kf)(C,"extensionhost")||(0,v.$Kf)(C,"pwa-extensionhost")?y:y.parentSession?p(y.parentSession):void 0}function r(y){return y.type&&(y.label||y.program||y.runtime)}function l(y,C,T){let $,b=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let A=null;for(;A=N.exec(y);){const F=A.index+1,G=F+A[0].length;if(F<=C&&G>=T){$=A[0],b=F;break}}if($){const F=/(\w|\p{L})+/gu;let G=null;for(;(G=F.exec($))&&!(G.index+1+b+G[0].length>=T););G&&($=$.substring(0,F.lastIndex))}return $?{start:b,end:b+$.length-1}:{start:0,end:0}}async function d(y,C,T,$){if(y.evaluatableExpressionProvider.has(C)){const b=y.evaluatableExpressionProvider.ordered(C),N=(0,s.$Lb)(await Promise.all(b.map(async A=>{try{return await A.provideEvaluatableExpression(C,T,$??m.CancellationToken.None)}catch{return}})));if(N.length>0){let A=N[0].expression;const F=N[0].range;return A||(A=C.getLineContent(T.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:A}}}else{const b=C.getLineContent(T.lineNumber),{start:N,end:A}=l(b,T.column,T.column),F=b.substring(N-1,A);return{matchingExpression:F,range:new O.$Wt(T.lineNumber,N,T.lineNumber,N+F.length)}}return null}const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(y){return!!(y&&y.match(a))}function n(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(i(y.path))return D.URI.parse(y.path);if((0,P.$nc)(y.path))return D.URI.file(y.path)}return y.path}function t(y){if(typeof y.path=="object"){const C=D.URI.revive(y.path);if(C)return C.scheme===R.Schemas.file?C.fsPath:C.toString()}return y.path}function o(y,C){const T=C?n:t,$=(0,L.$ko)(y);return g($,(b,N)=>{b&&N&&(N.path=T(N))}),$}function c(y,C){const T=C?n:t,$=(0,L.$ko)(y);return g($,(b,N)=>{!b&&N&&(N.path=T(N))}),$}function g(y,C){switch(y.type){case"event":{const T=y;switch(T.event){case"output":C(!1,T.body.source);break;case"loadedSource":C(!1,T.body.source);break;case"breakpoint":C(!1,T.body.breakpoint.source);break;default:break}break}case"request":{const T=y;switch(T.command){case"setBreakpoints":C(!0,T.arguments.source);break;case"breakpointLocations":C(!0,T.arguments.source);break;case"source":C(!0,T.arguments.source);break;case"gotoTargets":C(!0,T.arguments.source);break;case"launchVSCode":T.arguments.args.forEach($=>C(!1,$));break;default:break}break}case"response":{const T=y;if(T.success&&T.body)switch(T.command){case"stackTrace":T.body.stackFrames.forEach($=>C(!1,$.source));break;case"loadedSources":T.body.sources.forEach($=>C(!1,$));break;case"scopes":T.body.scopes.forEach($=>C(!1,$.source));break;case"setFunctionBreakpoints":T.body.breakpoints.forEach($=>C(!1,$.source));break;case"setBreakpoints":T.body.breakpoints.forEach($=>C(!1,$.source));break;case"disassemble":T.body?.instructions.forEach(b=>C(!1,b.location));break;case"locations":C(!1,T.body?.source);break;default:break}break}}}function f(y){return y.filter(C=>!C.presentation?.hidden).sort((C,T)=>C.presentation?T.presentation?C.presentation.group?T.presentation.group?C.presentation.group!==T.presentation.group?C.presentation.group.localeCompare(T.presentation.group):h(C.presentation.order,T.presentation.order):-1:T.presentation.group?1:h(C.presentation.order,T.presentation.order):-1:T.presentation?1:0)}function h(y,C){return typeof y!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:y-C}async function S(y,C){const T=y.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(T!=="none"&&(await C.saveAll(),T==="allEditorsInActiveGroup")){const $=C.activeEditorPane;$&&$.input.resource?.scheme===R.Schemas.untitled&&await C.save({editor:$.input,groupId:$.group.id})}await y.reloadConfiguration()}const k=(y,C)=>!y||!C?y===C:y.name===C.name&&y.path===C.path&&y.sourceReference===C.sourceReference;e.$CI=k}),define(Re[196],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gL=e.CellExecutionUpdateType=void 0;var D;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(D||(e.CellExecutionUpdateType=D={})),e.$gL=(0,v.$Ki)("INotebookExecutionService")}),define(Re[197],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$jL=e.ProxyKernelState=e.$iL=void 0,e.$iL=100;var D;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(D||(e.ProxyKernelState=D={})),e.$jL=(0,v.$Ki)("INotebookKernelService"),e.$kL=(0,v.$Ki)("INotebookKernelHistoryService")}),define(Re[198],Te([1,0,4,32,52,165,102]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K2b=void 0;class O extends v.$Zc{constructor(s,I,w){super(),this._source=s,this.b=I,this.c=w,this.a=void 0}f(s){const I=s.getLineCount();return new D.$Wt(1,1,I,this.g(s,I))}g(s,I){if(I<1||I>s.getLineCount())throw new Error("Illegal value for lineNumber");return s.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const s=new L.$JD;s.acceptChunk(this._source);const I=s.finish(!0),{textBuffer:w,disposable:u}=I.create(P.DefaultEndOfLine.LF);this.b=w,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(s=>{const I=new L.$JD;I.acceptChunk(s);const w=I.finish(!0),{textBuffer:u,disposable:E}=w.create(P.DefaultEndOfLine.LF);return this.B(E),u})),this.a}findInInputs(s){const w=new R.$xD(s,!1,!1,null).parseSearchRequest();if(!w)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,w,!0,5e3)}findInOutputs(s){const w=new R.$xD(s,!1,!1,null).parseSearchRequest();return w?this.outputTextBuffers.map(u=>{const E=u.findMatchesLineByLine(this.f(u),w,!0,5e3);if(E.length!==0)return{textBuffer:u,matches:E}}).filter(u=>!!u):[]}}e.$K2b=O}),define(Re[54],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pJ=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(L){L.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var D;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(D||(e.TestPosition=D={}));class P{static fromExtHostTestItem(R,O,m=R.parent){if(R._isRoot)return new P([O]);const s=[R.id];for(let I=m;I&&I.id!==O;I=I.parent)s.push(I.id);return s.push(O),new P(s.reverse())}static isRoot(R){return!R.includes(v.Delimiter)}static root(R){const O=R.indexOf(v.Delimiter);return O===-1?R:R.slice(0,O)}static fromString(R){return new P(R.split(v.Delimiter))}static join(R,O){return new P([...R.path,O])}static joinToString(R,O){return R.toString()+v.Delimiter+O}static parentId(R){const O=R.lastIndexOf(v.Delimiter);return O===-1?void 0:R.slice(0,O)}static localId(R){const O=R.lastIndexOf(v.Delimiter);return O===-1?R:R.slice(O+v.Delimiter.length)}static isChild(R,O){return O[R.length]===v.Delimiter&&O.startsWith(R)}static compare(R,O){return R===O?D.IsSame:P.isChild(R,O)?D.IsChild:P.isChild(O,R)?D.IsParent:D.Disconnected}static getLengthOfCommonPrefix(R,O){if(R===0)return 0;let m=0;for(;m<R-1;){for(let s=1;s<R;s++){const I=O(s-1),w=O(s);if(I.path[m]!==w.path[m])return m}m++}return m}constructor(R,O=R.length){if(this.path=R,this.d=O,R.length===0||O<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let O=0;O<R.d&&O<this.d;O++)if(R.path[O]!==this.path[O])return D.Disconnected;return R.d>this.d?D.IsChild:R.d<this.d?D.IsParent:D.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+=v.Delimiter,this.c+=this.path[R]}return this.c}}e.$pJ=P}),define(Re[55],Te([1,0,2,101,32,54]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$xJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$wJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$vJ=e.$uJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$tJ=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$sJ=e.$rJ=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$qJ=e.TestResultState=void 0;var R;(function(U){U[U.Unset=0]="Unset",U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$qJ={[R.Unset]:"unset",[R.Queued]:"queued",[R.Running]:"running",[R.Passed]:"passed",[R.Failed]:"failed",[R.Skipped]:"skipped",[R.Errored]:"errored"};var O;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(O||(e.ExtTestRunProfileKind=O={}));var m;(function(U){U[U.Refresh=2]="Refresh",U[U.CodeRelatedToTest=4]="CodeRelatedToTest",U[U.TestRelatedToCode=8]="TestRelatedToCode"})(m||(e.TestControllerCapability=m={}));var s;(function(U){U[U.Run=2]="Run",U[U.Debug=4]="Debug",U[U.Coverage=8]="Coverage",U[U.HasNonDefaultProfile=16]="HasNonDefaultProfile",U[U.HasConfigurable=32]="HasConfigurable",U[U.SupportsContinuousRun=64]="SupportsContinuousRun"})(s||(e.TestRunProfileBitset=s={})),e.$rJ=[s.Run,s.Debug,s.Coverage,s.HasNonDefaultProfile,s.HasConfigurable,s.SupportsContinuousRun];const I=U=>"runId"in U;e.$sJ=I;var w;(function(U){U.serialize=J=>({range:J.range.toJSON(),uri:J.uri.toJSON()}),U.deserialize=(J,Z)=>({range:P.$Wt.lift(Z.range),uri:J.asCanonicalUri(v.URI.revive(Z.uri))})})(w||(e.IRichLocation=w={}));var u;(function(U){U[U.Error=0]="Error",U[U.Output=1]="Output"})(u||(e.TestMessageType=u={}));var E;(function(U){U.serialize=J=>({label:J.label,uri:J.uri?.toJSON(),position:J.position?.toJSON()}),U.deserialize=(J,Z)=>({label:Z.label,uri:Z.uri?J.asCanonicalUri(v.URI.revive(Z.uri)):void 0,position:Z.position?D.$Vt.lift(Z.position):void 0})})(E||(e.ITestMessageStackFrame=E={}));var p;(function(U){U.serialize=J=>({message:J.message,type:u.Error,expected:J.expected,actual:J.actual,contextValue:J.contextValue,location:J.location&&w.serialize(J.location),stackTrace:J.stackTrace?.map(E.serialize)}),U.deserialize=(J,Z)=>({message:Z.message,type:u.Error,expected:Z.expected,actual:Z.actual,contextValue:Z.contextValue,location:Z.location&&w.deserialize(J,Z.location),stackTrace:Z.stackTrace&&Z.stackTrace.map(ae=>E.deserialize(J,ae))})})(p||(e.ITestErrorMessage=p={}));const r=(U,J)=>`${J?"s":"e"}${U}`;e.$tJ=r;var l;(function(U){U.serialize=J=>({message:J.message,type:u.Output,offset:J.offset,length:J.length,location:J.location&&w.serialize(J.location)}),U.deserialize=(J,Z)=>({message:Z.message,type:u.Output,offset:Z.offset,length:Z.length,location:Z.location&&w.deserialize(J,Z.location)})})(l||(e.ITestOutputMessage=l={}));var d;(function(U){U.serialize=J=>J.type===u.Error?p.serialize(J):l.serialize(J),U.deserialize=(J,Z)=>Z.type===u.Error?p.deserialize(J,Z):l.deserialize(J,Z),U.isDiffable=J=>J.type===u.Error&&J.actual!==void 0&&J.expected!==void 0})(d||(e.ITestMessage=d={}));var a;(function(U){U.serializeWithoutMessages=J=>({state:J.state,duration:J.duration,messages:[]}),U.serialize=J=>({state:J.state,duration:J.duration,messages:J.messages.map(d.serialize)}),U.deserialize=(J,Z)=>({state:Z.state,duration:Z.duration,messages:Z.messages.map(ae=>d.deserialize(J,ae))})})(a||(e.ITestTaskState=a={}));const i="\0",n=(U,J)=>U+i+J;e.$uJ=n;const t=U=>{const J=U.indexOf(i);return{ctrlId:U.slice(0,J),tagId:U.slice(J+1)}};e.$vJ=t;var o;(function(U){U.serialize=J=>({extId:J.extId,label:J.label,tags:J.tags,busy:J.busy,children:void 0,uri:J.uri?.toJSON(),range:J.range?.toJSON()||null,description:J.description,error:J.error,sortText:J.sortText}),U.deserialize=(J,Z)=>({extId:Z.extId,label:Z.label,tags:Z.tags,busy:Z.busy,children:void 0,uri:Z.uri?J.asCanonicalUri(v.URI.revive(Z.uri)):void 0,range:Z.range?P.$Wt.lift(Z.range):null,description:Z.description,error:Z.error,sortText:Z.sortText})})(o||(e.ITestItem=o={}));var c;(function(U){U[U.NotExpandable=0]="NotExpandable",U[U.Expandable=1]="Expandable",U[U.BusyExpanding=2]="BusyExpanding",U[U.Expanded=3]="Expanded"})(c||(e.TestItemExpandState=c={}));var g;(function(U){U.serialize=J=>({expand:J.expand,item:o.serialize(J.item)}),U.deserialize=(J,Z)=>({controllerId:L.$pJ.root(Z.item.extId),expand:Z.expand,item:o.deserialize(J,Z.item)})})(g||(e.InternalTestItem=g={}));var f;(function(U){U.serialize=J=>{let Z;return J.item&&(Z={},J.item.label!==void 0&&(Z.label=J.item.label),J.item.tags!==void 0&&(Z.tags=J.item.tags),J.item.busy!==void 0&&(Z.busy=J.item.busy),J.item.uri!==void 0&&(Z.uri=J.item.uri?.toJSON()),J.item.range!==void 0&&(Z.range=J.item.range?.toJSON()),J.item.description!==void 0&&(Z.description=J.item.description),J.item.error!==void 0&&(Z.error=J.item.error),J.item.sortText!==void 0&&(Z.sortText=J.item.sortText)),{extId:J.extId,expand:J.expand,item:Z}},U.deserialize=J=>{let Z;return J.item&&(Z={},J.item.label!==void 0&&(Z.label=J.item.label),J.item.tags!==void 0&&(Z.tags=J.item.tags),J.item.busy!==void 0&&(Z.busy=J.item.busy),J.item.range!==void 0&&(Z.range=J.item.range?P.$Wt.lift(J.item.range):null),J.item.description!==void 0&&(Z.description=J.item.description),J.item.error!==void 0&&(Z.error=J.item.error),J.item.sortText!==void 0&&(Z.sortText=J.item.sortText)),{extId:J.extId,expand:J.expand,item:Z}}})(f||(e.ITestItemUpdate=f={}));const h=(U,J)=>{J.expand!==void 0&&(U.expand=J.expand),J.item!==void 0&&(U.item=U.item?Object.assign(U.item,J.item):J.item)};e.$wJ=h;var S;(function(U){U.serializeWithoutMessages=J=>({...g.serialize(J),ownComputedState:J.ownComputedState,computedState:J.computedState,tasks:J.tasks.map(a.serializeWithoutMessages)}),U.serialize=J=>({...g.serialize(J),ownComputedState:J.ownComputedState,computedState:J.computedState,tasks:J.tasks.map(a.serialize)}),U.deserialize=(J,Z)=>({...g.deserialize(J,Z),ownComputedState:Z.ownComputedState,computedState:Z.computedState,tasks:Z.tasks.map(ae=>a.deserialize(J,ae)),retired:!0})})(S||(e.TestResultItem=S={}));var k;(function(U){U.empty=()=>({covered:0,total:0}),U.sum=(J,Z)=>{J.covered+=Z.covered,J.total+=Z.total}})(k||(e.ICoverageCount=k={}));var y;(function(U){U.serialize=J=>({id:J.id,statement:J.statement,branch:J.branch,declaration:J.declaration,testIds:J.testIds,uri:J.uri.toJSON()}),U.deserialize=(J,Z)=>({id:Z.id,statement:Z.statement,branch:Z.branch,declaration:Z.declaration,testIds:Z.testIds,uri:J.asCanonicalUri(v.URI.revive(Z.uri))}),U.empty=(J,Z)=>({id:J,uri:Z,statement:k.empty()})})(y||(e.IFileCoverage=y={}));function C(U){return{...U,location:U.location?.toJSON()}}function T(U){return U.location=U.location?D.$Vt.isIPosition(U.location)?D.$Vt.lift(U.location):P.$Wt.lift(U.location):void 0,U}e.$xJ=3;var $;(function(U){U[U.Declaration=0]="Declaration",U[U.Statement=1]="Statement",U[U.Branch=2]="Branch"})($||(e.DetailType=$={}));var b;(function(U){U.serialize=J=>J.type===$.Declaration?A.serialize(J):F.serialize(J),U.deserialize=J=>J.type===$.Declaration?A.deserialize(J):F.deserialize(J)})(b||(e.CoverageDetails=b={}));var N;(function(U){U.serialize=C,U.deserialize=T})(N||(e.IBranchCoverage=N={}));var A;(function(U){U.serialize=C,U.deserialize=T})(A||(e.IDeclarationCoverage=A={}));var F;(function(U){U.serialize=J=>({...C(J),branches:J.branches?.map(N.serialize)}),U.deserialize=J=>({...T(J),branches:J.branches?.map(N.deserialize)})})(F||(e.IStatementCoverage=F={}));var G;(function(U){U[U.Add=0]="Add",U[U.Update=1]="Update",U[U.DocumentSynced=2]="DocumentSynced",U[U.Remove=3]="Remove",U[U.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",U[U.Retire=5]="Retire",U[U.AddTag=6]="AddTag",U[U.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var x;(function(U){U.deserialize=(J,Z)=>Z.op===G.Add?{op:Z.op,item:g.deserialize(J,Z.item)}:Z.op===G.Update?{op:Z.op,item:f.deserialize(Z.item)}:Z.op===G.DocumentSynced?{op:Z.op,uri:J.asCanonicalUri(v.URI.revive(Z.uri)),docv:Z.docv}:Z,U.serialize=J=>J.op===G.Add?{op:J.op,item:g.serialize(J.item)}:J.op===G.Update?{op:J.op,item:f.serialize(J.item)}:J})(x||(e.TestsDiffOp=x={}));class j{constructor(J){this.l=J,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(J){const Z=this.x();for(const ae of J)switch(ae.op){case G.Add:this.p(g.deserialize(this.l,ae.item),Z);break;case G.Update:this.q(f.deserialize(ae.item),Z);break;case G.Remove:this.v(ae.itemId,Z);break;case G.Retire:this.w(ae.itemId);break;case G.IncrementPendingExtHosts:this.updatePendingRoots(ae.amount);break;case G.AddTag:this.f.set(ae.tag.id,ae.tag);break;case G.RemoveTag:this.f.delete(ae.id);break}Z.complete?.()}p(J,Z){const ae=L.$pJ.parentId(J.item.extId)?.toString();let ee;if(!ae)ee=this.y(J),this.h.add(ee),this.g.set(J.item.extId,ee);else if(this.g.has(ae)){const oe=this.g.get(ae);oe.children.add(J.item.extId),ee=this.y(J,oe),this.g.set(J.item.extId,ee)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(J)}`);return}return Z.add?.(ee),J.expand===c.BusyExpanding&&this.j++,ee}q(J,Z){const ae=this.g.get(J.extId);if(ae)return J.expand!==void 0&&(ae.expand===c.BusyExpanding&&this.j--,J.expand===c.BusyExpanding&&this.j++),(0,e.$wJ)(ae,J),Z.update?.(ae),ae}v(J,Z){const ae=this.g.get(J);if(!ae)return;const ee=L.$pJ.parentId(ae.item.extId)?.toString();ee?this.g.get(ee).children.delete(ae.item.extId):this.h.delete(ae);const oe=[[J]];for(;oe.length;)for(const ie of oe.pop()){const ue=this.g.get(ie);ue&&(oe.push(ue.children),this.g.delete(ie),Z.remove?.(ue,ue!==ae),ue.expand===c.BusyExpanding&&this.j--)}}w(J){}updatePendingRoots(J){this.k+=J}x(){return{}}}e.$yJ=j}),define(Re[199],Te([1,0,99,9,55]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$xHb=e.$wHb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var L;(function(w){w.ViewletId="workbench.view.extension.test",w.ExplorerViewId="workbench.view.testing",w.OutputPeekContributionId="editor.contrib.testingOutputPeek",w.DecorationsContributionId="editor.contrib.testingDecorations",w.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",w.CoverageViewId="workbench.view.testCoverage",w.ResultsPanelId="workbench.panel.testResults",w.ResultsViewId="workbench.panel.testResults.view",w.MessageLanguageId="vscodeInternalTestMessage"})(L||(e.Testing=L={}));var R;(function(w){w.List="list",w.Tree="true"})(R||(e.TestExplorerViewMode=R={}));var O;(function(w){w.ByLocation="location",w.ByStatus="status",w.ByDuration="duration"})(O||(e.TestExplorerViewSorting=O={}));const m={[P.TestResultState.Errored]:(0,D.localize)(10838,null),[P.TestResultState.Failed]:(0,D.localize)(10839,null),[P.TestResultState.Passed]:(0,D.localize)(10840,null),[P.TestResultState.Queued]:(0,D.localize)(10841,null),[P.TestResultState.Running]:(0,D.localize)(10842,null),[P.TestResultState.Skipped]:(0,D.localize)(10843,null),[P.TestResultState.Unset]:(0,D.localize)(10844,null)},s=(w,u)=>(0,D.localize)(10845,null,(0,v.$5k)(w),m[u]);e.$wHb=s,e.$xHb={[P.TestRunProfileBitset.Debug]:(0,D.localize)(10846,null),[P.TestRunProfileBitset.Run]:(0,D.localize)(10847,null),[P.TestRunProfileBitset.Coverage]:(0,D.localize)(10848,null)};var I;(function(w){w.CancelTestRefreshAction="testing.cancelTestRefresh",w.CancelTestRunAction="testing.cancelRun",w.ClearTestResultsAction="testing.clearTestResults",w.CollapseAllAction="testing.collapseAll",w.ConfigureTestProfilesAction="testing.configureProfile",w.ContinousRunUsingForTest="testing.continuousRunUsingForTest",w.CoverageAtCursor="testing.coverageAtCursor",w.CoverageByUri="testing.coverage.uri",w.CoverageClear="testing.coverage.close",w.CoverageCurrentFile="testing.coverageCurrentFile",w.CoverageFilterToTest="testing.coverageFilterToTest",w.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",w.CoverageLastRun="testing.coverageLastRun",w.CoverageSelectedAction="testing.coverageSelected",w.CoverageToggleToolbar="testing.coverageToggleToolbar",w.CoverageViewChangeSorting="testing.coverageViewChangeSorting",w.DebugAction="testing.debug",w.DebugAllAction="testing.debugAll",w.DebugAtCursor="testing.debugAtCursor",w.DebugByUri="testing.debug.uri",w.DebugCurrentFile="testing.debugCurrentFile",w.DebugFailedTests="testing.debugFailTests",w.DebugLastRun="testing.debugLastRun",w.DebugSelectedAction="testing.debugSelected",w.FilterAction="workbench.actions.treeView.testExplorer.filter",w.GetExplorerSelection="_testing.getExplorerSelection",w.GetSelectedProfiles="testing.getSelectedProfiles",w.GoToTest="testing.editFocusedTest",w.GoToRelatedTest="testing.goToRelatedTest",w.PeekRelatedTest="testing.peekRelatedTest",w.GoToRelatedCode="testing.goToRelatedCode",w.PeekRelatedCode="testing.peekRelatedCode",w.HideTestAction="testing.hideTest",w.OpenCoverage="testing.openCoverage",w.OpenOutputPeek="testing.openOutputPeek",w.RefreshTestsAction="testing.refreshTests",w.ReRunFailedTests="testing.reRunFailTests",w.ReRunLastRun="testing.reRunLastRun",w.RunAction="testing.run",w.RunAllAction="testing.runAll",w.RunAllWithCoverageAction="testing.coverageAll",w.RunAtCursor="testing.runAtCursor",w.RunByUri="testing.run.uri",w.RunCurrentFile="testing.runCurrentFile",w.RunSelectedAction="testing.runSelected",w.RunUsingProfileAction="testing.runUsing",w.RunWithCoverageAction="testing.coverage",w.SearchForTestExtension="testing.searchForTestExtension",w.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",w.ShowMostRecentOutputAction="testing.showMostRecentOutput",w.StartContinousRun="testing.startContinuousRun",w.StopContinousRun="testing.stopContinuousRun",w.TestingSortByDurationAction="testing.sortByDuration",w.TestingSortByLocationAction="testing.sortByLocation",w.TestingSortByStatusAction="testing.sortByStatus",w.TestingViewAsListAction="testing.viewAsList",w.TestingViewAsTreeAction="testing.viewAsTree",w.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",w.ToggleInlineTestOutput="testing.toggleInlineTestOutput",w.UnhideAllTestsAction="testing.unhideAllTests",w.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Re[82],Te([1,0,10,6,4,61,55,54]),function(we,e,v,D,P,L,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=e.$DQ=e.$CQ=e.$BQ=e.$AQ=e.TestItemEventOp=void 0;var m;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const s=(a,i)=>a===i,w=Object.entries({range:(a,i)=>a===i?!0:!a||!i?!1:a.equalsRange(i),busy:s,label:s,description:s,error:s,sortText:s,tags:(a,i)=>!(a.length!==i.length||a.some(n=>!i.includes(n)))}),u=(a,i)=>{let n;for(const[t,o]of w)o(a[t],i[t])||(n?n[t]=i[t]:n={[t]:i[t]});return n};class E extends P.$Zc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new v.$Wh(()=>this.flushDiff(),200)),this.g=this.B(new D.$qe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case R.TestDiffOpType.DocumentSynced:{for(const n of this.m)if(n.op===R.TestDiffOpType.DocumentSynced&&n.uri===i.uri){n.docv=i.docv;return}break}case R.TestDiffOpType.Update:{const n=this.m[this.m.length-1];if(n){if(n.op===R.TestDiffOpType.Update&&n.item.extId===i.item.extId){(0,R.$wJ)(n.item,i.item);return}if(n.op===R.TestDiffOpType.Add&&n.item.item.extId===i.item.extId){(0,R.$wJ)(n.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,n){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||n>t.expandLevels)&&(t.expandLevels=n),t.expand===R.TestItemExpandState.Expandable){const o=this.M(t);return o.isOpen()?this.L(t,n-1):o.wait().then(()=>this.L(t,n-1))}else if(t.expand===R.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,n-1)):this.L(t,n-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,n){switch(n.op){case m.RemoveChild:this.O(O.$pJ.joinToString(i.fullId,n.id));break;case m.Upsert:this.z(n.item,i);break;case m.Bulk:for(const t of n.ops)this.w(i,t);break;case m.SetTags:this.C(n.new,n.old,i.fullId.toString());break;case m.UpdateCanResolveChildren:this.J(i);break;case m.SetProp:this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:n.update}});break;case m.DocumentSynced:this.y(i.actual.uri);break;default:(0,L.$jd)(n)}}y(i){i&&this.pushDiff({op:R.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,n){const t=O.$pJ.fromExtHostTestItem(i,this.root.id,n?.actual),o=this.s.getApiFor(i);o.parent&&o.parent!==n?.actual&&this.s.getChildren(o.parent).delete(i.id);let c=this.tree.get(t.toString());if(!c){c={fullId:t,actual:i,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:R.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(c.fullId.toString(),c),this.G(i,n),this.pushDiff({op:R.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:c.expand,item:this.s.toITestItem(i)}}),this.I(i,c,n);return}if(c.actual===i){this.H(i,c,n);return}if(c.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,n);const g=this.s.getChildren(c.actual),f=c.actual,h=u(this.s.toITestItem(f),this.s.toITestItem(i));this.s.getApiFor(f).listener=void 0,c.actual=i,c.resolveBarrier=void 0,c.expand=R.TestItemExpandState.NotExpandable,h&&(h.hasOwnProperty("tags")&&(this.C(i.tags,f.tags,t.toString()),delete h.tags),this.w(c,{op:m.SetProp,update:h})),this.I(i,c,n);for(const[k,y]of g)this.s.getChildren(i).get(y.id)||this.O(O.$pJ.joinToString(t,y.id));const S=c.expandLevels;S!==void 0&&queueMicrotask(()=>{c.expand===R.TestItemExpandState.Expandable&&(c.expandLevels=void 0,this.expand(t.toString(),S))}),this.y(c.actual.uri)}C(i,n,t){const o=new Set(n.map(c=>c.id));for(const c of i)o.delete(c.id)||this.D(c);this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(c=>(0,R.$uJ)(this.s.controllerId,c.id))}}}),o.forEach(this.F,this)}D(i){const n=this.j.get(i.id);n?n.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:R.TestDiffOpType.AddTag,tag:{id:(0,R.$uJ)(this.s.controllerId,i.id)}}))}F(i){const n=this.j.get(i);n&&!--n.refCount&&(this.j.delete(i),this.pushDiff({op:R.TestDiffOpType.RemoveTag,id:(0,R.$uJ)(this.s.controllerId,i)}))}G(i,n){this.s.getApiFor(i).parent=n&&n.actual!==this.root?n.actual:void 0}H(i,n,t){this.G(i,t);const o=this.s.getApiFor(i);o.parent=t?.actual,o.listener=c=>this.w(n,c),this.J(n)}I(i,n,t){this.H(i,n,t);for(const[o,c]of this.s.getChildren(i))this.z(c,n)}J(i){let n;this.h?i.resolveBarrier?n=i.resolveBarrier.isOpen()?R.TestItemExpandState.Expanded:R.TestItemExpandState.BusyExpanding:n=i.actual.canResolveChildren?R.TestItemExpandState.Expandable:R.TestItemExpandState.NotExpandable:n=R.TestItemExpandState.NotExpandable,n!==i.expand&&(i.expand=n,this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:n}}),n===R.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,n){if(n<0)return;const t=[];for(const[o,c]of this.s.getChildren(i.actual)){const g=this.expand(O.$pJ.joinToString(i.fullId,c.id),n);(0,v.$wh)(g)&&t.push(g)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const c=new v.$Jh;return c.open(),c}i.expand=R.TestItemExpandState.BusyExpanding,this.N(i);const n=i.resolveBarrier=new v.$Jh,t=c=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,c)};let o;try{o=this.h(i.actual===this.root?void 0:i.actual)}catch(c){t(c)}return(0,v.$wh)(o)?o.catch(t).then(()=>{n.open(),this.J(i)}):(n.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const n=this.tree.get(i);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:R.TestDiffOpType.Remove,itemId:i});const t=[n];for(;t.length;){const o=t.pop();if(o){this.s.getApiFor(o.actual).listener=void 0;for(const c of o.actual.tags)this.F(c.id);this.tree.delete(o.fullId.toString());for(const[c,g]of this.s.getChildren(o.actual))t.push(this.tree.get(O.$pJ.joinToString(o.fullId,g.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$AQ=E;class p extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$BQ=p;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$CQ=r;class l extends Error{constructor(i,n,t){super(`TestItem with ID "${i}" is from controller "${n}" and cannot be added as a child of an item from controller "${t}".`)}}e.$DQ=l;const d=(a,i,n)=>{let t=new Map;return{get size(){return t.size},forEach(o,c){for(const g of t.values())o.call(c,g,this)},[Symbol.iterator](){return t.entries()},replace(o){const c=new Map,g=new Set(t.keys()),f={op:m.Bulk,ops:[]};for(const h of o){if(!(h instanceof n))throw new r(h.id);const S=i(h).controllerId;if(S!==a.controllerId)throw new l(h.id,S,a.controllerId);if(c.has(h.id))throw new p(h.id);c.set(h.id,h),g.delete(h.id),f.ops.push({op:m.Upsert,item:h})}for(const h of g.keys())f.ops.push({op:m.RemoveChild,id:h});a.listener?.(f),t=c},add(o){if(!(o instanceof n))throw new r(o.id);t.set(o.id,o),a.listener?.({op:m.Upsert,item:o})},delete(o){t.delete(o)&&a.listener?.({op:m.RemoveChild,id:o})},get(o){return t.get(o)},toJSON(){return Array.from(t.values())}}};e.$EQ=d}),define(Re[118],Te([1,0,82]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GQ=e.$FQ=void 0;const D=new WeakMap,P=(R,O)=>{const m={controllerId:O};return D.set(R,m),m};e.$FQ=P;const L=R=>{const O=D.get(R);if(!O)throw new v.$CQ(R?.id||"<unknown>");return O};e.$GQ=L}),define(Re[83],Te([1,0,30,15,2]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oEb=e.$nEb=e.$mEb=void 0,e.$pEb=L,e.$qEb=O,e.$mEb="vscode-cdn.net",e.$nEb=`vscode-resource.${e.$mEb}`,e.$oEb=`'self' https://*.${e.$mEb}`;function L(m,s){return m.scheme===D.Schemas.http||m.scheme===D.Schemas.https?m:(s&&s.authority&&s.isRemote&&m.scheme===D.Schemas.file&&(m=P.URI.from({scheme:D.Schemas.vscodeRemote,authority:s.authority,path:m.path})),P.URI.from({scheme:D.Schemas.https,authority:`${m.scheme}+${R(m.authority)}.${e.$nEb}`,path:m.path,fragment:m.fragment,query:m.query}))}function R(m){return m.replace(/./g,s=>{const I=s.charCodeAt(0);return I>=v.CharCode.a&&I<=v.CharCode.z||I>=v.CharCode.A&&I<=v.CharCode.Z||I>=v.CharCode.Digit0&&I<=v.CharCode.Digit9?s:"-"+I.toString(16).padStart(4,"0")})}function O(m){return m.replace(/-([0-9a-f]{4})/g,(s,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Re[200],Te([1,0,6,4,83]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=void 0;class L{constructor(O,m,s){this.d=O,this.e=m,this.f=s,this.a=0,this.b=new D.$Yc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const I=m.getVisibleTextEditors();for(const w of this.c.values())I.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this.c.forEach(O=>O.inset.dispose()),this.b.dispose()}createWebviewEditorInset(O,m,s,I,w){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===O){u=i;break}if(!u)throw new Error("not a visible editor");const E=this,p=this.a++,r=new v.$qe,l=new v.$qe,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,P.$pEb)(i,E.f)}get cspSource(){return P.$oEb}set options(i){this.b=i,E.d.$setOptions(p,i)}get options(){return this.b}set html(i){this.a=i,E.d.$setHtml(p,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return E.d.$postMessage(p,i)}},a=new class{constructor(){this.editor=O,this.line=m,this.height=s,this.webview=d,this.onDidDispose=l.event}dispose(){E.c.has(p)&&(E.c.delete(p),E.d.$disposeEditorInset(p),l.fire(),l.dispose(),r.dispose())}};return this.d.$createEditorInset(p,u.id,u.value.document.uri,m+1,s,I||{},w.identifier,w.extensionLocation),this.c.set(p,{editor:O,inset:a,onDidReceiveMessage:r}),a}$onDidDispose(O){const m=this.c.get(O);m&&m.inset.dispose()}$onDidReceiveMessage(O,m){this.c.get(O)?.onDidReceiveMessage.fire(m)}}e.$0qc=L}),define(Re[119],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=e.$bN=e.$aN=void 0,e.$aN="__",e.$bN=(0,v.$Ki)("IAuthenticationService"),e.$cN=(0,v.$Ki)("IAuthenticationExtensionsService")}),define(Re[201],Te([1,0,3,12]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zR=e.VariableKind=e.$yR=void 0,e.$yR=(0,v.$Ki)("configurationResolverService");var P;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(P||(e.VariableKind=P={}));class L extends D.$fb{constructor(O,m){super(m),this.variable=O}}e.$zR=L}),define(Re[202],Te([1,0,22,79,14,25,23,103,9,201,13]),function(we,e,v,D,P,L,R,O,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OR=void 0,v=Ve(v),D=Ve(D),P=Ve(P),L=Ve(L);class w{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,p,r,l){this.h=new Map,this.a=E,this.b=p,this.g=r,l&&(this.c=l.then(d=>this.i(d)))}i(E){if(R.$l){const p=Object.create(null);return Object.keys(E).forEach(r=>{p[r.toLowerCase()]=E[r]}),p}return E}resolveWithEnvironment(E,p,r){return this.l({env:this.i(E),userHome:void 0},p?p.uri:void 0,r)}async resolveAsync(E,p){const r={env:await this.c,userHome:await this.g};return this.l(r,E?E.uri:void 0,p)}async j(E,p,r,l){const d=L.$ko(p);R.$l&&d.windows?Object.keys(d.windows).forEach(i=>d[i]=d.windows[i]):R.$m&&d.osx?Object.keys(d.osx).forEach(i=>d[i]=d.osx[i]):R.$n&&d.linux&&Object.keys(d.linux).forEach(i=>d[i]=d.linux[i]),delete d.windows,delete d.osx,delete d.linux;const a={env:await this.c,userHome:await this.g};return this.l(a,E?E.uri:void 0,d,r,l)}async resolveAnyAsync(E,p,r){return this.j(E,p,r)}async resolveAnyMap(E,p,r){const l=new Map;return{newConfig:await this.j(E,p,r,l),resolvedVariables:l}}resolveWithInteractionReplace(E,p,r,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,p,r,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,p){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,p)}async l(E,p,r,l,d){if(P.$jg(r))return this.m(E,p,r,l,d);if(Array.isArray(r))return Promise.all(r.map(a=>this.l(E,p,a,l,d)));if(P.$lg(r)){const a=Object.create(null),i=await Promise.all(Object.keys(r).map(async n=>[await this.m(E,p,n,l,d),await this.l(E,p,r[n],l,d)]));for(const[n,t]of i)a[n]=t;return a}return r}m(E,p,r,l,d){return(0,I.$Cf)(r,w.VARIABLE_REGEXP,async(a,i)=>{if(i.includes(w.VARIABLE_LHS))return a;let n=await this.o(E,a,i,p,l);return d?.set(i,n),n!==a&&P.$jg(n)&&n.match(w.VARIABLE_REGEXP)&&(n=await this.m(E,p,n,l,d)),n})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,p,r,l,d){let a;const i=r.split(":");i.length>1&&(r=i[0],a=i[1]);const n=c=>{const g=this.a.getFilePath();if(g)return(0,O.$0w)(g);throw new s.$zR(c,(0,m.localize)(12131,null,p))},t=c=>{const g=n(c);if(this.a.getWorkspaceFolderPathForFile){const f=this.a.getWorkspaceFolderPathForFile();if(f)return(0,O.$0w)(f)}throw new s.$zR(c,(0,m.localize)(12132,null,p,v.$sc(g)))},o=c=>{if(a){const g=this.a.getFolderUri(a);if(g)return g;throw new s.$zR(c,(0,m.localize)(12133,null,p,a))}if(l)return l;throw this.a.getWorkspaceFolderCount()>1?new s.$zR(c,(0,m.localize)(12134,null,p)):new s.$zR(c,(0,m.localize)(12135,null,p))};switch(r){case"env":if(a){if(E.env){const c=E.env[R.$l?a.toLowerCase():a];if(P.$jg(c))return c}return""}throw new s.$zR(s.VariableKind.Env,(0,m.localize)(12136,null,p));case"config":if(a){const c=this.a.getConfigurationValue(l,a);if(P.$sg(c))throw new s.$zR(s.VariableKind.Config,(0,m.localize)(12137,null,p,a));if(P.$lg(c))throw new s.$zR(s.VariableKind.Config,(0,m.localize)(12138,null,p,a));return c}throw new s.$zR(s.VariableKind.Config,(0,m.localize)(12139,null,p));case"command":return this.p(s.VariableKind.Command,p,a,d,"command");case"input":return this.p(s.VariableKind.Input,p,a,d,"input");case"extensionInstallFolder":if(a){const c=await this.a.getExtension(a);if(!c)throw new s.$zR(s.VariableKind.ExtensionInstallFolder,(0,m.localize)(12140,null,p,a));return this.n(c.extensionLocation)}throw new s.$zR(s.VariableKind.ExtensionInstallFolder,(0,m.localize)(12141,null,p));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,O.$0w)(this.n(o(s.VariableKind.WorkspaceFolder)));case"cwd":return l||a?(0,O.$0w)(this.n(o(s.VariableKind.Cwd))):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,O.$0w)(v.$sc(this.n(o(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new s.$zR(s.VariableKind.UserHome,(0,m.localize)(12142,null,p))}case"lineNumber":{const c=this.a.getLineNumber();if(c)return c;throw new s.$zR(s.VariableKind.LineNumber,(0,m.localize)(12143,null,p))}case"selectedText":{const c=this.a.getSelectedText();if(c)return c;throw new s.$zR(s.VariableKind.SelectedText,(0,m.localize)(12144,null,p))}case"file":return n(s.VariableKind.File);case"fileWorkspaceFolder":return t(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$sc(t(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return l||a?v.$qc(this.n(o(s.VariableKind.RelativeFile)),n(s.VariableKind.RelativeFile)):n(s.VariableKind.RelativeFile);case"relativeFileDirname":{const c=v.$rc(n(s.VariableKind.RelativeFileDirname));if(l||a){const g=v.$qc(this.n(o(s.VariableKind.RelativeFileDirname)),c);return g.length===0?".":g}return c}case"fileDirname":return v.$rc(n(s.VariableKind.FileDirname));case"fileExtname":return v.$tc(n(s.VariableKind.FileExtname));case"fileBasename":return v.$sc(n(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const c=v.$sc(n(s.VariableKind.FileBasenameNoExtension));return c.slice(0,c.length-v.$tc(c).length)}case"fileDirnameBasename":return v.$sc(v.$rc(n(s.VariableKind.FileDirnameBasename)));case"execPath":{const c=this.a.getExecPath();return c||p}case"execInstallFolder":{const c=this.a.getAppRoot();return c||p}case"pathSeparator":case"/":return v.sep;default:try{const c=a?`${r}:${a}`:r;return this.p(s.VariableKind.Unknown,p,c,d,void 0)}catch{return p}}}}p(E,p,r,l,d){if(r&&l){const a=d===void 0?l[r]:l[d+":"+r];if(typeof a=="string")return a;throw new s.$zR(E,(0,m.localize)(12145,null,p))}return p}}e.$OR=w}),define(Re[120],Te([1,0,3,116]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$ME=void 0,e.$NE=s,e.$OE=u,e.$PE=E,e.$ME=(0,v.$Ki)("editorGroupsService");var P;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var L;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var O;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(O||(e.GroupsArrangement=O={}));var m;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function s(p){const r=p;return(0,D.$yG)(r?.editor)&&(0,D.$yG)(r?.replacement)}var I;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var w;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(w||(e.OpenEditorContext=w={}));function u(p){const r=p;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function E(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Re[203],Te([1,0,3,120]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TE=e.$SE=e.$RE=e.$QE=void 0,e.$UE=P,e.$QE=(0,v.$Ki)("editorService"),e.$RE=-1,e.$SE=-2,e.$TE=-3;function P(L){const R=L;return typeof L=="number"||(0,D.$OE)(R)}}),define(Re[204],Te([1,0,3,107]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=void 0,e.$uN=(0,v.$Li)(D.$Ri)}),define(Re[121],Te([1,0,18,6,22,4,10]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=e.$0ec=e.$9ec=e.$8ec=e.$7ec=void 0,P=Ve(P);class O{constructor(a,i){this.versionId=a,this.removedDueToLooping=i}}e.$7ec=O;class m{static isHostExtension(a,i,n){if(i.getExtensionDescription(a))return!1;const t=n.getExtensionDescription(a);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(a,i){this.j=a,this.c=new D.$qe,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new v.$zn,this.g=[],this.h=new Map;for(const a of this.e){if(this.f.has(a.identifier)){console.error("Extension `"+a.identifier.value+"` is already registered");continue}this.f.set(a.identifier,a),this.g.push(a);const i=this.j.readActivationEvents(a);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(a)}}set(a){return this.e=a,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(a,i){this.e=l(this.e,i),this.e=this.e.concat(a);const n=m.l(this.e);return this.e=l(this.e,n.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new O(this.d,n)}static l(a){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(g){this.d.has(g)||(this.d.add(g),this.e.push(g))}addArc(g,f){this.addNode(g),this.addNode(f),this.c.has(g)?this.c.get(g).push(f):this.c.set(g,[f])}getArcs(g){return this.c.has(g)?this.c.get(g):[]}hasOnlyGoodArcs(g,f){const h=i.getArcs(g);for(let S=0;S<h.length;S++)if(!f.has(h[S]))return!1;return!0}getNodes(){return this.e}},n=new v.$zn;for(const g of a)if(n.set(g.identifier,g),g.extensionDependencies)for(const f of g.extensionDependencies)i.addArc(v.$xn.toKey(g.identifier),v.$xn.toKey(f));const t=new Set;i.getNodes().filter(g=>i.getArcs(g).length===0).forEach(g=>t.add(g));const o=i.getNodes().filter(g=>!t.has(g));let c;do{c=!1;for(let g=0;g<o.length;g++){const f=o[g];i.hasOnlyGoodArcs(f,t)&&(o.splice(g,1),g--,t.add(f),c=!0)}}while(c);return o.map(g=>n.get(g))}containsActivationEvent(a){return this.h.has(a)}containsExtension(a){return this.f.has(a)}getExtensionDescriptionsForActivationEvent(a){const i=this.h.get(a);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new s(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(a){const i=this.f.get(a);return i||void 0}getExtensionDescriptionByUUID(a){for(const i of this.g)if(i.uuid===a)return i}getExtensionDescriptionByIdOrUUID(a,i){return this.getExtensionDescription(a)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$8ec=m;class s{constructor(a,i){this.versionId=a,this.extensions=i}}e.$9ec=s;class I{constructor(a){this.d=new E,this.c=new m(a,[])}async acquireLock(a){const i=await this.d.acquire(a);return new w(this,i)}deltaExtensions(a,i,n){if(!a.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(a){return this.c.containsActivationEvent(a)}containsExtension(a){return this.c.containsExtension(a)}getExtensionDescriptionsForActivationEvent(a){return this.c.getExtensionDescriptionsForActivationEvent(a)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(a){return this.c.getExtensionDescription(a)}getExtensionDescriptionByUUID(a){return this.c.getExtensionDescriptionByUUID(a)}getExtensionDescriptionByIdOrUUID(a,i){return this.c.getExtensionDescriptionByIdOrUUID(a,i)}}e.$0ec=I;class w extends L.$Zc{constructor(a,i){super(),this.f=a,this.c=!1,this.B(i)}isAcquiredFor(a){return!this.c&&this.f===a}}e.$$ec=w;class u{constructor(a){this.name=a;const i=(0,R.$Dh)();this.promise=i.promise,this.c=i.resolve}resolve(a){this.c(a)}}class E{constructor(){this.c=[],this.d=!1}async acquire(a){const i=new u(a);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const a=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${a.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};a.resolve((0,L.$Xc)(t))}}var p;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(p||(p={}));function r(d,a){const i=d.isBuiltin?p.Builtin:d.isUnderDevelopment?p.Dev:p.User,n=a.isBuiltin?p.Builtin:a.isUnderDevelopment?p.Dev:p.User;if(i!==n)return i-n;const t=P.$lc.basename(d.extensionLocation.path),o=P.$lc.basename(a.extensionLocation.path);return t<o?-1:t>o?1:0}function l(d,a){const i=new v.$yn(a);return d.filter(n=>!i.has(n.identifier))}}),define(Re[84],Te([1,0,20]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Hn=R,e.$In=O;var D;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(D||(e.UIKind=D={}));var P;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var L;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(s){const I=v.$Se.alloc(1);switch(s){case L.Initialized:I.writeUInt8(1,0);break;case L.Ready:I.writeUInt8(2,0);break;case L.Terminate:I.writeUInt8(3,0);break}return I}function O(s,I){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return I===L.Initialized;case 2:return I===L.Ready;case 3:return I===L.Terminate;default:return!1}}var m;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Re[66],Te([1,0,3,6,113,11,26,84,62,63,25,2,4,9]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Q=e.$3Q=e.$2Q=void 0,e.$4Q=l;let p=class extends u.$Zc{constructor(a,i){super(),this.s=a,this.t=i,this.a=this.B(new D.$qe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new D.$qe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=w.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:s.$Ip,name:(0,E.localize)(2713,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,L.$hk)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(a,i,n){const t=this.getTelemetryDetails(),o=new r(i,n,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),c=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...c,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(a,i,n){this.f=a,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const i=Object.create(null);switch(i["common.extname"]=`${a.publisher}.${a.name}`,i["common.extversion"]=a.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=l(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case O.UIKind.Web:i["common.uikind"]="web";break;case O.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,m.$on)((0,s.$Op)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const i=this.getTelemetryDetails();this.r.forEach((n,t)=>{const o=n.filter(c=>!c.isDisposed);o.length===0?this.r.delete(t):this.r.set(t,o)}),this.r.forEach(n=>{for(const t of n)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,i){const t=this.r.get(a.value)?.filter(c=>!c.isDisposed);if(!t)return this.r.delete(a.value),!1;let o=!1;for(const c of t)c.ignoreUnhandledExtHostErrors||(c.logError(i),o=!0);return o}};e.$2Q=p,e.$2Q=p=He([qe(0,R.$1Q),qe(1,L.$gk)],p);class r{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,i,n,t,o,c,g){this.g=n,this.h=t,this.i=o,this.j=c,this.a=new D.$qe,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(a,i){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let i="properties"in a?a.properties??{}:a;return i=(0,s.$Rp)(i,[]),this.c&&(i=(0,I.$no)(i,this.c)),this.b||(i=(0,I.$no)(i,this.j)),"properties"in a?a.properties=i:a=i,a}k(a,i){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(a,i),this.h.trace(a,i))}logUsage(a,i){this.d.isUsageEnabled&&this.k(a,i)}logError(a,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,i);else{const n={name:a.name,message:a.message,stack:a.stack,cause:a.cause},t=(0,s.$Rp)(n,[]),o=new Error(t.message,{cause:t.cause});o.stack=t.stack,o.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const a=this,i={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$3Q=r;function l(d){const a=Date.now()-new Date(d).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$5Q=(0,v.$Ki)("IExtHostTelemetry")}),define(Re[21],Te([1,0,6,2,178,112,18,3]),function(we,e,v,D,P,L,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EH=e.ActivationKind=e.$BH=e.$AH=e.$xH=e.ExtensionHostStartup=e.$wH=e.$vH=e.$uH=e.$tH=void 0,e.$yH=u,e.$zH=E,e.$CH=d,e.$DH=a,e.$tH=Object.freeze({identifier:new R.$xn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:D.URI.parse("void:location"),isBuiltin:!1,targetPlatform:R.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$uH="extensions.webWorker",e.$vH=(0,O.$Ki)("extensionService");class m{constructor(t){this.dependency=t}}e.$wH=m;var s;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,o,c){this.c=t,this.d=o.slice(0),this.e=c.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$fH.createActivationEventsMap(this.d)}}set(t,o,c){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const g=[],f=[],h=[],S=[],k=w(this.d),y=w(o),C=(A,F)=>A.extensionLocation.toString()===F.extensionLocation.toString()||A.isBuiltin===F.isBuiltin||A.isUserBuiltin===F.isUserBuiltin||A.isUnderDevelopment===F.isUnderDevelopment;for(const A of this.d){const F=y.get(A.identifier);if(!F){g.push(A.identifier),k.delete(A.identifier);continue}if(!C(A,F)){g.push(A.identifier),k.delete(A.identifier);continue}}for(const A of o){const F=k.get(A.identifier);if(!F){f.push(A);continue}if(!C(F,A)){g.push(F.identifier),k.delete(F.identifier);continue}}const T=new R.$yn(this.e),$=new R.$yn(c);for(const A of this.e)$.has(A)||h.push(A);for(const A of c)T.has(A)||S.push(A);const b=L.$fH.createActivationEventsMap(f),N={versionId:t,toRemove:g,toAdd:f,addActivationEvents:b,myToRemove:h,myToAdd:S};return this.delta(N),N}delta(t){if(this.c>=t.versionId)return null;const{toRemove:o,toAdd:c,myToRemove:g,myToAdd:f}=t,h=new R.$yn(o),S=new R.$yn(g);for(let k=0;k<this.d.length;k++)h.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)S.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of c)this.d.push(k);for(const k of f)this.e.push(k);return this.f=null,t}containsExtension(t){for(const o of this.e)if(R.$xn.equals(o,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const o of this.d){if(!this.containsExtension(o.identifier))continue;const c=L.$fH.readActivationEvents(o);for(const g of c)t.add(g)}return t}}e.$xH=I;function w(n){const t=new R.$zn;for(const o of n)t.set(o.identifier,o);return t}function u(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}function E(n,t){if(!u(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}class p{constructor(t,o,c,g){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=c,this.activationReason=g}}e.$AH=p;class r{constructor(t,o){this.description=t,this.value=o}}e.$BH=r;var l;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(l||(e.ActivationKind=l={}));function d(n){return{type:n.isBuiltin?R.ExtensionType.System:R.ExtensionType.User,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,P.$Xp)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}function a(n,t){const o=(0,P.$Vp)(n.manifest.publisher,n.manifest.name);return{id:o,identifier:new R.$xn(o),isBuiltin:n.type===R.ExtensionType.System,isUserBuiltin:n.type===R.ExtensionType.User&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform,publisherDisplayName:n.publisherDisplayName,...n.manifest}}class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,o){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$EH=i}),define(Re[205],Te([1,0,12,4,121,18,21,11,10]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yrc=e.$xrc=e.$wrc=e.$vrc=e.$urc=e.$trc=void 0,v=Ve(v);class s{static{this.NONE=new s(!1,-1,-1,-1)}constructor(a,i,n,t){this.startup=a,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=t}}e.$trc=s;class I{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,i){return a===-1||i===-1?-1:i-a}build(){return new s(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$urc=I;class w{constructor(a,i,n,t,o,c){this.activationFailed=a,this.activationFailedError=i,this.activationTimes=n,this.module=t,this.exports=o,this.disposable=c}}e.$vrc=w;class u extends w{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,D.$Zc.None)}}e.$wrc=u;class E extends w{constructor(){super(!1,null,s.NONE,{activate:void 0,deactivate:void 0},void 0,D.$Zc.None)}}e.$xrc=E;class p extends w{constructor(a){super(!0,a,s.NONE,{activate:void 0,deactivate:void 0},void 0,D.$Zc.None)}}let r=class{constructor(a,i,n,t){this.g=t,this.a=a,this.b=i,this.c=n,this.d=new L.$zn,this.f=Object.create(null)}dispose(){for(const[a,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const a=[];for(const[i,n]of this.d)a.push(n.wait());await Promise.all(a)}isActivated(a){const i=this.d.get(a);return!!(i&&i.value)}getActivatedExtension(a){const i=this.d.get(a);if(!i||!i.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return i.value}async activateByEvent(a,i){if(this.f[a])return;const n=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(n.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,i){const n=this.a.getExtensionDescription(a);if(!n)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(a){const i=a.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const i=this.a.getExtensionDescription(a.id);if(!i){const o=new Error(`Cannot activate unknown extension '${a.id.value}'`),c=this.k(a,null,[],new p(o));return this.c.onExtensionActivationError(a.id,o,new R.$wH(a.id.value)),c}const n=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of t){if(this.m(o))continue;const c=this.d.get(o);if(c){n.push(c);continue}if(this.l(o)){n.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:a.reason}));continue}const g=this.a.getExtensionDescription(o);if(g){if(!g.main&&!g.browser)continue;n.push(this.j({id:g.identifier,reason:a.reason}));continue}const f=i.displayName||i.identifier.value,h=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${o}'`),S=this.k(a,i.displayName,[],new p(h));return this.c.onExtensionActivationError(i.identifier,h,new R.$wH(o)),S}return this.k(a,i.displayName,n,null)}k(a,i,n,t){const o=new l(a.id,i,a.reason,n,t,this.c,this.g);return this.d.set(a.id,o),o}l(a){return P.$8ec.isHostExtension(a,this.a,this.b)}m(a){const i=this.b.getExtensionDescription(a);return i?!i.main&&!i.browser:!1}};e.$yrc=r,e.$yrc=r=He([qe(3,O.$fk)],r);let l=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,i,n,t,o,c,g){this.c=a,this.d=i,this.f=n,this.g=t,this.h=o,this.j=c,this.k=g,this.a=new m.$Jh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const i=this.g[a];if(i.value&&!i.value.activationFailed){this.g.splice(a,1),a--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new p(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const i=new Error;if(a&&a.name&&(i.name=a.name),a&&a.message?i.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(i.stack=a.stack),this.h=new p(i),this.b&&v.$8(a))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};l=He([qe(6,O.$fk)],l)});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[122],Te([1,0,9,12,37,111,78,29,18,109,112,105]),function(we,e,v,D,P,L,R,O,m,s,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=void 0,v=Ve(v),P=oi(P);const u=O.$xo.as(R.$yo.JSONContribution);class E{constructor(t,o,c){this.a=t,this.b=o,this.c=c}d(t,o){this.a({type:t,message:o,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(P.default.Error,t)}warn(t){this.d(P.default.Warning,t)}info(t){this.d(P.default.Info,t)}}e.$nH=E;class p{static a(t){const o=new m.$yn;for(let c=0,g=t.length;c<g;c++)o.add(t[c].description.identifier);return o}static compute(t,o){if(!t||!t.length)return new p(o,[]);if(!o||!o.length)return new p([],t);const c=this.a(t),g=this.a(o),f=o.filter(S=>!c.has(S.description.identifier)),h=t.filter(S=>!g.has(S.description.identifier));return new p(f,h)}constructor(t,o){this.added=t,this.removed=o}}e.$oH=p;class r{constructor(t,o){this.name=t,this.defaultExtensionKind=o,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=p.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,D.$4)(t)}}}e.$pH=r;const l={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(12300,null),v.localize(12301,null)]},d="vscode://schemas/vscode-extensions";e.$qH={properties:{engines:{type:"object",description:v.localize(12302,null),properties:{vscode:{type:"string",description:v.localize(12303,null),default:"^1.22.0"}}},publisher:{description:v.localize(12304,null),type:"string"},displayName:{description:v.localize(12305,null),type:"string"},categories:{description:v.localize(12306,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$wn},{type:"string",const:"Languages",deprecationMessage:v.localize(12307,null)}]}},galleryBanner:{type:"object",description:v.localize(12308,null),properties:{color:{description:v.localize(12309,null),type:"string"},theme:{description:v.localize(12310,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(12311,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(12312,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(12313,null)},enabledApiProposals:{markdownDescription:v.localize(12314,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals).map(n=>n),markdownEnumDescriptions:Object.values(w.allApiProposals).map(n=>n.proposal)}},api:{markdownDescription:v.localize(12315,null),type:"string",enum:["none"],enumDescriptions:[v.localize(12316,null)]},activationEvents:{description:v.localize(12317,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(12318,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(12319,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(12320,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(12321,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(12322,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(12323,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(12324,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(12325,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(12326,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(12327,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(12328,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(12329,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(12330,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(12331,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(12332,null)},{label:"onUri",body:"onUri",description:v.localize(12333,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(12334,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(12335,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(12336,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(12337,null)},{label:"onRenderer",description:v.localize(12338,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(12339,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(12340,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(12341,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(12342,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:v.localize(12343,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolId}",description:v.localize(12344,null)},{label:"*",description:v.localize(12345,null),body:"*"}]}},badges:{type:"array",description:v.localize(12346,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(12347,null)},href:{type:"string",description:v.localize(12348,null)},description:{type:"string",description:v.localize(12349,null)}}}},markdown:{type:"string",description:v.localize(12350,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(12351,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(12352,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$ep}},extensionPack:{description:v.localize(12353,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$ep}},extensionKind:{description:v.localize(12354,null),type:"array",items:l,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(12355,null)},{body:["workspace"],description:v.localize(12356,null)},{body:["ui","workspace"],description:v.localize(12357,null)},{body:["workspace","ui"],description:v.localize(12358,null)},{body:[],description:v.localize(12359,null)}]},capabilities:{description:v.localize(12360,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(12361,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(12362,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(12363,null),v.localize(12364,null),v.localize(12365,null)]},description:{type:"string",markdownDescription:v.localize(12366,null)}}},untrustedWorkspaces:{description:v.localize(12367,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(12368,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(12369,null),v.localize(12370,null),v.localize(12371,null)]},restrictedConfigurations:{description:v.localize(12372,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(12373,null)}}}}},sponsor:{description:v.localize(12374,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(12375,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(12376,null),type:"string"},"vscode:uninstall":{description:v.localize(12377,null),type:"string"}}},icon:{type:"string",description:v.localize(12378,null)},l10n:{type:"string",description:v.localize(12379,null)},pricing:{type:"string",markdownDescription:v.localize(12380,null),enum:["Free","Trial"],default:"Free"}}};class a{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const o=new r(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,o),t.activationEventsGenerator&&I.$fH.register(t.extensionPoint,t.activationEventsGenerator),e.$qH.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema(d,e.$qH),o}getExtensionPoints(){return Array.from(this.a.values())}}e.$rH=a;const i={ExtensionsRegistry:"ExtensionsRegistry"};O.$xo.add(i.ExtensionsRegistry,new a),e.$sH=O.$xo.as(i.ExtensionsRegistry),u.registerSchema(d,e.$qH),u.registerSchema(s.$zk,{properties:{extensionEnabledApiProposals:{description:v.localize(12381,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals).map(n=>n.proposal)}}]}}}})}),define(Re[206],Te([1,0,6,41,4,13,9,18,3,11,21,122]),function(we,e,v,D,P,L,R,O,m,s,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HH=e.$GH=e.$FH=e.ChatMessageRole=void 0;var u;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$FH=(0,m.$Ki)("ILanguageModelsService");const E={type:"object",properties:{vendor:{type:"string",description:(0,R.localize)(4737,null)}}};e.$GH=w.$sH.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,R.localize)(4738,null),oneOf:[E,{type:"array",items:E}]},activationEventsGenerator:(r,l)=>{for(const d of r)l.push(`onLanguageModelChat:${d.vendor}`)}});let p=class{constructor(l,d){this.e=l,this.f=d,this.a=new P.$Yc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$qe),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$GH.setHandler(a=>{this.c.clear();for(const n of a){if(!(0,I.$yH)(n.description,"chatProvider")){n.collector.error((0,R.localize)(4739,null));continue}for(const t of D.Iterable.wrap(n.value)){if(this.c.has(t.vendor)){n.collector.error((0,R.localize)(4740,null,t.vendor));continue}if((0,L.$hf)(t.vendor)){n.collector.error((0,R.localize)(4741,null));continue}if(t.vendor.trim()!==t.vendor){n.collector.error((0,R.localize)(4742,null));continue}this.c.add(t.vendor)}}const i=[];for(const[n,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(n),i.push(n));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(l){return this.b.get(l)?.metadata}async selectLanguageModels(l){if(l.vendor)await this.e.activateByEvent(`onLanguageModelChat:${l.vendor}}`);else{const a=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(a)}const d=[];for(const[a,i]of this.b)(l.vendor===void 0||i.metadata.vendor===l.vendor)&&(l.family===void 0||i.metadata.family===l.family)&&(l.version===void 0||i.metadata.version===l.version)&&(l.identifier===void 0||i.metadata.id===l.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(n=>O.$xn.equals(n,l.extension)))&&d.push(a);return this.f.trace("[LM] selected language models",l,d),d}registerLanguageModelChat(l,d){if(this.f.trace("[LM] registering language model chat",l,d.metadata),!this.c.has(d.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${d.metadata.vendor}.`);if(this.b.has(l))throw new Error(`Chat response provider with identifier ${l} is already registered.`);return this.b.set(l,d),this.d.fire({added:[{identifier:l,metadata:d.metadata}]}),(0,P.$Xc)(()=>{this.b.delete(l)&&(this.d.fire({removed:[l]}),this.f.trace("[LM] UNregistered language model chat",l,d.metadata))})}async sendChatRequest(l,d,a,i,n){const t=this.b.get(l);if(!t)throw new Error(`Chat response provider with identifier ${l} is not registered.`);return t.sendChatRequest(a,d,i,n)}computeTokenLength(l,d,a){const i=this.b.get(l);if(!i)throw new Error(`Chat response provider with identifier ${l} is not registered.`);return i.provideTokenCount(d,a)}};e.$HH=p,e.$HH=p=He([qe(0,I.$vH),qe(1,s.$fk)],p)}),define(Re[207],Te([1,0,9,14,25,122,31,6]),function(we,e,v,D,P,L,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dJ=void 0,v=Ve(v),D=Ve(D),P=Ve(P);const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(9876,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(9877,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(9878,null),default:""}}};var s;(function(u){function E(p,r,l){if(!p)return;const d=D.$jg(p.type)?p.type:void 0;if(!d||d.length===0){l.error(v.localize(9879,null));return}const a=[];if(Array.isArray(p.required))for(const i of p.required)D.$jg(i)&&a.push(i);return{extensionId:r.value,taskType:d,required:a,properties:p.properties?P.$ko(p.properties):{},when:p.when?R.$Ij.deserialize(p.when):void 0}}u.from=E})(s||(s={}));const I=L.$sH.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,E)=>{for(const p of u)p.type&&E.push(`onTaskType:${p.type}`)},jsonSchema:{description:v.localize(9880,null),type:"array",items:m}});class w{constructor(){this.d=new O.$qe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,p)=>{I.setHandler((r,l)=>{this.c=void 0;try{for(const d of l.removed){const a=d.value;for(const i of a)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const d of l.added){const a=d.value;for(const i of a){const n=s.from(i,d.description.identifier,d.collector);n&&(this.a[n.taskType]=n)}}(l.removed.length>0||l.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const p of this.all()){const r={type:"object",additionalProperties:!1};p.required.length>0&&(r.required=p.required.slice(0)),p.properties!==void 0?r.properties=P.$ko(p.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[p.taskType]},E.push(r)}this.c={oneOf:E}}return this.c}}e.$dJ=new w}),define(Re[208],Te([1,0,9,14,24,25,31,207,44]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$nJ=e.JsonSchemaVersion=e.ExecutionEngine=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$hJ=e.ShellQuoting=e.$gJ=e.$fJ=e.$eJ=void 0,v=Ve(v),D=Ve(D),P=Ve(P),L=Ve(L),e.$eJ="settings",e.$fJ=new R.$2j("taskRunning",!1,v.localize(9881,null)),e.$gJ=v.localize2(9883,"Tasks");var s;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(s||(e.ShellQuoting=s={})),e.$hJ="$customized",function(j){function U(J){if(!J)return j.Strong;switch(J.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=U}(s||(e.ShellQuoting=s={}));var I;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var w;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(w||(e.RevealKind=w={})),function(j){function U(J){switch(J.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=U}(w||(e.RevealKind=w={}));var u;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(j){function U(J){switch(J.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=U}(u||(e.RevealProblemKind=u={}));var E;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(E||(e.PanelKind=E={})),function(j){function U(J){switch(J.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=U}(E||(e.PanelKind=E={}));var p;(function(j){j.defaults={echo:!0,reveal:w.Always,revealProblems:u.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var r;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(j){function U(Z){switch(Z.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=U;function J(Z){switch(Z){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=J}(r||(e.RuntimeType=r={}));var l;(function(j){function U(J){return D.$jg(J)?J:J.value}j.value=U})(l||(e.CommandString=l={}));var d;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function U(Z){return Z===j.Clean._id||Z===j.Build._id||Z===j.Rebuild._id||Z===j.Test._id}j.is=U;function J(Z){if(Z!==void 0)return D.$jg(Z)?U(Z)?{_id:Z,isDefault:!1}:void 0:Z}j.from=J})(d||(e.TaskGroup=d={}));var a;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var i;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function U(J){switch(J){case j.User:return m.ConfigurationTarget.USER;case j.WorkspaceFile:return m.ConfigurationTarget.WORKSPACE;default:return m.ConfigurationTarget.WORKSPACE_FOLDER}}j.toConfigurationTarget=U})(i||(e.TaskSourceKind=i={}));var n;(function(j){j.parallel="parallel",j.sequence="sequence"})(n||(e.DependsOrder=n={}));var t;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var o;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class c{constructor(U,J,Z,ae,ee,oe){this._label="",this._id=U,J&&(this._label=J),Z&&(this.type=Z),this.runOptions=ae,this.configurationProperties=ee,this._source=oe}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,J=!1){if(U===void 0)return!1;if(D.$jg(U))return U===this._label||U===this.configurationProperties.identifier||J&&U===this._id;const Z=this.getDefinition(!0);return Z!==void 0&&Z._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$iJ=c;class g extends c{constructor(U,J,Z,ae,ee,oe,ie,ue){super(U,Z,void 0,ie,ue,J),this.command={},this._source=J,this.hasDefinedMatchers=oe,ee&&(this.command=ee)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let J;switch(this.command?this.command.runtime:void 0){case r.Shell:J="shell";break;case r.Process:J="process";break;case r.CustomExecution:J="customExecution";break;case void 0:J="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:J,_key:this._id,id:this._id}}}static is(U){return U instanceof g}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$eJ:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.d();if(!U)return;let J=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(J+=this._source.kind);const Z={type:e.$hJ,folder:U,id:J};return JSON.stringify(Z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ih(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new g(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$jJ=g;class f extends c{constructor(U,J,Z,ae,ee,oe,ie){super(U,Z,ae,oe,ie,J),this._source=J,this.configures=ee}static is(U){return U instanceof f}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ih(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$eJ:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.d();if(!U)return;let J=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(J+=this._source.kind);const Z={type:e.$hJ,folder:U,id:J};return JSON.stringify(Z)}}e.$kJ=f;class h extends c{constructor(U,J,Z,ae,ee,oe,ie,ue,_){super(U,Z,ae,ue,_,J),this.defines=ee,this.hasDefinedMatchers=ie,this.command=oe,this.icon=_.icon,this.hide=_.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof h}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===a.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new h(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$lJ=h;class S extends c{constructor(U,J,Z,ae,ee,oe){super(U,Z,ae,ee,oe,J),this._source=J}clone(){return new S(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof S}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new S(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$mJ=S;var k;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(k||(e.ExecutionEngine=k={})),function(j){j._default=j.Terminal}(k||(e.ExecutionEngine=k={}));var y;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class C{constructor(U){this.c=new Map;for(let J=0;J<U.length;J++)this.c.set(U[J].uri.toString(),J)}compare(U,J){const Z=U.getWorkspaceFolder(),ae=J.getWorkspaceFolder();if(Z&&ae){let ee=this.c.get(Z.uri.toString());ee=ee===void 0?0:ee+1;let oe=this.c.get(ae.uri.toString());return oe=oe===void 0?0:oe+1,ee===oe?U._label.localeCompare(J._label):ee-oe}else return!Z&&ae?-1:Z&&!ae?1:0}}e.$nJ=C;var T;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})(T||(e.TaskEventKind=T={}));var $;(function(j){j.SingleRun="singleRun",j.Background="background"})($||(e.TaskRunType=$={}));var b;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var N;(function(j){function U(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?$.Background:$.SingleRun,group:ue.configurationProperties.group,__task:ue}}function J(ue,_,$e){return{...U(ue),kind:T.Start,terminalId:_,resolvedVariables:$e}}j.start=J;function Z(ue,_,$e){return{...U(ue),kind:T.ProcessStarted,terminalId:_,processId:$e}}j.processStarted=Z;function ae(ue,_,$e){return{...U(ue),kind:T.ProcessEnded,terminalId:_,exitCode:$e}}j.processEnded=ae;function ee(ue,_,$e){return{...U(ue),kind:T.Terminated,exitReason:$e,terminalId:_}}j.terminated=ee;function oe(ue,_,$e){return{...U(_),kind:ue,terminalId:$e}}j.general=oe;function ie(){return{kind:T.Changed}}j.changed=ie})(N||(e.TaskEvent=N={}));var A;(function(j){function U(Z){const ae=Object.keys(Z).sort();let ee="";for(const oe of ae){let ie=Z[oe];ie instanceof Object?ie=U(ie):typeof ie=="string"&&(ie=ie.replace(/,/g,",,")),ee+=oe+","+ie+","}return ee}function J(Z){const ee={_key:U(Z),type:Z.taskType};return Object.assign(ee,Z),ee}j.create=J})(A||(e.KeyedTaskIdentifier=A={}));var F;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection",j.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var G;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(G||(e.TasksSchemaProperties=G={}));var x;(function(j){function U(J,Z){const ae=O.$dJ.get(J.type);if(ae===void 0){const ue=L.$ko(J);return delete ue._key,A.create(ue)}const ee=Object.create(null);ee.type=ae.taskType;const oe=new Set;ae.required.forEach(ue=>oe.add(ue));const ie=ae.properties;for(const ue of Object.keys(ie)){const _=J[ue];if(_!=null)ee[ue]=_;else if(oe.has(ue)){const $e=ie[ue];if($e.default!==void 0)ee[ue]=L.$ko($e.default);else switch($e.type){case"boolean":ee[ue]=!1;break;case"number":case"integer":ee[ue]=0;break;case"string":ee[ue]="";break;default:Z.error(v.localize(9882,null,JSON.stringify(J,void 0,0),ue));return}}}return A.create(ee)}j.createTaskIdentifier=U})(x||(e.TaskDefinition=x={}))}),define(Re[209],Te([1,0,12]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=e.$_ec=void 0;class D{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,O)=>{this.b=R,this.d=O,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,v.$4)(R))}then(R,O){return this.j().then(R,O)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$_ec=D;class P extends D{constructor(){super(),this.h=!0,this.i=new v.$9}}e.$afc=P}),define(Re[39],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7w=e.$4w=void 0,e.$5w=P,e.$6w=L;class v{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++v.count}}e.$4w=v;const D=[];function P(O){const m=new v(O);return D[m.nid]=m,m}function L(O){return D[O].sid}class R{constructor(m){this.value=m}}e.$7w=R}),define(Re[5],Te([1,0,39]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$N=e.$0N=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$9N=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(D||(e.TextEditorRevealType=D={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var L;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var O;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(O||(e.WebviewMessageArrayBufferViewType=O={}));var m;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var s;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var I;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class w{static{this.a=0}static mixin(l){return l._id=w.a++,l}}e.$9N=w;var u;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var E;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var p;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$0N={MainThreadAuthentication:(0,v.$5w)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$5w)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$5w)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$5w)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$5w)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$5w)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,v.$5w)("MainThreadChatSkills"),MainThreadClipboard:(0,v.$5w)("MainThreadClipboard"),MainThreadCommands:(0,v.$5w)("MainThreadCommands"),MainThreadComments:(0,v.$5w)("MainThreadComments"),MainThreadConfiguration:(0,v.$5w)("MainThreadConfiguration"),MainThreadConsole:(0,v.$5w)("MainThreadConsole"),MainThreadDebugService:(0,v.$5w)("MainThreadDebugService"),MainThreadDecorations:(0,v.$5w)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$5w)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$5w)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$5w)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$5w)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$5w)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$5w)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$5w)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$5w)("MainThreadErrors"),MainThreadTreeViews:(0,v.$5w)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$5w)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$5w)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$5w)("MainThreadLanguages"),MainThreadLogger:(0,v.$5w)("MainThreadLogger"),MainThreadMessageService:(0,v.$5w)("MainThreadMessageService"),MainThreadOutputService:(0,v.$5w)("MainThreadOutputService"),MainThreadProgress:(0,v.$5w)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$5w)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$5w)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$5w)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$5w)("MainThreadSecretState"),MainThreadStorage:(0,v.$5w)("MainThreadStorage"),MainThreadSpeech:(0,v.$5w)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$5w)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$5w)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$5w)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$5w)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$5w)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$5w)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$5w)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$5w)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$5w)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$5w)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$5w)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$5w)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$5w)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$5w)("MainThreadExtensionService"),MainThreadSCM:(0,v.$5w)("MainThreadSCM"),MainThreadSearch:(0,v.$5w)("MainThreadSearch"),MainThreadShare:(0,v.$5w)("MainThreadShare"),MainThreadTask:(0,v.$5w)("MainThreadTask"),MainThreadWindow:(0,v.$5w)("MainThreadWindow"),MainThreadLabelService:(0,v.$5w)("MainThreadLabelService"),MainThreadNotebook:(0,v.$5w)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$5w)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$5w)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$5w)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$5w)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$5w)("MainThreadInteractive"),MainThreadTheming:(0,v.$5w)("MainThreadTheming"),MainThreadTunnelService:(0,v.$5w)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$5w)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$5w)("MainThreadTimeline"),MainThreadTesting:(0,v.$5w)("MainThreadTesting"),MainThreadLocalization:(0,v.$5w)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$5w)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$5w)("MainThreadAiEmbeddingVector")},e.$$N={ExtHostCommands:(0,v.$5w)("ExtHostCommands"),ExtHostConfiguration:(0,v.$5w)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$5w)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$5w)("ExtHostDebugService"),ExtHostDecorations:(0,v.$5w)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$5w)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$5w)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$5w)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$5w)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$5w)("ExtHostEditors"),ExtHostTreeViews:(0,v.$5w)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$5w)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$5w)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$5w)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$5w)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$5w)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$5w)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$5w)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$5w)("ExtHostStatusBar"),ExtHostShare:(0,v.$5w)("ExtHostShare"),ExtHostExtensionService:(0,v.$5w)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$5w)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$5w)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$5w)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$5w)("ExtHostSCM"),ExtHostSearch:(0,v.$5w)("ExtHostSearch"),ExtHostTask:(0,v.$5w)("ExtHostTask"),ExtHostWorkspace:(0,v.$5w)("ExtHostWorkspace"),ExtHostWindow:(0,v.$5w)("ExtHostWindow"),ExtHostWebviews:(0,v.$5w)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$5w)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$5w)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$5w)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$5w)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$5w)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$5w)("ExtHostProgress"),ExtHostComments:(0,v.$5w)("ExtHostComments"),ExtHostSecretState:(0,v.$5w)("ExtHostSecretState"),ExtHostStorage:(0,v.$5w)("ExtHostStorage"),ExtHostUrls:(0,v.$5w)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$5w)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$5w)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$5w)("ExtHostOutputService"),ExtHostLabelService:(0,v.$5w)("ExtHostLabelService"),ExtHostNotebook:(0,v.$5w)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$5w)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$5w)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$5w)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$5w)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$5w)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$5w)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$5w)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$5w)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,v.$5w)("ExtHostChatSkills"),ExtHostChatProvider:(0,v.$5w)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$5w)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$5w)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$5w)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$5w)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$5w)("ExtHostTheming"),ExtHostTunnelService:(0,v.$5w)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$5w)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$5w)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$5w)("ExtHostTimeline"),ExtHostTesting:(0,v.$5w)("ExtHostTesting"),ExtHostTelemetry:(0,v.$5w)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$5w)("ExtHostLocalization")}}),define(Re[85],Te([1,0,3,11,5,16]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uqc=e.$Tqc=e.$Sqc=void 0,P=Ve(P),e.$Sqc=(0,v.$Ki)("IExtHostApiDeprecationService");let R=class{constructor(m,s){this.c=s,this.a=new Set,this.b=m.getProxy(P.$0N.MainThreadTelemetry)}report(m,s,I){const w=this.d(m,s);this.a.has(w)||(this.a.add(w),s.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:s.identifier.value,apiId:m}))}d(m,s){return`${m}-${s.identifier.value}`}};e.$Tqc=R,e.$Tqc=R=He([qe(0,L.$KQ),qe(1,D.$fk)],R),e.$Uqc=Object.freeze(new class{report(O,m,s){}})}),define(Re[210],Te([1,0,5]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8qc=void 0;class D{constructor(L){const R=L.getProxy(v.$0N.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(O){return R.$writeText(O)}})}}e.$8qc=D}),define(Re[211],Te([1,0,25,5,26,16]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9sc=void 0;let R=class{constructor(I,w){this.a=I.getProxy(D.$0N.MainThreadConsole),this.b=w.consoleForward.includeStack,this.c=w.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,w){const u=this,E=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u.e(I,w,E,arguments)}})}e(I,w,u,E){this.a.$logExtensionHostMessage({type:"__$console",severity:w,arguments:m(E,this.b)}),this.c&&this.f(I,u,E)}};e.$9sc=R,e.$9sc=R=He([qe(0,L.$KQ),qe(1,P.$1Q)],R);const O=1e5;function m(s,I){const w=[];if(s.length)for(let u=0;u<s.length;u++){let E=s[u];if(typeof E>"u")E="undefined";else if(E instanceof Error){const p=E;p.stack?E=p.stack:E=p.toString()}w.push(E)}if(I){const u=new Error().stack;u&&w.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,v.$po)(w);return u.length>O?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Re[212],Te([1,0,2,5,21]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0rc=void 0;class L{constructor(O){this.a=O.getProxy(D.$0N.MainThreadDialogs)}showOpenDialog(O,m){return m?.allowUIResources&&(0,P.$zH)(O,"showLocal"),this.a.$showOpenDialog(m).then(s=>s?s.map(I=>v.URI.revive(I)):void 0)}showSaveDialog(O){return this.a.$showSaveDialog(O).then(m=>m?v.URI.revive(m):void 0)}}e.$0rc=L}),define(Re[213],Te([1,0,19,6,4,5]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$asc=void 0;class R{constructor(m){this.b=new Map,this.c=new D.$qe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=m.getProxy(L.$0N.MainThreadEmbeddings)}registerEmbeddingsProvider(m,s,I){if(this.d.has(s))throw new Error("An embeddings provider for this model is already registered");const w=this.e++;return this.a.$registerEmbeddingProvider(w,s),this.b.set(w,{id:s,provider:I}),(0,P.$Xc)(()=>{this.d.delete(s),this.a.$unregisterEmbeddingProvider(w),this.b.delete(w)})}async computeEmbeddings(m,s,I){I??=v.CancellationToken.None;let w=!1;typeof s=="string"&&(s=[s],w=!0);const u=await this.a.$computeEmbeddings(m,s,I);if(u.length!==s.length)throw new Error;if(w){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(m,s,I){const w=this.b.get(m);if(!w)return[];const u=await w.provider.provideEmbeddings(s,I);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(m){this.d=new Set(m),this.c.fire()}}e.$asc=R}),define(Re[214],Te([1,0,4,5]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wsc=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(D.$0N.MainThreadLabelService)}$registerResourceLabelFormatter(R){const O=this.b++;return this.a.$registerResourceLabelFormatter(O,R),(0,v.$Xc)(()=>{this.a.$unregisterResourceLabelFormatter(O)})}}e.$wsc=P}),define(Re[86],Te([1,0,23,13,2,3,11,5,26,16]),function(we,e,v,D,P,L,R,O,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nrc=e.$Mrc=void 0;let I=class{constructor(u,E,p){this.f=p,this.d=new Map,this.a=E.getProxy(O.$0N.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===v.$j}getMessage(u,E){const{message:p,args:r,comment:l}=E;if(this.c)return(0,D.$jf)(p,r??{});let d=p;l&&l.length>0&&(d+=`/${Array.isArray(l)?l.join(""):l}`);const a=this.d.get(u)?.contents[d];return a||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,D.$jf)(a??p,r??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let E;const p=await this.g(u);if(!p){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(p),l=JSON.parse(r);E=u.isBuiltin?l.contents?.bundle:l}catch(r){this.f.error(`Failed to load translations for ${u.identifier.value} from ${p}: ${r.message}`);return}E&&this.d.set(u.identifier.value,{contents:E,uri:p})}async g(u){if(u.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return P.URI.revive(E)}return u.l10n?P.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Mrc=I,e.$Mrc=I=He([qe(0,m.$1Q),qe(1,s.$KQ),qe(2,R.$fk)],I),e.$Nrc=(0,L.$Ki)("IExtHostLocalizationService")}),define(Re[215],Te([1,0,11,5,26,16,2,34]),function(we,e,v,D,P,L,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8sc=void 0;let m=class extends v.$qk{constructor(w,u){super(u.logLevel,u.logsLocation,u.loggers.map(E=>(0,O.$hi)(E))),this.r=w.getProxy(D.$0N.MainThreadLogger)}$setLogLevel(w,u){u?this.setLogLevel(R.URI.revive(u),w):this.setLogLevel(w)}setVisibility(w,u){super.setVisibility(w,u),this.r.$setVisibility(w,u)}s(w,u,E){return new s(this.r,w,u,E)}};e.$8sc=m,e.$8sc=m=He([qe(0,L.$KQ),qe(1,P.$1Q)],m);class s extends v.$lk{constructor(w,u,E,p){super(p?.logLevel==="always"),this.r=w,this.s=u,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(u,p).then(()=>{this.u(this.n),this.m=!0})}g(w,u){const E=[[w,u]];this.m?this.u(E):this.n.push(...E)}u(w){this.r.$log(this.s,w)}flush(){this.r.$flush(this.s)}}}),define(Re[87],Te([1,0,5,3,4,16,20]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Prc=e.$Orc=void 0,e.$Orc=(0,D.$Ki)("IExtHostManagedSockets");let O=class{constructor(w){this.b=0,this.c=null,this.d=new Map,this.a=w.getProxy(v.$0N.MainThreadManagedSockets)}setFactory(w,u){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(w,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(w){if(!this.c||this.c.socketFactoryId!==w)throw new Error(`No socket factory with id ${w}`);const u=++this.b,E=await this.c.makeConnection(),p=new P.$Yc;return this.d.set(u,new s(u,E,p)),p.add((0,P.$Xc)(()=>this.d.delete(u))),p.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),p.dispose()})),p.add(E.onDidClose(r=>{this.a.$onDidManagedSocketClose(u,r?.stack??r?.message),p.dispose()})),p.add(E.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(u,R.$Se.wrap(r)))),u}$remoteSocketWrite(w,u){this.d.get(w)?.actual.send(u.buffer)}$remoteSocketEnd(w){const u=this.d.get(w);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(w){await this.d.get(w)?.actual.drain?.()}};e.$Prc=O,e.$Prc=O=He([qe(0,L.$KQ)],O);class m{constructor(w,u){this.socketFactoryId=w,this.makeConnection=u}}class s extends P.$Zc{constructor(w,u,E){super(),this.socketId=w,this.actual=u,this.B(E)}}}),define(Re[216],Te([1,0,5,11,21]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zsc=void 0;function L(O){return O&&O.title}let R=class{constructor(m,s){this.b=s,this.a=m.getProxy(v.$0N.MainThreadMessageService)}showMessage(m,s,I,w,u){const E={source:{identifier:m.identifier,label:m.displayName||m.name}};let p;typeof w=="string"||L(w)?p=[w,...u]:(E.modal=w?.modal,E.useCustom=w?.useCustom,E.detail=w?.detail,p=u),E.useCustom&&(0,P.$zH)(m,"resolvers");const r=[];let l=!1;for(let d=0;d<p.length;d++){const a=p[d];if(typeof a=="string")r.push({title:a,handle:d,isCloseAffordance:!1});else if(typeof a=="object"){const{title:i,isCloseAffordance:n}=a;r.push({title:i,isCloseAffordance:!!n,handle:d}),n&&(l?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,a):l=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,a)}return this.a.$showMessage(s,I,E,r).then(d=>{if(typeof d=="number")return p[d]})}};e.$zsc=R,e.$zsc=R=He([qe(1,D.$fk)],R)}),define(Re[217],Te([1,0,4,14,2,21,5]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Isc=void 0;class O{constructor(s){this.b=new Map,this.a=s.getProxy(R.$0N.MainThreadProfileContentHandlers)}registerProfileContentHandler(s,I,w){if((0,L.$zH)(s,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,w),this.a.$registerProfileContentHandler(I,w.name,w.description,s.identifier.value),(0,v.$Xc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(s,I,w,u){const E=this.b.get(s);if(!E)throw new Error(`Unknown handler with id: ${s}`);return E.saveProfile(I,w,u)}async $readProfile(s,I,w){const u=this.b.get(s);if(!u)throw new Error(`Unknown handler with id: ${s}`);return u.readProfile((0,D.$jg)(I)?I:P.URI.revive(I),w)}}e.$Isc=O}),define(Re[88],Te([1,0,5,6,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Krc=e.$Jrc=void 0;class L{constructor(O){this.b=new D.$qe,this.onDidChangePassword=this.b.event,this.a=O.getProxy(v.$0N.MainThreadSecretState)}async $onDidChangePassword(O){this.b.fire(O)}get(O,m){return this.a.$getPassword(O,m)}store(O,m,s){return this.a.$setPassword(O,m,s)}delete(O,m){return this.a.$deletePassword(O,m)}}e.$Jrc=L,e.$Krc=(0,P.$Ki)("IExtHostSecretState")}),define(Re[218],Te([1,0,19,4,5]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Psc=void 0;class L{static{this.a=1}constructor(O){this.c=new Map,this.d=new Map,this.f=new Map,this.b=O.getProxy(P.$0N.MainThreadSpeech)}async $createSpeechToTextSession(O,m,s){const I=this.c.get(O);if(!I)return;const w=new D.$Yc,u=new v.$Be;this.d.set(m,u);const E=await I.provideSpeechToTextSession(u.token,s?{language:s}:void 0);E&&(w.add(E.onDidChange(p=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,p)})),w.add(u.token.onCancellationRequested(()=>w.dispose())))}async $cancelSpeechToTextSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}async $createTextToSpeechSession(O,m,s){const I=this.c.get(O);if(!I)return;const w=new D.$Yc,u=new v.$Be;this.d.set(m,u);const E=await I.provideTextToSpeechSession(u.token,s?{language:s}:void 0);E&&(this.f.set(m,E),w.add(E.onDidChange(p=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(m,p)})),w.add(u.token.onCancellationRequested(()=>w.dispose())))}async $synthesizeSpeech(O,m){this.f.get(O)?.synthesize(m)}async $cancelTextToSpeechSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O),this.f.delete(O)}async $createKeywordRecognitionSession(O,m){const s=this.c.get(O);if(!s)return;const I=new D.$Yc,w=new v.$Be;this.d.set(m,w);const u=await s.provideKeywordRecognitionSession(w.token);u&&(I.add(u.onDidChange(E=>{w.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,E)})),I.add(w.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}registerProvider(O,m,s){const I=L.a++;return this.c.set(I,s),this.b.$registerProvider(I,m,{extension:O,displayName:O.value}),(0,D.$Xc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$Psc=L}),define(Re[89],Te([1,0,5,6,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Arc=e.$zrc=void 0;class L{constructor(O,m){this.c=m,this.b=new D.$qe,this.onDidChangeStorage=this.b.event,this.a=O.getProxy(v.$0N.MainThreadStorage)}registerExtensionStorageKeysToSync(O,m){this.a.$registerExtensionStorageKeysToSync(O,m)}async initializeExtensionStorage(O,m,s){const I=await this.a.$initializeExtensionStorage(O,m);let w;return I&&(w=this.d(O,m,I)),w||s}setValue(O,m,s){return this.a.$setValue(O,m,s)}$acceptValue(O,m,s){const I=this.d(O,m,s);I&&this.b.fire({shared:O,key:m,value:I})}d(O,m,s){try{return JSON.parse(s)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${O}): ${I}`)}}}e.$zrc=L,e.$Arc=(0,P.$Ki)("IExtHostStorage")}),define(Re[219],Te([1,0,4,15,2,5]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2sc=void 0;class R{static{this.a=new Set([D.Schemas.http,D.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(L.$0N.MainThreadUriOpeners)}registerExternalUriOpener(m,s,I,w){if(this.c.has(s))throw new Error(`Opener with id '${s}' already registered`);const u=w.schemes.find(E=>!R.a.has(E));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(s,I),this.b.$registerUriOpener(s,w.schemes,m,w.label),(0,v.$Xc)(()=>{this.c.delete(s),this.b.$unregisterUriOpener(s)})}async $canOpenUri(m,s,I){const w=this.c.get(m);if(!w)throw new Error(`Unknown opener with id: ${m}`);const u=P.URI.revive(s);return w.canOpenExternalUri(u,I)}async $openUri(m,s,I){const w=this.c.get(m);if(!w)throw new Error(`Unknown opener id: '${m}'`);return w.openExternalUri(P.URI.revive(s.resolvedUri),{sourceUri:P.URI.revive(s.sourceUri)},I)}}e.$2sc=R}),define(Re[220],Te([1,0,5,2,4,12,18]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3sc=void 0;class O{static{this.a=0}constructor(s){this.c=new R.$yn,this.d=new Map,this.b=s.getProxy(v.$0N.MainThreadUrls)}registerUriHandler(s,I){const w=s.identifier;if(this.c.has(w))throw new Error(`Protocol handler already registered for extension ${w}`);const u=O.a++;return this.c.add(w),this.d.set(u,I),this.b.$registerUriHandler(u,w,s.displayName||s.name),(0,P.$Xc)(()=>{this.c.delete(w),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(s,I){const w=this.d.get(s);if(!w)return Promise.resolve(void 0);try{w.handleUri(D.URI.revive(I))}catch(u){(0,L.$4)(u)}return Promise.resolve(void 0)}async createAppUri(s){return D.URI.revive(await this.b.$createAppUri(s))}}e.$3sc=O}),define(Re[221],Te([1,0,20,5]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2vb=L,e.$3vb=O,D=Ve(D);class P{constructor(){this.buffers=[]}add(s){let I=this.buffers.indexOf(s);return I<0&&(I=this.buffers.length,this.buffers.push(s)),I}}function L(m,s){if(s.serializeBuffersForPostMessage){const I=new P,u=JSON.stringify(m,(p,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r)};if(ArrayBuffer.isView(r)){const l=R(r);if(l)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r.buffer),view:{type:l,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),E=I.buffers.map(p=>{const r=new Uint8Array(p);return v.$Se.wrap(r)});return{message:u,buffers:E}}else return{message:JSON.stringify(m),buffers:[]}}function R(m){switch(m.constructor.name){case"Int8Array":return D.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return D.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return D.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return D.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return D.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return D.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return D.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return D.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return D.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return D.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return D.WebviewMessageArrayBufferViewType.BigUint64Array}}function O(m,s){const I=s.map(E=>{const p=new ArrayBuffer(E.byteLength);return new Uint8Array(p).set(E.buffer),p}),w=s.length?(E,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const r=p,{index:l}=r,d=I[l];if(r.view)switch(r.view.type){case D.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(d,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(d,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(d,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(d,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(d,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(d,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(d,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(d,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(d,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(d,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(d,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return p}:void 0;return{message:JSON.parse(m,w),arrayBuffers:I}}}),define(Re[67],Te([1,0,6,4,15,25,2,175,221,83,5]),function(we,e,v,D,P,L,R,O,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mrc=e.$krc=void 0,e.$lrc=u,e.$nrc=r,e.$orc=l,L=Ve(L),I=Ve(I);class w{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(n,t,o,c,g,f,h){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new v.$qe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$qe,this._onDidDispose=this.#h.event,this.#e=n,this.#t=t,this.#o=o,this.#n=c,this.#s=g,this.#r=f,this.#u=u(f),this.#d=E(f),this.#i=h}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#l=!0,(0,s.$pEb)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===P.Schemas.https||n.scheme===P.Schemas.http){let t=n.toString();return t.endsWith("/")||(t+="/"),t+" "+s.$oEb}return s.$oEb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#o}set options(n){this.a(),L.$oo(this.#o,n)||this.#t.$setOptions(this.#e,l(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#c)return!1;const t=(0,m.$2vb)(n,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const t=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,o=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(c,g,f,h,S,k)=>{const y=R.URI.from({scheme:h||"file",path:decodeURIComponent(S)}),C=(0,s.$pEb)(y,{isRemote:t,authority:o}).toString();return`${g}${C}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(c,g,f,h,S,k)=>{const y=R.URI.from({scheme:h||"file",path:decodeURIComponent(S)}),C=(0,s.$pEb)(y,{isRemote:t,authority:o}).toString();return`${g}${C}${k}`})}}e.$krc=w;function u(i){try{const n=(0,O.$8p)((0,O.$7p)(i.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}function E(i){try{const n=(0,O.$8p)((0,O.$7p)(i.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class p extends D.$Zc{constructor(n,t,o,c,g){super(),this.c=t,this.f=o,this.g=c,this.h=g,this.b=new Map,this.a=n.getProxy(I.$0N.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,t,o){const c=this.j(n);if(c){const{message:g}=(0,m.$3vb)(t,o.value);c._onMessageEmitter.fire(g)}}$onMissingCsp(n,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,t,o){const c=new w(n,this.a,d(t),this.c,this.f,o,this.h);this.b.set(n,c);const g=c._onDidDispose(()=>{g.dispose(),this.deleteWebview(n)});return c}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$mrc=p;function r(i){return{id:i.identifier,location:i.extensionLocation}}function l(i,n,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||a(i,n)}}function d(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(n=>R.URI.from(n))}}function a(i,n){return[...(n?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Re[123],Te([1,0,6,15,13,2,3,16,5]),function(we,e,v,D,P,L,R,O,m){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$6sc=e.$5sc=void 0;let I=class{static{s=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new v.$qe,this.onDidChangeWindowState=this.c.event,this.d=s.a,this.b=u.getProxy(m.$0N.MainThreadWindow),this.b.$getInitialState().then(({isFocused:E,isActive:p})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",p)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,E){E!==this.d[u]&&(this.d={...this.d,[u]:E},this.c.fire(this.d))}openUri(u,E){let p;if(typeof u=="string"){p=u;try{u=L.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,P.$hf)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===D.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,p,E)}async asExternalUri(u,E){if((0,P.$hf)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(u,E);return L.URI.from(p)}};e.$5sc=I,e.$5sc=I=s=He([qe(0,O.$KQ)],I),e.$6sc=(0,R.$Ki)("IExtHostWindow")}),define(Re[222],Te([1,0,211,26,16]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ivc=void 0;let L=class extends v.$9sc{constructor(O,m){super(O,m)}f(O,m,s){m.apply(console,s)}};e.$ivc=L,e.$ivc=L=He([qe(0,P.$KQ),qe(1,D.$1Q)],L)}),define(Re[223],Te([1,0,10,20,19,30,12,6,4,38,159,209,39]),function(we,e,v,D,P,L,R,O,m,s,I,w,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=e.ResponsiveState=e.RequestInitiator=void 0,e.$bfc=a,e.$cfc=i,R=Ve(R);function p(N,A){try{return JSON.stringify(N,A)}catch{return"null"}}const r="$$ref$$",l={[r]:-1};class d{constructor(A,F){this.jsonString=A,this.referencedBuffers=F}}function a(N,A=null,F=!1){const G=[];return{jsonString:(F?p:JSON.stringify)(N,(j,U)=>{if(typeof U>"u")return l;if(typeof U=="object"){if(U instanceof D.$Se){const J=G.push(U)-1;return{[r]:J}}if(A)return A(j,U)}return U}),referencedBuffers:G}}function i(N,A,F){return JSON.parse(N,(G,x)=>{if(x){const j=x[r];if(typeof j=="number")return A[j];if(F&&x.$mid===s.MarshalledId.Uri)return F.transformIncoming(x)}return x})}function n(N,A){return JSON.stringify(N,A)}function t(N){return N?(A,F)=>F&&F.$mid===s.MarshalledId.Uri?N.transformOutgoing(F):F:null}var o;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var c;(function(N){N[N.Responsive=0]="Responsive",N[N.Unresponsive=1]="Unresponsive"})(c||(e.ResponsiveState=c={}));const g=()=>{},f=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class S extends m.$Zc{static{E=f}static{this.a=3*1e3}constructor(A,F=null,G=null){super(),this[E]=!0,this.b=this.B(new O.$qe),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=F,this.g=G,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let x=0,j=u.$4w.count;x<j;x++)this.m[x]=null,this.s[x]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=c.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Wh(()=>this.H(),1e3)),this.B(this.c.onMessage(x=>this.L(x)))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const F=this.w[A];delete this.w[A],F.resolveErr(R.$0())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+S.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+S.a,this.z--,this.z===0&&this.D.cancel(),this.I(c.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(c.Unresponsive):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,I.$Vn)(A,this.g):A}getProxy(A){const{nid:F,sid:G}=A;return this.s[F]||(this.s[F]=this.J(F,G)),this.s[F]}J(A,F){const G={get:(x,j)=>(typeof j=="string"&&!x[j]&&j.charCodeAt(0)===L.CharCode.DollarSign&&(x[j]=(...U)=>this.U(A,j,U)),j===h?F:x[j])};return new Proxy(Object.create(null),G)}set(A,F){return this.m[A.nid]=F,F}assertRegistered(A){for(let F=0,G=A.length;F<G;F++){const x=A[F];if(!this.m[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}L(A){if(this.j)return;const F=A.byteLength,G=y.read(A,0),x=G.readUInt8(),j=G.readUInt32();switch(x){case $.RequestJSONArgs:case $.RequestJSONArgsWithCancellation:{let{rpcId:U,method:J,args:Z}=T.deserializeRequestJSONArgs(G);this.g&&(Z=(0,I.$Vn)(Z,this.g)),this.M(F,j,U,J,Z,x===$.RequestJSONArgsWithCancellation);break}case $.RequestMixedArgs:case $.RequestMixedArgsWithCancellation:{let{rpcId:U,method:J,args:Z}=T.deserializeRequestMixedArgs(G);this.g&&(Z=(0,I.$Vn)(Z,this.g)),this.M(F,j,U,J,Z,x===$.RequestMixedArgsWithCancellation);break}case $.Acknowledged:{this.f?.logIncoming(F,j,o.LocalSide,"ack"),this.G(j);break}case $.Cancel:{this.N(F,j);break}case $.ReplyOKEmpty:{this.O(F,j,void 0);break}case $.ReplyOKJSON:{let U=T.deserializeReplyOKJSON(G);this.g&&(U=(0,I.$Vn)(U,this.g)),this.O(F,j,U);break}case $.ReplyOKJSONWithBuffers:{const U=T.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(F,j,U);break}case $.ReplyOKVSBuffer:{const U=T.deserializeReplyOKVSBuffer(G);this.O(F,j,U);break}case $.ReplyErrError:{let U=T.deserializeReplyErrError(G);this.g&&(U=(0,I.$Vn)(U,this.g)),this.P(F,j,U);break}case $.ReplyErrEmpty:{this.P(F,j,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,F,G,x,j,U){this.f?.logIncoming(A,F,o.OtherSide,`receiveRequest ${(0,u.$6w)(G)}.${x}(`,j);const J=String(F);let Z,ae;if(U){const oe=new P.$Be;j.push(oe.token),Z=this.Q(G,x,j),ae=()=>oe.cancel()}else Z=this.Q(G,x,j),ae=g;this.u[J]=ae;const ee=T.serializeAcknowledged(F);this.f?.logOutgoing(ee.byteLength,F,o.OtherSide,"ack"),this.c.send(ee),Z.then(oe=>{delete this.u[J];const ie=T.serializeReplyOK(F,oe,this.h);this.f?.logOutgoing(ie.byteLength,F,o.OtherSide,"reply:",oe),this.c.send(ie)},oe=>{delete this.u[J];const ie=T.serializeReplyErr(F,oe);this.f?.logOutgoing(ie.byteLength,F,o.OtherSide,"replyErr:",oe),this.c.send(ie)})}N(A,F){this.f?.logIncoming(A,F,o.OtherSide,"receiveCancel");const G=String(F);this.u[G]?.()}O(A,F,G){this.f?.logIncoming(A,F,o.LocalSide,"receiveReply:",G);const x=String(F);if(!this.w.hasOwnProperty(x))return;const j=this.w[x];delete this.w[x],j.resolveOk(G)}P(A,F,G){this.f?.logIncoming(A,F,o.LocalSide,"receiveReplyErr:",G);const x=String(F);if(!this.w.hasOwnProperty(x))return;const j=this.w[x];delete this.w[x];let U;G&&(G.$isError?(U=new Error,U.name=G.name,U.message=G.message,U.stack=G.stack):U=G),j.resolveErr(U)}Q(A,F,G){try{return Promise.resolve(this.S(A,F,G))}catch(x){return Promise.reject(x)}}S(A,F,G){const x=this.m[A];if(!x)throw new Error("Unknown actor "+(0,u.$6w)(A));const j=x[F];if(typeof j!="function")throw new Error("Unknown method "+F+" on actor "+(0,u.$6w)(A));return j.apply(x,G)}U(A,F,G){if(this.j)return new w.$afc;let x=null;if(G.length>0&&P.CancellationToken.isCancellationToken(G[G.length-1])&&(x=G.pop()),x&&x.isCancellationRequested)return Promise.reject(R.$0());const j=T.serializeRequestArguments(G,this.h),U=++this.t,J=String(U),Z=new w.$_ec,ae=new m.$Yc;x&&ae.add(x.onCancellationRequested(()=>{const oe=T.serializeCancel(U);this.f?.logOutgoing(oe.byteLength,U,o.LocalSide,"cancel"),this.c.send(T.serializeCancel(U))})),this.w[J]=new k(Z,ae),this.F(U);const ee=T.serializeRequest(U,A,F,j,!!x);return this.f?.logOutgoing(ee.byteLength,U,o.LocalSide,`request: ${(0,u.$6w)(A)}.${F}(`,G),this.c.send(ee),Z}}e.$dfc=S;class k{constructor(A,F){this.a=A,this.b=F}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class y{static alloc(A,F,G){const x=new y(D.$Se.alloc(G+1+4),0);return x.writeUInt8(A),x.writeUInt32(F),x}static read(A,F){return new y(A,F)}get buffer(){return this.a}constructor(A,F){this.a=A,this.b=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+A).toString();return this.b+=A,G}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+A).toString();return this.b+=A,G}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+A);return this.b+=A,F}static sizeMixedArray(A){let F=0;F+=1;for(let G=0,x=A.length;G<x;G++){const j=A[G];switch(F+=1,j.type){case b.String:F+=this.sizeLongString(j.value);break;case b.VSBuffer:F+=this.sizeVSBuffer(j.value);break;case b.SerializedObjectWithBuffers:F+=this.sizeUInt32,F+=this.sizeLongString(j.value);for(let U=0;U<j.buffers.length;++U)F+=this.sizeVSBuffer(j.buffers[U]);break;case b.Undefined:break}}return F}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let F=0,G=A.length;F<G;F++){const x=A[F];switch(x.type){case b.String:this.writeUInt8(b.String),this.writeLongString(x.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(x.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let j=0;j<x.buffers.length;++j)this.writeBuffer(x.buffers[j]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const F=new Array(A);for(let G=0;G<A;G++)switch(this.readUInt8()){case b.String:F[G]=this.readLongString();break;case b.VSBuffer:F[G]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const j=this.readUInt32(),U=this.readLongString(),J=[];for(let Z=0;Z<j;++Z)J.push(this.readVSBuffer());F[G]=new u.$7w(i(U,J,null));break}case b.Undefined:F[G]=void 0;break}return F}}var C;(function(N){N[N.Simple=0]="Simple",N[N.Mixed=1]="Mixed"})(C||(C={}));class T{static a(A){for(let F=0,G=A.length;F<G;F++)if(A[F]instanceof D.$Se||A[F]instanceof u.$7w||typeof A[F]>"u")return!0;return!1}static serializeRequestArguments(A,F){if(this.a(A)){const G=[];for(let x=0,j=A.length;x<j;x++){const U=A[x];if(U instanceof D.$Se)G[x]={type:b.VSBuffer,value:U};else if(typeof U>"u")G[x]={type:b.Undefined};else if(U instanceof u.$7w){const{jsonString:J,referencedBuffers:Z}=a(U.value,F);G[x]={type:b.SerializedObjectWithBuffers,value:D.$Se.fromString(J),buffers:Z}}else G[x]={type:b.String,value:D.$Se.fromString(n(U,F))}}return{type:C.Mixed,args:G}}return{type:C.Simple,args:n(A,F)}}static serializeRequest(A,F,G,x,j){switch(x.type){case C.Simple:return this.b(A,F,G,x.args,j);case C.Mixed:return this.c(A,F,G,x.args,j)}}static b(A,F,G,x,j){const U=D.$Se.fromString(G),J=D.$Se.fromString(x);let Z=0;Z+=y.sizeUInt8(),Z+=y.sizeShortString(U),Z+=y.sizeLongString(J);const ae=y.alloc(j?$.RequestJSONArgsWithCancellation:$.RequestJSONArgs,A,Z);return ae.writeUInt8(F),ae.writeShortString(U),ae.writeLongString(J),ae.buffer}static deserializeRequestJSONArgs(A){const F=A.readUInt8(),G=A.readShortString(),x=A.readLongString();return{rpcId:F,method:G,args:JSON.parse(x)}}static c(A,F,G,x,j){const U=D.$Se.fromString(G);let J=0;J+=y.sizeUInt8(),J+=y.sizeShortString(U),J+=y.sizeMixedArray(x);const Z=y.alloc(j?$.RequestMixedArgsWithCancellation:$.RequestMixedArgs,A,J);return Z.writeUInt8(F),Z.writeShortString(U),Z.writeMixedArray(x),Z.buffer}static deserializeRequestMixedArgs(A){const F=A.readUInt8(),G=A.readShortString(),x=A.readMixedArray(),j=new Array(x.length);for(let U=0,J=x.length;U<J;U++){const Z=x[U];typeof Z=="string"?j[U]=JSON.parse(Z):j[U]=Z}return{rpcId:F,method:G,args:j}}static serializeAcknowledged(A){return y.alloc($.Acknowledged,A,0).buffer}static serializeCancel(A){return y.alloc($.Cancel,A,0).buffer}static serializeReplyOK(A,F,G){if(typeof F>"u")return this.d(A);if(F instanceof D.$Se)return this.e(A,F);if(F instanceof u.$7w){const{jsonString:x,referencedBuffers:j}=a(F.value,G,!0);return this.g(A,x,j)}else return this.f(A,p(F,G))}static d(A){return y.alloc($.ReplyOKEmpty,A,0).buffer}static e(A,F){let G=0;G+=y.sizeVSBuffer(F);const x=y.alloc($.ReplyOKVSBuffer,A,G);return x.writeVSBuffer(F),x.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,F){const G=D.$Se.fromString(F);let x=0;x+=y.sizeLongString(G);const j=y.alloc($.ReplyOKJSON,A,x);return j.writeLongString(G),j.buffer}static g(A,F,G){const x=D.$Se.fromString(F);let j=0;j+=y.sizeUInt32,j+=y.sizeLongString(x);for(const J of G)j+=y.sizeVSBuffer(J);const U=y.alloc($.ReplyOKJSONWithBuffers,A,j);U.writeUInt32(G.length),U.writeLongString(x);for(const J of G)U.writeBuffer(J);return U.buffer}static deserializeReplyOKJSON(A){const F=A.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(A,F){const G=A.readUInt32(),x=A.readLongString(),j=[];for(let U=0;U<G;++U)j.push(A.readVSBuffer());return new u.$7w(i(x,j,F))}static serializeReplyErr(A,F){const G=F?p(R.$6(F),null):void 0;if(typeof G!="string")return this.h(A);const x=D.$Se.fromString(G);let j=0;j+=y.sizeLongString(x);const U=y.alloc($.ReplyErrError,A,j);return U.writeLongString(x),U.buffer}static deserializeReplyErrError(A){const F=A.readLongString();return JSON.parse(F)}static h(A){return y.alloc($.ReplyErrEmpty,A,0).buffer}}var $;(function(N){N[N.RequestJSONArgs=1]="RequestJSONArgs",N[N.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",N[N.RequestMixedArgs=3]="RequestMixedArgs",N[N.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",N[N.Acknowledged=5]="Acknowledged",N[N.Cancel=6]="Cancel",N[N.ReplyOKEmpty=7]="ReplyOKEmpty",N[N.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",N[N.ReplyOKJSON=9]="ReplyOKJSON",N[N.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",N[N.ReplyErrError=11]="ReplyErrError",N[N.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var b;(function(N){N[N.String=1]="String",N[N.VSBuffer=2]="VSBuffer",N[N.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",N[N.Undefined=4]="Undefined"})(b||(b={}))}),define(Re[224],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kvc=void 0;const v=function(L){const R=O=>{globalThis.removeEventListener("message",R);const m=O.data;Object.defineProperties(globalThis,{postMessage:{value(s,I){m.postMessage(s,I)}},onmessage:{get(){return m.onmessage},set(s){m.onmessage=s}}}),m.addEventListener("message",s=>{globalThis.dispatchEvent(new MessageEvent("message",{data:s.data,ports:s.ports?[...s.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",R)}.toString();class D extends EventTarget{constructor(L,R,O){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${v})('${R}'))`,s=new Blob([m],{type:"application/javascript"}),I=URL.createObjectURL(s),w=new MessageChannel,u=I,E={type:"_newWorker",id:u,port:w.port2,url:I,options:O};L(E,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{L({type:"_terminateWorker",id:u}),URL.revokeObjectURL(I),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(p){w.port1.onmessage=p}},onmessageerror:{get(){return w.port1.onmessageerror},set(p){w.port1.onmessageerror=p}}}),w.port1.addEventListener("messageerror",p=>{const r=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(r)}),w.port1.addEventListener("message",p=>{const r=new MessageEvent("message",{data:p.data});this.dispatchEvent(r)}),w.port1.start()}}e.$kvc=D}),define(Re[225],Te([1,0,20,27,15,60,3]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RL=e.$ML=void 0,e.$NL=I,e.$OL=w,e.$PL=u,e.$QL=E,e.$ML=(0,R.$Ki)("notebookDocumentService");const O=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${O.join("")}]+`),s=7;function I(r){if(r.scheme!==P.Schemas.vscodeNotebookCell)return;const l=r.fragment.indexOf("s");if(l<0)return;const d=parseInt(r.fragment.substring(0,l).replace(m,""),s),a=(0,v.$_e)(r.fragment.substring(l+1)).toString();if(!isNaN(d))return{handle:d,notebook:r.with({scheme:a,fragment:null})}}function w(r,l){const d=l.toString(s),i=`${d.length<O.length?O[d.length-1]:"z"}${d}s${(0,v.$af)(v.$Se.fromString(r.scheme),!0,!0)}`;return r.with({scheme:P.Schemas.vscodeNotebookCell,fragment:i})}function u(r){if(r.scheme!==P.Schemas.vscodeNotebookMetadata)return;const l=(0,v.$_e)(r.fragment).toString();return r.with({scheme:l,fragment:null})}function E(r){const l=`${(0,v.$af)(v.$Se.fromString(r.scheme),!0,!0)}`;return r.with({scheme:P.Schemas.vscodeNotebookMetadata,fragment:l})}class p{constructor(){this.a=new D.$Fc}getNotebook(l){if(l.scheme===P.Schemas.vscodeNotebookCell){const d=I(l);if(d){const a=this.a.get(d.notebook);if(a)return a}}return this.a.get(l)}addNotebookDocument(l){this.a.set(l.uri,l)}removeNotebookDocument(l){this.a.delete(l.uri)}}e.$RL=p,(0,L.$Zs)(e.$ML,p,L.InstantiationType.Delayed)}),define(Re[90],Te([1,0,20,43,41,72,15,22,23,31,225]),function(we,e,v,D,P,L,R,O,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=e.$0L=e.CellStatusbarAlignment=e.$9L=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$6L=e.$5L=e.$3L=e.CellUri=e.NotebookUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$2L=e.$1L=e.$ZL=e.$YL=e.CellKind=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=void 0,e.$4L=g,e.$7L=S,e.$8L=k,e.$$L=T,e.$_L=b,D=Ve(D),e.$SL="workbench.editor.notebook",e.$TL="workbench.editor.notebookTextDiffEditor",e.$UL="workbench.editor.notebookMultiTextDiffEditor",e.$VL="workbench.editor.interactive",e.$WL="workbench.editor.repl",e.$XL="replNotebook.input.execute";var w;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(w||(e.CellKind=w={})),e.$YL=["application/json","application/javascript","text/html","image/svg+xml",L.$gt.latex,L.$gt.markdown,"image/png","image/jpeg",L.$gt.text],e.$ZL=[L.$gt.latex,L.$gt.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$gt.text],e.$1L=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$2L="_notAvailable";var u;(function(Z){Z[Z.Running=1]="Running",Z[Z.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var E;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var p;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var r;(function(Z){Z[Z.WithHardKernelDependency=0]="WithHardKernelDependency",Z[Z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Z[Z.Pure=2]="Pure",Z[Z.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var l;(function(Z){Z.Always="always",Z.Never="never",Z.Optional="optional"})(l||(e.RendererMessagingSpec=l={}));var d;(function(Z){Z[Z.ModelChange=1]="ModelChange",Z[Z.Move=2]="Move",Z[Z.ChangeCellLanguage=5]="ChangeCellLanguage",Z[Z.Initialize=6]="Initialize",Z[Z.ChangeCellMetadata=7]="ChangeCellMetadata",Z[Z.Output=8]="Output",Z[Z.OutputItem=9]="OutputItem",Z[Z.ChangeCellContent=10]="ChangeCellContent",Z[Z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Z[Z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Z[Z.ChangeCellMime=13]="ChangeCellMime",Z[Z.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var a;(function(Z){Z[Z.Handle=0]="Handle",Z[Z.Index=1]="Index"})(a||(e.SelectionStateType=a={}));var i;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Output=2]="Output",Z[Z.Metadata=3]="Metadata",Z[Z.CellLanguage=4]="CellLanguage",Z[Z.DocumentMetadata=5]="DocumentMetadata",Z[Z.Move=6]="Move",Z[Z.OutputItems=7]="OutputItems",Z[Z.PartialMetadata=8]="PartialMetadata",Z[Z.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(Z){Z.scheme=R.Schemas.vscodeNotebookMetadata;function ae(oe){return(0,I.$QL)(oe)}Z.generate=ae;function ee(oe){return(0,I.$PL)(oe)}Z.parse=ee})(n||(e.NotebookUri=n={}));var t;(function(Z){Z.scheme=R.Schemas.vscodeNotebookCell;function ae($e,Ie){return(0,I.$OL)($e,Ie)}Z.generate=ae;function ee($e){return(0,I.$NL)($e)}Z.parse=ee;function oe($e,Ie){return $e.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${Ie??""},${$e.scheme!==R.Schemas.file?$e.scheme:""}`})}Z.generateCellOutputUri=oe;function ie($e){if($e.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const Ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!Ie)return;const X=Ie[1]&&Ie[1]!==""?Ie[1]:void 0,V=Ie[2];return{outputId:X,notebook:$e.with({scheme:V||R.Schemas.file,fragment:null})}}Z.parseCellOutputUri=ie;function ue($e,Ie,X){return Z.generate($e,Ie).with({scheme:X})}Z.generateCellPropertyUri=ue;function _($e,Ie){if($e.scheme===Ie)return Z.parse($e.with({scheme:Z.scheme}))}Z.parseCellPropertyUri=_})(t||(e.CellUri=t={}));const o=Z=>m.$l?Z.replace(/\//g,"\\"):Z;class c{constructor(ae=[],ee=e.$YL){this.e=ee,this.d=[...new Set(ae)].map(oe=>({pattern:oe,matches:D.$Fk(o(oe))}))}sort(ae){const ee=new Map(P.Iterable.map(ae,ie=>[ie,o(ie)]));let oe=[];for(const{matches:ie}of this.d)for(const[ue,_]of ee)if(ie(_)){oe.push(ue),ee.delete(ue);break}return ee.size&&(oe=oe.concat([...ee.keys()].sort((ie,ue)=>this.e.indexOf(ie)-this.e.indexOf(ue)))),oe}prioritize(ae,ee){const oe=this.f(ae);if(oe===-1){this.d.unshift({pattern:ae,matches:D.$Fk(o(ae))});return}const ie=new Set(ee.map(_=>this.f(_,oe)));ie.delete(-1);const ue=Array.from(ie).sort();this.d.splice(oe+1,0,...ue.map(_=>this.d[_]));for(let _=ue.length-1;_>=0;_--)this.d.splice(ue[_],1)}toArray(){return this.d.map(ae=>ae.pattern)}f(ae,ee=this.d.length){const oe=o(ae);for(let ie=0;ie<ee;ie++)if(this.d[ie].matches(oe))return ie;return-1}}e.$3L=c;function g(Z,ae,ee,oe=(ie,ue)=>ie===ue){const ie=[];function ue(Ie,X,V){if(X===0&&V.length===0)return;const re=ie[ie.length-1];re&&re.start+re.deleteCount===Ie?(re.deleteCount+=X,re.toInsert.push(...V)):ie.push({start:Ie,deleteCount:X,toInsert:V})}let _=0,$e=0;for(;;){if(_===Z.length){ue(_,0,ae.slice($e));break}if($e===ae.length){ue(_,Z.length-_,[]);break}const Ie=Z[_],X=ae[$e];if(oe(Ie,X)){_+=1,$e+=1;continue}ee(X)?(ue(_,1,[]),_+=1):(ue(_,0,[X]),$e+=1)}return ie}e.$5L=new s.$2j("notebookEditorCursorAtBoundary","none"),e.$6L=new s.$2j("notebookEditorCursorAtLineBoundary","none");var f;(function(Z){Z.default="default",Z.option="option"})(f||(e.NotebookEditorPriority=f={}));var h;(function(Z){Z.Cells="cells",Z.Text="text",Z.None="none"})(h||(e.NotebookFindScopeType=h={}));function S(Z){const ae=Z;return!!((typeof ae.include=="string"||D.$Gk(ae.include))&&(typeof ae.exclude=="string"||D.$Gk(ae.exclude)))}function k(Z,ae,ee){if(Array.isArray(Z.viewType)&&Z.viewType.indexOf(ae)>=0||Z.viewType===ae)return!0;if(Z.filenamePattern){const oe=S(Z.filenamePattern)?Z.filenamePattern.include:Z.filenamePattern,ie=S(Z.filenamePattern)?Z.filenamePattern.exclude:void 0;if(D.$Ek(oe,(0,O.$sc)(ee.fsPath).toLowerCase()))return!(ie&&D.$Ek(ie,(0,O.$sc)(ee.fsPath).toLowerCase()))}return!1}e.$9L={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var y;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class C{static{this.d="notebook/"}static create(ae){return`${C.d}${ae}`}static parse(ae){if(ae.startsWith(C.d))return ae.substring(C.d.length)}}e.$0L=C;function T(Z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Z)}const $=new TextDecoder;function b(Z){const ae=[];let ee=!1;for(const _ of Z)(ae.length===0||ee)&&(ae.push(_),ee=!0);let oe=F(ae);const ie=v.$Se.concat(ae.map(_=>v.$Se.wrap(_))),ue=J(ie);return oe=oe||ue.byteLength!==ie.byteLength,{data:ue,didCompression:oe}}e.$aM="\x1B[A";const N=e.$aM.split("").map(Z=>Z.charCodeAt(0)),A=10;function F(Z){let ae=!1;return Z.forEach((ee,oe)=>{if(oe===0||ee.length<e.$aM.length)return;const ie=Z[oe-1],ue=ee.subarray(0,e.$aM.length);if(ue[0]===N[0]&&ue[1]===N[1]&&ue[2]===N[2]){const _=ie.lastIndexOf(A);if(_===-1)return;ae=!0,Z[oe-1]=ie.subarray(0,_),Z[oe]=ee.subarray(e.$aM.length)}}),ae}function G(Z){let ae=Z;do Z=ae,ae=Z.replace(/[^\n]\x08/gm,"");while(ae.length<Z.length);return Z}function x(Z){for(Z=Z.replace(/\r+\n/gm,`
`);Z.search(/\r[^$]/g)>-1;){const ae=Z.match(/^(.*)\r+/m)[1];let ee=Z.match(/\r+(.*)$/m)[1];ee=ee+ae.slice(ee.length,ae.length),Z=Z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ee)}return Z}const j=8,U=13;function J(Z){return!Z.buffer.includes(j)&&!Z.buffer.includes(U)?Z:v.$Se.fromString(x(G($.decode(Z.buffer))))}}),define(Re[7],Te([1,0,17,12,59,27,72,13,14,2,33,18,28,110,90]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p){"use strict";var r,l,d,a,i,n,t,o,c,g,f,h,S,k,y,C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$zQ=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$yQ=e.$xQ=e.$wQ=e.$vQ=e.$uQ=e.$tQ=e.$sQ=e.$rQ=e.LanguageModelChatMessageRole=e.$qQ=e.$pQ=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=e.$iQ=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.$dQ=e.$cQ=e.$bQ=e.$aQ=e.$_P=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$$P=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.$4P=e.$3P=e.$2P=e.$1P=e.$ZP=e.$YP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$XP=e.$WP=e.$VP=e.$UP=e.$SP=e.$RP=e.$QP=e.$PP=e.$OP=e.TestRunProfileKind=e.TestResultState=e.$NP=e.$MP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$LP=e.NotebookVariablesRequestKind=e.$KP=e.$JP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$IP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.ColorThemeKind=e.$CP=e.$BP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$AP=e.QuickInputButtonLocation=e.$zP=e.DebugConsoleMode=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$tP=e.$sP=e.FileChangeType=e.$rP=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$qP=e.$pP=e.$oP=e.$nP=e.InlineCompletionTriggerKind=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$dP=e.$cP=e.$aP=e.ConfigurationTarget=e.$_O=e.$$O=e.$0O=e.$9O=e.DocumentPasteTriggerKind=e.$8O=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$2O=e.ViewBadge=e.ProgressLocation=e.$1O=e.$ZO=e.TaskScope=e.ShellQuoting=e.$YO=e.$XO=e.$WO=e.TaskPanelKind=e.TaskRevealKind=e.$VO=e.TerminalLocation=e.$UO=e.$TO=e.$SO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$RO=e.$QO=e.$PO=e.$OO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$MO=e.$LO=e.$KO=e.$JO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$IO=e.$HO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.LanguageStatusSeverity=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.CodeActionTriggerKind=e.$vO=e.$uO=e.SymbolTag=e.SymbolKind=e.$tO=e.$sO=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.DiagnosticSeverity=e.DiagnosticTag=e.$mO=e.$lO=e.FileEditType=e.$kO=e.$jO=e.$iO=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$hO=e.$gO=e.$fO=e.$cO=e.$bO=e.$aO=e.$_N=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$dO=j,e.$eO=U,e.$NO=dt,e.$bP=ji,e.$TP=Cn;function $(z){return Object.assign(z,{apply:function(...ne){if(ne.length===0)return Reflect.construct(z,[]);{const Se=ne.length===1?[]:ne[1];return Reflect.construct(z,Se,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(z,[]);{const[Se,...Ke]=ne;return Reflect.construct(z,Ke,Se.constructor)}}})}var b;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var N;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let A=r=class{static from(...M){let ne=M;return new r(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}#e;constructor(M){this.#e=M}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$_N=A,e.$_N=A=r=He([$],A);let F=l=class{static Min(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let Se=1;Se<M.length;Se++){const Ke=M[Se];Ke.isBefore(ne)&&(ne=Ke)}return ne}static Max(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let Se=1;Se<M.length;Se++){const Ke=M[Se];Ke.isAfter(ne)&&(ne=Ke)}return ne}static isPosition(M){if(!M)return!1;if(M instanceof l)return!0;const{line:ne,character:Se}=M;return typeof ne=="number"&&typeof Se=="number"}static of(M){if(M instanceof l)return M;if(this.isPosition(M))return new l(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(M,ne){if(M<0)throw(0,D.$$)("line must be non-negative");if(ne<0)throw(0,D.$$)("character must be non-negative");this.c=M,this.e=ne}isBefore(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<M.e}isBeforeOrEqual(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<=M.e}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this.c===M.c&&this.e===M.e}compareTo(M){return this.c<M.c?-1:this.c>M.line?1:this.e<M.e?-1:this.e>M.e?1:0}translate(M,ne=0){if(M===null||ne===null)throw(0,D.$$)();let Se;return typeof M>"u"?Se=0:typeof M=="number"?Se=M:(Se=typeof M.lineDelta=="number"?M.lineDelta:0,ne=typeof M.characterDelta=="number"?M.characterDelta:0),Se===0&&ne===0?this:new l(this.line+Se,this.character+ne)}with(M,ne=this.character){if(M===null||ne===null)throw(0,D.$$)();let Se;return typeof M>"u"?Se=this.line:typeof M=="number"?Se=M:(Se=typeof M.line=="number"?M.line:this.line,ne=typeof M.character=="number"?M.character:this.character),Se===this.line&&ne===this.character?this:new l(Se,ne)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$aO=F,e.$aO=F=l=He([$],F);let G=d=class{static isRange(M){return M instanceof d?!0:M?F.isPosition(M.start)&&F.isPosition(M.end):!1}static of(M){if(M instanceof d)return M;if(this.isRange(M))return new d(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(M,ne,Se,Ke){let rt,pt;if(typeof M=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ke=="number"?(rt=new F(M,ne),pt=new F(Se,Ke)):F.isPosition(M)&&F.isPosition(ne)&&(rt=F.of(M),pt=F.of(ne)),!rt||!pt)throw new Error("Invalid arguments");rt.isBefore(pt)?(this.c=rt,this.e=pt):(this.c=pt,this.e=rt)}contains(M){return d.isRange(M)?this.contains(M.start)&&this.contains(M.end):F.isPosition(M)?!(F.of(M).isBefore(this.c)||this.e.isBefore(M)):!1}isEqual(M){return this.c.isEqual(M.c)&&this.e.isEqual(M.e)}intersection(M){const ne=F.Max(M.start,this.c),Se=F.Min(M.end,this.e);if(!ne.isAfter(Se))return new d(ne,Se)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ne=F.Min(M.start,this.c),Se=F.Max(M.end,this.end);return new d(ne,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(M,ne=this.end){if(M===null||ne===null)throw(0,D.$$)();let Se;return M?F.isPosition(M)?Se=M:(Se=M.start||this.start,ne=M.end||this.end):Se=this.start,Se.isEqual(this.c)&&ne.isEqual(this.end)?this:new d(Se,ne)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return j(this)}};e.$bO=G,e.$bO=G=d=He([$],G);let x=a=class extends G{static isSelection(M){return M instanceof a?!0:M?G.isRange(M)&&F.isPosition(M.anchor)&&F.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(M,ne,Se,Ke){let rt,pt;if(typeof M=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ke=="number"?(rt=new F(M,ne),pt=new F(Se,Ke)):F.isPosition(M)&&F.isPosition(ne)&&(rt=F.of(M),pt=F.of(ne)),!rt||!pt)throw new Error("Invalid arguments");super(rt,pt),this.f=rt,this.g=pt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return U(this)}};e.$cO=x,e.$cO=x=a=He([$],x);function j(z){return z.isEmpty?`[${z.start.line}:${z.start.character})`:`[${z.start.line}:${z.start.character} -> ${z.end.line}:${z.end.character})`}function U(z){let M=j(z);return z.isEmpty||(z.active.isEqual(z.start)?M=`|${M}`:M=`${M}|`),M}const J=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,D.$$)("connectionToken")};class Z{static isResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.host=="string"&&typeof M.port=="number"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,ne,Se){if(typeof M!="string"||M.length===0)throw(0,D.$$)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,D.$$)("port");typeof Se<"u"&&J(Se),this.host=M,this.port=Math.round(ne),this.connectionToken=Se}}e.$fO=Z;class ae{static isManagedResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.makeConnection=="function"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,ne){this.makeConnection=M,this.connectionToken=ne,typeof ne<"u"&&J(ne)}}e.$gO=ae;class ee extends Error{static NotAvailable(M,ne){return new ee(M,E.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(M){return new ee(M,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,ne=E.RemoteAuthorityResolverErrorCode.Unknown,Se){super(M),this._message=M,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,ee.prototype)}}e.$hO=ee;var oe;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(oe||(e.EndOfLine=oe={}));var ie;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(ie||(e.EnvironmentVariableMutatorType=ie={}));let ue=i=class{static isTextEdit(M){return M instanceof i?!0:M?G.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ne){return new i(M,ne)}static insert(M,ne){return i.replace(new G(M,M),ne)}static delete(M){return i.replace(M,"")}static setEndOfLine(M){const ne=new i(new G(new F(0,0),new F(0,0)),"");return ne.newEol=M,ne}get range(){return this.c}set range(M){if(M&&!G.isRange(M))throw(0,D.$$)("range");this.c=M}get newText(){return this.e||""}set newText(M){if(M&&typeof M!="string")throw(0,D.$$)("newText");this.e=M}get newEol(){return this.f}set newEol(M){if(M&&typeof M!="number")throw(0,D.$$)("newEol");this.f=M}constructor(M,ne){this.c=M,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$iO=ue,e.$iO=ue=i=He([$],ue);let _=n=class{static isNotebookCellEdit(M){return M instanceof n?!0:M?ki.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,ne){return new n(M,ne)}static insertCells(M,ne){return new n(new ki(M,M),ne)}static deleteCells(M){return new n(M,[])}static updateCellMetadata(M,ne){const Se=new n(new ki(M,M),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(M){const ne=new n(new ki(0,0),[]);return ne.newNotebookMetadata=M,ne}constructor(M,ne){this.range=M,this.newCells=ne}};e.$jO=_,e.$jO=_=n=He([$],_);class $e{static isSnippetTextEdit(M){return M instanceof $e?!0:M?G.isRange(M.range)&&V.isSnippetString(M.snippet):!1}static replace(M,ne){return new $e(M,ne)}static insert(M,ne){return $e.replace(new G(M,M),ne)}constructor(M,ne){this.range=M,this.snippet=ne}}e.$kO=$e;var Ie;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ie||(e.FileEditType=Ie={}));let X=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(M,ne,Se,Ke){this.c.push({_type:Ie.File,from:M,to:ne,options:Se,metadata:Ke})}createFile(M,ne,Se){this.c.push({_type:Ie.File,from:void 0,to:M,options:ne,metadata:Se})}deleteFile(M,ne,Se){this.c.push({_type:Ie.File,from:M,to:void 0,options:ne,metadata:Se})}e(M,ne,Se){this.c.push({_type:Ie.Cell,metadata:Se,uri:M,edit:{editType:p.CellEditType.DocumentMetadata,metadata:ne},notebookMetadata:ne})}f(M,ne,Se,Ke){const rt=ne.start,pt=ne.end;(rt!==pt||Se.length>0)&&this.c.push({_type:Ie.CellReplace,uri:M,index:rt,count:pt-rt,cells:Se,metadata:Ke})}g(M,ne,Se,Ke){this.c.push({_type:Ie.Cell,metadata:Ke,uri:M,edit:{editType:p.CellEditType.Metadata,index:ne,metadata:Se}})}replace(M,ne,Se,Ke){this.c.push({_type:Ie.Text,uri:M,edit:new ue(ne,Se),metadata:Ke})}insert(M,ne,Se,Ke){this.replace(M,new G(ne,ne),Se,Ke)}delete(M,ne,Se){this.replace(M,ne,"",Se)}has(M){return this.c.some(ne=>ne._type===Ie.Text&&ne.uri.toString()===M.toString())}set(M,ne){if(ne)for(const Se of ne){if(!Se)continue;let Ke,rt;Array.isArray(Se)?(Ke=Se[0],rt=Se[1]):Ke=Se,_.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(M,Ke.range.start,Ke.newCellMetadata,rt):Ke.newNotebookMetadata?this.e(M,Ke.newNotebookMetadata,rt):this.f(M,Ke.range,Ke.newCells,rt):$e.isSnippetTextEdit(Ke)?this.c.push({_type:Ie.Snippet,uri:M,range:Ke.range,edit:Ke.snippet,metadata:rt}):this.c.push({_type:Ie.Text,uri:M,edit:Ke,metadata:rt})}else{for(let Se=0;Se<this.c.length;Se++){const Ke=this.c[Se];switch(Ke._type){case Ie.Text:case Ie.Snippet:case Ie.Cell:case Ie.CellReplace:Ke.uri.toString()===M.toString()&&(this.c[Se]=void 0);break}}(0,v.$Mb)(this.c)}}get(M){const ne=[];for(const Se of this.c)Se._type===Ie.Text&&Se.uri.toString()===M.toString()&&ne.push(Se.edit);return ne}entries(){const M=new L.$Fc;for(const ne of this.c)if(ne._type===Ie.Text){let Se=M.get(ne.uri);Se||(Se=[ne.uri,[]],M.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$lO=X,e.$lO=X=He([$],X);let V=t=class{static isSnippetString(M){return M instanceof t?!0:M?typeof M.value=="string":!1}static c(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this.e=1,this.value=M||""}appendText(M){return this.value+=t.c(M),this}appendTabstop(M=this.e++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ne=this.e++){if(typeof M=="function"){const Se=new t;Se.e=this.e,M(Se),this.e=Se.e,M=Se.value}else M=t.c(M);return this.value+="${",this.value+=ne,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ne=this.e++){const Se=M.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(M,ne){if(typeof ne=="function"){const Se=new t;Se.e=this.e,ne(Se),this.e=Se.e,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$mO=V,e.$mO=V=t=He([$],V);var re;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(re||(e.DiagnosticTag=re={}));var be;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(be||(e.DiagnosticSeverity=be={}));let Pe=o=class{static isLocation(M){return M instanceof o?!0:M?G.isRange(M.range)&&s.URI.isUri(M.uri):!1}constructor(M,ne){if(this.uri=M,ne)if(G.isRange(ne))this.range=G.of(ne);else if(F.isPosition(ne))this.range=new G(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$nO=Pe,e.$nO=Pe=o=He([$],Pe);let Fe=class{static is(M){return M?typeof M.message=="string"&&M.location&&G.isRange(M.location.range)&&s.URI.isUri(M.location.uri):!1}constructor(M,ne){this.location=M,this.message=ne}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.location.range.isEqual(ne.location.range)&&M.location.uri.toString()===ne.location.uri.toString()}};e.$oO=Fe,e.$oO=Fe=He([$],Fe);let Be=class{constructor(M,ne,Se=be.Error){if(!G.isRange(M))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=M,this.message=ne,this.severity=Se}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.severity===ne.severity&&M.code===ne.code&&M.severity===ne.severity&&M.source===ne.source&&M.range.isEqual(ne.range)&&(0,v.$yb)(M.tags,ne.tags)&&(0,v.$yb)(M.relatedInformation,ne.relatedInformation,Fe.isEqual)}};e.$pO=Be,e.$pO=Be=He([$],Be);let xe=class{constructor(M,ne){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=ne}};e.$qO=xe,e.$qO=xe=He([$],xe);let nt=class extends xe{constructor(M,ne,Se,Ke){super(M,ne),this.canIncreaseVerbosity=Se,this.canDecreaseVerbosity=Ke}};e.$rO=nt,e.$rO=nt=He([$],nt);var ht;(function(z){z[z.Increase=0]="Increase",z[z.Decrease=1]="Decrease"})(ht||(e.HoverVerbosityAction=ht={}));var $t;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})($t||(e.DocumentHighlightKind=$t={}));let ut=class{constructor(M,ne=$t.Text){this.range=M,this.kind=ne}toJSON(){return{range:this.range,kind:$t[this.kind]}}};e.$sO=ut,e.$sO=ut=He([$],ut);let et=class{constructor(M,ne){this.uri=M,this.highlights=ne}toJSON(){return{uri:this.uri,highlights:this.highlights.map(M=>M.toJSON())}}};e.$tO=et,e.$tO=et=He([$],et);var Le;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Le||(e.SymbolKind=Le={}));var Me;(function(z){z[z.Deprecated=1]="Deprecated"})(Me||(e.SymbolTag=Me={}));let Ne=c=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,ne,Se,Ke,rt){this.name=M,this.kind=ne,this.containerName=rt,typeof Se=="string"&&(this.containerName=Se),Ke instanceof Pe?this.location=Ke:Se instanceof G&&(this.location=new Pe(Ke,Se)),c.validate(this)}toJSON(){return{name:this.name,kind:Le[this.kind],location:this.location,containerName:this.containerName}}};e.$uO=Ne,e.$uO=Ne=c=He([$],Ne);let W=g=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(g.validate)}constructor(M,ne,Se,Ke,rt){this.name=M,this.detail=ne,this.kind=Se,this.range=Ke,this.selectionRange=rt,this.children=[],g.validate(this)}};e.$vO=W,e.$vO=W=g=He([$],W);var B;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let Q=class{constructor(M,ne){this.title=M,this.kind=ne}};e.$wO=Q,e.$wO=Q=He([$],Q);let H=class{static{f=this}static{this.c="."}constructor(M){this.value=M}append(M){return new f(this.value?this.value+f.c+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+f.c)}};e.$xO=H,e.$xO=H=f=He([$],H),H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorMove=H.Refactor.append("move"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll"),H.Notebook=H.Empty.append("notebook");let se=class{constructor(M,ne){if(this.range=M,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$yO=se,e.$yO=se=He([$],se);class ge{constructor(M,ne,Se,Ke,rt,pt){this.kind=M,this.name=ne,this.detail=Se,this.uri=Ke,this.range=rt,this.selectionRange=pt}}e.$zO=ge;class Ee{constructor(M,ne){this.fromRanges=ne,this.from=M}}e.$AO=Ee;class ze{constructor(M,ne){this.fromRanges=ne,this.to=M}}e.$BO=ze;var Je;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Je||(e.LanguageStatusSeverity=Je={}));let _e=class{constructor(M,ne){this.range=M,this.command=ne}get isResolved(){return!!this.command}};e.$CO=_e,e.$CO=_e=He([$],_e);let tt=h=class{#e;static isMarkdownString(M){return M instanceof h?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,ne=!1){this.#e=new P.$9k(M,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(M){this.#e.value=M}get isTrusted(){return this.#e.isTrusted}set isTrusted(M){this.#e.isTrusted=M}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(M){this.#e.supportThemeIcons=M}get supportHtml(){return this.#e.supportHtml}set supportHtml(M){this.#e.supportHtml=M}get baseUri(){return this.#e.baseUri}set baseUri(M){this.#e.baseUri=M}appendText(M){return this.#e.appendText(M),this}appendMarkdown(M){return this.#e.appendMarkdown(M),this}appendCodeblock(M,ne){return this.#e.appendCodeblock(ne??"",M),this}};e.$DO=tt,e.$DO=tt=h=He([$],tt);let ct=class{constructor(M,ne){this.label=M,this.documentation=ne}};e.$EO=ct,e.$EO=ct=He([$],ct);let it=class{constructor(M,ne){this.label=M,this.documentation=ne,this.parameters=[]}};e.$FO=it,e.$FO=it=He([$],it);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$GO=at,e.$GO=at=He([$],at);var yt;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(yt||(e.SignatureHelpTriggerKind=yt={}));var Ye;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Ye||(e.InlayHintKind=Ye={}));let he=class{constructor(M){this.value=M}};e.$HO=he,e.$HO=he=He([$],he);let pe=class{constructor(M,ne,Se){this.position=M,this.label=ne,this.kind=Se}};e.$IO=pe,e.$IO=pe=He([$],pe);var ye;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ye||(e.CompletionTriggerKind=ye={}));var Ce;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ce||(e.CompletionItemKind=Ce={}));var fe;(function(z){z[z.Deprecated=1]="Deprecated"})(fe||(e.CompletionItemTag=fe={}));let ve=class{constructor(M,ne){this.label=M,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$JO=ve,e.$JO=ve=He([$],ve);let Y=class{constructor(M=[],ne=!1){this.items=M,this.isIncomplete=ne}};e.$KO=Y,e.$KO=Y=He([$],Y);let q=class{constructor(M,ne,Se){this.insertText=M,this.range=ne,this.command=Se}};e.$LO=q,e.$LO=q=He([$],q);let de=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.$MO=de,e.$MO=de=He([$],de);var je;(function(z){z[z.Unknown=0]="Unknown",z[z.Word=1]="Word",z[z.Line=2]="Line",z[z.Suggest=3]="Suggest"})(je||(e.PartialAcceptTriggerKind=je={}));var Qe;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Qe||(e.ViewColumn=Qe={}));var st;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function dt(z,M){return`${w.$xn.toKey(z)}.${M}`}var mt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval"})(mt||(e.TextEditorLineNumbersStyle=mt={}));var Tt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Tt||(e.TextDocumentSaveReason=Tt={}));var Ot;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ot||(e.TextEditorRevealType=Ot={}));var Qt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var _t;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Xe;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Xe||(e.DecorationRangeBehavior=Xe={})),function(z){function M(ne){switch(ne){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=M}(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var At;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(At||(e.SyntaxTokenType=At={})),function(z){function M(ne){switch(ne){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=M}(At||(e.SyntaxTokenType=At={}));let Ut=class{constructor(M,ne){if(ne&&!s.URI.isUri(ne))throw(0,D.$$)("target");if(!G.isRange(M)||M.isEmpty)throw(0,D.$$)("range");this.range=M,this.target=ne}};e.$OO=Ut,e.$OO=Ut=He([$],Ut);let wt=class{constructor(M,ne,Se,Ke){this.red=M,this.green=ne,this.blue=Se,this.alpha=Ke}};e.$PO=wt,e.$PO=wt=He([$],wt);let Dt=class{constructor(M,ne){if(ne&&!(ne instanceof wt))throw(0,D.$$)("color");if(!G.isRange(M)||M.isEmpty)throw(0,D.$$)("range");this.range=M,this.color=ne}};e.$QO=Dt,e.$QO=Dt=He([$],Dt);let ei=class{constructor(M){if(!M||typeof M!="string")throw(0,D.$$)("label");this.label=M}};e.$RO=ei,e.$RO=ei=He([$],ei);var ti;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var Ht;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Ht||(e.SourceControlInputBoxValidationType=Ht={}));var bt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(bt||(e.TerminalExitReason=bt={}));var Lt;(function(z){z[z.Low=0]="Low",z[z.Medium=1]="Medium",z[z.High=2]="High"})(Lt||(e.TerminalShellExecutionCommandLineConfidence=Lt={}));class ci{constructor(M,ne,Se){if(this.startIndex=M,this.length=ne,this.tooltip=Se,typeof M!="number"||M<0)throw(0,D.$$)("startIndex");if(typeof ne!="number"||ne<1)throw(0,D.$$)("length");if(Se!==void 0&&typeof Se!="string")throw(0,D.$$)("tooltip")}}e.$SO=ci;class Yt{constructor(M){this.uri=M}}e.$TO=Yt;class Ge{constructor(M){this.terminalCommand=M}}e.$UO=Ge;var ii;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(ii||(e.TerminalLocation=ii={}));class li{constructor(M){if(this.options=M,typeof M!="object")throw(0,D.$$)("options")}}e.$VO=li;var hi;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(hi||(e.TaskRevealKind=hi={}));var kt;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let jt=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(M){switch(M){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(M,ne){if(this.label=ne,typeof M!="string"||typeof ne!="string")throw(0,D.$$)("name");this.c=M}get id(){return this.c}};e.$WO=jt,e.$WO=jt=S=He([$],jt);function Nt(z){let M="";for(let ne=0;ne<z.length;ne++)M+=z[ne].replace(/,/g,",,")+",";return M}let Bt=class{constructor(M,ne,Se){if(typeof M!="string")throw(0,D.$$)("process");this.e=[],this.c=M,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=Se):this.f=ne)}get process(){return this.c}set process(M){if(typeof M!="string")throw(0,D.$$)("process");this.c=M}get args(){return this.e}set args(M){Array.isArray(M)||(M=[]),this.e=M}get options(){return this.f}set options(M){this.f=M}computeId(){const M=[];if(M.push("process"),this.c!==void 0&&M.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)M.push(ne);return Nt(M)}};e.$XO=Bt,e.$XO=Bt=He([$],Bt);let ai=class{constructor(M,ne,Se){if(this.f=[],Array.isArray(ne)){if(!M)throw(0,D.$$)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,D.$$)("command");this.e=M,this.f=ne,this.g=Se}else{if(typeof M!="string")throw(0,D.$$)("commandLine");this.c=M,this.g=ne}}get commandLine(){return this.c}set commandLine(M){if(typeof M!="string")throw(0,D.$$)("commandLine");this.c=M}get command(){return this.e?this.e:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,D.$$)("command");this.e=M}get args(){return this.f}set args(M){this.f=M||[]}get options(){return this.g}set options(M){this.g=M}computeId(){const M=[];if(M.push("shell"),this.c!==void 0&&M.push(this.c),this.e!==void 0&&M.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)M.push(typeof ne=="string"?ne:ne.value);return Nt(M)}};e.$YO=ai,e.$YO=ai=He([$],ai);var ni;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var ri;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class Gt{constructor(M){this.c=M}computeId(){return"customExecution"+(0,I.$7g)()}set callback(M){this.c=M}get callback(){return this.c}}e.$ZO=Gt;let Jt=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(M,ne,Se,Ke,rt,pt){this.k=!1,this.l=this.definition=M;let St;typeof ne=="string"?(this.o=this.name=ne,this.w=this.source=Se,this.execution=Ke,St=rt,this.k=!0):ne===ri.Global||ne===ri.Workspace?(this.target=ne,this.o=this.name=Se,this.w=this.source=Ke,this.execution=rt,St=pt):(this.target=ne,this.o=this.name=Se,this.w=this.source=Ke,this.execution=rt,St=pt),typeof St=="string"?(this.r=[St],this.t=!0):Array.isArray(St)?(this.r=St,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(M){this.j=M}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Bt?this.l={type:k.e,id:this.q.computeId()}:this.q instanceof ai?this.l={type:k.f,id:this.q.computeId()}:this.q instanceof Gt?this.l={type:k.c,id:this.q.computeId()}:this.l={type:k.g,id:(0,I.$7g)()}}get definition(){return this.l}set definition(M){if(M==null)throw(0,D.$$)("Kind can't be undefined or null");this.B(),this.l=M}get scope(){return this.m}set target(M){this.B(),this.m=M}get name(){return this.o}set name(M){if(typeof M!="string")throw(0,D.$$)("name");this.B(),this.o=M}get execution(){return this.q}set execution(M){M===null&&(M=void 0),this.B(),this.q=M;const ne=this.l.type;(k.g===ne||k.e===ne||k.f===ne||k.c===ne)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(M){if(Array.isArray(M))this.B(),this.r=M,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.B(),this.u=M}get source(){return this.w}set source(M){if(typeof M!="string"||M.length===0)throw(0,D.$$)("source must be a string of length > 0");this.B(),this.w=M}get group(){return this.x}set group(M){M===null&&(M=void 0),this.B(),this.x=M}get detail(){return this.A}set detail(M){M===null&&(M=void 0),this.A=M}get presentationOptions(){return this.y}set presentationOptions(M){M==null&&(M=Object.create(null)),this.B(),this.y=M}get runOptions(){return this.z}set runOptions(M){M==null&&(M=Object.create(null)),this.B(),this.z=M}};e.$1O=Jt,e.$1O=Jt=k=He([$],Jt);var ui;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(ui||(e.ProgressLocation=ui={}));var Mt;(function(z){function M(ne){const Se=ne;return(0,m.$ng)(Se.value)?Se.tooltip&&!(0,m.$jg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}z.isViewBadge=M})(Mt||(e.ViewBadge=Mt={}));let Ct=y=class{static isTreeItem(M,ne){const Se=M;if(Se.checkboxState!==void 0){const Ke=(0,m.$ng)(Se.checkboxState)?Se.checkboxState:(0,m.$lg)(Se.checkboxState)&&(0,m.$ng)(Se.checkboxState.state)?Se.checkboxState.state:void 0,rt=!(0,m.$ng)(Se.checkboxState)&&(0,m.$lg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Xt.Checked&&Ke!==Xt.Unchecked||rt!==void 0&&!(0,m.$jg)(rt))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(M instanceof y)return!0;if(Se.label!==void 0&&!(0,m.$jg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,m.$jg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,m.$jg)(Se.iconPath)&&!s.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,m.$jg)(Se.iconPath.id))){const Ke=Se.iconPath;if(!Ke||!(0,m.$jg)(Ke.light)&&!s.URI.isUri(Ke.light)&&!(0,m.$jg)(Ke.dark)&&!s.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,m.$jg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!s.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,m.$jg)(Se.tooltip)&&!(Se.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<vt.None&&Se.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,m.$jg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(M,ne=vt.None){this.collapsibleState=ne,s.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.$2O=Ct,e.$2O=Ct=y=He([$],Ct);var vt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var Xt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(Xt||(e.TreeItemCheckboxState=Xt={}));let Et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M){this.value=M}};e.$3O=Et,e.$3O=Et=He([$],Et);class si extends Et{}e.$4O=si;class Zt extends si{#e;constructor(M){super(""),this.#e=M}asFile(){return this.#e}}e.$5O=Zt;class Mi{constructor(M,ne,Se,Ke){this.name=M,this.uri=ne,this._itemId=Se,this.c=Ke}data(){return this.c()}}e.$6O=Mi;let di=class{#e=new Map;constructor(M){for(const[ne,Se]of M??[]){const Ke=this.#e.get(this.#t(ne));Ke?Ke.push(Se):this.#e.set(this.#t(ne),[Se])}}get(M){return this.#e.get(this.#t(M))?.[0]}set(M,ne){this.#e.set(this.#t(M),[ne])}forEach(M,ne){for(const[Se,Ke]of this.#e)for(const rt of Ke)M.call(ne,rt,Se,this)}*[Symbol.iterator](){for(const[M,ne]of this.#e)for(const Se of ne)yield[M,Se]}#t(M){return M.toLowerCase()}};e.$7O=di,e.$7O=di=He([$],di);let yi=class{constructor(M,ne,Se){this.insertText=M,this.title=ne,this.kind=Se}};e.$8O=yi,e.$8O=yi=He([$],yi);var qt;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(qt||(e.DocumentPasteTriggerKind=qt={}));class fi{static{this.c="."}constructor(M){this.value=M}append(...M){return new fi((this.value?[this.value,...M]:M).join(fi.c))}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+fi.c)}}e.$9O=fi,fi.Empty=new fi("");class Fi{constructor(M,ne,Se){this.title=ne,this.insertText=M,this.kind=Se}}e.$0O=Fi;let Rt=class{constructor(M,ne){this.id=M,this.color=ne}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.$$O=Rt,e.$$O=Rt=He([$],Rt),Rt.File=new Rt("file"),Rt.Folder=new Rt("folder");let Si=class{constructor(M){this.id=M}};e.$_O=Si,e.$_O=Si=He([$],Si);var Ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Ai||(e.ConfigurationTarget=Ai={}));let gi=class{get base(){return this.c}set base(M){this.c=M,this.e=s.URI.file(M)}get baseUri(){return this.e}set baseUri(M){this.e=M,this.c=M.fsPath}constructor(M,ne){if(typeof M!="string"&&(!M||!s.URI.isUri(M)&&!s.URI.isUri(M.uri)))throw(0,D.$$)("base");if(typeof ne!="string")throw(0,D.$$)("pattern");typeof M=="string"?this.baseUri=s.URI.file(M):s.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$aP=gi,e.$aP=gi=He([$],gi);const zi=new WeakMap;function ji(z,M){zi.set(z,M)}let zt=class{constructor(M,ne,Se,Ke,rt){this.enabled=typeof M=="boolean"?M:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof Ke=="string"&&(this.logMessage=Ke),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=zi.get(this)??(0,I.$7g)()),this.c}};e.$cP=zt,e.$cP=zt=He([$],zt);let Pi=class extends zt{constructor(M,ne,Se,Ke,rt,pt){if(super(ne,Se,Ke,rt,pt),M===null)throw(0,D.$$)("location");this.location=M}};e.$dP=Pi,e.$dP=Pi=He([$],Pi);let Di=class extends zt{constructor(M,ne,Se,Ke,rt,pt){super(ne,Se,Ke,rt,pt),this.functionName=M}};e.$eP=Di,e.$eP=Di=He([$],Di);let wi=class extends zt{constructor(M,ne,Se,Ke,rt,pt,St,xt){if(super(Ke,rt,pt,St,xt),!ne)throw(0,D.$$)("dataId");this.label=M,this.dataId=ne,this.canPersist=Se}};e.$fP=wi,e.$fP=wi=He([$],wi);let bi=class{constructor(M,ne,Se){this.command=M,this.args=ne||[],this.options=Se}};e.$gP=bi,e.$gP=bi=He([$],bi);let me=class{constructor(M,ne){this.port=M,this.host=ne}};e.$hP=me,e.$hP=me=He([$],me);let De=class{constructor(M){this.path=M}};e.$iP=De,e.$iP=De=He([$],De);let ce=class{constructor(M){this.implementation=M}};e.$jP=ce,e.$jP=ce=He([$],ce);class K{constructor(M,ne,Se){this.session=M,this.threadId=ne,this.frameId=Se}}e.$kP=K;class ke{constructor(M,ne){this.session=M,this.threadId=ne}}e.$lP=ke;let We=class{constructor(M,ne){this.range=M,this.expression=ne}};e.$mP=We,e.$mP=We=He([$],We);var Ze;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Ze||(e.InlineCompletionTriggerKind=Ze={}));let Ue=class{constructor(M,ne){this.range=M,this.text=ne}};e.$nP=Ue,e.$nP=Ue=He([$],Ue);let ot=class{constructor(M,ne,Se=!0){this.range=M,this.variableName=ne,this.caseSensitiveLookup=Se}};e.$oP=ot,e.$oP=ot=He([$],ot);let gt=class{constructor(M,ne){this.range=M,this.expression=ne}};e.$pP=gt,e.$pP=gt=He([$],gt);let Kt=class{constructor(M,ne){this.frameId=M,this.stoppedLocation=ne}};e.$qP=Kt,e.$qP=Kt=He([$],Kt);var Vt;(function(z){z[z.AIGenerated=1]="AIGenerated"})(Vt||(e.NewSymbolNameTag=Vt={}));var Wt;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Wt||(e.NewSymbolNameTriggerKind=Wt={}));class Li{constructor(M,ne){this.newSymbolName=M,this.tags=ne}}e.$rP=Li;var en;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(en||(e.FileChangeType=en={}));let Vi=C=class extends Error{static FileExists(M){return new C(M,u.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(M){return new C(M,u.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(M){return new C(M,u.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(M){return new C(M,u.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(M){return new C(M,u.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(M){return new C(M,u.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(M,ne=u.FileSystemProviderErrorCode.Unknown,Se){super(s.URI.isUri(M)?M.toString(!0):M),this.code=Se?.name??"Unknown",(0,u.$ul)(this,ne),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$sP=Vi,e.$sP=Vi=C=He([$],Vi);let Ei=class{constructor(M,ne,Se){this.start=M,this.end=ne,this.kind=Se}};e.$tP=Ei,e.$tP=Ei=He([$],Ei);var tn;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(tn||(e.FoldingRangeKind=tn={}));var nn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(nn||(e.CommentThreadCollapsibleState=nn={}));var Ui;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Ui||(e.CommentMode=Ui={}));var rn;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(rn||(e.CommentState=rn={}));var Bi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Bi||(e.CommentThreadState=Bi={}));var Qi;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));var sn;(function(z){z[z.Reply=1]="Reply",z[z.Comment=2]="Comment"})(sn||(e.CommentThreadFocus=sn={}));class on{constructor(M,ne=[]){this.tokenTypes=M,this.tokenModifiers=ne}}e.$uP=on;function wn(z){return typeof z>"u"||(0,m.$kg)(z)}class Ci{constructor(M){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,M){this.m=!0;for(let ne=0,Se=M.tokenTypes.length;ne<Se;ne++)this.k.set(M.tokenTypes[ne],ne);for(let ne=0,Se=M.tokenModifiers.length;ne<Se;ne++)this.l.set(M.tokenModifiers[ne],ne)}}push(M,ne,Se,Ke,rt){if(typeof M=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ke=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(M,ne,Se,Ke,rt);if(G.isRange(M)&&typeof ne=="string"&&wn(Se))return this.o(M,ne,Se);throw(0,D.$$)()}o(M,ne,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ke=M.start.line,rt=M.start.character,pt=M.end.character-M.start.character,St=this.k.get(ne);let xt=0;if(Se)for(const $i of Se){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const vi=this.l.get($i);xt|=1<<vi>>>0}this.q(Ke,rt,pt,St,xt)}q(M,ne,Se,Ke,rt){if(this.f&&(M<this.c||M===this.c&&ne<this.e)){this.f=!1;const xt=this.g.length/5|0;let $i=0,vi=0;for(let Ii=0;Ii<xt;Ii++){let Oi=this.g[5*Ii],xi=this.g[5*Ii+1];Oi===0?(Oi=$i,xi+=vi):Oi+=$i,this.g[5*Ii]=Oi,this.g[5*Ii+1]=xi,$i=Oi,vi=xi}}let pt=M,St=ne;this.f&&this.j>0&&(pt-=this.c,pt===0&&(St-=this.e)),this.g[this.j++]=pt,this.g[this.j++]=St,this.g[this.j++]=Se,this.g[this.j++]=Ke,this.g[this.j++]=rt,this.c=M,this.e=ne}static r(M){const ne=[],Se=M.length/5|0;for(let St=0;St<Se;St++)ne[St]=St;ne.sort((St,xt)=>{const $i=M[5*St],vi=M[5*xt];if($i===vi){const Ii=M[5*St+1],Oi=M[5*xt+1];return Ii-Oi}return $i-vi});const Ke=new Uint32Array(M.length);let rt=0,pt=0;for(let St=0;St<Se;St++){const xt=5*ne[St],$i=M[xt+0],vi=M[xt+1],Ii=M[xt+2],Oi=M[xt+3],xi=M[xt+4],Qn=$i-rt,Mr=Qn===0?vi-pt:vi,_i=5*St;Ke[_i+0]=Qn,Ke[_i+1]=Mr,Ke[_i+2]=Ii,Ke[_i+3]=Oi,Ke[_i+4]=xi,rt=$i,pt=vi}return Ke}build(M){return this.f?new Ki(new Uint32Array(this.g),M):new Ki(Ci.r(this.g),M)}}e.$vP=Ci;class Ki{constructor(M,ne){this.resultId=ne,this.data=M}}e.$wP=Ki;class bn{constructor(M,ne,Se){this.start=M,this.deleteCount=ne,this.data=Se}}e.$xP=bn;class vn{constructor(M,ne){this.resultId=ne,this.edits=M}}e.$yP=vn;var Wi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Wi||(e.DebugConsoleMode=Wi={}));class an{constructor(M){this.name=M}}e.$zP=an;var Ae;(function(z){z[z.Title=1]="Title",z[z.Inline=2]="Inline"})(Ae||(e.QuickInputButtonLocation=Ae={}));let mi=class{static{this.Back={iconPath:new Rt("arrow-left")}}constructor(){}};e.$AP=mi,e.$AP=mi=He([$],mi);var Hi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Hi||(e.QuickPickItemKind=Hi={}));var lt;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(lt||(e.InputBoxValidationSeverity=lt={}));var It;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(It||(e.ExtensionKind=It={}));class yn{static validate(M){if(typeof M.badge=="string"){let ne=(0,O.$Uf)(M.badge,0);if(ne<M.badge.length&&(ne+=(0,O.$Uf)(M.badge,ne)),M.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!Rt.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,ne,Se){this.badge=M,this.tooltip=ne,this.color=Se}}e.$BP=yn;let Gi=class{constructor(M){this.kind=M}};e.$CP=Gi,e.$CP=Gi=He([$],Gi);var Ji;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ji||(e.ColorThemeKind=Ji={}));class ki{static isNotebookRange(M){return M instanceof ki?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(M,ne){if(M<0)throw(0,D.$$)("start must be positive");if(ne<0)throw(0,D.$$)("end must be positive");M<=ne?(this.c=M,this.e=ne):(this.c=ne,this.e=M)}with(M){let ne=this.c,Se=this.e;return M.start!==void 0&&(ne=M.start),M.end!==void 0&&(Se=M.end),ne===this.c&&Se===this.e?this:new ki(ne,Se)}}e.$DP=ki;class Ri{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(ne=>Ri.isNotebookCellData(ne))}static isNotebookCellData(M){return!0}constructor(M,ne,Se,Ke,rt,pt,St){this.kind=M,this.value=ne,this.languageId=Se,this.mime=Ke,this.outputs=rt??[],this.metadata=pt,this.executionSummary=St,Ri.validate(this)}}e.$EP=Ri;class Sn{constructor(M){this.cells=M}}e.$FP=Sn;class pi{static isNotebookCellOutputItem(M){return M instanceof pi?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const ne={name:M.name,message:M.message,stack:M.stack};return pi.json(ne,"application/vnd.code.notebook.error")}static stdout(M){return pi.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return pi.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,ne="application/octet-stream"){return new pi(M,ne)}static#e=new TextEncoder;static text(M,ne=R.$gt.text){const Se=pi.#e.encode(String(M));return new pi(Se,ne)}static json(M,ne="text/x-json"){const Se=JSON.stringify(M,void 0,"	");return pi.text(Se,ne)}constructor(M,ne){this.data=M,this.mime=ne;const Se=(0,R.$kt)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$GP=pi;class qi{static isNotebookCellOutput(M){return M instanceof qi?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,ne=!1){const Se=new Set,Ke=new Set;for(let rt=0;rt<M.length;rt++){const pt=M[rt],St=(0,R.$kt)(pt.mime);if(!Se.has(St)||(0,p.$$L)(St)){Se.add(St);continue}Ke.add(rt),ne&&console.warn(`DUPLICATED mime type '${pt.mime}' will be dropped`)}return Ke.size===0?M:M.filter((rt,pt)=>!Ke.has(pt))}constructor(M,ne,Se){this.items=qi.ensureUniqueMimeTypes(M,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,I.$7g)(),this.metadata=ne??Se)}}e.$HP=qi;var Xi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Xi||(e.NotebookCellKind=Xi={}));var cn;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(cn||(e.NotebookCellExecutionState=cn={}));var ln;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ln||(e.NotebookCellStatusBarAlignment=ln={}));var un;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(un||(e.NotebookEditorRevealType=un={}));class En{constructor(M,ne){this.text=M,this.alignment=ne}}e.$IP=En;var hn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(hn||(e.NotebookControllerAffinity=hn={}));var dn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(dn||(e.NotebookControllerAffinity2=dn={}));class kn{constructor(M,ne=[]){this.uri=M,this.provides=(0,v.$6b)(ne)}}e.$JP=kn;class In{constructor(M){this.label=M}}e.$KP=In;var fn;(function(z){z[z.Named=1]="Named",z[z.Indexed=2]="Indexed"})(fn||(e.NotebookVariablesRequestKind=fn={}));let Yi=class{constructor(M,ne){this.label=M,this.timestamp=ne}};e.$LP=Yi,e.$LP=Yi=He([$],Yi);var gn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(gn||(e.ExtensionMode=gn={}));var te;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(te||(e.ExtensionRuntime=te={}));var le;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(le||(e.StandardTokenType=le={}));class Oe{constructor(M,ne){this.ranges=M,this.wordPattern=ne}}e.$MP=Oe;class ft{constructor(M){this.c=M}get autoForwardAction(){return this.c}}e.$NP=ft;var Pt;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Pt||(e.TestResultState=Pt={}));var Ft;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(Ft||(e.TestRunProfileKind=Ft={}));let Ti=class{constructor(M=void 0,ne=void 0,Se=void 0,Ke=!1,rt=!0){this.include=M,this.exclude=ne,this.profile=Se,this.continuous=Ke,this.preserveFocus=rt}};e.$OP=Ti,e.$OP=Ti=He([$],Ti);let Zi=T=class{static diff(M,ne,Se){const Ke=new T(M);return Ke.expectedOutput=ne,Ke.actualOutput=Se,Ke}constructor(M){this.message=M}};e.$PP=Zi,e.$PP=Zi=T=He([$],Zi);let Pn=class{constructor(M){this.id=M}};e.$QP=Pn,e.$QP=Pn=He([$],Pn);class Gn{constructor(M,ne,Se){this.label=M,this.uri=ne,this.position=Se}}e.$RP=Gn;class mn{constructor(M,ne){this.covered=M,this.total=ne,Cn(this)}}e.$SP=mn;function Cn(z){if(z){if(z.covered>z.total)throw new Error(`The total number of covered items (${z.covered}) cannot be greater than the total (${z.total})`);if(z.total<0)throw new Error(`The number of covered items (${z.total}) cannot be negative`)}}class Dn{static fromDetails(M,ne){const Se=new mn(0,0),Ke=new mn(0,0),rt=new mn(0,0);for(const St of ne)if("branches"in St){Se.total+=1,Se.covered+=St.executed?1:0;for(const xt of St.branches)Ke.total+=1,Ke.covered+=xt.executed?1:0}else rt.total+=1,rt.covered+=St.executed?1:0;const pt=new Dn(M,Se,Ke.total>0?Ke:void 0,rt.total>0?rt:void 0);return pt.detailedCoverage=ne,pt}constructor(M,ne,Se,Ke,rt=[]){this.uri=M,this.statementCoverage=ne,this.branchCoverage=Se,this.declarationCoverage=Ke,this.fromTests=rt}}e.$UP=Dn;class Jn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,ne,Se=[]){this.executed=M,this.location=ne,this.branches=Se}}e.$VP=Jn;class Xn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,ne,Se){this.executed=M,this.location=ne,this.label=Se}}e.$WP=Xn;class Yn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,ne,Se){this.name=M,this.executed=ne,this.location=Se}}e.$XP=Yn;var Rn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Rn||(e.ExternalUriOpenerPriority=Rn={}));var Tn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(Tn||(e.WorkspaceTrustState=Tn={}));var On;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(On||(e.PortAutoForwardAction=On={}));class Zn{constructor(M,ne,Se,Ke,rt,pt){this.kind=M,this.name=ne,this.detail=Se,this.uri=Ke,this.range=rt,this.selectionRange=pt}}e.$YP=Zn;class xn{constructor(M){this.uri=M}}e.$ZP=xn;class _n{constructor(M,ne){this.original=M,this.modified=ne}}e.$1P=_n;class er{constructor(M,ne,Se,Ke){this.base=M,this.input1=ne,this.input2=Se,this.result=Ke}}e.$2P=er;class tr{constructor(M,ne){this.uri=M,this.viewType=ne}}e.$3P=tr;class ir{constructor(M){this.viewType=M}}e.$4P=ir;class nr{constructor(M,ne){this.uri=M,this.notebookType=ne}}e.$5P=nr;class rr{constructor(M,ne,Se){this.original=M,this.modified=ne,this.notebookType=Se}}e.$6P=rr;class sr{constructor(){}}e.$7P=sr;class or{constructor(M,ne){this.uri=M,this.inputBoxUri=ne}}e.$8P=or;class ar{constructor(){}}e.$9P=ar;class cr{constructor(M){this.textDiffs=M}}e.$0P=cr;var An;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(An||(e.InteractiveSessionVoteDirection=An={}));var Ln;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(Ln||(e.ChatCopyKind=Ln={}));var Nn;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(Nn||(e.ChatVariableLevel=Nn={}));class lr{constructor(M,ne,Se){this.id=M,this.label=ne,this.values=Se}}e.$$P=lr;var Mn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted",z[z.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var Fn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(Fn||(e.ChatResultFeedbackKind=Fn={}));class ur{constructor(M){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new tt(M):M}}e.$_P=ur;class hr{constructor(M,ne){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new tt(M):M,this.vulnerabilities=ne}}e.$aQ=hr;class dr{constructor(M,ne){this.participant=M,this.command=ne}}e.$bQ=dr;class fr{constructor(M,ne,Se,Ke){this.title=M,this.message=ne,this.data=Se,this.buttons=Ke}}e.$cQ=fr;class gr{constructor(M,ne){this.value=M,this.baseUri=ne}}e.$dQ=gr;class mr{constructor(M,ne){this.value=M,this.title=ne}}e.$eQ=mr;class pr{constructor(M){this.value=M}}e.$fQ=pr;class $r{constructor(M,ne){this.value=M,this.task=ne}}e.$gQ=$r;class wr{constructor(M){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new tt(M):M}}e.$hQ=wr;class br{constructor(M){this.value=M}}e.$iQ=br;class vr{constructor(M,ne,Se){this.value=M,this.iconPath=ne,this.options=Se}}e.$jQ=vr;class yr{constructor(M,ne,Se){this.value=M,this.license=ne,this.snippet=Se}}e.$kQ=yr;class Sr{constructor(M,ne){this.uri=M,this.range=ne}}e.$lQ=Sr;class Er{constructor(M,ne){this.uri=M,this.edits=Array.isArray(ne)?ne:[ne]}}e.$mQ=Er;class kr{constructor(M,ne,Se,Ke){this.prompt=M,this.command=ne,this.references=Se,this.participant=Ke}}e.$nQ=kr;class Ir{constructor(M,ne,Se,Ke){this.response=M,this.result=ne,this.participant=Se,this.command=Ke}}e.$oQ=Ir;var zn;(function(z){z[z.Panel=1]="Panel",z[z.Terminal=2]="Terminal",z[z.Notebook=3]="Notebook",z[z.Editor=4]="Editor"})(zn||(e.ChatLocation=zn={}));var Un;(function(z){z[z.Complete=1]="Complete",z[z.Partial=2]="Partial",z[z.Omitted=3]="Omitted"})(Un||(e.ChatResponseReferencePartStatusKind=Un={}));class Pr{constructor(M,ne,Se){this.document=M,this.selection=ne,this.wholeRange=Se}}e.$pQ=Pr;class Dr{constructor(M){this.cell=M}}e.$qQ=Dr;var pn;(function(z){z[z.User=1]="User",z[z.Assistant=2]="Assistant",z[z.System=3]="System"})(pn||(e.LanguageModelChatMessageRole=pn={}));class Cr{constructor(M,ne,Se){this.toolCallId=M,this.content=ne,this.isError=Se??!1}}e.$rQ=Cr;class $n{static User(M,ne){const Se=new $n(pn.User,typeof M=="string"?M:"",ne);return Se.content2=[M],Se}static Assistant(M,ne){return new $n(pn.Assistant,M,ne)}constructor(M,ne,Se){this.role=M,this.content=ne,this.content2=[ne],this.name=Se}}e.$sQ=$n;class Rr{constructor(M,ne,Se){this.name=M,this.toolCallId=ne,this.parameters=Se}}e.$tQ=Rr;class Tr{constructor(M){this.value=M}}e.$uQ=Tr;class Or{constructor(M){this.content=M}}e.$vQ=Or;class Ar{constructor(M,ne){this.content=M,this.name=ne}}e.$wQ=Ar;class Lr{constructor(M,ne){this.content=M,this.name=ne}}e.$xQ=Lr;class Ni extends Error{static NotFound(M){return new Ni(M,Ni.NotFound.name)}static NoPermissions(M){return new Ni(M,Ni.NoPermissions.name)}static Blocked(M){return new Ni(M,Ni.Blocked.name)}constructor(M,ne,Se){super(M,{cause:Se}),this.name="LanguageModelError",this.code=ne??""}}e.$yQ=Ni;var jn;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(jn||(e.RelatedInformationType=jn={}));var Bn;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped",z[z.Error=5]="Error"})(Bn||(e.SpeechToTextStatus=Bn={}));var Wn;(function(z){z[z.Started=1]="Started",z[z.Stopped=2]="Stopped",z[z.Error=3]="Error"})(Wn||(e.TextToSpeechStatus=Wn={}));var qn;(function(z){z[z.Recognized=1]="Recognized",z[z.Stopped=2]="Stopped"})(qn||(e.KeywordRecognitionStatus=qn={}));class Nr{constructor(M,ne){this.text=M,this.range=ne}}e.$zQ=Nr;var Vn;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Vn||(e.InlineEditTriggerKind=Vn={}))}),define(Re[226],Te([1,0,5,7]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rqc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(v.$0N.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,O,m){if(this.a.size===0)throw new Error("No related information providers registered");const s=this.a.get(R);if(!s)throw new Error("related information provider not found");return await s.provideRelatedInformation(O,m)??[]}getRelatedInformation(R,O,m){return this.c.$getAiRelatedInformation(O,m)}registerRelatedInformationProvider(R,O,m){const s=this.b;return this.b++,this.a.set(s,m),this.c.$registerAiRelatedInformationProvider(s,O),new D.$_N(()=>{this.c.$unregisterAiRelatedInformationProvider(s),this.a.delete(s)})}}e.$Rqc=P}),define(Re[91],Te([1,0,6,5,7,18,119,3,16]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=e.$3qc=void 0,e.$3qc=(0,O.$Ki)("IExtHostAuthentication");let s=class{constructor(u){this.b=new Map,this.c=new v.$qe,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=u.getProxy(D.$0N.MainThreadAuthentication)}async getSession(u,E,p,r={}){const l=L.$xn.toKey(u.identifier),d=[...p].sort().join(" ");return await this.d.getOrCreate(`${l} ${E} ${d}`,async()=>{await this.a.$ensureProvider(E);const a=u.displayName||u.name;return this.a.$getSession(E,p,l,a,r)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,E){const p=this.b.get(u);return p?p.provider.removeSession(E):this.a.$removeSession(u,E)}registerAuthenticationProvider(u,E,p,r){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:E,provider:p,options:r??{supportsMultipleAccounts:!1}});const l=p.onDidChangeSessions(d=>this.a.$sendDidChangeSessions(u,d));return this.a.$registerAuthenticationProvider(u,E,r?.supportsMultipleAccounts??!1),new P.$_N(()=>{l.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,E,p){const r=this.b.get(u);if(r)return await r.provider.createSession(E,p);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,E){const p=this.b.get(u);if(p)return await p.provider.removeSession(E);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,E,p){const r=this.b.get(u);if(r)return await r.provider.getSessions(E,p);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,E){return u.startsWith(R.$aN)||this.c.fire({provider:{id:u,label:E}}),Promise.resolve()}};e.$4qc=s,e.$4qc=s=He([qe(0,m.$KQ)],s);class I{constructor(){this.a=new Map}getOrCreate(u,E){const p=this.a.get(u);if(p)return p;const r=E().finally(()=>this.a.delete(u));return this.a.set(u,r),r}}}),define(Re[124],Te([1,0,2,5,7,3,16,11,17,13,22,21]),function(we,e,v,D,P,L,R,O,m,s,I,w){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$9rc=e.$8rc=void 0;let E=class{static{u=this}static{this.c=0}static{this.d=250}constructor(r,l){this.h=l,this.f=new Map,this.g=r.getProxy(D.$0N.MainThreadDecorations)}registerFileDecorationProvider(r,l){const d=u.c++;this.f.set(d,{provider:r,extensionDescription:l}),this.g.$registerDecorationProvider(d,l.identifier.value);const a=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(d,null);return}const n=(0,m.$6b)(i);if(n.length<=u.d){this.g.$onDidChange(d,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",l.identifier.value,n.length);const t=n.map(g=>({uri:g,rank:(0,s.$nf)(g.path,"/")})),o=(0,m.$Db)(t,(g,f)=>g.rank-f.rank||(0,s.$Df)(g.uri.path,f.uri.path)),c=[];e:for(const g of o){let f;for(const h of g){const S=(0,I.$rc)(h.uri.path);if(f!==S&&(f=S,c.push(h.uri)>=u.d))break e}}this.g.$onDidChange(d,c)});return new P.$_N(()=>{a?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(r,l,d){if(!this.f.has(r))return Object.create(null);const a=Object.create(null),{provider:i,extensionDescription:n}=this.f.get(r);return await Promise.all(l.map(async t=>{try{const{uri:o,id:c}=t,g=await Promise.resolve(i.provideFileDecoration(v.URI.revive(o),d));if(!g)return;try{P.$BP.validate(g),g.badge&&typeof g.badge!="string"&&(0,w.$zH)(n,"codiconDecoration"),a[c]=[g.propagate,g.tooltip,g.badge,g.color]}catch(f){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${f}`)}}catch(o){this.h.error(o)}})),a}};e.$8rc=E,e.$8rc=E=u=He([qe(0,R.$KQ),qe(1,O.$fk)],E),e.$9rc=(0,L.$Ki)("IExtHostDecorations")}),define(Re[227],Te([1,0,12,2,7,5,15,19,13]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$rc=void 0;class s{static{this.a=0}constructor(w,u,E){this.d=u,this.e=E,this.b=new Map,this.c=w.getProxy(L.$0N.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,u){if(Object.keys(R.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const E=s.a++;this.b.set(E,u),this.c.$registerTextContentProvider(E,w);let p;if(typeof u.onDidChange=="function"){let r;p=u.onDidChange(async l=>{if(l.scheme!==w){this.e.warn(`Provider for scheme '${w}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(l))return;r&&await r;const d=this.$provideTextDocumentContent(E,l).then(async a=>{if(!a&&typeof a!="string")return;const i=this.d.getDocument(l);if(!i)return;const n=(0,m.$xf)(a);if(!i.equalLines(n))return this.c.$onVirtualDocumentChange(l,a)}).catch(v.$4).finally(()=>{r===d&&(r=void 0)});r=d})}return new P.$_N(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(w,u){const E=this.b.get(w);return E?Promise.resolve(E.provideTextDocumentContent(D.URI.revive(u),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$$rc=s}),define(Re[125],Te([1,0,61,15,13,284,169,7,17]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=e.$NQ=void 0,e.$MQ=I;const s=new Map;function I(p,r){r?s.set(p,r):s.delete(p)}function w(p){return s.get(p)}class u extends L.$yw{constructor(r,l,d,a,i,n,t){super(l,d,a,i),this.o=r,this.p=n,this.q=t,this.n=!1}dispose(){(0,v.ok)(!this.n),this.n=!0,this.q=!1}equalLines(r){return(0,m.$yb)(this.b,r)}get document(){if(!this.m){const r=this;this.m={get uri(){return r.a},get fileName(){return r.a.fsPath},get isUntitled(){return r.a.scheme===D.Schemas.untitled},get languageId(){return r.p},get version(){return r.d},get isClosed(){return r.n},get isDirty(){return r.q},save(){return r.r()},getText(l){return l?r.s(l):r.getText()},get eol(){return r.c===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return r.b.length},lineAt(l){return r.t(l)},offsetAt(l){return r.u(l)},positionAt(l){return r.v(l)},validateRange(l){return r.w(l)},validatePosition(l){return r.x(l)},getWordRangeAtPosition(l,d){return r.y(l,d)},[Symbol.for("debug.description")](){return`TextDocument(${r.a.toString()})`}}}return Object.freeze(this.m)}_acceptLanguageId(r){(0,v.ok)(!this.n),this.p=r}_acceptIsDirty(r){(0,v.ok)(!this.n),this.q=r}r(){return this.n?Promise.reject(new Error("Document has been closed")):this.o.$trySaveDocument(this.a)}s(r){const l=this.w(r);if(l.isEmpty)return"";if(l.isSingleLine)return this.b[l.start.line].substring(l.start.character,l.end.character);const d=this.c,a=l.start.line,i=l.end.line,n=[];n.push(this.b[a].substring(l.start.character));for(let t=a+1;t<i;t++)n.push(this.b[t]);return n.push(this.b[i].substring(0,l.end.character)),n.join(d)}t(r){let l;if(r instanceof O.$aO?l=r.line:typeof r=="number"&&(l=r),typeof l!="number"||l<0||l>=this.b.length||Math.floor(l)!==l)throw new Error("Illegal value for `line`");return new E(l,this.b[l],l===this.b.length-1)}u(r){return r=this.x(r),this.h(),this.f.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.h();const l=this.f.getIndexOf(r),d=this.b[l.index].length;return new O.$aO(l.index,Math.min(l.remainder,d))}w(r){if(!(r instanceof O.$bO))throw new Error("Invalid argument");const l=this.x(r.start),d=this.x(r.end);return l===r.start&&d===r.end?r:new O.$bO(l.line,l.character,d.line,d.character)}x(r){if(!(r instanceof O.$aO))throw new Error("Invalid argument");if(this.b.length===0)return r.with(0,0);let{line:l,character:d}=r,a=!1;if(l<0)l=0,d=0,a=!0;else if(l>=this.b.length)l=this.b.length-1,d=this.b[l].length,a=!0;else{const i=this.b[l].length;d<0?(d=0,a=!0):d>i&&(d=i,a=!0)}return a?new O.$aO(l,d):r}y(r,l){const d=this.x(r);if(!l)l=w(this.p);else if((0,P.$wf)(l))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${l.source}' because it matches the empty string.`);const a=(0,R.$yt)(d.character+1,(0,R.$wt)(l),this.b[d.line],0);if(a)return new O.$bO(d.line,a.startColumn-1,d.line,a.endColumn-1)}}e.$NQ=u;class E{constructor(r,l,d){this.a=r,this.b=l,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new O.$bO(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new O.$bO(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$OQ=E}),define(Re[228],Te([1,0,5,7]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bsc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(v.$0N.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,O,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const s=this.a.get(R);if(!s)throw new Error("Embedding vector provider not found");const I=await s.provideEmbeddingVector(O,m);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(R,O,m){const s=this.b;return this.b++,this.a.set(s,m),this.c.$registerAiEmbeddingVectorProvider(O,s),new D.$_N(()=>{this.c.$unregisterAiEmbeddingVectorProvider(s),this.a.delete(s)})}}e.$bsc=P}),define(Re[68],Te([1,0,5,28,7,20,3,16,50,4,10,24,15]),function(we,e,v,D,P,L,R,O,m,s,I,w,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=e.$grc=void 0,D=Ve(D);let p=E=class{constructor(l,d){this.b=new Map,this.c=new I.$Th,this.a=l.getProxy(v.$0N.MainThreadFileSystem);const a=this;this.value=Object.freeze({async stat(i){try{let n;const t=a.b.get(i.scheme);return t?(await a.a.$ensureActivation(i.scheme),n=await t.impl.stat(i)):n=await a.a.$stat(i),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===D.FilePermission.Readonly?1:void 0}}catch(n){E.e(n)}},async readDirectory(i){try{const n=a.b.get(i.scheme);return n?(await a.a.$ensureActivation(i.scheme),(await n.impl.readDirectory(i)).slice()):await a.a.$readdir(i)}catch(n){return E.e(n)}},async createDirectory(i){try{const n=a.b.get(i.scheme);return n&&!n.isReadonly?(await a.a.$ensureActivation(i.scheme),await a.d(n.impl,n.extUri,i)):await a.a.$mkdir(i)}catch(n){return E.e(n)}},async readFile(i){try{const n=a.b.get(i.scheme);return n?(await a.a.$ensureActivation(i.scheme),(await n.impl.readFile(i)).slice()):(await a.a.$readFile(i)).buffer}catch(n){return E.e(n)}},async writeFile(i,n){try{const t=a.b.get(i.scheme);return t&&!t.isReadonly?(await a.a.$ensureActivation(i.scheme),await a.d(t.impl,t.extUri,t.extUri.dirname(i)),await a.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,n,{create:!0,overwrite:!0})))):await a.a.$writeFile(i,L.$Se.wrap(n))}catch(t){return E.e(t)}},async delete(i,n){try{const t=a.b.get(i.scheme);return t&&!t.isReadonly&&!n?.useTrash?(await a.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...n})):await a.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(t){return E.e(t)}},async rename(i,n,t){try{return await a.a.$rename(i,n,{overwrite:!1,...t})}catch(o){return E.e(o)}},async copy(i,n,t){try{return await a.a.$copy(i,n,{overwrite:!1,...t})}catch(o){return E.e(o)}},isWritableFileSystem(i){const n=d.getCapabilities(i);if(typeof n=="number")return!(n&D.FileSystemProviderCapabilities.Readonly)}})}async d(l,d,a){const i=[];for(;!d.isEqual(a,d.dirname(a));)try{if(!((await l.stat(a)).type&D.FileType.Directory))throw P.$sP.FileExists(`Unable to create folder '${a.scheme===u.Schemas.file?a.fsPath:a.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(D.$vl(n)!==D.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(d.basename(a)),a=d.dirname(a)}for(let n=i.length-1;n>=0;n--){a=d.joinPath(a,i[n]);try{await l.createDirectory(a)}catch(t){if(D.$vl(t)!==D.FileSystemProviderErrorCode.FileExists)throw t}}}static e(l){if(l instanceof P.$sP)throw l;if(l instanceof D.$rl)switch(l.code){case D.FileSystemProviderErrorCode.FileExists:throw P.$sP.FileExists(l.message);case D.FileSystemProviderErrorCode.FileNotFound:throw P.$sP.FileNotFound(l.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw P.$sP.FileNotADirectory(l.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw P.$sP.FileIsADirectory(l.message);case D.FileSystemProviderErrorCode.NoPermissions:throw P.$sP.NoPermissions(l.message);case D.FileSystemProviderErrorCode.Unavailable:throw P.$sP.Unavailable(l.message);default:throw new P.$sP(l.message,l.name)}if(!(l instanceof Error))throw new P.$sP(String(l));if(l.name==="ENOPRO"||l.message.includes("ENOPRO"))throw P.$sP.Unavailable(l.message);switch(l.name){case D.FileSystemProviderErrorCode.FileExists:throw P.$sP.FileExists(l.message);case D.FileSystemProviderErrorCode.FileNotFound:throw P.$sP.FileNotFound(l.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw P.$sP.FileNotADirectory(l.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw P.$sP.FileIsADirectory(l.message);case D.FileSystemProviderErrorCode.NoPermissions:throw P.$sP.NoPermissions(l.message);case D.FileSystemProviderErrorCode.Unavailable:throw P.$sP.Unavailable(l.message);default:throw new P.$sP(l.message,l.name)}}addFileSystemProvider(l,d,a){return this.b.set(l,{impl:d,extUri:a?.isCaseSensitive?w.$bh:w.$dh,isReadonly:!!a?.isReadonly}),(0,s.$Xc)(()=>this.b.delete(l))}getFileSystemProviderExtUri(l){return this.b.get(l)?.extUri??w.$bh}};e.$grc=p,e.$grc=p=E=He([qe(0,O.$KQ),qe(1,m.$Wqc)],p),e.$hrc=(0,R.$Ki)("IExtHostConsumerFileSystem")}),define(Re[92],Te([1,0,3,26,11,68,2]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=e.$irc=void 0,e.$irc=(0,v.$Ki)("IExtensionStoragePaths");let O=class{constructor(s,I,w){this.d=I,this.f=w,this.a=s.workspace??void 0,this.b=s.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(s){return R.URI.joinPath(this.b.workspaceStorageHome,s)}async h(){if(!this.a)return Promise.resolve(void 0);const s=this.a.id,I=await this.g(s);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(R.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(w){this.d.error("[ExtHostStorage]",w);return}}workspaceValue(s){if(this.c)return R.URI.joinPath(this.c,s.identifier.value)}globalValue(s){return R.URI.joinPath(this.b.globalStorageHome,s.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$jrc=O,e.$jrc=O=He([qe(0,D.$1Q),qe(1,P.$fk),qe(2,L.$hrc)],O)}),define(Re[229],Te([1,0,7,16,6]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xsc=void 0;let L=class{constructor(O){this.a=new v.$CP(v.ColorThemeKind.Dark),this.b=new P.$qe}get activeColorTheme(){return this.a}$onColorThemeChange(O){let m;switch(O){case"light":m=v.ColorThemeKind.Light;break;case"hcDark":m=v.ColorThemeKind.HighContrast;break;case"hcLight":m=v.ColorThemeKind.HighContrastLight;break;default:m=v.ColorThemeKind.Dark}this.a=new v.$CP(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Xsc=L,e.$Xsc=L=He([qe(0,D.$KQ)],L)}),define(Re[93],Te([1,0,19,6,4,9,3,11,183,5,26,16,7]),function(we,e,v,D,P,L,R,O,m,s,I,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Gb=e.$6Gb=e.TunnelDtoConverter=void 0,L=Ve(L),u=Ve(u);class E extends m.$Xw{}var p;(function(l){function d(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:i.protocol}}l.fromApiTunnel=d;function a(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==m.TunnelPrivacyId.ConstantPrivate&&i.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}l.fromServiceTunnel=a})(p||(e.TunnelDtoConverter=p={})),e.$6Gb=(0,R.$Ki)("IExtHostTunnelService");let r=class extends P.$Zc{constructor(d,a,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new D.$qe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=d.getProxy(s.$0N.MainThreadTunnelService)}async openTunnel(d,a){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const i=await this.a.$openTunnel(a,d.displayName);if(i){const n=new E(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(d,a){d.portRange===void 0&&d.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:d,provider:a}),this.a.$registerPortsAttributesProvider(d,i),new u.$_N(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(d,a,i,n,t){const o=[];for(const g of d){const f=this.r.get(g);if(!f)return[];o.push(...await Promise.all(a.map(async h=>{let S;try{S=await f.provider.providePortAttributes({port:h,pid:i,commandLine:n},t)}catch{S=await f.provider.providePortAttributes(h,i,n,t)}return{providedAttributes:S,port:h}})))}const c=o.filter(g=>!!g.providedAttributes);return c.length>0?c.map(g=>({autoForwardAction:g.providedAttributes.autoForwardAction,port:g.port})):[]}async $registerCandidateFinder(d){}registerTunnelProvider(d,a){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,t)=>await d.provideTunnel(n,t,v.CancellationToken.None)??void 0;const i=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,privacyOptions:a.tunnelFeatures?.privacyOptions,protocol:a.tunnelFeatures.protocol===void 0?!0:a.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,P.$Xc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(d,a){if(d){d.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this.f=d.showCandidatePort,this.a.$setCandidateFilter());const i=d.tunnelFactory??(a?this.w(a):void 0);if(i){this.b=i;let n=d.tunnelFeatures?.privacyOptions??[];d.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:L.localize(2716,null),themeIcon:"lock"},{id:"public",label:L.localize(2717,null),themeIcon:"eye"}]);const t=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,public:!!d.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,P.$Xc)(()=>{this.b=void 0})}w(d){}async $closeTunnel(d,a){if(this.g.has(d.host)){const i=this.g.get(d.host);i.has(d.port)&&(a&&i.get(d.port).disposeListener.dispose(),await i.get(d.port).tunnel.dispose(),i.delete(d.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(d,a){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(d,a);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const n=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(d.remoteAddress.host)||this.g.set(d.remoteAddress.host,new Map);const t=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:n,disposeListener:t}),p.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(d){const a=await Promise.all(d.map(n=>this.f(n.host,n.port,n.detail??""))),i=d.filter((n,t)=>a[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(n=>n.port).join(", ")} to ${i.map(n=>n.port).join(", ")}`),i}};e.$7Gb=r,e.$7Gb=r=He([qe(0,w.$KQ),qe(1,I.$1Q),qe(2,O.$fk)],r)}),define(Re[8],Te([1,0,17,20,149,230,59,27,139,34,72,25,145,24,36,14,2,106,32,153,94,52,108,77,118,116,117,206,81,90,54,55,203,7]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i,n,t,o,c,g,f,h,S,k,y,C,T,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.LanguageModelToolResult=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatLanguageModelToolReference=e.ChatPromptReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseMovePart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$HQ=ie,e.$IQ=_,e.$JQ=$e,R=Ve(R),m=Ve(m),a=Ve(a),i=Ve(i),n=Ve(n),S=Ve(S),y=Ve(y),b=Ve(b);var N;(function(me){function De(K){const{selectionStartLineNumber:ke,selectionStartColumn:We,positionLineNumber:Ze,positionColumn:Ue}=K,ot=new b.$aO(ke-1,We-1),gt=new b.$aO(Ze-1,Ue-1);return new b.$cO(ot,gt)}me.to=De;function ce(K){const{anchor:ke,active:We}=K;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}me.from=ce})(N||(e.Selection=N={}));var A;(function(me){function De(K){if(!K)return;const{start:ke,end:We}=K;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}me.from=De;function ce(K){if(!K)return;const{startLineNumber:ke,startColumn:We,endLineNumber:Ze,endColumn:Ue}=K;return new b.$bO(ke-1,We-1,Ze-1,Ue-1)}me.to=ce})(A||(e.Range=A={}));var F;(function(me){function De(K){return{uri:K.uri,range:A.from(K.range)}}me.from=De;function ce(K){return new b.$nO(l.URI.revive(K.uri),A.to(K.range))}me.to=ce})(F||(e.Location=F={}));var G;(function(me){function De(ce){switch(ce){case i.StandardTokenType.Comment:return b.StandardTokenType.Comment;case i.StandardTokenType.Other:return b.StandardTokenType.Other;case i.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case i.StandardTokenType.String:return b.StandardTokenType.String}}me.to=De})(G||(e.TokenType=G={}));var x;(function(me){function De(K){return new b.$aO(K.lineNumber-1,K.column-1)}me.to=De;function ce(K){return{lineNumber:K.line+1,column:K.character+1}}me.from=ce})(x||(e.Position=x={}));var j;(function(me){function De(ke,We,Ze){return(0,v.$Lb)((0,v.$6b)(ke).map(Ue=>ce(Ue,We,Ze)))}me.from=De;function ce(ke,We,Ze){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Ze?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:K(ke.scheme,We),pattern:Qe.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Ze?.isBuiltin}}function K(ke,We){return We&&typeof ke=="string"?We.transformOutgoingScheme(ke):ke}})(j||(e.DocumentSelector=j={}));var U;(function(me){function De(K){switch(K){case b.DiagnosticTag.Unnecessary:return o.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return o.MarkerTag.Deprecated}}me.from=De;function ce(K){switch(K){case o.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case o.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}me.to=ce})(U||(e.DiagnosticTag=U={}));var J;(function(me){function De(K){let ke;return K.code&&((0,r.$jg)(K.code)||(0,r.$ng)(K.code)?ke=String(K.code):ke={value:String(K.code.value),target:K.code.target}),{...A.from(K.range),message:K.message,source:K.source,code:ke,severity:ae.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(Z.from),tags:Array.isArray(K.tags)?(0,v.$Lb)(K.tags.map(U.from)):void 0}}me.from=De;function ce(K){const ke=new b.$pO(A.to(K),K.message,ae.to(K.severity));return ke.source=K.source,ke.code=(0,r.$jg)(K.code)?K.code:K.code?.value,ke.relatedInformation=K.relatedInformation&&K.relatedInformation.map(Z.to),ke.tags=K.tags&&(0,v.$Lb)(K.tags.map(U.to)),ke}me.to=ce})(J||(e.Diagnostic=J={}));var Z;(function(me){function De(K){return{...A.from(K.location.range),message:K.message,resource:K.location.uri}}me.from=De;function ce(K){return new b.$oO(new b.$nO(K.resource,A.to(K)),K.message)}me.to=ce})(Z||(e.DiagnosticRelatedInformation=Z={}));var ae;(function(me){function De(K){switch(K){case b.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}me.from=De;function ce(K){switch(K){case o.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}me.to=ce})(ae||(e.DiagnosticSeverity=ae={}));var ee;(function(me){function De(K){return typeof K=="number"&&K>=b.ViewColumn.One?K-1:K===b.ViewColumn.Beside?$.$SE:$.$RE}me.from=De;function ce(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=ce})(ee||(e.ViewColumn=ee={}));function oe(me){return typeof me.range<"u"}function ie(me){return me.length===0?!0:!!oe(me[0])}var ue;(function(me){function De(Ue){return Ue.map(me.from)}me.fromMany=De;function ce(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function K(Ue){let ot;if(ce(Ue)){const{language:Vt,value:Wt}=Ue;ot={value:"```"+Vt+`
`+Wt+"\n```\n"}}else b.$DO.isMarkdownString(Ue)?ot={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml,baseUri:Ue.baseUri}:typeof Ue=="string"?ot={value:Ue}:ot={value:""};const gt=Object.create(null);ot.uris=gt;const Kt=({href:Vt})=>{try{let Wt=l.URI.parse(Vt,!0);Wt=Wt.with({query:ke(Wt.query,gt)}),gt[Vt]=Wt}catch{}return""};return m.marked.walkTokens(m.marked.lexer(ot.value),Vt=>{Vt.type==="link"?Kt({href:Vt.href}):Vt.type==="image"&&typeof Vt.href=="string"&&Kt(R.$el(Vt.href))}),ot}me.from=K;function ke(Ue,ot){if(!Ue)return Ue;let gt;try{gt=(0,s.$gi)(Ue)}catch{}if(!gt)return Ue;let Kt=!1;return gt=(0,w.$mo)(gt,Vt=>{if(l.URI.isUri(Vt)){const Wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[Wt]=Vt,Kt=!0,Wt}else return}),Kt?JSON.stringify(gt):Ue}function We(Ue){const ot=new b.$DO(Ue.value,Ue.supportThemeIcons);return ot.isTrusted=Ue.isTrusted,ot.supportHtml=Ue.supportHtml,ot.baseUri=Ue.baseUri?l.URI.from(Ue.baseUri):void 0,ot}me.to=We;function Ze(Ue){if(Ue)return typeof Ue=="string"?Ue:me.from(Ue)}me.fromStrict=Ze})(ue||(e.MarkdownString=ue={}));function _(me){return ie(me)?me.map(De=>({range:A.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?ue.fromMany(De.hoverMessage):De.hoverMessage?ue.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):me.map(De=>({range:A.from(De)}))}function $e(me){return typeof me>"u"?me:typeof me=="string"?l.URI.file(me):me}var Ie;(function(me){function De(ce){return typeof ce>"u"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?$e(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}me.from=De})(Ie||(e.ThemableDecorationAttachmentRenderOptions=Ie={}));var X;(function(me){function De(ce){return typeof ce>"u"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?$e(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?Ie.from(ce.before):void 0,after:ce.after?Ie.from(ce.after):void 0}}me.from=De})(X||(e.ThemableDecorationRenderOptions=X={}));var V;(function(me){function De(ce){if(typeof ce>"u")return ce;switch(ce){case b.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}me.from=De})(V||(e.DecorationRangeBehavior=V={}));var re;(function(me){function De(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?V.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?X.from(ce.light):void 0,dark:ce.dark?X.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?$e(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?Ie.from(ce.before):void 0,after:ce.after?Ie.from(ce.after):void 0}}me.from=De})(re||(e.DecorationRenderOptions=re={}));var be;(function(me){function De(K){return{text:K.newText,eol:K.newEol&&ve.from(K.newEol),range:A.from(K.range)}}me.from=De;function ce(K){const ke=new b.$iO(A.to(K.range),K.text);return ke.newEol=typeof K.eol>"u"?void 0:ve.to(K.eol),ke}me.to=ce})(be||(e.TextEdit=be={}));var Pe;(function(me){function De(K,ke){const We={edits:[]};if(K instanceof b.$lO){const Ze=new O.$Gc;for(const Ue of K._allEntries())Ue._type===b.FileEditType.File&&l.URI.isUri(Ue.to)&&Ue.from===void 0&&Ze.add(Ue.to);for(const Ue of K._allEntries())if(Ue._type===b.FileEditType.File){let ot;Ue.options?.contents&&(ArrayBuffer.isView(Ue.options.contents)?ot={type:"base64",value:(0,D.$af)(D.$Se.wrap(Ue.options.contents))}:ot={type:"dataTransferItem",id:Ue.options.contents._itemId}),We.edits.push({oldResource:Ue.from,newResource:Ue.to,options:{...Ue.options,contents:ot},metadata:Ue.metadata})}else Ue._type===b.FileEditType.Text?We.edits.push({resource:Ue.uri,textEdit:be.from(Ue.edit),versionId:Ze.has(Ue.uri)?void 0:ke?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===b.FileEditType.Snippet?We.edits.push({resource:Ue.uri,textEdit:{range:A.from(Ue.range),text:Ue.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ue.uri)?void 0:ke?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===b.FileEditType.Cell?We.edits.push({metadata:Ue.metadata,resource:Ue.uri,cellEdit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(Ue.uri)}):Ue._type===b.FileEditType.CellReplace&&We.edits.push({metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:ke?.getNotebookDocumentVersion(Ue.uri),cellEdit:{editType:y.CellEditType.Replace,index:Ue.index,count:Ue.count,cells:Ue.cells.map(Xe.from)}})}return We}me.from=De;function ce(K){const ke=new b.$lO,We=new O.$Fc;for(const Ze of K.edits)if(Ze.textEdit){const Ue=Ze,ot=l.URI.revive(Ue.resource),gt=A.to(Ue.textEdit.range),Kt=Ue.textEdit.text,Vt=Ue.textEdit.insertAsSnippet;let Wt;Vt?Wt=b.$kO.replace(gt,new b.$mO(Kt)):Wt=b.$iO.replace(gt,Kt);const Li=We.get(ot);Li?Li.push(Wt):We.set(ot,[Wt])}else ke.renameFile(l.URI.revive(Ze.oldResource),l.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ue]of We)ke.set(Ze,Ue);return ke}me.to=ce})(Pe||(e.WorkspaceEdit=Pe={}));var Fe;(function(me){const De=Object.create(null);De[b.SymbolKind.File]=n.SymbolKind.File,De[b.SymbolKind.Module]=n.SymbolKind.Module,De[b.SymbolKind.Namespace]=n.SymbolKind.Namespace,De[b.SymbolKind.Package]=n.SymbolKind.Package,De[b.SymbolKind.Class]=n.SymbolKind.Class,De[b.SymbolKind.Method]=n.SymbolKind.Method,De[b.SymbolKind.Property]=n.SymbolKind.Property,De[b.SymbolKind.Field]=n.SymbolKind.Field,De[b.SymbolKind.Constructor]=n.SymbolKind.Constructor,De[b.SymbolKind.Enum]=n.SymbolKind.Enum,De[b.SymbolKind.Interface]=n.SymbolKind.Interface,De[b.SymbolKind.Function]=n.SymbolKind.Function,De[b.SymbolKind.Variable]=n.SymbolKind.Variable,De[b.SymbolKind.Constant]=n.SymbolKind.Constant,De[b.SymbolKind.String]=n.SymbolKind.String,De[b.SymbolKind.Number]=n.SymbolKind.Number,De[b.SymbolKind.Boolean]=n.SymbolKind.Boolean,De[b.SymbolKind.Array]=n.SymbolKind.Array,De[b.SymbolKind.Object]=n.SymbolKind.Object,De[b.SymbolKind.Key]=n.SymbolKind.Key,De[b.SymbolKind.Null]=n.SymbolKind.Null,De[b.SymbolKind.EnumMember]=n.SymbolKind.EnumMember,De[b.SymbolKind.Struct]=n.SymbolKind.Struct,De[b.SymbolKind.Event]=n.SymbolKind.Event,De[b.SymbolKind.Operator]=n.SymbolKind.Operator,De[b.SymbolKind.TypeParameter]=n.SymbolKind.TypeParameter;function ce(ke){return typeof De[ke]=="number"?De[ke]:n.SymbolKind.Property}me.from=ce;function K(ke){for(const We in De)if(De[We]===ke)return Number(We);return b.SymbolKind.Property}me.to=K})(Fe||(e.SymbolKind=Fe={}));var Be;(function(me){function De(K){switch(K){case b.SymbolTag.Deprecated:return n.SymbolTag.Deprecated}}me.from=De;function ce(K){switch(K){case n.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}me.to=ce})(Be||(e.SymbolTag=Be={}));var xe;(function(me){function De(K){return{name:K.name,kind:Fe.from(K.kind),tags:K.tags&&K.tags.map(Be.from),containerName:K.containerName,location:et.from(K.location)}}me.from=De;function ce(K){const ke=new b.$uO(K.name,Fe.to(K.kind),K.containerName,et.to(K.location));return ke.tags=K.tags&&K.tags.map(Be.to),ke}me.to=ce})(xe||(e.WorkspaceSymbol=xe={}));var nt;(function(me){function De(K){const ke={name:K.name||"!!MISSING: name!!",detail:K.detail,range:A.from(K.range),selectionRange:A.from(K.selectionRange),kind:Fe.from(K.kind),tags:K.tags?.map(Be.from)??[]};return K.children&&(ke.children=K.children.map(De)),ke}me.from=De;function ce(K){const ke=new b.$vO(K.name,K.detail,Fe.to(K.kind),A.to(K.range),A.to(K.selectionRange));return(0,v.$Pb)(K.tags)&&(ke.tags=K.tags.map(Be.to)),K.children&&(ke.children=K.children.map(ce)),ke}me.to=ce})(nt||(e.DocumentSymbol=nt={}));var ht;(function(me){function De(K){const ke=new b.$zO(Fe.to(K.kind),K.name,K.detail||"",l.URI.revive(K.uri),A.to(K.range),A.to(K.selectionRange));return ke._sessionId=K._sessionId,ke._itemId=K._itemId,ke}me.to=De;function ce(K,ke,We){if(ke=ke??K._sessionId,We=We??K._itemId,ke===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:We,name:K.name,detail:K.detail,kind:Fe.from(K.kind),uri:K.uri,range:A.from(K.range),selectionRange:A.from(K.selectionRange),tags:K.tags?.map(Be.from)}}me.from=ce})(ht||(e.CallHierarchyItem=ht={}));var $t;(function(me){function De(ce){return new b.$AO(ht.to(ce.from),ce.fromRanges.map(K=>A.to(K)))}me.to=De})($t||(e.CallHierarchyIncomingCall=$t={}));var ut;(function(me){function De(ce){return new b.$BO(ht.to(ce.to),ce.fromRanges.map(K=>A.to(K)))}me.to=De})(ut||(e.CallHierarchyOutgoingCall=ut={}));var et;(function(me){function De(K){return{range:K.range&&A.from(K.range),uri:K.uri}}me.from=De;function ce(K){return new b.$nO(l.URI.revive(K.uri),A.to(K.range))}me.to=ce})(et||(e.location=et={}));var Le;(function(me){function De(K){const ke=K,We=K;return{originSelectionRange:ke.originSelectionRange?A.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:We.uri,range:A.from(ke.targetRange?ke.targetRange:We.range),targetSelectionRange:ke.targetSelectionRange?A.from(ke.targetSelectionRange):void 0}}me.from=De;function ce(K){return{targetUri:l.URI.revive(K.uri),targetRange:A.to(K.range),targetSelectionRange:K.targetSelectionRange?A.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?A.to(K.originSelectionRange):void 0}}me.to=ce})(Le||(e.DefinitionLink=Le={}));var Me;(function(me){function De(K){return{range:A.from(K.range),contents:ue.fromMany(K.contents),canIncreaseVerbosity:K.canIncreaseVerbosity,canDecreaseVerbosity:K.canDecreaseVerbosity}}me.from=De;function ce(K){const ke=K.contents.map(ue.to),We=A.to(K.range),Ze=K.canIncreaseVerbosity,Ue=K.canDecreaseVerbosity;return new b.$rO(ke,We,Ze,Ue)}me.to=ce})(Me||(e.Hover=Me={}));var Ne;(function(me){function De(K){return{range:A.from(K.range),expression:K.expression}}me.from=De;function ce(K){return new b.$mP(A.to(K.range),K.expression)}me.to=ce})(Ne||(e.EvaluatableExpression=Ne={}));var W;(function(me){function De(K){if(K instanceof b.$nP)return{type:"text",range:A.from(K.range),text:K.text};if(K instanceof b.$oP)return{type:"variable",range:A.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof b.$pP)return{type:"expression",range:A.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}me.from=De;function ce(K){switch(K.type){case"text":return{range:A.to(K.range),text:K.text};case"variable":return{range:A.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:A.to(K.range),expression:K.expression}}}me.to=ce})(W||(e.InlineValue=W={}));var B;(function(me){function De(K){return{frameId:K.frameId,stoppedLocation:A.from(K.stoppedLocation)}}me.from=De;function ce(K){return new b.$qP(K.frameId,A.to(K.stoppedLocation))}me.to=ce})(B||(e.InlineValueContext=B={}));var Q;(function(me){function De(K){return{range:A.from(K.range),kind:K.kind}}me.from=De;function ce(K){return new b.$sO(A.to(K.range),K.kind)}me.to=ce})(Q||(e.DocumentHighlight=Q={}));var H;(function(me){function De(K){return{uri:K.uri,highlights:K.highlights.map(Q.from)}}me.from=De;function ce(K){return new b.$tO(l.URI.revive(K.uri),K.highlights.map(Q.to))}me.to=ce})(H||(e.MultiDocumentHighlight=H={}));var se;(function(me){function De(ce){switch(ce){case n.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case n.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case n.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}me.to=De})(se||(e.CompletionTriggerKind=se={}));var ge;(function(me){function De(ce){return{triggerKind:se.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}me.to=De})(ge||(e.CompletionContext=ge={}));var Ee;(function(me){function De(K){switch(K){case b.CompletionItemTag.Deprecated:return n.CompletionItemTag.Deprecated}}me.from=De;function ce(K){switch(K){case n.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}me.to=ce})(Ee||(e.CompletionItemTag=Ee={}));var ze;(function(me){const De=new Map([[b.CompletionItemKind.Method,n.CompletionItemKind.Method],[b.CompletionItemKind.Function,n.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,n.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,n.CompletionItemKind.Field],[b.CompletionItemKind.Variable,n.CompletionItemKind.Variable],[b.CompletionItemKind.Class,n.CompletionItemKind.Class],[b.CompletionItemKind.Interface,n.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,n.CompletionItemKind.Struct],[b.CompletionItemKind.Module,n.CompletionItemKind.Module],[b.CompletionItemKind.Property,n.CompletionItemKind.Property],[b.CompletionItemKind.Unit,n.CompletionItemKind.Unit],[b.CompletionItemKind.Value,n.CompletionItemKind.Value],[b.CompletionItemKind.Constant,n.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,n.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,n.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,n.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,n.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,n.CompletionItemKind.Text],[b.CompletionItemKind.Color,n.CompletionItemKind.Color],[b.CompletionItemKind.File,n.CompletionItemKind.File],[b.CompletionItemKind.Reference,n.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,n.CompletionItemKind.Folder],[b.CompletionItemKind.Event,n.CompletionItemKind.Event],[b.CompletionItemKind.Operator,n.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,n.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,n.CompletionItemKind.Issue],[b.CompletionItemKind.User,n.CompletionItemKind.User]]);function ce(We){return De.get(We)??n.CompletionItemKind.Property}me.from=ce;const K=new Map([[n.CompletionItemKind.Method,b.CompletionItemKind.Method],[n.CompletionItemKind.Function,b.CompletionItemKind.Function],[n.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[n.CompletionItemKind.Field,b.CompletionItemKind.Field],[n.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[n.CompletionItemKind.Class,b.CompletionItemKind.Class],[n.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[n.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[n.CompletionItemKind.Module,b.CompletionItemKind.Module],[n.CompletionItemKind.Property,b.CompletionItemKind.Property],[n.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[n.CompletionItemKind.Value,b.CompletionItemKind.Value],[n.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[n.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[n.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[n.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[n.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[n.CompletionItemKind.Text,b.CompletionItemKind.Text],[n.CompletionItemKind.Color,b.CompletionItemKind.Color],[n.CompletionItemKind.File,b.CompletionItemKind.File],[n.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[n.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[n.CompletionItemKind.Event,b.CompletionItemKind.Event],[n.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[n.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[n.CompletionItemKind.User,b.CompletionItemKind.User],[n.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function ke(We){return K.get(We)??b.CompletionItemKind.Property}me.to=ke})(ze||(e.CompletionItemKind=ze={}));var Je;(function(me){function De(ce,K){const ke=new b.$JO(ce.label);return ke.insertText=ce.insertText,ke.kind=ze.to(ce.kind),ke.tags=ce.tags?.map(Ee.to),ke.detail=ce.detail,ke.documentation=R.$$k(ce.documentation)?ue.to(ce.documentation):ce.documentation,ke.sortText=ce.sortText,ke.filterText=ce.filterText,ke.preselect=ce.preselect,ke.commitCharacters=ce.commitCharacters,a.$Wt.isIRange(ce.range)?ke.range=A.to(ce.range):typeof ce.range=="object"&&(ke.range={inserting:A.to(ce.range.insert),replacing:A.to(ce.range.replace)}),ke.keepWhitespace=typeof ce.insertTextRules>"u"?!1:!!(ce.insertTextRules&n.CompletionItemInsertTextRule.KeepWhitespace),typeof ce.insertTextRules<"u"&&ce.insertTextRules&n.CompletionItemInsertTextRule.InsertAsSnippet?ke.insertText=new b.$mO(ce.insertText):(ke.insertText=ce.insertText,ke.textEdit=ke.range instanceof b.$bO?new b.$iO(ke.range,ke.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(ke.additionalTextEdits=ce.additionalTextEdits.map(We=>be.to(We))),ke.command=K&&ce.command?K.fromInternal(ce.command):void 0,ke}me.to=De})(Je||(e.CompletionItem=Je={}));var _e;(function(me){function De(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:ue.fromStrict(K.documentation)}}me.from=De;function ce(K){return{label:K.label,documentation:R.$$k(K.documentation)?ue.to(K.documentation):K.documentation}}me.to=ce})(_e||(e.ParameterInformation=_e={}));var tt;(function(me){function De(K){return{label:K.label,documentation:ue.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(_e.from):[],activeParameter:K.activeParameter}}me.from=De;function ce(K){return{label:K.label,documentation:R.$$k(K.documentation)?ue.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(_e.to):[],activeParameter:K.activeParameter}}me.to=ce})(tt||(e.SignatureInformation=tt={}));var ct;(function(me){function De(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(tt.from):[]}}me.from=De;function ce(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(tt.to):[]}}me.to=ce})(ct||(e.SignatureHelp=ct={}));var it;(function(me){function De(ce,K){const ke=new b.$IO(x.to(K.position),typeof K.label=="string"?K.label:K.label.map(at.to.bind(void 0,ce)),K.kind&&yt.to(K.kind));return ke.textEdits=K.textEdits&&K.textEdits.map(be.to),ke.tooltip=R.$$k(K.tooltip)?ue.to(K.tooltip):K.tooltip,ke.paddingLeft=K.paddingLeft,ke.paddingRight=K.paddingRight,ke}me.to=De})(it||(e.InlayHint=it={}));var at;(function(me){function De(ce,K){const ke=new b.$HO(K.label);return ke.tooltip=R.$$k(K.tooltip)?ue.to(K.tooltip):K.tooltip,n.Command.is(K.command)&&(ke.command=ce.fromInternal(K.command)),K.location&&(ke.location=et.to(K.location)),ke}me.to=De})(at||(e.InlayHintLabelPart=at={}));var yt;(function(me){function De(K){return K}me.from=De;function ce(K){return K}me.to=ce})(yt||(e.InlayHintKind=yt={}));var Ye;(function(me){function De(K){return{range:A.from(K.range),url:K.target,tooltip:K.tooltip}}me.from=De;function ce(K){let ke;if(K.url)try{ke=typeof K.url=="string"?l.URI.parse(K.url,!0):l.URI.revive(K.url)}catch{}const We=new b.$OO(A.to(K.range),ke);return We.tooltip=K.tooltip,We}me.to=ce})(Ye||(e.DocumentLink=Ye={}));var he;(function(me){function De(K){const ke=new b.$RO(K.label);return K.textEdit&&(ke.textEdit=be.to(K.textEdit)),K.additionalTextEdits&&(ke.additionalTextEdits=K.additionalTextEdits.map(We=>be.to(We))),ke}me.to=De;function ce(K){return{label:K.label,textEdit:K.textEdit?be.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(ke=>be.from(ke)):void 0}}me.from=ce})(he||(e.ColorPresentation=he={}));var pe;(function(me){function De(K){return new b.$PO(K[0],K[1],K[2],K[3])}me.to=De;function ce(K){return[K.red,K.green,K.blue,K.alpha]}me.from=ce})(pe||(e.Color=pe={}));var ye;(function(me){function De(K){return{range:A.from(K.range)}}me.from=De;function ce(K){return new b.$yO(A.to(K.range))}me.to=ce})(ye||(e.SelectionRange=ye={}));var Ce;(function(me){function De(ce){switch(ce){case f.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case f.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case f.SaveReason.FOCUS_CHANGE:case f.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}me.to=De})(Ce||(e.TextDocumentSaveReason=Ce={}));var fe;(function(me){function De(K){switch(K){case b.TextEditorLineNumbersStyle.Off:return d.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return d.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return d.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return d.RenderLineNumbersType.On}}me.from=De;function ce(K){switch(K){case d.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case d.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case d.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case d.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}me.to=ce})(fe||(e.TextEditorLineNumbersStyle=fe={}));var ve;(function(me){function De(K){if(K===b.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(K===b.EndOfLine.LF)return t.EndOfLineSequence.LF}me.from=De;function ce(K){if(K===t.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(K===t.EndOfLineSequence.LF)return b.EndOfLine.LF}me.to=ce})(ve||(e.EndOfLine=ve={}));var Y;(function(me){function De(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case b.ProgressLocation.SourceControl:return c.ProgressLocation.Scm;case b.ProgressLocation.Window:return c.ProgressLocation.Window;case b.ProgressLocation.Notification:return c.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}me.from=De})(Y||(e.ProgressLocation=Y={}));var q;(function(me){function De(K){const ke={start:K.start+1,end:K.end+1};return K.kind&&(ke.kind=de.from(K.kind)),ke}me.from=De;function ce(K){const ke={start:K.start-1,end:K.end-1};return K.kind&&(ke.kind=de.to(K.kind)),ke}me.to=ce})(q||(e.FoldingRange=q={}));var de;(function(me){function De(K){if(K)switch(K){case b.FoldingRangeKind.Comment:return n.$Xu.Comment;case b.FoldingRangeKind.Imports:return n.$Xu.Imports;case b.FoldingRangeKind.Region:return n.$Xu.Region}}me.from=De;function ce(K){if(K)switch(K.value){case n.$Xu.Comment.value:return b.FoldingRangeKind.Comment;case n.$Xu.Imports.value:return b.FoldingRangeKind.Imports;case n.$Xu.Region.value:return b.FoldingRangeKind.Region}}me.to=ce})(de||(e.FoldingRangeKind=de={}));var je;(function(me){function De(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?A.from(ce.selection):void 0,override:typeof ce.override=="boolean"?f.$jG.id:void 0}}me.from=De})(je||(e.TextEditorOpenOptions=je={}));var Qe;(function(me){function De(We){return We instanceof b.$aP?We.toJSON():typeof We=="string"?We:ce(We)||K(We)?new b.$aP(We.baseUri??We.base,We.pattern).toJSON():We}me.from=De;function ce(We){const Ze=We;return Ze?l.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function K(We){const Ze=We;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function ke(We){return typeof We=="string"?We:new b.$aP(l.URI.revive(We.baseUri),We.pattern)}me.to=ke})(Qe||(e.GlobPattern=Qe={}));var st;(function(me){function De(ce){if(ce){if(Array.isArray(ce))return ce.map(De);if(typeof ce=="string")return ce;{const K=ce;return{language:K.language,scheme:K.scheme,pattern:Qe.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}me.from=De})(st||(e.LanguageSelector=st={}));var dt;(function(me){function De(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(ke=>Array.isArray(ke)&&ke.every(We=>We&&typeof We=="object"&&"uri"in We&&l.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ze=>Ze instanceof b.$bO)))}me.is=De;function ce(K){return{documents:K.documents.map(ke=>ke.map(We=>({uri:l.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ze=>A.from(Ze))})))}}me.from=ce})(dt||(e.MappedEditsContext=dt={}));var mt;(function(me){function De(K){return{start:K.start,end:K.end}}me.from=De;function ce(K){return new b.$DP(K.start,K.end)}me.to=ce})(mt||(e.NotebookRange=mt={}));var Tt;(function(me){function De(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}me.to=De;function ce(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}me.from=ce})(Tt||(e.NotebookCellExecutionSummary=Tt={}));var Ot;(function(me){function De(ce){if(ce===y.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(ce===y.NotebookCellExecutionState.Pending)return;if(ce===y.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ce}`)}me.to=De})(Ot||(e.NotebookCellExecutionState=Ot={}));var Qt;(function(me){function De(K){switch(K){case b.NotebookCellKind.Markup:return y.CellKind.Markup;case b.NotebookCellKind.Code:default:return y.CellKind.Code}}me.from=De;function ce(K){switch(K){case y.CellKind.Markup:return b.NotebookCellKind.Markup;case y.CellKind.Code:default:return b.NotebookCellKind.Code}}me.to=ce})(Qt||(e.NotebookCellKind=Qt={}));var _t;(function(me){function De(K){const ke={metadata:K.metadata??Object.create(null),cells:[]};for(const We of K.cells)b.$EP.validate(We),ke.cells.push(Xe.from(We));return ke}me.from=De;function ce(K){const ke=new b.$FP(K.cells.map(Xe.to));return(0,r.$wg)(K.metadata)||(ke.metadata=K.metadata),ke}me.to=ce})(_t||(e.NotebookData=_t={}));var Xe;(function(me){function De(K){return{cellKind:Qt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Tt.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Ut.from):[]}}me.from=De;function ce(K){return new b.$EP(Qt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Ut.to):void 0,K.metadata,K.internalMetadata?Tt.to(K.internalMetadata):void 0)}me.to=ce})(Xe||(e.NotebookCellData=Xe={}));var At;(function(me){function De(K){return{mime:K.mime,valueBytes:D.$Se.wrap(K.data)}}me.from=De;function ce(K){return new b.$GP(K.valueBytes.buffer,K.mime)}me.to=ce})(At||(e.NotebookCellOutputItem=At={}));var Ut;(function(me){function De(K){return{outputId:K.id,items:K.items.map(At.from),metadata:K.metadata}}me.from=De;function ce(K){const ke=K.items.map(At.to);return new b.$HP(ke,K.outputId,K.metadata)}me.to=ce})(Ut||(e.NotebookCellOutput=Ut={}));var wt;(function(me){function De(ke){return K(ke)?{include:Qe.from(ke.include)??void 0,exclude:Qe.from(ke.exclude)??void 0}:Qe.from(ke)??void 0}me.from=De;function ce(ke){return K(ke)?{include:Qe.to(ke.include),exclude:Qe.to(ke.exclude)}:Qe.to(ke)}me.to=ce;function K(ke){const We=ke;return We?!(0,r.$sg)(We.include)&&!(0,r.$sg)(We.exclude):!1}})(wt||(e.NotebookExclusiveDocumentPattern=wt={}));var Dt;(function(me){function De(ce,K,ke){const We=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===b.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:K.toInternal(We,ke),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}me.from=De})(Dt||(e.NotebookStatusBarItem=Dt={}));var ei;(function(me){function De(ce,K,ke){const We=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{command:K.toInternal(We,ke),label:ce.label,description:ce.description,detail:ce.detail,documentation:ce.documentation}}me.from=De})(ei||(e.NotebookKernelSourceAction=ei={}));var ti;(function(me){function De(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{},cellContentMetadata:ce?.cellContentMetadata??{}}}me.from=De})(ti||(e.NotebookDocumentContentOptions=ti={}));var Ht;(function(me){function De(K){return{uri:K.uri,provides:K.provides}}me.from=De;function ce(K){return new b.$JP(l.URI.revive(K.uri),K.provides)}me.to=ce})(Ht||(e.NotebookRendererScript=Ht={}));var bt;(function(me){function De(K){return{message:ue.fromStrict(K.message)||"",type:T.TestMessageType.Error,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:A.from(K.location.range),uri:K.location.uri},stackTrace:K.stackTrace?.map(ke=>({label:ke.label,position:ke.position&&x.from(ke.position),uri:ke.uri&&l.URI.revive(ke.uri).toJSON()}))}}me.from=De;function ce(K){const ke=new b.$PP(typeof K.message=="string"?K.message:ue.to(K.message));return ke.actualOutput=K.actual,ke.expectedOutput=K.expected,ke.contextValue=K.contextValue,ke.location=K.location?et.to(K.location):void 0,ke}me.to=ce})(bt||(e.TestMessage=bt={}));var Lt;(function(me){me.namespace=T.$uJ,me.denamespace=T.$vJ})(Lt||(e.TestTag=Lt={}));var ci;(function(me){function De(K){const ke=(0,g.$GQ)(K).controllerId;return{extId:C.$pJ.fromExtHostTestItem(K,ke).toString(),label:K.label,uri:l.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(We=>Lt.namespace(ke,We.id)),range:a.$Wt.lift(A.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&ue.fromStrict(K.error)||null}}me.from=De;function ce(K){return{parent:void 0,error:void 0,id:C.$pJ.fromString(K.extId).localId,label:K.label,uri:l.URI.revive(K.uri),tags:(K.tags||[]).map(ke=>{const{tagId:We}=Lt.denamespace(ke);return new b.$QP(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:A.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}me.toPlain=ce})(ci||(e.TestItem=ci={})),function(me){function De(K){return{id:K.id}}me.from=De;function ce(K){return new b.$QP(K.id)}me.to=ce}(Lt||(e.TestTag=Lt={}));var Yt;(function(me){const De=(K,ke)=>{const We=K.value;if(!We)return;const Ze={...ci.toPlain(We.item),parent:ke,taskStates:We.tasks.map(Ue=>({state:Ue.state,duration:Ue.duration,messages:Ue.messages.filter(ot=>ot.type===T.TestMessageType.Error).map(bt.to)})),children:[]};if(K.children)for(const Ue of K.children.values()){const ot=De(Ue,Ze);ot&&Ze.children.push(ot)}return Ze};function ce(K){const ke=new u.$oJ;for(const Ue of K.items)ke.insert(C.$pJ.fromString(Ue.item.extId).path,Ue);const We=[ke.nodes],Ze=[];for(;We.length;)for(const Ue of We.pop())Ue.value?Ze.push(Ue):Ue.children&&We.push(Ue.children.values());return{completedAt:K.completedAt,results:Ze.map(Ue=>De(Ue)).filter(r.$rg)}}me.to=ce})(Yt||(e.TestResults=Yt={}));var Ge;(function(me){function De(Ue){return{covered:Ue.covered,total:Ue.total}}function ce(Ue){return"line"in Ue?x.from(Ue):A.from(Ue)}function K(Ue){if(Ue)return"endLineNumber"in Ue?A.to(Ue):x.to(Ue)}function ke(Ue){if(Ue.type===T.DetailType.Statement){const ot=[];if(Ue.branches)for(const gt of Ue.branches)ot.push({executed:gt.count,location:K(gt.location),label:gt.label});return new b.$VP(Ue.count,K(Ue.location),Ue.branches?.map(gt=>new b.$WP(gt.count,K(gt.location),gt.label)))}else return new b.$XP(Ue.name,Ue.count,K(Ue.location))}me.to=ke;function We(Ue){if(typeof Ue.executed=="number"&&Ue.executed<0)throw new Error(`Invalid coverage count ${Ue.executed}`);return"branches"in Ue?{count:Ue.executed,location:ce(Ue.location),type:T.DetailType.Statement,branches:Ue.branches.length?Ue.branches.map(ot=>({count:ot.executed,location:ot.location&&ce(ot.location),label:ot.label})):void 0}:{type:T.DetailType.Declaration,name:Ue.name,count:Ue.executed,location:ce(Ue.location)}}me.fromDetails=We;function Ze(Ue,ot,gt){return b.$TP(gt.statementCoverage),b.$TP(gt.branchCoverage),b.$TP(gt.declarationCoverage),{id:ot,uri:gt.uri,statement:De(gt.statementCoverage),branch:gt.branchCoverage&&De(gt.branchCoverage),declaration:gt.declarationCoverage&&De(gt.declarationCoverage),testIds:gt instanceof b.$UP&&gt.fromTests.length?gt.fromTests.map(Kt=>C.$pJ.fromExtHostTestItem(Kt,Ue).toString()):void 0}}me.fromFile=Ze})(Ge||(e.TestCoverage=Ge={}));var ii;(function(me){function De(ce){switch(ce){case n.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case n.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}me.to=De})(ii||(e.CodeActionTriggerKind=ii={}));var li;(function(me){function De(K){const ke=new b.$YP(Fe.to(K.kind),K.name,K.detail||"",l.URI.revive(K.uri),A.to(K.range),A.to(K.selectionRange));return ke._sessionId=K._sessionId,ke._itemId=K._itemId,ke}me.to=De;function ce(K,ke,We){if(ke=ke??K._sessionId,We=We??K._itemId,ke===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:We,kind:Fe.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:A.from(K.range),selectionRange:A.from(K.selectionRange),tags:K.tags?.map(Be.from)}}me.from=ce})(li||(e.TypeHierarchyItem=li={}));var hi;(function(me){function De(ce){if(ce)return{value:ce.value,tooltip:ce.tooltip}}me.from=De})(hi||(e.ViewBadge=hi={}));var kt;(function(me){function De(We,Ze,Ue){const ot=Ze.fileData;return ot?new b.$5O(new b.$6O(ot.name,l.URI.revive(ot.uri),ot.id,(0,L.$hb)(()=>Ue(ot.id)))):We===I.$gt.uriList&&Ze.uriListData?new b.$4O(ke(Ze.uriListData)):new b.$4O(Ze.asString)}me.to=De;async function ce(We,Ze){const Ue=await Ze.asString();if(We===I.$gt.uriList)return{asString:Ue,fileData:void 0,uriListData:K(Ue)};const ot=Ze.asFile();return{asString:Ue,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}me.from=ce;function K(We){return P.$Bu.split(We).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return l.URI.parse(Ze)}catch{}return Ze})}function ke(We){return P.$Bu.create(We.map(Ze=>typeof Ze=="string"?Ze:l.URI.revive(Ze)))}})(kt||(e.DataTransferItem=kt={}));var jt;(function(me){function De(K,ke){const We=K.items.map(([Ze,Ue])=>[Ze,kt.to(Ze,Ue,ke)]);return new b.$7O(We)}me.toDataTransfer=De;async function ce(K){const ke={items:[]},We=[];for(const[Ze,Ue]of K)We.push((async()=>{ke.items.push([Ze,await kt.from(Ze,Ue)])})());return await Promise.all(We),ke}me.from=ce})(jt||(e.DataTransfer=jt={}));var Nt;(function(me){function De(K,ke){return{kind:"reply",agentId:K.participant??ke?.agentId??"",subCommand:K.command??ke?.command,message:K.prompt,title:K.label}}me.from=De;function ce(K){return{prompt:K.message,label:K.title,participant:K.agentId,command:K.subCommand}}me.to=ce})(Nt||(e.ChatFollowup=Nt={}));var Bt;(function(me){function De(K){switch(K){case S.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case S.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case S.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}me.to=De;function ce(K){switch(K){case b.LanguageModelChatMessageRole.System:return S.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return S.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return S.ChatMessageRole.Assistant}return S.ChatMessageRole.User}me.from=ce})(Bt||(e.LanguageModelChatMessageRole=Bt={}));var ai;(function(me){function De(K){const ke=K.content.map(ot=>ot.type==="text"?ot.value:ot.type==="tool_result"?new b.$rQ(ot.toolCallId,ot.value,ot.isError):new b.$tQ(ot.name,ot.toolCallId,ot.parameters)),We=ke.find(ot=>typeof ot=="string")??"",Ze=Bt.to(K.role),Ue=new b.$sQ(Ze,We,K.name);return Ue.content2=ke,Ue}me.to=De;function ce(K){const ke=Bt.from(K.role),We=K.name,Ze=K.content2.map(Ue=>{if(Ue instanceof b.$rQ)return{type:"tool_result",toolCallId:Ue.toolCallId,value:Ue.content,isError:Ue.isError};if(Ue instanceof b.$tQ)return{type:"tool_use",toolCallId:Ue.toolCallId,name:Ue.name,parameters:Ue.parameters};if(typeof Ue!="string")throw new Error("Unexpected chat message content type");return{type:"text",value:Ue}});return{role:ke,name:We,content:Ze}}me.from=ce})(ai||(e.LanguageModelChatMessage=ai={}));var ni;(function(me){function De(K){return{kind:"markdownContent",content:ue.from(K.value)}}me.from=De;function ce(K){return new b.$_P(ue.to(K.content))}me.to=ce})(ni||(e.ChatResponseMarkdownPart=ni={}));var ri;(function(me){function De(K){return{kind:"markdownVuln",content:ue.from(K.value),vulnerabilities:K.vulnerabilities}}me.from=De;function ce(K){return new b.$aQ(ue.to(K.content),K.vulnerabilities)}me.to=ce})(ri||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ri={}));var Gt;(function(me){function De(K){return{kind:"agentDetection",agentId:K.participant,command:K.command}}me.from=De;function ce(K){return new b.$bQ(K.agentId,K.command)}me.to=ce})(Gt||(e.ChatResponseDetectedParticipantPart=Gt={}));var Jt;(function(me){function De(ce){return{kind:"confirmation",title:ce.title,message:ce.message,data:ce.data,buttons:ce.buttons}}me.from=De})(Jt||(e.ChatResponseConfirmationPart=Jt={}));var ui;(function(me){function De(K){const{value:ke,baseUri:We}=K;function Ze(Ue,ot){return Ue.map(gt=>{const Kt=l.URI.joinPath(ot,gt.name);return{label:gt.name,uri:Kt,children:gt.children&&Ze(gt.children,Kt)}})}return{kind:"treeData",treeData:{label:(0,E.$ih)(We),uri:We,children:Ze(ke,We)}}}me.from=De;function ce(K){const ke=(0,s.$hi)(K.treeData);function We(ot){return ot.map(gt=>({name:gt.label,children:gt.children&&We(gt.children)}))}const Ze=ke.uri,Ue=ke.children?We(ke.children):[];return new b.$dQ(Ue,Ze)}me.to=ce})(ui||(e.ChatResponseFilesPart=ui={}));var Mt;(function(me){function De(K){const ke=We=>l.URI.isUri(We);return{kind:"inlineReference",name:K.title,inlineReference:ke(K.value)?K.value:F.from(K.value)}}me.from=De;function ce(K){const ke=(0,s.$hi)(K);return new b.$eQ(l.URI.isUri(ke.inlineReference)?ke.inlineReference:F.to(ke.inlineReference),K.name)}me.to=ce})(Mt||(e.ChatResponseAnchorPart=Mt={}));var Ct;(function(me){function De(K){return{kind:"progressMessage",content:ue.from(K.value)}}me.from=De;function ce(K){return new b.$fQ(K.content.value)}me.to=ce})(Ct||(e.ChatResponseProgressPart=Ct={}));var vt;(function(me){function De(K){return{kind:"warning",content:ue.from(K.value)}}me.from=De;function ce(K){return new b.$hQ(K.content.value)}me.to=ce})(vt||(e.ChatResponseWarningPart=vt={}));var Xt;(function(me){function De(K){return{kind:"move",uri:K.uri,range:A.from(K.range)}}me.from=De;function ce(K){return new b.$lQ(l.URI.revive(K.uri),A.to(K.range))}me.to=ce})(Xt||(e.ChatResponseMovePart=Xt={}));var Et;(function(me){function De(ce){return{kind:"progressTask",content:ue.from(ce.value)}}me.from=De})(Et||(e.ChatTask=Et={}));var si;(function(me){function De(ce){return{kind:"progressTaskResult",content:typeof ce=="string"?ue.from(ce):void 0}}me.from=De})(si||(e.ChatTaskResult=si={}));var Zt;(function(me){function De(K,ke,We){return{kind:"command",command:ke.toInternal(K.value,We)??{command:K.value.command,title:K.value.title}}}me.from=De;function ce(K,ke){return new b.$iQ(ke.fromInternal(K.command)??{command:K.command.id,title:K.command.title})}me.to=ce})(Zt||(e.ChatResponseCommandButtonPart=Zt={}));var Mi;(function(me){function De(K){return{kind:"textEdit",uri:K.uri,edits:K.edits.map(ke=>be.from(ke))}}me.from=De;function ce(K){return new b.$mQ(l.URI.revive(K.uri),K.edits.map(ke=>be.to(ke)))}me.to=ce})(Mi||(e.ChatResponseTextEditPart=Mi={}));var di;(function(me){function De(K){const ke=p.ThemeIcon.isThemeIcon(K.iconPath)?K.iconPath:l.URI.isUri(K.iconPath)?{light:l.URI.revive(K.iconPath)}:K.iconPath&&"light"in K.iconPath&&"dark"in K.iconPath&&l.URI.isUri(K.iconPath.light)&&l.URI.isUri(K.iconPath.dark)?{light:l.URI.revive(K.iconPath.light),dark:l.URI.revive(K.iconPath.dark)}:void 0;return typeof K.value=="object"&&"variableName"in K.value?{kind:"reference",reference:{variableName:K.value.variableName,value:l.URI.isUri(K.value.value)||!K.value.value?K.value.value:F.from(K.value.value)},iconPath:ke,options:K.options}:{kind:"reference",reference:l.URI.isUri(K.value)||typeof K.value=="string"?K.value:F.from(K.value),iconPath:ke,options:K.options}}me.from=De;function ce(K){const ke=(0,s.$hi)(K),We=Ze=>l.URI.isUri(Ze)?Ze:F.to(Ze);return new b.$jQ(typeof ke.reference=="string"?ke.reference:"variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&We(ke.reference.value)}:We(ke.reference))}me.to=ce})(di||(e.ChatResponseReferencePart=di={}));var yi;(function(me){function De(ce){return{kind:"codeCitation",value:ce.value,license:ce.license,snippet:ce.snippet}}me.from=De})(yi||(e.ChatResponseCodeCitationPart=yi={}));var qt;(function(me){function De(ke,We,Ze){return ke instanceof b.$_P?ni.from(ke):ke instanceof b.$eQ?Mt.from(ke):ke instanceof b.$jQ?di.from(ke):ke instanceof b.$fQ?Ct.from(ke):ke instanceof b.$dQ?ui.from(ke):ke instanceof b.$iQ?Zt.from(ke,We,Ze):ke instanceof b.$mQ?Mi.from(ke):ke instanceof b.$aQ?ri.from(ke):ke instanceof b.$bQ?Gt.from(ke):ke instanceof b.$hQ?vt.from(ke):ke instanceof b.$cQ?Jt.from(ke):ke instanceof b.$kQ?yi.from(ke):ke instanceof b.$lQ?Xt.from(ke):{kind:"markdownContent",content:ue.from("")}}me.from=De;function ce(ke,We){switch(ke.kind){case"reference":return di.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return K(ke,We)}}me.to=ce;function K(ke,We){switch(ke.kind){case"markdownContent":return ni.to(ke);case"inlineReference":return Mt.to(ke);case"progressMessage":return;case"treeData":return ui.to(ke);case"command":return Zt.to(ke,We)}}me.toContent=K})(qt||(e.ChatResponsePart=qt={}));var fi;(function(me){function De(ce,K){const ke=ce.variables.variables.filter(Ze=>Ze.isTool),We=ce.variables.variables.filter(Ze=>!Ze.isTool);return{prompt:ce.message,command:ce.command,attempt:ce.attempt??0,enableCommandDetection:ce.enableCommandDetection??!0,isParticipantDetected:ce.isParticipantDetected??!1,references:We.map(Rt.to),toolReferences:ke.map(Si.to),location:Fi.to(ce.location),acceptedConfirmationData:ce.acceptedConfirmationData,rejectedConfirmationData:ce.rejectedConfirmationData,location2:K}}me.to=De})(fi||(e.ChatAgentRequest=fi={}));var Fi;(function(me){function De(K){switch(K){case h.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}me.to=De;function ce(K){switch(K){case b.ChatLocation.Notebook:return h.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return h.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return h.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return h.ChatAgentLocation.Editor}}me.from=ce})(Fi||(e.ChatLocation=Fi={}));var Rt;(function(me){function De(ce){const K=ce.value;if(!K)throw new Error("Invalid value reference");return{id:ce.id,name:ce.name,range:ce.range&&[ce.range.start,ce.range.endExclusive],value:(0,l.$Ac)(K)?l.URI.revive(K):K&&typeof K=="object"&&"uri"in K&&"range"in K&&(0,l.$Ac)(K.uri)?F.to((0,s.$hi)(K)):K,modelDescription:ce.modelDescription}}me.to=De})(Rt||(e.ChatPromptReference=Rt={}));var Si;(function(me){function De(ce){if(ce.value)throw new Error("Invalid tool reference");return{id:ce.id,range:ce.range&&[ce.range.start,ce.range.endExclusive]}}me.to=De})(Si||(e.ChatLanguageModelToolReference=Si={}));var Ai;(function(me){function De(ce,K,ke){return{id:ce.id,label:ce.label,fullName:ce.fullName,icon:ce.icon?.id,value:ce.values[0].value,insertText:ce.insertText,detail:ce.detail,documentation:ce.documentation,command:K.toInternal(ce.command,ke)}}me.from=De})(Ai||(e.ChatAgentCompletionItem=Ai={}));var gi;(function(me){function De(ce){return{errorDetails:ce.errorDetails,metadata:ce.metadata,nextQuestion:ce.nextQuestion}}me.to=De})(gi||(e.ChatAgentResult=gi={}));var zi;(function(me){function De(ce,K,ke){if(K.action.kind==="vote")return;const We=gi.to(ce);if(K.action.kind==="command"){const Ze=K.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ke.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:We}}else return K.action.kind==="followUp"?{action:{kind:"followUp",followup:Nt.to(K.action.followup)},result:We}:K.action.kind==="inlineChat"?{action:{kind:"editor",accepted:K.action.action==="accepted"},result:We}:{action:K.action,result:We}}me.to=De})(zi||(e.ChatAgentUserActionEvent=zi={}));var ji;(function(me){function De(K){return{...K,string:K.toString()}}me.from=De;function ce(K){const ke={...K,toString:()=>K.string};return delete ke.string,ke}me.to=ce})(ji||(e.LanguageModelToolResult=ji={}));var zt;(function(me){function De(ce,K,ke){return"terminalCommand"in ce?{terminalCommand:ce.terminalCommand,shouldExecute:ce.shouldExecute}:"uri"in ce?{uri:ce.uri}:K.toInternal(ce,ke)}me.from=De})(zt||(e.TerminalQuickFix=zt={}));var Pi;(function(me){function De(ce){return{kind:Di.to(ce.kind)}}me.to=De})(Pi||(e.PartialAcceptInfo=Pi={}));var Di;(function(me){function De(ce){switch(ce){case n.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case n.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case n.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}me.to=De})(Di||(e.PartialAcceptTriggerKind=Di={}));var wi;(function(me){function De(ce,K){return{id:K,label:ce.label,description:ce.description,canEdit:ce.canEdit,collapsibleState:ce.collapsibleState||k.DebugTreeItemCollapsibleState.None,contextValue:ce.contextValue}}me.from=De})(wi||(e.DebugTreeItem=wi={}));var bi;(function(me){function De(ce){return{id:ce.id,modelDescription:ce.modelDescription,parametersSchema:ce.parametersSchema,displayName:ce.displayName}}me.to=De})(bi||(e.LanguageModelToolDescription=bi={}))}),define(Re[231],Te([1,0,5,16,8,39]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0;let R=class{constructor(m,s){this.a=m.getProxy(v.$0N.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>s.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,s,I){const w=new L.$7w(P.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(w,void 0,I?.isRefactoring??!1)}};e.$5qc=R,e.$5qc=R=He([qe(0,D.$KQ)],R)}),define(Re[232],Te([1,0,17,10,42,6,41,4,34,69,14,2,18,5,8,7,117,193,21]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0,p=Ve(p),r=Ve(r);class i{constructor(c,g,f,h,S){this.j=c,this.k=g,this.l=f,this.m=h,this.n=S,this.b=s.$ke.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let g=function(h){if(c.c){const S=new Error("Response stream has been closed");throw Error.captureStackTrace(S,h),S}};const c=this;this.b.reset();const f=(h,S)=>{if(typeof this.d>"u"&&(h.kind==="markdownContent"||h.kind==="markdownVuln")&&(this.d=this.b.elapsed()),S){const k=this.l.$handleProgressChunk(this.k.requestId,h),y={report:C=>{k?.then(T=>{T&&(r.$DO.isMarkdownString(C.value)?this.l.$handleProgressChunk(this.k.requestId,p.ChatResponseWarningPart.from(C),T):this.l.$handleProgressChunk(this.k.requestId,p.ChatResponseReferencePart.from(C),T))})}};Promise.all([k,S?.(y)]).then(([C,T])=>{C!==void 0&&this.l.$handleProgressChunk(this.k.requestId,p.ChatTaskResult.from(T),C)})}else this.l.$handleProgressChunk(this.k.requestId,h)};this.g={markdown(h){g(this.markdown);const S=new r.$_P(h),k=p.ChatResponseMarkdownPart.from(S);return f(k),this},markdownWithVulnerabilities(h,S){g(this.markdown),S&&(0,a.$zH)(c.j,"chatParticipantAdditions");const k=new r.$aQ(h,S),y=p.ChatResponseMarkdownWithVulnerabilitiesPart.from(k);return f(y),this},filetree(h,S){g(this.filetree);const k=new r.$dQ(h,S),y=p.ChatResponseFilesPart.from(k);return f(y),this},anchor(h,S){g(this.anchor);const k=new r.$eQ(h,S),y=p.ChatResponseAnchorPart.from(k);return f(y),this},button(h){g(this.anchor);const S=new r.$iQ(h),k=p.ChatResponseCommandButtonPart.from(S,c.m,c.n);return f(k),this},progress(h,S){g(this.progress);const k=new r.$gQ(h,S),y=S?p.ChatTask.from(k):p.ChatResponseProgressPart.from(k);return f(y,S),this},warning(h){g(this.progress),(0,a.$zH)(c.j,"chatParticipantAdditions");const S=new r.$hQ(h),k=p.ChatResponseWarningPart.from(S);return f(k),this},reference(h,S){return this.reference2(h,S)},reference2(h,S,k){if(g(this.reference),typeof h=="object"&&"variableName"in h&&(0,a.$zH)(c.j,"chatParticipantAdditions"),typeof h=="object"&&"variableName"in h&&!h.value){const y=c.k.variables.variables.find(C=>C.name===h.variableName);if(y){let C;if(y.references?.length)C=y.references.map(T=>({kind:"reference",reference:{variableName:h.variableName,value:T.reference}}));else{const T=new r.$jQ(h,S,k);C=[p.ChatResponseReferencePart.from(T)]}return C.forEach(T=>f(T)),this}}else{const y=new r.$jQ(h,S,k),C=p.ChatResponseReferencePart.from(y);f(C)}return this},codeCitation(h,S,k){g(this.codeCitation),(0,a.$zH)(c.j,"chatParticipantAdditions");const y=new r.$kQ(h,S,k),C=p.ChatResponseCodeCitationPart.from(y);f(C)},textEdit(h,S){g(this.textEdit),(0,a.$zH)(c.j,"chatParticipantAdditions");const k=new r.$mQ(h,S),y=p.ChatResponseTextEditPart.from(k);return f(y),this},detectedParticipant(h,S){g(this.detectedParticipant),(0,a.$zH)(c.j,"chatParticipantAdditions");const k=new r.$bQ(h,S),y=p.ChatResponseDetectedParticipantPart.from(k);return f(y),this},confirmation(h,S,k,y){g(this.confirmation),(0,a.$zH)(c.j,"chatParticipantAdditions");const C=new r.$cQ(h,S,k,y),T=p.ChatResponseConfirmationPart.from(C);return f(T),this},push(h){if(g(this.push),(h instanceof r.$mQ||h instanceof r.$aQ||h instanceof r.$bQ||h instanceof r.$hQ||h instanceof r.$cQ||h instanceof r.$kQ||h instanceof r.$lQ)&&(0,a.$zH)(c.j,"chatParticipantAdditions"),h instanceof r.$jQ)this.reference2(h.value,h.iconPath,h.options);else{const S=p.ChatResponsePart.from(h,c.m,c.n);f(S)}return this}}}return this.g}}class n extends O.$Zc{static{this.b=0}static{this.j=0}constructor(c,g,f,h){super(),this.t=g,this.u=f,this.w=h,this.c=new Map,this.m=new Map,this.n=this.B(new O.$9c),this.s=this.B(new O.$9c),this.g=c.getProxy(E.$0N.MainThreadChatAgents2)}transferActiveChat(c){this.g.$transferActiveChatSession(c)}createChatAgent(c,g,f){const h=n.b++,S=new t(c,g,this.g,h,f);return this.c.set(h,S),this.g.$registerAgent(h,c.identifier,g,{},void 0),S.apiAgent}createDynamicChatAgent(c,g,f,h){const S=n.b++,k=new t(c,g,this.g,S,h);return this.c.set(S,k),this.g.$registerAgent(S,c.identifier,g,{isSticky:!0},f),k.apiAgent}registerChatParticipantDetectionProvider(c){const g=n.j++;return this.m.set(g,c),this.g.$registerChatParticipantDetectionProvider(g),(0,O.$Xc)(()=>{this.m.delete(g),this.g.$unregisterChatParticipantDetectionProvider(g)})}async $detectChatParticipant(c,g,f,h,S){const{request:k,location:y,history:C}=await this.y(g,f),T=this.m.get(c);if(T)return T.provideParticipantDetection(p.ChatAgentRequest.to(k,y),{history:C},{participants:h.participants,location:p.ChatLocation.to(h.location)},S)}async y(c,g){const f=(0,m.$hi)(c),h=await this.z(f.agentId,g);let S;if(f.locationData?.type===l.ChatAgentLocation.Editor){const k=this.w.getDocument(f.locationData.document);S=new r.$pQ(k,p.Selection.to(f.locationData.selection),p.Range.to(f.locationData.wholeRange))}else if(f.locationData?.type===l.ChatAgentLocation.Notebook){const k=this.w.getDocument(f.locationData.sessionInputUri);S=new r.$qQ(k)}else f.locationData?.type,l.ChatAgentLocation.Terminal;return{request:f,location:S,history:h}}async $invokeAgent(c,g,f,h){const S=this.c.get(c);if(!S)throw new Error(`[CHAT](${c}) CANNOT invoke agent because the agent is not registered`);let k;try{const{request:y,location:C,history:T}=await this.y(g,f);let $=this.n.get(y.sessionId);$||($=new O.$Yc,this.n.set(y.sessionId,$)),k=new i(S.extension,y,this.g,this.u.converter,$);const b=S.invoke(p.ChatAgentRequest.to(y,C),{history:T},k.apiObject,h);return await(0,D.$yh)(Promise.resolve(b).then(N=>{if(N?.metadata)try{JSON.stringify(N.metadata)}catch(F){const G=`result.metadata MUST be JSON.stringify-able. Got error: ${F.message}`;return this.t.error(`[${S.extension.identifier.value}] [@${S.id}] ${G}`,S.extension),{errorDetails:{message:G},timings:k?.timings,nextQuestion:N.nextQuestion}}let A;return N?.errorDetails&&(A={...N.errorDetails,responseIsIncomplete:!0}),A?.responseIsRedacted&&(0,a.$zH)(S.extension,"chatParticipantPrivate"),{errorDetails:A,timings:k?.timings,metadata:N?.metadata,nextQuestion:N?.nextQuestion}}),h)}catch(y){return this.t.error(y,S.extension),y instanceof r.$yQ&&y.cause&&(y=y.cause),{errorDetails:{message:(0,P.$vj)(y),responseIsIncomplete:!0}}}finally{k?.close()}}async z(c,g){const f=[];for(const h of g.history){const S=p.ChatAgentResult.to(h.result),k=c===h.request.agentId?S:{...S,metadata:void 0},y=h.request.variables.variables.filter(b=>!b.isTool).map(p.ChatPromptReference.to),C=h.request.variables.variables.filter(b=>b.isTool).map(p.ChatLanguageModelToolReference.to),T=new r.$nQ(h.request.message,h.request.command,y,h.request.agentId);T.toolReferences=C,f.push(T);const $=(0,v.$Lb)(h.response.map(b=>p.ChatResponsePart.toContent(b,this.u.converter)));f.push(new r.$oQ($,k,h.request.agentId,h.request.command))}return f}$releaseSession(c){this.n.deleteAndDispose(c)}async $provideFollowups(c,g,f,h,S){const k=this.c.get(g);if(!k)return Promise.resolve([]);const y=(0,m.$hi)(c),C=await this.z(k.id,h),T=p.ChatAgentResult.to(f);return(await k.provideFollowups(T,{history:C},S)).filter($=>{const b=!$.participant||R.Iterable.some(this.c.values(),N=>N.id===$.participant&&u.$xn.equals(N.extension.identifier,k.extension.identifier));return b||this.t.warn(`[@${k.id}] ChatFollowup refers to an unknown participant: ${$.participant}`),b}).map($=>p.ChatFollowup.from($,y))}$acceptFeedback(c,g,f){const h=this.c.get(c);if(!h)return;const S=p.ChatAgentResult.to(g);let k;switch(f.direction){case d.ChatAgentVoteDirection.Down:k=r.ChatResultFeedbackKind.Unhelpful;break;case d.ChatAgentVoteDirection.Up:k=r.ChatResultFeedbackKind.Helpful;break}const y={result:S,kind:k,unhelpfulReason:(0,a.$yH)(h.extension,"chatParticipantAdditions")?f.reason:void 0};h.acceptFeedback(Object.freeze(y))}$acceptAction(c,g,f){const h=this.c.get(c);if(!h||f.action.kind==="vote")return;const S=p.ChatAgentUserActionEvent.to(g,f,this.u.converter);S&&h.acceptAction(Object.freeze(S))}async $invokeCompletionProvider(c,g,f){const h=this.c.get(c);if(!h)return[];let S=this.s.get(c);return S?S.clear():(S=new O.$Yc,this.s.set(c,S)),(await h.invokeCompletionProvider(g,f)).map(y=>p.ChatAgentCompletionItem.from(y,this.u.converter,S))}async $provideWelcomeMessage(c,g,f){const h=this.c.get(c);if(h)return await h.provideWelcomeMessage(p.ChatLocation.to(g),f)}async $provideChatTitle(c,g,f){const h=this.c.get(c);if(!h)return;const S=await this.z(h.id,{history:g});return await h.provideTitle({history:S},f)}async $provideSampleQuestions(c,g,f){const h=this.c.get(c);if(h)return(await h.provideSampleQuestions(p.ChatLocation.to(g),f)).map(S=>p.ChatFollowup.from(S,void 0))}}e.$6qc=n;class t{constructor(c,g,f,h,S){this.extension=c,this.id=g,this.w=f,this.x=h,this.y=S,this.l=new L.$qe,this.m=new L.$qe}acceptFeedback(c){this.l.fire(c)}acceptAction(c){this.m.fire(c)}async invokeCompletionProvider(c,g){return this.o?await this.o.provider.provideCompletionItems(c,g)??[]:[]}async provideFollowups(c,g,f){if(!this.b)return[];const h=await this.b.provideFollowups(c,g,f);return h?h.filter(S=>!(S&&"commandId"in S)).filter(S=>!(S&&"message"in S)):[]}async provideWelcomeMessage(c,g){if(!this.q)return[];const f=await this.q.provideWelcomeMessage(c,g);return f?f.map(h=>typeof h=="string"?h:p.MarkdownString.from(h)):[]}async provideTitle(c,g){if(this.s)return await this.s.provideChatTitle(c,g)??void 0}async provideSampleQuestions(c,g){if(!this.q||!this.q.provideSampleQuestions)return[];const f=await this.q.provideSampleQuestions(c,g);return f||[]}get apiAgent(){let c=!1,g=!1;const f=()=>{c||g||(g=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof w.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof r.$$O?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.k,helpTextPrefix:!this.d||typeof this.d=="string"?this.d:p.MarkdownString.from(this.d),helpTextVariablesPrefix:!this.g||typeof this.g=="string"?this.g:p.MarkdownString.from(this.g),helpTextPostfix:!this.j||typeof this.j=="string"?this.j:p.MarkdownString.from(this.j),supportIssueReporting:this.n,requester:this.t,supportsSlowVariables:this.u}),g=!1}))},h=this;return{get id(){return h.id},get iconPath(){return h.c},set iconPath(S){h.c=S,f()},get requestHandler(){return h.y},set requestHandler(S){(0,I.$tg)(typeof S=="function","Invalid request handler"),h.y=S},get followupProvider(){return h.b},set followupProvider(S){h.b=S,f()},get helpTextPrefix(){return(0,a.$zH)(h.extension,"defaultChatParticipant"),h.d},set helpTextPrefix(S){(0,a.$zH)(h.extension,"defaultChatParticipant"),h.d=S,f()},get helpTextVariablesPrefix(){return(0,a.$zH)(h.extension,"defaultChatParticipant"),h.g},set helpTextVariablesPrefix(S){(0,a.$zH)(h.extension,"defaultChatParticipant"),h.g=S,f()},get helpTextPostfix(){return(0,a.$zH)(h.extension,"defaultChatParticipant"),h.j},set helpTextPostfix(S){(0,a.$zH)(h.extension,"defaultChatParticipant"),h.j=S,f()},get isSecondary(){return(0,a.$zH)(h.extension,"defaultChatParticipant"),h.k},set isSecondary(S){(0,a.$zH)(h.extension,"defaultChatParticipant"),h.k=S,f()},get supportIssueReporting(){return(0,a.$zH)(h.extension,"chatParticipantPrivate"),h.n},set supportIssueReporting(S){(0,a.$zH)(h.extension,"chatParticipantPrivate"),h.n=S,f()},get onDidReceiveFeedback(){return h.l.event},set participantVariableProvider(S){if((0,a.$zH)(h.extension,"chatParticipantAdditions"),h.o=S,S){if(!S.triggerCharacters.length)throw new Error("triggerCharacters are required");h.w.$registerAgentCompletionsProvider(h.x,h.id,S.triggerCharacters)}else h.w.$unregisterAgentCompletionsProvider(h.x,h.id)},get participantVariableProvider(){return(0,a.$zH)(h.extension,"chatParticipantAdditions"),h.o},set welcomeMessageProvider(S){(0,a.$zH)(h.extension,"defaultChatParticipant"),h.q=S,f()},get welcomeMessageProvider(){return(0,a.$zH)(h.extension,"defaultChatParticipant"),h.q},set titleProvider(S){(0,a.$zH)(h.extension,"defaultChatParticipant"),h.s=S,f()},get titleProvider(){return(0,a.$zH)(h.extension,"defaultChatParticipant"),h.s},onDidPerformAction:(0,a.$yH)(this.extension,"chatParticipantAdditions")?this.m.event:void 0,set requester(S){h.t=S,f()},get requester(){return h.t},set supportsSlowReferences(S){(0,a.$zH)(h.extension,"chatParticipantPrivate"),h.u=S,f()},get supportsSlowReferences(){return(0,a.$zH)(h.extension,"chatParticipantPrivate"),h.u},dispose(){c=!0,h.b=void 0,h.l.dispose(),h.w.$unregisterAgent(h.x)}}}invoke(c,g,f,h){return this.y(c,g,f,h)}}}),define(Re[233],Te([1,0,12,4,36,5,8,7,21]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=void 0,R=Ve(R),O=Ve(O);class s{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(L.$0N.MainThreadChatVariables)}async $resolveVariable(u,E,p,r){const l=this.b.get(u);if(l)try{if(l.resolver.resolve2){(0,m.$zH)(l.extension,"chatParticipantAdditions");const d=new I(E,this.c),a=await l.resolver.resolve2(l.data.name,{prompt:p},d.apiObject,r);if(a&&a[0])return a[0].value}else{const d=await l.resolver.resolve(l.data.name,{prompt:p},r);if(d&&d[0])return d[0].value}}catch(d){(0,v.$5)(d)}}registerVariableResolver(u,E,p,r,l,d,a,i,n){const t=s.a++,o=n?P.ThemeIcon.fromId(n):void 0;return this.b.set(t,{extension:u,data:{id:E,name:p,description:r,modelDescription:l,icon:o},resolver:a}),this.c.$registerVariable(t,{id:E,name:p,description:r,modelDescription:l,isSlow:d,fullName:i,icon:o}),(0,D.$Xc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$7qc=s;class I{constructor(u,E){this.c=u,this.d=E,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let E=function(r){if(u.a){const l=new Error("Response stream has been closed");throw Error.captureStackTrace(l,r),l}};const u=this,p=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){E(this.progress);const l=new O.$fQ(r),d=R.ChatResponseProgressPart.from(l);return p(d),this},reference(r){E(this.reference);const l=new O.$jQ(r),d=R.ChatResponseReferencePart.from(l);return p(d),this},push(r){return E(this.push),r instanceof O.$jQ?p(R.ChatResponseReferencePart.from(r)):r instanceof O.$fQ&&p(R.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Re[234],Te([1,0,10,71,6,4,38,2,94,18,8,7,5,21]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=p,m=Ve(m),I=Ve(I),w=Ve(w);function p(r,l,d){const a=r.getProxy(u.$0N.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new s.$zn,l.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===R.MarshalledId.CommentController){const C=this.b.get(y.handle);return C?C.value:y}else if(y&&y.$mid===R.MarshalledId.CommentThread){const C=y,T=this.b.get(C.commentControlHandle);if(!T)return C;const $=T.getCommentThread(C.commentThreadHandle);return $?$.value:C}else if(y&&(y.$mid===R.MarshalledId.CommentThreadReply||y.$mid===R.MarshalledId.CommentThreadInstance)){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const T=C.getCommentThread(y.thread.commentThreadHandle);return T?y.$mid===R.MarshalledId.CommentThreadInstance?T.value:{thread:T.value,text:y.text}:y}else if(y&&y.$mid===R.MarshalledId.CommentNode){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const T=C.getCommentThread(y.thread.commentThreadHandle);if(!T)return y;const $=y.commentUniqueId,b=T.getCommentByUniqueId($);return b||y}else if(y&&y.$mid===R.MarshalledId.CommentThreadNode){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const T=C.getCommentThread(y.thread.commentThreadHandle);if(!T)return y;const $=y.text,b=y.commentUniqueId,N=T.getCommentByUniqueId(b);return N?(typeof N.body=="string"?N.body=$:N.body=new w.$DO($),N):y}return y}})}createCommentController(y,C,T){const $=i.a++,b=new t(y,$,C,T);this.b.set(b.handle,b);const N=this.c.get(y.identifier)||[];return N.push(b),this.c.set(y.identifier,N),b.value}async $createCommentThreadTemplate(y,C,T,$){const b=this.b.get(y);b&&b.$createCommentThreadTemplate(C,T,$)}async $setActiveComment(y,C){const T=this.b.get(y);T&&T.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(y,C,T){const $=this.b.get(y);$&&$.$updateCommentThreadTemplate(C,T)}$deleteCommentThread(y,C){this.b.get(y)?.$deleteCommentThread(C)}async $provideCommentingRanges(y,C,T){const $=this.b.get(y);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const b=await d.ensureDocumentData(O.URI.revive(C));return(0,v.$Ch)(async()=>{const N=await $.commentingRangeProvider.provideCommentingRanges(b.document,T);let A;return Array.isArray(N)?A={ranges:N,fileComments:!1}:N?A={ranges:N.ranges||[],fileComments:N.enableFileComments||!1}:A=N??void 0,A}).then(N=>{let A;return N&&(A={ranges:N.ranges.map(F=>I.Range.from(F)),fileComments:N.fileComments}),A})}$toggleReaction(y,C,T,$,b){const N=this.b.get(y);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,v.$Ch)(()=>{const A=N.getCommentThread(C);if(A){const F=A.getCommentByUniqueId($.uniqueIdInThread);if(N!==void 0&&F&&N.reactionHandler)return N.reactionHandler(F,g(b))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,E.$zH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,C,T,$,b,N,A,F,G){this.m=C,this.n=T,this.o=$,this.p=b,this.q=N,this.extensionDescription=A,this.r=F,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$qe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$1c,this.l.value=new L.$Yc,this.n===void 0&&(this.n=`${y}.${this.handle}`),a.$createCommentThread(C,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(j=>o(this,j,this.k,this.extensionDescription)),A.identifier,this.r,G),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{a.$deleteCommentThread(C,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(j){x.range=j},get comments(){return x.comments},set comments(j){x.comments=j},get collapsibleState(){return x.collapsibleState},set collapsibleState(j){x.collapsibleState=j},get canReply(){return x.canReply},set canReply(j){x.canReply=j},get contextValue(){return x.contextValue},set contextValue(j){x.contextValue=j},get label(){return x.label},set label(j){x.label=j},get state(){return x.state},set state(j){x.state=j},reveal:(j,U)=>x.reveal(j,U),hide:()=>x.hide(),dispose:()=>{x.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Yc);const y=T=>Object.prototype.hasOwnProperty.call(this.b,T),C={};y("range")&&(C.range=I.Range.from(this.p)),y("label")&&(C.label=this.label),y("contextValue")&&(C.contextValue=this.contextValue??null),y("comments")&&(C.comments=this.q.map(T=>o(this,T,this.k,this.extensionDescription))),y("collapsibleState")&&(C.collapseState=f(this.g)),y("canReply")&&(C.canReply=this.canReply),y("state")&&(C.state=h(this.h)),y("applicability")&&(C.applicability=S(this.h)),y("isTemplate")&&(C.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(y){for(const C of this.k){const T=C[0],$=C[1];if(y===$)return T}}async reveal(y,C){(0,E.$zH)(this.extensionDescription,"commentReveal");let T;y&&y.body!==void 0?T=y:C=C??y;let $=T?this.k.get(T):void 0;$??=this.k.get(this.q[0]);let b=!0,N=!1;return C?.focus===w.CommentThreadFocus.Reply?(N=!0,b=!1):C?.focus===w.CommentThreadFocus.Comment&&(b=!1),a.$revealCommentThread(this.m,this.handle,$,{preserveFocus:b,focusReply:N})}async hide(){return a.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}He([(0,D.$di)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,E.$zH)(this.h,"commentingRangeHint"),a.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,E.$zH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,E.$zH)(this.h,"activeComment"),this.f?.value}constructor(y,C,T,$){this.h=y,this.i=C,this.j=T,this.k=$,this.a=new Map,a.$registerCommentController(this.handle,T,$,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(N){b.options=N},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(N){b.commentingRangeProvider=N},get reactionHandler(){return b.reactionHandler},set reactionHandler(N){b.reactionHandler=N},get activeCommentThread(){return b.activeCommentThread},createCommentThread(N,A,F){return b.createCommentThread(N,A,F).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(y,C,T){C===void 0&&(0,E.$zH)(this.h,"fileComments");const $=new n(this.id,this.handle,void 0,y,C,T,this.h,!1);return this.a.set($.handle,$),$}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const C=this.a.get(y.commentThreadHandle);C&&(this.e=y.uniqueIdInThread?C.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=C)}$createCommentThreadTemplate(y,C,T){const $=new n(this.id,this.handle,void 0,O.URI.revive(y),I.Range.to(C),[],this.h,!0,T);return $.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set($.handle,$),$}$updateCommentThreadTemplate(y,C){const T=this.a.get(y);T&&(T.range=I.Range.to(C))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function o(k,y,C,T){let $=C.get(y);return $||($=++k.commentHandle,C.set(y,$)),y.state!==void 0&&(0,E.$zH)(T,"commentsDraftState"),y.reactions?.some(b=>b.reactors!==void 0)&&(0,E.$zH)(T,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:$,body:typeof y.body=="string"?y.body:I.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(b=>c(b)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function c(k){return{label:k.label,iconPath:k.iconPath?I.$JQ(k.iconPath):void 0,count:k.count,hasReacted:k.authorHasReacted,reactors:k.reactors&&k.reactors.length>0&&typeof k.reactors[0]!="string"?k.reactors.map(y=>y.name):k.reactors}}function g(k){return{label:k.label||"",count:k.count||0,iconPath:k.iconPath?O.URI.revive(k.iconPath):"",authorHasReacted:k.hasReacted||!1,reactors:k.reactors?.map(y=>({name:y}))}}function f(k){if(k!==void 0)switch(k){case w.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case w.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function h(k){let y;if(typeof k=="object"?y=k.resolved:y=k,y!==void 0)switch(y){case w.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case w.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}function S(k){let y;if(typeof k=="object"&&(y=k.applicability),y!==void 0)switch(y){case w.CommentThreadApplicability.Current:return m.CommentThreadApplicability.Current;case w.CommentThreadApplicability.Outdated:return m.CommentThreadApplicability.Outdated}return m.CommentThreadApplicability.Current}return new i}}),define(Re[235],Te([1,0,19,76,4,15,24,2,8,67,80,5,7]),function(we,e,v,D,P,L,R,O,m,s,I,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qrc=void 0,m=Ve(m),w=Ve(w),u=Ve(u);class E{constructor(c,g){this.document=c,this.b=g,this.a=1,this.c=new I.$Qqc("custom documents")}addEdit(c){return this.c.add([c])}async undo(c,g){await this.f(c).undo(),g||this.disposeBackup()}async redo(c,g){await this.f(c).redo(),g||this.disposeBackup()}disposeEdits(c){for(const g of c)this.c.delete(g)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const c=t(this.document.uri)+this.a++;return(0,R.$lh)(this.b,c)}updateBackup(c){this.d?.delete(),this.d=c}disposeBackup(){this.d?.delete(),this.d=void 0}f(c){const g=this.c.get(c,0);if(!g)throw new Error("No edit found");return g}}class p{constructor(){this.a=new Map}get(c,g){return this.a.get(this.b(c,g))}add(c,g,f){const h=this.b(c,g.uri);if(this.a.has(h))throw new Error(`Document already exists for viewType:${c} resource:${g.uri}`);const S=new E(g,f);return this.a.set(h,S),S}delete(c,g){const f=this.b(c,g.uri);this.a.delete(f)}b(c,g){return`${c}@@@${g}`}}var r;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(r||(r={}));class l{constructor(){this.a=new Map}addTextProvider(c,g,f){return this.b(c,{type:r.Text,extension:g,provider:f})}addCustomProvider(c,g,f){return this.b(c,{type:r.Custom,extension:g,provider:f})}get(c){return this.a.get(c)}b(c,g){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,g),new u.$_N(()=>this.a.delete(c))}}class d{constructor(c,g,f,h,S){this.d=g,this.f=f,this.g=h,this.h=S,this.b=new l,this.c=new p,this.a=c.getProxy(w.$0N.MainThreadCustomEditors)}registerCustomEditorProvider(c,g,f,h){const S=new P.$Yc;return i(f)?(S.add(this.b.addTextProvider(g,c,f)),this.a.$registerTextEditorProvider((0,s.$nrc)(c),g,h.webviewOptions||{},{supportsMove:!!f.moveCustomTextEditor},(0,s.$lrc)(c))):(S.add(this.b.addCustomProvider(g,c,f)),a(f)&&S.add(f.onDidChangeCustomDocument(k=>{const y=this.i(g,k.document.uri);if(n(k)){const C=y.addEdit(k);this.a.$onDidEdit(k.document.uri,g,C,k.label)}else this.a.$onContentChange(k.document.uri,g)})),this.a.$registerCustomEditorProvider((0,s.$nrc)(c),g,h.webviewOptions||{},!!h.supportsMultipleEditorsPerDocument,(0,s.$lrc)(c))),u.$_N.from(S,new u.$_N(()=>{this.a.$unregisterEditorProvider(g)}))}async $createCustomDocument(c,g,f,h,S){const k=this.b.get(g);if(!k)throw new Error(`No provider found for '${g}'`);if(k.type!==r.Custom)throw new Error(`Invalid provide type for '${g}'`);const y=O.URI.revive(c),C=await k.provider.openCustomDocument(y,{backupId:f,untitledDocumentData:h?.buffer},S);let T;return a(k.provider)&&this.f&&(T=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(g,C,T),{editable:a(k.provider)}}async $disposeCustomDocument(c,g){const f=this.b.get(g);if(!f)throw new Error(`No provider found for '${g}'`);if(f.type!==r.Custom)throw new Error(`Invalid provider type for '${g}'`);const h=O.URI.revive(c),{document:S}=this.i(g,h);this.c.delete(g,S),S.dispose()}async $resolveCustomEditor(c,g,f,h,S,k){const y=this.b.get(f);if(!y)throw new Error(`No provider found for '${f}'`);const C=m.ViewColumn.to(S),T=this.g.createNewWebview(g,h.contentOptions,y.extension),$=this.h.createNewWebviewPanel(g,f,h.title,C,h.options,T,h.active),b=O.URI.revive(c);switch(y.type){case r.Custom:{const{document:N}=this.i(f,b);return y.provider.resolveCustomEditor(N,$,k)}case r.Text:{const N=this.d.getDocument(b);return y.provider.resolveCustomTextEditor(N,$,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,g,f){this.i(g,c).disposeEdits(f)}async $onMoveCustomEditor(c,g,f){const h=this.b.get(f);if(!h)throw new Error(`No provider found for '${f}'`);if(!h.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${f}'`);const S=this.h.getWebviewPanel(c);if(!S)throw new Error("No webview found");const k=O.URI.revive(g),y=this.d.getDocument(k);await h.provider.moveCustomTextEditor(y,S,v.CancellationToken.None)}async $undo(c,g,f,h){return this.i(g,c).undo(f,h)}async $redo(c,g,f,h){return this.i(g,c).redo(f,h)}async $revert(c,g,f){const h=this.i(g,c);await this.j(g).revertCustomDocument(h.document,f),h.disposeBackup()}async $onSave(c,g,f){const h=this.i(g,c);await this.j(g).saveCustomDocument(h.document,f),h.disposeBackup()}async $onSaveAs(c,g,f,h){const S=this.i(g,c);return this.j(g).saveCustomDocumentAs(S.document,O.URI.revive(f),h)}async $backup(c,g,f){const h=this.i(g,c),k=await this.j(g).backupCustomDocument(h.document,{destination:h.getNewBackupUri()},f);return h.updateBackup(k),k.id}i(c,g){const f=this.c.get(c,O.URI.revive(g));if(!f)throw new Error("No custom document found");return f}j(c){const f=this.b.get(c)?.provider;if(!f||!a(f))throw new Error("Custom document is not editable");return f}}e.$qrc=d;function a(o){return!!o.onDidChangeCustomDocument}function i(o){return typeof o.resolveCustomTextEditor=="function"}function n(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function t(o){const c=o.scheme===L.Schemas.file||o.scheme===L.Schemas.untitled?o.fsPath:o.toString();return(0,D.$yj)(c)+""}}),define(Re[236],Te([1,0,9,108,2,5,7,8,6,11,27,50]),function(we,e,v,D,P,L,R,O,m,s,I,w){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yqc=e.$Xqc=void 0,O=Ve(O);class E{#e;#t;#i;constructor(l,d,a,i,n,t,o,c){this.d=l,this.e=d,this.f=a,this.g=i,this.h=n,this.c=!1,this.f=Math.max(i,a),this.#i=new I.$Fc(g=>t.getComparisonKey(g)),this.#e=o,this.#t=c}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(l,d){if(!l){this.clear();return}this.j();let a=[];if(P.URI.isUri(l)){if(!d){this.delete(l);return}this.#i.set(l,d.slice()),a=[l]}else if(Array.isArray(l)){a=[];let t;l=[...l].sort(E.k);for(const o of l){const[c,g]=o;if((!t||c.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=c,a.push(c),this.#i.set(c,[])),g)this.#i.get(c)?.push(...g);else{const f=this.#i.get(c);f&&(f.length=0)}}}if(this.#t.fire(a),!this.#e)return;const i=[];let n=0;for(const t of a){let o=[];const c=this.#i.get(t);if(c)if(c.length>this.g){o=[];const g=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const h of c)if(h.severity===g[f]&&o.push({...O.Diagnostic.from(h),modelVersionId:this.h(t)})===this.g)break e;o.push({severity:D.MarkerSeverity.Info,message:(0,v.localize)(2700,null,c.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=c.map(g=>({...O.Diagnostic.from(g),modelVersionId:this.h(t)}));if(i.push([t,o]),n+=o.length,n>this.f)break}this.#e.$changeMany(this.e,i)}delete(l){this.j(),this.#t.fire([l]),this.#i.delete(l),this.#e?.$changeMany(this.e,[[l,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(l,d){this.j();for(const[a,i]of this)l.call(d,a,i,this)}*[Symbol.iterator](){this.j();for(const l of this.#i.keys())yield[l,this.get(l)]}get(l){this.j();const d=this.#i.get(l);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(l){return this.j(),Array.isArray(this.#i.get(l))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(l,d){return l[0].toString()<d[0].toString()?-1:l[0].toString()>d[0].toString()?1:0}}e.$Xqc=E;let p=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(l){const d=new I.$Fc;for(const a of l)d.set(a,a);return{uris:Object.freeze(Array.from(d.values()))}}constructor(l,d,a,i){this.j=d,this.k=a,this.l=i,this.g=new Map,this.h=new m.$ue({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,u._mapper),this.f=l.getProxy(L.$0N.MainThreadDiagnostics)}createDiagnosticCollection(l,d){const{g:a,f:i,h:n,j:t,k:o,l:c}=this,g=new class{$changeMany(S,k){i.$changeMany(S,k),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,S,k.length===0?"CLEARING":k)}$clear(S){i.$clear(S),t.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,S)}dispose(){i.dispose()}};let f;if(!d)d="_generated_diagnostic_collection_name_#"+u.c++,f=d;else if(!a.has(d))f=d;else{this.j.warn(`DiagnosticCollection with name '${d}' does already exist.`);do f=d+u.c++;while(a.has(f))}return new class extends E{constructor(){super(d,f,u.e,u.d,S=>c.getDocument(S)?.version,o.extUri,g,n),a.set(f,this)}dispose(){super.dispose(),a.delete(f)}}}getDiagnostics(l){if(l)return this.m(l);{const d=new Map,a=[];for(const i of this.g.values())i.forEach((n,t)=>{let o=d.get(n.toString());typeof o>"u"&&(o=a.length,d.set(n.toString(),o),a.push([n,[]])),a[o][1]=a[o][1].concat(...t)});return a}}m(l){let d=[];for(const a of this.g.values())a.has(l)&&(d=d.concat(a.get(l)));return d}$acceptMarkersChange(l){if(!this.n){const d="_generated_mirror",a=new E(d,d,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(d,a),this.n=a}for(const[d,a]of l)this.n.set(P.URI.revive(d),a.map(O.Diagnostic.to))}};e.$Yqc=p,e.$Yqc=p=u=He([qe(1,s.$fk),qe(2,w.$Wqc)],p)}),define(Re[237],Te([1,0,2,12,7,8,171,39]),function(we,e,v,D,P,L,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_rc=void 0;class m{constructor(I,w,u,E={timeout:1500,errors:3}){this.c=I,this.d=w,this.f=u,this.g=E,this.a=new R.$0c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(w,u,E)=>{const r={dispose:this.a.push([w,u,I])};return Array.isArray(E)&&E.push(r),r}}async $participateInSave(I,w){const u=v.URI.revive(I);let E=!1;const p=setTimeout(()=>E=!0,this.g.timeout),r=[];try{for(const l of[...this.a]){if(E)break;const d=this.d.getDocument(u),a=await this.h(l,{document:d,reason:L.TextDocumentSaveReason.to(w)});r.push(a)}}finally{clearTimeout(p)}return r}h([I,w,u],E){const p=this.b.get(I);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(u,I,w,E).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const l=this.b.get(I);this.b.set(I,l?l+1:1),typeof l=="number"&&l>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,w,u,E){const p=[],r=Date.now(),{document:l,reason:d}=E,{version:a}=l,i=Object.freeze({document:l,reason:d,waitUntil(n){if(Object.isFrozen(p))throw(0,D.$_)("waitUntil can not be called async");p.push(Promise.resolve(n))}});try{w.apply(u,[i])}catch(n){return Promise.reject(n)}return Object.freeze(p),new Promise((n,t)=>{const o=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(p).then(c=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(o),n(c)}).catch(c=>{clearTimeout(o),t(c)})}).then(n=>{const t={edits:[]};for(const o of n)if(Array.isArray(o)&&o.every(c=>c instanceof P.$iO))for(const{newText:c,newEol:g,range:f}of o)t.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:f&&L.Range.from(f),text:c,eol:g&&L.EndOfLine.from(g)}});if(t.edits.length!==0)return a===l.version?this.f.$tryApplyWorkspaceEdit(new O.$7w(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$_rc=m}),define(Re[238],Te([1,0,6,4,2,5,125,8,14,25,7]),function(we,e,v,D,P,L,R,O,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zqc=void 0,O=Ve(O);class w{constructor(E,p){this.a=new v.$qe,this.b=new v.$qe,this.c=new v.$qe,this.d=new v.$qe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new D.$Yc,this.h=new Map,this.f=E.getProxy(L.$0N.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(r=>{for(const l of r)this.b.fire(l.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const l of r)this.a.fire(l.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const p=this.g.getDocument(E);if(p)return p}getDocument(E){const p=this.getDocumentData(E);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return p.document}ensureDocumentData(E){const p=this.g.getDocument(E);if(p)return Promise.resolve(p);let r=this.h.get(E.toString());return r||(r=this.f.$tryOpenDocument(E).then(l=>{this.h.delete(E.toString());const d=P.URI.revive(l);return(0,m.$ug)(this.g.getDocument(d))},l=>(this.h.delete(E.toString()),Promise.reject(l))),this.h.set(E.toString(),r)),r}createDocumentData(E){return this.f.$tryCreateDocument(E).then(p=>P.URI.revive(p))}$acceptModelLanguageChanged(E,p){const r=P.URI.revive(E),l=this.g.getDocument(r);if(!l)throw new Error("unknown document");this.b.fire(l.document),l._acceptLanguageId(p),this.a.fire(l.document)}$acceptModelSaved(E){const p=P.URI.revive(E),r=this.g.getDocument(p);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(E,p){const r=P.URI.revive(E),l=this.g.getDocument(r);if(!l)throw new Error("unknown document");l._acceptIsDirty(p),this.c.fire({document:l.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,p,r){const l=P.URI.revive(E),d=this.g.getDocument(l);if(!d)throw new Error("unknown document");d._acceptIsDirty(r),d.onEvents(p);let a;p.isUndoing?a=I.TextDocumentChangeReason.Undo:p.isRedoing&&(a=I.TextDocumentChangeReason.Redo),this.c.fire((0,s.$lo)({document:d.document,contentChanges:p.changes.map(i=>({range:O.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:a}))}setWordDefinitionFor(E,p){(0,R.$MQ)(E,p)}}e.$Zqc=w}),define(Re[70],Te([1,0,239,6,14,2,3,5,16,8,7]),function(we,e,v,D,P,L,R,O,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$src=e.$rrc=void 0,s=Ve(s),e.$rrc=(0,R.$Ki)("IExtHostEditorTabs");class w{constructor(l,d,a){this.e=a,this.d=d,this.acceptDtoUpdate(l)}get apiObject(){if(!this.a){const l=this,d={get isActive(){return l.b.id===l.e()},get label(){return l.b.label},get input(){return l.c},get isDirty(){return l.b.isDirty},get isPinned(){return l.b.isPinned},get isPreview(){return l.b.isPreview},get group(){return l.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(l){this.b=l,this.c=this.f()}f(){switch(this.b.input.kind){case O.TabInputKind.TextInput:return new I.$ZP(L.URI.revive(this.b.input.uri));case O.TabInputKind.TextDiffInput:return new I.$1P(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case O.TabInputKind.TextMergeInput:return new I.$2P(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case O.TabInputKind.CustomEditorInput:return new I.$3P(L.URI.revive(this.b.input.uri),this.b.input.viewType);case O.TabInputKind.WebviewEditorInput:return new I.$4P(this.b.input.viewType);case O.TabInputKind.NotebookInput:return new I.$5P(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case O.TabInputKind.NotebookDiffInput:return new I.$6P(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case O.TabInputKind.TerminalEditorInput:return new I.$7P;case O.TabInputKind.InteractiveEditorInput:return new I.$8P(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case O.TabInputKind.ChatEditorInput:return new I.$9P;case O.TabInputKind.MultiDiffEditorInput:return new I.$0P(this.b.input.diffEditors.map(l=>new I.$1P(L.URI.revive(l.original),L.URI.revive(l.modified))));default:return}}}class u{constructor(l,d){this.c=[],this.d="",this.b=l,this.e=d;for(const a of l.tabs)a.isActive&&(this.d=a.id),this.c.push(new w(a,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const l=this,d={get isActive(){return l.b.groupId===l.e()},get viewColumn(){return s.ViewColumn.to(l.b.viewColumn)},get activeTab(){return l.c.find(a=>a.tabId===l.d)?.apiObject},get tabs(){return Object.freeze(l.c.map(a=>a.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(l){this.b=l}acceptTabOperation(l){if(l.kind===O.TabModelOperationKind.TAB_OPEN){const a=new w(l.tabDto,this,()=>this.activeTabId());return this.c.splice(l.index,0,a),l.tabDto.isActive&&(this.d=a.tabId),a}else if(l.kind===O.TabModelOperationKind.TAB_CLOSE){const a=this.c.splice(l.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${l.index} which does not exist`);return a.tabId===this.d&&(this.d=""),a}else if(l.kind===O.TabModelOperationKind.TAB_MOVE){if(l.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this.c.splice(l.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${l.oldIndex} which does not exist`);return this.c.splice(l.index,0,a),a}const d=this.c.find(a=>a.tabId===l.tabDto.id);if(!d)throw new Error("INVALID tab");return l.tabDto.isActive?this.d=l.tabDto.id:this.d===l.tabDto.id&&!l.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(l.tabDto),d}activeTabId(){return this.d}}let E=class{constructor(l){this.b=new D.$qe,this.c=new D.$qe,this.e=[],this.a=l.getProxy(O.$0N.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const l=this,d={onDidChangeTabGroups:l.c.event,onDidChangeTabs:l.b.event,get all(){return Object.freeze(l.e.map(a=>a.apiObject))},get activeTabGroup(){const a=l.d;return(0,P.$ug)(l.e.find(n=>n.groupId===a)?.apiObject)},close:async(a,i)=>{const n=Array.isArray(a)?a:[a];return n.length?p(n[0])?this.j(n,i):this.i(n,i):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(l){const d=new Set(this.e.map(g=>g.groupId)),a=new Set(l.map(g=>g.groupId)),i=(0,v.$f)(d,a),n=this.e.filter(g=>i.removed.includes(g.groupId)).map(g=>g.apiObject),t=[],o=[];this.e=l.map(g=>{const f=new u(g,()=>this.d);return i.added.includes(f.groupId)?t.push(f.apiObject):o.push(f.apiObject),f});const c=(0,P.$ug)(l.find(g=>g.isActive===!0)?.groupId);c!==void 0&&this.d!==c&&(this.d=c),this.c.fire(Object.freeze({opened:t,closed:n,changed:o}))}$acceptTabGroupUpdate(l){const d=this.e.find(a=>a.groupId===l.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(l),l.isActive&&(this.d=l.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(l){const d=this.e.find(i=>i.groupId===l.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const a=d.acceptTabOperation(l);switch(l.kind){case O.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case O.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case O.TabModelOperationKind.TAB_MOVE:case O.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}g(l){for(const d of this.e)for(const a of d.tabs)if(a.apiObject===l)return a}h(l){return this.e.find(d=>d.apiObject===l)}async i(l,d){const a=[];for(const i of l){const n=this.g(i);if(!n)throw new Error("Tab close: Invalid tab not found!");a.push(n.tabId)}return this.a.$closeTab(a,d)}async j(l,d){const a=[];for(const i of l){const n=this.h(i);if(!n)throw new Error("Group close: Invalid group not found!");a.push(n.groupId)}return this.a.$closeGroup(a,d)}};e.$src=E,e.$src=E=He([qe(0,m.$KQ)],E);function p(r){return r.tabs!==void 0}}),define(Re[240],Te([1,0,2,5,28,4,7,8,285,13,30,20,21,59]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$csc=void 0,P=Ve(P),O=Ve(O);class p{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const a=this.a.indexOf(d);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),a=[];let i,n,t=m.State.LastKnownState,o=m.State.LastKnownState;for(const c of d){let g=i?(0,s.$Mf)(i,c):0;for(g===0?n=m.State.Start:n=o;g<c.length;g++)g+1===c.length?(t=o,o=m.State.BeforeColon):o+=1,a.push([n,c.toUpperCase().charCodeAt(g),o]),a.push([n,c.toLowerCase().charCodeAt(g),o]),n=o;i=c,o=t}a.push([m.State.BeforeColon,I.CharCode.Colon,m.State.AfterColon]),a.push([m.State.AfterColon,I.CharCode.Slash,m.State.End]),this.b=new m.$04(a)}}provideDocumentLinks(d){this.c();const a=[],i=m.$$4.computeLinks({getLineContent(n){return d.lineAt(n-1).text},getLineCount(){return d.lineCount}},this.b);for(const n of i){const t=O.DocumentLink.to(n);t.target&&a.push(t)}return a}}class r{constructor(d,a){this.i=a,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(D.$0N.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,a,i,n={}){if(r.j(i),this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const t=this.h++;this.b.add(a),this.d.add(a),this.c.set(t,i);let o=P.FileSystemProviderCapabilities.FileReadWrite;n.isCaseSensitive&&(o+=P.FileSystemProviderCapabilities.PathCaseSensitive),n.isReadonly&&(o+=P.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(o+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$zH)(d,"fsChunks"),o+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let c;n.isReadonly&&(0,E.$$k)(n.isReadonly)&&n.isReadonly.value!==""&&(c={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,a,o,c).catch(f=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${a}`),console.error(f)});const g=i.onDidChangeFile(f=>{const h=[];for(const S of f){const{uri:k,type:y}=S;if(k.scheme!==a)continue;let C;switch(y){case R.FileChangeType.Changed:C=P.FileChangeType.UPDATED;break;case R.FileChangeType.Created:C=P.FileChangeType.ADDED;break;case R.FileChangeType.Deleted:C=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:k,type:C})}this.a.$onFileSystemChange(t,h)});return(0,L.$Xc)(()=>{g.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:a,ctime:i,mtime:n,size:t,permissions:o}=d;return{type:a,ctime:i,mtime:n,size:t,permissions:o}}$stat(d,a){return Promise.resolve(this.l(d).stat(v.URI.revive(a))).then(i=>r.k(i))}$readdir(d,a){return Promise.resolve(this.l(d).readDirectory(v.URI.revive(a)))}$readFile(d,a){return Promise.resolve(this.l(d).readFile(v.URI.revive(a))).then(i=>w.$Se.wrap(i))}$writeFile(d,a,i,n){return Promise.resolve(this.l(d).writeFile(v.URI.revive(a),i.buffer,n))}$delete(d,a,i){return Promise.resolve(this.l(d).delete(v.URI.revive(a),i))}$rename(d,a,i,n){return Promise.resolve(this.l(d).rename(v.URI.revive(a),v.URI.revive(i),n))}$copy(d,a,i,n){const t=this.l(d);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(v.URI.revive(a),v.URI.revive(i),n))}$mkdir(d,a){return Promise.resolve(this.l(d).createDirectory(v.URI.revive(a)))}$watch(d,a,i,n){const t=this.l(d).watch(v.URI.revive(i),n);this.f.set(a,t)}$unwatch(d,a){const i=this.f.get(a);i&&(i.dispose(),this.f.delete(a))}$open(d,a,i){const n=this.l(d);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(v.URI.revive(a),i))}$close(d,a){const i=this.l(d);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(a))}$read(d,a,i,n){const t=this.l(d);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const o=w.$Se.alloc(n);return Promise.resolve(t.read(a,i,o.buffer,0,n)).then(c=>o.slice(0,c))}$write(d,a,i,n){const t=this.l(d);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(a,i,n.buffer,0,n.byteLength))}l(d){const a=this.c.get(d);if(!a){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return a}}e.$csc=r}),define(Re[241],Te([1,0,6,43,2,5,8,7,28,51]),function(we,e,v,D,P,L,R,O,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dsc=void 0,R=Ve(R);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,r,l,d,a,i){this.a=Math.random(),this.b=new v.$qe,this.c=new v.$qe,this.d=new v.$qe,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,D.$Fk)(a),t=typeof a=="string",o=i?.correlate,c=d(g=>{if(!(typeof g.session=="number"&&g.session!==this.a)&&!(o&&typeof g.session>"u")){if(!i?.ignoreCreateEvents)for(const f of g.created){const h=P.URI.revive(f);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.b.fire(h)}if(!i?.ignoreChangeEvents)for(const f of g.changed){const h=P.URI.revive(f);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.c.fire(h)}if(!i?.ignoreDeleteEvents)for(const f of g.deleted){const h=P.URI.revive(f);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=O.$_N.from(this.i(p,l,a,i,i?.correlate),this.b,this.c,this.d,c)}i(p,r,l,d,a){const i=O.$_N.from();if(typeof l=="string"||d?.ignoreChangeEvents&&d?.ignoreCreateEvents&&d?.ignoreDeleteEvents)return i;const n=p.getProxy(L.$0N.MainThreadFileSystemEventService);let t=!1;(l.pattern.includes(D.$Bk)||l.pattern.includes(D.$Ck))&&(t=!0);let o;return a&&(d?.ignoreChangeEvents||d?.ignoreCreateEvents||d?.ignoreDeleteEvents)&&(o=m.FileChangeFilter.UPDATED|m.FileChangeFilter.ADDED|m.FileChangeFilter.DELETED,d?.ignoreChangeEvents&&(o&=~m.FileChangeFilter.UPDATED),d?.ignoreCreateEvents&&(o&=~m.FileChangeFilter.ADDED),d?.ignoreDeleteEvents&&(o&=~m.FileChangeFilter.DELETED)),n.$watch(r.identifier.value,this.a,l.baseUri,{recursive:t,excludes:d?.excludes??[],filter:o},!!a),O.$_N.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class w{constructor(p){this.a=p,this.session=this.a.session,this.b=new s.$Y(()=>this.a.created.map(P.URI.revive)),this.c=new s.$Y(()=>this.a.changed.map(P.URI.revive)),this.d=new s.$Y(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(p,r,l){this.j=p,this.k=r,this.l=l,this.a=new v.$qe,this.b=new v.$qe,this.c=new v.$qe,this.d=new v.$qe,this.g=new v.$se,this.h=new v.$se,this.i=new v.$se,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,r,l,d){return new I(this.j,p,r,this.a.event,R.GlobPattern.from(l),d)}$onFileEvent(p){this.a.fire(new w(p))}$onDidRunFileOperation(p,r){switch(p){case m.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(l=>({oldUri:P.URI.revive(l.source),newUri:P.URI.revive(l.target)}))}));break;case m.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(l=>P.URI.revive(l.target))}));break;case m.FileOperation.CREATE:case m.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(l=>P.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,r){return(l,d,a)=>{const i=function(t){l.call(d,t)};return i.extension=p,r.event(i,void 0,a)}}async $onWillRunFileOperation(p,r,l,d){switch(p){case m.FileOperation.MOVE:return await this.n(this.g,{files:r.map(a=>({oldUri:P.URI.revive(a.source),newUri:P.URI.revive(a.target)}))},l,d);case m.FileOperation.DELETE:return await this.n(this.i,{files:r.map(a=>P.URI.revive(a.target))},l,d);case m.FileOperation.CREATE:case m.FileOperation.COPY:return await this.n(this.h,{files:r.map(a=>P.URI.revive(a.target))},l,d)}}async n(p,r,l,d){const a=new Set,i=[];if(await p.fireAsync(r,d,async(t,o)=>{const c=Date.now(),g=await Promise.resolve(t);g instanceof O.$lO&&(i.push([o.extension,g]),a.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-c>l&&this.k.warn("SLOW file-participant",o.extension.identifier)}),d.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,t]of i){const{edits:o}=R.WorkspaceEdit.from(t,{getTextDocumentVersion:c=>this.l.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(o)}return{edit:n,extensionNames:Array.from(a)}}}e.$dsc=u}),define(Re[242],Te([1,0,17,10,19,12,97,4,25,69,13,14,2,32,286,94,104,9,18,8,7,21,80,5]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i,n,t,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1qc=void 0,r=Ve(r),i=Ve(i),c=Ve(c);class g{constructor(W,B){this.d=W,this.e=B}async provideDocumentSymbols(W,B){const Q=this.d.getDocument(W),H=await this.e.provideDocumentSymbols(Q,B);if(!(0,v.$Ob)(H))return H[0]instanceof n.$vO?H.map(i.DocumentSymbol.from):g.f(H)}static f(W){W=W.slice(0).sort((H,se)=>{let ge=H.location.range.start.compareTo(se.location.range.start);return ge===0&&(ge=se.location.range.end.compareTo(H.location.range.end)),ge});const B=[],Q=[];for(const H of W){const se={name:H.name||"!!MISSING: name!!",kind:i.SymbolKind.from(H.kind),tags:H.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:i.Range.from(H.location.range),selectionRange:i.Range.from(H.location.range),children:[]};for(;;){if(Q.length===0){Q.push(se),B.push(se);break}const ge=Q[Q.length-1];if(E.$Wt.containsRange(ge.range,se.range)&&!E.$Wt.equalsRange(ge.range,se.range)){ge.children?.push(se),Q.push(se);break}Q.pop()}}return B}}class f{constructor(W,B,Q,H,se,ge){this.f=W,this.g=B,this.h=Q,this.j=H,this.k=se,this.l=ge,this.d=new o.$Qqc("CodeLens"),this.e=new Map}async provideCodeLenses(W,B){const Q=this.f.getDocument(W),H=await this.h.provideCodeLenses(Q,B);if(!H||B.isCancellationRequested)return;const se=this.d.add(H),ge=new O.$Yc;this.e.set(se,ge);const Ee={cacheId:se,lenses:[]};for(let ze=0;ze<H.length;ze++)Ee.lenses.push({cacheId:[se,ze],range:i.Range.from(H[ze].range),command:this.g.toInternal(H[ze].command,ge)});return Ee}async resolveCodeLens(W,B){const Q=W.cacheId&&this.d.get(...W.cacheId);if(!Q)return;let H;if(typeof this.h.resolveCodeLens!="function"||Q.isResolved?H=Q:H=await this.h.resolveCodeLens(Q,B),H||(H=Q),B.isCancellationRequested)return;const se=W.cacheId&&this.e.get(W.cacheId[0]);if(se){if(!H.command){const ge=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ge),this.l.error(ge);return}return W.command=this.g.toInternal(H.command,se),W}}releaseCodeLenses(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}}function h(Ne){return Array.isArray(Ne)?Ne.map(i.DefinitionLink.from):Ne?[i.DefinitionLink.from(Ne)]:[]}class S{constructor(W,B){this.d=W,this.e=B}async provideDefinition(W,B,Q){const H=this.d.getDocument(W),se=i.Position.to(B),ge=await this.e.provideDefinition(H,se,Q);return h(ge)}}class k{constructor(W,B){this.d=W,this.e=B}async provideDeclaration(W,B,Q){const H=this.d.getDocument(W),se=i.Position.to(B),ge=await this.e.provideDeclaration(H,se,Q);return h(ge)}}class y{constructor(W,B){this.d=W,this.e=B}async provideImplementation(W,B,Q){const H=this.d.getDocument(W),se=i.Position.to(B),ge=await this.e.provideImplementation(H,se,Q);return h(ge)}}class C{constructor(W,B){this.d=W,this.e=B}async provideTypeDefinition(W,B,Q){const H=this.d.getDocument(W),se=i.Position.to(B),ge=await this.e.provideTypeDefinition(H,se,Q);return h(ge)}}class T{static{this.f=10}constructor(W,B){this.g=W,this.h=B,this.d=0,this.e=new Map}async provideHover(W,B,Q,H){const se=this.g.getDocument(W),ge=i.Position.to(B);let Ee;if(Q&&Q.verbosityRequest){const tt=Q.verbosityRequest.previousHover.id,ct=this.e.get(tt);if(!ct)throw new Error(`Hover with id ${tt} not found`);const it={verbosityDelta:Q.verbosityRequest.verbosityDelta,previousHover:ct};Ee=await this.h.provideHover(se,ge,H,it)}else Ee=await this.h.provideHover(se,ge,H);if(!Ee||(0,v.$Ob)(Ee.contents))return;Ee.range||(Ee.range=se.getWordRangeAtPosition(ge)),Ee.range||(Ee.range=new n.$bO(ge,ge));const ze=i.Hover.from(Ee),Je=this.d;if(this.e.size===T.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Je,Ee),this.d+=1,{...ze,id:Je}}releaseHover(W){this.e.delete(W)}}class ${constructor(W,B){this.d=W,this.e=B}async provideEvaluatableExpression(W,B,Q){const H=this.d.getDocument(W),se=i.Position.to(B),ge=await this.e.provideEvaluatableExpression(H,se,Q);if(ge)return i.EvaluatableExpression.from(ge)}}class b{constructor(W,B){this.d=W,this.e=B}async provideInlineValues(W,B,Q,H){const se=this.d.getDocument(W),ge=await this.e.provideInlineValues(se,i.Range.to(B),i.InlineValueContext.to(Q),H);if(Array.isArray(ge))return ge.map(Ee=>i.InlineValue.from(Ee))}}class N{constructor(W,B){this.d=W,this.e=B}async provideDocumentHighlights(W,B,Q){const H=this.d.getDocument(W),se=i.Position.to(B),ge=await this.e.provideDocumentHighlights(H,se,Q);if(Array.isArray(ge))return ge.map(i.DocumentHighlight.from)}}class A{constructor(W,B){this.d=W,this.e=B}async provideMultiDocumentHighlights(W,B,Q,H){const se=this.d.getDocument(W),ge=Q.map(Je=>this.d.getDocument(Je)),Ee=i.Position.to(B),ze=await this.e.provideMultiDocumentHighlights(se,Ee,ge,H);if(Array.isArray(ze))return ze.map(i.MultiDocumentHighlight.from)}}class F{constructor(W,B){this.d=W,this.e=B}async provideLinkedEditingRanges(W,B,Q){const H=this.d.getDocument(W),se=i.Position.to(B),ge=await this.e.provideLinkedEditingRanges(H,se,Q);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,v.$Lb)(ge.ranges.map(i.Range.from)),wordPattern:ge.wordPattern}}}class G{constructor(W,B){this.d=W,this.e=B}async provideReferences(W,B,Q,H){const se=this.d.getDocument(W),ge=i.Position.to(B),Ee=await this.e.provideReferences(se,ge,Q,H);if(Array.isArray(Ee))return Ee.map(i.location.from)}}class x{static{this.d=1e3}constructor(W,B,Q,H,se,ge,Ee){this.g=W,this.h=B,this.j=Q,this.k=H,this.l=se,this.m=ge,this.n=Ee,this.e=new o.$Qqc("CodeAction"),this.f=new Map}async provideCodeActions(W,B,Q,H){const se=this.g.getDocument(W),ge=p.$Yt.isISelection(B)?i.Selection.to(B):i.Range.to(B),Ee=[];for(const it of this.j.getDiagnostics(W))if(ge.intersection(it.range)&&Ee.push(it)>x.d)break;const ze={diagnostics:Ee,only:Q.only?new n.$xO(Q.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Q.trigger)},Je=await this.k.provideCodeActions(se,ge,ze,H);if(!(0,v.$Pb)(Je)||H.isCancellationRequested)return;const _e=this.e.add(Je),tt=new O.$Yc;this.f.set(_e,tt);const ct=[];for(let it=0;it<Je.length;it++){const at=Je[it];if(at)if(x.o(at))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ct.push({_isSynthetic:!0,title:at.title,command:this.h.toInternal(at,tt)});else{ze.only&&(at.kind?ze.only.contains(at.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value}' requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const yt=at.ranges??[];ct.push({cacheId:[_e,it],title:at.title,command:at.command&&this.h.toInternal(at.command,tt),diagnostics:at.diagnostics&&at.diagnostics.map(i.Diagnostic.from),edit:at.edit&&i.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,t.$yH)(this.m,"codeActionAI")?at.isAI:!1,ranges:(0,t.$yH)(this.m,"codeActionRanges")?(0,v.$Lb)(yt.map(i.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:_e,actions:ct}}async resolveCodeAction(W,B){const[Q,H]=W,se=this.e.get(Q,H);if(!se||x.o(se))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(se,B)??se;let Ee;ge.edit&&(Ee=i.WorkspaceEdit.from(ge.edit,void 0));let ze;if(ge.command){const Je=this.f.get(Q);Je&&(ze=this.h.toInternal(ge.command,Je))}return{edit:Ee,command:ze}}releaseCodeActions(W){this.f.get(W)?.dispose(),this.f.delete(W),this.e.delete(W)}static o(W){return typeof W.command=="string"&&typeof W.title=="string"}}class j{constructor(W,B,Q,H,se){this.e=W,this.f=B,this.g=Q,this.h=H,this.j=se,this.d=new o.$Qqc("DocumentPasteEdit")}async prepareDocumentPaste(W,B,Q,H){if(!this.g.prepareDocumentPaste)return;const se=this.f.getDocument(W),ge=B.map(Je=>i.Range.to(Je)),Ee=i.DataTransfer.toDataTransfer(Q,()=>{throw new L.$cb});if(await this.g.prepareDocumentPaste(se,ge,Ee,H),H.isCancellationRequested)return;const ze=Array.from(Ee).filter(([,Je])=>!(Je instanceof n.$4O));return i.DataTransfer.from(ze)}async providePasteEdits(W,B,Q,H,se,ge){if(!this.g.provideDocumentPasteEdits)return[];const Ee=this.f.getDocument(B),ze=Q.map(ct=>i.Range.to(ct)),Je=i.DataTransfer.toDataTransfer(H,async ct=>(await this.e.$resolvePasteFileData(this.h,W,ct)).buffer),_e=await this.g.provideDocumentPasteEdits(Ee,ze,Je,{only:se.only?new n.$9O(se.only):void 0,triggerKind:se.triggerKind},ge);if(!_e||ge.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((ct,it)=>({_cacheId:[tt,it],title:ct.title??(0,d.localize)(2703,null,this.j.displayName||this.j.name),kind:ct.kind,yieldTo:ct.yieldTo?.map(at=>at.value),insertText:typeof ct.insertText=="string"?ct.insertText:{snippet:ct.insertText.value},additionalEdit:ct.additionalEdit?i.WorkspaceEdit.from(ct.additionalEdit,void 0):void 0}))}async resolvePasteEdit(W,B){const[Q,H]=W,se=this.d.get(Q,H);if(!se||!this.g.resolveDocumentPasteEdit)return{};const ge=await this.g.resolveDocumentPasteEdit(se,B)??se;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releasePasteEdits(W){this.d.delete(W)}}class U{constructor(W,B){this.d=W,this.e=B}async provideDocumentFormattingEdits(W,B,Q){const H=this.d.getDocument(W),se=await this.e.provideDocumentFormattingEdits(H,B,Q);if(Array.isArray(se))return se.map(i.TextEdit.from)}}class J{constructor(W,B){this.d=W,this.e=B}async provideDocumentRangeFormattingEdits(W,B,Q,H){const se=this.d.getDocument(W),ge=i.Range.to(B),Ee=await this.e.provideDocumentRangeFormattingEdits(se,ge,Q,H);if(Array.isArray(Ee))return Ee.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(W,B,Q,H){(0,w.$tg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const se=this.d.getDocument(W),ge=B.map(i.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(se,ge,Q,H);if(Array.isArray(Ee))return Ee.map(i.TextEdit.from)}}class Z{constructor(W,B){this.d=W,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,B,Q,H,se){const ge=this.d.getDocument(W),Ee=i.Position.to(B),ze=await this.e.provideOnTypeFormattingEdits(ge,Ee,Q,H,se);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class ae{constructor(W,B){this.e=W,this.f=B,this.d=new o.$Qqc("WorkspaceSymbols")}async provideWorkspaceSymbols(W,B){const Q=await this.e.provideWorkspaceSymbols(W,B);if(!(0,v.$Pb)(Q))return{symbols:[]};const H=this.d.add(Q),se={cacheId:H,symbols:[]};for(let ge=0;ge<Q.length;ge++){const Ee=Q[ge];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}se.symbols.push({...i.WorkspaceSymbol.from(Ee),cacheId:[H,ge]})}return se}async resolveWorkspaceSymbol(W,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!W.cacheId)return W;const Q=this.d.get(...W.cacheId);if(Q){const H=await this.e.resolveWorkspaceSymbol(Q,B);return H&&(0,m.$no)(W,i.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(W){this.d.delete(W)}}class ee{static supportsResolving(W){return typeof W.prepareRename=="function"}constructor(W,B,Q){this.d=W,this.e=B,this.f=Q}async provideRenameEdits(W,B,Q,H){const se=this.d.getDocument(W),ge=i.Position.to(B);try{const Ee=await this.e.provideRenameEdits(se,ge,Q,H);return Ee?i.WorkspaceEdit.from(Ee):void 0}catch(Ee){const ze=ee.g(Ee);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(W,B,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(W),se=i.Position.to(B);try{const ge=await this.e.prepareRename(H,se,Q);let Ee,ze;if(n.$bO.isRange(ge)?(Ee=ge,ze=H.getText(ge)):(0,w.$lg)(ge)&&(Ee=ge.range,ze=ge.placeholder),!Ee||!ze)return;if(Ee.start.line>se.line||Ee.end.line<se.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ee),text:ze}}catch(ge){const Ee=ee.g(ge);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(ge)}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class oe{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:n.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:n.NewSymbolNameTriggerKind.Automatic}}constructor(W,B,Q){this.e=W,this.f=B,this.g=Q}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(W,B,Q,H){const se=this.e.getDocument(W),ge=i.Range.to(B);try{const Ee=oe.d[Q],ze=await this.f.provideNewSymbolNames(se,ge,Ee,H);return ze?ze.map(Je=>typeof Je=="string"?{newSymbolName:Je}:{newSymbolName:Je.newSymbolName,tags:Je.tags}):void 0}catch(Ee){this.g.error(oe.h(Ee)??JSON.stringify(Ee,null,"	"));return}}static h(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class ie{constructor(W,B){this.resultId=W,this.tokens=B}}class ue{constructor(W,B){this.f=W,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(W,B,Q){const H=this.f.getDocument(W),se=B!==0?this.d.get(B):null;let ge=typeof se?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,se.resultId,Q):await this.g.provideDocumentSemanticTokens(H,Q);return se&&this.d.delete(B),ge?(ge=ue.h(ge),this.o(ue.n(se,ge),ge)):null}async releaseDocumentSemanticColoring(W){this.d.delete(W)}static h(W){return ue.j(W)?ue.k(W)?W:new n.$wP(new Uint32Array(W.data),W.resultId):ue.l(W)?ue.m(W)?W:new n.$yP(W.edits.map(B=>new n.$xP(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),W.resultId):W}static j(W){return W&&!!W.data}static k(W){return W.data instanceof Uint32Array}static l(W){return W&&Array.isArray(W.edits)}static m(W){for(const B of W.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(W,B){if(!ue.j(B)||!W||!W.tokens)return B;const Q=W.tokens,H=Q.length,se=B.data,ge=se.length;let Ee=0;const ze=Math.min(H,ge);for(;Ee<ze&&Q[Ee]===se[Ee];)Ee++;if(Ee===H&&Ee===ge)return new n.$yP([],B.resultId);let Je=0;const _e=ze-Ee;for(;Je<_e&&Q[H-Je-1]===se[ge-Je-1];)Je++;return new n.$yP([{start:Ee,deleteCount:H-Ee-Je,data:se.subarray(Ee,ge-Je)}],B.resultId)}o(W,B){if(ue.j(W)){const Q=this.e++;return this.d.set(Q,new ie(W.resultId,W.data)),(0,l.$web)({id:Q,type:"full",data:W.data})}if(ue.l(W)){const Q=this.e++;return ue.j(B)?this.d.set(Q,new ie(B.resultId,B.data)):this.d.set(Q,new ie(W.resultId)),(0,l.$web)({id:Q,type:"delta",deltas:(W.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class _{constructor(W,B){this.d=W,this.e=B}async provideDocumentRangeSemanticTokens(W,B,Q){const H=this.d.getDocument(W),se=await this.e.provideDocumentRangeSemanticTokens(H,i.Range.to(B),Q);return se?this.f(se):null}f(W){return(0,l.$web)({id:0,type:"full",data:W.data})}}class $e{static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}constructor(W,B,Q,H,se){this.f=W,this.g=B,this.h=Q,this.j=H,this.k=se,this.d=new o.$Qqc("CompletionItem"),this.e=new Map}async provideCompletionItems(W,B,Q,H){const se=this.f.getDocument(W),ge=i.Position.to(B),Ee=se.getWordRangeAtPosition(ge)||new n.$bO(ge,ge),ze=Ee.with({end:ge}),Je=new s.$ke,_e=await this.h.provideCompletionItems(se,ge,H,i.CompletionContext.to(Q));if(!_e||H.isCancellationRequested)return;const tt=Array.isArray(_e)?new n.$KO(_e):_e,ct=$e.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),it=new O.$Yc;this.e.set(ct,it);const at=[],yt={x:ct,[c.ISuggestResultDtoField.completions]:at,[c.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ee),insert:i.Range.from(ze)},[c.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[c.ISuggestResultDtoField.duration]:Je.elapsed()};for(let Ye=0;Ye<tt.items.length;Ye++){const he=tt.items[Ye],pe=this.l(he,[ct,Ye],ze,Ee);at.push(pe)}return yt}async resolveCompletionItem(W,B){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...W);if(!Q)return;const H=this.l(Q,W),se=await this.h.resolveCompletionItem(Q,B);if(!se)return;const ge=this.l(se,W);return(H[c.ISuggestDataDtoField.insertText]!==ge[c.ISuggestDataDtoField.insertText]||H[c.ISuggestDataDtoField.insertTextRules]!==ge[c.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H[c.ISuggestDataDtoField.commandIdent]!==ge[c.ISuggestDataDtoField.commandIdent]||H[c.ISuggestDataDtoField.commandId]!==ge[c.ISuggestDataDtoField.commandId]||!(0,m.$oo)(H[c.ISuggestDataDtoField.commandArguments],ge[c.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,[c.ISuggestDataDtoField.documentation]:ge[c.ISuggestDataDtoField.documentation],[c.ISuggestDataDtoField.detail]:ge[c.ISuggestDataDtoField.detail],[c.ISuggestDataDtoField.additionalTextEdits]:ge[c.ISuggestDataDtoField.additionalTextEdits],[c.ISuggestDataDtoField.insertText]:ge[c.ISuggestDataDtoField.insertText],[c.ISuggestDataDtoField.insertTextRules]:ge[c.ISuggestDataDtoField.insertTextRules],[c.ISuggestDataDtoField.commandIdent]:ge[c.ISuggestDataDtoField.commandIdent],[c.ISuggestDataDtoField.commandId]:ge[c.ISuggestDataDtoField.commandId],[c.ISuggestDataDtoField.commandArguments]:ge[c.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,B,Q,H){const se=this.e.get(B[0]);if(!se)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(W.command,se),Ee={x:B,[c.ISuggestDataDtoField.label]:W.label,[c.ISuggestDataDtoField.kind]:W.kind!==void 0?i.CompletionItemKind.from(W.kind):void 0,[c.ISuggestDataDtoField.kindModifier]:W.tags&&W.tags.map(i.CompletionItemTag.from),[c.ISuggestDataDtoField.detail]:W.detail,[c.ISuggestDataDtoField.documentation]:typeof W.documentation>"u"?void 0:i.MarkdownString.fromStrict(W.documentation),[c.ISuggestDataDtoField.sortText]:W.sortText!==W.label?W.sortText:void 0,[c.ISuggestDataDtoField.filterText]:W.filterText!==W.label?W.filterText:void 0,[c.ISuggestDataDtoField.preselect]:W.preselect||void 0,[c.ISuggestDataDtoField.insertTextRules]:W.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[c.ISuggestDataDtoField.commitCharacters]:W.commitCharacters?.join(""),[c.ISuggestDataDtoField.additionalTextEdits]:W.additionalTextEdits&&W.additionalTextEdits.map(i.TextEdit.from),[c.ISuggestDataDtoField.commandIdent]:ge?.$ident,[c.ISuggestDataDtoField.commandId]:ge?.id,[c.ISuggestDataDtoField.commandArguments]:ge?.$ident?void 0:ge?.arguments};W.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee[c.ISuggestDataDtoField.insertText]=W.textEdit.newText):typeof W.insertText=="string"?Ee[c.ISuggestDataDtoField.insertText]=W.insertText:W.insertText instanceof n.$mO&&(Ee[c.ISuggestDataDtoField.insertText]=W.insertText.value,Ee[c.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let ze;return W.textEdit?ze=W.textEdit.range:W.range&&(ze=W.range),n.$bO.isRange(ze)?Ee[c.ISuggestDataDtoField.range]=i.Range.from(ze):ze&&(!Q?.isEqual(ze.inserting)||!H?.isEqual(ze.replacing))&&(Ee[c.ISuggestDataDtoField.range]={insert:i.Range.from(ze.inserting),replace:i.Range.from(ze.replacing)}),Ee}}class Ie{async provideInlineCompletions(W,B,Q,H){}async provideInlineEdits(W,B,Q,H){}disposeCompletions(W){}handleDidShowCompletionItem(W,B,Q){}handlePartialAccept(W,B,Q,H){}}class X extends Ie{constructor(W,B,Q,H){super(),this.f=W,this.g=B,this.h=Q,this.j=H,this.d=new re,this.e=(0,t.$yH)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:n.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:n.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$yH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(W,B,Q,H){const se=this.g.getDocument(W),ge=i.Position.to(B),Ee=await this.h.provideInlineCompletionItems(se,ge,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:i.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},H);if(!Ee||H.isCancellationRequested)return;const ze=Array.isArray(Ee)?Ee:Ee.items,Je=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:ze}),items:ze.map((it,at)=>{let yt;it.command&&(tt||(tt=new O.$Yc),yt=this.j.toInternal(it.command,tt));const Ye=it.insertText;return{insertText:typeof Ye=="string"?Ye:{snippet:Ye.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:yt,idx:at,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Je.map(it=>(tt||(tt=new O.$Yc),this.j.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(W,B,Q,H){if(!this.h.provideInlineEdits)return;(0,t.$zH)(this.f,"inlineCompletionsAdditions");const se=this.g.getDocument(W),ge=i.Range.to(B),Ee=await this.h.provideInlineEdits(se,ge,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:i.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind],userPrompt:Q.userPrompt},H);if(!Ee||H.isCancellationRequested)return;const ze=Array.isArray(Ee)?Ee:Ee.items,Je=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:ze}),items:ze.map((it,at)=>{let yt;it.command&&(tt||(tt=new O.$Yc),yt=this.j.toInternal(it.command,tt));const Ye=it.insertText;return{insertText:typeof Ye=="string"?Ye:{snippet:Ye.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:yt,idx:at,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Je.map(it=>(tt||(tt=new O.$Yc),this.j.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(W){this.d.disposeReferenceId(W)?.dispose()}handleDidShowCompletionItem(W,B,Q){const H=this.d.get(W)?.items[B];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,Q)}handlePartialAccept(W,B,Q,H){const se=this.d.get(W)?.items[B];se&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(se,Q),this.h.handleDidPartiallyAcceptCompletionItem(se,i.PartialAcceptInfo.to(H)))}}class V{async provideInlineEdits(W,B,Q){const H=this.f.getDocument(W),se=await this.g.provideInlineEdit(H,{triggerKind:this.e[B.triggerKind]},Q);if(!se||Q.isCancellationRequested)return;let ge;const Ee=this.d.createReferenceId({dispose(){ge?.dispose()},item:se});let ze;se.accepted&&(ge||(ge=new O.$Yc),ze=this.h.toInternal(se.accepted,ge));let Je;return se.rejected&&(ge||(ge=new O.$Yc),Je=this.h.toInternal(se.rejected,ge)),{pid:Ee,text:se.text,range:i.Range.from(se.range),accepted:ze,rejected:Je}}disposeEdit(W){this.d.disposeReferenceId(W)?.dispose()}constructor(W,B,Q,H){this.f=B,this.g=Q,this.h=H,this.d=new re,this.e={[r.InlineEditTriggerKind.Automatic]:n.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:n.InlineEditTriggerKind.Invoke}}}class re{constructor(){this.d=new Map,this.e=1}createReferenceId(W){const B=this.e++;return this.d.set(B,W),B}disposeReferenceId(W){const B=this.d.get(W);return this.d.delete(W),B}get(W){return this.d.get(W)}}class be{constructor(W,B){this.e=W,this.f=B,this.d=new o.$Qqc("SignatureHelp")}async provideSignatureHelp(W,B,Q,H){const se=this.e.getDocument(W),ge=i.Position.to(B),Ee=this.g(Q),ze=await this.f.provideSignatureHelp(se,ge,H,Ee);if(ze){const Je=this.d.add([ze]);return{...i.SignatureHelp.from(ze),id:Je}}}g(W){let B;if(W.activeSignatureHelp){const Q=i.SignatureHelp.to(W.activeSignatureHelp),H=this.d.get(W.activeSignatureHelp.id,0);H?(B=H,B.activeSignature=Q.activeSignature,B.activeParameter=Q.activeParameter):B=Q}return{...W,activeSignatureHelp:B}}releaseSignatureHelp(W){this.d.delete(W)}}class Pe{constructor(W,B,Q,H,se){this.f=W,this.g=B,this.h=Q,this.j=H,this.k=se,this.d=new o.$Qqc("InlayHints"),this.e=new Map}async provideInlayHints(W,B,Q){const H=this.f.getDocument(W),se=i.Range.to(B),ge=await this.h.provideInlayHints(H,se,Q);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`);return}if(Q.isCancellationRequested)return;const Ee=this.d.add(ge);this.e.set(Ee,new O.$Yc);const ze={hints:[],cacheId:Ee};for(let Je=0;Je<ge.length;Je++)this.l(ge[Je],se)&&ze.hints.push(this.m(ge[Je],[Ee,Je]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`),ze}async resolveInlayHint(W,B){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...W);if(!Q)return;const H=await this.h.resolveInlayHint(Q,B);if(H&&this.l(H))return this.m(H,W)}releaseHints(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,B){return W.label.length===0||Array.isArray(W.label)&&W.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",W),!1):!(B&&!B.contains(W.position))}m(W,B){const Q=this.e.get(B[0]);if(!Q)throw Error("DisposableStore is missing...");const H={label:"",cacheId:B,tooltip:i.MarkdownString.fromStrict(W.tooltip),position:i.Position.from(W.position),textEdits:W.textEdits&&W.textEdits.map(i.TextEdit.from),kind:W.kind&&i.InlayHintKind.from(W.kind),paddingLeft:W.paddingLeft,paddingRight:W.paddingRight};if(typeof W.label=="string")H.label=W.label;else{const se=[];H.label=se;for(const ge of W.label){if(!ge.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:ge.value,tooltip:i.MarkdownString.fromStrict(ge.tooltip)};n.$nO.isLocation(ge.location)&&(Ee.location=i.location.from(ge.location)),ge.command&&(Ee.command=this.g.toInternal(ge.command,Q)),se.push(Ee)}}return H}}class Fe{constructor(W,B){this.e=W,this.f=B,this.d=new o.$Qqc("DocumentLink")}async provideLinks(W,B){const Q=this.e.getDocument(W),H=await this.f.provideDocumentLinks(Q,B);if(!(!Array.isArray(H)||H.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(Fe.g).map(i.DocumentLink.from)};{const se=this.d.add(H),ge={links:[],cacheId:se};for(let Ee=0;Ee<H.length;Ee++){if(!Fe.g(H[Ee]))continue;const ze=i.DocumentLink.from(H[Ee]);ze.cacheId=[se,Ee],ge.links.push(ze)}return ge}}}static g(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,B){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...W);if(!Q)return;const H=await this.f.resolveDocumentLink(Q,B);if(!(!H||!Fe.g(H)))return i.DocumentLink.from(H)}releaseLinks(W){this.d.delete(W)}}class Be{constructor(W,B){this.d=W,this.e=B}async provideColors(W,B){const Q=this.d.getDocument(W),H=await this.e.provideDocumentColors(Q,B);return Array.isArray(H)?H.map(ge=>({color:i.Color.from(ge.color),range:i.Range.from(ge.range)})):[]}async provideColorPresentations(W,B,Q){const H=this.d.getDocument(W),se=i.Range.to(B.range),ge=i.Color.to(B.color),Ee=await this.e.provideColorPresentations(ge,{document:H,range:se},Q);if(Array.isArray(Ee))return Ee.map(i.ColorPresentation.from)}}class xe{constructor(W,B){this.d=W,this.e=B}async provideFoldingRanges(W,B,Q){const H=this.d.getDocument(W),se=await this.e.provideFoldingRanges(H,B,Q);if(Array.isArray(se))return se.map(i.FoldingRange.from)}}class nt{constructor(W,B,Q){this.d=W,this.e=B,this.f=Q}async provideSelectionRanges(W,B,Q){const H=this.d.getDocument(W),se=B.map(i.Position.to),ge=await this.e.provideSelectionRanges(H,se,Q);if(!(0,v.$Pb)(ge))return[];if(ge.length!==se.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let ze=0;ze<se.length;ze++){const Je=[];Ee.push(Je);let _e=se[ze],tt=ge[ze];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Je.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Ee}}class ht{constructor(W,B){this.f=W,this.g=B,this.d=new R.$PQ(""),this.e=new Map}async prepareSession(W,B,Q){const H=this.f.getDocument(W),se=i.Position.to(B),ge=await this.g.prepareCallHierarchy(H,se,Q);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ee,ze)):[this.h(Ee,ge)]}async provideCallsTo(W,B,Q){const H=this.j(W,B);if(!H)throw new Error("missing call hierarchy item");const se=await this.g.provideCallHierarchyIncomingCalls(H,Q);if(se)return se.map(ge=>({from:this.h(W,ge.from),fromRanges:ge.fromRanges.map(Ee=>i.Range.from(Ee))}))}async provideCallsFrom(W,B,Q){const H=this.j(W,B);if(!H)throw new Error("missing call hierarchy item");const se=await this.g.provideCallHierarchyOutgoingCalls(H,Q);if(se)return se.map(ge=>({to:this.h(W,ge.to),fromRanges:ge.fromRanges.map(Ee=>i.Range.from(Ee))}))}releaseSession(W){this.e.delete(W)}h(W,B){const Q=this.e.get(W),H=i.CallHierarchyItem.from(B,W,Q.size.toString(36));return Q.set(H._itemId,B),H}j(W,B){return this.e.get(W)?.get(B)}}class $t{constructor(W,B){this.f=W,this.g=B,this.d=new R.$PQ(""),this.e=new Map}async prepareSession(W,B,Q){const H=this.f.getDocument(W),se=i.Position.to(B),ge=await this.g.prepareTypeHierarchy(H,se,Q);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ee,ze)):[this.h(Ee,ge)]}async provideSupertypes(W,B,Q){const H=this.j(W,B);if(!H)throw new Error("missing type hierarchy item");const se=await this.g.provideTypeHierarchySupertypes(H,Q);if(se)return se.map(ge=>this.h(W,ge))}async provideSubtypes(W,B,Q){const H=this.j(W,B);if(!H)throw new Error("missing type hierarchy item");const se=await this.g.provideTypeHierarchySubtypes(H,Q);if(se)return se.map(ge=>this.h(W,ge))}releaseSession(W){this.e.delete(W)}h(W,B){const Q=this.e.get(W),H=i.TypeHierarchyItem.from(B,W,Q.size.toString(36));return Q.set(H._itemId,B),H}j(W,B){return this.e.get(W)?.get(B)}}class ut{constructor(W,B,Q,H,se){this.e=W,this.f=B,this.g=Q,this.h=H,this.j=se,this.d=new o.$Qqc("DocumentDropEdit")}async provideDocumentOnDropEdits(W,B,Q,H,se){const ge=this.f.getDocument(B),Ee=i.Position.to(Q),ze=i.DataTransfer.toDataTransfer(H,async ct=>(await this.e.$resolveDocumentOnDropFileData(this.h,W,ct)).buffer),Je=await this.g.provideDocumentDropEdits(ge,Ee,ze,se);if(!Je)return;const _e=(0,v.$6b)(Je),tt=this.d.add(_e);return _e.map((ct,it)=>({_cacheId:[tt,it],title:ct.title??(0,d.localize)(2704,null,this.j.displayName||this.j.name),kind:ct.kind?.value,yieldTo:ct.yieldTo?.map(at=>at.value),insertText:typeof ct.insertText=="string"?ct.insertText:{snippet:ct.insertText.value},additionalEdit:ct.additionalEdit?i.WorkspaceEdit.from(ct.additionalEdit,void 0):void 0}))}async resolveDropEdit(W,B){const[Q,H]=W,se=this.d.get(Q,H);if(!se||!this.g.resolveDocumentDropEdit)return{};const ge=await this.g.resolveDocumentDropEdit(se,B)??se;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releaseDropEdits(W){this.d.delete(W)}}class et{constructor(W,B){this.d=W,this.e=B}async provideMappedEdits(W,B,Q,H){const se=u.URI.revive(W),ge=this.d.getDocument(se),Ee=Q.documents.map(_e=>_e.map(tt=>({uri:u.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(ct=>i.Range.to(ct))}))),ze={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},Je=await this.e.provideMappedEdits(ge,B,ze,H);return Je?i.WorkspaceEdit.from(Je):null}}class Le{constructor(W,B){this.adapter=W,this.extension=B}}class Me{static{this.d=0}constructor(W,B,Q,H,se,ge,Ee,ze){this.g=B,this.h=Q,this.j=H,this.k=se,this.l=ge,this.m=Ee,this.n=ze,this.f=new Map,this.e=W.getProxy(c.$0N.MainThreadLanguageFeatures)}o(W,B){return i.DocumentSelector.from(W,this.g,B)}p(W){return new n.$_N(()=>{this.f.delete(W),this.e.$unregister(W)})}q(){return Me.d++}async s(W,B,Q,H,se,ge=!1){const Ee=this.f.get(W);if(!Ee||!(Ee.adapter instanceof B))return H;const ze=Date.now();ge||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const Je=Q(Ee.adapter,Ee.extension);return Promise.resolve(Je).catch(_e=>{(0,L.$8)(_e)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ee.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),P.CancellationToken.isCancellationToken(se)?(0,D.$zh)(Je,se):Je}t(W,B){const Q=this.q();return this.f.set(Q,new Le(W,B)),Q}static u(W){return W.displayName||W.name}static w(W){return W.identifier.value}registerDocumentSymbolProvider(W,B,Q,H){const se=this.t(new g(this.h,Q),W),ge=H&&H.label||Me.u(W);return this.e.$registerDocumentSymbolProvider(se,this.o(B,W),ge),this.p(se)}$provideDocumentSymbols(W,B,Q){return this.s(W,g,H=>H.provideDocumentSymbols(u.URI.revive(B),Q),void 0,Q)}registerCodeLensProvider(W,B,Q){const H=this.q(),se=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Le(new f(this.h,this.j.converter,Q,W,this.n,this.l),W)),this.e.$registerCodeLensSupport(H,this.o(B,W),se);let ge=this.p(H);if(se!==void 0){const Ee=Q.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(se));ge=n.$_N.from(ge,Ee)}return ge}$provideCodeLenses(W,B,Q){return this.s(W,f,H=>H.provideCodeLenses(u.URI.revive(B),Q),void 0,Q)}$resolveCodeLens(W,B,Q){return this.s(W,f,H=>H.resolveCodeLens(B,Q),void 0,void 0)}$releaseCodeLenses(W,B){this.s(W,f,Q=>Promise.resolve(Q.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(W,B,Q){const H=this.t(new S(this.h,Q),W);return this.e.$registerDefinitionSupport(H,this.o(B,W)),this.p(H)}$provideDefinition(W,B,Q,H){return this.s(W,S,se=>se.provideDefinition(u.URI.revive(B),Q,H),[],H)}registerDeclarationProvider(W,B,Q){const H=this.t(new k(this.h,Q),W);return this.e.$registerDeclarationSupport(H,this.o(B,W)),this.p(H)}$provideDeclaration(W,B,Q,H){return this.s(W,k,se=>se.provideDeclaration(u.URI.revive(B),Q,H),[],H)}registerImplementationProvider(W,B,Q){const H=this.t(new y(this.h,Q),W);return this.e.$registerImplementationSupport(H,this.o(B,W)),this.p(H)}$provideImplementation(W,B,Q,H){return this.s(W,y,se=>se.provideImplementation(u.URI.revive(B),Q,H),[],H)}registerTypeDefinitionProvider(W,B,Q){const H=this.t(new C(this.h,Q),W);return this.e.$registerTypeDefinitionSupport(H,this.o(B,W)),this.p(H)}$provideTypeDefinition(W,B,Q,H){return this.s(W,C,se=>se.provideTypeDefinition(u.URI.revive(B),Q,H),[],H)}registerHoverProvider(W,B,Q,H){const se=this.t(new T(this.h,Q),W);return this.e.$registerHoverProvider(se,this.o(B,W)),this.p(se)}$provideHover(W,B,Q,H,se){return this.s(W,T,ge=>ge.provideHover(u.URI.revive(B),Q,H,se),void 0,se)}$releaseHover(W,B){this.s(W,T,Q=>Promise.resolve(Q.releaseHover(B)),void 0,void 0)}registerEvaluatableExpressionProvider(W,B,Q,H){const se=this.t(new $(this.h,Q),W);return this.e.$registerEvaluatableExpressionProvider(se,this.o(B,W)),this.p(se)}$provideEvaluatableExpression(W,B,Q,H){return this.s(W,$,se=>se.provideEvaluatableExpression(u.URI.revive(B),Q,H),void 0,H)}registerInlineValuesProvider(W,B,Q,H){const se=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new b(this.h,Q),W);this.e.$registerInlineValuesProvider(ge,this.o(B,W),se);let Ee=this.p(ge);if(se!==void 0){const ze=Q.onDidChangeInlineValues(Je=>this.e.$emitInlineValuesEvent(se));Ee=n.$_N.from(Ee,ze)}return Ee}$provideInlineValues(W,B,Q,H,se){return this.s(W,b,ge=>ge.provideInlineValues(u.URI.revive(B),Q,H,se),void 0,se)}registerDocumentHighlightProvider(W,B,Q){const H=this.t(new N(this.h,Q),W);return this.e.$registerDocumentHighlightProvider(H,this.o(B,W)),this.p(H)}registerMultiDocumentHighlightProvider(W,B,Q){const H=this.t(new A(this.h,Q),W);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(B,W)),this.p(H)}$provideDocumentHighlights(W,B,Q,H){return this.s(W,N,se=>se.provideDocumentHighlights(u.URI.revive(B),Q,H),void 0,H)}$provideMultiDocumentHighlights(W,B,Q,H,se){return this.s(W,A,ge=>ge.provideMultiDocumentHighlights(u.URI.revive(B),Q,H.map(Ee=>u.URI.revive(Ee)),se),void 0,se)}registerLinkedEditingRangeProvider(W,B,Q){const H=this.t(new F(this.h,Q),W);return this.e.$registerLinkedEditingRangeProvider(H,this.o(B,W)),this.p(H)}$provideLinkedEditingRanges(W,B,Q,H){return this.s(W,F,async se=>{const ge=await se.provideLinkedEditingRanges(u.URI.revive(B),Q,H);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?Me.y(ge.wordPattern):void 0}},void 0,H)}registerReferenceProvider(W,B,Q){const H=this.t(new G(this.h,Q),W);return this.e.$registerReferenceSupport(H,this.o(B,W)),this.p(H)}$provideReferences(W,B,Q,H,se){return this.s(W,G,ge=>ge.provideReferences(u.URI.revive(B),Q,H,se),void 0,se)}registerCodeActionProvider(W,B,Q,H){const se=new O.$Yc,ge=this.t(new x(this.h,this.j.converter,this.k,Q,this.l,W,this.m),W);return this.e.$registerCodeActionSupport(ge,this.o(B,W),{providedKinds:H?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:H?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,se)}))},Me.u(W),Me.w(W),!!Q.resolveCodeAction),se.add(this.p(ge)),se}$provideCodeActions(W,B,Q,H,se){return this.s(W,x,ge=>ge.provideCodeActions(u.URI.revive(B),Q,H,se),void 0,se)}$resolveCodeAction(W,B,Q){return this.s(W,x,H=>H.resolveCodeAction(B,Q),{},void 0)}$releaseCodeActions(W,B){this.s(W,x,Q=>Promise.resolve(Q.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(W,B,Q){const H=this.t(new U(this.h,Q),W);return this.e.$registerDocumentFormattingSupport(H,this.o(B,W),W.identifier,W.displayName||W.name),this.p(H)}$provideDocumentFormattingEdits(W,B,Q,H){return this.s(W,U,se=>se.provideDocumentFormattingEdits(u.URI.revive(B),Q,H),void 0,H)}registerDocumentRangeFormattingEditProvider(W,B,Q){const H=typeof Q.provideDocumentRangesFormattingEdits=="function",se=this.t(new J(this.h,Q),W);return this.e.$registerRangeFormattingSupport(se,this.o(B,W),W.identifier,W.displayName||W.name,H),this.p(se)}$provideDocumentRangeFormattingEdits(W,B,Q,H,se){return this.s(W,J,ge=>ge.provideDocumentRangeFormattingEdits(u.URI.revive(B),Q,H,se),void 0,se)}$provideDocumentRangesFormattingEdits(W,B,Q,H,se){return this.s(W,J,ge=>ge.provideDocumentRangesFormattingEdits(u.URI.revive(B),Q,H,se),void 0,se)}registerOnTypeFormattingEditProvider(W,B,Q,H){const se=this.t(new Z(this.h,Q),W);return this.e.$registerOnTypeFormattingSupport(se,this.o(B,W),H,W.identifier),this.p(se)}$provideOnTypeFormattingEdits(W,B,Q,H,se,ge){return this.s(W,Z,Ee=>Ee.provideOnTypeFormattingEdits(u.URI.revive(B),Q,H,se,ge),void 0,ge)}registerWorkspaceSymbolProvider(W,B){const Q=this.t(new ae(B,this.l),W);return this.e.$registerNavigateTypeSupport(Q,typeof B.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(W,B,Q){return this.s(W,ae,H=>H.provideWorkspaceSymbols(B,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(W,B,Q){return this.s(W,ae,H=>H.resolveWorkspaceSymbol(B,Q),void 0,void 0)}$releaseWorkspaceSymbols(W,B){this.s(W,ae,Q=>Q.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(W,B,Q){const H=this.t(new ee(this.h,Q,this.l),W);return this.e.$registerRenameSupport(H,this.o(B,W),ee.supportsResolving(Q)),this.p(H)}$provideRenameEdits(W,B,Q,H,se){return this.s(W,ee,ge=>ge.provideRenameEdits(u.URI.revive(B),Q,H,se),void 0,se)}$resolveRenameLocation(W,B,Q,H){return this.s(W,ee,se=>se.resolveRenameLocation(u.URI.revive(B),Q,H),void 0,H)}registerNewSymbolNamesProvider(W,B,Q){const H=this.t(new oe(this.h,Q,this.l),W);return this.e.$registerNewSymbolNamesProvider(H,this.o(B,W)),this.p(H)}$supportsAutomaticNewSymbolNamesTriggerKind(W){return this.s(W,oe,B=>B.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(W,B,Q,H,se){return this.s(W,oe,ge=>ge.provideNewSymbolNames(u.URI.revive(B),Q,H,se),void 0,se)}registerDocumentSemanticTokensProvider(W,B,Q,H){const se=this.t(new ue(this.h,Q),W),ge=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(se,this.o(B,W),H,ge);let Ee=this.p(se);if(ge){const ze=Q.onDidChangeSemanticTokens(Je=>this.e.$emitDocumentSemanticTokensEvent(ge));Ee=n.$_N.from(Ee,ze)}return Ee}$provideDocumentSemanticTokens(W,B,Q,H){return this.s(W,ue,se=>se.provideDocumentSemanticTokens(u.URI.revive(B),Q,H),null,H)}$releaseDocumentSemanticTokens(W,B){this.s(W,ue,Q=>Q.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(W,B,Q,H){const se=this.t(new _(this.h,Q),W);return this.e.$registerDocumentRangeSemanticTokensProvider(se,this.o(B,W),H),this.p(se)}$provideDocumentRangeSemanticTokens(W,B,Q,H){return this.s(W,_,se=>se.provideDocumentRangeSemanticTokens(u.URI.revive(B),Q,H),null,H)}registerCompletionItemProvider(W,B,Q,H){const se=this.t(new $e(this.h,this.j.converter,Q,this.m,W),W);return this.e.$registerCompletionsProvider(se,this.o(B,W),H,$e.supportsResolving(Q),W.identifier),this.p(se)}$provideCompletionItems(W,B,Q,H,se){return this.s(W,$e,ge=>ge.provideCompletionItems(u.URI.revive(B),Q,H,se),void 0,se)}$resolveCompletionItem(W,B,Q){return this.s(W,$e,H=>H.resolveCompletionItem(B,Q),void 0,Q)}$releaseCompletionItems(W,B){this.s(W,$e,Q=>Q.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(W,B,Q,H){const se=new X(W,this.h,Q,this.j.converter),ge=this.t(se,W);return this.e.$registerInlineCompletionsSupport(ge,this.o(B,W),se.supportsHandleEvents,a.$xn.toKey(W.identifier.value),H?.yieldTo?.map(Ee=>a.$xn.toKey(Ee))||[]),this.p(ge)}$provideInlineCompletions(W,B,Q,H,se){return this.s(W,Ie,ge=>ge.provideInlineCompletions(u.URI.revive(B),Q,H,se),void 0,se)}$provideInlineEdits(W,B,Q,H,se){return this.s(W,Ie,ge=>ge.provideInlineEdits(u.URI.revive(B),Q,H,se),void 0,se)}$handleInlineCompletionDidShow(W,B,Q,H){this.s(W,Ie,async se=>{se.handleDidShowCompletionItem(B,Q,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(W,B,Q,H,se){this.s(W,Ie,async ge=>{ge.handlePartialAccept(B,Q,H,se)},void 0,void 0)}$freeInlineCompletionsList(W,B){this.s(W,Ie,async Q=>{Q.disposeCompletions(B)},void 0,void 0)}registerInlineEditProvider(W,B,Q){const H=new V(W,this.h,Q,this.j.converter),se=this.t(H,W);return this.e.$registerInlineEditProvider(se,this.o(B,W),W.identifier),this.p(se)}$provideInlineEdit(W,B,Q,H){return this.s(W,V,se=>se.provideInlineEdits(u.URI.revive(B),Q,H),void 0,H)}$freeInlineEdit(W,B){this.s(W,V,async Q=>{Q.disposeEdit(B)},void 0,void 0)}registerSignatureHelpProvider(W,B,Q,H){const se=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,ge=this.t(new be(this.h,Q),W);return this.e.$registerSignatureHelpProvider(ge,this.o(B,W),se),this.p(ge)}$provideSignatureHelp(W,B,Q,H,se){return this.s(W,be,ge=>ge.provideSignatureHelp(u.URI.revive(B),Q,H,se),void 0,se)}$releaseSignatureHelp(W,B){this.s(W,be,Q=>Q.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(W,B,Q){const H=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,se=this.t(new Pe(this.h,this.j.converter,Q,this.l,W),W);this.e.$registerInlayHintsProvider(se,this.o(B,W),typeof Q.resolveInlayHint=="function",H,Me.u(W));let ge=this.p(se);if(H!==void 0){const Ee=Q.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(H));ge=n.$_N.from(ge,Ee)}return ge}$provideInlayHints(W,B,Q,H){return this.s(W,Pe,se=>se.provideInlayHints(u.URI.revive(B),Q,H),void 0,H)}$resolveInlayHint(W,B,Q){return this.s(W,Pe,H=>H.resolveInlayHint(B,Q),void 0,Q)}$releaseInlayHints(W,B){this.s(W,Pe,Q=>Q.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(W,B,Q){const H=this.t(new Fe(this.h,Q),W);return this.e.$registerDocumentLinkProvider(H,this.o(B,W),typeof Q.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(W,B,Q){return this.s(W,Fe,H=>H.provideLinks(u.URI.revive(B),Q),void 0,Q,B.scheme==="output")}$resolveDocumentLink(W,B,Q){return this.s(W,Fe,H=>H.resolveLink(B,Q),void 0,void 0,!0)}$releaseDocumentLinks(W,B){this.s(W,Fe,Q=>Q.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(W,B,Q){const H=this.t(new Be(this.h,Q),W);return this.e.$registerDocumentColorProvider(H,this.o(B,W)),this.p(H)}$provideDocumentColors(W,B,Q){return this.s(W,Be,H=>H.provideColors(u.URI.revive(B),Q),[],Q)}$provideColorPresentations(W,B,Q,H){return this.s(W,Be,se=>se.provideColorPresentations(u.URI.revive(B),Q,H),void 0,H)}registerFoldingRangeProvider(W,B,Q){const H=this.q(),se=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Le(new xe(this.h,Q),W)),this.e.$registerFoldingRangeProvider(H,this.o(B,W),W.identifier,se);let ge=this.p(H);if(se!==void 0){const Ee=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(se));ge=n.$_N.from(ge,Ee)}return ge}$provideFoldingRanges(W,B,Q,H){return this.s(W,xe,se=>se.provideFoldingRanges(u.URI.revive(B),Q,H),void 0,H)}registerSelectionRangeProvider(W,B,Q){const H=this.t(new nt(this.h,Q,this.l),W);return this.e.$registerSelectionRangeProvider(H,this.o(B,W)),this.p(H)}$provideSelectionRanges(W,B,Q,H){return this.s(W,nt,se=>se.provideSelectionRanges(u.URI.revive(B),Q,H),[],H)}registerCallHierarchyProvider(W,B,Q){const H=this.t(new ht(this.h,Q),W);return this.e.$registerCallHierarchyProvider(H,this.o(B,W)),this.p(H)}$prepareCallHierarchy(W,B,Q,H){return this.s(W,ht,se=>Promise.resolve(se.prepareSession(u.URI.revive(B),Q,H)),void 0,H)}$provideCallHierarchyIncomingCalls(W,B,Q,H){return this.s(W,ht,se=>se.provideCallsTo(B,Q,H),void 0,H)}$provideCallHierarchyOutgoingCalls(W,B,Q,H){return this.s(W,ht,se=>se.provideCallsFrom(B,Q,H),void 0,H)}$releaseCallHierarchy(W,B){this.s(W,ht,Q=>Promise.resolve(Q.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(W,B,Q){const H=this.t(new $t(this.h,Q),W);return this.e.$registerTypeHierarchyProvider(H,this.o(B,W)),this.p(H)}$prepareTypeHierarchy(W,B,Q,H){return this.s(W,$t,se=>Promise.resolve(se.prepareSession(u.URI.revive(B),Q,H)),void 0,H)}$provideTypeHierarchySupertypes(W,B,Q,H){return this.s(W,$t,se=>se.provideSupertypes(B,Q,H),void 0,H)}$provideTypeHierarchySubtypes(W,B,Q,H){return this.s(W,$t,se=>se.provideSubtypes(B,Q,H),void 0,H)}$releaseTypeHierarchy(W,B){this.s(W,$t,Q=>Promise.resolve(Q.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(W,B,Q,H){const se=this.q();return this.f.set(se,new Le(new ut(this.e,this.h,Q,se,W),W)),this.e.$registerDocumentOnDropEditProvider(se,this.o(B,W),(0,t.$yH)(W,"documentPaste")&&H?{supportsResolve:!!Q.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(se)}$provideDocumentOnDropEdits(W,B,Q,H,se,ge){return this.s(W,ut,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(B,u.URI.revive(Q),H,se,ge)),void 0,void 0)}$resolveDropEdit(W,B,Q){return this.s(W,ut,H=>H.resolveDropEdit(B,Q),{},void 0)}$releaseDocumentOnDropEdits(W,B){this.s(W,ut,Q=>Promise.resolve(Q.releaseDropEdits(B)),void 0,void 0)}registerMappedEditsProvider(W,B,Q){const H=this.t(new et(this.h,Q),W);return this.e.$registerMappedEditsProvider(H,this.o(B,W),W.displayName??W.name),this.p(H)}$provideMappedEdits(W,B,Q,H,se){return this.s(W,et,ge=>Promise.resolve(ge.provideMappedEdits(B,Q,H,se)),null,se)}registerDocumentPasteEditProvider(W,B,Q,H){const se=this.q();return this.f.set(se,new Le(new j(this.e,this.h,Q,se,W),W)),this.e.$registerPasteEditProvider(se,this.o(B,W),{supportsCopy:!!Q.prepareDocumentPaste,supportsPaste:!!Q.provideDocumentPasteEdits,supportsResolve:!!Q.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(ge=>ge.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(se)}$prepareDocumentPaste(W,B,Q,H,se){return this.s(W,j,ge=>ge.prepareDocumentPaste(u.URI.revive(B),Q,H,se),void 0,se)}$providePasteEdits(W,B,Q,H,se,ge,Ee){return this.s(W,j,ze=>ze.providePasteEdits(B,u.URI.revive(Q),H,se,ge,Ee),void 0,Ee)}$resolvePasteEdit(W,B,Q){return this.s(W,j,H=>H.resolvePasteEdit(B,Q),{},void 0)}$releasePasteEdits(W,B){this.s(W,j,Q=>Promise.resolve(Q.releasePasteEdits(B)),void 0,void 0)}static y(W){return{pattern:W.source,flags:W.flags}}static z(W){return{decreaseIndentPattern:Me.y(W.decreaseIndentPattern),increaseIndentPattern:Me.y(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Me.y(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Me.y(W.unIndentedLinePattern):void 0}}static B(W){return{beforeText:Me.y(W.beforeText),afterText:W.afterText?Me.y(W.afterText):void 0,previousLineText:W.previousLineText?Me.y(W.previousLineText):void 0,action:W.action}}static C(W){return W.map(Me.B)}static D(W){return{open:W.open,close:W.close,notIn:W.notIn?W.notIn.map(B=>n.SyntaxTokenType.toString(B)):void 0}}static E(W){return W.map(Me.D)}setLanguageConfiguration(W,B,Q){const{wordPattern:H}=Q;if(H&&(0,I.$wf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(B,H):this.h.setWordDefinitionFor(B,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const se=this.q(),ge={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?Me.y(Q.wordPattern):void 0,indentationRules:Q.indentationRules?Me.z(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?Me.C(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport,autoClosingPairs:Q.autoClosingPairs?Me.E(Q.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(se,B,ge),this.p(se)}$setWordDefinitions(W){for(const B of W)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.$1qc=Me}),define(Re[243],Te([1,0,10,19,12,4,34,33,5,8]),function(we,e,v,D,P,L,R,O,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xsc=void 0,s=Ve(s);class I{constructor(u){this.a=new Map,this.c=new Map,this.d=new Map,this.b=u.getProxy(m.$0N.MainThreadLanguageModelTools),this.b.$getTools().then(E=>{for(const p of E)this.d.set(p.id,(0,R.$hi)(p))})}async $countTokensForInvocation(u,E,p){const r=this.c.get(u);if(!r)throw new Error(`Tool invocation call ${u} not found`);return await r(E,p)}async invokeTool(u,E,p){const r=(0,O.$7g)();E.tokenOptions&&this.c.set(r,E.tokenOptions.countTokens);try{const l=await this.b.$invokeTool({toolId:u,callId:r,parameters:E.parameters,tokenBudget:E.tokenOptions?.tokenBudget},p);return s.LanguageModelToolResult.to(l)}finally{this.c.delete(r)}}$onDidChangeTools(u){this.d.clear();for(const E of u)this.d.set(E.id,E)}get tools(){return Array.from(this.d.values()).map(u=>s.LanguageModelToolDescription.to(u))}async $invokeTool(u,E){const p=this.a.get(u.toolId);if(!p)throw new Error(`Unknown tool ${u.toolId}`);const r={parameters:u.parameters};u.tokenBudget!==void 0&&(r.tokenOptions={tokenBudget:u.tokenBudget,countTokens:this.c.get(u.callId)||((d,a=D.CancellationToken.None)=>this.b.$countTokensForInvocation(u.callId,d,a))});const l=await(0,v.$yh)(Promise.resolve(p.tool.invoke(r,E)),E);if(!l)throw new P.$9;for(const d of Object.keys(l))if(l[d]instanceof Promise)throw new Error(`Tool result for '${d}' cannot be a Promise`);return s.LanguageModelToolResult.from(l)}registerTool(u,E,p){return this.a.set(E,{extension:u,tool:p}),this.b.$registerTool(E),(0,L.$Xc)(()=>{this.a.delete(E),this.b.$unregisterTool(E)})}}e.$xsc=I}),define(Re[95],Te([1,0,10,19,42,12,6,41,4,9,18,3,11,77,5,91,16,8,7,119,21]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i,n){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Irc=e.$Hrc=void 0,d=Ve(d),a=Ve(a),e.$Hrc=(0,w.$Ki)("IExtHostLanguageModels");class o{constructor(h,S){this.option=h,this.stream=new v.$bi,this.stream=S??new v.$bi}}class c{constructor(){this.a=new Map,this.b=new v.$bi,this.c=!1;const h=this;this.apiObject={get stream(){return h.b.asyncIterable},get text(){return v.$$h.map(h.b.asyncIterable,S=>{if(S instanceof a.$uQ)return S.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,h]of this.a)yield h.stream;else yield this.b}handleFragment(h){if(this.c)return;let S=this.a.get(h.index);S||(this.a.size===0?S=new o(h.index,this.b):S=new o(h.index),this.a.set(h.index,S));let k;h.part.type==="text"?k=new a.$uQ(h.part.value):k=new a.$tQ(h.part.name,h.part.toolCallId,h.part.parameters),S.stream.emitOne(k)}reject(h){this.c=!0;for(const S of this.d())S.reject(h)}resolve(){this.c=!0;for(const h of this.d())h.resolve()}}let g=class{static{t=this}static{this.a=1}constructor(h,S,k){this.j=S,this.k=k,this.c=new R.$qe,this.d=new R.$qe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$zn,this.i=new Map,this.s=new Set,this.b=h.getProxy(p.$0N.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(h,S,k,y){const C=t.a++;this.f.set(C,{extension:h.identifier,provider:k,languageModelId:S});let T;y.auth&&(T={providerLabel:h.displayName||h.name,accountLabel:typeof y.auth=="object"?y.auth.label:void 0}),this.b.$registerLanguageModelProvider(C,`${I.$xn.toKey(h.identifier)}/${C}/${S}`,{extension:h.identifier,id:S,vendor:y.vendor??I.$xn.toKey(h.identifier),name:y.name??"",family:y.family??"",version:y.version,maxInputTokens:y.maxInputTokens,maxOutputTokens:y.maxOutputTokens,auth:T,targetExtensions:y.extensions});const $=k.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:N,tokenCount:A})=>{this.b.$whenLanguageModelChatRequestMade(S,new I.$xn(b),N,A)});return(0,m.$Xc)(()=>{this.f.delete(C),this.b.$unregisterProvider(C),$?.dispose()})}async $startChatRequest(h,S,k,y,C,T){const $=this.f.get(h);if(!$)throw new Error("Provider not found");const b=new E.$Iw(async A=>{if(T.isCancellationRequested){this.j.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let F;if(A.part instanceof a.$tQ?F={type:"tool_use",name:A.part.name,parameters:A.part.parameters,toolCallId:A.part.toolCallId}:A.part instanceof a.$uQ&&(F={type:"text",value:A.part.value}),!F){this.j.warn(`[CHAT](${$.extension.value}) UNKNOWN part ${JSON.stringify(A)}`);return}this.b.$reportResponsePart(S,{index:A.index,part:F})});let N;if($.provider.provideLanguageModelResponse2)N=Promise.resolve($.provider.provideLanguageModelResponse2(y.map(d.LanguageModelChatMessage.to),C,I.$xn.toKey(k),b,T));else{const A=new E.$Iw(async F=>{b.report({index:F.index,part:new a.$uQ(F.part)})});N=Promise.resolve($.provider.provideLanguageModelResponse(y.map(d.LanguageModelChatMessage.to),C?.modelOptions??{},I.$xn.toKey(k),A,T))}N.then(()=>{this.b.$reportResponseDone(S,void 0)},A=>{this.b.$reportResponseDone(S,(0,L.$6)(A))})}$provideTokenLength(h,S,k){const y=this.f.get(h);return y?Promise.resolve(y.provider.provideTokenCount(S,k)):Promise.resolve(0)}$acceptChatModelMetadata(h){if(h.added)for(const{identifier:S,metadata:k}of h.added)this.g.set(S,{metadata:k,apiObjects:new I.$zn});if(h.removed)for(const S of h.removed){this.g.delete(S);for(const[k,y]of this.i)y.languageModelId===S&&(y.res.reject(new L.$9),this.i.delete(k))}h.added?.forEach(S=>this.q(S.metadata)),this.d.fire(void 0)}async selectLanguageModels(h,S){const k=await this.b.$selectChatModels({...S,extension:h.identifier}),y=[],C=this;for(const T of k){const $=this.g.get(T);if(!$)continue;this.o(h.identifier,$.metadata)&&await this.q($.metadata);let b=$.apiObjects.get(h.identifier);b||(b={id:T,vendor:$.metadata.vendor,family:$.metadata.family,version:$.metadata.version,name:$.metadata.name,maxInputTokens:$.metadata.maxInputTokens,countTokens(N,A){if(!C.g.has(T))throw a.$yQ.NotFound(T);return C.r(T,N,A??D.CancellationToken.None)},sendRequest(N,A,F){if(!C.g.has(T))throw a.$yQ.NotFound(T);return C.l(h,T,N,A??{},F??D.CancellationToken.None)}},Object.freeze(b),$.apiObjects.set(h.identifier,b)),y.push(b)}return y}async l(h,S,k,y,C){const T=this.m(h,k),$=h.identifier,b=this.g.get(S)?.metadata;if(!b||!this.g.has(S))throw a.$yQ.NotFound(`Language model '${S}' is unknown.`);if(this.o($,b)&&(!await this.n(h,{identifier:b.extension,displayName:b.auth.providerLabel},y.justification,!1)||!this.h.get($)?.has(b.extension)))throw a.$yQ.NoPermissions(`Language model '${S}' cannot be used by '${$.value}'.`);try{const N=Math.random()*1e6|0,A=new c;this.i.set(N,{languageModelId:S,res:A});try{await this.b.$tryStartChatRequest($,S,N,T,y,C)}catch(F){throw this.i.delete(N),F}return A.apiObject}catch(N){throw N.name===a.$yQ.name?N:new a.$yQ(`Language model '${S}' errored: ${(0,P.$vj)(N)}`,"Unknown",N)}}m(h,S){const k=[];for(const y of S)y.role===a.LanguageModelChatMessageRole.System&&(0,n.$zH)(h,"languageModelSystem"),y.content2.some(C=>C instanceof a.$rQ)&&(0,n.$zH)(h,"lmTools"),k.push(d.LanguageModelChatMessage.from(y));return k}async $acceptResponsePart(h,S){const k=this.i.get(h);k&&k.res.handleFragment(S)}async $acceptResponseDone(h,S){const k=this.i.get(h);k&&(this.i.delete(h),S?k.res.reject((0,L.$7)(S)):k.res.resolve())}async n(h,S,k,y){const C=i.$aN+S.identifier.value;if(await this.k.getSession(h,C,[],{silent:!0}))return this.$updateModelAccesslist([{from:h.identifier,to:S.identifier,enabled:!0}]),!0;if(y)return!1;try{const $=k?(0,s.localize)(2705,null,S.displayName,k):void 0;return await this.k.getSession(h,C,[],{forceNewSession:{detail:$}}),this.$updateModelAccesslist([{from:h.identifier,to:S.identifier,enabled:!0}]),!0}catch{return!1}}o(h,S){return!!S.auth&&!I.$xn.equals(S.extension,h)}async q(h){if(h.auth)for(const S of this.s)try{await this.n(S,{identifier:h.extension,displayName:""},void 0,!0)}catch(k){this.j.error("Fake Auth request failed"),this.j.error(k)}}async r(h,S,k){if(!this.g.get(h))throw a.$yQ.NotFound(`Language model '${h}' is unknown.`);const C=O.Iterable.find(this.f.values(),T=>T.languageModelId===h);return C?C.provider.provideTokenCount(S,k):this.b.$countTokens(h,typeof S=="string"?S:d.LanguageModelChatMessage.from(S),k)}$updateModelAccesslist(h){const S=new Array;for(const{from:k,to:y,enabled:C}of h){const T=this.h.get(k)??new I.$yn;if(T.has(y)!==C){C?T.add(y):T.delete(y),this.h.set(k,T);const b={from:k,to:y};S.push(b),this.c.fire(b)}}}createLanguageModelAccessInformation(h){this.s.add(h);const S=this,k=R.Event.signal(R.Event.filter(this.c.event,C=>I.$xn.equals(C.from,h.identifier))),y=R.Event.signal(this.d.event);return{get onDidChange(){return R.Event.any(k,y)},canSendRequest(C){let T;e:for(const[b,N]of S.g)for(const A of N.apiObjects.values())if(A===C){T=N.metadata;break e}if(!T)return;if(!S.o(h.identifier,T))return!0;const $=S.h.get(h.identifier);if($)return $.has(T.extension)}}}};e.$Irc=g,e.$Irc=g=t=He([qe(0,l.$KQ),qe(1,u.$fk),qe(2,r.$3qc)],g)});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[244],Te([1,0,5,8,7,37,10,4,21]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ysc=void 0,D=Ve(D),L=oi(L);class s{constructor(w,u,E,p){this.c=u,this.d=E,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=w.getProxy(v.$0N.MainThreadLanguages)}$acceptLanguageIds(w){this.b=w}async getLanguages(){return this.b.slice(0)}async changeLanguage(w,u){await this.a.$changeLanguage(w,u);const E=this.c.getDocumentData(w);if(!E)throw new Error(`document '${w.toString()}' NOT found`);return E.document}async tokenAtPosition(w,u){const E=w.version,p=D.Position.from(u),r=await this.a.$tokensAtPosition(w.uri,p),l={type:P.StandardTokenType.Other,range:w.getWordRangeAtPosition(u)??new P.$bO(u.line,u.character,u.line,u.character)};if(!r)return l;const d={range:D.Range.to(r.range),type:D.TokenType.to(r.type)};return!d.range.contains(u)||E!==w.version?l:d}createLanguageStatusItem(w,u,E){const p=this.f++,r=this.a,l=this.g,d=`${w.identifier.value}/${u}`;if(l.has(d))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);l.add(d);const a={selector:E,id:u,name:w.displayName??w.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const n=new O.$Yc,t=()=>{if(i?.dispose(),!l.has(d)){console.warn(`LanguageStatusItem (${u}) from ${w.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.$Mh)(()=>{n.clear(),this.a.$setLanguageStatus(p,{id:d,name:a.name??w.displayName??w.name,source:w.displayName??w.name,selector:D.DocumentSelector.from(a.selector,this.e),label:a.text,detail:a.detail??"",severity:a.severity===P.LanguageStatusSeverity.Error?L.default.Error:a.severity===P.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:a.command&&this.d.toInternal(a.command,n),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},o={dispose(){n.dispose(),i?.dispose(),r.$removeLanguageStatus(p),l.delete(d)},get id(){return a.id},get name(){return a.name},set name(c){a.name=c,t()},get selector(){return a.selector},set selector(c){a.selector=c,t()},get text(){return a.text},set text(c){a.text=c,t()},set text2(c){(0,m.$zH)(w,"languageStatusText"),a.text=c,t()},get text2(){return(0,m.$zH)(w,"languageStatusText"),a.text},get detail(){return a.detail},set detail(c){a.detail=c,t()},get severity(){return a.severity},set severity(c){a.severity=c,t()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(c){a.accessibilityInformation=c,t()},get command(){return a.command},set command(c){a.command=c,t()},get busy(){return a.busy},set busy(c){a.busy=c,t()}};return t(),o}}e.$ysc=s}),define(Re[245],Te([1,0,15,2,8,7,90]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fsc=e.$esc=void 0,P=Ve(P),R=Ve(R);class O{constructor(w,u,E,p){this.start=w,this.deletedCount=u,this.deletedItems=E,this.items=p}asApiEvent(){return{range:new L.$DP(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1}}constructor(w,u,E){this.notebook=w,this.h=u,this.j=E,this.handle=E.handle,this.uri=D.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(P.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const w=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return w.g},set mime(p){w.g=p},get outputs(){return w.a.slice(0)},get metadata(){return w.b},get executionSummary(){return w.d}};this.f=Object.freeze(E)}return this.f}setOutputs(w){this.a=w.map(P.NotebookCellOutput.to)}setOutputItems(w,u,E){const p=E.map(P.NotebookCellOutputItem.to),r=this.a.find(l=>l.id===w);if(r&&(u||(r.items.length=0),r.items.push(...p),r.items.length>1&&r.items.every(l=>R.$$L(l.mime)))){const l=new Map,d=[];r.items.forEach(a=>{let i;l.has(a.mime)?i=l.get(a.mime):(i=[],l.set(a.mime,i),d.push(a.mime)),i.push(a.data)}),r.items.length=0,d.forEach(a=>{const i=R.$_L(l.get(a));r.items.push({mime:a,data:i.data.buffer})})}}setMetadata(w){this.b=Object.freeze(w)}setInternalMetadata(w){this.e=w,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.$esc=m;class s{static{this.a=0}constructor(w,u,E,p,r){this.k=w,this.l=u,this.m=E,this.uri=p,this.handle=s.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const w=this,u={get uri(){return w.uri},get version(){return w.g},get notebookType(){return w.d},get isDirty(){return w.h},get isUntitled(){return w.uri.scheme===v.Schemas.untitled},get isClosed(){return w.j},get metadata(){return w.f},get cellCount(){return w.b.length},cellAt(E){return E=w.n(E),w.b[E].apiCell},getCells(E){return(E?w.p(E):w.b).map(r=>r.apiCell)},save(){return w.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(w){w.metadata&&(this.f=Object.freeze({...this.f,...w.metadata}))}acceptDirty(w){this.h=w}acceptModelChanged(w,u,E){this.g=w.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:E});const p={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},r=[];for(const d of w.rawEvents)d.kind===R.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,p.contentChanges):d.kind===R.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,p.contentChanges):d.kind===R.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),r.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===R.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),r.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),r.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),r.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),r.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const l=new Map;for(let d=0;d<r.length;d++){const a=r[d],i=l.get(a.cell);if(i===void 0){const n=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});l.set(a.cell,n-1)}else p.cellChanges[i]={...p.cellChanges[i],...a}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(w){return w=w|0,w<0?0:w>=this.b.length?this.b.length-1:w}o(w){let u=w.start|0,E=w.end|0;return u<0&&(u=0),E>this.b.length&&(E=this.b.length),w.with({start:u,end:E})}p(w){w=this.o(w);const u=[];for(let E=w.start;E<w.end;E++)u.push(this.b[E]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(w,u,E){if(this.j)return;const p=[],r=[],l=[];if(w.reverse().forEach(d=>{const i=d[2].map(o=>{const c=new m(this,this.l,o);return u||r.push(m.asModelAddData(o)),c}),n=new O(d[0],d[1],[],i),t=this.b.splice(d[0],d[1],...i);for(const o of t)l.push(o.uri),n.deletedItems.push(o.apiCell);p.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:l}),E)for(const d of p)E.push(d.asApiEvent())}s(w,u,E,p){const r=this.b.splice(w,u);this.b.splice(E,0,...r);const l=[new O(w,u,r.map(d=>d.apiCell),[]),new O(E,0,[],r)];for(const d of l)p.push(d.asApiEvent())}t(w,u){this.b[w].setOutputs(u)}u(w,u,E,p){this.b[w].setOutputItems(u,E,p)}v(w,u){const E=this.b[w];E.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(E.uri,u)}w(w,u){const E=this.b[w];E.apiCell.mime=u}x(w,u){this.b[w].setMetadata(u)}y(w,u){this.b[w].setInternalMetadata(u)}getCellFromApiCell(w){return this.b.find(u=>u.apiCell===w)}getCellFromIndex(w){return this.b[w]}getCell(w){return this.b.find(u=>u.handle===w)}getCellIndex(w){return this.b.indexOf(w)}}e.$fsc=s}),define(Re[246],Te([1,0,6,2,8,7,39]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Asc=void 0;class O{constructor(s,I,w,u={timeout:1500,errors:3}){this.b=s,this.c=I,this.d=w,this.f=u,this.a=new v.$se}dispose(){}getOnWillSaveNotebookDocumentEvent(s){return(I,w,u)=>{const E=function(r){I.call(w,r)};return E.extension=s,this.a.event(E,void 0,u)}}async $participateInSave(s,I,w){const u=D.URI.revive(s),E=this.c.getNotebookDocument(u);if(!E)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:P.TextDocumentSaveReason.to(I)},w,async(l,d)=>{const a=Date.now(),i=await await Promise.resolve(l);Date.now()-a>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier),!w.isCancellationRequested&&i&&(i instanceof L.$lO?p.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier,"ignored due to invalid data"))}),w.isCancellationRequested)return!1;if(p.length===0)return!0;const r={edits:[]};for(const l of p){const{edits:d}=P.WorkspaceEdit.from(l);r.edits=r.edits.concat(d)}return this.d.$tryApplyWorkspaceEdit(new R.$7w(r))}}e.$Asc=O}),define(Re[126],Te([1,0,12,8,7]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gsc=void 0,D=Ve(D),P=Ve(P);class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(O,m,s,I,w,u){this.id=O,this.f=m,this.notebookData=s,this.a=[],this.b=[],this.d=!1,this.a=w,this.b=I,this.c=u}get apiEditor(){if(!this.e){const O=this;this.e={get notebook(){return O.notebookData.apiNotebook},get selection(){return O.a[0]},set selection(m){this.selections=[m]},get selections(){return O.a},set selections(m){if(!Array.isArray(m)||!m.every(P.$DP.isNotebookRange))throw(0,v.$$)("selections");O.a=m,O.g(m)},get visibleRanges(){return O.b},revealRange(m,s){O.f.$tryRevealRange(O.id,D.NotebookRange.from(m),s??P.NotebookEditorRevealType.Default)},get viewColumn(){return O.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(O){this.d=O}_acceptVisibleRanges(O){this.b=O}_acceptSelections(O){this.a=O}g(O){this.f.$trySetSelections(this.id,O.map(D.NotebookRange.from))}_acceptViewColumn(O){this.c=O}}e.$gsc=L}),define(Re[247],Te([1,0,6,11,8]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Csc=void 0,P=Ve(P);let L=class{constructor(O,m){this.c=O,this.d=m,this.a=new v.$qe,this.b=new v.$qe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(O,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",O,m);const s=this.d.getEditorById(O);m.visibleRanges&&s._acceptVisibleRanges(m.visibleRanges.ranges.map(P.NotebookRange.to)),m.selections&&s._acceptSelections(m.selections.selections.map(P.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:s.apiEditor,visibleRanges:s.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:s.apiEditor,selections:s.apiEditor.selections}))}$acceptEditorViewColumns(O){for(const m in O)this.d.getEditorById(m)._acceptViewColumn(P.ViewColumn.to(O[m]))}};e.$Csc=L,e.$Csc=L=He([qe(0,D.$fk)],L)}),define(Re[248],Te([1,0,6,5,126]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fsc=void 0;class L{constructor(O,m){this.c=m,this.a=new Map,this.b=O.getProxy(D.$0N.MainThreadNotebookRenderers)}$postRendererMessage(O,m,s){const I=this.c.getEditorById(O);this.a.get(m)?.fire({editor:I.apiEditor,message:s})}createRendererMessaging(O,m){if(!O.contributes?.notebookRenderer?.some(I=>I.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(I,w,u)=>this.d(m).event(I,w,u),postMessage:(I,w)=>{P.$gsc.apiEditorsToExtHost.has(I)&&([I,w]=[w,I]);const u=w&&P.$gsc.apiEditorsToExtHost.get(w);return this.b.$postMessage(u?.id,m,I)}}}d(O){let m=this.a.get(O);return m||(m=new v.$qe({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete(O)}}),this.a.set(O,m),m)}}e.$Fsc=L}),define(Re[249],Te([1,0,8,77,19,71,12]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jsc=void 0;class O{constructor(w){this.b=0,this.c=new Map,this.a=w}async withProgress(w,u,E){const p=this.b++,{title:r,location:l,cancellable:d}=u,a={label:w.displayName||w.name,id:w.identifier.value};return this.a.$startProgress(p,{location:v.ProgressLocation.from(l),title:r,source:a,cancellable:d},w.isUnderDevelopment?void 0:w.identifier.value).catch(R.$5),this.d(p,E,!!d)}d(w,u,E){let p;E&&(p=new P.$Be,this.c.set(w,p));const r=d=>{this.a.$progressEnd(d),this.c.delete(d),p?.dispose()};let l;try{l=u(new s(this.a,w),E&&p?p.token:P.CancellationToken.None)}catch(d){throw r(w),d}return l.then(d=>r(w),d=>r(w)),l}$acceptProgressCanceled(w){const u=this.c.get(w);u&&(u.cancel(),this.c.delete(w))}}e.$Jsc=O;function m(I,w){return I.message=w.message,typeof w.increment=="number"&&(typeof I.increment=="number"?I.increment+=w.increment:I.increment=w.increment),I}class s extends D.$Iw{constructor(w,u){super(E=>this.throttledReport(E)),this.c=w,this.d=u}throttledReport(w){this.c.$progressReport(this.d,w)}}He([(0,L.$ei)(100,(I,w)=>m(I,w),()=>Object.create(null))],s.prototype,"throttledReport",null)}),define(Re[250],Te([1,0,2,5,10,8]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ksc=void 0;class R{static{this.a=0}constructor(m,s){this.d=s,this.c=new Map,this.b=m.getProxy(D.$0N.MainThreadQuickDiff)}$provideOriginalResource(m,s,I){const w=v.URI.revive(s),u=this.c.get(m);return u?(0,P.$Ch)(()=>u.provideOriginalResource(w,I)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(m,s,I,w){const u=R.a++;return this.c.set(u,s),this.b.$registerQuickDiffProvider(u,L.DocumentSelector.from(m,this.d),I,w),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Ksc=R});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[251],Te([1,0,19,6,4,5,2,7,12,17,37,36,21,8]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lsc=p,I=oi(I);function p(r,l,d){const a=r.getProxy(L.$0N.MainThreadQuickOpen);class i{constructor(k,y){this.e=new Map,this.f=0,this.a=k,this.b=y}showQuickPick(k,y,C,T=v.CancellationToken.None){this.c=void 0;const $=Promise.resolve(y),b=++this.f,N=a.$show(b,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},T),A={},F=N.then(()=>A);return Promise.race([F,$]).then(G=>{if(G===A)return;const x=(0,u.$yH)(k,"quickPickItemTooltip");return $.then(j=>{const U=[];for(let J=0;J<j.length;J++){const Z=j[J];if(typeof Z=="string")U.push({label:Z,handle:J});else if(Z.kind===O.QuickPickItemKind.Separator)U.push({type:"separator",label:Z.label});else{Z.tooltip&&!x&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const ae=Z.iconPath?g(Z.iconPath):void 0;U.push({label:Z.label,iconPath:ae?.iconPath,iconClass:ae?.iconClass,description:Z.description,detail:Z.detail,picked:Z.picked,alwaysShow:Z.alwaysShow,tooltip:x?E.MarkdownString.fromStrict(Z.tooltip):void 0,handle:J})}}return C&&typeof C.onDidSelectItem=="function"&&(this.c=J=>{C.onDidSelectItem(j[J])}),a.$setItems(b,U),N.then(J=>{if(typeof J=="number")return j[J];if(Array.isArray(J))return J.map(Z=>j[Z])})})}).then(void 0,G=>{if(!(0,m.$8)(G))return a.$setError(b,G),Promise.reject(G)})}$onItemSelected(k){this.c?.(k)}showInput(k,y=v.CancellationToken.None){return this.d=k?.validateInput,a.$input(k,typeof this.d=="function",y).then(void 0,C=>{if(!(0,m.$8)(C))return Promise.reject(C)})}async $validateInput(k){if(!this.d)return;const y=await this.d(k);if(!y||typeof y=="string")return y;let C;switch(y.severity){case O.InputBoxValidationSeverity.Info:C=I.default.Info;break;case O.InputBoxValidationSeverity.Warning:C=I.default.Warning;break;case O.InputBoxValidationSeverity.Error:C=I.default.Error;break;default:C=y.message?I.default.Error:I.default.Ignore;break}return{content:y.message,severity:C}}async showWorkspaceFolderPick(k,y=v.CancellationToken.None){const C=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!C)return;const T=await this.a.getWorkspaceFolders2();if(T)return T.find($=>$.uri.toString()===C.uri.toString())}createQuickPick(k){const y=new f(k,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(k){const y=new h(k,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(k,y){this.e.get(k)?._fireDidChangeValue(y)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,y){const C=this.e.get(k);C instanceof f&&C._fireDidChangeActive(y)}$onDidChangeSelection(k,y){const C=this.e.get(k);C instanceof f&&C._fireDidChangeSelection(y)}$onDidTriggerButton(k,y){this.e.get(k)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(k,y,C){const T=this.e.get(k);T instanceof f&&T._fireDidTriggerItemButton(y,C)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class n{static{this.a=1}constructor(k,y){this.x=k,this.y=y,this._id=f.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new D.$qe,this.q=new D.$qe,this.r=new D.$qe,this.s=new D.$qe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){const y=(0,u.$yH)(this.x,"quickInputButtonLocation");!y&&k.some(C=>C.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=k.slice(),this.o.clear(),k.forEach((C,T)=>{const $=C===O.$AP.Back?-1:T;this.o.set($,C)}),this.z({buttons:k.map((C,T)=>({...g(C.iconPath),tooltip:C.tooltip,handle:C===O.$AP.Back?-1:T,location:y?C.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const y=this.o.get(k);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Uc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),a.$dispose(this._id))}z(k){if(!this.v){for(const y of Object.keys(k)){const C=k[y];this.u[y]=C===void 0?null:C}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){a.$createOrUpdate(this.u),this.u={id:this._id}}}function t(S){if(S instanceof O.$$O)return{id:S.id};const k=c(S),y=o(S);return{dark:typeof k=="string"?R.URI.file(k):k,light:typeof y=="string"?R.URI.file(y):y}}function o(S){return typeof S=="object"&&"light"in S?S.light:S}function c(S){return typeof S=="object"&&"dark"in S?S.dark:S}function g(S){const k=t(S);let y,C;return"id"in k?C=w.ThemeIcon.asClassName(k):y=k,{iconPath:y,iconClass:C}}class f extends n{constructor(k,y){super(k,y),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new D.$qe,this.L=[],this.M=new D.$qe,this.N=new D.$qe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((T,$)=>{this.C.set($,T),this.D.set(T,$)});const y=(0,u.$yH)(this.x,"quickPickItemTooltip"),C=[];for(let T=0;T<k.length;T++){const $=k[T];if($.kind===O.QuickPickItemKind.Separator)C.push({type:"separator",label:$.label});else{$.tooltip&&!y&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const b=$.iconPath?g($.iconPath):void 0;C.push({handle:T,label:$.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,tooltip:y?E.MarkdownString.fromStrict($.tooltip):void 0,buttons:$.buttons?.map((N,A)=>({...g(N.iconPath),tooltip:N.tooltip,handle:A}))})}}this.z({items:C})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(k){const y=(0,s.$Lb)(k.map(C=>this.C.get(C)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(k){const y=(0,s.$Lb)(k.map(C=>this.C.get(C)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(k,y){const C=this.C.get(k);if(!C||!C.buttons||!C.buttons.length)return;const T=C.buttons[y];T&&this.N.fire({button:T,item:C})}}class h extends n{constructor(k,y){super(k,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:I.default.Error}):this.z({validationMessage:k.message,severity:k.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(l,d)}}),define(Re[252],Te([1,0,2,6,71,4,10,5,17,158,11,18,38,36,8,21,15,23]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nsc=e.$Msc=void 0;function i(A){return A instanceof v.URI}function n(A,F){return A.scheme===l.Schemas.file&&F.scheme===l.Schemas.file&&d.$n?A.toString()===F.toString():A.toString().toLowerCase()===F.toString().toLowerCase()}function t(A){if(A)return typeof A.iconPath=="string"?v.URI.file(A.iconPath):v.URI.isUri(A.iconPath)||E.ThemeIcon.isThemeIcon(A.iconPath)?A.iconPath:void 0}function o(A){if(A){if(v.URI.isUri(A))return A;if(E.ThemeIcon.isThemeIcon(A))return A;{const F=A;return{light:F.light,dark:F.dark}}}else return}function c(A){const F=o(A.icon),G=A.labels?.map(x=>({title:x.title,icon:o(x.icon)}));return{...A,icon:F,labels:G}}function g(A,F){if(!A.iconPath&&!F.iconPath)return 0;if(A.iconPath){if(!F.iconPath)return 1}else return-1;const G=typeof A.iconPath=="string"?A.iconPath:v.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id,x=typeof F.iconPath=="string"?F.iconPath:v.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,s.$Sr)(G,x)}function f(A,F){let G=0;if(A.strikeThrough!==F.strikeThrough)return A.strikeThrough?1:-1;if(A.faded!==F.faded)return A.faded?1:-1;if(A.tooltip!==F.tooltip)return(A.tooltip||"").localeCompare(F.tooltip||"");if(G=g(A,F),G!==0)return G;if(A.light&&F.light)G=g(A.light,F.light);else{if(A.light)return 1;if(F.light)return-1}if(G!==0)return G;if(A.dark&&F.dark)G=g(A.dark,F.dark);else{if(A.dark)return 1;if(F.dark)return-1}return G}function h(A,F){if(A.command!==F.command)return A.command<F.command?-1:1;if(A.title!==F.title)return A.title<F.title?-1:1;if(A.tooltip!==F.tooltip){if(A.tooltip!==void 0&&F.tooltip!==void 0)return A.tooltip<F.tooltip?-1:1;if(A.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(A.arguments===F.arguments)return 0;if(A.arguments)if(F.arguments){if(A.arguments.length!==F.arguments.length)return A.arguments.length-F.arguments.length}else return 1;else return-1;for(let G=0;G<A.arguments.length;G++){const x=A.arguments[G],j=F.arguments[G];if(x!==j&&!(i(x)&&i(j)&&n(x,j)))return x<j?-1:1}return 0}function S(A,F){let G=(0,s.$Sr)(A.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(G!==0)return G;if(A.command&&F.command)G=h(A.command,F.command);else{if(A.command)return 1;if(F.command)return-1}if(G!==0)return G;if(A.decorations&&F.decorations)G=f(A.decorations,F.decorations);else{if(A.decorations)return 1;if(F.decorations)return-1}if(A.multiFileDiffEditorModifiedUri&&F.multiFileDiffEditorModifiedUri)G=(0,s.$Sr)(A.multiFileDiffEditorModifiedUri.fsPath,F.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(A.multiFileDiffEditorModifiedUri)return 1;if(F.multiFileDiffEditorModifiedUri)return-1}if(A.multiDiffEditorOriginalUri&&F.multiDiffEditorOriginalUri)G=(0,s.$Sr)(A.multiDiffEditorOriginalUri.fsPath,F.multiDiffEditorOriginalUri.fsPath,!0);else{if(A.multiDiffEditorOriginalUri)return 1;if(F.multiDiffEditorOriginalUri)return-1}return G}function k(A,F){for(let G=0;G<A.length;G++)if(A[G]!==F[G])return!1;return!0}function y(A,F){return A.command===F.command&&A.title===F.title&&A.tooltip===F.tooltip&&(A.arguments&&F.arguments?k(A.arguments,F.arguments):A.arguments===F.arguments)}function C(A,F){return(0,m.$yb)(A,F,y)}class T{#e;#t;get value(){return this.d}set value(F){F=F??"",this.#e.$setInputBoxValue(this.m,F),this.o(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){this.#e.$setInputBoxPlaceholder(this.m,F),this.f=F}get validateInput(){return(0,r.$zH)(this.k,"scmValidation"),this.g}set validateInput(F){if((0,r.$zH)(this.k,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=F,this.#e.$setValidationProviderIsEnabled(this.m,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,this.#e.$setInputBoxEnablement(this.m,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,this.#e.$setInputBoxVisibility(this.m,F))}get document(){return(0,r.$zH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(F,G,x,j,U){this.k=F,this.m=j,this.n=U,this.d="",this.e=new D.$qe,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=x}showValidationMessage(F,G){(0,r.$zH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,F,G)}$onInputBoxValueChange(F){this.o(F)}o(F){this.d=F,this.e.fire(F)}}e.$Msc=T;class ${static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(F){this.w=F,this.s.$updateGroupLabel(this.u,this.handle,F)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(F){this.q=F,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,G,x,j,U,J,Z){this.s=F,this.t=G,this.u=x,this.v=j,this.w=U,this.multiDiffEditorEnableViewChanges=J,this.x=Z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new D.$qe,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new D.$qe,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=$.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,G){const x=this.h.get(F);return x?(0,R.$Ch)(()=>this.t.executeCommand(x.command,...x.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(S),x=(0,m.$Hb)(this.p,F,S).map(J=>{const Z=J.toInsert.map(ae=>{const ee=this.e++;this.g.set(ee,ae);const oe=ae.resourceUri;let ie;if(ae.command)if(ae.command.command==="vscode.open"||ae.command.command==="vscode.diff"||ae.command.command==="vscode.changes"){const nt=new L.$Yc;ie=this.t.converter.toInternal(ae.command,nt),this.j.set(ee,nt)}else this.h.set(ee,ae.command);const ue=(0,r.$yH)(this.x,"scmMultiDiffEditor"),_=ue?ae.multiDiffEditorOriginalUri:void 0,$e=ue?ae.multiFileDiffEditorModifiedUri:void 0,Ie=t(ae.decorations),X=ae.decorations&&t(ae.decorations.light)||Ie,V=ae.decorations&&t(ae.decorations.dark)||Ie,re=[X,V],be=ae.decorations&&ae.decorations.tooltip||"",Pe=ae.decorations&&!!ae.decorations.strikeThrough,Fe=ae.decorations&&!!ae.decorations.faded,Be=ae.contextValue||"";return{rawResource:[ee,oe,re,be,Pe,Fe,Be,ie,_,$e],handle:ee}});return{start:J.start,deleteCount:J.deleteCount,toInsert:Z}}),j=x.map(({start:J,deleteCount:Z,toInsert:ae})=>[J,Z,ae.map(ee=>ee.rawResource)]),U=x.reverse();for(const{start:J,deleteCount:Z,toInsert:ae}of U){const ee=ae.map(ie=>ie.handle),oe=this.o.splice(J,Z,...ee);for(const ie of oe)this.g.delete(ie),this.h.delete(ie),this.j.get(ie)?.dispose(),this.j.delete(ie)}return this.p=F,j}dispose(){this.m=!0,this.n.fire()}}class b{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,this.#e.$updateSourceControl(this.x,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let G;(0,r.$yH)(this.y,"quickDiffProvider")&&(G=F?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!F,quickDiffLabel:G})}get historyProvider(){return(0,r.$zH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(F){(0,r.$zH)(this.y,"scmHistoryProvider"),this.j=F,this.k.value=new L.$Yc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!F}),F&&this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{this.m=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(F){F!==this.n&&(this.n=F,this.#e.$updateSourceControl(this.x,{commitTemplate:F}))}get acceptInputCommand(){return this.p}set acceptInputCommand(F){this.o.value=new L.$Yc,this.p=F;const G=this.z.converter.toInternal(F,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:G})}get actionButton(){return(0,r.$zH)(this.y,"scmActionButton"),this.s}set actionButton(F){(0,r.$zH)(this.y,"scmActionButton"),this.q.value=new L.$Yc,this.s=F;const G=F!==void 0?{command:this.z.converter.toInternal(F.command,this.q.value),secondaryCommands:F.secondaryCommands?.map(x=>x.map(j=>this.z.converter.toInternal(j,this.q.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:G??null})}get statusBarCommands(){return this.u}set statusBarCommands(F){if(this.u&&F&&C(this.u,F))return;this.t.value=new L.$Yc,this.u=F;const G=(F||[]).map(x=>this.z.converter.toInternal(x,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:G})}get selected(){return this.v}constructor(F,G,x,j,U,J,Z){this.y=F,this.z=j,this.A=U,this.B=J,this.C=Z,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$1c,this.n=void 0,this.o=new L.$1c,this.p=void 0,this.q=new L.$1c,this.t=new L.$1c,this.u=void 0,this.v=!1,this.w=new D.$qe,this.onDidChangeSelection=this.w.event,this.x=b.d++,this.D=new Map,this.E=new Set,this.#e=x;const ae=v.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:Z?`rootUri=${encodeURIComponent(Z.toString())}`:void 0});this.f=new T(F,G,this.#e,this.x,ae),this.#e.$registerSourceControl(this.x,U,J,Z,ae)}createResourceGroup(F,G,x){const j=(0,r.$yH)(this.y,"scmMultiDiffEditor")&&x?.multiDiffEditorEnableViewChanges===!0,U=new $(this.#e,this.z,this.x,F,G,j,this.y),J=D.Event.once(U.onDidDispose)(()=>this.D.delete(U));return this.D.set(U,J),this.eventuallyAddResourceGroups(),U}eventuallyAddResourceGroups(){const F=[],G=[];for(const[x,j]of this.D){j.dispose();const U=x.onDidUpdateResourceStates(()=>{this.E.add(x),this.eventuallyUpdateResourceStates()});D.Event.once(x.onDidDispose)(()=>{this.E.delete(x),U.dispose(),this.e.delete(x.handle),this.#e.$unregisterGroup(this.x,x.handle)}),F.push([x.handle,x.id,x.label,x.features,x.multiDiffEditorEnableViewChanges]);const J=x._takeResourceStateSnapshot();J.length>0&&G.push([x.handle,J]),this.e.set(x.handle,x)}this.#e.$registerGroups(this.x,F,G),this.D.clear()}eventuallyUpdateResourceStates(){const F=[];this.E.forEach(G=>{const x=G._takeResourceStateSnapshot();x.length!==0&&F.push([G.handle,x])}),F.length>0&&this.#e.$spliceResourceStates(this.x,F),this.E.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.v=F,this.w.fire(F)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,P.$di)(100)],b.prototype,"eventuallyAddResourceGroups",null),He([(0,P.$di)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let N=class{static{a=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(F,G,x,j){this.m=G,this.n=x,this.o=j,this.g=new Map,this.h=new w.$zn,this.j=new D.$qe,this.e=F.getProxy(O.$0N.MainThreadSCM),this.f=F.getProxy(O.$0N.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===u.MarshalledId.ScmResource){const J=this.g.get(U.sourceControlHandle);if(!J)return U;const Z=J.getResourceGroup(U.groupHandle);return Z?Z.getResourceState(U.handle):U}else if(U&&U.$mid===u.MarshalledId.ScmResourceGroup){const J=this.g.get(U.sourceControlHandle);return J?J.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===u.MarshalledId.ScmProvider){const J=this.g.get(U.handle);return J||U}return U}})}createSourceControl(F,G,x,j){this.o.trace("ExtHostSCM#createSourceControl",F.identifier.value,G,x,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const U=a.d++,J=new b(F,this.n,this.e,this.m,G,x,j);this.g.set(U,J);const Z=this.h.get(F.identifier)||[];return Z.push(J),this.h.set(F.identifier,Z),J}getLastInputBox(F){this.o.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const G=this.h.get(F.identifier),x=G&&G[G.length-1];return x&&x.inputBox}$provideOriginalResource(F,G,x){const j=v.URI.revive(G);this.o.trace("ExtHostSCM#$provideOriginalResource",F,j.toString());const U=this.g.get(F);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Ch)(()=>U.quickDiffProvider.provideOriginalResource(j,x)).then(J=>J||null)}$onInputBoxValueChange(F,G){this.o.trace("ExtHostSCM#$onInputBoxValueChange",F);const x=this.g.get(F);return x&&x.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(F,G,x,j){this.o.trace("ExtHostSCM#$executeResourceCommand",F,G,x);const U=this.g.get(F);if(!U)return Promise.resolve(void 0);const J=U.getResourceGroup(G);return J?J.$executeResourceCommand(x,j):Promise.resolve(void 0)}$validateInput(F,G,x){this.o.trace("ExtHostSCM#$validateInput",F);const j=this.g.get(F);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Ch)(()=>j.inputBox.validateInput(G,x)).then(U=>{if(!U)return Promise.resolve(void 0);const J=p.MarkdownString.fromStrict(U.message);return J?Promise.resolve([J,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.g.get(F)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(F,G,x,j){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,x,j)??void 0}async $resolveHistoryItemGroupCommonAncestor2(F,G,x){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(G,x)??void 0}async $provideHistoryItems(F,G,x,j){return(await this.g.get(F)?.historyProvider?.provideHistoryItems(G,x,j))?.map(Z=>c(Z))??void 0}async $provideHistoryItems2(F,G,x){return(await this.g.get(F)?.historyProvider?.provideHistoryItems2(G,x))?.map(J=>c(J))??void 0}async $provideHistoryItemSummary(F,G,x,j){const U=this.g.get(F)?.historyProvider;if(typeof U?.provideHistoryItemSummary!="function")return;const J=await U.provideHistoryItemSummary(G,x,j);return J?c(J):void 0}async $provideHistoryItemChanges(F,G,x,j){return await this.g.get(F)?.historyProvider?.provideHistoryItemChanges(G,x,j)??void 0}};e.$Nsc=N,e.$Nsc=N=a=He([qe(3,I.$fk)],N)}),define(Re[253],Te([1,0,5,8,2]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Osc=void 0;class L{static{this.a=0}constructor(O,m){this.d=m,this.c=new Map,this.b=O.getProxy(v.$0N.MainThreadShare)}async $provideShare(O,m,s){return await this.c.get(O)?.provideShare({selection:D.Range.to(m.selection),resourceUri:P.URI.revive(m.resourceUri)},s)??void 0}registerShareProvider(O,m){const s=L.a++;return this.c.set(s,m),this.b.$registerShareProvider(s,D.DocumentSelector.from(O,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(s),this.c.delete(s)}}}}e.$Osc=L}),define(Re[254],Te([1,0,7,5,9,4,8,14]),function(we,e,v,D,P,L,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rsc=e.$Qsc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$_O("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$_O("statusBarItem.warningForeground")]])}#e;#t;constructor(u,E,p,r,l,d=v.StatusBarAlignment.Left,a){if(this.i=!1,this.k="",this.q=new L.$Yc,this.#e=u,this.#t=E,l&&r){this.c=(0,v.$NO)(r.identifier,l);const i=p.get(this.c);i&&(d=i.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,a=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(m.a++);this.e=r,this.f=l,this.g=d,this.h=this.u(a)}u(u){if((0,O.$ng)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!m.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new L.$Yc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let E;this.m?E=this.m:E=(0,P.localize)(2711,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=m.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,E,this.k,r,this.r?.internal,p,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Qsc=m;class s{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(2712,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const E={message:u};return this.b.unshift(E),this.c(),new v.$_N(()=>{const p=this.b.indexOf(E);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(u,E){this.e=new Map,this.a=u.getProxy(D.$0N.MainThreadStatusBar),this.b=E,this.c=new s(this)}$acceptStaticEntries(u){for(const E of u)this.e.set(E.entryId,E)}createStatusBarEntry(u,E,p,r){return new m(this.a,this.b,this.e,u,E,p,r)}setStatusBarMessage(u,E){const p=this.c.setMessage(u);let r;return typeof E=="number"?r=setTimeout(()=>p.dispose(),E):typeof E<"u"&&E.then(()=>p.dispose(),()=>p.dispose()),new v.$_N(()=>{p.dispose(),clearTimeout(r)})}}e.$Rsc=I}),define(Re[127],Te([1,0,32,118,54,82,55,8,2]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZQ=e.$YQ=e.$XQ=e.$WQ=void 0,v=Ve(v),O=Ve(O);const s=(i,n,t,o)=>{let c=n;return{enumerable:!0,configurable:!1,get(){return c},set(g){if(!t(c,g)){const f=c;c=g,i.listener?.(o(g,f))}}}},I=(i,n)=>i===n,w={range:(i,n)=>i===n?!0:!i||!n?!1:i.isEqual(n),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,n)=>!(i.length!==n.length||i.some(t=>!n.find(o=>t.id===o.id)))},u=i=>n=>({op:L.TestItemEventOp.SetProp,update:i(n)}),E=(i,n)=>({range:(()=>{let t;const o=u(c=>({range:v.$Wt.lift(O.Range.from(c))}));return{enumerable:!0,configurable:!1,get(){return t},set(c){i.listener?.({op:L.TestItemEventOp.DocumentSynced}),w.range(t,c)||(t=c,i.listener?.(o(c)))}}})(),label:s(i,n,w.label,u(t=>({label:t}))),description:s(i,void 0,w.description,u(t=>({description:t}))),sortText:s(i,void 0,w.sortText,u(t=>({sortText:t}))),canResolveChildren:s(i,!1,w.canResolveChildren,t=>({op:L.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:s(i,!1,w.busy,u(t=>({busy:t}))),error:s(i,void 0,w.error,u(t=>({error:O.MarkdownString.fromStrict(t)||null}))),tags:s(i,[],w.tags,(t,o)=>({op:L.TestItemEventOp.SetTags,new:t.map(O.TestTag.from),old:o.map(O.TestTag.from)}))}),p=i=>{const n=P.$pJ.fromString(i.extId),t=new l(n.controllerId,n.localId,i.label,m.URI.revive(i.uri)||void 0);return t.range=O.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(o=>O.TestTag.to({id:(0,R.$vJ)(o).tagId})),t},r=i=>{let n;for(const t of i.tests){const o=p(t.item);(0,D.$GQ)(o).parent=n,n=o}return n};e.$WQ=r;class l{constructor(n,t,o,c){if(t.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const g=(0,D.$FQ)(this,n);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof d?void 0:g.parent}},children:{value:(0,L.$EQ)(g,D.$GQ,l),enumerable:!0,writable:!1},...E(g,o)})}}e.$XQ=l;class d extends l{constructor(n,t){super(n,n,t,void 0),this._isRoot=!0}}e.$YQ=d;class a extends L.$AQ{constructor(n,t,o){super({controllerId:n,getDocumentVersion:c=>c&&o.getDocument(c)?.version,getApiFor:D.$GQ,getChildren:c=>c.children,root:new d(n,t),toITestItem:O.TestItem.from})}}e.$ZQ=a}),define(Re[35],Te([1,0,14,7,8,25,5,17,11,34,32,101,2,4,3,16,127,20,39,42,69,63,66,33]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i,n,t,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Q=e.$0Q=e.$9Q=e.$8Q=e.$7Q=e.$6Q=void 0,D=Ve(D),P=Ve(P);let g=class{#e;#t;#i;constructor(C,T,$){this.b=new Map,this.c=new Map,this.#e=C.getProxy(R.$0N.MainThreadCommands),this.d=T,this.#i=$,this.#t=C.getProxy(R.$0N.MainThreadTelemetry),this.converter=new f(this,b=>{const N=this.c.get(b);return N?.result===S.Void?N:void 0},T),this.f=[{processArgument(b){return(0,s.$hi)(b)}},{processArgument(b){return(0,L.$mo)(b,function(N){if(I.$Wt.isIRange(N))return P.Range.to(N);if(w.$Vt.isIPosition(N))return P.Position.to(N);if(I.$Wt.isIRange(N.range)&&u.URI.isUri(N.uri))return P.location.to(N);if(N instanceof d.$Se)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const T=this.registerCommand(!1,C.id,async(...$)=>{const b=C.args.map((A,F)=>{if(!A.validate($[F]))throw new Error(`Invalid argument '${A.name}' when running '${C.id}', received: ${typeof $[F]=="object"?JSON.stringify($[F],null,"	"):$[F]} `);return A.convert($[F])}),N=await this.executeCommand(C.internalId,...b);return C.result.convert(N,$,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new D.$_N(()=>{T.dispose(),this.c.delete(C.id)})}registerCommand(C,T,$,b,N,A){if(this.d.trace("ExtHostCommands#registerCommand",T),!T.trim().length)throw new Error("invalid id");if(this.b.has(T))throw new Error(`command '${T}' already exists`);return this.b.set(T,{callback:$,thisArg:b,metadata:N,extension:A}),C&&this.#e.$registerCommand(T),new D.$_N(()=>{this.b.delete(T)&&C&&this.#e.$unregisterCommand(T)})}executeCommand(C,...T){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,T,!0)}async g(C,T,$){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,T,!1);{let b=!1;const N=(0,L.$mo)(T,function(A){if(A instanceof D.$aO)return P.Position.from(A);if(A instanceof D.$bO)return P.Range.from(A);if(A instanceof D.$nO)return P.location.from(A);if(D.$DP.isNotebookRange(A))return P.NotebookRange.from(A);if(A instanceof ArrayBuffer)return b=!0,d.$Se.wrap(new Uint8Array(A));if(A instanceof Uint8Array)return b=!0,d.$Se.wrap(A);if(A instanceof d.$Se)return b=!0,A;if(!Array.isArray(A))return A});try{const A=await this.#e.$executeCommand(C,b?new a.$7w(N):N,$);return(0,s.$hi)(A)}catch(A){if(A instanceof Error&&A.message==="$executeCommand:retry")return this.g(C,T,!1);throw A}}}async h(C,T,$){const b=this.b.get(C);if(!b)throw new Error("Unknown command");const{callback:N,thisArg:A,metadata:F}=b;if(F?.args)for(let x=0;x<F.args.length;x++)try{(0,v.$Ag)(T[x],F.args[x].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${F.args[x].name}' - ${F.args[x].description}`)}const G=n.$ke.create();try{return await N.apply(A,T)}catch(x){if(C===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...T);j&&(C=j.command)}if(this.d.error(x,C,b.extension?.identifier),!$)throw x;if(b.extension?.identifier){const j=this.#i.onExtensionError(b.extension.identifier,x);this.d.trace("forwarded error to extension?",j,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$vj)(x)),this.id=C,this.source=b.extension?.displayName??b.extension?.name}}}finally{this.j(b,C,G.elapsed())}}j(C,T,$){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.$Dp(T),duration:$})}$executeContributedCommand(C,...T){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const $=this.b.get(C);return $?(T=T.map(b=>this.f.reduce((N,A)=>A.processArgument(N,$.extension?.identifier),b)),this.h(C,T,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(T=>(C&&(T=T.filter($=>$[0]!=="_")),T))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[T,$]of this.b){const{metadata:b}=$;b&&(C[T]=b)}return Promise.resolve(C)}};e.$6Q=g,e.$6Q=g=He([qe(0,r.$KQ),qe(1,m.$fk),qe(2,o.$5Q)],g),e.$7Q=(0,p.$Ki)("IExtHostCommands");class f{constructor(C,T,$){this.d=C,this.f=T,this.g=$,this.delegatingCommandId=`__vsc${(0,c.$7g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,T){if(!C)return;const $={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return $;const b=this.f(C.command);if(b)$.id=b.internalId,$.arguments=b.args.map((N,A)=>N.convert(C.arguments&&C.arguments[A]));else if((0,O.$Pb)(C.arguments)){const N=`${C.command} /${++this.c}`;this.b.set(N,C),T.add((0,E.$Xc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),$.$ident=N,$.id=this.delegatingCommandId,$.arguments=[N],this.g.trace("CommandsConverter#CREATE",C.command,N)}return $}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const T=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],T?T.command:"MISSING"),T?this.d.executeCommand(T.command,...T.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$8Q=f;class h{static{this.Uri=new h("uri","Uri of a text document",C=>u.URI.isUri(C),C=>C)}static{this.Position=new h("position","A position in a text document",C=>D.$aO.isPosition(C),P.Position.from)}static{this.Range=new h("range","A range in a text document",C=>D.$bO.isRange(C),P.Range.from)}static{this.Selection=new h("selection","A selection in a text document",C=>D.$cO.isSelection(C),P.Selection.from)}static{this.Number=new h("number","",C=>typeof C=="number",C=>C)}static{this.String=new h("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=h.Arr(h.String)}static Arr(C){return new h(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,T=>Array.isArray(T)&&T.every($=>C.validate($)),T=>T.map($=>C.convert($)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",C=>C instanceof D.$zO,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",C=>C instanceof D.$YP,P.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",C=>C instanceof l.$XQ,P.TestItem.from)}constructor(C,T,$,b){this.name=C,this.description=T,this.validate=$,this.convert=b}optional(){return new h(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,T){return new h(C??this.name,T??this.description,this.validate,this.convert)}}e.$9Q=h;class S{static{this.Void=new S("no result",C=>C)}constructor(C,T){this.description=C,this.convert=T}}e.$0Q=S;class k{constructor(C,T,$,b,N){this.id=C,this.internalId=T,this.description=$,this.args=b,this.result=N}}e.$$Q=k}),define(Re[255],Te([1,0,17,15,2,94,104,31,35,8,7]),function(we,e,v,D,P,L,R,O,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qc=void 0,L=Ve(L),s=Ve(s),I=Ve(I);const w=[new m.$$Q("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of DocumentHighlight-instances.",E(s.DocumentHighlight.to))),new m.$$Q("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$9Q.Uri],new m.$0Q("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,l)=>{if((0,v.$Ob)(r))return;class d extends I.$uO{static to(i){const n=new d(i.name,s.SymbolKind.to(i.kind),i.containerName||"",new I.$nO(l[0],s.Range.to(i.range)));return n.detail=i.detail,n.range=n.location.range,n.selectionRange=s.Range.to(i.selectionRange),n.children=i.children?i.children.map(d.to):[],n}}return r.map(d.to)})),new m.$$Q("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$9Q.Uri,new m.$9Q("options","Formatting options",r=>!0,r=>r)],new m.$0Q("A promise that resolves to an array of TextEdits.",E(s.TextEdit.to))),new m.$$Q("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$9Q.Uri,m.$9Q.Range,new m.$9Q("options","Formatting options",r=>!0,r=>r)],new m.$0Q("A promise that resolves to an array of TextEdits.",E(s.TextEdit.to))),new m.$$Q("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$9Q.Uri,m.$9Q.Position,new m.$9Q("ch","Trigger character",r=>typeof r=="string",r=>r),new m.$9Q("options","Formatting options",r=>!0,r=>r)],new m.$0Q("A promise that resolves to an array of TextEdits.",E(s.TextEdit.to))),new m.$$Q("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of Location or LocationLink instances.",p)),new m.$$Q("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of Location or LocationLink instances.",p)),new m.$$Q("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of Location or LocationLink instances.",p)),new m.$$Q("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of Location or LocationLink instances.",p)),new m.$$Q("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of Location or LocationLink instances.",p)),new m.$$Q("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of Location or LocationLink instances.",p)),new m.$$Q("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of Location or LocationLink instances.",p)),new m.$$Q("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of Location or LocationLink instances.",p)),new m.$$Q("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of Location-instances.",E(s.location.to))),new m.$$Q("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of Location-instances.",E(s.location.to))),new m.$$Q("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of Hover-instances.",E(s.Hover.to))),new m.$$Q("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of Hover-instances.",E(s.Hover.to))),new m.$$Q("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$9Q.Uri,new m.$9Q("position","A position in a text document",r=>Array.isArray(r)&&r.every(l=>I.$aO.isPosition(l)),r=>r.map(s.Position.from))],new m.$0Q("A promise that resolves to an array of ranges.",r=>r.map(l=>{let d;for(const a of l.reverse())d=new I.$yO(s.Range.to(a),d);return d}))),new m.$$Q("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$9Q.String.with("query","Search string")],new m.$0Q("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(s.WorkspaceSymbol.to))),new m.$$Q("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(s.CallHierarchyItem.to))),new m.$$Q("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$9Q.CallHierarchyItem],new m.$0Q("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(s.CallHierarchyIncomingCall.to))),new m.$$Q("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$9Q.CallHierarchyItem],new m.$0Q("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(s.CallHierarchyOutgoingCall.to))),new m.$$Q("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:s.Range.to(r.range),placeholder:r.text}})),new m.$$Q("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$9Q.Uri,m.$9Q.Position,m.$9Q.String.with("newName","The new symbol name")],new m.$0Q("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return s.WorkspaceEdit.to(r)}})),new m.$$Q("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$9Q.Uri,m.$9Q.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$0Q("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(s.DocumentLink.to))),new m.$$Q("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$9Q.Uri],new m.$0Q("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$uP(r.tokenTypes,r.tokenModifiers)})),new m.$$Q("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$9Q.Uri],new m.$0Q("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const l=(0,R.$xeb)(r);if(l.type==="full")return new I.$wP(l.data,void 0)})),new m.$$Q("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$9Q.Uri,m.$9Q.Range.optional()],new m.$0Q("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$uP(r.tokenTypes,r.tokenModifiers)})),new m.$$Q("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$9Q.Uri,m.$9Q.Range],new m.$0Q("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const l=(0,R.$xeb)(r);if(l.type==="full")return new I.$wP(l.data,void 0)})),new m.$$Q("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$9Q.Uri,m.$9Q.Position,m.$9Q.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$9Q.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$0Q("A promise that resolves to a CompletionList-instance.",(r,l,d)=>{if(!r)return new I.$KO([]);const a=r.suggestions.map(i=>s.CompletionItem.to(i,d));return new I.$KO(a,r.incomplete)})),new m.$$Q("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$9Q.Uri,m.$9Q.Position,m.$9Q.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$0Q("A promise that resolves to SignatureHelp.",r=>{if(r)return s.SignatureHelp.to(r)})),new m.$$Q("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$9Q.Uri,m.$9Q.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$0Q("A promise that resolves to an array of CodeLens-instances.",(r,l,d)=>E(a=>new I.$CO(s.Range.to(a.range),a.command&&d.fromInternal(a.command)))(r))),new m.$$Q("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$9Q.Uri,new m.$9Q("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.$bO.isRange(r),r=>I.$cO.isSelection(r)?s.Selection.from(r):s.Range.from(r)),m.$9Q.String.with("kind","Code action kind to return code actions for").optional(),m.$9Q.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$0Q("A promise that resolves to an array of Command-instances.",(r,l,d)=>E(a=>{if(a._isSynthetic){if(!a.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(a.command)}else{const i=new I.$wO(a.title,a.kind?new I.$xO(a.kind):void 0);return a.edit&&(i.edit=s.WorkspaceEdit.to(a.edit)),a.command&&(i.command=d.fromInternal(a.command)),i.isPreferred=a.isPreferred,i}})(r))),new m.$$Q("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$9Q.Uri],new m.$0Q("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(l=>new I.$QO(s.Range.to(l.range),s.Color.to(l.color))):[])),new m.$$Q("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$9Q("color","The color to show and insert",r=>r instanceof I.$PO,s.Color.from),new m.$9Q("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:s.Range.from(r.range)}))],new m.$0Q("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(s.ColorPresentation.to):[])),new m.$$Q("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$9Q.Uri,m.$9Q.Range],new m.$0Q("A promise that resolves to an array of Inlay objects",(r,l,d)=>r.map(s.InlayHint.to.bind(void 0,d)))),new m.$$Q("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$9Q.Uri],new m.$0Q("A promise that resolves to an array of FoldingRange objects",(r,l)=>{if(r)return r.map(s.FoldingRange.to)})),new m.$$Q("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$0Q("A promise that resolves to an array of NotebookContentProvider static info objects.",E(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(l=>s.NotebookExclusiveDocumentPattern.to(l))})))),new m.$$Q("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$9Q.Uri,m.$9Q.Range,new m.$9Q("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof I.$bO,r=>s.InlineValueContext.from(r))],new m.$0Q("A promise that resolves to an array of InlineValue objects",r=>r.map(s.InlineValue.to))),new m.$$Q("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$9Q("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,D.$Ug)(r,D.Schemas.http,D.Schemas.https),r=>r),new m.$9Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional(),m.$9Q.String.with("label","").optional()],m.$0Q.Void),new m.$$Q("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$9Q.Uri.with("resource","Resource to open"),m.$9Q.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$9Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional()],m.$0Q.Void),new m.$$Q("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$9Q.Uri.with("left","Left-hand side resource of the diff editor"),m.$9Q.Uri.with("right","Right-hand side resource of the diff editor"),m.$9Q.String.with("title","Human readable title for the diff editor").optional(),new m.$9Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)]).optional()],m.$0Q.Void),new m.$$Q("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$9Q.String.with("title","Human readable title for the changes editor"),new m.$9Q("resourceList","List of resources to compare",r=>{for(const l of r){if(l.length!==3)return!1;const[d,a,i]=l;if(!P.URI.isUri(d)||!P.URI.isUri(a)&&a!==void 0&&a!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],m.$0Q.Void),new m.$$Q("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$9Q.Uri,m.$9Q.Position],new m.$0Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new m.$$Q("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$9Q.TypeHierarchyItem],new m.$0Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new m.$$Q("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$9Q.TypeHierarchyItem],new m.$0Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new m.$$Q("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$9Q.TestItem],m.$0Q.Void),new m.$$Q("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$9Q.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$0Q.Void),new m.$$Q("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$9Q.String.with("name","The context key name"),new m.$9Q("value","The context key value",()=>!0,r=>r)],m.$0Q.Void),new m.$$Q("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$9Q.Uri,m.$9Q.StringArray,new m.$9Q("MappedEditsContext","Mapped Edits Context",r=>s.MappedEditsContext.is(r),r=>s.MappedEditsContext.from(r))],new m.$0Q("A promise that resolves to a workspace edit or null",r=>r?s.WorkspaceEdit.to(r):null)),new m.$$Q("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$9Q("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?s.Range.from(r.initialRange):void 0,initialSelection:I.$cO.isSelection(r.initialSelection)?s.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?s.Position.from(r.position):void 0}})],m.$0Q.Void)];class u{static register(l){w.forEach(l.registerApiCommand,l),this.a(l)}static a(l){l.registerCommand(!1,"_validateWhenClauses",O.$Jj)}}e.$2qc=u;function E(r){return l=>{if(Array.isArray(l))return l.map(r)}}function p(r){if(!Array.isArray(r))return;const l=[];for(const d of r)L.$Tu(d)?l.push(s.DefinitionLink.to(d)):l.push(s.location.to(d));return l}}),define(Re[256],Te([1,0,2,35]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vsc=void 0;class P{constructor(R,O,m,s,I){this.a=O,this.b=m,this.c=s;const w=new D.$$Q("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new D.$9Q("showOptions","Show Options",u=>!0,u=>u),new D.$9Q("resource","Interactive resource Uri",u=>!0,u=>u),new D.$9Q("controllerId","Notebook controller Id",u=>!0,u=>u),new D.$9Q("title","Interactive editor title",u=>!0,u=>u)],new D.$0Q("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const E=this.a.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:v.URI.revive(u.notebookUri),inputUri:v.URI.revive(u.inputUri),notebookEditor:E.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:v.URI.revive(u.notebookUri),inputUri:v.URI.revive(u.inputUri)}}));this.c.registerApiCommand(w)}$willAddInteractiveDocument(R,O,m,s){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:m,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,O){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$vsc=P}),define(Re[257],Te([1,0,17,10,19,6,4,27,2,18,11,5,35,8,7,83,196,21,39,197]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dsc=void 0,e.$Esc=h,E=Ve(E);let n=class{constructor(k,y,C,T,$){this.m=y,this.n=C,this.o=T,this.q=$,this.b=new O.$Fc,this.c=new O.$Fc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new L.$qe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=k.getProxy(w.$0N.MainThreadNotebookKernels);const b=new u.$$Q("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$9Q("options","Select kernel options",A=>!0,A=>{if(A&&"notebookEditor"in A&&"id"in A){const F=this.n.getIdByEditor(A.notebookEditor);return{id:A.id,extension:A.extension,notebookEditorId:F}}else if(A&&"notebookEditor"in A){const F=this.n.getIdByEditor(A.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${A.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return A})],u.$0Q.Void),N=new u.$$Q("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$9Q.Uri],new u.$0Q("A promise that resolves to an array of variables",(A,F)=>A.map(G=>({variable:{name:G.name,value:G.value,expression:G.expression,type:G.type,language:G.language},hasNamedChildren:G.hasNamedChildren,indexedChildrenCount:G.indexedChildrenCount}))));this.o.registerApiCommand(b),this.o.registerApiCommand(N)}createNotebookController(k,y,C,T,$,b){for(const _ of this.j.values())if(_.controller.id===y&&s.$xn.equals(k.identifier,_.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const N=this.k++,A=this;this.q.trace(`NotebookController[${N}], CREATED by ${k.identifier.value}, ${y}`);const F=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${k.identifier}'`);let G=!1;const x=new L.$qe,j=new L.$qe,U={id:h(k.identifier,y),notebookType:C,extensionId:k.identifier,extensionLocation:k.extensionLocation,label:T||k.identifier.value,preloads:b?b.map(E.NotebookRendererScript.from):[]};let J=$??F,Z,ae;this.a.$addKernel(N,U).catch(_=>{console.log(_),G=!0});let ee=0;const oe=()=>{if(G)return;const _=++ee;Promise.resolve().then(()=>{_===ee&&this.a.$updateKernel(N,U)})},ie=new O.$Fc,ue={get id(){return y},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return U.label},set label(_){U.label=_??k.displayName??k.name,oe()},get detail(){return U.detail??""},set detail(_){U.detail=_,oe()},get description(){return U.description??""},set description(_){U.description=_,oe()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(_){U.supportedLanguages=_,oe()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(_){U.supportsExecutionOrder=_,oe()},get rendererScripts(){return U.preloads?U.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return J},set executeHandler(_){J=_??F},get interruptHandler(){return Z},set interruptHandler(_){Z=_,U.supportsInterrupt=!!_,oe()},set variableProvider(_){(0,d.$zH)(k,"notebookVariableProvider"),ae=_,U.hasVariableProvider=!!_,_?.onDidChangeVariables($e=>A.a.$variablesUpdated($e.uri)),oe()},get variableProvider(){return ae},createNotebookCellExecution(_){if(G)throw new Error("notebook controller is DISPOSED");if(!ie.has(_.notebook.uri))throw A.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map($e=>$e.toString())),new Error(`notebook controller is NOT associated to notebook: ${_.notebook.uri.toString()}`);return A._createNotebookCellExecution(_,h(k.identifier,this.id))},createNotebookExecution(_){if((0,d.$zH)(k,"notebookExecution"),G)throw new Error("notebook controller is DISPOSED");if(!ie.has(_.uri))throw A.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map($e=>$e.toString())),new Error(`notebook controller is NOT associated to notebook: ${_.uri.toString()}`);return A._createNotebookExecution(_,h(k.identifier,this.id))},dispose:()=>{G||(this.q.trace(`NotebookController[${N}], DISPOSED`),G=!0,this.j.delete(N),x.dispose(),j.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(_,$e){$e===p.NotebookControllerAffinity2.Hidden&&(0,d.$zH)(k,"notebookControllerAffinityHidden"),A.a.$updateNotebookPriority(N,_.uri,$e)},onDidReceiveMessage:j.event,postMessage(_,$e){return(0,d.$zH)(k,"notebookMessaging"),A.a.$postMessage(N,$e&&A.n.getIdByEditor($e),_)},asWebviewUri(_){return(0,d.$zH)(k,"notebookMessaging"),(0,r.$pEb)(_,A.m.remote)}};return this.j.set(N,{extensionId:k.identifier,controller:ue,onDidReceiveMessage:j,onDidChangeSelection:x,associatedNotebooks:ie}),ue}getIdByController(k){for(const[y,C]of this.j)if(C.controller===k)return h(C.extensionId,k.id);return null}createNotebookControllerDetectionTask(k,y){const C=this.g++,T=this;this.q.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${k.identifier.value}`),this.a.$addKernelDetectionTask(C,y);const $={dispose:()=>{this.f.delete(C),T.a.$removeKernelDetectionTask(C)}};return this.f.set(C,$),$}registerKernelSourceActionProvider(k,y,C){const T=this.i++,$=typeof C.onDidChangeNotebookKernelSourceActions=="function"?T:void 0,b=this;this.h.set(T,C),this.q.trace(`NotebookKernelSourceActionProvider[${T}], CREATED by ${k.identifier.value}`),this.a.$addKernelSourceActionProvider(T,T,y);let N;return $!==void 0&&(N=C.onDidChangeNotebookKernelSourceActions(A=>this.a.$emitNotebookKernelSourceActionsChangeEvent($))),{dispose:()=>{this.h.delete(T),b.a.$removeKernelSourceActionProvider(T,T),N?.dispose()}}}async $provideKernelSourceActions(k,y){const C=this.h.get(k);if(C){const T=new R.$Yc;return(await C.provideNotebookKernelSourceActions(y)??[]).map(b=>E.NotebookKernelSourceAction.from(b,this.o.converter,T))}return[]}$acceptNotebookAssociation(k,y,C){const T=this.j.get(k);if(T){const $=this.n.getNotebookDocument(m.URI.revive(y));C?T.associatedNotebooks.set($.uri,!0):T.associatedNotebooks.delete($.uri),this.q.trace(`NotebookController[${k}] ASSOCIATE notebook`,$.uri.toString(),C),T.onDidChangeSelection.fire({selected:C,notebook:$.apiNotebook})}}async $executeCells(k,y,C){const T=this.j.get(k);if(!T)return;const $=this.n.getNotebookDocument(m.URI.revive(y)),b=[];for(const N of C){const A=$.getCell(N);A&&b.push(A.apiCell)}try{this.q.trace(`NotebookController[${k}] EXECUTE cells`,$.uri.toString(),b.length),await T.controller.executeHandler.call(T.controller,b,$.apiNotebook,T.controller)}catch(N){this.q.error(`NotebookController[${k}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(k,y,C){const T=this.j.get(k);if(!T)return;const $=this.n.getNotebookDocument(m.URI.revive(y));if(T.controller.interruptHandler)await T.controller.interruptHandler.call(T.controller,$.apiNotebook);else for(const b of C){const N=$.getCell(b);N&&this.b.get(N.uri)?.cancel()}if(T.controller.interruptHandler){const b=this.c.get($.uri);this.c.delete($.uri),C.length&&Array.isArray(b)&&b.length&&b.forEach(N=>N.dispose())}}async $provideVariables(k,y,C,T,$,b,N){const A=this.j.get(k);if(!A)return;const F=this.n.getNotebookDocument(m.URI.revive(C)),G=A.controller.variableProvider;if(!G)return;let x;if(T!==void 0){if(x=this.s[T],!x)return}else this.s={};const j=$==="named"?p.NotebookVariablesRequestKind.Named:p.NotebookVariablesRequestKind.Indexed,U=G.provideVariables(F.apiNotebook,x,j,b,N);let J=0;for await(const Z of U){if(N.isCancellationRequested)return;const ae={id:this.r++,name:Z.variable.name,value:Z.variable.value,type:Z.variable.type,interfaces:Z.variable.interfaces,language:Z.variable.language,expression:Z.variable.expression,hasNamedChildren:Z.hasNamedChildren,indexedChildrenCount:Z.indexedChildrenCount,extensionId:A.extensionId.value};if(this.s[ae.id]=Z.variable,this.a.$receiveVariable(y,ae),J++>=i.$iL)return}}$acceptKernelMessageFromRenderer(k,y,C){const T=this.j.get(k);if(!T)return;const $=this.n.getEditorById(y);T.onDidReceiveMessage.fire(Object.freeze({editor:$.apiEditor,message:C}))}$cellExecutionChanged(k,y,C){const $=this.n.getNotebookDocument(m.URI.revive(k)).getCell(y);if($){const b=C?E.NotebookCellExecutionState.to(C):p.NotebookCellExecutionState.Idle;b!==void 0&&this.l.fire({cell:$.apiCell,state:b})}}_createNotebookCellExecution(k,y){if(k.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const T=this.n.getNotebookDocument(k.notebook.uri).getCellFromApiCell(k);if(!T)throw new Error("invalid cell");if(this.b.has(T.uri))throw new Error(`duplicate execution for ${T.uri}`);const $=new o(y,T,this.a);this.b.set(T.uri,$);const b=$.onDidChangeState(()=>{$.state===t.Resolved&&($.dispose(),b.dispose(),this.b.delete(T.uri))});return $.asApiObject()}_createNotebookExecution(k,y){const C=this.n.getNotebookDocument(k.uri),T=k.getCells().find(N=>{const A=C.getCellFromApiCell(N);return A&&this.b.has(A.uri)});if(T)throw new Error(`duplicate cell execution for ${T.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const $=new g(y,C,this.a),b=$.onDidChangeState(()=>{$.state===c.Resolved&&($.dispose(),b.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[$,b]),$.asApiObject()}};e.$Dsc=n,e.$Dsc=n=He([qe(4,I.$fk)],n);var t;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(t||(t={}));class o extends R.$Zc{static{this.a=0}get state(){return this.f}constructor(k,y,C){super(),this.m=y,this.n=C,this.b=o.a++,this.c=new L.$qe,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new P.$Be),this.h=new f(10,T=>this.s(T)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,k,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(k){await this.h.addItem(k)}async s(k){const y=Array.isArray(k)?k:[k];return this.n.$updateExecution(this.b,new a.$7w(y))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(k){let y=this.m;if(k&&(y=this.m.notebook.getCellFromApiCell(k)),!y)throw new Error("INVALID cell");return y.handle}y(k){return k.map(y=>{const C=p.$HP.ensureUniqueMimeTypes(y.items,!0);return C===y.items?E.NotebookCellOutput.from(y):E.NotebookCellOutput.from({items:C,id:y.id,metadata:y.metadata})})}async z(k,y,C){const T=this.w(y),$=this.y((0,v.$6b)(k));return this.r({editType:l.CellExecutionUpdateType.Output,cellHandle:T,append:C,outputs:$})}async C(k,y,C){return k=p.$HP.ensureUniqueMimeTypes((0,v.$6b)(k),!0),this.r({editType:l.CellExecutionUpdateType.OutputItems,items:k.map(E.NotebookCellOutputItem.from),outputId:y.id,append:C})}asApiObject(){const k=this;return Object.freeze({get token(){return k.g.token},get cell(){return k.m.apiCell},get executionOrder(){return k.j},set executionOrder(C){k.j=C,k.s([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:k.j}])},start(C){if(k.f===t.Resolved||k.f===t.Started)throw new Error("Cannot call start again");k.f=t.Started,k.c.fire(),k.s({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,T,$){if(k.f===t.Resolved)throw new Error("Cannot call resolve twice");k.f=t.Resolved,k.c.fire(),k.h.flush();const b=$?{message:$.message,stack:$.stack,location:$?.location?{startLineNumber:$.location.start.line,startColumn:$.location.start.character,endLineNumber:$.location.end.line,endColumn:$.location.end.character}:void 0,uri:$.uri}:void 0;k.n.$completeExecution(k.b,new a.$7w({runEndTime:T,lastRunSuccess:C,error:b}))},clearOutput(C){return k.t(),k.z([],C,!1)},appendOutput(C,T){return k.t(),k.z(C,T,!0)},replaceOutput(C,T){return k.t(),k.z(C,T,!1)},appendOutputItems(C,T){return k.t(),k.C(C,T,!0)},replaceOutputItems(C,T){return k.t(),k.C(C,T,!1)}})}}var c;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(c||(c={}));class g extends R.$Zc{static{this.a=0}get state(){return this.f}constructor(k,y,C){super(),this.h=y,this.j=C,this.b=g.a++,this.c=new L.$qe,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new P.$Be),this.j.$createNotebookExecution(this.b,k,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===c.Resolved||this.f===c.Started)throw new Error("Cannot call start again");this.f=c.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===c.Resolved)throw new Error("Cannot call resolve twice");this.f=c.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class f{constructor(k,y){this.f=k,this.g=y,this.a=[],this.b=Date.now()}addItem(k){return this.a.push(k),this.c||(this.c=new D.$8h,this.b=Date.now(),(0,D.$Lh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const k=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>k.complete())}}function h(S,k){return`${S.value}/${k}`}}),define(Re[56],Te([1,0,6,5,3,2,16,4,7,9,12,179,19,33,180,181,36,10,8,35,38]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Grc=e.$Frc=e.$Erc=e.$Drc=void 0,e.$Drc=(0,P.$Ki)("IExtHostTerminalService");class t extends O.$Zc{constructor($,b,N,A){super(),this.u=$,this._id=b,this.w=N,this.y=A,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$qe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(G=>this.g=G);const F=this;this.value={get name(){return F.y||""},get processId(){return F.b},get creationOptions(){return F.w},get exitStatus(){return F.j},get state(){return F.m},get selection(){return F.n},get shellIntegration(){return F.shellIntegration},sendText(G,x=!0){F.C(),F.u.$sendText(F._id,G,x)},show(G){F.C(),F.u.$show(F._id,G)},hide(){F.C(),F.u.$hide(F._id)},dispose(){F.a||(F.a=!0,F.u.$dispose(F._id))},get dimensions(){if(!(F.f===void 0||F.h===void 0))return{columns:F.f,rows:F.h}}}}dispose(){this.s.fire(),super.dispose()}async create($,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??b?.cwd??void 0,env:$.env??void 0,icon:k($.iconPath)??void 0,color:l.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.z($.location,b?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,b,N,A,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:A,color:l.ThemeColor.isThemeColor(F)?F.id:void 0,location:b?.location||this.z($,N),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z($,b){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in $?{viewColumn:a.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.y=$}setExitStatus($,b){this.j=Object.freeze({code:$,reason:b})}setDimensions($,b){return $===this.f&&b===this.h||$===0||b===0?!1:(this.f=$,this.h=b,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection($){this.n=$}_setProcessId($){this.g?(this.g($),this.g=void 0):this.b.then(b=>{b!==$&&(this.b=Promise.resolve($))})}}e.$Erc=t;class o{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new v.$qe,this.onProcessData=this.a.event,this.b=new v.$qe,this.d=new v.$qe,this.onDidChangeProperty=this.d.event,this.f=new v.$qe,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,b){this.g.setDimensions?.({columns:$,rows:b})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:p.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:p.ProcessPropertyType.Title,value:b})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let c=1,g=class extends O.$Zc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,b,N){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new O.$1c),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$qe,this.onDidCloseTerminal=this.H.event,this.I=new v.$qe,this.onDidOpenTerminal=this.I.event,this.J=new v.$qe,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$qe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$qe,this.onDidChangeTerminalState=this.M.event,this.N=new v.$qe,this.onDidChangeShell=this.N.event,this.O=new v.$qe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$qe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=N.getProxy(D.$0N.MainThreadTerminalService),this.y=new r.$3zb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:A=>{const F=G=>{const x=G;return this.getTerminalById(x.instanceId)?.value};switch(A?.$mid){case n.MarshalledId.TerminalContext:return F(A);default:{if(Array.isArray(A))for(let G=0;G<A.length&&A[G].$mid===n.MarshalledId.TerminalContext;G++)A[G]=F(A[G]);return A}}}}),this.B({dispose:()=>{for(const[A,F]of this.g)F.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,b){const N=new t(this.a,(0,E.$7g)(),$,$.name),A=new o($.pty);return N.createExtensionTerminal($.location,b,this.R($,b).resolvedExtHostIdentifier,k($.iconPath),y($.color)).then(F=>{const G=this.S(F,A);this.h[F]=G}),this.f.push(N),N.value}R($,b){if(b=b||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const N=$.location.parentTerminal;if(N){const A=this.f.find(F=>F.value===N);A&&(b.resolvedExtHostIdentifier=A._id)}}else $.location&&typeof $.location!="object"?b.location=$.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal($,b){if(!this.getTerminalById($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const A=new o(b),F=this.S($,A);this.h[$]=F}async $acceptActiveTerminalChanged($){const b=this.b;if($===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const N=this.getTerminalById($);N&&(this.b=N,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,b){const N=this.getTerminalById($);N&&this.O.fire({terminal:N.value,data:b})}async $acceptTerminalDimensions($,b,N){const A=this.getTerminalById($);A&&A.setDimensions(b,N)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand($,b){const N=this.getTerminalById($);N&&this.P.fire({terminal:N.value,...b})}async $acceptTerminalMaximumDimensions($,b,N){this.g.get($)?.resize(b,N)}async $acceptTerminalTitleChange($,b){const N=this.getTerminalById($);N&&(N.name=b)}async $acceptTerminalClosed($,b,N){const A=this.X(this.f,$);if(A!==null){const F=this.f.splice(A,1)[0];F.setExitStatus(b,N),this.H.fire(F.value)}}$acceptTerminalOpened($,b,N,A){if(b){const x=this.X(this.f,b);if(x!==null){this.f[x]._id=$,this.I.fire(this.terminals[x]),this.f[x].isOpen=!0;return}}const F={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:L.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},G=new t(this.a,$,F,N);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId($,b){this.getTerminalById($)?._setProcessId(b)}async $startExtensionTerminal($,b){const N=this.getTerminalById($);if(!N)return{message:(0,s.localize)(2714,null,$)};N.isOpen||await new Promise(F=>{const G=this.onDidOpenTerminal(async x=>{x===N.value&&(G.dispose(),F())})});const A=this.g.get($);A?A.startSendingEvents(b):this.j[$]={initialDimensions:b}}S($,b){const N=new O.$Yc;N.add(b.onProcessReady(F=>this.a.$sendProcessReady($,F.pid,F.cwd,F.windowsPty))),N.add(b.onDidChangeProperty(F=>this.a.$sendProcessProperty($,F))),this.y.startBuffering($,b.onProcessData),N.add(b.onProcessExit(F=>this.U($,F))),this.g.set($,b);const A=this.j[$];return A&&b instanceof o&&(b.startSendingEvents(A.initialDimensions),delete this.j[$]),N}$acceptProcessAckDataEvent($,b){this.g.get($)?.acknowledgeDataEvent(b)}$acceptProcessInput($,b){this.g.get($)?.input(b)}$acceptTerminalInteraction($){const b=this.getTerminalById($);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection($,b){this.getTerminalById($)?.setSelection(b)}$acceptProcessResize($,b,N){try{this.g.get($)?.resize(b,N)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown($,b){this.g.get($)?.shutdown(b)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(b=>this.a.$sendProcessProperty($,{type:p.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(b=>this.a.$sendProcessProperty($,{type:p.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new m.$_N(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,b,N){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,N),this.a.$registerProfileProvider(b,$.identifier.value),new m.$_N(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider($,b,N){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,N),this.a.$registerQuickFixProvider($,b),new m.$_N(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,b){const N=new u.$Be().token;if(N.isCancellationRequested)return;const A=this.D.get($);if(!A)return;const F=await A.provideTerminalQuickFixes(b,N);if(F===null||Array.isArray(F)&&F.length===0)return;const G=new O.$Yc;if(this.w.value=G,!Array.isArray(F))return F?a.TerminalQuickFix.from(F,this.Q.converter,G):void 0;const x=[];for(const j of F){const U=a.TerminalQuickFix.from(j,this.Q.converter,G);U&&x.push(U)}return x}async $createContributedProfileTerminal($,b){const N=new u.$Be().token;let A=await this.C.get($)?.provideTerminalProfile(N);if(!N.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,b);return}this.createTerminalFromOptions(A.options,b)}}async $provideLinks($,b){const N=this.getTerminalById($);if(!N)return[];this.F.delete($),this.G.get($)?.dispose(!0);const F=new u.$Be;this.G.set($,F);const G=[],x={terminal:N.value,line:b},j=[];for(const Z of this.z)j.push(d.Promises.withAsyncBody(async ae=>{F.token.onCancellationRequested(()=>ae({provider:Z,links:[]}));const ee=await Z.provideTerminalLinks(x,F.token)||[];F.token.isCancellationRequested||ae({provider:Z,links:ee})}));const U=await Promise.all(j);if(F.token.isCancellationRequested)return[];const J=new Map;for(const Z of U)Z&&Z.links.length>0&&G.push(...Z.links.map(ae=>{const ee={id:c++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return J.set(ee.id,{provider:Z.provider,link:ae}),ee}));return this.F.set($,J),G}$activateLink($,b){const N=this.F.get($)?.get(b);N&&N.provider.handleTerminalLink(N.link)}U($,b){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const N=this.h[$];N&&(N.dispose(),delete this.h[$]),this.a.$sendProcessExit($,b)}getTerminalById($){return this.W(this.f,$)}getTerminalIdByApiObject($){const b=this.f.findIndex(N=>N.value===$);return b>=0?b:null}W($,b){const N=this.X($,b);return N!==null?$[N]:null}X($,b){const N=$.findIndex(A=>A._id===b);return N>=0?N:null}getEnvironmentVariableCollection($){let b=this.n.get($.identifier.value);return b||(b=this.B(new f),this.Z($.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Y($,b){const N=(0,w.$Ns)(b.map),A=(0,w.$Os)(b.descriptionMap);this.a.$setEnvironmentVariableCollection($,b.persistent,N.length===0?void 0:N,A)}$initEnvironmentVariableCollections($){$.forEach(b=>{const N=b[0],A=this.B(new f(b[1]));this.Z(N,A)})}$acceptDefaultProfile($,b){const N=this.s;this.s=$,this.u=b,N?.path!==$.path&&this.N.fire($.path)}Z($,b){this.n.set($,b),this.B(b.onDidChangeCollection(()=>{this.Y($,b)}))}};e.$Frc=g,e.$Frc=g=He([qe(1,i.$7Q),qe(2,R.$KQ)],g);class f extends O.$Zc{get persistent(){return this.b}set persistent($){this.b=$,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor($){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$qe,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const b=this.j($);let N=this.a.get(b);return N||(N=new h(this,$),this.a.set(b,N),this.B(N.onDidChangeCollection(()=>this.f.fire()))),N}replace($,b,N,A){this.g($,{value:b,type:m.EnvironmentVariableMutatorType.Replace,options:N??{applyAtProcessCreation:!0},scope:A})}append($,b,N,A){this.g($,{value:b,type:m.EnvironmentVariableMutatorType.Append,options:N??{applyAtProcessCreation:!0},scope:A})}prepend($,b,N,A){this.g($,{value:b,type:m.EnvironmentVariableMutatorType.Prepend,options:N??{applyAtProcessCreation:!0},scope:A})}g($,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const N=this.h($,b.scope),A=this.map.get(N),F=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==b.value||A.type!==b.type||A.options?.applyAtProcessCreation!==F.applyAtProcessCreation||A.options?.applyAtShellIntegration!==F.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const G=this.h($,b.scope),x={variable:$,...b,options:F};this.map.set(G,x),this.f.fire()}}get($,b){const N=this.h($,b),A=this.map.get(N);return A?C(A):void 0}h($,b){const N=this.j(b);return N.length?`${$}:::${N}`:$}j($){return this.m($?.workspaceFolder)??""}m($){return $?$.uri.toString():void 0}getVariableMap($){const b=new Map;for(const[N,A]of this.map)this.j(A.scope)===this.j($)&&b.set(A.variable,C(A));return b}delete($,b){const N=this.h($,b);this.map.delete(N),this.f.fire()}clear($){if($?.workspaceFolder){for(const[b,N]of this.map)N.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(b);this.n($)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription($,b){const N=this.j(b),A=this.descriptionMap.get(N);if(!A||A.description!==$){let F;typeof $=="string"?F=$:F=$?.value.split(`

`)[0];const G={description:F,scope:b};this.descriptionMap.set(N,G),this.f.fire()}}getDescription($){const b=this.j($);return this.descriptionMap.get(b)?.description}n($){const b=this.j($);this.descriptionMap.delete(b)}}class h{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,b){this.b=$,this.d=b,this.a=new v.$qe}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,b,N){this.b.replace($,b,N,this.d)}append($,b,N){this.b.append($,b,N,this.d)}prepend($,b,N){this.b.prepend($,b,N,this.d)}get($){return this.b.get($,this.d)}forEach($,b){this.b.getVariableMap(this.d).forEach((N,A)=>$.call(b,A,N,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let S=class extends g{constructor($,b){super(!1,$,b)}createTerminal($,b,N){throw new I.$db}createTerminalFromOptions($,b){throw new I.$db}};e.$Grc=S,e.$Grc=S=He([qe(0,i.$7Q),qe(1,R.$KQ)],S);function k(T){if(!(!T||typeof T=="string"))return"id"in T?{id:T.id,color:T.color}:T}function y(T){return l.ThemeColor.isThemeColor(T)?T:void 0}function C(T){const $={...T};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(Re[128],Te([1,0,7,4,3,5,16,56,6,2,10]),function(we,e,v,D,P,L,R,O,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wsc=e.$Vsc=void 0,e.$Vsc=(0,P.$Ki)("IExtHostTerminalShellIntegration");let w=class extends D.$Zc{constructor(l,d){super(),this.h=d,this.b=new Map,this.c=new m.$qe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$qe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$qe,this.onDidEndTerminalShellExecution=this.g.event,this.a=l.getProxy(L.$0N.MainThreadTerminalShellIntegration),this.B((0,D.$Xc)(()=>{for(const[a,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(l){const d=this.h.getTerminalById(l);if(!d)return;const a=d.value;let i=this.b.get(l);i||(i=new u(d.value,this.f),this.b.set(l,i),i.store.add(d.onWillDispose(()=>this.b.get(l)?.dispose())),i.store.add(i.onDidRequestShellExecution(n=>this.a.$executeCommand(l,n))),i.store.add(i.onDidRequestEndExecution(n=>this.g.fire(n))),i.store.add(i.onDidRequestChangeShellIntegration(n=>this.c.fire(n))),d.shellIntegration=i.value),this.c.fire({terminal:a,shellIntegration:i.value})}$shellExecutionStart(l,d,a,i,n){this.b.has(l)||this.$shellIntegrationChange(l);const t={value:d,confidence:a,isTrusted:i};this.b.get(l)?.startShellExecution(t,s.URI.revive(n))}$shellExecutionEnd(l,d,a,i,n){const t={value:d,confidence:a,isTrusted:i};this.b.get(l)?.endShellExecution(t,n)}$shellExecutionData(l,d){this.b.get(l)?.emitData(d)}$cwdChange(l,d){this.b.get(l)?.setCwd(s.URI.revive(d))}$closeTerminal(l){this.b.get(l)?.dispose(),this.b.delete(l)}};e.$Wsc=w,e.$Wsc=w=He([qe(0,R.$KQ),qe(1,O.$Drc)],w);class u extends D.$Zc{get currentExecution(){return this.a}constructor(l,d){super(),this.j=l,this.m=d,this.b=!1,this.store=this.B(new D.$Yc),this.f=this.B(new m.$qe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$qe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$qe),this.onDidRequestEndExecution=this.h.event;const a=this;this.value={get cwd(){return a.c},executeCommand(i,n){let t=i;n&&(t+=` "${n.map(g=>`${g.replaceAll('"','\\"')}`).join('" "')}"`),a.g.fire(t);const o={value:t,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},c=a.startShellExecution(o,a.c,!0).value;return a.b=!0,c}}}startShellExecution(l,d,a){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new E(l,d??this.c);a?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(l){this.currentExecution?.emitData(l)}endShellExecution(l,d){this.a&&(this.a.endExecution(l),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:d}),this.a=void 0)}setCwd(l){let d=!1;s.URI.isUri(this.c)?d=!s.URI.isUri(l)||this.c.toString()!==l.toString():this.c!==l&&(d=!0),d&&(this.c=l,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class E{constructor(l,d){this.c=l,this.cwd=d,this.b=!1;const a=this;this.value={get commandLine(){return a.c},get cwd(){return a.cwd},read(){return a.d()}}}d(){if(!this.a){if(this.b)return I.$$h.EMPTY;this.a=new p}return this.a.createIterable()}emitData(l){this.a?.emitData(l)}endExecution(l){l&&(this.c=l),this.a?.endExecution(),this.a=void 0,this.b=!0}}class p extends D.$Zc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Jh);const l=this.a;return new I.$$h(async a=>{this.b.push(a),await l.wait()})}emitData(l){for(const d of this.b)d.emitOne(l)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Re[129],Te([1,0,61,12,97,8,7]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TQ=e.$SQ=e.$RQ=void 0,L=Ve(L);class O{static{this.c=new P.$PQ("TextEditorDecorationType")}constructor(u,E,p){const r=O.c.nextId();u.$registerTextEditorDecorationType(E.identifier,r,L.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.$RQ=O;class m{constructor(u,E){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,E){this.k();let p=null;if(u instanceof R.$aO)p=new R.$bO(u,u);else if(u instanceof R.$bO)p=u;else throw new Error("Unrecognized location");this.l(p,E,!1)}insert(u,E){this.k(),this.l(new R.$bO(u,u),E,!0)}delete(u){this.k();let E=null;if(u instanceof R.$bO)E=u;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(u,E,p){const r=this.c.validateRange(u);this.g.push({range:r,text:E,forceMoveMarkers:p})}setEndOfLine(u){if(this.k(),u!==R.EndOfLine.LF&&u!==R.EndOfLine.CRLF)throw(0,D.$$)("endOfLine");this.h=u}}class s{constructor(u,E,p,r){this.c=u,this.d=E,this._accept(p),this.e=r;const l=this;this.value={get tabSize(){return l.f},set tabSize(d){l.n(d)},get indentSize(){return l.g},set indentSize(d){l.p(d)},get insertSpaces(){return l.j},set insertSpaces(d){l.s(d)},get cursorStyle(){return l.k},set cursorStyle(d){l.t(d)},get lineNumbers(){return l.l},set lineNumbers(d){l.u(d)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=L.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}n(u){const E=this.m(u);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}p(u){const E=this.o(u);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const E=this.q(u);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(u)})))}assign(u){const E={};let p=!1;if(typeof u.tabSize<"u"){const r=this.m(u.tabSize);r==="auto"?(p=!0,E.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,p=!0,E.tabSize=r)}if(typeof u.indentSize<"u"){const r=this.o(u.indentSize);r==="tabSize"?(p=!0,E.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,p=!0,E.indentSize=r)}if(typeof u.insertSpaces<"u"){const r=this.q(u.insertSpaces);r==="auto"?(p=!0,E.insertSpaces=r):this.j!==r&&(this.j=r,p=!0,E.insertSpaces=r)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,p=!0,E.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,p=!0,E.lineNumbers=L.TextEditorLineNumbersStyle.from(u.lineNumbers)),p&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(u,E){E.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(p)})}}e.$SQ=s;class I{constructor(u,E,p,r,l,d,a,i){this.id=u,this.j=E,this.k=p,this.g=!1,this.h=new Set,this.c=l,this.d=new s(this.j,this.id,d,p),this.e=a,this.f=i;const n=this;this.value=Object.freeze({get document(){return r.value},set document(t){throw new D.$ab("document")},get selection(){return n.c&&n.c[0]},set selection(t){if(!(t instanceof R.$cO))throw(0,D.$$)("selection");n.c=[t],n.l()},get selections(){return n.c},set selections(t){if(!Array.isArray(t)||t.some(o=>!(o instanceof R.$cO)))throw(0,D.$$)("selections");n.c=t,n.l()},get visibleRanges(){return n.e},set visibleRanges(t){throw new D.$ab("visibleRanges")},get options(){return n.d.value},set options(t){n.g||n.d.assign(t)},get viewColumn(){return n.f},set viewColumn(t){throw new D.$ab("viewColumn")},edit(t,o={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const c=new m(r.value,o);return t(c),n.m(c)},insertSnippet(t,o,c={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let g;if(!o||Array.isArray(o)&&o.length===0)g=n.c.map(f=>L.Range.from(f));else if(o instanceof R.$aO){const{lineNumber:f,column:h}=L.Position.from(o);g=[{startLineNumber:f,startColumn:h,endLineNumber:f,endColumn:h}]}else if(o instanceof R.$bO)g=[L.Range.from(o)];else{g=[];for(const f of o)if(f instanceof R.$bO)g.push(L.Range.from(f));else{const{lineNumber:h,column:S}=L.Position.from(f);g.push({startLineNumber:h,startColumn:S,endLineNumber:h,endColumn:S})}}return E.$tryInsertSnippet(u,r.value.version,t.value,g,c)},setDecorations(t,o){const c=o.length===0;c&&!n.h.has(t.key)||(c?n.h.delete(t.key):n.h.add(t.key),n.n(()=>{if(L.$HQ(o))return E.$trySetDecorations(u,t.key,L.$IQ(o));{const g=new Array(4*o.length);for(let f=0,h=o.length;f<h;f++){const S=o[f];g[4*f]=S.start.line+1,g[4*f+1]=S.start.character+1,g[4*f+2]=S.end.line+1,g[4*f+3]=S.end.character+1}return E.$trySetDecorationsFast(u,t.key,g)}}))},revealRange(t,o){n.n(()=>E.$tryRevealRange(u,L.Range.from(t),o||R.TextEditorRevealType.Default))},show(t){E.$tryShowEditor(u,L.ViewColumn.from(t))},hide(){E.$tryHideEditor(u)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,v.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,v.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,v.ok)(!this.g),this.f=u}_acceptSelections(u){(0,v.ok)(!this.g),this.c=u}async l(){const u=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const E=u.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const p=E.edits.map(l=>l.range);p.sort((l,d)=>l.end.line===d.end.line?l.end.character===d.end.character?l.start.line===d.start.line?l.start.character-d.start.character:l.start.line-d.start.line:l.end.character-d.end.character:l.end.line-d.end.line);for(let l=0,d=p.length-1;l<d;l++){const a=p[l].end;if(p[l+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=E.edits.map(l=>({range:L.Range.from(l.range),text:l.text,forceMoveMarkers:l.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,r,{setEndOfLine:typeof E.setEndOfLine=="number"?L.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$TQ=I}),define(Re[57],Te([1,0,61,6,4,2,3,5,125,16,129,8,11,27,15,41,51]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VQ=e.$UQ=void 0,v=Ve(v),w=Ve(w);class d{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let a=class{constructor(n,t){this.h=n,this.i=t,this.a=null,this.b=new Map,this.c=new E.$Fc,this.d=new D.$qe,this.e=new D.$qe,this.f=new D.$qe,this.g=new D.$qe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const t=[],o=[],c=[];if(n.removedDocuments)for(const g of n.removedDocuments){const f=L.URI.revive(g),h=this.c.get(f);h?.unref()&&(this.c.delete(f),t.push(h.value))}if(n.addedDocuments)for(const g of n.addedDocuments){const f=L.URI.revive(g.uri);let h=this.c.get(f);if(h&&f.scheme!==p.Schemas.vscodeNotebookCell&&f.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${f} already exists!'`);h||(h=new d(new m.$NQ(this.h.getProxy(O.$0N.MainThreadDocuments),f,g.lines,g.EOL,g.versionId,g.languageId,g.isDirty)),this.c.set(f,h),o.push(h.value)),h.ref()}if(n.removedEditors)for(const g of n.removedEditors){const f=this.b.get(g);this.b.delete(g),f&&c.push(f)}if(n.addedEditors)for(const g of n.addedEditors){const f=L.URI.revive(g.documentUri);v.ok(this.c.has(f),`document '${f}' does not exist`),v.ok(!this.b.has(g.id),`editor '${g.id}' already exists!`);const h=this.c.get(f).value,S=new I.$TQ(g.id,this.h.getProxy(O.$0N.MainThreadTextEditors),this.i,new l.$Y(()=>h.document),g.selections.map(w.Selection.to),g.options,g.visibleRanges.map(k=>w.Range.to(k)),typeof g.editorPosition=="number"?w.ViewColumn.to(g.editorPosition):void 0);this.b.set(g.id,S)}n.newActiveEditor!==void 0&&(v.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,P.$Uc)(t),(0,P.$Uc)(c),n.removedDocuments&&this.e.fire(t),n.addedDocuments&&this.d.fire(o),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(g=>g.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return r.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const t=this.b.get(this.a);return n?t:t?.value}allEditors(){return[...this.b.values()]}};e.$UQ=a,e.$UQ=a=He([qe(0,s.$KQ),qe(1,u.$fk)],a),e.$VQ=(0,R.$Ki)("IExtHostDocumentsAndEditors")}),define(Re[96],Te([1,0,10,20,19,6,230,76,4,38,14,2,33,3,11,5,35,57,16,127,8,7,199,54,82,55,21]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i,n,t,o,c,g,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2rc=e.$1rc=e.$Zrc=e.$Yrc=e.$Xrc=void 0,n=Ve(n);let S=0;const k=new WeakMap;e.$Xrc=(0,E.$Ki)("IExtHostTesting");let y=class extends m.$Zc{constructor(ee,oe,ie,ue){super(),this.C=oe,this.D=ie,this.F=ue,this.f=this.B(new L.$qe),this.g=new Map,this.w=this.B(new L.$qe),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=ee.getProxy(r.$0N.MainThreadTesting),this.m=new x(this.h),this.j=new b(this.h,oe),ie.registerArgumentProcessor({processArgument:_=>{switch(_?.$mid){case s.MarshalledId.TestItemContext:{const $e=_,Ie=$e.tests[$e.tests.length-1].item.extId;return this.g.get(c.$pJ.root(Ie))?.collection.tree.get(Ie)?.actual??(0,i.$WQ)(_)}case s.MarshalledId.TestMessageMenuArgs:{const{test:$e,message:Ie}=_,X=$e.item.extId;return{test:this.g.get(c.$pJ.root(X))?.collection.tree.get(X)?.actual??(0,i.$WQ)({$mid:s.MarshalledId.TestItemContext,tests:[$e]}),message:n.TestMessage.to(Ie)}}default:return _}}}),ie.registerCommand(!1,"testing.getExplorerSelection",async()=>{const _=await ie.executeCommand(o.TestCommandId.GetExplorerSelection),$e=Ie=>{const X=this.g.get(c.$pJ.root(Ie));if(X)return c.$pJ.isRoot(Ie)?X.controller:X.collection.tree.get(Ie)?.actual};return{include:_?.include.map($e).filter(I.$rg)||[],exclude:_?.exclude.map($e).filter(I.$rg)||[]}})}createTestController(ee,oe,ie,ue){if(this.g.has(oe))throw new Error(`Attempt to insert a duplicate controller with ID "${oe}"`);const _=new m.$Yc,$e=_.add(new i.$ZQ(oe,ie,this.F));$e.root.label=ie;const Ie=new Map,X=new Set,V=this.h,re=()=>{let Fe=0;ue&&(Fe|=f.TestControllerCapability.Refresh);const Be=Pe.relatedCodeProvider;return Be&&(Be?.provideRelatedTests&&(Fe|=f.TestControllerCapability.TestRelatedToCode),Be?.provideRelatedCode&&(Fe|=f.TestControllerCapability.CodeRelatedToTest)),Fe},be={items:$e.root.children,get label(){return ie},set label(Fe){ie=Fe,$e.root.label=Fe,V.$updateController(oe,{label:ie})},get refreshHandler(){return ue},set refreshHandler(Fe){ue=Fe,V.$updateController(oe,{capabilities:re()})},get id(){return oe},get relatedCodeProvider(){return Pe.relatedCodeProvider},set relatedCodeProvider(Fe){(0,h.$zH)(ee,"testRelatedCode"),Pe.relatedCodeProvider=Fe,V.$updateController(oe,{capabilities:re()})},createRunProfile:(Fe,Be,xe,nt,ht,$t)=>{let ut=(0,O.$yj)(Fe);for(;Ie.has(ut);)ut++;return new U(this.h,Ie,X,this.w.event,oe,ut,Fe,Be,xe,nt,ht,$t)},createTestItem(Fe,Be,xe){return new i.$XQ(oe,Fe,Be,xe)},createTestRun:(Fe,Be,xe=!0)=>this.j.createTestRun(ee,oe,$e,Fe,Be,xe),invalidateTestResults:Fe=>{if(Fe===void 0)this.h.$markTestRetired(void 0);else{const Be=Fe instanceof Array?Fe:[Fe];this.h.$markTestRetired(Be.map(xe=>c.$pJ.fromExtHostTestItem(xe,oe).toString()))}},set resolveHandler(Fe){$e.resolveHandler=Fe},get resolveHandler(){return $e.resolveHandler},dispose:()=>{_.dispose()}},Pe={controller:be,collection:$e,profiles:Ie,extension:ee,activeProfiles:X};return V.$registerTestController(oe,ie,re()),_.add((0,m.$Xc)(()=>V.$unregisterTestController(oe))),this.g.set(oe,Pe),_.add((0,m.$Xc)(()=>this.g.delete(oe))),_.add($e.onDidGenerateDiff(Fe=>V.$publishDiff(oe,Fe.map(f.TestsDiffOp.serialize)))),be}createTestObserver(){return this.m.checkout()}async runTests(ee,oe=P.CancellationToken.None){const ie=N(ee);if(!ie)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ue=this.g.get(ie.controllerId);if(!ue)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:ee.preserveFocus??!0,group:J[ie.kind],targets:[{testIds:ee.include?.map(_=>c.$pJ.fromExtHostTestItem(_,ue.collection.root.id).toString())??[ue.collection.root.id],profileId:ie.profileId,controllerId:ie.controllerId}],exclude:ee.exclude?.map(_=>_.id)},oe)}registerTestFollowupProvider(ee){return this.y.add(ee),{dispose:()=>{this.y.delete(ee)}}}async $getTestsRelatedToCode(ee,oe,ie){const ue=this.F.getDocument(w.URI.revive(ee));if(!ue)return[];const _=n.Position.to(oe),$e=[];return await Promise.all([...this.g.values()].map(async Ie=>{let X;try{X=await Ie.relatedCodeProvider?.provideRelatedTests?.(ue.document,_,ie)}catch(V){ie.isCancellationRequested||this.C.warn(`Error thrown while providing related tests for ${Ie.controller.label}`,V)}if(X){for(const V of X)$e.push(c.$pJ.fromExtHostTestItem(V,Ie.controller.id).toString());Ie.collection.flushDiff()}})),$e}async $getCodeRelatedToTest(ee,oe){const ie=this.g.get(c.$pJ.root(ee));if(!ie)return[];const ue=ie.collection.tree.get(ee);return ue?(await ie.relatedCodeProvider?.provideRelatedCode?.(ue.actual,oe))?.map(n.location.from)??[]:[]}$syncTests(){for(const{collection:ee}of this.g.values())ee.flushDiff();return Promise.resolve()}async $getCoverageDetails(ee,oe,ie){return(await this.j.getCoverageDetails(ee,oe,ie))?.map(n.TestCoverage.fromDetails)}async $disposeRun(ee){this.j.disposeTestRun(ee)}$configureRunProfile(ee,oe){this.g.get(ee)?.profiles.get(oe)?.configureHandler?.()}$setDefaultRunProfiles(ee){const oe=new Map;for(const[ie,ue]of Object.entries(ee)){const _=this.g.get(ie);if(!_)continue;const $e=new Map,Ie=ue.filter(V=>!_.activeProfiles.has(V)),X=[..._.activeProfiles].filter(V=>!ue.includes(V));for(const V of Ie)$e.set(V,!0),_.activeProfiles.add(V);for(const V of X)$e.set(V,!1),_.activeProfiles.delete(V);$e.size&&oe.set(ie,$e)}this.w.fire(oe)}async $refreshTests(ee,oe){await this.g.get(ee)?.controller.refreshHandler?.(oe)}$publishTestResults(ee){this.results=Object.freeze(ee.map(oe=>{const ie=n.TestResults.to(oe),ue=oe.tasks.findIndex(_=>_.hasCoverage);return ue!==-1&&(ie.getDetailedCoverage=(_,$e=P.CancellationToken.None)=>this.h.$getCoverageDetails(oe.id,ue,_,$e).then(Ie=>Ie.map(n.TestCoverage.to))),k.set(ie,oe.id),ie}).concat(this.results).sort((oe,ie)=>ie.completedAt-oe.completedAt).slice(0,32)),this.f.fire()}async $expandTest(ee,oe){const ie=this.g.get(c.$pJ.fromString(ee).controllerId)?.collection;ie&&(await ie.expand(ee,oe<0?1/0:oe),ie.flushDiff())}$acceptDiff(ee){this.m.applyDiff(ee.map(oe=>f.TestsDiffOp.deserialize({asCanonicalUri:ie=>ie},oe)))}async $runControllerTests(ee,oe){return Promise.all(ee.map(ie=>this.G(ie,!1,oe)))}async $startContinuousRun(ee,oe){const ie=new P.$Be(oe),ue=await Promise.all(ee.map(_=>this.G(_,!0,ie.token)));return!oe.isCancellationRequested&&!ue.some(_=>_.error)&&await new Promise(_=>oe.onCancellationRequested(_)),ie.dispose(!0),ue}async $provideTestFollowups(ee,oe){const ie=this.results.find($e=>k.get($e)===ee.resultId),ue=ie&&Z(c.$pJ.fromString(ee.extId),ie?.results);if(!ue)return[];let _=[];return await Promise.all([...this.y].map(async $e=>{try{const Ie=await $e.provideFollowup(ie,ue,ee.taskIndex,ee.messageIndex,oe);Ie&&(_=_.concat(Ie))}catch(Ie){this.C.error("Error thrown while providing followup for test message",Ie)}})),oe.isCancellationRequested?[]:_.map($e=>{const Ie=S++;return this.z.set(Ie,$e),{title:$e.title,id:Ie}})}$disposeTestFollowups(ee){for(const oe of ee)this.z.delete(oe)}$executeTestFollowup(ee){const oe=this.z.get(ee);return oe?this.D.executeCommand(oe.command,...oe.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(ee,oe){ee===void 0?this.j.cancelAllRuns():this.j.cancelRunById(ee,oe)}getMetadataForRun(ee){for(const oe of this.j.trackers){const ie=oe.getTaskIdForRun(ee);if(ie)return{taskId:ie,runId:oe.id}}}async G(ee,oe,ie){const ue=this.g.get(ee.controllerId);if(!ue)return{};const{collection:_,profiles:$e,extension:Ie}=ue,X=$e.get(ee.profileId);if(!X)return{};const V=ee.testIds.map(Fe=>_.tree.get(Fe)).filter(I.$rg),re=ee.excludeExtIds.map(Fe=>ue.collection.tree.get(Fe)).filter(I.$rg).filter(Fe=>V.some(Be=>Be.fullId.compare(Fe.fullId)===c.TestPosition.IsChild));if(!V.length)return{};const be=new t.$OP(V.some(Fe=>Fe.actual instanceof i.$YQ)?void 0:V.map(Fe=>Fe.actual),re.map(Fe=>Fe.actual),X,oe),Pe=(0,f.$sJ)(ee)&&this.j.prepareForMainThreadTestRun(Ie,be,A.fromInternal(ee,ue.collection),X,ie);try{return await X.runHandler(be,ie),{}}catch(Fe){return{error:String(Fe)}}finally{Pe&&Pe.hasRunningTasks&&!ie.isCancellationRequested&&await L.Event.toPromise(Pe.onEnd)}}};e.$Yrc=y,e.$Yrc=y=He([qe(0,a.$KQ),qe(1,p.$fk),qe(2,l.$7Q),qe(3,d.$VQ)],y);const C=1e4;var T;(function(ae){ae[ae.Running=0]="Running",ae[ae.Cancelling=1]="Cancelling",ae[ae.Ended=2]="Ended"})(T||(T={}));class $ extends m.$Zc{get hasRunningTasks(){return this.g>0}get id(){return this.C.id}constructor(ee,oe,ie,ue,_,$e){super(),this.C=ee,this.D=oe,this.F=ie,this.G=ue,this.H=_,this.f=T.Running,this.g=0,this.h=new Map,this.j=new Set,this.w=this.B(new L.$qe),this.z=new Map,this.onEnd=this.w.event,this.m=this.B(new P.$Be($e));const Ie=this.B(new v.$Wh(()=>this.I(),C));this.B(this.m.token.onCancellationRequested(()=>Ie.schedule()));const X=new L.$qe;this.y=X.event,this.B((0,m.$Xc)(()=>{X.fire(),X.dispose()}))}getTaskIdForRun(ee){for(const[oe,{run:ie}]of this.h)if(ie===ee)return oe}cancel(ee){ee?this.h.get(ee)?.cts.cancel():this.f===T.Running?(this.m.cancel(),this.f=T.Cancelling):this.f===T.Cancelling&&this.I()}async getCoverageDetails(ee,oe,ie){const[,ue]=c.$pJ.fromString(ee).path,_=this.z.get(ee);if(!_)return[];const{report:$e,extIds:Ie}=_,X=this.h.get(ue);if(!X)throw new Error("unreachable: run task was not found");let V;if(oe&&$e instanceof t.$UP){const be=Ie.indexOf(oe);if(be===-1)return[];V=$e.fromTests[be]}return await(V?this.G?.loadDetailedCoverageForTest?.(X.run,$e,V,ie):this.G?.loadDetailedCoverage?.(X.run,$e,ie))??[]}createRun(ee){const oe=this.C.id,ie=this.C.controllerId,ue=(0,u.$7g)(),_=re=>(be,...Pe)=>{if(Ie){this.F.warn(`Setting the state of test "${be.id}" is a no-op after the run ends.`);return}this.L(be),re(be,...Pe)},$e=(re,be)=>{const Pe=be instanceof Array?be.map(n.TestMessage.from):[n.TestMessage.from(be)];if(re.uri&&re.range){const Fe={range:n.Range.from(re.range),uri:re.uri};for(const Be of Pe)Be.location=Be.location||Fe}this.D.$appendTestMessagesInRun(oe,ue,c.$pJ.fromExtHostTestItem(re,ie).toString(),Pe)};let Ie=!1;const X=this.B(new P.$Be(this.m.token)),V={isPersisted:this.C.isPersisted,token:X.token,name:ee,onDidDispose:this.y,addCoverage:re=>{if(Ie)return;const be=re instanceof t.$UP?re.fromTests:[];if(be.length){(0,h.$zH)(this.H,"attributableCoverage");for(const Be of be)this.L(Be)}const Pe=re.uri.toString(),Fe=new c.$pJ([oe,ue,Pe]).toString();this.z.set(Fe,{report:re,extIds:be.map(Be=>c.$pJ.fromExtHostTestItem(Be,ie).toString())}),this.D.$appendCoverage(oe,ue,n.TestCoverage.fromFile(ie,Fe,re))},enqueued:_(re=>{this.D.$updateTestStateInRun(oe,ue,c.$pJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Queued)}),skipped:_(re=>{this.D.$updateTestStateInRun(oe,ue,c.$pJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Skipped)}),started:_(re=>{this.D.$updateTestStateInRun(oe,ue,c.$pJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Running)}),errored:_((re,be,Pe)=>{$e(re,be),this.D.$updateTestStateInRun(oe,ue,c.$pJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Errored,Pe)}),failed:_((re,be,Pe)=>{$e(re,be),this.D.$updateTestStateInRun(oe,ue,c.$pJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Failed,Pe)}),passed:_((re,be)=>{this.D.$updateTestStateInRun(oe,ue,c.$pJ.fromExtHostTestItem(re,this.C.controllerId).toString(),f.TestResultState.Passed,be)}),appendOutput:(re,be,Pe)=>{Ie||(Pe&&this.L(Pe),this.D.$appendOutputToRun(oe,ue,D.$Se.fromString(re),be&&n.location.from(be),Pe&&c.$pJ.fromExtHostTestItem(Pe,ie).toString()))},end:()=>{Ie||(Ie=!0,this.D.$finishedTestRunTask(oe,ue),--this.g||this.J())}};return this.g++,this.h.set(ue,{run:V,cts:X}),this.D.$startedTestRunTask(oe,{id:ue,ctrlId:this.C.controllerId,name:ee||this.H.displayName||this.H.identifier.value,running:!0}),V}I(){for(const{run:ee}of this.h.values())ee.end()}J(){this.f!==T.Ended&&(this.f=T.Ended,this.w.fire())}L(ee){if(!(ee instanceof i.$XQ))throw new g.$CQ(ee.id);if(this.j.has(c.$pJ.fromExtHostTestItem(ee,this.C.controllerId).toString()))return;const oe=[],ie=this.C.colllection.root;for(;;){const ue=n.TestItem.from(ee);if(oe.unshift(ue),this.j.has(ue.extId)||(this.j.add(ue.extId),ee===ie))break;ee=ee.parent||ie}this.D.$addTestsToRun(this.C.controllerId,this.C.id,oe)}dispose(){this.J(),super.dispose()}}class b{get trackers(){return this.f.values()}constructor(ee,oe){this.h=ee,this.j=oe,this.f=new Map,this.g=new Map}getCoverageDetails(ee,oe,ie){const ue=c.$pJ.root(ee);return this.g.get(ue)?.getCoverageDetails(ee,oe,ie)||[]}disposeTestRun(ee){this.g.get(ee)?.dispose(),this.g.delete(ee);for(const[oe,{id:ie}]of this.f)ie===ee&&this.f.delete(oe)}prepareForMainThreadTestRun(ee,oe,ie,ue,_){return this.k(oe,ie,ue,ee,_)}cancelRunById(ee,oe){this.g.get(ee)?.cancel(oe)}cancelAllRuns(){for(const ee of this.f.values())ee.cancel()}createTestRun(ee,oe,ie,ue,_,$e){const Ie=this.f.get(ue);if(Ie)return Ie.createRun(_);const X=A.fromPublic(oe,ie,ue,$e),V=N(ue);this.h.$startedExtensionTestRun({controllerId:oe,continuous:!!ue.continuous,profile:V&&{group:J[V.kind],id:V.profileId},exclude:ue.exclude?.map(be=>c.$pJ.fromExtHostTestItem(be,ie.root.id).toString())??[],id:X.id,include:ue.include?.map(be=>c.$pJ.fromExtHostTestItem(be,ie.root.id).toString())??[ie.root.id],preserveFocus:ue.preserveFocus??!0,persist:$e});const re=this.k(ue,X,ue.profile,ee);return L.Event.once(re.onEnd)(()=>{this.h.$finishedExtensionTestRun(X.id)}),re.createRun(_)}k(ee,oe,ie,ue,_){const $e=new $(oe,this.h,this.j,ie,ue,_);return this.f.set(ee,$e),this.g.set($e.id,$e),$e}}e.$Zrc=b;const N=ae=>{if(ae.profile){if(!(ae.profile instanceof U))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ae.profile}};class A{static fromPublic(ee,oe,ie,ue){return new A(ee,(0,u.$7g)(),ue,oe)}static fromInternal(ee,oe){return new A(ee.controllerId,ee.runId,!0,oe)}constructor(ee,oe,ie,ue){this.controllerId=ee,this.id=oe,this.isPersisted=ie,this.colllection=ue}}e.$1rc=A;class F{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(ee){this.k=ee,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(ee){this.f.add(ee)}update(ee){Object.assign(ee.revived,n.TestItem.toPlain(ee.item)),this.f.has(ee)||this.g.add(ee)}remove(ee){if(this.f.has(ee)){this.f.delete(ee);return}this.g.delete(ee);const oe=c.$pJ.parentId(ee.item.extId);if(oe&&this.j.has(oe.toString())){this.j.add(ee.item.extId);return}this.h.add(ee)}getChangeEvent(){const{f:ee,g:oe,h:ie}=this;return{get added(){return[...ee].map(ue=>ue.revived)},get updated(){return[...oe].map(ue=>ue.revived)},get removed(){return[...ie].map(ue=>ue.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class G extends f.$yJ{constructor(){super(...arguments),this.z=new L.$qe,this.onDidChangeTests=this.z.event}get rootTests(){return this.h}getMirroredTestDataById(ee){return this.g.get(ee)}getMirroredTestDataByReference(ee){return this.g.get(ee.id)}y(ee,oe){return{...ee,revived:n.TestItem.toPlain(ee.item),depth:oe?oe.depth+1:0,children:new Set}}x(){return new F(this.z)}}class x{constructor(ee){this.g=ee}checkout(){this.f||(this.f=this.h());const ee=this.f;return ee.observers++,{onDidChangeTest:ee.tests.onDidChangeTests,get tests(){return[...ee.tests.rootTests].map(oe=>oe.revived)},dispose:(0,R.$hb)(()=>{--ee.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(ee){return this.f?.tests.getMirroredTestDataByReference(ee)}applyDiff(ee){this.f?.tests.apply(ee)}h(){const ee=new G({asCanonicalUri:oe=>oe});return this.g.$subscribeToDiffs(),{observers:0,tests:ee}}}const j=(ae,ee,oe,ie)=>{oe?Object.assign(oe,ie):ee.$updateTestRunConfig(ae.controllerId,ae.profileId,ie)};class U{#e;#t;#i;#n;#s;get label(){return this.g}set label(ee){ee!==this.g&&(this.g=ee,j(this,this.#e,this.#n,{label:ee}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(ee){ee!==this.h&&(this.h=ee,j(this,this.#e,this.#n,{supportsContinuousRun:ee}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(ee){ee!==this.isDefault&&(ee?this.#t.add(this.profileId):this.#t.delete(this.profileId),j(this,this.#e,this.#n,{isDefault:ee}))}get tag(){return this._tag}set tag(ee){ee?.id!==this._tag?.id&&(this._tag=ee,j(this,this.#e,this.#n,{tag:ee?n.TestTag.namespace(this.controllerId,ee.id):null}))}get configureHandler(){return this.f}set configureHandler(ee){ee!==this.f&&(this.f=ee,j(this,this.#e,this.#n,{hasConfigurationHandler:!!ee}))}get onDidChangeDefault(){return L.Event.chain(this.#i,ee=>ee.map(oe=>oe.get(this.controllerId)?.get(this.profileId)).filter(I.$rg))}constructor(ee,oe,ie,ue,_,$e,Ie,X,V,re=!1,be=void 0,Pe=!1){this.controllerId=_,this.profileId=$e,this.g=Ie,this.kind=X,this.runHandler=V,this._tag=be,this.h=Pe,this.#e=ee,this.#s=oe,this.#t=ie,this.#i=ue,oe.set($e,this);const Fe=J[X];if(typeof Fe!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);re&&ie.add($e),this.#n={profileId:$e,controllerId:_,tag:be?n.TestTag.namespace(this.controllerId,be.id):null,label:Ie,group:Fe,isDefault:re,hasConfigurationHandler:!1,supportsContinuousRun:Pe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$2rc=U;const J={[t.TestRunProfileKind.Coverage]:f.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:f.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:f.TestRunProfileBitset.Run};function Z(ae,ee){for(let oe=0;oe<ae.path.length;oe++){const ie=ee.find(ue=>ue.id===ae.path[oe]);if(!ie)return;if(oe===ae.path.length-1)return ie;ee=ie.children}}}),define(Re[258],Te([1,0,17,6,4,5,129,8,7]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=void 0,v=Ve(v),O=Ve(O);class s extends P.$Zc{constructor(w,u){super(),this.m=u,this.a=new D.$qe,this.b=new D.$qe,this.c=new D.$qe,this.f=new D.$qe,this.g=new D.$qe,this.h=new D.$qe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=w.getProxy(L.$0N.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(E=>this.h.fire(E))),this.B(this.m.onDidChangeActiveTextEditor(E=>this.g.fire(E)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(w){const u=this.m.allEditors();return w?u:u.map(E=>E.value)}async showTextDocument(w,u,E){let p;typeof u=="number"?p={position:O.ViewColumn.from(u),preserveFocus:E}:typeof u=="object"?p={position:O.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?O.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:p={preserveFocus:!1};const r=await this.j.$tryShowTextDocument(w.uri,p),l=r&&this.m.getEditor(r);if(l)return l.value;throw r?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}createTextEditorDecorationType(w,u){return new R.$RQ(this.j,w,u).value}$acceptEditorPropertiesChanged(w,u){const E=this.m.getEditor(w);if(!E)throw new Error("unknown text editor");if(u.options&&E._acceptOptions(u.options),u.selections){const p=u.selections.selections.map(O.Selection.to);E._acceptSelections(p)}if(u.visibleRanges){const p=v.$Lb(u.visibleRanges.map(O.Range.to));E._acceptVisibleRanges(p)}if(u.options&&this.b.fire({textEditor:E.value,options:{...u.options,lineNumbers:O.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const p=m.TextEditorSelectionChangeKind.fromValue(u.selections.source),r=u.selections.selections.map(O.Selection.to);this.a.fire({textEditor:E.value,selections:r,kind:p})}if(u.visibleRanges){const p=v.$Lb(u.visibleRanges.map(O.Range.to));this.c.fire({textEditor:E.value,visibleRanges:p})}}$acceptEditorPositionData(w){for(const u in w){const E=this.m.getEditor(u);if(!E)throw new Error("Unknown text editor");const p=O.ViewColumn.to(w[u]);E.value.viewColumn!==p&&(E._acceptViewColumn(p),this.f.fire({textEditor:E.value,viewColumn:p}))}}getDiffInformation(w){return Promise.resolve(this.j.$getDiffInformation(w))}}e.$9qc=s}),define(Re[259],Te([1,0,2,3,5,4,7,8,18,38,14]),function(we,e,v,D,P,L,R,O,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zsc=e.$Ysc=void 0,e.$Ysc=(0,D.$Ki)("IExtHostTimeline");class w{constructor(p,r){this.b=new Map,this.c=new Map,this.a=p.getProxy(P.$0N.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(l,d)=>{if(l&&l.$mid===s.MarshalledId.TimelineActionContext)if(this.b.get(l.source)&&m.$xn.equals(d,this.b.get(l.source)?.extension)){const a=l.uri===void 0?void 0:v.URI.revive(l.uri);return this.c.get(l.source)?.get(u(a))?.get(l.handle)}else return;return l}})}async $getTimeline(p,r,l,d){return this.b.get(p)?.provider.provideTimeline(v.URI.revive(r),l,d)}registerTimelineProvider(p,r,l,d){const a=new L.$Yc,i=this.d(r.id,d,a).bind(this);let n;r.onDidChange&&(n=r.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:r.id}),this));const t=this.c;return this.f({...r,scheme:p,onDidChange:void 0,async provideTimeline(o,c,g){c?.resetCache&&(a.clear(),t.get(r.id)?.clear());const f=await r.provideTimeline(o,c,g);if(f==null)return;const h=i(o,c);return{...f,source:r.id,items:f.items.map(h)}},dispose(){for(const o of t.values())o.get(r.id)?.clear();n?.dispose(),a.dispose()}},l)}d(p,r,l){return(d,a)=>{let i;if(a?.cacheResults){let n=this.c.get(p);n===void 0&&(n=new Map,this.c.set(p,n));const t=u(d);i=n.get(t),i===void 0&&(i=new Map,n.set(t,i))}return n=>{const{iconPath:t,...o}=n,c=`${p}|${n.id??n.timestamp}`;i?.set(c,n);let g,f,h;n.iconPath&&(t instanceof R.$$O?h={id:t.id,color:t.color}:v.URI.isUri(t)?(g=t,f=t):{light:g,dark:f}=t);let S;return R.$DO.isMarkdownString(o.tooltip)?S=O.MarkdownString.from(o.tooltip):(0,I.$jg)(o.tooltip)?S=o.tooltip:R.$DO.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=O.MarkdownString.from(o.detail)):(0,I.$jg)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=o.detail),{...o,id:o.id??void 0,handle:c,source:p,command:n.command?r.toInternal(n.command,l):void 0,icon:g,iconDark:f,themeIcon:h,tooltip:S,accessibilityInformation:n.accessibilityInformation}}}}f(p,r){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:r}),(0,L.$Xc)(()=>{for(const d of this.c.values())d.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$Zsc=w;function u(E){return E?.toString()}}),define(Re[260],Te([1,0,9,24,2,6,4,191,10,7,14,17,8,59,19,155,21]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1sc=void 0,s=Ve(s);function d(n,t){if((0,I.$jg)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let o;return Array.isArray(n.highlights)&&(o=n.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),o=o.length?o:void 0),{label:n.label,highlights:o}}}class a extends R.$Zc{constructor(t,o,c){super(),this.f=t,this.g=o,this.h=c,this.a=new Map,this.b=new r.$jab;function g(f){return f&&f.$treeViewId&&(f.$treeItemHandle||f.$selectedTreeItems||f.$focusedTreeItem)}o.registerArgumentProcessor({processArgument:f=>g(f)?this.r(f):Array.isArray(f)&&f.length>0?f.map(h=>g(h)?this.r(h):h):f})}registerTreeDataProvider(t,o,c){const g=this.createTreeView(t,{treeDataProvider:o},c);return{dispose:()=>g.dispose()}}createTreeView(t,o,c){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=o.dragAndDropController?.dropMimeTypes??[],f=o.dragAndDropController?.dragMimeTypes??[],h=!!o.dragAndDropController?.handleDrag,S=!!o.dragAndDropController?.handleDrop,k=this.m(t,o,c),y={showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:g,dragMimeTypes:f,hasHandleDrag:h,hasHandleDrop:S,manuallyManageCheckboxes:!!o.manageCheckboxStateManually},C=this.f.$registerTreeViewDataProvider(t,y),T={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,l.$zH)(c,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,l.$zH)(c,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message($){(0,E.$$k)($)&&(0,l.$zH)(c,"treeViewMarkdownMessage"),k.message=$},get title(){return k.title},set title($){k.title=$},get description(){return k.description},set description($){k.description=$},get badge(){return k.badge},set badge($){$!==void 0&&s.ViewBadge.isViewBadge($)?k.badge={value:Math.floor(Math.abs($.value)),tooltip:$.tooltip}:$===void 0&&(k.badge=void 0)},reveal:($,b)=>k.reveal($,b),dispose:async()=>{await C,this.a.delete(t),k.dispose()}};return this.B(T),T}$getChildren(t,o){const c=this.a.get(t);return c?c.getChildren(o):Promise.reject(new O.$TG(t))}async $handleDrop(t,o,c,g,f,h,S,k){const y=this.a.get(t);if(!y)return Promise.reject(new O.$TG(t));const C=u.DataTransfer.toDataTransfer(c,async T=>(await this.f.$resolveDropFileData(t,o,T)).buffer);return S===t&&k&&await this.j(C,y,k,f,h),y.onDrop(C,g,f)}async j(t,o,c,g,f){const h=this.b.removeDragOperationTransfer(f);if(h)(await h)?.forEach((S,k)=>{S&&t.set(k,S)});else if(f&&o.handleDrag){const S=o.handleDrag(c,t,g);this.b.addDragOperationTransfer(f,S),await S}return t}async $handleDrag(t,o,c,g){const f=this.a.get(t);if(!f)return Promise.reject(new O.$TG(t));const h=await this.j(new s.$7O,f,o,g,c);if(!(!h||g.isCancellationRequested))return u.DataTransfer.from(h)}async $hasResolve(t){const o=this.a.get(t);if(!o)throw new O.$TG(t);return o.hasResolve}$resolve(t,o,c){const g=this.a.get(t);if(!g)throw new O.$TG(t);return g.resolveTreeItem(o,c)}$setExpanded(t,o,c){const g=this.a.get(t);if(!g)throw new O.$TG(t);g.setExpanded(o,c)}$setSelectionAndFocus(t,o,c){const g=this.a.get(t);if(!g)throw new O.$TG(t);g.setSelectionAndFocus(o,c)}$setVisible(t,o){const c=this.a.get(t);if(!c){if(!o)return;throw new O.$TG(t)}c.setVisible(o)}$changeCheckboxState(t,o){const c=this.a.get(t);if(!c)throw new O.$TG(t);c.setCheckboxState(o)}m(t,o,c){const g=this.B(new i(t,o,this.f,this.g.converter,this.h,c));return this.a.set(t,g),g}r(t){const o=this.a.get(t.$treeViewId);return o&&"$treeItemHandle"in t?o.getExtensionElement(t.$treeItemHandle):o&&"$focusedTreeItem"in t&&t.$focusedTreeItem?o.focusedElement:null}}e.$1sc=a;class i extends R.$Zc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$sg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,o,c,g,f,h){if(super(),this.I=t,this.J=c,this.L=g,this.M=f,this.N=h,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$qe),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$qe),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$qe),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$qe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$qe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$qe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$qe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$Be,h.contributes&&h.contributes.views)for(const C in h.contributes.views)for(const T of h.contributes.views[C])T.id===t&&(this.P=T.name);this.f=o.treeDataProvider,this.g=o.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(C=>{Array.isArray(C)&&C.length===0||this.F.fire({message:!1,element:C})}));let S,k;const y=L.Event.debounce(this.F.event,(C,T)=>(C||(C={message:!1,elements:[]}),T.element!==!1&&(S||(S=new Promise($=>k=$),this.G=this.G.then(()=>S)),Array.isArray(T.element)?C.elements.push(...T.element):C.elements.push(T.element)),T.message&&(C.message=!0),C),200,!0);this.B(y(({message:C,elements:T})=>{T.length&&(this.H=this.H.then(()=>{const $=k;return S=null,this.$(T).then(()=>$())})),C&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const o=t?this.getExtensionElement(t):void 0;if(t&&!o)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let c=this.X(t);return c||(c=await this.Y(o)),c?c.map(g=>g.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,o){o=o||{select:!0,focus:!1};const c=(0,I.$sg)(o.select)?!0:o.select,g=(0,I.$sg)(o.focus)?!1:o.focus,f=(0,I.$sg)(o.expand)?!1:o.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(h=>this.W(t,h[h.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:h.map(k=>k.item)},{select:c,focus:g,expand:f})),h=>this.M.error(h)):this.J.$reveal(this.I,void 0,{select:c,focus:g,expand:f})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,o){const c=this.getExtensionElement(t);c&&(o?this.u.fire(Object.freeze({element:c})):this.w.fire(Object.freeze({element:c})))}setSelectionAndFocus(t,o){const c=!(0,w.$yb)(this.s,t);this.s=t;const g=this.t!==o;this.t=o,c&&this.y.fire(Object.freeze({selection:this.selectedElements})),g&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const o=(await Promise.all(t.map(async c=>{const g=this.getExtensionElement(c.treeItemHandle);return g?{extensionItem:g,treeItem:await this.f.getTreeItem(g),newState:c.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(c=>c!==void 0);o.forEach(c=>{c.treeItem.checkboxState=c.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}),this.D.fire({items:o.map(c=>[c.extensionItem,c.newState])})}async handleDrag(t,o,c){const g=[];for(const f of t){const h=this.getExtensionElement(f);h&&g.push(h)}if(!(!this.g?.handleDrag||g.length===0))return await this.g.handleDrag(g,o,c),o}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,o,c){const g=o?this.getExtensionElement(o):void 0;if(!(!g&&o||!this.g?.handleDrop))return(0,m.$Ch)(()=>this.g?.handleDrop?this.g.handleDrop(g,t,c):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,o){if(!this.f.resolveTreeItem)return;const c=this.j.get(t);if(c){const g=this.m.get(c);if(g){const f=await this.f.resolveTreeItem(g.extensionItem,c,o)??g.extensionItem;return this.hb(f),g.item.tooltip=this.eb(f.tooltip),g.item.command=this.fb(g.disposableStore,f.command),g.item}}}S(t){return this.U(t).then(o=>o?this.S(o).then(c=>this.W(o,c[c.length-1]).then(g=>(c.push(g),c))):Promise.resolve([]))}U(t){const o=this.m.get(t);return o?Promise.resolve(o.parent?this.j.get(o.parent.item.handle):void 0):(0,m.$Ch)(()=>this.f.getParent(t))}W(t,o){const c=this.m.get(t);return c?Promise.resolve(c):(0,m.$Ch)(()=>this.f.getTreeItem(t)).then(g=>this.kb(t,g,o,!0)).then(g=>this.getChildren(o?o.item.handle:void 0).then(()=>{const f=this.getExtensionElement(g);if(f){const h=this.m.get(f);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${g} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let o;if(typeof t=="string"){const c=this.getExtensionElement(t);o=c?this.m.get(c):void 0}else o=t;return o&&o.children||void 0}return this.h}async Y(t){this.rb(t);const o=new p.$Be(this.Z.token);try{const c=t?this.m.get(t):void 0,g=await this.f.getChildren(t);if(o.token.isCancellationRequested)return;const f=(0,w.$Lb)(g||[]),h=await Promise.all((0,w.$Lb)(f).map(k=>this.f.getTreeItem(k)));if(o.token.isCancellationRequested)return;const S=h.map((k,y)=>k?this.db(f[y],k,c):null);return(0,w.$Lb)(S)}finally{o.dispose()}}$(t){if(t.some(c=>!c))return this.Z.dispose(!0),this.Z=new p.$Be,this.tb(),this.J.$refresh(this.I);{const c=this.ab(t);if(c.length)return this.bb(c)}return Promise.resolve(void 0)}ab(t){const o=new Set,c=t.map(f=>this.m.get(f));for(const f of c)if(f&&!o.has(f.item.handle)){let h=f;for(;h&&h.parent&&c.findIndex(S=>h&&h.parent&&S&&S.item.handle===h.parent.item.handle)===-1;){const S=this.j.get(h.parent.item.handle);h=S?this.m.get(S):void 0}h&&!h.parent&&o.add(f.item.handle)}const g=[];return o.forEach(f=>{const h=this.j.get(f);if(h){const S=this.m.get(h);S&&(!S.parent||!o.has(S.parent.item.handle))&&g.push(f)}}),g}bb(t){const o={};return Promise.all(t.map(c=>this.cb(c).then(g=>{g&&(o[c]=g.item)}))).then(()=>Object.keys(o).length?this.J.$refresh(this.I,o):void 0)}cb(t){const o=this.getExtensionElement(t);if(o){const c=this.m.get(o);if(c)return this.rb(o),(0,m.$Ch)(()=>this.f.getTreeItem(o)).then(g=>{if(g){const f=this.ib(o,g,c.parent);return this.pb(o,f,c,c.parent),c.dispose(),f}return null})}return Promise.resolve(null)}db(t,o,c){const g=this.ib(t,o,c);if(o.id&&this.j.has(g.item.handle))throw new Error((0,v.localize)(2715,null,o.id));return this.ob(t,g),this.qb(g,c),g}eb(t){return s.$DO.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,o){return o?{...this.L.toInternal(o,t),originalId:o.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let o,c,g;return typeof t.checkboxState=="number"?o=t.checkboxState:(o=t.checkboxState.state,c=t.checkboxState.tooltip,g=t.checkboxState.accessibilityInformation),{isChecked:o===s.TreeItemCheckboxState.Checked,tooltip:c,accessibilityInformation:g}}hb(t){if(!s.$2O.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,o,c){this.hb(o);const g=this.B(new R.$Yc),f=this.kb(t,o,c),h=this.lb(o);return{item:{handle:f,parentHandle:c?c.item.handle:void 0,label:d(o.label,this.N),description:o.description,resourceUri:o.resourceUri,tooltip:this.eb(o.tooltip),command:this.fb(g,o.command),contextValue:o.contextValue,icon:h,iconDark:this.mb(o)||h,themeIcon:this.jb(o),collapsibleState:(0,I.$sg)(o.collapsibleState)?s.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation,checkbox:this.gb(o)},extensionItem:o,parent:c,children:void 0,disposableStore:g,dispose(){g.dispose()}}}jb(t){return t.iconPath instanceof s.$$O?t.iconPath:void 0}kb(t,{id:o,label:c,resourceUri:g},f,h){if(o)return`${i.b}/${o}`;const S=d(c,this.N),k=f?f.item.handle:i.a;let y=S?S.label:g?(0,D.$ih)(g):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const C=this.m.has(t)?this.m.get(t).item.handle:void 0,T=this.X(f)||[];let $,b=0;do{if($=`${k}/${b}:${y}`,h||!this.j.has($)||C===$)break;b++}while(b<=T.length);return $}lb(t){if(t.iconPath&&!(t.iconPath instanceof s.$$O))return typeof t.iconPath=="string"||P.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof s.$$O)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return P.URI.isUri(t)?t:P.URI.file(t)}ob(t,o){this.j.set(o.item.handle,t),this.m.set(t,o)}pb(t,o,c,g){this.j.delete(o.item.handle),this.m.delete(t),o.item.handle!==c.item.handle&&this.j.delete(c.item.handle),this.ob(t,o);const f=this.X(g)||[],h=f.filter(S=>S.item.handle===c.item.handle)[0];h&&f.splice(f.indexOf(h),1,o)}qb(t,o){o?(o.children||(o.children=[]),o.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const o=this.m.get(t);if(o){if(o.children)for(const c of o.children){const g=this.j.get(c.item.handle);g&&this.sb(g)}o.children=void 0}}else this.tb()}sb(t){const o=this.m.get(t);if(o){if(o.children)for(const c of o.children){const g=this.j.get(c.item.handle);g&&this.sb(g)}this.m.delete(t),this.j.delete(o.item.handle),o.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[261],Te([1,0,6,4,2,33,8,67,5,7]),function(we,e,v,D,P,L,R,O,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$prc=void 0,R=Ve(R),m=Ve(m),s=Ve(s);class I extends D.$Zc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(p,r,l,d){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new v.$qe),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$qe),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=r,this.#n=l,this.#i=d.viewType,this.#s=d.panelOptions,this.#o=d.viewColumn,this.#r=d.title,this.#l=d.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(p){this.c(),this.#r!==p&&(this.#r=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,P.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(p){this.#u||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#l=p.active,this.#c=p.visible,this.#o=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:R.ViewColumn.from(p),preserveFocus:!!r})}c(){if(this.#u)throw new Error("Webview is disposed")}}class w extends D.$Zc{static c(){return(0,L.$7g)()}constructor(p,r,l){super(),this.j=r,this.m=l,this.g=new Map,this.h=new Map,this.f=p.getProxy(m.$0N.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,r,l,d,a={}){const i=typeof d=="object"?d.viewColumn:d,n={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof d=="object"&&!!d.preserveFocus},t=(0,O.$lrc)(p),o=w.c();this.f.$createWebviewPanel((0,O.$nrc)(p),o,r,{title:l,panelOptions:u(a),webviewOptions:(0,O.$orc)(p,this.m,a),serializeBuffersForPostMessage:t},n);const c=this.j.createNewWebview(o,a,p);return this.createNewWebviewPanel(o,r,l,i,a,c,!0)}$onDidChangeWebviewPanelViewStates(p){const r=Object.keys(p);r.sort((l,d)=>{const a=p[l],i=p[d];return a.active?1:i.active?-1:+a.visible-+i.visible});for(const l of r){const d=this.getWebviewPanel(l);if(!d)continue;const a=p[l];d._updateViewState({active:a.active,visible:a.visible,viewColumn:R.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,r,l){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:l,extension:p}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,O.$lrc)(p)}),new s.$_N(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(p,r,l,d){const a=this.h.get(r);if(!a)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:n}=a,t=this.j.createNewWebview(p,l.webviewOptions,n),o=this.createNewWebviewPanel(p,r,l.title,d,l.panelOptions,t,l.active);await i.deserializeWebviewPanel(o,l.state)}createNewWebviewPanel(p,r,l,d,a,i,n){const t=new I(p,this.f,i,{viewType:r,title:l,viewColumn:d,panelOptions:a,active:n});return this.g.set(p,t),t}getWebviewPanel(p){return this.g.get(p)}}e.$prc=w;function u(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Re[262],Te([1,0,6,4,67,8,5,7]),function(we,e,v,D,P,L,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4sc=void 0,R=Ve(R),O=Ve(O);class m extends D.$Zc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(w,u,E,p,r,l){super(),this.#s=!1,this.#l=this.B(new v.$qe),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new v.$qe),this.onDidDispose=this.#u.event,this.#i=E,this.#a=p,this.#e=w,this.#t=u,this.#n=r,this.#r=l}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(w){this.a(),this.#a!==w&&(this.#a=w,this.#t.$setWebviewViewTitle(this.#e,w))}get description(){return this.a(),this.#o}set description(w){this.a(),this.#o!==w&&(this.#o=w,this.#t.$setWebviewViewDescription(this.#e,w))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(w){w===this.#r||this.#s||(this.#r=w,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(w){this.a(),!(w?.value===this.#c?.value&&w?.tooltip===this.#c?.tooltip)&&(this.#c=L.ViewBadge.from(w),this.#t.$setWebviewViewBadge(this.#e,w))}show(w){this.a(),this.#t.$show(this.#e,!!w)}a(){if(this.#s)throw new Error("Webview is disposed")}}class s{constructor(w,u){this.d=u,this.b=new Map,this.c=new Map,this.a=w.getProxy(R.$0N.MainThreadWebviewViews)}registerWebviewViewProvider(w,u,E,p){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:E,extension:w}),this.a.$registerWebviewViewProvider((0,P.$nrc)(w),u,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$lrc)(w)}),new O.$_N(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(w,u,E,p,r){const l=this.b.get(u);if(!l)throw new Error(`No view provider found for '${u}'`);const{provider:d,extension:a}=l,i=this.d.createNewWebview(w,{},a),n=new m(w,this.a,u,E,i,!0);this.c.set(w,n),await d.resolveWebviewView(n,{state:p},r)}async $onDidChangeWebviewViewVisibility(w,u){this.e(w)._setVisible(u)}async $disposeWebviewView(w){const u=this.e(w);this.c.delete(w),u.dispose(),this.d.deleteWebview(w)}e(w){const u=this.c.get(w);if(!u)throw new Error("No webview found");return u}}e.$4sc=s}),define(Re[263],Te([1,0,6,29,31,3]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=e.$sN=e.OutputChannelUpdateMode=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.$hN=e.$gN=void 0,e.$gN="text/x-code-output",e.$hN="Log",e.$iN="text/x-code-log-output",e.$jN="log",e.$kN="workbench.panel.output",e.$lN=new P.$2j("inOutput",!1),e.$mN=new P.$2j("activeLogOutput",!1),e.$nN=new P.$2j("activeLogOutput.levelSettable",!1),e.$oN=new P.$2j("activeLogOutput.level",""),e.$pN=new P.$2j("activeLogOutput.levelIsDefault",!1),e.$qN=new P.$2j("outputView.scrollLock",!1),e.$rN=(0,L.$Ki)("outputService");var R;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$sN={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new v.$qe,this.onDidRegisterChannel=this.b.event,this.c=new v.$qe,this.onDidRemoveChannel=this.c.event}registerChannel(s){this.a.has(s.id)||(this.a.set(s.id,s),this.b.fire(s.id))}getChannels(){const s=[];return this.a.forEach(I=>s.push(I)),s}getChannel(s){return this.a.get(s)}removeChannel(s){this.a.delete(s),this.c.fire(s)}}D.$xo.add(e.$sN.OutputChannels,new O),e.$tN=new P.$2j("activeOutputChannel","")}),define(Re[130],Te([1,0,5,3,16,18,11,263,68,26,50,157,20,14,28,6,4]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hsc=e.$Gsc=void 0;class d extends R.$lk{get disposed(){return this.n}constructor(t,o,c,g,f){super(),this.id=t,this.name=o,this.r=c,this.s=g,this.extension=f,this.m=0,this.n=!1,this.visible=!1,this.setLevel(c.getLevel()),this.B(c.onDidChangeLogLevel(h=>this.setLevel(h)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Clear,t)}replace(t){const o=this.m;this.info(t),this.s.$update(this.id,O.OutputChannelUpdateMode.Replace,o),this.visible&&this.r.flush()}show(t,o){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:o))}hide(){this.s.$close(this.id)}g(t,o){this.m+=u.$Se.fromString(o).byteLength,(0,R.log)(this.r,t,o),this.visible&&(this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class a extends d{appendLine(t){this.append(t)}}let i=class{constructor(t,o,c,g,f,h){this.i=o,this.j=c,this.k=g,this.l=f,this.m=h,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(v.$0N.MainThreadOutputService),this.b=this.k.extUri.joinPath(o.logsLocation,`output_logging_${(0,w.$0m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[o,c]of this.g)c.visible=o===this.h}createOutputChannel(t,o,c){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const g=typeof o=="object"&&o.log,f=(0,E.$jg)(o)?o:void 0;if((0,E.$jg)(f)&&!f.trim())throw new Error("illegal argument `languageId`. must not be empty");let h;const S=this.i.environment.extensionLogLevel?.find(([y])=>L.$xn.equals(c.identifier,y))?.[1];S&&(h=(0,R.$wk)(S));const k=g?this.o(t,h,c):this.n(t,f,c);return k.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),g?this.r(t,h??this.m.getLevel(),k):this.q(t,k)}async n(t,o,c){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const g=await this.c,f=this.k.extUri.joinPath(g,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.l.createLogger(f,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(t,f,o,c.identifier.value);return new d(S,t,h,this.a,c)}async o(t,o,c){const g=await this.p(c),f=t.replace(/[\\/:\*\?"<>\|]/g,""),h=this.k.extUri.joinPath(g,`${f}.log`),S=`${c.identifier.value}.${f}`,k=this.l.createLogger(h,{id:S,name:t,logLevel:o,extensionId:c.identifier.value});return new a(S,t,k,this.a,c)}p(t){let o=this.d.get(t.identifier.value);if(!o){const c=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,o=(async()=>{try{await this.j.value.createDirectory(c)}catch(g){if((0,p.$vl)(g)!==p.FileSystemProviderErrorCode.FileExists)throw g}return c})())}return o}q(t,o){let c=!1;const g=()=>{if(c)throw new Error("Channel has been closed")};return{get name(){return t},append(f){g(),o.then(h=>h.append(f))},appendLine(f){g(),o.then(h=>h.appendLine(f))},clear(){g(),o.then(f=>f.clear())},replace(f){g(),o.then(h=>h.replace(f))},show(f,h){g(),o.then(S=>S.show(f,h))},hide(){g(),o.then(f=>f.hide())},dispose(){c=!0,o.then(f=>f.dispose())}}}r(t,o,c){const g=new l.$Yc,f=()=>{if(g.isDisposed)throw new Error("Channel has been closed")},h=g.add(new r.$qe);function S(k){o=k,h.fire(k)}return c.then(k=>{g.add(k),k.logLevel!==o&&S(k.logLevel),g.add(k.onDidChangeLogLevel(y=>S(y)))}),{...this.q(t,c),get logLevel(){return o},onDidChangeLogLevel:h.event,trace(k,...y){f(),c.then(C=>C.trace(k,...y))},debug(k,...y){f(),c.then(C=>C.debug(k,...y))},info(k,...y){f(),c.then(C=>C.info(k,...y))},warn(k,...y){f(),c.then(C=>C.warn(k,...y))},error(k,...y){f(),c.then(C=>C.error(k,...y))},dispose(){g.dispose()}}}};e.$Gsc=i,e.$Gsc=i=He([qe(0,P.$KQ),qe(1,s.$1Q),qe(2,m.$hrc),qe(3,I.$Wqc),qe(4,R.$gk),qe(5,R.$fk)],i),e.$Hsc=(0,D.$Ki)("IExtHostOutputService")}),define(Re[131],Te([1,0,3,10]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=void 0,e.$2m=(0,v.$Ki)("remoteAgentService"),e.$3m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let L=1/0;for(let O=0;O<this.maxSampleCount;O++){const m=await P.getRoundTripTime();if(m===void 0)return;L=Math.min(L,m/2),await(0,D.$Lh)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce((O,m)=>O+m,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce((O,m)=>O+m,0)/this.average.length,high:typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[264],Te([1,0,9,53,29,49,44,4,6,131,23,25,10,115]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=void 0,e.$yL=Object.freeze({id:"application",order:100,title:(0,v.localize)(3975,null),type:"object"}),e.$zL=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(3976,null),type:"object"}),e.$AL=Object.freeze({id:"security",scope:D.ConfigurationScope.APPLICATION,title:(0,v.localize)(3977,null),type:"object",order:7}),e.$BL=Object.freeze({id:"problems",title:(0,v.localize)(3978,null),type:"object",order:101}),e.$CL=Object.freeze({id:"window",order:8,title:(0,v.localize)(3979,null),type:"object"}),e.$DL={ConfigurationMigration:"base.contributions.configuration.migration"};class p{constructor(){this.migrations=[],this.a=new m.$qe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new p;P.$xo.add(e.$DL.ConfigurationMigration,r);let l=class extends O.$Zc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const c of o.added)await this.f(c,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(o=>this.g(o,n?.uri))])}async g(n,t){const o=this.a.inspect(n.key,{resource:t}),c=this.b.getWorkbenchState()===L.WorkbenchState.WORKSPACE?[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE],["workspaceFolder",R.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE]];for(const[g,f]of c){const h=o[g];if(!h)continue;const S=[];if(h.value!==void 0){const k=await this.h(n,g,h.value,t,void 0);for(const y of k??[])S.push([y,[]])}for(const{identifiers:k,value:y}of h.overrides??[])if(y!==void 0){const C=await this.h(n,g,y,t,k);for(const T of C??[])S.push([T,k])}S.length&&await Promise.allSettled(S.map(async([[k,y],C])=>this.a.updateValue(k,y.value,{resource:t,overrideIdentifiers:C},f)))}}async h(n,t,o,c,g){const f=S=>{const y=this.a.inspect(S,{resource:c})[t];if(y)return g?y.overrides?.find(({identifiers:C})=>(0,w.$oo)(C,g))?.value:y.value},h=await n.migrateFn(o,f);return Array.isArray(h)?h:[[n.key,h]]}};e.$EL=l,e.$EL=l=He([qe(0,R.$ej),qe(1,L.$Ti)],l);let d=class extends O.$Zc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new u.$8h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$l&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;P.$xo.as(D.$Co.Configuration).registerConfiguration({...e.$AL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(3980,null)},default:[],markdownDescription:(0,v.localize)(3981,null),scope:D.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(3982,null),scope:D.ConfigurationScope.MACHINE}}})}};e.$FL=d,e.$FL=d=He([qe(0,s.$2m)],d),e.$GL="window.newWindowProfile";let a=class extends O.$Zc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,t){super(),this.c=n,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(o=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(o=>{o.source!==R.ConfigurationTarget.DEFAULT&&o.affectsConfiguration(e.$GL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const n=P.$xo.as(D.$Co.Configuration),t={...e.$CL,properties:{[e.$GL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(o=>o.name),null],enumItemLabels:[...this.c.profiles.map(o=>""),(0,v.localize)(3983,null)],description:(0,v.localize)(3984,null),scope:D.ConfigurationScope.APPLICATION}}};this.a?n.updateConfigurations({add:[t],remove:[this.a]}):n.registerConfiguration(t),this.a=t}h(){const n=this.f.getValue(e.$GL);this.b=n?this.c.profiles.find(t=>t.name===n):void 0}j(){const n=this.f.getValue(e.$GL);if(!n)return;const t=this.b?this.c.profiles.find(o=>o.id===this.b.id):void 0;n!==t?.name&&this.f.updateValue(e.$GL,t?.name)}};e.$HL=a,e.$HL=a=He([qe(0,E.$Rl),qe(1,R.$ej)],a)}),define(Re[265],Te([1,0,43,15,22,24,9,264,53,3,29]),function(we,e,v,D,P,L,R,O,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$JL=e.$IL=void 0,e.$KL=r,e.$LL=l,v=Ve(v),e.$IL=(0,s.$Ki)("editorResolverService"),e.$JL="workbench.editorAssociations";const w=I.$xo.as(m.$Co.Configuration),u={...O.$zL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(12198,null),additionalProperties:{type:"string"}}}};w.registerConfiguration(u);var E;(function(d){d.builtin="builtin",d.option="option",d.exclusive="exclusive",d.default="default"})(E||(e.RegisteredEditorPriority=E={}));var p;(function(d){d[d.ABORT=1]="ABORT",d[d.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function r(d){switch(d){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function l(d,a){if(new Set([D.Schemas.extension,D.Schemas.webviewPanel,D.Schemas.vscodeWorkspaceTrust,D.Schemas.vscodeSettings]).has(a.scheme))return!1;const t=typeof d=="string"&&d.indexOf(P.$lc.sep)>=0?`${a.scheme}:${a.path}`:(0,L.$ih)(a);return v.$Ek(typeof d=="string"?d.toLowerCase():d,t.toLowerCase())}}),define(Re[266],Te([1,0,73,15,22,23,24,2,3,185,49,204,131]),function(we,e,v,D,P,L,R,O,m,s,I,w,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=e.$LN=void 0,e.$LN=(0,m.$Ki)("pathService");let p=E=class{constructor(l,d,a,i){this.d=l,this.e=d,this.f=a,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??l})()}hasValidBasename(l,d,a){return typeof d=="string"||typeof d>"u"?this.a.then(i=>this.h(l,i,d)):this.h(l,d,a)}h(l,d,a){return l.scheme===D.Schemas.file||l.scheme===D.Schemas.vscodeRemote?(0,v.$Hg)(a??(0,R.$ih)(l),d===L.OperatingSystem.Windows):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(l,d){if(l.remoteAuthority)return D.Schemas.vscodeRemote;const a=(0,s.$IN)(d.getWorkspace());if(a)return a;const i=d.getWorkspace().folders[0];if(i)return i.uri.scheme;const n=d.getWorkspace().configuration;return n?n.scheme:D.Schemas.file}userHome(l){return l?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(l=>l===L.OperatingSystem.Windows?P.$kc:P.$lc)}async fileURI(l){let d="";if(await this.a===L.OperatingSystem.Windows&&(l=l.replace(/\\/g,"/")),l[0]==="/"&&l[1]==="/"){const i=l.indexOf("/",2);i===-1?(d=l.substring(2),l="/"):(d=l.substring(2,i),l=l.substring(i)||"/")}return O.URI.from({scheme:D.Schemas.file,authority:d,path:l,query:"",fragment:""})}};e.$MN=p,e.$MN=p=E=He([qe(1,u.$2m),qe(2,w.$uN),qe(3,I.$Ti)],p)}),define(Re[58],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.ExcludeSettingOptions=e.$mM=e.$lM=e.$kM=e.$jM=void 0;class v{constructor(s,I){this.line=s,this.character=I}isBefore(s){return!1}isBeforeOrEqual(s){return!1}isAfter(s){return!1}isAfterOrEqual(s){return!1}isEqual(s){return!1}compareTo(s){return 0}translate(s,I){return new v(0,0)}with(s){return new v(0,0)}}e.$jM=v;class D{constructor(s,I,w,u){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(s,I),this.end=new v(w,u)}contains(s){return!1}isEqual(s){return!1}intersection(s){}union(s){return new D(0,0,0,0)}with(s){return new D(0,0,0,0)}}e.$kM=D;class P{constructor(s,I,w){this.uri=s,this.ranges=I,this.previewText=w}}e.$lM=P;class L{constructor(s,I,w){this.uri=s,this.text=I,this.lineNumber=w}}e.$mM=L;var R;(function(m){m[m.None=1]="None",m[m.FilesExclude=2]="FilesExclude",m[m.SearchAndFilesExclude=3]="SearchAndFilesExclude"})(R||(e.ExcludeSettingOptions=R={}));var O;(function(m){m[m.Information=1]="Information",m[m.Warning=2]="Warning"})(O||(e.TextSearchCompleteMessageType=O={}))}),define(Re[40],Te([1,0,17,43,25,73,13,3,22,12,58,10]),function(we,e,v,D,P,L,R,O,m,s,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$MM=e.$KM=e.$DM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$AM=e.$zM=e.$yM=e.$xM=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.TextSearchCompleteMessageType=void 0,e.$uM=d,e.$vM=a,e.$wM=i,e.$BM=k,e.$CM=y,e.$EM=$,e.$FM=b,e.$GM=N,e.$HM=A,e.$IM=F,e.$JM=G,e.$LM=j,e.$NM=Z,e.$OM=ae,e.$PM=oe,D=Ve(D),P=Ve(P),L=Ve(L),m=Ve(m),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$nM="workbench.view.search",e.$oM="workbench.panel.search",e.$pM="workbench.view.search",e.$qM="search-result",e.$rM="search.exclude",e.$sM=2e4;const u="\u27EA ",E=" characters skipped \u27EB",p=(u.length+E.length+5)*2;e.$tM=(0,O.$Ki)("searchService");var r;(function(ie){ie[ie.file=0]="file",ie[ie.text=1]="text",ie[ie.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var l;(function(ie){ie[ie.File=1]="File",ie[ie.Text=2]="Text",ie[ie.aiText=3]="aiText"})(l||(e.QueryType=l={}));function d(ie){return!!ie.rangeLocations&&!!ie.previewText}function a(ie){return!!ie.resource}function i(ie){return!!ie.message}var n;(function(ie){ie[ie.Normal=0]="Normal",ie[ie.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class t{constructor(ue){this.resource=ue,this.results=[]}}e.$xM=t;class o{constructor(ue,_,$e,Ie){this.rangeLocations=[],this.webviewIndex=Ie;const X=Array.isArray(_)?_:[_];if($e&&$e.matchLines===1&&c(X)){ue=(0,R.$cg)(ue,$e.matchLines);let V="",re=0,be=0;const Pe=Math.floor($e.charsPerLine/5);for(const Fe of X){const Be=Math.max(Fe.startColumn-Pe,0),xe=Fe.startColumn+$e.charsPerLine;if(Be>be+Pe+p){const nt=u+(Be-be)+E;V+=nt+ue.slice(Be,xe),re+=Be-(be+nt.length)}else V+=ue.slice(be,xe);be=xe,this.rangeLocations.push({source:Fe,preview:new f(0,Fe.startColumn-re,Fe.endColumn-re)})}this.previewText=V}else{const V=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber,re=(0,v.$5b)(_,be=>({preview:new g(be.startLineNumber-V,be.startColumn,be.endLineNumber-V,be.endColumn),source:be}));this.rangeLocations=Array.isArray(re)?re:[re],this.previewText=ue}}}e.$yM=o;function c(ie){const ue=ie[0].startLineNumber;for(const _ of ie)if(_.startLineNumber!==ue||_.endLineNumber!==ue)return!1;return!0}class g{constructor(ue,_,$e,Ie){this.startLineNumber=ue,this.startColumn=_,this.endLineNumber=$e,this.endColumn=Ie}}e.$zM=g;class f extends g{constructor(ue,_,$e){super(ue,_,ue,$e)}}e.$AM=f;var h;(function(ie){ie.List="list",ie.Tree="tree"})(h||(e.ViewMode=h={}));var S;(function(ie){ie.Default="default",ie.FileNames="fileNames",ie.Type="type",ie.Modified="modified",ie.CountDescending="countDescending",ie.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function k(ie,ue=!0){const _=ie&&ie.files&&ie.files.exclude,$e=ue&&ie&&ie.search&&ie.search.exclude;if(!_&&!$e)return;if(!_||!$e)return _||$e||void 0;let Ie=Object.create(null);return Ie=P.$no(Ie,P.$ko(_)),Ie=P.$no(Ie,P.$ko($e),!0),Ie}function y(ie,ue){return ie.excludePattern&&D.$Ek(ie.excludePattern,ue)?!1:ie.includePattern||ie.usingSearchPaths?ie.includePattern&&D.$Ek(ie.includePattern,ue)?!0:ie.usingSearchPaths?!!ie.folderQueries&&ie.folderQueries.some(_=>{const $e=_.folder.fsPath;if(L.$Jg(ue,$e)){const Ie=m.$qc($e,ue);return!_.includePattern||!!D.$Ek(_.includePattern,Ie)}else return!1}):!1:!0}var C;(function(ie){ie[ie.unknownEncoding=1]="unknownEncoding",ie[ie.regexParseError=2]="regexParseError",ie[ie.globParseError=3]="globParseError",ie[ie.invalidLiteral=4]="invalidLiteral",ie[ie.rgProcessError=5]="rgProcessError",ie[ie.other=6]="other",ie[ie.canceled=7]="canceled"})(C||(e.SearchErrorCode=C={}));class T extends Error{constructor(ue,_){super(ue),this.code=_}}e.$DM=T;function $(ie){const ue=ie.message;if((0,s.$8)(ie))return new T(ue,C.canceled);try{const _=JSON.parse(ue);return new T(_.message,_.code)}catch{return new T(ue,C.other)}}function b(ie){const ue={message:ie.message,code:ie.code};return new Error(JSON.stringify(ue))}function N(ie){return ie.type==="error"?!0:ie.type==="success"}function A(ie){return ie.type==="success"}function F(ie){return!!ie.path}function G(ie,ue,_=!0){const $e=ie.searchPath?ie.searchPath:ie.relativePath;return _?(0,R.$_f)($e,ue):D.$Ek(ue,$e)}class x{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$KM=x;function j(ie,ue){const _={...ie||{},...ue||{}};return Object.keys(_).filter($e=>{const Ie=_[$e];return typeof Ie=="boolean"&&Ie})}class U{constructor(ue,_){this.c=null,this.a=_.excludePattern?.map(Ie=>({...ue.excludePattern||{},...Ie.pattern||{}}))??[],this.a.length===0&&(this.a=[ue.excludePattern||{}]),this.b=this.a.map(Ie=>D.$Fk(Ie));let $e=ue.includePattern;_.includePattern&&($e?$e={...$e,..._.includePattern}:$e=_.includePattern),$e&&(this.c=D.$Fk($e))}d(ue,_,$e){let Ie=null;for(const X of this.b){const V=X(ue,_,$e);if(typeof V=="string"){Ie=V;break}}return Ie}matchesExcludesSync(ue,_,$e){return!!(this.b&&this.d(ue,_,$e))}includedInQuerySync(ue,_,$e){return!(this.b&&this.d(ue,_,$e)||this.c&&!this.c(ue,_,$e))}includedInQuery(ue,_,$e){const Ie=()=>this.c?!!this.c(ue,_,$e):!0;return Promise.all(this.b.map(X=>{const V=X(ue,_,$e);return(0,w.$wh)(V)?V.then(re=>re?!1:Ie()):Ie()})).then(X=>X.some(V=>!!V))}hasSiblingExcludeClauses(){return this.a.reduce((ue,_)=>J(_)||ue,!1)}}e.$MM=U;function J(ie){for(const ue in ie)if(typeof ie[ue]!="boolean")return!0;return!1}function Z(ie){if(!ie)return;let ue;return _=>(ue||(ue=(ie()||Promise.resolve([])).then($e=>$e?ee($e):{})),ue.then($e=>!!$e[_]))}function ae(ie){if(!ie)return;let ue;return _=>{if(!ue){const $e=ie();ue=$e?ee($e):{}}return!!ue[_]}}function ee(ie){const ue={};for(const _ of ie)ue[_]=!0;return ue}function oe(ie){return ie.flatMap(ue=>ue.patterns.map(_=>ue.baseUri?{baseUri:ue.baseUri,pattern:_}:_))}e.$QM={matchLines:100,charsPerLine:1e4}}),define(Re[45],Te([1,0,17,10,19,6,4,48,15,141,24,13,2,9,28,3,11,173,49,50,26,16,8,7,65,40,5,34,58]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i,n,t,o,c,g,f,h,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$crc=e.$brc=void 0;function y(x,j,U){return new I.$ah(J=>b(J,U)).isEqual(x,j)}function C(x,j,U){return y(x.uri,j.uri,U)?0:(0,w.$Df)(x.uri.toString(),j.uri.toString())}function T(x,j,U){return x.index!==j.index?x.index<j.index?-1:1:y(x.uri,j.uri,U)?(0,w.$Df)(x.name,j.name):(0,w.$Df)(x.uri.toString(),j.uri.toString())}function $(x,j,U,J){const Z=x.slice(0).sort((ee,oe)=>U(ee,oe,J)),ae=j.slice(0).sort((ee,oe)=>U(ee,oe,J));return(0,v.$Ib)(Z,ae,(ee,oe)=>U(ee,oe,J))}function b(x,j){const U=j.getCapabilities(x.scheme);return!(U&&U&p.FileSystemProviderCapabilities.PathCaseSensitive)}class N extends a.$4i{static toExtHostWorkspace(j,U,J,Z){if(!j)return{workspace:null,added:[],removed:[]};const{id:ae,name:ee,folders:oe,configuration:ie,transient:ue,isUntitled:_}=j,$e=[],Ie=U;U?oe.forEach((be,Pe)=>{const Fe=u.URI.revive(be.uri),Be=N.o(J||U,Fe,Z);Be?(Be.name=be.name,Be.index=be.index,$e.push(Be)):$e.push({uri:Fe,name:be.name,index:Pe})}):$e.push(...oe.map(({uri:be,name:Pe,index:Fe})=>({uri:u.URI.revive(be),name:Pe,index:Fe}))),$e.sort((be,Pe)=>be.index<Pe.index?-1:1);const X=new N(ae,ee,$e,!!ue,ie?u.URI.revive(ie):null,!!_,be=>b(be,Z)),{added:V,removed:re}=$(Ie?Ie.workspaceFolders:[],X.workspaceFolders,C,Z);return{workspace:X,added:V,removed:re}}static o(j,U,J){for(let Z=0;Z<j.folders.length;Z++){const ae=j.workspaceFolders[Z];if(y(ae.uri,U,J))return ae}}constructor(j,U,J,Z,ae,ee,oe){super(j,J.map(ie=>new a.$5i(ie)),Z,ae,oe),this.t=U,this.u=ee,this.q=[],this.s=O.$Qi.forUris(oe,()=>!0),J.forEach(ie=>{this.q.push(ie),this.s.set(ie.uri,ie)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,U){return U&&this.s.get(j)&&(j=(0,I.$kh)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let A=class{constructor(j,U,J,Z,ae){this.c=new L.$qe,this.onDidChangeWorkspace=this.c.event,this.g=new L.$qe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.B=0,this.C=new L.$se,this.D=new Map,this.h=Z,this.s=J,this.t=ae,this.j=new s.$Sm,this.k=new D.$Jh,this.o=j.getProxy(h.$0N.MainThreadWorkspace),this.q=j.getProxy(h.$0N.MainThreadMessageService);const ee=U.workspace;this.l=ee?new N(ee.id,ee.name,[],!!ee.transient,ee.configuration?u.URI.revive(ee.configuration):null,!!ee.isUntitled,oe=>b(oe,J)):void 0}$initializeWorkspace(j,U){this.v=U,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:m.Schemas.untitled,path:(0,I.$ih)((0,I.$kh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,U,J,...Z){const ae=[];if(Array.isArray(Z)&&Z.forEach(_=>{u.URI.isUri(_.uri)&&!ae.some($e=>y($e.uri,_.uri,this.s))&&ae.push({uri:_.uri,name:_.name||(0,I.$hh)(_.uri)})}),this.n||[U,J].some(_=>typeof _!="number"||_<0)||J===0&&ae.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(U+J>ee.length)return!1;const oe=ee.slice(0);oe.splice(U,J,...ae.map(_=>({uri:_.uri,name:_.name||(0,I.$hh)(_.uri),index:void 0})));for(let _=0;_<oe.length;_++){const $e=oe[_];if(oe.some((Ie,X)=>X!==_&&y($e.uri,Ie.uri,this.s)))return!1}oe.forEach((_,$e)=>_.index=$e);const{added:ie,removed:ue}=$(ee,oe,T,this.s);if(ie.length===0&&ue.length===0)return!1;if(this.o){const _=j.displayName||j.name;this.o.$updateWorkspaceFolders(_,U,J,ae).then(void 0,$e=>{this.n=void 0;const Ie={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(d.Severity.Error,(0,E.localize)(2718,null,_,$e.toString()),Ie,[])})}return this.y(oe),!0}getWorkspaceFolder(j,U){if(this.x)return this.x.getWorkspaceFolder(j,U)}async getWorkspaceFolder2(j,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,U)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,U){let J,Z="";if(typeof j=="string"?(J=u.URI.file(j),Z=j):typeof j<"u"&&(J=j,Z=j.fsPath),!J)return Z;const ae=this.getWorkspaceFolder(J,!0);if(!ae)return Z;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ee=(0,I.$nh)(ae.uri,J);return U&&ae.name&&(ee=`${ae.name}/${ee}`),ee}y(j){this.x&&(this.n=N.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:U,added:J,removed:Z}=N.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:J,removed:Z}))}findFiles(j,U,J,Z,ae=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Z.value}, entryPoint: findFiles`);let ee="",oe=!0;return U===null?oe=!1:U!==void 0&&(typeof U=="string"?ee=U:ee=U.pattern),this.z(j,void 0,{exclude:[ee],maxResults:J,useExcludeSettings:oe?k.ExcludeSettingOptions.FilesExclude:k.ExcludeSettingOptions.None,useIgnoreFiles:{local:!1}},ae)}findFiles2(j,U={},J,Z=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${J.value}, entryPoint: findFiles2`);const ae=U.useDefaultExcludes??!0,ee=U.useDefaultSearchExcludes??!0,oe=ae?ee?k.ExcludeSettingOptions.SearchAndFilesExclude:k.ExcludeSettingOptions.FilesExclude:k.ExcludeSettingOptions.None,ie={exclude:U.exclude?[U.exclude]:void 0,useIgnoreFiles:{local:U.useIgnoreFiles,global:U.useGlobalIgnoreFiles,parent:U.useParentIgnoreFiles},useExcludeSettings:oe,followSymlinks:U.followSymlinks,maxResults:U.maxResults};return this.z(void 0,j!==void 0?[j]:[],ie,Z)}findFiles2New(j,U={},J,Z=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2New: fileSearch, extension: ${J.value}, entryPoint: findFiles2New`),this.z(void 0,j,U,Z)}async z(j,U,J,Z=P.CancellationToken.None){if(Z&&Z.isCancellationRequested)return Promise.resolve([]);const ee=(j!==void 0?[j]:U)?.map(oe=>{const ie=G(J.exclude),ue={ignoreSymlinks:typeof J.followSymlinks=="boolean"?!J.followSymlinks:void 0,disregardIgnoreFiles:typeof J.useIgnoreFiles?.local=="boolean"?!J.useIgnoreFiles.local:void 0,disregardGlobalIgnoreFiles:typeof J.useIgnoreFiles?.global=="boolean"?!J.useIgnoreFiles.global:void 0,disregardParentIgnoreFiles:typeof J.useIgnoreFiles?.parent=="boolean"?!J.useIgnoreFiles.parent:void 0,disregardExcludeSettings:J.useExcludeSettings!==void 0&&J.useExcludeSettings===k.ExcludeSettingOptions.None,disregardSearchExcludeSettings:J.useExcludeSettings!==void 0&&J.useExcludeSettings!==k.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:J.maxResults,excludePattern:ie.length>0?ie:void 0,_reason:"startFileSearch",shouldGlobSearch:j?void 0:!0},_=F(o.GlobPattern.from(oe)),$e=_?.folder;return j?ue.includePattern=_?.pattern:ue.filePattern=_?.pattern,{folder:$e,options:ue}})??[];return this.A(ee,Z)}async A(j,U){return(await Promise.all(j?.map(Z=>this.o.$startFileSearch(Z.folder??null,Z.options,U).then(ae=>Array.isArray(ae)?ae.map(ee=>u.URI.revive(ee)):[]))??[])).flat()}findTextInFilesNew(j,U,J,Z){this.h.trace(`extHostWorkspace#findTextInFilesNew: textSearch, extension: ${U.value}, entryPoint: findTextInFilesNew`);const ae=_=>{if(!J)return{folder:void 0,options:{}};const $e=_?F(o.GlobPattern.from(_)):void 0,Ie=_?G(J.exclude):void 0;return{options:{ignoreSymlinks:typeof J.followSymlinks=="boolean"?!J.followSymlinks:void 0,disregardIgnoreFiles:typeof J.useIgnoreFiles=="boolean"?!J.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof J.useIgnoreFiles?.global=="boolean"?!J.useIgnoreFiles?.global:void 0,disregardParentIgnoreFiles:typeof J.useIgnoreFiles?.parent=="boolean"?!J.useIgnoreFiles?.parent:void 0,disregardExcludeSettings:J.useExcludeSettings!==void 0&&J.useExcludeSettings===k.ExcludeSettingOptions.None,disregardSearchExcludeSettings:J.useExcludeSettings!==void 0&&J.useExcludeSettings!==k.ExcludeSettingOptions.SearchAndFilesExclude,fileEncoding:J.encoding,maxResults:J.maxResults,previewOptions:J.previewOptions?{matchLines:J.previewOptions?.numMatchLines??100,charsPerLine:J.previewOptions?.charsPerLine??1e4}:void 0,surroundingContext:J.surroundingContext,includePattern:$e?.pattern,excludePattern:Ie},folder:$e?.folder}},oe=(J?.include?.map(_=>ae(_))??[ae(void 0)]).filter(_=>!!_),ie=Promise.resolve(void 0);return{results:new D.$$h(async _=>{const $e=(Ie,X)=>((0,f.$uM)(Ie)?_.emitOne(new k.$lM(X,Ie.rangeLocations.map(V=>({previewRange:new c.$bO(V.preview.startLineNumber,V.preview.startColumn,V.preview.endLineNumber,V.preview.endColumn),sourceRange:new c.$bO(V.source.startLineNumber,V.source.startColumn,V.source.endLineNumber,V.source.endColumn)})),Ie.previewText)):_.emitOne(new k.$mM(X,Ie.text,Ie.lineNumber)),Ie);await ie.then(Ie=>this.findTextInFilesBase(j,oe,$e,Z))}),complete:ie.then(_=>({limitHit:_?.limitHit??!1}))}}async findTextInFilesBase(j,U,J,Z=P.CancellationToken.None){const ae=this.j.getNext(),ee=!1;if(this.u[ae]=oe=>{if(ee)return;const ie=u.URI.revive(oe.resource);oe.results.forEach(ue=>{const _=(0,S.$hi)(ue);J(_,ie)})},Z.isCancellationRequested)return{};try{const oe=await Promise.all(U?.map(ie=>this.o.$startTextSearch(j,ie.folder??null,ie.options,ae,Z)||{})??[]);return delete this.u[ae],oe.reduce((ie,ue)=>({limitHit:ie?.limitHit||(ue?.limitHit??!1),message:[ie?.message??[],ue?.message??[]].flat()}),{})??{limitHit:!1}}catch(oe){throw delete this.u[ae],oe}}async findTextInFiles(j,U,J,Z,ae=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Z.value}, entryPoint: findTextInFiles`);const ee=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,oe=F(o.GlobPattern.from(U.include)),ie=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ue={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof U.useSearchExclude=="boolean"?!U.useSearchExclude:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ee,surroundingContext:U.afterContext,includePattern:oe?.pattern,excludePattern:ie?[{pattern:ie}]:void 0},_=($e,Ie)=>{(0,f.$uM)($e)?J({uri:Ie,preview:{text:$e.previewText,matches:(0,v.$5b)($e.rangeLocations,X=>new c.$bO(X.preview.startLineNumber,X.preview.startColumn,X.preview.endLineNumber,X.preview.endColumn))},ranges:(0,v.$5b)($e.rangeLocations,X=>new c.$bO(X.source.startLineNumber,X.source.startColumn,X.source.endLineNumber,X.source.endColumn))}):J({uri:Ie,text:$e.text,lineNumber:$e.lineNumber})};return this.findTextInFilesBase(j,[{options:ue,folder:oe?.folder}],_,ae)}$handleTextSearchResult(j,U){this.u[U]?.(j)}async save(j){const U=await this.o.$save(j,{saveAs:!1});return u.URI.revive(U)}async saveAs(j){const U=await this.o.$save(j,{saveAs:!0});return u.URI.revive(U)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}lookupAuthorization(j){return this.o.$lookupAuthorization(j)}lookupKerberosAuthorization(j){return this.o.$lookupKerberosAuthorization(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,U){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,U);const J=this.t.transformOutgoingScheme(j),Z=this.B++;return this.o.$registerEditSessionIdentityProvider(Z,J),(0,R.$Xc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(Z)})}async $getEditSessionIdentifier(j,U){this.h.info("Getting edit session identifier for workspaceFolder",j);const J=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!J){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",J);const Z=this.w.get(J.uri.scheme);if(this.h.info(`Provider for scheme ${J.uri.scheme} is defined: `,!!Z),!Z)return;const ae=await Z.provideEditSessionIdentity(J,U);if(this.h.info("Provider returned edit session identifier: ",ae),!!ae)return ae}async $provideEditSessionIdentityMatch(j,U,J,Z){this.h.info("Getting edit session identifier for workspaceFolder",j);const ae=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!ae){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ae);const ee=this.w.get(ae.uri.scheme);if(this.h.info(`Provider for scheme ${ae.uri.scheme} is defined: `,!!ee),!ee)return;const oe=await ee.provideEditSessionIdentityMatch?.(U,J,Z);if(this.h.info("Provider returned edit session identifier match result: ",oe),!!oe)return oe}getOnWillCreateEditSessionIdentityEvent(j){return(U,J,Z)=>{const ae=function(oe){U.call(J,oe)};return ae.extension=j,this.C.event(ae,void 0,Z)}}async $onWillCreateEditSessionIdentity(j,U,J){const Z=await this.resolveWorkspaceFolder(u.URI.revive(j));if(Z===void 0)throw new Error("Unable to resolve workspace folder");await this.C.fireAsync({workspaceFolder:Z},U,async(ae,ee)=>{const oe=Date.now();await Promise.resolve(ae),Date.now()-oe>J&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(j,U){if(this.D.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.D.set(j,U);const J=this.t.transformOutgoingScheme(j),Z=this.B++;return this.o.$registerCanonicalUriProvider(Z,J),(0,R.$Xc)(()=>{this.D.delete(j),this.o.$unregisterCanonicalUriProvider(Z)})}async provideCanonicalUri(j,U,J){const Z=this.D.get(j.scheme);if(!Z)return;const ae=await Z.provideCanonicalUri?.(u.URI.revive(j),U,J);if(ae)return ae}async $provideCanonicalUri(j,U,J){return this.provideCanonicalUri(u.URI.revive(j),{targetScheme:U},J)}};e.$brc=A,e.$brc=A=He([qe(0,t.$KQ),qe(1,n.$1Q),qe(2,i.$Wqc),qe(3,l.$fk),qe(4,g.$_qc)],A),e.$crc=(0,r.$Ki)("IExtHostWorkspace");function F(x){let j,U;if(x)return typeof x=="string"?j=x:(j=x.pattern,U=u.URI.revive(x.baseUri)),{pattern:j,folder:U}}function G(x){return(x?.map(j=>{if(typeof j=="string")return j===""?void 0:{pattern:j,uri:void 0};{const U=F(j);return U?{pattern:U.pattern,uri:U.folder}:void 0}})??[]).filter(j=>!!j)}}),define(Re[46],Te([1,0,25,6,45,5,7,44,174,53,14,10,3,16,11,2]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=e.$erc=e.$drc=void 0;function l(g,f){if(f){const h=f.split(".");let S=g;for(let k=0;S&&k<h.length;k++)S=S[h[k]];return S}}function d(g){return g instanceof r.URI}function a(g){return g&&g.uri instanceof r.URI&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function n(g){return g&&g.uri instanceof r.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function t(g){if(d(g))return{resource:g};if(a(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(i(g))return{overrideIdentifier:g.languageId};if(n(g))return{resource:g.uri};if(g===null)return{resource:null}}let o=class{constructor(f,h,S){this.a=f.getProxy(L.$0N.MainThreadConfiguration),this.c=h,this.b=S,this.d=new w.$Jh,this.e=null}getConfigProvider(){return this.d.wait().then(f=>this.e)}$initializeConfiguration(f){this.e=new c(this.a,this.c,f,this.b),this.d.open()}$acceptConfigurationChanged(f,h){this.getConfigProvider().then(S=>S.$acceptConfigurationChanged(f,h))}};e.$drc=o,e.$drc=o=He([qe(0,E.$KQ),qe(1,P.$crc),qe(2,p.$fk)],o);class c{constructor(f,h,S,k){this.a=new D.$qe,this.b=f,this.f=k,this.c=h,this.e=m.$Xo.parse(S,k),this.d=this.k(S.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(f,h){const S={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$Xo.parse(f,this.f),this.d=this.k(f.configurationScopes),this.a.fire(this.j(h,S))}getConfiguration(f,h,S){const k=t(h)||{},y=this.g(f?l(this.e.getValue(void 0,k,this.c.workspace),f):this.e.getValue(void 0,k,this.c.workspace));f&&this.h(f,k,S?.identifier);function C($){if($==null)return null;if(typeof $=="boolean")return $?O.ConfigurationTarget.USER:O.ConfigurationTarget.WORKSPACE;switch($){case R.ConfigurationTarget.Global:return O.ConfigurationTarget.USER;case R.ConfigurationTarget.Workspace:return O.ConfigurationTarget.WORKSPACE;case R.ConfigurationTarget.WorkspaceFolder:return O.ConfigurationTarget.WORKSPACE_FOLDER}}const T={has($){return typeof l(y,$)<"u"},get:($,b)=>{this.h(f?`${f}.${$}`:$,k,S?.identifier);let N=l(y,$);if(typeof N>"u")N=b;else{let A;const F=(G,x)=>{if((0,I.$lg)(G)){let j;const U=()=>{A=A||(0,v.$ko)(y),j=j||l(A,x)};return new Proxy(G,{get:(J,Z)=>{if(typeof Z=="string"&&Z.toLowerCase()==="tojson")return U(),()=>j;if(A)return j=j||l(A,x),j[Z];const ae=J[Z];return typeof Z=="string"?F(ae,`${x}.${Z}`):ae},set:(J,Z,ae)=>(U(),j&&(j[Z]=ae),!0),deleteProperty:(J,Z)=>(U(),j&&delete j[Z],!0),defineProperty:(J,Z,ae)=>(U(),j&&Object.defineProperty(j,Z,ae),!0)})}return Array.isArray(G)?(0,v.$ko)(G):G};N=F(N,$)}return N},update:($,b,N,A)=>{$=f?`${f}.${$}`:$;const F=C(N);return b!==void 0?this.b.$updateConfigurationOption(F,$,b,k,A):this.b.$removeConfigurationOption(F,$,k,A)},inspect:$=>{$=f?`${f}.${$}`:$;const b=this.e.inspect($,k,this.c.workspace);if(b)return{key:$,defaultValue:(0,v.$ko)(b.policy?.value??b.default?.value),globalValue:(0,v.$ko)(b.user?.value??b.application?.value),workspaceValue:(0,v.$ko)(b.workspace?.value),workspaceFolderValue:(0,v.$ko)(b.workspaceFolder?.value),defaultLanguageValue:(0,v.$ko)(b.default?.override),globalLanguageValue:(0,v.$ko)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,v.$ko)(b.workspace?.override),workspaceFolderLanguageValue:(0,v.$ko)(b.workspaceFolder?.override),languageIds:(0,v.$ko)(b.overrideIdentifiers)}}};return typeof y=="object"&&(0,v.$no)(T,y,!1),Object.freeze(T)}g(f){const h=S=>(0,I.$lg)(S)?new Proxy(S,{get:(k,y)=>h(k[y]),set:(k,y,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(k,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(k,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:k=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):S;return h(f)}h(f,h,S){const k=s.$Mo.test(f)?s.ConfigurationScope.RESOURCE:this.d.get(f),y=S?`[${S.value}] `:"";if(s.ConfigurationScope.RESOURCE===k){typeof h?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${f}', provide the URI of a resource or 'null' for any resource.`);return}if(s.ConfigurationScope.WINDOW===k){h?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${f}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(f,h){const S=new m.$Zo(f,h,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(k,y)=>S.affectsConfiguration(k,t(y))})}k(f){return f.reduce((h,S)=>(h.set(S[0],S[1]),h),new Map)}}e.$erc=c,e.$frc=(0,u.$Ki)("IExtHostConfiguration")}),define(Re[132],Te([1,0,2,10,6,5,7,45,57,46,19,56,16,26,3,15,23,11,85,208,12,17]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Usc=e.$Tsc=e.$Ssc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,R=Ve(R),l=Ve(l);var o;(function(F){function G(j){if(j!=null)return j}F.from=G;function x(j){if(j!=null)return j}F.to=x})(o||(o={}));var c;(function(F){function G(j){if(j!=null)return j}F.from=G;function x(j){if(j!=null)return j}F.to=x})(c||(c={}));var g;(function(F){function G(j){if(j!=null)return j}F.from=G;function x(j){if(j!=null)return j}F.to=x})(g||(g={}));var f;(function(F){function G(U){if(U){const J=U;return J&&!!J.process}else return!1}F.is=G;function x(U){if(U==null)return;const J={process:U.process,args:U.args};return U.options&&(J.options=g.from(U.options)),J}F.from=x;function j(U){if(U!=null)return new R.$XO(U.process,U.args,U.options)}F.to=j})(f||(f={}));var h;(function(F){function G(j){if(j!=null)return j}F.from=G;function x(j){if(j!=null)return j}F.to=x})(h||(h={}));var S;(function(F){function G(U){if(U){const J=U;return J&&(!!J.commandLine||!!J.command)}else return!1}F.is=G;function x(U){if(U==null)return;const J={};return U.commandLine!==void 0?J.commandLine=U.commandLine:(J.command=U.command,J.args=U.args),U.options&&(J.options=h.from(U.options)),J}F.from=x;function j(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new R.$YO(U.commandLine,U.options):new R.$YO(U.command,U.args?U.args:[],U.options)}F.to=j})(S||(S={}));var k;(function(F){function G(U){if(U){const J=U;return J&&J.customExecution==="customExecution"}else return!1}F.is=G;function x(U){return{customExecution:"customExecution"}}F.from=x;function j(U,J){return J.get(U)}F.to=j})(k||(e.CustomExecutionDTO=k={}));var y;(function(F){function G(x,j){let U;return x.scope!==void 0&&typeof x.scope!="number"?U=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===R.TaskScope.Workspace&&j&&j.workspaceFile?U=j.workspaceFile:U=i.$eJ),{id:x._id,workspaceFolder:U}}F.from=G})(y||(e.TaskHandleDTO=y={}));var C;(function(F){function G(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}F.from=G})(C||(C={}));var T;(function(F){function G(U,J){if(U==null)return[];const Z=[];for(const ae of U){const ee=x(ae,J);ee&&Z.push(ee)}return Z}F.fromMany=G;function x(U,J){if(U==null)return;let Z;U.execution instanceof R.$XO?Z=f.from(U.execution):U.execution instanceof R.$YO?Z=S.from(U.execution):U.execution&&U.execution instanceof R.$ZO&&(Z=k.from(U.execution));const ae=o.from(U.definition);let ee;return U.scope?typeof U.scope=="number"?ee=U.scope:ee=U.scope.uri:ee=R.TaskScope.Workspace,!ae||!ee?void 0:{_id:U._id,definition:ae,name:U.name,source:{extensionId:J.identifier.value,label:U.source,scope:ee},execution:Z,isBackground:U.isBackground,group:C.from(U.group),presentationOptions:c.from(U.presentationOptions),problemMatchers:(0,t.$6b)(U.problemMatchers),hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}F.from=x;async function j(U,J,Z){if(U==null)return;let ae;f.is(U.execution)?ae=f.to(U.execution):S.is(U.execution)?ae=S.to(U.execution):k.is(U.execution)&&(ae=k.to(U._id,Z));const ee=o.to(U.definition);let oe;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?oe=U.source.scope:oe=await J.resolveWorkspaceFolder(v.URI.revive(U.source.scope)):oe=R.TaskScope.Workspace),!ee||!oe)return;const ie=new R.$1O(ee,oe,U.name,U.source.label,ae,U.problemMatchers);return U.isBackground!==void 0&&(ie.isBackground=U.isBackground),U.group!==void 0&&(ie.group=R.$WO.from(U.group._id),ie.group&&U.group.isDefault&&(ie.group=new R.$WO(ie.group.id,ie.group.label),U.group.isDefault===!0&&(ie.group.isDefault=U.group.isDefault))),U.presentationOptions&&(ie.presentationOptions=c.to(U.presentationOptions)),U._id&&(ie._id=U._id),U.detail&&(ie.detail=U.detail),ie}F.to=j})(T||(e.TaskDTO=T={}));var $;(function(F){function G(j){return j}F.from=G;function x(j){if(j)return Object.assign(Object.create(null),j)}F.to=x})($||($={}));class b{#e;constructor(G,x,j){this._id=x,this.a=j,this.#e=G}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(G){}fireDidEndProcess(G){}}let N=class{constructor(G,x,j,U,J,Z,ae,ee){this.q=new P.$qe,this.r=new P.$qe,this.s=new P.$qe,this.u=new P.$qe,this.a=G.getProxy(L.$0N.MainThreadTask),this.b=j,this.c=U,this.d=J,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ae,this.g=ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(G,x,j){if(!j)return new R.$_N(()=>{});const U=this.x();return this.j.set(U,{type:x,provider:j,extension:G}),this.a.$registerTaskProvider(U,x),new R.$_N(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(G,x){this.a.$registerTaskSystem(G,x)}fetchTasks(G){return this.a.$fetchTasks($.from(G)).then(async x=>{const j=[];for(const U of x){const J=await T.to(U,this.b,this.m);J&&j.push(J)}return j})}get taskExecutions(){const G=[];return this.k.forEach(x=>G.push(x)),G}terminateTask(G){if(!(G instanceof b))throw new Error("No valid task execution provided");return this.a.$terminateTask(G._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(G,x,j){const U=this.m.get(G.id);U&&(this.o.set(G.id,U),this.e.attachPtyToTerminal(x,await U.callback(j))),this.p=G.id,this.q.fire({execution:await this.z(G)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(G){if(!this.l.has(G.id))return;const x=await this.z(G);this.l.delete(G.id),this.k.delete(G.id),this.B(G),this.r.fire({execution:x})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(G){const x=await this.z(G.id);this.s.fire({execution:x,processId:G.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(G){const x=await this.z(G.id);this.u.fire({execution:x,exitCode:G.exitCode})}$provideTasks(G,x){const j=this.j.get(G);if(!j)return Promise.reject(new Error("no handler found"));const U=[],J=(0,D.$Ch)(()=>j.provider.provideTasks(I.CancellationToken.None)).then(Z=>this.v(x,U,j,Z));return new Promise(Z=>{J.then(ae=>{Promise.all(U).then(()=>{Z(ae)})})})}async $resolveTask(G,x){const j=this.j.get(G);if(!j)return Promise.reject(new Error("no handler found"));if(x.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${j.type}].`);const U=await T.to(x,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const J=await j.provider.resolveTask(U,I.CancellationToken.None);if(!J)return;this.A(J,j);const Z=T.from(J,j.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(J.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return k.is(Z.execution)&&await this.y(Z,J,!0),await this.w(Z)}x(){return this.h++}async y(G,x,j){const U=await this.a.$createTaskId(G);!j&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,x.execution)),this.m.set(U,x.execution)}async z(G,x){if(typeof G=="string"){const J=this.l.get(G);if(!J)throw new n.$fb("Unexpected: The specified task is missing an execution");return J}const j=this.l.get(G.id);if(j)return j;let U;return x?U=Promise.resolve(new b(this,G.id,x)):U=T.to(G.task,this.b,this.m).then(J=>{if(!J)throw new n.$fb("Unexpected: Task does not exist.");return new b(this,G.id,J)}),this.l.set(G.id,U),U.then(J=>(this.k.set(G.id,J),J))}A(G,x){G._deprecated&&this.g.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}B(G){this.o.get(G.id)&&this.o.delete(G.id),this.n.has(G.id)&&this.p!==G.id&&(this.m.delete(G.id),this.n.delete(G.id));const j=this.n.values();let U=j.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=j.next()}};e.$Ssc=N,e.$Ssc=N=He([qe(0,u.$KQ),qe(1,E.$1Q),qe(2,O.$crc),qe(3,m.$VQ),qe(4,s.$frc),qe(5,w.$Drc),qe(6,d.$fk),qe(7,a.$Sqc)],N);let A=class extends N{constructor(G,x,j,U,J,Z,ae,ee){super(G,x,j,U,J,Z,ae,ee),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:l.$k(l.Platform.Web)})}async executeTask(G,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const j=T.from(x,G);if(j===void 0)throw new Error("Task is not valid");if(k.is(j.execution))await this.y(j,x,!1);else throw new n.$db;const U=await this.z(await this.a.$getTaskExecution(j),x);return this.a.$executeTask(j).catch(J=>{throw new Error(J)}),U}v(G,x,j,U){const J=[];if(U)for(const Z of U){if(this.A(Z,j),!Z.definition||!G[Z.definition.type]){const ee=Z.source?Z.source:"No task source";this.f.warn(`The task [${ee}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`)}const ae=T.from(Z,j.extension);ae&&k.is(ae.execution)?(J.push(ae),x.push(this.y(ae,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:J,extension:j.extension}}async w(G){if(k.is(G.execution))return G;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(G,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(G,x,j){}};e.$Tsc=A,e.$Tsc=A=He([qe(0,u.$KQ),qe(1,E.$1Q),qe(2,O.$crc),qe(3,m.$VQ),qe(4,s.$frc),qe(5,w.$Drc),qe(6,d.$fk),qe(7,a.$Sqc)],A),e.$Usc=(0,p.$Ki)("IExtHostTask")}),define(Re[267],Te([1,0,40,32]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=void 0,e.$WM=P,e.$YM=L;function P(R){return"cellResults"in R}e.$XM="rawCell#";function L(R,O){let m=-1;const s=[];let I=[];return R.forEach(u=>{u.range.startLineNumber!==m&&I.length>0&&(s.push([...I]),I=[]),I.push(u),m=u.range.endLineNumber}),I.length>0&&s.push([...I]),s.map(u=>{const E=[],p=u[0].range.startLineNumber,r=u[u.length-1].range.endLineNumber;for(let l=p;l<=r;l++)E.push(O.getLineContent(l));return new v.$yM(E.join(`
`)+`
`,u.map(l=>new D.$Wt(l.range.startLineNumber-1,l.range.startColumn-1,l.range.endLineNumber-1,l.range.endColumn-1)))})}}),define(Re[268],Te([1,0,9,20,6,4,27,38,13,14,2,28,80,5,35,8,7,39,245,126,25,15,40,198,267,265]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i,n,t,o,c,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$usc=void 0,w=Ve(w),r=Ve(r),l=Ve(l);class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(k=>k.apiEditor)}constructor(k,y,C,T,$,b,N){this.q=C,this.r=T,this.s=$,this.t=b,this.u=N,this.f=new Map,this.g=new R.$Fc,this.h=new Map,this.j=new P.$qe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$qe,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$qe,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$qe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$Qqc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=k.getProxy(E.$0N.MainThreadNotebook),this.c=k.getProxy(E.$0N.MainThreadNotebookDocuments),this.d=k.getProxy(E.$0N.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===O.MarshalledId.NotebookCellActionContext){const F=A.notebookEditor?.notebookUri,G=A.cell.handle,j=this.g.get(F)?.getCell(G);if(j)return j.apiCell}if(A&&A.$mid===O.MarshalledId.NotebookActionContext){const F=A.uri,G=this.g.get(F);if(G)return G.apiNotebook}return A}}),h.C(y)}getEditorById(k){const y=this.h.get(k);if(!y)throw new Error(`unknown text editor: ${k}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(k){for(const[y,C]of this.h)if(C.apiEditor===k)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(k,y){const C=this.g.get(k);if(!C&&!y)throw new Error(`NO notebook document for '${k}'`);return C}static w(k,y){if(!y)return;const C=y.filenamePattern.map(T=>r.NotebookExclusiveDocumentPattern.from(T)).filter(T=>T!==void 0);if(y.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:k.identifier,providerDisplayName:k.displayName||k.name,displayName:y.displayName,filenamePattern:C,priority:y.exclusive?f.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(k,y,C){const T=h.a++,$=typeof C.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(T,C),this.b.$registerNotebookCellStatusBarItemProvider(T,$,y);let b;return $!==void 0&&(b=C.onDidChangeCellStatusBarItems(N=>this.b.$emitCellStatusBarEvent($))),new l.$_N(()=>{this.f.delete(T),this.b.$unregisterNotebookCellStatusBarItemProvider(T,$),b?.dispose()})}async createNotebookDocument(k){const y=await this.c.$tryCreateNotebook({viewType:k.viewType,content:k.content&&r.NotebookData.from(k.content)});return I.URI.revive(y)}async openNotebookDocument(k){const y=this.g.get(k);if(y)return y.apiNotebook;const C=await this.c.$tryOpenNotebook(k),T=this.g.get(I.URI.revive(C));return(0,s.$ug)(T?.apiNotebook)}async showNotebookDocument(k,y){let C;typeof y=="object"?C={position:r.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(r.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0,label:y?.label}:C={preserveFocus:!1,pinned:!0};const T=y?.asRepl?"repl":k.notebookType,$=await this.d.$tryShowNotebookDocument(k.uri,T,C),b=$&&this.h.get($)?.apiEditor;if(b)return b;throw $?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(k,y,C,T){const $=this.f.get(k),b=I.URI.revive(y),N=this.g.get(b);if(!N||!$)return;const A=N.getCellFromIndex(C);if(!A)return;const F=await $.provideCellStatusBarItems(A.apiCell,T);if(!F)return;const G=new L.$Yc,x=this.p.add([G]),U=(Array.isArray(F)?F:[F]).map(J=>r.NotebookStatusBarItem.from(J,this.i,G));return{cacheId:x,items:U}}$releaseNotebookCellStatusBarItems(k){this.p.delete(k)}registerNotebookSerializer(k,y,C,T,$){if((0,m.$hf)(y))throw new Error("viewType cannot be empty or just whitespace");const b=this.x++;return this.y.set(b,{viewType:y,serializer:C,options:T}),this.b.$registerNotebookSerializer(b,{id:k.identifier,location:k.extensionLocation},y,r.NotebookDocumentContentOptions.from(T),h.w(k,$)),(0,L.$Xc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(k,y,C){const T=this.y.get(k);if(!T)throw new Error("NO serializer found");const $=await T.serializer.deserializeNotebook(y.buffer,C);return new d.$7w(r.NotebookData.from($))}async $notebookToData(k,y,C){const T=this.y.get(k);if(!T)throw new Error("NO serializer found");const $=await T.serializer.serializeNotebook(r.NotebookData.to(y.value),C);return D.$Se.wrap($)}async $saveNotebook(k,y,C,T,$){const b=I.URI.revive(y),N=this.y.get(k);if(this.D(`enter saveNotebook(versionId: ${C}, ${b.toString()})`),!N)throw new Error("NO serializer found");const A=this.g.get(b);if(!A)throw new Error("Document NOT found");if(A.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new w.$Al((0,v.localize)(2709,null,this.A(b)),w.FileOperationResult.FILE_PERMISSION_DENIED);const F={metadata:(0,n.$so)(A.apiNotebook.metadata,J=>!(N.options?.transientDocumentMetadata??{})[J]),cells:[]};for(const J of A.apiNotebook.getCells()){const Z=new l.$EP(J.kind,J.document.getText(),J.document.languageId,J.mime,N.options?.transientOutputs?[]:[...J.outputs],J.metadata,J.executionSummary);Z.metadata=(0,n.$so)(J.metadata,ae=>!(N.options?.transientCellMetadata??{})[ae]),F.cells.push(Z)}if(await this.z(b,T),$.isCancellationRequested)throw new Error("canceled");const G=await N.serializer.serializeNotebook(F,$);if($.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${C} ${b.toString()}`),await this.s.value.writeFile(b,G),this.D(`Finished write versionId: ${C} ${b.toString()}`);const x=this.s.getFileSystemProviderExtUri(b.scheme),j=await this.s.value.stat(b),U={name:x.basename(b),isFile:(j.type&w.FileType.File)!==0,isDirectory:(j.type&w.FileType.Directory)!==0,isSymbolicLink:(j.type&w.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&w.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((j.permissions??0)&w.FilePermission.Locked),etag:w.$Ll({mtime:j.mtime,size:j.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${C}, ${b.toString()})`),U}async $searchInNotebooks(k,y,C,T,$){const b=this.y.get(k)?.serializer;if(!b)return{limitHit:!1,results:[]};const N=new R.$Gc;await(async(j,U,J)=>{await Promise.all(j.map(async Z=>await Promise.all(Z.filenamePatterns.map(ae=>{const ee={_reason:J._reason,folderQueries:J.folderQueries,includePattern:J.includePattern,excludePattern:J.excludePattern,maxResults:J.maxResults,type:o.QueryType.File,filePattern:ae};return this.t.doInternalFileSearchWithCustomCallback(ee,U,oe=>{oe.forEach(ie=>{N.has(ie)||T.some(_=>Z.isFromSettings&&!_.isFromSettings?!1:_.filenamePatterns.some($e=>(0,f.$LL)($e,ie)))||N.add(ie)})}).catch(oe=>{if(oe.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw oe})}))))})(C,$,y);const F=new R.$Fc;let G=!1;const x=Array.from(N).map(async j=>{const U=[];try{if($.isCancellationRequested)return;if(y.maxResults&&[...F.values()].reduce((ee,oe)=>ee+oe.cellResults.length,0)>y.maxResults){G=!0;return}const J=[],Z=this.g.get(j);if(Z)Z.apiNotebook.getCells().forEach(oe=>J.push({input:oe.document.getText(),outputs:oe.outputs.flatMap(ie=>ie.items.map(ue=>ue.data.toString()))}));else{const ee=await this.s.value.readFile(j),oe=D.$Se.fromString(ee.toString()),ie=await b.deserializeNotebook(oe.buffer,$);if($.isCancellationRequested)return;r.NotebookData.from(ie).cells.forEach(_=>J.push({input:_.source,outputs:_.outputs.flatMap($e=>$e.items.map(Ie=>Ie.valueBytes.toString()))}))}if($.isCancellationRequested)return;J.forEach((ee,oe)=>{const ie=y.contentPattern.pattern,ue=new c.$K2b(ee.input,void 0,ee.outputs),_=ue.findInInputs(ie),$e=ue.findInOutputs(ie),Ie=$e.flatMap(X=>(0,g.$YM)(X.matches,X.textBuffer)).map((X,V)=>(X.webviewIndex=V,X));if(_.length>0||$e.length>0){const X={index:oe,contentResults:(0,g.$YM)(_,ue.inputTextBuffer),webviewResults:Ie};U.push(X)}});const ae={resource:j,cellResults:U};F.set(j,ae);return}catch{return}});return await Promise.all(x),{limitHit:G,results:[...F.values()]}}async z(k,y){const C=await this.s.value.stat(k);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==w.$Kl&&typeof C.mtime=="number"&&typeof C.size=="number"&&y.mtime<C.mtime&&y.etag!==w.$Ll({mtime:y.mtime,size:C.size}))throw new w.$Al((0,v.localize)(2710,null),w.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(k){return k.scheme===t.Schemas.file?k.fsPath:k.toString()}B(k,y,C){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const T=new i.$gsc(y,this.d,k,C.visibleRanges.map(r.NotebookRange.to),C.selections.map(r.NotebookRange.to),typeof C.viewColumn=="number"?r.ViewColumn.to(C.viewColumn):void 0);this.h.set(y,T)}$acceptDocumentAndEditorsDelta(k){if(k.value.removedDocuments)for(const C of k.value.removedDocuments){const T=I.URI.revive(C),$=this.g.get(T);$&&($.dispose(),this.g.delete(T),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:$.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire($.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===T.toString()&&this.h.delete(b.id)}if(k.value.addedDocuments){const C=[];for(const T of k.value.addedDocuments){const $=I.URI.revive(T.uri);if(this.g.has($))throw new Error(`adding EXISTING notebook ${$} `);const b=new a.$fsc(this.c,this.q,this.r,$,T);C.push(...T.cells.map(N=>a.$esc.asModelAddData(N))),this.g.get($)?.dispose(),this.g.set($,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(b.apiNotebook)}}if(k.value.addedEditors)for(const C of k.value.addedEditors){if(this.h.has(C.id))return;const T=I.URI.revive(C.documentUri),$=this.g.get(T);$&&this.B($,C.id,C)}const y=[];if(k.value.removedEditors)for(const C of k.value.removedEditors){const T=this.h.get(C);T&&(this.h.delete(C),this.k?.id===T.id&&(this.k=void 0),y.push(T))}if(k.value.visibleEditors){this.l=k.value.visibleEditors.map(T=>this.h.get(T)).filter(T=>!!T);const C=new Set;this.l.forEach(T=>C.add(T.id));for(const T of this.h.values()){const $=C.has(T.id);T._acceptVisibility($)}this.l=[...this.h.values()].map(T=>T).filter(T=>T.visible),this.o.fire(this.visibleNotebookEditors)}k.value.newActiveEditor===null?this.k=void 0:k.value.newActiveEditor&&(this.h.get(k.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${k.value.newActiveEditor}`),this.k=this.h.get(k.value.newActiveEditor)),k.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(k){const y=p.$9Q.String.with("notebookType","A notebook type"),C=new p.$$Q("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new p.$9Q("data","Bytes to convert to data",$=>$ instanceof Uint8Array,$=>D.$Se.wrap($))],new p.$0Q("Notebook Data",$=>r.NotebookData.to($.value))),T=new p.$$Q("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new p.$9Q("NotebookData","Notebook data to convert to bytes",$=>!0,$=>new d.$7w(r.NotebookData.from($)))],new p.$0Q("Bytes",$=>$.buffer));k.registerApiCommand(C),k.registerApiCommand(T)}D(k){this.u.trace(`[Extension Host Notebook] ${k}`)}}e.$usc=h}),define(Re[269],Te([1,0,22,19,42,43,24,69,40,48]),function(we,e,v,D,P,L,R,O,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hsc=void 0,v=Ve(v),L=Ve(L),R=Ve(R);class I{constructor(E,p,r){this.l=E,this.o=p,this.p=r,this.f=!1,this.g=0,this.h=!1,this.a=E.filePattern,this.b=E.includePattern&&L.$Fk(E.includePattern),this.c=E.maxResults||void 0,this.d=E.exists,this.j=new Set,this.k=E.excludePattern&&L.$Fk(E.excludePattern)}cancel(){this.h=!0,this.j.forEach(E=>E.cancel()),this.j=new Set}search(E){const p=this.l.folderQueries||[];return new Promise((r,l)=>{const d=a=>{this.g++,E(a)};if(this.h)return r({limitHit:this.f});this.l.extraFileResources&&this.l.extraFileResources.forEach(a=>{const i=a.toString(),n=v.$sc(i);this.k&&this.k(i,n)||this.w(d,{base:a,basename:n})}),this.q(p,d).then(a=>{r({limitHit:this.f,stats:a||void 0})},a=>{l(new Error((0,P.$vj)(a)))})})}async q(E,p){const r=new D.$Be,d={folderOptions:E.map(n=>this.r(n)),maxResults:this.l.maxResults??m.$sM,session:this.p},a=s.$Qi.forUris();E.forEach(n=>{const t=new m.$MM(this.l,n),o=!t.hasSiblingExcludeClauses();a.set(n.folder,{queryTester:t,noSiblingsClauses:o,folder:n.folder,tree:this.s()})});let i;try{this.j.add(r),i=O.$ke.create();const n=await this.o.provideFileSearchResults(this.l.filePattern||"",d,r.token),t=i.elapsed(),o=O.$ke.create();return this.h&&!this.f||(n&&n.forEach(c=>{const g=a.findSubstr(c),f=v.$lc.relative(g.folder.path,c.path);if(g.noSiblingsClauses){const h=v.$sc(c.path);this.w(p,{base:g.folder,relativePath:f,basename:h});return}this.u(g.tree,g.folder,f,p)}),this.h&&!this.f)?null:(a.forEach(c=>{this.v(c.tree,c.queryTester,p)}),{providerTime:t,postProcessTime:o.elapsed()})}finally{r.dispose(),this.j.delete(r)}}r(E){const p=(0,m.$LM)(this.l.includePattern,E.includePattern);let r=E.excludePattern?.map(d=>({folder:d.folder,patterns:(0,m.$LM)(this.l.excludePattern,d.pattern)}));r?.length||(r=[{folder:void 0,patterns:(0,m.$LM)(this.l.excludePattern,void 0)}]);const l=(0,m.$PM)(r);return{folder:E.folder,excludes:l,includes:p,useIgnoreFiles:{local:!E.disregardIgnoreFiles,parent:!E.disregardParentIgnoreFiles,global:!E.disregardGlobalIgnoreFiles},followSymlinks:!E.ignoreSymlinks}}s(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}u({pathToEntries:E},p,r,l){if(r===this.a){const a=v.$sc(this.a);this.w(l,{base:p,relativePath:this.a,basename:a})}function d(a){const i=v.$sc(a),n=v.$rc(a);let t=E[n];t||(t=E[n]=[],d(n)),t.push({base:p,relativePath:a,basename:i})}d(r)}v({rootEntries:E,pathToEntries:p},r,l){const d=this,a=this.a;function i(n){const t=(0,m.$OM)(()=>n.map(o=>o.basename));for(let o=0,c=n.length;o<c;o++){const g=n[o],{relativePath:f,basename:h}=g;if(r.matchesExcludesSync(f,h,a!==h?t:void 0))continue;const S=p[f];if(S)i(S);else{if(f===a)continue;d.w(l,g)}if(d.f)break}}i(E)}w(E,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.g>=this.c)&&(this.f=!0,this.cancel()),this.f||E(p))}}class w{constructor(){this.b=new Map}static{this.a=512}fileSearch(E,p,r,l){const d=this.c(E.cacheKey),a=new I(E,p,d);let i=0;const n=t=>{i+=t.length,r(t.map(o=>this.d(o)))};return this.f(a,w.a,n,l).then(t=>({limitHit:t.limitHit,stats:t.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:t.stats}:void 0,messages:[]}))}clearCache(E){this.b.delete(E)}c(E){if(E)return this.b.has(E)||this.b.set(E,new Object),this.b.get(E)}d(E){return E.relativePath?{resource:R.$lh(E.base,E.relativePath)}:{resource:E.base}}f(E,p,r,l){const d=l.onCancellationRequested(()=>{E.cancel()}),a=n=>{n&&(i.push(n),p>0&&i.length>=p&&(r(i),i=[]))};let i=[];return E.search(a).then(n=>(i.length&&r(i),d.dispose(),n),n=>(i.length&&r(i),d.dispose(),Promise.reject(n)))}}e.$hsc=w}),define(Re[270],Te([1,0,17,239,43,103,27,15,22,24,13,14,2,102,9,44,11,114,49,120,266,40]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=void 0,e.$NN=o,e.$ON=c,e.$QN=$,v=Ve(v),D=Ve(D),P=Ve(P),m=Ve(m),I=Ve(I),p=Ve(p);function o(b){return typeof b=="object"&&"uri"in b&&"pattern"in b}function c(b){return typeof b=="string"?{pattern:b}:{pattern:b.pattern,uri:b.baseUri}}let g=class{constructor(N,A,F,G,x,j){this.a=N,this.b=A,this.c=F,this.d=G,this.f=x,this.g=j}text(N,A,F={}){N=this.h(N,F);const G=this.a.getValue(),x=A&&A.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.j(A?.map(a.$6i),F),type:t.QueryType.Text,contentPattern:N,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:G.search.usePCRE2||x||!1,surroundingContext:F.surroundingContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}h(N,A){const F=this.a.getValue();N.isRegExp&&(N.pattern=N.pattern.replace(/\r?\n/g,"\\n"));const G={...N,wordSeparators:F.editor.wordSeparators};return this.l(N,A)&&(G.isCaseSensitive=!0),this.m(N)&&(G.isMultiline=!0),A.notebookSearchConfig?.includeMarkupInput&&(G.notebookInfo||(G.notebookInfo={}),G.notebookInfo.isInNotebookMarkdownInput=A.notebookSearchConfig.includeMarkupInput),A.notebookSearchConfig?.includeMarkupPreview&&(G.notebookInfo||(G.notebookInfo={}),G.notebookInfo.isInNotebookMarkdownPreview=A.notebookSearchConfig.includeMarkupPreview),A.notebookSearchConfig?.includeCodeInput&&(G.notebookInfo||(G.notebookInfo={}),G.notebookInfo.isInNotebookCellInput=A.notebookSearchConfig.includeCodeInput),A.notebookSearchConfig?.includeOutput&&(G.notebookInfo||(G.notebookInfo={}),G.notebookInfo.isInNotebookCellOutput=A.notebookSearchConfig.includeOutput),G}file(N,A={}){return{...this.j(N,A),type:t.QueryType.File,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey,shouldGlobMatchFilePattern:A.shouldGlobSearch}}i(N,A){if(!N)return{};if(Array.isArray(N)){if(N=N.filter(F=>F.length>0).map(y),!N.length)return{}}else N=y(N);return A?this.parseSearchPaths(N):{pattern:h(...Array.isArray(N)?N:[N])}}j(N=[],A={}){let F=Array.isArray(A.excludePattern)?A.excludePattern.map(ae=>ae.pattern).flat():A.excludePattern;F=F?.length===1?F[0]:F;const G=this.i(A.includePattern,A.expandPatterns),x=this.i(F,A.expandPatterns),j=N.length>1,U=(G.searchPaths&&G.searchPaths.length?G.searchPaths.map(ae=>this.t(ae,A,x)):N.map(ae=>this.u(ae,A,x,j))).filter(ae=>!!ae),J={_reason:A._reason,folderQueries:U,usingSearchPaths:!!(G.searchPaths&&G.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:x.pattern,includePattern:G.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const ae=v.$Lb(this.c.groups.flatMap(ie=>ie.editors.map(ue=>ue.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(ae));const ee=ae.filter(ie=>(0,t.$CM)(J,ie.fsPath)),oe=this.k(ee);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(oe)),{...J,...oe}}const Z=A.extraFileResources&&A.extraFileResources.filter(ae=>(0,t.$CM)(J,ae.fsPath));return J.extraFileResources=Z&&Z.length?Z:void 0,J}k(N){const A=[],F=new R.$Fc,G={};let x=!1;return N.forEach(j=>{if(j.scheme===O.Schemas.walkThrough)return;if((0,s.$ph)(j)){const J=this.b.getWorkspaceFolder(j)?.uri??this.g.extUri.dirname(j);let Z=F.get(J);Z||(x=!0,Z={folder:J,includePattern:{}},A.push(Z),F.set(J,Z));const ae=m.$qc(J.fsPath,j.fsPath);(0,w.$ug)(Z.includePattern)[ae.replace(/\\/g,"/")]=!0}else j.fsPath&&(x=!0,G[j.fsPath]=!0)}),{folderQueries:A,includePattern:G,usingSearchPaths:!0,excludePattern:x?void 0:{"**/*":!0}}}l(N,A){if(A.isSmartCase){if(N.isRegExp){if(I.$ag(N.pattern,!0))return!0}else if(I.$ag(N.pattern))return!0}return!!N.isCaseSensitive}m(N){return N.isMultiline||N.isRegExp&&(0,E.$yD)(N.pattern)||N.pattern.indexOf(`
`)>=0?!0:!!N.isMultiline}parseSearchPaths(N){const A=ee=>m.$nc(ee)||/^\.\.?([\/\\]|$)/.test(ee),G=(Array.isArray(N)?N:S(N)).map(ee=>{const oe=this.f.resolvedUserHome;return oe?(0,L.$_w)(ee,oe.scheme===O.Schemas.file?oe.fsPath:oe.path):ee}),x=D.$e(G,ee=>A(ee)?"searchPaths":"exprSegments"),j=(x.exprSegments||[]).map(ee=>I.$sf(ee,"/")).map(ee=>I.$sf(ee,"\\")).map(ee=>(ee[0]==="."&&(ee="*"+ee),k(ee))),U={},J=this.o(x.searchPaths||[]);J&&J.length&&(U.searchPaths=J);const Z=j.flat(),ae=h(...Z);return ae&&(U.pattern=ae),U}n(N,A){return A.disregardExcludeSettings?void 0:(0,t.$BM)(N,!A.disregardSearchExcludeSettings)}o(N){if(!N||!N.length)return[];const A=N.flatMap(G=>{let{pathPortion:x,globPortion:j}=f(G);return j&&(j=C(j)),this.q(x).flatMap(J=>this.r(J,j))}),F=new Map;return A.forEach(G=>{const x=G.searchPath.toString(),j=F.get(x);j?G.pattern&&(j.pattern=j.pattern||{},j.pattern[G.pattern]=!0):F.set(x,{searchPath:G.searchPath,pattern:G.pattern?h(G.pattern):void 0})}),Array.from(F.values())}q(N){if(m.$nc(N)){const A=this.b.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==O.Schemas.file?[{searchPath:A[0].uri.with({path:N})}]:[{searchPath:u.URI.file(m.$mc(N))}]}if(this.b.getWorkbenchState()===a.WorkbenchState.FOLDER){const A=this.b.getWorkspace().folders[0].uri;if(N=y(N),N.startsWith("../")||N===".."){const G=m.$lc.resolve(A.path,N);return[{searchPath:A.with({path:G})}]}const F=C(N);return[{searchPath:A,pattern:F}]}else{if(N==="./"||N===".\\")return[];{const A=N.replace(/^\.[\/\\]/,""),G=this.b.getWorkspace().folders.map(x=>{const j=A.match(new RegExp(`^${I.$mf(x.name)}(?:/(.*)|$)`));return j?{match:j,folder:x}:null}).filter(w.$rg);if(G.length)return G.map(x=>{const j=x.match[1];return{searchPath:x.folder.uri,pattern:j&&C(j)}});{const x=N.match(/\.[\/\\](.+)[\/\\]?/),j=x?x[1]:N,U=p.localize(12591,null,j);throw new Error(U)}}}}r(N,A){const F=N.pattern&&A?`${N.pattern}/${A}`:N.pattern||A,G=[{searchPath:N.searchPath,pattern:F}];return F&&!F.endsWith("**")&&G.push({searchPath:N.searchPath,pattern:F+"/**"}),G}t(N,A,F){const G=this.u((0,a.$6i)(N.searchPath),A,F,!1);return G?{...G,includePattern:N.pattern}:null}u(N,A,F,G){let x;const j=u.URI.isUri(N)?N:N.uri;let U=A.excludePattern?.map(ie=>{const ue=A.excludePattern&&o(ie)?ie.uri:void 0;return!ue||!(u.URI.isUri(N)&&this.g.extUri.isEqual(N,ue))?ue:void 0});if(U?.length||(U=[void 0]),F.searchPaths){const ie=F.searchPaths.filter(ue=>(0,s.$eh)(ue.searchPath,j))[0];if(ie&&!ie.pattern)return null;ie&&(x=ie.pattern)}const J=this.a.getValue({resource:j}),ae={...this.n(J,A)||{},...x||{}},ee=u.URI.isUri(N)?(0,s.$ih)(N):N.name,oe=U.map(ie=>Object.keys(ae).length>0?{folder:ie,pattern:ae}:void 0).filter(ie=>ie);return{folder:j,folderName:G?ee:void 0,excludePattern:oe,fileEncoding:J.files&&J.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!J.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!J.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof A.disregardParentIgnoreFiles=="boolean"?A.disregardParentIgnoreFiles:!J.search.useParentIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!J.search.followSymlinks}}};e.$PN=g,e.$PN=g=He([qe(0,r.$ej),qe(1,a.$Ti),qe(2,i.$ME),qe(3,l.$fk),qe(4,n.$LN),qe(5,d.$Pl)],g);function f(b){const N=b.match(/[\*\{\}\(\)\[\]\?]/);if(N){const A=N.index,F=b.substr(0,A).match(/[/|\\][^/\\]*$/);if(F){let G=b.substr(0,F.index);return G.match(/[/\\]/)||(G+="/"),{pathPortion:G,globPortion:b.substr((F.index||0)+1)}}}return{pathPortion:b}}function h(...b){return b.length?b.reduce((N,A)=>(N[A]=!0,N),Object.create(null)):void 0}function S(b){return P.$Dk(b,",").map(N=>N.trim()).filter(N=>!!N.length)}function k(b){return[`**/${b}/**`,`**/${b}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function y(b){return b.replace(/\\/g,"/")}function C(b){return y(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function T(b){return b.replace(/([?*[\]])/g,"[$1]")}function $(b,N){b=v.$Qb(b,G=>G.toString());const A=[],F=N.getWorkspace();return b&&b.forEach(G=>{let x;if(N.getWorkbenchState()===a.WorkbenchState.FOLDER)x=(0,s.$nh)(F.folders[0].uri,G),x&&x!=="."&&(x="./"+x);else{const j=N.getWorkspaceFolder(G);if(j){const U=j.name;if(F.folders.filter(Z=>Z.name===U).length===1){const Z=(0,s.$nh)(j.uri,G);Z===""?x=`./${j.name}`:x=`./${j.name}/${Z}`}else x=G.fsPath}}x&&A.push(T(x))}),A}}),define(Re[271],Te([1,0,24,2,19,12,3,270,40,49,10]),function(we,e,v,D,P,L,R,O,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IAb=u,e.$JAb=r,v=Ve(v),L=Ve(L);const w=7e3;function u(l,d){const a=d.activationEvents;if(!a)return Promise.resolve(void 0);const i=[],n=[];for(const h of a)if(/^workspaceContains:/.test(h)){const S=h.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||l.forceUsingSearch?n.push(S):i.push(S)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);const{promise:t,resolve:o}=(0,I.$Dh)(),c=h=>o({activationEvent:h}),g=Promise.all(i.map(h=>E(l,h,c))).then(()=>{}),f=p(l,d.identifier,n,c);return Promise.all([g,f]).then(()=>{o(void 0)}),t}async function E(l,d,a){for(const i of l.folders)if(await l.exists(v.$lh(D.URI.revive(i),d))){a(`workspaceContains:${d}`);return}}async function p(l,d,a,i){if(a.length===0)return Promise.resolve(void 0);const n=new P.$Be,t=l.checkExists(l.folders,a,n.token),o=setTimeout(async()=>{n.cancel(),l.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${a.join(",")}`)},w);let c=!1;try{c=await t}catch(g){L.$8(g)||L.$4(g)}n.dispose(),clearTimeout(o),c&&i(`workspaceContains:${a.join(",")}`)}function r(l,d,a,i){const n=l.get(R.$Ji),t=l.get(m.$tM),c=n.createInstance(O.$PN).file(d.map(g=>(0,s.$6i)(D.URI.revive(g))),{_reason:"checkExists",includePattern:a,exists:!0});return t.fileSearch(c,i).then(g=>!!g.limitHit,g=>L.$8(g)?!1:Promise.reject(g))}}),define(Re[47],Te([1,0,9,22,64,24,10,4,48,2,11,5,46,205,89,45,21,121,12,18,20,188,7,110,3,26,92,16,75,93,56,95,6,271,88,190,15,86,69,23,87]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i,n,t,o,c,g,f,h,S,k,y,C,T,$,b,N,A,F,G,x,j,U){"use strict";var J;Object.defineProperty(e,"__esModule",{value:!0}),e.$Urc=e.$Trc=e.$Src=e.$Rrc=e.$Qrc=void 0,v=Ve(v),D=Ve(D),P=Ve(P),a=Ve(a),e.$Qrc=(0,g.$Ki)("IHostUtils");let Z=J=class extends O.$Zc{constructor(X,V,re,be,Pe,Fe,Be,xe,nt,ht,$t,ut,et){super(),this.Y=ut,this.Z=et,this.a=this.B(new $.$qe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=V,this.g=re,this.f=Be,this.j=be,this.m=Pe,this.s=Fe,this.t=nt,this.u=ht,this.w=$t,this.y=this.g.getProxy(w.$0N.MainThreadWorkspace),this.z=this.g.getProxy(w.$0N.MainThreadTelemetry),this.C=this.g.getProxy(w.$0N.MainThreadExtensionService),this.D=new R.$Jh,this.F=new R.$Jh,this.G=new R.$Jh,this.H=new R.$Jh,this.I=new $e(this.f.extensions.activationEvents),this.L=new d.$8ec(this.I,this.f.extensions.allExtensions);const Le=new i.$yn(this.f.extensions.myExtensions);this.J=new d.$8ec(this.I,ue(this.L,Le)),j.$w&&(this.s.info(`Creating extension host with the following global extensions: ${oe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${oe(this.J)}`)),this.M=new p.$zrc(this.g,this.s),this.N=new N.$Jrc(this.g),this.O=xe,this.h=this.q.add(X.createChild(new k.$Ii([p.$Arc,this.M],[N.$Krc,this.N]))),this.P=this.B(new E.$yrc(this.J,this.L,{onExtensionActivationError:(Me,Ne,W)=>{this.C.$onExtensionActivationError(Me,a.$6(Ne),W)},actualActivateExtension:async(Me,Ne)=>{if(d.$8ec.isHostExtension(Me,this.J,this.L))return await this.C.$activateExtension(Me,Ne),new E.$xrc;const W=this.J.getExtensionDescription(Me);return this.fb(W,Ne)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(X){a.$4(X)}}async $(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(Pe=>Pe.identifier).filter(Pe=>this.isActivated(Pe)).map(Pe=>this.eb(Pe))}catch{}await Promise.all(X)}terminate(X,V=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),a.setUnexpectedErrorHandler(be=>{this.s.error(be)}),this.g.dispose();const re=this.$();Promise.race([(0,R.$Lh)(5e3),re]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const V=await this.C.$getExtension(X);return V&&{...V,identifier:new i.$xn(V.identifier.value),extensionLocation:s.URI.revive(V.extensionLocation)}}ab(X,V){return this.P.activateByEvent(X,V)}bb(X,V){return this.P.activateById(X,V)}activateByIdWithErrors(X,V){return this.bb(X,V).then(()=>{const re=this.P.getActivatedExtension(X);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async cb(X){if(X.scheme===F.Schemas.file&&this.c.fsRealpath){const V=X.fsPath;this.R.has(V)||this.R.set(V,this.c.fsRealpath(V));const re=await this.R.get(V);return s.URI.file(re)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(X=>new _(X))),this.Q}async db(X){const V=m.$Qi.forUris(re=>L.$ch.ignorePathCasing(re));return await Promise.all(X.map(async re=>{if(this.wb(re)){const be=await this.cb(re.extensionLocation);V.set(be,re)}})),V}eb(X){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return V;const re=this.P.getActivatedExtension(X);if(!re)return V;try{typeof re.module.deactivate=="function"&&(V=Promise.resolve(re.module.deactivate()).then(void 0,be=>(this.s.error(be),Promise.resolve(void 0))))}catch(be){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(be)}try{re.disposable.dispose()}catch(be){this.s.error(`An error occurred when disposing the subscriptions for extension '${X.value}':`),this.s.error(be)}return V}async fb(X,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.hb(X,V).then(re=>{const be=re.activationTimes;return this.C.$onDidActivateExtension(X.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,V),this.gb(X,V,"success",be),re},re=>{throw this.gb(X,V,"failure"),re})}gb(X,V,re,be){const Pe=ee(X,V);this.z.$publicLog2("extensionActivationTimes",{...Pe,...be||{},outcome:re})}hb(X,V){const re=ee(X,V);this.z.$publicLog2("activatePlugin",re);const be=this.wb(X);if(!be)return Promise.resolve(new E.$wrc(E.$trc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${X.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Pe=new O.$Yc,Fe=new E.$urc(V.startup);return Promise.all([this.xb(X,(0,L.$lh)(X.extensionLocation,be),Fe),this.ib(X,Pe)]).then(Be=>(P.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),J.jb(this.s,X.identifier,Be[0],Be[1],Pe,Fe))).then(Be=>(P.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),Be))}ib(X,V){const re=this.Z.createLanguageModelAccessInformation(X),be=V.add(new t.$Crc(X,this.M)),Pe=V.add(new t.$Brc(X.identifier.value,!1,this.M)),Fe=V.add(new A.$Lrc(X,this.N)),Be=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,xe=this.f.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([be.whenReady,Pe.whenReady,this.O.whenReady]).then(()=>{const nt=this;let ht,$t;const ut=(0,l.$yH)(X,"ipc")?this.f.messagePorts?.get(i.$xn.toKey(X.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Pe,secrets:Fe,subscriptions:[],get languageModelAccessInformation(){return re},get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(et){return D.$oc(X.extensionLocation.fsPath,et)},get storagePath(){return nt.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return nt.O.globalValue(X).fsPath},get logPath(){return D.$oc(nt.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return s.URI.joinPath(nt.f.logsLocation,X.identifier.value)},get storageUri(){return nt.O.workspaceValue(X)},get globalStorageUri(){return nt.O.globalValue(X)},get extensionMode(){return Be},get extension(){return ht===void 0&&(ht=new ie(nt,X.identifier,X,xe,!1)),ht},get extensionRuntime(){return(0,l.$zH)(X,"extensionRuntime"),nt.extensionRuntime},get environmentVariableCollection(){return nt.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!$t){if(!ut)return;const et=$.Event.buffer($.Event.fromDOMEventEmitter(ut,"message",Le=>Le.data));ut.start(),$t={onDidReceiveMessage:et,postMessage:ut.postMessage.bind(ut)}}return $t}})})}static jb(X,V,re,be,Pe,Fe){return re=re||{activate:void 0,deactivate:void 0},this.kb(X,V,re,be,Fe).then(Be=>new E.$vrc(!1,null,Fe.build(),re,Be,(0,O.$Xc)(()=>{Pe.dispose(),(0,O.$Uc)(be.subscriptions)})))}static kb(X,V,re,be,Pe){if(typeof re.activate=="function")try{Pe.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Fe=typeof global=="object"?global:self,Be=re.activate.apply(Fe,[be]);return Pe.activateCallStop(),Pe.activateResolveStart(),Promise.resolve(Be).then(xe=>(Pe.activateResolveStop(),xe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(re)}lb(X,V){this.bb(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:V}).then(void 0,re=>{this.s.error(re)})}mb(X,V=0){const be=Date.now();(0,j.$E)(()=>{for(let Pe=V;Pe<X.length;Pe+=1){const Fe=X[Pe];for(const Be of Fe.activationEvents??[])if(Be==="onStartupFinished")if(Date.now()-be>50){this.mb(X,Pe);break}else this.lb(Fe,Be)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(X=>{const V=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),re=this.J.getAllExtensionDescriptions();if(V)this.mb(re);else for(const be of re)if(be.activationEvents)for(const Pe of be.activationEvents)Pe==="onStartupFinished"&&this.lb(be,Pe)})}ob(){const X=this.ab("*",!0).then(void 0,Fe=>{this.s.error(Fe)});this.B(this.j.onDidChangeWorkspace(Fe=>this.pb(Fe.added)));const V=this.j.workspace?this.j.workspace.folders:[],re=this.pb(V),be=this.rb(),Pe=Promise.all([be,X,re]).then(()=>{});return Promise.race([Pe,(0,R.$Lh)(1e4)]).then(()=>{this.nb()}),Pe}pb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.qb(X,V))).then(()=>{})}async qb(X,V){if(this.isActivated(V.identifier))return;const re=!this.f.remote.isRemote&&!!this.f.remote.authority,be={logService:this.s,folders:X.map(Fe=>Fe.uri),forceUsingSearch:re||!this.c.fsExists,exists:Fe=>this.c.fsExists(Fe.fsPath),checkExists:(Fe,Be,xe)=>this.y.$checkExists(Fe,Be,xe)},Pe=await(0,b.$IAb)(be,V);if(Pe)return this.bb(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Pe.activationEvent}).then(void 0,Fe=>this.s.error(Fe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(X){throw console.error(X),X}}async sb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:V}=this.f.environment;if(!X||!V)throw new Error(v.localize(2701,null));const re=await this.xb(null,V,new E.$urc(!1));if(!re||typeof re.run!="function")throw new Error(v.localize(2702,null,V.toString()));return new Promise((be,Pe)=>{const Fe=(nt,ht)=>{nt?(j.$w&&this.s.error("Test runner called back with error",nt),Pe(nt)):(j.$w&&(ht?this.s.info(`Test runner called back with ${ht} failures.`):this.s.info("Test runner called back with successful outcome.")),be(typeof ht=="number"&&ht>0?1:0))},Be=(0,L.$_g)(V),xe=re.run(Be,Fe);xe&&xe.then&&xe.then(()=>{j.$w&&this.s.info("Test runner finished successfully."),be(0)}).catch(nt=>{j.$w&&this.s.error("Test runner finished with error",nt),Pe(nt instanceof Error&&nt.stack?nt.stack:String(nt))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Lh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,V){return this.S[X]=V,(0,O.$Xc)(()=>{delete this.S[X]})}async getRemoteExecServer(X){const{resolver:V}=await this.ub(X);return V?.resolveExecServer?.(X,{resolveAttempt:0})}async ub(X){const V=X.indexOf("+");if(V===-1)throw new o.$hO("Not an authority that can be resolved!",c.RemoteAuthorityResolverErrorCode.InvalidAuthority);const re=X.substr(0,V);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this.S[re]}}async $resolveAuthority(X,V){const re=x.$ke.create(!1),be=()=>`[resolveAuthority(${(0,c.$1l)(X)},${V})][${re.elapsed()}ms] `,Pe=B=>this.s.info(`${be()}${B}`),Fe=B=>this.s.warn(`${be()}${B}`),Be=(B,Q=void 0)=>this.s.error(`${be()}${B}`,Q),xe=B=>{if(B instanceof o.$hO)return{type:"error",error:{code:B._code,message:B._message,detail:B._detail}};throw B},nt=async B=>{Pe(`activating resolver for ${B}...`);const{resolver:Q,authorityPrefix:H}=await this.ub(B);if(!Q)throw Be(`no resolver for ${H}`),new o.$hO(`No remote extension installed to resolve ${H}.`,c.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:H,remoteAuthority:B}},ht=X.split(/@|%40/g).reverse();Pe(`activating remote resolvers ${ht.join(" -> ")}`);let $t;try{$t=await Promise.all(ht.map(nt)).catch(async B=>{if(!(B instanceof o.$hO)||B._code!==c.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw B;return Fe(`resolving nested authorities failed: ${B.message}`),[await nt(X)]})}catch(B){return xe(B)}const ut=new R.$Vh;ut.cancelAndSet(()=>Pe("waiting..."),1e3);let et,Le;for(const[B,{authorityPrefix:Q,resolver:H,remoteAuthority:se}]of $t.entries())try{if(B===$t.length-1)Pe("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${Q}`),et=await H.resolve(se,{resolveAttempt:V,execServer:Le}),P.mark(`code/extHost/didResolveAuthorityOK/${Q}`),Pe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,o.$gO.isManagedResolvedAuthority(et)?et:void 0));else{if(Pe(`invoking resolveExecServer() for ${se}`),P.mark(`code/extHost/willResolveExecServer/${Q}`),Le=await H.resolveExecServer?.(se,{resolveAttempt:V,execServer:Le}),!Le)throw new o.$hO(`Exec server was not available for ${se}`,c.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(ge){return P.mark(`code/extHost/didResolveAuthorityError/${Q}`),Be("returned an error",ge),ut.dispose(),xe(ge)}ut.dispose();const Me={environmentTunnels:et.environmentTunnels,features:et.tunnelFeatures?{elevation:et.tunnelFeatures.elevation,privacyOptions:et.tunnelFeatures.privacyOptions,protocol:et.tunnelFeatures.protocol===void 0?!0:et.tunnelFeatures.protocol}:void 0},Ne={extensionHostEnv:et.extensionHostEnv,isTrusted:et.isTrusted,authenticationSession:et.authenticationSessionForInitializingExtensions?{id:et.authenticationSessionForInitializingExtensions.id,providerId:et.authenticationSessionForInitializingExtensions.providerId}:void 0};Pe(`returned ${o.$gO.isManagedResolvedAuthority(et)?"managed authority":`${et.host}:${et.port}`}`);let W;if(o.$gO.isManagedResolvedAuthority(et)){const B=V;this.Y.setFactory(B,et.makeConnection),W={authority:X,connectTo:new c.$Xl(B),connectionToken:et.connectionToken}}else W={authority:X,connectTo:new c.$Yl(et.host,et.port),connectionToken:et.connectionToken};return{type:"ok",value:{authority:W,options:Ne,tunnelInformation:Me}}}async $getCanonicalURI(X,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,c.$1l)(X)})`);const{resolver:re}=await this.ub(X);if(!re)return null;const be=s.URI.revive(V);if(typeof re.getCanonicalURI>"u")return be;const Pe=await(0,R.$Ch)(()=>re.getCanonicalURI(be));return Pe||be}async $startExtensionHost(X){X.toAdd.forEach(Fe=>Fe.extensionLocation=s.URI.revive(Fe.extensionLocation));const{globalRegistry:V,myExtensions:re}=ae(this.I,this.L,this.J,X),be=await this.db(re);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(V.getAllExtensionDescriptions()),this.J.set(re),j.$w&&(this.s.info(`$startExtensionHost: global extensions: ${oe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${oe(this.J)}`)),this.tb()}$activateByEvent(X,V){return V===l.ActivationKind.Immediate?this.D.wait().then(re=>this.ab(X,!1)):this.G.wait().then(re=>this.ab(X,!1))}async $activate(X,V){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.bb(X,V),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(Fe=>Fe.extensionLocation=s.URI.revive(Fe.extensionLocation));const{globalRegistry:V,myExtensions:re}=ae(this.I,this.L,this.J,X),be=await this.db(re);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(V.getAllExtensionDescriptions()),this.J.set(re),j.$w&&(this.s.info(`$deltaExtensions: global extensions: ${oe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${oe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const V=n.$Se.alloc(X),re=Math.random()%256;for(let be=0;be<X;be++)V.writeUInt8(re,be);return V}async $updateRemoteConnectionData(X){this.X=X,this.a.fire()}};e.$Rrc=Z,e.$Rrc=Z=J=He([qe(0,g.$Ji),qe(1,e.$Qrc),qe(2,S.$KQ),qe(3,r.$crc),qe(4,u.$frc),qe(5,I.$fk),qe(6,f.$1Q),qe(7,h.$irc),qe(8,y.$6Gb),qe(9,C.$Drc),qe(10,G.$Nrc),qe(11,U.$Orc),qe(12,T.$Hrc)],Z);function ae(Ie,X,V,re){Ie.addActivationEvents(re.addActivationEvents);const be=new d.$8ec(Ie,X.getAllExtensionDescriptions());be.deltaExtensions(re.toAdd,re.toRemove);const Pe=new i.$yn(V.getAllExtensionDescriptions().map(Be=>Be.identifier));for(const Be of re.myToRemove)Pe.delete(Be);for(const Be of re.myToAdd)Pe.add(Be);const Fe=ue(be,Pe);return{globalRegistry:be,myExtensions:Fe}}function ee(Ie,X){return{id:Ie.identifier.value,name:Ie.name,extensionVersion:Ie.version,publisherDisplayName:Ie.publisher,activationEvents:Ie.activationEvents?Ie.activationEvents.join(","):null,isBuiltin:Ie.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function oe(Ie){return Ie.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$Src=(0,g.$Ki)("IExtHostExtensionService");class ie{#e;#t;#i;constructor(X,V,re,be,Pe){this.#e=X,this.#t=V,this.#i=re.identifier,this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=D.$mc((0,L.$_g)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=be,this.isFromDifferentExtensionHost=Pe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Trc=ie;function ue(Ie,X){return Ie.getAllExtensionDescriptions().filter(V=>X.has(V.identifier))}class _{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$Urc=_;class $e{constructor(X){this.a=new i.$zn,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const V of Object.keys(X))this.a.set(V,X[V])}}}),define(Re[272],Te([1,0,64,2,5,46,21,18,16,26,3,47,11,13]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$$sc=void 0,v=Ve(v);let r=class{constructor(n,t,o,c,g,f,h){this.c=n,this.d=t,this.e=o,this.f=c,this.g=g,this.h=f,this.i=h,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new d(this.c,t,this.d,n,this.i)),this.register(this.e.createInstance(l)),this.h.remote.isRemote&&this.register(this.e.createInstance(a,t,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const t of n.nodeModuleName)this.a.set(t,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(t=>n.alternativeModuleName(t))}};e.$$sc=r,e.$$sc=r=He([qe(2,I.$Ji),qe(3,L.$frc),qe(4,w.$Src),qe(5,s.$1Q),qe(6,u.$fk)],r);let l=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&p.a.size){const t=(0,E.$mf)(this.c(n.environment.appRoot.fsPath)),o="[a-z0-9_.-]",c=`@${o}+\\/${o}+|${o}+`,g="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${g}\\/)(${c})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const t=this.b.exec(this.c(n));if(!t)return;const[,o,c,g]=t,f=p.a.get(c);if(f!==void 0)return console.warn(`${c} as been renamed to ${f}, please update your imports`),o+f+g}c(n){return n.replace(/\\/g,"/")}};l=p=He([qe(0,s.$1Q)],l);class d{constructor(n,t,o,c,g){this.c=n,this.d=t,this.e=o,this.f=c,this.g=g,this.nodeModuleName="vscode",this.a=new O.$zn}load(n,t){const o=this.d.findSubstr(t);if(o){let c=this.a.get(o.identifier);return c||(c=this.c(o,this.e,this.f),this.a.set(o.identifier,c)),c}if(!this.b){let c="";this.d.forEach((g,f)=>c+=`	${f} -> ${g.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${c}`),this.b=this.c(R.$tH,this.e,this.f)}return this.b}}let a=class{constructor(n,t,o){this.e=n,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(P.$0N.MainThreadTelemetry);const c=o.getProxy(P.$0N.MainThreadWindow);this.c=(g,f)=>{const h=D.URI.parse(g);return f?this.g(g,f):h.scheme==="http"||h.scheme==="https"?c.$openUri(h,g,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?c.$openUri(h,g,{}):this.g(g,f)}}load(n,t,o){const c=this.e.findSubstr(t);return c&&(this.a=c.identifier.value,this.h()),this.b=o(n),this.c}g(n,t){return this.i(),this.b(n,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};a=He([qe(2,m.$KQ)],a)}),define(Re[133],Te([1,0,51,4,22,79,3,57,70,47,7,45,202,46]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wrc=e.$Vrc=void 0,P=Ve(P),L=Ve(L),e.$Vrc=(0,R.$Ki)("IExtHostVariableResolverProvider");class p extends u.$OR{constructor(d,a,i,n,t,o,c){function g(){if(i){const f=i.activeEditor();if(f)return f.document.uri;const h=n.tabGroups.all.find(S=>S.isActive)?.activeTab;if(h!==void 0){if(h.input instanceof I.$1P||h.input instanceof I.$6P)return h.input.modified;if(h.input instanceof I.$ZP||h.input instanceof I.$5P||h.input instanceof I.$3P)return h.input.uri}}}super({getFolderUri:f=>{const h=o.folders.filter(S=>S.name===f);if(h&&h.length>0)return h[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(f,h)=>t.getConfiguration(void 0,f).get(h),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const f=g();if(f)return P.$mc(f.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const f=g();if(f){const h=a.getWorkspaceFolder(f);if(h)return P.$mc(h.uri.fsPath)}}},getSelectedText:()=>{if(i){const f=i.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(i){const f=i.activeEditor();if(f)return String(f.selection.end.line+1)}},getExtension:f=>d.getExtension(f)},void 0,c?Promise.resolve(c):void 0,Promise.resolve(L.env))}}let r=class extends D.$Zc{constructor(d,a,i,n,t){super(),this.b=d,this.c=a,this.g=i,this.h=n,this.j=t,this.a=new v.$Y(async()=>{const o=await this.h.getConfigProvider(),g={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async f=>{g.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,o,g,this.m())})}getResolver(){return this.a.value}m(){}};e.$Wrc=r,e.$Wrc=r=He([qe(0,s.$Src),qe(1,w.$crc),qe(2,O.$VQ),qe(3,E.$frc),qe(4,m.$rrc)],r)}),define(Re[134],Te([1,0,10,6,2,4,18,3,5,70,47,16,7,45,194,81,195,46,133,36,35,8,17,96]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i,n,t,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7rc=e.$6rc=e.$5rc=e.$4rc=e.$3rc=void 0,t=Ve(t),e.$3rc=(0,O.$Ki)("IExtHostDebugService");let g=class extends L.$Zc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(T,$,b,N,A,F,G,x){super(),this.Y=$,this.Z=b,this.$=N,this.ab=A,this.bb=F,this.cb=G,this.db=x,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new D.$qe),this.z=this.B(new D.$qe),this.C=this.B(new D.$qe),this.F=this.B(new D.$qe),this.u=T.getProxy(m.$0N.MainThreadDebugService),this.I=this.B(new D.$qe),this.L=this.B(new D.$qe),this.G=new h(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(j=>{this.B(j.onDidChange(U=>{this.fb(j)})),this.fb(j)})}async $getVisualizerTreeItem(T,$){const b=this.gb($);if(!b)return;const N=await this.Q.get(T)?.getTreeItem?.(b);return N?this.eb(T,N):void 0}registerDebugVisualizationTree(T,$,b){const N=R.$xn.toKey(T.identifier),A=this.ub(N,$);if(this.P.has(A))throw new Error(`A debug visualization provider with id '${$}' is already registered`);return this.Q.set(A,b),this.u.$registerDebugVisualizerTree(A,!!b.editItem),(0,L.$Xc)(()=>{this.u.$unregisterDebugVisualizerTree(A),this.Q.delete($)})}async $getVisualizerTreeItemChildren(T,$){const b=this.S.get($)?.item;return b?(await this.Q.get(T)?.getChildren?.(b))?.map(A=>this.eb(T,A))||[]:[]}async $editVisualizerTreeItem(T,$){const b=this.S.get(T);if(!b)return;const N=await this.Q.get(b.provider)?.editItem?.(b.item,$);return this.eb(b.provider,N||b.item)}$disposeVisualizedTree(T){const $=this.S.get(T);if(!$)return;const b=[$.children];for(const N of b)if(N)for(const A of N)b.push(this.S.get(A)?.children),this.S.delete(A)}eb(T,$){let b=this.R.get($);return b||(b=this.O++,this.R.set($,b),this.S.set(b,{provider:T,item:$})),t.DebugTreeItem.from($,b)}asDebugSourceUri(T,$){const b=T;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let N=`debug:${encodeURIComponent(b.path||"")}`,A="?";return $&&(N+=`${A}session=${encodeURIComponent($.id)}`,A="&"),N+=`${A}ref=${b.sourceReference}`,P.URI.parse(N)}else{if(b.path)return P.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(T){const $=[];for(const b of T.getAllExtensionDescriptions())if(b.contributes){const N=b.contributes.debuggers;if(N&&N.length>0)for(const A of N)(0,l.$uI)(A)&&$.push(A.type)}this.u.$registerDebugTypes($)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const T=[];return this.H.forEach($=>T.push($)),T}async $resolveDebugVisualizer(T,$){const b=this.W.get(T);if(!b)throw new Error(`No debug visualizer found with id '${T}'`);let{v:N,provider:A,extensionId:F}=b;if(N.visualization||(N=await A.resolveDebugVisualization?.(N,$)||N,b.v=N),!N.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${A}'`);return this.vb(F,N.visualization)}async $executeDebugVisualizerCommand(T){const $=this.W.get(T);if(!$)throw new Error(`No debug visualizer found with id '${T}'`);const b=$.v.visualization;b&&"command"in b&&this.cb.executeCommand(b.command,...b.arguments||[])}gb(T){const $=this.w.get(T.sessionId);return $&&{session:$.api,variable:T.variable,containerId:T.containerId,frameId:T.frameId,threadId:T.threadId}}async $provideDebugVisualizers(T,$,b,N){const A=this.gb(b),F=this.ub(T,$),G=this.P.get(F);if(!A||!G)return[];const x=await G.provideDebugVisualization(A,N);return x?x.map(j=>{const U=++this.X;this.W.set(U,{v:j,provider:G,extensionId:T});const J=j.iconPath?this.wb(j.iconPath):void 0;return{id:U,name:j.name,iconClass:J?.iconClass,iconPath:J?.iconPath,visualization:this.vb(T,j.visualization)}}):[]}$disposeDebugVisualizers(T){for(const $ of T)this.W.delete($)}registerDebugVisualizationProvider(T,$,b){if(!T.contributes?.debugVisualizers?.some(F=>F.id===$))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${$})`);const N=R.$xn.toKey(T.identifier),A=this.ub(N,$);if(this.P.has(A))throw new Error(`A debug visualization provider with id '${$}' is already registered`);return this.P.set(A,b),this.u.$registerDebugVisualizer(N,$),(0,L.$Xc)(()=>{this.u.$unregisterDebugVisualizer(N,$),this.P.delete($)})}addBreakpoints(T){const $=T.filter(A=>{const F=A.id;return this.H.has(F)?!1:(this.H.set(F,A),!0)});this.rb($,[],[]);const b=[],N=new Map;for(const A of $)if(A instanceof u.$dP){let F=N.get(A.location.uri.toString());F||(F={type:"sourceMulti",uri:A.location.uri,lines:[]},N.set(A.location.uri.toString(),F),b.push(F)),F.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character,mode:A.mode})}else A instanceof u.$eP&&b.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName,mode:A.mode});return this.u.$registerBreakpoints(b)}removeBreakpoints(T){const $=T.filter(F=>this.H.delete(F.id));this.rb([],$,[]);const b=$.filter(F=>F instanceof u.$dP).map(F=>F.id),N=$.filter(F=>F instanceof u.$eP).map(F=>F.id),A=$.filter(F=>F instanceof u.$fP).map(F=>F.id);return this.u.$unregisterBreakpoints(b,N,A)}startDebugging(T,$,b){const N=b.testRun&&this.db.getMetadataForRun(b.testRun);return this.u.$startDebugging(T?T.uri:void 0,$,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:N&&{runId:N.runId,taskId:N.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(T){return this.u.$stopDebugging(T?T.id:void 0)}registerDebugConfigurationProvider(T,$,b){if(!$)return new u.$_N(()=>{});const N=this.f++;return this.g.push({type:T,handle:N,provider:$}),this.u.$registerDebugConfigurationProvider(T,b,!!$.provideDebugConfigurations,!!$.resolveDebugConfiguration,!!$.resolveDebugConfigurationWithSubstitutedVariables,N),new u.$_N(()=>{this.g=this.g.filter(A=>A.provider!==$),this.u.$unregisterDebugConfigurationProvider(N)})}registerDebugAdapterDescriptorFactory(T,$,b){if(!b)return new u.$_N(()=>{});if(!this.nb(T,$))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${$}' debugger.`);if(this.kb($))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const N=this.h++;return this.j.push({type:$,handle:N,factory:b}),this.u.$registerDebugAdapterDescriptorFactory($,N),new u.$_N(()=>{this.j=this.j.filter(A=>A.factory!==b),this.u.$unregisterDebugAdapterDescriptorFactory(N)})}registerDebugAdapterTrackerFactory(T,$){if(!$)return new u.$_N(()=>{});const b=this.m++;return this.n.push({type:T,handle:b,factory:$}),new u.$_N(()=>{this.n=this.n.filter(N=>N.factory!==$)})}async $runInTerminal(T,$){return Promise.resolve(void 0)}async $substituteVariables(T,$){let b;const N=await this.tb(T);return N&&(b={uri:N.uri,name:N.name,index:N.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(b,$)}hb(T,$){if(T.type==="implementation")return new k(T.implementation)}ib(){}async $startDASession(T,$){const b=this,N=await this.sb($);return this.pb(this.kb(N.type),N).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${N.type}' (extension might have failed to activate)`);const F=this.jb(A),G=this.hb(F,N);if(!G)throw new Error(`Couldn't create a debug adapter for type '${N.type}'.`);const x=G;return this.M.set(T,x),this.ob(N).then(j=>(j&&this.N.set(T,j),x.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const J=U,Z={type:"response",seq:0,command:J.command,request_seq:J.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const ae=await this.U.sign(J.arguments.value);Z.body={signature:ae},x.sendResponse(Z)}else throw new Error("no signer")}catch(ae){Z.success=!1,Z.message=ae.message,x.sendResponse(Z)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(U),U=(0,l.$zI)(U,!0),b.u.$acceptDAMessage(T,U)}),x.onError(U=>{j&&j.onError&&j.onError(U),this.u.$acceptDAError(T,U.name,U.message,U.stack)}),x.onExit(U=>{j&&j.onExit&&j.onExit(U??void 0,void 0),this.u.$acceptDAExit(T,U??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),x.startSession()))})}$sendDAMessage(T,$){$=(0,l.$yI)($,!1);const b=this.N.get(T);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage($),this.M.get(T)?.sendMessage($)}$stopDASession(T){const $=this.N.get(T);this.N.delete(T),$&&$.onWillStopSession&&$.onWillStopSession();const b=this.M.get(T);return this.M.delete(T),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(T){const $=[],b=[],N=[];if(T.added)for(const A of T.added){const F=A.id;if(F&&!this.H.has(F)){let G;if(A.type==="function")G=new u.$eP(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage,A.mode);else if(A.type==="data")G=new u.$fP(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage,A.mode);else{const x=P.URI.revive(A.uri);G=new u.$dP(new u.$nO(x,new u.$aO(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage,A.mode)}(0,u.$bP)(G,F),this.H.set(F,G),$.push(G)}}if(T.removed)for(const A of T.removed){const F=this.H.get(A);F&&(this.H.delete(A),b.push(F))}if(T.changed){for(const A of T.changed)if(A.id){const F=this.H.get(A.id);if(F){if(F instanceof u.$eP&&A.type==="function"){const G=F;G.enabled=A.enabled,G.condition=A.condition,G.hitCondition=A.hitCondition,G.logMessage=A.logMessage,G.functionName=A.functionName}else if(F instanceof u.$dP&&A.type==="source"){const G=F;G.enabled=A.enabled,G.condition=A.condition,G.hitCondition=A.hitCondition,G.logMessage=A.logMessage,G.location=new u.$nO(P.URI.revive(A.uri),new u.$aO(A.line,A.character))}N.push(F)}}}this.rb($,b,N)}async $acceptStackFrameFocus(T){let $;if(T){const b=await this.sb(T.sessionId);T.kind==="thread"?$=new u.$lP(b.api,T.threadId):$=new u.$kP(b.api,T.threadId,T.frameId)}this.J=$,this.L.fire(this.J)}$provideDebugConfigurations(T,$,b){return(0,v.$Ch)(async()=>{const N=this.mb(T);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.tb($);return N.provideDebugConfigurations(A,b)}).then(N=>{if(!N)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return N})}$resolveDebugConfiguration(T,$,b,N){return(0,v.$Ch)(async()=>{const A=this.mb(T);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.tb($);return A.resolveDebugConfiguration(F,b,N)})}$resolveDebugConfigurationWithSubstitutedVariables(T,$,b,N){return(0,v.$Ch)(async()=>{const A=this.mb(T);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.tb($);return A.resolveDebugConfigurationWithSubstitutedVariables(F,b,N)})}async $provideDebugAdapter(T,$){const b=this.lb(T);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const N=await this.sb($);return this.pb(b,N).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${N.type}'`);return this.jb(A)})}async $acceptDebugSessionStarted(T){const $=await this.sb(T);this.y.fire($.api)}async $acceptDebugSessionTerminated(T){const $=await this.sb(T);$&&(this.z.fire($.api),this.w.delete($.id))}async $acceptDebugSessionActiveChanged(T){this.D=T?await this.sb(T):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(T,$){(await this.sb(T))?._acceptNameChanged($)}async $acceptDebugSessionCustomEvent(T,$){const N={session:(await this.sb(T)).api,event:$.event,body:$.body};this.F.fire(N)}jb(T){if(T instanceof u.$gP)return{type:"executable",command:T.command,args:T.args,options:T.options};if(T instanceof u.$hP)return{type:"server",port:T.port,host:T.host};if(T instanceof u.$iP)return{type:"pipeServer",path:T.path};if(T instanceof u.$jP)return{type:"implementation",implementation:T.implementation};throw new Error("convertToDto unexpected type")}kb(T){const $=this.j.filter(b=>b.type===T);if($.length>0)return $[0].factory}lb(T){const $=this.j.filter(b=>b.handle===T);if($.length>0)return $[0].factory}mb(T){const $=this.g.filter(b=>b.handle===T);if($.length>0)return $[0].provider}nb(T,$){if(T.contributes){const b=T.contributes.debuggers;if(b&&b.length>0){for(const N of b)if(N.label&&N.type&&N.type===$)return!0}}return!1}ob(T){const b=T.configuration.type,N=this.n.filter(A=>A.type===b||A.type==="*").map(A=>(0,v.$Ch)(()=>A.factory.createDebugAdapterTracker(T.api)).then(F=>F,F=>null));return Promise.race([Promise.all(N).then(A=>{const F=(0,o.$Lb)(A);if(F.length>0)return new S(F)}),new Promise(A=>setTimeout(()=>A(void 0),1e3))]).catch(A=>{})}async pb(T,$){const b=$.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new u.$hP(b));if(T){const A=await this.Z.getExtensionRegistry();return(0,v.$Ch)(()=>T.createDebugAdapterDescriptor($.api,this.qb($,A))).then(F=>{if(F)return F})}const N=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb($,N))}qb(T,$){}rb(T,$,b){(T.length>0||$.length>0||b.length>0)&&this.I.fire(Object.freeze({added:T,removed:$,changed:b}))}async sb(T){if(T)if(typeof T=="string"){const $=this.w.get(T);if($)return $}else{let $=this.w.get(T.id);if(!$){const b=await this.tb(T.folderUri),N=T.parent?this.w.get(T.parent):void 0;$=new f(this.u,T.id,T.type,T.name,b,T.configuration,N?.api),this.w.set($.id,$),this.u.$sessionCached($.id)}return $}throw new Error("cannot find session")}tb(T){if(T){const $=P.URI.revive(T);return this.Y.resolveWorkspaceFolder($)}return Promise.resolve(void 0)}ub(T,$){return`${T}\0${$}`}vb(T,$){if($){if("title"in $&&"command"in $)return{type:r.DebugVisualizationType.Command};if("treeId"in $)return{type:r.DebugVisualizationType.Tree,id:`${T}\0${$.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(T){const $=this.xb(T);let b,N;return"id"in $?N=i.ThemeIcon.asClassName($):b=$,{iconPath:b,iconClass:N}}xb(T){if(T instanceof u.$$O)return{id:T.id};const $=typeof T=="object"&&"dark"in T?T.dark:T,b=typeof T=="object"&&"light"in T?T.light:T;return{dark:typeof $=="string"?P.URI.file($):$,light:typeof b=="string"?P.URI.file(b):b}}};e.$4rc=g,e.$4rc=g=He([qe(0,w.$KQ),qe(1,E.$crc),qe(2,I.$Src),qe(3,d.$frc),qe(4,s.$rrc),qe(5,a.$Vrc),qe(6,n.$7Q),qe(7,c.$Xrc)],g);class f{constructor(T,$,b,N,A,F,G){this.f=T,this.g=$,this.h=b,this.j=N,this.k=A,this.l=F,this.m=G}get api(){const T=this;return this.d??=Object.freeze({id:T.g,type:T.h,get name(){return T.j},set name($){T.j=$,T.f.$setDebugSessionName(T.g,$)},parentSession:T.m,workspaceFolder:T.k,configuration:T.l,customRequest($,b){return T.f.$customDebugAdapterRequest(T.g,$,b)},getDebugProtocolBreakpoint($){return T.f.$getDebugProtocolBreakpoint(T.g,$.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(T){this.j=T}get configuration(){return this.l}}e.$5rc=f;class h{constructor(T){this.value=Object.freeze({append($){T.$appendDebugConsole($)},appendLine($){this.append($+`
`)}})}}e.$6rc=h;class S{constructor(T){this.d=T}onWillStartSession(){this.d.forEach(T=>T.onWillStartSession?T.onWillStartSession():void 0)}onWillReceiveMessage(T){this.d.forEach($=>$.onWillReceiveMessage?$.onWillReceiveMessage(T):void 0)}onDidSendMessage(T){this.d.forEach($=>$.onDidSendMessage?$.onDidSendMessage(T):void 0)}onWillStopSession(){this.d.forEach(T=>T.onWillStopSession?T.onWillStopSession():void 0)}onError(T){this.d.forEach($=>$.onError?$.onError(T):void 0)}onExit(T,$){this.d.forEach(b=>b.onExit?b.onExit(T,$):void 0)}}class k extends p.$cwb{constructor(T){super(),this.h=T,T.onDidSendMessage($=>{this.acceptMessage($)})}startSession(){return Promise.resolve(void 0)}sendMessage(T){this.h.handleMessage(T)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends g{constructor(T,$,b,N,A,F,G,x){super(T,$,b,N,A,F,G,x)}};e.$7rc=y,e.$7rc=y=He([qe(0,w.$KQ),qe(1,E.$crc),qe(2,I.$Src),qe(3,d.$frc),qe(4,s.$rrc),qe(5,a.$Vrc),qe(6,n.$7Q),qe(7,c.$Xrc)],y)}),define(Re[273],Te([1,0,12,64,2,5,223,11,60,75,26,170,16,65,47,66]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$atc=e.$_sc=void 0,v=Ve(v),D=Ve(D);class l{static async installEarlyHandler(i){Error.stackTraceLimit=100;const n=i.get(O.$fk),o=i.get(u.$KQ).getProxy(L.$0N.MainThreadErrors);v.setUnexpectedErrorHandler(c=>{n.error(c);const g=v.$6(c);o.$onUnexpectedError(g)})}static async installFullHandler(i){const n=i.get(O.$fk),t=i.get(u.$KQ),o=i.get(p.$Src),c=i.get(r.$5Q),g=t.getProxy(L.$0N.MainThreadExtensionService),f=t.getProxy(L.$0N.MainThreadErrors),h=await o.getExtensionPathIndex(),S=new WeakMap;function k(T,$){if(S.has(T))return S.get(T).stack;let b="",N,A;for(const G of $)b+=`
	at ${G.toString()}`,A=G.getFileName(),!N&&A&&(N=h.findSubstr(P.URI.file(A)));const F=`${T.name||"Error"}: ${T.message||""}${b}`;return S.set(T,{extensionIdentifier:N?.identifier,stack:F}),F}const y=Symbol("prepareStackTrace wrapped");let C=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(T){if(T===k||!T||T[y]){C=T||k;return}C=function($,b){return k($,b),T.call(Error,$,b)},Object.assign(C,{[y]:!0})}}),v.setUnexpectedErrorHandler(T=>{n.error(T);const $=v.$6(T),b=S.get(T);if(!b?.extensionIdentifier){f.$onUnexpectedError($);return}g.$onExtensionRuntimeError(b.extensionIdentifier,$);const N=c.onExtensionError(b.extensionIdentifier,T);n.trace("forwarded error to extension?",N,b)})}}e.$_sc=l;class d{constructor(i,n,t,o,c){this.a=t,this.b=new R.$dfc(i,null,o),n=d.e(n,this.b);const g=new s.$Ii(...(0,m.$1s)());g.set(I.$1Q,{_serviceBrand:void 0,...n,messagePorts:c}),g.set(u.$KQ,new u.$LQ(this.b)),g.set(E.$_qc,new E.$arc(o)),g.set(p.$Qrc,t);const f=new w.$Er(g,!0);f.invokeFunction(l.installEarlyHandler),this.d=f.invokeFunction(h=>h.get(O.$fk)),D.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=f.invokeFunction(h=>h.get(p.$Src)),this.c.initialize(),f.invokeFunction(l.installFullHandler)}async asBrowserUri(i){const n=this.b.getProxy(L.$0N.MainThreadExtensionService);return P.URI.revive(await n.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,n){i.extensions.allExtensions.forEach(o=>{o.extensionLocation=P.URI.revive(n.transformIncomingURIs(o.extensionLocation))}),i.environment.appRoot=P.URI.revive(n.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(o=>P.URI.revive(n.transformIncomingURIs(o)))),i.environment.extensionTestsLocationURI=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(n.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(n.transformIncomingURIs(i.logsLocation)),i.workspace=n.transformIncomingURIs(i.workspace),i}}e.$atc=d}),define(Re[274],Te([1,0,17,40,58]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$psc=e.$osc=e.$lsc=void 0,e.$msc=s,e.$nsc=I,e.$qsc=p;function L(r){return"uri"in r&&"ranges"in r&&"preview"in r}function R(r){return r.folderOptions.map(l=>({folder:l.folder,excludes:l.excludes.map(d=>typeof d=="string"?d:d.pattern),includes:l.includes,useGlobalIgnoreFiles:l.useIgnoreFiles.global,useIgnoreFiles:l.useIgnoreFiles.local,useParentIgnoreFiles:l.useIgnoreFiles.parent,followSymlinks:l.followSymlinks,maxResults:r.maxResults,session:r.session}))}class O{constructor(l){this.a=l}provideFileSearchResults(l,d,a){return(async()=>{const n=R(d);return Promise.all(n.map(t=>this.a.provideFileSearchResults({pattern:l},t,a)))})().then(n=>(0,v.$Lb)(n).flat())}}e.$lsc=O;function m(r){return r.folderOptions.map(l=>({folder:l.folder,excludes:l.excludes.map(d=>typeof d=="string"?d:d.pattern),includes:l.includes,useGlobalIgnoreFiles:l.useIgnoreFiles.global,useIgnoreFiles:l.useIgnoreFiles.local,useParentIgnoreFiles:l.useIgnoreFiles.parent,followSymlinks:l.followSymlinks,maxResults:r.maxResults,previewOptions:s(r.previewOptions),maxFileSize:r.maxFileSize,encoding:l.encoding,afterContext:r.surroundingContext,beforeContext:r.surroundingContext}))}function s(r){return{matchLines:r?.matchLines??D.$QM.matchLines,charsPerLine:r?.charsPerLine??D.$QM.charsPerLine}}function I(r){if(L(r)){const l=(0,v.$6b)(r.ranges).map((d,a)=>{const n=(0,v.$6b)(r.preview.matches)[a];return{sourceRange:d,previewRange:n}});return new P.$lM(r.uri,l,r.preview.text)}else return new P.$mM(r.uri,r.text,r.lineNumber)}class w{constructor(l){this.a=l}provideTextSearchResults(l,d,a,i){const n=c=>{E(c)&&a.report(I(c))};return(async()=>(0,v.$Lb)(await Promise.all(m(d).map(c=>this.a.provideTextSearchResults(l,c,{report:g=>n(g)},i)))).reduce((c,g)=>({limitHit:c.limitHit||g.limitHit}),{limitHit:!1}))().then(c=>({limitHit:c.limitHit,message:(0,v.$Lb)((0,v.$6b)(c.message))}))}}e.$osc=w;class u{constructor(l){this.a=l}provideAITextSearchResults(l,d,a,i){const n=c=>{E(c)&&a.report(I(c))};return(async()=>(0,v.$Lb)(await Promise.all(m(d).map(c=>this.a.provideAITextSearchResults(l,c,{report:g=>n(g)},i)))).reduce((c,g)=>({limitHit:c.limitHit||g.limitHit}),{limitHit:!1}))().then(c=>({limitHit:c.limitHit,message:(0,v.$Lb)((0,v.$6b)(c.message))}))}}e.$psc=u;function E(r){if(p(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}function p(r){return!!r.preview}}),define(Re[275],Te([1,0,10,19,42,15,22,24,48,2,40,58]),function(we,e,v,D,P,L,R,O,m,s,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ksc=e.$jsc=e.$isc=void 0,R=Ve(R),O=Ve(O);class u{constructor(a,i,n){this.f=a,this.g=i,this.h=n,this.b=null,this.c=!1,this.d=0}get j(){return this.f.query}search(a,i){const n=this.j.folderQueries||[],t=new D.$Be(i);return new Promise((o,c)=>{this.b=new p(a);let g=!1;const f=(h,S)=>{if(!g&&!this.c){const k=this.l(h);h instanceof w.$lM&&typeof this.j.maxResults=="number"&&this.d+k>this.j.maxResults&&(this.c=!0,g=!0,t.cancel(),h=this.m(h,this.j.maxResults-this.d));const y=this.l(h);this.d+=y;const C=h instanceof w.$lM;(y>0||!C)&&this.b.add(h,S)}};this.n(n,f,t.token).then(h=>{t.dispose(),this.b.flush(),o({limitHit:this.c||h?.limitHit,messages:this.k(h),stats:{type:this.h}})},h=>{t.dispose();const S=(0,P.$vj)(h);c(new Error(S))})})}k(a){return a?.message?Array.isArray(a.message)?a.message:[a.message]:[]}l(a){return a instanceof w.$lM?Array.isArray(a.ranges)?a.ranges.length:1:0}m(a,i){return new w.$lM(a.uri,a.ranges.slice(0,i),a.previewText)}async n(a,i,n){const t=m.$Qi.forUris();a.forEach((S,k)=>{const y=new I.$MM(this.j,S);t.set(S.folder,{queryTester:y,folder:S.folder,folderIdx:k})});const o=[],c={report:S=>{if(S.uri===void 0)throw Error("Text search result URI is undefined. Please check provider implementation.");const k=t.findSubstr(S.uri),y=k.folder.scheme===L.Schemas.file?(0,I.$NM)(()=>this.g.readdir(O.$kh(S.uri))):void 0,C=O.$nh(k.folder,S.uri);if(C){const T=k.queryTester.includedInQuery(C,R.$sc(C),y);(0,v.$wh)(T)?o.push(T.then($=>{$&&i(S,k.folderIdx)})):T&&i(S,k.folderIdx)}}},f={folderOptions:a.map(S=>this.o(S)),maxFileSize:this.j.maxFileSize,maxResults:this.j.maxResults??I.$sM,previewOptions:this.j.previewOptions??I.$QM,surroundingContext:this.j.surroundingContext??0};"usePCRE2"in this.j&&(f.usePCRE2=this.j.usePCRE2);let h;return this.f.query.type===I.QueryType.aiText?h=await this.f.provider.provideAITextSearchResults(this.f.query.contentPattern,f,c,n):h=await this.f.provider.provideTextSearchResults(E(this.f.query.contentPattern),f,c,n),o.length&&await Promise.all(o),h}o(a){const i=(0,I.$LM)(this.j.includePattern,a.includePattern);let n=a.excludePattern?.map(c=>({folder:c.folder,patterns:(0,I.$LM)(this.j.excludePattern,c.pattern)}));(!n||n.length===0)&&(n=[{folder:void 0,patterns:(0,I.$LM)(this.j.excludePattern,void 0)}]);const t=(0,I.$PM)(n);return{folder:s.URI.from(a.folder),excludes:t,includes:i,useIgnoreFiles:{local:!a.disregardIgnoreFiles,parent:!a.disregardParentIgnoreFiles,global:!a.disregardGlobalIgnoreFiles},followSymlinks:!a.ignoreSymlinks,encoding:(a.fileEncoding&&this.g.toCanonicalName(a.fileEncoding))??""}}}e.$isc=u;function E(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class p{constructor(a){this.g=a,this.c=-1,this.f=null,this.b=new l(512,i=>this.j(i))}add(a,i){this.f&&(this.c!==i||!O.$eh(this.d,a.uri))&&(this.h(),this.f=null),this.f||(this.c=i,this.f={resource:a.uri,results:[]}),this.f.results.push(r(a))}h(){const a=this.f&&this.f.results?this.f.results.length:0;this.b.addItem(this.f,a)}flush(){this.h(),this.b.flush()}j(a){this.g(a)}}e.$jsc=p;function r(d){return d instanceof w.$lM?{previewText:d.previewText,rangeLocations:d.ranges.map(a=>({preview:{startLineNumber:a.previewRange.start.line,startColumn:a.previewRange.start.character,endLineNumber:a.previewRange.end.line,endColumn:a.previewRange.end.character},source:{startLineNumber:a.sourceRange.start.line,startColumn:a.sourceRange.start.character,endLineNumber:a.sourceRange.end.line,endColumn:a.sourceRange.end.character}}))}:{text:d.text,lineNumber:d.lineNumber}}class l{static{this.b=4e3}static{this.c=50}constructor(a,i){this.j=a,this.k=i,this.d=0,this.f=[],this.g=0}addItem(a,i){a&&this.l(a,i)}addItems(a,i){a&&this.m(a,i)}l(a,i){this.f.push(a),this.g+=i,this.n()}m(a,i){this.f=this.f.concat(a),this.g+=i,this.n()}n(){this.d<l.c?this.flush():this.g>=this.j?this.flush():this.h||(this.h=setTimeout(()=>{this.flush()},l.b))}flush(){this.g&&(this.d+=this.g,this.k(this.f),this.f=[],this.g=0,this.h&&(clearTimeout(this.h),this.h=0))}}e.$ksc=l}),define(Re[135],Te([1,0,4,5,3,269,16,65,11,2,275,34,274]),function(we,e,v,D,P,L,R,O,m,s,I,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ssc=e.$rsc=void 0,e.$tsc=p,e.$rsc=(0,P.$Ki)("IExtHostSearch");let E=class{constructor(d,a,i){this.n=d,this.o=a,this.q=i,this.c=this.n.getProxy(D.$0N.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new L.$hsc}s(d){return this.o.transformOutgoingScheme(d)}registerTextSearchProviderOld(d,a){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const i=this.d++;return this.e.set(i,new u.$osc(a)),this.c.$registerTextSearchProvider(i,this.s(d)),(0,v.$Xc)(()=>{this.g.delete(d),this.e.delete(i),this.c.$unregisterProvider(i)})}registerTextSearchProvider(d,a){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const i=this.d++;return this.e.set(i,a),this.c.$registerTextSearchProvider(i,this.s(d)),(0,v.$Xc)(()=>{this.g.delete(d),this.e.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProviderOld(d,a){if(this.i.has(d))throw new Error(`an AI text search provider for the scheme '${d}'is already registered`);this.i.add(d);const i=this.d++;return this.h.set(i,new u.$psc(a)),this.c.$registerAITextSearchProvider(i,this.s(d)),(0,v.$Xc)(()=>{this.i.delete(d),this.h.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProvider(d,a){if(this.i.has(d))throw new Error(`an AI text search provider for the scheme '${d}'is already registered`);this.i.add(d);const i=this.d++;return this.h.set(i,a),this.c.$registerAITextSearchProvider(i,this.s(d)),(0,v.$Xc)(()=>{this.i.delete(d),this.h.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProviderOld(d,a){if(this.k.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.k.add(d);const i=this.d++;return this.j.set(i,new u.$lsc(a)),this.c.$registerFileSearchProvider(i,this.s(d)),(0,v.$Xc)(()=>{this.k.delete(d),this.j.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(d,a){if(this.k.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.k.add(d);const i=this.d++;return this.j.set(i,a),this.c.$registerFileSearchProvider(i,this.s(d)),(0,v.$Xc)(()=>{this.k.delete(d),this.j.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(d,a,i,n){const t=p(i),o=this.j.get(d);if(o)return this.l.fileSearch(t,o,c=>{this.c.$handleFileMatch(d,a,c.map(g=>g.resource))},n);throw new Error("unknown provider: "+d)}async doInternalFileSearchWithCustomCallback(d,a,i){return{messages:[]}}$clearCache(d){return this.l.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,a,i,n){const t=this.e.get(d);if(!t||!t.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${d}`);const o=p(i);return this.t(o,t).search(g=>this.c.$handleTextMatch(d,a,g),n)}$provideAITextSearchResults(d,a,i,n){const t=this.h.get(d);if(!t||!t.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${d}`);const o=p(i);return this.v(o,t).search(g=>this.c.$handleTextMatch(d,a,g),n)}$enableExtensionHostSearch(){}t(d,a){return new I.$isc({query:d,provider:a},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}v(d,a){return new I.$isc({query:d,provider:a},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"aiTextSearchProvider")}};e.$ssc=E,e.$ssc=E=He([qe(0,R.$KQ),qe(1,O.$_qc),qe(2,m.$fk)],E);function p(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(r),extraFileResources:l.extraFileResources&&l.extraFileResources.map(d=>s.URI.revive(d))}}function r(l){return(0,w.$hi)(l)}});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[276],Te([1,0,19,12,6,4,15,37,2,106,163,152,52,18,28,11,62,63,184,5,226,255,85,91,231,232,233,210,200,35,234,46,235,134,124,236,212,227,237,238,57,70,213,228,47,240,68,241,50,26,256,214,242,243,95,244,86,87,216,268,246,189,247,257,248,130,217,249,250,251,16,252,135,88,253,218,254,89,92,132,66,56,128,96,258,229,259,260,93,8,7,219,65,220,67,261,262,123,45,81,84,21,58]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i,n,t,o,c,g,f,h,S,k,y,C,T,$,b,N,A,F,G,x,j,U,J,Z,ae,ee,oe,ie,ue,_,$e,Ie,X,V,re,be,Pe,Fe,Be,xe,nt,ht,$t,ut,et,Le,Me,Ne,W,B,Q,H,se,ge,Ee,ze,Je,_e,tt,ct,it,at,yt,Ye,he,pe,ye,Ce,fe,ve,Y,q,de,je,Qe,st,dt,mt,Tt,Ot,Qt,_t,Xe,At){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7sc=Ut,D=Ve(D),O=oi(O),w=Ve(w),p=Ve(p),Y=Ve(Y),q=Ve(q);function Ut(wt){const Dt=wt.get($e.$1Q),ei=wt.get(_.$Wqc),ti=wt.get(ie.$hrc),Ht=wt.get(ee.$Src),bt=wt.get(Ot.$crc),Lt=wt.get(at.$5Q),ci=wt.get(T.$frc),Yt=wt.get(je.$_qc),Ge=wt.get(H.$KQ),ii=wt.get(tt.$Arc),li=wt.get(ct.$irc),hi=wt.get(r.$gk),kt=wt.get(r.$fk),jt=wt.get(ve.$6Gb),Nt=wt.get(o.$Sqc),Bt=wt.get(Tt.$6sc),ai=wt.get(Ee.$Krc),ni=wt.get(J.$rrc),ri=wt.get(Be.$Orc),Gt=wt.get(c.$3qc),Jt=wt.get(be.$Hrc);Ge.set(i.$$N.ExtHostFileSystemInfo,ei),Ge.set(i.$$N.ExtHostLogLevelServiceShape,hi),Ge.set(i.$$N.ExtHostWorkspace,bt),Ge.set(i.$$N.ExtHostConfiguration,ci),Ge.set(i.$$N.ExtHostExtensionService,Ht),Ge.set(i.$$N.ExtHostStorage,ii),Ge.set(i.$$N.ExtHostTunnelService,jt),Ge.set(i.$$N.ExtHostWindow,Bt),Ge.set(i.$$N.ExtHostSecretState,ai),Ge.set(i.$$N.ExtHostTelemetry,Lt),Ge.set(i.$$N.ExtHostEditorTabs,ni),Ge.set(i.$$N.ExtHostManagedSockets,ri),Ge.set(i.$$N.ExtHostAuthentication,Gt),Ge.set(i.$$N.ExtHostChatProvider,Jt);const ui=Ge.set(i.$$N.ExtHostDecorations,wt.get(N.$9rc)),Mt=Ge.set(i.$$N.ExtHostDocumentsAndEditors,wt.get(U.$VQ)),Ct=Ge.set(i.$$N.ExtHostCommands,wt.get(y.$7Q)),vt=Ge.set(i.$$N.ExtHostTerminalService,wt.get(yt.$Drc)),Xt=Ge.set(i.$$N.ExtHostTerminalShellIntegration,wt.get(Ye.$Vsc)),Et=Ge.set(i.$$N.ExtHostDebugService,wt.get(b.$3rc)),si=Ge.set(i.$$N.ExtHostSearch,wt.get(ge.$rsc)),Zt=Ge.set(i.$$N.ExtHostTask,wt.get(it.$Usc)),Mi=Ge.set(i.$$N.ExtHostOutputService,wt.get(Me.$Hsc)),di=Ge.set(i.$$N.ExtHostLocalization,wt.get(Fe.$Nrc)),yi=Ge.set(i.$$N.ExtHostUrls,new Qe.$3sc(Ge)),qt=Ge.set(i.$$N.ExtHostDocuments,new j.$Zqc(Ge,Mt)),fi=Ge.set(i.$$N.ExtHostDocumentContentProviders,new G.$$rc(Ge,Mt,kt)),Fi=Ge.set(i.$$N.ExtHostDocumentSaveParticipant,new x.$_rc(kt,qt,Ge.getProxy(i.$0N.MainThreadBulkEdits))),Rt=Ge.set(i.$$N.ExtHostNotebook,new nt.$usc(Ge,Ct,Mt,qt,ti,si,kt)),Si=Ge.set(i.$$N.ExtHostNotebookDocuments,new $t.$Bsc(Rt)),Ai=Ge.set(i.$$N.ExtHostNotebookEditors,new ut.$Csc(kt,Rt)),gi=Ge.set(i.$$N.ExtHostNotebookKernels,new et.$Dsc(Ge,Dt,Rt,Ct,kt)),zi=Ge.set(i.$$N.ExtHostNotebookRenderers,new Le.$Fsc(Ge,Rt)),ji=Ge.set(i.$$N.ExtHostNotebookDocumentSaveParticipant,new ht.$Asc(kt,Rt,Ge.getProxy(i.$0N.MainThreadBulkEdits))),zt=Ge.set(i.$$N.ExtHostEditors,new pe.$9qc(Ge,Mt)),Pi=Ge.set(i.$$N.ExtHostTreeViews,new fe.$1sc(Ge.getProxy(i.$0N.MainThreadTreeViews),Ct,kt)),Di=Ge.set(i.$$N.ExtHostEditorInsets,new k.$0qc(Ge.getProxy(i.$0N.MainThreadEditorInsets),zt,Dt.remote)),wi=Ge.set(i.$$N.ExtHostDiagnostics,new A.$Yqc(Ge,kt,ei,Mt)),bi=Ge.set(i.$$N.ExtHostLanguages,new Pe.$ysc(Ge,qt,Ct.converter,Yt)),me=Ge.set(i.$$N.ExtHostLanguageFeatures,new V.$1qc(Ge,Yt,qt,Ct,wi,kt,Nt,Lt)),De=Ge.set(i.$$N.ExtHostFileSystem,new oe.$csc(Ge,me)),ce=Ge.set(i.$$N.ExtHostFileSystemEventService,new ue.$dsc(Ge,kt,Mt)),K=Ge.set(i.$$N.ExtHostQuickOpen,(0,Q.$Lsc)(Ge,bt,Ct)),ke=Ge.set(i.$$N.ExtHostSCM,new se.$Nsc(Ge,Ct,qt,kt)),We=Ge.set(i.$$N.ExtHostQuickDiff,new B.$Ksc(Ge,Yt)),Ze=Ge.set(i.$$N.ExtHostShare,new ze.$Osc(Ge,Yt)),Ue=Ge.set(i.$$N.ExtHostComments,(0,C.$$qc)(Ge,Ct,qt)),ot=Ge.set(i.$$N.ExtHostProgress,new W.$Jsc(Ge.getProxy(i.$0N.MainThreadProgress))),gt=Ge.set(i.$$N.ExtHostLabelService,new X.$wsc(Ge)),Kt=Ge.set(i.$$N.ExtHostTheming,new ye.$Xsc(Ge)),Vt=Ge.set(i.$$N.ExtHostTimeline,new Ce.$Zsc(Ge,Ct)),Wt=Ge.set(i.$$N.ExtHostWebviews,new st.$mrc(Ge,Dt.remote,bt,kt,Nt)),Li=Ge.set(i.$$N.ExtHostWebviewPanels,new dt.$prc(Ge,Wt,bt)),en=Ge.set(i.$$N.ExtHostCustomEditors,new $.$qrc(Ge,qt,li,Wt,Li)),Vi=Ge.set(i.$$N.ExtHostWebviewViews,new mt.$4sc(Ge,Wt)),Ei=Ge.set(i.$$N.ExtHostTesting,wt.get(he.$Xrc)),tn=Ge.set(i.$$N.ExtHostUriOpeners,new de.$2sc(Ge)),nn=Ge.set(i.$$N.ExtHostProfileContentHandlers,new Ne.$Isc(Ge));Ge.set(i.$$N.ExtHostInteractive,new Ie.$vsc(Ge,Rt,Mt,Ct,kt));const Ui=Ge.set(i.$$N.ExtHostChatAgents2,new f.$6qc(Ge,kt,Ct,qt)),rn=Ge.set(i.$$N.ExtHostChatVariables,new h.$7qc(Ge)),Bi=Ge.set(i.$$N.ExtHostLanguageModelTools,new re.$xsc(Ge)),Qi=Ge.set(i.$$N.ExtHostAiRelatedInformation,new n.$Rqc(Ge)),sn=Ge.set(i.$$N.ExtHostAiEmbeddingVector,new ae.$bsc(Ge)),on=Ge.set(i.$$N.ExtHostStatusBar,new _e.$Rsc(Ge,Ct.converter)),wn=Ge.set(i.$$N.ExtHostSpeech,new Je.$Psc(Ge)),Ci=Ge.set(i.$$N.ExtHostEmbeddings,new Z.$asc(Ge)),Ki=Object.values(i.$$N);Ge.assertRegistered(Ki);const bn=new g.$5qc(Ge,Mt),vn=new S.$8qc(Ge),Wi=new xe.$zsc(Ge,kt),an=new F.$0rc(Ge);return t.$2qc.register(Ct),function(Ae,mi,Hi){function lt(te){return(le,Oe,ft)=>{const Pt=te(Ft=>{try{le.call(Oe,Ft)}catch(Ti){D.$5(new Error(`[ExtensionListenerError] Extension '${Ae.identifier.value}' FAILED to handle event: ${Ti.toString()}`,{cause:Ti})),Lt.onExtensionError(Ae.identifier,Ti)}});return ft?.push(Pt),Pt}}const It=function(){let te=!Ae.isUnderDevelopment;function le(){te||(kt.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Oe(ft){if(Array.isArray(ft))ft.forEach(Oe);else if(typeof ft=="string")le();else{const Pt=ft;typeof Pt.scheme>"u"&&le(),typeof Pt.exclusive=="boolean"&&(0,Xe.$zH)(Ae,"documentFiltersExclusive")}return ft}}(),yn={getSession(te,le,Oe){return typeof Oe?.forceNewSession=="object"&&Oe.forceNewSession.learnMore&&(0,Xe.$zH)(Ae,"authLearnMore"),Gt.getSession(Ae,te,le,Oe)},getAccounts(te){return Gt.getAccounts(te)},async hasSession(te,le){return(0,Xe.$zH)(Ae,"authSession"),!!await Gt.getSession(Ae,te,le,{silent:!0})},get onDidChangeSessions(){return lt(Gt.onDidChangeSessions)},registerAuthenticationProvider(te,le,Oe,ft){return Gt.registerAuthenticationProvider(te,le,Oe,ft)}},Gi={registerCommand(te,le,Oe){return Ct.registerCommand(!0,te,le,Oe,void 0,Ae)},registerTextEditorCommand(te,le,Oe){return Ct.registerCommand(!0,te,(...ft)=>{const Pt=zt.getActiveTextEditor();if(!Pt){kt.warn("Cannot execute "+te+" because there is no active text editor.");return}return Pt.edit(Ft=>{le.apply(Oe,[Pt,Ft,...ft])}).then(Ft=>{Ft||kt.warn("Edits from command "+te+" were not applied.")},Ft=>{kt.warn("An error occurred while running command "+te,Ft)})},void 0,void 0,Ae)},registerDiffInformationCommand:(te,le,Oe)=>((0,Xe.$zH)(Ae,"diffCommand"),Ct.registerCommand(!0,te,async(...ft)=>{const Pt=Mt.activeEditor(!0);if(!Pt){kt.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ft=await zt.getDiffInformation(Pt.id);le.apply(Oe,[Ft,...ft])},void 0,void 0,Ae)),executeCommand(te,...le){return Ct.executeCommand(te,...le)},getCommands(te=!1){return Ct.getCommands(te)}},Ji={get machineId(){return Dt.telemetryInfo.machineId},get sessionId(){return Dt.telemetryInfo.sessionId},get language(){return Dt.environment.appLanguage},get appName(){return Dt.environment.appName},get appRoot(){return Dt.environment.appRoot?.fsPath??""},get appHost(){return Dt.environment.appHost},get uriScheme(){return Dt.environment.appUriScheme},get clipboard(){return vn.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return lt(vt.onDidChangeShell)},get isTelemetryEnabled(){return Lt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return lt(Lt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$zH)(Ae,"telemetry"),Lt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$zH)(Ae,"telemetry"),lt(Lt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,at.$4Q)(Dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,le){return at.$3Q.validateSender(te),Lt.instantiateLogger(Ae,te,le)},openExternal(te,le){return Bt.openUri(te,{allowTunneling:!!Dt.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Dt.environment.appUriScheme)return yi.createAppUri(te);try{return await Bt.asExternalUri(te,{allowTunneling:!!Dt.remote.authority})}catch(le){if((0,R.$Tg)(te,R.Schemas.http)||(0,R.$Tg)(te,R.Schemas.https))return te;throw le}},get remoteName(){return(0,l.$on)(Dt.remote.authority)},get remoteAuthority(){return(0,Xe.$zH)(Ae,"resolvers"),Dt.remote.authority},get uiKind(){return Dt.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return lt(kt.onDidChangeLogLevel)},get appQuality(){return(0,Xe.$zH)(Ae,"resolvers"),Dt.quality},get appCommit(){return(0,Xe.$zH)(Ae,"resolvers"),Dt.commit}};Dt.environment.extensionTestsLocationURI||Object.freeze(Ji);const ki={createTestController(te,le,Oe){return Ei.createTestController(Ae,te,le,Oe)},createTestObserver(){return(0,Xe.$zH)(Ae,"testObserver"),Ei.createTestObserver()},runTests(te){return(0,Xe.$zH)(Ae,"testObserver"),Ei.runTests(te)},registerTestFollowupProvider(te){return(0,Xe.$zH)(Ae,"testObserver"),Ei.registerTestFollowupProvider(te)},get onDidChangeTestResults(){return(0,Xe.$zH)(Ae,"testObserver"),lt(Ei.onResultsChanged)},get testResults(){return(0,Xe.$zH)(Ae,"testObserver"),Ei.results}},Ri=Dt.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,Sn={getExtension(te,le){(0,Xe.$yH)(Ae,"extensionsAny")||(le=!1);const Oe=mi.mine.getExtensionDescription(te);if(Oe)return new ee.$Trc(Ht,Ae.identifier,Oe,Ri,!1);if(le){const ft=mi.all.getExtensionDescription(te);if(ft)return new ee.$Trc(Ht,Ae.identifier,ft,Ri,!0)}},get all(){const te=[];for(const le of mi.mine.getAllExtensionDescriptions())te.push(new ee.$Trc(Ht,Ae.identifier,le,Ri,!1));return te},get allAcrossExtensionHosts(){(0,Xe.$zH)(Ae,"extensionsAny");const te=new E.$yn(mi.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),le=[];for(const Oe of mi.all.getAllExtensionDescriptions()){const ft=!te.has(Oe.identifier);le.push(new ee.$Trc(Ht,Ae.identifier,Oe,Ri,ft))}return le},get onDidChange(){return(0,Xe.$yH)(Ae,"extensionsAny")?lt(P.Event.any(mi.mine.onDidChange,mi.all.onDidChange)):lt(mi.mine.onDidChange)}},pi={createDiagnosticCollection(te){return wi.createDiagnosticCollection(Ae.identifier,te)},get onDidChangeDiagnostics(){return lt(wi.onDidChangeDiagnostics)},getDiagnostics:te=>wi.getDiagnostics(te),getLanguages(){return bi.getLanguages()},setTextDocumentLanguage(te,le){return bi.changeLanguage(te.uri,le)},match(te,le){const Oe=Y.LanguageSelector.from(te);let ft;return(0,I.$Fu)(Oe)&&(ft=Rt.notebookDocuments.find(Pt=>Pt.apiNotebook.getCells().find(Ft=>Ft.document===le))?.apiNotebook),(0,I.$Eu)(Oe,le.uri,le.languageId,!0,ft?.uri,ft?.notebookType)},registerCodeActionsProvider(te,le,Oe){return me.registerCodeActionProvider(Ae,It(te),le,Oe)},registerDocumentPasteEditProvider(te,le,Oe){return(0,Xe.$zH)(Ae,"documentPaste"),me.registerDocumentPasteEditProvider(Ae,It(te),le,Oe)},registerCodeLensProvider(te,le){return me.registerCodeLensProvider(Ae,It(te),le)},registerDefinitionProvider(te,le){return me.registerDefinitionProvider(Ae,It(te),le)},registerDeclarationProvider(te,le){return me.registerDeclarationProvider(Ae,It(te),le)},registerImplementationProvider(te,le){return me.registerImplementationProvider(Ae,It(te),le)},registerTypeDefinitionProvider(te,le){return me.registerTypeDefinitionProvider(Ae,It(te),le)},registerHoverProvider(te,le){return me.registerHoverProvider(Ae,It(te),le,Ae.identifier)},registerEvaluatableExpressionProvider(te,le){return me.registerEvaluatableExpressionProvider(Ae,It(te),le,Ae.identifier)},registerInlineValuesProvider(te,le){return me.registerInlineValuesProvider(Ae,It(te),le,Ae.identifier)},registerDocumentHighlightProvider(te,le){return me.registerDocumentHighlightProvider(Ae,It(te),le)},registerMultiDocumentHighlightProvider(te,le){return me.registerMultiDocumentHighlightProvider(Ae,It(te),le)},registerLinkedEditingRangeProvider(te,le){return me.registerLinkedEditingRangeProvider(Ae,It(te),le)},registerReferenceProvider(te,le){return me.registerReferenceProvider(Ae,It(te),le)},registerRenameProvider(te,le){return me.registerRenameProvider(Ae,It(te),le)},registerNewSymbolNamesProvider(te,le){return(0,Xe.$zH)(Ae,"newSymbolNamesProvider"),me.registerNewSymbolNamesProvider(Ae,It(te),le)},registerDocumentSymbolProvider(te,le,Oe){return me.registerDocumentSymbolProvider(Ae,It(te),le,Oe)},registerWorkspaceSymbolProvider(te){return me.registerWorkspaceSymbolProvider(Ae,te)},registerDocumentFormattingEditProvider(te,le){return me.registerDocumentFormattingEditProvider(Ae,It(te),le)},registerDocumentRangeFormattingEditProvider(te,le){return me.registerDocumentRangeFormattingEditProvider(Ae,It(te),le)},registerOnTypeFormattingEditProvider(te,le,Oe,...ft){return me.registerOnTypeFormattingEditProvider(Ae,It(te),le,[Oe].concat(ft))},registerDocumentSemanticTokensProvider(te,le,Oe){return me.registerDocumentSemanticTokensProvider(Ae,It(te),le,Oe)},registerDocumentRangeSemanticTokensProvider(te,le,Oe){return me.registerDocumentRangeSemanticTokensProvider(Ae,It(te),le,Oe)},registerSignatureHelpProvider(te,le,Oe,...ft){return typeof Oe=="object"?me.registerSignatureHelpProvider(Ae,It(te),le,Oe):me.registerSignatureHelpProvider(Ae,It(te),le,typeof Oe>"u"?[]:[Oe,...ft])},registerCompletionItemProvider(te,le,...Oe){return me.registerCompletionItemProvider(Ae,It(te),le,Oe)},registerInlineCompletionItemProvider(te,le,Oe){return le.handleDidShowCompletionItem&&(0,Xe.$zH)(Ae,"inlineCompletionsAdditions"),le.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$zH)(Ae,"inlineCompletionsAdditions"),Oe&&(0,Xe.$zH)(Ae,"inlineCompletionsAdditions"),me.registerInlineCompletionsProvider(Ae,It(te),le,Oe)},registerInlineEditProvider(te,le){return(0,Xe.$zH)(Ae,"inlineEdit"),me.registerInlineEditProvider(Ae,It(te),le)},registerDocumentLinkProvider(te,le){return me.registerDocumentLinkProvider(Ae,It(te),le)},registerColorProvider(te,le){return me.registerColorProvider(Ae,It(te),le)},registerFoldingRangeProvider(te,le){return me.registerFoldingRangeProvider(Ae,It(te),le)},registerSelectionRangeProvider(te,le){return me.registerSelectionRangeProvider(Ae,te,le)},registerCallHierarchyProvider(te,le){return me.registerCallHierarchyProvider(Ae,te,le)},registerTypeHierarchyProvider(te,le){return me.registerTypeHierarchyProvider(Ae,te,le)},setLanguageConfiguration:(te,le)=>me.setLanguageConfiguration(Ae,te,le),getTokenInformationAtPosition(te,le){return(0,Xe.$zH)(Ae,"tokenInformation"),bi.tokenAtPosition(te,le)},registerInlayHintsProvider(te,le){return me.registerInlayHintsProvider(Ae,te,le)},createLanguageStatusItem(te,le){return bi.createLanguageStatusItem(Ae,te,le)},registerDocumentDropEditProvider(te,le,Oe){return me.registerDocumentOnDropEditProvider(Ae,te,le,(0,Xe.$yH)(Ae,"documentPaste")?Oe:void 0)}},qi={get activeTextEditor(){return zt.getActiveTextEditor()},get visibleTextEditors(){return zt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(te,le,Oe){m.URI.isUri(te)&&te.scheme===R.Schemas.vscodeRemote&&!te.authority&&Nt.report("workspace.showTextDocument",Ae,"A URI of 'vscode-remote' scheme requires an authority.");const ft=await(m.URI.isUri(te)?Promise.resolve(Xi.openTextDocument(te)):Promise.resolve(te));return zt.showTextDocument(ft,le,Oe)},createTextEditorDecorationType(te){return zt.createTextEditorDecorationType(Ae,te)},onDidChangeActiveTextEditor(te,le,Oe){return lt(zt.onDidChangeActiveTextEditor)(te,le,Oe)},onDidChangeVisibleTextEditors(te,le,Oe){return lt(zt.onDidChangeVisibleTextEditors)(te,le,Oe)},onDidChangeTextEditorSelection(te,le,Oe){return lt(zt.onDidChangeTextEditorSelection)(te,le,Oe)},onDidChangeTextEditorOptions(te,le,Oe){return lt(zt.onDidChangeTextEditorOptions)(te,le,Oe)},onDidChangeTextEditorVisibleRanges(te,le,Oe){return lt(zt.onDidChangeTextEditorVisibleRanges)(te,le,Oe)},onDidChangeTextEditorViewColumn(te,le,Oe){return lt(zt.onDidChangeTextEditorViewColumn)(te,le,Oe)},onDidCloseTerminal(te,le,Oe){return lt(vt.onDidCloseTerminal)(te,le,Oe)},onDidOpenTerminal(te,le,Oe){return lt(vt.onDidOpenTerminal)(te,le,Oe)},onDidChangeActiveTerminal(te,le,Oe){return lt(vt.onDidChangeActiveTerminal)(te,le,Oe)},onDidChangeTerminalDimensions(te,le,Oe){return(0,Xe.$zH)(Ae,"terminalDimensions"),lt(vt.onDidChangeTerminalDimensions)(te,le,Oe)},onDidChangeTerminalState(te,le,Oe){return lt(vt.onDidChangeTerminalState)(te,le,Oe)},onDidWriteTerminalData(te,le,Oe){return(0,Xe.$zH)(Ae,"terminalDataWriteEvent"),lt(vt.onDidWriteTerminalData)(te,le,Oe)},onDidExecuteTerminalCommand(te,le,Oe){return(0,Xe.$zH)(Ae,"terminalExecuteCommandEvent"),lt(vt.onDidExecuteTerminalCommand)(te,le,Oe)},onDidChangeTerminalShellIntegration(te,le,Oe){return lt(Xt.onDidChangeTerminalShellIntegration)(te,le,Oe)},onDidStartTerminalShellExecution(te,le,Oe){return lt(Xt.onDidStartTerminalShellExecution)(te,le,Oe)},onDidEndTerminalShellExecution(te,le,Oe){return lt(Xt.onDidEndTerminalShellExecution)(te,le,Oe)},get state(){return Bt.getState()},onDidChangeWindowState(te,le,Oe){return lt(Bt.onDidChangeWindowState)(te,le,Oe)},showInformationMessage(te,...le){return Wi.showMessage(Ae,O.default.Info,te,le[0],le.slice(1))},showWarningMessage(te,...le){return Wi.showMessage(Ae,O.default.Warning,te,le[0],le.slice(1))},showErrorMessage(te,...le){return Wi.showMessage(Ae,O.default.Error,te,le[0],le.slice(1))},showQuickPick(te,le,Oe){return K.showQuickPick(Ae,te,le,Oe)},showWorkspaceFolderPick(te){return K.showWorkspaceFolderPick(te)},showInputBox(te,le){return K.showInput(te,le)},showOpenDialog(te){return an.showOpenDialog(Ae,te)},showSaveDialog(te){return an.showSaveDialog(te)},createStatusBarItem(te,le,Oe){let ft,Pt,Ft;return typeof te=="string"?(ft=te,Pt=le,Ft=Oe):(Pt=te,Ft=le),on.createStatusBarEntry(Ae,ft,Pt,Ft)},setStatusBarMessage(te,le){return on.setStatusBarMessage(te,le)},withScmProgress(te){return Nt.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),ot.withProgress(Ae,{location:q.ProgressLocation.SourceControl},(le,Oe)=>te({report(ft){}}))},withProgress(te,le){return ot.withProgress(Ae,te,le)},createOutputChannel(te,le){return Mi.createOutputChannel(te,le,Ae)},createWebviewPanel(te,le,Oe,ft){return Li.createWebviewPanel(Ae,te,le,Oe,ft)},createWebviewTextEditorInset(te,le,Oe,ft){return(0,Xe.$zH)(Ae,"editorInsets"),Di.createWebviewEditorInset(te,le,Oe,ft,Ae)},createTerminal(te,le,Oe){return typeof te=="object"?"pty"in te?vt.createExtensionTerminal(te):vt.createTerminalFromOptions(te):vt.createTerminal(te,le,Oe)},registerTerminalLinkProvider(te){return vt.registerLinkProvider(te)},registerTerminalProfileProvider(te,le){return vt.registerProfileProvider(Ae,te,le)},registerTerminalQuickFixProvider(te,le){return(0,Xe.$zH)(Ae,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(te,Ae.identifier.value,le)},registerTreeDataProvider(te,le){return Pi.registerTreeDataProvider(te,le,Ae)},createTreeView(te,le){return Pi.createTreeView(te,le,Ae)},registerWebviewPanelSerializer:(te,le)=>Li.registerWebviewPanelSerializer(Ae,te,le),registerCustomEditorProvider:(te,le,Oe={})=>en.registerCustomEditorProvider(Ae,te,le,Oe),registerFileDecorationProvider(te){return ui.registerFileDecorationProvider(te,Ae)},registerUriHandler(te){return yi.registerUriHandler(Ae,te)},createQuickPick(){return K.createQuickPick(Ae)},createInputBox(){return K.createInputBox(Ae)},get activeColorTheme(){return Kt.activeColorTheme},onDidChangeActiveColorTheme(te,le,Oe){return lt(Kt.onDidChangeActiveColorTheme)(te,le,Oe)},registerWebviewViewProvider(te,le,Oe){return Vi.registerWebviewViewProvider(Ae,te,le,Oe?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,le,Oe){return lt(Rt.onDidChangeActiveNotebookEditor)(te,le,Oe)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return lt(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(te,le,Oe){return lt(Ai.onDidChangeNotebookEditorSelection)(te,le,Oe)},onDidChangeNotebookEditorVisibleRanges(te,le,Oe){return lt(Ai.onDidChangeNotebookEditorVisibleRanges)(te,le,Oe)},showNotebookDocument(te,le){return Rt.showNotebookDocument(te,le)},registerExternalUriOpener(te,le,Oe){return(0,Xe.$zH)(Ae,"externalUriOpener"),tn.registerExternalUriOpener(Ae.identifier,te,le,Oe)},registerProfileContentHandler(te,le){return(0,Xe.$zH)(Ae,"profileContentHandlers"),nn.registerProfileContentHandler(Ae,te,le)},registerQuickDiffProvider(te,le,Oe,ft){return(0,Xe.$zH)(Ae,"quickDiffProvider"),We.registerQuickDiffProvider(It(te),le,Oe,ft)},get tabGroups(){return ni.tabGroups},registerShareProvider(te,le){return(0,Xe.$zH)(Ae,"shareProvider"),Ze.registerShareProvider(It(te),le)}},Xi={get rootPath(){return Nt.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),bt.getPath()},set rootPath(te){throw new D.$ab("rootPath")},getWorkspaceFolder(te){return bt.getWorkspaceFolder(te)},get workspaceFolders(){return bt.getWorkspaceFolders()},get name(){return bt.name},set name(te){throw new D.$ab("name")},get workspaceFile(){return bt.workspaceFile},set workspaceFile(te){throw new D.$ab("workspaceFile")},updateWorkspaceFolders:(te,le,...Oe)=>bt.updateWorkspaceFolders(Ae,te,le||0,...Oe),onDidChangeWorkspaceFolders:function(te,le,Oe){return lt(bt.onDidChangeWorkspace)(te,le,Oe)},asRelativePath:(te,le)=>bt.getRelativePath(te,le),findFiles:(te,le,Oe,ft)=>bt.findFiles(te,le,Oe,Ae.identifier,ft),findFiles2:(te,le,Oe)=>((0,Xe.$zH)(Ae,"findFiles2"),bt.findFiles2(te,le,Ae.identifier,Oe)),findFiles2New:(te,le,Oe)=>((0,Xe.$zH)(Ae,"findFiles2New"),bt.findFiles2New(te,le,Ae.identifier,Oe)),findTextInFiles:(te,le,Oe,ft)=>{(0,Xe.$zH)(Ae,"findTextInFiles");let Pt,Ft;return typeof le=="object"?(Pt=le,Ft=Oe):(Pt={},Ft=le,ft=Oe),bt.findTextInFiles(te,Pt||{},Ft,Ae.identifier,ft)},findTextInFilesNew:(te,le,Oe)=>((0,Xe.$zH)(Ae,"findTextInFilesNew"),(0,Xe.$zH)(Ae,"textSearchProviderNew"),bt.findTextInFilesNew(te,Ae.identifier,le||{},Oe)),save:te=>bt.save(te),saveAs:te=>bt.saveAs(te),saveAll:te=>bt.saveAll(te),applyEdit(te,le){return bn.applyWorkspaceEdit(te,Ae,le)},createFileSystemWatcher:(te,le,Oe,ft)=>{let Pt;return typeof le=="boolean"?Pt={ignoreCreateEvents:!!le,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!ft,correlate:!1}:le&&((0,Xe.$zH)(Ae,"createFileSystemWatcher"),Pt={...le,correlate:!0}),ce.createFileSystemWatcher(bt,Ae,te,Pt)},get textDocuments(){return qt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new D.$ab("textDocuments")},openTextDocument(te){let le;const Oe=te;if(typeof te=="string")le=Promise.resolve(m.URI.file(te));else if(m.URI.isUri(te))le=Promise.resolve(te);else if(!Oe||typeof Oe=="object")le=qt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(ft=>(kt.trace(`openTextDocument from ${Ae.identifier}`),ft.scheme===R.Schemas.vscodeRemote&&!ft.authority&&Nt.report("workspace.openTextDocument",Ae,"A URI of 'vscode-remote' scheme requires an authority."),qt.ensureDocumentData(ft).then(Pt=>Pt.document)))},onDidOpenTextDocument:(te,le,Oe)=>lt(qt.onDidAddDocument)(te,le,Oe),onDidCloseTextDocument:(te,le,Oe)=>lt(qt.onDidRemoveDocument)(te,le,Oe),onDidChangeTextDocument:(te,le,Oe)=>lt(qt.onDidChangeDocument)(te,le,Oe),onDidSaveTextDocument:(te,le,Oe)=>lt(qt.onDidSaveDocument)(te,le,Oe),onWillSaveTextDocument:(te,le,Oe)=>lt(Fi.getOnWillSaveTextDocumentEvent(Ae))(te,le,Oe),get notebookDocuments(){return Rt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,le){let Oe;if(m.URI.isUri(te))Oe=te,await Rt.openNotebookDocument(te);else if(typeof te=="string")Oe=m.URI.revive(await Rt.createNotebookDocument({viewType:te,content:le}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(te,le,Oe){return lt(Si.onDidSaveNotebookDocument)(te,le,Oe)},onDidChangeNotebookDocument(te,le,Oe){return lt(Si.onDidChangeNotebookDocument)(te,le,Oe)},onWillSaveNotebookDocument(te,le,Oe){return lt(ji.getOnWillSaveNotebookDocumentEvent(Ae))(te,le,Oe)},get onDidOpenNotebookDocument(){return lt(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return lt(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(te,le,Oe,ft){return Rt.registerNotebookSerializer(Ae,te,le,Oe,(0,Xe.$yH)(Ae,"notebookLiveShare")?ft:void 0)},onDidChangeConfiguration:(te,le,Oe)=>lt(Hi.onDidChangeConfiguration)(te,le,Oe),getConfiguration(te,le){return le=arguments.length===1?void 0:le,Hi.getConfiguration(te,le,Ae)},registerTextDocumentContentProvider(te,le){return fi.registerTextDocumentContentProvider(te,le)},registerTaskProvider:(te,le)=>(Nt.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),Zt.registerTaskProvider(Ae,te,le)),registerFileSystemProvider(te,le,Oe){return(0,L.$Wc)(De.registerFileSystemProvider(Ae,te,le,Oe),ti.addFileSystemProvider(te,le,Oe))},get fs(){return ti.value},registerFileSearchProvider:(te,le)=>((0,Xe.$zH)(Ae,"fileSearchProvider"),si.registerFileSearchProviderOld(te,le)),registerTextSearchProvider:(te,le)=>((0,Xe.$zH)(Ae,"textSearchProvider"),si.registerTextSearchProviderOld(te,le)),registerAITextSearchProvider:(te,le)=>((0,Xe.$zH)(Ae,"aiTextSearchProvider"),(0,Xe.$zH)(Ae,"textSearchProvider"),si.registerAITextSearchProviderOld(te,le)),registerFileSearchProviderNew:(te,le)=>((0,Xe.$zH)(Ae,"fileSearchProviderNew"),si.registerFileSearchProvider(te,le)),registerTextSearchProviderNew:(te,le)=>((0,Xe.$zH)(Ae,"textSearchProviderNew"),si.registerTextSearchProvider(te,le)),registerAITextSearchProviderNew:(te,le)=>((0,Xe.$zH)(Ae,"aiTextSearchProviderNew"),(0,Xe.$zH)(Ae,"textSearchProviderNew"),si.registerAITextSearchProvider(te,le)),registerRemoteAuthorityResolver:(te,le)=>((0,Xe.$zH)(Ae,"resolvers"),Ht.registerRemoteAuthorityResolver(te,le)),registerResourceLabelFormatter:te=>((0,Xe.$zH)(Ae,"resolvers"),gt.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Xe.$zH)(Ae,"resolvers"),Ht.getRemoteExecServer(te)),onDidCreateFiles:(te,le,Oe)=>lt(ce.onDidCreateFile)(te,le,Oe),onDidDeleteFiles:(te,le,Oe)=>lt(ce.onDidDeleteFile)(te,le,Oe),onDidRenameFiles:(te,le,Oe)=>lt(ce.onDidRenameFile)(te,le,Oe),onWillCreateFiles:(te,le,Oe)=>lt(ce.getOnWillCreateFileEvent(Ae))(te,le,Oe),onWillDeleteFiles:(te,le,Oe)=>lt(ce.getOnWillDeleteFileEvent(Ae))(te,le,Oe),onWillRenameFiles:(te,le,Oe)=>lt(ce.getOnWillRenameFileEvent(Ae))(te,le,Oe),openTunnel:te=>((0,Xe.$zH)(Ae,"tunnels"),jt.openTunnel(Ae,te).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,Xe.$zH)(Ae,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(te,le,Oe)=>((0,Xe.$zH)(Ae,"tunnels"),lt(jt.onDidChangeTunnels)(te,le,Oe)),registerPortAttributesProvider:(te,le)=>((0,Xe.$zH)(Ae,"portsAttributes"),jt.registerPortsAttributesProvider(te,le)),registerTunnelProvider:(te,le)=>((0,Xe.$zH)(Ae,"tunnelFactory"),jt.registerTunnelProvider(te,le)),registerTimelineProvider:(te,le)=>((0,Xe.$zH)(Ae,"timeline"),Vt.registerTimelineProvider(te,le,Ae.identifier,Ct.converter)),get isTrusted(){return bt.trusted},requestWorkspaceTrust:te=>((0,Xe.$zH)(Ae,"workspaceTrust"),bt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,le,Oe)=>lt(bt.onDidGrantWorkspaceTrust)(te,le,Oe),registerEditSessionIdentityProvider:(te,le)=>((0,Xe.$zH)(Ae,"editSessionIdentityProvider"),bt.registerEditSessionIdentityProvider(te,le)),onWillCreateEditSessionIdentity:(te,le,Oe)=>((0,Xe.$zH)(Ae,"editSessionIdentityProvider"),lt(bt.getOnWillCreateEditSessionIdentityEvent(Ae))(te,le,Oe)),registerCanonicalUriProvider:(te,le)=>((0,Xe.$zH)(Ae,"canonicalUriProvider"),bt.registerCanonicalUriProvider(te,le)),getCanonicalUri:(te,le,Oe)=>((0,Xe.$zH)(Ae,"canonicalUriProvider"),bt.provideCanonicalUri(te,le,Oe))},cn={get inputBox(){return Nt.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),ke.getLastInputBox(Ae)},createSourceControl(te,le,Oe){return ke.createSourceControl(Ae,te,le,Oe)}},ln={createCommentController(te,le){return Ue.createCommentController(Ae,te,le)}},un={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){return Et.activeStackItem},registerDebugVisualizationProvider(te,le){return(0,Xe.$zH)(Ae,"debugVisualization"),Et.registerDebugVisualizationProvider(Ae,te,le)},registerDebugVisualizationTreeProvider(te,le){return(0,Xe.$zH)(Ae,"debugVisualization"),Et.registerDebugVisualizationTree(Ae,te,le)},onDidStartDebugSession(te,le,Oe){return lt(Et.onDidStartDebugSession)(te,le,Oe)},onDidTerminateDebugSession(te,le,Oe){return lt(Et.onDidTerminateDebugSession)(te,le,Oe)},onDidChangeActiveDebugSession(te,le,Oe){return lt(Et.onDidChangeActiveDebugSession)(te,le,Oe)},onDidReceiveDebugSessionCustomEvent(te,le,Oe){return lt(Et.onDidReceiveDebugSessionCustomEvent)(te,le,Oe)},onDidChangeBreakpoints(te,le,Oe){return lt(Et.onDidChangeBreakpoints)(te,le,Oe)},onDidChangeActiveStackItem(te,le,Oe){return lt(Et.onDidChangeActiveStackItem)(te,le,Oe)},registerDebugConfigurationProvider(te,le,Oe){return Et.registerDebugConfigurationProvider(te,le,Oe||Qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,le){return Et.registerDebugAdapterDescriptorFactory(Ae,te,le)},registerDebugAdapterTrackerFactory(te,le){return Et.registerDebugAdapterTrackerFactory(te,le)},startDebugging(te,le,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?Et.startDebugging(te,le,{parentSession:Oe}):Et.startDebugging(te,le,Oe||{})},stopDebugging(te){return Et.stopDebugging(te)},addBreakpoints(te){return Et.addBreakpoints(te)},removeBreakpoints(te){return Et.removeBreakpoints(te)},asDebugSourceUri(te,le){return Et.asDebugSourceUri(te,le)}},En={registerTaskProvider:(te,le)=>Zt.registerTaskProvider(Ae,te,le),fetchTasks:te=>Zt.fetchTasks(te),executeTask:te=>Zt.executeTask(Ae,te),get taskExecutions(){return Zt.taskExecutions},onDidStartTask:(te,le,Oe)=>lt(Zt.onDidStartTask)(te,le,Oe),onDidEndTask:(te,le,Oe)=>lt(Zt.onDidEndTask)(te,le,Oe),onDidStartTaskProcess:(te,le,Oe)=>lt(Zt.onDidStartTaskProcess)(te,le,Oe),onDidEndTaskProcess:(te,le,Oe)=>lt(Zt.onDidEndTaskProcess)(te,le,Oe)},hn={createNotebookController(te,le,Oe,ft,Pt){return gi.createNotebookController(Ae,te,le,Oe,ft,(0,Xe.$yH)(Ae,"notebookMessaging")?Pt:void 0)},registerNotebookCellStatusBarItemProvider:(te,le)=>Rt.registerNotebookCellStatusBarItemProvider(Ae,te,le),createRendererMessaging(te){return zi.createRendererMessaging(Ae,te)},createNotebookControllerDetectionTask(te){return(0,Xe.$zH)(Ae,"notebookKernelSource"),gi.createNotebookControllerDetectionTask(Ae,te)},registerKernelSourceActionProvider(te,le){return(0,Xe.$zH)(Ae,"notebookKernelSource"),gi.registerKernelSourceActionProvider(Ae,te,le)},onDidChangeNotebookCellExecutionState(te,le,Oe){return(0,Xe.$zH)(Ae,"notebookCellExecutionState"),lt(gi.onDidChangeNotebookCellExecutionState)(te,le,Oe)}},dn={t(...te){if(typeof te[0]=="string"){const le=te.shift(),Oe=!te||typeof te[0]!="object"?te:te[0];return di.getMessage(Ae.identifier.value,{message:le,args:Oe})}return di.getMessage(Ae.identifier.value,te[0])},get bundle(){return di.getBundle(Ae.identifier.value)},get uri(){return di.getBundleUri(Ae.identifier.value)}},kn={transferActiveChat(te){return(0,Xe.$zH)(Ae,"interactive"),Ui.transferActiveChat(te)}},In={getRelatedInformation(te,le){return(0,Xe.$zH)(Ae,"aiRelatedInformation"),Qi.getRelatedInformation(Ae,te,le)},registerRelatedInformationProvider(te,le){return(0,Xe.$zH)(Ae,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Ae,te,le)},registerEmbeddingVectorProvider(te,le){return(0,Xe.$zH)(Ae,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(Ae,te,le)}},fn={registerChatResponseProvider(te,le,Oe){return(0,Xe.$zH)(Ae,"chatProvider"),Jt.registerLanguageModel(Ae,te,le,Oe)},registerChatVariableResolver(te,le,Oe,ft,Pt,Ft,Ti,Zi){return(0,Xe.$zH)(Ae,"chatVariableResolver"),rn.registerVariableResolver(Ae,te,le,Oe,ft,Pt,Ft,Ti,Zi?.id)},registerMappedEditsProvider(te,le){return(0,Xe.$zH)(Ae,"mappedEditsProvider"),me.registerMappedEditsProvider(Ae,te,le)},createChatParticipant(te,le){return Ui.createChatAgent(Ae,te,le)},createDynamicChatParticipant(te,le,Oe){return(0,Xe.$zH)(Ae,"chatParticipantPrivate"),Ui.createDynamicChatAgent(Ae,te,le,Oe)},registerChatParticipantDetectionProvider(te){return(0,Xe.$zH)(Ae,"chatParticipantAdditions"),Ui.registerChatParticipantDetectionProvider(te)}},Yi={selectChatModels:te=>Jt.selectLanguageModels(Ae,te??{}),onDidChangeChatModels:(te,le,Oe)=>Jt.onDidChangeProviders(te,le,Oe),registerChatModelProvider:(te,le,Oe)=>((0,Xe.$zH)(Ae,"chatProvider"),Jt.registerLanguageModel(Ae,te,le,Oe)),get embeddingModels(){return(0,Xe.$zH)(Ae,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(te,le,Oe)=>((0,Xe.$zH)(Ae,"embeddings"),Ci.onDidChange(te,le,Oe)),registerEmbeddingsProvider(te,le){return(0,Xe.$zH)(Ae,"embeddings"),Ci.registerEmbeddingsProvider(Ae,te,le)},async computeEmbeddings(te,le,Oe){return(0,Xe.$zH)(Ae,"embeddings"),Ci.computeEmbeddings(te,le,Oe)},registerTool(te,le){return(0,Xe.$zH)(Ae,"lmTools"),Bi.registerTool(Ae,te,le)},invokeTool(te,le,Oe){return(0,Xe.$zH)(Ae,"lmTools"),Bi.invokeTool(te,le,Oe)},get tools(){return(0,Xe.$zH)(Ae,"lmTools"),Bi.tools}},gn={registerSpeechProvider(te,le){return(0,Xe.$zH)(Ae,"speech"),wn.registerProvider(Ae.identifier,te,le)}};return{version:Dt.version,ai:In,authentication:yn,commands:Gi,comments:ln,chat:fn,debug:un,env:Ji,extensions:Sn,interactive:kn,l10n:dn,languages:pi,lm:Yi,notebooks:hn,scm:cn,speech:gn,tasks:En,tests:ki,window:qi,workspace:Xi,Breakpoint:q.$cP,TerminalOutputAnchor:q.TerminalOutputAnchor,ChatResultFeedbackKind:q.ChatResultFeedbackKind,ChatVariableLevel:q.ChatVariableLevel,ChatCompletionItem:q.$$P,CallHierarchyIncomingCall:q.$AO,CallHierarchyItem:q.$zO,CallHierarchyOutgoingCall:q.$BO,CancellationError:D.$9,CancellationTokenSource:v.$Be,CandidatePortSource:i.CandidatePortSource,CodeAction:q.$wO,CodeActionKind:q.$xO,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.$CO,Color:q.$PO,ColorInformation:q.$QO,ColorPresentation:q.$RO,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentState:q.CommentState,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CommentThreadApplicability:q.CommentThreadApplicability,CommentThreadFocus:q.CommentThreadFocus,CompletionItem:q.$JO,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.$KO,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.$ZO,DebugAdapterExecutable:q.$gP,DebugAdapterInlineImplementation:q.$jP,DebugAdapterNamedPipeServer:q.$iP,DebugAdapterServer:q.$hP,DebugConfigurationProviderTriggerKind:Qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DebugVisualization:q.$zP,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.$pO,DiagnosticRelatedInformation:q.$oO,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.$_N,DocumentHighlight:q.$sO,DocumentHighlightKind:q.DocumentHighlightKind,MultiDocumentHighlight:q.$tO,DocumentLink:q.$OO,DocumentSymbol:q.$vO,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.$mP,InlineValueText:q.$nP,InlineValueVariableLookup:q.$oP,InlineValueEvaluatableExpression:q.$pP,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:P.$qe,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.$BP,FileDecoration2:q.$BP,FileSystemError:q.$sP,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:q.$tP,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.$eP,InlineCompletionItem:q.$LO,InlineCompletionList:q.$MO,Hover:q.$qO,VerboseHover:q.$rO,HoverVerbosityAction:q.HoverVerbosityAction,IndentAction:w.IndentAction,Location:q.$nO,MarkdownString:q.$DO,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:q.$EO,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.$aO,ProcessExecution:q.$XO,ProgressLocation:q.ProgressLocation,QuickInputButtonLocation:q.QuickInputButtonLocation,QuickInputButtons:q.$AP,Range:q.$bO,RelativePattern:q.$aP,Selection:q.$cO,SelectionRange:q.$yO,SemanticTokens:q.$wP,SemanticTokensBuilder:q.$vP,SemanticTokensEdit:q.$xP,SemanticTokensEdits:q.$yP,SemanticTokensLegend:q.$uP,ShellExecution:q.$YO,ShellQuoting:q.ShellQuoting,SignatureHelp:q.$GO,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.$FO,SnippetString:q.$mO,SourceBreakpoint:q.$dP,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.$uO,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.$1O,TaskGroup:q.$WO,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.$SO,TerminalQuickFixTerminalCommand:q.$UO,TerminalQuickFixOpener:q.$TO,TerminalLocation:q.TerminalLocation,TerminalProfile:q.$VO,TerminalExitReason:q.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:q.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.$iO,SnippetTextEdit:q.$kO,TextEditorCursorStyle:s.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,SyntaxTokenType:q.SyntaxTokenType,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.$_O,ThemeIcon:q.$$O,TreeItem:q.$2O,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.$YP,UIKind:_t.UIKind,Uri:m.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.$lO,DocumentPasteTriggerKind:q.DocumentPasteTriggerKind,DocumentDropEdit:q.$8O,DocumentDropOrPasteEditKind:q.$9O,DocumentPasteEdit:q.$0O,InlayHint:q.$IO,InlayHintLabelPart:q.$HO,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.$hO,ResolvedAuthority:q.$fO,ManagedResolvedAuthority:q.$gO,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.$LP,NotebookRange:q.$DP,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.$EP,NotebookData:q.$FP,NotebookRendererScript:q.$JP,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.$HP,NotebookCellOutputItem:q.$GP,NotebookCellStatusBarItem:q.$IP,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.$jO,NotebookKernelSourceAction:q.$KP,NotebookVariablesRequestKind:q.NotebookVariablesRequestKind,PortAttributes:q.$NP,LinkedEditingRanges:q.$MP,TestResultState:q.TestResultState,TestRunRequest:q.$OP,TestMessage:q.$PP,TestMessageStackFrame:q.$RP,TestTag:q.$QP,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:At.TextSearchCompleteMessageType,DataTransfer:q.$7O,DataTransferItem:q.$3O,TestCoverageCount:q.$SP,FileCoverage:q.$UP,FileCoverage2:q.$UP,StatementCoverage:q.$VP,BranchCoverage:q.$WP,DeclarationCoverage:q.$XP,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.$ZP,TabInputTextDiff:q.$1P,TabInputTextMerge:q.$2P,TabInputCustom:q.$3P,TabInputNotebook:q.$5P,TabInputNotebookDiff:q.$6P,TabInputWebview:q.$4P,TabInputTerminal:q.$7P,TabInputInteractiveWindow:q.$8P,TabInputChat:q.$9P,TabInputTextMultiDiff:q.$0P,TelemetryTrustedValue:d.$Dp,LogLevel:r.LogLevel,EditSessionIdentityMatch:a.EditSessionIdentityMatch,InteractiveSessionVoteDirection:q.InteractiveSessionVoteDirection,ChatCopyKind:q.ChatCopyKind,InteractiveEditorResponseFeedbackKind:q.InteractiveEditorResponseFeedbackKind,DebugStackFrame:q.$kP,DebugThread:q.$lP,RelatedInformationType:q.RelatedInformationType,SpeechToTextStatus:q.SpeechToTextStatus,TextToSpeechStatus:q.TextToSpeechStatus,PartialAcceptTriggerKind:q.PartialAcceptTriggerKind,KeywordRecognitionStatus:q.KeywordRecognitionStatus,ChatResponseMarkdownPart:q.$_P,ChatResponseFileTreePart:q.$dQ,ChatResponseAnchorPart:q.$eQ,ChatResponseProgressPart:q.$fQ,ChatResponseProgressPart2:q.$gQ,ChatResponseReferencePart:q.$jQ,ChatResponseReferencePart2:q.$jQ,ChatResponseCodeCitationPart:q.$kQ,ChatResponseWarningPart:q.$hQ,ChatResponseTextEditPart:q.$mQ,ChatResponseMarkdownWithVulnerabilitiesPart:q.$aQ,ChatResponseCommandButtonPart:q.$iQ,ChatResponseDetectedParticipantPart:q.$bQ,ChatResponseConfirmationPart:q.$cQ,ChatResponseMovePart:q.$lQ,ChatResponseReferencePartStatusKind:q.ChatResponseReferencePartStatusKind,ChatRequestTurn:q.$nQ,ChatResponseTurn:q.$oQ,ChatLocation:q.ChatLocation,ChatRequestEditorData:q.$pQ,ChatRequestNotebookData:q.$qQ,LanguageModelChatMessageRole:q.LanguageModelChatMessageRole,LanguageModelChatMessage:q.$sQ,LanguageModelChatMessageToolResultPart:q.$rQ,LanguageModelChatResponseTextPart:q.$uQ,LanguageModelChatResponseToolCallPart:q.$tQ,LanguageModelError:q.$yQ,NewSymbolName:q.$rP,NewSymbolNameTag:q.NewSymbolNameTag,NewSymbolNameTriggerKind:q.NewSymbolNameTriggerKind,InlineEdit:q.$zQ,InlineEditTriggerKind:q.InlineEditTriggerKind,ExcludeSettingOptions:At.ExcludeSettingOptions,TextSearchContextNew:At.$mM,TextSearchMatchNew:At.$lM,TextSearchCompleteMessageTypeNew:At.TextSearchCompleteMessageType}}}}),define(Re[277],Te([1,0,60,130,45,124,46,35,57,56,132,134,135,89,93,85,123,68,50,88,66,70,215,11,133,86,87,91,95,128,96]),function(we,e,v,D,P,L,R,O,m,s,I,w,u,E,p,r,l,d,a,i,n,t,o,c,g,f,h,S,k,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$Zs)(f.$Nrc,f.$Mrc,v.InstantiationType.Delayed),(0,v.$Zs)(c.$gk,o.$8sc,v.InstantiationType.Delayed),(0,v.$Zs)(r.$Sqc,r.$Tqc,v.InstantiationType.Delayed),(0,v.$Zs)(O.$7Q,O.$6Q,v.InstantiationType.Eager),(0,v.$Zs)(S.$3qc,S.$4qc,v.InstantiationType.Eager),(0,v.$Zs)(k.$Hrc,k.$Irc,v.InstantiationType.Eager),(0,v.$Zs)(R.$frc,R.$drc,v.InstantiationType.Eager),(0,v.$Zs)(d.$hrc,d.$grc,v.InstantiationType.Eager),(0,v.$Zs)(C.$Xrc,C.$Yrc,v.InstantiationType.Eager),(0,v.$Zs)(w.$3rc,w.$7rc,v.InstantiationType.Eager),(0,v.$Zs)(L.$9rc,L.$8rc,v.InstantiationType.Eager),(0,v.$Zs)(m.$VQ,m.$UQ,v.InstantiationType.Eager),(0,v.$Zs)(h.$Orc,h.$Prc,v.InstantiationType.Eager),(0,v.$Zs)(a.$Wqc,a.$Vqc,v.InstantiationType.Eager),(0,v.$Zs)(D.$Hsc,D.$Gsc,v.InstantiationType.Delayed),(0,v.$Zs)(u.$rsc,u.$ssc,v.InstantiationType.Eager),(0,v.$Zs)(E.$Arc,E.$zrc,v.InstantiationType.Eager),(0,v.$Zs)(I.$Usc,I.$Tsc,v.InstantiationType.Eager),(0,v.$Zs)(s.$Drc,s.$Grc,v.InstantiationType.Eager),(0,v.$Zs)(y.$Vsc,y.$Wsc,v.InstantiationType.Eager),(0,v.$Zs)(p.$6Gb,p.$7Gb,v.InstantiationType.Eager),(0,v.$Zs)(l.$6sc,l.$5sc,v.InstantiationType.Eager),(0,v.$Zs)(P.$crc,P.$brc,v.InstantiationType.Eager),(0,v.$Zs)(i.$Krc,i.$Jrc,v.InstantiationType.Eager),(0,v.$Zs)(n.$5Q,n.$2Q,v.InstantiationType.Eager),(0,v.$Zs)(t.$rrc,t.$src,v.InstantiationType.Eager),(0,v.$Zs)(g.$Vrc,g.$Wrc,v.InstantiationType.Eager)}),define(Re[278],Te([1,0,276,47,2,272,7,10,222]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jvc=void 0;class s extends L.$$sc{j(){}getModule(E,p){for(const r of this.b){const l=r(E);if(l){E=l;break}}if(this.a.has(E))return this.a.get(E).load(E,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends D.$Rrc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(m.$ivc);const E=this.h.invokeFunction(v.$7sc);this.r=this.h.createInstance(s,E,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(E){return E.browser}async xb(E,p,r){p=p.with({path:w(p.path,".js")});const l=E?.identifier.value;l&&performance.mark(`code/extHost/willFetchExtensionCode/${l}`);const d=P.URI.revive(await this.C.$asBrowserUri(p)),a=await fetch(d.toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l}`),a.status!==200)throw new Error(a.statusText);const i=await a.text(),n=`${p.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${n}`;let o;try{o=new Function("module","exports","require",t)}catch(h){throw console.error(l?`Loading code for extension ${l} failed: ${h.message}`:`Loading code failed: ${h.message}`),console.error(`${p.toString(!0)}${typeof h.line=="number"?` line ${h.line}`:""}${typeof h.column=="number"?` column ${h.column}`:""}`),console.error(h),h}E&&await this.w.initializeLocalizedMessages(E);const c={},g={exports:c},f=h=>{const S=this.r.getModule(h,p);if(S===void 0)throw new Error(`Cannot load module '${h}'`);return S};try{return r.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l}`),o(g,c,f),g.exports!==c?g.exports:c}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l}`),r.codeLoadingStop()}}async $setRemoteEnvironment(E){}async Bb(E=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+E;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,O.$Lh)(10)}}e.$jvc=I;function w(u,E){return u.endsWith(E)?u:u+E}}),define(Re[279],Te([1,0,74,60,11,47,187,92,278]),function(we,e,v,D,P,L,R,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Zs)(P.$fk,new v.$Hi(R.$0sc,[!0],!0)),(0,D.$Zs)(L.$Src,m.$jvc,D.InstantiationType.Eager),(0,D.$Zs)(O.$irc,O.$jrc,D.InstantiationType.Eager)}),define(Re[287],Te([1,0,20,6,84,273,224,22,64,15,2,277,279]),function(we,e,v,D,P,L,R,O,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,O=Ve(O),m=Ve(m);const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(o){return/^(file|vscode-remote):/i.test(o)}const p=fetch.bind(self);function r(o){self.fetch=async function(c,g){return c instanceof Request||E(String(c))&&(c=(await o(I.URI.parse(String(c)))).toString(!0)),p(c,g)},self.XMLHttpRequest=class extends XMLHttpRequest{open(c,g,f,h,S){(async()=>(E(g.toString())&&(g=(await o(I.URI.parse(g.toString()))).toString(!0)),super.open(c,g,f??!0,h,S)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.Worker;Worker=function(c,g){if(/^file:/i.test(c.toString()))c=s.$5g.uriToBrowserUri(I.URI.parse(c.toString())).toString(!0);else if(/^vscode-remote:/i.test(c.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const h=`(${function(C){function T(N){return typeof N=="string"||N instanceof URL?String(N).replace(/^file:\/\//i,"vscode-file://vscode-app"):N}const $=fetch.bind(self);self.fetch=function(N,A){return N instanceof Request?$(N,A):$(T(N),A)},self.XMLHttpRequest=class extends XMLHttpRequest{open(N,A,F,G,x){return super.open(N,T(A),F??!0,G,x)}};const b=importScripts.bind(self);self.importScripts=(...N)=>{b(...N.map(T))},b(C)}.toString()}('${c}'))`;g=g||{},g.name=`${name} -> ${g.name||O.$sc(c.toString())}`;const S=new Blob([h],{type:"application/javascript"}),k=URL.createObjectURL(S);return new o(k,g)}}else self.Worker=class extends R.$kvc{constructor(o,c){super(u,o,{name:O.$sc(o.toString()),...c})}};const l=new class{constructor(){this.pid=void 0}exit(o){w()}};class d{constructor(){const c=new MessageChannel,g=new D.$qe;let f=!1;u(c.port2,[c.port2]),c.port1.onmessage=h=>{const{data:S}=h;if(!(S instanceof ArrayBuffer)){console.warn("UNKNOWN data received",S);return}const k=v.$Se.wrap(new Uint8Array(S,0,S.byteLength));if((0,P.$In)(k,P.MessageType.Terminate)){f=!0,i("received terminate message from renderer");return}g.fire(k)},this.protocol={onMessage:g.event,send:h=>{if(!f){const S=h.buffer.buffer.slice(h.buffer.byteOffset,h.buffer.byteOffset+h.buffer.byteLength);c.port1.postMessage(S,[S])}}}}}function a(o){return new Promise(c=>{const g=o.onMessage(f=>{g.dispose();const h=JSON.parse(f.toString());o.send((0,P.$Hn)(P.MessageType.Initialized)),c({protocol:o,initData:h})});o.send((0,P.$Hn)(P.MessageType.Ready))})}let i=o=>w();function n(o){return!!o&&typeof o=="object"&&o.type==="vscode.init"&&o.data instanceof Map}function t(){m.mark("code/extHost/willConnectToRenderer");const o=new d;return{onmessage(c){n(c)&&a(o.protocol).then(g=>{m.mark("code/extHost/didWaitForInitData");const f=new L.$atc(g.protocol,g.initData,l,null,c.data);r(h=>f.asBrowserUri(h)),i=h=>f.terminate(h)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/d1388fd24fc0acf17ae1f759e85c1acf559ed759/core/vs/workbench/api/worker/extensionHostWorker.js.map
